loc_4150: ; Demo Mode / Normal Game Play
    bset    #7, (Game_Mode).w
    tst.w   (Demo_mode_flag).w
    bmi.s   Level_Init              ; loc_4164
    move.b  #$F9, d0
    bsr     Play_Sfx                ; loc_14C6
Level_Init: ; loc_4164:                
    bsr     ClearPLC                ; loc_179A
    bsr     Pal_FadeFrom            ; loc_263A 
    tst.w   (Demo_mode_flag).w
    bmi.s   loc_41C0
    move    #$2700, SR
    move.l  #$70000002, ($C00004)
    lea     (Title_Cards), A0 ; loc_7EA04  / Load Title Cards sprites
    bsr     NemesisDec              ; loc_15FC
    bsr     ClearScreen             ; loc_1418
    move    #$2300, SR
    moveq   #0, d0
    move.w  d0, (Timer_frames).w
    move.b  (Current_Zone).w, d0
    add.w   d0, d0
    add.w   d0, d0
    move.w  d0, d1
    add.w   d0, d0
    add.w   d1, d0
    lea     (TilesMainTable), a2    ; loc_24354
    lea     $00(a2, d0), a2
    moveq   #0, d0
    move.b  (a2), d0
    beq.s   loc_41BA
    bsr     LoadPLC                 ; loc_173C
loc_41BA:
    moveq   #1, d0
    bsr     LoadPLC                 ; loc_173C
loc_41C0:
    lea     (Sprite_Table_Input).w, a1
    moveq   #0, d0
    move.w  #$FF, d1
loc_41CA:
    move.l  d0, (a1)+
    dbra    d1, loc_41CA
    lea     (Object_RAM).w, a1
    moveq   #0, d0
    move.w  #$7FF, d1
loc_41DA:
    move.l  d0, (a1)+
    dbra    d1, loc_41DA
    lea     ($FFFFF628).w, a1
    moveq   #0, d0
    move.w  #$15, d1
loc_41EA:
    move.l  d0, (a1)+
    dbra    d1, loc_41EA
    lea     (Misc_Variables).w, a1
    moveq   #0, d0
    move.w  #$3F, d1
loc_41FA:
    move.l  d0, (a1)+
    dbra    d1, loc_41FA
    lea     ($FFFFFE60).w, a1
    moveq   #0, d0
    move.w  #$47, d1
loc_420A:
    move.l  d0, (a1)+
    dbra    d1, loc_420A
    cmpi.w  #$D01, (Current_ZoneAndAct).w  ; If Chemical Plant
    beq.s   Init_Water             ; loc_4228 Load up the water
    cmpi.b  #$F, (Current_ZoneAndAct).w    ; If Neo Green Hill
    beq.s   Init_Water             ; loc_4228 Load up the Water
    cmpi.b  #8, (Current_ZoneAndAct).w    ; If Not Hidden Palace
    bne.s   Init_No_Water          ; loc_4234 
Init_Water: ; loc_4228:
    move.b  #1, (Water_flag).w
    move.w  #$00, (Two_player_mode).w  ; If Water Level Clear Two Player Flag
Init_No_Water: ; loc_4234:
    lea     ($C00004), a6
    move.w  #$8B03, (a6)
    move.w  #$8230, (a6)
    move.w  #$8407, (a6)
    move.w  #$857C, (a6)
    move.w  #$9001, (a6)
    move.w  #$8004, (a6)
    move.w  #$8720, (a6)
    btst    #5, (Ctrl_1_Held).w
    beq.s   loc_4262
    move.w  #$8C89, (a6)
loc_4262:
    move.w  #$8ADF, (Hint_counter_reserve).w
    tst.w   (Two_player_mode).w
    beq.s   loc_427C
    move.w  #$8A6B, (Hint_counter_reserve).w
    move.w  #$8014, (a6)
    move.w  #$8C87, (a6)
loc_427C:
    move.w  (Hint_counter_reserve).w, (a6)
    move.l  #VDP_Command_Buffer, (VDP_Command_Buffer_Slot).w
    tst.b   (Water_flag).w
    beq.s   LevelInit_NoWater       ; loc_42C8
    move.w  #$8014, (a6)
    moveq   #0, d0
    move.w  (Current_Zone).w, d0
    subi.w  #$800, d0
    ror.b   #1, d0
    lsr.w   #6, d0
    andi.w  #$FFFE, d0
    lea     (Water_Height_Array), a1 ; loc_46B8
    move.w  $00(a1, d0), d0                
    move.w  d0, (Water_Level_1).w
    move.w  d0, (Water_Level_2).w
    move.w  d0, (Water_Level_3).w
    clr.b   (Water_Routine).w
    clr.b   (Water_move).w
    move.b  #1, (Water_on).w
LevelInit_NoWater: ; loc_42C8:
    move.w  #$1E, ($FFFFFE14).w
    moveq   #3, d0
    bsr     PalLoad2                ; loc_28FE
    tst.b   (Water_flag).w
    beq.s   LevelInit_NoUndewaterPalette ; loc_4300
    moveq   #$15, d0                ; Load HPz Underwater Palette
    cmpi.b  #8, (Current_ZoneAndAct).w
    beq.s   LevelInit_UndewaterPalette ; loc_42F0
    moveq   #$16, d0                ; Load CPz Underwater Palette
    cmpi.b  #$D, (Current_ZoneAndAct).w
    beq.s   LevelInit_UndewaterPalette ; loc_42F0
    moveq   #$17, d0                ; Load NGHz Underwater Palette
LevelInit_UndewaterPalette: ; loc_42F0:
    bsr     PalLoad3_Water ; loc_2916 ; Call Underwater palette routine
    tst.b   (Last_star_pole_hit).w
    beq.s   LevelInit_NoUndewaterPalette ; loc_4300
    move.b  (Saved_Water_move).w, (Water_move).w
LevelInit_NoUndewaterPalette: ; loc_4300:
    tst.w   (Demo_mode_flag).w
    bmi.s   loc_434E
    moveq   #0, d0
    move.b  (Current_Zone).w, d0
    lea     PlayList(PC), a1        ; loc_4140
    move.b  $00(a1, d0), d0
    bsr     PlayMusic              ; loc_14C0
    move.b  #$34, ($FFFFB080).w     ; Load Title Cards Object
LevelInit_TitleCard: ; loc_431E:                
    move.b  #$C, (Delay_Time).w
    bsr     DelayProgram            ; loc_31D8
    jsr     Load_Objects            ; loc_CFD0
    jsr     Build_Sprites           ; loc_D4DA
    bsr     RunPLC                  ; loc_17A8
    move.w  ($FFFFB108).w, d0
    cmp.w   ($FFFFB130).w, d0
    bne.s   LevelInit_TitleCard     ; loc_431E 
    tst.l   (Plc_Buffer).w
    bne.s   LevelInit_TitleCard     ; loc_431E
    jsr     Head_Up_Display_Base    ; loc_23184 Call HUD routine
loc_434E:
    moveq   #3, d0
    bsr     PalLoad1                ; loc_28E2
    bsr     Level_Size_Load         ; loc_5904
    bsr     Background_Scroll_Layer ; loc_5D5C
    bset    #2, ($FFFFEE50).w
    bsr     Main_Level_Load_16_128_Blocks ; loc_779A
    jsr     Load_16x16_Mappings_For_Dyn_Sprites ; loc_2293A
    bsr     Load_Tiles_From_Start   ; loc_76BE
    jsr     loc_135DA
    bsr     Load_Colision_Index     ; loc_4AAA
    bsr     Water_Effects           ; loc_465A
    move.b  #1, (MainCharacter).w  ; Load Sonic Object
    tst.w   (Demo_mode_flag).w
    bmi.s   Skip_Head_Up_Display ; loc_4390                 
    move.b  #$21, ($FFFFB380).w  ; Load HUD Object
Skip_Head_Up_Display: ; loc_4390:                
    move.b  #2, (Sidekick).w  ; Load Tails Object
    move.w  ($FFFFB008).w, ($FFFFB048).w
    move.w  ($FFFFB00C).w, ($FFFFB04C).w
    subi.w  #$20, ($FFFFB048).w
    tst.b   ($FFFFFFD2).w
    beq.s   loc_43BC
    btst    #6, (Ctrl_1_Held).w
    beq.s   loc_43BC
    move.b  #1, (Debug_mode_flag).w
loc_43BC:
    move.w  #$00, (Ctrl_1_Held_Logical).w
    move.w  #$00, (Ctrl_1_Held).w
    tst.b   (Water_flag).w
    beq.s   loc_43E6
    move.b  #4, ($FFFFB780).w
    move.w  #$60, ($FFFFB788).w
    move.b  #4, ($FFFFB7C0).w
    move.w  #$120, ($FFFFB7C8).w
loc_43E6:
    cmpi.b  #$A, (Current_ZoneAndAct).w
    bne.s   loc_43F4
    move.b  #7, ($FFFFB780).w
loc_43F4:
    jsr     Load_Object_Pos         ; loc_E250
    jsr     Load_Ring_Pos           ; loc_DE34
    jsr     Load_Objects            ; loc_CFD0
    jsr     Build_Sprites           ; loc_D4DA
    bsr     JumpToDynamic_Art_Cues  ; loc_51F8
    moveq   #0, d0
    tst.b   (Last_star_pole_hit).w  ; Set last Starpost hit to 0, thus making you start at the beginning.
    bne.s   loc_4424
    move.w  d0, (Ring_count).w
    move.l  d0, (Timer).w
    move.b  d0, (Extra_life_flags).w
loc_4424:                
    move.b  d0, (Time_Over_flag).w
    move.b  d0, ($FFFFFE2C).w
    move.b  d0, ($FFFFFE2D).w
    move.b  d0, ($FFFFFE2E).w
    move.b  d0, ($FFFFFE2F).w
    move.w  d0, (Debug_placement_mode).w
    move.w  d0, (Level_Inactive_flag).w
    bsr     Oscillate_Num_Init      ; loc_4B64
    move.b  #1, (Update_HUD_score).w
    move.b  #1, (Update_HUD_rings).w
    move.b  #1, (Update_HUD_timer).w
    move.w  #$4, (Sonic_Pos_Record_Index).w
    move.w  #$00, (Sonic_Pos_Record_Buf).w
    move.w  #$00, (Demo_button_index).w
    move.w  #$00, ($FFFFF740).w
    lea     (Demo_Index), a1        ; loc_49F2
    moveq   #0, d0
    move.b  (Current_Zone).w, d0
    lsl.w   #2, d0
    move.l  $00(a1, d0), a1
    tst.w   (Demo_mode_flag).w
    bpl.s   loc_4498
    lea     (Demo_End_Index), a1    ; loc_4A7A
    move.w  ($FFFFFFF4).w, d0
    subq.w  #1, d0
    lsl.w   #2, d0
    move.l  $00(a1, d0), a1
loc_4498:
    move.b  $1(a1), (Demo_press_counter).w
    subq.b  #1, (Demo_press_counter).w
    lea     (Demo_Tails_Ghz), a1   ; loc_4DF8 Green Hill - Tails Demo control
    move.b  $1(a1), ($FFFFF742).w
    subq.b  #1, ($FFFFF742).w
    move.w  #$668, (Demo_Time_left).w
    tst.w   (Demo_mode_flag).w
    bpl.s   loc_44D2
    move.w  #$21C, (Demo_Time_left).w
    cmpi.w  #$4, ($FFFFFFF4).w
    bne.s   loc_44D2
    move.w  #$1FE, (Demo_Time_left).w
loc_44D2:
    tst.b   (Water_flag).w
    beq.s   loc_44F2
    moveq   #$15, d0
    cmpi.b  #8, (Current_ZoneAndAct).w ; Is the level CPZ?
    beq.s   loc_44EE ;If so, the load the Water Palette
    moveq   #$16, d0  ; Palette load Number for CPZ's Underwater Palette
    cmpi.b  #$D, (Current_ZoneAndAct).w ; Is the level ARZ(NGHZ)?
    beq.s   loc_44EE ; If so the Water Palette
    moveq   #$17, d0 ; Palette load Number for ARZ(NGHZ)'s Underwater Palette
loc_44EE:
    bsr     PalLoad4_Water          ; loc_2932
loc_44F2:
    move.w  #$3, d1
loc_44F6:                
    move.b  #8, (Delay_Time).w
    bsr     DelayProgram            ; loc_31D8
    dbra    d1, loc_44F6 
    move.w  #$202F, ($FFFFF626).w
    bsr     Pal_FadeTo2             ; loc_259C
    tst.w   (Demo_mode_flag).w
    bmi.s   Level_ClrTitleCard      ; loc_4526
    addq.b  #2, ($FFFFB0A4).w 
    addq.b  #4, ($FFFFB0E4).w
    addq.b  #4, ($FFFFB124).w
    addq.b  #4, ($FFFFB164).w   
    bra.s   loc_452E
Level_ClrTitleCard: ; loc_4526:
    moveq   #2, d0
    jsr     LoadPLC                 ; loc_173C
loc_452E:                
    bclr    #7, (Game_Mode).w
Level_Main_Loop: ; loc_4534:                
    bsr     Pause                   ; loc_14D2
    move.b  #8, (Delay_Time).w   
    bsr     DelayProgram            ; loc_31D8
    addq.w  #1, (Timer_frames).w
    bsr     Move_Sonic_In_Demo      ; loc_48DE
    bsr     Water_Effects           ; loc_465A
    jsr     Load_Objects            ; loc_CFD0
    tst.w   (Level_Inactive_flag).w
    bne     Level                   ; loc_4150
    tst.w   (Debug_placement_mode).w
    bne.s   loc_456A
    cmpi.b  #6, ($FFFFB024).w
    bcc.s   loc_456E
loc_456A:
    bsr     Background_Scroll_Layer ; loc_5D5C                 
loc_456E:
    bsr     Change_Water_Surface_Pos ; loc_4630
    jsr     Load_Ring_Pos           ; loc_DE34
    bsr     JumpToDynamic_Art_Cues  ; loc_51F8
    bsr     PalCycle_Load           ; loc_1F18
    bsr     RunPLC                  ; loc_17A8
    bsr     Oscillate_Num_Do        ; loc_4BBA
    bsr     Change_Ring_Frame       ; loc_4C52
    bsr     End_Level_Art_Load      ; loc_4CC0
    jsr     Build_Sprites           ; loc_D4DA
    jsr     Load_Object_Pos         ; loc_E250
    cmpi.b  #8, (Game_Mode).w
    beq.s   loc_45B0
    cmpi.b  #$C, (Game_Mode).w
    beq     Level_Main_Loop         ; loc_4534
    rts
loc_45B0:
    tst.w   (Level_Inactive_flag).w
    bne.s   loc_45CE
    tst.w   (Demo_Time_left).w
    beq.s   loc_45CE
    cmpi.b  #8, (Game_Mode).w
    beq     Level_Main_Loop         ; loc_4534
    move.b  #0, (Game_Mode).w
    rts
loc_45CE:
    cmpi.b  #8, (Game_Mode).w
    bne.s   loc_45E8
    move.b  #0, (Game_Mode).w
    tst.w   (Demo_mode_flag).w
    bpl.s   loc_45E8
    move.b  #$1C, (Game_Mode).w
loc_45E8:
    move.w  #$3C, (Demo_Time_left).w
    move.w  #$3F, ($FFFFF626).w
    clr.w   ($FFFFF794).w
loc_45F8:                
    move.b  #8, (Delay_Time).w
    bsr     DelayProgram            ; loc_31D8
    bsr     Move_Sonic_In_Demo      ; loc_48DE
    jsr     Load_Objects            ; loc_CFD0
    jsr     Build_Sprites           ; loc_D4DA
    jsr     Load_Object_Pos         ; loc_E250
    subq.w  #1, ($FFFFF794).w
    bpl.s   loc_4628
    move.w  #$2, ($FFFFF794).w
    bsr     Pal_FadeOut             ; loc_265A
loc_4628:
    tst.w   (Demo_Time_left).w
    bne.s   loc_45F8
    rts           
Change_Water_Surface_Pos: ; loc_4630:
    tst.b   (Water_flag).w
    beq.s   loc_4658
    move.w  (Camera_RAM).w, d1
    btst    #0, ($FFFFFE05).w
    beq.s   loc_4646
    addi.w  #$20, d1
loc_4646:
    move.w  d1, d0
    addi.w  #$60, d0
    move.w  d0, ($FFFFB788).w
    addi.w  #$120, d1
    move.w  d1, ($FFFFB7C8).w
loc_4658:
    rts