;===============================================================================
;
; ChecksumError
;
; Leftover subroutine from Sonic 1 showing a red
;  screen when the checksum was	wrong
;
;===============================================================================                
ChecksumError:                  
    bsr     VDPRegSetup      ; loc_1368 
    move.l  #$C0000000, ($C00004)   
    moveq   #$3F, d7  
ChksumErr_RedFill: ; loc_3C0:                  
    move.w  #$E, ($C00000) 
    dbra    d7, ChksumErr_RedFill   ; loc_3C0 
ChksumErr_InfLoop: ; loc_3CC:
    bra.s   ChksumErr_InfLoop       ; loc_3CC             
BusError: ; loc_3CE:
    move.b  #2, ($FFFFFC44).w
    bra.s   ErrorMsg_TwoAddresses   ; loc_432
AddressError: ; loc_3D6:                
    move.b  #4, ($FFFFFC44).w
    bra.s   ErrorMsg_TwoAddresses   ; loc_432
IllegalInstr: ; loc_3DE:                
    move.b  #6, ($FFFFFC44).w
    addq.l  #2, $2(a7)
    bra.s   ErrorMessage            ; loc_45A
ZeroDivide: ; loc_3EA:                
    move.b  #8, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A
ChkInstr: ; loc_3F2:                
    move.b  #$A, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A
TrapvInstr: ; loc_3FA:                
    move.b  #$C, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A             
PrivilegeViolation: ; loc_402:
    move.b  #$E, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A  
Trace: ; loc_40A:
    move.b  #$10, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A 
Line1010Emu: ; loc_412:
    move.b  #$12, ($FFFFFC44).w
    addq.l  #2, $2(a7)
    bra.s   ErrorMessage            ; loc_45A                 
Line1111Emu: ; loc_41E:
    move.b  #$14, ($FFFFFC44).w
    addq.l  #2, $2(a7)
    bra.s   ErrorMessage            ; loc_45A 
ErrorException: ; loc_42A:
    move.b  #0, ($FFFFFC44).w
    bra.s   ErrorMessage            ; loc_45A 
ErrorMsg_TwoAddresses: ; loc_432: 
    move    #$2700, SR
    addq.w  #2, a7
    move.l  (a7)+, ($FFFFFC40).w
    addq.w  #2, a7
    movem.l d0-a7, (Object_Respawn_Table).w
    bsr     ShowErrorMsg            ; loc_480
    move.l  $2(a7), d0
    bsr     ShowErrAddress          ; loc_5B2
    move.l  ($FFFFFC40).w, d0
    bsr     ShowErrAddress          ; loc_5B2
    bra.s   ErrorMsg_Wait           ; loc_470                  
ErrorMessage: ; loc_45A:
    move    #$2700, SR
    movem.l d0-a7, (Object_Respawn_Table).w
    bsr     ShowErrorMsg            ; loc_480
    move.l  $2(a7), d0
    bsr     ShowErrAddress          ; loc_5B2
ErrorMsg_Wait: ; loc_470:
    bsr     Error_WaitForC          ; loc_5D8 
    movem.l (Object_Respawn_Table).w, d0-a7  
    move    #$2300, SR
                rte        
ShowErrorMsg: ; loc_480:
    lea     ($C00000), a6  
    move.l  #$78000003, ($C00004)
    lea     (Art_Menu_Text), A0     ; loc_5E8
    move.w  #$27F, d1
Error_LoadGfx: ; loc_49A:                
    move.w  (A0)+, (a6)
    dbra    d1, Error_LoadGfx       ; loc_49A                 
    moveq   #0, d0
    move.b ($FFFFFC44).w, d0
    move.w  Error_Text(PC, d0), d0  ; loc_4CA
    lea     Error_Text(PC, d0), A0  ; loc_4CA
    move.l  #$46040003, ($C00004)
    moveq   #$12, d1
loc_4BA:                 
    moveq   #0, d0
    move.b (A0)+, d0
    addi.w  #$790, d0
    move.w  d0, (a6)
    dbra    d1, loc_4BA
    rts
Error_Text: ; loc_4CA:
    dc.w    ErrTxt_Exception-Error_Text  
    dc.w    ErrTxt_BusError-Error_Text  
    dc.w    ErrTxt_AddressError-Error_Text  
    dc.w    ErrTxt_IllegalInstruction-Error_Text  
    dc.w    ErrTxt_ZeroDivide-Error_Text 
    dc.w    ErrTxt_ChkIntruction-Error_Text
    dc.w    ErrTxt_TrapvInstructuion-Error_Text
    dc.w    ErrTxt_PrivilegeViolation-Error_Text
    dc.w    ErrTxt_Trace-Error_Text
    dc.w    ErrTxt_Line1010Emulator-Error_Text
    dc.w    ErrTxt_Line1111Emulator-Error_Text
ErrTxt_Exception: ; loc_4E0: 
    dc.b    'ERROR EXCEPTION    '
ErrTxt_BusError: ; loc_4F3: 
    dc.b    'BUS ERROR          ' 
ErrTxt_AddressError: ; loc_506: 
    dc.b    'ADDRESS ERROR      '   
ErrTxt_IllegalInstruction: ; loc_519: 
    dc.b    'ILLEGAL INSTRUCTION' 
ErrTxt_ZeroDivide: ; loc_52C: 
    dc.b    '@ERO DIVIDE        ' 
ErrTxt_ChkIntruction: ; loc_53F:                 
    dc.b    'CHK INSTRUCTION    '
ErrTxt_TrapvInstructuion: ; loc_552:                
    dc.b    'TRAPV INSTRUCTION  '
ErrTxt_PrivilegeViolation: ; loc_565:                 
    dc.b    'PRIVILEGE VIOLATION'
ErrTxt_Trace: ; loc_578:                 
    dc.b    'TRACE              '
ErrTxt_Line1010Emulator: ; loc_58B:                
    dc.b    'LINE 1010 EMULATOR '
ErrTxt_Line1111Emulator: ;loc_59E:                 
    dc.b    'LINE 1111 EMULATOR ' 
    dc.b    $00                           ; Filler                                                  
ShowErrAddress: ; loc_5B2:
    move.w  #$7CA, (a6)
    moveq   #7, d2 
ShowErrAddress_DigitLoop: ; loc_5B8:                
                rol.l   #4, d0
    bsr.s   ShowErrDigit            ; loc_5C2
    dbra    d2, ShowErrAddress_DigitLoop ; loc_5B8
    rts
ShowErrDigit: ; loc_5C2:   
    move.w  d0, d1
    andi.w  #$F, d1
    cmpi.w  #$A, d1
    bcs.s   ShowErrDigit_NoOverflow ; loc_5D0
    addq.w  #7, d1
ShowErrDigit_NoOverflow: ; loc_5D0:                
    addi.w  #$7C0, d1 
    move.w  d1, (a6)
    rts
Error_WaitForC: ; loc_5D8:
    bsr     ReadJoypads             ; loc_132C
    cmpi.b  #$20, (Ctrl_1_Press).w
    bne     Error_WaitForC          ; loc_5D8
    rts 