;===============================================================================         
;	Object 11 - Bridge (All Zones)
;===============================================================================    
Obj11_Bridge:  ; loc_7FDC: 
        btst    #$6,render_flags(a0)		; Main Object Initialization
        bne     Display_Obj11	;Sprite Initialization
        moveq	#0,d0		
        move.b  routine(a0), d0	; 
        move.w  Obj11_Index(pc,d0),d1
        jmp     Obj11_Index(PC,d1)
; ===========================================================================		
Display_Obj11:
        move.w  #$180,d0
        bra     DisplaySprite_Param     ; loc_D3FE
; ===========================================================================		
Obj11_Index:        
        dc.w    Obj11_Main-Obj11_Index
        dc.w    Obj11_Action-Obj11_Index
        dc.w    BranchTo_DisplaySprite-Obj11_Index
        dc.w    Obj11_Action_HPZ-Obj11_Index
; ===========================================================================		
Obj11_Main:        
        addq.b  #2,routine(a0)					; This indicates that this is the main object Subtype. The parent.
        move.l  #Bridge_Mappings,mappings(a0) 	; loc_85E0	; Load the EHZ bridge Mappings.
        move.w  #$43C6,art_tile(a0)				; Load into the VRAM
        move.b  #$3,priority(a0)				; Something to do with Object Priority.
        cmpi.b  #$8,(Current_Zone).w			; Check if the level is HPZ
        bne.s   Obj11_Properties				; If not, branch
        addq.b  #$4, routine(a0)				; Object Subtype and Object Initialization.
        move.l  #HpzBridge,mappings(a0)			; loc_8598		
												; Load the HPZ bridge Mappings
        move.w  #$6300,art_tile(a0)				; Load into the VRAM.
Obj11_Properties:
        bsr     Adjust2PArtPointer    	 		; loc_DC30
        move.b  #$4,render_flags(a0)
        move.b  #$80,width_pixels(a0)			; Collision width size of each "log" of the bridge.
        move.w  y_pos(a0),d2			
        move.w  d2,objoff_3C(a0)
        move.w  x_pos(a0),d3
        lea     subtype(a0), a2					; copy bridge subtype to a2
		moveq	#0,d1
		move.b	(a2),d1							; copy a2 to d1
        move.w  d1,d0
        lsr.w   #$1,d0
        lsl.w   #$4,d0
        sub.w   d0,d3
        swap.w  d1
        move.w  #$8,d1
        bsr.s   Obj11_MakeBdgSegment
        move.w  subtype(a1), d0
        subq.w  #$8,d0
        move.w  d0, x_pos(a1)
        move.l  a1,objoff_30(a0)
        swap.w  d1
        subq.w  #$8,d1
        bls.s   BranchTo_Obj11_Action
        move.w  d1,d4
        bsr.s   Obj11_MakeBdgSegment
        move.l  a1,objoff_34(a0)
        move.w  d4,d0
        add.w   d0,d0
        add.w   d4,d0
        move.w  $10(a1,d0), d0
        subq.w  #$8,d0
        move.w  d0, x_pos(a1)
;----------------------------------------------------------------------------		
BranchTo_Obj11_Action:
        bra.s   Obj11_Action
; ||||||||||||||| S U B R O U T I N E |||||||||||||||||||||||||||||||||||||||		
Obj11_MakeBdgSegment:        
        bsr     SingleObjLoad2      ; loc_E788
        bne.s   loc_80E8
        move.b  $0(a0), $0(a1)		; load obj11
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  mappings(a0), mappings(a1)
        move.w art_tile(a0),art_tile(a1)
        move.b render_flags(a0),render_flags(a1)
        bset    #$6,render_flags(a1)
        move.b  #$40,objoff_E(a1)
        move.b  d1,objoff_F(a1)
        subq.b  #$1,d1
        lea     $10(a1), a2
loc_80D8:        
        move.w  d3,(a2)+
        move.w  d2,(a2)+
        move.w  #$0,(a2)+
        addi.w  #$10,d3
        dbra    d1, loc_80D8
loc_80E8:
        rts  

; ===========================================================================
Obj11_Action:
        move.b  status(a0), d0
        andi.b  #$18,d0			; has something to do with the bridge going down and how Sonic effects it.
        bne.s   loc_8100
        tst.b   objoff_3E(a0)
        beq.s   loc_812C
        subq.b  #$4, objoff_3E(a0)
        bra.s   loc_8128
loc_8100:
        andi.b  #$10,d0
        beq.s   loc_811C
        move.b  objoff_3F(a0), d0
        sub.b   objoff_3B(a0), d0
        beq.s   loc_811C
        bcc.s   loc_8118
        addq.b  #$1, objoff_3F(a0)
        bra.s   loc_811C
loc_8118:
        subq.b  #$1, objoff_3F(a0)
loc_811C:
        cmpi.b  #$40, objoff_3E(a0)
        beq.s   loc_8128
        addq.b  #$4, objoff_3E(a0)
loc_8128:
        bsr     Obj11_Depress
loc_812C:
        moveq	#0,d1
        move.b  subtype(a0),d1
        lsl.w   #$3,d1
        move.w  d1,d2
        addq.w  #$8,d1
        add.w   d2,d2
        moveq   #$8,d3
        move.w  x_pos(a0),d4
        bsr     loc_81E2
loc_8144:        
        tst.w   (Two_player_mode).w
        beq.s   loc_814C
        rts
loc_814C:
        move.w  x_pos(a0), d0
        andi.w  #$FF80,d0
        sub.w   (Camera_X_pos_coarse).w,d0
        cmpi.w  #$280,d0
        bhi.s   loc_8160
        rts
loc_8160:
        move.l  objoff_30(a0), a1
        bsr     DeleteObject2
        cmpi.b  #$8, subtype(a0)
        bls.s   Delete_Obj11
        move.l objoff_34(a0), a1
        bsr     DeleteObject2
; ===========================================================================		
Delete_Obj11:        
        bra     DeleteObject            ; loc_D3B4
; ===========================================================================		
BranchTo_DisplaySprite:
        bra     DisplaySprite           ; loc_D3C2
; ===========================================================================		
Obj11_Action_HPZ:
        move.b  status(a0), d0
        andi.b  #$18,d0
        bne.s   loc_8196
        tst.b   objoff_3E(a0)
        beq.s   loc_81C2
        subq.b  #$4, objoff_3E(a0)
        bra.s   loc_81BE
loc_8196:
        andi.b  #$10,d0
        beq.s   loc_81B2
        move.b  objoff_3F(a0), d0
        sub.b   objoff_3B(a0), d0
        beq.s   loc_81B2
        bcc.s   loc_81AE
        addq.b  #$1, objoff_3F(a0)
        bra.s   loc_81B2
loc_81AE:
        subq.b  #$1, objoff_3F(a0)
loc_81B2:
        cmpi.b  #$40, objoff_3E(a0)
        beq.s   loc_81BE
        addq.b  #$4, objoff_3E(a0)
loc_81BE:
        bsr     Obj11_Depress
loc_81C2:        
        moveq	#0,d1
        move.b  subtype(a0),d1
        lsl.w   #$3,d1
        move.w  d1,d2
        addq.w  #$8,d1
        add.w   d2,d2
        moveq   #$8,d3
        move.w  x_pos(a0),d4        
        bsr     loc_81E2
        bsr     loc_8282
        bra     loc_8144
loc_81E2:
        lea     (Sidekick).w,a1
        moveq   #$4,d6
        moveq   #$3B,d5
        movem.l d1-d4, -(a7)        
        bsr.s   loc_81FC
        movem.l (a7)+,d1-d4
        lea     (MainCharacter).w,a1
        subq.b  #$1,d6
        moveq   #$3F,d5
loc_81FC:
        btst    d6, status(a0)
        beq.s   loc_8260
        btst    #$1, status(a1)
        bne.s   loc_821C
        moveq	#0,d0
        move.w  x_pos(a1), d0
        sub.w   x_pos(a0), d0
        add.w   d1,d0
        bmi.s   loc_821C
        cmp.w   d2,d0
        bcs.s   loc_822A
loc_821C:
        bclr    #$3, status(a1)
        bclr    d6, status(a0)
        moveq	#0,d4
        rts
loc_822A:
        lsr.w   #$4,d0
        move.b  d0, $00(a0,d5)
        move.l  objoff_30(a0), a2
        cmpi.w  #$8,d0
        bcs.s   loc_8242
        move.l objoff_34(a0), a2
        subi.w  #$8,d0
loc_8242:
        add.w   d0,d0
        move.w  d0,d1
        add.w   d0,d0
        add.w   d1,d0
        move.w  $12(a2,d0), d0
        subq.w  #$8,d0
        moveq	#0,d1
        move.b  y_radius(a1),d1
        sub.w   d1,d0
        move.w  d0, y_pos(a1)
        moveq	#0,d4
        rts
loc_8260:
        move.w  d1, -(a7)
        bsr     loc_FA7A
        move.w  (a7)+,d1
        btst    d6, status(a0)
        beq.s   loc_8280
        moveq	#0,d0
        move.w  x_pos(a1), d0
        sub.w   x_pos(a0), d0
        add.w   d1,d0
        lsr.w   #$4,d0
        move.b  d0, $00(a0,d5)
loc_8280:
        rts          

loc_8282:
        moveq	#0,d0
        tst.w   (MainCharacter+x_vel).w
        bne.s   loc_8294
        move.b  ($FFFFFE0F).w,d0
        andi.w  #$1C,d0
        lsr.w   #$1,d0
loc_8294:        
        moveq	#0,d2
        move.b  loc_82C1(pc,d0),d2
        swap.w  d2
        move.b  loc_82C0(pc,d0),d2
        moveq	#0,d0
        tst.w   (Sidekick+x_vel).w
        bne.s   loc_82B2
        move.b  ($FFFFFE0F).w,d0
        andi.w  #$1C,d0
        lsr.w   #$1,d0
loc_82B2:        
        moveq	#0,d6
        move.b  loc_82C1(pc,d0),d6
        swap.w  d6
        move.b  loc_82C0(pc,d0),d6
        bra.s   loc_82D0
loc_82C0:
        dc.b    $1
loc_82C1:
        dc.b    $2, $1, $2, $1, $2, $1, $2, $00, $1, $00, $00, $00, $00, $00, $1
loc_82D0:
		moveq	#-2,d3
		moveq	#-2,d4
        move.b  status(a0), d0
        andi.b  #$8,d0
        beq.s   loc_82E2
        move.b  objoff_3F(a0),d3
loc_82E2:        
        move.b  status(a0), d0
        andi.b  #$10,d0
        beq.s   loc_82F0
        move.b  objoff_3B(a0),d4
loc_82F0:        
        move.l  objoff_30(a0), a1
        lea     $45(a1), a2
        lea     $15(a1), a1
        moveq	#0,d1
        move.b  subtype(a0),d1
        subq.b  #$1,d1
        moveq	#0,d5
loc_8306:
        moveq	#0,d0
        subq.w  #$1,d3
        cmp.b   d3,d5
        bne.s   loc_8310
        move.w  d2,d0
loc_8310:
        addq.w  #$2,d3
        cmp.b   d3,d5
        bne.s   loc_8318
        move.w  d2,d0
loc_8318:
        subq.w  #$1,d3
        subq.w  #$1,d4
        cmp.b   d4,d5
        bne.s   loc_8322
        move.w  d6,d0
loc_8322:
        addq.w  #$2,d4
        cmp.b   d4,d5
        bne.s   loc_832A
        move.w  d6,d0
loc_832A:
        subq.w  #$1,d4
        cmp.b   d3,d5
        bne.s   loc_8336
        swap.w  d2
        move.w  d2,d0
        swap.w  d2
loc_8336:
        cmp.b   d4,d5
        bne.s   loc_8340
        swap.w  d6
        move.w  d6,d0
        swap.w  d6
loc_8340:
        move.b  d0,(a1)
        addq.w  #$1,d5
        addq.w  #$6,a1
        cmpa.w  a2,a1
        bne.s   loc_8352
        move.l objoff_34(a0), a1
        lea     $15(a1), a1
loc_8352:
        dbra    d1, loc_8306
        rts
		
; ===========================================================================
; subroutine to make the bridge push down where Sonic or Tails walks over
; ===========================================================================
Obj11_Depress:
        move.b  objoff_3E(a0), d0
        bsr     CalcSine        ; loc_320A
        move.w  d0,d4
        lea     (Obj11_SecondDepressionOffsets), a4
        moveq	#0,d0
        move.b  subtype(a0), d0
        lsl.w   #$4,d0
        moveq	#0,d3
        move.b  objoff_3F(a0),d3
        move.w  d3,d2
        add.w   d0,d3
        moveq	#0,d5
        lea     (Obj11_DepressionOffsets-$80), a5
        move.b  $00(a5,d3),d5
        andi.w  #$F,d3
        lsl.w   #$4,d3
        lea     $00(a4,d3), a3
        move.l  objoff_30(a0), a1
        lea     $42(a1), a2
        lea     $12(a1), a1
loc_839C:
        moveq	#0,d0
        move.b  (a3)+, d0
        addq.w  #$1,d0
        mulu.w  d5,d0
        mulu.w  d4,d0
        swap.w  d0
        add.w  objoff_3C(a0), d0
        move.w  d0,(a1)
        addq.w  #$6,a1
        cmpa.w  a2,a1
        bne.s   loc_83BC
        move.l objoff_34(a0), a1
        lea     $12(a1), a1
loc_83BC:
        dbra    d2, loc_839C
        moveq	#0,d0
        move.b  subtype(a0), d0
        moveq	#0,d3
        move.b  objoff_3F(a0),d3
        addq.b  #$1,d3
        sub.b   d0,d3
        neg.b   d3
        bmi.s   loc_8406
        move.w  d3,d2
        lsl.w   #$4,d3
        lea     $00(a4,d3), a3
        adda.w  d2,a3
        subq.w  #$1,d2
        bcs.s   loc_8406
loc_83E2:
        moveq	#0,d0
        move.b  -(a3), d0
        addq.w  #$1,d0
        mulu.w  d5,d0
        mulu.w  d4,d0
        swap.w  d0
        add.w  objoff_3C(a0), d0
        move.w  d0,(a1)
        addq.w  #$6,a1
        cmpa.w  a2,a1
        bne.s   loc_8402
        move.l objoff_34(a0), a1
        lea     $12(a1), a1
loc_8402:
        dbra    d2, loc_83E2
loc_8406:
        rts
; ===========================================================================		
Obj11_DepressionOffsets:   
		dc.b   2,  4,  6,  8,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b   2,  4,  6,  8, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b   2,  4,  6,  8, $A, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0,  0; 48
		dc.b   2,  4,  6,  8, $A, $C, $A,  8,  6,  4,  2,  0,  0,  0,  0,  0; 64
		dc.b   2,  4,  6,  8, $A, $C, $C, $A,  8,  6,  4,  2,  0,  0,  0,  0; 80
		dc.b   2,  4,  6,  8, $A, $C, $E, $C, $A,  8,  6,  4,  2,  0,  0,  0; 96
		dc.b   2,  4,  6,  8, $A, $C, $E, $E, $C, $A,  8,  6,  4,  2,  0,  0; 112
		dc.b   2,  4,  6,  8, $A, $C, $E,$10, $E, $C, $A,  8,  6,  4,  2,  0; 128
		dc.b   2,  4,  6,  8, $A, $C, $E,$10,$10, $E, $C, $A,  8,  6,  4,  2; 144     
; ===========================================================================		
Obj11_SecondDepressionOffsets:
		dc.b $FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 16
		dc.b $B5,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 32
		dc.b $7E,$DB,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 48
		dc.b $61,$B5,$EC,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 64
		dc.b $4A,$93,$CD,$F3,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 80
		dc.b $3E,$7E,$B0,$DB,$F6,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0; 96
		dc.b $38,$6D,$9D,$C5,$E4,$F8,$FF,  0,  0,  0,  0,  0,  0,  0,  0,  0; 112
		dc.b $31,$61,$8E,$B5,$D4,$EC,$FB,$FF,  0,  0,  0,  0,  0,  0,  0,  0; 128
		dc.b $2B,$56,$7E,$A2,$C1,$DB,$EE,$FB,$FF,  0,  0,  0,  0,  0,  0,  0; 144
		dc.b $25,$4A,$73,$93,$B0,$CD,$E1,$F3,$FC,$FF,  0,  0,  0,  0,  0,  0; 160
		dc.b $1F,$44,$67,$88,$A7,$BD,$D4,$E7,$F4,$FD,$FF,  0,  0,  0,  0,  0; 176
		dc.b $1F,$3E,$5C,$7E,$98,$B0,$C9,$DB,$EA,$F6,$FD,$FF,  0,  0,  0,  0; 192
		dc.b $19,$38,$56,$73,$8E,$A7,$BD,$D1,$E1,$EE,$F8,$FE,$FF,  0,  0,  0; 208
		dc.b $19,$38,$50,$6D,$83,$9D,$B0,$C5,$D8,$E4,$F1,$F8,$FE,$FF,  0,  0; 224
		dc.b $19,$31,$4A,$67,$7E,$93,$A7,$BD,$CD,$DB,$E7,$F3,$F9,$FE,$FF,  0; 240
		dc.b $19,$31,$4A,$61,$78,$8E,$A2,$B5,$C5,$D4,$E1,$EC,$F4,$FB,$FE,$FF; 256
; ===========================================================================		
;=============================================================================== 
; HPZ Bridge Mappings
;===============================================================================  
	
HpzBridge: ; loc_8598:
     incbin mappings/HPZ/obj11HPZ.bin
	 
;=============================================================================== 
; HPZ Bridge Mappings
;===============================================================================
	 
Bridge_Mappings: ; loc_85E0:
     incbin mappings/GHZ/obj11.bin    
	 
;===============================================================================           
; Obj11 Bridge End