loc_FC48: 
    tst.w   (Debug_placement_mode).w
    beq.s   Sonic_Normal ; loc_FC54
    jmp     Debug_Mode ; loc_23B70
; ---------------------------------------------------------------------------	
Sonic_Normal: ; loc_FC54:
    moveq   #0, d0
    move.b  routine(A0), d0
    move.w  Sonic_Index(pc, d0), d1 ; loc_FC62
    jmp     Sonic_Index(pc, d1)     ; loc_FC62
; ============== JUMP TABLE =================================================	
Sonic_Index: ; loc_FC62:
    dc.w    Sonic_Main-Sonic_Index       ; loc_FC6C
    dc.w    Sonic_Control-Sonic_Index    ; loc_FCE2
    dc.w    Sonic_Hurt-Sonic_Index       ; loc_1096A 
    dc.w    Sonic_Death-Sonic_Index      ; loc_109FE
    dc.w    Sonic_ResetLevel-Sonic_Index ; loc_10A9E
; ============== END JUMP TABLE =============================================	
Sonic_Main: ; loc_FC6C: 
    addq.b  #2, routine(A0)	; => Obj01_Control
    move.b  #$13, y_radius(A0) ; this sets Sonic's collision height (2*pixels)
    move.b  #$9, x_radius(A0)
    move.l  #Sonic_Mappings, mappings(A0) ; loc_614C0
    move.w  #$780, $2(A0)
    bsr     Adjust2PArtPointer     ; loc_DC30
    move.b  #2, priority(A0)
    move.b  #$18, width_pixels(A0)
    move.b  #4, $1(A0)
	move.w	#$600,(Sonic_top_speed).w	; set Sonic's top speed
	move.w	#$C,(Sonic_acceleration).w	; set Sonic's acceleration
	move.w	#$80,(Sonic_deceleration).w	; set Sonic's deceleration
    move.b  #$C, $3E(A0)
    move.b  #$D, $3F(A0)
    move.b  #0, $2C(A0)
    move.b  #4, $2D(A0)
    move.w  #$00, (Sonic_Pos_Record_Index).w
    move.w  #$3F, d2
Sonic_InitCont:        
    bsr     CopySonicMovesForTails  ; loc_FDFA
    move.w  #$00, $00(a1, d0)
    dbra    d2, Sonic_InitCont  
	
; ---------------------------------------------------------------------------
; Normal state for Sonic
; ---------------------------------------------------------------------------
	
Sonic_Control: ; loc_FCE2:
    tst.w   (Debug_mode_flag).w
    beq.s   loc_FCFC
    btst    #4, (Ctrl_1_Press).w
    beq.s   loc_FCFC
    move.w  #$1, (Debug_placement_mode).w
    clr.b   (Control_Locked).w
    rts
loc_FCFC:
    tst.b   (Control_Locked).w
    bne.s   loc_FD08
    move.w  (Ctrl_1).w, (Ctrl_1_Held_Logical).w
loc_FD08:
    btst    #0, $2A(A0)
    bne.s   Sonic_ControlsLock      ; loc_FD22 
    moveq   #0, d0
    move.b  status(A0), d0
    andi.w  #$6, d0
    move.w  Sonic_Modes(pc, d0), d1 ; loc_FD5E
    jsr     Sonic_Modes(pc, d1)     ; loc_FD5E    
	
Sonic_ControlsLock: ; loc_FD22:
    bsr.s   Sonic_Display       ; loc_FD76
    bsr     CopySonicMovesForTails  ; loc_FDFA
    bsr     Sonic_Water         ; loc_FE4E
    move.b  ($FFFFF768).w, $36(A0)
    move.b  ($FFFFF76A).w, $37(A0)
    tst.b   ($FFFFF7C7).w
    beq.s   loc_FD4A
    tst.b   anim(A0)
    bne.s   loc_FD4A
    move.b  next_anim(A0), anim(A0)
loc_FD4A:
    bsr     Sonic_Animate       ; loc_10AB2
    tst.b   $2A(A0)
    bmi.s   loc_FD5A
    jsr     TouchResponse       ; loc_21160
loc_FD5A:
    bra     Load_Sonic_Dynamic_PLC  ; loc_10DDC 
Sonic_Modes: ; loc_FD5E:
    dc.w    Sonic_MdNormal-Sonic_Modes    ; loc_FEEC
    dc.w    Sonic_MdJump-Sonic_Modes      ; loc_FF14
    dc.w    Sonic_MdRoll-Sonic_Modes      ; loc_FF3E
    dc.w    Sonic_MdJump2-Sonic_Modes     ; loc_FF5E          
Sonic_PlayList: ; loc_FD66:
    dc.b    $82, $82, $83, $90, $83, $83, $93, $96, $86, $8F, $81, $85, $84, $8D, $8D, $87 

;=============================================================================== 
; Sub Routine Sonic_Display
; [ Begin ]             
;===============================================================================   
Sonic_Display: ; loc_FD76:
    move.w  $30(A0), d0         
    beq.s   Obj01_Display
    subq.w  #1, $30(A0)
    lsr.w   #3, d0
    bcc.s   Obj01_ChkInvin
Obj01_Display:
    jsr     DisplaySprite       ; loc_D3C2
Obj01_ChkInvin:
    tst.b   ($FFFFFE2D).w
    beq.s   Obj01_ChkShoes
    tst.w   $32(A0)
    beq.s   Obj01_ChkShoes
    subq.w  #1, $32(A0)
    bne.s   Obj01_ChkShoes
    tst.b   (Current_Boss_ID).w
    bne.s   Obj01_RmvInvin
    cmpi.w  #$C, ($FFFFFE14).w
    bcs.s   Obj01_RmvInvin
    moveq   #0, d0
    move.b  (Current_Zone).w, d0
    lea     Sonic_PlayList(pc), a1  ; loc_FD66
    move.b  $00(a1, d0), d0
    jsr     (PlayMusic)        ; loc_14C0
Obj01_RmvInvin:
    move.b  #0, ($FFFFFE2D).w
Obj01_ChkShoes:
    tst.b   ($FFFFFE2E).w
    beq.s   Obj01_ExitChk
    tst.w   $34(A0)
    beq.s   Obj01_ExitChk
    subq.w  #1, $34(A0)
    bne.s   Obj01_ExitChk
    move.w  #$600, (Sonic_top_speed).w
    move.w  #$C, (Sonic_acceleration).w
    move.w  #$80, (Sonic_deceleration).w
    move.b  #0, ($FFFFFE2E).w
    move.w  #$FC, d0
    jmp     (PlayMusic)        ; loc_14C0           
Obj01_ExitChk:
    rts
;=============================================================================== 
; Sub Routine Sonic_Display
; [ End ]             
;===============================================================================
          
;=============================================================================== 
; Sub Routine CopySonicMovesForTails
; [ Begin ]             
;===============================================================================         
CopySonicMovesForTails: ; loc_FDFA:
    move.w  (Sonic_Pos_Record_Index).w, d0
    lea     (Sonic_Pos_Record_Buf).w, a1
    lea     $00(a1, d0), a1
    move.w  x_pos(A0), (a1)+
    move.w  y_pos(A0), (a1)+
    addq.b  #4, ($FFFFEED3).w
    lea     (Sonic_Stat_Record_Buf).w, a1
    move.w  (Ctrl_1).w, $00(a1, d0)
    rts
;=============================================================================== 
; Sub Routine CopySonicMovesForTails
; [ End ]             
;===============================================================================
          
; loc_FE1E:
    move.w  ($FFFFEEE0).w, d0
    subq.b  #4, d0
    lea     (Tails_Pos_Record_Buf).w, a1
    lea     $00(a1, d0), a2
    move.w  x_pos(A0), d1
    swap.w  d1
    move.w  y_pos(A0), d1
    cmp.l   (a2), d1
    beq.s   loc_FE4C
    addq.b  #4, d0
    lea     $00(a1, d0), a2
    move.w  x_pos(A0), (a2)+
    move.w  y_pos(A0), (a2)
    addq.b  #4, ($FFFFEEE1).w
loc_FE4C:
    rts  
; ---------------------------------------------------------------------------
; Subroutine for Sonic when he's underwater
; ---------------------------------------------------------------------------

; ||||||||||||||| S U B R O U T I N E |||||||||||||||||||||||||||||||||||||||
     
Sonic_Water: ; loc_FE4E:
    tst.b   (Water_flag).w
    bne.s   Sonic_InLevelWithWater  ; loc_FE56
loc_FE54:        
    rts
Sonic_InLevelWithWater: ; loc_FE56:
    move.w  (Water_Level_1).w, d0
    cmp.w   y_pos(A0), d0
    bge.s   Sonic_NotInWater    ; loc_FEA8
    bset    #6, status(A0)
    bne.s   loc_FE54  
    bsr     ResumeMusic         ; loc_124FE
	move.b	#$A,(Object_RAM+$2080).w ; load Obj0A (sonic's breathing bubbles) at $FFFFD080
	move.b	#$81,(Object_RAM+$2080+subtype).w
    move.w  #$300, (Sonic_top_speed).w
    move.w  #$6, (Sonic_acceleration).w
    move.w  #$40, (Sonic_deceleration).w
    asr.w   x_vel(A0)
    asr.w   y_vel(A0)
    asr.w   y_vel(A0)
    beq.s   loc_FE54
    move.b  #8, ($FFFFB300).w
    move.w  #$AA, d0
    jmp     (Play_Sfx)          ; loc_14C6
;===============================================================================         
Sonic_NotInWater: ; loc_FEA8:          
    bclr    #6, status(A0)
    beq.s   loc_FE54
    bsr     ResumeMusic         ; loc_124FE
    move.w  #$600, (Sonic_top_speed).w
    move.w  #$C, (Sonic_acceleration).w
    move.w  #$80, (Sonic_deceleration).w
    asl.w   y_vel(A0)
    beq     loc_FE54
    move.b  #8, ($FFFFB300).w
    cmpi.w  #$F000, y_vel(A0)
    bgt.s   loc_FEE2
    move.w  #$F000, y_vel(A0)
loc_FEE2:        
    move.w  #$AA, d0
    jmp     (Play_Sfx)          ; loc_14C6
Sonic_MdNormal: ; loc_FEEC:
    bsr     Sonic_Spindash      ; loc_10560
    bsr     Sonic_Jump          ; loc_10476
    bsr     Sonic_SlopeResist       ; loc_105EC
    bsr     Sonic_Move          ; loc_FF88
    bsr     Sonic_Roll          ; loc_10410
    bsr     Sonic_LevelBoundaries   ; loc_1038C
    jsr     SpeedToPos          ; loc_D27A
    bsr     Sonic_AnglePos      ; loc_12D28
    bsr     Sonic_SlopeRepel    ; loc_1065E
    rts
	
; ===========================================================================
; Start of subroutine Sonic_MdAir
; Called if Sonic is airborne, but not in a ball (thus, probably not jumping)
; ===========================================================================	
Sonic_MdJump: ; loc_FF14:
    bsr     Sonic_JumpHeight    ; loc_10524
    bsr     Sonic_ChgJumpDir    ; loc_10300
    bsr     Sonic_LevelBoundaries   ; loc_1038C
    jsr     ObjectFall          ; loc_D24E
    btst    #6, status(A0)
    beq.s   loc_FF34
    subi.w  #$28, y_vel(A0)
loc_FF34:
    bsr     Sonic_JumpAngle     ; loc_106A0
    bsr     Sonic_Floor         ; loc_10700
    rts
	
; ===========================================================================
; Start of subroutine Sonic
; Called if Sonic is in a ball, but not airborne (thus, probably rolling)	
; ===========================================================================
Sonic_MdRoll: ; loc_FF3E:
    bsr     Sonic_Jump          ; loc_10476
    bsr     Sonic_RollRepel     ; loc_10622
    bsr     Sonic_RollSpeed     ; loc_10208
    bsr     Sonic_LevelBoundaries   ; loc_1038C
    jsr     SpeedToPos          ; loc_D27A
    bsr     Sonic_AnglePos      ; loc_12D28
    bsr     Sonic_SlopeRepel    ; loc_1065E
    rts
Sonic_MdJump2: ; loc_FF5E:
    bsr     Sonic_JumpHeight    ; loc_10524
    bsr     Sonic_ChgJumpDir    ; loc_10300
    bsr     Sonic_LevelBoundaries   ; loc_1038C
    jsr     ObjectFall          ; loc_D24E
    btst    #6, status(A0)
    beq.s   loc_FF7E
    subi.w  #$28, y_vel(A0)
loc_FF7E:
    bsr     Sonic_JumpAngle     ; loc_106A0
    bsr     Sonic_Floor         ; loc_10700
    rts
        
;=============================================================================== 
; Sub Routine Sonic_Move
; [ Begin ]             
;===============================================================================          
Sonic_Move: ; loc_FF88:
    move.w  (Sonic_top_speed).w, d6
    move.w  (Sonic_acceleration).w, d5
    move.w  (Sonic_deceleration).w, d4
    tst.b   ($FFFFF7CA).w
    bne     loc_1009A
    tst.w   $2E(A0)
    bne     Sonic_ResetScr
    btst    #2, (Ctrl_1_Held_Logical).w
    beq.s   Sonic_NotLeft
    bsr     Sonic_MoveLeft      ; loc_1012A
Sonic_NotLeft:
    btst    #3, (Ctrl_1_Held_Logical).w
    beq.s   Sonic_NotRight
    bsr     Sonic_MoveRight     ; loc_1019C
Sonic_NotRight:
    move.b  angle(A0), d0
    addi.b  #$20, d0
	andi.b	#$C0,d0		; is Sonic on a slope?
	bne.w	Sonic_ResetScr	; if yes, branch
	tst.w	inertia(a0)	; is Sonic moving?
	bne.w	Sonic_ResetScr	; if yes, branch
	bclr	#5,status(a0)
	move.b	#5,anim(a0)	; use "standing" animation
    btst    #3, status(A0)
    beq.s   Sonic_Balance       ; loc_1001E
    moveq   #0, d0
    move.b  $3D(A0), d0
    lsl.w   #6, d0
    lea     (MainCharacter).w, a1
    lea     $00(a1, d0), a1
    tst.b   status(a1)
    bmi.s   Sonic_LookUp        ; loc_10050
    moveq   #0, d1
    move.b  width_pixels(a1), d1
    move.w  d1, d2
    add.w   d2, d2
    subq.w  #4, d2
    add.w   x_pos(A0), d1
    sub.w   x_pos(a1), d1
    cmpi.w  #$4, d1
    blt.s   loc_10042
    cmp.w   d2, d1
    bge.s   loc_10032
    bra.s   Sonic_LookUp        ; loc_10050
;===============================================================================        
Sonic_Balance: ; loc_1001E:
    jsr     Sonic_HitFloor      ; loc_137F4
    cmpi.w  #$C, d1
    blt.s   Sonic_LookUp        ; loc_10050
    cmpi.b  #3, $36(A0)
    bne.s   loc_1003A
loc_10032:
    bclr    #0, status(A0)
    bra.s   loc_10048
loc_1003A:
    cmpi.b  #3, $37(A0)
    bne.s   Sonic_LookUp        ; loc_10050
loc_10042:        
    bset    #0, status(A0)
loc_10048:        
    move.b  #6, anim(A0)
    bra.s   Sonic_ResetScr
;===============================================================================           
Sonic_LookUp: ; loc_10050:
    btst    #0, (Ctrl_1_Held_Logical).w
    beq.s   Sonic_Duck          ; loc_10060
    move.b  #7, anim(A0)
    bra.s   Sonic_ResetScr
;===============================================================================           
Sonic_Duck: ; loc_10060:
    btst    #1, (Ctrl_1_Held_Logical).w
    beq.s   Sonic_ResetScr
    move.b  #8, anim(A0)
Sonic_ResetScr:
    move.b  (Ctrl_1_Logical).w, d0
    andi.b  #$C, d0
    bne.s   loc_1009A
    move.w  inertia(A0), d0
    beq.s   loc_1009A
    bmi.s   loc_1008E
    sub.w   d5, d0
    bcc.s   loc_10088
    move.w  #$00, d0
loc_10088:
    move.w  d0, inertia(A0)
    bra.s   loc_1009A
loc_1008E:
    add.w   d5, d0
    bcc.s   loc_10096
    move.w  #$00, d0
loc_10096:
    move.w  d0, inertia(A0)
loc_1009A:
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  inertia(A0), d1
    asr.l   #8, d1
    move.w  d1, x_vel(A0)
    muls.w  inertia(A0), d0
    asr.l   #8, d0
    move.w  d0, y_vel(A0)
loc_100B8:        
    move.b  angle(A0), d0
    addi.b  #$40, d0
    bmi.s   loc_10128
    move.b  #$40, d1
    tst.w   inertia(A0)
    beq.s   loc_10128
    bmi.s   loc_100D0
    neg.w   d1
loc_100D0:
    move.b  angle(A0), d0
    add.b   d1, d0
    move.w  d0, -(a7)
    bsr     Sonic_WalkSpeed     ; loc_1366C
    move.w  (a7)+, d0
    tst.w   d1
    bpl.s   loc_10128
    asl.w   #8, d1
    addi.b  #$20, d0
    andi.b  #$C0, d0
    beq.s   loc_10124
    cmpi.b  #$40, d0
    beq.s   loc_10112
    cmpi.b  #$80, d0
    beq.s   loc_1010C
    add.w   d1, x_vel(A0)
    bset    #5, status(A0)
    move.w  #$00, inertia(A0)
    rts
loc_1010C:
    sub.w   d1, y_vel(A0)
    rts
loc_10112:
    sub.w   d1, x_vel(A0)
    bset    #5, status(A0)
    move.w  #$00, inertia(A0)
    rts
loc_10124:
    add.w   d1, y_vel(A0)
loc_10128:        
    rts    
;=============================================================================== 
; Sub Routine Sonic_Move
; [ End ]             
;===============================================================================  

;=============================================================================== 
; Sub Routine Sonic_MoveLeft
; [ Begin ]             
;===============================================================================                 
Sonic_MoveLeft: ; loc_1012A:
    move.w  inertia(A0), d0
    beq.s   loc_10132
    bpl.s   Sonic_TurnLeft
loc_10132:
    bset    #0, status(A0)
    bne.s   loc_10146
    bclr    #5, status(A0)          
    move.b  #1, next_anim(A0) 
loc_10146:
    sub.w   d5, d0
    move.w  d6, d1
    neg.w   d1
    cmp.w   d1, d0
    bgt.s   loc_10158
    add.w   d5, d0
    cmp.w   d1, d0
    ble.s   loc_10158
    move.w  d1, d0
loc_10158:
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    rts
; ---------------------------------------------------------------------------	
Sonic_TurnLeft:
    sub.w   d4, d0
    bcc.s   loc_1016C
    move.w  #$FF80, d0
loc_1016C:
    move.w  d0, inertia(A0)
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    bne.s   loc_1019A
    cmpi.w  #$400, d0         
    blt.s   loc_1019A
    move.b  #$D, anim(A0)
    bclr    #0, status(A0)
    move.w  #$A4, d0
    jsr     (Play_Sfx)          ; loc_14C6
loc_1019A:
    rts
;=============================================================================== 
; Sub Routine Sonic_MoveLeft
; [ End ]             
;===============================================================================    

;=============================================================================== 
; Sub Routine Sonic_MoveRight
; [ Begin ]             
;===============================================================================          
Sonic_MoveRight: ; loc_1019C:
    move.w  inertia(A0), d0
    bmi.s   loc_101D0
    bclr    #0, status(A0)
    beq.s   loc_101B6
    bclr    #5, status(A0)
    move.b  #1, next_anim(A0)
loc_101B6:
    add.w   d5, d0
    cmp.w   d6, d0
    blt.s   loc_101C4
    sub.w   d5, d0
    cmp.w   d6, d0
    bge.s   loc_101C4
    move.w  d6, d0
loc_101C4:
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    rts 
loc_101D0:
    add.w   d4, d0
    bcc.s   loc_101D8
    move.w  #$80, d0
loc_101D8:
    move.w  d0, inertia(A0)
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    bne.s   loc_10206
    cmpi.w  #$FC00, d0
    bgt.s   loc_10206
    move.b  #$D, anim(A0)
    bset    #0, status(A0)
    move.w  #$A4, d0
    jsr     (Play_Sfx)          ; loc_14C6
loc_10206:
    rts
;=============================================================================== 
; Sub Routine Sonic_MoveRight
; [ End ]             
;===============================================================================    
           
;=============================================================================== 
; Sub Routine Sonic_RollSpeed
; [ Begin ]             
;===============================================================================               
Sonic_RollSpeed: ; loc_10208:
    move.w  (Sonic_top_speed).w, d6
    asl.w   #1, d6
    move.w  (Sonic_acceleration).w, d5
    asr.w   #1, d5
    move.w  (Sonic_deceleration).w, d4
    asr.w   #2, d4
    tst.b   ($FFFFF7CA).w
    bne     loc_10284
    tst.w   $2E(A0)
    bne.s   loc_10240
    btst    #2, (Ctrl_1_Held_Logical).w
    beq.s   loc_10234
    bsr     Sonic_RollLeft      ; loc_102BA
loc_10234:        
    btst    #3, (Ctrl_1_Held_Logical).w
    beq.s   loc_10240
    bsr     Sonic_RollRight     ; loc_102DE
loc_10240:        
    move.w  inertia(A0), d0        
    beq.s   loc_10262
    bmi.s   loc_10256
    sub.w   d5, d0
    bcc.s   loc_10250
    move.w  #$00, d0
loc_10250:
    move.w  d0, inertia(A0)
    bra.s   loc_10262
loc_10256:
    add.w   d5, d0
    bcc.s   loc_1025E
    move.w  #$00, d0
loc_1025E:        
    move.w  d0, inertia(A0) 
loc_10262:        
    tst.w   inertia(A0)
    bne.s   loc_10284
    bclr    #2, status(A0)
    move.b  #$13, y_radius(A0)
    move.b  #$9, x_radius(A0)
    move.b  #5, anim(A0)
    subq.w  #5, y_pos(A0)
loc_10284:        
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  inertia(A0), d0
    asr.l   #8, d0
    move.w  d0, y_vel(A0)
    muls.w  inertia(A0), d1
    asr.l   #8, d1
    cmpi.w  #$1000, d1
    ble.s   loc_102A8
    move.w  #$1000, d1
loc_102A8:
    cmpi.w  #$F000, d1
    bge.s   loc_102B2
    move.w  #$F000, d1
loc_102B2:
    move.w  d1, x_vel(A0)
    bra     loc_100B8   
;=============================================================================== 
; Sub Routine Sonic_RollSpeed
; [ End ]             
;===============================================================================  

;=============================================================================== 
; Sub Routine Sonic_RollLeft
; [ Begin ]             
;===============================================================================  
Sonic_RollLeft: ; loc_102BA:
    move.w  inertia(A0), d0
    beq.s   loc_102C2
    bpl.s   loc_102D0
loc_102C2:
    bset    #0, status(A0)
    move.b  #2, anim(A0)
    rts
loc_102D0:
    sub.w   d4, d0
    bcc.s   loc_102D8
    move.w  #$FF80, d0
loc_102D8:
    move.w  d0, inertia(A0)
    rts 
;=============================================================================== 
; Sub Routine Sonic_RollLeft
; [ End ]             
;===============================================================================  

;=============================================================================== 
; Sub Routine Sonic_RollRight
; [ Begin ]             
;===============================================================================  
Sonic_RollRight: ; loc_102DE:
    move.w  inertia(A0), d0
    bmi.s   loc_102F2
    bclr    #0, status(A0)
    move.b  #2, anim(A0)
    rts
loc_102F2:
    add.w   d4, d0
    bcc.s   loc_102FA
    move.w  #$80, d0
loc_102FA:
    move.w  d0, inertia(A0)
    rts   
;=============================================================================== 
; Sub Routine Sonic_RollRight
; [ End ]             
;===============================================================================
          
;=============================================================================== 
; Sub Routine Sonic_ChgJumpDir
; [ Begin ]             
;===============================================================================         
Sonic_ChgJumpDir: ; loc_10300:
    move.w  (Sonic_top_speed).w, d6
    move.w  (Sonic_acceleration).w, d5
    asl.w   #1, d5
    btst    #4, status(A0)
    bne.s   loc_1034A
    move.w  x_vel(A0), d0
    btst    #2, (Ctrl_1_Held_Logical).w
    beq.s   loc_10330
    bset    #0, status(A0)
    sub.w   d5, d0
    move.w  d6, d1
    neg.w   d1
    cmp.w   d1, d0
    bgt.s   loc_10330
    move.w  d1, d0
loc_10330:
    btst    #3, (Ctrl_1_Held_Logical).w
    beq.s   loc_10346
    bclr    #0, status(A0)
    add.w   d5, d0
    cmp.w   d6, d0
    blt.s   loc_10346
    move.w  d6, d0
loc_10346:
    move.w  d0, x_vel(A0)
loc_1034A:
    cmpi.w  #$60, (Camera_Y_pos_bias).w
    beq.s   loc_1035C
    bcc.s   loc_10358
    addq.w  #4, (Camera_Y_pos_bias).w
loc_10358:
    subq.w  #2, (Camera_Y_pos_bias).w
loc_1035C:
    cmpi.w  #$FC00, y_vel(A0)
    bcs.s   loc_1038A         
    move.w  x_vel(A0), d0
    move.w  d0, d1
    asr.w   #5, d1
    beq.s   loc_1038A
    bmi.s   loc_1037E
    sub.w   d1, d0
    bcc.s   loc_10378
    move.w  #$00, d0
loc_10378:
    move.w  d0, x_vel(A0)
    rts
loc_1037E:
    sub.w   d1, d0
    bcs.s   loc_10386
    move.w  #$00, d0
loc_10386:
    move.w  d0, x_vel(A0)
loc_1038A:        
    rts    
;=============================================================================== 
; Sub Routine Sonic_ChgJumpDir
; [ End ]             
;===============================================================================
              
;=============================================================================== 
; Sub Routine Sonic_LevelBoundaries
; [ Begin ]             
;===============================================================================                   
Sonic_LevelBoundaries: ; loc_1038C:
    move.l  x_pos(A0), d1
    move.w  x_vel(A0), d0
    ext.l   d0
    asl.l   #8, d0
    add.l   d0, d1
    swap.w  d1
    move.w  (Camera_Min_X_pos).w, d0
    addi.w  #$10, d0
    cmp.w   d1, d0
    bhi.s   loc_103F8
    move.w  (Camera_Max_X_pos).w, d0
    addi.w  #$128, d0
    tst.b   (Current_Boss_ID).w
    bne.s   loc_103BA
    addi.w  #$40, d0
loc_103BA:
    cmp.w   d1, d0
    bls.s   loc_103F8
loc_103BE:
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$E0, d0
    cmp.w   y_pos(A0), d0
    blt.s   loc_103CE
    rts
loc_103CE:
    bra     J_KillSonic_00      ; loc_10E30
    cmpi.w  #$1001, (Current_ZoneAndAct).w
    bne     J_KillSonic_00      ; loc_10E30
    cmpi.w  #$2000, ($FFFFB008).w
    bcs     J_KillSonic_00      ; loc_10E30
    clr.b   (Last_star_pole_hit).w
    move.w  #$1, (Level_Inactive_flag).w
    move.w  #$103, (Current_ZoneAndAct).w
    rts
loc_103F8:
    move.w  d0, x_pos(A0)
    move.w  #$00, $A(A0)
    move.w  #$00, x_vel(A0)
    move.w  #$00, inertia(A0)
    bra.s   loc_103BE
;=============================================================================== 
; Sub Routine Sonic_LevelBoundaries
; [ End ]             
;===============================================================================          
        
;=============================================================================== 
; Sub Routine Sonic_Roll
; [ Begin ]             
;===============================================================================           
Sonic_Roll: ; loc_10410:
    tst.b   ($FFFFF7CA).w
    bne.s   Sonic_NoRoll        ; loc_10436
    move.w  inertia(A0), d0
    bpl.s   loc_1041E
    neg.w   d0
loc_1041E:
    cmpi.w  #$80, d0
    bcs.s   Sonic_NoRoll        ; loc_10436
    move.b  (Ctrl_1_Logical).w, d0
    andi.b  #$C, d0
    bne.s   Sonic_NoRoll        ; loc_10436
    btst    #1, (Ctrl_1_Held_Logical).w
    bne.s   loc_10438
Sonic_NoRoll: ; loc_10436:
    rts
loc_10438:
    btst    #2, status(A0)
    beq.s   Sonic_DoRoll        ; loc_10442
    rts
;===============================================================================          
Sonic_DoRoll: ; loc_10442:
    bset    #2, status(A0)
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    addq.w  #5, y_pos(A0)
    move.w  #$BE, d0
    jsr     (Play_Sfx)          ; loc_14C6
    tst.w   inertia(A0)
    bne.s   loc_10474
    move.w  #$200, inertia(A0)
loc_10474:
    rts
;=============================================================================== 
; Sub Routine Sonic_Roll
; [ End ]             
;===============================================================================    
          
;=============================================================================== 
; Sub Routine Sonic_Jump
; [ Begin ]             
;===============================================================================        
Sonic_Jump: ; loc_10476:
    move.b  (Ctrl_1_Press_Logical).w, d0
    andi.b  #$70, d0
    beq     loc_1051A
    moveq   #0, d0
    move.b  angle(A0), d0
    addi.b  #$80, d0
    bsr     loc_136F2
    cmpi.w  #$6, d1
    blt     loc_1051A
    move.w  #$680, d2
    btst    #6, status(A0)
    beq.s   loc_104A8
    move.w  #$380, d2
loc_104A8:
    moveq   #0, d0
    move.b  angle(A0), d0
    subi.b  #$40, d0
    jsr     CalcSine        ; loc_320A
    muls.w  d2, d1
    asr.l   #8, d1
    add.w   d1, x_vel(A0)
    muls.w  d2, d0
    asr.l   #8, d0
    add.w   d0, y_vel(A0)
    bset    #1, status(A0)
    bclr    #5, status(A0)
    addq.l  #4, a7
    move.b  #1, $3C(A0)
    clr.b   $38(A0)
    move.w  #$A0, d0
    jsr     (Play_Sfx)          ; loc_14C6
    move.b  #$13, y_radius(A0)
    move.b  #$9, x_radius(A0)
    btst    #2, status(A0)
    bne.s   loc_1051C
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    bset    #2, status(A0)
    addq.w  #5, y_pos(A0)
loc_1051A:        
    rts
loc_1051C:
    bset    #4, status(A0)
    rts   
;=============================================================================== 
; Sub Routine Sonic_Jump
; [ End ]             
;===============================================================================   

;=============================================================================== 
; Sub Routine Sonic_JumpHeight
; [ Begin ]             
;===============================================================================   
Sonic_JumpHeight: ; loc_10524:
    tst.b   $3C(A0)
    beq.s   loc_10550
    move.w  #$FC00, d1
    btst    #6, status(A0)
    beq.s   loc_1053A
    move.w  #$FE00, d1
loc_1053A:
    cmp.w   y_vel(A0), d1
    ble.s   loc_1054E
    move.b  (Ctrl_1_Logical).w, d0
    andi.b  #$70, d0
    bne.s   loc_1054E
    move.w  d1, y_vel(A0)
loc_1054E:
    rts  
loc_10550:
    cmpi.w  #$F040, y_vel(A0)
    bge.s   loc_1055E
    move.w  #$F040, y_vel(A0)
loc_1055E:
    rts 
;=============================================================================== 
; Sub Routine Sonic_JumpHeight
; [ End ]             
;===============================================================================
          
;=============================================================================== 
; Sub Routine Sonic_Spindash
; [ Begin ]             
;===============================================================================                     
Sonic_Spindash: ; loc_10560:
    tst.b   $39(A0)
    bne.s   loc_10594
    cmpi.b  #8, anim(A0)
    bne.s   loc_10592
    move.b  (Ctrl_1_Press_Logical).w, d0
    andi.b  #$70, d0
    beq     loc_10592
    move.b  #$9, anim(A0)
    move.w  #$BE, d0
    jsr     (Play_Sfx)          ; loc_14C6
    addq.l  #4, a7
    move.b  #1, $39(A0)
loc_10592:
    rts
loc_10594:        
    move.b  (Ctrl_1_Logical).w, d0
    btst    #1, d0
    bne.s   loc_105DA
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    addq.w  #5, y_pos(A0)
    move.b  #0, $39(A0)
    move.w  #$2000, ($FFFFEED0).w
    move.w  #$800, inertia(A0)
    btst    #0, status(A0)
    beq.s   loc_105D2
    neg.w   inertia(A0)
loc_105D2:
    bset    #2, status(A0)
    rts
loc_105DA:
    move.b  (Ctrl_1_Press_Logical).w, d0
    andi.b  #$70, d0
    beq     loc_105E8
    nop
loc_105E8:
    addq.l  #4, a7
    rts          
;=============================================================================== 
; Sub Routine Sonic_Spindash
; [ End ]             
;===============================================================================  

;=============================================================================== 
; Sub Routine Sonic_SlopeResist
; [ Begin ]             
;===============================================================================              
Sonic_SlopeResist: ; loc_105EC:
    move.b  angle(A0), d0
    addi.b  #$60, d0
    cmpi.b  #$C0, d0
    bcc.s   loc_10620
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  #$20, d0
    asr.l   #8, d0
    tst.w   inertia(A0)
    beq.s   loc_10620
    bmi.s   loc_1061C
    tst.w   d0
    beq.s   loc_1061A
    add.w   d0, inertia(A0)
loc_1061A:
    rts
loc_1061C:
    add.w   d0, inertia(A0)
loc_10620:
    rts
;=============================================================================== 
; Sub Routine Sonic_SlopeResist
; [ End ]             
;=============================================================================== 
 
;=============================================================================== 
; Sub Routine Sonic_RollRepel
; [ Begin ]             
;===============================================================================  
Sonic_RollRepel: ; loc_10622:
    move.b  angle(A0), d0
    addi.b  #$60, d0
    cmpi.b  #$C0, d0
    bcc.s   loc_1065C
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  #$50, d0
    asr.l   #8, d0
    tst.w   inertia(A0)
    bmi.s   loc_10652
    tst.w   d0
    bpl.s   loc_1064C
    asr.l   #2, d0
loc_1064C:
    add.w   d0, inertia(A0)
    rts
loc_10652:
    tst.w   d0
    bmi.s   loc_10658
    asr.l   #2, d0
loc_10658:
    add.w   d0, inertia(A0)
loc_1065C:
    rts  
;=============================================================================== 
; Sub Routine Sonic_RollRepel
; [ End ]             
;===============================================================================   
           
;=============================================================================== 
; Sub Routine Sonic_SlopeRepel
; [ Begin ]             
;===============================================================================  
Sonic_SlopeRepel: ; loc_1065E:
    nop
    tst.b   $38(A0)
    bne.s   loc_10698
    tst.w   $2E(A0)
    bne.s   loc_1069A
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    beq.s   loc_10698
    move.w  inertia(A0), d0
    bpl.s   loc_10682
    neg.w   d0
loc_10682:
    cmpi.w  #$280, d0
    bcc.s   loc_10698
    clr.w   inertia(A0)
    bset    #1, status(A0)
    move.w  #$1E, $2E(A0)
loc_10698:
    rts
loc_1069A:
    subq.w  #1, $2E(A0)
    rts 
;=============================================================================== 
; Sub Routine Sonic_SlopeRepel
; [ End ]             
;===============================================================================  

;=============================================================================== 
; Sub Routine Sonic_JumpAngle
; [ Begin ]             
;=============================================================================== 
Sonic_JumpAngle: ; loc_106A0:
    move.b  angle(A0), d0
    beq.s   loc_106BA
    bpl.s   loc_106B0
    addq.b  #2, d0
    bcc.s   loc_106AE
    moveq   #0, d0
loc_106AE:
    bra.s   loc_106B6
loc_106B0:        
    subq.b  #2, d0
    bcc.s   loc_106B6
    moveq   #0, d0
loc_106B6:
    move.b  d0, angle(A0)
loc_106BA:
    move.b  flip_angle(A0), d0
    beq.s   loc_106FE
    tst.w   inertia(A0)
    bmi.s   loc_106DE
loc_106C6:
    move.b  $2D(A0), d1
    add.b   d1, d0
    bcc.s   loc_106DC
    subq.b  #1, $2C(A0)
    bcc.s   loc_106DC
    move.b  #0, $2C(A0)
    moveq   #0, d0
loc_106DC:
    bra.s   loc_106FA
loc_106DE:
    tst.b   flip_turned(A0)
    bne.s   loc_106C6
    move.b  $2D(A0), d1
    sub.b   d1, d0
    bcc.s   loc_106FA
    subq.b  #1, $2C(A0)
    bcc.s   loc_106FA
    move.b  #0, $2C(A0)
    moveq   #0, d0
loc_106FA:
    move.b  d0, flip_angle(A0)
loc_106FE:        
    rts
;=============================================================================== 
; Sub Routine Sonic_JumpAngle
; [ End ]             
;=============================================================================== 

;=============================================================================== 
; Sub Routine Sonic_Floor
; [ Begin ]             
;=============================================================================== 
Sonic_Floor: ; loc_10700:
    move.l  #Tails_Tails, (Collision_addr).w
    cmpi.b  #$C, $3E(A0)
    beq.s   loc_10718
    move.l  #Primary_Collision, (Collision_addr).w
loc_10718:
    move.b  $3F(A0), d5
    move.w  x_vel(A0), d1
    move.w  y_vel(A0), d2
    jsr     CalcAngle           ; loc_34A2
    move.b  d0, $2B(A0)
    subi.b  #$20, d0
    andi.b  #$C0, d0
    cmpi.b  #$40, d0
    beq     loc_107EC
    cmpi.b  #$80, d0
    beq     loc_1084E
    cmpi.b  #$C0, d0
    beq     loc_108AA
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_10760
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_10760:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_10772
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_10772:
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_107EA
    move.b  y_vel(A0), d2
    addq.b  #8, d2
    neg.b   d2
    cmp.b   d2, d1
    bge.s   loc_1078A
    cmp.b   d2, d0
    blt.s   loc_107EA
loc_1078A:
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Sonic_ResetOnFloor      ; loc_1090C
    move.b  #0, anim(A0)
    move.b  d3, d0
    addi.b  #$20, d0
    andi.b  #$40, d0
    bne.s   loc_107C8
    move.b  d3, d0
    addi.b  #$10, d0
    andi.b  #$20, d0
    beq.s   loc_107BA
    asr.w   y_vel(A0)
    bra.s   loc_107DC
loc_107BA:
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
    rts
loc_107C8:
    move.w  #$00, x_vel(A0)
    cmpi.w  #$FC0, y_vel(A0)
    ble.s   loc_107DC
    move.w  #$FC0, y_vel(A0)
loc_107DC:
    move.w  y_vel(A0), inertia(A0)
    tst.b   d3
    bpl.s   loc_107EA
    neg.w   inertia(A0)
loc_107EA:
    rts 
loc_107EC:
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_10806
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
    move.w  y_vel(A0), inertia(A0)
    rts
loc_10806:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_10820
    sub.w   d1, y_pos(A0)
    tst.w   y_vel(A0)
    bpl.s   loc_1081E
    move.w  #$00, y_vel(A0)
loc_1081E:
    rts
loc_10820:
    tst.w   y_vel(A0)
    bmi.s   loc_1084C
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_1084C
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Sonic_ResetOnFloor      ; loc_1090C
    move.b  #0, anim(A0)
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
loc_1084C:  
    rts
loc_1084E:
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_10860
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_10860:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_10872
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_10872:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_108A8
    sub.w   d1, y_pos(A0)
    move.b  d3, d0
    addi.b  #$20, d0
    andi.b  #$40, d0
    bne.s   loc_10892
    move.w  #$00, y_vel(A0)
    rts
loc_10892:
    move.b  d3, angle(A0)
    bsr     Sonic_ResetOnFloor      ; loc_1090C
    move.w  y_vel(A0), inertia(A0)
    tst.b   d3
    bpl.s   loc_108A8
    neg.w   inertia(A0)
loc_108A8:
    rts
loc_108AA:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_108C4
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
    move.w  y_vel(A0), inertia(A0)
    rts
loc_108C4:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_108DE
    sub.w   d1, y_pos(A0)
    tst.w   y_vel(A0)
    bpl.s   loc_108DC
    move.w  #$00, y_vel(A0)
loc_108DC:
    rts
loc_108DE:
    tst.w   y_vel(A0)
    bmi.s   loc_1090A
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_1090A
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Sonic_ResetOnFloor      ; loc_1090C
    move.b  #0, anim(A0)
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
loc_1090A:
    rts
;=============================================================================== 
; Sub Routine Sonic_Floor
; [ End ]             
;===============================================================================     
        
;=============================================================================== 
; Sub Routine Sonic_ResetOnFloor
; [ Begin ]             
;===============================================================================          
Sonic_ResetOnFloor: ; loc_1090C:
    btst    #4, status(A0)
    beq.s   loc_1091A
    nop
    nop
    nop
loc_1091A:
    bclr    #5, status(A0)
    bclr    #1, status(A0)
    bclr    #4, status(A0)
    btst    #2, status(A0)
    beq.s   loc_10950
    bclr    #2, status(A0)
    move.b  #$13, y_radius(A0)
    move.b  #$9, x_radius(A0)
    move.b  #0, anim(A0)
    subq.w  #5, y_pos(A0)
loc_10950:
    move.b  #0, $3C(A0)
    move.w  #$00, (Chain_Bonus_counter).w
    move.b  #0, flip_angle(A0)
    move.b  #0, flip_turned(A0)
    rts 
;=============================================================================== 
; Sub Routine Sonic_ResetOnFloor
; [ End ]             
;===============================================================================          
        
Sonic_Hurt: ; loc_1096A:
    tst.b   routine_secondary(A0)
    bmi     loc_109E2
    jsr     SpeedToPos          ; loc_D27A
    addi.w  #$30, y_vel(A0)
    btst    #6, status(A0)
    beq.s   loc_1098C
    subi.w  #$20, y_vel(A0)
loc_1098C:            
    bsr     Sonic_HurtStop      ; loc_109A6
    bsr     Sonic_LevelBoundaries   ; loc_1038C
    bsr     CopySonicMovesForTails  ; loc_FDFA
    bsr     Sonic_Animate       ; loc_10AB2
    bsr     Load_Sonic_Dynamic_PLC  ; loc_10DDC
    jmp     DisplaySprite       ; loc_D3C2
;=============================================================================== 
; Sub Routine Sonic_HurtStop
; [ Begin ]             
;===============================================================================           
Sonic_HurtStop: ; loc_109A6:
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$E0, d0
    cmp.w   y_pos(A0), d0
    bcs     J_KillSonic_00      ; loc_10E30
    bsr     Sonic_Floor         ; loc_10700
    btst    #1, status(A0)
    bne.s   loc_109E0
    moveq   #0, d0
    move.w  d0, y_vel(A0)
    move.w  d0, x_vel(A0)
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    subq.b  #2, routine(A0)
    move.w  #$78, $30(A0)
loc_109E0:
    rts
;=============================================================================== 
; Sub Routine Sonic_HurtStop
; [ End ]             
;===============================================================================  
        
loc_109E2:
    subq.b  #2, routine(A0)
    move.b  #0, routine_secondary(A0)
    bsr     CopySonicMovesForTails  ; loc_FDFA
    bsr     Sonic_Animate       ; loc_10AB2
    bsr     Load_Sonic_Dynamic_PLC  ; loc_10DDC
    jmp     DisplaySprite       ; loc_D3C2
Sonic_Death: ; loc_109FE:        
    bsr     Sonic_GameOver      ; loc_10A1A
    jsr     ObjectFall          ; loc_D24E
    bsr     CopySonicMovesForTails  ; loc_FDFA
    bsr     Sonic_Animate       ; loc_10AB2
    bsr     Load_Sonic_Dynamic_PLC  ; loc_10DDC
    jmp     DisplaySprite       ; loc_D3C2
        
;=============================================================================== 
; Sub Routine Sonic_GameOver
; [ Begin ]             
;===============================================================================           
Sonic_GameOver: ; loc_10A1A:
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$100, d0
    cmp.w   y_pos(A0), d0
    bcc     loc_10A9C
    move.w  #$FFC8, y_vel(A0)
    addq.b  #2, routine(A0)
    clr.b   (Update_HUD_timer).w
    addq.b  #1, (Update_HUD_lives).w
    subq.b  #1, (Life_count).w
    bne.s   loc_10A70
    move.w  #$00, $3A(A0)
    move.b  #$39, ($FFFFB080).w
    move.b  #$39, ($FFFFB0C0).w         
    move.b  #1, ($FFFFB0DA).w
    clr.b   (Time_Over_flag).w
loc_10A5E:        
    move.w  #$9B, d0
    jsr     (PlayMusic)        ; loc_14C0
    moveq   #3, d0
    jmp     LoadPLC         ; loc_173C   
loc_10A70:
    move.w  #$3C, $3A(A0)
    tst.b   (Time_Over_flag).w
    beq.s   loc_10A9C
    move.w  #$00, $3A(A0)
    move.b  #$39, ($FFFFB080).w
    move.b  #$39, ($FFFFB0C0).w
    move.b  #2, ($FFFFB09A).w
    move.b  #3, ($FFFFB0DA).w
    bra.s   loc_10A5E
loc_10A9C:
    rts
;=============================================================================== 
; Sub Routine Sonic_GameOver
; [ End ]             
;===============================================================================         
        
Sonic_ResetLevel: ; loc_10A9E:
    tst.w   $3A(A0)
    beq.s   loc_10AB0
    subq.w  #1, $3A(A0)
    bne.s   loc_10AB0
    move.w  #$1, (Level_Inactive_flag).w
loc_10AB0:
    rts
        
;=============================================================================== 
; Sub Routine Sonic_Animate
; [ Begin ]             
;===============================================================================          
Sonic_Animate: ; loc_10AB2:
    lea     (Sonic_AnimateData), a1 ; loc_10CB4
    moveq   #0, d0
    move.b  anim(A0), d0
    cmp.b   next_anim(A0), d0
    beq.s   SAnim_Do
    move.b  d0, next_anim(A0)
    move.b  #0, anim_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    bclr    #5, status(A0)
SAnim_Do:
    add.w   d0, d0
    adda.w  $00(a1, d0), a1
    move.b  (a1), d0
    bmi.s   SAnim_WalkRun
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    subq.b  #1, anim_frame_duration(A0) 
    bpl.s   SAnim_Delay
    move.b  d0, anim_frame_duration(A0)         
SAnim_Do2:        
    moveq   #0, d1
    move.b  anim_frame(A0), d1
    move.b  $1(a1, d1), d0
    cmpi.b  #$F0, d0
    bcc.s   SAnim_End_FF
SAnim_Next:        
    move.b  d0, mapping_frame(A0)
    addq.b  #1, anim_frame(A0)
SAnim_Delay:        
    rts
; ===========================================================================	
SAnim_End_FF:
    addq.b  #1, d0
    bne.s   SAnim_End_FE
    move.b  #0, anim_frame(A0)
    move.b  $1(a1), d0
    bra.s   SAnim_Next
; ===========================================================================	
SAnim_End_FE:
    addq.b  #1, d0
    bne.s   SAnim_End_FD
    move.b  $2(a1, d1), d0
    sub.b   d0, anim_frame(A0)
    sub.b   d0, d1
    move.b  $1(a1, d1), d0
    bra.s   SAnim_Next
; ===========================================================================	
SAnim_End_FD:
    addq.b  #1, d0
    bne.s   SAnim_End
    move.b  $2(a1, d1), anim(A0)
SAnim_End: 
    rts 
; ===========================================================================	
SAnim_WalkRun: 
    subq.b  #1, anim_frame_duration(A0)
    bpl.s   SAnim_Delay
    addq.b  #1, d0
    bne     SAnim_Roll
    moveq   #0, d0
    move.b  flip_angle(A0), d0
    bne     loc_10BD8
    moveq   #0, d1
    move.b  angle(A0), d0
    move.b  status(A0), d2
    andi.b  #1, d2
    bne.s   loc_10B72
    not.b  d0
loc_10B72:
    addi.b  #$10, d0
    bpl.s   loc_10B7A
    moveq   #3, d1
loc_10B7A:
    andi.b  #$FC, $1(A0)
    eor.b   d1, d2
    or.b    d2, $1(A0)
    btst    #5, status(A0)
    bne     loc_10C82
    lsr.b   #4, d0
    andi.b  #6, d0
    move.w  inertia(A0), d2
    bpl.s   loc_10B9E
    neg.w   d2
loc_10B9E:
    lea     (Sonic_Animate_Run), a1 ; loc_10D00
    cmpi.w  #$600, d2
    bcc.s   loc_10BB0
    lea     (Sonic_Animate_Walk), a1 ; loc_10CF2
loc_10BB0:
    move.b  d0, d1
    lsr.b   #1, d1
    add.b   d1, d0
    add.b   d0, d0
    add.b   d0, d0
    move.b  d0, d3
    neg.w   d2
    addi.w  #$800, d2
    bpl.s   loc_10BC6
    moveq   #0, d2
loc_10BC6:
    lsr.w   #8, d2
    lsr.w   #1, d2
    move.b  d2, anim_frame_duration(A0)
    bsr     SAnim_Do2
    add.b   d3, mapping_frame(A0)
    rts    
loc_10BD8:
    move.b  flip_angle(A0), d0
    moveq   #0, d1
    move.b  status(A0), d2
    andi.b  #1, d2
    bne.s   loc_10C06
    andi.b  #$FC, $1(A0)
    addi.b  #$B, d0
    divu.w  #$16, d0
    addi.b  #$9B, d0
    move.b  d0, mapping_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    rts
loc_10C06:
    andi.b  #$FC, $1(A0)
    tst.b   flip_turned(A0)
    beq.s   loc_10C1E
    ori.b   #1, $1(A0)
    addi.b  #$B, d0
    bra.s   loc_10C2A
loc_10C1E:
    ori.b   #3, $1(A0)
    neg.b   d0
    addi.b  #$8F, d0
loc_10C2A:
    divu.w  #$16, d0
    addi.b  #$9B, d0
    move.b  d0, mapping_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    rts 
SAnim_Roll:
    addq.b  #1, d0
    bne.s   loc_10C82
    move.w  inertia(A0), d2
    bpl.s   loc_10C4A
    neg.w   d2
loc_10C4A:
    lea     (Sonic_Animate_Roll2), a1 ; loc_10D18
    cmpi.w  #$600, d2
    bcc.s   loc_10C5C
    lea     (Sonic_Animate_Roll), a1 ; loc_10D0E
loc_10C5C:
    neg.w   d2
    addi.w  #$400, d2
    bpl.s   loc_10C66
    moveq   #0, d2
loc_10C66:
    lsr.w   #8, d2
    move.b  d2, anim_frame_duration(A0)
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    bra     SAnim_Do2
loc_10C82:        
    move.w  inertia(A0), d2
    bmi.s   loc_10C8A
    neg.w   d2
loc_10C8A:
    addi.w  #$800, d2
    bpl.s   loc_10C92
    moveq   #0, d2
loc_10C92:
    lsr.w   #6, d2
    move.b  d2, anim_frame_duration(A0)
    lea     (Sonic_Animate_Push), a1 ; loc_10D22
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    bra     SAnim_Do2                 
Sonic_AnimateData: ; loc_10CB4:
    dc.w    Sonic_Animate_Walk-Sonic_AnimateData    ; loc_10CF2
    dc.w    Sonic_Animate_Run-Sonic_AnimateData     ; loc_10D00
    dc.w    Sonic_Animate_Roll-Sonic_AnimateData    ; loc_10D0E
    dc.w    Sonic_Animate_Roll2-Sonic_AnimateData       ; loc_10D18 
    dc.w    Sonic_Animate_Push-Sonic_AnimateData    ; loc_10D22
    dc.w    Sonic_Animate_Wait-Sonic_AnimateData    ; loc_10D30
    dc.w    Sonic_Animate_Balance-Sonic_AnimateData     ; loc_10D59
    dc.w    Sonic_Animate_LookUp-Sonic_AnimateData      ; loc_10D5D
    dc.w    Sonic_Animate_Duck-Sonic_AnimateData    ; loc_10D62
    dc.w    Sonic_Animate_Spindash-Sonic_AnimateData    ; loc_10D67
    dc.w    Sonic_Animate_WallRecoil1-Sonic_AnimateData ; loc_10D74
    dc.w    Sonic_Animate_WallRecoil2-Sonic_AnimateData ; loc_10D77
    dc.w    Sonic_Animate_0x0C-Sonic_AnimateData    ; loc_10D7D
    dc.w    Sonic_Animate_Stop-Sonic_AnimateData    ; loc_10D81
    dc.w    Sonic_Animate_Float1-Sonic_AnimateData      ; loc_10D8C
    dc.w    Sonic_Animate_Float2-Sonic_AnimateData      ; loc_10D90
    dc.w    Sonic_Animate_0x10-Sonic_AnimateData    ; loc_10D97
    dc.w    Sonic_Animate_S1LzHang-Sonic_AnimateData    ; loc_10D9B
    dc.w    Sonic_Animate_Unused_0x12-Sonic_AnimateData ; loc_10D9F
    dc.w    Sonic_Animate_Unused_0x13-Sonic_AnimateData ; loc_10DA5
    dc.w    Sonic_Animate_Unused_0x14-Sonic_AnimateData ; loc_10DAA
    dc.w    Sonic_Animate_Bubble-Sonic_AnimateData      ; loc_10DAD
    dc.w    Sonic_Animate_Death1-Sonic_AnimateData      ; loc_10DB4
    dc.w    Sonic_Animate_Drown-Sonic_AnimateData       ; loc_10DB7
    dc.w    Sonic_Animate_Death2-Sonic_AnimateData      ; loc_10DBA
    dc.w    Sonic_Animate_Unused_0x19-Sonic_AnimateData ; loc_10DBD
    dc.w    Sonic_Animate_Hurt-Sonic_AnimateData    ; loc_10DC6
    dc.w    Sonic_Animate_S1LzSlide-Sonic_AnimateData   ; loc_10DC9
    dc.w    Sonic_Animate_0x1C-Sonic_AnimateData    ; loc_10DCD
    dc.w    Sonic_Animate_Float3-Sonic_AnimateData      ; loc_10DD1
    dc.w    Sonic_Animate_0x1E-Sonic_AnimateData    ; loc_10DD8
Sonic_Animate_Walk: ; loc_10CF2:
    dc.b    $FF, $10, $11, $12, $13, $14, $15, $16, $17, $C, $D, $E, $F, $FF
Sonic_Animate_Run: ; loc_10D00:
    dc.b    $FF, $3C, $3D, $3E, $3F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
Sonic_Animate_Roll: ; loc_10D0E:
    dc.b    $FE, $6C, $70, $6D, $70, $6E, $70, $6F, $70, $FF
Sonic_Animate_Roll2: ; loc_10D18:
    dc.b    $FE, $6C, $70, $6D, $70, $6E, $70, $6F, $70, $FF
Sonic_Animate_Push: ; loc_10D22:
    dc.b    $FD, $77, $78, $79, $7A, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
Sonic_Animate_Wait: ; loc_10D30:        
    dc.b    $7, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1
    dc.b    $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $2
    dc.b    $3, $3, $3, $4, $4, $5, $5, $FE, $4
Sonic_Animate_Balance: ; loc_10D59:         
    dc.b    $7, $89, $8A, $FF
Sonic_Animate_LookUp: ; loc_10D5D:        
    dc.b    $5, $6, $7, $FE, $1
Sonic_Animate_Duck: ; loc_10D62:          
    dc.b    $5, $7F, $80, $FE, $1
Sonic_Animate_Spindash: ; loc_10D67:        
    dc.b    $00, $71, $72, $71, $73, $71, $74, $71, $75, $71, $76, $71, $FF 
Sonic_Animate_WallRecoil1: ; loc_10D74:        
    dc.b    $3F, $82, $FF
Sonic_Animate_WallRecoil2: ; loc_10D77:
    dc.b    $7, $8, $8, $9, $FD, $5
Sonic_Animate_0x0C: ; loc_10D7D:        
    dc.b    $7, $9, $FD, $5
Sonic_Animate_Stop: ; loc_10D81:         
    dc.b    $3, $81, $82, $83, $84, $85, $86, $87, $88, $FE, $2
Sonic_Animate_Float1: ; loc_10D8C:         
    dc.b    $7, $94, $96, $FF
Sonic_Animate_Float2: ; loc_10D90:        
    dc.b    $7, $91, $92, $93, $94, $95, $FF
Sonic_Animate_0x10: ; loc_10D97:        
    dc.b    $2F, $7E, $FD, $00
Sonic_Animate_S1LzHang: ; loc_10D9B:        
    dc.b    $5, $8F, $90, $FF
Sonic_Animate_Unused_0x12: ; loc_10D9F:        
    dc.b    $F, $43, $43, $43, $FE, $1
Sonic_Animate_Unused_0x13: ; loc_10DA5:        
    dc.b    $F, $43, $44, $FE, $1
Sonic_Animate_Unused_0x14: ; loc_10DAA:        
    dc.b    $3F, $49, $FF
Sonic_Animate_Bubble: ; loc_10DAD:         
    dc.b    $B, $97, $97, $12, $13, $FD, $00
Sonic_Animate_Death1: ; loc_10DB4:         
    dc.b    $20, $9A, $FF
Sonic_Animate_Drown: ; loc_10DB7:        
    dc.b    $20, $99, $FF
Sonic_Animate_Death2: ; loc_10DBA:         
    dc.b    $20, $98, $FF
Sonic_Animate_Unused_0x19: ; loc_10DBD: 
    dc.b    $3, $4E, $4F, $50, $51, $52, $00, $FE, $1
Sonic_Animate_Hurt: ; loc_10DC6:        
    dc.b    $40, $8D, $FF
Sonic_Animate_S1LzSlide: ; loc_10DC9:          
    dc.b    $9, $8D, $8E, $FF
Sonic_Animate_0x1C: ; loc_10DCD:        
    dc.b    $77, $00, $FD, $00
Sonic_Animate_Float3: ; loc_10DD1:        
    dc.b    $3, $91, $92, $93, $94, $95, $FF
Sonic_Animate_0x1E: ; loc_10DD8:        
    dc.b    $3, $3C, $FD, $00
;=============================================================================== 
; Sub Routine Sonic_Animate
; [ End ]             
;===============================================================================
           
;=============================================================================== 
; Sub Routine Load_Sonic_Dynamic_PLC
; [ Begin ]             
;===============================================================================          
Load_Sonic_Dynamic_PLC: ; loc_10DDC:
    moveq   #0, d0
    move.b  mapping_frame(A0), d0
    cmp.b   ($FFFFF766).w, d0
    beq.s   loc_10E2E
    move.b  d0, ($FFFFF766).w
    lea     (Sonic_Dyn_Script), a2  ; loc_6DA4C
    add.w   d0, d0
    adda.w  $00(a2, d0), a2
    move.w  (a2)+, d5
    subq.w  #1, d5
    bmi.s   loc_10E2E
    move.w  #$F000, d4
loc_10E02:
    moveq   #0, d1
    move.w  (a2)+, d1
    move.w  d1, d3
    lsr.w   #8, d3
    andi.w  #$F0, d3
    addi.w  #$10, d3
    andi.w  #$FFF, d1
    lsl.l   #5, d1
    addi.l  #Sonic_Sprites, d1      ; loc_50000
    move.w  d4, d2
    add.w   d3, d4
    add.w   d3, d4
    jsr     DMA_68KtoVRAM       ; loc_156C
    dbra    d5, loc_10E02
loc_10E2E:        
    rts