
; Sonic 2 Beta By Esrael L. G. Neto, Modified by Super Egg.

; ===========================================================================================
; For this Disassembly, I went with the modern route and started replacing some of the 
; RAM addresses with their Sonic 2 Final equivalants. Luckily, all versions of Sonic 2,
; Nick Arcade through Revision 2, have all the same RAM addresses, so Sonic 2's will be what
; I will be going with. Other notes and whatnot will be in the Readme.
; ===========================================================================================


; ===========================================================================================
;          Sonic 2 Alpha              Sonic 2 Beta   
; Level Id $00       Green Hill (Sonic 1)    -> Emerald Hill (Green Hill) 
; Level Id $01       Labyrinth (Sonic 1)     -> (Labyrinth lefover cleaned now Empty)
; Level Id $02       Chemical Plant          -> (Moved to Id $0d now Wood
; Level Id $03       Emerald Hill            -> (Moved to Id $00 now Empty)
; Level Id $04       Hidden Palace           -> (Moved to Id $08 now Metropolis)
; Level Id $05       Hill Top        -> (Moved to Id $07 now Metropolis)
; Level Id $06       Sonic 1 Ending Sequence -> (Sonic 1 Ending Sequence cleaned now Empty) 
; ===========================================================================================

;======================================
; RAM ADDRESSES
;======================================

 include 'ramstuff.asm'

; Rom Start             
        dc.l    $FFFFFE00, EntryPoint, BusError, AddressError          
        dc.l    IllegalInstr, ZeroDivide, ChkInstr, TrapvInstr
        dc.l    PrivilegeViolation, Trace, Line1010Emu, Line1111Emu
        dc.l    ErrorException, ErrorException, ErrorException, ErrorException
        dc.l    ErrorException, ErrorException, ErrorException, ErrorException
        dc.l    ErrorException, ErrorException, ErrorException, ErrorException
        dc.l    ErrorException, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    VBlank, ErrorTrap, HBlank, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
        dc.l    ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap 
Console:
        dc.b    'SEGA MEGA DRIVE (C)'
Date:        
        dc.b    'SEGA 1991.APR'
Title_Local:        
        dc.b    'SONIC THE             HEDGEHOG 2                  '
Title_International:       
        dc.b    'SONIC THE             HEDGEHOG 2                  '
Serial:        
        dc.b    'GM 00004049-01'
Checksum: ; loc_00018E:                        
        dc.w    $AFC7
IOSupport:        
        dc.b    'J               '
ROMStart:        
        dc.l    $00000000
ROMEnd:   ; loc_0001A4:         
        dc.l    $0007FFFF
RAMStart:        
        dc.l    $00FF0000
RAMEnd:        
        dc.l    $00FFFFFF
SRAMSupport:               
        dc.b    '        '
Notes:        
        dc.b    '                        '
Region:        
        dc.b    'JUE             ' 
ErrorTrap:   ; loc_000200: if there's an error, we hope you'll fall into this
        nop  ;   endless loop...
        nop  
        bra.s   ErrorTrap               ; loc_000200
EntryPoint: ; loc_000206: ...otherwise, please start here.       
        tst.l   $00A10008       ; Is the value at Port 1 set at 0?
        bne.s   PortA_OK        ; If not, skip on to PortA_OK(loc_000214)
        tst.w   $00A1000C       ; Otherwise, see if Port 2 is set at 0
PortA_OK: ; loc_000214: If Port 1 != 0, you came here. Otherwise you
          ;   just tested Port 2 for a 0 value.
        bne.s   PortC_OK        ; I'm guessing if either Port 1 or Port 2 != 0,
                                ;   branch to PortC_OK(loc_000292)
        lea     InitValues(PC), a5      ; Compute the value of InitValues
                                        ;   (loc_000294) in relation to the
                                        ;   PC and deposit said address in a5
        movem.w (a5)+, d5-D7            ; Copy Z80 RAM start locations into d5,
                                        ;   d6, and d7.
		movem.l	(a5)+,a0-a4                 ; Copy Z80 and VDP addresses into a0,
                                        ;   a1, a2, a3, and a4.
		move.b	-$10FF(a1),d0	              ; get hardware version and throw it in d0
		andi.b	#$F,d0                      ; Do a logical AND to
        beq.s   SkipSecurity            ;   SkipSecurity(loc_000234) if equal
        move.l  #'SEGA', $2F00(a1)       
SkipSecurity: ; loc_000234: You passed the AND test                
        move.w  (a4), d0        ; Copy VDP control port data to d0
        moveq	#0,d0             ; Clear d0
        movea.l	d0,a6           ; Store the address of d0's data in a6
        move.l    a6, USP       ; move a6's address to the User Stack Pointer
        moveq   #$17, d1        ; put $17 in d1
VDPInitLoop: ; loc_00023E: Start the VDP's Loop        
        move.b  (a5)+, d5               ; copy next byte in a5 and store in d5. a5++
        move.w  d5, (a4)                ; copy the word stored at d5 into the VDP
                                        ;   control port
        add.w   d7,d5                   ; add contents of d7 to d5 and store in d5
        dbra    d1, VDPInitLoop         ; d1's counter is at $17, causing VDPInitLoop
                                        ;   (loc_00023E) to loop until 0'd
		
        move.l  (a5)+, (a4)             ; copy next byte from InitValues and store it
                                        ;   in the VDP control port. a5++ (4bytes)
        move.w  d0, (a3)                ; clear the VDP data port
        move.w  d7, (a1)                ; RAM Start stored for Z80 Bus Request
        move.w  d7, (a2)                ; RAM Start stored for Z80 Reset
WaitForZ80: ; loc_000250: Loop until Z80 starts =P
        btst	d0,(a1)                   ; Has the Bus Request been set to 0?
        bne.s   WaitForZ80              ; If not, continue to WaitForZ80
                                        ;   (loc_000250)
        moveq   #$25, D2                ; Change d2's value to $25
Z80InitLoop: ; loc_000256: Pulling more array values for Z80's Init        
        move.b  (a5)+, (A0)+            ; copy value from a5 to a0 then ++
                                        ;   both addresses by a byte
        dbra    D2, Z80InitLoop         ; d2-- ($25) each loop until 0, then return
                                        ;   to Z80InitLoop(loc_000256)		
        move.w  d0, (a2)                ; Clear Z80 reset's value
        move.w  d0, (a1)                ; Clear Z80 busreq's value
        move.w  d7, (a2)                ; Set z80 reset to $0100 (d7)
ClearRAMLoop: ; loc_000262: Zero out a bunch of RAM, more init stuff         
        move.l  d0, -(a6)               ; set value of a6 to 0 and a6 addy --
        dbra    d6, ClearRAMLoop        ; Loop $3FFF times back to ClearRAMLoop
                                        ; (loc_000262).
        move.l  (a5)+, (a4)             ; copy value from array into VDP control 
                                        ;   port, then increment to next array value
        move.l  (a5)+, (a4)             ; copy value from array into VDP control 
                                        ;   port, then increment to next array value
        moveq   #$1F, d3                ; set d3 to $1F (counter to clear CRAM)
ClearCRAMLoop: ; loc_00026E: Clearing CRAM mostly =P        
        move.l  d0, (a3)                ; Clear VDP data port value
        dbra    d3, ClearCRAMLoop       ; Loop $1F times back to ClearCRAMLoop
                                        ; (loc_00026E)
        move.l  (a5)+, (a4)             ; copy value from array into VDP control 
                                        ;   port, then increment to next array value
        moveq   #$13, D4                ; set d4 to $13 (counter to clear VSRAM)
ClearVSRAMLoop: ; loc_000278: Random garbage in RAM is no good
        move.l  d0, (a3)                ; Clear VDP data port value, I'm guessing
                                        ; this spot in RAM changes a whole lot
        dbra    d4, ClearVSRAMLoop      ; Loop $13 times back to ClearVSRAMLoop
                                        ; (loc_000278)
        moveq   #3,d5                   ; set d5 to #3(counter for a loop? Sure is!)
PSGInitLoop: ; loc_000280: Start the Programmable Sound Generator!           
        move.b  (a5)+, $0011(a3)        ; I believe this says to copy value from
                                        ; array into $00C00011 then go to next array
                                        ; value.
        dbra    d5, PSGInitLoop         ; Loop $3 times back to PSGInitLoop
                                        ; (loc_000280)
        move.w  d0, (a2)                ; Clear value at Z80 Reset's address
        movem.l (a6), D0-a6             ; Clear the values of all data and address
                                        ;   registers? Makes sense since we're about
                                        ;   to go from display / sound / boot stuff
                                        ;   into the actual game code.
        move    #$2700, SR              ; Moves $2700 into the status register which
                                        ;   would have the effect of clearing all the
                                        ;   condition codes.
PortC_OK: ; loc_000292: if Port 1 or Port 2 != 0, you wound up here.  Otherwise,
          ;   you set up a bunch of display and sound stuff =P 
        bra.s   GameProgram             ; proceeds to the GameProgram(loc_000300) 
InitValues: ; loc_000294: array of initialisation values        
        dc.w    $8000, $3FFF, $0100     ; Z80 RAM start	location
        dc.l    $00A00000               ; Z80 Mapping start location
        dc.l    $00A11100               ; Z80 bus request
        dc.l    $00A11200               ; Z80 reset
        dc.l    $00C00000               ; VDP data port
        dc.l    $00C00004               ; VDP control port
        dc.w    $0414, $303C, $076C, $0000, $0000, $FF00, $8137, $0001  ; array for init
        dc.w    $0100, $00FF, $FF00, $0080, $4000, $0080, $AF01, $D91F
        dc.w    $1127, $0021, $2600, $F977, $EDB0, $DDE1, $FDE1, $ED47
        dc.w    $ED4F, $D1E1, $F108, $D9C1, $D1E1, $F1F9, $F3ED, $5636
        dc.w    $E9E9, $8104, $8F02, $C000, $0000, $4000, $0010, $9FBF
        dc.w    $DFFF
GameProgram: ; loc_000300:
        tst.w   ($00C00004) 
        btst    #6, ($00A1000D)
        beq.s   ChecksumCheck           ; loc_00031C
        cmpi.l  #'init', (Checksum_fourcc).w
        beq     AlreadyInit             ; loc_00036A
ChecksumCheck: ; loc_00031C:
        move.l  #ErrorTrap, A0          ; loc_000200
        move.l  #ROMEnd, A1             ; loc_0001A4
        move.l  (A1), D0  
        move.l  #$007FFFF, d0
        moveq   #0,d1 
ChksumChkLoop: ; loc_000332:        
        add.w   (A0)+, d1
        cmp.l   A0, d0 
        bcc.s   ChksumChkLoop           ; loc_000332 
        move.l  #Checksum, A1           ; loc_00018E
        cmp.w   (A1), d1
        nop
        nop
        lea     (System_Stack).w, a6
        moveq   #0, D7 
        move.w  #$07F, D6
ClearSomeRAMLoop: ; loc_00034E:         
        move.l  d7, (a6)+
;loc_000350:  
        dbra    d6, ClearSomeRAMLoop    ; loc_00034E  
        move.b  ($00A10001), D0  
        andi.b  #$C0, d0
        move.b  d0, (Graphics_Flags).w  
        move.l  #'init', (Checksum_fourcc).w
AlreadyInit: ; loc_00036A:         Game has already been initialised. Load work RAM address        
        lea     ($00FF0000), a6       ; ($FF0000)into addr reg 6. Clear data reg 7 and move 3F7F
        moveq   #0, d7              ; into data reg 6 which sets us up for...
        move.w  #$3F7F, d6 
ClearRemainingRAMLoop: ; loc_000376:   subroutine designed to clear out any erroneous data in RAM
        move.l  d7, (a6)+                                          ; move the empty contents of data
        dbra    d6, ClearRemainingRAMLoop ; loc_000376        ; reg 7 into the contents of addy
                                          ; reg 6 and ++ 4 bytes for a lw. Take data reg 6 (3F7F) and
                                          ; check if value is 0. If not, -- and repeat from label
                                          ; 'ClearRemainingRAMLoop'. Repeat until d6 == 0 then branch.
        bsr     VDPRegSetup             ; branch to VDPRegSetup(loc_001368)
        bsr     SoundDriverLoad         ; branch to SoundDriverLoad(loc_0014B8)
        bsr     JoypadInit              ; branch to JoypadInit(loc_0012FC)
        move.b  #4, (Game_Mode).w     ; Boot from Game Intro / Title Screen
MainGameLoop: ; loc_00038E:        
        move.b  (Game_Mode).w, d0
        andi.w  #$1C, d0
        jsr     GameModeArray(pc,d0)   ; loc_00039C
        bra.s   MainGameLoop            ; loc_00038E
		
		
; ===============================================================================		
GameModeArray: ; loc_00039C:   
        bra     SegaScreen       ; SEGA Logo ; loc_00360C   
        bra     TitleScreen      ; Game Intro / Title Screen ; loc_003738
        bra     Level            ; Demo Mode         ; loc_004150
        bra     Level            ; Normal Game Play  ; loc_004150 
        bra     SpecialStage     ; Special Stage     ; loc_005200
; ===============================================================================
;
; ChecksumError
;
; Leftover subroutine from Sonic 1 showing a red
; screen when the checksum was	wrong
;
;===============================================================================        
ChecksumError:          
        bsr     VDPRegSetup      ; loc_001368 
        move.l  #$C0000000, ($00C00004)   
        moveq   #$3F, D7  
ChksumErr_RedFill: ; loc_0003C0:          
        move.w  #$00E, ($00C00000) 
        dbra    d7, ChksumErr_RedFill   ; loc_0003C0 
ChksumErr_InfLoop: ; loc_0003CC:
        bra.s   ChksumErr_InfLoop       ; loc_0003CC             
BusError: ; loc_0003CE:
        move.b  #$2, ($FFFFFC44).w
        bra.s   ErrorMsg_TwoAddresses   ; loc_000432
AddressError: ; loc_0003D6:        
        move.b  #4, ($FFFFFC44).w
        bra.s   ErrorMsg_TwoAddresses   ; loc_000432
IllegalInstr: ; loc_0003DE:        
        move.b  #6, ($FFFFFC44).w
        addq.l  #$2, art_tile(a7)
        bra.s   ErrorMessage            ; loc_00045A
ZeroDivide: ; loc_0003EA:        
        move.b  #8, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A
ChkInstr: ; loc_0003F2:        
        move.b  #$A, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A
TrapvInstr: ; loc_0003FA:        
        move.b  #$C, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A             
PrivilegeViolation: ; loc_000402:
        move.b  #$E, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A  
Trace: ; loc_00040A:
        move.b  #$10, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A 
Line1010Emu: ; loc_000412:
        move.b  #$12, ($FFFFFC44).w
        addq.l  #$2, art_tile(a7)
        bra.s   ErrorMessage            ; loc_00045A         
Line1111Emu: ; loc_00041E:
        move.b  #$14, ($FFFFFC44).w
        addq.l  #$2, art_tile(a7)
        bra.s   ErrorMessage            ; loc_00045A 
ErrorException: ; loc_00042A:
        move.b  #0, ($FFFFFC44).w
        bra.s   ErrorMessage            ; loc_00045A 
ErrorMsg_TwoAddresses: ; loc_000432: 
        move    #$2700, SR
        addq.w  #$2, A7
        move.l  (A7)+, ($FFFFFC40).w
        addq.w  #$2, A7
        movem.l D0-A7, (Object_Respawn_Table).w
        bsr     ShowErrorMsg            ; loc_000480
        move.l  art_tile(A7), D0
        bsr     ShowErrAddress          ; loc_0005B2
        move.l  ($FFFFFC40).w, d0
        bsr     ShowErrAddress          ; loc_0005B2
        bra.s   ErrorMsg_Wait           ; loc_000470          
ErrorMessage: ; loc_00045A:
        move    #$2700, SR
        movem.l D0-A7, (Object_Respawn_Table).w
        bsr     ShowErrorMsg            ; loc_000480
        move.l  art_tile(A7), D0
        bsr     ShowErrAddress          ; loc_0005B2
ErrorMsg_Wait: ; loc_000470:
        bsr     Error_WaitForC          ; loc_0005D8 
        movem.l (Object_Respawn_Table).w, d0-A7  
        move    #$2300, SR
        rte        
ShowErrorMsg: ; loc_000480:
        lea     ($00C00000), a6  
        move.l  #$78000003, ($00C00004)
        lea     (Art_Menu_Text), A0     ; loc_0005E8
        move.w  #$27F, d1
Error_LoadGfx: ; loc_00049A:        
        move.w  (A0)+, (a6)
        dbra    d1, Error_LoadGfx       ; loc_00049A         
        moveq	#0,d0
        move.b ($FFFFFC44).w, d0
        move.w  Error_Text(pc,d0), D0  ; loc_0004CA
        lea     Error_Text(pc,d0), A0  ; loc_0004CA
        move.l  #$46040003, ($00C00004)
        moveq   #$12, d1
loc_0004BA:         
        moveq	#0,d0
        move.b (A0)+, D0
        addi.w  #$790, d0
        move.w  d0, (a6)
        dbra    d1, loc_0004BA
        rts
Error_Text: ; loc_0004CA:
        dc.w    ErrTxt_Exception-Error_Text  
        dc.w    ErrTxt_BusError-Error_Text  
        dc.w    ErrTxt_AddressError-Error_Text  
        dc.w    ErrTxt_IllegalInstruction-Error_Text  
        dc.w    ErrTxt_ZeroDivide-Error_Text 
        dc.w    ErrTxt_ChkIntruction-Error_Text
        dc.w    ErrTxt_TrapvInstructuion-Error_Text
        dc.w    ErrTxt_PrivilegeViolation-Error_Text
        dc.w    ErrTxt_Trace-Error_Text
        dc.w    ErrTxt_Line1010Emulator-Error_Text
        dc.w    ErrTxt_Line1111Emulator-Error_Text
ErrTxt_Exception: ; loc_0004E0: 
        dc.b    'ERROR EXCEPTION    '
ErrTxt_BusError: ; loc_0004F3: 
        dc.b    'BUS ERROR          ' 
ErrTxt_AddressError: ; loc_000506: 
        dc.b    'ADDRESS ERROR      '   
ErrTxt_IllegalInstruction: ; loc_000519: 
        dc.b    'ILLEGAL INSTRUCTION' 
ErrTxt_ZeroDivide: ; loc_00052C: 
        dc.b    '@ERO DIVIDE        ' 
ErrTxt_ChkIntruction: ; loc_00053F:         
        dc.b    'CHK INSTRUCTION    '
ErrTxt_TrapvInstructuion: ; loc_000552:        
        dc.b    'TRAPV INSTRUCTION  '
ErrTxt_PrivilegeViolation: ; loc_000565:         
        dc.b    'PRIVILEGE VIOLATION'
ErrTxt_Trace: ; loc_000578:         
        dc.b    'TRACE              '
ErrTxt_Line1010Emulator: ; loc_00058B:        
        dc.b    'LINE 1010 EMULATOR '
ErrTxt_Line1111Emulator: ;loc_00059E:         
        dc.b    'LINE 1111 EMULATOR ' 
        dc.b    $00                   ; Filler                          
ShowErrAddress: ; loc_0005B2:
        move.w  #$7CA, (a6)
        moveq   #$7, D2 
ShowErrAddress_DigitLoop: ; loc_0005B8:        
        rol.l   #4, d0
        bsr.s   ShowErrDigit            ; loc_0005C2
        dbra    D2, ShowErrAddress_DigitLoop ; loc_0005B8
        rts
ShowErrDigit: ; loc_0005C2:   
        move.w  d0, d1
        andi.w  #$F, d1
        cmpi.w  #$00A, d1
        bcs.s   ShowErrDigit_NoOverflow ; loc_0005D0
        addq.w  #$7, d1
ShowErrDigit_NoOverflow: ; loc_0005D0:        
        addi.w  #$7C0, d1 
        move.w  d1, (a6)
        rts
Error_WaitForC: ; loc_0005D8:
        bsr     ReadJoypads             ; loc_00132C
        cmpi.b  #$20, (Ctrl_1_Press).w
        bne     Error_WaitForC          ; loc_0005D8
        rts
		
; ==================================================
; Letters for the Level Select Menu/ Sound Test.
; ==================================================		

Art_Menu_Text: ; loc_0005E8:
        incbin   'data\sprites\art_menu.dat'

; ======================================
; Beginning of H-Blank.
; ======================================		

HBlank: ; loc_000B08:          
        movem.l D0-a6, -(A7) 
        tst.b	(Delay_Time).w
        beq     HBlank_GameMode 
HBlank1:         
        move.w	($00C00004), D0
        andi.w	#8, d0
        beq.s   HBlank1
        move.l  #$40000010, ($00C00004)
        move.l	(Vscroll_Factor).w, ($00C00000)
        btst	#6, (Graphics_Flags).w
        beq.s   HBlank2
        move.w  #$700, d0
HBlank1a: 
        dbra    d0, HBlank1a 
HBlank2:         
        move.b	(Delay_Time).w, d0  
        move.b	#0, (Delay_Time).w
		move.w	#$001, ($FFFFF644).w  
        andi.w	#$03E, d0         
        move.w	HBlank_Index(pc,d0), D0   
		jsr	HBlank_Index(pc,d0)   
HBlank2b:		
        addq.l	#1, ($FFFFFE0C).w
		movem.l (A7)+, D0-a6
		rte
HBlank_Index:  
        dc.w    (HBlank_GameMode-HBlank_Index)
        dc.w    (loc_000CEC-HBlank_Index)
        dc.w    (loc_000D2A-HBlank_Index)
        dc.w    (loc_000D40-HBlank_Index)
        dc.w    (loc_000D50-HBlank_Index)
        dc.w    (loc_000E72-HBlank_Index)
        dc.w    (loc_000F18-HBlank_Index)
        dc.w    (loc_001004-HBlank_Index)
        dc.w    (loc_000D46-HBlank_Index)
        dc.w    (loc_001014-HBlank_Index)
        dc.w    (loc_000CFE-HBlank_Index)
        dc.w    (loc_001020-HBlank_Index)
        dc.w    (loc_000F18-HBlank_Index)
HBlank_GameMode:
        cmpi.b  #$8C, (Game_Mode).w 
        beq.s   loc_000BBC
        cmpi.b  #8, (Game_Mode).w 
        beq.s   loc_000BBC  
        cmpi.b  #$C, (Game_Mode).w 
        beq.s   loc_000BBC        
        move.w	#$100, ($00A11100)
HBlank_GameMode2:           
        btst	#0, ($00A11100)
        bne.s   HBlank_GameMode2
        jsr     loc_0012AC
        move.w  #0, ($00A11100)
        bra.s   HBlank2b
loc_000BBC:          
        tst.b	($FFFFF730).w
        beq     loc_000C60
        move.w	($00C00004), D0
        btst	#6, (Graphics_Flags).w
        beq.s   loc_000BDA
        move.w	#$700, d0
loc_000BD6:   
        dbra    d0, loc_000BD6             
loc_000BDA:
        move.w	#$001, ($FFFFF644).w 
        move.w	#$100, ($00A11100)
loc_000BE8:        
        btst	#0, ($00A11100)
        bne.s   loc_000BE8  
        tst.b	(Water_move).w 
        bne.s   loc_000C1E   
        lea	($00C00004), a5 
        move.l	#$94009340, (a5)
		move.l	#$96FD9580, (a5) 
        move.w	#$977F, (a5)
        move.w	#$C000, (a5) 
        move.w	#$080, (DMA_data_thunk).w  
        move.w	(DMA_data_thunk).w, (a5)
        bra.s   loc_000C42   
loc_000C1E:
        lea	($00C00004), a5 
        move.l	#$94009340, (a5)
        move.l	#$96FD9540, (a5)
        move.w	#$977F, (a5)
        move.w	#$C000, (a5) 
        move.w	#$080, (DMA_data_thunk).w  
        move.w	(DMA_data_thunk).w, (a5)
loc_000C42:        
        move.w	(Hint_counter_reserve).w, (a5)
        move.w	#$8230, ($00C00004) 
        jsr     loc_0012AC
        move.w	#0, ($00A11100)
        bra     HBlank2b
loc_000C60:        
        move.w  ($00C00004), D0 
        move.l	#$40000010, ($00C00004)
        move.l	(Vscroll_Factor).w, ($00C00000)
        btst	#6, (Graphics_Flags).w
        beq.s   loc_000C88
        move.w	#$700, d0
loc_000C84:  
        dbra    d0, loc_000C84            
loc_000C88:
        move.w	#$001, ($FFFFF644).w 
        move.w	(Hint_counter_reserve).w, ($00C00004) 
        move.w	#$8230, ($00C00004)  
        move.l	($FFFFF61E).w, ($FFFFEEEC).w 
        move.w	#$100, ($00A11100) 
loc_000CAC:        
        btst	#0, ($00A11100)
        bne.s   loc_000CAC  
        lea	($00C00004), a5 
        move.l	#$94019340, (a5)
        move.l	#$96FC9500, (a5) 
        move.w	#$977F, (a5)
        move.w	#$7800, (a5) 
        move.w	#$083, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5) 
        jsr     loc_0012AC
        move.w	#0, ($00A11100)
        bra     HBlank2b
loc_000CEC:
        bsr     loc_0010BE
        tst.w   (Demo_Time_left).w
        beq     loc_000CFC  ; beq.s
        subq.w  #1, (Demo_Time_left).w 
loc_000CFC:
        rts        
loc_000CFE:
        move.w	#$100, ($00A11100)
loc_000D06:        
        btst	#0, ($00A11100)
        bne.s   loc_000D06
        bsr     ReadJoypads             ; loc_00132C 
        move.w	#0, ($00A11100)
        tst.w   (Demo_Time_left).w
        beq     loc_000D28
        subq.w  #1, (Demo_Time_left).w 
loc_000D28:  
        rts 
loc_000D2A:
        bsr     loc_0010BE
        bsr     loc_0017FE
        tst.w   (Demo_Time_left).w
        beq     loc_000D3E
        subq.w  #1, (Demo_Time_left).w 
loc_000D3E:  
        rts        
loc_000D40:
        bsr     loc_0010BE
        rts
loc_000D46:
        cmpi.b  #$10, (Game_Mode).w
        beq     loc_000E72         
loc_000D50:
        move.w	#$100, ($00A11100)
loc_000D58:        
        btst	#0, ($00A11100)
        bne.s   loc_000D58
        bsr     ReadJoypads             ; loc_00132C 
        tst.b   (Water_move).w
        bne.s   loc_000D92
        lea     ($00C00004), a5
        move.l  #$94009340, (a5)
        move.l  #$96FD9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
        bra.s   loc_000DB6
loc_000D92:
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9540, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
loc_000DB6:  
        move.w  (Hint_counter_reserve).w, (a5)  
        move.w  #$8230, ($00C00004)  
        lea     ($00C00004), a5 
        move.l  #$940193C0, (a5)
        move.l  #$96F09500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7C00, (a5) 
        move.w  #$083, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5) 
        lea     ($00C00004), a5  
        move.l  #$94019340, (a5) 
        move.l  #$96FC9500, (a5)  
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)  
        move.w  #$083, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5)
        bsr     Process_DMA             ; loc_0015CA
        jsr     loc_0012AC
        move.w	#0, ($00A11100)
        movem.l ($FFFFEE00).w, d0-D7
        movem.l  D0-d7, ($FFFFEE60).w
        movem.l ($FFFFEE20).w, d0-D7
        movem.l  D0-d7, ($FFFFEE80).w
        movem.l ($FFFFEE50).w, d0-D3
        movem.l  D0-d3, ($FFFFEEA0).w
        move.l  ($FFFFF61E).w, ($FFFFEEEC).w
        cmpi.b  #$5C, ($FFFFF625).w
        bcc.s   DemoTime        ; loc_000E56
        move.b  #1, ($FFFFF64F).w
        rts
		
; ===================================================
; Demo Time Sub
; ===================================================		

DemoTime: ; loc_000E56:   
        bsr     LoadTilesAsYouMove      ; loc_006E1A
        jsr     HudUpdate               ; loc_023012
        bsr     loc_00181A
        tst.w   (Demo_Time_left).w
        beq     DemoTime_End            ; loc_000E70
        subq.w  #1, (Demo_Time_left).w
DemoTime_End: ; loc_000E70:
        rts        
loc_000E72:
        move.w  #$100, ($00A11100)
loc_000E7A:        
        btst	#0, ($00A11100)
        bne.s   loc_000E7A
        bsr     ReadJoypads             ; loc_00132C
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        lea     ($00C00004), a5 
        move.l  #$94019340, (a5)
        move.l  #$96FC9500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
        lea     ($00C00004), a5 
        move.l  #$940193C0, (a5)
        move.l  #$96F09500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7C00, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
        bsr     Process_DMA             ; loc_0015CA
        jsr     loc_0012AC
        move.w  #0, ($00A11100)
        bsr     S1_Pal_Cycle_Special_Stage ; loc_005584 
        tst.w   (Demo_Time_left).w
        beq     loc_000F16
        subq.w  #1, (Demo_Time_left).w
loc_000F16: 
        rts               
loc_000F18:
        move.w  #$100, ($00A11100)
loc_000F20:        
        btst	#0, ($00A11100)
        bne.s   loc_000F20
        bsr     ReadJoypads             ; loc_00132C
        tst.b   (Water_move).w
        bne.s   loc_000F5A
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
        bra.s   loc_000F7E
loc_000F5A: 
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9540, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)         
loc_000F7E:     
        move.w  (Hint_counter_reserve).w, (a5)
        lea     ($00C00004), a5 
        move.l  #$940193C0, (a5)
        move.l  #$96F09500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7C00, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        lea     ($00C00004), a5 
        move.l  #$94019340, (a5)
        move.l  #$96FC9500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        bsr     Process_DMA             ; loc_0015CA
        jsr     loc_0012AC
        move.w  #0, ($00A11100)
        movem.l ($FFFFEE00).w, d0-D7
        movem.l D0-d7, ($FFFFEE60).w
        movem.l ($FFFFEE50).w, d0-d1
        movem.l D0-d1, ($FFFFEEA0).w
        bsr     LoadTilesAsYouMove     ; loc_006E1A
        jsr     HudUpdate              ; loc_023012
        bsr     loc_0017FE
        rts
loc_001004:
        bsr     loc_0010BE
        addq.b  #1, ($FFFFF628).w
        move.b  #$E, (Delay_Time).w
        rts
loc_001014:
        bsr     loc_0010BE 
        move.w  (Hint_counter_reserve).w, (a5)
        bra     loc_0017FE 
loc_001020:
        move.w  #$100, ($00A11100)
loc_001028:        
        btst	#0, ($00A11100)
        bne.s   loc_001028
        bsr     ReadJoypads             ; loc_00132C
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        lea     ($00C00004), a5 
        move.l  #$94019340, (a5)
        move.l  #$96FC9500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        lea     ($00C00004), a5 
        move.l  #$940193C0, (a5)
        move.l  #$96F09500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7C00, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5) 
        jsr     loc_0012AC
        move.w  #0, ($00A11100)
        tst.w   (Demo_Time_left).w
        beq     loc_0010BC
        subq.w  #1, (Demo_Time_left).w
loc_0010BC:
        rts
loc_0010BE:         
        move.w	#$100, ($00A11100)
loc_0010C6:        
        btst	#0, ($00A11100) 
        bne.s   loc_0010C6 
        bsr     ReadJoypads             ; loc_00132C 
        tst.b   (Water_move).w
        bne.s   loc_001100
        lea     ($00C00004), a5 
        move.l  #$94009340, (a5)
        move.l  #$96FD9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5)
        bra.s   loc_001124 
loc_001100:   
        lea     ($00C00004), a5
        move.l  #$94009340, (a5)
        move.l  #$96FD9540, (a5)
        move.w  #$977F, (a5)
        move.w  #$C000, (a5)
        move.w  #$080, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5)
loc_001124: 
        lea     ($00C00004), a5
        move.l  #$94019340, (a5)
        move.l  #$96FC9500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)
        move.w  #$083, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5)
        lea     ($00C00004), a5
        move.l  #$940193C0, (a5)
        move.l  #$96F09500, (a5)
        move.w  #$977F, (a5)
        move.w  #$7C00, (a5)
        move.w  #$083, (DMA_data_thunk).w
        move.w  (DMA_data_thunk).w, (a5)
        jsr     loc_0012AC
        move.w	#0, ($00A11100)
        rts
VBlank: ; loc_00117C:        
        tst.w   ($FFFFF644).w
        beq     loc_001226
        tst.w   (Two_player_mode).w   
        beq     VBlank_Not2pMode        ; loc_001228
        move.w  #0, ($FFFFF644).w 
        move.l  a5, -(A7)
        move.l  d0, -(A7)
loc_001196        
        move.w  ($00C00004), D0
        andi.w  #$004, d0
        beq.s   loc_001196
        move.w  (VDP_Reg0_Val).w, d0
        andi.b  #$BF, d0
        move.w  d0, ($00C00004)
        move.w  #$8228, ($00C00004) 
        move.l  #$40000010, ($00C00004) 
        move.l  ($FFFFEEEC).w, ($00C00000)
        move.w	#$100, ($00A11100) 
loc_0011D2:
        btst    #0, ($00A11100)
        bne.s   loc_0011D2
        lea     ($00C00004), a5 
        move.l  #$94019340, (a5)
        move.l  #$96EE9580, (a5)
        move.w  #$977F, (a5)
        move.w  #$7800, (a5)
        move.w  #$083, (DMA_data_thunk).w 
        move.w  (DMA_data_thunk).w, (a5) 
        move.w	#0, ($00A11100) 
loc_001208:
        move.w  ($00C00004), D0
        andi.w  #$004, d0
        beq.s   loc_001208
        move.w  (VDP_Reg0_Val).w, d0
        ori.b   #$40, d0
        move.w  d0, ($00C00004)
        move.l  (A7)+, D0
        move.l  (A7)+, a5
loc_001226:
        rte
VBlank_Not2pMode: ; loc_001228:  
        move    #$2700, SR 
        move.w  #0, ($FFFFF644).w  
        movem.l A0-A1, -(A7)
        lea     ($00C00000), A1 
        lea     ($FFFFFA80).w, A0 
        move.l  #$C0000000, mappings(a1)  
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)
        move.l  (A0)+, (a1)   
        move.l  (A0)+, (a1) 
        move.l  (A0)+, (a1)                        
        move.w  #$8ADF, mappings(a1)
        movem.l (A7)+, A0-A1
        tst.b   ($FFFFF64F).w
        bne.s   loc_00129A
        rte
loc_00129A: 
        clr.b   ($FFFFF64F).w 
        movem.l  D0-a6, -(A7)   
        bsr     DemoTime        ; loc_000E56  
        movem.l (A7)+, D0-a6 
        rte    
loc_0012AC:
        lea     ($00FFFFE0), A0
        lea	($00A01B80), A1
        cmpi.b  #$80, x_pos(a1)
        bne.s   loc_0012E0
        move.b	0(A0), D0
        beq.s   loc_0012E0
        clr.b   0(a0)
        move.b	d0, d1
        subi.b	#$FE, d1
        bcs.s   loc_0012DC
        addi.b  #$7F, d1
        move.b  d1, $0003(a1)
        bra.s   loc_0012E0
loc_0012DC: 
        move.b	d0, x_pos(a1)               
loc_0012E0:        
        moveq	#3, d1
loc_0012E2:        
        move.b  $01(A0, d1), D0
        beq.s   loc_0012F6
        tst.b   $09(A1, d1)
        bne.s   loc_0012F6
        clr.b   $01(A0, d1)         
        move.b  d0, $09(A1, d1)  
loc_0012F6:        
        dbra    d1, loc_0012E2
        rts 
JoypadInit: ; loc_0012FC:
        move.w  #$100, ($00A11100)  
JoypadInit_Z80Wait: ; loc_001304:
        btst    #0, ($00A11100)
        bne.s   JoypadInit_Z80Wait      ; loc_001304
        moveq   #$40, d0
        move.b  d0, ($00A10009)
        move.b  d0, ($00A1000B)
        move.b  d0, ($00A1000D)   
        move.w  #0, ($00A11100)                 
        rts
ReadJoypads: ; loc_00132C:               
        lea     ($FFFFF604).w, A0
        lea     ($00A10003), A1
        bsr.s   Joypad_Read             ; loc_00133A
        addq.w  #$2, A1
Joypad_Read: ; loc_00133A:
        move.b  #0, (a1) 
        nop
        nop
        move.b  (A1), D0
        lsl.b   #$2, d0  
        andi.b  #$C0, d0
        move.b  #$40, (a1) 
        nop
        nop  
        move.b  (A1), d1
        andi.b  #$3F, d1 
        or.b    d1, d0  
        not.b   D0   
        move.b  (A0), d1
        eor.b   d0, d1
        move.b  d0, (A0)+ 
        and.b   d0, d1
        move.b  d1, (A0)+ 
        rts          
VDPRegSetup: ; loc_001368:  Video Display Processor Regulation Setup      
        lea     ($00C00004), A0   ; a0 points to the VDP Control Port addy
        lea     ($00C00000), A1   ; a1 points to the VDP Data Port addy
        lea     (VDPRegSetup_Array), A2 ; a2 points to the VDPRegSetup_Array(loc_0013F2)
        moveq   #$12, d7          ; quickmove 12 into d7
VDPRegSetup_Loop: ; loc_00137C: VDP Regulation Setup... loop?        
        move.w  (a2)+, (a0)             ; move VDP array into the VDP Control Port, a2++
        dbra    d7, VDPRegSetup_Loop    ; d7 != 0, so return to beginning
                                        ; of 'VDPRegSetup_Loop'(loc_00137C).
        move    (VDPReg_01), d0         ; loc_0013F4
        move.w  d0, (VDP_Reg0_Val).w
        move.w  #$8ADF, (Hint_counter_reserve).w
        moveq   #0,d0
        move.l  #$40000010, ($00C00004)
        move.w  d0, (a1)
        move.w  d0, (a1)
        move.l  #$C0000000, ($00C00004)
        move.w  #$03F, d7
VDPRegSetup_ClearCRAM: ; loc_0013B0:         
        move.w  d0, (a1)
        dbra    d7, VDPRegSetup_ClearCRAM ; loc_0013B0
        clr.l   (Vscroll_Factor).w
        clr.l   ($FFFFF61A).w
        move.l  d1, -(A7)
        lea     ($00C00004), a5
        move.w  #$8F01, (a5)
        move.l  #$94FF93FF, (a5)
        move.w  #$9780, (a5)
        move.l  #$40000080, (a5)
        move.w  #0, ($00C00000)
VDPRegSetup_DMAWait: ; loc_0013E2:        
        move.w  (a5), d1
        btst    #1,d1
        bne.s   VDPRegSetup_DMAWait     ; loc_0013E2
        move.w  #$8F02, (a5)
        move.l  (A7)+, d1
        rts
VDPRegSetup_Array: ; loc_0013F2:
        dc.w    $8004
VDPReg_01: ; loc_0013F4:  
        dc.w    $8134, $8230, $8328, $8407, $857C, $8600, $8700, $8800
        dc.w    $8900, $8A00, $8B00, $8C81, $8D3F, $8E00, $8F02, $9001
        dc.w    $9100, $9200
ClearScreen: ; loc_001418:
        move.w  #$100, ($00A11100)
loc_001420:     
        btst    #0, ($00A11100)
        bne.s   loc_001420            
        lea     ($00C00004), a5  
        move.w  #$8F01, (a5)  
        move.l  #$940F93FF, (a5)
        move.w  #$9780, (a5)
        move.l  #$40000083, (a5)
        move.w  #0, ($00C00000) 
ClearScreen_DMAWait: ; loc_00144C:           
        move.w  (a5), d1  
        btst    #1,d1 
        bne.s   ClearScreen_DMAWait     ; loc_00144C 
        move.w  #$8F02, (a5)  
        lea     ($00C00004), a5    
        move.w  #$8F01, (a5)  
        move.l  #$940F93FF, (a5)
        move.w  #$9780, (a5) 
        move.l  #$60000083, (a5) 
        move.w  #0, ($00C00000)
ClearScreen_DMA2Wait: ; loc_00147A:          
        move.w  (a5), d1   
        btst    #1,d1 
        bne.s   ClearScreen_DMA2Wait    ; loc_00147A 
        move.w  #$8F02, (a5)   
        clr.l   (Vscroll_Factor).w
        clr.l   ($FFFFF61A).w
        lea     ($FFFFF800).w, A1   
        moveq	#0,d0
        move.w  #$0A0, d1
ClearScreen_ClearBuffer1: ; loc_001498:        
        move.l  d0, (A1)+
        dbra    d1, ClearScreen_ClearBuffer1 ; loc_001498  
        lea     ($FFFFE000).w, A1 
        moveq	#0,d0
        move.w  #$100, d1
ClearScreen_ClearBuffer2: ; loc_0014A8:        
        move.l  d0, (A1)+
        dbra    d1, ClearScreen_ClearBuffer2 ; loc_0014A8         
        move.w  #0, ($00A11100)
        rts
SoundDriverLoad: ; loc_0014B8:
        nop
        jmp     Sound_Driver            ; loc_0EC000
Play_Music: ; loc_0014C0: 
        move.b  d0, (Music_to_play).w     
        rts 
Play_Sfx: ; loc_0014C6:  
        move.b  d0, (SFX_to_play).w     
        rts 
;Play_Unknow: ;loc_0014CC: 
        move.b  d0, (SFX_to_play_2).w     
        rts   
Pause: ; loc_0014D2: 
        nop 
        tst.b   ($FFFFFE12).w
        beq     Unpause         ; loc_001536
        tst.w   (Game_paused).w
        bne.s   Pause_AlreadyPaused     ; loc_0014EA
        btst    #$7, (Ctrl_1_Press).w
        beq.s   Pause_DoNothing         ; loc_00153C
Pause_AlreadyPaused: ; loc_0014EA:         
        move.w  #$001, (Game_paused).w 
        move.b  #$FE, (Music_to_play).w
Pause_Loop: ; loc_0014F6:        
        move.b  #$10, (Delay_Time).w 
        bsr     DelayProgram            ; loc_0031D8
        tst.b   ($FFFFFFD1).w
        beq.s   Pause_CheckStart        ; loc_001528
        btst    #6, (Ctrl_1_Press).w
        beq.s   Pause_CheckBC           ; loc_001518
        move.b  #4, (Game_Mode).w
        nop 
        bra.s   loc_001530
Pause_CheckBC: ; loc_001518: 
        btst    #4, ($FFFFF604).w 
        bne.s   loc_00153E  
        btst    #5, (Ctrl_1_Press).w  
        bne.s   loc_00153E          
Pause_CheckStart: ; loc_001528:  
        btst    #$7, (Ctrl_1_Press).w 
        beq.s   Pause_Loop              ; loc_0014F6
loc_001530: 
        move.b  #$FF, (Music_to_play).w  
Unpause: ; loc_001536:        
        move.w  #0, (Game_paused).w 
Pause_DoNothing: ; loc_00153C:         
        rts       
loc_00153E:   
        move.w  #$001, (Game_paused).w 
        move.b  #$FF, (Music_to_play).w 
        rts 
ShowVDPGraphics: ; loc_00154C: 
        lea     ($00C00000), a6 
        move.l  #$0800000, D4
ShowVDPGraphics_LineLoop: ; loc_001558:          
        move.l  d0, mappings(a6) 
        move.w  d1, d3   
ShowVDPGraphics_TileLoop: ; loc_00155E:        
        move.w  (A1)+, (a6)                                     
        dbra    d3, ShowVDPGraphics_TileLoop ; loc_00155E
        add.l   d4, d0
        dbra    D2, ShowVDPGraphics_LineLoop ; loc_001558
        rts
DMA_68KtoVRAM: ; loc_00156C:        
        move.l  ($FFFFDCFC).w, A1
        cmpa.w  #($FFFFDCFC), A1
        beq.s   DMA_68KtoVRAM_NoDMA     ; loc_0015C8
        move.w  #$9300, d0 
        move.b  d3, d0
        move.w  d0, (a1)+
        move.w  #$9400, d0 
        lsr.w   #8, d3 
        move.b  d3, d0
        move.w  d0, (a1)+
        move.w  #$9500, d0 
        lsr.l   #1,d1
        move.b  d1, d0
        move.w  d0, (a1)+
        move.w  #$9600, d0 
        lsr.l   #8, d1
        move.b  d1, d0
        move.w  d0, (a1)+
        move.w  #$9700, d0 
        lsr.l   #8, d1
        move.b  d1, d0
        move.w  d0, (a1)+
        andi.l  #$000FFFF, D2
        lsl.l   #$2, D2
        lsr.w   #$2, D2
        swap.w  D2
        ori.l   #$40000080, D2
        move.l  D2, (A1)+
        move.l  A1, ($FFFFDCFC).w
        cmpa.w  #$FFFFDCFC, A1
        beq.s   DMA_68KtoVRAM_NoDMA     ; loc_0015C8
        move.w  #0, (a1)
DMA_68KtoVRAM_NoDMA: ; loc_0015C8:         
        rts
Process_DMA: ; loc_0015CA:
        lea     ($00C00004), a5
        lea     ($FFFFDC00).w, A1
Process_DMA_Loop: ; loc_0015D4:        
        move.w  (A1)+, D0
        beq.s   Process_DMA_End         ; loc_0015EC
        move.w  d0, (a5)
        move.w  (A1)+, (a5)
        move.w  (A1)+, (a5)
        move.w  (A1)+, (a5)
        move.w  (A1)+, (a5)
        move.w  (A1)+, (a5)
        move.w  (A1)+, (a5)
        cmpa.w  #$FFFFDCFC, A1
        bne.s   Process_DMA_Loop        ; loc_0015D4
Process_DMA_End: ; loc_0015EC:           
        move.w  #0, ($FFFFDC00).w
        move.l  #$FFFFDC00, ($FFFFDCFC).w        
        rts 
NemesisDec: ; loc_0015FC: ; Decompress Sprites to VRam         
        movem.l D0-D7/A0/A1/A3-a5, -(A7) 
        lea     (NemesisDec_Output), A3 ; loc_0016BE
        lea     ($00C00000), A4
        bra.s   loc_001618
NemesisDec_ToRAM: ;loc_00160E: ; Decompress Sprites to Ram
        movem.l D0-D7/A0/A1/A3-a5, -(A7)
        lea     (NemesisDec_OutputRAM), A3 ; loc_0016D4
loc_001618:        
        lea     (Decomp_Buffer).w, A1
        move.w  (A0)+, D2
        lsl.w   #1, D2
        bcc.s   loc_001626
        adda.w  #$00A, A3
loc_001626:         
        lsl.w   #$2, D2
        move.w  D2, a5
        moveq   #8, d3 
        moveq   #0, D2
        moveq   #0, D4  
        bsr     NemesisDec4             ; loc_0016EA
        move.b  (A0)+, D5
        asl.w   #8,d5
        move.b  (A0)+, D5
        move.w  #$010, D6 
        bsr.s   loc_001646
        movem.l (A7)+, D0-D7/A0/A1/A3-a5
        rts 
loc_001646:  
        move.w  d6, D7
        subq.w  #8, D7
        move.w  d5, d1
        lsr.w   d7, d1
        cmpi.b  #$FC, d1
        bcc.s   loc_001692
        andi.w  #$0FF, d1
        add.w   d1, d1
        move.b  $00(A1, d1), D0
        ext.w   D0
        sub.w   d0, D6
        cmpi.w  #$009, D6
        bcc.s   loc_00166E
        addq.w  #8, D6
        asl.w   #8,d5
        move.b  (A0)+, D5
loc_00166E:        
        move.b  $01(A1, d1), d1
        move.w  d1, d0
        andi.w  #$F, d1
        andi.w  #$0F0, d0
loc_00167C:          
        lsr.w   #4, d0
loc_00167E:         
        lsl.l   #4, D4
        or.b    d1, D4
        subq.w  #1, d3
        bne.s   loc_00168C
        jmp     (a3) 
NemesisDec3: ; loc_001688:        
        moveq   #0, D4
        moveq   #8, d3 
loc_00168C:        
        dbra    d0, loc_00167E
        bra.s   loc_001646   
loc_001692: 
        subq.w  #6, D6  
        cmpi.w  #$009, D6 
        bcc.s   loc_0016A0
        addq.w  #8, D6
        asl.w   #8,d5
        move.b  (A0)+, D5
loc_0016A0:        
        subq.w  #$7, D6 
        move.w  d5, d1  
        lsr.w   d6, d1
        move.w  d1, d0
        andi.w  #$F, d1
        andi.w  #$070, d0
        cmpi.w  #$009, D6  
        bcc.s   loc_00167C  
        addq.w  #8, D6   
        asl.w   #8,d5   
        move.b  (A0)+, D5  
        bra.s   loc_00167C 
NemesisDec_Output: ; loc_0016BE:
        move.l  d4, (a4) 
        subq.w  #1, a5
        move.w  a5, D4 
        bne.s   NemesisDec3             ; loc_001688
        rts 
;NemesisDec_Output_XOR: ; loc_0016C8:
        eor.l   d4, D2
        move.l  D2, (a4)  
        subq.w  #1, a5  
        move.w  a5, D4  
        bne.s   NemesisDec3             ; loc_001688
        rts 
NemesisDec_OutputRAM: ; loc_0016D4:
        move.l  d4, (A4)+
        subq.w  #1, a5    
        move.w  a5, D4   
        bne.s   NemesisDec3             ; loc_001688
        rts  
;NemesisDec_OutputRAM_XOR: ; loc_0016DE:
        eor.l   d4, D2
        move.l  D2, (A4)+   
        subq.w  #1, a5   
        move.w  a5, D4 
        bne.s   NemesisDec3             ; loc_001688
        rts              
NemesisDec4: ; loc_0016EA: 
        move.b  (A0)+, D0 
loc_0016EC:        
        cmpi.b  #$FF, d0
        bne.s   loc_0016F4
        rts
loc_0016F4:        
        move.w  d0, D7
loc_0016F6:        
        move.b  (A0)+, D0  
        cmpi.b  #$80, d0
        bcc.s   loc_0016EC 
        move.b  d0, d1         
        andi.w  #$F, D7
        andi.w  #$070, d1
        or.w    d1, D7
        andi.w  #$F, d0
        move.b  d0, d1     
        lsl.w   #8, d1
        or.w    d1, D7
        moveq   #8, d1
        sub.w   d0, d1
        bne.s   loc_001724
        move.b  (A0)+, D0 
        add.w   d0, d0
        move.w  d7, $00(A1, d0)
        bra.s   loc_0016F6         
loc_001724:   
        move.b  (A0)+, D0  
        lsl.w   d1, d0
        add.w   d0, d0
        moveq   #1,d5
        lsl.w   d1,d5
        subq.w  #1,d5 
loc_001730:        
        move.w  d7, $00(A1, d0) 
        addq.w  #$2, d0
        dbra    d5, loc_001730
        bra.s   loc_0016F6
 				
LoadPLC: ; loc_00173C:
        movem.l A1/A2, -(A7)
        lea     (ArtLoadCues), A1       ; loc_024420
        add.w   d0, d0 
        move.w  $00(A1, d0), D0  
        lea     $00(A1, d0), A1
        lea     ($FFFFF680).w, a2 
loc_001754:        
        tst.l   (a2)
        beq.s   loc_00175C
        addq.w  #6, a2
        bra.s   loc_001754
loc_00175C:        
        move.w  (A1)+, D0
        bmi.s   loc_001768
loc_001760:        
        move.l  (A1)+, (A2)+
        move.w  (A1)+, (A2)+
        dbra    d0, loc_001760
loc_001768:         
        movem.l (A7)+, A1/A2
        rts   
LoadPLC2: ; loc_00176E:          
        movem.l A1/A2, -(A7)  
        lea     (ArtLoadCues), A1       ; loc_024420
        add.w   d0, d0  
        move.w  $00(A1, d0), D0 
        lea     $00(A1, d0), A1
        bsr.s   ClearPLC        ; loc_00179A
        lea     ($FFFFF680).w, a2 
        move.w  (A1)+, D0
        bmi.s   loc_001794
loc_00178C:         
        move.l  (A1)+, (A2)+
        move.w  (A1)+, (A2)+
        dbra    d0, loc_00178C 
loc_001794:   
        movem.l (A7)+, A1/A2 
        rts            
ClearPLC: ; loc_00179A:
        lea     ($FFFFF680).w, a2
        moveq   #$1F, d0
loc_0017A0:        
        clr.l   (A2)+
        dbra    d0, loc_0017A0
        rts
RunPLC: ; loc_0017A8:        
        tst.l   ($FFFFF680).w
        beq.s   loc_0017FC
        tst.w   ($FFFFF6F8).w
        bne.s   loc_0017FC
        move.l  ($FFFFF680).w, A0
        lea     NemesisDec_Output(PC), A3 ; loc_0016BE              
        nop
        lea     (Decomp_Buffer).w, A1
        move.w  (A0)+, D2
        bpl.s   loc_0017CA
        adda.w  #$00A, A3 
loc_0017CA: 
        andi.w  #$7FFF, D2
        move.w  D2, ($FFFFF6F8).w
        bsr     NemesisDec4             ; loc_0016EA
        move.b  (A0)+, D5
        asl.w   #8,d5
        move.b  (A0)+, D5  
        moveq   #$10, D6
        moveq	#0,d0
        move.l  A0, ($FFFFF680).w
        move.l  A3, ($FFFFF6E0).w
        move.l  d0, ($FFFFF6E4).w
        move.l  d0, ($FFFFF6E8).w
        move.l  d0, ($FFFFF6EC).w
        move.l  d5, ($FFFFF6F0).w 
        move.l  d6, ($FFFFF6F4).w           
loc_0017FC:    
        rts                   
loc_0017FE:
        tst.w   ($FFFFF6F8).w 
        beq     loc_001896
        move.w  #$009, ($FFFFF6FA).w            
        moveq	#0,d0
        move.w  ($FFFFF684).w, d0 
        addi.w  #$120, ($FFFFF684).w
        bra.s   loc_001832           
loc_00181A:
        tst.w   ($FFFFF6F8).w 
        beq.s   loc_001896
        move.w  #$003, ($FFFFF6FA).w 
        moveq	#0,d0
        move.w  ($FFFFF684).w, d0 
        addi.w  #$060, ($FFFFF684).w
loc_001832:        
        lea     ($00C00004), A4
        lsl.l   #$2, d0
        lsr.w   #$2, d0
        ori.w   #$4000, d0
        swap.w  D0
        move.l  d0, (a4)
        subq.w  #4, A4
        move.l  ($FFFFF680).w, A0
        move.l  ($FFFFF6E0).w, A3
        move.l  ($FFFFF6E4).w, d0
        move.l  ($FFFFF6E8).w, d1
        move.l  ($FFFFF6EC).w, D2 
        move.l  ($FFFFF6F0).w,d5
        move.l  ($FFFFF6F4).w, D6
        lea     (Decomp_Buffer).w, A1
loc_001866:        
        move.w  #8, a5
        bsr     NemesisDec3             ; loc_001688
        subq.w  #1, ($FFFFF6F8).w
        beq.s   loc_001898
        subq.w  #1, ($FFFFF6FA).w
        bne.s   loc_001866
        move.l  A0, ($FFFFF680).w
        move.l  A3, ($FFFFF6E0).w
        move.l  d0, ($FFFFF6E4).w
        move.l  d1, ($FFFFF6E8).w
        move.l  D2, ($FFFFF6EC).w
        move.l  d5, ($FFFFF6F0).w
        move.l  d6, ($FFFFF6F4).w
loc_001896:         
        rts               
loc_001898:         
        lea     ($FFFFF680).w, A0
        moveq   #$15, d0
loc_00189E:        
        move.l  $0006(A0), (A0)+
        dbra    d0, loc_00189E
        rts
RunPLC_ROM: ; loc_0018A8:
        lea     (ArtLoadCues), A1       ; loc_024420
        add.w   d0, d0
        move.w  $00(A1, d0), D0
        lea     $00(A1, d0), A1
        move.w  (A1)+, d1
loc_0018BA:        
        move.l  (A1)+, A0
        moveq	#0,d0
        move.w  (A1)+, D0
        lsl.l   #$2, d0
        lsr.w   #$2, d0
        ori.w   #$4000, d0
        swap.w  D0
        move.l  d0, ($00C00004)
        bsr     NemesisDec              ; loc_0015FC
        dbra    d1, loc_0018BA
        rts
EnigmaDec: ; loc_0018DA:
        movem.l D0-D7/A1-a5, -(A7)         
        move.w  d0, A3
        move.b  (A0)+, D0
        ext.w   D0
        move.w  d0, a5
        move.b  (A0)+, D4
        lsl.b   #3, D4
        move.w  (A0)+, A2
        adda.w  A3, a2
        move.w  (A0)+, A4
        adda.w  A3, A4
        move.b  (A0)+, D5 
        asl.w   #8,d5
        move.b  (A0)+, D5 
        moveq   #$10, D6
loc_0018FA:        
        moveq   #$7, d0
        move.w  d6, D7
        sub.w   d0, D7
        move.w  d5, d1
        lsr.w   d7, d1
        andi.w  #$07F, d1
        move.w  d1, D2
        cmpi.w  #$40, d1
        bcc.s   loc_001914
        moveq   #6, d0
        lsr.w   #1, D2
loc_001914:        
        bsr     loc_001A48
        andi.w  #$F, D2
        lsr.w   #4, d1
        add.w   d1, d1
        jmp     loc_001970(pc,d1)
loc_001924:         
        move.w  A2, (A1)+
        addq.w  #1, a2
        dbra    D2, loc_001924
        bra.s   loc_0018FA
loc_00192E:
        move.w  A4, (A1)+
        dbra    D2, loc_00192E
        bra.s   loc_0018FA
loc_001936:         
        bsr     loc_001998 
loc_00193A: 
        move.w  d1, (A1)+ 
        dbra    D2, loc_00193A  
        bra.s   loc_0018FA 
loc_001942:        
        bsr     loc_001998 
loc_001946:  
        move.w  d1, (A1)+ 
        addq.w  #1,d1
        dbra    D2, loc_001946 
        bra.s   loc_0018FA 
loc_001950:         
        bsr     loc_001998  
loc_001954:  
        move.w  d1, (A1)+ 
        subq.w  #1,d1 
        dbra    D2, loc_001954  
        bra.s   loc_0018FA 
loc_00195E:
        cmpi.w  #$F, D2
        beq.s   loc_001980
loc_001964:        
        bsr     loc_001998  
        move.w  d1, (A1)+  
        dbra    D2, loc_001964  
        bra.s   loc_0018FA             
loc_001970: 
        bra.s   loc_001924
        bra.s   loc_001924
        bra.s   loc_00192E
        bra.s   loc_00192E
        bra.s   loc_001936
        bra.s   loc_001942
        bra.s   loc_001950
        bra.s   loc_00195E          
loc_001980:  
        subq.w  #1, A0
        cmpi.w  #$010, D6
        bne.s   loc_00198A
        subq.w  #1, A0
loc_00198A:  
        move.w  A0, d0  
        lsr.w   #1,d0
        bcc.s   loc_001992
        addq.w  #1, A0
loc_001992:  
        movem.l (A7)+, D0-D7/A1-a5
        rts             
loc_001998:        
        move.w  A3, d3
        move.b  d4, d1
        add.b   d1, d1
        bcc.s   loc_0019AA
        subq.w  #1, D6
        btst    d6,d5
        beq.s   loc_0019AA
        ori.w   #$8000, d3
loc_0019AA:         
        add.b   d1, d1
        bcc.s   loc_0019B8
        subq.w  #1, D6
        btst    d6,d5
        beq.s   loc_0019B8
        addi.w  #$4000, d3
loc_0019B8:        
        add.b   d1, d1
        bcc.s   loc_0019C6
        subq.w  #1, D6
        btst    d6,d5
        beq.s   loc_0019C6
        addi.w  #$2000, d3
loc_0019C6:  
        add.b   d1, d1
        bcc.s   loc_0019D4
        subq.w  #1, D6
        btst    d6,d5
        beq.s   loc_0019D4
        ori.w   #$1000, d3
loc_0019D4:    
        add.b   d1, d1
        bcc.s   loc_0019E2
        subq.w  #1, D6
        btst    d6,d5
        beq.s   loc_0019E2
        ori.w   #$800, d3
loc_0019E2:   
        move.w  d5, d1   
        move.w  d6, D7 
        sub.w   a5, D7 
        bcc.s   loc_001A12
        move.w  d7, D6 
        addi.w  #$010, D6
        neg.w   D7
        lsl.w   d7, d1
        move.b  (A0), D5
        rol.b   d7,d5
        add.w   d7, D7
        and.w   loc_001A28-$02(PC, D7), D5
        add.w   d5, d1
loc_001A00:        
        move.w  a5, d0
        add.w   d0, d0  
        and.w   loc_001A28-$02(pc,d0), d1 
        add.w   d3, d1
        move.b  (A0)+, D5
        lsl.w   #8,d5
        move.b  (A0)+, D5
        rts
loc_001A12:
        beq.s   loc_001A24
        lsr.w   d7, d1
        move.w  a5, d0
        add.w   d0, d0 
        and.w   loc_001A28-$02(pc,d0), d1
        add.w   d3, d1
        move.w  a5, d0
        bra.s   loc_001A48
loc_001A24: 
        moveq   #$10, D6
        bra.s   loc_001A00
loc_001A28:  
        dc.w    $0001, $0003, $0007, $000F, $001F, $003F, $007F, $00FF
        dc.w    $01FF, $03FF, $07FF, $0FFF, $1FFF, $3FFF, $7FFF, $FFFF     
loc_001A48:    
        sub.w   d0, D6
        cmpi.w  #$009, D6
        bcc.s   loc_001A56
        addq.w  #8, D6
        asl.w   #8,d5
        move.b  (A0)+, D5
loc_001A56:        
        rts
KosinskiDec: ; loc_001A58:        
        subq.l  #$2, A7
        move.b  (A0)+, render_flags(a7)
        move.b  (A0)+, (a7)
        move.w  (A7), D5
        moveq   #$F, D4
loc_001A64:         
        lsr.w   #1,d5
        move    SR, D6
        dbra    d4, loc_001A76
        move.b  (A0)+, render_flags(a7)
        move.b  (A0)+, (a7)
        move.w  (A7), D5
        moveq   #$F, D4
loc_001A76: 
        move    d6, CCR  
        bcc.s   loc_001A7E
        move.b  (A0)+, (A1)+
        bra.s   loc_001A64
loc_001A7E: 
        moveq   #0, d3  
        lsr.w   #1,d5 
        move    SR, D6 
        dbra    d4, loc_001A92   
        move.b  (A0)+, render_flags(a7)  
        move.b  (A0)+, (a7) 
        move.w  (A7), D5 
        moveq   #$F, D4                 
loc_001A92:          
        move    d6, CCR 
        bcs.s   loc_001AC2
        lsr.w   #1,d5
        dbra    d4, loc_001AA6
        move.b  (A0)+, render_flags(a7)
        move.b  (A0)+, (a7) 
        move.w  (A7), D5
        moveq   #$F, D4
loc_001AA6:  
        roxl.w  #1, d3 
        lsr.w   #1,d5 
        dbra    d4, loc_001AB8
        move.b  (A0)+, render_flags(a7)
        move.b  (A0)+, (a7) 
        move.w  (A7), D5
        moveq   #$F, D4 
loc_001AB8: 
        roxl.w  #1, d3 
        addq.w  #1, d3
        moveq   #$FFFFFFFF, D2
        move.b  (A0)+, D2
        bra.s   loc_001AD8
loc_001AC2: 
        move.b  (A0)+, D0 
        move.b  (A0)+, d1 
        moveq   #$FFFFFFFF, D2
        move.b  d1, D2 
        lsl.w   #5, D2
        move.b  d0, D2
        andi.w  #$007, d1
        beq.s   loc_001AE4
        move.b  d1, d3 
        addq.w  #1, d3 
loc_001AD8:
        move.b  $00(A1, D2), D0
        move.b  d0, (A1)+
        dbra    d3, loc_001AD8 
        bra.s   loc_001A64         
loc_001AE4:   
        move.b  (A0)+, d1
        beq.s   loc_001AF4
        cmpi.b  #1,d1
        beq     loc_001A64
        move.b  d1, d3 
        bra.s   loc_001AD8
loc_001AF4:
        addq.l  #$2, A7
        rts
UnknownDec: ; loc_001AF8:        
        moveq	#0,d0
        move.w  #$7FF, D4
        moveq   #0,d5
        moveq   #0, D6
        move.w  A3, D7
        subq.w  #1, D2
        beq     loc_001E98
        subq.w  #1, D2
        beq     loc_001E1A
        subq.w  #1, D2
        beq     loc_001D9C
        subq.w  #1, D2
        beq     loc_001D1E
        subq.w  #1, D2
        beq     loc_001CA2
        subq.w  #1, D2
        beq     loc_001C24
        subq.w  #1, D2
        beq     loc_001BAA
loc_001B2E:        
        move.b  (A0)+, d1
        add.b   d1, d1
        bcs.s   loc_001BA8
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001B50
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001B44
        move.b  (a6)+, (A2)+
loc_001B44: 
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001B98
        bra     loc_001CA2        
loc_001B50: 
        lsl.w   #3, d1
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001B64
        add.b   d1, d1
        bcs.s   loc_001B7A
        bra.s   loc_001B7C
loc_001B64:
        add.b   d1, d1
        bcc.s   loc_001B78
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001B8A
        subq.w  #6, d0
        bmi.s   loc_001B90
loc_001B72:        
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001B72
loc_001B78:         
        move.b  (a6)+, (A2)+
loc_001B7A: 
        move.b  (a6)+, (A2)+
loc_001B7C:  
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+ 
        cmp.w   A2, D7
        bls.s   loc_001BA0
        bra     loc_001E98
loc_001B8A: 
        move.w  #0, d0
        rts
loc_001B90:  
        move.w  #$FFFF, d0
        moveq   #1, D2
        rts
loc_001B98: 
        move.w  #$001, d0
        moveq   #5, D2
        rts
loc_001BA0:   
        move.w  #$001, d0
        moveq   #1, D2
        rts
loc_001BA8:     
        move.b  (A1)+, (A2)+ 
loc_001BAA:        
        add.b   d1, d1
        bcs.s   loc_001C22
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001BCA
        move.b  (A1)+, D5 
        sub.l   d5, a6
        add.b   d1, d1
        bcc.s   loc_001BBE
        move.b  (a6)+, (A2)+ 
loc_001BBE:   
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001C12
        bra     loc_001D1E
loc_001BCA:
        lsl.w   #3, d1
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6 
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001BDE
        add.b   d1, d1
        bcs.s   loc_001BF4
        bra.s   loc_001BF6
loc_001BDE: 
        add.b   d1, d1
        bcc.s   loc_001BF2
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001C04
        subq.w  #6, d0
        bmi.s   loc_001C0A
loc_001BEC:        
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001BEC
loc_001BF2: 
        move.b  (a6)+, (A2)+         
loc_001BF4:
        move.b  (a6)+, (A2)+ 
loc_001BF6:
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001C1A
        bra     loc_001B2E
loc_001C04: 
        move.w  #0, d0
        rts
loc_001C0A:   
        move.w  #$FFFF, d0
        moveq   #0, D2
        rts
loc_001C12:
        move.w  #$001, d0
        moveq   #4, D2
        rts
loc_001C1A: 
        move.w  #$001, d0
        moveq   #0, D2
        rts
loc_001C22: 
        move.b  (A1)+, (A2)+
loc_001C24:    
        add.b   d1, d1 
        bcs.s   loc_001CA0
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001C44
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001C38
        move.b  (a6)+, (A2)+
loc_001C38:    
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001C90
        bra     loc_001D9C
loc_001C44: 
        lsl.w   #3, d1
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001C5A
        move.b  (A0)+, d1
        add.b   d1, d1
        bcs.s   loc_001C72
        bra.s   loc_001C74
loc_001C5A: 
        move.b  (A0)+, d1
        add.b   d1, d1
        bcc.s   loc_001C70
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001C82
        subq.w  #6, d0
        bmi.s   loc_001C88
loc_001C6A:  
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001C6A
loc_001C70:  
        move.b  (a6)+, (A2)+
loc_001C72:
        move.b  (a6)+, (A2)+
loc_001C74: 
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001C98
        bra     loc_001BAA
loc_001C82:
        move.w  #0, d0
        rts
loc_001C88:  
        move.w  #$FFFF, d0
        moveq   #$7, D2
        rts
loc_001C90:  
        move.w  #$001, d0
        moveq   #3, D2
        rts
loc_001C98:    
        move.w  #$001, d0
        moveq   #$7, D2
        rts
loc_001CA0:  
        move.b  (A1)+, (A2)+  
loc_001CA2:          
        add.b   d1, d1
        bcs.s   loc_001D1C 
        move.l  A2, a6   
        add.b   d1, d1 
        bcs.s   loc_001CC2
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001CB6
        move.b  (a6)+, (A2)+ 
loc_001CB6:   
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7 
        bls.s   loc_001D0C
        bra     loc_001E1A
loc_001CC2:  
        lsl.w   #3, d1
        move.b  (A0)+, d1
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001CD8
        add.b   d1, d1
        bcs.s   loc_001CEE
        bra.s   loc_001CF0
loc_001CD8: 
        add.b   d1, d1
        bcc.s   loc_001CEC
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001CFE
        subq.w  #6, d0
        bmi.s   loc_001D04
loc_001CE6:
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001CE6              
loc_001CEC:      
        move.b  (a6)+, (A2)+
loc_001CEE:
        move.b  (a6)+, (A2)+
loc_001CF0: 
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+  
        cmp.w   A2, D7   
        bls.s   loc_001D14    
        bra     loc_001C24      
loc_001CFE: 
        move.w  #0, d0
        rts
loc_001D04:    
        move.w  #$FFFF, d0
        moveq   #6, D2
        rts
loc_001D0C:
        move.w  #$001, d0
        moveq   #$2, D2
        rts
loc_001D14:   
        move.w  #$001, d0
        moveq   #6, D2
        rts
loc_001D1C:               
        move.b  (A1)+, (A2)+  
loc_001D1E: 
        add.b   d1, d1 
        bcs.s   loc_001D9A
        move.l  A2, a6
        add.b   d1, d1 
        bcs.s   loc_001D3E
        move.b  (A1)+, D5 
        suba.l  d5, a6
        add.b   d1, d1 
        bcc.s   loc_001D32
        move.b  (a6)+, (A2)+  
loc_001D32:    
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001D8A
        bra     loc_001E98
loc_001D3E:
        lsl.w   #$2, d1
        move.b  (A0)+, d1
        add.w   d1, d1
        move.w  d1, D6
        and.w   d4, D6 
        move.b  (A1)+, D6 
        suba.l  d6, a6
        add.b   d1, d1 
        bcs.s   loc_001D56
        add.b   d1, d1 
        bcs.s   loc_001D6C
        bra.s   loc_001D6E
loc_001D56:  
        add.b   d1, d1
        bcc.s   loc_001D6A
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001D7C
        subq.w  #6, d0
        bmi.s   loc_001D82
loc_001D64:   
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001D64
loc_001D6A:     
        move.b  (a6)+, (A2)+
loc_001D6C: 
        move.b  (a6)+, (A2)+
loc_001D6E: 
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001D92
        bra     loc_001CA2
loc_001D7C:  
        move.w  #0, d0
        rts
loc_001D82:   
        move.w  #$FFFF, d0
        moveq   #5, D2
        rts           
loc_001D8A:
        move.w  #$001, d0
        moveq   #1, D2
        rts  
loc_001D92:  
        move.w  #$001, d0
        moveq   #5, D2
        rts 
loc_001D9A:
        move.b  (A1)+, (A2)+ 
loc_001D9C:         
        add.b   d1, d1
        bcs.s   loc_001E18
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001DBC
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001DB0
        move.b  (a6)+, (A2)+
loc_001DB0:  
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001E08
        bra     loc_001B2E
loc_001DBC:
        add.w   d1, d1
        move.b  (A0)+, d1
        lsl.w   #$2, d1  
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001DD4
        add.b   d1, d1
        bcs.s   loc_001DEA
        bra.s   loc_001DEC
loc_001DD4:  
        add.b   d1, d1
        bcc.s   loc_001DE8
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001DFA
        subq.w  #6, d0
        bmi.s   loc_001E00
loc_001DE2:        
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001DE2
loc_001DE8:  
        move.b  (a6)+, (A2)+
loc_001DEA:
        move.b  (a6)+, (A2)+
loc_001DEC:
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001E10
        bra     loc_001D1E
loc_001DFA: 
        move.w  #0, d0
        rts 
loc_001E00:   
        move.w  #$FFFF, d0
        moveq   #4, D2        
        rts
loc_001E08:
        move.w  #$001, d0
        moveq   #8, D2        
        rts
loc_001E10:  
        move.w  #$001, d0
        moveq   #4, D2        
        rts
loc_001E18:
        move.b  (A1)+, (A2)+
loc_001E1A:          
        add.b   d1, d1
        bcs.s   loc_001E96
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001E3C
        move.b  (A0)+, d1
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001E30
        move.b  (a6)+, (A2)+
loc_001E30:   
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001E86
        bra     loc_001BAA
loc_001E3C:
        move.b  (A0)+, d1
        lsl.w   #3, d1
        move.w  d1, D6 
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001E52
        add.b   d1, d1
        bcs.s   loc_001E68
        bra.s   loc_001E6A
loc_001E52:
        add.b   d1, d1
        bcc.s   loc_001E66
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001E78
        subq.w  #6, d0
        bmi.s   loc_001E7E
loc_001E60:         
        move.b  (a6)+, (A2)+
        dbra    d0, loc_001E60        
loc_001E66:       
        move.b  (a6)+, (A2)+
loc_001E68:   
        move.b  (a6)+, (A2)+
loc_001E6A:
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001E8E
        bra     loc_001D9C
loc_001E78:  
        move.w  #0, d0
        rts
loc_001E7E:    
        move.w  #$FFFF, d0
        moveq   #3, D2
        rts
loc_001E86:
        move.w  #$001, d0
        moveq   #$7, D2
        rts       
loc_001E8E:          
        move.w  #$001, d0
        moveq   #3, D2
        rts 
loc_001E96:
        move.b  (A1)+, (A2)+          
loc_001E98:
        add.b   d1, d1
        bcs.s   loc_001F12
        move.b  (A0)+, d1
        move.l  A2, a6
        add.b   d1, d1
        bcs.s   loc_001EBA
        move.b  (A1)+, D5
        suba.l  d5, a6
        add.b   d1, d1
        bcc.s   loc_001EAE
        move.b  (a6)+, (A2)+ 
loc_001EAE:  
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+ 
        cmp.w   A2, D7
        bls.s   loc_001F02
        bra     loc_001C24
loc_001EBA:  
        lsl.w   #3, d1
        move.w  d1, D6
        and.w   d4, D6
        move.b  (A1)+, D6
        suba.l  d6, a6
        add.b   d1, d1
        bcs.s   loc_001ECE
        add.b   d1, d1
        bcs.s   loc_001EE4
        bra.s   loc_001EE6
loc_001ECE: 
        add.b   d1, d1
        bcc.s   loc_001EE2
        moveq	#0,d0
        move.b  (A1)+, D0
        beq.s   loc_001EF4
        subq.w  #6, d0
        bmi.s   loc_001EFA
loc_001EDC:        
        move.b  (a6)+, (A2)+ 
        dbra    d0, loc_001EDC
loc_001EE2: 
        move.b  (a6)+, (A2)+ 
loc_001EE4: 
        move.b  (a6)+, (A2)+ 
loc_001EE6: 
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+ 
        move.b  (a6)+, (A2)+
        cmp.w   A2, D7
        bls.s   loc_001F0A
        bra     loc_001E1A
loc_001EF4: 
        move.w  #0, d0
        rts
loc_001EFA:  
        move.w  #$FFFF, d0
        moveq   #$2, D2
        rts
loc_001F02: 
        move.w  #$001, d0
        moveq   #6, D2
        rts
loc_001F0A:   
        move.w  #$001, d0
        moveq   #$2, D2
        rts
loc_001F12:        
        move.b  (A1)+, (A2)+ 
        bra     loc_001B2E
PalCycle_Load: ; loc_001F18: ; Rotating Palette routine
        bsr     loc_0024A2
        moveq   #0, D2
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        move.w  PalCycle(pc,d0), D0    ; loc_001F30
        jmp     PalCycle(pc,d0)        ; loc_001F30
        rts
PalCycle: ; loc_001F30:        
        dc.w    PalCycle_GHz-PalCycle ; $00 - Green Hill 
        dc.w    PalCycle_Null-PalCycle ; $01
        dc.w    PalCycle_Wz-PalCycle ; $02 - Wood
        dc.w    PalCycle_Null-PalCycle ; $03
        dc.w    PalCycle_Mz-PalCycle ; $04 - Metropolis
        dc.w    PalCycle_Mz-PalCycle ; $05 - Metropolis
        dc.w    PalCycle_Null-PalCycle ; $06
        dc.w    PalCycle_HTz-PalCycle ; $07 - Hill Top
        dc.w    PalCycle_HPz-PalCycle ; $08 - Hidden Palace
        dc.w    PalCycle_Null-PalCycle ; $09
        dc.w    PalCycle_OOz-PalCycle ; $0A - Oil Ocean
        dc.w    PalCycle_DHz-PalCycle ; $0B - Dust Hill
        dc.w    PalCycle_CNz-PalCycle ; $0C - Casino Night
        dc.w    PalCycle_CPz-PalCycle ; $0D - Chemical Plant
        dc.w    PalCycle_Null-PalCycle ; $0E - Genocide City
        dc.w    PalCycle_NGHz-PalCycle ; $0F - Neo Green Hill
        dc.w    PalCycle_Null-PalCycle ; $10 - Death Egg
PalCycle_Null: ; loc_001F52:
        rts             
PalCycle_GHz: ; loc_001F54: ; $00 - Green Hill Rotating Palette routine
        lea     (Pal_GHzCyc), A0        ; loc_002284
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_001F80
        move.w  #$007, ($FFFFF634).w
        move.w  ($FFFFF632).w, d0
        addq.w  #1, ($FFFFF632).w
        andi.w  #$003, d0
        lsl.w   #3, d0
        move.l  $00(A0, d0), ($FFFFFB26).w
        move.l  $04(A0, d0), ($FFFFFB3C).w
loc_001F80:
        rts  
PalCycle_Wz: ; loc_001F82: ; $02 - Wood Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_001FB0
        move.w  #$002, ($FFFFF634).w
        lea     (Pal_WzCyc), A0         ; loc_002324
        move.w  ($FFFFF632).w, d0
        subq.w  #$2, ($FFFFF632).w
        bcc.s   loc_001FA4
        move.w  #$006, ($FFFFF632).w         
loc_001FA4:
        lea     ($FFFFFB66).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
loc_001FB0:        
        rts  
PalCycle_Mz: ; loc_001FB2: ; $04/$05 - Metropolis Rotating Palette routine
        subq.w  #1, ($FFFFF634).w    
        bpl.s   loc_001FE2
        move.w  #$011, ($FFFFF634).w
        lea     (Pal_MzCyc1), A0        ; loc_002334
        move.w  ($FFFFF632).w, d0
        addq.w  #$2, ($FFFFF632).w
        cmpi.w  #$00C, ($FFFFF632).w
        bcs.s   loc_001FDA
        move.w  #0, ($FFFFF632).w
loc_001FDA:
        lea     ($FFFFFB4A).w, A1
        move.w  $00(A0, d0), (a1)
loc_001FE2:
        subq.w  #1, ($FFFFF666).w
        bpl.s   loc_002016
        move.w  #$002, ($FFFFF666).w
        lea     (Pal_MzCyc2), A0        ; loc_002340
        move.w  (Water_change_speed).w, d0
        addq.w  #$2, (Water_change_speed).w
        cmpi.w  #$006, (Water_change_speed).w
        bcs.s   loc_00200A
        move.w  #0, (Water_change_speed).w
loc_00200A:
        lea     ($FFFFFB42).w, A1
        move.l  $00(A0, d0), (A1)+
        move.w  $04(A0, d0), (a1)
loc_002016:
        subq.w  #1, ($FFFFF668).w
        bpl.s   loc_002046
        move.w  #$009, ($FFFFF668).w
        lea     (Pal_MzCyc3), A0        ; loc_00234C
        move.w  ($FFFFF654).w, d0
        addq.w  #$2, ($FFFFF654).w
        cmpi.w  #$014, ($FFFFF654).w
        bcs.s   loc_00203E
        move.w  #0, ($FFFFF654).w
loc_00203E:
        lea     ($FFFFFB5E).w, A1
        move.w  $00(A0, d0), (a1)
loc_002046:
        rts        
PalCycle_HTz: ; loc_002048: ; $07 - Hill Top Rotating Palette routine
        lea     (Pal_HTzCyc1), A0       ; loc_0022A4
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_00207A
        move.w  #0, ($FFFFF634).w
        move.w  ($FFFFF632).w, d0
        addq.w  #1, ($FFFFF632).w
        andi.w  #$F, d0
        move.b  Pal_HTzCyc2(pc,d0), ($FFFFF635).w  ; loc_00207C
        lsl.w   #3, d0
        move.l  $00(A0, d0), ($FFFFFB26).w
        move.l  $04(A0, d0), ($FFFFFB3C).w 
loc_00207A:
        rts          
Pal_HTzCyc2: ; loc_00207C:
        dc.w    $0B0B, $0B0A, $080A, $0B0B, $0B0B, $0D0F, $0D0B, $0B0B
PalCycle_HPz: ; loc_00208C: ; $08 - Hidden Palace Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_0020CC
        move.w  #$004, ($FFFFF634).w
        lea     (Pal_HPzCyc1), A0       ; loc_002360
        move.w  ($FFFFF632).w, d0
        subq.w  #$2, ($FFFFF632).w
        bcc.s   loc_0020AE
        move.w  #$006, ($FFFFF632).w
loc_0020AE:
        lea     ($FFFFFB72).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
        lea     (Pal_HPzCyc2), A0       ; loc_002370
        lea     ($FFFFFAF2).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
loc_0020CC:
        rts             
PalCycle_OOz: ; loc_0020CE: ; $0A - Oil Ocean Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_0020FA
        move.w  #$007, ($FFFFF634).w
        lea     (Pal_OOzCyc), A0        ; loc_002380
        move.w  ($FFFFF632).w, d0
        addq.w  #$2, ($FFFFF632).w
        andi.w  #$006, ($FFFFF632).w
        lea     ($FFFFFB54).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
loc_0020FA:
        rts    
PalCycle_DHz: ; loc_0020FC: ; $0B - Dust Hill Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_002122
        move.w  #$001, ($FFFFF634).w
        lea     (Pal_DHzCyc), A0        ; loc_002390
        move.w  ($FFFFF632).w, d0
        addq.w  #$2, ($FFFFF632).w
        andi.w  #$006, ($FFFFF632).w
        move.w  $00(A0, d0), ($FFFFFB36).w
loc_002122:
        rts
PalCycle_CNz: ; loc_002124: ; $0C - Casino Night Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl     loc_0021C2
        move.w  #$007, ($FFFFF634).w
        lea     (Pal_CNzCyc1), A0       ; loc_002398
        move.w  ($FFFFF632).w, d0
        addq.w  #$2, ($FFFFF632).w
        cmpi.w  #$006, ($FFFFF632).w
        bcs.s   loc_00214E
        move.w  #0, ($FFFFF632).w
loc_00214E:
        lea     $00(A0, d0), A0
        lea     ($FFFFFB00).w, A1
        move.w  0(A0), $004A(a1)
        move.w  $0006(A0), $004C(a1)
        move.w  y_pos(a0), $004E(a1)
        move.w  $0012(A0), $0056(a1)
        move.w  $0018(A0), $0058(a1)
        move.w  $001E(A0), $005A(a1)
        lea     (Pal_CNzCyc2), A0       ; loc_0023BC
        lea     $00(A0, d0), A0
        move.w  0(A0), $0064(a1)
        move.w  $0006(A0), $0066(a1)
        move.w  y_pos(a0), $0068(a1)
        lea     (Pal_CNzCyc3), A0       ; loc_0023CE
        move.w  (Water_change_speed).w, d0
        addq.w  #$2, (Water_change_speed).w
        cmpi.w  #$01C, (Water_change_speed).w
        bcs.s   loc_0021B2
        move.w  #0, (Water_change_speed).w
loc_0021B2:
        lea     ($FFFFFB72).w, A1
        move.w  $00(A0, d0), (A1)+
        move.w  $1C(A0, d0), (A1)+
        move.w  $38(A0, d0), (A1)+
loc_0021C2:
        rts        
PalCycle_CPz: ; loc_0021C4: ; $0D - Chemical Plant Rotating Palette routine
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_002234
        move.w  #$007, ($FFFFF634).w
        lea     (Pal_CPzCyc1), A0       ; loc_002422
        move.w  ($FFFFF632).w, d0
        addq.w  #6, ($FFFFF632).w
        cmpi.w  #$036, ($FFFFF632).w
        bcs.s   loc_0021EC
        move.w  #0, ($FFFFF632).w
loc_0021EC:
        lea     ($FFFFFB78).w, A1
        move.l  $00(A0, d0), (A1)+
        move.w  $04(A0, d0), (a1)
        lea     (Pal_CPzCyc2), A0       ; loc_002458
        move.w  (Water_change_speed).w, d0
        addq.w  #$2, (Water_change_speed).w
        cmpi.w  #$02A, (Water_change_speed).w
        bcs.s   loc_002214
        move.w  #0, (Water_change_speed).w
loc_002214:
        move.w  $00(A0, d0), ($FFFFFB7E).w
        lea     (Pal_CPzCyc3), A0       ; loc_002482
        move.w  ($FFFFF654).w, d0
        addq.w  #$2, ($FFFFF654).w
        andi.w  #$01E, ($FFFFF654).w
        move.w  $00(A0, d0), ($FFFFFB5E).w
loc_002234:
        rts        
PalCycle_NGHz: ; loc_002236: ; $0F - Neo Green Hill Rotating Palette routine
        lea     (Pal_GHzCyc), A0        ; loc_002284
        subq.w  #1, ($FFFFF634).w
        bpl.s   loc_002262
        move.w  #$005, ($FFFFF634).w
        move.w  ($FFFFF632).w, d0
        addq.w  #1, ($FFFFF632).w
        andi.w  #$003, d0
        lsl.w   #3, d0
        lea     ($FFFFFB44).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
loc_002262:
        rts  
;Pal_S1TitleCyc: ;loc_002264: ; Left Over - Unused Rotating Palette
        dc.w    $0C42, $0E86, $0ECA, $0EEC, $0EEC, $0C42, $0E86, $0ECA
        dc.w    $0ECA, $0EEC, $0C42, $0E86, $0E86, $0ECA, $0EEC, $0C42                
Pal_GHzCyc: ; loc_002284: ; $00 - Green Hill Rotating Palette               
        dc.w    $0A86, $0E86, $0EA8, $0ECA, $0ECA, $0A86, $0E86, $0EA8
        dc.w    $0EA8, $0ECA, $0A86, $0E86, $0E86, $0EA8, $0ECA, $0A86
Pal_HTzCyc1: ; loc_0022A4: ; $07 - Hill Top Rotating Palette         
        dc.w    $000E, $006E, $00AE, $00EE, $00EE, $000E, $006E, $00AE
        dc.w    $02CE, $00EE, $000E, $006E, $006E, $04EE, $08EE, $002E
        dc.w    $004E, $008E, $06EE, $0AEE, $08EE, $002E, $006E, $04EE
        dc.w    $02CE, $00EE, $000E, $006E, $006E, $02CE, $00EE, $000E
        dc.w    $000E, $006E, $00AE, $00EE, $00CE, $000C, $004E, $008E
        dc.w    $006E, $00AC, $000A, $002E, $000C, $004C, $008E, $0008
        dc.w    $000A, $002E, $006E, $00AC, $00CE, $000C, $004E, $008E
        dc.w    $00AE, $00EE, $000E, $006E, $006E, $00AE, $00EE, $000E
Pal_WzCyc: ; loc_002324: ; $02 - Wood Rotating Palette 
        dc.w    $0248, $046A, $048C, $06CE, $0248, $046A, $048C, $06CE
Pal_MzCyc1: ; loc_002334: ; $04/$05 - Metropolis Rotating Palette 
        dc.w    $0006, $0008, $000A, $000C, $000A, $0008         
Pal_MzCyc2: ; loc_002340: ; $04/$05 - Metropolis Rotating Palette 
        dc.w    $0422, $0866, $0ECC, $0422, $0866, $0ECC 
Pal_MzCyc3: ;loc_00234C: ; $04/$05 - Metropolis Rotating Palette 
        dc.w    $00A0, $0000, $00EE, $0000, $002E, $0000, $0E2E, $0000
        dc.w    $0E80, $0000
Pal_HPzCyc1: ; loc_002360: ; $08 - Hidden Palace Rotating Palette 
        dc.w    $0E44, $0E82, $0EA8, $0EEE, $0E44, $0E82, $0EA8, $0EEE
Pal_HPzCyc2: ; loc_002370: ; $08 - Hidden Palace Rotating Palette 
        dc.w    $0E84, $0EA6, $0EC6, $0EE6, $0E84, $0EA6, $0EC6, $0EE6
Pal_OOzCyc: ; loc_002380: ; $0A - Oil Ocean Rotating Palette 
        dc.w    $0400, $0602, $0804, $0806, $0400, $0602, $0804, $0806
Pal_DHzCyc: ; loc_002390: ; $0B - Dust Hill Rotating Palette 
        dc.w    $000C, $006E, $00CE, $08EE
Pal_CNzCyc1: ; loc_002398: ; $0C - Casino Night Rotating Palette 
        dc.w    $000C, $00CC, $004C, $004C, $000C, $00CC, $00CC, $004C
        dc.w    $000C, $00EC, $0080, $00C4, $00C4, $00EC, $0080, $0080
        dc.w    $00C4, $00EC
Pal_CNzCyc2: ; loc_0023BC: ; $0C - Casino Night Rotating Palette 
        dc.w    $0044, $0088, $00EE, $0088, $00EE, $0044, $00EE, $0044
        dc.w    $0088
Pal_CNzCyc3: ; loc_0023CE: ; $0C - Casino Night Rotating Palette  
        dc.w    $00EC, $0EEE, $00EA, $00E4, $06C0, $0CC4, $0E80, $0E40
        dc.w    $0E04, $0C08, $0C2E, $000E, $006E, $00AE, $00AE, $00EC
        dc.w    $0EEE, $00EA, $00E4, $06C0, $0CC4, $0E80, $0E40, $0E04
        dc.w    $0C08, $0C2E, $000E, $006E, $00EE, $00AE, $00EC, $0EEE
        dc.w    $00EA, $00E4, $06C0, $0CC4, $0E80, $0E40, $0E04, $0C08
        dc.w    $0C2E, $000E
Pal_CPzCyc1: ; loc_002422: ; $0D - Chemical Plant Rotating Palette 
        dc.w    $0E40, $0C00, $0C00, $0E60, $0C20, $0C00, $0E40, $0E40
        dc.w    $0C00, $0C20, $0E60, $0C20, $0C00, $0E40, $0C40, $0C00
        dc.w    $0C20, $0E40, $0C00, $0C00, $0E60, $0C20, $0C00, $0E40
        dc.w    $0E20, $0C00, $0C20
Pal_CPzCyc2: ; loc_002458: ; $0D - Chemical Plant Rotating Palette 
        dc.w    $00E0, $00C2, $00A4, $0086, $0068, $004A, $002C, $000E
        dc.w    $020C, $040A, $0608, $0806, $0A04, $0C02, $0E00, $0C20
        dc.w    $0A40, $0860, $0680, $04A0, $02C0
Pal_CPzCyc3: ; loc_002482: ; $0D - Chemical Plant Rotating Palette   
        dc.w    $000E, $000C, $000A, $0008, $0006, $0004, $0002, $0004
        dc.w    $0006, $0008, $000A, $000C, $000E, $002E, $004E, $002E     
loc_0024A2:
        tst.b   (Super_Sonic_palette).w
        beq.s   loc_0024DE
        bmi.s   loc_0024E0
        subq.b  #1, (Palette_frame_count).w 
        bpl.s   loc_0024DE
        move.b  #3, (Palette_frame_count).w
        lea     (loc_002516), A0
        move.w  ($FFFFF65C).w, d0
        addq.w  #8, ($FFFFF65C).w
        cmpi.w  #$030, ($FFFFF65C).w
        bcs.s   loc_0024D2
        move.b  #$FF, (Super_Sonic_palette).w
loc_0024D2:
        lea     ($FFFFFB04).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
loc_0024DE:
        rts
loc_0024E0:
        subq.b  #1, (Palette_frame_count).w
        bpl.s   loc_0024DE
        move.b  #$7, (Palette_frame_count).w
        lea     (loc_002516), A0
        move.w  ($FFFFF65C).w, d0
        addq.w  #8, ($FFFFF65C).w
        cmpi.w  #$078, ($FFFFF65C).w
        bcs.s   loc_002508
        move.w  #$030, ($FFFFF65C).w
loc_002508:
        lea     ($FFFFFB04).w, A1
        move.l  $00(A0, d0), (A1)+
        move.l  $04(A0, d0), (a1)
        rts
loc_002516:              
        dc.w    $0A22, $0C42, $0E44, $0E66, $0844, $0A64, $0E66, $0E88
        dc.w    $0666, $0A86, $0E88, $0EAA, $0488, $0AA8, $0EAA, $0ECC
        dc.w    $04AA, $0ACA, $0ECC, $0EEE, $04CC, $0AEC, $0EEE, $0EEE
        dc.w    $04EE, $0AEE, $0EEE, $0EEE, $06EE, $0EEE, $0EEE, $0EEE
        dc.w    $08EE, $0EEE, $0EEE, $0EEE, $06EE, $0CEE, $0EEE, $0EEE
        dc.w    $04EE, $0AEE, $0EEE, $0EEE, $02EE, $08EE, $0CEE, $0EEE
        dc.w    $00EE, $06EE, $0AEE, $0EEE, $00EE, $04EE, $08EE, $0CEE
        dc.w    $00EE, $06EE, $0AEE, $0EEE, $00EE, $08EE, $0CEE, $0EEE
Pal_FadeTo: ; loc_002596:
        move.w  #$03F, ($FFFFF626).w
Pal_FadeTo2: ; loc_00259C:        
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        moveq   #0,d1
        move.b  ($FFFFF627).w, d0
loc_0025AE:        
        move.w  d1, (A0)+
        dbra    d0, loc_0025AE
        move.w  #$015, D4
loc_0025B8:        
        move.b  #$12, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr.s   Pal_FadeIn              ; loc_0025CE
        bsr     RunPLC          ; loc_0017A8
        dbra    d4, loc_0025B8
        rts
Pal_FadeIn: ; loc_0025CE:        
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        lea     ($FFFFFB80).w, A1
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        adda.w  d0, A1
        move.b  ($FFFFF627).w, d0
loc_0025E4:        
        bsr.s   Pal_AddColor            ; loc_00260E
        dbra    d0, loc_0025E4
        tst.b   ($FFFFF730).w
        beq.s   loc_00260C
        moveq	#0,d0
        lea     ($FFFFFA80).w, A0
        lea     ($FFFFFA00).w, A1
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        adda.w  d0, A1
        move.b  ($FFFFF627).w, d0
loc_002606:         
        bsr.s   Pal_AddColor            ; loc_00260E         
        dbra    d0, loc_002606
loc_00260C:        
        rts
Pal_AddColor: ; loc_00260E:  
        move.w  (A1)+, D2
        move.w  (A0), D3
        cmp.w   D2, d3
        beq.s   Pal_NoAdd               ; loc_002636
        move.w  d3, d1
        addi.w  #$200, d1         
        cmp.w   D2, d1
        bhi.s   Pal_AddGreen            ; loc_002624
        move.w  d1, (A0)+
        rts 
Pal_AddGreen: ; loc_002624:
        move.w  d3, d1
        addi.w  #$20, d1
        cmp.w   D2, d1
        bhi.s   Pal_AddRed              ; loc_002632
        move.w  d1, (A0)+ 
        rts
Pal_AddRed: ; loc_002632:               
        addq.w  #$2, (A0)+
        rts 
Pal_NoAdd: ; loc_002636:
        addq.w  #$2, A0
        rts
Pal_FadeFrom: ; loc_00263A:
        move.w  #$03F, ($FFFFF626).w
        move.w  #$015, D4
loc_002644:
        move.b  #$12, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr.s   Pal_FadeOut             ; loc_00265A
        bsr     RunPLC          ; loc_0017A8
        dbra    d4, loc_002644
        rts
Pal_FadeOut: ; loc_00265A:        
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        move.b  ($FFFFF627).w, d0
loc_00266A:
        bsr.s   Pal_DecColor            ; loc_002688
        dbra    d0, loc_00266A
        moveq	#0,d0
        lea     ($FFFFFA80).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        move.b  ($FFFFF627).w, d0
loc_002680:        
        bsr.s   Pal_DecColor            ; loc_002688  
        dbra    d0, loc_002680
        rts
Pal_DecColor: ; loc_002688:
        move.w  (A0), D2
        beq.s   Pal_NoDec               ; loc_0026B4
        move.w  D2, d1
        andi.w  #$00E, d1
        beq.s   Pal_DecGreen            ; loc_002698
        subq.w  #$2, (A0)+
        rts
Pal_DecGreen: ; loc_002698:
        move.w  D2, d1
        andi.w  #$0E0, d1
        beq.s   Pal_DecBlue             ; loc_0026A6
        subi.w  #$20, (A0)+
        rts
Pal_DecBlue: ; loc_0026A6:
        move.w  D2, d1
        andi.w  #$E00, d1
        beq.s   Pal_NoDec               ; loc_0026B4
        subi.w  #$200, (A0)+
        rts
Pal_NoDec: ; loc_0026B4:
        addq.w  #2, A0
        rts 
Pal_MakeWhite: ; loc_0026B8:               ; Special Stage Blank Screen
        move.w  #$03F, ($FFFFF626).w
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        move.w  #$EEE, d1
        move.b  ($FFFFF627).w, d0
loc_0026D2:        
        move.w  d1, (A0)+
        dbra    d0, loc_0026D2
        move.w  #$015, D4
loc_0026DC:        
        move.b  #$12, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr.s   Pal_WhiteToBlack        ; loc_0026F2
        bsr     RunPLC          ; loc_0017A8
        dbra    d4, loc_0026DC
        rts
Pal_WhiteToBlack: ; loc_0026F2:
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        lea     ($FFFFFB80).w, A1
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        adda.w  d0, A1
        move.b  ($FFFFF627).w, d0
loc_002708:               
        bsr.s   Pal_DecColor2           ; loc_002732
        dbra    d0, loc_002708
        tst.b   ($FFFFF730).w
        beq.s   loc_002730
        moveq	#0,d0
        lea     ($FFFFFA80).w, A0
        lea     ($FFFFFA00).w, A1
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        adda.w  d0, A1
        move.b  ($FFFFF627).w, d0
loc_00272A:        
        bsr.s   Pal_DecColor2           ; loc_002732
        dbra    d0, loc_00272A
loc_002730:
        rts
Pal_DecColor2: ; loc_002732:
        move.w  (A1)+, D2
        move.w  (A0), D3
        cmp.w   D2, d3
        beq.s   loc_00275E
        move.w  d3, d1
        subi.w  #$200, d1
        bcs.s   loc_00274A
        cmp.w   D2, d1
        bcs.s   loc_00274A
        move.w  d1, (A0)+
        rts
loc_00274A:
        move.w  d3, d1
        subi.w  #$20, d1
        bcs.s   loc_00275A
        cmp.w   D2, d1
        bcs.s   loc_00275A
        move.w  d1, (A0)+
        rts
loc_00275A:
        subq.w  #$2, (A0)+
        rts
loc_00275E:
        addq.w  #$2, A0
        rts                ; Special Stage Blank Screen End...
Pal_MakeFlash: ; loc_002762:          ; Called by Special Stage Routine   
        move.w  #$03F, ($FFFFF626).w
        move.w  #$015, D4
loc_00276C:        
        move.b  #$12, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr.s   Pal_ToWhite             ; loc_002782
        bsr     RunPLC          ; loc_0017A8
        dbra    d4, loc_00276C
        rts
Pal_ToWhite: ; loc_002782:
        moveq	#0,d0
        lea     ($FFFFFB00).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        move.b  ($FFFFF627).w, d0
loc_002792:        
        bsr.s   Pal_AddColor2           ; loc_0027B0
        dbra    d0, loc_002792
        moveq	#0,d0
        lea     ($FFFFFA80).w, A0
        move.b  ($FFFFF626).w, d0
        adda.w  d0, A0
        move.b  ($FFFFF627).w, d0
loc_0027A8:        
        bsr.s   Pal_AddColor2           ; loc_0027B0
        dbra    d0, loc_0027A8
        rts
Pal_AddColor2: ; loc_0027B0:
        move.w  (A0), D2
        cmpi.w  #$EEE, D2
        beq.s   loc_0027EC
        move.w  D2, d1
        andi.w  #$00E, d1
        cmpi.w  #$00E, d1
        beq.s   loc_0027C8
        addq.w  #$2, (A0)+
        rts
loc_0027C8:
        move.w  D2, d1
        andi.w  #$0E0, d1
        cmpi.w  #$0E0, d1
        beq.s   loc_0027DA
        addi.w  #$20, (A0)+
        rts
loc_0027DA:
        move.w  D2, d1
        andi.w  #$E00, d1
        cmpi.w  #$E00, d1
        beq.s   loc_0027EC
        addi.w  #$200, (A0)+
        rts
loc_0027EC:
        addq.w  #$2, A0
        rts         
PalCycle_Sega: ; loc_0027F0: ; "Sega" Logo rotating Palette
        tst.b   ($FFFFF635).w
        bne.s   loc_002850
        lea     ($FFFFFB20).w, A1
        lea     (Pal_Sega1), A0  ; loc_0028A6 ; Load "Sega" Logo Palette
        moveq   #5, d1
        move.w  ($FFFFF632).w, d0
loc_002806:        
        bpl.s   loc_002810
        addq.w  #$2, A0
        subq.w  #1,d1
        addq.w  #$2, d0
        bra.s   loc_002806
loc_002810:  
        move.w  d0, D2
        andi.w  #$01E, D2
        bne.s   loc_00281A
        addq.w  #$2, d0
loc_00281A:
        cmpi.w  #$060, d0
        bcc.s   loc_002824
        move.w  (A0)+, $00(A1, d0)
loc_002824:
        addq.w  #$2, d0
        dbra    d1, loc_002810
        move.w  ($FFFFF632).w, d0
        addq.w  #$2, d0
        move.w  d0, D2
        andi.w  #$01E, D2
        bne.s   loc_00283A
        addq.w  #$2, d0
loc_00283A:
        cmpi.w  #$064, d0
        blt.s   loc_002848
        move.w  #$401, ($FFFFF634).w
        moveq   #$FFFFFFF4, d0
loc_002848:
        move.w  d0, ($FFFFF632).w
        moveq   #1,d0
        rts          
loc_002850:
        subq.b  #1, ($FFFFF634).w
        bpl.s   loc_0028A2
        move.b  #4, ($FFFFF634).w
        move.w  ($FFFFF632).w, d0
        addi.w  #$00C, d0
        cmpi.w  #$030, d0
        bcs.s   loc_00286E
        moveq	#0,d0
        rts
loc_00286E:
        move.w  d0, ($FFFFF632).w
        lea     (Pal_Sega2), A0 ; loc_0028B2 ; Load "Sega" Logo Palette
        lea     $00(A0, d0), A0
        lea     ($FFFFFB04).w, A1
        move.l  (A0)+, (A1)+
        move.l  (A0)+, (A1)+
        move.w  (A0)+, (a1)
        lea     ($FFFFFB20).w, A1
        moveq	#0,d0
        moveq   #$2C, d1
loc_00288E:        
        move.w  d0, D2
        andi.w  #$01E, D2
        bne.s   loc_002898
        addq.w  #$2, d0
loc_002898:
        move.w  (A0), $00(A1, d0)
        addq.w  #$2, d0
        dbra    d1, loc_00288E
loc_0028A2:
        moveq   #1,d0
        rts
Pal_Sega1: ; loc_0028A6: ; "Sega" Logo Palette              
        dc.w    $0EEE, $0EEA, $0EE4, $0EC0, $0EE4, $0EEA
Pal_Sega2: ; loc_0028B2: ; "Sega" Logo Palette              
        dc.w    $0EEC, $0EEA, $0EEA, $0EEA, $0EEA, $0EEA, $0EEC, $0EEA
        dc.w    $0EE4, $0EC0, $0EC0, $0EC0, $0EEC, $0EEA, $0EE4, $0EC0
        dc.w    $0EA0, $0E60, $0EEA, $0EE4, $0EC0, $0EA0, $0E80, $0E00
PalLoad1: ; loc_0028E2:
        lea     (PalPointers), A1       ; loc_00294E
        lsl.w   #3, d0
        adda.w  d0, A1
        move.l  (A1)+, A2
        move.w  (A1)+, A3
        adda.w  #$080, A3
        move.w  (A1)+, D7
loc_0028F6:
        move.l  (A2)+, (A3)+
        dbra    d7, loc_0028F6
        rts
PalLoad2: ;loc_0028FE:
        lea     (PalPointers), A1       ; loc_00294E
        lsl.w   #3, d0
        adda.w  d0, A1
        move.l  (A1)+, A2
        move.w  (A1)+, A3
        move.w  (A1)+, D7  
loc_00290E:
        move.l  (A2)+, (A3)+
        dbra    d7, loc_00290E
        rts   
PalLoad3_Water: ; loc_002916: ; Load Underwater palette routine
        lea     (PalPointers), A1       ; loc_00294E
        lsl.w   #3, d0
        adda.w  d0, A1
        move.l  (A1)+, A2
        move.w  (A1)+, A3
        suba.w  #$080, A3
        move.w  (A1)+, D7
loc_00292A:
        move.l  (A2)+, (A3)+
        dbra    d7, loc_00292A
        rts
PalLoad4_Water: ;loc_002932:
        lea     (PalPointers), A1       ; loc_00294E
        lsl.w   #3, d0
        adda.w  d0, A1
        move.l  (A1)+, A2
        move.w  (A1)+, A3
        suba.w  #$100, A3
        move.w  (A1)+, D7
loc_002946:
        move.l  (A2)+, (A3)+
        dbra    d7, loc_002946
        rts
PalPointers: ; loc_00294E: ; Palette List        
        dc.l    Pal_SegaBg, $FB00001F ; Sega Logo
        dc.l    Pal_TitleScreen, $FB00001F ; Title Screen
        dc.l    Pal_LevelSelectMenu, $FB00001F ; Level Select Menu
        dc.l    Pal_SonicAndTails, $FB000007 ; Sonic & Tails
        dc.l    Pal_GHz, $FB200017 ; Green Hill
        dc.l    Pal_GHz, $FB200017 ; Level $01 
        dc.l    Pal_Wz, $FB200017 ; Wood
        dc.l    Pal_GHz, $FB200017 ; Level $03
        dc.l    Pal_Mz, $FB200017 ; Metropolis
        dc.l    Pal_Mz, $FB200017 ; Metropolis
        dc.l    Pal_CNz2, $FB200017 ; Level $06 / Casino Night Act 2
        dc.l    Pal_HTz, $FB200017 ; Hill Top
        dc.l    Pal_HPz, $FB200017 ; Hidden Palace
        dc.l    Pal_GHz, $FB200017 ; Level $09
        dc.l    Pal_OOz, $FB200017 ; Oil Ocean
        dc.l    Pal_DHz, $FB200017 ; Dust Hill
        dc.l    Pal_CNz1, $FB200017 ; Casino Night
        dc.l    Pal_CPz, $FB200017 ; Chemical Plant
        dc.l    Pal_GHz, $FB200017 ; Genocide City
        dc.l    Pal_NGHz, $FB200017 ; Neo Green Hill
        dc.l    Pal_GHz, $FB200017 ; Death Egg
        dc.l    Pal_HPzWater, $FB00001F ; Hidden Palace Underwater 
        dc.l    Pal_CPzWater, $FB00001F ; Chemical Plant Underwater  
        dc.l    Pal_NGHzWater, $FB00001F ; Neo Green Hill Underwater
        dc.l    Pal_SpecialStage, $FB00001F
Pal_SegaBg: ; loc_002A16: ; Sega Logo
        incbin palettes/SegaBg.bin
Pal_TitleScreen: ; loc_002A96: ; Title Screen
        incbin palettes/TitleScreen.bin
Pal_LevelSelectMenu: ; loc_002B16: ; Level Select Menu
        incbin palettes/LevelSelectMenu.bin
Pal_SonicAndTails: ; loc_002B96: ; Sonic & Tails
        incbin palettes/Sonic.bin
Pal_Ghz: ; loc_002BB6: ; Green Hill
        incbin palettes/ghz.bin    
Pal_Wz: ; loc_002C16: ; Wood              
        incbin palettes/wz.bin          
Pal_Mz: ; loc_002C76: ; Metropolis
        incbin palettes/Mz.bin
Pal_HTz: ; loc_002CD6: ; Hill Top
        incbin palettes/HTZ.bin
Pal_HPz: ; loc_002D36: ; Hidden Palace
        incbin palettes/HPZ.bin
Pal_HPzWater: ; loc_002D96: ; Hidden Palace Underwater   
        incbin palettes/HPZWater.bin
Pal_OOz: ; loc_002E16: ; Oil Ocean
        incbin palettes/OOZ.bin
Pal_DHz: ;loc_002E76: ; Dust Hill
        incbin palettes/DHZ.bin
Pal_CNz1: ; loc_002ED6: ; Casino Night
        incbin palettes/CNZ1.bin
Pal_CNz2: ; loc_002F36: ; Level $06 / Casino Night Act 2
        incbin palettes/CNZ2.bin
Pal_CPz: ; loc_002F96: ; Chemical Plant
        incbin palettes/CPZ.bin
Pal_CPzWater: ; loc_002FF6: ; Chemical Plant Underwater  
        incbin palettes/CPZWater.bin
Pal_NGHz: ;loc_003076: ; Neo Green Hill
        incbin palettes/NGHZ.bin
Pal_NGHzWater: ; loc_0030D6: ; Neo Green Hill Underwater
        incbin palettes/NGHZWater.bin
Pal_SpecialStage: ; loc_003156:              
        incbin palettes/SpecialStage.bin
        nop    
DelayProgram: ; loc_0031D8: 
        move.w  #$2300, SR
loc_0031DC:         
        tst.b   (Delay_Time).w
        bne.s   loc_0031DC
        rts
PseudoRandomNumber: ; loc_0031E4:
        move.l  (RNG_seed).w, d1 
        bne.s   loc_0031F0
        move.l  #$2A6D365A, d1
loc_0031F0:        
        move.l  d1, d0
        asl.l   #$2, d1
        add.l   d0, d1
        asl.l   #3, d1
        add.l   d0, d1        
        move.w  d1, d0
        swap.w  d1
        add.w   d1, d0
        move.w  d0, d1
        swap.w  d1
        move.l  d1, (RNG_seed).w
        rts
CalcSine: ; loc_00320A:        
        andi.w  #$0FF, d0
        add.w   d0, d0
        addi.w  #$080, d0
        move.w  Sine_Data(pc,d0), d1   ; loc_003222
        subi.w  #$080, d0 
        move.w  Sine_Data(pc,d0), D0   ; loc_003222
        rts
Sine_Data: ; loc_003222:         
        incbin _inc/sine.bin
CalcAngle: ; loc_0034A2:        
        movem.l D3-d4, -(A7)
        moveq   #0, d3
        moveq   #0, D4
        move.w  d1, d3
        move.w  D2, D4
        or.w    d3, D4
        beq.s   loc_0034FE
        move.w  D2, D4
        tst.w   D3
        bpl     loc_0034BC
        neg.w   D3 
loc_0034BC:        
        tst.w   D4
        bpl     loc_0034C4
        neg.w   D4 
loc_0034C4:        
        cmp.w   d3, D4
        bcc     loc_0034D6
        lsl.l   #8, D4
        divu.w  d3, D4
        moveq	#0,d0
        move.b  AngleData(PC, D4), D0   ; loc_003508
        bra.s   loc_0034E0
loc_0034D6:
        lsl.l   #8, d3
        divu.w  d4, d3
        moveq   #$40, d0
        sub.b   AngleData(PC, d3), D0   ; loc_003508
loc_0034E0: 
        tst.w   d1
        bpl     loc_0034EC
        neg.w   D0
        addi.w  #$080, d0
loc_0034EC:   
        tst.w   D2
        bpl     loc_0034F8
        neg.w   D0
        addi.w  #$100, d0
loc_0034F8:   
        movem.l (A7)+, D3-D4
        rts              
loc_0034FE:  
        move.w  #$40, d0
        movem.l (A7)+, D3-D4
        rts
AngleData: ; loc_003508:  
        incbin _inc/AngleData.bin
		nop 
;===============================================================================
; Sega Logo              
;===============================================================================         
SegaScreen: ; loc_00360C: ; SEGA Logo
        move.b  #$FD, d0
        bsr     Play_Music              ; loc_0014C0
        bsr     ClearPLC        ; loc_00179A
        bsr     Pal_FadeFrom            ; loc_00263A 
        lea     ($00C00004), a6
        move.w  #$8004, (a6)
        move.w  #$8230, (a6)
        move.w  #$8407, (a6)
        move.w  #$8700, (a6)
        move.w  #$8B00, (a6)
        move.w  #$8C81, (a6)
        clr.b   (Water_move).w
        move    #$2700, SR
        move.w  (VDP_Reg0_Val).w, d0
        andi.b  #$BF, d0
        move.w  d0, ($00C00004)
        bsr     ClearScreen             ; loc_001418
        move.l  #$40000000, ($00C00004)
        lea     (SegaLogo), A0          ; Load Sega Sprites ; loc_070960  
        bsr     NemesisDec              ; loc_0015FC
        lea     ($FFFF0000), A1
        lea     (SegaLogo_Mappings), A0 ; Load Sega Mappings ; loc_070DD0
        move.w  #0, d0
        bsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.l  #$65100003, d0
        moveq   #$17, d1
        moveq   #$7, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        lea     ($FFFF0180), A1
        move.l  #$40000003, d0
        moveq   #$27, d1
        moveq   #$1B, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        tst.b   (Graphics_Flags).w
        bmi.s   loc_0036BE
        lea     ($FFFF0A40), A1
        move.l  #$453A0003, d0
        moveq   #$2, d1
        moveq   #1, D2
        bsr     ShowVDPGraphics         ; loc_00154C
loc_0036BE:
        moveq	#0,d0
        bsr     PalLoad2        ; loc_0028FE
        move.w  #$FFF6, ($FFFFF632).w
        move.w  #0, ($FFFFF634).w
        move.w  #0, ($FFFFF662).w
        move.w  #0, ($FFFFF660).w
        move.w  #$0B4, (Demo_Time_left).w
        move.w  (VDP_Reg0_Val).w, d0
        ori.b   #$40, d0
        move.w  d0, ($00C00004)
Sega_WaitPalette: ; loc_0036F0:           
        move.b  #$2, (Delay_Time).w               
        bsr     DelayProgram            ; loc_0031D8
        bsr     PalCycle_Sega           ; loc_0027F0 ; Load "Sega" rotating palette
        bne.s   Sega_WaitPalette        ; loc_0036F0 
        move.b  #$FA, d0        ; Load "Sega" sound
        bsr     Play_Sfx        ; loc_0014C6
        move.b  #$2, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        move.w  #$0B4, (Demo_Time_left).w
Sega_WaitEnd: ; loc_003718:        
        move.b  #$14, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        tst.w   (Demo_Time_left).w
        beq.s   Sega_GoToTitleScreen    ; loc_003730
        andi.b  #$80, (Ctrl_1_Press).w
        beq.s   Sega_WaitEnd            ; loc_003718   
Sega_GoToTitleScreen: ; loc_003730:        
        move.b  #4, (Game_Mode).w
        rts
;===============================================================================
; Sega Logo            
;=============================================================================== 
;===============================================================================
; Title Screen            
;===============================================================================           
TitleScreen: ; loc_003738: ; Game Intro / Title Screen
        move.b  #$FD, d0   
        bsr     Play_Music              ; loc_0014C0
        bsr     ClearPLC        ; loc_00179A
        bsr     Pal_FadeFrom            ; loc_00263A  
        move    #$2700, SR
        lea     ($00C00004), a6 
        move.w  #$8004, (a6)
        move.w  #$8230, (a6)
        move.w  #$8407, (a6)
        move.w  #$9001, (a6)
        move.w  #$9200, (a6)
        move.w  #$8B03, (a6)
        move.w  #$8720, (a6)         
        clr.b   (Water_move).w
        move.w  #$8C81, (a6)
        bsr     ClearScreen             ; loc_001418 
        lea     (Sprite_Table_Input).w, A1
        moveq	#0,d0
        move.w  #$0FF, d1
loc_003784:        
        move.l  d0, (A1)+
        dbra    d1, loc_003784
        lea     (MainCharacter).w, A1
        moveq	#0,d0
        move.w  #$7FF, d1
loc_003794:        
        move.l  d0, (A1)+
        dbra    d1, loc_003794
        lea     ($FFFFF700).w, A1
        moveq	#0,d0
        move.w  #$03F, d1
loc_0037A4:        
        move.l  d0, (A1)+
        dbra    d1, loc_0037A4
        lea     ($FFFFEE00).w, A1
        moveq	#0,d0
        move.w  #$03F, d1
loc_0037B4:        
        move.l  d0, (A1)+
        dbra    d1, loc_0037B4
        lea     ($FFFFFB80).w, A1
        moveq	#0,d0
        move.w  #$01F, d1
loc_0037C4:        
        move.l  d0, (A1)+
        dbra    d1, loc_0037C4
        moveq   #3, d0        ; Load Sonic Palette "Sonic Team Presents" Left Over
        bsr     PalLoad1        ; loc_0028E2
        bsr     Pal_FadeTo              ; loc_002596
        move    #$2700, SR
        move.l  #$40000000, ($00C00004)
        lea     (Title_Screen_Bg_Wings), A0 ; loc_071520 ; Load Title Screen wings and background
        bsr     NemesisDec              ; loc_0015FC
        move.l  #$40000001, ($00C00004)
        lea     (Title_Screen_Sonic_Tails), A0 ; loc_072E82 ; Load Sonic and Tails in Title Screen
        bsr     NemesisDec              ; loc_0015FC
        lea     ($00C00000), a6
        move.l  #$50000003, mappings(a6)
        lea     (Art_Menu_Text), a5     ; loc_0005E8
        move.w  #$28F, d1
loc_003818:
        move.w  (a5)+, (a6)
        dbra    d1, loc_003818
        nop
        move.b  #0, (Last_star_pole_hit).w
        move.w  #0, (Debug_placement_mode).w
        move.w  #0, ($FFFFFFF0).w
        move.w  #0, ($FFFFFFDA).w
        move.w  #$F00, (Current_ZoneAndAct).w
        move.w  #0, ($FFFFF634).w
        bsr     Pal_FadeFrom            ; loc_00263A 
        move    #$2700, SR
        lea     ($FFFF0000), A1
        lea     (TS_Wings_Sonic_Mappings), A0 ; loc_070ECC Load Wings, Sonic 2, (c) Sega 1992 mappings
        move.w  #0, d0
        bsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.l  #$40000003, d0
        moveq   #$27, d1
        moveq   #$1B, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        lea     ($FFFF0000), A1
        lea     (Title_Screen_Bg_Mappings), A0 ; loc_071024 Load Title Screen Background mappings
        move.w  #0, d0
        bsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.l  #$60000003, d0
        moveq   #$1F, d1
        moveq   #$1B, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        lea     ($FFFF0000), A1
        lea     (Title_Screen_R_Bg_Mappings), A0 ; loc_0712D8 Load Title Screen Background mappings (Right Side) 
        move.w  #0, d0
        bsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.l  #$60400003, d0
        moveq   #$1F, d1
        moveq   #$1B, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        moveq   #1,d0        ; Load Title Screen Palette
        bsr     PalLoad1        ; loc_0028E2      
        move.b  #$99, d0        ; Load Title Screen Music
        bsr     Play_Music              ; loc_0014C0
        move.b  #0, ($FFFFFFFA).w
        move.w  #0, (Two_player_mode).w
        move.w  #$178, (Demo_Time_left).w
        lea     ($FFFFB080).w, A1
        moveq	#0,d0
        move.w  #$F, d1
loc_0038EE:        
        move.l  d0, (A1)+
        dbra    d1, loc_0038EE   
        
        move.b  #$E, (Sidekick).w
        move.b  #$E, ($FFFFB080).w
        move.b  #1, ($FFFFB09A).w
        jsr     (Load_Objects)          ; loc_00CFD0
        jsr     (Build_Sprites)         ; loc_00D4DA
        moveq	#0,d0
        bsr     LoadPLC2        ; loc_00176E
        move.w  #0, ($FFFFFFD4).w
        move.w  #0, ($FFFFFFD6).w
        move.b  #1, ($FFFFFFD0).w
        move.w  #$004, ($FFFFEED2).w
        move.w  #0, ($FFFFE500).w
        move.w  (VDP_Reg0_Val).w, d0
        ori.b   #$40, d0
        move.w  d0, ($00C00004)
        bsr     Pal_FadeTo              ; loc_002596
TitleScreen_Loop: ; loc_003948:        
        move.b  #4, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        jsr     (Load_Objects)          ; loc_00CFD0
        bsr     loc_005E38         ; Load Title Screen Background Scroll 
        jsr     (Build_Sprites)         ; loc_00D4DA
        bsr     RunPLC          ; loc_0017A8
        tst.b   (Graphics_Flags).w
        bpl.s   Code_Sequence_J         ; loc_003974
        lea     (Level_Select_Code_J), A0 ; loc_003B5A
        bra.s   Level_Select_Cheat_Test ; loc_00397A
Code_Sequence_J: ; loc_003974:
        lea     (Level_Select_Code_US), A0 ; loc_003B52
Level_Select_Cheat_Test: ;loc_00397A:        
        move.w  ($FFFFFFD4).w, d0
        adda.w  d0, A0
        move.b  (Ctrl_1_Press).w, d0
        andi.b  #$F, d0
        cmp.b   (A0), D0
        bne.s   Title_Cheat_NoMatch     ; loc_0039C0
        addq.w  #1, ($FFFFFFD4).w
        tst.b   D0
        bne.s   Title_Cheat_CountC      ; loc_0039D2
        lea     ($FFFFFFD0).w, A0
        move.w  ($FFFFFFD6).w, d1
        lsr.w   #1, d1
        andi.w  #$003, d1
        beq.s   Title_Cheat_PlayRing    ; loc_0039B0
        tst.b   (Graphics_Flags).w
        bpl.s   Title_Cheat_PlayRing    ; loc_0039B0
        moveq   #1,d1
        move.b  d1, $01(A0, d1)           
Title_Cheat_PlayRing: ; loc_0039B0:
        move.b  #1, $00(A0, d1)
        move.b  #$B5, d0
        bsr     Play_Sfx        ; loc_0014C6
        bra.s   Title_Cheat_CountC      ; loc_0039D2
Title_Cheat_NoMatch: ; loc_0039C0:        
        tst.b   D0
        beq.s   Title_Cheat_CountC      ; loc_0039D2
        cmpi.w  #$009, ($FFFFFFD4).w
        beq.s   Title_Cheat_CountC      ; loc_0039D2
        move.w  #0, ($FFFFFFD4).w
Title_Cheat_CountC: ; loc_0039D2:
        move.b  (Ctrl_1_Press).w, d0
        andi.b  #$20, d0
        beq.s   Title_Cheat_NoC         ; loc_0039E0
        addq.w  #1, ($FFFFFFD6).w
Title_Cheat_NoC: ; loc_0039E0:
        tst.w   (Demo_Time_left).w
        beq     Demo_Mode               ; loc_003B62
        andi.b  #$80, (Ctrl_1_Press).w
        beq     TitleScreen_Loop        ; loc_003948
loc_0039F2:        
        tst.b   ($FFFFFFD0).w
        beq     PlayLevel               ; loc_003B12
        btst    #6, ($FFFFF604).w
        beq     PlayLevel               ; loc_003B12
        move.b  #$8A, d0        ; Load Level Select Menu Music
        bsr     Play_Music              ; loc_0014C0
        moveq   #$2, d0
        bsr     PalLoad2        ; loc_0028FE
        lea     ($FFFFE000).w, A1
        moveq	#0,d0
        move.w  #$0DF, d1
LevelSelect_ClearScroll: ; loc_003A1C:        
        move.l  d0, (A1)+
        dbra    d1, LevelSelect_ClearScroll ; loc_003A1C 
        move.l  d0, (Vscroll_Factor).w
        move    #$2700, SR
        lea     ($00C00000), a6
        move.l  #$60000003, ($00C00004)
        move.w  #$3FF, d1
LevelSelect_ClearVRAM: ; loc_003A3E:        
        move.l  d0, (a6) 
        dbra    d1, LevelSelect_ClearVRAM ; loc_003A3E
        bsr     LevelSelect_TextLoad ; loc_003CC4
LevelSelect_Loop: ; loc_003A48:        
        move.b  #4, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr     LevelSelect_Controls    ; loc_003C2E
        bsr     RunPLC          ; loc_0017A8
        tst.l   ($FFFFF680).w
        bne.s   LevelSelect_Loop        ; loc_003A48   
        andi.b  #$F0, (Ctrl_1_Press).w
        beq.s   LevelSelect_Loop        ; loc_003A48
        move.w  #0, (Two_player_mode).w
        btst    #4, ($FFFFF604).w
        beq.s   loc_003A7C
        move.w  #$001, (Two_player_mode).w
loc_003A7C:
        move.w  ($FFFFFF82).w, d0
        cmpi.w  #$01A, d0
        bne.s   loc_003A9C
        btst    #6, (Ctrl_1_Press).w
        bne.s   LevelSelect_Loop        ; loc_003A48
        move.w  ($FFFFFF84).w, d0
        addi.w  #$080, d0
        bsr     Play_Sfx        ; loc_0014C6
        bra.s   LevelSelect_Loop        ; loc_003A48
loc_003A9C:
        add.w   d0, d0               
        move.w  Level_Select_Array(pc,d0), D0 ; loc_003AD4 Load Level Select Array
        bmi     LevelSelect_Loop        ; loc_003A48
        cmpi.w  #$8000, d0
        bne.s   Level_Select_Level      ; loc_003B0A
        move.b  #$10, (Game_Mode).w
        clr.w   (Current_Zone).w
        move.b  #3, ($FFFFFE12).w
        moveq	#0,d0
        move.w  d0, (Ring_count).w
        move.l  d0, ($FFFFFE22).w
        move.l  d0, (Score).w
        move.l  #$0001388, ($FFFFFFC0).w
        rts
Level_Select_Array: ; loc_003AD4: ; Level Select Array
        dc.w    $0000, $0001         ; GHz
        dc.w    $0200, $0201         ; Wz
        dc.w    $0400, $0401, $0500  ; Mz
        dc.w    $0700, $0701         ; HTz
        dc.w    $0800, $0801         ; HPz
        dc.w    $0A00, $0A01         ; OOz
        dc.w    $0B00, $0B01         ; DHz
        dc.w    $0C00, $0C01         ; CNz
        dc.w    $0D00, $0D01         ; CPz
        dc.w    $0E00, $0E01         ; GCz
        dc.w    $0F00, $0F01         ; NGHz
        dc.w    $1000, $1001         ; Dez
        dc.w    $8000        ; SS 
        dc.w    $0000        ; Sound Test
Level_Select_Level: ; loc_003B0A:
        andi.w  #$3FFF, d0
        move.w  d0, (Current_ZoneAndAct).w
PlayLevel: ; loc_003B12:        
        move.b  #$C, (Game_Mode).w
        move.b  #3, ($FFFFFE12).w
        moveq	#0,d0
        move.w  d0, (Ring_count).w
        move.l  d0, ($FFFFFE22).w
        move.l  d0, (Score).w
        move.b  d0, ($FFFFFE16).w
        move.b  d0, ($FFFFFE57).w
        move.l  d0, ($FFFFFE58).w
        move.l  d0, ($FFFFFE5C).w
        move.b  d0, ($FFFFFE18).w
        move.l  #$0001388, ($FFFFFFC0).w
        move.b  #$E0, d0
        bsr     Play_Sfx        ; loc_0014C6
        rts  
Level_Select_Code_US: ; loc_003B52:
        dc.b    $01, $02, $02, $02, $02, $01, $00, $FF  ; Code sequence  
Level_Select_Code_J:  ; loc_003B5A:
        dc.b    $01, $02, $02, $02, $02, $01, $00, $FF  ; Code sequence      
Demo_Mode: ; loc_003B62:
        move.w  #$01E, (Demo_Time_left).w
loc_003B68:        
        move.b  #4, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr     RunPLC          ; loc_0017A8
        move.w  (MainCharacter+x_pos).w, d0
        addq.w  #2, d0
        move.w  d0, (MainCharacter+x_pos).w
        cmpi.w  #$1C00, d0
        bcs.s   Run_Demo_Mode           ; loc_003B8E
        move.b  #0, (Game_Mode).w
        rts
Run_Demo_Mode: ; loc_003B8E:
        andi.b  #$80, (Ctrl_1_Press).w 
        bne     loc_0039F2
        tst.w   (Demo_Time_left).w
        bne     loc_003B68
        move.b  #$E0, d0
        bsr     Play_Sfx        ; loc_0014C6
        move.w  ($FFFFFFF2).w, d0
        andi.w  #$007, d0
        add.w   d0, d0
        move.w  Demo_Mode_Level_Array(pc,d0), D0 ; loc_003C16 Load Demo sequence array
        move.w  d0, (Current_ZoneAndAct).w
        addq.w  #1, ($FFFFFFF2).w
        cmpi.w  #$004, ($FFFFFFF2).w
        bcs.s   loc_003BCC
        move.w  #0, ($FFFFFFF2).w
loc_003BCC:
        move.w  #$001, ($FFFFFFF0).w
        move.b  #8, (Game_Mode).w
        cmpi.w  #0, d0
        bne.s   loc_003BE4
        move.w  #$001, (Two_player_mode).w
loc_003BE4:
        cmpi.w  #$600, d0
        bne.s   loc_003BF8
        move.b  #$10, (Game_Mode).w
        clr.w   (Current_Zone).w
        clr.b   ($FFFFFE16).w
loc_003BF8:
        move.b  #3, ($FFFFFE12).w
        moveq	#0,d0
        move.w  d0, (Ring_count).w
        move.l  d0, ($FFFFFE22).w
        move.l  d0, (Score).w
        move.l  #$0001388, ($FFFFFFC0).w
        rts
Demo_Mode_Level_Array: ; loc_003C16: ; Demo sequence array
        dc.w    $0D00, $0000, $0800, $0700, $0500, $0500, $0500, $0500
        dc.w    $0400, $0400, $0400, $0400
LevelSelect_Controls: ; loc_003C2E:
        move.b  (Ctrl_1_Press).w, d1
        andi.b  #3, d1
        bne.s   loc_003C3E
        subq.w  #1, ($FFFFFF80).w
        bpl.s   loc_003C78
loc_003C3E:
        move.w  #$00B, ($FFFFFF80).w
        move.b  ($FFFFF604).w, d1
        andi.b  #3, d1
        beq.s   loc_003C78
        move.w  ($FFFFFF82).w, d0
        btst    #0,d1
        beq.s   loc_003C5E
        subq.w  #1,d0
        bcc.s   loc_003C5E
        moveq   #$1A, d0
loc_003C5E:
        btst    #1,d1
        beq.s   loc_003C6E
        addq.w  #1,d0
        cmpi.w  #$01B, d0
        bcs.s   loc_003C6E
        moveq	#0,d0
loc_003C6E:
        move.w  d0, ($FFFFFF82).w
        bsr     LevelSelect_TextLoad    ; loc_003CC4
        rts
loc_003C78:
        cmpi.w  #$01A, ($FFFFFF82).w
        bne.s   loc_003CC2
        move.w  ($FFFFFF84).w, d0
        move.b  (Ctrl_1_Press).w, d1
        andi.b  #$C, d1
        beq.s   loc_003CAA
        btst    #$2, d1
        beq.s   loc_003C9A
        subq.b  #1,d0
        bcc.s   loc_003C9A
        moveq   #$7F, d0
loc_003C9A:
        btst    #3, d1
        beq.s   loc_003CAA
        addq.b  #1,d0
        cmpi.w  #$080, d0
        bcs.s   loc_003CAA
        moveq	#0,d0
loc_003CAA:
        btst    #6, (Ctrl_1_Press).w
        beq.s   loc_003CBA
        addi.b  #$10, d0
        andi.b  #$7F, d0
loc_003CBA:
        move.w  d0, ($FFFFFF84).w
        bsr     LevelSelect_TextLoad    ; loc_003CC4
loc_003CC2:        
        rts
LevelSelect_TextLoad: ;loc_003CC4:
        lea     (Level_Select_Text), A1 ; loc_003D7C Load Level Select Menu - Text
        lea     ($00C00000), a6
        move.l  #$608C0003, D4
        move.w  #$8680, d3
        moveq   #$1A, d1
loc_003CDC:        
        move.l  d4, mappings(a6)
        bsr     loc_003D60
        addi.l  #$0800000, D4
        dbra    d1, loc_003CDC 
        moveq	#0,d0
        move.w  ($FFFFFF82).w, d0
        move.w  d0, d1
        move.l  #$608C0003, D4
        lsl.w   #$7, d0
        swap.w  D0
        add.l   d0, D4
        lea     (Level_Select_Text), A1 ; loc_003D7C Load Level Select Menu - Text
        mulu.w  #$01B, d1
        adda.w  d1, A1
        move.w  #$C680, d3
        move.l  d4, mappings(a6)
        bsr     loc_003D60
        move.w  #$8680, d3
        cmpi.w  #$01A, ($FFFFFF82).w
        bne.s   loc_003D2A
        move.w  #$C680, d3
loc_003D2A:
        move.l  #$6DB00003, ($00C00004)
        move.w  ($FFFFFF84).w, d0
        addi.w  #$080, d0
        move.b  d0, D2
        lsr.b   #4, d0
        bsr     loc_003D4C
        move.b  d2, d0
        bsr     loc_003D4C
        rts
loc_003D4C:
        andi.w  #$F, d0
        cmpi.b  #$A, d0
        bcs.s   loc_003D5A
        addi.b  #$7, d0
loc_003D5A:
        add.w   d3, d0
        move.w  d0, (a6)
        rts
loc_003D60:
        moveq   #$1A, D2
loc_003D62:        
        moveq	#0,d0
        move.b  (A1)+, D0
        bpl.s   loc_003D72
        move.w  #0, (a6)
        dbra    D2, loc_003D62 
        rts
loc_003D72:
        add.w   d3, d0
        move.w  d0, (a6)
        dbra    D2, loc_003D62
        rts

_0 = $00
_1 = $01
_2 = $02        
_A = $11
_B = $12
_C = $13
_D = $14        
_E = $15
_F = $16
_G = $17
_H = $18
_I = $19
_J = $1A
_K = $1B
_L = $1C
_M = $1D
_N = $1E
_O = $1F
_P = $20
_Q = $21
_R = $22
_S = $23
_T = $24
_U = $25
_V = $26
_W = $27
_X = $28
_Y = $0F
_Z = $10
__ = $FF        
Level_Select_Text: ; loc_003D7C: ; Level Select Menu Text         
        dc.b    _G,_R,_E,_E,_N,__,_H,_I,_L,_L,__,_Z,_O,_N,_E,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1  
        dc.b    _W,_O,_O,_D,__,_Z,_O,_N,_E,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1 
        dc.b    _M,_E,_T,_R,_O,_P,_O,_L,_I,_S,__,_Z,_O,_N,_E,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_2     
        dc.b    _H,_I,_L,_L,__,_T,_O,_P,__,_Z,_O,_N,_E,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1
        dc.b    _H,_I,_D,_D,_E,_N,__,_P,_A,_L,_A,_C,_E,__,_Z,_O,_N,_E,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1
        dc.b    _O,_I,_L,__,_O,_C,_E,_A,_N,__,_Z,_O,_N,_E,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1 
        dc.b    _D,_U,_S,_T,__,_H,_I,_L,_L,__,_Z,_O,_N,_E,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1          
        dc.b    _C,_A,_S,_I,_N,_O,__,_N,_I,_G,_H,_T,__,_Z,_O,_N,_E,__,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1 
        dc.b    _C,_H,_E,_M,_I,_C,_A,_L,__,_P,_L,_A,_N,_T,__,_Z,_O,_N,_E,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1 
        dc.b    _G,_E,_N,_O,_C,_I,_D,_E,__,_C,_I,_T,_Y,__,_Z,_O,_N,_E,__,__,_S,_T,_A,_G,_E,__,_0 
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1 
        dc.b    _N,_E,_O,__,_G,_R,_E,_E,_N,__,_H,_I,_L,_L,__,_Z,_O,_N,_E,__,_S,_T,_A,_G,_E,__,_0  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1  
        dc.b    _D,_E,_A,_T,_H,__,_E,_G,_G,__,_Z,_O,_N,_E,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_0  
        dc.b    __,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__,_S,_T,_A,_G,_E,__,_1  
        dc.b    _S,_P,_E,_C,_I,_A,_L,__,_S,_T,_A,_G,_E,__,__,__,__,__,__,__,__,__,__,__,__,__,__
        dc.b    _S,_O,_U,_N,_D,__,_S,_E,_L,_E,_C,_T,__,__,__,__,__,__,__,__,__,__,__,__,__,__,__
        dc.b    $00 ; Filler
Unused_Code1: ; loc_004056:         
        lea     ($FFFF0000), A1
        move.w  #$2EB, D2
Unused_Code1_Loop: ; loc_004060:        
        move.w  (A1), D0
        move.w  d0, d1
        andi.w  #$F800, d1
        andi.w  #$7FF, d0
        lsr.w   #1,d0
        or.w    d0, d1
        move.w  d1, (A1)+
        dbra    D2, Unused_Code1_Loop   ; loc_004060
        rts
Unused_Code2: ; loc_004078:        
        lea     ($00FE0000), A1
        lea     ($00FE0080), A2
        lea     ($FFFF0000), A3
        move.w  #$03F, d1
Unused_Code2_Loop: ; loc_00408E:        
        bsr     Unused_Code4            ; loc_004120
        bsr     Unused_Code4            ; loc_004120
        dbra    d1, Unused_Code2_Loop   ; loc_00408E
        lea     ($00FE0000), A1
        lea     ($00FF0000), A2
        move.w  #$03F, d1
Unused_Code2_Loop2: ; loc_0040AA:        
        move.w  #0, (A2)+
        dbra    d1, Unused_Code2_Loop2  ; loc_0040AA
        move.w  #$3FBF, d1
Unused_Code2_Loop3: ; loc_0040B6:        
        move.w  (A1)+, (A2)+
        dbra    d1, Unused_Code2_Loop3  ; loc_0040B6
        rts
Unused_Code3: ; loc_0040BE:              
        lea     ($00FE0000), A1
        lea     ($FFFF0000), A3
        moveq   #$1F, d0
Unused_Code3_Loop: ; loc_0040CC:        
        move.l  (A1)+, (A3)+
        dbra    d0, Unused_Code3_Loop   ; loc_0040CC
        moveq   #0, D7
        lea     ($00FE0000), A1
        move.w  #$0FF,d5
Unused_Code3_Loop2: ; loc_0040DE:        
        lea     ($FFFF0000), A3
        move.w  d7, D6
Unused_Code3_Loop3: ; loc_0040E6:        
        movem.l A1-A3, -(A7)
        move.w  #$03F, d0
Unused_Code3_Loop4: ; loc_0040EE:        
        cmpm.w  (A1)+, (A3)+
        bne.s   Unused_Code3_loc_004104
        dbra    d0, Unused_Code3_Loop4  ; loc_0040EE
        movem.l (A7)+, A1-A3
        adda.w  #$080, A1
        dbra    d5, Unused_Code3_Loop2  ; loc_0040DE
        bra.s   Unused_Code3_loc_00411E
Unused_Code3_loc_004104:
        movem.l (A7)+, A1-A3
        adda.w  #$080, A3
        dbra    d6, Unused_Code3_Loop3  ; loc_0040E6
        moveq   #$1F, d0
Unused_Code3_Loop5: ; loc_004112:        
        move.l  (A1)+, (A3)+
        dbra    d0, Unused_Code3_Loop5  ; loc_004112
        addq.l  #1, D7
        dbra    d5, Unused_Code3_Loop2  ; loc_0040DE
Unused_Code3_loc_00411E:
        bra.s   Unused_Code3_loc_00411E           
Unused_Code4: ; loc_004120:
        moveq   #$7, d0
Unused_Code4_Loop: ; loc_004122:        
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        dbra    d0, Unused_Code4_Loop   ; loc_004122
        adda.w  #$080, A1
        adda.w  #$080, a2
        rts                        
PlayList: ; loc_004140:               
        dc.b    $82, $82, $83, $90, $83, $83, $93, $96, $86, $8F, $81, $85, $84, $8D, $8D, $87 
Level: ; loc_004150: ; Demo Mode / Normal Game Play
        bset    #$7, (Game_Mode).w
        tst.w   ($FFFFFFF0).w
        bmi.s   Level_Init              ; loc_004164
        move.b  #$F9, d0
        bsr     Play_Sfx        ; loc_0014C6
Level_Init: ; loc_004164:        
        bsr     ClearPLC        ; loc_00179A
        bsr     Pal_FadeFrom            ; loc_00263A 
        tst.w   ($FFFFFFF0).w
        bmi.s   loc_0041C0
        move    #$2700, SR
        move.l  #$70000002, ($00C00004)
        lea     (Title_Cards), A0 ; loc_07EA04  / Load Title Cards sprites
        bsr     NemesisDec              ; loc_0015FC
        bsr     ClearScreen             ; loc_001418
        move    #$2300, SR
        moveq	#0,d0
        move.w  d0, ($FFFFFE04).w
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        add.w   d0, d0
        move.w  d0, d1
        add.w   d0, d0
        add.w   d1, d0
        lea     (TilesMainTable), A2    ; loc_024354
        lea     $00(A2, d0), A2
        moveq	#0,d0
        move.b  (A2), D0
        beq.s   loc_0041BA
        bsr     LoadPLC         ; loc_00173C
loc_0041BA:
        moveq   #1,d0
        bsr     LoadPLC         ; loc_00173C
loc_0041C0:
        lea     (Sprite_Table_Input).w, A1
        moveq	#0,d0
        move.w  #$0FF, d1
loc_0041CA:
        move.l  d0, (A1)+
        dbra    d1, loc_0041CA
        lea     (MainCharacter).w, A1
        moveq	#0,d0
        move.w  #$7FF, d1
loc_0041DA:
        move.l  d0, (A1)+
        dbra    d1, loc_0041DA
        lea     ($FFFFF628).w, A1
        moveq	#0,d0
        move.w  #$015, d1
loc_0041EA:
        move.l  d0, (A1)+
        dbra    d1, loc_0041EA
        lea     ($FFFFF700).w, A1
        moveq	#0,d0
        move.w  #$03F, d1
loc_0041FA:
        move.l  d0, (A1)+
        dbra    d1, loc_0041FA
        lea     ($FFFFFE60).w, A1
        moveq	#0,d0
        move.w  #$047, d1
loc_00420A:
        move.l  d0, (A1)+
        dbra    d1, loc_00420A
        cmpi.w  #$D01, (Current_ZoneAndAct).w  ; If Chemical Plant
        beq.s   Init_Water             ; loc_004228
        cmpi.b  #$F, (Current_ZoneAndAct).w    ; If Neo Green Hill
        beq.s   Init_Water             ; loc_004228
        cmpi.b  #8, (Current_ZoneAndAct).w    ; If Not Hidden Palace
        bne.s   Init_No_Water          ; loc_004234
Init_Water: ; loc_004228:
        move.b  #1, ($FFFFF730).w
        move.w  #0, (Two_player_mode).w  ; If Water Level Clear Two Player Flag
Init_No_Water: ; loc_004234:
        lea     ($00C00004), a6
        move.w  #$8B03, (a6)
        move.w  #$8230, (a6)
        move.w  #$8407, (a6)
        move.w  #$857C, (a6)
        move.w  #$9001, (a6)
        move.w  #$8004, (a6)
        move.w  #$8720, (a6)
        btst    #5, ($FFFFF604).w
        beq.s   loc_004262
        move.w  #$8C89, (a6)
loc_004262:
        move.w  #$8ADF, (Hint_counter_reserve).w
        tst.w   (Two_player_mode).w
        beq.s   loc_00427C
        move.w  #$8A6B, (Hint_counter_reserve).w
        move.w  #$8014, (a6)
        move.w  #$8C87, (a6)
loc_00427C:
        move.w  (Hint_counter_reserve).w, (a6)
        move.l  #$FFFFDC00, ($FFFFDCFC).w
        tst.b   ($FFFFF730).w
        beq.s   LevelInit_NoWater       ; loc_0042C8
        move.w  #$8014, (a6)
        moveq	#0,d0
        move.w  (Current_Zone).w, d0
        subi.w  #$800, d0
        ror.b   #1,d0
        lsr.w   #6, d0
        andi.w  #$FFFFFFFE, d0
        lea     (Water_Height_Array), A1 ; loc_0046B8
        move.w  $00(A1, d0), D0        
        move.w  d0, (Water_Level_1).w
        move.w  d0, (Water_Level_2).w
        move.w  d0, (Water_Level_3).w
        clr.b   (Water_routine).w
        clr.b   (Water_move).w
        move.b  #1, (Water_on).w
LevelInit_NoWater: ; loc_0042C8:
        move.w  #$01E, ($FFFFFE14).w
        moveq   #3, d0
        bsr     PalLoad2        ; loc_0028FE
        tst.b   ($FFFFF730).w
        beq.s   LevelInit_NoUndewaterPalette ; loc_004300
        moveq   #$15, d0        ; Load HPz Underwater Palette
        cmpi.b  #8, (Current_ZoneAndAct).w
        beq.s   LevelInit_UndewaterPalette ; loc_0042F0
        moveq   #$16, d0        ; Load CPz Underwater Palette
        cmpi.b  #$D, (Current_ZoneAndAct).w
        beq.s   LevelInit_UndewaterPalette ; loc_0042F0
        moveq   #$17, d0        ; Load NGHz Underwater Palette
LevelInit_UndewaterPalette: ; loc_0042F0:
        bsr     PalLoad3_Water ; loc_002916 ; Call Underwater palette routine
        tst.b   (Last_star_pole_hit).w
        beq.s   LevelInit_NoUndewaterPalette ; loc_004300
        move.b  ($FFFFFE53).w, (Water_move).w
LevelInit_NoUndewaterPalette: ; loc_004300:
        tst.w   ($FFFFFFF0).w
        bmi.s   loc_00434E
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        lea     PlayList(PC), A1        ; loc_004140
        move.b  $00(A1, d0), D0
        bsr     Play_Music              ; loc_0014C0
        move.b  #$34, ($FFFFB080).w     ; Load Title Cards Object
LevelInit_TitleCard: ; loc_00431E:        
        move.b  #$C, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        jsr     Load_Objects            ; loc_00CFD0
        jsr     Build_Sprites           ; loc_00D4DA
        bsr     RunPLC          ; loc_0017A8
        move.w  ($FFFFB108).w, d0
        cmp.w   ($FFFFB130).w, d0
        bne.s   LevelInit_TitleCard     ; loc_00431E 
        tst.l   ($FFFFF680).w
        bne.s   LevelInit_TitleCard     ; loc_00431E
        jsr     Head_Up_Display_Base    ; loc_023184 Call HUD routine
loc_00434E:
        moveq   #3, d0
        bsr     PalLoad1        ; loc_0028E2
        bsr     Level_Size_Load         ; loc_005904
        bsr     Background_Scroll_Layer ; loc_005D5C
        bset    #$2, ($FFFFEE50).w
        bsr     Main_Level_Load_16_128_Blocks ; loc_00779A
        jsr     Load_16x16_Mappings_For_Dyn_Sprites ; loc_02293A
        bsr     Load_Tiles_From_Start   ; loc_0076BE
        jsr     loc_0135DA
        bsr     Load_Colision_Index     ; loc_004AAA
        bsr     Water_Effects           ; loc_00465A
        move.b  #1, (MainCharacter).w  ; Load Sonic Object
        tst.w   ($FFFFFFF0).w
        bmi.s   Skip_Head_Up_Display ; loc_004390         
        move.b  #$21, ($FFFFB380).w  ; Load HUD Object
Skip_Head_Up_Display: ; loc_004390:        
        move.b  #$2, (Sidekick).w  ; Load Tails Object
        move.w  (MainCharacter+x_pos).w, ($FFFFB048).w
        move.w  ($FFFFB00C).w, ($FFFFB04C).w
        subi.w  #$20, ($FFFFB048).w
        tst.b   ($FFFFFFD2).w
        beq.s   loc_0043BC
        btst    #6, ($FFFFF604).w
        beq.s   loc_0043BC
        move.b  #1, ($FFFFFFFA).w
loc_0043BC:
        move.w  #0, ($FFFFF602).w
        move.w  #0, ($FFFFF604).w
        tst.b   ($FFFFF730).w
        beq.s   loc_0043E6
        move.b  #4, ($FFFFB780).w
        move.w  #$060, ($FFFFB788).w
        move.b  #4, ($FFFFB7C0).w
        move.w  #$120, ($FFFFB7C8).w
loc_0043E6:
        cmpi.b  #$A, (Current_ZoneAndAct).w
        bne.s   loc_0043F4
        move.b  #$7, ($FFFFB780).w
loc_0043F4:
        jsr     Load_Object_Pos         ; loc_00E250
        jsr     Load_Ring_Pos           ; loc_00DE34
        jsr     Load_Objects            ; loc_00CFD0
        jsr     Build_Sprites           ; loc_00D4DA
        bsr     JumpToDynamic_Art_Cues  ; loc_0051F8
        moveq	#0,d0
        tst.b   (Last_star_pole_hit).w
        bne.s   loc_004424
        move.w  d0, (Ring_count).w
        move.l  d0, ($FFFFFE22).w
        move.b  d0, ($FFFFFE1B).w
loc_004424:        
        move.b  d0, ($FFFFFE1A).w
        move.b  d0, ($FFFFFE2C).w
        move.b  d0, ($FFFFFE2D).w
        move.b  d0, ($FFFFFE2E).w
        move.b  d0, ($FFFFFE2F).w
        move.w  d0, (Debug_placement_mode).w
        move.w  d0, ($FFFFFE02).w
        bsr     Oscillate_Num_Init      ; loc_004B64
        move.b  #1, (Update_HUD_Score).w
        move.b  #1, (Update_HUD_rings).w
        move.b  #1, (Update_HUD_timer).w
        move.w  #$004, ($FFFFEED2).w
        move.w  #0, ($FFFFE500).w
        move.w  #0, ($FFFFF790).w
        move.w  #0, ($FFFFF740).w
        lea     (Demo_Index), A1        ; loc_0049F2
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        lsl.w   #$2, d0
        move.l  $00(A1, d0), A1
        tst.w   ($FFFFFFF0).w
        bpl.s   loc_004498
        lea     (Demo_End_Index), A1    ; loc_004A7A
        move.w  ($FFFFFFF4).w, d0
        subq.w  #1,d0
        lsl.w   #$2, d0
        move.l  $00(A1, d0), A1
loc_004498:
        move.b  render_flags(A1), ($FFFFF792).w
        subq.b  #1, ($FFFFF792).w
        lea     (Demo_Tails_Ghz), A1   ; loc_004DF8 Green Hill - Tails Demo control
        move.b  render_flags(A1), ($FFFFF742).w
        subq.b  #1, ($FFFFF742).w
        move.w  #$668, (Demo_Time_left).w
        tst.w   ($FFFFFFF0).w
        bpl.s   loc_0044D2
        move.w  #$21C, (Demo_Time_left).w
        cmpi.w  #$004, ($FFFFFFF4).w
        bne.s   loc_0044D2
        move.w  #$1FE, (Demo_Time_left).w
loc_0044D2:
        tst.b   ($FFFFF730).w
        beq.s   loc_0044F2
        moveq   #$15, d0
        cmpi.b  #8, (Current_ZoneAndAct).w
        beq.s   loc_0044EE
        moveq   #$16, d0
        cmpi.b  #$D, (Current_ZoneAndAct).w
        beq.s   loc_0044EE
        moveq   #$17, d0
loc_0044EE:
        bsr     PalLoad4_Water          ; loc_002932
loc_0044F2:
        move.w  #$003, d1
loc_0044F6:        
        move.b  #8, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        dbra    d1, loc_0044F6 
        move.w  #$202F, ($FFFFF626).w
        bsr     Pal_FadeTo2             ; loc_00259C
        tst.w   ($FFFFFFF0).w
        bmi.s   Level_ClrTitleCard      ; loc_004526
        addq.b  #$2, ($FFFFB0A4).w 
        addq.b  #4, ($FFFFB0E4).w
        addq.b  #4, ($FFFFB124).w
        addq.b  #4, ($FFFFB164).w   
        bra.s   loc_00452E
Level_ClrTitleCard: ; loc_004526:
        moveq   #$2, d0
        jsr     LoadPLC         ; loc_00173C
loc_00452E:        
        bclr    #$7, (Game_Mode).w
Level_Main_Loop: ; loc_004534:        
        bsr     Pause           ; loc_0014D2
        move.b  #8, (Delay_Time).w   
        bsr     DelayProgram            ; loc_0031D8
        addq.w  #1, ($FFFFFE04).w
        bsr     Move_Sonic_In_Demo      ; loc_0048DE
        bsr     Water_Effects           ; loc_00465A
        jsr     Load_Objects            ; loc_00CFD0
        tst.w   ($FFFFFE02).w
        bne     Level           ; loc_004150
        tst.w   (Debug_placement_mode).w
        bne.s   loc_00456A
        cmpi.b  #6, ($FFFFB024).w
        bcc.s   loc_00456E
loc_00456A:
        bsr     Background_Scroll_Layer ; loc_005D5C         
loc_00456E:
        bsr     Change_Water_Surface_Pos ; loc_004630
        jsr     Load_Ring_Pos           ; loc_00DE34
        bsr     JumpToDynamic_Art_Cues  ; loc_0051F8
        bsr     PalCycle_Load           ; loc_001F18
        bsr     RunPLC          ; loc_0017A8
        bsr     Oscillate_Num_Do        ; loc_004BBA
        bsr     Change_Ring_Frame       ; loc_004C52
        bsr     End_Level_Art_Load      ; loc_004CC0
        jsr     Build_Sprites           ; loc_00D4DA
        jsr     Load_Object_Pos         ; loc_00E250
        cmpi.b  #8, (Game_Mode).w
        beq.s   loc_0045B0
        cmpi.b  #$C, (Game_Mode).w
        beq     Level_Main_Loop         ; loc_004534
        rts
loc_0045B0:
        tst.w   ($FFFFFE02).w
        bne.s   loc_0045CE
        tst.w   (Demo_Time_left).w
        beq.s   loc_0045CE
        cmpi.b  #8, (Game_Mode).w
        beq     Level_Main_Loop         ; loc_004534
        move.b  #0, (Game_Mode).w
        rts
loc_0045CE:
        cmpi.b  #8, (Game_Mode).w
        bne.s   loc_0045E8
        move.b  #0, (Game_Mode).w
        tst.w   ($FFFFFFF0).w
        bpl.s   loc_0045E8
        move.b  #$1C, (Game_Mode).w
loc_0045E8:
        move.w  #$03C, (Demo_Time_left).w
        move.w  #$03F, ($FFFFF626).w
        clr.w   ($FFFFF794).w
loc_0045F8:        
        move.b  #8, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr     Move_Sonic_In_Demo      ; loc_0048DE
        jsr     Load_Objects            ; loc_00CFD0
        jsr     Build_Sprites           ; loc_00D4DA
        jsr     Load_Object_Pos         ; loc_00E250
        subq.w  #1, ($FFFFF794).w
        bpl.s   loc_004628
        move.w  #$002, ($FFFFF794).w
        bsr     Pal_FadeOut             ; loc_00265A
loc_004628:
        tst.w   (Demo_Time_left).w
        bne.s   loc_0045F8
        rts           
Change_Water_Surface_Pos: ; loc_004630:
        tst.b   ($FFFFF730).w
        beq.s   loc_004658
        move.w  ($FFFFEE00).w, d1
        btst    #0, ($FFFFFE05).w
        beq.s   loc_004646
        addi.w  #$20, d1
loc_004646:
        move.w  d1, d0
        addi.w  #$060, d0
        move.w  d0, ($FFFFB788).w
        addi.w  #$120, d1
        move.w  d1, ($FFFFB7C8).w
loc_004658:
        rts
Water_Effects: ; loc_00465A:
        tst.b   ($FFFFF730).w
        beq.s   loc_0046B6
        tst.b   ($FFFFEEDC).w
        bne.s   loc_004672
        cmpi.b  #6, ($FFFFB024).w
        bcc.s   loc_004672
        bsr     Dynamic_Water_Height    ; loc_0046D8
loc_004672:
        clr.b   (Water_move).w
        moveq	#0,d0
        cmpi.b  #$F, (Current_ZoneAndAct).w
        beq.s   loc_004686
        move.b  ($FFFFFE60).w, d0
        lsr.w   #1,d0
loc_004686:
        add.w   (Water_Level_2).w, d0
        move.w  d0, (Water_Level_1).w
        move.w  (Water_Level_1).w, d0
        sub.w   ($FFFFEE04).w, d0
        bcc.s   loc_0046A8
        tst.w   D0
        bpl.s   loc_0046A8
        move.b  #$DF, ($FFFFF625).w
        move.b  #1, (Water_move).w
loc_0046A8:
        cmpi.w  #$0DF, d0
        bcs.s   loc_0046B2
        move.w  #$0DF, d0
loc_0046B2:
        move.b  d0, ($FFFFF625).w
loc_0046B6:
        rts
Water_Height_Array: ; loc_0046B8: ; Water Height Array         
        dc.w    $0600, $0600, $0600, $0600, $0600, $0600, $0600, $0600
        dc.w    $0600, $0600, $0600, $0710, $0600, $0600, $0410, $0510
Dynamic_Water_Height: ; loc_0046D8:
        moveq	#0,d0   
        move.w  (Current_Zone).w, d0
        subi.w  #$800, d0
        ror.b   #1,d0
        lsr.w   #6, d0
        andi.w  #$FFFFFFFE, d0
        move.w  Dynamic_Water_Index(pc,d0), D0 ; loc_00470C
        jsr     Dynamic_Water_Index(pc,d0) ; loc_00470C
        moveq   #0,d1
        move.b  (Water_on).w, d1
        move.w  (Water_Level_3).w, d0
        sub.w   (Water_Level_2).w, d0
        beq.s   loc_00470A
        bcc.s   loc_004706
        neg.w   d1
loc_004706:
        add.w   d1, (Water_Level_2).w
loc_00470A:
        rts
Dynamic_Water_Index: ; loc_00470C:      
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index            
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index   
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index            
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_CPz_Water-Dynamic_Water_Index ; $0D - Chemical Plant          
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index             
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index 
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index
        dc.w    Dynamic_Null_Water-Dynamic_Water_Index               
Dynamic_Null_Water: ; loc_00472C:               
        rts
Dynamic_CPz_Water: ; loc_00472E:
        cmpi.w  #$1DE0, ($FFFFEE00).w
        bcs.s   loc_00473C
        move.w  #$510, (Water_Level_3).w
loc_00473C:    
        rts  
S1_LZ_Wind_Tunnels:; loc_00473E: leftover from Sonic 1's LZ                     
        tst.w   (Debug_placement_mode).w
        bne     loc_00481A
        lea     (S1_LZ_Wind_Data), A2   ; loc_004824
        moveq	#0,d0
        move.b  ($FFFFFE11).w, d0
        lsl.w   #3, d0
        adda.w  d0, a2
        moveq   #0,d1
        tst.b   ($FFFFFE11).w
        bne.s   loc_004762
        moveq   #1,d1
        subq.w  #8, a2
loc_004762:
        lea     (MainCharacter).w, A1
loc_004766:        
        move.w  x_pos(A1), D0
        cmp.w   (A2), D0
        bcs     loc_004804
        cmp.w   mappings(A2), D0
        bcc     loc_004804
        move.w  y_pos(A1), D2
        cmp.w   art_tile(A2), D2
        bcs     loc_004804
        cmp.w   $0006(A2), D2
        bcc.s   loc_004804
        move.b  ($FFFFFE0F).w, d0
        andi.b  #$3F, d0
        bne.s   loc_00479E
        move.w  #$0D0, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_00479E:
        tst.b   ($FFFFF7C9).w
        bne     loc_00481A
        cmpi.b  #4, $0024(a1)
        bcc.s   loc_004816
        move.b  #1, ($FFFFF7C7).w
        subi.w  #$080, d0
        cmp.w   (A2), D0
        bcc.s   loc_0047CC
        moveq   #$2, d0
        cmpi.b  #1, ($FFFFFE11).w
        bne.s   loc_0047C8
        neg.w   D0
loc_0047C8:
        add.w   d0, y_pos(a1)
loc_0047CC:
        addi.w  #$004, x_pos(a1)
        move.w  #$400,x_vel(a1)
        move.w  #0, $0012(a1)
        move.b  #$F, $001C(a1)
        bset    #1, status(a1)
        btst    #0, ($FFFFF604).w
        beq.s   loc_0047F6
        subq.w  #1, y_pos(a1)
loc_0047F6:
        btst    #1, ($FFFFF604).w
        beq.s   loc_004802
        addq.w  #1, y_pos(a1)
loc_004802:
        rts
loc_004804:
        addq.w  #8, a2
        dbra    d1, loc_004766
        tst.b   ($FFFFF7C7).w
        beq.s   loc_00481A
        move.b  #0, $001C(a1)
loc_004816:
        clr.b   ($FFFFF7C7).w
loc_00481A:
        rts        
;loc_00481C:
        dc.w    $0A80, $0300, $0C10, $0380
S1_LZ_Wind_Data: ; loc_004824:
        dc.w    $0F80, $0100, $1410, $0180, $0460, $0400, $0710, $0480
        dc.w    $0A20, $0600, $1610, $06E0, $0C80, $0600, $13D0, $0680        
S1_LZ_Water_Slides: ; loc_004844:
        lea     (MainCharacter).w, A1
        btst    #1, status(a1)
        bne.s   loc_004878
        move.w  y_pos(A1), D0
        andi.w  #$700, d0
        move.b  x_pos(A1), d1
        andi.w  #$07F, d1
        add.w   d1, d0
        lea     ($FFFF8000).w, a2
        move.b  $00(A2, d0), D0
        lea     loc_0048DD(PC), A2
        moveq   #6, d1
loc_004870:        
        cmp.b   -(A2), D0
        dbeq    d1, loc_004870
        beq.s   loc_00488A
loc_004878:
        tst.b   ($FFFFF7CA).w
        beq.s   loc_004888
        move.w  #$005, $002E(a1)
        clr.b   ($FFFFF7CA).w
loc_004888:
        rts
loc_00488A:
        cmpi.w  #$003, d1
        bcc.s   loc_004892
        nop
loc_004892:
        bclr    #0, status(a1)
        move.b  loc_0048CE(pc,d1), D0
        move.b  d0, $14(a1)
        bpl.s   loc_0048A8
        bset    #0, status(a1)
loc_0048A8:
        clr.b   $0015(a1)
        move.b  #$1B, $001C(a1)
        move.b  #1, ($FFFFF7CA).w
        move.b  ($FFFFFE0F).w, d0
        andi.b  #$1F, d0
        bne.s   loc_0048CC
        move.w  #$0D0, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_0048CC:
        rts  
loc_0048CE:
        dc.b    $0A, $F5, $0A, $F6, $F5, $F4, $0B, $00, $02, $07, $03, $4C, $4B, $08, $04 
loc_0048DD:
        dc.b    $00                                           
Move_Sonic_In_Demo: ; loc_0048DE:
        tst.w   ($FFFFFFF0).w
        bne.s   Move_Demo_On            ; loc_00495C
        rts
Move_Sonic_Demo_Record: ; unused subroutine for	recording demos        
        lea     ($00FE8000), A1
        move.w  ($FFFFF790).w, d0
        adda.w  d0, A1
        move.b  ($FFFFF604).w, d0
        cmp.b   (A1), D0
        bne.s   loc_004908
        addq.b  #1, render_flags(a1)
        cmpi.b  #$FF, render_flags(a1)
        beq.s   loc_004908
        bra.s   loc_00491C
loc_004908:
        move.b  d0, art_tile(a1)
        move.b  #0, $0003(a1)
        addq.w  #$2, ($FFFFF790).w
        andi.w  #$3FF, ($FFFFF790).w 
loc_00491C:
        cmpi.b  #0, (Current_ZoneAndAct).w
        bne.s   loc_00495A
        lea     ($00FEC000), A1
        move.w  ($FFFFF740).w, d0
        adda.w  d0, A1
        move.b  ($FFFFF606).w, d0
        cmp.b   (A1), D0
        bne.s   loc_004946
        addq.b  #1, render_flags(a1)
        cmpi.b  #$FF, render_flags(a1)
        beq.s   loc_004946
        bra.s   loc_00495A
loc_004946:
        move.b  d0, art_tile(a1)
        move.b  #0, $0003(a1)
        addq.w  #$2, ($FFFFF740).w
        andi.w  #$3FF, ($FFFFF740).w
loc_00495A:
        rts
Move_Demo_On: ; loc_00495C:
        tst.b   ($FFFFF604).w
        bpl.s   loc_00496E
        tst.w   ($FFFFFFF0).w
        bmi.s   loc_00496E
        move.b  #4, (Game_Mode).w
loc_00496E:
        lea     (Demo_Index), A1        ; loc_0049F2
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        cmpi.b  #$10, (Game_Mode).w
        bne.s   loc_004984
        moveq   #6, d0
loc_004984:
        lsl.w   #$2, d0
        move.l  $00(A1, d0), A1
        move.w  ($FFFFF790).w, d0
        adda.w  d0, A1
        move.b  (A1), D0
        lea     ($FFFFF604).w, A0
        move.b  d0, d1
        moveq   #0, D2
        eor.b   d2, d0
        move.b  d1, (A0)+
        and.b   d1, d0
        move.b  d0, (A0)+
        subq.b  #1, ($FFFFF792).w
        bcc.s   loc_0049B2
        move.b  $0003(A1), ($FFFFF792).w
        addq.w  #$2, ($FFFFF790).w
loc_0049B2:
        cmpi.b  #0, (Current_ZoneAndAct).w
        bne.s   loc_0049EA
        lea     (Demo_Tails_Ghz), A1    ; loc_004DF8
        move.w  ($FFFFF740).w, d0
        adda.w  d0, A1
        move.b  (A1), D0
        lea     ($FFFFF606).w, A0
        move.b  d0, d1
        moveq   #0, D2
        eor.b   d2, d0
        move.b  d1, (A0)+
        and.b   d1, d0
        move.b  d0, (A0)+
        subq.b  #1, ($FFFFF742).w
        bcc.s   loc_0049E8
        move.b  $0003(A1), ($FFFFF742).w
        addq.w  #$2, ($FFFFF740).w
loc_0049E8:
        rts
loc_0049EA:
        move.w  #0, ($FFFFF606).w
        rts
Demo_Index: ; loc_0049F2: ; Demo sequence array
        dc.l    Demo_Green_Hill     ; $00 - Green Hill
        dc.l    Demo_Green_Hill     ; $01 
        dc.l    Demo_Green_Hill     ; $02 - Wood
        dc.l    Demo_Green_Hill     ; $03 
        dc.l    Demo_Green_Hill     ; $04 - Metropolis 
        dc.l    Demo_Green_Hill     ; $05 - Metropolis 
        dc.l    Demo_Green_Hill     ; $06
        dc.l    Demo_Hill_Top       ; $07 - Hill Top
        dc.l    Demo_Hidden_Palace  ; $08 - Hidden Palace
        dc.l    Demo_Green_Hill     ; $09
        dc.l    Demo_Green_Hill     ; $0A - Oil Ocean
        dc.l    Demo_Green_Hill     ; $0B - Dust Hill
        dc.l    Demo_Green_Hill     ; $0C - Casino Night
        dc.l    Demo_Chemical_Plant ; $0D - Chemical Plant
        dc.l    Demo_Green_Hill     ; $0E - Genocide City
        dc.l    Demo_Green_Hill     ; $0F - Neo Green Hill
        dc.l    Demo_Green_Hill     ; $10 - Death Egg
;loc_004A36:
        dc.l    $00FE8000, $00FE8000, $00FE8000, $00FE8000
        dc.l    $00FE8000, $00FE8000, $00FE8000, $00FE8000
        dc.l    $00FE8000, $00FE8000, $00FE8000, $00FE8000
        dc.l    $00FE8000, $00FE8000, $00FE8000, $00FE8000
        dc.l    $00FE8000                
Demo_End_Index: ; loc_004A7A:        
        dc.w    $008B, $0837, $0042, $085C, $006A, $085F, $002F, $082C
        dc.w    $0021, $0803, $2830, $0808, $002E, $0815, $000F, $0846
        dc.w    $001A, $08FF, $08CA, $0000, $0000, $0000, $0000, $0000
Load_Colision_Index: ; loc_004AAA:
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        lsl.w   #$2, d0
        move.l  #PNT_Buffer, ($FFFFF796).w
        move.l  Primary_Colision_Index(pc,d0), A1 ; loc_004ADC
        lea     (PNT_Buffer).w, a2
        bsr.s   Load_Colision           ; loc_004ACC
        move.l  Secundary_Colision_Index(pc,d0), A1 ; loc_004B20
        lea     (Primary_Collision).w, a2
Load_Colision: ; loc_004ACC:
        move.w  #$2FF, d1
        moveq   #0, D2
Load_Colision_Loop: ; loc_004AD2:
        move.b  (A1)+, D2
        move.w  D2, (A2)+
        dbra    d1, Load_Colision_Loop    ; loc_004AD2
        rts  
Primary_Colision_Index: ; loc_004ADC: 
        dc.l    Green_Hill_Colision_1     ; loc_02F2EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Wood_Colision             ; loc_02F8EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Metropolis_Colision       ; loc_02FBEA
        dc.l    Metropolis_Colision       ; loc_02FBEA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Green_Hill_Colision_1     ; loc_02F2EA
        dc.l    Hidden_Palace_Colision_1  ; loc_02FEEA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Oil_Ocean_Colision        ; loc_0304EA
        dc.l    Dust_Hill_Colision        ; loc_0307EA
        dc.l    Casino_Night_Colision_1   ; loc_030AEA
        dc.l    Chemical_Plant_Colision_1 ; loc_0310EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Neo_Green_Hill_Colision_1 ; loc_0316EA
        dc.l    Special_Stage_1           ; loc_031CEA 
Secundary_Colision_Index: ; loc_004B20:        
        dc.l    Green_Hill_Colision_2     ; loc_02F5EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Wood_Colision             ; loc_02F8EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Metropolis_Colision       ; loc_02FBEA
        dc.l    Metropolis_Colision       ; loc_02FBEA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Green_Hill_Colision_2     ; loc_02F5EA
        dc.l    Hidden_Palace_Colision_2  ; loc_0301EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Oil_Ocean_Colision        ; loc_0304EA
        dc.l    Dust_Hill_Colision        ; loc_0307EA
        dc.l    Casino_Night_Colision_2   ; loc_030DEA
        dc.l    Chemical_Plant_Colision_2 ; loc_0313EA
        dc.l    Special_Stage_1           ; loc_031CEA
        dc.l    Neo_Green_Hill_Colision_2 ; loc_0319EA
        dc.l    Special_Stage_1           ; loc_031CEA          
Oscillate_Num_Init: ; loc_004B64:
        lea     ($FFFFFE5E).w, A1
        lea     (Oscillate_Data), A2    ; loc_004B78
        moveq   #$20, d1
loc_004B70:
        move.w  (A2)+, (A1)+
        dbra    d1, loc_004B70
        rts
Oscillate_Data: ; loc_004B78:
        dc.w    $007D, $0080, $0000, $0080, $0000, $0080, $0000, $0080
        dc.w    $0000, $0080, $0000, $0080, $0000, $0080, $0000, $0080
        dc.w    $0000, $0080, $0000, $3848, $00EE, $2080, $00B4, $3080
        dc.w    $010E, $5080, $01C2, $7080, $0276, $0080, $0000, $4000
        dc.w    $00FE          
Oscillate_Num_Do: ; loc_004BBA:
        cmpi.b  #6, ($FFFFB024).w
        bcc.s   loc_004C10
        lea     ($FFFFFE5E).w, A1
        lea     (Oscillate_Data2), A2   ; loc_004C12
        move.w  (A1)+, D3
        moveq   #$F, d1 
loc_004BD0:        
        move.w  (A2)+, D2
        move.w  (A2)+, D4
        btst    d1, d3
        bne.s   loc_004BF0
        move.w  art_tile(A1), D0
        add.w   d2, d0
        move.w  d0, art_tile(a1)
        add.w   d0, 0(a1)
        cmp.b   0(A1), D4
        bhi.s   loc_004C06
        bset    d1, d3
        bra.s   loc_004C06
loc_004BF0:
        move.w  art_tile(A1), D0
        sub.w   d2, d0
        move.w  d0, art_tile(a1)
        add.w   d0, 0(a1)
        cmp.b   0(A1), D4
        bls.s   loc_004C06
        bclr    d1, d3
loc_004C06:
        addq.w  #4, A1
        dbra    d1, loc_004BD0   
        move.w  d3, ($FFFFFE5E).w
loc_004C10:
        rts        
Oscillate_Data2: ; loc_004C12:
        dc.w    $0002, $0010, $0002, $0018, $0002, $0020, $0002, $0030
        dc.w    $0004, $0020, $0008, $0008, $0008, $0040, $0004, $0040
        dc.w    $0002, $0038, $0002, $0038, $0002, $0020, $0003, $0030
        dc.w    $0005, $0050, $0007, $0070, $0002, $0040, $0002, $0040
Change_Ring_Frame: ; loc_004C52:
        subq.b  #1, ($FFFFFEC0).w
        bpl.s   loc_004C68
        move.b  #$B, ($FFFFFEC0).w
        subq.b  #1, ($FFFFFEC1).w
        andi.b  #$7, ($FFFFFEC1).w         
loc_004C68:
        subq.b  #1, ($FFFFFEC2).w
        bpl.s   loc_004C7E
        move.b  #$7, ($FFFFFEC2).w
        addq.b  #1, ($FFFFFEC3).w
        andi.b  #3, ($FFFFFEC3).w
loc_004C7E:
        subq.b  #1, ($FFFFFEC4).w
        bpl.s   loc_004C9C
        move.b  #$7, ($FFFFFEC4).w
        addq.b  #1, ($FFFFFEC5).w
        cmpi.b  #6, ($FFFFFEC5).w
        bcs.s   loc_004C9C
        move.b  #0, ($FFFFFEC5).w
loc_004C9C:
        tst.b   ($FFFFFEC6).w
        beq.s   loc_004CBE
        moveq	#0,d0
        move.b  ($FFFFFEC6).w, d0
        add.w   ($FFFFFEC8).w, d0   
        move.w  d0, ($FFFFFEC8).w
        rol.w   #$7, d0
        andi.w  #$003, d0
        move.b  d0, ($FFFFFEC7).w
        subq.b  #1, ($FFFFFEC6).w
loc_004CBE:
        rts
End_Level_Art_Load: ; loc_004CC0: ; Test for load end level sprites...
        tst.w   (Debug_placement_mode).w
        bne     Skip_End_Level_Art_Load ; loc_004CF6
        cmpi.w  #$001, (Current_ZoneAndAct).w
        beq.s   Skip_End_Level_Art_Load ; loc_004CF6
        move.w  ($FFFFEE00).w, d0
        move.w  ($FFFFEECA).w, d1
        subi.w  #$100, d1
        cmp.w   d1, d0
        blt.s   Skip_End_Level_Art_Load ; loc_004CF6
        tst.b   (Update_HUD_timer).w
        beq.s   Skip_End_Level_Art_Load ; loc_004CF6
        cmp.w   ($FFFFEEC8).w, d1
        beq.s   Skip_End_Level_Art_Load ; loc_004CF6
        move.w  d1, ($FFFFEEC8).w
        moveq   #$27, d0
        bra     LoadPLC2        ; loc_00176E
Skip_End_Level_Art_Load: ; loc_004CF6:
        rts        
Demo_Green_Hill: ; loc_004CF8: ; $00 - Green Hill Sonic Demo control
        dc.w    $0044, $0800, $2805, $0859, $2804, $0835, $2806, $0842
        dc.w    $2804, $0819, $000F, $080A, $2809, $084A, $2809, $0810
        dc.w    $0005, $041B, $0200, $084B, $282D, $0855, $2809, $0826
        dc.w    $281C, $0819, $2808, $08FF, $0896, $2813, $081D, $2819
        dc.w    $082A, $2807, $0900, $0100, $0520, $0402, $0501, $0000
        dc.w    $083A, $0025, $040A, $2409, $041C, $0003, $083A, $2806
        dc.w    $080C, $0016, $0800, $280F, $0833, $2807, $0804, $0046
        dc.w    $086A, $0029, $8000, $C000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000              
Demo_Tails_Ghz: ; loc_004DF8: ; $00 - Green Hill Tails Demo control
        dc.w    $0046, $081E, $280A, $085E, $2830, $0866, $000F, $080F
        dc.w    $282E, $0800, $001F, $0812, $0013, $080A, $0016, $040D
        dc.w    $0008, $0410, $0030, $086B, $2814, $0880, $0A02, $0223
        dc.w    $0007, $0813, $2817, $0800, $0003, $0403, $0500, $0100
        dc.w    $0901, $083C, $2807, $0018, $084D, $2812, $0801, $0004
        dc.w    $080B, $0007, $081B, $0009, $2005, $2813, $0804, $0021
        dc.w    $0811, $0020, $0851, $000B, $0457, $000D, $0227, $0A00
        dc.w    $0002, $0901, $082A, $2815, $0803, $2819, $080A, $000A
        dc.w    $0802, $281B, $0833, $0027, $083A, $0912, $0107, $0013
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000   
Demo_Hill_Top: ; loc_004EF8: ; $07 - Hill Top Sonic Demo control
        dc.w    $0005, $011D, $0903, $2905, $0910, $0100, $0013, $0400
        dc.w    $050A, $2507, $0510, $0401, $000C, $0804, $090C, $290A
        dc.w    $0910, $0803, $001C, $2007, $000B, $0406, $0025, $2006
        dc.w    $0022, $0805, $0025, $040E, $0033, $0807, $0039, $080A
        dc.w    $2808, $0816, $0024, $0874, $2802, $2907, $0903, $000F
        dc.w    $080D, $0005, $040C, $0001, $2002, $2800, $2A08, $2802
        dc.w    $081E, $0004, $0413, $0012, $0818, $280B, $0811, $002C
        dc.w    $080C, $000D, $2004, $2803, $0805, $0022, $0412, $0004
        dc.w    $081A, $000D, $0406, $0037, $080C, $0019, $080D, $000C
        dc.w    $0409, $0003, $0820, $001A, $0406, $0022, $0809, $0009
        dc.w    $0816, $002F, $080E, $2804, $2002, $0008, $0419, $0005
        dc.w    $0806, $2808, $0808, $0024, $0872, $0A09, $020E, $0A6B
        dc.w    $8A00, $4000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
Demo_Hidden_Palace: ; loc_004FF8: ; $07 - Hidden Palace Sonic Demo control
        dc.w    $0040, $0833, $2806, $0839, $2805, $080D, $0025, $0810
        dc.w    $282A, $081C, $0200, $2603, $2200, $2A00, $2806, $0822
        dc.w    $0200, $060F, $0408, $0600, $020E, $062F, $0279, $0601
        dc.w    $0443, $240F, $0417, $0009, $081C, $2803, $0845, $0005
        dc.w    $081A, $2833, $0872, $000F, $0415, $2410, $040B, $0024
        dc.w    $0401, $2408, $0407, $0006, $0404, $001E, $240E, $0415
        dc.w    $001E, $2003, $240F, $0400, $0007, $0812, $0409, $240F
        dc.w    $0406, $000A, $0462, $2412, $2004, $0021, $280E, $0816
        dc.w    $0019, $0829, $0063, $0415, $2409, $0439, $0031, $0825
        dc.w    $2802, $0812, $0093, $8000, $C000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000 
Demo_Chemical_Plant: ; loc_0050F8: ; $07 - Chemical Plant Sonic Demo control
        dc.w    $001B, $0130, $0019, $0829, $2813, $0803, $001D, $2003
        dc.w    $281E, $0802, $0009, $0405, $002E, $081E, $2805, $2003
        dc.w    $000B, $0401, $0507, $0400, $002F, $2803, $2A04, $0A00
        dc.w    $0806, $0024, $0802, $2806, $0801, $0026, $08FF, $0814
        dc.w    $280A, $0803, $0060, $080E, $2807, $080C, $0008, $040B
        dc.w    $0023, $0805, $0093, $0819, $2811, $0878, $280F, $08FF
        dc.w    $0883, $280D, $0882, $001F, $8000, $4000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000 
JumpToDynamic_Art_Cues: ;loc_0051F8:
        jmp     Dynamic_Art_Cues ; loc_0223EC 
        dc.w    $0000 ; Filler  
;===============================================================================
; Special Stage           
;===============================================================================                 
SpecialStage: ; loc_005200:       
        move.w  #$0CA, d0
        bsr     Play_Sfx        ; loc_0014C6
        bsr     Pal_MakeFlash           ; loc_002762
        move    #$2700, SR
        lea     ($00C00004), a6
        move.w  #$8B03, (a6)
        move.w  #$8004, (a6)
        move.w  #$8AAF, (Hint_counter_reserve).w
        move.w  #$9011, (a6)
        move.w  (VDP_Reg0_Val).w, d0
        andi.b  #$BF, d0
        move.w  d0, ($00C00004)
        bsr     ClearScreen             ; loc_001418
        move    #$2300, SR
        lea     ($00C00004), a5
        move.w  #$8F01, (a5)
        move.l  #$946F93FF, (a5)
        move.w  #$9780, (a5)
        move.l  #$50000081, (a5)
        move.w  #0, ($00C00000)
loc_005260:        
        move.w  (a5), d1
        btst    #1,d1
        bne.s   loc_005260
        move.w  #$8F02, (a5)
        bsr     SS_Background_Load      ; loc_0054CA
        moveq   #$14, d0
        bsr     RunPLC_ROM              ; loc_0018A8
        lea     (PNT_Buffer).w, A1
        moveq	#0,d0
        move.w  #$7FF, d1
loc_005280:        
        move.l  d0, (A1)+
        dbra    d1, loc_005280
        lea     ($FFFFF700).w, A1
        moveq	#0,d0
        move.w  #$03F, d1
loc_005290:        
        move.l  d0, (A1)+
        dbra    d1, loc_005290
        lea     ($FFFFFE60).w, A1
        moveq	#0,d0
        move.w  #$027, d1
loc_0052A0:        
        move.l  d0, (A1)+
        dbra    d1, loc_0052A0
        lea     (Decomp_Buffer).w, A1
        moveq	#0,d0
        move.w  #$07F, d1
loc_0052B0:        
        move.l  d0, (A1)+
        dbra    d1, loc_0052B0
        clr.b   (Water_move).w
        clr.w   ($FFFFFE02).w
        moveq   #$16, d0
        bsr     PalLoad1        ; loc_0028E2
        jsr     (S1_Special_Stage_Load) ; loc_021A36
        move.l  #$0000000, ($FFFFEE00).w
        move.l  #$0000000, ($FFFFEE04).w
        move.b  #$9, (MainCharacter).w
        bsr     S1_Pal_Cycle_Special_Stage ; loc_005584
        clr.w   ($FFFFF750).w
        move.w  #$40, ($FFFFF752).w
        move.w  #$089, d0
        bsr     Play_Music              ; loc_0014C0
        move.w  #0, ($FFFFF790).w
        lea     (Demo_Index), A1        ; loc_0049F2
        moveq   #6, d0
        lsl.w   #$2, d0
        move.l  $00(A1, d0), A1
        move.b  render_flags(A1), ($FFFFF792).w
        subq.b  #1, ($FFFFF792).w
        clr.w   (Ring_count).w
        clr.b   ($FFFFFE1B).w
        move.w  #0, (Debug_placement_mode).w
        move.w  #$708, (Demo_Time_left).w
        tst.b   ($FFFFFFD2).w
        beq.s   loc_00533C
        btst    #6, ($FFFFF604).w
        beq.s   loc_00533C
        move.b  #1, ($FFFFFFFA).w
loc_00533C:
        move.w  (VDP_Reg0_Val).w, d0
        ori.b   #$40, d0
        move.w  d0, ($00C00004)
        bsr     Pal_MakeWhite           ; loc_0026B8
loc_00534E:        
        bsr     Pause           ; loc_0014D2
        move.b  #$A, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr     Move_Sonic_In_Demo      ; loc_0048DE
        move.w  ($FFFFF604).w, ($FFFFF602).w
        jsr     (Load_Objects)          ; loc_00CFD0
        jsr     (Build_Sprites)         ; loc_00D4DA
        jsr     (S1_SS_Show_Layout)     ; loc_021508
        bsr     S1_SS_Bg_Animate        ; loc_005806
        tst.w   ($FFFFFFF0).w
        beq.s   loc_00538A
        tst.w   (Demo_Time_left).w
        beq     loc_0054B8
loc_00538A:
        cmpi.b  #$10, (Game_Mode).w
        beq     loc_00534E
        tst.w   ($FFFFFFF0).w
        bne     loc_0054C0
        move.b  #$C, (Game_Mode).w
        cmpi.w  #$503, (Current_ZoneAndAct).w
        bcs.s   loc_0053AE
        clr.w   (Current_Zone).w
loc_0053AE:
        move.w  #$03C, (Demo_Time_left).w
        move.w  #$03F, ($FFFFF626).w
        clr.w   ($FFFFF794).w
loc_0053BE:        
        move.b  #$16, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        bsr     Move_Sonic_In_Demo      ; loc_0048DE
        move.w  ($FFFFF604).w, ($FFFFF602).w
        jsr     (Load_Objects)          ; loc_00CFD0
        jsr     (Build_Sprites)         ; loc_00D4DA
        jsr     (S1_SS_Show_Layout)     ; loc_021508
        bsr     S1_SS_Bg_Animate        ; loc_005806
        subq.w  #1, ($FFFFF794).w
        bpl.s   loc_0053F8
        move.w  #$002, ($FFFFF794).w
        bsr     Pal_ToWhite             ; loc_002782
loc_0053F8:
        tst.w   (Demo_Time_left).w
        bne.s   loc_0053BE
        move    #$2700, SR
        lea     ($00C00004), a6
        move.w  #$8230, (a6)
        move.w  #$8407, (a6)
        move.w  #$9001, (a6)
        bsr     ClearScreen             ; loc_001418
        move.l  #$70000002, ($00C00004)
        lea     (Title_Cards), A0 ; loc_07EA04
        bsr     NemesisDec              ; loc_0015FC
        jsr     (Head_Up_Display_Base)  ; loc_023184
        move    #$2300, SR
        moveq   #$16, d0
        bsr     PalLoad2        ; loc_0028FE
        moveq	#0,d0
        bsr     LoadPLC2        ; loc_00176E
        moveq   #$1B, d0
        bsr     LoadPLC         ; loc_00173C
        move.b  #1, (Update_HUD_Score).w
        move.b  #1, ($FFFFF7D6).w
        move.w  (Ring_count).w, d0
        mulu.w  #$00A, d0
        move.w  d0, ($FFFFF7D4).w
        move.w  #$08E, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        lea     (MainCharacter).w, A1
        moveq	#0,d0
        move.w  #$7FF, d1
loc_005474:        
        move.l  d0, (A1)+
        dbra    d1, loc_005474
        move.b  #$7E, ($FFFFB5C0).w
loc_005480:        
        bsr     Pause           ; loc_0014D2
        move.b  #$C, (Delay_Time).w
        bsr     DelayProgram            ; loc_0031D8
        jsr     (Load_Objects)          ; loc_00CFD0
        jsr     (Build_Sprites)         ; loc_00D4DA
        bsr     RunPLC          ; loc_0017A8
        tst.w   ($FFFFFE02).w
        beq.s   loc_005480
        tst.l   ($FFFFF680).w
        bne.s   loc_005480
        move.w  #$0CA, d0
        bsr     Play_Sfx        ; loc_0014C6
        bsr     Pal_MakeFlash           ; loc_002762
        rts
loc_0054B8:
        move.b  #0, (Game_Mode).w
        rts
loc_0054C0:
        cmpi.b  #$C, (Game_Mode).w
        beq.s   loc_0054B8
        rts
SS_Background_Load: ; loc_0054CA:
        lea     ($FFFF0000), A1
        move.w  #$4051, d0
        bsr     EnigmaDec               ; loc_0018DA
        move.l  #$50000001, d3
        lea     ($FFFF0080), A2
        moveq   #6, D7
loc_0054E6:        
        move.l  d3, d0
        moveq   #3, D6
        moveq   #0, D4
        cmpi.w  #$003, D7
        bcc.s   loc_0054F4
        moveq   #1, D4
loc_0054F4:
        moveq   #$7,d5
loc_0054F6:        
        move.l  A2, A1
        eori.b  #1, D4
        bne.s   loc_00550A
        cmpi.w  #$006, D7
        bne.s   loc_00551A
        lea     ($FFFF0000), A1
loc_00550A:
        movem.l D0-d4, -(A7)
        moveq   #$7, d1
        moveq   #$7, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        movem.l (A7)+, D0-D4
loc_00551A:
        addi.l  #$0100000, d0
        dbra    d5, loc_0054F6
        addi.l  #$3800000, d0
        eori.b  #1, D4
        dbra    d6, loc_0054F4
        addi.l  #$10000000, d3
        bpl.s   loc_005544
        swap.w  D3
        addi.l  #$000C000, d3
        swap.w  D3
loc_005544:
        adda.w  #$080, a2
        dbra    d7, loc_0054E6
        lea     ($FFFF0000), A1
        move.w  #$4000, d0
        bsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.l  #$40000003, d0
        moveq   #$3F, d1
        moveq   #$1F, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        lea     ($FFFF0000), A1
        move.l  #$50000003, d0
        moveq   #$3F, d1
        moveq   #$3F, D2
        bsr     ShowVDPGraphics         ; loc_00154C
        rts                     
S1_Pal_Cycle_Special_Stage: ; loc_005584:
        tst.w   (Game_paused).w
        bne.s   loc_005608
        subq.w  #1, ($FFFFF79C).w
        bpl.s   loc_005608
        lea     ($00C00004), a6
        move.w  ($FFFFF79A).w, d0
        addq.w  #1, ($FFFFF79A).w
        andi.w  #$01F, d0
        lsl.w   #$2, d0
        lea     (loc_00565E), A0
        adda.w  d0, A0 
        move.b  (A0)+, D0
        bpl.s   loc_0055B4
        move.w  #$1FF, d0
loc_0055B4:  
        move.w  d0, ($FFFFF79C).w
        moveq	#0,d0
        move.b  (A0)+, D0
        move.w  d0, ($FFFFF7A0).w 
        lea     (loc_0056DE), A1
        lea     $00(A1, d0), A1
        move.w  #$8200, d0
        move.b  (A1)+, D0
        move.w  d0, (a6)
        move.b  (A1), (Vscroll_Factor).w
        move.w  #$8400, d0
        move.b  (A0)+, D0
        move.w  d0, (a6) 
        move.l  #$40000010, ($00C00004) 
        move.l  (Vscroll_Factor).w, ($00C00000)
        moveq	#0,d0
        move.b  (A0)+, D0
        bmi.s   loc_00560A
        lea     (Pal_S1_SS_Cycle1), A1  ; loc_0056EC
        adda.w  d0, A1
        lea     ($FFFFFB4E).w, a2
        move.l  (A1)+, (A2)+
        move.l  (A1)+, (A2)+
        move.l  (A1)+, (A2)+
loc_005608: 
        rts 
loc_00560A:
        move.w  ($FFFFF79E).w, d1
        cmpi.w  #$08A, d0 
        bcs.s   loc_005616
        addq.w  #1,d1
loc_005616:  
        mulu.w  #$02A, d1
        lea     (Pal_S1_SS_Cycle2), A1  ; loc_005734
        adda.w  d1, A1
        andi.w  #$07F, d0
        bclr    #0, d0
        beq.s   loc_00563A
        lea     ($FFFFFB6E).w, a2
        move.l  (A1), (A2)+
        move.l  mappings(A1), (A2)+
        move.l  x_pos(A1), (A2)+
loc_00563A:        
        adda.w  #$00C, A1
        lea     ($FFFFFB5A).w, a2
        cmpi.w  #$00A, d0
        bcs.s   loc_005650
        subi.w  #$00A, d0
        lea     ($FFFFFB7A).w, a2
loc_005650:      
        move.w  d0, d1   
        add.w   d0, d0  
        add.w   d1, d0  
        adda.w  d0, A1 
        move.l  (A1)+, (A2)+    
        move.w  (A1)+, (A2)+ 
        rts                     
loc_00565E:  
        dc.w    $0300, $0792, $0300, $0790, $0300, $078E, $0300, $078C
        dc.w    $0300, $078B, $0300, $0780, $0300, $0782, $0300, $0784
        dc.w    $0300, $0786, $0300, $0788, $0708, $0700, $070A, $070C
        dc.w    $FF0C, $0718, $FF0C, $0718, $070A, $070C, $0708, $0700
        dc.w    $0300, $0688, $0300, $0686, $0300, $0684, $0300, $0682
        dc.w    $0300, $0681, $0300, $068A, $0300, $068C, $0300, $068E
        dc.w    $0300, $0690, $0300, $0692, $0702, $0624, $0704, $0630
        dc.w    $FF06, $063C, $FF06, $063C, $0704, $0630, $0702, $0624
loc_0056DE:  
        dc.w    $1001, $1800, $1801, $2000, $2001, $2800, $2801            
Pal_S1_SS_Cycle1: ; loc_0056EC: 
        dc.w    $0400, $0600, $0620, $0624, $0664, $0666, $0600, $0820
        dc.w    $0A64, $0A68, $0AA6, $0AAA, $0800, $0C42, $0E86, $0ECA
        dc.w    $0EEC, $0EEE, $0400, $0420, $0620, $0620, $0864, $0666
        dc.w    $0420, $0620, $0842, $0842, $0A86, $0AAA, $0620, $0842
        dc.w    $0A64, $0C86, $0EA8, $0EEE
Pal_S1_SS_Cycle2: ; loc_005734: 
        dc.w    $0EEA, $0EE0, $0AA0, $0880, $0660, $0440, $0EE0, $0AA0
        dc.w    $0440, $0AA0, $0AA0, $0AA0, $0860, $0860, $0860, $0640
        dc.w    $0640, $0640, $0400, $0400, $0400, $0AEC, $06EA, $04C6
        dc.w    $02A4, $0082, $0060, $06EA, $04C6, $0060, $04C6, $04C6
        dc.w    $04C6, $0484, $0484, $0484, $0442, $0442, $0442, $0400
        dc.w    $0400, $0400, $0ECC, $0E8A, $0C68, $0A46, $0824, $0602
        dc.w    $0E8A, $0C68, $0602, $0C68, $0C68, $0C68, $0846, $0846
        dc.w    $0846, $0624, $0624, $0624, $0400, $0400, $0400, $0AEC
        dc.w    $08CA, $06A8, $0486, $0264, $0042, $08CA, $06A8, $0042
        dc.w    $06A8, $06A8, $06A8, $0684, $0684, $0684, $0442, $0442
        dc.w    $0442, $0400, $0400, $0400, $0EEC, $0CCA, $0AA8, $0886
        dc.w    $0664, $0442, $0CCA, $0AA8, $0442, $0AA8, $0AA8, $0AA8
        dc.w    $0864, $0864, $0864, $0642, $0642, $0642, $0400, $0400
        dc.w    $0400  
S1_SS_Bg_Animate: ; loc_005806:
        move.w  ($FFFFF7A0).w, d0
        bne.s   loc_005818
        move.w  #0, ($FFFFEE0C).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
loc_005818:
        cmpi.w  #8, d0
        bcc.s   loc_005870
        cmpi.w  #$006, d0
        bne.s   loc_005832
        addq.w  #1, ($FFFFEE18).w
        addq.w  #1, ($FFFFEE0C).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
loc_005832:
        moveq	#0,d0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
        swap.w  D0
        lea     (loc_0058ED), A1
        lea     (Decomp_Buffer).w, A3
        moveq   #$9, d3
loc_005848:        
        move.w  art_tile(A3), D0
        bsr     CalcSine        ; loc_00320A
        moveq   #0, D2
        move.b  (A1)+, D2
        muls.w  d2, d0
        asr.l   #8,d0
        move.w  d0, (A3)+
        move.b  (A1)+, D2
        ext.w   D2
        add.w   D2, (A3)+
        dbra    d3, loc_005848
        lea     (Decomp_Buffer).w, A3
        lea     (loc_0058DA), A2
        bra.s   loc_0058A0
loc_005870:
        cmpi.w  #$00C, d0
        bne.s   loc_005896
        subq.w  #1, ($FFFFEE18).w
        lea     ($FFFFAB00).w, A3
        move.l  #$0018000, D2
        moveq   #6, d1
loc_005886:        
        move.l  (A3), D0
        sub.l   d2, d0
        move.l  d0, (A3)+
        subi.l  #$0002000, D2
        dbra    d1, loc_005886
loc_005896:
        lea     ($FFFFAB00).w, A3
        lea     (loc_0058E5), A2
loc_0058A0:
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE18).w, d0
        neg.w   D0
        swap.w  D0
        moveq   #0, d3
        move.b  (A2)+, D3
        move.w  ($FFFFEE0C).w, D2
        neg.w   D2
        andi.w  #$0FF, D2
        lsl.w   #$2, D2
loc_0058BC:        
        move.w  (A3)+, D0
        addq.w  #$2, A3
        moveq   #0,d1
        move.b  (A2)+, d1
        subq.w  #1,d1
loc_0058C6:        
        move.l  d0, $00(A1, D2)
        addq.w  #4, D2
        andi.w  #$3FC, D2
        dbra    d1, loc_0058C6
        dbra    d3, loc_0058BC
        rts   
loc_0058DA:
        dc.b    $09, $28, $18, $10, $28, $18, $10, $30, $18, $08, $10
loc_0058E5:
        dc.b    $06, $30, $30, $30, $28, $18, $18, $18
loc_0058ED:
        dc.b    $08, $02, $04, $FF, $02, $03, $08, $FF, $04, $02, $02, $03, $08, $FD, $04, $02
        dc.b    $02, $03, $02, $FF, $00                    
;===============================================================================
; Special Stage             
;===============================================================================          
        nop                     ; Filler   
Level_Size_Load: ; loc_005904: ; Level Size routine
        clr.w   ($FFFFEE50).w
        clr.w   ($FFFFEE52).w
        clr.w   ($FFFFEE54).w
        clr.w   ($FFFFEE56).w
        clr.w   ($FFFFEE58).w
        clr.w   ($FFFFEE5A).w
        clr.w   ($FFFFEE5C).w
        clr.w   ($FFFFEE5E).w
        clr.w   ($FFFFEEA0).w
        clr.w   ($FFFFEEA2).w
        clr.w   ($FFFFEEA4).w
        clr.w   ($FFFFEEA6).w
        clr.w   ($FFFFEEA8).w
        clr.w   ($FFFFEEAA).w
        clr.w   ($FFFFEEAC).w
        clr.w   ($FFFFEEAE).w
        clr.b   ($FFFFEEDC).w
        clr.b   ($FFFFEEBC).w
        clr.b   ($FFFFEEBD).w
        moveq	#0,d0
        move.b  d0, ($FFFFEEDF).w
        move.w  (Current_Zone).w, d0
        ror.b   #1,d0
        lsr.w   #4, d0
        lea     Level_Size_Array(pc,d0), A0 ; loc_005986
        move.l  (A0)+, D0
        move.l  d0, ($FFFFEEC8).w
        move.l  d0, ($FFFFEEC0).w
        move.l  (A0)+, D0
        move.l  d0, ($FFFFEECC).w
        move.l  d0, ($FFFFEEC4).w
        move.w  #$1010, ($FFFFEE40).w
        move.w  #$060, ($FFFFEED8).w
        bra     Level_Size_Check_Lamp_Post ; loc_005A96
Level_Size_Array: ; loc_005986: ; Level Size Array               
        dc.l    $000029A0, $00000320, $00002940, $00000420 ; $00 - Green Hill
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $01
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $02 - Wood
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $03 
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $04 - Metropolis
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $05 - Metropolis
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $06
        dc.l    $00002800, $00000720, $00002880, $00000720 ; $07 - Hill Top
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $08 - Hidden Palace
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $09
        dc.l    $00002F80, $00000680, $00002580, $00000680 ; $0A - Oil Ocean
        dc.l    $00002380, $03C00720, $00002180, $00600720 ; $0B - Dust Hill
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $0C - Casino Night
        dc.l    $00002780, $00000720, $00002880, $00000720 ; $0D - Chemical Plant
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $0E - Genocide City
        dc.l    $000028C0, $020003A0, $000026C0, $018005A0 ; $0F - Neo Green Hill
        dc.l    $00003FFF, $00000720, $00003FFF, $00000720 ; $10 - Death Egg
Level_Size_Check_Lamp_Post: ; loc_005A96: ; Player Start Position routine
        tst.b   (Last_star_pole_hit).w 
        beq.s   Level_Size_Start_Loc    ; loc_005AAC
        jsr     Lamp_Post_Load_Info ; loc_013CE4
        move.w  (MainCharacter+x_pos).w, d1
        move.w  ($FFFFB00C).w, d0         
        bra.s   Level_Size_Start_Loc_Loaded ; loc_005AC8
Level_Size_Start_Loc: ; loc_005AAC:        
        move.w  (Current_Zone).w, d0
        ror.b   #1,d0
        lsr.w   #5, d0
        lea     Player_Start_Position_Array(pc,d0), A1 ; loc_005B02
        moveq   #0,d1
        move.w  (A1)+, d1
        move.w  d1, (MainCharacter+x_pos).w
        moveq	#0,d0
        move.w  (A1), D0
        move.w  d0, ($FFFFB00C).w
Level_Size_Start_Loc_Loaded: ; loc_005AC8:        
        subi.w  #$0A0, d1
        bcc.s   loc_005AD0    
        moveq   #0,d1
loc_005AD0:
        move.w  ($FFFFEECA).w, D2
        cmp.w   D2, d1
        bcs.s   loc_005ADA
        move.w  D2, d1
loc_005ADA:
        move.w  d1, ($FFFFEE00).w
        move.w  d1, ($FFFFEE20).w
        subi.w  #$060, d0
        bcc.s   loc_005AEA
        moveq	#0,d0
loc_005AEA:
        cmp.w   ($FFFFEECE).w, d0
        blt.s   loc_005AF4
        move.w  ($FFFFEECE).w, d0
loc_005AF4:
        move.w  d0, ($FFFFEE04).w
        move.w  d0, ($FFFFEE24).w
        bsr     Background_Scroll_Speed ; loc_005B8A
        rts
Player_Start_Position_Array: ; loc_005B02: ; Player Start Position Array              
        dc.l    $0060028F, $004002AF ; $00 - Green Hill
        dc.l    $0060028F, $004002AF ; $01
        dc.l    $006001AC, $004001AC ; $02 - Wood
        dc.l    $0060028F, $004002AF ; $03
        dc.l    $0060028C, $004005EC ; $04 - Metropolis
        dc.l    $006001EC, $004002AF ; $05 - Metropolis
        dc.l    $0060028F, $004002AF ; $06
        dc.l    $004003AF, $0060068F ; $07 - Hill Top
        dc.l    $023001AC, $003001BD ; $08 - Hidden Palace
        dc.l    $0060028F, $004002AF ; $09
        dc.l    $006006AC, $0050056C ; $0A - Oil Ocean
        dc.l    $006006AC, $006005AC ; $0B - Dust Hill
        dc.l    $0060028F, $004002AF ; $0C - Casino Night
        dc.l    $003001EC, $0030012C ; $0D - Chemical Plant
        dc.l    $0060028F, $004002AF ; $0E - Genocide City
        dc.l    $0050037C, $0050037C ; $0F - Neo Green Hill
        dc.l    $0060028F, $004002AF ; $10 - Death Egg
Background_Scroll_Speed: ; loc_005B8A: ; Background Position
        tst.b   (Last_star_pole_hit).w
        bne.s   loc_005BB8
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFEE14).w
        move.w  d1, ($FFFFEE08).w
        move.w  d1, ($FFFFEE10).w
        move.w  d1, ($FFFFEE18).w
        move.w  d0, ($FFFFEE2C).w
        move.w  d0, ($FFFFEE34).w
        move.w  d1, ($FFFFEE28).w
        move.w  d1, ($FFFFEE30).w
        move.w  d1, ($FFFFEE38).w   
loc_005BB8:        
        moveq   #0, D2
        move.b  (Current_Zone).w, D2
        add.w   D2, D2
        move.w  Bg_Scroll_Speed_Index(PC, D2), D2 ; loc_005BC8
        jmp     Bg_Scroll_Speed_Index(PC, D2) ; loc_005BC8
Bg_Scroll_Speed_Index: ; loc_005BC8: 
        dc.w    Bg_Scroll_Speed_GHz-Bg_Scroll_Speed_Index ; $00 - Green Background Position
        dc.w    Bg_Scroll_Speed_Null-Bg_Scroll_Speed_Index ; $01 - Null Background Position
        dc.w    Bg_Scroll_Speed_Wz-Bg_Scroll_Speed_Index ; $02 - Wood Background Position
        dc.w    Bg_Scroll_Speed_Null-Bg_Scroll_Speed_Index ; $03 - Null Background Position
        dc.w    Bg_Scroll_Speed_Mz-Bg_Scroll_Speed_Index ; $04 - Metropolis Background Position 
        dc.w    Bg_Scroll_Speed_Mz-Bg_Scroll_Speed_Index ; $05 - Metropolis Background Position 
        dc.w    Bg_Scroll_Speed_Null-Bg_Scroll_Speed_Index ; $06 - Null Background Position
        dc.w    Bg_Scroll_Speed_HTz-Bg_Scroll_Speed_Index ; $07 - Hill Top Background Position 
        dc.w    Bg_Scroll_Speed_HPz-Bg_Scroll_Speed_Index ; $08 - Hidden Palace Background Position 
        dc.w    Bg_Scroll_Speed_Null2-Bg_Scroll_Speed_Index ; $09 - Null Background Position
        dc.w    Bg_Scroll_Speed_OOz-Bg_Scroll_Speed_Index ; $0A - Oil Ocean Background Position 
        dc.w    Bg_Scroll_Speed_DHz-Bg_Scroll_Speed_Index ; $0B - Dust Hill Background Position 
        dc.w    Bg_Scroll_Speed_CNz-Bg_Scroll_Speed_Index ; $0C - Casino Night Background Position
        dc.w    Bg_Scroll_Speed_CPz-Bg_Scroll_Speed_Index ; $0D - Chemical Plant Background Position 
        dc.w    Bg_Scroll_Speed_Null3-Bg_Scroll_Speed_Index ; $0E - Genocide City Background Position (Null)
        dc.w    Bg_Scroll_Speed_NGHz-Bg_Scroll_Speed_Index ; $0F - Neo Green Hill Background Position 
        dc.w    Bg_Scroll_Speed_Null4-Bg_Scroll_Speed_Index ; $10 - Death Egg Background Position (Null)
Bg_Scroll_Speed_GHz: ; loc_005BEA: ; Green Hill Background Position
        clr.l   ($FFFFEE08).w
        clr.l   ($FFFFEE0C).w
        clr.l   ($FFFFEE14).w
        clr.l   ($FFFFEE1C).w
        lea     ($FFFFA800).w, a2
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   ($FFFFEE28).w
        clr.l   ($FFFFEE2C).w
        clr.l   ($FFFFEE34).w
        clr.l   ($FFFFEE3C).w
        rts               
Bg_Scroll_Speed_Null: ; loc_005C16: ; Null
        rts   
Bg_Scroll_Speed_Wz: ; loc_005C18: ; Wood Background Position               
        asr.w   #$2, d0
        addi.w  #$400, d0
        move.w  d0, ($FFFFEE0C).w
        asr.w   #3, d1
        move.w  d1, ($FFFFEE08).w
        rts
Bg_Scroll_Speed_Mz: ; loc_005C2A: ; Metropolis Background Position         
        asr.w   #$2, d0
        move.w  d0, ($FFFFEE0C).w
        asr.w   #3, d1
        move.w  d1, ($FFFFEE08).w
        rts
Bg_Scroll_Speed_HTz: ; loc_005C38: ; Hill Top Background Position  
        clr.l   ($FFFFEE08).w
        clr.l   ($FFFFEE0C).w
        clr.l   ($FFFFEE14).w
        clr.l   ($FFFFEE1C).w
        lea     ($FFFFA800).w, a2
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   ($FFFFEE28).w
        clr.l   ($FFFFEE2C).w
        clr.l   ($FFFFEE34).w
        clr.l   ($FFFFEE3C).w
        rts
Bg_Scroll_Speed_HPz: ; loc_005C64: ; Hidden Palace Background Position  
        asr.w   #1,d0
        move.w  d0, ($FFFFEE0C).w
        clr.l   ($FFFFEE08).w
        rts 
Bg_Scroll_Speed_S1_Spring_Yard: ; loc_005C70:  
        asl.l   #4, d0
        move.l  d0, D2
        asl.l   #1,d0
        add.l   d2, d0
        asr.l   #8,d0
        addq.w  #1,d0
        move.w  d0, ($FFFFEE0C).w
        clr.l   ($FFFFEE08).w
        rts
Bg_Scroll_Speed_Null2: ; loc_005C86:
        rts  
Bg_Scroll_Speed_OOz: ; loc_005C88: ; Oil Ocean Background Position 
        lsr.w   #3, d0
        addi.w  #$050, d0
        move.w  d0, ($FFFFEE0C).w
        clr.l   ($FFFFEE08).w
        rts    
Bg_Scroll_Speed_S1_Spring_Yard2: ; loc_005C98: 
        asl.l   #4, d0
        move.l  d0, D2
        asl.l   #1,d0
        add.l   d2, d0
        asr.l   #8,d0
        addq.w  #1,d0
        move.w  d0, ($FFFFEE0C).w
        clr.l   ($FFFFEE08).w
        rts        
;loc_005CAE: 
        asr.w   #3, d0
        move.w  d0, ($FFFFEE0C).w
        rts        
Bg_Scroll_Speed_DHz: ; loc_005CB6: ; Dust Hill Background Position
        clr.l   ($FFFFEE08).w
        clr.l   ($FFFFEE28).w
        tst.b   ($FFFFFE11).w
        bne.s   loc_005CD6
        divu.w  #$003, d0
        subi.w  #$140, d0
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFEE2C).w
        rts
loc_005CD6: 
        divu.w  #$006, d0
        subi.w  #$010, d0
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFEE2C).w
        rts   
Bg_Scroll_Speed_CNz: ; loc_005CE8: ; Casino Night Background Position 
        lsr.w   #6, d0
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFEE2C).w
        clr.l   ($FFFFEE08).w
        lea     ($FFFFA800).w, a2
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   ($FFFFEE28).w
        clr.l   ($FFFFEE2C).w
        clr.l   ($FFFFEE34).w
        clr.l   ($FFFFEE3C).w
        rts                                      
Bg_Scroll_Speed_CPz: ; loc_005D12: ; Chemical Plant Background Position 
        lsr.w   #$2, d0
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFEE2C).w
        clr.l   ($FFFFEE08).w
        clr.l   ($FFFFEE10).w
        rts
Bg_Scroll_Speed_Null3: ; loc_005D26: ; Genocide City Background Position (Null)
        rts    
Bg_Scroll_Speed_NGHz: ; loc_005D28: ; Neo Green Hill Background Position 
        tst.b   ($FFFFFE11).w
        beq.s   loc_005D3A
        subi.w  #$0E0, d0
        lsr.w   #1,d0
        move.w  d0, ($FFFFEE0C).w
        bra.s   loc_005D42
loc_005D3A:
        subi.w  #$180, d0
        move.w  d0, ($FFFFEE0C).w
loc_005D42:
        clr.l   ($FFFFEE08).w
        clr.l   ($FFFFEE14).w
        clr.l   ($FFFFEE1C).w
        lea     ($FFFFA800).w, a2
        clr.l   (A2)+
        clr.l   (A2)+
        clr.l   (A2)+
        rts        
Bg_Scroll_Speed_Null4: ; loc_005D5A: ; Death Egg Background Position (Null)
        rts              
Background_Scroll_Layer: ; loc_005D5C:
        tst.b   ($FFFFEEDC).w
        beq.s   loc_005D64
        rts   
loc_005D64:  
        clr.w   ($FFFFEE50).w
        clr.w   ($FFFFEE52).w
        clr.w   ($FFFFEE54).w
        clr.w   ($FFFFEE56).w
        clr.w   ($FFFFEE58).w
        clr.w   ($FFFFEE5A).w
        clr.w   ($FFFFEE5C).w
        clr.w   ($FFFFEE5E).w
        lea     (MainCharacter).w, A0
        lea     ($FFFFEE00).w, A1
        lea     ($FFFFEE40).w, a2
        lea     ($FFFFEE50).w, A3
        lea     ($FFFFEEB0).w, A4
        lea     ($FFFFEED0).w, a5
        lea     ($FFFFE500).w, a6
        bsr     Scroll_Horizontal       ; loc_006AEC
        lea     ($FFFFEE04).w, A1
        lea     ($FFFFEE41).w, a2
        lea     ($FFFFEEB2).w, A4
        bsr     Scroll_Vertical         ; loc_006B84
        tst.w   (Two_player_mode).w
        beq.s   loc_005DEA
        lea     (Sidekick).w, A0
        lea     ($FFFFEE20).w, A1
        lea     ($FFFFEE48).w, a2
        lea     ($FFFFEE58).w, A3
        lea     ($FFFFEEB8).w, A4
        lea     ($FFFFEED4).w, a5
        lea     ($FFFFE700).w, a6
        bsr     Scroll_Horizontal       ; loc_006AEC
        lea     ($FFFFEE24).w, A1
        lea     ($FFFFEE49).w, a2
        lea     ($FFFFEEBA).w, A4
        bsr     Scroll_Vertical         ; loc_006B84
loc_005DEA:        
        bsr     Dyn_Screen_Boss_Loader  ; loc_0079C0
        move.w  ($FFFFEE04).w, (Vscroll_Factor).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        move.l  ($FFFFEE00).w, ($FFFFEEF0).w
        move.l  ($FFFFEE04).w, ($FFFFEEF4).w
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        move.w  Bg_Scroll_Index(pc,d0), D0 ; loc_005E16
        jmp     Bg_Scroll_Index(pc,d0) ; loc_005E16
Bg_Scroll_Index: ; loc_005E16:
        dc.w    Bg_Scroll_GHz-Bg_Scroll_Index; $00 - Green Hill Background Scroll   
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $01 - Null Background Scroll 
        dc.w    Bg_Scroll_Wz-Bg_Scroll_Index; $02 - Wood Background Scroll  
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $03 - Null Background Scroll  
        dc.w    Bg_Scroll_Mz-Bg_Scroll_Index; $04 - Metropolis Background Scroll 
        dc.w    Bg_Scroll_Mz-Bg_Scroll_Index; $05 - Metropolis Background Scroll 
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $06 - Null Background Scroll 
        dc.w    Bg_Scroll_HTz-Bg_Scroll_Index; $07 - Hill Top Background Scroll 
        dc.w    Bg_Scroll_HPz-Bg_Scroll_Index; $08 - Hidden Palace Background Scroll 
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $09 - Null Background Scroll 
        dc.w    Bg_Scroll_OOz-Bg_Scroll_Index; $0A - Oil Ocean Background Scroll 
        dc.w    Bg_Scroll_DHz-Bg_Scroll_Index; $0B - Dust Hill Background Scroll 
        dc.w    Bg_Scroll_CNz-Bg_Scroll_Index; $0C - Casino Night Background Scroll 
        dc.w    Bg_Scroll_CPz-Bg_Scroll_Index; $0D - Chemical Plant Background Scroll               
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $0E - Genocide City (Null) Background Scroll 
        dc.w    Bg_Scroll_NGHz-Bg_Scroll_Index; $0F - Neo Green Hill Background Scroll 
        dc.w    Bg_Scroll_Null-Bg_Scroll_Index; $10 - Death Egg (Null) Background Scroll    
loc_005E38: ; Title Screen Background Scroll
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        move.w  ($FFFFEE00).w, d0
        cmpi.w  #$1C00, d0
        bcc.s   loc_005E4A
        addq.w  #8,d0
loc_005E4A:
        move.w  d0, ($FFFFEE00).w
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE00).w, D2
        neg.w   D2
        moveq	#0,d0
        bra.s   loc_005E78
Bg_Scroll_GHz: ; loc_005E5C: ; $00 - Green Hill Background Scroll        
        tst.w   (Two_player_mode).w
        bne     loc_005FA2
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        move.w  d0, D2
        swap.w  D0
loc_005E78:        
        move.w  #0, d0
        move.w  #$015, d1
loc_005E80:
        move.l  d0, (A1)+
        dbra    d1, loc_005E80
        move.w  d2, d0
        asr.w   #6, d0
        move.w  #$039, d1  
loc_005E8E:
        move.l  d0, (A1)+
        dbra    d1, loc_005E8E
        move.w  d0, d3
        move.b  ($FFFFFE0F).w, d1
        andi.w  #$007, d1
        bne.s   loc_005EA4
        subq.w  #1, ($FFFFA800).w
loc_005EA4:
        move.w  ($FFFFA800).w, d1
        andi.w  #$01F, d1
        lea     (loc_005F60), A2
        lea     $00(A2, d1), A2
        move.w  #$014, d1
loc_005EBA:
        move.b  (A2)+, D0
        ext.w   D0
        add.w   d3, d0
        move.l  d0, (A1)+
        dbra    d1, loc_005EBA
        
        move.w  #0, d0
        move.w  #$00A, d1     
loc_005ECE:
        move.l  d0, (A1)+
        dbra    d1, loc_005ECE
        move.w  d2, d0
        asr.w   #4, d0
        move.w  #$F, d1
loc_005EDC:
        move.l  d0, (A1)+
        dbra    d1, loc_005EDC
        move.w  d2, d0
        asr.w   #4, d0
        move.w  d0, d1
        asr.w   #1,d1
        add.w   d1, d0
        move.w  #$F, d1
loc_005EF0:
        move.l  d0, (A1)+
        dbra    d1, loc_005EF0
        move.l  d0, D4
        swap.w  D4
        move.w  d2, d0
        asr.w   #1,d0
        move.w  D2, d1
        asr.w   #3, d1
        sub.w   d1, d0
        ext.l   D0
        asl.l   #8,d0
        divs.w  #$030, d0
        ext.l   D0
        asl.l   #8,d0
        moveq   #0, d3
        move.w  D2, d3
        asr.w   #3, d3
        move.w  #$00E, d1
loc_005F1A:        
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        dbra    d1, loc_005F1A
        move.w  #8,d1               
loc_005F2C:
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        dbra    d1, loc_005F2C
        move.w  #$00E, d1
loc_005F44:        
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        move.w  d4, (A1)+
        move.w  d3, (A1)+
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        dbra    d1, loc_005F44               
        rts   
loc_005F60:         
        dc.b    $01, $02, $01, $03, $01, $02, $02, $01, $02, $03, $01, $02, $01, $02, $00, $00
        dc.b    $02, $00, $03, $02, $02, $03, $02, $02, $01, $03, $00, $00, $01, $00, $01, $03
        dc.b    $01, $02, $01, $03, $01, $02, $02, $01, $02, $03, $01, $02, $01, $02, $00, $00
        dc.b    $02, $00, $03, $02, $02, $03, $02, $02, $01, $03, $00, $00, $01, $00, $01, $03
        dc.b    $01, $02               
loc_005FA2:
        move.b  ($FFFFFE0F).w, d1
        andi.w  #$007, d1
        bne.s   loc_005FB0
        subq.w  #1, ($FFFFA800).w
loc_005FB0:        
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        andi.l  #$FFFEFFFE, (Vscroll_Factor).w
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE00).w, d0
        move.w  #$00A, d1 
        bsr.s   loc_005FF8
        moveq	#0,d0
        move.w  d0, ($FFFFF620).w
        subi.w  #$0E0, ($FFFFF620).w
        move.w  ($FFFFEE24).w, ($FFFFF61E).w
        subi.w  #$0E0, ($FFFFF61E).w
        andi.l  #$FFFEFFFE, ($FFFFF61E).w
        lea     ($FFFFE1B0).w, A1
        move.w  ($FFFFEE20).w, d0
        move.w  #$00E, d1
loc_005FF8:
        neg.w   D0
        move.w  d0, D2
        swap.w  D0
        move.w  #0, d0
loc_006002:
        move.l  d0, (A1)+
        dbra    d1, loc_006002
        move.w  d2, d0
        asr.w   #6, d0
        move.w  #$01C, d1
loc_006010:
        move.l  d0, (A1)+
        dbra    d1, loc_006010
        move.w  d0, d3
        move.w  ($FFFFA800).w, d1
        andi.w  #$01F, d1
        lea     loc_005F60(PC), A2
        lea     $00(A2, d1), A2
        move.w  #$00A, d1
loc_00602C:        
        move.b  (A2)+, D0
        ext.w   D0
        add.w   d3, d0
        move.l  d0, (A1)+
        dbra    d1, loc_00602C    
        move.w  #0, d0
        move.w  #$004, d1
loc_006040:
        move.l  d0, (A1)+
        dbra    d1, loc_006040
        move.w  d2, d0
        asr.w   #4, d0
        move.w  #$007, d1
loc_00604E:
        move.l  d0, (A1)+
        dbra    d1, loc_00604E
        move.w  d2, d0
        asr.w   #4, d0
        move.w  d0, d1
        asr.w   #1,d1
        add.w   d1, d0
        move.w  #$007, d1
loc_006062:
        move.l  d0, (A1)+
        dbra    d1, loc_006062
        move.w  d2, d0
        asr.w   #1,d0
        move.w  D2, d1
        asr.w   #3, d1
        sub.w   d1, d0
        ext.l   D0
        asl.l   #8,d0
        divs.w  #$030, d0
        ext.l   D0
        asl.l   #8,d0
        moveq   #0, d3
        move.w  D2, d3
        asr.w   #3, d3
        move.w  #$027, d1
loc_006088:        
        move.w  D2, (A1)+
        move.w  d3, (A1)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        dbra    d1, loc_006088    
        rts          
Bg_Scroll_Wz: ; loc_006098: ; Wood Background Scroll
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #5, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #6,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  #$00DF, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_0060C8:
        move.l  d0, (A1)+
        dbra    d1, loc_0060C8
        rts               
Bg_Scroll_Mz: ; loc_0060D0: ; Metropolis Background Scroll 
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #5, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #6,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  #$0DF, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_006100:
        move.l  d0, (A1)+
        dbra    d1, loc_006100
        rts             
Bg_Scroll_HTz: ; loc_006108: ; Hill Top Background Scroll 
        tst.w   (Two_player_mode).w
        bne     loc_0062B4
        tst.b   ($FFFFEEBC).w
        bne     loc_006236
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        move.w  d0, D2
        swap.w  D0
        move.w  d2, d0
        asr.w   #3, d0
        move.w  #$07F, d1
loc_006134:
        move.l  d0, (A1)+
        dbra    d1, loc_006134
        move.l  d0, D4
        move.w  ($FFFFA822).w, d0
        addq.w  #4, ($FFFFA822).w
        sub.w   d0, D2
        move.w  d2, d0
        move.w  d0, d1
        asr.w   #1,d0
        asr.w   #4, d1
        sub.w   d1, d0
        ext.l   D0
        asl.l   #8,d0
        divs.w  #$070, d0
        ext.l   D0
        asl.l   #8,d0
        lea     ($FFFFA800).w, a2
        moveq   #0, d3
        move.w  d1, d3
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A2)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A2)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A2)+
        move.w  d3, (A2)+
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        moveq   #3, d1
loc_006188:
        move.w  d3, (A2)+
        move.w  d3, (A2)+
        move.w  d3, (A2)+
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        dbra    d1, loc_006188
        add.l   d0, d0
        add.l   d0, d0
        move.w  d3, D4
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, D4
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        move.l  d4, (A1)+
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, D4
        move.w  #$006, d1
loc_0061C6:
        move.l  d4, (A1)+
        dbra    d1, loc_0061C6
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, D4
        move.w  #$007, d1
loc_0061DA:
        move.l  d4, (A1)+
        dbra    d1, loc_0061DA
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, D4
        move.w  #$009, d1
loc_0061EE:
        move.l  d4, (A1)+
        dbra    d1, loc_0061EE
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, D4
        move.w  #$00E, d1
loc_006204:
        move.l  d4, (A1)+
        dbra    d1, loc_006204
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        move.w  #$002, D2
loc_006218:
        move.w  d3, D4
        move.w  #$F, d1
loc_00621E:
        move.l  d4, (A1)+
        dbra    d1, loc_00621E
        swap.w  D3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        add.l   d0, d3
        swap.w  D3
        dbra    D2, loc_006218 
        rts
loc_006236:
        move.w  ($FFFFEEB4).w, D4
        ext.l   D4
        lsl.l   #8, D4
        moveq   #$2, D6
        bsr     Scroll_Block2           ; loc_006D1E
        move.w  ($FFFFEEB6).w,d5
        ext.l   D5
        lsl.l   #8,d5
        moveq   #0, D6
        bsr     Scroll_Block3           ; loc_006D52
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        move.w  ($FFFFEE04).w, (Vscroll_Factor).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        moveq   #0, D2
        tst.b   ($FFFFEEBD).w
        beq.s   loc_006292
        move.w  ($FFFFFE04).w, d0
        andi.w  #$03F, d0
        lea     loc_005F60(PC), A1
        lea     $00(A1, d0), A1
        moveq	#0,d0
        move.b  (A1)+, D0
        add.w   d0, (Vscroll_Factor).w
        add.w   d0, ($FFFFF618).w
        add.w   d0, ($FFFFEEF4).w
        move.b  (A1)+, D2
        add.w   D2, ($FFFFEEF0).w
loc_006292:
        lea     ($FFFFE000).w, A1
        move.w  #$0DF, d1
        move.w  ($FFFFEE00).w, d0
        add.w   d2, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        add.w   d2, d0
        neg.w   D0
loc_0062AC:
        move.l  d0, (A1)+
        dbra    d1, loc_0062AC
        rts
loc_0062B4:
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #6, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #$2,d5
        moveq   #0,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.b  #0, ($FFFFEE52).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        andi.l  #$FFFEFFFE, (Vscroll_Factor).w
        lea     ($FFFFE000).w, A1
        move.w  #$06F, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_0062F4:
        move.l  d0, (A1)+
        dbra    d1, loc_0062F4
        move.w  ($FFFFEEB8).w, D4
        ext.l   D4
        asl.l   #6, D4
        add.l   d4, ($FFFFEE28).w
        moveq	#0,d0
        move.w  d0, ($FFFFF620).w
        subi.w  #$0E0, ($FFFFF620).w
        move.w  ($FFFFEE24).w, ($FFFFF61E).w
        subi.w  #$0E0, ($FFFFF61E).w
        andi.l  #$FFFEFFFE, ($FFFFF61E).w
        lea     ($FFFFE1B0).w, A1
        move.w  #$073, d1
        move.w  ($FFFFEE20).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE28).w, d0
        neg.w   D0
loc_00633C:
        move.l  d0, (A1)+
        dbra    d1, loc_00633C
        rts         
Bg_Scroll_HPz: ; loc_006344: ; Hidden Palace Background Scroll 
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #6, D4
        moveq   #$2, D6
        bsr     Scroll_Block2           ; loc_006D1E
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #$7,d5
        moveq   #6, D6
        bsr     Scroll_Block3           ; loc_006D52
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFA800).w, A1
        move.w  ($FFFFEE00).w, D2
        neg.w   D2
        move.w  d2, d0
        asr.w   #1,d0
        move.w  #$007, d1
loc_006378:
        move.w  d0, (a1)+
        dbra    d1, loc_006378
        move.w  d2, d0
        asr.w   #3, d0
        sub.w   d2, d0
        ext.l   D0
        asl.l   #3, d0
        divs.w  #8, d0
        ext.l   D0
        asl.l   #4, d0
        asl.l   #8,d0
        moveq   #0, d3
        move.w  D2, d3
        asr.w   #1, d3
        lea     ($FFFFA860).w, a2
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A1)+
        move.w  d3, (A1)+
        move.w  d3, (A1)+
        move.w  d3, -(A2)
        move.w  d3, -(A2)
        move.w  d3, -(A2)
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A1)+
        move.w  d3, (A1)+
        move.w  d3, -(A2)
        move.w  d3, -(A2)
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A1)+
        move.w  d3, -(A2)
        swap.w  D3
        add.l   d0, d3
        swap.w  D3
        move.w  d3, (A1)+
        move.w  d3, -(A2)
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
        move.w  #$019, d1
loc_0063DA:
        move.w  d0, (a1)+
        dbra    d1, loc_0063DA
        adda.w  #$00E, A1
        move.w  d2, d0
        asr.w   #1,d0
        move.w  #$017, d1
loc_0063EC:
        move.w  d0, (a1)+
        dbra    d1, loc_0063EC
        lea     ($FFFFA800).w, a2
        move.w  ($FFFFEE0C).w, d0
        move.w  d0, D2
        andi.w  #$3F0, d0
        lsr.w   #3, d0
        lea     $00(A2, d0), A2
        bra     loc_006AA8
Bg_Scroll_OOz: ; loc_00640A: ; Oil Ocean Background Scroll               
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #5, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #5,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  #$0DF, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_00643A:
        move.l  d0, (A1)+
        dbra    d1, loc_00643A
        rts
Bg_Scroll_DHz: ; loc_006442: ; Dust Hill Background Scroll        
        tst.w   (Two_player_mode).w
        bne     loc_00656C
        move.w  ($FFFFEE04).w, d0
        move.l  ($FFFFEE0C).w, d3
        tst.b   ($FFFFFE11).w
        bne.s   loc_006462
        divu.w  #$003, d0
        subi.w  #$140, d0
        bra.s   loc_00646A
loc_006462:  
        divu.w  #$006, d0
        subi.w  #$010, d0
loc_00646A:   
        swap.w  D0
        moveq   #6, D6
        bsr     loc_006D5A
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFA800).w, a2
        lea     $001E(A2), A3
        move.w  ($FFFFEE00).w, d0
        ext.l   D0
        asl.l   #4, d0
        divs.w  #$00A, d0
        ext.l   D0
        asl.l   #4, d0
        asl.l   #8,d0
        move.l  d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, Objoff_E(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, y_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $000A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, x_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $0006(a2)
        move.w  d1,x_vel(a2)
        move.w  d1, $001C(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, mappings(a2)
        move.w  d1, $0012(a2)
        move.w  d1, $001A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, art_tile(a2)
        move.w  d1, $14(a2)
        move.w  d1, $0018(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, (a2)
        move.w  d1, y_radius(a2)
        lea     (loc_006554), A3
        lea     ($FFFFA800).w, a2
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE0C).w, d1
        moveq	#0,d0
loc_006526:        
        move.b  (A3)+, D0
        addq.w  #$2, a2
        sub.w   d0, d1
        bcc.s   loc_006526      
        neg.w   d1
        subq.w  #$2, a2
        move.w  #$0DF, D2
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  (A2)+, D0
        neg.w   D0
loc_006542:
        move.l  d0, (A1)+
        subq.w  #1,d1
        bne.s   loc_00654E
        move.b  (A3)+, d1
        move.w  (A2)+, D0
        neg.w   D0
loc_00654E:
        dbra    D2, loc_006542
        rts
loc_006554:
        dc.b    $25, $17, $12, $07, $07, $02, $02, $30, $0D, $13, $20, $40, $20, $13, $0D, $30
        dc.b    $02, $02, $07, $07, $20, $12, $17, $25
loc_00656C:
        moveq	#0,d0
        move.w  ($FFFFEE04).w, d0
        tst.b   ($FFFFFE11).w
        bne.s   loc_006582
        divu.w  #$003, d0
        subi.w  #$140, d0
        bra.s   loc_00658A
loc_006582:
        divu.w  #$006, d0
        subi.w  #$010, d0
loc_00658A:
        move.w  d0, ($FFFFEE0C).w
        move.w  d0, ($FFFFF618).w
        andi.l  #$FFFEFFFE, (Vscroll_Factor).w
        lea     ($FFFFA800).w, a2
        lea     $001E(A2), A3
        move.w  ($FFFFEE00).w, d0
        ext.l   D0
        asl.l   #4, d0
        divs.w  #$00A, d0
        ext.l   D0
        asl.l   #4, d0
        asl.l   #8,d0
        move.l  d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, Objoff_E(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, y_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $000A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, x_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $0006(a2)
        move.w  d1,x_vel(a2)
        move.w  d1, $001C(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, mappings(a2)
        move.w  d1, $0012(a2)
        move.w  d1, $001A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, art_tile(a2)
        move.w  d1, $14(a2)
        move.w  d1, $0018(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, (a2)
        move.w  d1, y_radius(a2)
        lea     (loc_006678), A3
        lea     ($FFFFA800).w, a2
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE0C).w, d1
        lsr.w   #1,d1
        moveq	#0,d0
loc_00664A:
        move.b  (A3)+, D0
        addq.w  #$2, a2
        sub.w   d0, d1
        bcc.s   loc_00664A        
        neg.w   d1
        subq.w  #$2, a2
        move.w  #$06F, D2
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  (A2)+, D0
        neg.w   D0
loc_006666:
        move.l  d0, (A1)+
        subq.w  #1,d1
        bne.s   loc_006672
        move.b  (A3)+, d1
        move.w  (A2)+, D0
        neg.w   D0
loc_006672:
        dbra    D2, loc_006666   
        bra.s   loc_006690
loc_006678:
        dc.b    $13
loc_006679:
        dc.b    $0B, $09, $04, $03, $01, $01, $18, $06, $0A, $10, $20, $10, $0A, $06, $18, $01
        dc.b    $01, $03, $04, $10, $09, $0B, $13
loc_006690:
        moveq	#0,d0
        move.w  ($FFFFEE24).w, d0
        tst.b   ($FFFFFE11).w
        bne.s   loc_0066A6
        divu.w  #$003, d0
        subi.w  #$140, d0
        bra.s   loc_0066AE
loc_0066A6:
        divu.w  #$006, d0
        subi.w  #$010, d0
loc_0066AE:
        move.w  d0, ($FFFFEE2C).w
        move.w  d0, ($FFFFF620).w
        subi.w  #$0E0, ($FFFFF620).w
        move.w  ($FFFFEE24).w, ($FFFFF61E).w
        subi.w  #$0E0, ($FFFFF61E).w
        andi.l  #$FFFEFFFE, ($FFFFF61E).w
        lea     ($FFFFA800).w, a2
        lea     $001E(A2), A3
        move.w  ($FFFFEE20).w, d0
        ext.l   D0
        asl.l   #4, d0
        divs.w  #$00A, d0
        ext.l   D0
        asl.l   #4, d0
        asl.l   #8,d0
        move.l  d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, Objoff_E(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, y_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $000A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, x_pos(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, $0006(a2)
        move.w  d1,x_vel(a2)
        move.w  d1, $001C(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, mappings(a2)
        move.w  d1, $0012(a2)
        move.w  d1, $001A(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, art_tile(a2)
        move.w  d1, $14(a2)
        move.w  d1, $0018(a2)
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, (a2)
        move.w  d1, y_radius(a2)
        lea     loc_006679(PC), A3
        lea     ($FFFFA800).w, a2
        lea     ($FFFFE1B0).w, A1
        move.w  ($FFFFEE2C).w, d1
        lsr.w   #1,d1
        moveq   #$17, d0
        bra.s   loc_006782
loc_006780:
        move.b  (A3)+, D0
loc_006782:        
        addq.w  #$2, a2
        sub.w   d0, d1
        bcc.s   loc_006780
        neg.w   d1
        subq.w  #$2, a2
        move.w  #$073, D2
        move.w  ($FFFFEE20).w, d0
        neg.w   D0
        swap.w  D0
        move.w  (A2)+, D0
        neg.w   D0
loc_00679C:
        move.l  d0, (A1)+
        subq.w  #1,d1  
        bne.s   loc_0067A8
        move.b  (A3)+, d1
        move.w  (A2)+, D0
        neg.w   D0
loc_0067A8:        
        dbra    D2, loc_00679C
        rts         
Bg_Scroll_CNz: ; loc_0067AE: ; Casino Night Background Scroll 
        tst.w   (Two_player_mode).w
        bne     loc_0067F2
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #6, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #$2,d5
        bsr     Scroll_Block1           ; loc_006CB4
        clr.b   ($FFFFEE52).w
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  #$0DF, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_0067EA:
        move.l  d0, (A1)+
        dbra    d1, loc_0067EA
        rts
loc_0067F2:
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #6, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #$2,d5
        moveq   #0,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        andi.l  #$FFFEFFFE, (Vscroll_Factor).w
        lea     ($FFFFE000).w, A1
        move.w  #$06F, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_00682C:
        move.l  d0, (A1)+
        dbra    d1, loc_00682C
        move.w  ($FFFFEEB8).w, D4
        ext.l   D4
        asl.l   #6, D4
        add.l   d4, ($FFFFEE28).w
        moveq	#0,d0
        move.w  d0, ($FFFFF620).w
        subi.w  #$0E0, ($FFFFF620).w
        move.w  ($FFFFEE24).w, ($FFFFF61E).w
        subi.w  #$0E0, ($FFFFF61E).w
        andi.l  #$FFFEFFFE, ($FFFFF61E).w
        lea     ($FFFFE1B0).w, A1
        move.w  #$073, d1
        move.w  ($FFFFEE20).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE28).w, d0
        neg.w   D0
loc_006874:
        move.l  d0, (A1)+
        dbra    d1, loc_006874
        rts         
Bg_Scroll_CPz: ; loc_00687C: ; Chemical Plant Background Scroll
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #5, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #6,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #$7, D4
        moveq   #4, D6
        bsr     Scroll_Block4           ; loc_006D86
        move.w  ($FFFFEE0C).w, d0
        move.w  d0, ($FFFFEE14).w
        move.w  d0, ($FFFFF618).w
        move.b  ($FFFFEE52).w, d0
        or.b    ($FFFFEE54).w, d0
        move.b  d0, ($FFFFEE56).w
        clr.b   ($FFFFEE52).w
        clr.b   ($FFFFEE54).w
        move.b  ($FFFFFE0F).w, d1
        andi.w  #$007, d1
        bne.s   loc_0068CC
        subq.w  #1, ($FFFFA800).w
loc_0068CC:
        lea     (loc_00718F), A0
        move.w  ($FFFFEE0C).w, d0
        move.w  d0, D2
        andi.w  #$3F0, d0
        lsr.w   #4, d0
        lea     $00(A0, d0), A0
        move.w  d0, D4
        lea     ($FFFFE000).w, A1
        move.w  #$00E, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        andi.w  #$F, D2
        move.w  ($FFFFEE08).w, d0
        cmpi.b  #$12, D4
        beq.s   loc_00694A
        bcs.s   loc_006908
        move.w  ($FFFFEE10).w, d0
loc_006908:
        neg.w   D0
        add.w   D2, D2
        jmp     loc_006922(PC, D2)
loc_006910:        
        move.w  ($FFFFEE08).w, d0
        cmpi.b  #$12, D4
        beq.s   loc_006954
        bcs.s   loc_006920
        move.w  ($FFFFEE10).w, d0
loc_006920:
        neg.w   D0
loc_006922:
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        addq.b  #1, D4
        dbra    d1, loc_006910 
        rts
loc_00694A:
        move.w  #$F, d0
        sub.w   d2, d0
        move.w  d0, D2
        bra.s   loc_006958
loc_006954:
        move.w  #$F, D2
loc_006958:
        move.w  ($FFFFEE08).w, d3
        neg.w   D3
        move.w  ($FFFFA800).w, d0
        andi.w  #$01F, d0
        lea     loc_005F60(PC), A2
        lea     $00(A2, d0), A2
loc_00696E:
        move.b  (A2)+, D0
        ext.w   D0
        add.w   d3, d0
        move.l  d0, (A1)+
        dbra    D2, loc_00696E   
        addq.b  #1, D4
        dbra    d1, loc_006910
        rts                 
Bg_Scroll_NGHz: ; loc_006982: ; Neo Green Hill Background Scroll  
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        muls.w  #$119, D4
        moveq   #$2, D6
        bsr     Scroll_Block2           ; loc_006D1E
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #$7,d5
        tst.b   ($FFFFFE11).w
        bne.s   loc_0069A2
        asl.l   #1,d5
loc_0069A2:
        moveq   #6, D6
        bsr     Scroll_Block3           ; loc_006D52
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFA800).w, a2
        lea     $0006(A2), A3
        move.w  ($FFFFEE00).w, d0
        ext.l   D0
        asl.l   #4, d0
        divs.w  #$00A, d0
        ext.l   D0
        asl.l   #4, d0
        asl.l   #8,d0
        move.l  d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d1, d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        swap.w  d1
        add.l   d0, d1
        swap.w  d1
        move.w  d1, (A3)+
        move.w  d1, (a2)
        move.w  d1, mappings(a2)
        move.w  ($FFFFEE08).w, d0
        move.w  d0, art_tile(a2)
        move.w  d0, y_radius(a2)
        move.w  d0, 0(a2)
        move.w  d0, mappings(a2)
        lea     (loc_006A64), A3
        lea     ($FFFFA800).w, a2
        lea     ($FFFFE000).w, A1
        move.w  ($FFFFEE0C).w, d1
        moveq	#0,d0
loc_006A36:        
        move.b  (A3)+, D0
        addq.w  #$2, a2
        sub.w   d0, d1
        bcc.s   loc_006A36 
        neg.w   d1
        subq.w  #$2, a2
        move.w  #$0DF, D2
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  (A2)+, D0
        neg.w   D0
loc_006A52:
        move.l  d0, (A1)+
        subq.w  #1,d1
        bne.s   loc_006A5E
        move.b  (A3)+, d1
        move.w  (A2)+, D0
        neg.w   D0
loc_006A5E:
        dbra    D2, loc_006A52
        rts
loc_006A64:
        dc.b    $B0, $70, $30, $60, $15, $0C, $0E, $06, $0C, $1F, $30, $C0
Bg_Scroll_Null: ; loc_006A70: ; Null Background Scroll
        move.w  ($FFFFEEB0).w, D4
        ext.l   D4
        asl.l   #5, D4
        move.w  ($FFFFEEB2).w,d5
        ext.l   D5
        asl.l   #6,d5
        bsr     Scroll_Block1           ; loc_006CB4
        move.w  ($FFFFEE0C).w, ($FFFFF618).w
        lea     ($FFFFE000).w, A1
        move.w  #$0DF, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        move.w  ($FFFFEE08).w, d0
        neg.w   D0
loc_006AA0:             
        move.l  d0, (A1)+
        dbra    d1, loc_006AA0
        rts        
loc_006AA8:
        lea     ($FFFFE000).w, A1
        move.w  #$00E, d1
        move.w  ($FFFFEE00).w, d0
        neg.w   D0
        swap.w  D0
        andi.w  #$F, D2
        add.w   D2, D2
        move.w  (A2)+, D0
        jmp     loc_006AC6(PC, D2)
loc_006AC4:
        move.w  (A2)+, D0
loc_006AC6:
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        move.l  d0, (A1)+
        dbra    d1, loc_006AC4
        rts                
Scroll_Horizontal: ; loc_006AEC:
        move.w  (A1), D4
        bsr.s   loc_006B12
        move.w  (A1), D0
        andi.w  #$010, d0
        move.b  (a2),d1
        eor.b   d1, d0
        bne.s   loc_006B10
        eori.b  #$10, (a2)
        move.w  (A1), D0
        sub.w   d4, d0
        bpl.s   loc_006B0C
        bset    #$2, (a3)
        rts
loc_006B0C:
        bset    #3, (a3)
loc_006B10:
        rts
loc_006B12:
        move.w  (a5), d1
        beq.s   loc_006B34
        subi.w  #$100, d1
        move.w  d1, (a5)
        moveq   #0,d1
        move.b  (a5), d1
        lsl.b   #$2, d1
        addq.b  #4, d1
        move.w  art_tile(a5), D0
        sub.b   d1, d0
        move.w  $00(a6, d0), D0
        andi.w  #$3FFF, d0
        bra.s   loc_006B38
loc_006B34:
        move.w  x_pos(a0), D0
loc_006B38:
        sub.w   (A1), D0
        subi.w  #$090, d0
        blt.s   loc_006B4A
        subi.w  #$010, d0
        bge.s   loc_006B62
        clr.w   (a4)
        rts
loc_006B4A:
        cmpi.w  #$FFF0, d0
        bgt.s   loc_006B54
        move.w  #$FFF0, d0
loc_006B54:
        add.w   (A1), D0
        cmp.w   ($FFFFEEC8).w, d0
        bgt.s   loc_006B78
        move.w  ($FFFFEEC8).w, d0
        bra.s   loc_006B78
loc_006B62:        
        cmpi.w  #$010, d0
        bcs.s   loc_006B6C
        move.w  #$010, d0
loc_006B6C:
        add.w   (A1), D0
        cmp.w   ($FFFFEECA).w, d0
        blt.s   loc_006B78
        move.w  ($FFFFEECA).w, d0
loc_006B78:
        move.w  d0, d1
        sub.w   (A1), d1
        asl.w   #8, d1
        move.w  d0, (a1)
        move.w  d1, (a4)
        rts
Scroll_Vertical: ; loc_006B84:
        moveq   #0,d1
        move.w  y_pos(a0), D0
        sub.w   (A1), D0
        btst    #$2, status(a0)
        beq.s   loc_006B96
        subq.w  #5, d0
loc_006B96:
        btst    #1, status(a0)
        beq.s   loc_006BB6
        addi.w  #$20, d0
        sub.w   ($FFFFEED8).w, d0
        bcs.s   loc_006C00
        subi.w  #$40, d0
        bcc.s   loc_006C00
        tst.b   ($FFFFEEDE).w
        bne.s   loc_006C12
        bra.s   loc_006BC2
loc_006BB6:
        sub.w   ($FFFFEED8).w, d0
        bne.s   loc_006BC6
        tst.b   ($FFFFEEDE).w
        bne.s   loc_006C12
loc_006BC2:        
        clr.w   (a4)
        rts
loc_006BC6:
        cmpi.w  #$060, ($FFFFEED8).w
        bne.s   loc_006BEE 
        move.w  $14(A0), d1
        bpl.s   loc_006BD6
        neg.w   d1
loc_006BD6:
        cmpi.w  #$800, d1
        bcc.s   loc_006C00
        move.w  #$600, d1
        cmpi.w  #$006, d0
        bgt.s   loc_006C5A
        cmpi.w  #$FFFFFFFA, d0
        blt.s   loc_006C28
        bra.s   loc_006C18
loc_006BEE:
        move.w  #$200, d1
        cmpi.w  #$002, d0
        bgt.s   loc_006C5A
        cmpi.w  #$FFFFFFFE, d0
        blt.s   loc_006C28
        bra.s   loc_006C18    
loc_006C00:
        move.w  #$1000, d1
        cmpi.w  #$010, d0
        bgt.s   loc_006C5A
        cmpi.w  #$FFF0, d0
        blt.s   loc_006C28
        bra.s   loc_006C18
loc_006C12:
        moveq	#0,d0
        move.b  d0, ($FFFFEEDE).w
loc_006C18:        
        moveq   #0,d1
        move.w  d0, d1
        add.w   (A1), d1  
        tst.w   D0
        bpl     loc_006C62
        bra     loc_006C32
loc_006C28:        
        neg.w   d1
        ext.l   d1    
        asl.l   #8, d1
        add.l   (A1), d1
        swap.w  d1
loc_006C32:        
        cmp.w   ($FFFFEECC).w, d1
        bgt.s   loc_006C84
loc_006C38:
        cmpi.w  #$FF00, d1
        bgt.s   loc_006C54
        andi.w  #$7FF, d1
        andi.w  #$7FF, y_pos(a0)
        andi.w  #$7FF, (a1)
        andi.w  #$3FF, x_pos(a1)
        bra.s   loc_006C84
loc_006C54:   
        move.w  ($FFFFEECC).w, d1
        bra.s   loc_006C84             
loc_006C5A:
        ext.l   d1
        asl.l   #8, d1
        add.l   (A1), d1
        swap.w  d1
loc_006C62:        
        cmp.w   ($FFFFEECE).w, d1
        blt.s   loc_006C84
        subi.w  #$800, d1
        bcs.s   loc_006C80
        andi.w  #$7FF, y_pos(a0)
        subi.w  #$800, (a1)
        andi.w  #$3FF, x_pos(a1)
        bra.s   loc_006C84
loc_006C80:
        move.w  ($FFFFEECE).w, d1
loc_006C84:
        move.w  (A1), D4
        swap.w  d1
        move.l  d1, d3
        sub.l   (A1), D3
        ror.l   #8, d3
        move.w  d3, (a4)
        move.l  d1, (a1)
        move.w  (A1), D0
        andi.w  #$010, d0
        move.b  (a2),d1
        eor.b   d1, d0
        bne.s   loc_006CB2
        eori.b  #$10, (a2)
        move.w  (A1), D0
        sub.w   d4, d0
        bpl.s   loc_006CAE
        bset    #0, (a3)
        rts
loc_006CAE:
        bset    #1, (a3)
loc_006CB2:
        rts  
Scroll_Block1: ; loc_006CB4:
        move.l  ($FFFFEE08).w, D2
        move.l  d2, d0
        add.l   d4, d0
        move.l  d0, ($FFFFEE08).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE42).w, d3
        eor.b   d3, d1
        bne.s   loc_006CE8
        eori.b  #$10, ($FFFFEE42).w
        sub.l   d2, d0
        bpl.s   loc_006CE2
        bset    #$2, ($FFFFEE52).w
        bra.s   loc_006CE8
loc_006CE2:
        bset    #3, ($FFFFEE52).w
loc_006CE8:
        move.l  ($FFFFEE0C).w, d3
        move.l  d3, d0
        add.l   d5, d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE43).w, D2
        eor.b   D2, d1
        bne.s   loc_006D1C
        eori.b  #$10, ($FFFFEE43).w
        sub.l   d3, d0
        bpl.s   loc_006D16
        bset    #0, ($FFFFEE52).w
        rts
loc_006D16:
        bset    #1, ($FFFFEE52).w
loc_006D1C:
        rts  
Scroll_Block2: ;loc_006D1E:
        move.l  ($FFFFEE08).w, D2
        move.l  d2, d0
        add.l   d4, d0
        move.l  d0, ($FFFFEE08).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE42).w, d3
        eor.b   d3, d1
        bne.s   loc_006D50
        eori.b  #$10, ($FFFFEE42).w
        sub.l   d2, d0
        bpl.s   loc_006D4A
        bset    d6, ($FFFFEE52).w
        bra.s   loc_006D50
loc_006D4A:
        addq.b  #1, D6
        bset    d6, ($FFFFEE52).w
loc_006D50:
        rts
Scroll_Block3: ; loc_006D52:
        move.l  ($FFFFEE0C).w, d3
        move.l  d3, d0
        add.l   d5, d0
loc_006D5A:        
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE43).w, D2
        eor.b   D2, d1
        bne.s   loc_006D84
        eori.b  #$10, ($FFFFEE43).w
        sub.l   d3, d0
        bpl.s   loc_006D7E
        bset    d6, ($FFFFEE52).w
        rts
loc_006D7E:
        addq.b  #1, D6
        bset    d6, ($FFFFEE52).w
loc_006D84:
        rts
Scroll_Block4: ; loc_006D86:
        move.l  ($FFFFEE10).w, D2
        move.l  d2, d0
        add.l   d4, d0
        move.l  d0, ($FFFFEE10).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE44).w, d3
        eor.b   d3, d1
        bne.s   loc_006DB8
        eori.b  #$10, ($FFFFEE44).w
        sub.l   d2, d0
        bpl.s   loc_006DB2
        bset    d6, ($FFFFEE54).w
        bra.s   loc_006DB8
loc_006DB2:
        addq.b  #1, D6
        bset    d6, ($FFFFEE54).w
loc_006DB8:
        rts          
; Scroll_Block5: ;loc_006DBA:  Left Over GHz S1 Scroll
        move.l  ($FFFFEE18).w, D2
        move.l  d2, d0
        add.l   d4, d0
        move.l  d0, ($FFFFEE18).w
        move.l  d0, d1
        swap.w  d1
        andi.w  #$010, d1
        move.b  ($FFFFEE46).w, d3
        eor.b   d3, d1
        bne.s   loc_006DEC
        eori.b  #$10, ($FFFFEE46).w
        sub.l   d2, d0
        bpl.s   loc_006DE6
        bset    d6, ($FFFFEE56).w
        bra.s   loc_006DEC
loc_006DE6:
        addq.b  #1, D6
        bset    d6, ($FFFFEE56).w
loc_006DEC:
        rts
        lea     ($00C00004), a5
        lea     ($00C00000), a6
        lea     ($FFFFEE52).w, a2
        lea     ($FFFFEE08).w, A3
        lea     ($FFFF8080).w, A4
        move.w  #$6000, D2
        bsr     loc_006F80
        lea     ($FFFFEE54).w, a2
        lea     ($FFFFEE10).w, A3
        bra     loc_007050                                     
LoadTilesAsYouMove: ; loc_006E1A:
        lea     ($00C00004), a5
        lea     ($00C00000), a6
        lea     ($FFFFEEA2).w, a2
        lea     ($FFFFEE68).w, A3   
        lea     ($FFFF8080).w, A4
        move.w  #$6000, D2 
        bsr     loc_006F80
        lea     ($FFFFEEA4).w, a2
        lea     ($FFFFEE70).w, A3 
        bsr     loc_007050
        lea     ($FFFFEEA6).w, a2
        lea     ($FFFFEE78).w, A3 
        bsr     loc_007140
        tst.w   (Two_player_mode).w
        beq.s   loc_006E6C
        lea     ($FFFFEEA8).w, a2
        lea     ($FFFFEE80).w, A3 
        lea     ($FFFF8000).w, A4
        move.w  #$6000, D2 
        bsr     loc_006F1A
loc_006E6C:        
        lea     ($FFFFEEA0).w, a2
        lea     ($FFFFEE60).w, A3 
        lea     ($FFFF8000).w, A4
        move.w  #$4000, D2 
        tst.b   ($FFFFF720).w
        beq.s   loc_006EB4
        move.b  #0, ($FFFFF720).w
        moveq   #$FFFFFFF0, D4
        moveq   #$F, D6
loc_006E8C        
        movem.l D4-d6, -(A7)
        moveq   #$FFFFFFF0,d5
        move.w  d4, d1
        bsr     loc_007644
        move.w  d1, D4 
        moveq   #$FFFFFFF0,d5
        bsr     loc_007350
        movem.l (A7)+, D4-D6 
        addi.w  #$010, D4
        dbra    d6, loc_006E8C
        move.b  #0, ($FFFFEEA0).w
        rts
loc_006EB4:
        tst.b   (a2)
        beq.s   loc_006F18
        bclr    #0, (a2)
        beq.s   loc_006ECE
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5  
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5 
        bsr     loc_007350
loc_006ECE:         
        bclr    #1, (a2)
        beq.s   loc_006EE8
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5 
        bsr     loc_007644
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5 
        bsr     loc_007350
loc_006EE8:    
        bclr    #$2, (a2)
        beq.s   loc_006EFE
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_0072C2
loc_006EFE: 
        bclr    #3, (a2)
        beq.s   loc_006F18
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_0072C2
loc_006F18: 
        rts        
loc_006F1A: 
        tst.b   (a2)
        beq.s   loc_006F7E
        bclr    #0, (a2)
        beq.s   loc_006F34
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007680
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007350
loc_006F34:  
        bclr    #1, (a2)
        beq.s   loc_006F4E
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007680
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007350
loc_006F4E: 
        bclr    #$2, (a2)
        beq.s   loc_006F64
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007680
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_0072C2
loc_006F64:   
        bclr    #3, (a2)
        beq.s   loc_006F7E
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_007680
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_0072C2
loc_006F7E:   
        rts                    
loc_006F80: 
        tst.b   (a2)
        beq     loc_00704E
        bclr    #0, (a2)
        beq.s   loc_006F9C 
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007350
loc_006F9C:      
        bclr    #1, (a2)
        beq.s   loc_006FB6
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007350
loc_006FB6:    
        bclr    #$2, (a2)
        beq.s   loc_006FCC
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_0072C2           
loc_006FCC:    
        bclr    #3, (a2)
        beq.s   loc_006FE6
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        move.w  #$140,d5
        bsr     loc_0072C2
loc_006FE6:     
        bclr    #4, (a2)
        beq.s   loc_006FFE
        moveq   #$FFFFFFF0, D4
        moveq   #0,d5
        bsr     loc_007646
        moveq   #$FFFFFFF0, D4
        moveq   #0,d5
        moveq   #$1F, D6
        bsr     loc_007354          
loc_006FFE:     
        bclr    #5, (a2)
        beq.s   loc_00701A
        move.w  #$0E0, D4
        moveq   #0,d5
        bsr     loc_007646
        move.w  #$0E0, D4
        moveq   #0,d5
        moveq   #$1F, D6
        bsr     loc_007354 
loc_00701A:    
        bclr    #6, (a2)
        beq.s   loc_007032
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        moveq   #$1F, D6
        bsr     loc_007348
loc_007032:    
        bclr    #$7, (a2)
        beq.s   loc_00704E
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644  
        move.w  #$0E0, D4
        moveq   #$FFFFFFF0,d5
        moveq   #$1F, D6
        bsr     loc_007348
loc_00704E:
        rts         
loc_007050:  
        tst.b   (a2)
        beq     loc_007092
        bclr    #0, (a2)
        beq.s   loc_007072
        move.w  #$070, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644 
        move.w  #$070, D4
        moveq   #$FFFFFFF0,d5
        moveq   #$2, D6
        bsr     loc_0072C4           
loc_007072:  
        bclr    #1, (a2)
        beq.s   loc_007092
        move.w  #$070, D4
        move.w  #$140,d5
        bsr     loc_007644 
        move.w  #$070, D4
        move.w  #$140,d5
        moveq   #$2, D6
        bsr     loc_0072C4
loc_007092:     
        rts

loc_007094:
        dc.b    $00
loc_007095:
        dc.b    $00, $00, $00, $00, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $04, $04
        dc.b    $04, $04, $04, $04, $04, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
        dc.b    $00        
;loc_0070B6:
        moveq   #$FFFFFFF0, D4
        bclr    #0, (a2)
        bne.s   loc_0070C8
        bclr    #1, (a2)
        beq.s   loc_007110
        move.w  #$0E0, D4
loc_0070C8:
        lea     loc_007095(PC), A0
        move.w  ($FFFFEE0C).w, d0
        add.w   d4, d0
        andi.w  #$1F0, d0
        lsr.w   #4, d0
        move.b  $00(A0, d0), D0
        lea     (loc_00723C), A3
        move.w  $00(A3, d0), A3
        beq.s   loc_0070FC
        moveq   #$FFFFFFF0,d5
        movem.l D4/d5, -(A7)
        bsr     loc_007644
        movem.l (A7)+, D4/D5
        bsr     loc_007350
        bra.s   loc_007110
loc_0070FC:
        moveq   #0,d5
        movem.l D4/d5, -(A7)
        bsr     loc_007646
        movem.l (A7)+, D4/D5
        moveq   #$1F, D6
        bsr     loc_007354
loc_007110:
        tst.b   (a2)
        bne.s   loc_007116
        rts
loc_007116:
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        move.b  (A2), D0
        andi.b  #$A8, d0
        beq.s   loc_00712A
        lsr.b   #1,d0
        move.b  d0, (a2)
        move.w  #$140,d5
loc_00712A:
        lea     loc_007094(PC), A0
        move.w  ($FFFFEE0C).w, d0
        andi.w  #$1F0, d0
        lsr.w   #4, d0
        lea     $00(A0, d0), A0
        bra     loc_007244        
loc_007140:
        tst.b   (a2)
        beq     loc_00718C
        cmpi.b  #$D, (Current_ZoneAndAct).w
        beq     loc_0071D0
        bclr    #0, (a2)
        beq.s   loc_00716C
        move.w  #$40, D4
        moveq   #$FFFFFFF0,d5
        bsr     loc_007644 
        move.w  #$40, D4
        moveq   #$FFFFFFF0,d5
        moveq   #$2, D6
        bsr     loc_0072C4
loc_00716C: 
        bclr    #1, (a2)
        beq.s   loc_00718C
        move.w  #$40, D4
        move.w  #$140,d5
        bsr     loc_007644 
        move.w  #$40, D4
        move.w  #$140,d5
        moveq   #$2, D6
        bsr     loc_0072C4
loc_00718C:
        rts
loc_00718E:         
        dc.b    $02 
loc_00718F:  
        dc.b    $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
        dc.b    $02, $02, $02, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $00    ; filler           
loc_0071D0:    
        moveq   #$FFFFFFF0, D4
        bclr    #0, (a2)
        bne.s   loc_0071E2
        bclr    #1, (a2) 
        beq.s   loc_00720C
        move.w  #$0E0, D4
loc_0071E2:         
        lea     loc_00718F(PC), A0
        move.w  ($FFFFEE0C).w, d0
        add.w   d4, d0
        andi.w  #$3F0, d0 
        lsr.w   #4, d0
        move.b  $00(A0, d0), D0
        move.w  loc_00723C(pc,d0), A3
        moveq   #$FFFFFFF0,d5
        movem.l D4-d5, -(A7)         
        bsr     loc_007644
        movem.l (A7)+, D4-D5
        bsr     loc_007350
loc_00720C: 
        tst.b   (a2)
        bne.s   loc_007212
        rts 
loc_007212:
        moveq   #$FFFFFFF0, D4
        moveq   #$FFFFFFF0,d5
        move.b  (A2), D0
        andi.b  #$A8, d0
        beq.s   loc_007226
        lsr.b   #1,d0
        move.b  d0, (a2)
        move.w  #$140,d5
loc_007226:        
        lea     loc_00718E(PC), A0
        move.w  ($FFFFEE0C).w, d0
        andi.w  #$7F0, d0
        lsr.w   #4, d0
        lea     $00(A0, d0), A0
        bra     loc_007244
loc_00723C: 
        dc.w    $EE68, $EE68, $EE70, $EE78
loc_007244:
        tst.w   (Two_player_mode).w   
        bne.s   loc_007286
        moveq   #$F, D6
        move.l  #$0800000, D7
loc_007252:        
        moveq	#0,d0
        move.b  (A0)+, D0
        btst    d0, (a2)
        beq.s   loc_00727A
        move.w  loc_00723C(pc,d0), A3
        movem.l D4-D5/A0, -(A7) 
        movem.l D4-d5, -(A7) 
        bsr     loc_007602
        movem.l (A7)+, D4-D5
        bsr     loc_007644
        bsr     loc_007532
        movem.l (A7)+, D4-D5/A0
loc_00727A:   
        addi.w  #$010, D4
        dbra    d6,  loc_007252  
        clr.b   (a2)
        rts          
loc_007286:      
        moveq   #$F, D6
        move.l  #$0800000, D7 
loc_00728E:
        moveq	#0,d0
        move.b  (A0)+, D0
        btst    d0, (a2)
        beq.s   loc_0072B6
        move.w  loc_00723C(pc,d0), A3
        movem.l D4-D5/A0, -(A7) 
        movem.l D4-d5, -(A7) 
        bsr     loc_007602
        movem.l (A7)+, D4-D5
        bsr     loc_007644
        bsr     loc_0075B8
        movem.l (A7)+, D4-D5/A0
loc_0072B6:  
        addi.w  #$010, D4
        dbra    d6,  loc_00728E  
        clr.b   (a2)
        rts                     
loc_0072C2:
        moveq   #$F, D6
loc_0072C4:
        add.w   (A3), D5
        add.w   mappings(A3), D4
        move.l  #$0800000, D7 
        move.l  d0, d1
        bsr     loc_00745C
        tst.w   (Two_player_mode).w
        bne.s   loc_007312
loc_0072DC:        
        move.w  (A0), D3
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        lea     (Block_Table).w, A1
        adda.w  d3, A1
        move.l  d1, d0
        bsr     loc_007532
        adda.w  #$010, A0
        addi.w  #$100, d1
        andi.w  #$FFF, d1
        addi.w  #$010, D4
        move.w  d4, d0
        andi.w  #$070, d0
        bne.s   loc_00730C
        bsr     loc_00745C
loc_00730C:         
        dbra    d6, loc_0072DC
        rts        
loc_007312:     
        move.w  (A0), D3
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        lea     (Block_Table).w, A1
        adda.w  d3, A1
        move.l  d1, d0
        bsr     loc_0075B8
        adda.w  #$010, A0
        addi.w  #$080, d1
        andi.w  #$FFF, d1
        addi.w  #$010, D4
        move.w  d4, d0
        andi.w  #$070, d0
loc_00733C:        
        bne.s   loc_007342
        bsr     loc_00745C
loc_007342:
        dbra    d6, loc_007312
        rts
loc_007348:
        add.w   (A3), D5
        add.w   mappings(A3), D4
        bra.s   loc_007358
loc_007350:
        moveq   #$15, D6
        add.w   (A3), D5
loc_007354:        
        add.w   mappings(A3), D4  
loc_007358:         
        tst.w   (Two_player_mode).w
        bne.s   loc_0073D6
        move.l  A2, -(A7)
        move.w  d6, -(A7)
        lea     ($FFFFEF00).w, a2
        move.l  d0, d1
        or.w    D2, d1
        swap.w  d1
        move.l  d1, -(A7)
        move.l  d1, (a5)
        swap.w  d1
        bsr     loc_00745C
loc_007376:            
        move.w  (A0), D3              
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        lea     (Block_Table).w, A1
        adda.w  d3, A1
        bsr     loc_007492
        addq.w  #$2, A0
        addq.b  #4, d1
        bpl.s   loc_007398
        andi.b  #$7F, d1
        swap.w  d1
        move.l  d1, (a5)
        swap.w  d1
loc_007398:
        addi.w  #$010,d5
        move.w  d5, d0
        andi.w  #$070, d0
        bne.s   loc_0073A8
        bsr     loc_00745C  
loc_0073A8:
        dbra    d6, loc_007376   
        move.l  (A7)+, d1
        addi.l  #$0800000, d1
        lea     ($FFFFEF00).w, a2   
        move.l  d1, (a5)
        swap.w  d1
        move.w  (A7)+, D6  
loc_0073BE:
        move.l  (A2)+, (a6)
        addq.b  #4, d1
        bmi.s   loc_0073CE
        ori.b   #$80, d1
        swap.w  d1
        move.l  d1, (a5)
        swap.w  d1
loc_0073CE:
        dbra    d6, loc_0073BE
        move.l  (A7)+, A2
        rts
loc_0073D6:
        move.l  d0, d1
        or.w    D2, d1
        swap.w  d1
        move.l  d1, (a5)
        swap.w  d1
        tst.b   d1
        bmi.s   loc_007420
        bsr     loc_00745C
loc_0073E8:        
        move.w  (A0), D3
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        lea     (Block_Table).w, A1
        adda.w  d3, A1
        bsr     loc_0074F4
        addq.w  #$2, A0
        addq.b  #4, d1
        bpl.s   loc_00740A
        andi.b  #$7F, d1
        swap.w  d1
        move.l  d1, (a5)
        swap.w  d1
loc_00740A:
        addi.w  #$010,d5
        move.w  d5, d0
        andi.w  #$070, d0
        bne.s   loc_00741A
        bsr     loc_00745C
loc_00741A:
        dbra    d6, loc_0073E8
        rts 
loc_007420:
        bsr     loc_00745C
loc_007424:        
        move.w  (A0), D3
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        lea     (Block_Table).w, A1
        adda.w  d3, A1
        bsr     loc_0074F4
        addq.w  #$2, A0
        addq.b  #4, d1
        bmi.s   loc_007446
        ori.b   #$80, d1
        swap.w  d1
        move.l  d1, (a5)
        swap.w  d1
loc_007446:
        addi.w  #$010,d5
        move.w  d5, d0
        andi.w  #$070, d0
        bne.s   loc_007456
        bsr     loc_00745C
loc_007456:
        dbra    d6, loc_007424
        rts        
loc_00745C:               
        movem.l D4-d5, -(A7)
        move.w  d4, d3
        add.w   d3, d3
        andi.w  #$F00, d3
        lsr.w   #3,d5
        move.w  d5, d0
        lsr.w   #4, d0
        andi.w  #$07F, d0
        add.w   d3, d0
        moveq   #$FFFFFFFF, d3
        clr.w   D3
        move.b  $00(A4, d0), D3
        lsl.w   #7, d3
        andi.w  #$070, D4
        andi.w  #$00E,d5
        add.w   d4, d3
        add.w   d5, d3
        move.l  d3, A0
        movem.l (A7)+, D4-D5
        rts  
loc_007492:
        btst    #3, (a0)
        bne.s   loc_0074BE
        btst    #$2, (a0)
        bne.s   loc_0074A4
        move.l  (A1)+, (a6)
        move.l  (A1)+, (A2)+
        rts
loc_0074A4:
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (a6)
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (A2)+
        rts
loc_0074BE:
        btst    #$2, (a0)
        bne.s   loc_0074DA
        move.l  (A1)+, D0
        move.l  (A1)+, D3
        eori.l  #$10001000, d3
        move.l  d3, (a6)
        eori.l  #$10001000, d0
        move.l  d0, (A2)+
        rts
loc_0074DA:
        move.l  (A1)+, D0
        move.l  (A1)+, D3
        eori.l  #$18001800, d3
        swap.w  D3
        move.l  d3, (a6)
        eori.l  #$18001800, d0
        swap.w  D0
        move.l  d0, (A2)+
        rts  
loc_0074F4:
        btst    #3, (a0)
        bne.s   loc_007512
        btst    #$2, (a0)
        bne.s   loc_007504
        move.l  (A1)+, (a6)
        rts
loc_007504:
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (a6)
        rts
loc_007512:
        btst    #$2, (a0)
        bne.s   loc_007524
        move.l  (A1)+, D3
        eori.l  #$10001000, d3
        move.l  d3, (a6)
        rts
loc_007524:
        move.l  (A1)+, D3
        eori.l  #$18001800, d3
        swap.w  D3
        move.l  d3, (a6)
        rts
loc_007532:
        or.w    d2, d0
        swap.w  D0
        btst    #3, (a0)
        bne.s   loc_00756E
        btst    #$2, (a0)
        bne.s   loc_00754E
        move.l  d0, (a5)
        move.l  (A1)+, (a6)
        add.l   d7, d0
        move.l  d0, (a5)
        move.l  (A1)+, (a6)
        rts
loc_00754E:
        move.l  d0, (a5)
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (a6)
        add.l   d7, d0
        move.l  d0, (a5)
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (a6)
        rts
loc_00756E:
        btst    #$2, (a0)
        bne.s   loc_007594
        move.l  d5, -(A7)
        move.l  d0, (a5)
        move.l  (A1)+, D5
        move.l  (A1)+, D3
        eori.l  #$10001000, d3
        move.l  d3, (a6)
        add.l   d7, d0
        move.l  d0, (a5)
        eori.l  #$10001000,d5
        move.l  d5, (a6)
        move.l  (A7)+, D5
        rts
loc_007594:
        move.l  d5, -(A7)
        move.l  d0, (a5)
        move.l  (A1)+, D5
        move.l  (A1)+, D3
        eori.l  #$18001800, d3
        swap.w  D3
        move.l  d3, (a6)
        add.l   d7, d0
        move.l  d0, (a5)
        eori.l  #$18001800,d5
        swap.w  D5
        move.l  d5, (a6)
        move.l  (A7)+, D5
        rts
loc_0075B8:
        or.w    d2, d0
        swap.w  D0
        btst    #3, (a0)
        bne.s   loc_0075DE
        btst    #$2, (a0)
        bne.s   loc_0075CE
        move.l  d0, (a5)
        move.l  (A1)+, (a6)
        rts
loc_0075CE:
        move.l  d0, (a5)
        move.l  (A1)+, D3
        eori.l  #$8000800, d3
        swap.w  D3
        move.l  d3, (a6)
        rts
loc_0075DE:
        btst    #$2, (a0)
        bne.s   loc_0075F2
        move.l  d0, (a5)
        move.l  (A1)+, D3
        eori.l  #$10001000, d3
        move.l  d3, (a6)
        rts
loc_0075F2:
        move.l  d0, (a5)
        move.l  (A1)+, D3
        eori.l  #$18001800, d3
        swap.w  D3
        move.l  d3, (a6)
        rts
loc_007602:
        add.w   (A3), D5
        add.w   mappings(A3), D4
        lea     (Block_Table).w, A1
        move.w  d4, d3
        add.w   d3, d3
        andi.w  #$F00, d3
        lsr.w   #3,d5
        move.w  d5, d0
        lsr.w   #4, d0
        andi.w  #$07F, d0
        add.w   d3, d0
        moveq   #$FFFFFFFF, d3
        clr.w   D3
        move.b  $00(A4, d0), D3
        lsl.w   #$7, d3
        andi.w  #$070, D4
        andi.w  #$00E,d5
        add.w   d4, d3
        add.w   d5, d3
        move.l  d3, A0
        move.w  (A0), D3
        andi.w  #$3FF, d3
        lsl.w   #3, d3
        adda.w  d3, A1
        rts
loc_007644:
        add.w   (A3), D5   
loc_007646:
        tst.w   (Two_player_mode).w
        bne.s   loc_007666
        add.w   mappings(A3), D4
        andi.w  #$0F0, D4
        andi.w  #$1F0,d5
        lsl.w   #4, D4
        lsr.w   #$2,d5
        add.w   d5, D4
        moveq   #3, d0
        swap.w  D0
        move.w  d4, d0
        rts
loc_007666:
        add.w   mappings(A3), D4
loc_00766A:        
        andi.w  #$1F0, D4
        andi.w  #$1F0,d5  
        lsl.w   #3, D4
        lsr.w   #2,d5
        add.w   d5, D4
        moveq   #3, d0
        swap.w  D0
        move.w  d4, d0
        rts
loc_007680:
        tst.w   (Two_player_mode).w
        bne.s   loc_0076A2
        add.w   mappings(A3), D4
        add.w   (A3), D5
        andi.w  #$0F0, D4
        andi.w  #$1F0,d5
        lsl.w   #4, D4
        lsr.w   #2,d5
        add.w   d5, D4
        moveq   #$2, d0
        swap.w  D0
        move.w  d4, d0
        rts
loc_0076A2:
        add.w   mappings(A3), D4
        add.w   (A3), D5
        andi.w  #$1F0, D4
        andi.w  #$1F0,d5
        lsl.w   #3, D4
        lsr.w   #2,d5
        add.w   d5, D4
        moveq   #$2, d0
        swap.w  D0
        move.w  d4, d0
        rts  
Load_Tiles_From_Start: ; loc_0076BE:
        lea     ($00C00004), a5
        lea     ($00C00000), a6
        tst.w   (Two_player_mode).w
        beq.s   loc_0076DE
        lea     ($FFFFEE20).w, A3
        lea     ($FFFF8000).w, A4
        move.w  #$6000, D2
        bsr.s   loc_00773A
loc_0076DE:
        lea     ($FFFFEE00).w, A3
        lea     ($FFFF8000).w, A4
        move.w  #$4000, D2
        bsr.s   loc_00770A
        lea     ($FFFFEE08).w, A3
        lea     ($FFFF8080).w, A4
        move.w  #$6000, D2
        tst.w   (Two_player_mode).w
        beq     loc_00770A
        cmpi.b  #$B, (Current_ZoneAndAct).w
        beq     loc_00776A
loc_00770A:
        moveq   #$FFFFFFF0, D4
        moveq   #$F, D6
loc_00770E        
        movem.l D4-d6, -(A7)
        moveq   #0,d5
        move.w  d4, d1
        bsr     loc_007644
        move.w  d1, D4
        moveq   #0,d5
        moveq   #$1F, D6
        move    #$2700, SR
        bsr     loc_007348
        move    #$2300, SR
        movem.l (A7)+, D4-D6
        addi.w  #$010, D4
        dbra    d6, loc_00770E
        rts          
loc_00773A:
        moveq   #$FFFFFFF0, D4
        moveq   #$F, D6
loc_00773E        
        movem.l D4-d6, -(A7)
        moveq   #0,d5
        move.w  d4, d1
        bsr     loc_007680
        move.w  d1, D4
        moveq   #0,d5
        moveq   #$1F, D6
        move    #$2700, SR
        bsr     loc_007348
        move    #$2300, SR
        movem.l (A7)+, D4-D6
        addi.w  #$010, D4
        dbra    d6, loc_00773E
        rts     
loc_00776A:
        moveq   #0, D4
        moveq   #$1F, D6
loc_00776E:
        movem.l D4-d6, -(A7)
        moveq   #0,d5
        move.w  d4, d1
        bsr     loc_00766A
        move.w  d1, D4
        moveq   #0,d5
        moveq   #$1F, D6
        move    #$2700, SR
        bsr     loc_007358
        move    #$2300, SR
        movem.l (A7)+, D4-D6
        addi.w  #$010, D4
        dbra    d6, loc_00776E
        rts  
        
;=============================================================================== 
; Beginning of Sub Main_Level_Load_16_128_Blocks                
;===============================================================================            
Main_Level_Load_16_128_Blocks: ; loc_00779A: Load 16x16/128x128 Tiles
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        add.w   d0, d0
        move.w  d0, d1
        add.w   d0, d0
        add.w   d1, d0
        lea     (TilesMainTable), A2    ; loc_024354
        lea     $00(A2, d0), A2
        move.l  A2, -(A7)
        addq.w  #4, a2
        move.l  (A2)+, A0
        bra.s   Main_Level_Load_Blocks_Convert16 ; loc_0077CA
;===============================================================================
; loc_0077BC:        
        lea     (Block_Table).w, A1       ; 16x16 Tiles
        move.w  #0, d0
        bsr     EnigmaDec               ; loc_0018DA
        bra.s   loc_0077EE
;===============================================================================        
Main_Level_Load_Blocks_Convert16: ; loc_0077CA:
        lea     (Block_Table).w, A1
        move.w  #$BFF, D2
Main_Level_Load_16_Blocks_Loop: ; loc_0077D2:
        move.w  (A0)+, D0
        tst.w   (Two_player_mode).w
        beq.s   Main_Level_Load_16_Blocks_Not2p ; loc_0077E8
        move.w  d0, d1
        andi.w  #$F800, d0
        andi.w  #$7FF, d1
        lsr.w   #1,d1
        or.w    d1, d0
Main_Level_Load_16_Blocks_Not2p: ; loc_0077E8:        
        move.w  d0, (a1)+
        dbra    D2, Main_Level_Load_16_Blocks_Loop ; loc_0077D2    
loc_0077EE:    
        cmpi.b  #$7, (Current_ZoneAndAct).w
        bne.s   loc_007820
        lea     ($FFFF9980).w, A1
        lea     (Hill_Top_16x16_Map), A0 ; loc_084A50
        move.w  #$3FF, D2
loc_007804:           
        move.w  (A0)+, D0
        tst.w   (Two_player_mode).w
        beq.s   loc_00781A
        move.w  d0, d1
        andi.w  #$F800, d0
        andi.w  #$7FF, d1
        lsr.w   #1,d1
        or.w    d1, d0
loc_00781A:
        move.w  d0, (a1)+
        dbra    D2, loc_007804 
loc_007820:        
        move.l  (A2)+, A0
        lea     ($FFFF0000), A1         ; 128x128 Tiles
        bsr     KosinskiDec             ; loc_001A58
        bra.s   Load_Level_Sprites      ; loc_00785E 
;=============================================================================== 
; End of Sub Main_Level_Load_16_128_Blocks              
;===============================================================================         
        
;=============================================================================== 
; Beginning of Sub Unused #1                
;===============================================================================          
;loc_00782E:
        bra.s   loc_00784E        
;loc_007830:
        moveq   #0,d1
        moveq   #0, D2
        move.w  (A0)+, D0
        lea     $00(A0, d0), A1
        lea     ($FFFF0000), A2
        lea     ($FFFF8000).w, A3
loc_007844:
        bsr     UnknownDec              ; loc_001AF8
        tst.w   D0
        bmi.s   loc_007844
        bra.s   Load_Level_Sprites      ; loc_00785E
loc_00784E:
        lea     ($FFFF0000), A1
        move.w  #$3FFF, d0
loc_007858:        
        move.w  (A0)+, (A1)+
        dbra    d0, loc_007858
;=============================================================================== 
; End of Sub Unused #1             
;===============================================================================            

;=============================================================================== 
; Beginning of Sub Load_Level_Sprites                
;===============================================================================          
Load_Level_Sprites: ; loc_00785E: ; Load Palette for Levels
        bsr     Load_Level_Layout ; loc_007886
        move.l  (A7)+, A2
        addq.w  #4, a2
        moveq	#0,d0
        move.b  (A2), D0
        beq.s   Load_Level_Palete       ; loc_007870
        bsr     LoadPLC         ; loc_00173C
;=============================================================================== 
; End of Sub Load_Level_Sprites              
;=============================================================================== 
           
;=============================================================================== 
; Beginning of Sub Load_Level_Palete                
;===============================================================================        
Load_Level_Palete: ; loc_007870:        
        addq.w  #4, a2
        moveq	#0,d0
        move.b  (A2), D0
        cmpi.w  #$C01, (Current_ZoneAndAct).w
        bne.s   loc_007880         
        moveq   #$A, d0        
loc_007880:
        bsr     PalLoad1        ; loc_0028E2
        rts  
;=============================================================================== 
; End of Sub Load_Level_Palete               
;===============================================================================
                      
;=============================================================================== 
; Beginning of Sub Load_Level_Layout                 
;===============================================================================
Load_Level_Layout: ; loc_007886: ; Load Level Layout
        lea     ($FFFF8000).w, A3 ; Level Layout
        move.w  #$3FF, d1
        moveq	#0,d0 
loc_007890:
        move.l  d0, (A3)+
        dbra    d1, loc_007890
        lea     ($FFFF8000).w, A3 ; Foreground
        moveq   #0,d1
        bsr     Interleave_Level_Layout ; loc_0078A6
        lea     ($FFFF8080).w, A3 ; Background
        moveq   #$2, d1
Interleave_Level_Layout: ; loc_0078A6:        
        moveq	#0,d0
        move.w  (Current_Zone).w, d0
        ror.b   #1,d0
        lsr.w   #5, d0
        add.w   d1, d0
        lea     (Level_Layout), A1   ; loc_03334E
        move.w  $00(A1, d0), D0
        lea     $00(A1, d0.l), A1
        moveq   #0,d1
        move.w  d1, D2
        move.b  (A1)+, d1
        move.b  (A1)+, D2
        move.l  d1,d5
        addq.l  #1,d5
        moveq   #0, d3
        move.w  #$080, d3
        divu.w  d5, d3
        subq.w  #1, d3
loc_0078D6:        
        move.l  A3, A0
        move.w  d3, D4
loc_0078DA:        
        move.l  A1, -(A7)
        move.w  d1, d0
loc_0078DE:        
        move.b  (A1)+, (A0)+  
        dbra    d0, loc_0078DE
        move.l  (A7)+, A1
        dbra    d4, loc_0078DA 
        lea     $00(A1,d5), A1
        lea     $0100(A3), A3
        dbra    D2, loc_0078D6
        rts
;=============================================================================== 
; End of Sub Load_Level_Layout                
;===============================================================================

;=============================================================================== 
; Beginning of Sub Unused #2                
;===============================================================================         
;loc_0078F8:
        lea     ($00FE0000), A1
        lea     ($00FE0080), A2
        lea     ($FFFF0000), A3
        move.w  #$03F, d1
loc_00790E:        
        bsr     loc_0079A0
        bsr     loc_0079A0
        dbra    d1, loc_00790E
        lea     ($00FE0000), A1
        lea     ($00FF0000), A2
        move.w  #$03F, d1
loc_00792A:        
        move.w  #0, (A2)+
        dbra    d1, loc_00792A
        move.w  #$3FBF, d1
loc_007936:          
        move.w  (A1)+, (A2)+
        dbra    d1, loc_007936
        rts
        lea     ($00FE0000), A1
        lea     ($FFFF0000), A3
        moveq   #$1F, d0
loc_00794C:              
        move.l  (A1)+, (A3)+
        dbra    d0, loc_00794C
        moveq   #0, D7
        lea     ($00FE0000), A1
        move.w  #$0FF,d5
loc_00795E:        
        lea     ($FFFF0000), A3
        move.w  d7, D6
loc_007966:        
        movem.l A1-A3, -(A7)
        move.w  #$03F, d0
loc_00796E:        
        cmpm.w  (A1)+, (A3)+
        bne.s   loc_007984
        dbra    d0, loc_00796E
        movem.l (A7)+, A1-A3
        adda.w  #$080, A1
        dbra    d5, loc_00795E
        bra.s   loc_00799E
loc_007984:
        movem.l (A7)+, A1-A3
        adda.w  #$080, A3
        dbra    d6, loc_007966
        moveq   #$1F, d0
loc_007992:        
        move.l  (A1)+, (A3)+
        dbra    d0, loc_007992
        addq.l  #1, D7
        dbra    d5, loc_00795E
loc_00799E:
        bra.s   loc_00799E
loc_0079A0:
        moveq   #$7, d0
loc_0079A2:        
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A1)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        move.l  (A3)+, (A2)+
        dbra    d0, loc_0079A2
        adda.w  #$080, A1
        adda.w  #$080, a2
        rts            
;=============================================================================== 
; End of Sub Unused #2                 
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub Dyn_Screen_Boss_Loader                 
;===============================================================================            
Dyn_Screen_Boss_Loader: ; loc_0079C0: ; Boss Loader / Level Dynamic Resize
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        move.w  DynResize_Index(pc,d0), D0 ; loc_007A26
        jsr     DynResize_Index(pc,d0)     ; loc_007A26
        moveq   #$2, d1
        move.w  ($FFFFEEC6).w, d0
        sub.w   ($FFFFEECE).w, d0
        beq.s   loc_0079FE
        bcc.s   loc_007A00
        neg.w   d1
        move.w  ($FFFFEE04).w, d0
        cmp.w   ($FFFFEEC6).w, d0
        bls.s   loc_0079F4
        move.w  d0, ($FFFFEECE).w
        andi.w  #$FFFFFFFE, ($FFFFEECE).w
loc_0079F4:
        add.w   d1, ($FFFFEECE).w
        move.b  #1, ($FFFFEEDE).w
loc_0079FE:
        rts
loc_007A00:
        move.w  ($FFFFEE04).w, d0
        addi.w  #8, d0
        cmp.w   ($FFFFEECE).w, d0
        bcs.s   loc_007A1A
        btst    #1, ($FFFFB022).w
        beq.s   loc_007A1A
        add.w   d1, d1
        add.w   d1, d1
loc_007A1A:
        add.w   d1, ($FFFFEECE).w
        move.b  #1, ($FFFFEEDE).w
        rts
DynResize_Index: ; loc_007A26:
        dc.w    loc_007A48-DynResize_Index
        dc.w    loc_007AD8-DynResize_Index
        dc.w    loc_007ADA-DynResize_Index
        dc.w    loc_007ADC-DynResize_Index
        dc.w    loc_007ADE-DynResize_Index
        dc.w    loc_007AE0-DynResize_Index
        dc.w    loc_007AE2-DynResize_Index
        dc.w    loc_007AE4-DynResize_Index
        dc.w    loc_007FC8-DynResize_Index
        dc.w    loc_007FCA-DynResize_Index
        dc.w    loc_007FCC-DynResize_Index
        dc.w    loc_007FCE-DynResize_Index
        dc.w    DynResize_CNz-DynResize_Index  ; loc_007FD0
        dc.w    DynResize_CPz-DynResize_Index  ; loc_007FD2
        dc.w    DynResize_GCz-DynResize_Index  ; loc_007FD4
        dc.w    DynResize_NGHz-DynResize_Index ; loc_007FD6
        dc.w    DynResize_DEz-DynResize_Index  ; loc_007FD8
loc_007A48:
        tst.b   ($FFFFFE11).w
        bne.s   loc_007A50
        rts
loc_007A50:
        moveq	#0,d0
        move.b  ($FFFFEEDF).w, d0
        move.w  loc_007A5E(pc,d0), D0
        jmp     loc_007A5E(pc,d0)
loc_007A5E:
        dc.w    loc_007A64-loc_007A5E
        dc.w    loc_007AB4-loc_007A5E
        dc.w    loc_007AC8-loc_007A5E
loc_007A64:
        cmpi.w  #$26E0, ($FFFFEE00).w
        bcs.s   loc_007AB2
        move.w  ($FFFFEE00).w, ($FFFFEEC8).w
        move.w  #$390, ($FFFFEEC6).w
        move.w  #$390, ($FFFFEECE).w
        addq.b  #$2, ($FFFFEEDF).w
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_007A9E
        move.b  #$55, (a1)
        move.b  #$81, subtype(a1)
        move.w  #$29D0, x_pos(a1)
        move.w  #$426, y_pos(a1)
loc_007A9E:
        move.w  #$08E, d0
        bsr     Play_Music              ; loc_0014C0
        move.b  #1, ($FFFFF7AA).w
        moveq   #$28, d0
        bra     LoadPLC         ; loc_00173C
loc_007AB2:
        rts
loc_007AB4:
        cmpi.w  #$2880, ($FFFFEE00).w
        bcs.s   loc_007AC6
        move.w  #$2880, ($FFFFEEC8).w
        addq.b  #$2, ($FFFFEEDF).w
loc_007AC6:
        rts
loc_007AC8:
        tst.b   ($FFFFF7A7).w
        beq.s   loc_007AD4
        move.b  #0, (Game_Mode).w
loc_007AD4:
        rts
        rts
loc_007AD8:
        rts
loc_007ADA:
        rts
loc_007ADC:
        rts
loc_007ADE:
        rts
loc_007AE0:
        rts
loc_007AE2:
        rts
loc_007AE4:
        tst.b   ($FFFFFE11).w
        bne     loc_007CF6
        moveq	#0,d0
        move.b  ($FFFFEEDF).w, d0
        move.w  loc_007AFA(pc,d0), D0
        jmp     loc_007AFA(pc,d0)
loc_007AFA:
        dc.w    loc_007B00-loc_007AFA
        dc.w    loc_007B6C-loc_007AFA
        dc.w    loc_007C20-loc_007AFA
loc_007B00:
        cmpi.w  #$400, ($FFFFEE04).w
        bcs.s   loc_007B48
        cmpi.w  #$1800, ($FFFFEE00).w
        bcs.s   loc_007B48
        move.b  #1, ($FFFFEEBC).w
        move.l  ($FFFFEE00).w, ($FFFFEE08).w
        move.l  ($FFFFEE04).w, ($FFFFEE0C).w
        moveq	#0,d0
        move.w  d0, ($FFFFEEB4).w
        move.w  d0, ($FFFFEEB6).w
        move.w  d0, ($FFFFEEE2).w
        move.w  #$140, ($FFFFEEE4).w
        subi.w  #$100, ($FFFFEE0C).w
        move.w  #0, ($FFFFEEE6).w
        addq.b  #$2, ($FFFFEEDF).w
loc_007B46:        
        rts
loc_007B48:
        tst.b   ($FFFFEEBC).w
        beq.s   loc_007B46
        move.w  #$200, d0
        moveq   #0,d1
        move.w  d1, ($FFFFEEB4).w
        move.w  d1, ($FFFFEEB6).w
        bsr     loc_007C84
        or.w    d0, d1
        bne.s   loc_007B46
        move.b  #0, ($FFFFEEBC).w
        rts
loc_007B6C:
        tst.b   ($FFFFEEE8).w
        bne.s   loc_007B8A
        cmpi.w  #$140, ($FFFFEEE4).w
        beq.s   loc_007BA2
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007BC0
        addq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007BC0
loc_007B8A:
        cmpi.w  #$0E0, ($FFFFEEE4).w
        beq.s   loc_007BA2
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007BC0
        subq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007BC0
loc_007BA2:
        move.b  #0, ($FFFFEEBD).w
        subq.w  #1, ($FFFFEEE6).w
        bpl.s   loc_007BC0
        move.w  #$078, ($FFFFEEE6).w
        eori.b  #1, ($FFFFEEE8).w
        move.b  #1, ($FFFFEEBD).w
loc_007BC0:
        cmpi.w  #$1800, ($FFFFEE00).w
        bcs.s   loc_007BE8
        cmpi.w  #$1F00, ($FFFFEE00).w
        bcc.s   loc_007C04
        move.w  ($FFFFEEB0).w, ($FFFFEEB4).w
        move.w  ($FFFFEEB2).w, ($FFFFEEB6).w
        move.w  ($FFFFEE00).w, d0
        move.w  ($FFFFEE04).w, d1
        bra     loc_007C84
loc_007BE8:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        subq.b  #$2, ($FFFFEEDF).w
        rts
loc_007C04:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        addq.b  #$2, ($FFFFEEDF).w
        rts
loc_007C20:
        cmpi.w  #$1F00, ($FFFFEE00).w
        bcc.s   loc_007C60
        move.b  #1, ($FFFFEEBC).w
        move.l  ($FFFFEE00).w, ($FFFFEE08).w
        move.l  ($FFFFEE04).w, ($FFFFEE0C).w
        moveq	#0,d0
        move.w  d0, ($FFFFEEB4).w
        move.w  d0, ($FFFFEEB6).w
        move.w  d0, ($FFFFEEE2).w
        move.w  #$140, ($FFFFEEE4).w
        subi.w  #$100, ($FFFFEE0C).w
        move.w  #0, ($FFFFEEE6).w
        subq.b  #$2, ($FFFFEEDF).w
loc_007C5E:        
        rts
loc_007C60:
        tst.b   ($FFFFEEBC).w
        beq.s   loc_007C5E
        move.w  #$200, d0
        moveq   #0,d1
        move.w  d1, ($FFFFEEB4).w
        move.w  d1, ($FFFFEEB6).w
        bsr     loc_007C84
        or.w    d0, d1
        bne.s   loc_007C5E
        move.b  #0, ($FFFFEEBC).w
        rts
loc_007C84:
        sub.w   ($FFFFEE08).w, d0
        sub.w   ($FFFFEEE2).w, d0
        bpl.s   loc_007C9A
        cmpi.w  #$FFF0, d0
        bgt.s   loc_007C98
        move.w  #$FFF0, d0
loc_007C98:
        bra.s   loc_007CA4
loc_007C9A:
        cmpi.w  #$010, d0
        bcs.s   loc_007CA4
        move.w  #$010, d0
loc_007CA4:
        move.b  d0, ($FFFFEEB4).w
        sub.w   ($FFFFEE0C).w, d1
        sub.w   ($FFFFEEE4).w, d1
        bpl.s   loc_007CBE
        cmpi.w  #$FFF0, d1
        bgt.s   loc_007CBC
        move.w  #$FFF0, d1
loc_007CBC:
        bra.s   loc_007CC8
loc_007CBE:
        cmpi.w  #$010, d1
        bcs.s   loc_007CC8
        move.w  #$010, d1
loc_007CC8:
        move.b  d1, ($FFFFEEB6).w
        rts
        btst    #0, ($FFFFF606).w
        beq.s   loc_007CE0
        tst.w   ($FFFFEEE4).w
        beq.s   loc_007CE0
        subq.w  #1, ($FFFFEEE4).w
loc_007CE0:
        btst    #1, ($FFFFF606).w
        beq.s   loc_007CF4
        cmpi.w  #$700, ($FFFFEEE4).w
        beq.s   loc_007CF4
        addq.w  #1, ($FFFFEEE4).w
loc_007CF4:
        rts
loc_007CF6:
        moveq	#0,d0
        move.b  ($FFFFEEDF).w, d0
        move.w  loc_007D04(pc,d0), D0
        jmp     loc_007D04(pc,d0)
loc_007D04:
        dc.w    loc_007D0E-loc_007D04
        dc.w    loc_007D90-loc_007D04
        dc.w    loc_007E44-loc_007D04
        dc.w    loc_007EA8-loc_007D04
        dc.w    loc_007F5C-loc_007D04
loc_007D0E:
        cmpi.w  #$14C0, ($FFFFEE00).w
        bcs.s   loc_007D6C
        move.b  #1, ($FFFFEEBC).w
        move.l  ($FFFFEE00).w, ($FFFFEE08).w
        move.l  ($FFFFEE04).w, ($FFFFEE0C).w
        moveq	#0,d0
        move.w  d0, ($FFFFEEB4).w
        move.w  d0, ($FFFFEEB6).w
        move.w  d0, ($FFFFEEE2).w
        move.w  #$2C0, ($FFFFEEE4).w
        subi.w  #$100, ($FFFFEE0C).w
        move.w  #0, ($FFFFEEE6).w
        addq.b  #$2, ($FFFFEEDF).w
        cmpi.w  #$380, ($FFFFEE04).w
        bcs.s   loc_007D6A
        move.w  #$F980, ($FFFFEEE2).w
        addi.w  #$480, ($FFFFEE08).w
        move.w  #$300, ($FFFFEEE4).w
        addq.b  #6, ($FFFFEEDF).w
loc_007D6A:
        rts
loc_007D6C:
        tst.b   ($FFFFEEBC).w
        beq.s   loc_007D6A
        move.w  #$200, d0
        moveq   #0,d1
        move.w  d1, ($FFFFEEB4).w
        move.w  d1, ($FFFFEEB6).w
        bsr     loc_007C84
        or.w    d0, d1
        bne.s   loc_007D6A
        move.b  #0, ($FFFFEEBC).w
        rts
loc_007D90:
        tst.b   ($FFFFEEE8).w
        bne.s   loc_007DAE
        cmpi.w  #$2C0, ($FFFFEEE4).w
        beq.s   loc_007DC6
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007DE4
        addq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007DE4
loc_007DAE:
        cmpi.w  #0, ($FFFFEEE4).w
        beq.s   loc_007DC6
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007DE4
        subq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007DE4
loc_007DC6:
        move.b  #0, ($FFFFEEBD).w
        subq.w  #1, ($FFFFEEE6).w
        bpl.s   loc_007DE4
        move.w  #$078, ($FFFFEEE6).w
        eori.b  #1, ($FFFFEEE8).w
        move.b  #1, ($FFFFEEBD).w
loc_007DE4:
        cmpi.w  #$14C0, ($FFFFEE00).w
        bcs.s   loc_007E0C
        cmpi.w  #$1B00, ($FFFFEE00).w
        bcc.s   loc_007E28
        move.w  ($FFFFEEB0).w, ($FFFFEEB4).w
        move.w  ($FFFFEEB2).w, ($FFFFEEB6).w
        move.w  ($FFFFEE00).w, d0
        move.w  ($FFFFEE04).w, d1
        bra     loc_007C84
loc_007E0C:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        subq.b  #$2, ($FFFFEEDF).w
        rts
loc_007E28:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        addq.b  #$2, ($FFFFEEDF).w
        rts
loc_007E44:
        cmpi.w  #$1B00, ($FFFFEE00).w
        bcc.s   loc_007E84
        move.b  #1, ($FFFFEEBC).w
        move.l  ($FFFFEE00).w, ($FFFFEE08).w
        move.l  ($FFFFEE04).w, ($FFFFEE0C).w
        moveq	#0,d0
        move.w  d0, ($FFFFEEB4).w
        move.w  d0, ($FFFFEEB6).w
        move.w  d0, ($FFFFEEE2).w
        move.w  #$2C0, ($FFFFEEE4).w
        subi.w  #$100, ($FFFFEE0C).w
        move.w  #0, ($FFFFEEE6).w
        subq.b  #$2, ($FFFFEEDF).w
loc_007E82:        
        rts
loc_007E84:
        tst.b   ($FFFFEEBC).w
        beq.s   loc_007E82
        move.w  #$200, d0
        moveq   #0,d1
        move.w  d1, ($FFFFEEB4).w
        move.w  d1, ($FFFFEEB6).w
        bsr     loc_007C84
        or.w    d0, d1
        bne.s   loc_007E82
        move.b  #0, ($FFFFEEBC).w
        rts
loc_007EA8:
        tst.b   ($FFFFEEE8).w
        bne.s   loc_007EC6
        cmpi.w  #$300, ($FFFFEEE4).w
        beq.s   loc_007EDE
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007EFC
        addq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007EFC
loc_007EC6:
        cmpi.w  #0, ($FFFFEEE4).w
        beq.s   loc_007EDE
        move.w  ($FFFFFE04).w, d0
        andi.w  #$003, d0
        bne.s   loc_007EFC
        subq.w  #1, ($FFFFEEE4).w
        bra.s   loc_007EFC
loc_007EDE:
        move.b  #0, ($FFFFEEBD).w
        subq.w  #1, ($FFFFEEE6).w
        bpl.s   loc_007EFC
        move.w  #$078, ($FFFFEEE6).w
        eori.b  #1, ($FFFFEEE8).w
        move.b  #1, ($FFFFEEBD).w
loc_007EFC:
        cmpi.w  #$14C0, ($FFFFEE00).w
        bcs.s   loc_007F24
        cmpi.w  #$1B00, ($FFFFEE00).w
        bcc.s   loc_007F40
        move.w  ($FFFFEEB0).w, ($FFFFEEB4).w
        move.w  ($FFFFEEB2).w, ($FFFFEEB6).w
        move.w  ($FFFFEE00).w, d0
        move.w  ($FFFFEE04).w, d1
        bra     loc_007C84
loc_007F24:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        subq.b  #6, ($FFFFEEDF).w
        rts
loc_007F40:
        move.l  #$4000000, ($FFFFEE08).w
        moveq	#0,d0
        move.l  d0, ($FFFFEE0C).w
        move.l  d0, ($FFFFEEE2).w
        move.b  d0, ($FFFFEEE8).w
        addq.b  #$2, ($FFFFEEDF).w
        rts
loc_007F5C:
        cmpi.w  #$1B00, ($FFFFEE00).w
        bcc.s   loc_007FA4
        move.b  #1, ($FFFFEEBC).w
        move.l  ($FFFFEE00).w, ($FFFFEE08).w
        move.l  ($FFFFEE04).w, ($FFFFEE0C).w
        moveq	#0,d0
        move.w  d0, ($FFFFEEB4).w
        move.w  d0, ($FFFFEEB6).w
        move.w  #$F980, ($FFFFEEE2).w
        addi.w  #$480, ($FFFFEE08).w
        move.w  #$300, ($FFFFEEE4).w
        subi.w  #$100, ($FFFFEE0C).w
        move.w  #0, ($FFFFEEE6).w
        subq.b  #$2, ($FFFFEEDF).w
loc_007FA2:        
        rts
loc_007FA4:
        tst.b   ($FFFFEEBC).w
        beq.s   loc_007FA2
        move.w  #$200, d0
        moveq   #0,d1
        move.w  d1, ($FFFFEEB4).w
        move.w  d1, ($FFFFEEB6).w
        bsr     loc_007C84
        or.w    d0, d1
        bne.s   loc_007FA2
        move.b  #0, ($FFFFEEBC).w
        rts
loc_007FC8:
        rts
loc_007FCA:
        rts
loc_007FCC:
        rts
loc_007FCE:
        rts
DynResize_CNz: ; loc_007FD0:
        rts
DynResize_CPz: ;loc_007FD2:
        rts
DynResize_GCz: ;loc_007FD4:
        rts
DynResize_NGHz: ;loc_007FD6:
        rts
DynResize_DEz: ;loc_007FD8:
        rts   
        nop                     ; Filler    
;===============================================================================         
; Obj11 Bridge Beginning
;===============================================================================        
Obj11_Bridge:  ; loc_007FDC:
     include "Objects/main/Obj11Bridge.asm"

;===============================================================================           
; Obj11 Bridge End
;=============================================================================== 

;=============================================================================== 
; Object 0x15 - Swing Platforms - Dust Hill / Oil Ocean
;===============================================================================   
Obj15_Swing_Platform: ; loc_0085F8:
        btst    #6,render_flags(a0)
        bne     Obj15_BeginDis
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Obj15_States(pc,d0), d1
        jmp     Obj15_States(pc,d1)
		
Obj15_BeginDis:
        move.w  #$200, d0
        bra     DisplaySprite_Param     ; loc_00D3FE
; ===========================================================================		
Obj15_States:
        dc.w    Obj15_Init-Obj15_States
        dc.w    Obj15_State2-Obj15_States
        dc.w    Obj15_Display-Obj15_States
        dc.w    Obj15_State4-Obj15_States
        dc.w    Obj15_State5-Obj15_States
        dc.w    Obj15_State6-Obj15_States
        dc.w    Obj15_State7-Obj15_States
; ===========================================================================		
Obj15_Init:
        addq.b  #2,routine(a0)
        move.l  #Swing_Platforms_Mappings,mappings(a0) ; loc_008AD8
        move.w  #$43E3,art_tile(a0) ; standard plc load address
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$20,width_pixels(a0) 
        move.b  #$10, y_radius(a0)
        move.w  y_pos(a0), objoff_38(a0)
        move.w  x_pos(a0), objoff_3A(a0)
        cmpi.b  #$B, (Current_ZoneAndAct).w ; is level Mystic Cave Zone?
        bne.s   Obj15_NGHZ ; if not, move on to Aquatic Ruins loading
        move.l  #DhzPlatformsMappings,mappings(a0) ; loc_008B46 
        move.w  #0,art_tile(a0)    ; MCZ plc load address           
        move.b  #$18,width_pixels(a0)
        move.b  #8, y_radius(a0)
		
Obj15_NGHZ:
        cmpi.b  #$F, (Current_ZoneAndAct).w ;is Level Aquatic Ruin?
        bne.s   Obj15_NGHZArtLoad
        move.l  #Nghz_Swing_Platforms_Mappings,mappings(a0) ; loc_008B0E
        move.w  #0,art_tile(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #8, y_radius(a0)
		
Obj15_NGHZArtLoad:
        bsr     Adjust2PArtPointer     ; loc_00DC30
        moveq   #0,d1
        move.b  subtype(A0), d1
        bpl.s   Obj15_Load
        addq.b  #4,routine(a0)
		
Obj15_Load:
        andi.w  #$F, d1
        move.w  d1, D2
        lsl.w   #4, D2
        addi.b  #8, D2
        move.b  D2, Objoff_3C(a0)
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   Obj15_DHZSets
        move.b  0(A0), 0(a1) ; load obj15
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  #4, render_flags(a1)
        bset    #6, render_flags(a1)
        move.b  #$48, Objoff_E(a1)
        move.b  d1, Objoff_F(a1)
        subq.b  #1,d1
        lea     $10(a1),a2
		
loc_0086FC:        
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        move.w  #$001, (A2)+
        addi.w  #$010, d3
        dbra    d1, loc_0086FC
        move.b  #$2, $0015(a1)
        move.w  D2, x_pos(a1)
        move.w  d3, y_pos(a1)
        move.b  #1, $000B(a1)
        move.l  A1, Objoff_30(a0)
        addi.w  #8, d3
        move.w  d3, y_pos(a0)
        move.b  #$50, $14(a1)
        bset    #4, render_flags(a1)
		
Obj15_DHZSets:
        move.w  #$8000,angle(a0)
        move.w  #0, Objoff_3E(a0)
        move.b  subtype(A0), d1
        andi.w  #$70, d1
        move.b  d1, subtype(a0)
        cmpi.b  #$40, d1
        bne.s   Obj15_State2
        move.l  #DhzPlatformsMappings_2,mappings(a0) ; loc_008B7A
        move.b  #$A7,collision_flags(a0)
Obj15_State2:
        move.w  x_pos(a0), -(A7)
        bsr     loc_008784
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_00FA28
        bra     loc_0088FC
		
loc_008784:
        move.b  ($FFFFFE78).w, d0
        move.b  subtype(A0), d1
        beq.s   loc_0087C4
        cmpi.b  #$10, d1
        bne.s   loc_00879E
        cmpi.b  #$40, d0
        bcc.s   loc_0087C4
        moveq   #$40, d0
        bra.s   loc_0087C4
; ===========================================================================
		
loc_00879E:
        cmpi.b  #$20, d1
        bne.s   loc_0087AA
        moveq   #$40, d0
        bra     loc_00885C
loc_0087AA:
        cmpi.b  #$30, d1
        bne.s   loc_0087BA
        cmpi.b  #$40, d0
        bcs.s   loc_0087C4
        moveq   #$40, d0
        bra.s   loc_0087C4
loc_0087BA:
        cmpi.b  #$40, d1
        bne.s   loc_0087C4
        bsr     loc_00885E
loc_0087C4:
        move.w  #$080, d1
        btst    #0, status(a0)
        beq.s   loc_0087D4
        neg.w   D0
        add.w   d1, d0
loc_0087D4:
        bsr     CalcSine        ; loc_00320A
        move.w  objoff_38(A0), D2
        move.w  objoff_3A(A0), D3
        moveq   #0, D4
        move.b  Objoff_3C(a0), D4
        move.l  d4,d5
        muls.w  d0, D4
        asr.l   #8, D4
        muls.w  d1,d5
        asr.l   #8,d5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d4, y_pos(a0)
        move.w  d5, x_pos(a0)
        moveq   #0, D6
        move.l  Objoff_30(A0), A1
        move.b  Objoff_F(A1), D6
        subq.w  #1, D6
        bcs.s   loc_00885C
        asl.w   #4, d0
        ext.l   D0
        asl.l   #8,d0
        asl.w   #4, d1
        ext.l   d1
        asl.l   #8, d1
        moveq   #0, D4
        moveq   #0,d5
        lea     $10(a1),a2
loc_00881E:        
        movem.l D4/d5, -(A7)
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d5, (A2)+
        move.w  d4, (A2)+
        movem.l (A7)+, D4/D5
        add.l   d0, D4
        add.l   d1,d5
        addq.w  #$2, a2
        dbra    d6, loc_00881E
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  subtype(A1), D0
        move.w  $002A(A1), d1
        move.w  d5, subtype(a1)
        move.w  d4, $002A(a1)
        move.w  d0, x_pos(a1)
        move.w  d1, y_pos(a1)
loc_00885C:
        rts
loc_00885E:
        tst.w   objoff_36(a0)
        beq.s   loc_00886C
        subq.w  #1, objoff_36(a0)
        bra     loc_0088F6
loc_00886C:
        tst.b   Objoff_34(a0)
        bne.s   loc_008892
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   objoff_3A(A0), D0
        addi.w  #$20, d0
        cmpi.w  #$40, d0
        bcc.s   loc_0088F6
        tst.w   (Debug_placement_mode).w
        bne     loc_0088F6
        move.b  #1, Objoff_34(a0)
loc_008892:
        tst.b   objoff_3D(a0)
        beq.s   loc_0088C8
        move.w  Objoff_3E(A0), D0
        addi.w  #8, d0
        move.w  d0, Objoff_3E(a0)
        add.w   d0,angle(a0)
        cmpi.w  #$200, d0
        bne.s   loc_0088F6
        move.w  #0, Objoff_3E(a0)
        move.w  #$8000,angle(a0)
        move.b  #0, objoff_3D(a0)
        move.w  #$03C, objoff_36(a0)
        bra.s   loc_0088F6
; ===========================================================================
		
loc_0088C8:
        move.w  Objoff_3E(A0), D0
        subi.w  #8, d0
        move.w  d0, Objoff_3E(a0)
        add.w   d0,angle(a0)
        cmpi.w  #$FE00, d0
        bne.s   loc_0088F6
        move.w  #0, Objoff_3E(a0)
        move.w  #$4000,angle(a0)
        move.b  #1, objoff_3D(a0)
        move.w  #$03C, objoff_36(a0)
loc_0088F6:
        move.b  angle(A0), D0
        rts
; ===========================================================================
		
loc_0088FC:
        tst.w   (Two_player_mode).w
        beq.s   loc_008906
        bra     DisplaySprite           ; loc_00D3C2
; ===========================================================================
		
loc_008906:
        move.w  objoff_3A(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_00891E
        bra     DisplaySprite           ; loc_00D3C2
; ===========================================================================
		
loc_00891E:
        move.l  Objoff_30(A0), A1
        bsr     DeleteObject2
        bra     DeleteObject            ; loc_00D3B4
; ===========================================================================
		
Obj15_Display:
        bra     DisplaySprite           ; loc_00D3C2
; ===========================================================================
		
Obj15_State4:
        move.w  x_pos(a0), -(A7)
        bsr     loc_008784
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_00FA28
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq     loc_0089E4
        tst.b   ($FFFFFE78).w
        bne     loc_0089E4
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_0089D4
        moveq	#0,d0
        move.w  #$F, d1
		
loc_00896A:        
        move.l  $00(A0, d0), $00(A1, d0)
        addq.w  #4, d0
        dbra    d1, loc_00896A
        move.b  #$A, $0024(a1)
        cmpi.b  #$F, (Current_ZoneAndAct).w
        bne.s   loc_008988
        addq.b  #$2, $0024(a1)
loc_008988:
        move.w  #$200,x_vel(a1)
        btst    #0, status(a0)
        beq.s   loc_00899A
        neg.w  x_vel(a1)
		
loc_00899A:
        bset    #1, status(a1)
        move.w  A0, d0
        subi.w  #Object_RAM, d0
        lsr.w   #6, d0
        andi.w  #$07F, d0
        move.w  A1, d1
        subi.w  #Object_RAM, d1
        lsr.w   #6, d1
        andi.w  #$07F, d1
        lea     (MainCharacter).w, A1
        cmp.b   objoff_3D(A1), D0
        bne.s   loc_0089C6
        move.b  d1, objoff_3D(a1)
loc_0089C6:
        lea     (Sidekick).w, A1
        cmp.b   objoff_3D(A1), D0
        bne.s   loc_0089D4
        move.b  d1, objoff_3D(a1)
loc_0089D4:
        move.b  #3, $001A(a0)
        addq.b  #2,routine(a0)
        andi.b  #$E7, status(a0)
loc_0089E4:
        bra     loc_0088FC
Obj15_State5:
        bsr     loc_008784
        bra     loc_0088FC
Obj15_State6:
        move.w  x_pos(a0), -(A7)
        btst    #1, status(a0)
        beq.s   loc_008A2E
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        cmpi.w  #$720, y_pos(a0)
        bcs.s   loc_008A3E
        move.w  #$720, y_pos(a0)
        bclr    #1, status(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $0012(a0)
        move.w  y_pos(a0), objoff_38(a0)
        bra.s   loc_008A3E
loc_008A2E:
        moveq	#0,d0
        move.b  ($FFFFFE74).w, d0
        lsr.w   #1,d0
        add.w   objoff_38(A0), D0
        move.w  d0, y_pos(a0)
loc_008A3E:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_00FA28
        bra     MarkObjGone             ; loc_00D2A0
Obj15_State7:
        move.w  x_pos(a0), -(A7)
        bsr     SpeedToPos              ; loc_00D27A
        btst    #1, status(a0)
        beq.s   loc_008A92
        addi.w  #$018, $0012(a0)
        move.w  (Water_Level_2).w, d0
        cmp.w   y_pos(a0), D0
        bhi.s   loc_008AC0
        move.w  d0, y_pos(a0)
        move.w  d0, objoff_38(a0)
        bclr    #1, status(a0)
        move.w  #$100,x_vel(a0)
        move.w  #0, $0012(a0)
        bra.s   loc_008AC0
loc_008A92:
        moveq	#0,d0
        move.b  ($FFFFFE74).w, d0
        lsr.w   #1,d0
        add.w   objoff_38(A0), D0
        move.w  d0, y_pos(a0)
        tst.w  x_vel(a0)
        beq.s   loc_008AC0
        moveq   #0, d3
        move.b width_pixels(a0), D3
        bsr     loc_008B94
        tst.w   d1
        bpl.s   loc_008AC0
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_008AC0:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_00FA28
        bra     MarkObjGone             ; loc_00D2A0
Swing_Platforms_Mappings: ; loc_008AD8:
        dc.w    Swing_Platforms_Map_01-Swing_Platforms_Mappings
        dc.w    Swing_Platforms_Map_02-Swing_Platforms_Mappings
        dc.w    Swing_Platforms_Map_02-Swing_Platforms_Mappings
        dc.w    Swing_Platforms_Map_Null-Swing_Platforms_Mappings
Swing_Platforms_Map_01: ; loc_008AE0:
        dc.w    $0004
        dc.l    $F00D2004, $2002FFE0, $F00D200C, $20060000
        dc.l    $000D2014, $200AFFE0, $000D2814, $280A0000
Swing_Platforms_Map_02: ; loc_008B02:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
Swing_Platforms_Map_Null: ; loc_008B0C:
        dc.w    $0000
Nghz_Swing_Platforms_Mappings: ; loc_008B0E:
        dc.w    Nghz_Swing_Platforms_Map_01-Nghz_Swing_Platforms_Mappings
        dc.w    Nghz_Swing_Platforms_Map_02-Nghz_Swing_Platforms_Mappings
        dc.w    Nghz_Swing_Platforms_Map_03-Nghz_Swing_Platforms_Mappings
        dc.w    Nghz_Swing_Platforms_Map_Null-Nghz_Swing_Platforms_Mappings
Nghz_Swing_Platforms_Map_01: ; loc_008B16:
        dc.w    $0002
        dc.l    $F80D6055, $602AFFE0, $F80D6055, $602A0000
Nghz_Swing_Platforms_Map_02: ; loc_008B28:
        dc.w    $0001
        dc.l    $F8052051, $2028FFF8
Nghz_Swing_Platforms_Map_03: ; loc_008B32:
        dc.w    $0002
        dc.l    $F00E4045, $4022FFF0, $F8052051, $2028FFF8
Nghz_Swing_Platforms_Map_Null: ; loc_008B44:
        dc.w    $0000 
DhzPlatformsMappings: ; loc_008B46:
        dc.w    Dhz_Swing_Platforms_Map_01-DhzPlatformsMappings
        dc.w    Dhz_Swing_Platforms_Map_02-DhzPlatformsMappings
        dc.w    Dhz_Swing_Platforms_Map_03-DhzPlatformsMappings
Dhz_Swing_Platforms_Map_01: ; loc_008B4C:
        dc.w    $0002
        dc.l    $F8096060, $6030FFE8, $F8096860, $68300000
Dhz_Swing_Platforms_Map_02: ; loc_008B5E:
        dc.w    $0001
        dc.l    $F8056066, $6033FFF8
Dhz_Swing_Platforms_Map_03: ; loc_008B68:
        dc.w    $0002
        dc.l    $E805406A, $4035FFF4, $F80B406E, $4037FFF4   
DhzPlatformsMappings_2: ; loc_008B7A:
        dc.w    Dhz_Swing_Platforms_Map_04-DhzPlatformsMappings_2
        dc.w    Dhz_Swing_Platforms_Map_02-DhzPlatformsMappings_2
        dc.w    Dhz_Swing_Platforms_Map_03-DhzPlatformsMappings_2
Dhz_Swing_Platforms_Map_04: ; loc_008B80:
        dc.w    $0002
        dc.l    $F80D6058, $602CFFE0, $F80D6858, $682C0000                          
;=============================================================================== 
; Object 0x15 - Swing Platforms - Dust Hill / Oil Ocean
;===============================================================================   
        nop                     ; Filler  
loc_008B94:
        jmp     ObjHitWallRight         ; (loc_01399E)    
        dc.w    $0000           ; Filler 
;=============================================================================== 
; Object 0x17
;===============================================================================          
Obj17: ; loc_008B9C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_008BAA(pc,d0), d1
        jmp     loc_008BAA(pc,d1)
loc_008BAA:        
        dc.w    loc_008BB0-loc_008BAA
        dc.w    loc_008C74-loc_008BAA
        dc.w    loc_008CD6-loc_008BAA
loc_008BB0:
        addq.b  #2,routine(a0)
        move.l  #loc_008CDE,mappings(a0)
        move.w  #$4398,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #8,width_pixels(a0)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        move.b  0(A0), D4
        lea     subtype(A0), A2
        moveq   #0,d1
        move.b  (a2),d1
        move.b  #0, (A2)+
        move.w  d1, d0
        lsr.w   #1,d0
        lsl.w   #4, d0
        sub.w   d0, d3
        subq.b  #$2, d1
        bcs.s   loc_008C74
        moveq   #0, D6
loc_008BFE:        
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_008C74
        addq.b  #1, subtype(a0)
        move.w  A1,d5
        subi.w  #Object_RAM,d5
        lsr.w   #6,d5
        andi.w  #$07F,d5
        move.b  d5, (A2)+
        move.b  #4, $0024(a1)
        move.b  d4, 0(a1)
        move.w  D2, y_pos(a1)
        move.w  d3, x_pos(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  #$4398, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #8, $0019(a1)
        move.b  d6, Objoff_3E(a1)
        addq.b  #1, D6
        andi.b  #$7, D6
        addi.w  #$010, d3
        cmp.w   x_pos(a0), D3
        bne.s   loc_008C70
        move.b  d6, Objoff_3E(a0)
        addq.b  #1, D6
        andi.b  #$7, D6
        addi.w  #$010, d3
        addq.b  #1, subtype(a0)
loc_008C70:
        dbra    d1, loc_008BFE
loc_008C74:
        bsr     loc_008CB6
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_008C90
        bra     DisplaySprite           ; loc_00D3C2
loc_008C90:
        moveq   #0, D2
        lea     subtype(A0), A2
        move.b  (A2)+, D2
        subq.b  #$2, D2
        bcs.s   loc_008CB2
loc_008C9C:        
        moveq	#0,d0             
        move.b  (A2)+, D0
        lsl.w   #6, d0
        addi.l  #MainCharacter, d0
        move.l  d0, A1
        bsr     DeleteObject2
        dbra    D2, loc_008C9C
loc_008CB2:
        bra     DeleteObject            ; loc_00D3B4
loc_008CB6:
        move.b  ($FFFFFEC1).w, d0
        move.b  #0,collision_flags(a0)
        add.b   Objoff_3E(A0), D0
        andi.b  #$7, d0
        move.b  d0, $001A(a0)
        bne.s   loc_008CD4
        move.b  #$84,collision_flags(a0)
loc_008CD4:
        rts
loc_008CD6:
        bsr     loc_008CB6
        bra     DisplaySprite           ; loc_00D3C2
loc_008CDE:
        dc.w    loc_008CEE-loc_008CDE
        dc.w    loc_008CF8-loc_008CDE
        dc.w    loc_008D02-loc_008CDE
        dc.w    loc_008D0C-loc_008CDE
        dc.w    loc_008D16-loc_008CDE
        dc.w    loc_008D20-loc_008CDE
        dc.w    loc_008D34-loc_008CDE
        dc.w    loc_008D2A-loc_008CDE
loc_008CEE:
        dc.w    $0001
        dc.l    $F0010000, $0000FFFC
loc_008CF8:
        dc.w    $0001
        dc.l    $F5050002, $0001FFF8
loc_008D02:
        dc.w    $0001
        dc.l    $F8050006, $0003FFF8
loc_008D0C:
        dc.w    $0001
        dc.l    $FB05000A, $0005FFF8
loc_008D16:
        dc.w    $0001
        dc.l    $0001000E, $0007FFFC
loc_008D20:
        dc.w    $0001
        dc.l    $04000010, $0008FFFD
loc_008D2A:
        dc.w    $0001
        dc.l    $F4000011, $0008FFFD
loc_008D34:
        dc.w    $0000           
;=============================================================================== 
; Object 0x17
;===============================================================================        
        nop                     ; Filler
;=============================================================================== 
; Object 0x18 - Platforms 
;===============================================================================   
Obj18_Platforms: ; loc_008D38:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_008D46(pc,d0), d1
        jmp     loc_008D46(pc,d1)         
loc_008D46:
        dc.w    loc_008D5A-loc_008D46
        dc.w    loc_008DF6-loc_008D46
        dc.w    loc_008E5C-loc_008D46
        dc.w    loc_008E34-loc_008D46
        dc.w    loc_008E60-loc_008D46
loc_008D50:
        dc.w    $2000, $2001, $2002, $4003, $3004   
loc_008D5A: 
        addq.b  #2,routine(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$00E, d0
        lea     loc_008D50(pc,d0), A2
        move.b  (A2)+,width_pixels(a0)
        move.b  (A2)+, $001A(a0)
        move.l  #Ghz_Platform_Mappings,mappings(a0) ; loc_009078
        move.w  #$4000,art_tile(a0)
        cmpi.b  #$F, (Current_ZoneAndAct).w
        bne.s   loc_008D9A
        move.l  #Nghz_Platform_Mappings,mappings(a0) ; loc_0090D0
        move.w  #$4000,art_tile(a0)
loc_008D9A:
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.w  y_pos(a0), $002C(a0)
        move.w  y_pos(a0), Objoff_34(a0)
        move.w  x_pos(a0), $0032(a0)
        move.w  #$080,angle(a0)
        tst.b   subtype(a0)
        bpl.s   loc_008DF0
        addq.b  #6, $0024(a0)
        andi.b  #$F, subtype(a0)
        move.b  #$30, y_radius(a0)
        cmpi.b  #$F, (Current_ZoneAndAct).w
        bne.s   loc_008DE6
        move.b  #$28, y_radius(a0)
loc_008DE6:
        bset    #4,render_flags(a0)
        bra     loc_008E60         
loc_008DF0:
        andi.b  #$F, subtype(a0)
loc_008DF6:
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_008E0C
        tst.b   objoff_38(a0)
        beq.s   loc_008E18
        subq.b  #4, objoff_38(a0)
        bra.s   loc_008E18
loc_008E0C:
        cmpi.b  #$40, objoff_38(a0)
        beq.s   loc_008E18
        addq.b  #4, objoff_38(a0)
loc_008E18:
        move.w  x_pos(a0), -(A7)
        bsr     loc_008EC4
        bsr     loc_008EAA
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #8, d3
        move.w  (A7)+, D4
        bsr     loc_00F984
        bra.s   loc_008E3C
loc_008E34:
        bsr     loc_008EC4
        bsr     loc_008EAA
loc_008E3C:
        tst.w   (Two_player_mode).w
        beq.s   loc_008E46
        bra     DisplaySprite           ; loc_00D3C2
loc_008E46:
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_008E5C
        bra     DisplaySprite           ; loc_00D3C2
loc_008E5C:
        bra     DeleteObject            ; loc_00D3B4
loc_008E60:
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_008E76
        tst.b   objoff_38(a0)
        beq.s   loc_008E82
        subq.b  #4, objoff_38(a0)
        bra.s   loc_008E82
loc_008E76:
        cmpi.b  #$40, objoff_38(a0)
        beq.s   loc_008E82
        addq.b  #4, objoff_38(a0)
loc_008E82:
        move.w  x_pos(a0), -(A7)
        bsr     loc_008EC4
        bsr     loc_008EAA
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  (A7)+, D4
        bsr     SolidObject             ; loc_00F4A0
        bra.s   loc_008E3C
loc_008EAA:
        move.b  objoff_38(A0), D0
        bsr     CalcSine        ; loc_00320A
        move.w  #$400, d1
        muls.w  d1, d0
        swap.w  D0
        add.w   $002C(A0), D0
        move.w  d0, y_pos(a0)
        rts
loc_008EC4:
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        add.w   d0, d0
        move.w  loc_008ED8(pc,d0), d1
        jmp     loc_008ED8(pc,d1)
loc_008ED8:
        dc.w    loc_008EF4-loc_008ED8
        dc.w    loc_008F06-loc_008ED8
        dc.w    loc_008F4C-loc_008ED8
        dc.w    loc_008F64-loc_008ED8
        dc.w    loc_008F8C-loc_008ED8
        dc.w    loc_008EF6-loc_008ED8
        dc.w    loc_008F3C-loc_008ED8
        dc.w    loc_008FFA-loc_008ED8
        dc.w    loc_009026-loc_008ED8
        dc.w    loc_008EF4-loc_008ED8
        dc.w    loc_00903E-loc_008ED8
        dc.w    loc_009058-loc_008ED8
        dc.w    loc_008F2E-loc_008ED8
        dc.w    loc_008F1E-loc_008ED8
loc_008EF4:               
        rts
loc_008EF6:   
        move.w  $0032(A0), D0
        move.b  angle(A0), d1
        neg.b   d1
        addi.b  #$40, d1
        bra.s   loc_008F12
loc_008F06:
        move.w  $0032(A0), D0
        move.b  angle(A0), d1
        subi.b  #$40, d1
loc_008F12:
        ext.w   d1
        add.w   d1, d0
        move.w  d0, x_pos(a0)
        bra     loc_009070
loc_008F1E:
        move.w  Objoff_34(A0), D0
        move.b  ($FFFFFE6C).w, d1
        neg.b   d1
        addi.b  #$30, d1
        bra.s   loc_008F58
loc_008F2E:
        move.w  Objoff_34(A0), D0
        move.b  ($FFFFFE6C).w, d1
        subi.b  #$30, d1
        bra.s   loc_008F58
loc_008F3C:
        move.w  Objoff_34(A0), D0
        move.b  angle(A0), d1
        neg.b   d1
        addi.b  #$40, d1
        bra.s   loc_008F58
loc_008F4C:
        move.w  Objoff_34(A0), D0
        move.b  angle(A0), d1
        subi.b  #$40, d1
loc_008F58:
        ext.w   d1
        add.w   d1, d0
        move.w  d0, $002C(a0)
        bra     loc_009070
loc_008F64:
        tst.w   objoff_3A(a0)
        bne.s   loc_008F7A
        btst    #3, status(a0)
        beq.s   loc_008F78
        move.w  #$01E, objoff_3A(a0)
loc_008F78:
        rts
loc_008F7A:
        subq.w  #1, objoff_3A(a0)
        bne.s   loc_008F78
        move.w  #$20, objoff_3A(a0)
        addq.b  #1, subtype(a0)
        rts
loc_008F8C:
        tst.w   objoff_3A(a0)
        beq.s   loc_008FCC
        subq.w  #1, objoff_3A(a0)
        bne.s   loc_008FCC
        btst    #3, status(a0)
        beq.s   loc_008FC6
        lea     (MainCharacter).w, A1
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        bclr    #3, status(a0)
        clr.b   $0025(a0)
        move.w  $0012(A0), $0012(a1)
loc_008FC6:
        move.b  #6, $0024(a0)
loc_008FCC:
        move.l  $002C(A0), D3
        move.w  $0012(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  d3, $002C(a0)
        addi.w  #$038, $0012(a0)
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   $002C(A0), D0
        bcc.s   loc_008FF8
        move.b  #4,routine(a0)
loc_008FF8:
        rts
loc_008FFA:
        tst.w   objoff_3A(a0)
        bne.s   loc_00901A
        lea     ($FFFFF7E0).w, a2
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #4, d0
        tst.b   $00(A2, d0)
        beq.s   loc_009018
        move.w  #$03C, objoff_3A(a0)
loc_009018:
        rts
loc_00901A:
        subq.w  #1, objoff_3A(a0)
        bne.s   loc_009018
        addq.b  #1, subtype(a0)
        rts
loc_009026:
        subq.w  #$2, $002C(a0)
        move.w  Objoff_34(A0), D0
        subi.w  #$200, d0
        cmp.w   $002C(A0), D0
        bne.s   loc_00903C
        clr.b   subtype(a0)
loc_00903C:
        rts
loc_00903E:
        move.w  Objoff_34(A0), D0
        move.b  angle(A0), d1
        subi.b  #$40, d1
        ext.w   d1
        asr.w   #1,d1
        add.w   d1, d0
        move.w  d0, $002C(a0)
        bra     loc_009070
loc_009058:
        move.w  Objoff_34(A0), D0
        move.b  angle(A0), d1
        neg.b   d1
        addi.b  #$40, d1
        ext.w   d1
        asr.w   #1,d1
        add.w   d1, d0
        move.w  d0, $002C(a0)
loc_009070:
        move.b  ($FFFFFE78).w,angle(a0)
        rts
Ghz_Platform_Mappings: ; loc_009078:
        dc.w    Ghz_Platform_Map_01-Ghz_Platform_Mappings
        dc.w    Ghz_Platform_Map_02-Ghz_Platform_Mappings
Ghz_Platform_Map_01: ; loc_00907C:
        dc.w    $0002
        dc.l    $F40F0056, $002BFFE0, $F40F0856, $082B0000
Ghz_Platform_Map_02: ; loc_00908E:
        dc.w    $0008
        dc.l    $CC07000A, $0005FFE0, $CC0D0012, $0009FFF0
        dc.l    $DC0D001A, $000DFFF0, $CC070022, $00110010
        dc.l    $EC0F002A, $0015FFE0, $EC0F082A, $08150000
        dc.l    $0C0F003A, $001DFFE0, $0C0F083A, $081D0000
Nghz_Platform_Mappings: ; loc_0090D0:
        dc.w    Nghz_Platform_Map_01-Nghz_Platform_Mappings
        dc.w    Nghz_Platform_Map_02-Nghz_Platform_Mappings
Nghz_Platform_Map_01: ; loc_0090D4:
        dc.w    $0004
        dc.l    $F00E0001, $0000FFE0, $F00E0801, $08000000
        dc.l    $080E002D, $0016FFE0, $080E0039, $001C0000
Nghz_Platform_Map_02: ; loc_0090F6:
        dc.w    $0006
        dc.l    $D00E0001, $0000FFE0, $D00E0801, $08000000
        dc.l    $E80F000D, $0006FFE0, $E80F001D, $000E0000
        dc.l    $080F000D, $0006FFE0, $080F001D, $000E0000                
;=============================================================================== 
; Object 0x18 - Platforms 
;===============================================================================   
 
;=============================================================================== 
; Object 0x1A - Collapsing Platforms - Hidden Palace / Oil Ocean ...
;===============================================================================           
Obj1A_Collapsing_Platforms: ; loc_009128:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009136(pc,d0), d1
        jmp     loc_009136(pc,d1)
loc_009136:
        dc.w    loc_00913C-loc_009136
        dc.w    loc_0091E8-loc_009136
        dc.w    loc_009220-loc_009136
loc_00913C:               
        addq.b  #2,routine(a0)
        move.l  #Collapsing_Platforms_Mappings,mappings(a0) ; loc_0094A8
        move.w  #$4000,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$7, objoff_38(a0)
        move.b  subtype(A0), $001A(a0)
        move.l  #loc_009436, Objoff_34(a0)
        cmpi.b  #8, (Current_ZoneAndAct).w
        bne.s   loc_0091A4
        move.l  #HPz_Collapsing_Platforms_Mappings,mappings(a0) ; loc_009858
        move.w  #$434A,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$30,width_pixels(a0)
        move.l  #loc_009828, Objoff_3C(a0)
        move.l  #loc_00944F, Objoff_34(a0)
        bra.s   loc_0091E8
loc_0091A4:
        cmpi.b  #$A, (Current_ZoneAndAct).w
        bne.s   loc_0091CE
        move.l  #OOz_Collapsing_Platforms_Mappings,mappings(a0) ; loc_009902
        move.w  #$639D,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$40,width_pixels(a0)
        move.l  #loc_009818, Objoff_3C(a0)
        bra.s   loc_0091E8
loc_0091CE:        
        move.l  #loc_009478, Objoff_3C(a0)
        move.b  #$34,width_pixels(a0)
        move.b  #$38, y_radius(a0)
        bset    #4,render_flags(a0)
loc_0091E8:
        tst.b   objoff_3A(a0)
        beq.s   loc_0091FA
        tst.b   objoff_38(a0)
        beq     loc_0093AC
        subq.b  #1, objoff_38(a0)
loc_0091FA:        
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_00920A
        move.b  #1, objoff_3A(a0)
loc_00920A:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.l  Objoff_3C(a0), A2
        move.w  x_pos(a0), D4
        bsr     loc_00F9D6
        bra     MarkObjGone             ; loc_00D2A0 
loc_009220:
        tst.b   objoff_38(a0)
        beq.s   loc_009264
        tst.b   objoff_3A(a0)
        bne.s   loc_009234
        subq.b  #1, objoff_38(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_009234:
        bsr     loc_00920A
        subq.b  #1, objoff_38(a0)
        bne.s   loc_009262
        lea     (MainCharacter).w, A1
        bsr.s   loc_009248
        lea     (Sidekick).w, A1
loc_009248:
        btst    #3, status(a1)
        beq.s   loc_009262
        bclr    #3, status(a1)
        bclr    #5, status(a1)
        move.b  #1, $001D(a1)
loc_009262:
        rts
loc_009264:
        bsr     ObjectFall              ; loc_00D24E
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2            
;=============================================================================== 
; Object 0x1A - Collapsing Platforms - Hidden Palace / Oil Ocean ...
;===============================================================================   
        
;=============================================================================== 
; Object 0x1F - Collapsing Platforms - Dust Hill / Oil Ocean ...
;===============================================================================           
Obj1F_Collapsing_Platforms: ; loc_009274:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009282(pc,d0), d1
        jmp     loc_009282(pc,d1)  
loc_009282:
        dc.w    loc_009288-loc_009282
        dc.w    loc_00931A-loc_009282
        dc.w    loc_009352-loc_009282
loc_009288:
        addq.b  #2,routine(a0)
        move.l  #loc_009748,mappings(a0)
        move.w  #$42B8,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$7, objoff_38(a0)
        move.b  #$44,width_pixels(a0)
        lea     (loc_00945B), A4
        btst    #0, subtype(a0)
        beq.s   loc_0092C6
        lea     (loc_009463), A4
loc_0092C6:
        move.l  A4, Objoff_34(a0)
        cmpi.b  #$A, (Current_ZoneAndAct).w
        bne.s   loc_0092F2
        move.l  #OOz_Collapsing_Platforms_Mappings,mappings(a0) ; loc_009902
        move.w  #$639D,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$40,width_pixels(a0)
        move.l  #loc_00946B, Objoff_34(a0)
loc_0092F2:
        cmpi.b  #$B, (Current_ZoneAndAct).w
        bne.s   loc_00931A
        move.l  #Dhz_Collapsing_Platforms_Mappings,mappings(a0) ; loc_009942
        move.w  #$63F4,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$20,width_pixels(a0)
        move.l  #loc_009472, Objoff_34(a0)
loc_00931A:
        tst.b   objoff_3A(a0)
        beq.s   loc_00932C
        tst.b   objoff_38(a0)
        beq     loc_0093A6
        subq.b  #1, objoff_38(a0)
loc_00932C:
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_00933C
        move.b  #1, objoff_3A(a0)
loc_00933C:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        bsr     loc_00F984
        bra     MarkObjGone             ; loc_00D2A0
loc_009352:
        tst.b   objoff_38(a0)
        beq.s   loc_009396
        tst.b   objoff_3A(a0)
        bne.s   loc_009366
        subq.b  #1, objoff_38(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_009366:
        bsr     loc_00933C
        subq.b  #1, objoff_38(a0)
        bne.s   loc_009394
        lea     (MainCharacter).w, A1
        bsr.s   loc_00937A
        lea     (Sidekick).w, A1
loc_00937A:
        btst    #3, status(a1)
        beq.s   loc_009394
        bclr    #3, status(a1)
        bclr    #5, status(a1)
        move.b  #1, $001D(a1)
loc_009394:
        rts
loc_009396:
        bsr     ObjectFall              ; loc_00D24E
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_0093A6:
        addq.b  #1, $001A(a0)
        bra.s   loc_0093B0              
loc_0093AC:
        addq.b  #$2, $001A(a0)
loc_0093B0:        
        move.l  Objoff_34(A0), A4          
        moveq	#0,d0
        move.b  $001A(A0), D0
        add.w   d0, d0
        move.l  mappings(A0), A3
        adda.w  $00(A3, d0), A3
        move.w  (A3)+, d1
        subq.w  #1,d1
        bset    #5,render_flags(a0)
        move.b  0(A0), D4
        move.b  render_flags(A0), D5
        move.l  A0, A1
        bra.s   loc_0093E2
loc_0093DA:
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_009428
        addq.w  #8,  A3
loc_0093E2:
        move.b  #4, $0024(a1)
        move.b  d4, 0(a1)
        move.l  A3, mappings(a1)
        move.b  d5, render_flags(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  $0018(A0), $0018(a1)
        move.b width_pixels(a0), $0019(a1)
        move.b  y_radius(A0), y_radius(a1)
        move.b  (A4)+, objoff_38(a1)
        cmpa.l  A0, A1
        bcc.s   loc_009424
        bsr     DisplayA1Sprite         ; loc_00D3E0
loc_009424:
        dbra    d1, loc_0093DA
loc_009428:        
        bsr     DisplaySprite           ; loc_00D3C2
        move.w  #$0B9, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_009436:        
        dc.b    $1C, $18, $14, $10, $1A, $16, $12, $0E, $0A, $06, $18, $14, $10, $0C, $08, $04
        dc.b    $16, $12, $0E, $0A, $06, $02, $14, $10, $0C            
loc_00944F:
        dc.b    $18, $1C, $20, $1E, $1A, $16, $06, $0E, $14, $12, $0A, $02
loc_00945B:              
        dc.b    $1E, $16, $0E, $06, $1A, $12, $0A, $02
loc_009463:
        dc.b    $16, $1E, $1A, $12, $06, $0E, $0A, $02
loc_00946B:
        dc.b    $1A, $12, $0A, $02, $16, $0E, $06              
loc_009472:        
        dc.b    $1A, $16, $12, $0E, $0A, $02                         
loc_009478:
        dc.b    $20, $20, $20, $20, $20, $20, $20, $20, $21, $21, $22, $22, $23, $23, $24, $24
        dc.b    $25, $25, $26, $26, $27, $27, $28, $28, $29, $29, $2A, $2A, $2B, $2B, $2C, $2C
        dc.b    $2D, $2D, $2E, $2E, $2F, $2F, $30, $30, $30, $30, $30, $30, $30, $30, $30, $30          
Collapsing_Platforms_Mappings: ; loc_0094A8:
        dc.w    Collapsing_Platforms_Map_01-Collapsing_Platforms_Mappings
        dc.w    Collapsing_Platforms_Map_02-Collapsing_Platforms_Mappings
        dc.w    Collapsing_Platforms_Map_03-Collapsing_Platforms_Mappings
        dc.w    Collapsing_Platforms_Map_04-Collapsing_Platforms_Mappings
Collapsing_Platforms_Map_01: ; loc_0094B0:
        dc.w    $0010
        dc.l    $C80E0057, $002B0010, $D00D0063, $0031FFF0
        dc.l    $E00D006B, $00350010, $E00D0073, $0039FFF0
        dc.l    $D806007B, $003DFFE0, $D8060081, $0040FFD0
        dc.l    $F00D0087, $00430010, $F00D008F, $0047FFF0
        dc.l    $F0050097, $004BFFE0, $F005009B, $004DFFD0
        dc.l    $000D009F, $004F0010, $000500A7, $00530000
        dc.l    $000D00AB, $0055FFE0, $000500B3, $0059FFD0
        dc.l    $100D00AB, $00550010, $100500B7, $005B0000
Collapsing_Platforms_Map_02: ; loc_009532:
        dc.w    $0010
        dc.l    $C80E0057, $002B0010, $D00D0063, $0031FFF0
        dc.l    $E00D006B, $00350010, $E00D0073, $0039FFF0
        dc.l    $D806007B, $003DFFE0, $D80600BB, $005DFFD0
        dc.l    $F00D0087, $00430010, $F00D008F, $0047FFF0
        dc.l    $F0050097, $004BFFE0, $F00500C1, $0060FFD0
        dc.l    $000D009F, $004F0010, $000500A7, $00530000
        dc.l    $000D00AB, $0055FFE0, $000500B7, $005BFFD0
        dc.l    $100D00AB, $00550010, $100500B7, $005B0000
Collapsing_Platforms_Map_03: ; loc_0095B4:
        dc.w    $0019
        dc.l    $C806005D, $002E0020, $C8060057, $002B0010
        dc.l    $D0050067, $00330000, $D0050063, $0031FFF0
        dc.l    $E005006F, $00370020, $E005006B, $00350010
        dc.l    $E0050077, $003B0000, $E0050073, $0039FFF0
        dc.l    $D806007B, $003DFFE0, $D8060081, $0040FFD0
        dc.l    $F005008B, $00450020, $F0050087, $00430010
        dc.l    $F0050093, $00490000, $F005008F, $0047FFF0
        dc.l    $F0050097, $004BFFE0, $F005009B, $004DFFD0
        dc.l    $0005008B, $00450020, $0005008B, $00450010
        dc.l    $000500A7, $00530000, $000500AB, $0055FFF0
        dc.l    $000500AB, $0055FFE0, $000500B3, $0059FFD0
        dc.l    $100500AB, $00550020, $100500AB, $00550010
        dc.l    $100500B7, $005B0000
Collapsing_Platforms_Map_04: ; loc_00967E:
        dc.w    $0019
        dc.l    $C806005D, $002E0020, $C8060057, $002B0010
        dc.l    $D0050067, $00330000, $D0050063, $0031FFF0
        dc.l    $E005006F, $00370020, $E005006B, $00350010
        dc.l    $E0050077, $003B0000, $E0050073, $0039FFF0
        dc.l    $D806007B, $003DFFE0, $D80600BB, $005DFFD0
        dc.l    $F005008B, $00450020, $F0050087, $00430010
        dc.l    $F0050093, $00490000, $F005008F, $0047FFF0
        dc.l    $F0050097, $004BFFE0, $F00500C1, $0060FFD0
        dc.l    $0005008B, $00450020, $0005008B, $00450010
        dc.l    $000500A7, $00530000, $000500AB, $0055FFF0
        dc.l    $000500AB, $0055FFE0, $000500B7, $005BFFD0
        dc.l    $100500AB, $00550020, $100500AB, $00550010
        dc.l    $100500B7, $005B0000              
loc_009748:
        dc.w    loc_009750-loc_009748
        dc.w    loc_009772-loc_009748
        dc.w    loc_0097B4-loc_009748
        dc.w    loc_0097D6-loc_009748
loc_009750:
        dc.w    $0004
        dc.l    $F80D0000, $0000FFE0, $080D0000, $0000FFE0
        dc.l    $F80D0000, $00000000, $080D0000, $00000000
loc_009772:
        dc.w    $0008
        dc.l    $F8050000, $0000FFE0, $F8050000, $0000FFF0
        dc.l    $F8050000, $00000000, $F8050000, $00000010
        dc.l    $08050000, $0000FFE0, $08050000, $0000FFF0
        dc.l    $08050000, $00000000, $08050000, $00000010
loc_0097B4:
        dc.w    $0004
        dc.l    $F80D0000, $0000FFE0, $080D0008, $0004FFE0
        dc.l    $F80D0000, $00000000, $080D0008, $00040000
loc_0097D6:
        dc.w    $0008
        dc.l    $F8050000, $0000FFE0, $F8050004, $0002FFF0
        dc.l    $F8050000, $00000000, $F8050004, $00020010
        dc.l    $08050008, $0004FFE0, $0805000C, $0006FFF0
        dc.l    $08050008, $00040000, $0805000C, $00060010
loc_009818:         
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10            
loc_009828:
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10           
HPz_Collapsing_Platforms_Mappings: ; loc_009858:
        dc.w    HPz_Collapsing_Platforms_Map_01-HPz_Collapsing_Platforms_Mappings
        dc.w    HPz_Collapsing_Platforms_Map_02-HPz_Collapsing_Platforms_Mappings
        dc.w    HPz_Collapsing_Platforms_Map_02-HPz_Collapsing_Platforms_Mappings
HPz_Collapsing_Platforms_Map_01: ; loc_00985E:
        dc.w    $0008
        dc.l    $F00D0000, $0000FFD0, $000D0008, $0004FFD0
        dc.l    $F0050004, $0002FFF0, $F0050804, $08020000
        dc.l    $0005000C, $0006FFF0, $0005080C, $08060000
        dc.l    $F00D0800, $08000010, $000D0808, $08040010
HPz_Collapsing_Platforms_Map_02: ; loc_0098A0:
        dc.w    $000C
        dc.l    $F0050000, $0000FFD0, $F0050004, $0002FFE0
        dc.l    $F0050004, $0002FFF0, $F0050804, $08020000
        dc.l    $F0050804, $08020010, $F0050800, $08000020
        dc.l    $00050008, $0004FFD0, $0005000C, $0006FFE0
        dc.l    $0005000C, $0006FFF0, $0005080C, $08060000
        dc.l    $0005080C, $08060010, $00050808, $08040020                
OOz_Collapsing_Platforms_Mappings: ; loc_009902:
        dc.w    OOz_Collapsing_Platforms_Map_01-OOz_Collapsing_Platforms_Mappings
        dc.w    OOz_Collapsing_Platforms_Map_01-OOz_Collapsing_Platforms_Mappings
        dc.w    OOz_Collapsing_Platforms_Map_01-OOz_Collapsing_Platforms_Mappings
OOz_Collapsing_Platforms_Map_01: ; loc_009908:
        dc.w    $0007
        dc.l    $F00F0810, $0808FFC0, $F00F0810, $0808FFE0
        dc.l    $F00F0810, $08080000, $F00F0800, $08000020
        dc.l    $100D0820, $0810FFC0, $100D0820, $0810FFE0
        dc.l    $100D0820, $08100000
Dhz_Collapsing_Platforms_Mappings: ; loc_009942:
        dc.w    Dhz_Collapsing_Platforms_Map_01-Dhz_Collapsing_Platforms_Mappings
        dc.w    Dhz_Collapsing_Platforms_Map_02-Dhz_Collapsing_Platforms_Mappings
Dhz_Collapsing_Platforms_Map_01: ; loc_009946:
        dc.w    $0004
        dc.l    $F00D0000, $0000FFE0, $F00D0800, $08000000
        dc.l    $00090008, $0004FFF0, $000B000E, $00070008
Dhz_Collapsing_Platforms_Map_02: ; loc_009968:
        dc.w    $0006
        dc.l    $F0050000, $0000FFE0, $F0050004, $0002FFF0
        dc.l    $F0050804, $08020000, $F0050800, $08000010
        dc.l    $00090008, $0004FFF0, $000B000E, $00070008                    
;=============================================================================== 
; Object 0x1F - Collapsing Platforms - Dust Hill / Oil Ocean ...
;===============================================================================             
        nop                     ; Filler    
;=============================================================================== 
; Object 0x1C - Bridge, Support, Hill Top Posts... 
;===============================================================================        
Obj1C_Misc: ; loc_00999C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0099AA(pc,d0), d1
        jmp     loc_0099AA(pc,d1)   
loc_0099AA:                     
        dc.w    loc_009A1E-loc_0099AA
        dc.w    loc_009A50-loc_0099AA
loc_0099AE:
        dc.l    loc_009B9A
        dc.w    $43FD
        dc.b    $04, $06
        
        dc.l    ($01<<$18)|loc_009B9A
        dc.w    $43FD
        dc.b    $04, $06
        
        dc.l    ($01<<$18)|Bridge_Mappings ; loc_0085E0 
        dc.w    $43C6
        dc.b    $04, $01
        
        dc.l    ($02<<$18)|loc_009B9A
        dc.w    $23FD
        dc.b    $10, $06
        
        dc.l    ($03<<$18)|Teleferics_Mappings ; loc_01611E 
        dc.w    $43E6
        dc.b    $08, $04
        
        dc.l    ($04<<$18)|Teleferics_Mappings ; loc_01611E 
        dc.w    $43E6
        dc.b    $08, $04
        
        dc.l    ($01<<$18)|Teleferics_Mappings ; loc_01611E 
        dc.w    $43E6
        dc.b    $20, $01
        
        dc.l    loc_009B3A 
        dc.w    $4000
        dc.b    $08, $01
        
        dc.l    ($01<<$18)|loc_009B3A 
        dc.w    $4000
        dc.b    $08, $01
        
        dc.l    loc_009B52 
        dc.w    $4428
        dc.b    $04, $04
        
        dc.l    loc_009B6A 
        dc.w    $4346
        dc.b    $08, $04
        
        dc.l    ($01<<$18)|loc_009B6A 
        dc.w    $4346
        dc.b    $08, $04
        
        dc.l    ($02<<$18)|loc_009B6A 
        dc.w    $4346
        dc.b    $08, $04
        
        dc.l    ($03<<$18)|loc_009B6A 
        dc.w    $4346
        dc.b    $08, $04          
loc_009A1E:              
        addq.b  #2,routine(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsl.w   #3, d0
        lea     loc_0099AE(PC), A1  
        lea     $00(A1, d0), A1
        move.b  (A1), $001A(a0)
        move.l  (A1)+, mappings(a0)
        move.w  (A1)+,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  (A1)+,width_pixels(a0)
        move.b  (A1)+, $0018(a0)
loc_009A50:
        bra     MarkObjGone             ; loc_00D2A0
;=============================================================================== 
; Object 0x1C - Bridge, Support, Hill Top Posts... 
;=============================================================================== 
 
;=============================================================================== 
; Object 0x71 - Bridge, Support, Hidden Palace Orbs, Metropolis Lava Bubbles... 
;===============================================================================    
Obj71_Hpz_Misc: ; loc_009A54: 
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009A62(pc,d0), d1
        jmp     loc_009A62(pc,d1)
loc_009A62:
        dc.w    loc_009A7E-loc_009A62
        dc.w    loc_009AC0-loc_009A62
loc_009A66:
        dc.l    ($03<<$18)|Hpz_Bridge_Mappings ; loc_008598
        dc.w    $6300
        dc.b    $04, 01 
        dc.l    Hpz_Orbs_Mappings              ; loc_009AFA
        dc.w    $E35A
        dc.b    $10, $01   
        dc.l    Lava_Bubble_Mappings           ; loc_009BBE 
        dc.w    $4536
        dc.b    $10, $01        
loc_009A7E:
        addq.b  #2,routine(a0)
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        lsl.w   #3, d0
        lea     loc_009A66(PC), A1
        lea     $00(A1, d0), A1
        move.b  (A1), $001A(a0)
        move.l  (A1)+, mappings(a0)
        move.w  (A1)+,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  (A1)+,width_pixels(a0)
        move.b  (A1)+, $0018(a0)
        move.b  subtype(A0), D0
        andi.w  #$0F0, d0
        lsr.b   #4, d0
        move.b  d0, $001C(a0)
loc_009AC0:        
        lea     (loc_009ACE), A1
        bsr     AnimateSprite           ; loc_00D412
        bra     MarkObjGone             ; loc_00D2A0
loc_009ACE:
        dc.w    loc_009AD6-loc_009ACE
        dc.w    loc_009ADE-loc_009ACE
        dc.w    loc_009AED-loc_009ACE
        dc.w    loc_009AF6-loc_009ACE
loc_009AD6:
        dc.b    $08, $03, $03, $04, $05, $05, $04, $FF
loc_009ADE:
        dc.b    $05, $00, $00, $00, $01, $02, $03, $03, $02, $01, $02, $03, $03, $01, $FF
loc_009AED:
        dc.b    $0B, $00, $01, $02, $03, $04, $05, $FD, $03
loc_009AF6:
        dc.b    $7F, $06, $FD, $02               
Hpz_Orbs_Mappings: ; loc_009AFA:
        dc.w    loc_009B02-Hpz_Orbs_Mappings
        dc.w    loc_009B0C-Hpz_Orbs_Mappings
        dc.w    loc_009B16-Hpz_Orbs_Mappings
        dc.w    loc_009B28-Hpz_Orbs_Mappings
loc_009B02:
        dc.w    $0001
        dc.l    $F40A0000, $0000FFF4
loc_009B0C:
        dc.w    $0001
        dc.l    $F40A0009, $0004FFF4
loc_009B16:
        dc.w    $0002
        dc.l    $F00D0012, $0009FFF0, $000D1812, $1809FFF0
loc_009B28:
        dc.w    $0002
        dc.l    $F00D001A, $000DFFF0, $000D181A, $180DFFF0        
;=============================================================================== 
; Object 0x71 - Bridge, Support, Hidden Palace Orbs, Metropolis Lava Bubbles... 
;===============================================================================               
loc_009B3A:
        dc.w    loc_009B3E-loc_009B3A
        dc.w    loc_009B48-loc_009B3A
loc_009B3E:
        dc.w    $0001
        dc.l    $F8050002, $0001FFF8
loc_009B48:
        dc.w    $0001
        dc.l    $F8050006, $0003FFF8
loc_009B52:
        dc.w    loc_009B56-loc_009B52
        dc.w    loc_009B60-loc_009B52
loc_009B56:
        dc.w    $0001
        dc.l    $F8010000, $0000FFFC
loc_009B60:
        dc.w    $0001
        dc.l    $F8010002, $0001FFFC
loc_009B6A:
        dc.w    loc_009B72-loc_009B6A
        dc.w    loc_009B7C-loc_009B6A
        dc.w    loc_009B86-loc_009B6A
        dc.w    loc_009B90-loc_009B6A
loc_009B72:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_009B7C:
        dc.w    $0001
        dc.l    $F8050004, $0002FFF8
loc_009B86:
        dc.w    $0001
        dc.l    $F8052008, $2004FFF8
loc_009B90:
        dc.w    $0001
        dc.l    $F801000C, $0006FFFC          
loc_009B9A:
        dc.w    loc_009BA0-loc_009B9A
        dc.w    loc_009BAA-loc_009B9A
        dc.w    loc_009BB4-loc_009B9A
loc_009BA0:
        dc.w    $0001
        dc.l    $F8010004, $0002FFFC
loc_009BAA:
        dc.w    $0001
        dc.l    $F8010006, $0003FFFC
loc_009BB4:
        dc.w    $0001
        dc.l    $FC0C0000, $0000FFF0  
Lava_Bubble_Mappings:                  
loc_009BBE:
        dc.w    loc_009BCC-loc_009BBE
        dc.w    loc_009BD6-loc_009BBE
        dc.w    loc_009BE0-loc_009BBE
        dc.w    loc_009BEA-loc_009BBE
        dc.w    loc_009BF4-loc_009BBE
        dc.w    loc_009BFE-loc_009BBE
        dc.w    loc_009C08-loc_009BBE
loc_009BCC:
        dc.w    $0001
        dc.l    $02040000, $0000FFF8
loc_009BD6:
        dc.w    $0001
        dc.l    $00040000, $0000FFF8
loc_009BE0:
        dc.w    $0001
        dc.l    $FE040000, $0000FFF8
loc_009BEA:
        dc.w    $0001
        dc.l    $FC040000, $0000FFF8
loc_009BF4:
        dc.w    $0001
        dc.l    $FC080002, $0001FFF4
loc_009BFE:
        dc.w    $0001
        dc.l    $FC0C0005, $0002FFF0
loc_009C08:
        dc.w    $0000  
        nop                     ; Filler
;=============================================================================== 
; Object 0x2A - Dust Hill - Up and Down Pillar
;===============================================================================            
Obj2A_Up_Down_Pillar: ; loc_009C0C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009C1A(pc,d0), d1
        jmp     loc_009C1A(pc,d1)
loc_009C1A:
        dc.w    loc_009C1E-loc_009C1A
        dc.w    loc_009C58-loc_009C1A
loc_009C1E:
        addq.b  #2,routine(a0)
        move.l  #Up_Down_Pillar_Mappings,mappings(a0) ; loc_009CAE
        move.w  #$4000,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  #$50, y_radius(a0)
        bset    #4,render_flags(a0)
loc_009C58:
        tst.b   $0025(a0)
        bne.s   loc_009C72
        addq.w  #1, Objoff_30(a0)
        cmpi.w  #$060, Objoff_30(a0)
        bne.s   loc_009C84
        move.b  #$2, $0025(a0)
        bra.s   loc_009C84
loc_009C72:
        subq.w  #8, Objoff_30(a0)
        bhi.s   loc_009C84
        move.w  #0, Objoff_30(a0)
        move.b  #0, $0025(a0)
loc_009C84:
        move.w  $0032(A0), D0
        sub.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$40, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        bra     MarkObjGone             ; loc_00D2A0
Up_Down_Pillar_Mappings:        
loc_009CAE:
        dc.w    loc_009CB0-loc_009CAE
loc_009CB0:
        dc.w    $0006
        dc.l    $B009001A, $000DFFF0, $C00F0020, $0010FFF0
        dc.l    $E00F0030, $0018FFF0, $000F1030, $1018FFF0
        dc.l    $200F1020, $1010FFF0, $4009101A, $100DFFF0        
;=============================================================================== 
; Object 0x2A - Dust Hill - Up and Down Pillar
;===============================================================================           

;=============================================================================== 
; Object 0x2D - Hill Top / Chemical Plant - Automatic Door. 
;===============================================================================          
Obj2D_Automatic_Door: ; loc_009CE2:        
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009CF0(pc,d0), d1
        jmp     loc_009CF0(pc,d1)
loc_009CF0:
        dc.w    loc_009CF4-loc_009CF0
        dc.w    loc_009D76-loc_009CF0
loc_009CF4:
        addq.b  #2,routine(a0)
        move.l  #Automatic_Door_Mappings,mappings(a0) ; loc_009E1E
        move.w  #$2426,art_tile(a0)
        move.b  #8,width_pixels(a0)
        cmpi.b  #4, (Current_ZoneAndAct).w
        bne.s   loc_009D20
        move.w  #$6000,art_tile(a0)
        move.b  #$C,width_pixels(a0)
loc_009D20:
        cmpi.b  #$D, (Current_ZoneAndAct).w
        bne.s   loc_009D34
        move.w  #$2394,art_tile(a0)
        move.b  #$C,width_pixels(a0)
loc_009D34:
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  subtype(A0), $001A(a0)
        move.w  x_pos(a0), D2
        move.w  D2, d3
        subi.w  #$200, D2
        addi.w  #$018, d3
        btst    #0, status(a0)
        beq.s   loc_009D6E
        subi.w  #$FE18, D2
        addi.w  #$1E8, d3
loc_009D6E:
        move.w  D2, objoff_38(a0)
        move.w  d3, objoff_3A(a0)
loc_009D76:
        btst    #0, status(a0)
        bne.s   loc_009D92
        move.w  objoff_38(A0), D2
        move.w  x_pos(a0), D3
        tst.b   $0025(a0)
        beq.s   loc_009DA4
        move.w  objoff_3A(A0), D3
        bra.s   loc_009DA4
loc_009D92:
        move.w  x_pos(a0), D2
        move.w  objoff_3A(A0), D3
        tst.b   $0025(a0)
        beq.s   loc_009DA4
        move.w  objoff_38(A0), D2
loc_009DA4:
        move.b  #0, $0025(a0)
        move.w  (MainCharacter+x_pos).w, d0
        cmp.w   d2, d0
        bcs     loc_009DC0
        cmp.w   d3, d0
        bcc     loc_009DC0
        move.b  #$2, $0025(a0)
loc_009DC0:
        move.w  ($FFFFB048).w, d0
        cmp.w   d2, d0
        bcs     loc_009DD6
        cmp.w   d3, d0
        bcc     loc_009DD6
        move.b  #$2, $0025(a0)
loc_009DD6:
        tst.b   $0025(a0)
        beq.s   loc_009DEA
        cmpi.w  #$40, Objoff_30(a0)
        beq.s   loc_009E00
        addq.w  #8,  Objoff_30(a0)
        bra.s   loc_009DF4
loc_009DEA:
        tst.w   Objoff_30(a0)
        beq.s   loc_009E00
        subq.w  #8, Objoff_30(a0)
loc_009DF4:
        move.w  $0032(A0), D0
        sub.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
loc_009E00:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$20, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        bra     MarkObjGone             ; loc_00D2A0
Automatic_Door_Mappings:        
loc_009E1E:
        dc.w    loc_009E24-loc_009E1E
        dc.w    loc_009E46-loc_009E1E
        dc.w    loc_009E58-loc_009E1E
loc_009E24:
        dc.w    $0004
        dc.l    $E0050000, $0000FFF8, $F0050000, $0000FFF8
        dc.l    $00050000, $0000FFF8, $10050000, $0000FFF8
loc_009E46:
        dc.w    $0002
        dc.l    $E00B005F, $002FFFF4, $000B005F, $002FFFF4
loc_009E58:
        dc.w    $0002
        dc.l    $E0070000, $0000FFF8, $00070000, $0000FFF8
;=============================================================================== 
; Object 0x2D - Hill Top / Chemical Plant - Automatic Door. 
;===============================================================================
        nop                     ; Filler
;=============================================================================== 
; Object ??? - Unknow Object 0x009E6C
;    Sonic 1 Object 1E - leftover Ballhog Object
;===============================================================================        
S1_Ballhog: ; Unknow_Obj009E6C: ; loc_009E6C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009E7A(pc,d0), d1
        jmp     loc_009E7A(pc,d1)
loc_009E7A:
        dc.w    loc_009E7E-loc_009E7A
        dc.w    loc_009ED2-loc_009E7A
loc_009E7E:
        move.b  #$13, y_radius(a0)
        move.b  #8, $0017(a0)
        move.l  #S1_Ballhog_Mappings,mappings(a0) loc_00A18E
        move.w  #$2302,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #5,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        bsr     ObjectFall              ; loc_00D24E
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_009ED0
        add.w   d1, y_pos(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
loc_009ED0:
        rts
loc_009ED2:
        lea     (Ani_S1_Ballhog), A1    ; loc_00A174
        bsr     AnimateSprite           ; loc_00D412
        cmpi.b  #1, $001A(a0)
        bne.s   loc_009EEC
        tst.b   $0032(a0)
        beq.s   loc_009EF4
        bra.s   loc_009EF0
loc_009EEC:
        clr.b   $0032(a0)
loc_009EF0:
        bra     MarkObjGone             ; loc_00D2A0
loc_009EF4:
        move.b  #1, $0032(a0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_009F38
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$FF00,x_vel(a1)
        move.w  #0, $0012(a1)
        moveq   #Checksum_fourcc, d0
        btst    #0, status(a0)
        beq.s   loc_009F28
        neg.w   D0
        neg.w  x_vel(a1)
loc_009F28:
        add.w   d0, x_pos(a1)
        addi.w  #$00C, y_pos(a1)
        move.b  subtype(A0), subtype(a1)
loc_009F38:
        bra.s   loc_009EF0                
;=============================================================================== 
; Object ??? - Unknow Object 0x009E6C
;===============================================================================           
;=============================================================================== 
; Object ??? - Unknow Object 0x009F3A    
;  Sonic1 Object 20 - leftover Object for the ball that Ballhog throws
;===============================================================================  
S1_BallHog_Ball: ; Unknow_Obj009F3A: ; loc_009F3A:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_009F48(pc,d0), d1
        jmp     loc_009F48(pc,d1)
loc_009F48:
        dc.w    loc_009F4C-loc_009F48
        dc.w    loc_009F94-loc_009F48
loc_009F4C:
        addq.b  #2,routine(a0)
        move.b  #$7, y_radius(a0)
        move.l  #S1_Ballhog_Mappings,mappings(a0) ; loc_00A18E
        move.w  #$2302,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$87,collision_flags(a0)
        move.b  #8,width_pixels(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        mulu.w  #$03C, d0
        move.w  d0, Objoff_30(a0)
        move.b  #4, $001A(a0)
loc_009F94:
        jsr     ObjectFall              ; (loc_00D24E)
        tst.w   $0012(a0)
        bmi.s   loc_009FD0
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_009FD0
        add.w   d1, y_pos(a0)
        move.w  #$FD00, $0012(a0)
        tst.b   D3
        beq.s   loc_009FD0
        bmi.s   loc_009FC6
        tst.w  x_vel(a0)
        bpl.s   loc_009FD0
        neg.w  x_vel(a0)
        bra.s   loc_009FD0
loc_009FC6:
        tst.w  x_vel(a0)
        bmi.s   loc_009FD0
        neg.w  x_vel(a0)
loc_009FD0:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_009FEC
        move.b  #$24, 0(a0)
        move.b  #$3F, 0(a0)
        move.b  #0, $0024(a0)
        bra     Obj3F        ; loc_00A11E
loc_009FEC:
        subq.b  #1, $001E(a0)
        bpl.s   loc_009FFE
        move.b  #5, $001E(a0)
        bchg    #0, $001A(a0)
loc_009FFE:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object ??? - Unknow Object 0x009F3A
;===============================================================================  

;=============================================================================== 
; Object 0x24 
;===============================================================================            
Obj24: ; loc_00A012:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00A020(pc,d0), d1
        jmp     loc_00A020(pc,d1)
loc_00A020:
        dc.w    loc_00A024-loc_00A020
        dc.w    loc_00A068-loc_00A020
loc_00A024:
        addq.b  #2,routine(a0)
        move.l  #loc_00A1F6,mappings(a0)
        move.w  #$41C,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #0,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        move.b  #$9, $001E(a0)
        move.b  #0, $001A(a0)
        move.w  #$0A5, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_00A068:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00A082
        move.b  #$9, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #4, $001A(a0)
        beq     DeleteObject            ; loc_00D3B4
loc_00A082:
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x24 
;=============================================================================== 
             
;=============================================================================== 
; Object 0x27 - Object Hit - Enemies / Monitors 
;===============================================================================         
Obj27_Object_Hit: ; loc_00A086:             
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Object_Hit_Index(pc,d0), d1 ; loc_00A094
        jmp     Object_Hit_Index(pc,d1)     ; loc_00A094
Object_Hit_Index: ; loc_00A094:
        dc.w    loc_00A09A-Object_Hit_Index
        dc.w    loc_00A0BC-Object_Hit_Index
        dc.w    loc_00A100-Object_Hit_Index
loc_00A09A:
        addq.b  #2,routine(a0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00A0BC
        move.b  #$28, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  Objoff_3E(A0), Objoff_3E(a1)
loc_00A0BC:
        addq.b  #2,routine(a0)
        move.l  #Object_Hit_Mappings,mappings(a0) loc_00A226
        move.w  #$5A0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #0,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        move.b  #$7, $001E(a0)
        move.b  #0, $001A(a0)
        move.w  #$0C1, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_00A100:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00A11A
        move.b  #$7, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #5, $001A(a0)
        beq     DeleteObject            ; loc_00D3B4
loc_00A11A:
        bra     DisplaySprite           ; loc_00D3C2  
;=============================================================================== 
; Object 0x27 - Object Hit - Enemies / Monitors 
;===============================================================================   
;=============================================================================== 
; Object 0x3F 
;===============================================================================  
Obj3F: ; loc_00A11E:               
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00A12C(pc,d0), d1
        jmp     loc_00A12C(pc,d1)
loc_00A12C:
        dc.w    loc_00A130-loc_00A12C
        dc.w    loc_00A100-loc_00A12C
loc_00A130:
        addq.b  #2,routine(a0)
        move.l  #loc_00A292,mappings(a0)
        move.w  #$5A0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #0,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        move.b  #$7, $001E(a0)
        move.b  #0, $001A(a0)
        move.w  #$0C4, d0
        jmp     (Play_Sfx)              ; loc_0014C6           
;=============================================================================== 
; Object 0x3F
;===============================================================================        
Ani_S1_Ballhog: ; Unknow_Obj009E6C_Data: ; loc_00A174:
        dc.w    loc_00A176-Ani_S1_Ballhog
loc_00A176:
        dc.b    $09, $00, $00, $02, $02, $03, $02, $00, $00, $02, $02, $03, $02, $00, $00, $02
        dc.b    $02, $03, $02, $00, $00, $01, $FF, $00    
S1_Ballhog_Mappings: ; Unknow_Obj009E6C_Mappings:  loc_00A18E:
        dc.w    loc_00A19A-S1_Ballhog_Mappings
        dc.w    loc_00A1AC-S1_Ballhog_Mappings
        dc.w    loc_00A1BE-S1_Ballhog_Mappings
        dc.w    loc_00A1D0-S1_Ballhog_Mappings
        dc.w    loc_00A1E2-S1_Ballhog_Mappings
        dc.w    loc_00A1EC-S1_Ballhog_Mappings
loc_00A19A:
        dc.w    $0002
        dc.l    $EF090000, $0000FFF4, $FF0A0006, $0003FFF4
loc_00A1AC:
        dc.w    $0002
        dc.l    $EF090000, $0000FFF4, $FF0A000F, $0007FFF4
loc_00A1BE:
        dc.w    $0002
        dc.l    $F4090000, $0000FFF4, $04090018, $000CFFF4
loc_00A1D0:
        dc.w    $0002
        dc.l    $E4090000, $0000FFF4, $F40A001E, $000FFFF4
loc_00A1E2:
        dc.w    $0001
        dc.l    $F8050027, $0013FFF8
loc_00A1EC:
        dc.w    $0001
        dc.l    $F805002B, $0015FFF8              
loc_00A1F6:
        dc.w    loc_00A1FE-loc_00A1F6
        dc.w    loc_00A208-loc_00A1F6
        dc.w    loc_00A212-loc_00A1F6
        dc.w    loc_00A21C-loc_00A1F6
loc_00A1FE:
        dc.w    $0001
        dc.l    $F40A0000, $0000FFF4
loc_00A208:
        dc.w    $0001
        dc.l    $F40A0009, $0004FFF4
loc_00A212:
        dc.w    $0001
        dc.l    $F40A0012, $0009FFF4
loc_00A21C:
        dc.w    $0001
        dc.l    $F40A001B, $000DFFF4
Object_Hit_Mappings: ; loc_00A226:
        dc.w    Object_Hit_Map_01-Object_Hit_Mappings
        dc.w    Object_Hit_Map_02-Object_Hit_Mappings
        dc.w    Object_Hit_Map_03-Object_Hit_Mappings
        dc.w    Object_Hit_Map_04-Object_Hit_Mappings
        dc.w    Object_Hit_Map_05-Object_Hit_Mappings
Object_Hit_Map_01: ; loc_00A230:
        dc.w    $0001
        dc.l    $F8090000, $0000FFF4
Object_Hit_Map_02: ;loc_00A23A:
        dc.w    $0001
        dc.l    $F00F0006, $0003FFF0
Object_Hit_Map_03: ;loc_00A244:
        dc.w    $0001
        dc.l    $F00F0016, $000BFFF0
Object_Hit_Map_04: ;loc_00A24E:
        dc.w    $0004
        dc.l    $EC0A0026, $0013FFEC, $EC05002F, $00170004
        dc.l    $0405182F, $1817FFEC, $FC0A1826, $1813FFFC
Object_Hit_Map_05: ;loc_00A270:
        dc.w    $0004
        dc.l    $EC0A0033, $0019FFEC, $EC05003C, $001E0004
        dc.l    $0405183C, $181EFFEC, $FC0A1833, $1819FFFC
loc_00A292:
        dc.w    Object_Hit_Map_01-loc_00A292
        dc.w    loc_00A29C-loc_00A292
        dc.w    loc_00A2A6-loc_00A292
        dc.w    Object_Hit_Map_04-loc_00A292
        dc.w    Object_Hit_Map_05-loc_00A292
loc_00A29C:
        dc.w    $0001
        dc.l    $F00F0040, $0020FFF0
loc_00A2A6:
        dc.w    $0001
        dc.l    $F00F0050, $0028FFF0  
;=============================================================================== 
; Object 0x28 - Flickies
;===============================================================================                         
Obj28_Flickies: ; loc_00A2B0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Flickies_Index(pc,d0), d1 ; loc_00A2BE
        jmp     Flickies_Index(pc,d1)     ; loc_00A2BE
Flickies_Index: ; loc_00A2BE:
        dc.w    loc_00A3B2-Flickies_Index
        dc.w    loc_00A4D8-Flickies_Index
        dc.w    loc_00A532-Flickies_Index
        dc.w    loc_00A56E-Flickies_Index
        dc.w    loc_00A532-Flickies_Index
        dc.w    loc_00A532-Flickies_Index
        dc.w    loc_00A532-Flickies_Index
        dc.w    loc_00A56E-Flickies_Index
        dc.w    loc_00A532-Flickies_Index
        dc.w    loc_00A5EE-Flickies_Index
        dc.w    loc_00A60E-Flickies_Index
        dc.w    loc_00A60E-Flickies_Index
        dc.w    loc_00A62E-Flickies_Index
        dc.w    loc_00A668-Flickies_Index
        dc.w    loc_00A6C2-Flickies_Index
        dc.w    loc_00A6E0-Flickies_Index
        dc.w    loc_00A6C2-Flickies_Index
        dc.w    loc_00A6E0-Flickies_Index
        dc.w    loc_00A6C2-Flickies_Index
        dc.w    loc_00A71E-Flickies_Index
        dc.w    loc_00A684-Flickies_Index
loc_00A2E8:
        dc.b    $00, $05, $02, $03, $06, $03, $04, $05, $04, $01, $00, $01, $00, $05, $02, $03
        dc.b    $06, $03, $04, $05, $04, $01, $00, $01, $00, $05, $02, $03, $06, $03, $04, $05
        dc.b    $04, $01, $00, $01
loc_00A30C:
        dc.w    $FE00, $FC00
        dc.l    loc_00A816
        dc.w    $FE00, $FD00
        dc.l    loc_00A83A
        dc.w    $FE80, $FD00
        dc.l    loc_00A816
        dc.w    $FEC0, $FE80
        dc.l    loc_00A83A
        dc.w    $FE40, $FD00
        dc.l    loc_00A85E
        dc.w    $FD00, $FC00
        dc.l    loc_00A83A
        dc.w    $FD80, $FC80
        dc.l    loc_00A85E
loc_00A344:
        dc.w    $FBC0, $FC00, $FBC0, $FC00, $FBC0, $FC00, $FD00, $FC00
        dc.w    $FD00, $FC00, $FE80, $FD00, $FE80, $FD00, $FEC0, $FE80
        dc.w    $FE40, $FD00, $FE00, $FD00, $FD80, $FC80
loc_00A370:
        dc.l    loc_00A83A
        dc.l    loc_00A83A
        dc.l    loc_00A83A
        dc.l    loc_00A816
        dc.l    loc_00A816
        dc.l    loc_00A816
        dc.l    loc_00A816
        dc.l    loc_00A83A
        dc.l    loc_00A85E
        dc.l    loc_00A83A
        dc.l    loc_00A85E        
loc_00A39C:
        dc.w    $05A5, $05A5, $05A5, $0553, $0553, $0573, $0573, $0585
        dc.w    $0593, $0565, $05B3
loc_00A3B2:
        tst.b   subtype(a0)
        beq     loc_00A420
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.b  d0, $0024(a0)
        subi.w  #$014, d0
        move.w  loc_00A39C(pc,d0),art_tile(a0)
        add.w   d0, d0
        move.l  loc_00A370(pc,d0), mappings(a0)
        lea     loc_00A344(PC), A1
        move.w  $00(A1, d0), $0032(a0)
        move.w  $00(A1, d0),x_vel(a0)
        move.w  $02(A1, d0), Objoff_34(a0)
        move.w  $02(A1, d0), $0012(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$C, y_radius(a0)
        move.b  #4,render_flags(a0)
        bset    #0,render_flags(a0)
        move.b  #6, $0018(a0)
        move.b  #8,width_pixels(a0)
        move.b  #$7, $001E(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00A420:
        addq.b  #2,routine(a0)
        bsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$001, d0
        moveq   #0,d1
        move.b  (Current_Zone).w, d1
        add.w   d1, d1
        add.w   d0, d1
        lea     loc_00A2E8(PC), A1
        move.b  $00(A1, d1), D0
        move.b  d0, Objoff_30(a0)
        lsl.w   #3, d0
        lea     loc_00A30C(PC), A1
        adda.w  d0, A1
        move.w  (A1)+, $0032(a0)
        move.w  (A1)+, Objoff_34(a0)
        move.l  (A1)+, mappings(a0)
        move.w  #$580,art_tile(a0)
        btst    #0, Objoff_30(a0)
        beq.s   loc_00A46A
        move.w  #$592,art_tile(a0)
loc_00A46A:
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$C, y_radius(a0)
        move.b  #4,render_flags(a0)
        bset    #0,render_flags(a0)
        move.b  #6, $0018(a0)
        move.b  #8,width_pixels(a0)
        move.b  #$7, $001E(a0)
        move.b  #$2, $001A(a0)
        move.w  #$FC00, $0012(a0)
        tst.b   ($FFFFF7A7).w
        bne.s   loc_00A4CA
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00A4C6
        move.b  #$29, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  Objoff_3E(A0), D0
        lsr.w   #1,d0
        move.b  d0, $001A(a1)
loc_00A4C6:
        bra     DisplaySprite           ; loc_00D3C2
loc_00A4CA:
        move.b  #$12, $0024(a0)
        clr.w  x_vel(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00A4D8:
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bsr     ObjectFall              ; loc_00D24E
        tst.w   $0012(a0)
        bmi.s   loc_00A52E
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A52E
        add.w   d1, y_pos(a0)
        move.w  $0032(A0),x_vel(a0)
        move.w  Objoff_34(A0), $0012(a0)
        move.b  #1, $001A(a0)
        move.b  Objoff_30(A0), D0
        add.b   d0, d0
        addq.b  #4, d0
        move.b  d0, $0024(a0)
        tst.b   ($FFFFF7A7).w
        beq.s   loc_00A52E
        btst    #4, ($FFFFFE0F).w
        beq.s   loc_00A52E
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
loc_00A52E:
        bra     DisplaySprite           ; loc_00D3C2
loc_00A532:
        bsr     ObjectFall              ; loc_00D24E
        move.b  #1, $001A(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A55C
        move.b  #0, $001A(a0)
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A55C
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
loc_00A55C:
        tst.b   subtype(a0)
        bne.s   loc_00A5D2
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00A56E:
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A5AA
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A5AA
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
        tst.b   subtype(a0)
        beq.s   loc_00A5AA
        cmpi.b  #$A, subtype(a0)
        beq.s   loc_00A5AA
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
loc_00A5AA:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00A5C0
        move.b  #1, $001E(a0)
        addq.b  #1, $001A(a0)
        andi.b  #1, $001A(a0)
loc_00A5C0:
        tst.b   subtype(a0)
        bne.s   loc_00A5D2
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00A5D2:
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bcs.s   loc_00A5EA
        subi.w  #$180, d0
        bpl.s   loc_00A5EA
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
loc_00A5EA:
        bra     DisplaySprite           ; loc_00D3C2
loc_00A5EE:
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        subq.w  #1, objoff_36(a0)
        bne     loc_00A60A
        move.b  #2,routine(a0)
        move.b  #3,priority(a0)
loc_00A60A:
        bra     DisplaySprite           ; loc_00D3C2
loc_00A60E:
        bsr     loc_00A7B2
        bcc.s   loc_00A62A
        move.w  $0032(A0),x_vel(a0)
        move.w  Objoff_34(A0), $0012(a0)
        move.b  #$E, $0024(a0)
        bra     loc_00A56E
loc_00A62A:
        bra     loc_00A5D2
loc_00A62E:
        bsr     loc_00A7B2
        bpl.s   loc_00A664
        clr.w  x_vel(a0)
        clr.w   $0032(a0)
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        bsr     loc_00A772
        bsr     loc_00A79A
        subq.b  #1, $001E(a0)
        bpl.s   loc_00A664
        move.b  #1, $001E(a0)
        addq.b  #1, $001A(a0)
        andi.b  #1, $001A(a0)
loc_00A664:
        bra     loc_00A5D2
loc_00A668:
        bsr     loc_00A7B2
        bpl.s   loc_00A6BE
        move.w  $0032(A0),x_vel(a0)
        move.w  Objoff_34(A0), $0012(a0)
        move.b  #4,routine(a0)
        bra     loc_00A532
loc_00A684:
        bsr     ObjectFall              ; loc_00D24E
        move.b  #1, $001A(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A6BE
        move.b  #0, $001A(a0)
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A6BE
        not.b  $0029(a0)
        bne.s   loc_00A6B4
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
loc_00A6B4:
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
loc_00A6BE:
        bra     loc_00A5D2
loc_00A6C2:
        bsr     loc_00A7B2
        bpl.s   loc_00A6DC
        clr.w  x_vel(a0)
        clr.w   $0032(a0)
        bsr     ObjectFall              ; loc_00D24E
        bsr     loc_00A772
        bsr     loc_00A79A
loc_00A6DC:
        bra     loc_00A5D2
loc_00A6E0:
        bsr     loc_00A7B2
        bpl.s   loc_00A71A
        bsr     ObjectFall              ; loc_00D24E
        move.b  #1, $001A(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A71A
        move.b  #0, $001A(a0)
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A71A
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
loc_00A71A:
        bra     loc_00A5D2
loc_00A71E:
        bsr     loc_00A7B2
        bpl.s   loc_00A76E
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A758
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A758
        not.b  $0029(a0)
        bne.s   loc_00A74E
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
loc_00A74E:
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
loc_00A758:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00A76E
        move.b  #1, $001E(a0)
        addq.b  #1, $001A(a0)
        andi.b  #1, $001A(a0)
loc_00A76E:
        bra     loc_00A5D2
loc_00A772:
        move.b  #1, $001A(a0)
        tst.w   $0012(a0)
        bmi.s   loc_00A798
        move.b  #0, $001A(a0)
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A798
        add.w   d1, y_pos(a0)
        move.w  Objoff_34(A0), $0012(a0)
loc_00A798:
        rts
loc_00A79A:
        bset    #0,render_flags(a0)
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bcc.s   loc_00A7B0
        bclr    #0,render_flags(a0)
loc_00A7B0:
        rts
loc_00A7B2:
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        subi.w  #$0B8, d0
        rts   
;=============================================================================== 
; Object 0x28 - Flickies
;===============================================================================  
;=============================================================================== 
; Object 0x29 - Enemy Points
;===============================================================================            
Obj29_Enemy_Points: ; loc_00A7C0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Enemy_Points_Index(pc,d0), d1  ; loc_00A7CE
        jmp     Enemy_Points_Index(pc,d1)      ; loc_00A7CE
Enemy_Points_Index: ; loc_00A7CE:
        dc.w    loc_00A7D2-Enemy_Points_Index
        dc.w    loc_00A800-Enemy_Points_Index
loc_00A7D2:
        addq.b  #2,routine(a0)
        move.l  #Enemy_Points_Mappings,mappings(a0) ; loc_00A882
        move.w  #$4AC,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #8,width_pixels(a0)
        move.w  #$FD00, $0012(a0)
loc_00A800:
        tst.w   $0012(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x29 - Enemy Points
;===============================================================================         
loc_00A816:
        dc.w    loc_00A826-loc_00A816
        dc.w    loc_00A830-loc_00A816
        dc.w    loc_00A81C-loc_00A816
loc_00A81C:
        dc.w    $0001
        dc.l    $F4060000, $0000FFF8
loc_00A826:
        dc.w    $0001
        dc.l    $F4060006, $0003FFF8
loc_00A830:
        dc.w    $0001
        dc.l    $F406000C, $0006FFF8                     
loc_00A83A:
        dc.w    loc_00A84A-loc_00A83A
        dc.w    loc_00A854-loc_00A83A
        dc.w    loc_00A840-loc_00A83A
loc_00A840:
        dc.w    $0001
        dc.l    $F4060000, $0000FFF8
loc_00A84A:
        dc.w    $0001
        dc.l    $FC050006, $0003FFF8
loc_00A854:
        dc.w    $0001
        dc.l    $FC05000A, $0005FFF8
loc_00A85E:
        dc.w    loc_00A86E-loc_00A85E
        dc.w    loc_00A878-loc_00A85E
        dc.w    loc_00A864-loc_00A85E
loc_00A864:
        dc.w    $0001
        dc.l    $F4060000, $0000FFF8
loc_00A86E:
        dc.w    $0001
        dc.l    $FC090006, $0003FFF4
loc_00A878:
        dc.w    $0001
        dc.l    $FC09000C, $0006FFF4                    
Enemy_Points_Mappings:
loc_00A882:
        dc.w    loc_00A890-loc_00A882
        dc.w    loc_00A89A-loc_00A882
        dc.w    loc_00A8A4-loc_00A882
        dc.w    loc_00A8AE-loc_00A882
        dc.w    loc_00A8C0-loc_00A882
        dc.w    loc_00A8CA-loc_00A882
        dc.w    loc_00A8DC-loc_00A882
loc_00A890:
        dc.w    $0001
        dc.l    $F8050002, $0001FFF8
loc_00A89A:
        dc.w    $0001
        dc.l    $F8050006, $0003FFF8
loc_00A8A4:
        dc.w    $0001
        dc.l    $F805000A, $0005FFF8
loc_00A8AE:
        dc.w    $0002
        dc.l    $F8010000, $0000FFF8, $F805000E, $00070000
loc_00A8C0:
        dc.w    $0001
        dc.l    $F8010000, $0000FFFC
loc_00A8CA:
        dc.w    $0002
        dc.l    $F8050002, $0001FFF0, $F805000E, $00070000
loc_00A8DC:
        dc.w    $0002
        dc.l    $F805000A, $0005FFF0, $F805000E, $00070000                  
               
        nop                     ; Filler                        
;=============================================================================== 
; Object ??? - Unknow Object 0x00A8F0  (Sonic 1 Object 1F - GHZ Crabmeat)
;===============================================================================          
S1_Crabmeat: ; Unknow_Obj00A8F0: ; loc_00A8F0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00A8FE(pc,d0), d1
        jmp     loc_00A8FE(pc,d1)
loc_00A8FE:
        dc.w    loc_00A908-loc_00A8FE
        dc.w    loc_00A960-loc_00A8FE
        dc.w    loc_00AABC-loc_00A8FE
        dc.w    loc_00AAC0-loc_00A8FE
        dc.w    loc_00AAFA-loc_00A8FE
loc_00A908:
        move.b  #$10, y_radius(a0)
        move.b  #8, $0017(a0)
        move.l  #Crabmeat_Mappings,mappings(a0) ; loc_00AB4C
        move.w  #$400,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #6,collision_flags(a0)
        move.b  #$15,width_pixels(a0)
        bsr     ObjectFall              ; loc_00D24E
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_00A95E
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
loc_00A95E:
        rts
loc_00A960:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_00A97C(pc,d0), d1
        jsr     loc_00A97C(pc,d1)
        lea     (loc_00AB1C), A1
        bsr     AnimateSprite           ; loc_00D412
        bra     MarkObjGone             ; loc_00D2A0
loc_00A97C:
        dc.w    loc_00A980-loc_00A97C
        dc.w    loc_00AA1E-loc_00A97C
loc_00A980:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_00A9BA
        tst.b   render_flags(a0)
        bpl.s   loc_00A994
        bchg    #1, $0032(a0)
        bne.s   loc_00A9BC
loc_00A994:
        addq.b  #$2, $0025(a0)
        move.w  #$07F, Objoff_30(a0)
        move.w  #$080,x_vel(a0)
        bsr     loc_00AA8C
        addq.b  #3, d0
        move.b  d0, $001C(a0)
        bchg    #0, status(a0)
        bne.s   loc_00A9BA
        neg.w  x_vel(a0)
loc_00A9BA:
        rts
loc_00A9BC:
        move.w  #$03B, Objoff_30(a0)
        move.b  #6, $001C(a0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00A9F2
        move.b  #$1F, 0(a1)
        move.b  #6, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        subi.w  #$010, x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$FF00,x_vel(a1)
loc_00A9F2:
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00AA1C
        move.b  #$1F, 0(a1)
        move.b  #6, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        addi.w  #$010, x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$100,x_vel(a1)
loc_00AA1C:
        rts
loc_00AA1E:
        subq.w  #1, Objoff_30(a0)
        bmi.s   loc_00AA72
        bsr     SpeedToPos              ; loc_00D27A
        bchg    #0, $0032(a0)
        bne.s   loc_00AA58
        move.w  x_pos(a0), D3
        addi.w  #$010, d3
        btst    #0, status(a0)
        beq.s   loc_00AA44
        subi.w  #$20, d3
loc_00AA44:
        jsr     ObjHitFloor2            ; (loc_01389C)
        cmpi.w  #$FFF8, d1
        blt.s   loc_00AA72
        cmpi.w  #$00C, d1
        bge.s   loc_00AA72
        rts
loc_00AA58:
        jsr     ObjHitFloor             ; (loc_013898)
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     loc_00AA8C
        addq.b  #3, d0
        move.b  d0, $001C(a0)
        rts
loc_00AA72:
        subq.b  #$2, $0025(a0)
        move.w  #$03B, Objoff_30(a0)
        move.w  #0,x_vel(a0)
        bsr     loc_00AA8C
        move.b  d0, $001C(a0)
        rts
loc_00AA8C:
        moveq	#0,d0
        move.b  angle(A0), D3
        bmi.s   loc_00AAA8
        cmpi.b  #6, d3
        bcs.s   loc_00AAA6
        moveq   #1,d0
        btst    #0, status(a0)
        bne.s   loc_00AAA6
        moveq   #$2, d0
loc_00AAA6:
        rts
loc_00AAA8:
        cmpi.b  #$FA, d3
        bhi.s   loc_00AABA
        moveq   #$2, d0
        btst    #0, status(a0)
        bne.s   loc_00AABA
        moveq   #1,d0
loc_00AABA:
        rts
loc_00AABC:
        bra     DeleteObject            ; loc_00D3B4
loc_00AAC0:
        addq.b  #2,routine(a0)
        move.l  #Crabmeat_Mappings,mappings(a0) ; loc_00AB4C
        move.w  #$400,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$87,collision_flags(a0)
        move.b  #8,width_pixels(a0)
        move.w  #$FC00, $0012(a0)
        move.b  #$7, $001C(a0)
loc_00AAFA:
        lea     (loc_00AB1C), A1
        bsr     AnimateSprite           ; loc_00D412
        bsr     ObjectFall              ; loc_00D24E
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2  
loc_00AB1C:
        dc.w    loc_00AB2C-loc_00AB1C
        dc.w    loc_00AB2F-loc_00AB1C
        dc.w    loc_00AB32-loc_00AB1C
        dc.w    loc_00AB35-loc_00AB1C
        dc.w    loc_00AB3A-loc_00AB1C
        dc.w    loc_00AB3F-loc_00AB1C
        dc.w    loc_00AB44-loc_00AB1C
        dc.w    loc_00AB47-loc_00AB1C
loc_00AB2C:
        dc.b    $0F, $00, $FF
loc_00AB2F:
        dc.b    $0F, $02, $FF
loc_00AB32:
        dc.b    $0F, $22, $FF
loc_00AB35:
        dc.b    $0F, $01, $21, $00, $FF
loc_00AB3A:
        dc.b    $0F, $21, $03, $02, $FF
loc_00AB3F:
        dc.b    $0F, $01, $23, $22, $FF
loc_00AB44:
        dc.b    $0F, $04, $FF
loc_00AB47:
        dc.b    $01, $05, $06, $FF, $00     
Crabmeat_Mappings: ; loc_00AB4C:
        dc.w    loc_00AB5A-Crabmeat_Mappings
        dc.w    loc_00AB7C-Crabmeat_Mappings
        dc.w    loc_00AB9E-Crabmeat_Mappings
        dc.w    loc_00ABC0-Crabmeat_Mappings
        dc.w    loc_00ABE2-Crabmeat_Mappings
        dc.w    loc_00AC14-Crabmeat_Mappings
        dc.w    loc_00AC1E-Crabmeat_Mappings
loc_00AB5A:
        dc.w    $0004
        dc.l    $F0090000, $0000FFE8, $F0090800, $08000000
        dc.l    $00050006, $0003FFF0, $00050806, $08030000
loc_00AB7C:
        dc.w    $0004
        dc.l    $F009000A, $0005FFE8, $F0090010, $00080000
        dc.l    $00050016, $000BFFF0, $0009001A, $000D0000
loc_00AB9E:
        dc.w    $0004
        dc.l    $EC090000, $0000FFE8, $EC090800, $08000000
        dc.l    $FC050806, $08030000, $FC060020, $0010FFF0
loc_00ABC0:
        dc.w    $0004
        dc.l    $EC09000A, $0005FFE8, $EC090010, $00080000
        dc.l    $FC090026, $00130000, $FC06002C, $0016FFF0
loc_00ABE2:
        dc.w    $0006
        dc.l    $F0040032, $0019FFF0, $F0040832, $08190000
        dc.l    $F8090034, $001AFFE8, $F8090834, $081A0000
        dc.l    $0804003A, $001DFFF0, $0804083A, $081D0000
loc_00AC14:
        dc.w    $0001
        dc.l    $F805003C, $001EFFF8
loc_00AC1E:
        dc.w    $0001
        dc.l    $F8050040, $0020FFF8                   
;=============================================================================== 
; Object ??? - Unknow Object 0x00A8F0
;===============================================================================          
                  
;=============================================================================== 
; Object 0x25 - Rings  
;===============================================================================           
Obj25_Rings: ; loc_00AC28:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Rings_Index(pc,d0), d1  ; loc_00AC36
        jmp     Rings_Index(pc,d1)      ; loc_00AC36
Rings_Index: ; loc_00AC36:
        dc.w    loc_00AC60-Rings_Index
        dc.w    loc_00ACCE-Rings_Index
        dc.w    loc_00ACEA-Rings_Index
        dc.w    loc_00AD10-Rings_Index
        dc.w    loc_00AD1E-Rings_Index        
;loc_00AC40:
        dc.b    $10, $00, $18, $00, $20, $00, $00, $10, $00, $18, $00, $20, $10, $10, $18, $18
        dc.b    $20, $20, $F0, $10, $E8, $18, $E0, $20, $10, $08, $18, $10, $F0, $08, $E8, $10   
loc_00AC60:
        move.l  A0, A1
        moveq   #0,d1
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        bra.s   loc_00AC76
loc_00AC6E:
        swap.w  d1
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00ACCE
loc_00AC76:
        move.b  #$25, 0(a1)
        addq.b  #$2, $0024(a1)
        move.w  D2, x_pos(a1)
        move.w  x_pos(a0), $0032(a1)
        move.w  d3, y_pos(a1)
        move.l  #Rings_Mappings, mappings(a1)  ; loc_00B036
        move.w  #$26BC, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #4, render_flags(a1)
        move.b  #$2, $0018(a1)
        move.b  #$47, $0020(a1)
        move.b  #8, $0019(a1)
        move.b  $0023(A0), $0023(a1)
        move.b  d1, Objoff_34(a1)
        addq.w  #1,d1
        add.w   d5, D2
        add.w   d6, d3
        swap.w  d1
        dbra    d1, loc_00AC6E   
loc_00ACCE:
        move.b  ($FFFFFEC3).w, $001A(a0)
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_00AD1E
        bra     DisplaySprite           ; loc_00D3C2
loc_00ACEA:
        addq.b  #2,routine(a0)
        move.b  #0,collision_flags(a0)
        move.b  #1, $0018(a0)
        bsr     loc_00AD22
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        move.b  Objoff_34(A0), d1
        bset    d1, $02(A2, d0)
loc_00AD10:
        lea     (loc_00B02E), A1
        bsr     AnimateSprite           ; loc_00D412
        bra     DisplaySprite           ; loc_00D3C2
loc_00AD1E:
        bra     DeleteObject            ; loc_00D3B4
loc_00AD22:
        addq.w  #1, (Ring_count).w
        ori.b   #1, (Update_HUD_rings).w
        move.w  #$0B5, d0
        cmpi.w  #$064, (Ring_count).w
        bcs.s   loc_00AD5C
        bset    #1, ($FFFFFE1B).w
        beq.s   loc_00AD50
        cmpi.w  #$0C8, (Ring_count).w
        bcs.s   loc_00AD5C
        bset    #$2, ($FFFFFE1B).w
        bne.s   loc_00AD5C
loc_00AD50:
        addq.b  #1, ($FFFFFE12).w
        addq.b  #1, (Update_HUD_lives).w
        move.w  #$088, d0           ; +1UP Sound - Sonic 1 LeftOver
loc_00AD5C:
        jmp     (Play_Sfx)              ; loc_0014C6
;=============================================================================== 
; Object 0x25 - Rings  
;===============================================================================  

;=============================================================================== 
; Object 0x37 - Rings flying out of you when you get hit 
;=============================================================================== 
Obj37_Rings_Out: ; loc_00AD62:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Rings_Out_Index(pc,d0), d1 ; loc_00AD70
        jmp     Rings_Out_Index(pc,d1)     ; loc_00AD70
Rings_Out_Index: ; loc_00AD70:
        dc.w    loc_00AD7A-Rings_Out_Index
        dc.w    loc_00AE3E-Rings_Out_Index
        dc.w    loc_00AE90-Rings_Out_Index
        dc.w    loc_00AEA4-Rings_Out_Index
        dc.w    loc_00AEB2-Rings_Out_Index
loc_00AD7A:
        move.l  A0, A1
        moveq   #0,d5
        move.w  (Ring_count).w,d5
        moveq   #$20, d0
        cmp.w   d0,d5
        bcs.s   loc_00AD8A
        move.w  d0,d5
loc_00AD8A:
        subq.w  #1,d5
        move.w  #$288, D4
        bra.s   loc_00AD9A
loc_00AD92:  
        bsr     SingleObjectLoad        ; loc_00E772
        bne     loc_00AE22
loc_00AD9A:
        move.b  #$37, 0(a1)
        addq.b  #$2, $0024(a1)
        move.b  #8, y_radius(a1)
        move.b  #8, $0017(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  #Rings_Mappings, mappings(a1)  ; loc_00B036
        move.w  #$26BC, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #$47, $0020(a1)
        move.b  #8, $0019(a1)
        move.b  #$FF, ($FFFFFEC6).w
        tst.w   D4
        bmi.s   loc_00AE12
        move.w  d4, d0
        bsr     CalcSine        ; loc_00320A
        move.w  d4, D2
        lsr.w   #8, D2
        asl.w   d2, d0
        asl.w   D2, d1
        move.w  d0, D2
        move.w  d1, d3
        addi.b  #$10, D4
        bcc.s   loc_00AE12
        subi.w  #$080, D4
        bcc.s   loc_00AE12
        move.w  #$288, D4
loc_00AE12:
        move.w  D2,x_vel(a1)
        move.w  d3, $0012(a1)
        neg.w   D2
        neg.w   D4
        dbra    d5, loc_00AD92 
loc_00AE22:         
        move.w  #0, (Ring_count).w
        move.b  #$80, (Update_HUD_rings).w
        move.b  #0, ($FFFFFE1B).w
        move.w  #$0C6, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_00AE3E:
        move.b  ($FFFFFEC7).w, $001A(a0)
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        bmi.s   loc_00AE78
        move.b  ($FFFFFE0F).w, d0
        add.b   d7, d0
        andi.b  #3, d0
        bne.s   loc_00AE78
        jsr     loc_0138F4
        tst.w   d1
        bpl.s   loc_00AE78
        add.w   d1, y_pos(a0)
        move.w  $0012(A0), D0
        asr.w   #$2, d0
        sub.w   d0, $0012(a0)
        neg.w   $0012(a0)
loc_00AE78:
        tst.b   ($FFFFFEC6).w
        beq.s   loc_00AEB2
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs.s   loc_00AEB2
        bra     DisplaySprite           ; loc_00D3C2
loc_00AE90:
        addq.b  #2,routine(a0)
        move.b  #0,collision_flags(a0)
        move.b  #1, $0018(a0)
        bsr     loc_00AD22
loc_00AEA4:
        lea     (loc_00B02E), A1
        bsr     AnimateSprite           ; loc_00D412
        bra     DisplaySprite           ; loc_00D3C2
loc_00AEB2:
        bra     DeleteObject            ; loc_00D3B4
;=============================================================================== 
; Object 0x37 - Rings flying out of you when you get hit   
;===============================================================================         
        
;=============================================================================== 
; Object 0x4B - Big Ring (Special Stage Access)   
;             Unused - Sonic 1 LeftOver
;===============================================================================             
Obj4B_Big_Ring: ; loc_00AEB6:  
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Big_Ring_Index(pc,d0), d1  ; loc_00AEC4
        jmp     Big_Ring_Index(pc,d1)      ; loc_00AEC4
Big_Ring_Index: ; loc_00AEC4:
        dc.w    loc_00AECC-Big_Ring_Index
        dc.w    loc_00AF1A-Big_Ring_Index
        dc.w    loc_00AF38-Big_Ring_Index
        dc.w    loc_00AF7C-Big_Ring_Index
loc_00AECC:        
        move.l  #Big_Ring_Mappings,mappings(a0) ; loc_00B09A
        move.w  #$2400,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #$40,width_pixels(a0)
        tst.b   render_flags(a0)
        bpl.s   loc_00AF1A
        cmpi.b  #6, ($FFFFFE57).w
        beq     loc_00AF7C
        cmpi.w  #$032, (Ring_count).w
        bcc.s   loc_00AF04
        rts
loc_00AF04:
        addq.b  #2,routine(a0)
        move.b  #$2, $0018(a0)
        move.b  #$52,collision_flags(a0)
        move.w  #$C40, ($FFFFF7BE).w
loc_00AF1A:
        move.b  ($FFFFFEC3).w, $001A(a0)
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00AF38:
        subq.b  #2,routine(a0)
        move.b  #0,collision_flags(a0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne     loc_00AF70
        move.b  #$7C, 0(a1)     ; Call Object 0x7C - Big Ring Flash
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  A0, $003C(a1)
        move.w  (MainCharacter+x_pos).w, d0
        cmp.w   x_pos(a0), D0
        bcs.s   loc_00AF70
        bset    #0, render_flags(a1)
loc_00AF70:
        move.w  #$0C3, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        bra.s   loc_00AF1A
loc_00AF7C:
        bra     DeleteObject            ; loc_00D3B4
;=============================================================================== 
; Object 0x4B - Big Ring (Special Stage Access)   
;             Unused - Sonic 1 LeftOver 
;===============================================================================  

;=============================================================================== 
; Object 0x7C - Big Ring Flash (Special Stage Access)   
;             Unused - Sonic 1 LeftOver
;===============================================================================   
Obj7C_Big_Ring_Flash: ; loc_00AF80: 
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Big_Ring_Flash_Index(pc,d0), d1   ; loc_00AF8E
        jmp     Big_Ring_Flash_Index(pc,d1)       ; loc_00AF8E
Big_Ring_Flash_Index: ; loc_00AF8E:
        dc.w    loc_00AF94-Big_Ring_Flash_Index
        dc.w    loc_00AFC2-Big_Ring_Flash_Index
        dc.w    loc_00B02A-Big_Ring_Flash_Index
loc_00AF94:        
        addq.b  #2,routine(a0)
        move.l  #Big_Ring_Flash_Mappings,mappings(a0) ; loc_00B19A
        move.w  #$2462,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #0, $0018(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #$FF, $001A(a0)
loc_00AFC2:  
        bsr.s   loc_00AFDC
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2 
loc_00AFDC:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00B01A
        move.b  #1, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #8, $001A(a0)
        bcc.s   loc_00B01C
        cmpi.b  #3, $001A(a0)
        bne.s   loc_00B01A
        move.l  Objoff_3C(a0), A1
        move.b  #6, $0024(a1)
        move.b  #$1C, ($FFFFB01C).w
        move.b  #1, ($FFFFF7CD).w
        clr.b   ($FFFFFE2D).w
        clr.b   ($FFFFFE2C).w
loc_00B01A:
        rts
loc_00B01C:
        addq.b  #2,routine(a0)
        move.w  #0, (MainCharacter).w
        addq.l  #4, A7
        rts
loc_00B02A:
        bra     DeleteObject            ; loc_00D3B4
;=============================================================================== 
; Object 0x7C - Big Ring Flash (Special Stage Access)   
;            Unused - Sonic 1 LeftOver
;===============================================================================  
loc_00B02E:
        dc.w    $0002, $0504, $0506, $07FC  
Rings_Mappings: ; loc_00B036:
        dc.w    Rings_Map_01-Rings_Mappings
        dc.w    Rings_Map_02-Rings_Mappings
        dc.w    Rings_Map_03-Rings_Mappings
        dc.w    Rings_Map_04-Rings_Mappings
        dc.w    Rings_Map_05-Rings_Mappings
        dc.w    Rings_Map_06-Rings_Mappings
        dc.w    Rings_Map_07-Rings_Mappings
        dc.w    Rings_Map_08-Rings_Mappings
        dc.w    Rings_Map_Null-Rings_Mappings
Rings_Map_01: ; loc_00B048:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
Rings_Map_02: ; loc_00B052:
        dc.w    $0001
        dc.l    $F8050004, $0002FFF8
Rings_Map_03: ; loc_00B05C:
        dc.w    $0001
        dc.l    $F8010008, $0004FFFC
Rings_Map_04: ; loc_00B066:
        dc.w    $0001
        dc.l    $F8050804, $0802FFF8
Rings_Map_05: ; loc_00B070:
        dc.w    $0001
        dc.l    $F805000A, $0005FFF8
Rings_Map_06: ; loc_00B07A:
        dc.w    $0001
        dc.l    $F805180A, $1805FFF8
Rings_Map_07: ; loc_00B084:
        dc.w    $0001
        dc.l    $F805080A, $0805FFF8
Rings_Map_08: ; loc_00B08E:
        dc.w    $0001
        dc.l    $F805100A, $1005FFF8
Rings_Map_Null: ; loc_00B098:
        dc.w    $0000          
Big_Ring_Mappings: ; loc_00B09A:
        dc.w    Big_Ring_Map_01-Big_Ring_Mappings
        dc.w    Big_Ring_Map_02-Big_Ring_Mappings
        dc.w    Big_Ring_Map_03-Big_Ring_Mappings
        dc.w    Big_Ring_Map_04-Big_Ring_Mappings
Big_Ring_Map_01: ; loc_00B0A2:
        dc.w    $000A
        dc.l    $E0080000, $0000FFE8, $E0080003, $00010000
        dc.l    $E80C0006, $0003FFE0, $E80C000A, $00050000
        dc.l    $F007000E, $0007FFE0, $F0070016, $000B0010
        dc.l    $100C001E, $000FFFE0, $100C0022, $00110000
        dc.l    $18080026, $0013FFE8, $18080029, $00140000
Big_Ring_Map_02: ; loc_00B0F4:
        dc.w    $0008
        dc.l    $E00C002C, $0016FFF0, $E8080030, $0018FFE8
        dc.l    $E8090033, $00190000, $F0070039, $001CFFE8
        dc.l    $F8050041, $00200008, $08090045, $00220000
        dc.l    $1008004B, $0025FFE8, $180C004E, $0027FFF0
Big_Ring_Map_03: ; loc_00B136:
        dc.w    $0004
        dc.l    $E0070052, $0029FFF4, $E0030852, $08290004
        dc.l    $0007005A, $002DFFF4, $0003085A, $082D0004
Big_Ring_Map_04: ; loc_00B158:
        dc.w    $0008
        dc.l    $E00C082C, $0816FFF0, $E8080830, $08180000
        dc.l    $E8090833, $0819FFE8, $F0070839, $081C0008
        dc.l    $F8050841, $0820FFE8, $08090845, $0822FFE8
        dc.l    $1008084B, $08250000, $180C084E, $0827FFF0 
Big_Ring_Flash_Mappings: ; loc_00B19A:
        dc.w    Big_Ring_Flash_Map_01-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_02-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_03-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_04-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_05-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_06-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_07-Big_Ring_Flash_Mappings
        dc.w    Big_Ring_Flash_Map_08-Big_Ring_Flash_Mappings
Big_Ring_Flash_Map_01: ; loc_00B1AA:
        dc.w    $0002
        dc.l    $E00F0000, $00000000, $000F1000, $10000000
Big_Ring_Flash_Map_02: ; loc_00B1BC:
        dc.w    $0004
        dc.l    $E00F0010, $0008FFF0, $E0070020, $00100010
        dc.l    $000F1010, $1008FFF0, $00071020, $10100010
Big_Ring_Flash_Map_03: ; loc_00B1DE:
        dc.w    $0004
        dc.l    $E00F0028, $0014FFE8, $E00B0038, $001C0008
        dc.l    $000F1028, $1014FFE8, $000B1038, $101C0008
Big_Ring_Flash_Map_04: ; loc_00B200:
        dc.w    $0004
        dc.l    $E00F0834, $081AFFE0, $E00F0034, $001A0000
        dc.l    $000F1834, $181AFFE0, $000F1034, $101A0000
Big_Ring_Flash_Map_05: ; loc_00B222:
        dc.w    $0004
        dc.l    $E00B0838, $081CFFE0, $E00F0828, $0814FFF8
        dc.l    $000B1838, $181CFFE0, $000F1828, $1814FFF8
Big_Ring_Flash_Map_06: ; loc_00B244:
        dc.w    $0004
        dc.l    $E0070820, $0810FFE0, $E00F0810, $0808FFF0
        dc.l    $00071820, $1810FFE0, $000F1810, $1808FFF0
Big_Ring_Flash_Map_07: ; loc_00B266:
        dc.w    $0002
        dc.l    $E00F0800, $0800FFE0, $000F1800, $1800FFE0
Big_Ring_Flash_Map_08: ; loc_00B278:
        dc.w    $0004
        dc.l    $E00F0044, $0022FFE0, $E00F0844, $08220000
        dc.l    $000F1044, $1022FFE0, $000F1844, $18220000
        nop                     ; Filler
;=============================================================================== 
; Object 0x26 - Monitors 
;===============================================================================          
Obj26_Monitors: ; loc_00B29C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Monitors_Index(pc,d0), d1 ; loc_00B2AA
        jmp     Monitors_Index(pc,d1)     ; loc_00B2AA
Monitors_Index: ; loc_00B2AA:
        dc.w    loc_00B2B4-Monitors_Index
        dc.w    loc_00B31A-Monitors_Index
        dc.w    loc_00B40C-Monitors_Index
        dc.w    loc_00B3FE-Monitors_Index
        dc.w    loc_00B408-Monitors_Index
loc_00B2B4:
        addq.b  #2,routine(a0)
        move.b  #$E, y_radius(a0)
        move.b  #$E, $0017(a0)
        move.l  #Monitors_Mappings,mappings(a0) ; loc_00B6D2
        move.w  #$680,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$F,width_pixels(a0)
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        bclr    #$7, $02(A2, d0)
        btst    #0, $02(A2, d0)
        beq.s   loc_00B30E
        move.b  #8, $0024(a0)
        move.b  #$B, $001A(a0)
        rts
loc_00B30E:
        move.b  #$46,collision_flags(a0)
        move.b  subtype(A0), $001C(a0)
loc_00B31A:
        move.b  $0025(A0), D0
        beq.s   loc_00B374
        subq.b  #$2, d0
        bne.s   loc_00B354
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        bsr     loc_00FBC0
        btst    #3, status(a1)
        bne     loc_00B344
        clr.b   $0025(a0)
        bra     loc_00B3FE
loc_00B344:
        move.w  #$010, d3
        move.w  x_pos(a0), D2
        bsr     loc_00F8E4
        bra     loc_00B3FE
loc_00B354:
        bsr     ObjectFall              ; loc_00D24E
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl     loc_00B3FE
        add.w   d1, y_pos(a0)
        clr.w   $0012(a0)
        clr.b   $0025(a0)
        bra     loc_00B3FE
loc_00B374:
        move.w  #$01A, d1
        move.w  #$F, D2
        bsr     loc_00B5F0
        beq     loc_00B3E4
        tst.w   $0012(a1)
        bmi.s   loc_00B392
        cmpi.b  #$2, $001C(a1)
        beq.s   loc_00B3E4
loc_00B392:
        tst.w   d1
        bpl.s   loc_00B3A8
        sub.w   d3, y_pos(a1)
        bsr     loc_00FAF2
        move.b  #$2, $0025(a0)
        bra     loc_00B3FE
loc_00B3A8:
        tst.w   D0
        beq     loc_00B3CE
        bmi.s   loc_00B3B8
        tst.w  x_vel(a1)
        bmi.s   loc_00B3CE
        bra.s   loc_00B3BE
loc_00B3B8:
        tst.w  x_vel(a1)
        bpl.s   loc_00B3CE
loc_00B3BE:
        sub.w   d0, x_pos(a1)
        move.w  #0, $14(a1)
        move.w  #0,x_vel(a1)
loc_00B3CE:
        btst    #1, status(a1)
        bne.s   loc_00B3F2
        bset    #5, status(a1)
        bset    #5, status(a0)
        bra.s   loc_00B3FE
loc_00B3E4:
        btst    #5, status(a0)
        beq.s   loc_00B3FE
        move.w  #$001, $001C(a1)
loc_00B3F2:
        bclr    #5, status(a0)
        bclr    #5, status(a1)
loc_00B3FE:
        lea     (loc_00B66A), A1
        bsr     AnimateSprite           ; loc_00D412
loc_00B408:
        bra     MarkObjGone             ; loc_00D2A0
loc_00B40C:
        addq.b  #2,routine(a0)
        move.b  #0,collision_flags(a0)
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_00B434
        move.b  #$2E, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  $001C(A0), $001C(a1)
loc_00B434:
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_00B450
        move.b  #$27, 0(a1)
        addq.b  #$2, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
loc_00B450:
        lea     (Object_Respawn_Table).w, a2           
        moveq	#0,d0
        move.b  $0023(A0), D0
        bset    #0, $02(A2, d0)
        move.b  #$A, $001C(a0)
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x26 - Monitors 
;===============================================================================   
;=============================================================================== 
; Object 0x2E - Monitors Contents
;===============================================================================           
Obj2E_Monitors_Contents: ; loc_00B46A:        
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00B478(pc,d0), d1
        jmp     loc_00B478(pc,d1)
loc_00B478:
        dc.w    loc_00B47E-loc_00B478
        dc.w    loc_00B4C2-loc_00B478
        dc.w    loc_00B5E4-loc_00B478
loc_00B47E:
        addq.b  #2,routine(a0)
        move.w  #$680,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$24,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #8,width_pixels(a0)
        move.w  #$FD00, $0012(a0)
        moveq	#0,d0
        move.b  $001C(A0), D0
        addq.b  #1,d0
        move.b  d0, $001A(a0)
        move.l  #Monitors_Mappings, A1  ; loc_00B6D2
        add.b   d0, d0
        adda.w  $00(A1, d0), A1
        addq.w  #$2, A1
        move.l  A1,mappings(a0)
loc_00B4C2:
        bsr.s   loc_00B4C8
        bra     DisplaySprite           ; loc_00D3C2
loc_00B4C8:
        tst.w   $0012(a0)
        bpl     loc_00B4DC
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$018, $0012(a0)
        rts
loc_00B4DC:
        addq.b  #2,routine(a0)
        move.w  #$01D, $001E(a0)
        moveq	#0,d0
        move.b  $001C(A0), D0
        add.w   d0, d0
        move.w  Monitor_Subroutines(pc,d0), D0 ; loc_00B4F6
        jmp     Monitor_Subroutines(pc,d0)     ; loc_00B4F6
Monitor_Subroutines: ; loc_00B4F6:
        dc.w    Monitor_Null-Monitor_Subroutines          ; loc_00B50A
        dc.w    Monitor_SonicLife-Monitor_Subroutines     ; loc_00B50C
        dc.w    Monitor_TailsLife-Monitor_Subroutines     ; loc_00B51E
        dc.w    Monitor_Null-Monitor_Subroutines          ; loc_00B50A
        dc.w    Monitor_Rings-Monitor_Subroutines         ; loc_00B530
        dc.w    Monitor_Shoes-Monitor_Subroutines         ; loc_00B56A
        dc.w    Monitor_Shield-Monitor_Subroutines        ; loc_00B592
        dc.w    Monitor_Invincibility-Monitor_Subroutines ; loc_00B5A8
        dc.w    Monitor_SuperSonic-Monitor_Subroutines    ; loc_00B5D4
        dc.w    Monitor_Null-Monitor_Subroutines          ; loc_00B50A
Monitor_Null: ; loc_00B50A:
        rts
Monitor_SonicLife: ; loc_00B50C:
        addq.b  #1, ($FFFFFE12).w
        addq.b  #1, (Update_HUD_lives).w
        move.w  #$098, d0
        jmp     (Play_Music)            ; loc_0014C0
Monitor_TailsLife: ; loc_00B51E:
        addq.b  #1, ($FFFFFE12).w
        addq.b  #1, (Update_HUD_lives).w
        move.w  #$098, d0
        jmp     (Play_Music)            ; loc_0014C0
Monitor_Rings: ; loc_00B530:
        addi.w  #$00A, (Ring_count).w
        ori.b   #1, (Update_HUD_rings).w
        cmpi.w  #$064, (Ring_count).w
        bcs.s   loc_00B560
        bset    #1, ($FFFFFE1B).w
        beq     Monitor_SonicLife       ; loc_00B50C
        cmpi.w  #$0C8, (Ring_count).w
        bcs.s   loc_00B560
        bset    #$2, ($FFFFFE1B).w
        beq     Monitor_SonicLife       ; loc_00B50C
loc_00B560:
        move.w  #$0B5, d0
        jmp     (Play_Music)            ; loc_0014C0
Monitor_Shoes: ; loc_00B56A:
        move.b  #1, ($FFFFFE2E).w
        move.w  #$4B0, ($FFFFB034).w
        move.w  #$C00, ($FFFFF760).w
        move.w  #$018, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        move.w  #$0FB, d0
        jmp     (Play_Music)            ; loc_0014C0
Monitor_Shield: ; loc_00B592:
        move.b  #1, ($FFFFFE2C).w
        move.b  #$38, ($FFFFB180).w
        move.w  #$0AF, d0
        jmp     (Play_Music)            ; loc_0014C0
Monitor_Invincibility: ; loc_00B5A8:
        move.b  #1, ($FFFFFE2D).w
        move.w  #$4B0, ($FFFFB032).w
        move.b  #$35, ($FFFFB200).w
        tst.b   ($FFFFF7AA).w
        bne.s   loc_00B5D2
        cmpi.w  #$00C, ($FFFFFE14).w
        bls.s   loc_00B5D2
        move.w  #$095, d0
        jmp     (Play_Music)            ; loc_0014C0
loc_00B5D2:
        rts
Monitor_SuperSonic: ; loc_00B5D4:
        move.b  #1, (Super_Sonic_palette).w
        move.w  #$0AF, d0
        jmp     (Play_Music)            ; loc_0014C0
loc_00B5E4:
        subq.w  #1, $001E(a0)
        bmi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00B5F0:
        lea     (MainCharacter).w, A1
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00B648
        move.w  d1, d3
        add.w   d3, d3
        cmp.w   d3, d0
        bhi.s   loc_00B648
        move.b  y_radius(A1), D3
        ext.w   D3
        add.w   d3, D2
        move.w  y_pos(A1), D3
        sub.w   y_pos(a0), D3
        add.w   D2, d3
        bmi.s   loc_00B648
        add.w   D2, D2
        cmp.w   D2, d3
        bcc.s   loc_00B648
        tst.b   $002A(a1)
        bmi.s   loc_00B648
        cmpi.b  #6, ($FFFFB024).w
        bcc.s   loc_00B648
        tst.w   (Debug_placement_mode).w
        bne.s   loc_00B648
        cmp.w   d0, d1
        bcc.s   loc_00B63E
        add.w   d1, d1
        sub.w   d1, d0
loc_00B63E:
        cmpi.w  #$010, d3
        bcs.s   loc_00B64C
loc_00B644:        
        moveq   #1,d1
        rts
loc_00B648:
        moveq   #0,d1
        rts
loc_00B64C:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addq.w  #4, d1
        move.w  d1, D2
        add.w   D2, D2
        add.w   x_pos(A1), d1
        sub.w   x_pos(a0), d1
        bmi.s   loc_00B644
        cmp.w   D2, d1
        bcc.s   loc_00B644
        moveq   #$FFFFFFFF, d1
        rts    
loc_00B66A:
        dc.w    loc_00B680-loc_00B66A
        dc.w    loc_00B684-loc_00B66A
        dc.w    loc_00B68C-loc_00B66A
        dc.w    loc_00B694-loc_00B66A
        dc.w    loc_00B69C-loc_00B66A
        dc.w    loc_00B6A4-loc_00B66A
        dc.w    loc_00B6AC-loc_00B66A
        dc.w    loc_00B6B4-loc_00B66A
        dc.w    loc_00B6BC-loc_00B66A
        dc.w    loc_00B6C4-loc_00B66A
        dc.w    loc_00B6CC-loc_00B66A
loc_00B680:
        dc.b    $01, $00, $01, $FF
loc_00B684:
        dc.b    $01, $00, $02, $02, $01, $02, $02, $FF
loc_00B68C:
        dc.b    $01, $00, $03, $03, $01, $03, $03, $FF
loc_00B694:
        dc.b    $01, $00, $04, $04, $01, $04, $04, $FF
loc_00B69C:
        dc.b    $01, $00, $05, $05, $01, $05, $05, $FF
loc_00B6A4:
        dc.b    $01, $00, $06, $06, $01, $06, $06, $FF
loc_00B6AC:
        dc.b    $01, $00, $07, $07, $01, $07, $07, $FF
loc_00B6B4:
        dc.b    $01, $00, $08, $08, $01, $08, $08, $FF
loc_00B6BC:
        dc.b    $01, $00, $09, $09, $01, $09, $09, $FF
loc_00B6C4:
        dc.b    $01, $00, $0A, $0A, $01, $0A, $0A, $FF
loc_00B6CC:
        dc.b    $02, $00, $01, $0B, $FE, $01
Monitors_Mappings: ; loc_00B6D2:
        dc.w    loc_00B6EA-Monitors_Mappings
        dc.w    loc_00B6F4-Monitors_Mappings
        dc.w    loc_00B706-Monitors_Mappings
        dc.w    loc_00B718-Monitors_Mappings
        dc.w    loc_00B72A-Monitors_Mappings
        dc.w    loc_00B73C-Monitors_Mappings
        dc.w    loc_00B74E-Monitors_Mappings
        dc.w    loc_00B760-Monitors_Mappings
        dc.w    loc_00B772-Monitors_Mappings
        dc.w    loc_00B784-Monitors_Mappings
        dc.w    loc_00B796-Monitors_Mappings
        dc.w    loc_00B7A8-Monitors_Mappings
loc_00B6EA:
        dc.w    $0001
        dc.l    $EF0F0000, $0000FFF0
loc_00B6F4:
        dc.w    $0002
        dc.l    $F5050018, $000CFFF8, $EF0F0000, $0000FFF0
loc_00B706:
        dc.w    $0002
        dc.l    $F5050154, $00AAFFF8, $EF0F0000, $0000FFF0
loc_00B718:
        dc.w    $0002
        dc.l    $F505001C, $000EFFF8, $EF0F0000, $0000FFF0
loc_00B72A:
        dc.w    $0002
        dc.l    $F5050020, $0010FFF8, $EF0F0000, $0000FFF0
loc_00B73C:
        dc.w    $0002
        dc.l    $F5052024, $2012FFF8, $EF0F0000, $0000FFF0
loc_00B74E:
        dc.w    $0002
        dc.l    $F5050028, $0014FFF8, $EF0F0000, $0000FFF0
loc_00B760:
        dc.w    $0002
        dc.l    $F505002C, $0016FFF8, $EF0F0000, $0000FFF0
loc_00B772:
        dc.w    $0002
        dc.l    $F5050030, $0018FFF8, $EF0F0000, $0000FFF0
loc_00B784:
        dc.w    $0002
        dc.l    $F5050034, $001AFFF8, $EF0F0000, $0000FFF0
loc_00B796:
        dc.w    $0002
        dc.l    $F5050038, $001CFFF8, $EF0F0000, $0000FFF0
loc_00B7A8:
        dc.w    $0001
        dc.l    $FF0D0010, $0008FFF0        
;=============================================================================== 
; Object 0x2E - Monitors Contents
;===============================================================================          
        nop                     ; Filler        
;=============================================================================== 
; Object 0x0E - Sonic & Tails in Title Screen   
;===============================================================================                      
Obj0E_Sonic_Tails: ; loc_00B7B4:        
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Sonic_Tails_Index(pc,d0), d1  ; loc_00B7C2
        jmp     Sonic_Tails_Index(pc,d1)      ; loc_00B7C2
Sonic_Tails_Index: ; loc_00B7C2:
        dc.w    loc_00B7CA-Sonic_Tails_Index
        dc.w    loc_00B80C-Sonic_Tails_Index
        dc.w    loc_00B820-Sonic_Tails_Index
        dc.w    loc_00B836-Sonic_Tails_Index             
loc_00B7CA:
        addq.b  #2,routine(a0)
        move.w  #$148, x_pos(a0)
        move.w  #$0C4, $000A(a0)
        move.l  #Sonic_Tails_Mappings,mappings(a0) ; loc_00BAA2
        move.w  #$4200,art_tile(a0)
        move.b  #1, $0018(a0)
        move.b  #$1D, $001F(a0)
        tst.b   $001A(a0)
        beq.s   loc_00B80C
        move.w  #$0FC, x_pos(a0)
        move.w  #$0CC, $000A(a0)
        move.w  #$2200,art_tile(a0) 
loc_00B80C:
        bra     DisplaySprite           ; loc_00D3C2           
loc_00B810:
        subq.b  #1, $001F(a0)
        bpl.s   loc_00B81E
        addq.b  #2,routine(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00B81E:
        rts
loc_00B820:
        subi.w  #8, $000A(a0)
        cmpi.w  #$096, $000A(a0)
        bne.s   loc_00B832
        addq.b  #2,routine(a0)
loc_00B832:
        bra     DisplaySprite           ; loc_00D3C2
loc_00B836:
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x0E - Object 0x0E - Sonic & Tails in Title Screen   
;===============================================================================          
        
;=============================================================================== 
; Object 0x0F 
;===============================================================================    
Obj0F: ; loc_00B83A:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00B84C(pc,d0), d1
        jsr     loc_00B84C(pc,d1)
        bra     DisplaySprite           ; loc_00D3C2
loc_00B84C:
        dc.w    loc_00B852-loc_00B84C
        dc.w    loc_00B874-loc_00B84C
        dc.w    loc_00B874-loc_00B84C
loc_00B852:
        addq.b  #2,routine(a0)
        move.w  #$090, x_pos(a0)
        move.w  #$090, $000A(a0)
        move.l  #loc_00B896,mappings(a0)
        move.w  #$680,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
loc_00B874:
        move.b  (Ctrl_1_Press).w, d0
        btst    #5, d0
        beq.s   loc_00B888
        addq.b  #1, $001A(a0)
        andi.b  #$F, $001A(a0)
loc_00B888:
        btst    #4, d0
        beq.s   loc_00B894
        bchg    #0, ($FFFFFFD9).w
loc_00B894:
        rts
loc_00B896:
        dc.w    loc_00B8B6-loc_00B896
        dc.w    loc_00B8C0-loc_00B896
        dc.w    loc_00B8CA-loc_00B896
        dc.w    loc_00B8D4-loc_00B896
        dc.w    loc_00B8DE-loc_00B896
        dc.w    loc_00B8E8-loc_00B896
        dc.w    loc_00B8F2-loc_00B896
        dc.w    loc_00B8FC-loc_00B896
        dc.w    loc_00B906-loc_00B896
        dc.w    loc_00B910-loc_00B896
        dc.w    loc_00B91A-loc_00B896
        dc.w    loc_00B924-loc_00B896
        dc.w    loc_00B92E-loc_00B896
        dc.w    loc_00B938-loc_00B896
        dc.w    loc_00B942-loc_00B896
        dc.w    loc_00B94C-loc_00B896
loc_00B8B6:
        dc.w    $0001
        dc.l    $00000000, $00000000
loc_00B8C0:
        dc.w    $0001
        dc.l    $00010000, $00000000
loc_00B8CA:
        dc.w    $0001
        dc.l    $00020000, $00000000
loc_00B8D4:
        dc.w    $0001
        dc.l    $00030000, $00000000
loc_00B8DE:
        dc.w    $0001
        dc.l    $00040000, $00000000
loc_00B8E8:
        dc.w    $0001
        dc.l    $00050000, $00000000
loc_00B8F2:
        dc.w    $0001
        dc.l    $00060000, $00000000
loc_00B8FC:
        dc.w    $0001
        dc.l    $00070000, $00000000
loc_00B906:
        dc.w    $0001
        dc.l    $00080000, $00000000
loc_00B910:
        dc.w    $0001
        dc.l    $00090000, $00000000
loc_00B91A:
        dc.w    $0001
        dc.l    $000A0000, $00000000
loc_00B924:
        dc.w    $0001
        dc.l    $000B0000, $00000000
loc_00B92E:
        dc.w    $0001
        dc.l    $000C0000, $00000000
loc_00B938:
        dc.w    $0001
        dc.l    $000D0000, $00000000
loc_00B942:
        dc.w    $0001
        dc.l    $000E0000, $00000000
loc_00B94C:
        dc.w    $0001
        dc.l    $000F0000, $00000000
;=============================================================================== 
; Object 0x0F  
;===============================================================================  
loc_00B956:  ; Unknow Object Data
        dc.w    loc_00B958-loc_00B956
loc_00B958:
        dc.b    $07, $00, $01, $02, $03, $04, $05, $06, $07, $FE, $02, $00, $00, $02, $1F, $00
        dc.b    $01, $FF
S1_Obj0F_Mappings: ; loc_00B96A:  ; Unknow Mappings
        dc.w    loc_00B972-S1_Obj0F_Mappings
        dc.w    loc_00B974-S1_Obj0F_Mappings
        dc.w    loc_00B9A6-S1_Obj0F_Mappings
        dc.w    loc_00BA98-S1_Obj0F_Mappings
loc_00B972:
        dc.w    $0000
loc_00B974:
        dc.w    $0006
        dc.l    $000C00F0, $00780000, $000000F3, $00790020
        dc.l    $000000F3, $00790030, $000C00F4, $007A0038
        dc.l    $000800F8, $007C0060, $000800FB, $007D0078
loc_00B9A6:
        dc.w    $001E
        dc.l    $B80F0000, $0000FF80, $B80F0000, $0000FF80
        dc.l    $B80F0000, $0000FF80, $B80F0000, $0000FF80
        dc.l    $B80F0000, $0000FF80, $B80F0000, $0000FF80
        dc.l    $B80F0000, $0000FF80, $B80F0000, $0000FF80
        dc.l    $B80F0000, $0000FF80, $B80F0000, $0000FF80
        dc.l    $D80F0000, $0000FF80, $D80F0000, $0000FF80
        dc.l    $D80F0000, $0000FF80, $D80F0000, $0000FF80
        dc.l    $D80F0000, $0000FF80, $D80F0000, $0000FF80
        dc.l    $D80F0000, $0000FF80, $D80F0000, $0000FF80
        dc.l    $D80F0000, $0000FF80, $D80F0000, $0000FF80
        dc.l    $F80F0000, $0000FF80, $F80F0000, $0000FF80
        dc.l    $F80F0000, $0000FF80, $F80F0000, $0000FF80
        dc.l    $F80F0000, $0000FF80, $F80F0000, $0000FF80
        dc.l    $F80F0000, $0000FF80, $F80F0000, $0000FF80
        dc.l    $F80F0000, $0000FF80, $F80F0000, $0000FF80
loc_00BA98:
        dc.w    $0001
        dc.l    $FC040000, $0000FFF8                
Sonic_Tails_Mappings:        
loc_00BAA2:                          
        dc.w    loc_00BAA6-loc_00BAA2
        dc.w    loc_00BB00-loc_00BAA2 
loc_00BAA6: ; Object $0E - Mappings
        dc.w    $000B ; Sonic in Title Screen
        dc.l    $D40D0000, $0000FFD8, $CC0E0008, $0004FFF8
        dc.l    $CC070014, $000A0018, $E40F001C, $000EFFE0
        dc.l    $E40B002C, $00160000, $EC070038, $001C0018
        dc.l    $040F0040, $0020FFD8, $040F0050, $0028FFF8
        dc.l    $0C060060, $00300018, $24040066, $0033FFE8
        dc.l    $240D0068, $0034FFF8
loc_00BB00:
        dc.w    $000A ; Tails in Title Screen
        dc.l    $DC060070, $0038FFEC, $F40F0076, $003BFFD4
        dc.l    $F40F0086, $0043FFF4, $E4090096, $004BFFFC
        dc.l    $DC0B009C, $004E0014, $FC0800A8, $00540014
        dc.l    $040500AB, $00550014, $140400AF, $0057FFD4
        dc.l    $140D00B1, $0058FFE4, $140D00B9, $005C0004
        nop

               
;=============================================================================== 
; Object 0x34 - Title Cards / Splash Screen
;===============================================================================   
Obj34_Title_Cards: ; loc_00BB54: 
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Title_Cards_Index(pc,d0), d1 ; loc_00BB62
        jmp     Title_Cards_Index(pc,d1)     ; loc_00BB62
Title_Cards_Index: ; loc_00BB62:        
        dc.w    loc_00BB6A-Title_Cards_Index
        dc.w    loc_00BBDC-Title_Cards_Index
        dc.w    loc_00BC04-Title_Cards_Index
        dc.w    loc_00BC04-Title_Cards_Index
loc_00BB6A:
        move.l  A0, A1
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        move.w  d0, D2
        lea     (Title_Cards_Config), A3 ; loc_00BC66
        lsl.w   #4, d0
        adda.w  d0, A3
        lea     (Title_Cards_Main_Position), A2 ; loc_00BC56
        moveq   #3, d1
Title_Card_Loop: ; loc_00BB86:        
        move.b  #$34, 0(a1)
        move.w  (A3), x_pos(a1)
        move.w  (A3)+, $0032(a1)
        move.w  (A3)+, Objoff_30(a1)
        move.w  (A2)+, $000A(a1)
        move.b  (A2)+, $0024(a1)
        move.b  (A2)+, D0
        bne.s   Title_Cards_MakeSprite  ; loc_00BBA6
        move.b  d2, d0
Title_Cards_MakeSprite: ; loc_00BBA6:
        move.b  d0, $001A(a1)
        move.l  #Title_Cards_Mappings, mappings(a1) ; loc_00C2A0
        move.w  #$8580, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #$78, $0019(a1)
        move.b  #0, render_flags(a1)
        move.b  #0, $0018(a1)
        move.w  #$03C, $001E(a1)
        lea     $0040(A1), A1
        dbra    d1, Title_Card_Loop     ; loc_00BB86
loc_00BBDC:
        moveq   #$10, d1
        move.w  Objoff_30(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_00BBF0
        bge.s   loc_00BBEC
        neg.w   d1
loc_00BBEC:
        add.w   d1, x_pos(a0)
loc_00BBF0:        
        move.w  x_pos(a0), D0
        bmi.s   loc_00BC02
        cmpi.w  #$200, d0
        bcc.s   loc_00BC02
        rts
        bra     DisplaySprite           ; loc_00D3C2
loc_00BC02:
        rts
loc_00BC04:
        tst.w   $001E(a0)
        beq.s   loc_00BC14
        subq.w  #1, $001E(a0)
        rts
        bra     DisplaySprite           ; loc_00D3C2
loc_00BC14:
        tst.b   render_flags(a0)
        bpl.s   loc_00BC42
        moveq   #$20, d1
        move.w  $0032(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_00BC42
        bge.s   loc_00BC2A
        neg.w   d1
loc_00BC2A:
        add.w   d1, x_pos(a0)
        move.w  x_pos(a0), D0
        bmi.s   loc_00BC40
        cmpi.w  #$200, d0
        bcc.s   loc_00BC40
        rts
        bra     DisplaySprite           ; loc_00D3C2
loc_00BC40:
        rts
loc_00BC42:
        cmpi.b  #4,routine(a0)
        bne.s   loc_00BC52
        moveq   #$2, d0
        jsr     LoadPLC         ; loc_00173C
loc_00BC52:        
        bra     DeleteObject            ; loc_00D3B4
Title_Cards_Main_Position: ; loc_00BC56:
        dc.w    $00D0, $0200 ; Level Name Position X / Y
        dc.w    $00E4, $0206 ; "Zone" word Position X / Y
        dc.w    $00EA, $0207 ; "Act x" word Position X / Y
        dc.w    $00E0, $020A ; Oval Position X / Y
Title_Cards_Config: ; loc_00BC66:        
        dc.w    $0000, $0120, $FEFC, $013C, $0414, $0154, $0214, $0154
        dc.w    $0000, $0120, $FEF4, $0134, $040C, $014C, $020C, $014C
        dc.w    $0000, $0120, $FEE0, $0120, $03F8, $0138, $01F8, $0138
        dc.w    $0000, $0120, $FEFC, $013C, $0414, $0154, $0214, $0154
        dc.w    $0000, $0120, $FF04, $0144, $041C, $015C, $021C, $015C
        dc.w    $0000, $0120, $FF04, $0144, $041C, $015C, $021C, $015C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
        dc.w    $0000, $0120, $FEE4, $0124, $03EC, $03EC, $01EC, $012C
;=============================================================================== 
; Object 0x34 - Title Cards / Splash Screen
;===============================================================================  
;=============================================================================== 
; Object 0x39 - Time Over / Game Over
;=============================================================================== 
Obj39_Time_Game_Over: ; loc_00BD76:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Time_Game_Over_Index(pc,d0), d1 ; loc_00BD84
        jmp     Time_Game_Over_Index(pc,d1)     ; loc_00BD84
Time_Game_Over_Index: ; loc_00BD84:
        dc.w    loc_00BD8A-Time_Game_Over_Index
        dc.w    loc_00BDCE-Time_Game_Over_Index
        dc.w    loc_00BDF0-Time_Game_Over_Index
loc_00BD8A:
        tst.l   ($FFFFF680).w
        beq.s   loc_00BD92
        rts
loc_00BD92:
        addq.b  #2,routine(a0)
        move.w  #$050, x_pos(a0)
        btst    #0, $001A(a0)
        beq.s   loc_00BDAA
        move.w  #$1F0, x_pos(a0)
loc_00BDAA:
        move.w  #$0F0, $000A(a0)
        move.l  #Time_Game_Over_Mappings,mappings(a0) ; loc_00C558
        move.w  #$855E,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #0,render_flags(a0)
        move.b  #0, $0018(a0)
loc_00BDCE:
        moveq   #$10, d1
        cmpi.w  #$120, x_pos(a0)
        beq.s   loc_00BDE4
        bcs.s   loc_00BDDC
        neg.w   d1
loc_00BDDC:
        add.w   d1, x_pos(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00BDE4:
        move.w  #$2D0, $001E(a0)
        addq.b  #2,routine(a0)
        rts
loc_00BDF0:
        move.b  (Ctrl_1_Press).w, d0
        andi.b  #$70, d0
        bne.s   loc_00BE10
        btst    #0, $001A(a0)
        bne.s   loc_00BE34
        tst.w   $001E(a0)
        beq.s   loc_00BE10
        subq.w  #1, $001E(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00BE10:
        tst.b   ($FFFFFE1A).w
        bne.s   loc_00BE2A
        move.b  #$14, (Game_Mode).w
        tst.b   ($FFFFFE18).w
        bne.s   loc_00BE34
        move.b  #0, (Game_Mode).w
        bra.s   loc_00BE34
loc_00BE2A:
        clr.l   (Saved_Timer).w
        move.w  #$001, ($FFFFFE02).w
loc_00BE34:
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x39 - Time Over / Game Over
;=============================================================================== 
;=============================================================================== 
; Object 0x3A - Level Results
;=============================================================================== 
Obj3A_Level_Results: ; loc_00BE38:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Level_Results_Index(pc,d0), d1  ; loc_00BE46
        jmp     Level_Results_Index(pc,d1)      ; loc_00BE46
Level_Results_Index: ; loc_00BE46:
        dc.w    loc_00BE4E-Level_Results_Index
        dc.w    loc_00BEAA-Level_Results_Index
        dc.w    loc_00BEF6-Level_Results_Index
        dc.w    loc_00BF66-Level_Results_Index
loc_00BE4E:
        tst.l   ($FFFFF680).w
        beq.s   loc_00BE56
        rts
loc_00BE56:
        move.l  A0, A1
        lea     (loc_00C030), A2
        moveq   #6, d1
loc_00BE60:        
        move.b  #$3A, 0(a1)
        move.w  (A2), x_pos(a1)
        move.w  (A2)+, $0032(a1)
        move.w  (A2)+, Objoff_30(a1)
        move.w  (A2)+, $000A(a1)
        move.b  (A2)+, $0024(a1)
        move.b  (A2)+, D0
        cmpi.b  #6, d0
        bne.s   loc_00BE86
        add.b   ($FFFFFE11).w, d0
loc_00BE86:
        move.b  d0, $001A(a1)
        move.l  #Level_Results_Mappings, mappings(a1) ; loc_00C5A8
        move.w  #$8580, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #0, render_flags(a1)
        lea     $0040(A1), A1
        dbra    d1, loc_00BE60
loc_00BEAA:
        moveq   #$10, d1
        move.w  Objoff_30(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_00BEDC
        bge.s   loc_00BEBA
        neg.w   d1
loc_00BEBA:
        add.w   d1, x_pos(a0)
loc_00BEBE:        
        move.w  x_pos(a0), D0
        bmi.s   loc_00BED0
        cmpi.w  #$200, d0
        bcc.s   loc_00BED0
        rts
        bra     DisplaySprite           ; loc_00D3C2
loc_00BED0:
        rts
loc_00BED2:        
        move.b  #$E, $0024(a0)
        bra     loc_00BFDE
loc_00BEDC:
        cmpi.b  #$E, ($FFFFB724).w
        beq.s   loc_00BED2
        cmpi.b  #4, $001A(a0)
        bne.s   loc_00BEBE
        addq.b  #2,routine(a0)
        move.w  #$0B4, $001E(a0)
loc_00BEF6:
        subq.w  #1, $001E(a0)
        bne.s   loc_00BF00
        addq.b  #2,routine(a0)
loc_00BF00:
        rts
        bra     DisplaySprite           ; loc_00D3C2
        bsr     DisplaySprite           ; loc_00D3C2
        move.b  #1, ($FFFFF7D6).w
        moveq	#0,d0
        tst.w   ($FFFFF7D2).w
        beq.s   loc_00BF22
        addi.w  #$00A, d0
        subi.w  #$00A, ($FFFFF7D2).w
loc_00BF22:
        tst.w   ($FFFFF7D4).w
        beq.s   loc_00BF32
        addi.w  #$00A, d0
        subi.w  #$00A, ($FFFFF7D4).w
loc_00BF32:
        tst.w   D0
        bne.s   loc_00BF4C
        move.w  #$0C5, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #2,routine(a0)
        move.w  #$0B4, $001E(a0)
loc_00BF4A:        
        rts
loc_00BF4C:
        jsr     AddPoints               ; (loc_022FD0)      
        move.b  ($FFFFFE0F).w, d0
        andi.b  #3, d0
        bne.s   loc_00BF4A
        move.w  #$0CD, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_00BF66:
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        add.b   ($FFFFFE11).w, d0
        add.w   d0, d0
        move.w  loc_00BF9A(pc,d0), D0
        move.w  d0, (Current_ZoneAndAct).w
        clr.b   (Last_star_pole_hit).w
        tst.b   ($FFFFF7CD).w
        beq.s   loc_00BF8E
        move.b  #$10, (Game_Mode).w
        bra.s   loc_00BF94
loc_00BF8E:
        move.w  #$001, ($FFFFFE02).w
loc_00BF94:
        rts
        bra     DisplaySprite           ; loc_00D3C2
loc_00BF9A:
        dc.w    $0001, $0200, $0000, $0000, $0201, $0400, $0000, $0000
        dc.w    $0401, $0700, $0000, $0000, $0000, $0000, $0701, $0000
        dc.w    $0801, $0A00, $0000, $0000, $0A01, $0B00, $0B01, $0C00
        dc.w    $0C01, $0D00, $0D01, $0700, $0E01, $0F00, $0F01, $0D00
        dc.w    $1001, $0000
loc_00BFDE:
        moveq   #$20, d1
        move.w  $0032(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_00C004
        bge.s   loc_00BFEE
        neg.w   d1
loc_00BFEE:
        add.w   d1, x_pos(a0)
        move.w  x_pos(a0), D0
        bmi.s   loc_00C002
        cmpi.w  #$200, d0
        bcc.s   loc_00C002
        bra     DisplaySprite           ; loc_00D3C2
loc_00C002:
        rts
loc_00C004:
        cmpi.b  #4, $001A(a0)
        bne     DeleteObject            ; loc_00D3B4
        addq.b  #2,routine(a0)
        clr.b   ($FFFFF7CC).w
        move.w  #$09A, d0
        jmp     (Play_Music)            ; loc_0014C0
        addq.w  #$2, ($FFFFEECA).w
        cmpi.w  #$2100, ($FFFFEECA).w
        beq     DeleteObject            ; loc_00D3B4
        rts
loc_00C030:
        dc.w    $0004, $0124, $00BC, $0200, $FEE0, $0120, $00D0, $0201
        dc.w    $040C, $014C, $00D6, $0206, $0520, $0120, $00EC, $0202
        dc.w    $0540, $0120, $00FC, $0203, $0560, $0120, $010C, $0204
        dc.w    $020C, $014C, $00CC, $0205        
;=============================================================================== 
; Object 0x3A - Level Results
;=============================================================================== 

;=============================================================================== 
; Object 0x?? - Special Stage Results Screen
;=============================================================================== 
Special_Stage_Results: ; loc_00C068:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  SS_Results_Index(pc,d0), d1  ; loc_00C076
        jmp     SS_Results_Index(pc,d1)      ; loc_00C076
SS_Results_Index: ; loc_00C076:
        dc.w    loc_00C08C-SS_Results_Index
        dc.w    loc_00C104-SS_Results_Index
        dc.w    loc_00C13C-SS_Results_Index
        dc.w    loc_00C14A-SS_Results_Index
        dc.w    loc_00C13C-SS_Results_Index
        dc.w    loc_00C1A4-SS_Results_Index
        dc.w    loc_00C13C-SS_Results_Index
        dc.w    loc_00C1AE-SS_Results_Index
        dc.w    loc_00C13C-SS_Results_Index
        dc.w    loc_00C1A4-SS_Results_Index
        dc.w    loc_00C1D2-SS_Results_Index
loc_00C08C:
        tst.l   ($FFFFF680).w
        beq.s   loc_00C094
        rts
loc_00C094:
        move.l  A0, A1
        lea     (loc_00C1E6), A2
        moveq   #3, d1
        cmpi.w  #$032, (Ring_count).w
        bcs.s   loc_00C0A8
        addq.w  #1,d1
loc_00C0A8:
        move.b  0(A0), 0(a1)
        move.w  (A2)+, x_pos(a1)
        move.w  (A2)+, Objoff_30(a1)
        move.w  (A2)+, $000A(a1)
        move.b  (A2)+, $0024(a1)
        move.b  (A2)+, $001A(a1)
        move.l  #Special_Stage_Results_Mappings, mappings(a1) ; loc_00C6D4
        move.w  #$8580, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #0, render_flags(a1)
        lea     $0040(A1), A1
        dbra    d1, loc_00C0A8
        moveq   #$7, d0
        move.b  ($FFFFFE57).w, d1
        beq.s   loc_00C100
        moveq	#0,d0
        cmpi.b  #6, d1
        bne.s   loc_00C100
        moveq   #8,d0
        move.w  #$018, x_pos(a0)
        move.w  #$118, Objoff_30(a0)
loc_00C100:
        move.b  d0, $001A(a0)
loc_00C104:
        moveq   #$10, d1
        move.w  Objoff_30(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_00C12A
        bge.s   loc_00C114
        neg.w   d1
loc_00C114:
        add.w   d1, x_pos(a0)
loc_00C118:        
        move.w  x_pos(a0), D0
        bmi.s   loc_00C128
        cmpi.w  #$200, d0
        bcc.s   loc_00C128
        bra     DisplaySprite           ; loc_00D3C2
loc_00C128:
        rts
loc_00C12A:
        cmpi.b  #$2, $001A(a0)
        bne.s   loc_00C118
        addq.b  #2,routine(a0)
        move.w  #$0B4, $001E(a0)
loc_00C13C:
        subq.w  #1, $001E(a0)
        bne.s   loc_00C146
        addq.b  #2,routine(a0)
loc_00C146:
        bra     DisplaySprite           ; loc_00D3C2
loc_00C14A:
        bsr     DisplaySprite           ; loc_00D3C2
        move.b  #1, ($FFFFF7D6).w
        tst.w   ($FFFFF7D4).w
        beq.s   loc_00C17C
        subi.w  #$00A, ($FFFFF7D4).w
        moveq   #$A, d0
        jsr     AddPoints               ; (loc_022FD0)
        move.b  ($FFFFFE0F).w, d0
        andi.b  #3, d0
        bne.s   loc_00C1A2
        move.w  #$0CD, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_00C17C:
        move.w  #$0C5, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #2,routine(a0)
        move.w  #$0B4, $001E(a0)
        cmpi.w  #$032, (Ring_count).w
        bcs.s   loc_00C1A2
        move.w  #$03C, $001E(a0)
        addq.b  #4,routine(a0)
loc_00C1A2:
        rts
loc_00C1A4:
        move.w  #$001, ($FFFFFE02).w
        bra     DisplaySprite           ; loc_00D3C2
loc_00C1AE:
        move.b  #4, ($FFFFB6DA).w
        move.b  #$14, ($FFFFB6E4).w
        move.w  #$0BF, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #2,routine(a0)
        move.w  #$168, $001E(a0)
        bra     DisplaySprite           ; loc_00D3C2
loc_00C1D2:
        move.b  ($FFFFFE0F).w, d0
        andi.b  #$F, d0
        bne.s   loc_00C1E2
        bchg    #0, $001A(a0)
loc_00C1E2:
        bra     DisplaySprite           ; loc_00D3C2
loc_00C1E6:
        dc.w    $0020, $0120, $00C4, $0200, $0320, $0120, $0118, $0201
        dc.w    $0360, $0120, $0128, $0202, $01EC, $011C, $00C4, $0203
        dc.w    $03A0, $0120, $0138, $0206        
;=============================================================================== 
; Object 0x?? - Special Stage Results Screen
;===============================================================================     
    
;=============================================================================== 
; Object 0x?? - Emeralds From Special Stage Results Screen
;===============================================================================    
Emeralds: ; loc_00C20E:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00C21C(pc,d0), d1
        jmp     loc_00C21C(pc,d1)
loc_00C21C:
        dc.w    loc_00C22C-loc_00C21C
        dc.w    loc_00C286-loc_00C21C
loc_00C220:
        dc.w    $0110, $0128, $00F8, $0140, $00E0, $0158
loc_00C22C:
        move.l  A0, A1
        lea     loc_00C220(PC), A2
        moveq   #0, D2
        moveq   #0,d1
        move.b  ($FFFFFE57).w, d1
        subq.b  #1,d1
        bcs     DeleteObject            ; loc_00D3B4
loc_00C240:        
        move.b  0(A0), 0(a1)
        move.w  (A2)+, x_pos(a1)
        move.w  #$0F0, $000A(a1)
        lea     ($FFFFFE58).w, A3
        move.b  $00(A3, D2), D3
        move.b  d3, $001A(a1)
        move.b  d3, $001C(a1)
        addq.b  #1, D2
        addq.b  #$2, $0024(a1)
        move.l  #Emeralds_Mappings, mappings(a1) ; loc_00C8F6
        move.w  #$8541, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #0, render_flags(a1)
        lea     $0040(A1), A1
        dbra    d1, loc_00C240
loc_00C286:
        move.b  $001A(A0), D0
        move.b  #6, $001A(a0)
        cmpi.b  #6, d0
        bne.s   loc_00C29C
        move.b  $001C(A0), $001A(a0)
loc_00C29C:
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x?? - Emeralds From Special Stage Results Screen
;===============================================================================    
Title_Cards_Mappings: ; loc_00C2A0: ; Object $34 - Mappings
        dc.w    TC_GHz_Map-Title_Cards_Mappings  ; Green Hill
        dc.w    TC_Lz_Map-Title_Cards_Mappings   ; Labyrinth
        dc.w    TC_Mz_Map-Title_Cards_Mappings   ; Marble  
        dc.w    TC_SLz_Map-Title_Cards_Mappings  ; Star Light
        dc.w    TC_SYz_Map-Title_Cards_Mappings  ; Spring Yard
        dc.w    TC_SBz_Map-Title_Cards_Mappings  ; Scrap Brain
        dc.w    TC_Zone_Map-Title_Cards_Mappings ; Zone
        dc.w    TC_Act1_Map-Title_Cards_Mappings ; Act 1
        dc.w    TC_Act2_Map-Title_Cards_Mappings ; Act 2
        dc.w    TC_Act3_Map-Title_Cards_Mappings ; Act 3
        dc.w    TC_Oval_Map-Title_Cards_Mappings ; Oval
        dc.w    TC_Fz_Map-Title_Cards_Mappings   ; Final  
TC_GHz_Map: ; loc_00C2B8: ; Green Hill         
        dc.w    $0009 
        dc.l    $F8050018, $000CFFB4, $F805003A, $001DFFC4
        dc.l    $F8050010, $0008FFD4, $F8050010, $0008FFE4
        dc.l    $F805002E, $0017FFF4, $F805001C, $000E0014
        dc.l    $F8010020, $00100024, $F8050026, $0013002C
        dc.l    $F8050026, $0013003C
TC_Lz_Map: ; loc_00C302: ; Labyrinth
        dc.w    $0009
        dc.l    $F8050026, $0013FFBC, $F8050000, $0000FFCC
        dc.l    $F8050004, $0002FFDC, $F805004A, $0025FFEC
        dc.l    $F805003A, $001DFFFC, $F8010020, $0010000C
        dc.l    $F805002E, $00170014, $F8050042, $00210024
        dc.l    $F805001C, $000E0034
TC_Mz_Map: ; loc_00C34C: ; Marble 
        dc.w    $0006
        dc.l    $F805002A, $0015FFCF, $F8050000, $0000FFE0
        dc.l    $F805003A, $001DFFF0, $F8050004, $00020000
        dc.l    $F8050026, $00130010, $F8050010, $00080020 
TC_SLz_Map: ; loc_00C37E: ; Star Light
        dc.w    $0009
        dc.l    $F805003E, $001FFFB4, $F8050042, $0021FFC4
        dc.l    $F8050000, $0000FFD4, $F805003A, $001DFFE4
        dc.l    $F8050026, $00130004, $F8010020, $00100014
        dc.l    $F8050018, $000C001C, $F805001C, $000E002C
        dc.l    $F8050042, $0021003C
TC_SYz_Map: ; loc_00C3C8: ; Spring Yard
        dc.w    $000A
        dc.w    $F805, $003E, $001F, $FFAC, $F805, $0036, $001B, $FFBC
        dc.w    $F805, $003A, $001D, $FFCC, $F801, $0020, $0010, $FFDC
        dc.w    $F805, $002E, $0017, $FFE4, $F805, $0018, $000C, $FFF4
        dc.w    $F805, $004A, $0025, $14, $F805, $0000, $0000, $0024
        dc.w    $F805, $003A, $001D, $0034, $F805, $000C, $0006, $0044 
TC_SBz_Map: ; loc_00C41A: ; Scrap Brain
        dc.w    $000A
        dc.l    $F805003E, $001FFFAC, $F8050008, $0004FFBC
        dc.l    $F805003A, $001DFFCC, $F8050000, $0000FFDC
        dc.l    $F8050036, $001BFFEC, $F8050004, $0002000C
        dc.l    $F805003A, $001D001C, $F8050000, $0000002C
        dc.l    $F8010020, $0010003C, $F805002E, $00170044
TC_Zone_Map: ; loc_00C46C: ; Zone
        dc.w    $0004
        dc.l    $F805004E, $0027FFE0, $F8050032, $0019FFF0
        dc.l    $F805002E, $00170000, $F8050010, $00080010
TC_Act1_Map: ; loc_00C48E: ; Act 1
        dc.w    $0002
        dc.l    $040C0053, $0029FFEC, $F4020057, $002B000C
TC_Act2_Map: ; loc_00C4A0: ; Act 2
        dc.w    $0002
        dc.l    $040C0053, $0029FFEC, $F406005A, $002D0008
TC_Act3_Map: ; loc_00C4B2: ; Act 3
        dc.w    $0002
        dc.l    $040C0053, $0029FFEC, $F4060060, $00300008
TC_Oval_Map: ; loc_00C4C4: ; Oval
        dc.w    $000D
        dc.l    $E40C0070, $0038FFF4, $E4020074, $003A0014
        dc.l    $EC040077, $003BFFEC, $F4050079, $003CFFE4
        dc.l    $140C1870, $1838FFEC, $04021874, $183AFFE4
        dc.l    $0C041877, $183B0004, $FC051879, $183C000C
        dc.l    $EC08007D, $003EFFFC, $F40C007C, $003EFFF4
        dc.l    $FC08007C, $003EFFF4, $040C007C, $003EFFEC
        dc.l    $0C08007C, $003EFFEC
TC_Fz_Map: ; loc_00C52E: ; Final
        dc.w    $0005
        dc.l    $F8050014, $000AFFDC, $F8010020, $0010FFEC
        dc.l    $F805002E, $0017FFF4, $F8050000, $00000004
        dc.l    $F8050026, $00130014
Time_Game_Over_Mappings: ; loc_00C558:
        dc.w    loc_00C560-Time_Game_Over_Mappings
        dc.w    loc_00C572-Time_Game_Over_Mappings
        dc.w    loc_00C584-Time_Game_Over_Mappings
        dc.w    loc_00C596-Time_Game_Over_Mappings
loc_00C560:
        dc.w    $0002
        dc.l    $F80D0000, $0000FFB8, $F80D0008, $0004FFD8
loc_00C572:
        dc.w    $0002
        dc.l    $F80D0014, $000A0008, $F80D000C, $00060028
loc_00C584:
        dc.w    $0002
        dc.l    $F809001C, $000EFFC4, $F80D0008, $0004FFDC
loc_00C596:
        dc.w    $0002
        dc.l    $F80D0014, $000A000C, $F80D000C, $0006002C  
Level_Results_Mappings: ; loc_00C5A8:
        dc.w    LR_Sonic_Has_Map-Level_Results_Mappings
        dc.w    LR_Passed_Map-Level_Results_Mappings
        dc.w    LR_Score_Map-Level_Results_Mappings
        dc.w    LR_Time_Bonus_Map-Level_Results_Mappings
        dc.w    LR_Ring_Bonus_Map-Level_Results_Mappings
        dc.w    TC_Oval_Map-Level_Results_Mappings
        dc.w    TC_Act1_Map-Level_Results_Mappings
        dc.w    TC_Act2_Map-Level_Results_Mappings
        dc.w    TC_Act3_Map-Level_Results_Mappings
LR_Sonic_Has_Map: ; loc_00C5BA: ; Sonic Has
        dc.w    $0008
        dc.l    $F805003E, $001FFFB8, $F8050032, $0019FFC8
        dc.l    $F805002E, $0017FFD8, $F8010020, $0010FFE8
        dc.l    $F8050008, $0004FFF0, $F805001C, $000E0010
        dc.l    $F8050000, $00000020, $F805003E, $001F0030
LR_Passed_Map: ; loc_00C5FC: ; Passed
        dc.w    $0006
        dc.l    $F8050036, $001BFFD0, $F8050000, $0000FFE0
        dc.l    $F805003E, $001FFFF0, $F805003E, $001F0000
        dc.l    $F8050010, $00080010, $F805000C, $00060020
LR_Score_Map: ; loc_00C62E:
        dc.w    $0006
        dc.l    $F80D014A, $00A5FFB0, $F8010162, $00B1FFD0
        dc.l    $F8090164, $00B20018, $F80D016A, $00B50030
        dc.l    $F704006E, $0037FFCD, $FF04186E, $1837FFCD
LR_Time_Bonus_Map: ; loc_00C660:
        dc.w    $0007
        dc.l    $F80D015A, $00ADFFB0, $F80D0066, $0033FFD9
        dc.l    $F801014A, $00A5FFF9, $F704006E, $0037FFF6
        dc.l    $FF04186E, $1837FFF6, $F80DFFF0, $FBF80028
        dc.l    $F8010170, $00B80048
LR_Ring_Bonus_Map: ; loc_00C69A:
        dc.w    $0007
        dc.l    $F80D0152, $00A9FFB0, $F80D0066, $0033FFD9
        dc.l    $F801014A, $00A5FFF9, $F704006E, $0037FFF6
        dc.l    $FF04186E, $1837FFF6, $F80DFFF8, $FBFC0028
        dc.l    $F8010170, $00B80048    
Special_Stage_Results_Mappings: ; loc_00C6D4:
        dc.w    loc_00C6E6-Special_Stage_Results_Mappings
        dc.w    loc_00C750-Special_Stage_Results_Mappings
        dc.w    loc_00C782-Special_Stage_Results_Mappings
        dc.w    TC_Oval_Map-Special_Stage_Results_Mappings
        dc.w    loc_00C7BC-Special_Stage_Results_Mappings
        dc.w    loc_00C7DE-Special_Stage_Results_Mappings
        dc.w    loc_00C800-Special_Stage_Results_Mappings
        dc.w    loc_00C81A-Special_Stage_Results_Mappings
        dc.w    loc_00C87C-Special_Stage_Results_Mappings
loc_00C6E6:
        dc.w    $000D
        dc.l    $F8050008, $0004FF90, $F805001C, $000EFFA0
        dc.l    $F8050000, $0000FFB0, $F8050032, $0019FFC0
        dc.l    $F805003E, $001FFFD0, $F8050010, $0008FFF0
        dc.l    $F805002A, $00150000, $F8050010, $00080010
        dc.l    $F805003A, $001D0020, $F8050000, $00000030
        dc.l    $F8050026, $00130040, $F805000C, $00060050
        dc.l    $F805003E, $001F0060
loc_00C750:
        dc.w    $0006
        dc.l    $F80D014A, $00A5FFB0, $F8010162, $00B1FFD0
        dc.l    $F8090164, $00B20018, $F80D016A, $00B50030
        dc.l    $F704006E, $0037FFCD, $FF04186E, $1837FFCD
loc_00C782:
        dc.w    $0007
        dc.l    $F80D0152, $00A9FFB0, $F80D0066, $0033FFD9
        dc.l    $F801014A, $00A5FFF9, $F704006E, $0037FFF6
        dc.l    $FF04186E, $1837FFF6, $F80DFFF8, $FBFC0028
        dc.l    $F8010170, $00B80048
loc_00C7BC:
        dc.w    $0004
        dc.l    $F80DFFD1, $7FC8FFB0, $F80DFFD9, $7FD4FFD0
        dc.l    $F801FFE1, $7FE0FFF0, $F8061FE3, $2FE30040
loc_00C7DE:
        dc.w    $0004
        dc.l    $F80DFFD1, $7FC8FFB0, $F80DFFD9, $7FD4FFD0
        dc.l    $F801FFE1, $7FE0FFF0, $F8061FE9, $2FEC0040
loc_00C800:
        dc.w    $0003
        dc.l    $F80DFFD1, $7FC8FFB0, $F80DFFD9, $7FD4FFD0
        dc.l    $F801FFE1, $7FE0FFF0
loc_00C81A:
        dc.w    $000C
        dc.l    $F805003E, $001FFF9C, $F8050036, $001BFFAC
        dc.l    $F8050010, $0008FFBC, $F8050008, $0004FFCC
        dc.l    $F8010020, $0010FFDC, $F8050000, $0000FFE4
        dc.l    $F8050026, $0013FFF4, $F805003E, $001F0014
        dc.l    $F8050042, $00210024, $F8050000, $00000034
        dc.l    $F8050018, $000C0044, $F8050010, $00080054
loc_00C87C:
        dc.w    $000F
        dc.l    $F805003E, $001FFF88, $F8050032, $0019FF98
        dc.l    $F805002E, $0017FFA8, $F8010020, $0010FFB8
        dc.l    $F8050008, $0004FFC0, $F8050018, $000CFFD8
        dc.l    $F8050032, $0019FFE8, $F8050042, $0021FFF8
        dc.l    $F8050042, $00210010, $F805001C, $000E0020
        dc.l    $F8050010, $00080030, $F805002A, $00150040
        dc.l    $F8050000, $00000058, $F8050026, $00130068
        dc.l    $F8050026, $00130078        
Emeralds_Mappings: ; loc_00C8F6:
        dc.w    loc_00C904-Emeralds_Mappings
        dc.w    loc_00C90E-Emeralds_Mappings
        dc.w    loc_00C918-Emeralds_Mappings
        dc.w    loc_00C922-Emeralds_Mappings
        dc.w    loc_00C92C-Emeralds_Mappings
        dc.w    loc_00C936-Emeralds_Mappings
        dc.w    loc_00C940-Emeralds_Mappings
loc_00C904:
        dc.w    $0001
        dc.l    $F8052004, $2002FFF8
loc_00C90E:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_00C918:
        dc.w    $0001
        dc.l    $F8054004, $4002FFF8
loc_00C922:
        dc.w    $0001
        dc.l    $F8056004, $6002FFF8
loc_00C92C:
        dc.w    $0001
        dc.l    $F8052008, $2004FFF8
loc_00C936:
        dc.w    $0001
        dc.l    $F805200C, $2006FFF8
loc_00C940:
        dc.w    $0000           ; Filler                    
        nop           
;=============================================================================== 
; Object 0x36 - Vertical Spikes                
;===============================================================================         
Obj36_Spikes: ; loc_00C944:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00C952(pc,d0), d1
        jmp     loc_00C952(pc,d1)
loc_00C952:
        dc.w    loc_00C96A-loc_00C952
        dc.w    loc_00C9D6-loc_00C952
        dc.w    loc_00CA26-loc_00C952
        dc.w    loc_00CA82-loc_00C952        
loc_00C95A:
        dc.b    $10, $10, $20, $10, $30, $10, $40, $10, $10, $10, $10, $20, $10, $30, $10, $40          
loc_00C96A:
        addq.b  #2,routine(a0)
        move.l  #Spike_Mappings,mappings(a0) ; loc_00CBA0
        move.w  #$2434,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), D0
        andi.b  #$F, subtype(a0)
        andi.w  #$0F0, d0  
        lea     loc_00C95A(PC), A1
        lsr.w   #3, d0
        adda.w  d0, A1
        move.b  (A1)+,width_pixels(a0)
        move.b  (A1)+, y_radius(a0)
        lsr.w   #1,d0
        move.b  d0, $001A(a0)
        cmpi.b  #4, d0
        bcs.s   loc_00C9BA
        addq.b  #2,routine(a0)
loc_00C9BA:
        btst    #1, status(a0)
        beq.s   loc_00C9C8
        move.b  #6, $0024(a0)
loc_00C9C8:
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), $0032(a0)
        rts
loc_00C9D6:
        bsr     loc_00CAFE
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        move.b  status(a0), D6
        andi.b  #$18, D6
        beq.s   loc_00CA1E
        move.b  d6, d0
        andi.b  #8,d0
        beq.s   loc_00CA10
        lea     (MainCharacter).w, A1
        bsr     Touch_Spikes            ; loc_00CAD0
loc_00CA10:
        andi.b  #$10, D6
        beq.s   loc_00CA1E
        lea     (Sidekick).w, A1
        bsr     Touch_Spikes            ; loc_00CAD0
loc_00CA1E:
        move.w  Objoff_30(A0), D0
        bra     loc_00D2D8
loc_00CA26:        
        move.w  x_pos(a0), -(A7)
        bsr     loc_00CAFE
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  (A7)+, D4
        bsr     SolidObject             ; loc_00F4A0
        swap.w  D6
        andi.w  #$003, D6
        beq.s   loc_00CA7A
        move.b  d6, d0
        andi.b  #1,d0
        beq.s   loc_00CA66
        lea     (MainCharacter).w, A1
        bsr     Touch_Spikes            ; loc_00CAD0
        bclr    #5, status(a0)
loc_00CA66:        
        andi.b  #$2, D6
        beq.s   loc_00CA7A
        lea     (Sidekick).w, A1  
        bsr     Touch_Spikes            ; loc_00CAD0
        bclr    #6, status(a0)
loc_00CA7A:
        move.w  Objoff_30(A0), D0
        bra     loc_00D2D8
loc_00CA82:
        bsr     loc_00CAFE
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        swap.w  D6
        andi.w  #$00C, D6
        beq.s   loc_00CAC8
        move.b  d6, d0
        andi.b  #4, d0
        beq.s   loc_00CABA
        lea     (MainCharacter).w, A1
        bsr     Touch_Spikes            ; loc_00CAD0
loc_00CABA:
        andi.b  #8, D6
        beq.s   loc_00CAC8
        lea     (Sidekick).w, A1
        bsr     Touch_Spikes            ; loc_00CAD0
loc_00CAC8:
        move.w  Objoff_30(A0), D0
        bra     loc_00D2D8
;===============================================================================
; Beginning of Sub Touch_Spikes
;===============================================================================        
Touch_Spikes: ; loc_00CAD0:
        tst.b   ($FFFFFE2D).w           ; Invincibility Running ?
        bne.s   Touch_Spikes_No_Hurt    ; loc_00CAFC
        cmpi.b  #4, $0024(a1)
        bcc.s   Touch_Spikes_No_Hurt    ; loc_00CAFC
        move.l  y_pos(A1), D3
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        sub.l   d0, d3
        move.l  d3, y_pos(a1)
        move.l  A0, a2
        move.l  A1, A0
        jsr     HurtSonic               ; loc_021384
        move.l  A2, A0
Touch_Spikes_No_Hurt: ; loc_00CAFC:        
        rts
;===============================================================================
; End of Sub Touch_Spikes
;===============================================================================            
loc_00CAFE:
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.w  loc_00CB0E(pc,d0), d1
        jmp     loc_00CB0E(pc,d1)
loc_00CB0E:
        dc.w    loc_00CB14-loc_00CB0E
        dc.w    loc_00CB16-loc_00CB0E
        dc.w    loc_00CB2A-loc_00CB0E
loc_00CB14:          
        rts
loc_00CB16:
        bsr     loc_00CB3E
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        add.w   $0032(A0), D0
        move.w  d0, y_pos(a0)
        rts
loc_00CB2A:
        bsr     loc_00CB3E
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        rts
loc_00CB3E:
        tst.w   objoff_38(a0)
        beq.s   loc_00CB5C
        subq.w  #1, objoff_38(a0)
        bne.s   loc_00CB9E
        tst.b   render_flags(a0)
        bpl.s   loc_00CB9E
        move.w  #$0B6, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        bra.s   loc_00CB9E
loc_00CB5C:
        tst.w   objoff_36(a0)
        beq.s   loc_00CB7E
        subi.w  #$800, Objoff_34(a0)
        bcc.s   loc_00CB9E
        move.w  #0, Objoff_34(a0)
        move.w  #0, objoff_36(a0)
        move.w  #$03C, objoff_38(a0)
        bra.s   loc_00CB9E
loc_00CB7E:
        addi.w  #$800, Objoff_34(a0)
        cmpi.w  #$2000, Objoff_34(a0)
        bcs.s   loc_00CB9E
        move.w  #$2000, Objoff_34(a0)
        move.w  #$001, objoff_36(a0)
        move.w  #$03C, objoff_38(a0)
loc_00CB9E:
        rts
Spike_Mappings:        
loc_00CBA0:
        dc.w    loc_00CBB0-loc_00CBA0
        dc.w    loc_00CBC2-loc_00CBA0
        dc.w    loc_00CBE4-loc_00CBA0
        dc.w    loc_00CC16-loc_00CBA0
        dc.w    loc_00CC58-loc_00CBA0
        dc.w    loc_00CC6A-loc_00CBA0
        dc.w    loc_00CC8C-loc_00CBA0
        dc.w    loc_00CCBE-loc_00CBA0
loc_00CBB0:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F0070000, $00000000
loc_00CBC2:
        dc.w    $0004
        dc.l    $F0070000, $0000FFE0, $F0070000, $0000FFF0
        dc.l    $F0070000, $00000000, $F0070000, $00000010
loc_00CBE4:
        dc.w    $0006
        dc.l    $F0070000, $0000FFD0, $F0070000, $0000FFE0
        dc.l    $F0070000, $0000FFF0, $F0070000, $00000000
        dc.l    $F0070000, $00000010, $F0070000, $00000020
loc_00CC16:
        dc.w    $0008
        dc.l    $F0070000, $0000FFC0, $F0070000, $0000FFD0
        dc.l    $F0070000, $0000FFE0, $F0070000, $0000FFF0
        dc.l    $F0070000, $00000000, $F0070000, $00000010
        dc.l    $F0070000, $00000020, $F0070000, $00000030
loc_00CC58:
        dc.w    $0002
        dc.l    $F00DFFF8, $FBFCFFF0, $000DFFF8, $FBFCFFF0
loc_00CC6A:
        dc.w    $0004
        dc.l    $E00DFFF8, $FBFCFFF0, $F00DFFF8, $FBFCFFF0
        dc.l    $000DFFF8, $FBFCFFF0, $100DFFF8, $FBFCFFF0
loc_00CC8C:
        dc.w    $0006
        dc.l    $D00DFFF8, $FBFCFFF0, $E00DFFF8, $FBFCFFF0
        dc.l    $F00DFFF8, $FBFCFFF0, $000DFFF8, $FBFCFFF0
        dc.l    $100DFFF8, $FBFCFFF0, $200DFFF8, $FBFCFFF0
loc_00CCBE:
        dc.w    $0008
        dc.l    $C00DFFF8, $FBFCFFF0, $D00DFFF8, $FBFCFFF0
        dc.l    $E00DFFF8, $FBFCFFF0, $F00DFFF8, $FBFCFFF0
        dc.l    $000DFFF8, $FBFCFFF0, $100DFFF8, $FBFCFFF0
        dc.l    $200DFFF8, $FBFCFFF0, $300DFFF8, $FBFCFFF0         
;=============================================================================== 
; Object 0x36 - Vertical Spikes              
;===============================================================================   

;=============================================================================== 
; Object 0x3B                 
;===============================================================================   
Obj3B: ; loc_00CD00:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00CD0E(pc,d0), d1
        jmp     loc_00CD0E(pc,d1)
loc_00CD0E:
        dc.w    loc_00CD12-loc_00CD0E
        dc.w    loc_00CD3A-loc_00CD0E
loc_00CD12:
        addq.b  #2,routine(a0)
        move.l  #loc_00CD66,mappings(a0)
        move.w  #$66C0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$13,width_pixels(a0)
        move.b  #4, $0018(a0)
loc_00CD3A:
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00CD66:
        dc.w    loc_00CD68-loc_00CD66
loc_00CD68:
        dc.w    $0002
        dc.l    $F00B0000, $0000FFE8, $F00B000C, $00060000
;=============================================================================== 
; Object 0x3B                
;===============================================================================
        dc.w    $0000           ; Filler 
;=============================================================================== 
; Object 0x3C                  
;=============================================================================== 
Obj3C: ; loc_00CD7C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00CD8E(pc,d0), d1
        jsr     loc_00CD8E(pc,d1)
        bra     MarkObjGone             ; loc_00D2A0
loc_00CD8E:
        dc.w    loc_00CD94-loc_00CD8E
        dc.w    loc_00CDC2-loc_00CD8E
        dc.w    loc_00CE3A-loc_00CD8E
loc_00CD94:
        addq.b  #2,routine(a0)
        move.l  #loc_00CF04,mappings(a0)
        move.w  #$4590,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), $001A(a0)
loc_00CDC2:
        move.w  ($FFFFB010).w, Objoff_30(a0)
        move.w  #$01B, d1
        move.w  #$20, D2
        move.w  #$20, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        btst    #5, status(a0)
        bne.s   loc_00CDE6
loc_00CDE4:        
        rts
loc_00CDE6:
        lea     (MainCharacter).w, A1
        cmpi.b  #$2, $001C(a1)
        bne.s   loc_00CDE4
        move.w  Objoff_30(A0), D0
        bpl.s   loc_00CDFA
        neg.w   D0
loc_00CDFA:
        cmpi.w  #$480, d0
        bcs.s   loc_00CDE4
        move.w  Objoff_30(A0),x_vel(a1)
        addq.w  #4, x_pos(a1)
        lea     (loc_00CEC4), A4
        move.w  x_pos(a0), D0
        cmp.w   x_pos(A1), D0
        bcs.s   loc_00CE26
        subi.w  #8, x_pos(a1)
        lea     (loc_00CEE4), A4
loc_00CE26:
        move.w x_vel(A1), $14(a1)
        bclr    #5, status(a0)
        bclr    #5, status(a1)
        bsr.s   loc_00CE50
loc_00CE3A:
        bsr     SpeedToPos              ; loc_00D27A
        addi.w  #$070, $0012(a0)
        tst.b   render_flags(a0)
        bpl     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Object 0x3C                
;=============================================================================== 

loc_00CE50:
        moveq	#0,d0
        move.b  $001A(A0), D0
        add.w   d0, d0
        move.l  mappings(A0), A3
        adda.w  $00(A3, d0), A3
        move.w  (A3)+, d1
        subq.w  #1,d1
        bset    #5,render_flags(a0)
        move.b  0(A0), D4
        move.b  render_flags(A0), D5
        move.l  A0, A1
        bra.s   loc_00CE7E
loc_00CE76:        
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_00CEBA
        addq.w  #8, A3
loc_00CE7E:
        move.b  #4, $0024(a1)
        move.b  d4, 0(a1)
        move.l  A3, mappings(a1)
        move.b  d5, render_flags(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  $0018(A0), $0018(a1)
        move.b width_pixels(a0), $0019(a1)
        move.w  (A4)+,x_vel(a1)
        move.w  (A4)+, $0012(a1)
        dbra    d1, loc_00CE76
loc_00CEBA:
        move.w  #$0CB, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_00CEC4:
        dc.w    $0400, $FB00, $0600, $FF00, $0600, $0100, $0400, $0500
        dc.w    $0600, $FA00, $0800, $FE00, $0800, $0200, $0600, $0600        
loc_00CEE4:
        dc.w    $FA00, $FA00, $F800, $FE00, $F800, $0200, $FA00, $0600
        dc.w    $FC00, $FB00, $FA00, $FF00, $FA00, $0100, $FC00, $0500               
loc_00CF04:
        dc.w    loc_00CF0A-loc_00CF04
        dc.w    loc_00CF4C-loc_00CF04
        dc.w    loc_00CF8E-loc_00CF04
loc_00CF0A:
        dc.w    $0008
        dc.l    $E0050000, $0000FFF0, $F0050000, $0000FFF0
        dc.l    $00050000, $0000FFF0, $10050000, $0000FFF0
        dc.l    $E0050004, $00020000, $F0050004, $00020000
        dc.l    $00050004, $00020000, $10050004, $00020000
loc_00CF4C:
        dc.w    $0008
        dc.l    $E0050004, $0002FFF0, $F0050004, $0002FFF0
        dc.l    $00050004, $0002FFF0, $10050004, $0002FFF0
        dc.l    $E0050004, $00020000, $F0050004, $00020000
        dc.l    $00050004, $00020000, $10050004, $00020000
loc_00CF8E:
        dc.w    $0008
        dc.l    $E0050004, $0002FFF0, $F0050004, $0002FFF0
        dc.l    $00050004, $0002FFF0, $10050004, $0002FFF0
        dc.l    $E0050008, $00040000, $F0050008, $00040000
        dc.l    $00050008, $00040000, $10050008, $00040000

;=================================================================
; Load Object Array Subordinates
;=================================================================

Load_Objects: ; loc_00CFD0: ; Load Objects List Routine
        lea     (MainCharacter).w, A0
        moveq   #$7F, D7
        moveq	#0,d0
        cmpi.b  #6, ($FFFFB024).w
        bcc.s   Load_Objects3
Load_Objects2:        
        move.b  (A0), D0
        beq.s   Load_Objects2a
        add.w   d0, d0
        add.w   d0, d0
        move.l  ObjectListArray-$04(pc,d0), A1 ; Load Object List Array
        jsr     (a1)
        moveq	#0,d0
Load_Objects2a:
        lea     $0040(A0), A0
        dbra    d7, Load_Objects2
        rts
Load_Objects3:
        moveq   #$1F, D7
        bsr.s   Load_Objects2
        moveq   #$5F, D7
Load_Objects4:        
        moveq	#0,d0
        move.b  (A0), D0
        beq.s   PreLoad_Objects
        tst.b   render_flags(a0)
        bpl.s   PreLoad_Objects
        bsr     DisplaySprite           ; loc_00D3C2
PreLoad_Objects:
        lea     $0040(A0), A0
        dbra    d7, Load_Objects4
        rts
ObjectListArray: ; Object List Array
        dc.l    Obj01_Sonic            ; loc_00FC48 
        dc.l    Obj02_Tails            ; loc_010E38
        dc.l    Obj03_Layer_Switch             ; loc_0144B0
        dc.l    Obj04                  ; loc_015090 
        dc.l    Obj05_Tails_Tail               ; loc_011F96 
        dc.l    Obj06_Spiral_Attributes        ; loc_01572C 
        dc.l    Obj07                  ; loc_0180D0 
        dc.l    Obj08_Water_Splash             ; loc_012B42 
        dc.l    Obj09_Sonic_In_Special_Stage   ; loc_021D40
        dc.l    Obj0A_Bubbles_And_Numbers      ; loc_01207C 
        dc.l    Obj0B_Open_Close_Platform      ; loc_0148AC 
        dc.l    Obj0C                  ; loc_0149FC
        dc.l    Obj0D_End_Panel        ; loc_00F1F4 
        dc.l    Obj0E_Sonic_Tails              ; loc_00B7B4 
        dc.l    Obj0F                  ; loc_00B83A 
        dc.l    Obj10                  ; loc_0223E2
        dc.l    Obj11_Bridge           ; loc_007FDC done
        dc.l    Obj12_Emerald          ; loc_014AFC 
        dc.l    Obj13_Hpz_Waterfalls           ; loc_014B78  
        dc.l    Obj14_See_saw          ; loc_015B8C 
        dc.l    Obj15_Swing_Platform           ; loc_0085F8
        dc.l    Obj16_Teleferics               ; loc_01600C 
        dc.l    Obj17                  ; loc_008B9C
        dc.l    Obj18_Platforms        ; loc_008D38 
        dc.l    Obj19_Elevator         ; loc_01621C         
        dc.l    Obj1A_Collapsing_Platforms     ; loc_009128 
        dc.l    Obj1B_Speed_Booster            ; loc_016468
        dc.l    Obj1C_Misc             ; loc_00999C 
        dc.l    Obj1D_Worms            ; loc_0165B0   
        dc.l    Obj1E_Tube_Attributes          ; loc_016724 
        dc.l    Obj1F_Collapsing_Platforms     ; loc_009274 
        dc.l    Obj20_Fireball         ; loc_017174
        dc.l    Obj21_Head_Up_Display          ; loc_022DFC
        dc.l    Obj22_Arrow_Shooter            ; loc_019660
        dc.l    Obj23_Pillar           ; loc_019850    
        dc.l    Obj24                  ; loc_00A012
        dc.l    Obj25_Rings            ; loc_00AC28 
        dc.l    Obj26_Monitors         ; loc_00B29C
        dc.l    Obj27_Object_Hit               ; loc_00A086
        dc.l    Obj28_Flickies         ; loc_00A2B0
        dc.l    Obj29_Enemy_Points             ; loc_00A7C0
        dc.l    Obj2A_Up_Down_Pillar           ; loc_009C0C
        dc.l    Obj2B_Breakable_Pillar         ; loc_019A1E
        dc.l    Obj2C_Leaves           ; loc_01A0C4
        dc.l    Obj2D_Automatic_Door           ; loc_009CE2   
        dc.l    Obj2E_Monitors_Contents        ; loc_00B46A
        dc.l    Obj2F_Breakable_Floor          ; loc_01747C
        dc.l    Obj30                  ; loc_017A4C
        dc.l    Obj31_Lava_Attributes          ; loc_0155A0 
        dc.l    Obj32_Breakable_Obstacule      ; loc_01768A
        dc.l    Obj33_Touch_Booster            ; loc_017CA0   
        dc.l    Obj34_Title_Cards              ; loc_00BB54 
        dc.l    Obj35_Invincibility            ; loc_01264E
        dc.l    Obj36_Spikes           ; loc_00C944 
        dc.l    Obj37_Rings_Out        ; loc_00AD62 
        dc.l    Obj38_Shield           ; loc_0125CE
        dc.l    Obj39_Time_Game_Over           ; loc_00BD76
        dc.l    Obj3A_Level_Results            ; loc_00BE38 
        dc.l    Obj3B                  ; loc_00CD00
        dc.l    Obj3C                  ; loc_00CD7C
        dc.l    Obj3D_Break_Boost              ; loc_018E78   
        dc.l    Obj3E_Egg_Prison               ; loc_020E5C
        dc.l    Obj3F                  ; loc_00A11E
        dc.l    Obj40_Diagonal_Springs         ; loc_01A30C
        dc.l    Obj41_Springs          ; loc_00E7B8 
        dc.l    Obj42_Steam_Vent               ; loc_01A5CC
        dc.l    Obj43_Giant_Spikeball          ; loc_017F0C  
        dc.l    Obj44                  ; loc_00F10C
        dc.l    Obj45_Spring_Push_Boost        ; loc_0181A0
        dc.l    Obj46_Spring_Ball              ; loc_018ABE 
        dc.l    Obj47_Switch           ; loc_018D9C
        dc.l    Obj48_Cannon           ; loc_019250
        dc.l    Obj49_Waterfall        ; loc_015352 
        dc.l    Obj4A_Octus            ; loc_01EBB8
        dc.l    Obj4B_Buzz_Bomber              ; loc_01E89C 
        dc.l    Obj4C_Batbot           ; loc_01EE68 
        dc.l    Obj4D_Rhinobot         ; loc_01D984 
        dc.l    Obj4E_Crocobot         ; loc_01F2F0
        dc.l    Obj4F_Dinobot          ; loc_01DEAC
        dc.l    Obj50_Aquis            ; loc_01E010
        dc.l    Obj51_Aquis            ; loc_01E62C
        dc.l    Obj52_Piranha          ; loc_01DC54
        dc.l    Obj53_Chopper          ; loc_01F5E8   
        dc.l    Obj54_Motobug          ; loc_01F6E8 
        dc.l    Obj55_Ghz_Boss         ; loc_02030C
        dc.l    Obj56                  ; loc_0205A6
        dc.l    Obj57                  ; loc_01F99C
        dc.l    Obj58                  ; loc_01FC0A
        dc.l    Obj_Null                  ; loc_00D24A ; Object $59
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5A
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5B
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5C
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5D   
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5E
        dc.l    Obj_Null                  ; loc_00D24A ; Object $5F
        dc.l    Obj_Null                  ; loc_00D24A ; Object $60
        dc.l    Obj_Null                  ; loc_00D24A ; Object $61
        dc.l    Obj_Null                  ; loc_00D24A ; Object $62
        dc.l    Obj_Null                  ; loc_00D24A ; Object $63   
        dc.l    Obj64_Pistons          ; loc_01A8B4
        dc.l    Obj65_Platform         ; loc_01AA74 
        dc.l    Obj66_Spring_Wall              ; loc_01AEBC
        dc.l    Obj67_Teleport_Attributes      ; loc_01B0C4
        dc.l    Obj68_Block_Arrow              ; loc_01B520
        dc.l    Obj69_Screw_Nut        ; loc_01B810
        dc.l    Obj6A_Rotating_Boxes           ; loc_01BA30
        dc.l    Obj6B_Mz_Platform              ; loc_01BCEC
        dc.l    Obj6C_Mz_Moving_Platforms      ; loc_01BF6C
        dc.l    Obj6D_Harpoon          ; loc_01B720   
        dc.l    Obj6E_Machine          ; loc_01C2E4
        dc.l    Obj_Ox6F_Parallelogram_Elevator   ; loc_01C4F8
        dc.l    Obj70_Rotating_Gears           ; loc_01C850
        dc.l    Obj71_Hpz_Misc         ; loc_009A54 
        dc.l    Obj72_Conveyor_Belt_Attributes ; loc_01CBCC
        dc.l    Obj73_Rotating_Rings           ; loc_01CC54   
        dc.l    Obj74_Invisible_Block          ; loc_01561A
        dc.l    Obj75_Spikeball_Chain          ; loc_01CE48
        dc.l    Obj76_Platform_Spikes          ; loc_01D078
        dc.l    Obj77_Bridge           ; loc_01D208
        dc.l    Obj78_Rotating_Platforms       ; loc_01D3C0
        dc.l    Obj79_Lamp_Post        ; loc_013B54
        dc.l    Obj7A_Platform_Horizontal      ; loc_01D594
        dc.l    Obj7B_Spring_Tubes             ; loc_01D74C
        dc.l    Obj_Null                  ; loc_00D24A ; Object $7C
        dc.l    Obj7D_Hidden_Bonus             ; loc_013DFC 
        dc.l    Obj_Null                  ; loc_00D24A ; Object $7E
        dc.l    Obj_Null                  ; loc_00D24A ; Object $7F
        dc.l    Obj_Null                  ; loc_00D24A ; Object $80
        dc.l    Obj_Null                  ; loc_00D24A ; Object $81
        dc.l    Obj_Null                  ; loc_00D24A ; Object $82
        dc.l    Obj_Null                  ; loc_00D24A ; Object $83   
        dc.l    Obj_Null                  ; loc_00D24A ; Object $84
        dc.l    Obj_Null                  ; loc_00D24A ; Object $85
        dc.l    Obj_Null                  ; loc_00D24A ; Object $86
        dc.l    Obj_Null                  ; loc_00D24A ; Object $87
        dc.l    Obj_Null                  ; loc_00D24A ; Object $88
        dc.l    Obj_Null                  ; loc_00D24A ; Object $89
        dc.l    Obj8A_Credits          ; loc_020740
        dc.l    Obj_Null                  ; loc_00D24A ; Object $8B
        dc.l    Obj_Null                  ; loc_00D24A ; Object $8C   
Obj_Null: ; loc_00D24A:
        bra     DeleteObject            ; loc_00D3B4   

		
;=============================================================================== 
; Beginning of End of Sub for ObjectFall                 
;===============================================================================         
ObjectFall: ; loc_00D24E:
        move.l  x_pos(a0), D2
        move.l  y_pos(a0), D3
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A0), D0
        addi.w  #$038, $0012(a0)
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a0)
        move.l  d3, y_pos(a0)
        rts
;=============================================================================== 
;  End of Sub for ObjectFall                 
;===============================================================================  
        
;=============================================================================== 
; Beginning of Sub SpeedToPos
;===============================================================================               
SpeedToPos: ; loc_00D27A:
        move.l  x_pos(a0), D2
        move.l  y_pos(a0), D3
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a0)
        move.l  d3, y_pos(a0)
        rts     
;=============================================================================== 
; End of Sub SpeedToPos            
;=============================================================================== 
 
;=============================================================================== 
; Beginning of Sub MarkObjGone                
;===============================================================================                   
MarkObjGone: ; loc_00D2A0:
        tst.w   (Two_player_mode).w
        beq.s   loc_00D2AA
        bra     DisplaySprite           ; loc_00D3C2
loc_00D2AA:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_00D2C2
        bra     DisplaySprite           ; loc_00D3C2
loc_00D2C2:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_00D2D4
        bclr    #$7, $02(A2, d0)
loc_00D2D4:
        bra     DeleteObject            ; loc_00D3B4
loc_00D2D8:        
        tst.w   (Two_player_mode).w
        beq.s   loc_00D2E2
        bra     DisplaySprite           ; loc_00D3C2
loc_00D2E2:
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_00D2F6
        bra     DisplaySprite           ; loc_00D3C2
loc_00D2F6:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_00D308
        bclr    #$7, $02(A2, d0)
loc_00D308:
        bra     DeleteObject            ; loc_00D3B4
loc_00D30C:         
        tst.w   (Two_player_mode).w
        beq.s   loc_00D314
        rts
loc_00D314:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_00D32A
        rts
loc_00D32A:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_00D33C
        bclr    #$7, $02(A2, d0)
loc_00D33C:
        bra     DeleteObject            ; loc_00D3B4
loc_00D340:        
        tst.w   (Two_player_mode).w
        bne.s   loc_00D374
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_00D35E
        bra     DisplaySprite           ; loc_00D3C2
loc_00D35E:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_00D370
        bclr    #$7, $02(A2, d0)
loc_00D370:
        bra     DeleteObject            ; loc_00D3B4
loc_00D374:
        move.w  x_pos(a0), D0
        andi.w  #$FF00, d0
        move.w  d0, d1
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$300, d0
        bhi     loc_00D38E
        bra     DisplaySprite           ; loc_00D3C2
loc_00D38E:
        sub.w   ($FFFFF7DC).w, d1
        cmpi.w  #$300, d1
        bhi     loc_00D39E
        bra     DisplaySprite           ; loc_00D3C2
loc_00D39E:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_00D3B0
        bclr    #$7, $02(A2, d0)
loc_00D3B0:
        bra     DeleteObject            ; loc_00D3B4
;=============================================================================== 
; End of Sub MarkObjGone            
;===============================================================================         

;=============================================================================== 
; Beginning of Sub DeleteObject                 
;===============================================================================         
DeleteObject:  ; loc_00D3B4: ; Delete Object / Null Object
        move.l  A0, A1
DeleteObject2:        
        moveq   #0,d1
        moveq   #$F, d0  
loc_00D3BA:
        move.l  d1, (A1)+
        dbra    d0, loc_00D3BA
        rts   
;=============================================================================== 
; End of Sub DeleteObject              
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub DisplaySprite                
;===============================================================================                   
DisplaySprite: ; loc_00D3C2: ; Display Object
        lea     (Sprite_Table_Input).w, A1
        move.w  $0018(A0), D0
        lsr.w   #1,d0
        andi.w  #$380, d0
        adda.w  d0, A1
        cmpi.w  #$07E, (a1)
        bcc.s   loc_00D3DE
        addq.w  #$2, (a1)
        adda.w  (A1), A1
        move.w  A0, (a1)
loc_00D3DE:
        rts
;=============================================================================== 
; End of Sub DisplaySprite               
;===============================================================================
 
;=============================================================================== 
; Beginning of Sub DisplaySprite                
;===============================================================================           
DisplayA1Sprite: ; loc_00D3E0:
        lea     (Sprite_Table_Input).w, a2
        move.w  $0018(A1), D0
        lsr.w   #1,d0
        andi.w  #$380, d0
        adda.w  d0, a2
        cmpi.w  #$07E, (a2)
        bcc.s   loc_00D3FC
        addq.w  #$2, (a2)
        adda.w  (A2), A2
        move.w  A1, (a2)
loc_00D3FC:
        rts
;=============================================================================== 
; End of Sub DisplaySprite               
;===============================================================================  

;=============================================================================== 
; Beginning of Sub DisplaySprite_Param                
;===============================================================================   
DisplaySprite_Param: ;loc_00D3FE:
        lea     (Sprite_Table_Input).w, A1
        adda.w  d0, A1
        cmpi.w  #$07E, (a1)
        bcc.s   loc_00D410
        addq.w  #$2, (a1)
        adda.w  (A1), A1
        move.w  A0, (a1)
loc_00D410:
        rts   
;=============================================================================== 
; End of Sub DisplaySprite_Param               
;=============================================================================== 
          
;=============================================================================== 
; Beginning of Sub AnimateSprite                
;===============================================================================           
AnimateSprite: ; loc_00D412:
        moveq	#0,d0
        move.b  $001C(A0), D0
        cmp.b   $001D(A0), D0
        beq.s   loc_00D42E
        move.b  d0, $001D(a0)
        move.b  #0, $001B(a0)
        move.b  #0, $001E(a0)
loc_00D42E:
        subq.b  #1, $001E(a0)
        bpl.s   loc_00D468
        add.w   d0, d0
        adda.w  $00(A1, d0), A1
        move.b  (A1), $001E(a0)
        moveq   #0,d1
        move.b  $001B(A0), d1
        move.b  $01(A1, d1), D0
        bmi.s   loc_00D46A
loc_00D44A: 
        andi.b  #$7F, d0
        move.b  d0, $001A(a0)
        move.b  status(a0), d1
        andi.b  #3, d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        addq.b  #1, $001B(a0)
loc_00D468:
        rts
loc_00D46A:
        addq.b  #1,d0
        bne.s   loc_00D47A
        move.b  #0, $001B(a0)
        move.b  render_flags(A1), D0
        bra.s   loc_00D44A
loc_00D47A:
        addq.b  #1,d0 
        bne.s   loc_00D48E
        move.b  $02(A1, d1), D0
        sub.b   d0, $001B(a0)
        sub.b   d0, d1
        move.b  $01(A1, d1), D0
        bra.s   loc_00D44A
loc_00D48E:
        addq.b  #1,d0
        bne.s   loc_00D49A
        move.b  $02(A1, d1), $001C(a0)
        rts
loc_00D49A:
        addq.b  #1,d0
        bne.s   loc_00D4AE
        addq.b  #2,routine(a0)
        move.b  #0, $001E(a0)
        addq.b  #1, $001B(a0)
        rts
loc_00D4AE:
        addq.b  #1,d0
        bne.s   loc_00D4BE
        move.b  #0, $001B(a0)
        clr.b   $0025(a0)
        rts
loc_00D4BE:
        addq.b  #1,d0
        bne.s   loc_00D4C8
        addq.b  #$2, $0025(a0)
        rts
loc_00D4C8:
        rts
;=============================================================================== 
; End of Sub AnimateSprite              
;===============================================================================   
               
;=============================================================================== 
; Beginning of Sub Build_Sprites                 
;===============================================================================               
BldSpr_ScrPos: ; loc_00D4CA:
        dc.l    $00000000, $FFFFEEF0, $FFFFEE08, $FFFFEE18                  
Build_Sprites: ; loc_00D4DA:
        tst.w   (Two_player_mode).w
        bne     Build_Sprites_2p        ; loc_00D824
        lea     ($FFFFF800).w, a2
        moveq   #0,d5
        moveq   #0, D4
        tst.b   ($FFFFF711).w
        beq.s   loc_00D4F4
        bsr     loc_00E01C
loc_00D4F4:
        lea     (Sprite_Table_Input).w, A4
        moveq   #$7, D7
loc_00D4FA:        
        tst.w   (a4)
        beq     loc_00D5D0
        moveq   #$2, D6
loc_00D502:        
        move.w  $00(A4, D6), A0
        tst.b   (a0)
        beq     loc_00D5F2 
        tst.l   mappings(a0)
        beq     loc_00D5F2
        andi.b  #$7F,render_flags(a0)
        move.b  render_flags(A0), D0
        move.b  d0, D4
        btst    #6, d0
        bne     loc_00D5F4
        andi.w  #$00C, d0
        beq.s   loc_00D580
        move.l  BldSpr_ScrPos(pc,d0), A1  ; loc_00D4CA
        moveq	#0,d0
        move.b width_pixels(a0), D0
        move.w  x_pos(a0), D3
        sub.w   (A1), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00D5C8
        move.w  d3, d1           
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge     loc_00D5C8
        addi.w  #$080, d3
        btst    #4, D4
        beq.s   loc_00D58A
        moveq	#0,d0
        move.b  y_radius(A0), D0
        move.w  y_pos(a0), D2         
        sub.w   mappings(A1), D2
        move.w  D2, d1
        add.w   d0, d1
        bmi.s   loc_00D5C8
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge.s   loc_00D5C8
        addi.w  #$080, D2
        bra.s   loc_00D5A2
loc_00D580:         
        move.w  $000A(A0), D2
        move.w  x_pos(a0), D3
        bra.s   loc_00D5A2
loc_00D58A:
        move.w  y_pos(a0), D2
        sub.w   mappings(A1), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00D5C8
        cmpi.w  #$180, D2
        bcc.s   loc_00D5C8
loc_00D5A2:
        move.l  mappings(A0), A1
        moveq   #0,d1
        btst    #5, D4
        bne.s   loc_00D5BE
        move.b  $001A(A0), d1
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00D5C2
loc_00D5BE:
        bsr     loc_00D6D8
loc_00D5C2:        
        ori.b   #$80,render_flags(a0)
loc_00D5C8:        
        addq.w  #$2, D6        
        subq.w  #$2, (a4)
        bne     loc_00D502    
loc_00D5D0:
        lea     $0080(A4), A4
        dbra    d7, loc_00D4FA  
        move.b  d5, ($FFFFF62C).w
        cmpi.b  #$50,d5
        beq.s   loc_00D5EA
        move.l  #$0000000, (a2)
        rts
loc_00D5EA:
        move.b  #0, $FFFFFFFB(a2)
        rts
loc_00D5F2:
        bra.s   loc_00D5C8             
loc_00D5F4:
        move.l  A4, -(A7)
        lea     ($FFFFEE00).w, A4
        move.w  art_tile(A0), A3
        move.l  mappings(A0), a5
        moveq	#0,d0
        move.b  Objoff_E(A0), D0
        move.w  x_pos(a0), D3
        sub.w   (A4), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00D6CA
        move.w  d3, d1
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge     loc_00D6CA
        addi.w  #$080, d3
        btst    #4, D4
        beq.s   loc_00D652
        moveq	#0,d0
        move.b  $14(A0), D0
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        move.w  D2, d1
        add.w   d0, d1
        bmi     loc_00D6CA
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge.s   loc_00D6CA
        addi.w  #$080, D2           
        bra.s   loc_00D66A
loc_00D652:        
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00D6CA
        cmpi.w  #$180, D2
        bcc.s   loc_00D6CA
loc_00D66A:        
        moveq   #0,d1
        move.b  $000B(A0), d1
        beq.s   loc_00D684
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00D684
        bsr     loc_00D6D0
loc_00D684:
        ori.b   #$80,render_flags(a0)
        lea    x_vel(A0), a6
        moveq	#0,d0
        move.b  Objoff_F(A0), D0
        subq.w  #1,d0
        bcs.s   loc_00D6CA
loc_00D698:        
        swap.w  D0
        move.w  (a6)+, D3
        sub.w   (A4), D3
        addi.w  #$080, d3
        move.w  (a6)+, D2
        sub.w   mappings(A4), D2
        addi.w  #$080, D2
        addq.w  #1, a6
        moveq   #0,d1
        move.b  (a6)+, d1
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00D6C4
        bsr     loc_00D6D0
loc_00D6C4:
        swap.w  D0
        dbra    d0, loc_00D698         
loc_00D6CA:
        move.l  (A7)+, A4
        bra     loc_00D5C8
loc_00D6D0:
        cmpi.b  #$50,d5
        bcs.s   loc_00D6F0
        rts
loc_00D6D8:
        move.w  art_tile(A0), A3
        cmpi.b  #$50,d5
        bcc.s   loc_00D718
        btst    #0, D4
        bne.s   loc_00D71A
        btst    #1, D4
        bne     loc_00D77A
loc_00D6F0:
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        move.w  (A1)+, D0
        add.w   A3, d0
        move.w  d0, (a2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00D712
        addq.w  #1,d0
loc_00D712:
        move.w  d0, (a2)+
        dbra    d1, loc_00D6F0
loc_00D718:
        rts   
loc_00D71A:
        btst    #1, D4
        bne     loc_00D7C2
loc_00D722:        
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  d4, (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$800, d0
        move.w  d0, (a2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        neg.w   D0
        move.b  loc_00D75A(PC, D4), D4
        sub.w   d4, d0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00D752
        addq.w  #1,d0
loc_00D752:
        move.w  d0, (a2)+
        dbra    d1, loc_00D722
        rts
loc_00D75A:
        dc.b    $08, $08, $08, $08, $10, $10, $10, $10, $18, $18, $18, $18, $20, $20, $20, $20
loc_00D76A:        
        dc.b    $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20
loc_00D77A:
        move.b  (A1)+, D0
        move.b  (A1), D4
        ext.w   D0
        neg.w   D0
        move.b  loc_00D76A(PC, D4), D4
        sub.w   d4, d0
        add.w   d2, d0        
        move.w  d0, (a2)+
        move.b  (A1)+, (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$1000, d0
        move.w  d0, (a2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00D7AA
        addq.w  #1,d0
loc_00D7AA:
        move.w  d0, (a2)+  
        dbra    d1, loc_00D77A                    
        rts 
loc_00D7B2:        
        dc.b    $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20
loc_00D7C2:
        move.b  (A1)+, D0
        move.b  (A1), D4
        ext.w   D0
        neg.w   D0
        move.b  loc_00D7B2(PC, D4), D4
        sub.w   d4, d0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  d4, (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$1800, d0
        move.w  d0, (a2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        neg.w   D0
        move.b  loc_00D804(PC, D4), D4
        sub.w   d4, d0    
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00D7FC
        addq.w  #1,d0
loc_00D7FC:
        move.w  d0, (a2)+
        dbra    d1, loc_00D7C2
        rts
loc_00D804:
        dc.b    $08, $08, $08, $08, $10, $10, $10, $10, $18, $18, $18, $18, $20, $20, $20, $20
;=============================================================================== 
; End of Sub Build_Sprites                
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Build_Sprites_2p                
;===============================================================================  
BldSpr_ScrPos_2p: ; loc_00D814:        
        dc.l    $00000000, $FFFFEE00, $FFFFEE08, $FFFFEE18
Build_Sprites_2p: ; loc_00D824:
        tst.w   ($FFFFF644).w
        bne.s   Build_Sprites_2p        ; loc_00D824
        lea     ($FFFFF800).w, a2
        moveq   #$2,d5
        moveq   #0, D4
        move.l  #$1D80F01, (A2)+
        move.l  #$0000001, (A2)+
        move.l  #$1D80F02, (A2)+
        move.l  #$0000000, (A2)+
        tst.b   ($FFFFF711).w
        beq.s   loc_00D854
        bsr     loc_00E098
loc_00D854:
        lea     (Sprite_Table_Input).w, A4
        moveq   #$7, D7
loc_00D85A:        
        move.w  (a4), d0
        beq     loc_00D932
        move.w  d0, -(A7)
        moveq   #$2, D6
loc_00D864:        
        move.w  $00(A4, D6), A0
        tst.b   (a0)
        beq     loc_00D928
        andi.b  #$7F,render_flags(a0)
        move.b  render_flags(A0), D0
        move.b  d0, D4
        btst    #6, d0
        bne     loc_00DA6C
        andi.w  #$00C, d0
        beq.s   loc_00D8D8
        move.l  BldSpr_ScrPos_2p(pc,d0), A1  ; loc_00D814
        moveq	#0,d0
        move.b width_pixels(a0), D0
        move.w  x_pos(a0), D3
        sub.w   (A1), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00D928
        move.w  d3, d1
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge.s   loc_00D928
        addi.w  #$080, d3
        btst    #4, D4  
        beq.s   loc_00D8E6
        moveq	#0,d0
        move.b  y_radius(A0), D0
        move.w  y_pos(a0), D2
        sub.w   mappings(A1), D2
        move.w  D2, d1
        add.w   d0, d1
        bmi.s   loc_00D928
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge.s   loc_00D928
        addi.w  #$100, D2
        bra.s   loc_00D902
loc_00D8D8:        
        move.w  $000A(A0), D2
        move.w  x_pos(a0), D3
        addi.w  #$080, D2
        bra.s   loc_00D902
loc_00D8E6:        
        move.w  y_pos(a0), D2
        sub.w   mappings(A1), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00D928
        cmpi.w  #$180, D2
        bcc.s   loc_00D928
        addi.w  #$080, D2
loc_00D902:
        move.l  mappings(A0), A1
        moveq   #0,d1
        btst    #5, D4
        bne.s   loc_00D91E
        move.b  $001A(A0), d1
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1, d1
        bmi.s   loc_00D922
loc_00D91E:
        bsr     loc_00DC70
loc_00D922:
        ori.b   #$80,render_flags(a0)
loc_00D928:        
        addq.w  #$2, D6
        subq.w  #$2, (a7)
        bne     loc_00D864
        addq.w  #$2, A7
loc_00D932:        
        lea     $0080(A4), A4
        dbra    d7, loc_00D85A
        move.b  d5, ($FFFFF62C).w
        cmpi.b  #$50,d5
        bcc.s   loc_00D94C
        move.l  #$0000000, (a2)
        bra.s   loc_00D964
loc_00D94C:
        move.b  #0, $FFFFFFFB(a2)
        bra.s   loc_00D964
loc_00D954:
        dc.b    $00, $00, $00, $00, $FF, $FF, $EE, $20, $FF, $FF, $EE, $28, $FF, $FF, $EE, $38                   
loc_00D964:
        lea     ($FFFFDD00).w, a2
        moveq   #0,d5
        moveq   #0, D4
        tst.b   ($FFFFF711).w
        beq.s   loc_00D976
        bsr     loc_00E0AE
loc_00D976:
        lea     (Sprite_Table_Input).w, A4
        moveq   #$7, D7
loc_00D97C:        
        tst.w   (a4)
        beq     loc_00DA4A
        moveq   #$2, D6
loc_00D984:        
        move.w  $00(A4, D6), A0
        tst.b   (a0)
        beq     loc_00DA42
        move.b  render_flags(A0), D0
        move.b  d0, D4
        btst    #6, d0
        bne     loc_00DB4E
        andi.w  #$00C, d0
        beq.s   loc_00D9F2
        move.l  loc_00D954(pc,d0), A1
        moveq	#0,d0
        move.b width_pixels(a0), D0
        move.w  x_pos(a0), D3
        sub.w   (A1), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00DA42
        move.w  d3, d1
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge.s   loc_00DA42
        addi.w  #$080, d3
        btst    #4, D4
        beq.s   loc_00DA00
        moveq	#0,d0
        move.b  y_radius(A0), D0
        move.w  y_pos(a0), D2
        sub.w   mappings(A1), D2
        move.w  D2, d1 
        add.w   d0, d1
        bmi.s   loc_00DA42
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge.s   loc_00DA42
        addi.w  #$1E0, D2
        bra.s   loc_00DA1C
loc_00D9F2:
        move.w  $000A(A0), D2
        move.w  x_pos(a0), D3
        addi.w  #$160, D2
        bra.s   loc_00DA1C
loc_00DA00:
        move.w  y_pos(a0), D2
        sub.w   mappings(A1), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00DA42
        cmpi.w  #$180, D2
        bcc.s   loc_00DA42
        addi.w  #$160, D2
loc_00DA1C:
        move.l  mappings(A0), A1
        moveq   #0,d1
        btst    #5, D4
        bne.s   loc_00DA38
        move.b  $001A(A0), d1
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00DA3C
loc_00DA38:
        bsr     loc_00DC70
loc_00DA3C:
        ori.b   #$80,render_flags(a0)
loc_00DA42:        
        addq.w  #$2, D6
        subq.w  #$2, (a4)
        bne     loc_00D984
loc_00DA4A:        
        lea     $0080(A4), A4
        dbra    d7, loc_00D97C         
        move.b  d5, ($FFFFF62C).w
        cmpi.b  #$50,d5
        beq.s   loc_00DA64
        move.l  #$0000000, (a2)
        rts
loc_00DA64:
        move.b  #0, $FFFFFFFB(a2)
        rts
loc_00DA6C:
        move.l  A4, -(A7)
        lea     ($FFFFEE00).w, A4
        move.w  art_tile(A0), A3
        move.l  mappings(A0), a5
        moveq	#0,d0
        move.b  Objoff_E(A0), D0
        move.w  x_pos(a0), D3
        sub.w   (A4), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00DB48
        move.w  d3, d1
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge     loc_00DB48
        addi.w  #$080, d3
        btst    #4, D4
        beq.s   loc_00DACC
        moveq	#0,d0
        move.b  $14(A0), D0
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        move.w  D2, d1
        add.w   d0, d1
        bmi     loc_00DB48
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge     loc_00DB48
        addi.w  #$100, D2
        bra.s   loc_00DAE8
loc_00DACC:
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00DB48
        cmpi.w  #$180, D2
        bcc.s   loc_00DB48
        addi.w  #$080, D2
loc_00DAE8:        
        moveq   #0,d1
        move.b  $000B(A0), d1
        beq.s   loc_00DB02
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00DB02
        bsr     loc_00DC68
loc_00DB02:
        ori.b   #$80,render_flags(a0)
        lea    x_vel(A0), a6
        moveq	#0,d0
        move.b  Objoff_F(A0), D0
        subq.w  #1,d0
        bcs.s   loc_00DB48
loc_00DB16:        
        swap.w  D0
        move.w  (a6)+, D3
        sub.w   (A4), D3
        addi.w  #$080, d3
        move.w  (a6)+, D2
        sub.w   mappings(A4), D2
        addi.w  #$100, D2
        addq.w  #1, a6
        moveq   #0,d1
        move.b  (a6)+, d1
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00DB42
        bsr     loc_00DC68
loc_00DB42:
        swap.w  D0
        dbra    d0, loc_00DB16
loc_00DB48:
        move.l  (A7)+, A4
loc_00DB4A:        
        bra     loc_00D928             
loc_00DB4E:
        move.l  A4, -(A7)
        lea     ($FFFFEE20).w, A4
        move.w  art_tile(A0), A3
        move.l  mappings(A0), a5
        moveq	#0,d0
        move.b  Objoff_E(A0), D0
        move.w  x_pos(a0), D3
        sub.w   (A4), D3
        move.w  d3, d1
        add.w   d0, d1
        bmi     loc_00DC2A
        move.w  d3, d1
        sub.w   d0, d1
        cmpi.w  #$140, d1
        bge     loc_00DC2A
        addi.w  #$080, d3
        btst    #4, D4
        beq.s   loc_00DBAE
        moveq	#0,d0
        move.b  $14(A0), D0
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        move.w  D2, d1
        add.w   d0, d1
        bmi     loc_00DC2A
        move.w  D2, d1
        sub.w   d0, d1
        cmpi.w  #$0E0, d1
        bge     loc_00DC2A
        addi.w  #$1E0, D2
        bra.s   loc_00DBCA
loc_00DBAE:        
        move.w  y_pos(a0), D2
        sub.w   mappings(A4), D2
        addi.w  #$080, D2
        cmpi.w  #$060, D2
        bcs.s   loc_00DC2A
        cmpi.w  #$180, D2
        bcc.s   loc_00DC2A
        addi.w  #$160, D2
loc_00DBCA:
        moveq   #0,d1
        move.b  $000B(A0), d1
        beq.s   loc_00DBE4
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1, d1
        bmi.s   loc_00DBE4
        bsr     loc_00DC68
loc_00DBE4: 
        ori.b   #$80,render_flags(a0)
        lea    x_vel(A0), a6
        moveq	#0,d0
        move.b  Objoff_F(A0), D0
        subq.w  #1,d0
        bcs.s   loc_00DC2A
loc_00DBF8:        
        swap.w  D0
        move.w  (a6)+, D3
        sub.w   (A4), D3
        addi.w  #$080, d3
        move.w  (a6)+, D2
        sub.w   mappings(A4), D2
        addi.w  #$1E0, D2
        addq.w  #1, a6
        moveq   #0,d1
        move.b  (a6)+, d1
        add.w   d1, d1
        move.l  a5, A1
        adda.w  $00(A1, d1), A1
        move.w  (A1)+, d1
        subq.w  #1,d1
        bmi.s   loc_00DC24
        bsr     loc_00DC68
loc_00DC24:
        swap.w  D0
        dbra    d0, loc_00DBF8    
loc_00DC2A:
        move.l  (A7)+, A4
        bra     loc_00DA42
;=============================================================================== 
; End of Sub Build_Sprites_2p         
;===============================================================================          

;=============================================================================== 
; Beginning of Sub Adjust2PArtPointer         
; 2P Mode Objects Attributes #1
;===============================================================================          
Adjust2PArtPointer: ; loc_00DC30: 
        tst.w   (Two_player_mode).w
        beq.s   loc_00DC4A
        move.w  art_tile(A0), D0
        andi.w  #$7FF, d0
        lsr.w   #1,d0
        andi.w  #$F800,art_tile(a0)
        add.w   d0,art_tile(a0)
loc_00DC4A:
        rts  
;=============================================================================== 
; End of Sub Adjust2PArtPointer         
;                2P Mode Objects Attributes #1
;===============================================================================         

;=============================================================================== 
; Beginning of Sub Adjust2PArtPointer         
 ;                    2P Mode Objects Attributes #2
;===============================================================================          
ModifyA1SpriteAttr_2P: ; loc_00DC4C: 
        tst.w   (Two_player_mode).w
        beq.s   ModifySpriteAttr_Not2pmode ; loc_00DC66
        move.w  art_tile(A1), D0
        andi.w  #$7FF, d0
        lsr.w   #1,d0
        andi.w  #$F800, art_tile(a1)
        add.w   d0, art_tile(a1)
ModifySpriteAttr_Not2pmode ; loc_00DC66:
        rts 
;=============================================================================== 
; End of Sub Adjust2PArtPointer         
;                      2P Mode Objects Attributes #2
;===============================================================================
                          
loc_00DC68:
        cmpi.b  #$50,d5
        bcs.s   loc_00DC88
        rts
loc_00DC70:
        move.w  art_tile(A0), A3
        cmpi.b  #$50,d5
        bcc.s   loc_00DCB4
        btst    #0, D4
        bne.s   loc_00DCC6
        btst    #1, D4
        bne     loc_00DD28
loc_00DC88:        
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4    
        move.b  loc_00DCB6(PC, D4), (A2)+             
        addq.b  #1,d5
        move.b  d5, (A2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   A3, d0
        move.w  d0, (a2)+
        move.w  (A1)+, D0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00DCAE
        addq.w  #1,d0
loc_00DCAE:
        move.w  d0, (a2)+
        dbra    d1, loc_00DC88
loc_00DCB4:        
        rts        
loc_00DCB6:               
        dc.b    $00, $00, $01, $01, $04, $04, $05, $05, $08, $08, $09, $09, $0C, $0C, $0D, $0D
loc_00DCC6:
        btst    #1, D4
        bne     loc_00DD84
loc_00DCCE:        
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  loc_00DCB6(PC, D4), (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$800, d0
        move.w  d0, (a2)+
        move.w  (A1)+, D0
        neg.w   D0
        move.b  loc_00DD08(PC, D4), D4
        sub.w   d4, d0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00DD00
        addq.w  #1, d0
loc_00DD00:
        move.w  d0, (a2)+
        dbra    d1, loc_00DCCE
        rts      
loc_00DD08:
        dc.b    $08, $08, $08, $08, $10, $10, $10, $10, $18, $18, $18, $18, $20, $20, $20, $20  
loc_00DD18: 
        dc.b    $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20
loc_00DD28:
        move.b  (A1)+, D0
        move.b  (A1), D4
        ext.w   D0
        neg.w   D0
        move.b  loc_00DD18(PC, D4), D4
        sub.w   d4, d0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  loc_00DD64(PC, D4), (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$1000, d0
        move.w  d0, (a2)+
        move.w  (A1)+, D0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00DD5C
        addq.w  #1,d0   
loc_00DD5C:
        move.w  d0, (a2)+
        dbra    d1, loc_00DD28
        rts           
loc_00DD64:
        dc.b    $00, $00, $01, $01, $04, $04, $05, $05, $08, $08, $09, $09, $0C, $0C, $0D, $0D 
loc_00DD74:  
        dc.b    $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20, $08, $10, $18, $20
loc_00DD84:
        move.b  (A1)+, D0
        move.b  (A1), D4
        ext.w   D0
        neg.w   D0
        move.b  loc_00DD74(PC, D4), D4
        sub.w   d4, d0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  loc_00DD64(PC, D4), (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   A3, d0
        eori.w  #$1800, d0
        move.w  d0, (a2)+
        move.w  (A1)+, D0
        neg.w   D0
        move.b  loc_00DDC8(PC, D4), D4
        sub.w   d4, d0
        add.w   d3, d0
        andi.w  #$1FF, d0
        bne.s   loc_00DDC0
        addq.w  #1,d0
loc_00DDC0:
        move.w  d0, (a2)+
        dbra    d1, loc_00DD84
        rts               
loc_00DDC8:
        dc.b    $08, $08, $08, $08, $10, $10, $10, $10, $18, $18, $18, $18, $20, $20, $20, $20
loc_00DDD8:
        move.w  x_pos(a0), D0
        sub.w   ($FFFFEE00).w, d0
        bmi.s   loc_00DDFC
        cmpi.w  #$140, d0
        bge.s   loc_00DDFC
        move.w  y_pos(a0), d1
        sub.w   ($FFFFEE04).w, d1
        bmi.s   loc_00DDFC
        cmpi.w  #$0E0, d1
        bge.s   loc_00DDFC
        moveq	#0,d0
        rts
loc_00DDFC:
        moveq   #1,d0
        rts   
;loc_00DE00:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  x_pos(a0), D0
        sub.w   ($FFFFEE00).w, d0
        add.w   d1, d0
        bmi.s   loc_00DE30
        add.w   d1, d1
        sub.w   d1, d0
        cmpi.w  #$140, d0
        bge.s   loc_00DE30
        move.w  y_pos(a0), d1
        sub.w   ($FFFFEE04).w, d1
        bmi.s   loc_00DE30
        cmpi.w  #$0E0, d1
        bge.s   loc_00DE30
        moveq	#0,d0
        rts
loc_00DE30:
        moveq   #1,d0
        rts
;========================= Load Ring List - [ Start ] ==========================         
Load_Ring_Pos: ; loc_00DE34:
        moveq	#0,d0
        move.b  ($FFFFF710).w, d0
        move.w  loc_00DE42(pc,d0), D0
        jmp     loc_00DE42(pc,d0)
loc_00DE42:  
        dc.w    loc_00DE46-loc_00DE42
        dc.w    loc_00DE90-loc_00DE42
loc_00DE46: 
        addq.b  #$2, ($FFFFF710).w
        bsr     loc_00E140
        lea     ($FFFFE800).w, A1
        move.w  ($FFFFEE00).w, D4
        subq.w  #8, D4
        bhi.s   loc_00DE62
        moveq   #1, D4
        bra.s   loc_00DE62
loc_00DE5E:        
        lea     $0006(A1), A1
loc_00DE62:
        cmp.w   art_tile(A1), D4
        bhi.s   loc_00DE5E
        move.w  A1, ($FFFFF712).w
        move.w  A1, ($FFFFF716).w
        addi.w  #$150, D4
        bra.s   loc_00DE7A
loc_00DE76:        
        lea     $0006(A1), A1
loc_00DE7A:
        cmp.w   art_tile(A1), D4
        bhi.s   loc_00DE76   
        move.w  A1, ($FFFFF714).w
        move.w  A1, ($FFFFF718).w
        move.b  #1, ($FFFFF711).w
        rts
loc_00DE90:
        lea     ($FFFFEF80).w, a2
        move.w  (A2)+, d1
        subq.w  #1,d1
        bcs.s   loc_00DEC6
loc_00DE9A:        
        move.w  (A2)+, D0
        beq.s   loc_00DE9A
        move.w  d0, A1
        subq.b  #1, (a1)
        bne.s   loc_00DEC2
        move.b  #6, (a1)
        addq.b  #1, render_flags(a1)
        cmpi.b  #8, render_flags(a1)
        bne.s   loc_00DEC2
        move.w  #$FFFFFFFF, (a1)
        move.w  #0, $FFFFFFFE(a2)
        subq.w  #1, ($FFFFEF80).w
loc_00DEC2:
        dbra    d1, loc_00DE9A
loc_00DEC6:        
        move.w  ($FFFFF712).w, A1
        move.w  ($FFFFEE00).w, D4
        subq.w  #8, D4
        bhi.s   loc_00DEDA
        moveq   #1, D4
        bra.s   loc_00DEDA
loc_00DED6:        
        lea     $0006(A1), A1
loc_00DEDA:
        cmp.w   art_tile(A1), D4
        bhi.s   loc_00DED6
        bra.s   loc_00DEE4
loc_00DEE2:        
        subq.w  #6, A1
loc_00DEE4:
        cmp.w   Checksum_fourcc(A1), D4
        bls.s   loc_00DEE2
        move.w  A1, ($FFFFF712).w
        move.w  ($FFFFF714).w, a2
        addi.w  #$150, D4
        bra.s   loc_00DEFC
loc_00DEF8:        
        lea     $0006(A2), A2
loc_00DEFC:
        cmp.w   art_tile(A2), D4
        bhi.s   loc_00DEF8
        bra.s   loc_00DF06
loc_00DF04:        
        subq.w  #6, a2
loc_00DF06:
        cmp.w   Checksum_fourcc(A2), D4
        bls.s   loc_00DF04
        move.w  A2, ($FFFFF714).w
        tst.w   (Two_player_mode).w
        bne.s   loc_00DF20
        move.w  A1, ($FFFFF716).w
        move.w  A2, ($FFFFF718).w
        rts
loc_00DF20:
        move.w  ($FFFFF716).w, A1
        move.w  ($FFFFEE20).w, D4
        subq.w  #8, D4
        bhi.s   loc_00DF34
        moveq   #1, D4
        bra.s   loc_00DF34
loc_00DF30:        
        lea     $0006(A1), A1
loc_00DF34:
        cmp.w   art_tile(A1), D4
        bhi.s   loc_00DF30
        bra.s   loc_00DF3E
loc_00DF3C:        
        subq.w  #6, A1 
loc_00DF3E:
        cmp.w   Checksum_fourcc(A1), D4
        bls.s   loc_00DF3C
        move.w  A1, ($FFFFF716).w
        move.w  ($FFFFF718).w, a2
        addi.w  #$150, D4
        bra.s   loc_00DF56
loc_00DF52:
        lea     $0006(A2), A2
loc_00DF56:
        cmp.w   art_tile(A2), D4
        bhi.s   loc_00DF52
        bra.s   loc_00DF60
loc_00DF5E:
        subq.w  #6, a2   
loc_00DF60:
        cmp.w   Checksum_fourcc(A2), D4
        bls.s   loc_00DF5E
        move.w  A2, ($FFFFF718).w
        rts
        
;===============================================================================        
TouchRings: ; loc_00DF6C:
        move.w  ($FFFFF712).w, A1
        move.w  ($FFFFF714).w, a2
        cmpa.w  #Object_RAM, A0
        beq.s   loc_00DF82
        move.w  ($FFFFF716).w, A1
        move.w  ($FFFFF718).w, a2
loc_00DF82:
        cmpa.l  A1, a2
        beq     loc_00E01A
        cmpi.w  #$05A, Objoff_30(a0)
        bcc     loc_00E01A
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        subi.w  #8, D2
        moveq   #0,d5
        move.b  y_radius(A0), D5
        subq.b  #3,d5
        sub.w   d5, d3
        cmpi.b  #$39, $001A(a0)
        bne.s   loc_00DFB6
        addi.w  #$00C, d3
        moveq   #$A,d5
loc_00DFB6:
        move.w  #$006, d1
        move.w  #$00C, D6
        move.w  #$010, D4
        add.w   d5,d5
loc_00DFC4:        
        tst.w   (a1)
        bne     loc_00E010
        move.w  art_tile(A1), D0
        sub.w   d1, d0
        sub.w   d2, d0
        bcc.s   loc_00DFDC
        add.w   d6, d0
        bcs.s   loc_00DFE2
        bra     loc_00E010
loc_00DFDC:
        cmp.w   d4, d0
        bhi     loc_00E010
loc_00DFE2:        
        move.w  mappings(A1), D0
        sub.w   d1, d0
        sub.w   d3, d0
        bcc.s   loc_00DFF4
        add.w   d6, d0
        bcs.s   loc_00DFFA
        bra     loc_00E010
loc_00DFF4:
        cmp.w   d5, d0
        bhi     loc_00E010
loc_00DFFA:
        move.w  #$604, (a1)
        bsr     loc_00AD22
        lea     ($FFFFEF82).w, A3
loc_00E006:
        tst.w   (A3)+
        bne.s   loc_00E006
        move.w  A1, -(A3)
        addq.w  #1, ($FFFFEF80).w
loc_00E010:
        lea     $0006(A1), A1
        cmpa.l  A1, a2
        bne     loc_00DFC4
loc_00E01A:
        rts                  
loc_00E01C:
        move.w  ($FFFFF712).w, A0
        move.w  ($FFFFF714).w, A4
        cmpa.l  A0, A4
        bne.s   loc_00E02A
        rts
loc_00E02A:
        lea     ($FFFFEE00).w, A3
loc_00E02E:        
        tst.w   (a0)
        bmi     loc_00E08C
        move.w  art_tile(A0), D3
        sub.w   (A3), D3
        addi.w  #$080, d3
        move.w  mappings(A0), D2
        sub.w   mappings(A3), D2
        addi.w  #8, D2
        bmi.s   loc_00E08C
        cmpi.w  #$0F0, D2
        bge.s   loc_00E08C
        addi.w  #$078, D2
        lea     (loc_00E200), A1
        moveq   #0,d1
        move.b  render_flags(A0), d1
        bne.s   loc_00E068
        move.b  ($FFFFFEC3).w, d1
loc_00E068:
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        move.w  (A1)+, D0
        addi.w  #$26BC, d0
        move.w  d0, (a2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        add.w   d3, d0
        move.w  d0, (a2)+
loc_00E08C:
        lea     $0006(A0), A0
        cmpa.l  A0, A4
        bne     loc_00E02E  
        rts
loc_00E098:
        lea     ($FFFFEE00).w, A3
        move.w  #$078, D6
        move.w  ($FFFFF712).w, A0
        move.w  ($FFFFF714).w, A4
        cmpa.l  A0, A4
        bne.s   loc_00E0C4
        rts
loc_00E0AE:
        lea     ($FFFFEE20).w, A3
        move.w  #$158, D6
        move.w  ($FFFFF716).w, A0
        move.w  ($FFFFF718).w, A4
        cmpa.l  A0, A4        
        bne.s   loc_00E0C4
        rts
loc_00E0C4:
        tst.w   (a0)
        bmi     loc_00E124
        move.w  art_tile(A0), D3
        sub.w   (A3), D3
        addi.w  #$080, d3
        move.w  mappings(A0), D2
        sub.w   mappings(A3), D2
        addi.w  #$088, D2
        bmi.s   loc_00E124
        cmpi.w  #$170, D2
        bge.s   loc_00E124
        add.w   d6, D2
        lea     (loc_00E200), A1
        moveq   #0,d1
        move.b  render_flags(A0), d1
        bne.s   loc_00E0FC
        move.b  ($FFFFFEC3).w, d1
loc_00E0FC:
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.b  (A1)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, (a2)+
        move.b  (A1)+, D4
        move.b  loc_00E130(PC, D4), (A2)+
        addq.b  #1,d5
        move.b  d5, (A2)+
        addq.w  #$2, A1
        move.w  (A1)+, D0
        addi.w  #$235E, d0
        move.w  d0, (a2)+
        move.w  (A1)+, D0
        add.w   d3, d0
        move.w  d0, (a2)+
loc_00E124:        
        lea     $0006(A0), A0
        cmpa.l  A0, A4
        bne     loc_00E0C4
        rts     
loc_00E130:
        dc.b    $00, $00, $01, $01, $04, $04, $05, $05, $08, $08, $09, $09, $0C, $0C, $0D, $0D  
loc_00E140: ; Load Rings routine
        lea     ($FFFFE800).w, A1
        moveq	#0,d0
        move.w  #$17F, d1
loc_00E14A:
        move.l  d0, (A1)+
        dbra    d1, loc_00E14A
        lea     ($FFFFEF80).w, A1
        move.w  #$F, d1
loc_00E158:
        move.l  d0, (A1)+
        dbra    d1, loc_00E158
        moveq   #0,d5
        moveq	#0,d0
        move.w  (Current_Zone).w, d0
        ror.b   #1,d0
        lsr.w   #6, d0
        lea     (Rings_Layout), A1      ; loc_048000
        move.w  $00(A1, d0), D0
        lea     $00(A1, d0), A1
        lea     ($FFFFE806).w, a2
loc_00E17C:        
        move.w  (A1)+, D2
        bmi.s   loc_00E1C4
        move.w  (A1)+, D3
        bmi.s   loc_00E1A4
        move.w  d3, d0
        rol.w   #4, d0
        andi.w  #$007, d0
        andi.w  #$FFF, d3
loc_00E190:        
        move.w  #0, (A2)+
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        addi.w  #$018, D2
        addq.w  #1,d5
        dbra    d0, loc_00E190
        bra.s   loc_00E17C
loc_00E1A4:
        move.w  d3, d0
        rol.w   #4, d0
        andi.w  #$007, d0
        andi.w  #$FFF, d3
loc_00E1B0:        
        move.w  #0, (A2)+
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        addi.w  #$018, d3
        addq.w  #1,d5
        dbra    d0, loc_00E1B0
        bra.s   loc_00E17C
loc_00E1C4:
        move.w  d5, ($FFFFFF40).w
        moveq   #$FFFFFFFF, d0
        move.l  d0, (A2)+
        lea     ($FFFFE802).w, A1
        move.w  #$0FE, d3
loc_00E1D4:
        move.w  d3, D4
        lea     $0006(A1), A2
        move.w  (A1), D0
loc_00E1DC:
        tst.w   (a2)
        beq.s   loc_00E1EE
        cmp.w   (A2), D0
        bls.s   loc_00E1EE
        move.l  (A1), d1
        move.l  (A2), D0
        move.l  d0, (a1)
        move.l  d1, (a2)
        swap.w  D0
loc_00E1EE:
        lea     $0006(A2), A2
        dbra    d4, loc_00E1DC
        lea     $0006(A1), A1
        dbra    d3, loc_00E1D4
        rts
loc_00E200:    
        dc.w    loc_00E210-loc_00E200
        dc.w    loc_00E218-loc_00E200
        dc.w    loc_00E220-loc_00E200
        dc.w    loc_00E228-loc_00E200
        dc.w    loc_00E230-loc_00E200
        dc.w    loc_00E238-loc_00E200
        dc.w    loc_00E240-loc_00E200
        dc.w    loc_00E248-loc_00E200
loc_00E210:
        dc.l    $F8050000, $0000FFF8
loc_00E218:
        dc.l    $F8050004, $0002FFF8
loc_00E220:
        dc.l    $F8010008, $0004FFFC
loc_00E228:
        dc.l    $F8050804, $0802FFF8
loc_00E230:
        dc.l    $F805000A, $0005FFF8
loc_00E238:
        dc.l    $F805180A, $1805FFF8
loc_00E240:
        dc.l    $F805080A, $0805FFF8
loc_00E248: 
        dc.l    $F805100A, $1005FFF8
        
;======================== Load Object List - [ Start ] ========================         
Load_Object_Pos: ; loc_00E250:         
        moveq	#0,d0
        move.b  ($FFFFF76C).w, d0
        move.w  Load_Object_Pos_Index(pc,d0), D0 ; loc_00E25E
        jmp     Load_Object_Pos_Index(pc,d0)     ; loc_00E25E
Load_Object_Pos_Index: ; loc_00E25E:                
        dc.w    Load_Object_Pos_Sub_01-Load_Object_Pos_Index ; loc_00E264
        dc.w    Load_Object_Pos_Sub_02-Load_Object_Pos_Index ; loc_00E310
        dc.w    Load_Object_Pos_Sub_03-Load_Object_Pos_Index ; loc_00E458
Load_Object_Pos_Sub_01: ; loc_00E264:   
        addq.b  #$2, ($FFFFF76C).w
        move.w  (Current_Zone).w, d0
        ror.b   #1,d0
        lsr.w   #6, d0
        lea     (Objects_Layout), A0    ; loc_044000
        move.l  A0, A1
        adda.w  $00(A0, d0), A0
        move.l  A0, ($FFFFF770).w
        move.l  A0, ($FFFFF774).w
        move.l  A0, ($FFFFF778).w
        move.l  A0, ($FFFFF77C).w
        lea     (Object_Respawn_Table).w, a2
        move.w  #$101, (A2)+
        move.w  #$05E, d0
loc_00E298:
        clr.l   (A2)+
        dbra    d0, loc_00E298
        lea     (Object_Respawn_Table).w, a2
        moveq   #0, D2
        move.w  ($FFFFEE00).w, D6
        subi.w  #$080, D6
        bcc.s   loc_00E2B0
        moveq   #0, D6
loc_00E2B0:
        andi.w  #$FF80, D6
        move.l  ($FFFFF770).w, A0
loc_00E2B8:
        cmp.w   (A0), D6
        bls.s   loc_00E2CA
        tst.b   mappings(a0)
        bpl.s   loc_00E2C6
        move.b  (A2), D2
        addq.b  #1, (a2)
loc_00E2C6:
        addq.w  #6, A0
        bra.s   loc_00E2B8
loc_00E2CA:
        move.l  A0, ($FFFFF770).w   
        move.l  A0, ($FFFFF778).w
        move.l  ($FFFFF774).w, A0
        subi.w  #$080, D6
        bcs.s   loc_00E2EE
loc_00E2DC:
        cmp.w   (A0), D6
        bls.s   loc_00E2EE
        tst.b   mappings(a0)
        bpl.s   loc_00E2EA
        addq.b  #1, render_flags(a2)
loc_00E2EA:
        addq.w  #6, A0
        bra.s   loc_00E2DC
loc_00E2EE:
        move.l  A0, ($FFFFF774).w
        move.l  A0, ($FFFFF77C).w
        move.w  #$FFFF, ($FFFFF76E).w
        move.w  #$FFFF, ($FFFFF78C).w
        tst.w   (Two_player_mode).w
        beq.s   Load_Object_Pos_Sub_02  ; loc_00E310
        addq.b  #$2, ($FFFFF76C).w
        bra     loc_00E3DC
Load_Object_Pos_Sub_02: ;loc_00E310:
        move.w  ($FFFFEE00).w, d1
        subi.w  #$080, d1
        andi.w  #$FF80, d1
        move.w  d1, (Camera_X_pos_coarse).w
        lea     (Object_Respawn_Table).w, a2
        moveq   #0, D2
        move.w  ($FFFFEE00).w, D6
        andi.w  #$FF80, D6
        cmp.w   ($FFFFF76E).w, D6
        beq     loc_00E3DA
        bge.s   loc_00E396
        move.w  d6, ($FFFFF76E).w
        move.l  ($FFFFF774).w, A0
        subi.w  #$080, D6
        bcs.s   loc_00E372
loc_00E346:
        cmp.w   $FFFFFFFA(A0), D6
        bge.s   loc_00E372
        subq.w  #6, A0
        tst.b   mappings(a0)
        bpl.s   loc_00E35C
        subq.b  #1, render_flags(a2)
        move.b  render_flags(A2), D2
loc_00E35C:
        bsr     loc_00E6C2
        bne.s   loc_00E366
        subq.w  #6, A0
        bra.s   loc_00E346
loc_00E366:
        tst.b   mappings(a0)
        bpl.s   loc_00E370
        addq.b  #1, render_flags(a2)
loc_00E370:
        addq.w  #6, A0
loc_00E372:        
        move.l  A0, ($FFFFF774).w
        move.l  ($FFFFF770).w, A0
        addi.w  #$300, D6 
loc_00E37E:
        cmp.w   $FFFFFFFA(A0), D6
        bgt.s   loc_00E390
        tst.b   $FFFFFFFE(a0)
        bpl.s   loc_00E38C
        subq.b  #1, (a2)
loc_00E38C:
        subq.w  #6, A0
        bra.s   loc_00E37E
loc_00E390:
        move.l  A0, ($FFFFF770).w
        rts
loc_00E396:
        move.w  d6, ($FFFFF76E).w
        move.l  ($FFFFF770).w, A0
        addi.w  #$280, D6
loc_00E3A2:
        cmp.w   (A0), D6
        bls.s   loc_00E3B6
        tst.b   mappings(a0)
        bpl.s   loc_00E3B0
        move.b  (A2), D2
        addq.b  #1, (a2)
loc_00E3B0:
        bsr     loc_00E6C2
        beq.s   loc_00E3A2
loc_00E3B6:
        move.l  A0, ($FFFFF770).w
        move.l  ($FFFFF774).w, A0
        subi.w  #$300, D6
        bcs.s   loc_00E3D6
loc_00E3C4:
        cmp.w   (A0), D6
        bls.s   loc_00E3D6
        tst.b   mappings(a0)
        bpl.s   loc_00E3D2
        addq.b  #1, render_flags(a2)
loc_00E3D2:
        addq.w  #6, A0
        bra.s   loc_00E3C4
loc_00E3D6:
        move.l  A0, ($FFFFF774).w
loc_00E3DA:
        rts
loc_00E3DC:
        moveq   #$FFFFFFFF, d0
        move.l  d0, ($FFFFF780).w
        move.l  d0, ($FFFFF784).w
        move.l  d0, ($FFFFF788).w
        move.l  d0, ($FFFFF78C).w
        move.w  #0, ($FFFFF76E).w
        move.w  #0, ($FFFFF78C).w
        lea     (Object_Respawn_Table).w, a2
        move.w  (A2), ($FFFFF78E).w
        moveq   #0, D2
        lea     (Object_Respawn_Table).w, a5
        lea     ($FFFFF770).w, A4
        lea     ($FFFFF786).w, A1
        lea     ($FFFFF789).w, a6
        moveq   #$FFFFFFFE, D6
        bsr     loc_00E570
        lea     ($FFFFF786).w, A1
        moveq   #$FFFFFFFF, D6
        bsr     loc_00E570
        lea     ($FFFFF786).w, A1
        moveq   #0, D6
        bsr     loc_00E570
        lea     ($FFFFF78E).w, a5
        lea     ($FFFFF778).w, A4
        lea     ($FFFFF789).w, A1
        lea     ($FFFFF786).w, a6
        moveq   #$FFFFFFFE, D6
        bsr     loc_00E570
        lea     ($FFFFF789).w, A1
        moveq   #$FFFFFFFF, D6
        bsr     loc_00E570
        lea     ($FFFFF789).w, A1
        moveq   #0, D6
        bsr     loc_00E570
Load_Object_Pos_Sub_03: ; loc_00E458:
        move.w  ($FFFFEE00).w, d1
        andi.w  #$FF00, d1
        move.w  d1, (Camera_X_pos_coarse).w
        move.w  ($FFFFEE20).w, d1
        andi.w  #$FF00, d1
        move.w  d1, ($FFFFF7DC).w
        move.b  ($FFFFEE00).w, D6
        andi.w  #$0FF, D6
        move.w  ($FFFFF76E).w, d0
        cmp.w   ($FFFFF76E).w, D6
        beq.s   loc_00E498
        move.w  d6, ($FFFFF76E).w
        lea     (Object_Respawn_Table).w, a5
        lea     ($FFFFF770).w, A4
        lea     ($FFFFF786).w, A1
        lea     ($FFFFF789).w, a6
        bsr.s   loc_00E4C2
loc_00E498:
        move.b  ($FFFFEE20).w, D6
        andi.w  #$0FF, D6
        move.w  ($FFFFF78C).w, d0
        cmp.w   ($FFFFF78C).w, D6
        beq.s   loc_00E4C0
        move.w  d6, ($FFFFF78C).w
        lea     ($FFFFF78E).w, a5
        lea     ($FFFFF778).w, A4
        lea     ($FFFFF789).w, A1
        lea     ($FFFFF786).w, a6
        bsr.s   loc_00E4C2
loc_00E4C0:
        rts
loc_00E4C2:
        lea     (Object_Respawn_Table).w, a2
        moveq   #0, D2
        cmp.w   d0, D6
        beq     loc_00E3DA
        bge     loc_00E570
        move.b  art_tile(A1), D2
        move.b  render_flags(A1), art_tile(a1)
        move.b  (A1), render_flags(a1)
        move.b  d6, (a1)
        cmp.b   (a6), D2
        beq.s   loc_00E4F8
        cmp.b   render_flags(a6), D2
        beq.s   loc_00E4F8
        cmp.b   art_tile(a6), D2
        beq.s   loc_00E4F8
        bsr     loc_00E652
        bra.s   loc_00E4FC
loc_00E4F8:        
        bsr     loc_00E616
loc_00E4FC:
        bsr     loc_00E5F2 
        bne.s   loc_00E520
        move.l  mappings(A4), A0
loc_00E506:
        cmp.b   $FFFFFFFA(A0), D6
        bne.s   loc_00E51A
        tst.b   $FFFFFFFE(a0)
        bpl.s   loc_00E516
        subq.b  #1, render_flags(a5)
loc_00E516:
        subq.w  #6, A0
        bra.s   loc_00E506
loc_00E51A:
        move.l  A0, mappings(a4)
        bra.s   loc_00E556
loc_00E520:
        move.l  mappings(A4), A0
        move.b  d6, (a1)
loc_00E526:
        cmp.b   $FFFFFFFA(A0), D6
        bne.s   loc_00E552
        subq.w  #6, A0
        tst.b   mappings(a0)
        bpl.s   loc_00E53C
        subq.b  #1, render_flags(a5)
        move.b  render_flags(a5), D2
loc_00E53C:
        bsr     loc_00E712
        bne.s   loc_00E546
        subq.w  #6, A0
        bra.s   loc_00E526
loc_00E546:
        tst.b   mappings(a0)
        bpl.s   loc_00E550
        addq.b  #1, render_flags(a5)
loc_00E550:
        addq.w  #6, A0
loc_00E552:
        move.l  A0, mappings(a4)
loc_00E556:
        move.l  (A4), A0
        addq.w  #3, D6
loc_00E55A:
        cmp.b   $FFFFFFFA(A0), D6
        bne.s   loc_00E56C
        tst.b   $FFFFFFFE(a0)
        bpl.s   loc_00E568
        subq.b  #1, (a5)
loc_00E568:
        subq.w  #6, A0
        bra.s   loc_00E55A
loc_00E56C:
        move.l  A0, (a4)
        rts              
loc_00E570:
        addq.w  #$2, D6
        move.b  (A1), D2
        move.b  render_flags(A1), (a1)
        move.b  art_tile(A1), render_flags(a1)
        move.b  d6, art_tile(a1)
        cmp.b   (a6), D2
        beq.s   loc_00E598
        cmp.b   render_flags(a6), D2
        beq.s   loc_00E598
        cmp.b   art_tile(a6), D2
        beq.s   loc_00E598
        bsr     loc_00E652
        bra.s   loc_00E59C
loc_00E598:
        bsr     loc_00E616
loc_00E59C:
        bsr     loc_00E5F2
        bne.s   loc_00E5B8
        move.l  (A4), A0
loc_00E5A4:
        cmp.b   (A0), D6
        bne.s   loc_00E5B4
        tst.b   mappings(a0)
        bpl.s   loc_00E5B0
        addq.b  #1, (a5)
loc_00E5B0:
        addq.w  #6, A0
        bra.s   loc_00E5A4
loc_00E5B4:
        move.l  A0, (a4)
        bra.s   loc_00E5D2
loc_00E5B8:
        move.l  (A4), A0
        move.b  d6, (a1)
loc_00E5BC:
        cmp.b   (A0), D6
        bne.s   loc_00E5D0
        tst.b   mappings(a0)
        bpl.s   loc_00E5CA
        move.b  (a5), D2
        addq.b  #1, (a5)
loc_00E5CA:
        bsr     loc_00E712
        beq.s   loc_00E5BC
loc_00E5D0:
        move.l  A0, (a4)    
loc_00E5D2:
        move.l  mappings(A4), A0
        subq.w  #3, D6
        bcs.s   loc_00E5EC
loc_00E5DA:
        cmp.b   (A0), D6
        bne.s   loc_00E5EC
        tst.b   mappings(a0)
        bpl.s   loc_00E5E8
        addq.b  #1, render_flags(a5)
loc_00E5E8:
        addq.w  #6, A0
        bra.s   loc_00E5DA
loc_00E5EC:
        move.l  A0, mappings(a4)   
        rts  
loc_00E5F2:
        move.l  A1, -(A7)
        lea     ($FFFFF780).w, A1
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        cmp.b   (A1)+, D6
        beq.s   loc_00E612
        moveq   #1,d0
loc_00E612:
        move.l  (A7)+, A1
        rts
loc_00E616:        
        lea     ($FFFFF780).w, A1
        lea     ($FFFFBE00).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E
        lea     ($FFFFC100).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E
        lea     ($FFFFC400).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E
        lea     ($FFFFC700).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E
        lea     ($FFFFCA00).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E
        lea     ($FFFFCD00).w, A3
        tst.b   (A1)+
        bmi.s   loc_00E64E         
        nop
        nop
loc_00E64E:
        subq.w  #1, A1
        rts    
loc_00E652:
        lea     ($FFFFF780).w, A1
        lea     ($FFFFBE00).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        lea     ($FFFFC100).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        lea     ($FFFFC400).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        lea     ($FFFFC700).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        lea     ($FFFFCA00).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        lea     ($FFFFCD00).w, A3
        cmp.b   (A1)+, D2
        beq.s   loc_00E68A
        nop
        nop
loc_00E68A:
        move.b  #$FF, -(A1)
        movem.l A1/A3, -(A7)
        moveq   #0,d1
        moveq   #$B, D2
loc_00E696:
        tst.b   (a3)
        beq.s   loc_00E6B2
        move.l  A3, A1
        moveq	#0,d0
        move.b  $0023(A1), D0
        beq.s   loc_00E6AA
        bclr    #$7, $02(A2, d0)
loc_00E6AA:
        moveq   #$F, d0
loc_00E6AC:
        move.l  d1, (A1)+
        dbra    d0, loc_00E6AC
loc_00E6B2:    
        lea     $0040(A3), A3
        dbra    D2, loc_00E696 
        moveq   #0, D2
        movem.l (A7)+, A1/A3
        rts       
loc_00E6C2:
        tst.b   mappings(a0)
        bpl.s   loc_00E6D6
        bset    #$7, $02(A2, D2)
        beq.s   loc_00E6D6
        addq.w  #6, A0
        moveq	#0,d0
        rts
loc_00E6D6:
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00E710
        move.w  (A0)+, x_pos(a1)
        move.w  (A0)+, D0
        move.w  d0, d1
        andi.w  #$FFF, d0
        move.w  d0, y_pos(a1)
        rol.w   #$2, d1
        andi.b  #3, d1
        move.b  d1, render_flags(a1)
        move.b  d1, status(a1)
        move.b  (A0)+, D0
        bpl.s   loc_00E706
        andi.b  #$7F, d0
        move.b  D2, $0023(a1)
loc_00E706:
        move.b  d0, 0(a1)
        move.b  (A0)+, subtype(a1)
        moveq	#0,d0
loc_00E710:
        rts    
loc_00E712:
        tst.b   mappings(a0)
        bpl.s   loc_00E726
        bset    #$7, $02(A2, D2)
        beq.s   loc_00E726
        addq.w  #6, A0
        moveq	#0,d0
        rts
loc_00E726:
        btst    #5,art_tile(a0)
        beq.s   loc_00E736
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00E770
        bra.s   loc_00E73C
loc_00E736:
        bsr     loc_00E7A4
        bne.s   loc_00E770
loc_00E73C:
        move.w  (A0)+, x_pos(a1) 
        move.w  (A0)+, D0
        move.w  d0, d1
        andi.w  #$FFF, d0
        move.w  d0, y_pos(a1)
        rol.w   #$2, d1
        andi.b  #3, d1
        move.b  d1, render_flags(a1)
        move.b  d1, status(a1)
        move.b  (A0)+, D0
        bpl.s   loc_00E766
        andi.b  #$7F, d0
        move.b  D2, $0023(a1)
loc_00E766:
        move.b  d0, 0(a1)
        move.b  (A0)+, subtype(a1)
        moveq	#0,d0
loc_00E770:
        rts
;========================= Load Object List -  =========================   
               
;=============================================================================== 
; Beginning of Sub SingleObjectLoad        
;===============================================================================        
SingleObjectLoad: ; loc_00E772:        
        lea     ($FFFFB800).w, A1
        move.w  #$05F, d0
loc_00E77A:
        tst.b   (a1)
        beq.s   loc_00E786
        lea     $0040(A1), A1
        dbra    d0, loc_00E77A
loc_00E786:
        rts     
;=============================================================================== 
; End of Sub SingleObjectLoad                 
;===============================================================================          
                                            
;=============================================================================== 
; Beginning of Sub JmpTo_SingleObjLoad2              
;==============================================================================         
JmpTo_SingleObjLoad2: ;loc_00E788:
        move.l  A0, A1
        move.w  #$D000, d0
        sub.w   A0, d0
        lsr.w   #6, d0
        subq.w  #1,d0
        bcs.s   loc_00E7A2
loc_00E796:
        tst.b   (a1)
        beq.s   loc_00E7A2
        lea     $0040(A1), A1
        dbra    d0, loc_00E796
loc_00E7A2:
        rts   
;=============================================================================== 
; End of Sub JmpTo_SingleObjLoad2                 
;===============================================================================    
             
loc_00E7A4: ; Load Object List Subroutine - Start 
        move.l  A3, A1
        move.w  #$00B, d0
loc_00E7AA: 
        tst.b   (a1)
        beq.s   loc_00E7B6
        lea     $0040(A1), A1
        dbra    d0, loc_00E7AA
loc_00E7B6:
        rts ; Load Object List Subroutine - End 
        
;=============================================================================== 
; Object 0x41 - Springs 
;===============================================================================             
Obj41_Springs: ; loc_00E7B8:     
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00E7E8(pc,d0), d1
        jsr     loc_00E7E8(pc,d1)
        tst.w   (Two_player_mode).w
        beq.s   loc_00E7D0
        bra     DisplaySprite           ; loc_00D3C2
loc_00E7D0:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00E7E8:
        dc.w    loc_00E7F4-loc_00E7E8
        dc.w    loc_00E8CC-loc_00E7E8
        dc.w    loc_00E9BE-loc_00E7E8
        dc.w    loc_00EBD0-loc_00E7E8
        dc.w    loc_00ECBC-loc_00E7E8
        dc.w    loc_00EDF2-loc_00E7E8
loc_00E7F4:
        addq.b  #2,routine(a0)
        move.l  #Spring_Mappings,mappings(a0) ; loc_00EF70
        move.w  #$45C,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$00E, d0
        move.w  loc_00E82A(pc,d0), D0
        jmp     loc_00E82A(pc,d0)
loc_00E82A:
        dc.w    loc_00E8A0-loc_00E82A
        dc.w    loc_00E834-loc_00E82A
        dc.w    loc_00E854-loc_00E82A
        dc.w    loc_00E868-loc_00E82A
        dc.w    loc_00E882-loc_00E82A            
loc_00E834:
        move.b  #4,routine(a0)
        move.b  #$2, $001C(a0)
        move.b  #3, $001A(a0)
        move.w  #$470,art_tile(a0)
        move.b  #8,width_pixels(a0)
        bra.s   loc_00E8A0
loc_00E854:        
        move.b  #6, $0024(a0)
        move.b  #6, $001A(a0)
        bset    #1, status(a0)
        bra.s   loc_00E8A0
loc_00E868:        
        move.b  #8, $0024(a0)
        move.b  #4, $001C(a0)
        move.b  #$7, $001A(a0)
        move.w  #$43C,art_tile(a0)          
        bra.s   loc_00E8A0
loc_00E882:        
        move.b  #$A, $0024(a0)
        move.b  #4, $001C(a0)
        move.b  #$A, $001A(a0)
        move.w  #$43C,art_tile(a0)
        bset    #1, status(a0)
loc_00E8A0:
        move.b  subtype(A0), D0
        andi.w  #$002, d0
        move.w  loc_00E8C8(pc,d0), Objoff_30(a0)
        btst    #1,d0
        beq.s   loc_00E8C2
        bset    #5,art_tile(a0)
        move.l  #loc_00EF86,mappings(a0)
loc_00E8C2:
        bsr     Adjust2PArtPointer     ; loc_00DC30
        rts
loc_00E8C8:
        dc.w    $F000, $F600           
loc_00E8CC:
        move.w  #$01B, d1
        move.w  #8, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_00F510
        btst    #3, status(a0)
        beq.s   loc_00E8F4
        bsr.s   loc_00E918
loc_00E8F4:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_00F510
        btst    #4, status(a0)
        beq.s   loc_00E90C
        bsr.s   loc_00E918
loc_00E90C:
        lea     (loc_00EF36), A1
        bra     AnimateSprite           ; loc_00D412
        rts
loc_00E918:
        move.w  #$100, $001C(a0)
        addq.w  #8,  y_pos(a1)
        move.w  Objoff_30(A0), $0012(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        bpl.s   loc_00E94C
        move.w  #0,x_vel(a1)
loc_00E94C:
        btst    #0, d0
        beq.s   loc_00E98C
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        btst    #1,d0
        bne.s   loc_00E97C
        move.b  #1, $002C(a1)
loc_00E97C:
        btst    #0, status(a1)
        beq.s   loc_00E98C
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_00E98C:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_00E9A2
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_00E9A2:
        cmpi.b  #8,d0
        bne.s   loc_00E9B4
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_00E9B4:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6    
loc_00E9BE:
        move.w  #$013, d1
        move.w  #$00E, D2
        move.w  #$F, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_00F510
        btst    #5, status(a0)
        beq.s   loc_00E9FE
        move.b  status(a0), d1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcs.s   loc_00E9F6
        eori.b  #1,d1
loc_00E9F6:
        andi.b  #1,d1
        bne.s   loc_00E9FE
        bsr.s   loc_00EA3E
loc_00E9FE:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_00F510
        btst    #6, status(a0)
        beq.s   loc_00EA2E
        move.b  status(a0), d1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcs.s   loc_00EA26
        eori.b  #1,d1
loc_00EA26:
        andi.b  #1,d1
        bne.s   loc_00EA2E
        bsr.s   loc_00EA3E
loc_00EA2E:
        bsr     loc_00EB16
        lea     (loc_00EF36), A1
        bra     AnimateSprite           ; loc_00D412
        rts
loc_00EA3E:
        move.w  #$300, $001C(a0)
        move.w  Objoff_30(A0),x_vel(a1)
        addq.w  #8,  x_pos(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_00EA6C
        bclr    #0, status(a1)
        subi.w  #$010, x_pos(a1)
        neg.w  x_vel(a1)
loc_00EA6C:
        move.w  #$F, $002E(a1)
        move.w x_vel(A1), $14(a1)
        btst    #$2, status(a1)
        bne.s   loc_00EA86
        move.b  #0, $001C(a1)
loc_00EA86:
        move.b  subtype(A0), D0
        bpl.s   loc_00EA92
        move.w  #0, $0012(a1)
loc_00EA92:
        btst    #0, d0
        beq.s   loc_00EAD2
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0
        bne.s   loc_00EAC2
        move.b  #3, $002C(a1)
loc_00EAC2:
        btst    #0, status(a1)
        beq.s   loc_00EAD2
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_00EAD2:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_00EAE8
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_00EAE8:
        cmpi.b  #8,d0
        bne.s   loc_00EAFA
        move.b  #$E, Objoff_3E(a1)   
        move.b  #$F, Objoff_3F(a1)
loc_00EAFA:
        bclr    #5, status(a0)
        bclr    #6, status(a0)
        bclr    #5, status(a1)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6  
loc_00EB16:
        cmpi.b  #3, $001C(a0)
        beq     loc_00EBCE
        move.w  x_pos(a0), D0
        move.w  d0, d1
        addi.w  #$028, d1
        btst    #0, status(a0)
        beq.s   loc_00EB38
        move.w  d0, d1
        subi.w  #$028, d0
loc_00EB38:
        move.w  y_pos(a0), D2
        move.w  D2, d3
        subi.w  #$018, D2
        addi.w  #$018, d3
        lea     (MainCharacter).w, A1
        btst    #1, status(a1)
        bne.s   loc_00EB8C
        move.w  $14(A1), D4
        btst    #0, status(a0)
        beq.s   loc_00EB60
        neg.w   D4
loc_00EB60:
        tst.w   D4
        bmi.s   loc_00EB8C
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_00EB8C
        cmp.w   d1, D4
        bcc     loc_00EB8C
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_00EB8C
        cmp.w   d3, D4
        bcc     loc_00EB8C
        move.w  d0, -(A7)
        bsr     loc_00EA3E
        move.w  (A7)+, D0
loc_00EB8C:
        lea     (Sidekick).w, A1
        btst    #1, status(a1)
        bne.s   loc_00EBCE
        move.w  $14(A1), D4
        btst    #0, status(a0)
        beq.s   loc_00EBA6
        neg.w   D4
loc_00EBA6:
        tst.w   D4
        bmi.s   loc_00EBCE
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_00EBCE
        cmp.w   d1, D4
        bcc     loc_00EBCE
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_00EBCE
        cmp.w   d3, D4
        bcc     loc_00EBCE
        bsr     loc_00EA3E
loc_00EBCE:
        rts    
loc_00EBD0:
        move.w  #$01B, d1
        move.w  #8, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_00F510
        cmpi.w  #$FFFFFFFE, D4
        bne.s   loc_00EBF6
        bsr.s   loc_00EC18
loc_00EBF6:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_00F510
        cmpi.w  #$FFFFFFFE, D4
        bne.s   loc_00EC0C
        bsr.s   loc_00EC18
loc_00EC0C:
        lea     (loc_00EF36), A1
        bra     AnimateSprite           ; loc_00D412
        rts
loc_00EC18:
        move.w  #$100, $001C(a0)
        subq.w  #8, y_pos(a1)
        move.w  Objoff_30(A0), $0012(a1)
        neg.w   $0012(a1)
        move.b  subtype(A0), D0
        bpl.s   loc_00EC38
        move.w  #0,x_vel(a1)
loc_00EC38:
        btst    #0, d0
        beq.s   loc_00EC78
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        btst    #1,d0
        bne.s   loc_00EC68
        move.b  #1, $002C(a1)
loc_00EC68:
        btst    #0, status(a1)
        beq.s   loc_00EC78
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_00EC78:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_00EC8E
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_00EC8E:
        cmpi.b  #8,d0
        bne.s   loc_00ECA0
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_00ECA0:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6   
loc_00ECBC:
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  x_pos(a0), D4
        lea     loc_00EEFE(PC), A2
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_00F562
        btst    #3, status(a0)
        beq.s   loc_00ECE4
        bsr.s   loc_00ED08
loc_00ECE4:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_00F562
        btst    #4, status(a0)
        beq.s   loc_00ECFC
        bsr.s   loc_00ED08
loc_00ECFC:
        lea     (loc_00EF36), A1
        bra     AnimateSprite           ; loc_00D412
        rts
loc_00ED08:
        btst    #0, status(a0)
        bne.s   loc_00ED1E           
        move.w  x_pos(a0), D0
        subq.w  #4, d0
        cmp.w   x_pos(A1), D0
        bcs.s   loc_00ED2C
        rts
loc_00ED1E:
        move.w  x_pos(a0), D0
        addq.w  #4, d0
        cmp.w   x_pos(A1), D0
        bcc.s   loc_00ED2C
        rts
loc_00ED2C:
        move.w  #$500, $001C(a0)
        move.w  Objoff_30(A0), $0012(a1)
        move.w  Objoff_30(A0),x_vel(a1)
        addq.w  #6, y_pos(a1)
        addq.w  #6, x_pos(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_00ED64
        bclr    #0, status(a1)
        subi.w  #$00C, x_pos(a1)
        neg.w  x_vel(a1)
loc_00ED64:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        btst    #0, d0
        beq.s   loc_00EDC0
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0
        bne.s   loc_00EDB0
        move.b  #3, $002C(a1)
loc_00EDB0:
        btst    #0, status(a1)
        beq.s   loc_00EDC0
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_00EDC0:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_00EDD6
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_00EDD6:
        cmpi.b  #8,d0
        bne.s   loc_00EDE8
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_00EDE8:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6     
loc_00EDF2:
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  x_pos(a0), D4
        lea     loc_00EF1A(PC), A2
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_00F562
        cmpi.w  #$FFFFFFFE, D4
        bne.s   loc_00EE18
        bsr.s   loc_00EE3A
loc_00EE18:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_00F562
        cmpi.w  #$FFFFFFFE, D4
        bne.s   loc_00EE2E
        bsr.s   loc_00EE3A
loc_00EE2E:
        lea     (loc_00EF36), A1
        bra     AnimateSprite           ; loc_00D412
        rts
loc_00EE3A:
        move.w  #$500, $001C(a0)
        move.w  Objoff_30(A0), $0012(a1)
        neg.w   $0012(a1)
        move.w  Objoff_30(A0),x_vel(a1)
        subq.w  #6, y_pos(a1)
        addq.w  #6, x_pos(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_00EE76
        bclr    #0, status(a1)
        subi.w  #$00C, x_pos(a1)
        neg.w  x_vel(a1)
loc_00EE76:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        btst    #0, d0
        beq.s   loc_00EECC
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0 
        bne.s   loc_00EEBC
        move.b  #3, $002C(a1)
loc_00EEBC:
        btst    #0, status(a1)
        beq.s   loc_00EECC
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_00EECC:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_00EEE2
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_00EEE2:
        cmpi.b  #8,d0
        bne.s   loc_00EEF4
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_00EEF4:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6 
loc_00EEFE:   
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $0E, $0C, $0A, $08
        dc.b    $06, $04, $02, $00, $FE, $FC, $FC, $FC, $FC, $FC, $FC, $FC
loc_00EF1A:        
        dc.b    $F4, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0, $F2, $F4, $F6, $F8
        dc.b    $FA, $FC, $FE, $00, $02, $04, $04, $04, $04, $04, $04, $04
loc_00EF36:
        dc.b    $00, $0C, $00, $0F, $00, $1B, $00, $1E, $00, $2A, $00, $2D, $0F, $00, $FF, $00
        dc.b    $01, $00, $00, $02, $02, $02, $02, $02, $02, $FD, $00, $0F, $03, $FF, $00, $04
        dc.b    $03, $03, $05, $05, $05, $05, $05, $05, $FD, $02, $0F, $07, $FF, $00, $08, $07
        dc.b    $07, $09, $09, $09, $09, $09, $09, $FD, $04, $00
Spring_Mappings:
loc_00EF70:
        dc.w    loc_00EF9C-loc_00EF70
        dc.w    loc_00EFAE-loc_00EF70
        dc.w    loc_00EFB8-loc_00EF70
        dc.w    loc_00EFCA-loc_00EF70
        dc.w    loc_00EFDC-loc_00EF70
        dc.w    loc_00EFE6-loc_00EF70
        dc.w    loc_00EFF8-loc_00EF70
        dc.w    loc_00F00A-loc_00EF70
        dc.w    loc_00F02C-loc_00EF70
        dc.w    loc_00F046-loc_00EF70
        dc.w    loc_00F068-loc_00EF70
loc_00EF86:
        dc.w    loc_00EF9C-loc_00EF86
        dc.w    loc_00EFAE-loc_00EF86
        dc.w    loc_00EFB8-loc_00EF86
        dc.w    loc_00EFCA-loc_00EF86
        dc.w    loc_00EFDC-loc_00EF86
        dc.w    loc_00EFE6-loc_00EF86
        dc.w    loc_00EFF8-loc_00EF86
        dc.w    loc_00F08A-loc_00EF86
        dc.w    loc_00F0AC-loc_00EF86
        dc.w    loc_00F0C6-loc_00EF86
        dc.w    loc_00F0E8-loc_00EF86         
loc_00EF9C:
        dc.w    $0002
        dc.l    $F00D0000, $0000FFF0, $00050008, $0004FFF8
loc_00EFAE:
        dc.w    $0001
        dc.l    $F80D0000, $0000FFF0
loc_00EFB8:
        dc.w    $0002
        dc.l    $E00D0000, $0000FFF0, $F007000C, $0006FFF8
loc_00EFCA:
        dc.w    $0002
        dc.l    $F0030000, $00000000, $F8010004, $0002FFF8
loc_00EFDC:
        dc.w    $0001
        dc.l    $F0030000, $0000FFF8
loc_00EFE6:
        dc.w    $0002
        dc.l    $F0030000, $00000010, $F8090006, $0003FFF8
loc_00EFF8:
        dc.w    $0002
        dc.l    $000D1000, $1000FFF0, $F0051008, $1004FFF8
loc_00F00A:
        dc.w    $0004
        dc.l    $F00D0000, $0000FFF0, $00050008, $00040000
        dc.l    $FB05000C, $0006FFF6, $0005201C, $200EFFF0
loc_00F02C:
        dc.w    $0003
        dc.l    $F60D0000, $0000FFEA, $06050008, $0004FFFA
        dc.l    $0005201C, $200EFFF0
loc_00F046:
        dc.w    $0004
        dc.l    $E60D0000, $0000FFFB, $F6050008, $0004000B
        dc.l    $F30B0010, $0008FFF6, $0005201C, $200EFFF0
loc_00F068:
        dc.w    $0004
        dc.l    $000D1000, $1000FFF0, $F0051008, $10040000
        dc.l    $F505100C, $1006FFF6, $F005301C, $300EFFF0  
loc_00F08A:
        dc.w    $0004
        dc.l    $F00D0000, $0000FFF0, $00050008, $00040000
        dc.l    $FB05000C, $0006FFF6, $0005001C, $000EFFF0
loc_00F0AC:
        dc.w    $0003
        dc.l    $F60D0000, $0000FFEA, $06050008, $0004FFFA
        dc.l    $0005001C, $000EFFF0
loc_00F0C6:
        dc.w    $0004
        dc.l    $E60D0000, $0000FFFB, $F6050008, $0004000B
        dc.l    $F30B0010, $0008FFF6, $0005001C, $000EFFF0
loc_00F0E8:
        dc.w    $0004
        dc.l    $000D1000, $1000FFF0, $F0051008, $10040000
        dc.l    $F505100C, $1006FFF6, $F005101C, $100EFFF0   
;=============================================================================== 
; Object 0x41 - Springs 
;===============================================================================   
        nop                     ; Filler  
;=============================================================================== 
; Object 0x44
;===============================================================================          
Obj44: ; loc_00F10C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00F11A(pc,d0), d1
        jmp     loc_00F11A(pc,d1)
loc_00F11A:
        dc.w    loc_00F120-loc_00F11A
        dc.w    loc_00F15C-loc_00F11A
        dc.w    loc_00F170-loc_00F11A
loc_00F120:
        addq.b  #2,routine(a0)
        move.l  #loc_00F188,mappings(a0)
        move.w  #$434C,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #8,width_pixels(a0)
        move.b  #6, $0018(a0)
        move.b  subtype(A0), $001A(a0)
        bclr    #4, $001A(a0)
        beq.s   loc_00F15C
        addq.b  #2,routine(a0)
        bra.s   loc_00F170
loc_00F15C:
        move.w  #$013, d1
        move.w  #$028, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
loc_00F170:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00F188:
        dc.w    loc_00F18E-loc_00F188
        dc.w    loc_00F1B0-loc_00F188
        dc.w    loc_00F1D2-loc_00F188
loc_00F18E:
        dc.w    $0004
        dc.l    $E0050004, $0002FFF8, $F0050008, $0004FFF8
        dc.l    $00050008, $0004FFF8, $10050008, $0004FFF8
loc_00F1B0:
        dc.w    $0004
        dc.l    $E0050008, $0004FFF8, $F0050008, $0004FFF8
        dc.l    $00050008, $0004FFF8, $10050008, $0004FFF8
loc_00F1D2:
        dc.w    $0004
        dc.l    $E0050000, $0000FFF8, $F0050000, $0000FFF8
        dc.l    $00050000, $0000FFF8, $10050000, $0000FFF8            
;=============================================================================== 
; Object 0x44
;===============================================================================          
        
;=============================================================================== 
; Object 0x0D - End Panel 
;===============================================================================             
Obj0D_End_Panel: ; loc_00F1F4:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_00F224(pc,d0), d1
        jsr     loc_00F224(pc,d1)
        lea     (loc_00F3E4), A1
        bsr     AnimateSprite           ; loc_00D412
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_00F224:
        dc.w    End_Panel_Sub_01-loc_00F224 ; loc_00F22E
        dc.w    End_Panel_Sub_02-loc_00F224 ; loc_00F256
        dc.w    End_Panel_Sub_03-loc_00F224 ; loc_00F280
        dc.w    End_Panel_Sub_04-loc_00F224 ; loc_00F31C
        dc.w    End_Panel_Sub_05-loc_00F224 ; loc_00F3E2
End_Panel_Sub_01: ; loc_00F22E:
        addq.b  #2,routine(a0)
        move.l  #End_Panel_Mappings,mappings(a0) ; loc_00F40E
        move.w  #$434,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #4, $0018(a0)
End_Panel_Sub_02: ; loc_00F256:
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        bcs.s   loc_00F27E
        cmpi.w  #$20, d0
        bcc.s   loc_00F27E
        move.w  #$0CF, d0
        jsr     (Play_Music)            ; loc_0014C0
        clr.b   (Update_HUD_timer).w
        move.w  ($FFFFEECA).w, ($FFFFEEC8).w
        addq.b  #2,routine(a0)
loc_00F27E:
        rts
End_Panel_Sub_03: ; loc_00F280:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_00F29C
        move.w  #$03C, Objoff_30(a0)
        addq.b  #1, $001C(a0)
        cmpi.b  #3, $001C(a0)
        bne.s   loc_00F29C
        addq.b  #2,routine(a0)
loc_00F29C:
        subq.w  #1, $0032(a0)
        bpl.s   loc_00F30A
        move.w  #$00B, $0032(a0)
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        addq.b  #$2, Objoff_34(a0)
        andi.b  #$E, Objoff_34(a0)
        lea     loc_00F30C(pc,d0), A2
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_00F30A
        move.b  #$25, 0(a1)
        move.b  #6, $0024(a1)
        move.b  (A2)+, D0
        ext.w   D0
        add.w   x_pos(a0), D0
        move.w  d0, x_pos(a1)
        move.b  (A2)+, D0
        ext.w   D0
        add.w   y_pos(a0), D0
        move.w  d0, y_pos(a1)
        move.l  #Rings_Mappings, mappings(a1) ; loc_00B036
        move.w  #$27B2, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #4, render_flags(a1)
        move.b  #$2, $0018(a1)
        move.b  #8, $0019(a1)
loc_00F30A:
        rts
loc_00F30C: 
        dc.b    $E8, $F0, $08, $08, $F0, $00, $18, $F8, $00, $F8, $10, $00, $E8, $08, $18, $10
End_Panel_Sub_04: ; loc_00F31C:
        tst.w   (Debug_placement_mode).w  
        bne     loc_00F3B6
        btst    #1, ($FFFFB022).w
        bne.s   loc_00F338
        move.b  #1, ($FFFFF7CC).w
        move.w  #$800, ($FFFFF602).w
loc_00F338:
        tst.b   (MainCharacter).w
        beq.s   loc_00F34E
        move.w  (MainCharacter+x_pos).w, d0
        move.w  ($FFFFEECA).w, d1
        addi.w  #$128, d1
        cmp.w   d1, d0
        bcs.s   loc_00F3B6
loc_00F34E:
        addq.b  #2,routine(a0)
loc_00F352:        
        tst.b   ($FFFFB5C0).w
        bne.s   loc_00F3B6
        move.w  ($FFFFEECA).w, ($FFFFEEC8).w
        clr.b   ($FFFFFE2D).w
        clr.b   (Update_HUD_timer).w
        move.b  #$3A, ($FFFFB5C0).w
        moveq   #$26, d0
        jsr     LoadPLC2        ; loc_00176E
        move.b  #1, ($FFFFF7D6).w
        moveq	#0,d0
        move.b  (Timer_minute).w, d0
        mulu.w  #$03C, d0
        moveq   #0,d1
        move.b  (Timer_second).w, d1
        add.w   d1, d0
        divu.w  #$F, d0
        moveq   #$14, d1
        cmp.w   d1, d0
        bcs.s   loc_00F398
        move.w  d1, d0
loc_00F398:
        add.w   d0, d0
        move.w  loc_00F3B8(pc,d0), ($FFFFF7D2).w
        move.w  (Ring_count).w, d0
        mulu.w  #$00A, d0
        move.w  d0, ($FFFFF7D4).w
        move.w  #$09A, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_00F3B6:
        rts
loc_00F3B8:
        dc.w    $1388, $1388, $03E8, $01F4, $0190, $0190, $012C, $012C
        dc.w    $00C8, $00C8, $00C8, $00C8, $0064, $0064, $0064, $0064
        dc.w    $0032, $0032, $0032, $0032, $0000
End_Panel_Sub_05: ; loc_00F3E2:
        rts
loc_00F3E4:
        dc.w    loc_00F3EC-loc_00F3E4
        dc.w    loc_00F3EF-loc_00F3E4
        dc.w    loc_00F3FD-loc_00F3E4
        dc.w    loc_00F40B-loc_00F3E4
loc_00F3EC:
        dc.b    $0F, $02, $FF
loc_00F3EF:
        dc.b    $01, $02, $03, $04, $05, $01, $03, $04, $05, $00, $03, $04, $05, $FF
loc_00F3FD:
        dc.b    $01, $02, $03, $04, $05, $01, $03, $04, $05, $00, $03, $04, $05, $FF
loc_00F40B:
        dc.b    $0F, $00, $FF
End_Panel_Mappings:               
loc_00F40E:        
        dc.w    loc_00F41A-loc_00F40E
        dc.w    loc_00F434-loc_00F40E
        dc.w    loc_00F44E-loc_00F40E
        dc.w    loc_00F468-loc_00F40E
        dc.w    loc_00F47A-loc_00F40E
        dc.w    loc_00F48C-loc_00F40E
loc_00F41A:
        dc.w    $0003
        dc.l    $F00B0000, $0000FFE8, $F00B000C, $00060000
        dc.l    $10010050, $0028FFFC
loc_00F434:
        dc.w    $0003
        dc.l    $F00B0018, $000CFFE8, $F00B0024, $00120000
        dc.l    $10010050, $0028FFFC
loc_00F44E:
        dc.w    $0003
        dc.l    $F00B0030, $0018FFE8, $F00B0830, $08180000
        dc.l    $10010050, $0028FFFC
loc_00F468:
        dc.w    $0002
        dc.l    $F00F003C, $001EFFF0, $10010050, $0028FFFC
loc_00F47A:
        dc.w    $0002
        dc.l    $F003004C, $0026FFFC, $10010050, $0028FFFC
loc_00F48C:
        dc.w    $0002
        dc.l    $F00F083C, $081EFFF0, $10010050, $0028FFFC                  
;=============================================================================== 
; Object 0x0D - End Panel 
; 
;===============================================================================   
        nop                     ; Filler
;=============================================================================== 
; Beginning of Sub SolidObject
                 
;===============================================================================        
SolidObject: ; loc_00F4A0:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F4BE
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        tst.b   render_flags(a1)
        bpl     loc_00F4F8
        addq.b  #1, D6
loc_00F4BE:
        btst    d6, status(a0)
        beq     loc_00F752
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00F4E2
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F4E2
        cmp.w   d2, d0
        bcs.s   loc_00F4F0
loc_00F4E2:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00F4F0:
        move.w  d4, D2
        bsr     loc_00F8E4
        moveq   #0, D4
loc_00F4F8:        
        rts        
loc_00F4FA:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F510
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F510:    
        btst    d6, status(a0)
        beq     loc_00F75A
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00F534
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F534
        cmp.w   d2, d0        
        bcs.s   loc_00F542
loc_00F534:
        bclr    #3, status(a1)
        bclr    d6, status(a0) 
        moveq   #0, D4
        rts
loc_00F542:
        move.w  d4, D2
        bsr     loc_00F8E4
        moveq   #0, D4
        rts
loc_00F54C:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F562
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F562:
        btst    d6, status(a0)
        beq     loc_00F698
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00F586
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F586
        cmp.w   d2, d0
        bcs.s   loc_00F594
loc_00F586:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00F594:
        move.w  d4, D2
        bsr     loc_00F91E
        moveq   #0, D4
        rts

loc_00F59E:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F5B4
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F5B4:
        btst    d6, status(a0)
        beq     loc_00F6F2
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00F5D8
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F5D8
        cmp.w   d2, d0
        bcs.s   loc_00F5E6
loc_00F5D8:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00F5E6:
        move.w  d4, D2
        bsr     loc_00F960
        moveq   #0, D4
        rts     
loc_00F5F0:         
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F606
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F606:
        btst    d6, status(a0)
        beq     loc_00F656
        btst    #1, status(a1)
        bne.s   loc_00F628
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F628
        add.w   d1, d1
        cmp.w   d1, d0
        bcs.s   loc_00F636
loc_00F628:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00F636:
        move.w  y_pos(a0), D0
        sub.w   d2, d0
        add.w   d3, d0
        moveq   #0,d1
        move.b  y_radius(A1), d1
        sub.w   d1, d0
        move.w  d0, y_pos(a1)
        sub.w   x_pos(a0), D4
        sub.w   d4, x_pos(a1)
        moveq   #0, D4
        rts
loc_00F656:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00F82A
        move.w  d1, D4
        add.w   d4, D4
        cmp.w   d4, d0
        bhi     loc_00F82A
        move.w  y_pos(a0), D5
        add.w   d3,d5
        move.b  y_radius(A1), D3
        ext.w   D3
        add.w   d3, D2
        move.w  y_pos(A1), D3
        sub.w   d5, d3
        addq.w  #4, d3
        add.w   D2, d3
        bmi     loc_00F82A
        move.w  D2, D4
        add.w   d4, D4
        cmp.w   d4, d3
        bcc     loc_00F82A
        bra     loc_00F794        
loc_00F698:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00F82A
        move.w  d1, d3
        add.w   d3, d3
        cmp.w   d3, d0
        bhi     loc_00F82A
        move.w  d0,d5
        btst    #0,render_flags(a0)
        beq.s   loc_00F6BE
        not.w   D5
        add.w   d3,d5
loc_00F6BE:
        lsr.w   #1,d5
        move.b  $00(A2,d5), D3
        sub.b   (A2), D3
        ext.w   D3
        move.w  y_pos(a0), D5
        sub.w   d3,d5
        move.b  y_radius(A1), D3
        ext.w   D3
        add.w   d3, D2
        move.w  y_pos(A1), D3
        sub.w   d5, d3
        addq.w  #4, d3
        add.w   D2, d3
        bmi     loc_00F82A
        move.w  D2, D4
        add.w   d4, D4
        cmp.w   d4, d3
        bcc     loc_00F82A
        bra     loc_00F794   
loc_00F6F2:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00F82A
        move.w  d1, d3
        add.w   d3, d3
        cmp.w   d3, d0
        bhi     loc_00F82A
        move.w  d0,d5
        btst    #0,render_flags(a0)
        beq.s   loc_00F718
        not.w  D5
        add.w   d3,d5
loc_00F718:
        andi.w  #$FFFFFFFE,d5
        move.b  $00(A2,d5), D3
        move.b  $01(A2,d5), D2
        ext.w   D2
        ext.w   D3
        move.w  y_pos(a0), D5
        sub.w   d3,d5
        move.w  y_pos(A1), D3
        sub.w   d5, d3
        move.b  y_radius(A1), D5
        ext.w   D5
        add.w   d5, d3
        addq.w  #4, d3
        bmi     loc_00F82A
        add.w   d5, D2
        move.w  D2, D4
        add.w   d5, D4
        cmp.w   d4, d3
        bcc     loc_00F82A
        bra     loc_00F794        
loc_00F752:
        tst.b   render_flags(a0)
        bpl     loc_00F82A
loc_00F75A:        
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00F82A
        move.w  d1, d3
        add.w   d3, d3
        cmp.w   d3, d0
        bhi     loc_00F82A
        move.b  y_radius(A1), D3
        ext.w   D3
        add.w   d3, D2
        move.w  y_pos(A1), D3
        sub.w   y_pos(a0), D3
        addq.w  #4, d3
        add.w   D2, d3
        bmi     loc_00F82A
        move.w  D2, D4
        add.w   d4, D4
        cmp.w   d4, d3
        bcc     loc_00F82A
loc_00F794:        
        tst.b   $002A(a1)
        bmi     loc_00F82A
        cmpi.b  #6, $0024(a1)
        bcc     loc_00F848
        tst.w   (Debug_placement_mode).w
        bne     loc_00F848
        move.w  d0,d5
        cmp.w   d0, d1
        bcc.s   loc_00F7BC
        add.w   d1, d1
        sub.w   d1, d0
        move.w  d0,d5
        neg.w   D5
loc_00F7BC:
        move.w  d3, d1
        cmp.w   d3, D2
        bcc.s   loc_00F7CA
        subq.w  #4, d3
        sub.w   d4, d3
        move.w  d3, d1
        neg.w   d1
loc_00F7CA:
        cmp.w   d1,d5
        bhi     loc_00F84C
loc_00F7D0:
        cmpi.w  #$004, d1
        bls.s   loc_00F81C
        tst.w   D0
        beq.s   loc_00F7F6
        bmi.s   loc_00F7E4
        tst.w  x_vel(a1)
        bmi.s   loc_00F7F6
        bra.s   loc_00F7EA
loc_00F7E4:
        tst.w  x_vel(a1)
        bpl.s   loc_00F7F6
loc_00F7EA:
        move.w  #0, $14(a1)
        move.w  #0,x_vel(a1)
loc_00F7F6:
        sub.w   d0, x_pos(a1)
        btst    #1, status(a1)
        bne.s   loc_00F81C
        move.l  d6, D4
        addq.b  #$2, D4
        bset    d4, status(a0)
        bset    #5, status(a1)
        move.w  d6, D4
        addi.b  #$D, D4
        bset    d4, D6
        moveq   #1, D4
        rts
loc_00F81C:
        bsr.s   loc_00F83A
        move.w  d6, D4
        addi.b  #$D, D4
        bset    d4, D6
        moveq   #1, D4
        rts
loc_00F82A:
        move.l  d6, D4
        addq.b  #$2, D4
        btst    d4, status(a0)
        beq.s   loc_00F848
        move.w  #$001, $001C(a1)
loc_00F83A:
        move.l  d6, D4
        addq.b  #$2, D4
        bclr    d4, status(a0)
        bclr    #5, status(a1)
loc_00F848:
        moveq   #0, D4
        rts   
loc_00F84C:
        tst.w   D3
        bmi.s   loc_00F858
        cmpi.w  #$010, d3
        bcs.s   loc_00F8A8
        bra.s   loc_00F82A
loc_00F858:
        tst.w   $0012(a1)
        beq.s   loc_00F87A
        bpl.s   loc_00F86E
        tst.w   D3
        bpl.s   loc_00F86E
        sub.w   d3, y_pos(a1)
        move.w  #0, $0012(a1)
loc_00F86E:
        move.w  d6, D4
        addi.b  #$F, D4
        bset    d4, D6
        moveq   #$FFFFFFFE, D4
        rts
loc_00F87A:
        btst    #1, status(a1)
        bne.s   loc_00F86E
        move.w  d0, D4
        bpl.s   loc_00F888
        neg.w   D4
loc_00F888:
        cmpi.w  #$010, D4
        bcs     loc_00F7D0
        move.l  A0, -(A7)
        move.l  A1, A0
        jsr     KillSonic               ; loc_021422
        move.l  (A7)+, A0
        move.w  d6, D4
        addi.b  #$F, D4
        bset    d4, D6
        moveq   #$FFFFFFFE, D4
        rts
loc_00F8A8:
        subq.w  #4, d3
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  d1, D2
        add.w   D2, D2
        add.w   x_pos(A1), d1
        sub.w   x_pos(a0), d1
        bmi.s   loc_00F8E0
        cmp.w   D2, d1
        bcc.s   loc_00F8E0
        tst.w   $0012(a1)
        bmi.s   loc_00F8E0
        sub.w   d3, y_pos(a1)
        subq.w  #1, y_pos(a1)
        bsr     loc_00FAF2
        move.w  d6, D4
        addi.b  #$11, D4
        bset    d4, D6
        moveq   #$FFFFFFFF, D4
        rts
loc_00F8E0:
        moveq   #0, D4
        rts
loc_00F8E4:
        move.w  y_pos(a0), D0
        sub.w   d3, d0
        bra.s   loc_00F8F4
        move.w  y_pos(a0), D0
        subi.w  #$009, d0
loc_00F8F4:
        tst.b   $002A(a1)
        bmi.s   loc_00F91C
        cmpi.b  #6, $0024(a1)
        bcc.s   loc_00F91C
        tst.w   (Debug_placement_mode).w
        bne.s   loc_00F91C
        moveq   #0,d1
        move.b  y_radius(A1), d1
        sub.w   d1, d0
        move.w  d0, y_pos(a1)
        sub.w   x_pos(a0), D2
        sub.w   D2, x_pos(a1)
loc_00F91C:
        rts        
loc_00F91E:
        btst    #3, status(a1)
        beq.s   loc_00F95E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        lsr.w   #1,d0
        btst    #0,render_flags(a0)
        beq.s   loc_00F93E
        not.w  d0
        add.w   d1, d0
loc_00F93E:
        move.b  $00(A2, d0), d1
        ext.w   d1
        move.w  y_pos(a0), D0
        sub.w   d1, d0
        moveq   #0,d1
        move.b  y_radius(A1), d1
        sub.w   d1, d0
        move.w  d0, y_pos(a1)
        sub.w   x_pos(a0), D2
        sub.w   D2, x_pos(a1)
loc_00F95E:
        rts
loc_00F960:

        btst    #3, status(a1)
        beq.s   loc_00F95E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        btst    #0,render_flags(a0)
        beq.s   loc_00F97E
        not.w  D0
        add.w   d1, d0
loc_00F97E:
        andi.w  #$FFFFFFFE, d0
        bra.s   loc_00F93E
loc_00F984:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F99A
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F99A:
        btst    d6, status(a0)
        beq     loc_00FA98
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00F9BE
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00F9BE
        cmp.w   d2, d0
        bcs.s   loc_00F9CC
loc_00F9BE:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00F9CC:
        move.w  d4, D2
        bsr     loc_00F8E4
        moveq   #0, D4
        rts
loc_00F9D6:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00F9EC
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00F9EC:        
        btst    d6, status(a0)
        beq     loc_00FB60
        move.w  d1, D2
        add.w   D2, D2  
        btst    #1, status(a1)
        bne.s   loc_00FA10
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00FA10
        cmp.w   d2, d0
        bcs.s   loc_00FA1E
loc_00FA10:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00FA1E:
        move.w  d4, D2
        bsr     loc_00F91E
        moveq   #0, D4
        rts

loc_00FA28:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr.s   loc_00FA3E
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_00FA3E:
        btst    d6, status(a0)
        beq     loc_00FB98
        move.w  d1, D2
        add.w   D2, D2
        btst    #1, status(a1)
        bne.s   loc_00FA62
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00FA62
        cmp.w   d2, d0
        bcs.s   loc_00FA70
loc_00FA62:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        moveq   #0, D4
        rts
loc_00FA70:
        move.w  d4, D2
        bsr     loc_00F8E4
        moveq   #0, D4
        rts        
loc_00FA7A:
        tst.w   $0012(a1)
        bmi     loc_00FB5E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00FB5E
        cmp.w   d2, d0
        bcc     loc_00FB5E
        bra.s   loc_00FAB6
loc_00FA98:        
        tst.w   $0012(a1)
        bmi     loc_00FB5E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00FB5E
        add.w   d1, d1
        cmp.w   d1, d0
        bcc     loc_00FB5E
loc_00FAB6:
        move.w  y_pos(a0), D0
        sub.w   d3, d0
loc_00FABC:
        move.w  y_pos(A1), D2
        move.b  y_radius(A1), d1
        ext.w   d1
        add.w   D2, d1
        addq.w  #4, d1
        sub.w   d1, d0
        bhi     loc_00FB5E
        cmpi.w  #$FFF0, d0
        bcs     loc_00FB5E
        tst.b   $002A(a1)
        bmi     loc_00FB5E
        cmpi.b  #6, $0024(a1)
        bcc     loc_00FB5E
        add.w   d0, D2
        addq.w  #3, D2
        move.w  D2, y_pos(a1)
loc_00FAF2:        
        btst    #3, status(a1)
        beq.s   loc_00FB0E
        moveq	#0,d0
        move.b  objoff_3D(A1), D0
        lsl.w   #6, d0
        addi.l  #MainCharacter, d0
        move.l  d0, A3
        bclr    d6, status(a3)
loc_00FB0E:
        move.w  A0, d0
        subi.w  #Object_RAM, d0
        lsr.w   #6, d0
        andi.w  #$07F, d0
        move.b  d0, objoff_3D(a1)
        move.b  #0, angle(a1)
        move.w  #0, $0012(a1)
        move.w x_vel(A1), $14(a1)
        btst    #1, status(a1)
        beq.s   loc_00FB54
        move.l  A0, -(A7)
        move.l  A1, A0
        move.w  A0, d1
        subi.w  #Object_RAM, d1
        bne.s   loc_00FB4C
        jsr     Sonic_ResetOnFloor      ; loc_01090C
        bra.s   loc_00FB52
loc_00FB4C:
        jsr     Tails_ResetTailsOnFloor ; loc_011A66 
loc_00FB52:
        move.l  (A7)+, A0
loc_00FB54:
        bset    #3, status(a1)
        bset    d6, status(a0)
loc_00FB5E:
        rts              
loc_00FB60:
        tst.w   $0012(a1)
        bmi     loc_00FB5E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00FB5E
        add.w   d1, d1
        cmp.w   d1, d0
        bcc.s   loc_00FB5E
        btst    #0,render_flags(a0)
        beq.s   loc_00FB86
        not.w   D0
        add.w   d1, d0
loc_00FB86:
        lsr.w   #1,d0
        move.b  $00(A2, d0), D3
        ext.w   D3
        move.w  y_pos(a0), D0
        sub.w   d3, d0
        bra     loc_00FABC
loc_00FB98:        
        tst.w   $0012(a1)
        bmi     loc_00FB5E
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi     loc_00FB5E
        add.w   d1, d1
        cmp.w   d1, d0
        bcc     loc_00FB5E
        move.w  y_pos(a0), D0
        sub.w   d3, d0
        bra     loc_00FABC
loc_00FBC0:        
        move.w  d1, D2
        add.w   D2, D2
        lea     (MainCharacter).w, A1
        btst    #1, status(a1)
        bne.s   loc_00FBE0
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d1, d0
        bmi.s   loc_00FBE0
        cmp.w   d2, d0
        bcs.s   loc_00FBF2
loc_00FBE0:
        bclr    #3, status(a1)
        move.b  #2,routine(a0)
        bclr    #3, status(a0)
loc_00FBF2:
        rts        
loc_00FBF4:
        lea     (MainCharacter).w, A1
        btst    #3, status(a0)
        beq.s   loc_00FC1C
        jsr     Sonic_HitFloor2         ; (loc_013846)
        tst.w   d1
        beq.s   loc_00FC0C
        bpl.s   loc_00FC1C
loc_00FC0C:
        lea     (MainCharacter).w, A1
        bclr    #3, status(a1)
        bclr    #3, status(a0)
loc_00FC1C:
        lea     (Sidekick).w, A1
        btst    #4, status(a0)
        beq.s   loc_00FC44
        jsr     Sonic_HitFloor2         ; (loc_013846)
        tst.w   d1
        beq.s   loc_00FC34
        bpl.s   loc_00FC44
loc_00FC34:
        lea     (Sidekick).w, A1
        bclr    #3, status(a1)
        bclr    #4, status(a0)
loc_00FC44:
        moveq   #0, D4
        rts
;=============================================================================== 
; Object 0x01 - Sonic 

;===============================================================================               
Obj01_Sonic: ; loc_00FC48: 
        tst.w   (Debug_placement_mode).w
        beq.s   Sonic_Normal ; loc_00FC54
        jmp     Debug_Mode ; loc_023B70
Sonic_Normal: ; loc_00FC54:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Sonic_Index(pc,d0), d1 ; loc_00FC62
        jmp     Sonic_Index(pc,d1)     ; loc_00FC62
Sonic_Index: ; loc_00FC62:
        dc.w    Sonic_Main-Sonic_Index       ; loc_00FC6C
        dc.w    Sonic_Control-Sonic_Index    ; loc_00FCE2
        dc.w    Sonic_Hurt-Sonic_Index       ; loc_01096A 
        dc.w    Sonic_Death-Sonic_Index      ; loc_0109FE
        dc.w    Sonic_ResetLevel-Sonic_Index ; loc_010A9E
Sonic_Main: ; loc_00FC6C: 
        addq.b  #2,routine(a0)
        move.b  #$13, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.l  #Sonic_Mappings,mappings(a0) ; loc_0614C0
        move.w  #$780,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$2, $0018(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #4,render_flags(a0)
        move.w  #$600, ($FFFFF760).w
        move.w  #$00C, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        move.b  #$C, Objoff_3E(a0)
        move.b  #$D, Objoff_3F(a0)
        move.b  #0, $002C(a0)
        move.b  #4, $002D(a0)
        move.w  #0, ($FFFFEED2).w
        move.w  #$03F, D2
loc_00FCD4:        
        bsr     CopySonicMovesForTails  ; loc_00FDFA
        move.w  #0, $00(A1, d0)
        dbra    D2, loc_00FCD4  
Sonic_Control: ; loc_00FCE2:
        tst.w   ($FFFFFFFA).w
        beq.s   loc_00FCFC
        btst    #4, (Ctrl_1_Press).w
        beq.s   loc_00FCFC
        move.w  #$001, (Debug_placement_mode).w
        clr.b   ($FFFFF7CC).w
        rts
loc_00FCFC:
        tst.b   ($FFFFF7CC).w
        bne.s   loc_00FD08
        move.w  ($FFFFF604).w, ($FFFFF602).w
loc_00FD08:
        btst    #0, $002A(a0)
        bne.s   Sonic_ControlsLock      ; loc_00FD22 
        moveq	#0,d0
        move.b  status(a0), D0
        andi.w  #$006, d0
        move.w  Sonic_Modes(pc,d0), d1 ; loc_00FD5E
        jsr     Sonic_Modes(pc,d1)     ; loc_00FD5E         
Sonic_ControlsLock: ; loc_00FD22:
        bsr.s   Sonic_Display           ; loc_00FD76
        bsr     CopySonicMovesForTails  ; loc_00FDFA
        bsr     Sonic_Water             ; loc_00FE4E
        move.b  ($FFFFF768).w, objoff_36(a0)
        move.b  ($FFFFF76A).w, $0037(a0)
        tst.b   ($FFFFF7C7).w
        beq.s   loc_00FD4A
        tst.b   $001C(a0)
        bne.s   loc_00FD4A
        move.b  $001D(A0), $001C(a0)
loc_00FD4A:
        bsr     Sonic_Animate           ; loc_010AB2
        tst.b   $002A(a0)
        bmi.s   loc_00FD5A
        jsr     TouchResponse           ; loc_021160
loc_00FD5A:
        bra     Load_Sonic_Dynamic_PLC  ; loc_010DDC 
Sonic_Modes: ; loc_00FD5E:
        dc.w    Sonic_MdNormal-Sonic_Modes    ; loc_00FEEC
        dc.w    Sonic_MdJump-Sonic_Modes      ; loc_00FF14
        dc.w    Sonic_MdRoll-Sonic_Modes      ; loc_00FF3E
        dc.w    Sonic_MdJump2-Sonic_Modes     ; loc_00FF5E              
Sonic_PlayList: ; loc_00FD66:
        dc.b    $82, $82, $83, $90, $83, $83, $93, $96, $86, $8F, $81, $85, $84, $8D, $8D, $87 

;=============================================================================== 
; Beginning of Sub Sonic_Display
                 
;===============================================================================   
Sonic_Display: ; loc_00FD76:
        move.w  Objoff_30(A0), D0         
        beq.s   loc_00FD84
        subq.w  #1, Objoff_30(a0)
        lsr.w   #3, d0
        bcc.s   loc_00FD8A
loc_00FD84:
        jsr     DisplaySprite           ; loc_00D3C2
loc_00FD8A:
        tst.b   ($FFFFFE2D).w
        beq.s   loc_00FDC4
        tst.w   $0032(a0)
        beq.s   loc_00FDC4
        subq.w  #1, $0032(a0)
        bne.s   loc_00FDC4
        tst.b   ($FFFFF7AA).w
        bne.s   loc_00FDBE
        cmpi.w  #$00C, ($FFFFFE14).w
        bcs.s   loc_00FDBE
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        lea     Sonic_PlayList(PC), A1  ; loc_00FD66
        move.b  $00(A1, d0), D0
        jsr     (Play_Music)            ; loc_0014C0
loc_00FDBE:
        move.b  #0, ($FFFFFE2D).w
loc_00FDC4:
        tst.b   ($FFFFFE2E).w
        beq.s   loc_00FDF8
        tst.w   Objoff_34(a0)
        beq.s   loc_00FDF8
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_00FDF8
        move.w  #$600, ($FFFFF760).w
        move.w  #$00C, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        move.b  #0, ($FFFFFE2E).w
        move.w  #$0FC, d0
        jmp     (Play_Music)            ; loc_0014C0           
loc_00FDF8:
        rts
;=============================================================================== 
; End of Sub Sonic_Display         
;===============================================================================
          
;=============================================================================== 
; Beginning of Sub CopySonicMovesForTails              
;===============================================================================         
CopySonicMovesForTails: ; loc_00FDFA:
        move.w  ($FFFFEED2).w, d0
        lea     ($FFFFE500).w, A1
        lea     $00(A1, d0), A1
        move.w  x_pos(a0), (A1)+
        move.w  y_pos(a0), (A1)+
        addq.b  #4, ($FFFFEED3).w
        lea     ($FFFFE400).w, A1
        move.w  ($FFFFF604).w, $00(A1, d0)
        rts
;=============================================================================== 
; End of Sub CopySonicMovesForTails                 
;===============================================================================
          
; loc_00FE1E:
        move.w  ($FFFFEEE0).w, d0
        subq.b  #4, d0
        lea     ($FFFFE600).w, A1
        lea     $00(A1, d0), A2
        move.w  x_pos(a0), d1
        swap.w  d1
        move.w  y_pos(a0), d1
        cmp.l   (a2),d1
        beq.s   loc_00FE4C
        addq.b  #4, d0
        lea     $00(A1, d0), A2
        move.w  x_pos(a0), (A2)+
        move.w  y_pos(a0), (a2)
        addq.b  #4, ($FFFFEEE1).w
loc_00FE4C:
        rts  
;=============================================================================== 
; Beginning of Sub Sonic_Water
                 
;===============================================================================     
Sonic_Water: ; loc_00FE4E:
        tst.b   ($FFFFF730).w
        bne.s   Sonic_InLevelWithWater  ; loc_00FE56
loc_00FE54:        
        rts
Sonic_InLevelWithWater: ; loc_00FE56:
        move.w  (Water_Level_1).w, d0
        cmp.w   y_pos(a0), D0
        bge.s   Sonic_NotInWater        ; loc_00FEA8
        bset    #6, status(a0)
        bne.s   loc_00FE54  
        bsr     ResumeMusic             ; loc_0124FE
        move.b  #$A, ($FFFFB340).w
        move.b  #$81, ($FFFFB368).w
        move.w  #$300, ($FFFFF760).w
        move.w  #$006, ($FFFFF762).w
        move.w  #$40, ($FFFFF764).w
        asr.w  x_vel(a0)
        asr.w   $0012(a0)
        asr.w   $0012(a0)
        beq.s   loc_00FE54
        move.b  #8, ($FFFFB300).w
        move.w  #$0AA, d0
        jmp     (Play_Sfx)              ; loc_0014C6
;===============================================================================         
Sonic_NotInWater: ; loc_00FEA8:          
        bclr    #6, status(a0)
        beq.s   loc_00FE54
        bsr     ResumeMusic             ; loc_0124FE
        move.w  #$600, ($FFFFF760).w
        move.w  #$00C, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        asl.w   $0012(a0)
        beq     loc_00FE54
        move.b  #8, ($FFFFB300).w
        cmpi.w  #$F000, $0012(a0)
        bgt.s   loc_00FEE2
        move.w  #$F000, $0012(a0)
loc_00FEE2:        
        move.w  #$0AA, d0
        jmp     (Play_Sfx)              ; loc_0014C6
Sonic_MdNormal: ; loc_00FEEC:
        bsr     Sonic_Spindash          ; loc_010560
        bsr     Sonic_Jump              ; loc_010476
        bsr     Sonic_SlopeResist       ; loc_0105EC
        bsr     Sonic_Move              ; loc_00FF88
        bsr     Sonic_Roll              ; loc_010410
        bsr     Sonic_LevelBoundaries   ; loc_01038C
        jsr     SpeedToPos              ; loc_00D27A
        bsr     Sonic_AnglePos          ; loc_012D28
        bsr     Sonic_SlopeRepel        ; loc_01065E
        rts
Sonic_MdJump: ; loc_00FF14:
        bsr     Sonic_JumpHeight        ; loc_010524
        bsr     Sonic_ChgJumpDir        ; loc_010300
        bsr     Sonic_LevelBoundaries   ; loc_01038C
        jsr     ObjectFall              ; loc_00D24E
        btst    #6, status(a0)
        beq.s   loc_00FF34
        subi.w  #$028, $0012(a0)
loc_00FF34:
        bsr     Sonic_JumpAngle         ; loc_0106A0
        bsr     Sonic_Floor             ; loc_010700
        rts
Sonic_MdRoll: ; loc_00FF3E:
        bsr     Sonic_Jump              ; loc_010476
        bsr     Sonic_RollRepel         ; loc_010622
        bsr     Sonic_RollSpeed         ; loc_010208
        bsr     Sonic_LevelBoundaries   ; loc_01038C
        jsr     SpeedToPos              ; loc_00D27A
        bsr     Sonic_AnglePos          ; loc_012D28
        bsr     Sonic_SlopeRepel        ; loc_01065E
        rts
Sonic_MdJump2: ; loc_00FF5E:
        bsr     Sonic_JumpHeight        ; loc_010524
        bsr     Sonic_ChgJumpDir        ; loc_010300
        bsr     Sonic_LevelBoundaries   ; loc_01038C
        jsr     ObjectFall              ; loc_00D24E
        btst    #6, status(a0)
        beq.s   loc_00FF7E
        subi.w  #$028, $0012(a0)
loc_00FF7E:
        bsr     Sonic_JumpAngle         ; loc_0106A0
        bsr     Sonic_Floor             ; loc_010700
        rts
        
;=============================================================================== 
; Beginning of Sub Sonic_Move
                 
;===============================================================================          
Sonic_Move: ; loc_00FF88:
        move.w  ($FFFFF760).w, D6
        move.w  ($FFFFF762).w,d5
        move.w  ($FFFFF764).w, D4
        tst.b   ($FFFFF7CA).w
        bne     loc_01009A
        tst.w   $002E(a0)
        bne     loc_01006E
        btst    #$2, ($FFFFF602).w
        beq.s   loc_00FFB0
        bsr     Sonic_MoveLeft          ; loc_01012A
loc_00FFB0:
        btst    #3, ($FFFFF602).w
        beq.s   loc_00FFBC
        bsr     Sonic_MoveRight         ; loc_01019C
loc_00FFBC:
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne     loc_01006E
        tst.w   $14(a0)
        bne     loc_01006E
        bclr    #5, status(a0)
        move.b  #5, $001C(a0)
        btst    #3, status(a0)
        beq.s   Sonic_Balance           ; loc_01001E
        moveq	#0,d0
        move.b  objoff_3D(A0), D0
        lsl.w   #6, d0
        lea     (MainCharacter).w, A1
        lea     $00(A1, d0), A1
        tst.b   status(a1)
        bmi.s   Sonic_LookUp            ; loc_010050
        moveq   #0,d1
        move.b  $0019(A1), d1
        move.w  d1, D2
        add.w   D2, D2
        subq.w  #4, D2
        add.w   x_pos(a0), d1
        sub.w   x_pos(A1), d1
        cmpi.w  #$004, d1
        blt.s   loc_010042
        cmp.w   D2, d1
        bge.s   loc_010032
        bra.s   Sonic_LookUp            ; loc_010050
;===============================================================================        
Sonic_Balance: ; loc_01001E:
        jsr     Sonic_HitFloor          ; loc_0137F4
        cmpi.w  #$00C, d1
        blt.s   Sonic_LookUp            ; loc_010050
        cmpi.b  #3, objoff_36(a0)
        bne.s   loc_01003A
loc_010032:
        bclr    #0, status(a0)
        bra.s   loc_010048
loc_01003A:
        cmpi.b  #3, $0037(a0)
        bne.s   Sonic_LookUp            ; loc_010050
loc_010042:        
        bset    #0, status(a0)
loc_010048:        
        move.b  #6, $001C(a0)
        bra.s   loc_01006E
;===============================================================================           
Sonic_LookUp: ; loc_010050:
        btst    #0, ($FFFFF602).w
        beq.s   Sonic_Duck              ; loc_010060
        move.b  #$7, $001C(a0)
        bra.s   loc_01006E
;===============================================================================           
Sonic_Duck: ; loc_010060:
        btst    #1, ($FFFFF602).w
        beq.s   loc_01006E
        move.b  #8, $001C(a0)
loc_01006E:
        move.b  ($FFFFF602).w, d0
        andi.b  #$C, d0
        bne.s   loc_01009A
        move.w  $14(A0), D0
        beq.s   loc_01009A
        bmi.s   loc_01008E
        sub.w   d5, d0
        bcc.s   loc_010088
        move.w  #0, d0
loc_010088:
        move.w  d0, $14(a0)
        bra.s   loc_01009A
loc_01008E:
        add.w   d5, d0
        bcc.s   loc_010096
        move.w  #0, d0
loc_010096:
        move.w  d0, $14(a0)
loc_01009A:
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), d1
        asr.l   #8, d1
        move.w  d1,x_vel(a0)
        muls.w  $14(A0), D0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
loc_0100B8:        
        move.b  angle(A0), D0
        addi.b  #$40, d0
        bmi.s   loc_010128
        move.b  #$40, d1
        tst.w   $14(a0)
        beq.s   loc_010128
        bmi.s   loc_0100D0
        neg.w   d1
loc_0100D0:
        move.b  angle(A0), D0
        add.b   d1, d0
        move.w  d0, -(A7)
        bsr     Sonic_WalkSpeed         ; loc_01366C
        move.w  (A7)+, D0
        tst.w   d1
        bpl.s   loc_010128
        asl.w   #8, d1
        addi.b  #$20, d0
        andi.b  #$C0, d0
        beq.s   loc_010124
        cmpi.b  #$40, d0
        beq.s   loc_010112
        cmpi.b  #$80, d0
        beq.s   loc_01010C
        add.w   d1,x_vel(a0)
        bset    #5, status(a0)
        move.w  #0, $14(a0)
        rts
loc_01010C:
        sub.w   d1, $0012(a0)
        rts
loc_010112:
        sub.w   d1,x_vel(a0)
        bset    #5, status(a0)
        move.w  #0, $14(a0)
        rts
loc_010124:
        add.w   d1, $0012(a0)
loc_010128:        
        rts    
;=============================================================================== 
; End of Sub Sonic_Move              
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Sonic_MoveLeft               
;===============================================================================                     
Sonic_MoveLeft: ; loc_01012A:
        move.w  $14(A0), D0
        beq.s   loc_010132
        bpl.s   loc_010164
loc_010132:
        bset    #0, status(a0)
        bne.s   loc_010146
        bclr    #5, status(a0)          
        move.b  #1, $001D(a0) 
loc_010146:
        sub.w   d5, d0
        move.w  d6, d1
        neg.w   d1
        cmp.w   d1, d0
        bgt.s   loc_010158
        add.w   d5, d0
        cmp.w   d1, d0
        ble.s   loc_010158
        move.w  d1, d0
loc_010158:
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        rts
loc_010164:
        sub.w   d4, d0
        bcc.s   loc_01016C
        move.w  #$FF80, d0
loc_01016C:
        move.w  d0, $14(a0)
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne.s   loc_01019A
        cmpi.w  #$400, d0             
        blt.s   loc_01019A
        move.b  #$D, $001C(a0)
        bclr    #0, status(a0)
        move.w  #$0A4, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01019A:
        rts
;=============================================================================== 
; End of Sub Sonic_MoveLeft                
;===============================================================================    

;=============================================================================== 
; Beginning of Sub Sonic_MoveRight                
;===============================================================================          
Sonic_MoveRight: ; loc_01019C:
        move.w  $14(A0), D0
        bmi.s   loc_0101D0
        bclr    #0, status(a0)
        beq.s   loc_0101B6
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
loc_0101B6:
        add.w   d5, d0
        cmp.w   d6, d0
        blt.s   loc_0101C4
        sub.w   d5, d0
        cmp.w   d6, d0
        bge.s   loc_0101C4
        move.w  d6, d0
loc_0101C4:
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        rts 
loc_0101D0:
        add.w   d4, d0
        bcc.s   loc_0101D8
        move.w  #$080, d0
loc_0101D8:
        move.w  d0, $14(a0)
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne.s   loc_010206
        cmpi.w  #$FC00, d0
        bgt.s   loc_010206
        move.b  #$D, $001C(a0)
        bset    #0, status(a0)
        move.w  #$0A4, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_010206:
        rts
;=============================================================================== 
; End of Sub Sonic_MoveRight                
;===============================================================================    
           
;=============================================================================== 
; Beginning of Sub Sonic_RollSpeed
                 
;===============================================================================                   
Sonic_RollSpeed: ; loc_010208:
        move.w  ($FFFFF760).w, D6
        asl.w   #1, D6
        move.w  ($FFFFF762).w,d5
        asr.w   #1,d5
        move.w  ($FFFFF764).w, D4
        asr.w   #$2, D4
        tst.b   ($FFFFF7CA).w
        bne     loc_010284
        tst.w   $002E(a0)
        bne.s   loc_010240
        btst    #$2, ($FFFFF602).w
        beq.s   loc_010234
        bsr     Sonic_RollLeft          ; loc_0102BA
loc_010234:        
        btst    #3, ($FFFFF602).w
        beq.s   loc_010240
        bsr     Sonic_RollRight         ; loc_0102DE
loc_010240:        
        move.w  $14(A0), D0        
        beq.s   loc_010262
        bmi.s   loc_010256
        sub.w   d5, d0
        bcc.s   loc_010250
        move.w  #0, d0
loc_010250:
        move.w  d0, $14(a0)
        bra.s   loc_010262
loc_010256:
        add.w   d5, d0
        bcc.s   loc_01025E
        move.w  #0, d0
loc_01025E:        
        move.w  d0, $14(a0) 
loc_010262:        
        tst.w   $14(a0)
        bne.s   loc_010284
        bclr    #$2, status(a0)
        move.b  #$13, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.b  #5, $001C(a0)
        subq.w  #5, y_pos(a0)
loc_010284:        
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), D0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
        muls.w  $14(A0), d1
        asr.l   #8, d1
        cmpi.w  #$1000, d1
        ble.s   loc_0102A8
        move.w  #$1000, d1
loc_0102A8:
        cmpi.w  #$F000, d1
        bge.s   loc_0102B2
        move.w  #$F000, d1
loc_0102B2:
        move.w  d1,x_vel(a0)
        bra     loc_0100B8   
;=============================================================================== 
; End of Sub Sonic_RollSpeed                
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Sonic_RollLeft
                 
;===============================================================================  
Sonic_RollLeft: ; loc_0102BA:
        move.w  $14(A0), D0
        beq.s   loc_0102C2
        bpl.s   loc_0102D0
loc_0102C2:
        bset    #0, status(a0)
        move.b  #$2, $001C(a0)
        rts
loc_0102D0:
        sub.w   d4, d0
        bcc.s   loc_0102D8
        move.w  #$FF80, d0
loc_0102D8:
        move.w  d0, $14(a0)
        rts 
;=============================================================================== 
; End of Sub Sonic_RollLeft                
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Sonic_RollRight
                 
;===============================================================================  
Sonic_RollRight: ; loc_0102DE:
        move.w  $14(A0), D0
        bmi.s   loc_0102F2
        bclr    #0, status(a0)
        move.b  #$2, $001C(a0)
        rts
loc_0102F2:
        add.w   d4, d0
        bcc.s   loc_0102FA
        move.w  #$080, d0
loc_0102FA:
        move.w  d0, $14(a0)
        rts   
;=============================================================================== 
; End of Sub Sonic_RollRight                
;===============================================================================
          
;=============================================================================== 
; Beginning of Sub Sonic_ChgJumpDir
                 
;===============================================================================             
Sonic_ChgJumpDir: ; loc_010300:
        move.w  ($FFFFF760).w, D6
        move.w  ($FFFFF762).w,d5
        asl.w   #1,d5
        btst    #4, status(a0)
        bne.s   loc_01034A
        move.w x_vel(A0), D0
        btst    #$2, ($FFFFF602).w
        beq.s   loc_010330
        bset    #0, status(a0)
        sub.w   d5, d0
        move.w  d6, d1
        neg.w   d1
        cmp.w   d1, d0
        bgt.s   loc_010330
        move.w  d1, d0
loc_010330:
        btst    #3, ($FFFFF602).w
        beq.s   loc_010346
        bclr    #0, status(a0)
        add.w   d5, d0
        cmp.w   d6, d0
        blt.s   loc_010346
        move.w  d6, d0
loc_010346:
        move.w  d0,x_vel(a0)
loc_01034A:
        cmpi.w  #$060, ($FFFFEED8).w
        beq.s   loc_01035C
        bcc.s   loc_010358
        addq.w  #4, ($FFFFEED8).w
loc_010358:
        subq.w  #$2, ($FFFFEED8).w
loc_01035C:
        cmpi.w  #$FC00, $0012(a0)
        bcs.s   loc_01038A         
        move.w x_vel(A0), D0
        move.w  d0, d1
        asr.w   #5, d1
        beq.s   loc_01038A
        bmi.s   loc_01037E
        sub.w   d1, d0
        bcc.s   loc_010378
        move.w  #0, d0
loc_010378:
        move.w  d0,x_vel(a0)
        rts
loc_01037E:
        sub.w   d1, d0
        bcs.s   loc_010386
        move.w  #0, d0
loc_010386:
        move.w  d0,x_vel(a0)
loc_01038A:        
        rts    
;=============================================================================== 
; End of Sub Sonic_ChgJumpDir                
;===============================================================================
              
;=============================================================================== 
; Beginning of Sub Sonic_LevelBoundaries             
;===============================================================================                       
Sonic_LevelBoundaries: ; loc_01038C:
        move.l  x_pos(a0), d1
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d1
        swap.w  d1
        move.w  ($FFFFEEC8).w, d0
        addi.w  #$010, d0
        cmp.w   d1, d0
        bhi.s   loc_0103F8
        move.w  ($FFFFEECA).w, d0
        addi.w  #$128, d0
        tst.b   ($FFFFF7AA).w
        bne.s   loc_0103BA
        addi.w  #$40, d0
loc_0103BA:
        cmp.w   d1, d0
        bls.s   loc_0103F8
loc_0103BE:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        blt.s   loc_0103CE
        rts
loc_0103CE:
        bra     J_KillSonic_00          ; loc_010E30
        cmpi.w  #$1001, (Current_ZoneAndAct).w
        bne     J_KillSonic_00          ; loc_010E30
        cmpi.w  #$2000, (MainCharacter+x_pos).w
        bcs     J_KillSonic_00          ; loc_010E30
        clr.b   (Last_star_pole_hit).w
        move.w  #$001, ($FFFFFE02).w
        move.w  #$103, (Current_ZoneAndAct).w
        rts
loc_0103F8:
        move.w  d0, x_pos(a0)
        move.w  #0, $000A(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $14(a0)
        bra.s   loc_0103BE
;=============================================================================== 
; End of Sub Sonic_LevelBoundaries                
;===============================================================================          
        
;=============================================================================== 
; Beginning of Sub Sonic_Roll                 
;===============================================================================           
Sonic_Roll: ; loc_010410:
        tst.b   ($FFFFF7CA).w
        bne.s   Sonic_NoRoll            ; loc_010436
        move.w  $14(A0), D0
        bpl.s   loc_01041E
        neg.w   D0
loc_01041E:
        cmpi.w  #$080, d0
        bcs.s   Sonic_NoRoll            ; loc_010436
        move.b  ($FFFFF602).w, d0
        andi.b  #$C, d0
        bne.s   Sonic_NoRoll            ; loc_010436
        btst    #1, ($FFFFF602).w
        bne.s   loc_010438
Sonic_NoRoll: ; loc_010436:
        rts
loc_010438:
        btst    #$2, status(a0)
        beq.s   Sonic_DoRoll            ; loc_010442
        rts
;===============================================================================          
Sonic_DoRoll: ; loc_010442:
        bset    #$2, status(a0)
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        addq.w  #5, y_pos(a0)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        tst.w   $14(a0)
        bne.s   loc_010474
        move.w  #$200, $14(a0)
loc_010474:
        rts
;=============================================================================== 
; End of Sub Sonic_Roll                
;===============================================================================    
              
;=============================================================================== 
; Beginning of Sub Sonic_Jump          
;===============================================================================        
Sonic_Jump: ; loc_010476:
        move.b  (Ctrl_1_Press_Logical).w, d0
        andi.b  #$70, d0
        beq     loc_01051A
        moveq	#0,d0
        move.b  angle(A0), D0
        addi.b  #$80, d0
        bsr     loc_0136F2
        cmpi.w  #$006, d1
        blt     loc_01051A
        move.w  #$680, D2
        btst    #6, status(a0)
        beq.s   loc_0104A8
        move.w  #$380, D2
loc_0104A8:
        moveq	#0,d0
        move.b  angle(A0), D0
        subi.b  #$40, d0
        jsr     CalcSine        ; loc_00320A
        muls.w  D2, d1
        asr.l   #8, d1
        add.w   d1,x_vel(a0)
        muls.w  d2, d0
        asr.l   #8,d0
        add.w   d0, $0012(a0)
        bset    #1, status(a0)
        bclr    #5, status(a0)
        addq.l  #4, A7
        move.b  #1, Objoff_3C(a0)
        clr.b   objoff_38(a0)
        move.w  #$0A0, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        move.b  #$13, y_radius(a0)
        move.b  #$9, $0017(a0)
        btst    #$2, status(a0)
        bne.s   loc_01051C
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        bset    #$2, status(a0)
        addq.w  #5, y_pos(a0)
loc_01051A:        
        rts
loc_01051C:
        bset    #4, status(a0)
        rts   
;=============================================================================== 
; End of Sub Sonic_Jump                
;===============================================================================   

;=============================================================================== 
; Beginning of Sub Sonic_JumpHeight                 
;===============================================================================   
Sonic_JumpHeight: ; loc_010524:
        tst.b   Objoff_3C(a0)
        beq.s   loc_010550
        move.w  #$FC00, d1
        btst    #6, status(a0)
        beq.s   loc_01053A
        move.w  #$FE00, d1
loc_01053A:
        cmp.w   $0012(A0), d1
        ble.s   loc_01054E
        move.b  ($FFFFF602).w, d0
        andi.b  #$70, d0
        bne.s   loc_01054E
        move.w  d1, $0012(a0)
loc_01054E:
        rts  
loc_010550:
        cmpi.w  #$F040, $0012(a0)
        bge.s   loc_01055E
        move.w  #$F040, $0012(a0)
loc_01055E:
        rts 
;=============================================================================== 
; End of Sub Sonic_JumpHeight                
;===============================================================================
          
;=============================================================================== 
; Beginning of Sub Sonic_Spindash                
;===============================================================================                     
Sonic_Spindash: ; loc_010560:
        tst.b   $0039(a0)
        bne.s   loc_010594
        cmpi.b  #8, $001C(a0)
        bne.s   loc_010592
        move.b  (Ctrl_1_Press_Logical).w, d0
        andi.b  #$70, d0
        beq     loc_010592
        move.b  #$9, $001C(a0)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.l  #4, A7
        move.b  #1, $0039(a0)
loc_010592:
        rts
loc_010594:        
        move.b  ($FFFFF602).w, d0
        btst    #1,d0
        bne.s   loc_0105DA
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        addq.w  #5, y_pos(a0)
        move.b  #0, $0039(a0)
        move.w  #$2000, ($FFFFEED0).w
        move.w  #$800, $14(a0)
        btst    #0, status(a0)
        beq.s   loc_0105D2
        neg.w   $14(a0)
loc_0105D2:
        bset    #$2, status(a0)
        rts
loc_0105DA:
        move.b  (Ctrl_1_Press_Logical).w, d0
        andi.b  #$70, d0
        beq     loc_0105E8
        nop
loc_0105E8:
        addq.l  #4, A7
        rts          
;=============================================================================== 
; End of Sub Sonic_Spindash                
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Sonic_SlopeResist              
;===============================================================================              
Sonic_SlopeResist: ; loc_0105EC:
        move.b  angle(A0), D0
        addi.b  #$60, d0
        cmpi.b  #$C0, d0
        bcc.s   loc_010620
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  #$20, d0
        asr.l   #8,d0
        tst.w   $14(a0)
        beq.s   loc_010620
        bmi.s   loc_01061C
        tst.w   D0
        beq.s   loc_01061A
        add.w   d0, $14(a0)
loc_01061A:
        rts
loc_01061C:
        add.w   d0, $14(a0)
loc_010620:
        rts
;=============================================================================== 
; End of Sub Sonic_SlopeResist                
;=============================================================================== 
 
;=============================================================================== 
; Beginning of Sub Sonic_RollRepel                
;===============================================================================  
Sonic_RollRepel: ; loc_010622:
        move.b  angle(A0), D0
        addi.b  #$60, d0
        cmpi.b  #$C0, d0
        bcc.s   loc_01065C
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  #$050, d0
        asr.l   #8,d0
        tst.w   $14(a0)
        bmi.s   loc_010652
        tst.w   D0
        bpl.s   loc_01064C
        asr.l   #$2, d0
loc_01064C:
        add.w   d0, $14(a0)
        rts
loc_010652:
        tst.w   D0
        bmi.s   loc_010658
        asr.l   #$2, d0
loc_010658:
        add.w   d0, $14(a0)
loc_01065C:
        rts  
;=============================================================================== 
; End of Sub Sonic_RollRepel                
;===============================================================================   
               
;=============================================================================== 
; Beginning of Sub Sonic_SlopeRepel               
;===============================================================================  
Sonic_SlopeRepel: ; loc_01065E:
        nop
        tst.b   objoff_38(a0)
        bne.s   loc_010698
        tst.w   $002E(a0)
        bne.s   loc_01069A
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        beq.s   loc_010698
        move.w  $14(A0), D0
        bpl.s   loc_010682
        neg.w   D0
loc_010682:
        cmpi.w  #$280, d0
        bcc.s   loc_010698
        clr.w   $14(a0)
        bset    #1, status(a0)
        move.w  #$01E, $002E(a0)
loc_010698:
        rts
loc_01069A:
        subq.w  #1, $002E(a0)
        rts 
;=============================================================================== 
; End of Sub Sonic_SlopeRepel                
;===============================================================================  

;=============================================================================== 
; Beginning of Sub Sonic_JumpAngle                
;=============================================================================== 
Sonic_JumpAngle: ; loc_0106A0:
        move.b  angle(A0), D0
        beq.s   loc_0106BA
        bpl.s   loc_0106B0
        addq.b  #$2, d0
        bcc.s   loc_0106AE
        moveq	#0,d0
loc_0106AE:
        bra.s   loc_0106B6
loc_0106B0:        
        subq.b  #$2, d0
        bcc.s   loc_0106B6
        moveq	#0,d0
loc_0106B6:
        move.b  d0,angle(a0)
loc_0106BA:
        move.b  $0027(A0), D0
        beq.s   loc_0106FE
        tst.w   $14(a0)
        bmi.s   loc_0106DE
loc_0106C6:
        move.b  $002D(A0), d1
        add.b   d1, d0
        bcc.s   loc_0106DC
        subq.b  #1, $002C(a0)
        bcc.s   loc_0106DC
        move.b  #0, $002C(a0)
        moveq	#0,d0
loc_0106DC:
        bra.s   loc_0106FA
loc_0106DE:
        tst.b   $0029(a0)
        bne.s   loc_0106C6
        move.b  $002D(A0), d1
        sub.b   d1, d0
        bcc.s   loc_0106FA
        subq.b  #1, $002C(a0)
        bcc.s   loc_0106FA
        move.b  #0, $002C(a0)
        moveq	#0,d0
loc_0106FA:
        move.b  d0, $0027(a0)
loc_0106FE:        
        rts
;=============================================================================== 
; End of Sub Sonic_JumpAngle                
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub Sonic_Floor                
;=============================================================================== 
Sonic_Floor: ; loc_010700:
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_010718
        move.l  #Primary_Collision, ($FFFFF796).w
loc_010718:
        move.b  Objoff_3F(A0), D5
        move.w x_vel(A0), d1
        move.w  $0012(A0), D2
        jsr     CalcAngle               ; loc_0034A2
        move.b  d0, $002B(a0)
        subi.b  #$20, d0
        andi.b  #$C0, d0
        cmpi.b  #$40, d0
        beq     loc_0107EC
        cmpi.b  #$80, d0
        beq     loc_01084E
        cmpi.b  #$C0, d0
        beq     loc_0108AA
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_010760
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_010760:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_010772
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_010772:
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_0107EA
        move.b  $0012(A0), D2
        addq.b  #8, D2
        neg.b   D2
        cmp.b   D2, d1
        bge.s   loc_01078A
        cmp.b   d2, d0
        blt.s   loc_0107EA
loc_01078A:
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Sonic_ResetOnFloor      ; loc_01090C
        move.b  #0, $001C(a0)
        move.b  d3, d0
        addi.b  #$20, d0
        andi.b  #$40, d0
        bne.s   loc_0107C8
        move.b  d3, d0
        addi.b  #$10, d0
        andi.b  #$20, d0
        beq.s   loc_0107BA
        asr.w   $0012(a0)
        bra.s   loc_0107DC
loc_0107BA:
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
        rts
loc_0107C8:
        move.w  #0,x_vel(a0)
        cmpi.w  #$FC0, $0012(a0)
        ble.s   loc_0107DC
        move.w  #$FC0, $0012(a0)
loc_0107DC:
        move.w  $0012(A0), $14(a0)
        tst.b   D3
        bpl.s   loc_0107EA
        neg.w   $14(a0)
loc_0107EA:
        rts 
loc_0107EC:
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_010806
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
        move.w  $0012(A0), $14(a0)
        rts
loc_010806:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_010820
        sub.w   d1, y_pos(a0)
        tst.w   $0012(a0)
        bpl.s   loc_01081E
        move.w  #0, $0012(a0)
loc_01081E:
        rts
loc_010820:
        tst.w   $0012(a0)
        bmi.s   loc_01084C
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_01084C
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Sonic_ResetOnFloor      ; loc_01090C
        move.b  #0, $001C(a0)
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
loc_01084C:  
        rts
loc_01084E:
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_010860
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_010860:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_010872
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_010872:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_0108A8
        sub.w   d1, y_pos(a0)
        move.b  d3, d0
        addi.b  #$20, d0
        andi.b  #$40, d0
        bne.s   loc_010892
        move.w  #0, $0012(a0)
        rts
loc_010892:
        move.b  d3,angle(a0)
        bsr     Sonic_ResetOnFloor      ; loc_01090C
        move.w  $0012(A0), $14(a0)
        tst.b   D3
        bpl.s   loc_0108A8
        neg.w   $14(a0)
loc_0108A8:
        rts
loc_0108AA:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_0108C4
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
        move.w  $0012(A0), $14(a0)
        rts
loc_0108C4:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_0108DE
        sub.w   d1, y_pos(a0)
        tst.w   $0012(a0)
        bpl.s   loc_0108DC
        move.w  #0, $0012(a0)
loc_0108DC:
        rts
loc_0108DE:
        tst.w   $0012(a0)
        bmi.s   loc_01090A
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_01090A
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Sonic_ResetOnFloor      ; loc_01090C
        move.b  #0, $001C(a0)
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
loc_01090A:
        rts
;=============================================================================== 
; End of Sub Sonic_Floor                
;===============================================================================     
            
;=============================================================================== 
; Beginning of Sub Sonic_ResetOnFloor                
;===============================================================================          
Sonic_ResetOnFloor: ; loc_01090C:
        btst    #4, status(a0)
        beq.s   loc_01091A
        nop
        nop
        nop
loc_01091A:
        bclr    #5, status(a0)
        bclr    #1, status(a0)
        bclr    #4, status(a0)
        btst    #$2, status(a0)
        beq.s   loc_010950
        bclr    #$2, status(a0)
        move.b  #$13, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.b  #0, $001C(a0)
        subq.w  #5, y_pos(a0)
loc_010950:
        move.b  #0, Objoff_3C(a0)
        move.w  #0, ($FFFFF7D0).w
        move.b  #0, $0027(a0)
        move.b  #0, $0029(a0)
        rts 
;=============================================================================== 
; End of Sub Sonic_ResetOnFloor                
;===============================================================================          
        
Sonic_Hurt: ; loc_01096A:
        tst.b   $0025(a0)
        bmi     loc_0109E2
        jsr     SpeedToPos              ; loc_00D27A
        addi.w  #$030, $0012(a0)
        btst    #6, status(a0)
        beq.s   loc_01098C
        subi.w  #$20, $0012(a0)
loc_01098C:            
        bsr     Sonic_HurtStop          ; loc_0109A6
        bsr     Sonic_LevelBoundaries   ; loc_01038C
        bsr     CopySonicMovesForTails  ; loc_00FDFA
        bsr     Sonic_Animate           ; loc_010AB2
        bsr     Load_Sonic_Dynamic_PLC  ; loc_010DDC
        jmp     DisplaySprite           ; loc_00D3C2
;=============================================================================== 
; Beginning of Sub Sonic_HurtStop
                 
;===============================================================================           
Sonic_HurtStop: ; loc_0109A6:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs     J_KillSonic_00          ; loc_010E30
        bsr     Sonic_Floor             ; loc_010700
        btst    #1, status(a0)
        bne.s   loc_0109E0
        moveq	#0,d0
        move.w  d0, $0012(a0)
        move.w  d0,x_vel(a0)
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        subq.b  #2,routine(a0)
        move.w  #$078, Objoff_30(a0)
loc_0109E0:
        rts
;=============================================================================== 
; End of Sub Sonic_HurtStop                
;===============================================================================  
        
loc_0109E2:
        subq.b  #2,routine(a0)
        move.b  #0, $0025(a0)
        bsr     CopySonicMovesForTails  ; loc_00FDFA
        bsr     Sonic_Animate           ; loc_010AB2
        bsr     Load_Sonic_Dynamic_PLC  ; loc_010DDC
        jmp     DisplaySprite           ; loc_00D3C2
Sonic_Death: ; loc_0109FE:        
        bsr     Sonic_GameOver          ; loc_010A1A
        jsr     ObjectFall              ; loc_00D24E
        bsr     CopySonicMovesForTails  ; loc_00FDFA
        bsr     Sonic_Animate           ; loc_010AB2
        bsr     Load_Sonic_Dynamic_PLC  ; loc_010DDC
        jmp     DisplaySprite           ; loc_00D3C2
        
;=============================================================================== 
; Beginning of Sub Sonic_GameOver
                 
;===============================================================================           
Sonic_GameOver: ; loc_010A1A:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$100, d0
        cmp.w   y_pos(a0), D0
        bcc     loc_010A9C
        move.w  #$FFC8, $0012(a0)
        addq.b  #2,routine(a0)
        clr.b   (Update_HUD_timer).w
        addq.b  #1, (Update_HUD_lives).w
        subq.b  #1, ($FFFFFE12).w
        bne.s   loc_010A70
        move.w  #0, objoff_3A(a0)
        move.b  #$39, ($FFFFB080).w
        move.b  #$39, ($FFFFB0C0).w         
        move.b  #1, ($FFFFB0DA).w
        clr.b   ($FFFFFE1A).w
loc_010A5E:        
        move.w  #$09B, d0
        jsr     (Play_Music)            ; loc_0014C0
        moveq   #3, d0
        jmp     LoadPLC         ; loc_00173C   
loc_010A70:
        move.w  #$03C, objoff_3A(a0)
        tst.b   ($FFFFFE1A).w
        beq.s   loc_010A9C
        move.w  #0, objoff_3A(a0)
        move.b  #$39, ($FFFFB080).w
        move.b  #$39, ($FFFFB0C0).w
        move.b  #$2, ($FFFFB09A).w
        move.b  #3, ($FFFFB0DA).w
        bra.s   loc_010A5E
loc_010A9C:
        rts
;=============================================================================== 
; End of Sub Sonic_GameOver                
;===============================================================================         
        
Sonic_ResetLevel: ; loc_010A9E:
        tst.w   objoff_3A(a0)
        beq.s   loc_010AB0
        subq.w  #1, objoff_3A(a0)
        bne.s   loc_010AB0
        move.w  #$001, ($FFFFFE02).w
loc_010AB0:
        rts
        
;=============================================================================== 
; Beginning of Sub Sonic_Animate                
;===============================================================================          
Sonic_Animate: ; loc_010AB2:
        lea     (Sonic_AnimateData), A1 ; loc_010CB4
        moveq	#0,d0
        move.b  $001C(A0), D0
        cmp.b   $001D(A0), D0
        beq.s   loc_010ADA
        move.b  d0, $001D(a0)
        move.b  #0, $001B(a0)
        move.b  #0, $001E(a0)
        bclr    #5, status(a0)
loc_010ADA:
        add.w   d0, d0
        adda.w  $00(A1, d0), A1
        move.b  (A1), D0
        bmi.s   loc_010B4A
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        subq.b  #1, $001E(a0) 
        bpl.s   loc_010B18
        move.b  d0, $001E(a0)             
loc_010B00:        
        moveq   #0,d1
        move.b  $001B(A0), d1
        move.b  $01(A1, d1), D0
        cmpi.b  #$F0, d0
        bcc.s   loc_010B1A
loc_010B10:        
        move.b  d0, $001A(a0)
        addq.b  #1, $001B(a0)
loc_010B18:        
        rts
loc_010B1A:
        addq.b  #1,d0
        bne.s   loc_010B2A
        move.b  #0, $001B(a0)
        move.b  render_flags(A1), D0
        bra.s   loc_010B10
loc_010B2A:
        addq.b  #1,d0
        bne.s   loc_010B3E
        move.b  $02(A1, d1), D0
        sub.b   d0, $001B(a0)
        sub.b   d0, d1
        move.b  $01(A1, d1), D0
        bra.s   loc_010B10
loc_010B3E:
        addq.b  #1,d0
        bne.s   loc_010B48
        move.b  $02(A1, d1), $001C(a0)
loc_010B48: 
        rts            
loc_010B4A: 
        subq.b  #1, $001E(a0)
        bpl.s   loc_010B18
        addq.b  #1,d0
        bne     loc_010C3E
        moveq	#0,d0
        move.b  $0027(A0), D0
        bne     loc_010BD8
        moveq   #0,d1
        move.b  angle(A0), D0
        move.b  status(a0), D2
        andi.b  #1, D2
        bne.s   loc_010B72
        not.b  d0
loc_010B72:
        addi.b  #$10, d0
        bpl.s   loc_010B7A
        moveq   #3, d1
loc_010B7A:
        andi.b  #$FC,render_flags(a0)
        eor.b   d1, D2
        or.b    D2,render_flags(a0)
        btst    #5, status(a0)
        bne     loc_010C82
        lsr.b   #4, d0
        andi.b  #6, d0
        move.w  $14(A0), D2
        bpl.s   loc_010B9E
        neg.w   D2
loc_010B9E:
        lea     (Sonic_Animate_Run), A1 ; loc_010D00
        cmpi.w  #$600, D2
        bcc.s   loc_010BB0
        lea     (Sonic_Animate_Walk), A1 ; loc_010CF2
loc_010BB0:
        move.b  d0, d1
        lsr.b   #1,d1
        add.b   d1, d0
        add.b   d0, d0
        add.b   d0, d0
        move.b  d0, d3
        neg.w   D2
        addi.w  #$800, D2
        bpl.s   loc_010BC6
        moveq   #0, D2
loc_010BC6:
        lsr.w   #8, D2
        lsr.w   #1, D2
        move.b  D2, $001E(a0)
        bsr     loc_010B00
        add.b   d3, $001A(a0)
        rts    
loc_010BD8:
        move.b  $0027(A0), D0
        moveq   #0,d1
        move.b  status(a0), D2
        andi.b  #1, D2
        bne.s   loc_010C06
        andi.b  #$FC,render_flags(a0)
        addi.b  #$B, d0
        divu.w  #$016, d0
        addi.b  #$9B, d0
        move.b  d0, $001A(a0)
        move.b  #0, $001E(a0)
        rts
loc_010C06:
        andi.b  #$FC,render_flags(a0)
        tst.b   $0029(a0)
        beq.s   loc_010C1E
        ori.b   #1,render_flags(a0)
        addi.b  #$B, d0
        bra.s   loc_010C2A
loc_010C1E:
        ori.b   #3,render_flags(a0)
        neg.b   D0
        addi.b  #$8F, d0
loc_010C2A:
        divu.w  #$016, d0
        addi.b  #$9B, d0
        move.b  d0, $001A(a0)
        move.b  #0, $001E(a0)
        rts 
loc_010C3E:
        addq.b  #1,d0
        bne.s   loc_010C82
        move.w  $14(A0), D2
        bpl.s   loc_010C4A
        neg.w   D2
loc_010C4A:
        lea     (Sonic_Animate_Roll2), A1 ; loc_010D18
        cmpi.w  #$600, D2
        bcc.s   loc_010C5C
        lea     (Sonic_Animate_Roll), A1 ; loc_010D0E
loc_010C5C:
        neg.w   D2
        addi.w  #$400, D2
        bpl.s   loc_010C66
        moveq   #0, D2
loc_010C66:
        lsr.w   #8, D2
        move.b  D2, $001E(a0)
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        bra     loc_010B00
loc_010C82:        
        move.w  $14(A0), D2
        bmi.s   loc_010C8A
        neg.w   D2
loc_010C8A:
        addi.w  #$800, D2
        bpl.s   loc_010C92
        moveq   #0, D2
loc_010C92:
        lsr.w   #6, D2
        move.b  D2, $001E(a0)
        lea     (Sonic_Animate_Push), A1 ; loc_010D22
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        bra     loc_010B00                 
Sonic_AnimateData: ; loc_010CB4:
        dc.w    Sonic_Animate_Walk-Sonic_AnimateData        ; loc_010CF2
        dc.w    Sonic_Animate_Run-Sonic_AnimateData         ; loc_010D00
        dc.w    Sonic_Animate_Roll-Sonic_AnimateData        ; loc_010D0E
        dc.w    Sonic_Animate_Roll2-Sonic_AnimateData       ; loc_010D18 
        dc.w    Sonic_Animate_Push-Sonic_AnimateData        ; loc_010D22
        dc.w    Sonic_Animate_Wait-Sonic_AnimateData        ; loc_010D30
        dc.w    Sonic_Animate_Balance-Sonic_AnimateData     ; loc_010D59
        dc.w    Sonic_Animate_LookUp-Sonic_AnimateData      ; loc_010D5D
        dc.w    Sonic_Animate_Duck-Sonic_AnimateData        ; loc_010D62
        dc.w    Sonic_Animate_Spindash-Sonic_AnimateData    ; loc_010D67
        dc.w    Sonic_Animate_WallRecoil1-Sonic_AnimateData ; loc_010D74
        dc.w    Sonic_Animate_WallRecoil2-Sonic_AnimateData ; loc_010D77
        dc.w    Sonic_Animate_0x0C-Sonic_AnimateData        ; loc_010D7D
        dc.w    Sonic_Animate_Stop-Sonic_AnimateData        ; loc_010D81
        dc.w    Sonic_Animate_Float1-Sonic_AnimateData      ; loc_010D8C
        dc.w    Sonic_Animate_Float2-Sonic_AnimateData      ; loc_010D90
        dc.w    Sonic_Animate_0x10-Sonic_AnimateData        ; loc_010D97
        dc.w    Sonic_Animate_S1LzHang-Sonic_AnimateData    ; loc_010D9B
        dc.w    Sonic_Animate_Unused_0x12-Sonic_AnimateData ; loc_010D9F
        dc.w    Sonic_Animate_Unused_0x13-Sonic_AnimateData ; loc_010DA5
        dc.w    Sonic_Animate_Unused_0x14-Sonic_AnimateData ; loc_010DAA
        dc.w    Sonic_Animate_Bubble-Sonic_AnimateData      ; loc_010DAD
        dc.w    Sonic_Animate_Death1-Sonic_AnimateData      ; loc_010DB4
        dc.w    Sonic_Animate_Drown-Sonic_AnimateData       ; loc_010DB7
        dc.w    Sonic_Animate_Death2-Sonic_AnimateData      ; loc_010DBA
        dc.w    Sonic_Animate_Unused_0x19-Sonic_AnimateData ; loc_010DBD
        dc.w    Sonic_Animate_Hurt-Sonic_AnimateData        ; loc_010DC6
        dc.w    Sonic_Animate_S1LzSlide-Sonic_AnimateData   ; loc_010DC9
        dc.w    Sonic_Animate_0x1C-Sonic_AnimateData        ; loc_010DCD
        dc.w    Sonic_Animate_Float3-Sonic_AnimateData      ; loc_010DD1
        dc.w    Sonic_Animate_0x1E-Sonic_AnimateData        ; loc_010DD8
Sonic_Animate_Walk: ; loc_010CF2:
        dc.b    $FF, $10, $11, $12, $13, $14, $15, $16, $17, $0C, $0D, $0E, $0F, $FF
Sonic_Animate_Run: ; loc_010D00:
        dc.b    $FF, $3C, $3D, $3E, $3F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
Sonic_Animate_Roll: ; loc_010D0E:
        dc.b    $FE, $6C, $70, $6D, $70, $6E, $70, $6F, $70, $FF
Sonic_Animate_Roll2: ; loc_010D18:
        dc.b    $FE, $6C, $70, $6D, $70, $6E, $70, $6F, $70, $FF
Sonic_Animate_Push: ; loc_010D22:
        dc.b    $FD, $77, $78, $79, $7A, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
Sonic_Animate_Wait: ; loc_010D30:        
        dc.b    $07, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01
        dc.b    $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $02
        dc.b    $03, $03, $03, $04, $04, $05, $05, $FE, $04
Sonic_Animate_Balance: ; loc_010D59:         
        dc.b    $07, $89, $8A, $FF
Sonic_Animate_LookUp: ; loc_010D5D:        
        dc.b    $05, $06, $07, $FE, $01
Sonic_Animate_Duck: ; loc_010D62:          
        dc.b    $05, $7F, $80, $FE, $01
Sonic_Animate_Spindash: ; loc_010D67:        
        dc.b    $00, $71, $72, $71, $73, $71, $74, $71, $75, $71, $76, $71, $FF 
Sonic_Animate_WallRecoil1: ; loc_010D74:        
        dc.b    $3F, $82, $FF
Sonic_Animate_WallRecoil2: ; loc_010D77:
        dc.b    $07, $08, $08, $09, $FD, $05
Sonic_Animate_0x0C: ; loc_010D7D:        
        dc.b    $07, $09, $FD, $05
Sonic_Animate_Stop: ; loc_010D81:         
        dc.b    $03, $81, $82, $83, $84, $85, $86, $87, $88, $FE, $02
Sonic_Animate_Float1: ; loc_010D8C:         
        dc.b    $07, $94, $96, $FF
Sonic_Animate_Float2: ; loc_010D90:        
        dc.b    $07, $91, $92, $93, $94, $95, $FF
Sonic_Animate_0x10: ; loc_010D97:        
        dc.b    $2F, $7E, $FD, $00
Sonic_Animate_S1LzHang: ; loc_010D9B:        
        dc.b    $05, $8F, $90, $FF
Sonic_Animate_Unused_0x12: ; loc_010D9F:        
        dc.b    $0F, $43, $43, $43, $FE, $01
Sonic_Animate_Unused_0x13: ; loc_010DA5:        
        dc.b    $0F, $43, $44, $FE, $01
Sonic_Animate_Unused_0x14: ; loc_010DAA:        
        dc.b    $3F, $49, $FF
Sonic_Animate_Bubble: ; loc_010DAD:         
        dc.b    $0B, $97, $97, $12, $13, $FD, $00
Sonic_Animate_Death1: ; loc_010DB4:         
        dc.b    $20, $9A, $FF
Sonic_Animate_Drown: ; loc_010DB7:        
        dc.b    $20, $99, $FF
Sonic_Animate_Death2: ; loc_010DBA:         
        dc.b    $20, $98, $FF
Sonic_Animate_Unused_0x19: ; loc_010DBD: 
        dc.b    $03, $4E, $4F, $50, $51, $52, $00, $FE, $01
Sonic_Animate_Hurt: ; loc_010DC6:        
        dc.b    $40, $8D, $FF
Sonic_Animate_S1LzSlide: ; loc_010DC9:          
        dc.b    $09, $8D, $8E, $FF
Sonic_Animate_0x1C: ; loc_010DCD:        
        dc.b    $77, $00, $FD, $00
Sonic_Animate_Float3: ; loc_010DD1:        
        dc.b    $03, $91, $92, $93, $94, $95, $FF
Sonic_Animate_0x1E: ; loc_010DD8:        
        dc.b    $03, $3C, $FD, $00
;=============================================================================== 
; End of Sub Sonic_Animate                
;===============================================================================
           
;=============================================================================== 
; Beginning of Sub Load_Sonic_Dynamic_PLC                
;===============================================================================          
Load_Sonic_Dynamic_PLC: ; loc_010DDC:
        moveq	#0,d0
        move.b  $001A(A0), D0
        cmp.b   ($FFFFF766).w, d0
        beq.s   loc_010E2E
        move.b  d0, ($FFFFF766).w
        lea     (Sonic_Dyn_Script), A2  ; loc_06DA4C
        add.w   d0, d0
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D5
        subq.w  #1,d5
        bmi.s   loc_010E2E
        move.w  #$F000, D4
loc_010E02:
        moveq   #0,d1
        move.w  (A2)+, d1
        move.w  d1, d3
        lsr.w   #8, d3
        andi.w  #$0F0, d3
        addi.w  #$010, d3
        andi.w  #$FFF, d1
        lsl.l   #5, d1
        addi.l  #Sonic_Sprites, d1      ; loc_050000
        move.w  d4, D2
        add.w   d3, D4
        add.w   d3, D4
        jsr     DMA_68KtoVRAM           ; loc_00156C
        dbra    d5, loc_010E02
loc_010E2E:        
        rts
J_KillSonic_00: ; loc_010E30:
        jmp     KillSonic               ; loc_021422  
;=============================================================================== 
; End of Sub Load_Sonic_Dynamic_PLC                
;===============================================================================                  
;=============================================================================== 
; Object 0x01 - Sonic
;===============================================================================        
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x02 - Tails
;===============================================================================  
Obj02_Tails: ; loc_010E38:         
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Tails_Index(pc,d0), d1      ; loc_010E46
        jmp     Tails_Index(pc,d1)          ; loc_010E46
Tails_Index: ; loc_010E46:
        dc.w    Tails_Main-Tails_Index       ; loc_010E50
        dc.w    Tails_Control-Tails_Index    ; loc_010EB4
        dc.w    Tails_Hurt-Tails_Index       ; loc_011AC4
        dc.w    Tails_Death-Tails_Index      ; loc_011B32
        dc.w    Tails_ResetLevel-Tails_Index ; loc_011B8E
Tails_Main: ; loc_010E50:
        addq.b  #2,routine(a0)
        move.b  #$F, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.l  #Tails_Mappings,mappings(a0) ; loc_06FB3C
        move.w  #$7A0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$2, $0018(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #$84,render_flags(a0)
        move.w  #$600, ($FFFFF760).w
        move.w  #$00C, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        move.b  #$C, Objoff_3E(a0)
        move.b  #$D, Objoff_3F(a0)
        move.b  #0, $002C(a0)
        move.b  #4, $002D(a0)
        move.b  #5, ($FFFFB1C0).w
Tails_Control: ; loc_010EB4:
        bsr     Tails_Control2          ; loc_010F96
        btst    #0, $002A(a0)
        bne.s   Tails_ControlsLock      ; loc_010ED2
        moveq	#0,d0
        move.b  status(a0), D0
        andi.w  #$006, d0
        move.w  Tails_Modes(pc,d0), d1 ; loc_010EFA
        jsr     Tails_Modes(pc,d1)     ; loc_010EFA
Tails_ControlsLock: ; loc_010ED2:
        bsr.s   Tails_Display           ; loc_010F12
        bsr     Tails_RecordMoves       ; loc_011056
        move.b  ($FFFFF768).w, objoff_36(a0)
        move.b  ($FFFFF76A).w, $0037(a0)
        bsr     Tails_Animate           ; loc_011BA2
        tst.b   $002A(a0)
        bmi.s   loc_010EF4
        jsr     TouchResponse           ; loc_021160
loc_010EF4:
        bsr     Load_Tails_Dynamic_PLC  ; loc_011F42
        rts
Tails_Modes: ; loc_010EFA:
        dc.w    Tails_MdNormal-Tails_Modes  ; loc_011070
        dc.w    Tails_MdJump-Tails_Modes    ; loc_011098
        dc.w    Tails_MdRoll-Tails_Modes    ; loc_0110C2
        dc.w    Tails_MdJump2-Tails_Modes   ; loc_0110E2
Tails_PlayList: ; loc_010F02:
        dc.b    $82, $82, $83, $90, $83, $83, $93, $96, $86, $8F, $81, $85, $84, $8D, $8D, $87 

;=============================================================================== 
; Beginning of Sub Tails_Display
                 
;===============================================================================                  
Tails_Display: ; loc_010F12:
        move.w  Objoff_30(A0), D0
        beq.s   loc_010F20
        subq.w  #1, Objoff_30(a0)
        lsr.w   #3, d0
        bcc.s   loc_010F26
loc_010F20:
        jsr     DisplaySprite           ; loc_00D3C2
loc_010F26:
        tst.b   ($FFFFFE2D).w
        beq.s   loc_010F60
        tst.w   $0032(a0)
        beq.s   loc_010F60
        subq.w  #1, $0032(a0)
        bne.s   loc_010F60
        tst.b   ($FFFFF7AA).w
        bne.s   loc_010F5A
        cmpi.w  #$00C, ($FFFFFE14).w
        bcs.s   loc_010F5A
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        lea     Tails_PlayList(PC), A1  ; loc_010F02
        move.b  $00(A1, d0), D0
        jsr     (Play_Music)            ; loc_0014C0
loc_010F5A:
        move.b  #0, ($FFFFFE2D).w
loc_010F60:
        tst.b   ($FFFFFE2E).w
        beq.s   loc_010F94
        tst.w   Objoff_34(a0)
        beq.s   loc_010F94
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_010F94
        move.w  #$600, ($FFFFF760).w
        move.w  #$00C, ($FFFFF762).w
        move.w  #$080, ($FFFFF764).w
        move.b  #0, ($FFFFFE2E).w
        move.w  #$0FC, d0
        jmp     (Play_Music)            ; loc_0014C0
loc_010F94:
        rts  
;=============================================================================== 
; End of Sub Tails_Display                
;===============================================================================   

;=============================================================================== 
; Beginning of Sub Tails_Control2              
;===============================================================================     
Tails_Control2: ; loc_010F96:
        move.b  ($FFFFF606).w, d0
        andi.b  #$7F, d0
        beq.s   Tails_ControlNoKeysPressed    ; loc_010FAE
        move.w  #0, ($FFFFF700).w
        move.w  #$12C, ($FFFFF702).w
        rts
Tails_ControlNoKeysPressed: ; loc_010FAE:
        tst.w   ($FFFFF702).w
        beq.s   Tails_DoControl        ; loc_010FBA
        subq.w  #1, ($FFFFF702).w
        rts
Tails_DoControl: ; loc_010FBA:
        move.w  ($FFFFF708).w, d0
        move.w  Tails_ControlIndex(pc,d0), D0 ; loc_010FC6
        jmp     Tails_ControlIndex(pc,d0)     ; loc_010FC6
Tails_ControlIndex: ; loc_010FC6:
        dc.w    Tails_Control_00-Tails_ControlIndex  ; loc_010FCE
        dc.w    Tails_Control_01-Tails_ControlIndex  ; loc_010FD6
        dc.w    Tails_Control_02-Tails_ControlIndex  ; loc_010FEA
        dc.w    Tails_ControlCopySonicMoves-Tails_ControlIndex ; loc_011024
Tails_Control_00: ; loc_010FCE:
        move.w  #$006, ($FFFFF708).w
        rts
Tails_Control_01: ; loc_010FD6:
        move.w  #$006, ($FFFFF708).w
        rts
        move.w  #$40, ($FFFFF706).w
        move.w  #$004, ($FFFFF708).w
Tails_Control_02: ; loc_010FEA:
        move.w  #$006, ($FFFFF708).w
        rts
        move.w  ($FFFFF706).w, d1
        subq.w  #1,d1
        cmpi.w  #$010, d1
        bne.s   loc_011004
        move.w  #$006, ($FFFFF708).w
loc_011004:
        move.w  d1, ($FFFFF706).w
        lea     ($FFFFE600).w, A1
        lsl.b   #$2, d1
        addq.b  #4, d1
        move.w  ($FFFFEEE0).w, d0
        sub.b   d1, d0
        move.w  $00(A1, d0), x_pos(a0)
        move.w  $02(A1, d0), y_pos(a0)
        rts
Tails_ControlCopySonicMoves: ; loc_011024:
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        bpl.s   loc_011030
        neg.w   D0
loc_011030:
        cmpi.w  #$0C0, d0
        bcs.s   loc_011038
        nop
loc_011038:
        lea     ($FFFFE500).w, A1
        move.w  #$010, d1
        lsl.b   #$2, d1
        addq.b  #4, d1
        move.w  ($FFFFEED2).w, d0
        sub.b   d1, d0
        lea     ($FFFFE400).w, A1
        move.w  $00(A1, d0), ($FFFFF606).w
        rts
        
;=============================================================================== 
; Beginning of Sub Tails_RecordMoves                
;===============================================================================    
Tails_RecordMoves: ; loc_011056:
        move.w  ($FFFFEED6).w, d0
        lea     ($FFFFE700).w, A1
        lea     $00(A1, d0), A1
        move.w  x_pos(a0), (A1)+
        move.w  y_pos(a0), (A1)+
        addq.b  #4, ($FFFFEED7).w
        rts
;=============================================================================== 
; End of Sub Tails_RecordMoves                
;===============================================================================   
               
Tails_MdNormal: ; loc_011070:
        bsr     Tails_Spindash          ; loc_0116D2
        bsr     Tails_Jump              ; loc_0115E8
        bsr     Tails_SlopeResist       ; loc_01175E
        bsr     Tails_Move              ; loc_01110C
        bsr     Tails_Roll              ; loc_011582
        bsr     Tails_LevelBoundaries   ; loc_0114FE
        jsr     SpeedToPos              ; loc_00D27A
        bsr     Sonic_AnglePos          ; loc_012D28
        bsr     Tails_SlopeRepel        ; loc_0117D0
        rts
Tails_MdJump: ; loc_011098:
        bsr     Tails_JumpHeight        ; loc_011696
        bsr     Tails_ChgJumpDir        ; loc_011484
        bsr     Tails_LevelBoundaries   ; loc_0114FE
        jsr     ObjectFall              ; loc_00D24E
        btst    #6, status(a0)
        beq.s   loc_0110B8
        subi.w  #$028, $0012(a0)
loc_0110B8:
        bsr     Tails_JumpAngle         ; loc_011812
        bsr     Tails_Floor             ; loc_011872
        rts
Tails_MdRoll: ; loc_0110C2:
        bsr     Tails_Jump              ; loc_0115E8
        bsr     Tails_RollRepel         ; loc_011794
        bsr     Tails_RollSpeed         ; loc_01138C
        bsr     Tails_LevelBoundaries   ; loc_0114FE
        jsr     SpeedToPos              ; loc_00D27A
        bsr     Sonic_AnglePos          ; loc_012D28
        bsr     Tails_SlopeRepel        ; loc_0117D0
        rts
Tails_MdJump2: ; loc_0110E2:
        bsr     Tails_JumpHeight        ; loc_011696
        bsr     Tails_ChgJumpDir        ; loc_011484
        bsr     Tails_LevelBoundaries   ; loc_0114FE
        jsr     ObjectFall              ; loc_00D24E
        btst    #6, status(a0)
        beq.s   loc_011102
        subi.w  #$028, $0012(a0)
loc_011102:
        bsr     Tails_JumpAngle         ; loc_011812
        bsr     Tails_Floor             ; loc_011872
        rts
        
;=============================================================================== 
; Beginning of Sub Tails_Move
                 
;===============================================================================          
Tails_Move: ; loc_01110C:
        move.w  ($FFFFF760).w, D6
        move.w  ($FFFFF762).w,d5
        move.w  ($FFFFF764).w, D4
        tst.b   ($FFFFF7CA).w
        bne     loc_01121E
        tst.w   $002E(a0)
        bne     loc_0111F2
        btst    #$2, ($FFFFF606).w
        beq.s   loc_011134
        bsr     Tails_MoveLeft          ; loc_0112AE
loc_011134:
        btst    #3, ($FFFFF606).w
        beq.s   loc_011140
        bsr     Tails_MoveRight         ; loc_011320
loc_011140:
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne     loc_0111F2
        tst.w   $14(a0)
        bne     loc_0111F2
        bclr    #5, status(a0)
        move.b  #5, $001C(a0)
        btst    #3, status(a0)
        beq.s   Tails_Balance           ; loc_0111A2
        moveq	#0,d0
        move.b  objoff_3D(A0), D0
        lsl.w   #6, d0
        lea     (MainCharacter).w, A1
        lea     $00(A1, d0), A1
        tst.b   status(a1)
        bmi.s   Tails_LookUp            ; loc_0111D4
        moveq   #0,d1
        move.b  $0019(A1), d1
        move.w  d1, D2
        add.w   D2, D2
        subq.w  #4, D2
        add.w   x_pos(a0), d1
        sub.w   x_pos(A1), d1
        cmpi.w  #$004, d1
        blt.s   loc_0111C6
        cmp.w   D2, d1
        bge.s   loc_0111B6
        bra.s   Tails_LookUp            ; loc_0111D4 
;=============================================================================== 
Tails_Balance: ; loc_0111A2:
        jsr     ObjHitFloor             ; loc_013898
        cmpi.w  #$00C, d1
        blt.s   Tails_LookUp            ; loc_0111D4
        cmpi.b  #3, objoff_36(a0)
        bne.s   loc_0111BE
loc_0111B6:
        bclr    #0, status(a0)
        bra.s   loc_0111CC
loc_0111BE:
        cmpi.b  #3, $0037(a0)
        bne.s   Tails_LookUp            ; loc_0111D4
loc_0111C6:
        bset    #0, status(a0)
loc_0111CC:
        move.b  #6, $001C(a0)
        bra.s   loc_0111F2
;===============================================================================               
Tails_LookUp: ; loc_0111D4:
        btst    #0, ($FFFFF606).w
        beq.s   loc_0111E4
        move.b  #$7, $001C(a0)
        bra.s   loc_0111F2
loc_0111E4:
        btst    #1, ($FFFFF606).w
        beq.s   loc_0111F2
        move.b  #8, $001C(a0)
loc_0111F2:
        move.b  ($FFFFF606).w, d0
        andi.b  #$C, d0
        bne.s   loc_01121E
        move.w  $14(A0), D0
        beq.s   loc_01121E
        bmi.s   loc_011212
        sub.w   d5, d0
        bcc.s   loc_01120C
        move.w  #0, d0
loc_01120C:
        move.w  d0, $14(a0)
        bra.s   loc_01121E
loc_011212:
        add.w   d5, d0
        bcc.s   loc_01121A
        move.w  #0, d0
loc_01121A:
        move.w  d0, $14(a0)
loc_01121E:
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), d1
        asr.l   #8, d1
        move.w  d1,x_vel(a0)
        muls.w  $14(A0), D0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
loc_01123C:        
        move.b  angle(A0), D0
        addi.b  #$40, d0
        bmi.s   loc_0112AC
        move.b  #$40, d1
        tst.w   $14(a0)
        beq.s   loc_0112AC
        bmi.s   loc_011254
        neg.w   d1
loc_011254:
        move.b  angle(A0), D0
        add.b   d1, d0
        move.w  d0, -(A7)
        bsr     Sonic_WalkSpeed         ; loc_01366C
        move.w  (A7)+, D0
        tst.w   d1
        bpl.s   loc_0112AC
        asl.w   #8, d1
        addi.b  #$20, d0
        andi.b  #$C0, d0
        beq.s   loc_0112A8
        cmpi.b  #$40, d0
        beq.s   loc_011296
        cmpi.b  #$80, d0
        beq.s   loc_011290
        add.w   d1,x_vel(a0)
        bset    #5, status(a0)
        move.w  #0, $14(a0)
        rts
loc_011290:
        sub.w   d1, $0012(a0)
        rts
loc_011296:
        sub.w   d1,x_vel(a0)
        bset    #5, status(a0)
        move.w  #0, $14(a0)
        rts
loc_0112A8:
        add.w   d1, $0012(a0)
loc_0112AC:
        rts
;=============================================================================== 
; End of Sub Tails_Move                
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub Tails_MoveLeft                 
;===============================================================================           
Tails_MoveLeft: ; loc_0112AE:
        move.w  $14(A0), D0
        beq.s   loc_0112B6
        bpl.s   loc_0112E8
loc_0112B6:
        bset    #0, status(a0)
        bne.s   loc_0112CA
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
loc_0112CA:
        sub.w   d5, d0
        move.w  d6, d1
        neg.w   d1
        cmp.w   d1, d0
        bgt.s   loc_0112DC
        add.w   d5, d0
        cmp.w   d1, d0
        ble.s   loc_0112DC
        move.w  d1, d0
loc_0112DC:
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        rts
loc_0112E8:
        sub.w   d4, d0
        bcc.s   loc_0112F0
        move.w  #$FF80, d0
loc_0112F0:
        move.w  d0, $14(a0)
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne.s   loc_01131E
        cmpi.w  #$400, d0
        blt.s   loc_01131E
        move.b  #$D, $001C(a0)
        bclr    #0, status(a0)
        move.w  #$0A4, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01131E:
        rts
;=============================================================================== 
; End of Sub Tails_MoveLeft                
;===============================================================================   
              
;=============================================================================== 
; Beginning of Sub Tails_MoveRight               
;===============================================================================         
Tails_MoveRight: ; loc_011320:
        move.w  $14(A0), D0
        bmi.s   loc_011354
        bclr    #0, status(a0)
        beq.s   loc_01133A
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
loc_01133A:
        add.w   d5, d0
        cmp.w   d6, d0
        blt.s   loc_011348
        sub.w   d5, d0
        cmp.w   d6, d0
        bge.s   loc_011348
        move.w  d6, d0
loc_011348:
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        rts
loc_011354:
        add.w   d4, d0
        bcc.s   loc_01135C
        move.w  #$080, d0
loc_01135C:
        move.w  d0, $14(a0)
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        bne.s   loc_01138A
        cmpi.w  #$FC00, d0
        bgt.s   loc_01138A
        move.b  #$D, $001C(a0)
        bset    #0, status(a0)
        move.w  #$0A4, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01138A:
        rts
;=============================================================================== 
; End of Sub Tails_MoveRight                
;===============================================================================  
         
;=============================================================================== 
; Beginning of Sub Tails_RollSpeed               
;===============================================================================         
Tails_RollSpeed: ; loc_01138C:
        move.w  ($FFFFF760).w, D6
        asl.w   #1, D6
        move.w  ($FFFFF762).w,d5
        asr.w   #1,d5
        move.w  ($FFFFF764).w, D4
        asr.w   #$2, D4
        tst.b   ($FFFFF7CA).w
        bne     loc_011408
        tst.w   $002E(a0)
        bne.s   loc_0113C4
        btst    #$2, ($FFFFF606).w
        beq.s   loc_0113B8
        bsr     Tails_RollLeft          ; loc_01143E
loc_0113B8:
        btst    #3, ($FFFFF606).w
        beq.s   loc_0113C4
        bsr     Tails_RollRight         ; loc_011462
loc_0113C4:
        move.w  $14(A0), D0
        beq.s   loc_0113E6
        bmi.s   loc_0113DA
        sub.w   d5, d0
        bcc.s   loc_0113D4
        move.w  #0, d0
loc_0113D4:
        move.w  d0, $14(a0)
        bra.s   loc_0113E6
loc_0113DA:
        add.w   d5, d0
        bcc.s   loc_0113E2
        move.w  #0, d0
loc_0113E2:
        move.w  d0, $14(a0)
loc_0113E6:
        tst.w   $14(a0)
        bne.s   loc_011408
        bclr    #$2, status(a0)
        move.b  #$F, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.b  #5, $001C(a0)
        subq.w  #5, y_pos(a0)
loc_011408:
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), D0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
        muls.w  $14(A0), d1
        asr.l   #8, d1
        cmpi.w  #$1000, d1
        ble.s   loc_01142C
        move.w  #$1000, d1
loc_01142C:
        cmpi.w  #$F000, d1
        bge.s   loc_011436
        move.w  #$F000, d1
loc_011436:
        move.w  d1,x_vel(a0)
        bra     loc_01123C
;=============================================================================== 
; End of Sub Tails_RollSpeed
                
;===============================================================================
  
;=============================================================================== 
; Beginning of Sub Tails_RollLeft
                 
;===============================================================================           
Tails_RollLeft: ; loc_01143E:
        move.w  $14(A0), D0
        beq.s   loc_011446
        bpl.s   loc_011454
loc_011446:
        bset    #0, status(a0)
        move.b  #$2, $001C(a0)
        rts
loc_011454:
        sub.w   d4, d0
        bcc.s   loc_01145C
        move.w  #$FF80, d0
loc_01145C:
        move.w  d0, $14(a0)
        rts
;=============================================================================== 
; End of Sub Tails_RollLeft
                
;===============================================================================
   
;=============================================================================== 
; Beginning of Sub Tails_RollRight
                 
;===============================================================================           
Tails_RollRight: ; loc_011462:
        move.w  $14(A0), D0
        bmi.s   loc_011476
        bclr    #0, status(a0)
        move.b  #$2, $001C(a0)
        rts
loc_011476:
        add.w   d4, d0
        bcc.s   loc_01147E
        move.w  #$080, d0
loc_01147E:
        move.w  d0, $14(a0)
        rts
;=============================================================================== 
; End of Sub Tails_RollRight
                
;===============================================================================  
          
;=============================================================================== 
; Beginning of Sub Tails_ChgJumpDir
                 
;===============================================================================          
Tails_ChgJumpDir: ; loc_011484:
        move.w  ($FFFFF760).w, D6
        move.w  ($FFFFF762).w,d5
        asl.w   #1,d5
        btst    #4, status(a0)
        bne.s   loc_0114CE
        move.w x_vel(A0), D0
        btst    #$2, ($FFFFF606).w
        beq.s   loc_0114B4
        bset    #0, status(a0)
        sub.w   d5, d0
        move.w  d6, d1
        neg.w   d1
        cmp.w   d1, d0
        bgt.s   loc_0114B4
        move.w  d1, d0
loc_0114B4:
        btst    #3, ($FFFFF606).w
        beq.s   loc_0114CA
        bclr    #0, status(a0)
        add.w   d5, d0
        cmp.w   d6, d0
        blt.s   loc_0114CA
        move.w  d6, d0
loc_0114CA:
        move.w  d0,x_vel(a0)
loc_0114CE:
        cmpi.w  #$FC00, $0012(a0)
        bcs.s   loc_0114FC
        move.w x_vel(A0), D0
        move.w  d0, d1
        asr.w   #5, d1
        beq.s   loc_0114FC
        bmi.s   loc_0114F0
        sub.w   d1, d0
        bcc.s   loc_0114EA
        move.w  #0, d0
loc_0114EA:
        move.w  d0,x_vel(a0)
        rts
loc_0114F0:
        sub.w   d1, d0
        bcs.s   loc_0114F8
        move.w  #0, d0
loc_0114F8:
        move.w  d0,x_vel(a0)
loc_0114FC:
        rts 
;=============================================================================== 
; End of Sub Tails_ChgJumpDir
                
;===============================================================================
            
;=============================================================================== 
; Beginning of Sub Tails_LevelBoundaries
                 
;=============================================================================== 
Tails_LevelBoundaries: ; loc_0114FE:
        move.l  x_pos(a0), d1
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d1
        swap.w  d1
        move.w  ($FFFFEEC8).w, d0
        addi.w  #$010, d0
        cmp.w   d1, d0
        bhi.s   loc_01156A
        move.w  ($FFFFEECA).w, d0
        addi.w  #$128, d0
        tst.b   ($FFFFF7AA).w
        bne.s   loc_01152C
        addi.w  #$40, d0
loc_01152C:
        cmp.w   d1, d0
        bls.s   loc_01156A
loc_011530:        
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        blt.s   loc_011540
        rts
loc_011540:
        bra     KillTails               ; loc_012074
        cmpi.w  #$501, (Current_ZoneAndAct).w
        bne     KillTails               ; loc_012074
        cmpi.w  #$2000, x_pos(a0)
        bcs     KillTails               ; loc_012074
        clr.b   (Last_star_pole_hit).w
        move.w  #$001, ($FFFFFE02).w
        move.w  #$103, (Current_ZoneAndAct).w
        rts
loc_01156A:
        move.w  d0, x_pos(a0)
        move.w  #0, $000A(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $14(a0)
        bra.s   loc_011530
;=============================================================================== 
; End of Sub Tails_LevelBoundaries
                
;===============================================================================  
               
;=============================================================================== 
; Beginning of Sub Tails_Roll
                 
;===============================================================================           
Tails_Roll: ; loc_011582:
        tst.b   ($FFFFF7CA).w
        bne.s   loc_0115A8
        move.w  $14(A0), D0
        bpl.s   loc_011590
        neg.w   D0
loc_011590:
        cmpi.w  #$080, d0
        bcs.s   loc_0115A8
        move.b  ($FFFFF606).w, d0
        andi.b  #$C, d0
        bne.s   loc_0115A8
        btst    #1, ($FFFFF606).w
        bne.s   loc_0115AA
loc_0115A8:
        rts
loc_0115AA:
        btst    #$2, status(a0)
        beq.s   loc_0115B4
        rts
loc_0115B4:
        bset    #$2, status(a0)
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        addq.w  #5, y_pos(a0)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        tst.w   $14(a0)
        bne.s   loc_0115E6
        move.w  #$200, $14(a0)
loc_0115E6:
        rts
;=============================================================================== 
; End of Sub Tails_Roll
                
;=============================================================================== 
         
;=============================================================================== 
; Beginning of Sub Tails_Jump
                 
;===============================================================================          
Tails_Jump: ; loc_0115E8:
        move.b  (Ctrl_2_Press).w, d0
        andi.b  #$70, d0
        beq     loc_01168C
        moveq	#0,d0
        move.b  angle(A0), D0
        addi.b  #$80, d0
        bsr     loc_0136F2
        cmpi.w  #$006, d1
        blt     loc_01168C
        move.w  #$680, D2
        btst    #6, status(a0)
        beq.s   loc_01161A
        move.w  #$380, D2
loc_01161A:
        moveq	#0,d0
        move.b  angle(A0), D0
        subi.b  #$40, d0
        jsr     CalcSine        ; loc_00320A
        muls.w  D2, d1
        asr.l   #8, d1
        add.w   d1,x_vel(a0)
        muls.w  d2, d0
        asr.l   #8,d0
        add.w   d0, $0012(a0)
        bset    #1, status(a0)
        bclr    #5, status(a0)
        addq.l  #4, A7
        move.b  #1, Objoff_3C(a0)
        clr.b   objoff_38(a0)
        move.w  #$0A0, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        move.b  #$F, y_radius(a0)
        move.b  #$9, $0017(a0)
        btst    #$2, status(a0)
        bne.s   loc_01168E
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        bset    #$2, status(a0)
        addq.w  #5, y_pos(a0)
loc_01168C:
        rts
loc_01168E:
        bset    #4, status(a0)
        rts
;=============================================================================== 
; End of Sub Tails_Jump
                
;===============================================================================     
              
;=============================================================================== 
; Beginning of Sub Tails_JumpHeight
                 
;===============================================================================           
Tails_JumpHeight: ; loc_011696:
        tst.b   Objoff_3C(a0)
        beq.s   loc_0116C2
        move.w  #$FC00, d1
        btst    #6, status(a0)
        beq.s   loc_0116AC
        move.w  #$FE00, d1
loc_0116AC:
        cmp.w   $0012(A0), d1
        ble.s   loc_0116C0
        move.b  ($FFFFF606).w, d0
        andi.b  #$70, d0
        bne.s   loc_0116C0
        move.w  d1, $0012(a0)
loc_0116C0:
        rts
loc_0116C2:
        cmpi.w  #$F040, $0012(a0)
        bge.s   loc_0116D0
        move.w  #$F040, $0012(a0)
loc_0116D0:
        rts
;=============================================================================== 
; End of Sub Tails_JumpHeight
                
;=============================================================================== 
         
;=============================================================================== 
; Beginning of Sub Tails_Spindash
                 
;===============================================================================          
Tails_Spindash: ; loc_0116D2:
        tst.b   $0039(a0)
        bne.s   loc_011706
        cmpi.b  #8, $001C(a0)
        bne.s   loc_011704
        move.b  (Ctrl_2_Press).w, d0
        andi.b  #$70, d0
        beq     loc_011704
        move.b  #$9, $001C(a0)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.l  #4, A7
        move.b  #1, $0039(a0)
loc_011704:
        rts
loc_011706:
        move.b  ($FFFFF606).w, d0
        btst    #1,d0
        bne.s   loc_01174C
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.b  #$2, $001C(a0)
        addq.w  #5, y_pos(a0)
        move.b  #0, $0039(a0)
        move.w  #$2000, ($FFFFEED4).w
        move.w  #$800, $14(a0)
        btst    #0, status(a0)
        beq.s   loc_011744
        neg.w   $14(a0)
loc_011744:
        bset    #$2, status(a0)
        rts
loc_01174C:
        move.b  (Ctrl_2_Press).w, d0
        andi.b  #$70, d0
        beq     loc_01175A
        nop
loc_01175A:
        addq.l  #4, A7
        rts   
;=============================================================================== 
; End of Sub Tails_Spindash
                
;===============================================================================   
 
;=============================================================================== 
; Beginning of Sub Tails_SlopeResist
                 
;===============================================================================           
Tails_SlopeResist: ; loc_01175E:
        move.b  angle(A0), D0
        addi.b  #$60, d0
        cmpi.b  #$C0, d0
        bcc.s   loc_011792
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  #$20, d0
        asr.l   #8,d0
        tst.w   $14(a0)
        beq.s   loc_011792
        bmi.s   loc_01178E
        tst.w   D0
        beq.s   loc_01178C
        add.w   d0, $14(a0)
loc_01178C:
        rts
loc_01178E:
        add.w   d0, $14(a0)
loc_011792:
        rts
;=============================================================================== 
; End of Sub Tails_SlopeResist
                
;===============================================================================     
             
;=============================================================================== 
; Beginning of Sub Tails_RollRepel
                 
;===============================================================================           
Tails_RollRepel: ; loc_011794:
        move.b  angle(A0), D0
        addi.b  #$60, d0
        cmpi.b  #$C0, d0
        bcc.s   loc_0117CE
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  #$050, d0
        asr.l   #8,d0
        tst.w   $14(a0)
        bmi.s   loc_0117C4
        tst.w   D0
        bpl.s   loc_0117BE
        asr.l   #$2, d0
loc_0117BE:
        add.w   d0, $14(a0)
        rts
loc_0117C4:
        tst.w   D0
        bmi.s   loc_0117CA
        asr.l   #$2, d0
loc_0117CA:
        add.w   d0, $14(a0)
loc_0117CE:
        rts
;=============================================================================== 
; End of Sub Tails_RollRepel
                
;===============================================================================   
        
;=============================================================================== 
; Beginning of Sub Tails_SlopeRepel
                 
;===============================================================================          
Tails_SlopeRepel: ; loc_0117D0:
        nop
        tst.b   objoff_38(a0)
        bne.s   loc_01180A
        tst.w   $002E(a0)
        bne.s   loc_01180C
        move.b  angle(A0), D0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        beq.s   loc_01180A
        move.w  $14(A0), D0
        bpl.s   loc_0117F4
        neg.w   D0
loc_0117F4:
        cmpi.w  #$280, d0
        bcc.s   loc_01180A
        clr.w   $14(a0)
        bset    #1, status(a0)
        move.w  #$01E, $002E(a0)
loc_01180A:
        rts
loc_01180C:
        subq.w  #1, $002E(a0)
        rts
;=============================================================================== 
; End of Sub Tails_SlopeRepel
                
;===============================================================================  
         
;=============================================================================== 
; Beginning of Sub Tails_JumpAngle
                 
;===============================================================================          
Tails_JumpAngle: ; loc_011812:
        move.b  angle(A0), D0
        beq.s   loc_01182C
        bpl.s   loc_011822
        addq.b  #$2, d0
        bcc.s   loc_011820
        moveq	#0,d0
loc_011820:
        bra.s   loc_011828
loc_011822:
        subq.b  #$2, d0
        bcc.s   loc_011828
        moveq	#0,d0
loc_011828:
        move.b  d0,angle(a0)
loc_01182C:
        move.b  $0027(A0), D0
        beq.s   loc_011870
        tst.w   $14(a0)
        bmi.s   loc_011850
loc_011838:        
        move.b  $002D(A0), d1
        add.b   d1, d0
        bcc.s   loc_01184E
        subq.b  #1, $002C(a0)
        bcc.s   loc_01184E
        move.b  #0, $002C(a0)
        moveq	#0,d0
loc_01184E:
        bra.s   loc_01186C
loc_011850:
        tst.b   $0029(a0)
        bne.s   loc_011838
        move.b  $002D(A0), d1
        sub.b   d1, d0
        bcc.s   loc_01186C
        subq.b  #1, $002C(a0)
        bcc.s   loc_01186C
        move.b  #0, $002C(a0)
        moveq	#0,d0
loc_01186C:
        move.b  d0, $0027(a0)
loc_011870:
        rts
;=============================================================================== 
; End of Sub Tails_JumpAngle
                
;===============================================================================     
             
;=============================================================================== 
; Beginning of Sub Tails_Floor
                 
;===============================================================================           
Tails_Floor: ; loc_011872:
        move.b  Objoff_3F(A0), D5
        move.w x_vel(A0), d1
        move.w  $0012(A0), D2
        jsr     CalcAngle               ; loc_0034A2
        move.b  d0, $002B(a0)
        subi.b  #$20, d0
        andi.b  #$C0, d0
        cmpi.b  #$40, d0
        beq     loc_011946
        cmpi.b  #$80, d0
        beq     loc_0119A8
        cmpi.b  #$C0, d0
        beq     loc_011A04
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_0118BA
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_0118BA:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_0118CC
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_0118CC:
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_011944
        move.b  $0012(A0), D2
        addq.b  #8,  D2
        neg.b   D2
        cmp.b   D2, d1
        bge.s   loc_0118E4
        cmp.b   d2, d0
        blt.s   loc_011944
loc_0118E4:
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Tails_ResetTailsOnFloor ; loc_011A66
        move.b  #0, $001C(a0)
        move.b  d3, d0
        addi.b  #$20, d0
        andi.b  #$40, d0
        bne.s   loc_011922
        move.b  d3, d0
        addi.b  #$10, d0
        andi.b  #$20, d0
        beq.s   loc_011914
        asr.w   $0012(a0)
        bra.s   loc_011936
loc_011914:
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
        rts
loc_011922:
        move.w  #0,x_vel(a0)
        cmpi.w  #$FC0, $0012(a0)
        ble.s   loc_011936
        move.w  #$FC0, $0012(a0)
loc_011936:
        move.w  $0012(A0), $14(a0)
        tst.b   D3
        bpl.s   loc_011944
        neg.w   $14(a0)
loc_011944:
        rts
loc_011946:
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_011960
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
        move.w  $0012(A0), $14(a0)
        rts
loc_011960:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_01197A
        sub.w   d1, y_pos(a0)
        tst.w   $0012(a0)
        bpl.s   loc_011978
        move.w  #0, $0012(a0)
loc_011978:
        rts
loc_01197A:
        tst.w   $0012(a0)
        bmi.s   loc_0119A6
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_0119A6
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Tails_ResetTailsOnFloor ; loc_011A66
        move.b  #0, $001C(a0)
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
loc_0119A6:
        rts
loc_0119A8:
        bsr     Sonic_HitWall           ; loc_013AFC
        tst.w   d1
        bpl.s   loc_0119BA
        sub.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_0119BA:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_0119CC
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_0119CC:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_011A02
        sub.w   d1, y_pos(a0)
        move.b  d3, d0
        addi.b  #$20, d0
        andi.b  #$40, d0
        bne.s   loc_0119EC
        move.w  #0, $0012(a0)
        rts
loc_0119EC:
        move.b  d3,angle(a0)
        bsr     Tails_ResetTailsOnFloor ; loc_011A66
        move.w  $0012(A0), $14(a0)
        tst.b   D3
        bpl.s   loc_011A02
        neg.w   $14(a0)
loc_011A02:
        rts
loc_011A04:
        bsr     loc_01397A
        tst.w   d1
        bpl.s   loc_011A1E
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
        move.w  $0012(A0), $14(a0)
        rts
loc_011A1E:
        bsr     Sonic_DontRunOnWalls    ; loc_0139CC
        tst.w   d1
        bpl.s   loc_011A38
        sub.w   d1, y_pos(a0)
        tst.w   $0012(a0)
        bpl.s   loc_011A36
        move.w  #0, $0012(a0)
loc_011A36:
        rts
loc_011A38:
        tst.w   $0012(a0)
        bmi.s   loc_011A64
        bsr     loc_013736
        tst.w   d1
        bpl.s   loc_011A64
        add.w   d1, y_pos(a0)
        move.b  d3,angle(a0)
        bsr     Tails_ResetTailsOnFloor ; loc_011A66
        move.b  #0, $001C(a0)
        move.w  #0, $0012(a0)
        move.w x_vel(A0), $14(a0)
loc_011A64:
        rts  
;=============================================================================== 
; End of Sub Tails_Floor
                
;===============================================================================          
              
;=============================================================================== 
; Object 0x02 - Tails
; 
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub Tails_ResetTailsOnFloor
                 
;===============================================================================               
Tails_ResetTailsOnFloor: ; loc_011A66:
        btst    #4, status(a0)
        beq.s   loc_011A74
        nop
        nop
        nop
loc_011A74:
        bclr    #5, status(a0)
        bclr    #1, status(a0)
        bclr    #4, status(a0)
        btst    #$2, status(a0)
        beq.s   loc_011AAA
        bclr    #$2, status(a0)
        move.b  #$F, y_radius(a0)
        move.b  #$9, $0017(a0)
        move.b  #0, $001C(a0)
        subq.w  #1, y_pos(a0)
loc_011AAA:
        move.b  #0, Objoff_3C(a0)
        move.w  #0, ($FFFFF7D0).w
        move.b  #0, $0027(a0)
        move.b  #0, $0029(a0)
        rts  
;=============================================================================== 
; End of Sub Tails_ResetTailsOnFloor
                
;=============================================================================== 
               
Tails_Hurt: ; loc_011AC4:
        jsr     SpeedToPos              ; loc_00D27A
        addi.w  #$030, $0012(a0)
        btst    #6, status(a0)
        beq.s   loc_011ADE
        subi.w  #$20, $0012(a0)
loc_011ADE:
        bsr     Tails_HurtStop          ; loc_011AF4
        bsr     Tails_LevelBoundaries   ; loc_0114FE
        bsr     Tails_Animate           ; loc_011BA2
        bsr     Load_Tails_Dynamic_PLC  ; loc_011F42
        jmp     DisplaySprite           ; loc_00D3C2
        
;=============================================================================== 
; Beginning of Sub Tails_HurtStop
                 
;===============================================================================         
Tails_HurtStop: ; loc_011AF4:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs     KillTails               ; loc_012074
        bsr     Tails_Floor             ; loc_011872
        btst    #1, status(a0)
        bne.s   loc_011B30
        moveq	#0,d0
        move.w  d0, $0012(a0)
        move.w  d0,x_vel(a0)
        move.w  d0, $14(a0)
        move.b  #0, $001C(a0)
        move.b  #2,routine(a0)
        move.w  #$078, Objoff_30(a0)
loc_011B30:
        rts
;=============================================================================== 
; End of Sub Tails_HurtStop
                
;===============================================================================          
        
Tails_Death: ; loc_011B32:
        bsr     Tails_GameOver          ; loc_011B4A
        jsr     ObjectFall              ; loc_00D24E
        bsr     Tails_Animate           ; loc_011BA2
        bsr     Load_Tails_Dynamic_PLC  ; loc_011F42
        jmp     DisplaySprite           ; loc_00D3C2
        
;=============================================================================== 
; Beginning of Sub Tails_GameOver
                 
;===============================================================================         
Tails_GameOver: ; loc_011B4A:
        move.w  ($FFFFEECE).w, d0
        addi.w  #$100, d0
        cmp.w   y_pos(a0), D0
        bcc     loc_011B8C
        move.w  (MainCharacter+x_pos).w, d0
        subi.w  #$40, d0
        move.w  d0, x_pos(a0)
        move.w  ($FFFFB00C).w, d0
        subi.w  #$080, d0
        move.w  d0, y_pos(a0)
        move.b  #2,routine(a0)
        andi.w  #$7FFF,art_tile(a0)
        move.b  #$C, Objoff_3E(a0)
        move.b  #$D, Objoff_3F(a0)
        nop
loc_011B8C:
        rts
;=============================================================================== 
; End of Sub Tails_GameOver
                
;===============================================================================
         
Tails_ResetLevel: ; loc_011B8E:
        tst.w   objoff_3A(a0)
        beq.s   loc_011BA0
        subq.w  #1, objoff_3A(a0)
        bne.s   loc_011BA0
        move.w  #$001, ($FFFFFE02).w
loc_011BA0:
        rts
        
;=============================================================================== 
; Beginning of Sub Tails_Animate
                 
;===============================================================================    
Tails_Animate: ; loc_011BA2: ; Tails Subroutine  
        lea     (Tails_AnimateData), A1 ; loc_011DF4
Tails_Animate2: ; loc_011BA8:        
        moveq	#0,d0
        move.b  $001C(A0), D0
        cmp.b   $001D(A0), D0
        beq.s   loc_011BCA
        move.b  d0, $001D(a0)
        move.b  #0, $001B(a0)
        move.b  #0, $001E(a0)
        bclr    #5, status(a0)
loc_011BCA:
        add.w   d0, d0
        adda.w  $00(A1, d0), A1
        move.b  (A1), D0
        bmi.s   loc_011C3A
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        subq.b  #1, $001E(a0)
        bpl.s   loc_011C08
        move.b  d0, $001E(a0)
loc_011BF0:        
        moveq   #0,d1
        move.b  $001B(A0), d1
        move.b  $01(A1, d1), D0
        cmpi.b  #$F0, d0          
        bcc.s   loc_011C0A
loc_011C00:        
        move.b  d0, $001A(a0)
        addq.b  #1, $001B(a0)
loc_011C08:
        rts
loc_011C0A:
        addq.b  #1,d0
        bne.s   loc_011C1A
        move.b  #0, $001B(a0)
        move.b  render_flags(A1), D0
        bra.s   loc_011C00
loc_011C1A:
        addq.b  #1,d0
        bne.s   loc_011C2E
        move.b  $02(A1, d1), D0
        sub.b   d0, $001B(a0)
        sub.b   d0, d1
        move.b  $01(A1, d1), D0
        bra.s   loc_011C00
loc_011C2E:
        addq.b  #1,d0
        bne.s   loc_011C38
        move.b  $02(A1, d1), $001C(a0)
loc_011C38:
        rts
loc_011C3A:
        subq.b  #1, $001E(a0)
        bpl.s   loc_011C08
        addq.b  #1,d0
        bne     loc_011D26
        moveq	#0,d0
        move.b  $0027(A0), D0
        bne     loc_011CC0
        moveq   #0,d1
        move.b  angle(A0), D0
        move.b  status(a0), D2
        andi.b  #1, D2
        bne.s   loc_011C62
        not.b  d0
loc_011C62:
        addi.b  #$10, d0
        bpl.s   loc_011C6A
        moveq   #3, d1
loc_011C6A:
        andi.b  #$FC,render_flags(a0)
        eor.b   d1, D2
        or.b    D2,render_flags(a0)
        lsr.b   #4, d0
        andi.b  #6, d0
        move.w  $14(A0), D2
        bpl.s   loc_011C84
        neg.w   D2
loc_011C84:
        move.b  d0, d3
        add.b   d3, d3
        add.b   d3, d3
        lea     (Tails_Animate_Walk), A1 ; loc_011E32
        cmpi.w  #$600, D2
        bcs.s   loc_011CA6
        lea     (Tails_Animate_Run), A1 ; loc_011E3C
        move.b  d0, d1
        lsr.b   #1,d1
        add.b   d1, d0
        add.b   d0, d0
        move.b  d0, d3
loc_011CA6:
        neg.w   D2
        addi.w  #$800, D2
        bpl.s   loc_011CB0
        moveq   #0, D2
loc_011CB0:
        lsr.w   #8, D2
        move.b  D2, $001E(a0)
        bsr     loc_011BF0
        add.b   d3, $001A(a0)
        rts
loc_011CC0:
        move.b  $0027(A0), D0
        moveq   #0,d1
        move.b  status(a0), D2
        andi.b  #1, D2
        bne.s   loc_011CEE
        andi.b  #$FC,render_flags(a0)
        addi.b  #$B, d0
        divu.w  #$016, d0
        addi.b  #$75, d0
        move.b  d0, $001A(a0)
        move.b  #0, $001E(a0)
        rts
loc_011CEE:
        andi.b  #$FC,render_flags(a0)
        tst.b   $0029(a0)
        beq.s   loc_011D06
        ori.b   #1,render_flags(a0)
        addi.b  #$B, d0
        bra.s   loc_011D12
loc_011D06:
        ori.b   #3,render_flags(a0)
        neg.b   D0
        addi.b  #$8F, d0
loc_011D12:
        divu.w  #$016, d0
        addi.b  #$75, d0
        move.b  d0, $001A(a0)
        move.b  #0, $001E(a0)
        rts
loc_011D26:
        addq.b  #1,d0
        bne.s   loc_011D6A
        move.w  $14(A0), D2
        bpl.s   loc_011D32
        neg.w   D2
loc_011D32:
        lea     (Tails_Animate_Roll2), A1 ; loc_011E4B
        cmpi.w  #$600, D2
        bcc.s   loc_011D44
        lea     (Tails_Animate_Roll), A1 ; loc_011E46
loc_011D44:
        neg.w   D2
        addi.w  #$400, D2
        bpl.s   loc_011D4E
        moveq   #0, D2
loc_011D4E:
        lsr.w   #8, D2
        move.b  D2, $001E(a0)
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        bra     loc_011BF0
loc_011D6A:
        addq.b  #1,d0
        bne.s   loc_011DA0
        move.w  $14(A0), D2
        bmi.s   loc_011D76
        neg.w   D2
loc_011D76:
        addi.w  #$800, D2
        bpl.s   loc_011D7E
        moveq   #0, D2
loc_011D7E:
        lsr.w   #6, D2
        move.b  D2, $001E(a0)
        lea     (Tails_Animate_Push_NoArt), A1 ; loc_011E50
        move.b  status(a0), d1
        andi.b  #1,d1
        andi.b  #$FC,render_flags(a0)
        or.b    d1,render_flags(a0)
        bra     loc_011BF0
loc_011DA0:
        move.w  ($FFFFB050).w, d1
        move.w  ($FFFFB052).w, D2
        jsr     CalcAngle               ; loc_0034A2
        moveq   #0,d1
        move.b  status(a0), D2
        andi.b  #1, D2
        bne.s   loc_011DBE
        not.b  d0
        bra.s   loc_011DC2
loc_011DBE:
        addi.b  #$80, d0
loc_011DC2:
        addi.b  #$10, d0
        bpl.s   loc_011DCA
        moveq   #3, d1
loc_011DCA:
        andi.b  #$FC,render_flags(a0)
        eor.b   d1, D2
        or.b    D2,render_flags(a0)
        lsr.b   #3, d0
        andi.b  #$C, d0
        move.b  d0, d3
        lea     (loc_012054), A1
        move.b  #3, $001E(a0)
        bsr     loc_011BF0
        add.b   d3, $001A(a0)
        rts 
Tails_AnimateData: ; loc_011DF4: ; Tails Data               
        dc.w    Tails_Animate_Walk-Tails_AnimateData           ; loc_011E32
        dc.w    Tails_Animate_Run-Tails_AnimateData            ; loc_011E3C
        dc.w    Tails_Animate_Roll-Tails_AnimateData           ; loc_011E46
        dc.w    Tails_Animate_Roll2-Tails_AnimateData          ; loc_011E4B
        dc.w    Tails_Animate_Push_NoArt-Tails_AnimateData     ; loc_011E50
        dc.w    Tails_Animate_Wait-Tails_AnimateData           ; loc_011E58
        dc.w    Tails_Animate_Balance_NoArt-Tails_AnimateData  ; loc_011E96
        dc.w    Tails_Animate_LookUp-Tails_AnimateData         ; loc_011EA0
        dc.w    Tails_Animate_Duck-Tails_AnimateData           ; loc_011EA3
        dc.w    Tails_Animate_Spindash-Tails_AnimateData       ; loc_011EA6
        dc.w    Tails_Animate_0x0A-Tails_AnimateData           ; loc_011EAB
        dc.w    Tails_Animate_0x0B-Tails_AnimateData           ; loc_011EAE
        dc.w    Tails_Animate_0x0C-Tails_AnimateData           ; loc_011EB4
        dc.w    Tails_Animate_Stop-Tails_AnimateData           ; loc_011EB8
        dc.w    Tails_Animate_Fly-Tails_AnimateData            ; loc_011EBC
        dc.w    Tails_Animate_0x0F-Tails_AnimateData           ; loc_011EC0
        dc.w    Tails_Animate_Jump-Tails_AnimateData           ; loc_011EC7
        dc.w    Tails_Animate_0x11-Tails_AnimateData           ; loc_011ED6
        dc.w    Tails_Animate_0x12-Tails_AnimateData           ; loc_011EDA
        dc.w    Tails_Animate_0x13-Tails_AnimateData           ; loc_011EE0
        dc.w    Tails_Animate_0x14-Tails_AnimateData           ; loc_011EE5
        dc.w    Tails_Animate_0x15-Tails_AnimateData           ; loc_011EE8
        dc.w    Tails_Animate_Death1-Tails_AnimateData         ; loc_011EEF
        dc.w    Tails_Animate_Unused_Drown-Tails_AnimateData   ; loc_011EF2
        dc.w    Tails_Animate_Death2-Tails_AnimateData         ; loc_011EF5
        dc.w    Tails_Animate_0x19-Tails_AnimateData           ; loc_011EF8
        dc.w    Tails_Animate_0x1A-Tails_AnimateData           ; loc_011EFB
        dc.w    Tails_Animate_0x1B-Tails_AnimateData           ; loc_011EFE
        dc.w    Tails_Animate_0x1C-Tails_AnimateData           ; loc_011F02
        dc.w    Tails_Animate_0x1D-Tails_AnimateData           ; loc_011F06
        dc.w    Tails_Animate_0x1E-Tails_AnimateData           ; loc_011F10
Tails_Animate_Walk: ; loc_011E32:
        dc.b    $FF, $10, $11, $12, $13, $14, $15, $0E, $0F, $FF  
Tails_Animate_Run: ; loc_011E3C:
        dc.b    $FF, $2E, $2F, $30, $31, $FF, $FF, $FF, $FF, $FF
Tails_Animate_Roll: ; loc_011E46:
        dc.b    $01, $48, $47, $46, $FF
Tails_Animate_Roll2: ; loc_011E4B:
        dc.b    $01, $48, $47, $46, $FF
Tails_Animate_Push_NoArt: ; loc_011E50:
        dc.b    $FD, $09, $0A, $0B, $0C, $0D, $0E, $FF
Tails_Animate_Wait: ; loc_011E58:
        dc.b    $07, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $03, $02, $01, $01, $01
        dc.b    $01, $01, $01, $01, $01, $03, $02, $01, $01, $01, $01, $01, $01, $01, $01, $01
        dc.b    $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $06, $07, $08, $07, $08, $07, $08, $07, $08, $07, $08, $06, $FE, $1C  
Tails_Animate_Balance_NoArt: ; loc_011E96:
        dc.b    $1F, $01, $02, $03, $04, $05, $06, $07, $08, $FF
Tails_Animate_LookUp: ; loc_011EA0:
        dc.b    $3F, $04, $FF
Tails_Animate_Duck: ; loc_011EA3:
        dc.b    $3F, $5B, $FF
Tails_Animate_Spindash: ; loc_011EA6:
        dc.b    $00, $60, $61, $62, $FF
Tails_Animate_0x0A: ; loc_011EAB:
        dc.b    $3F, $82, $FF
Tails_Animate_0x0B: ; loc_011EAE:
        dc.b    $07, $08, $08, $09, $FD, $05
Tails_Animate_0x0C: ; loc_011EB4:
        dc.b    $07, $09, $FD, $05
Tails_Animate_Stop: ; loc_011EB8:
        dc.b    $07, $01, $02, $FF
Tails_Animate_Fly: ; loc_011EBC:
        dc.b    $07, $5E, $5F, $FF
Tails_Animate_0x0F: ; loc_011EC0:
        dc.b    $07, $01, $02, $03, $04, $05, $FF
Tails_Animate_Jump: ; loc_011EC7:
        dc.b    $03, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $FD, $00
Tails_Animate_0x11: ; loc_011ED6:
        dc.b    $04, $01, $02, $FF
Tails_Animate_0x12: ; loc_011EDA:
        dc.b    $0F, $01, $02, $03, $FE, $01
Tails_Animate_0x13: ; loc_011EE0:
        dc.b    $0F, $01, $02, $FE, $01
Tails_Animate_0x14: ; loc_011EE5:
        dc.b    $3F, $01, $FF
Tails_Animate_0x15: ; loc_011EE8:
        dc.b    $0B, $01, $02, $03, $04, $FD, $00
Tails_Animate_Death1: ; loc_011EEF:
        dc.b    $20, $5D, $FF
Tails_Animate_Unused_Drown: ; loc_011EF2:
        dc.b    $2F, $5D, $FF
Tails_Animate_Death2: ; loc_011EF5:
        dc.b    $03, $5D, $FF
Tails_Animate_0x19: ; loc_011EF8:
        dc.b    $03, $5D, $FF
Tails_Animate_0x1A: ; loc_011EFB:
        dc.b    $03, $5C, $FF
Tails_Animate_0x1B: ; loc_011EFE:
        dc.b    $07, $01, $01, $FF
Tails_Animate_0x1C: ; loc_011F02:
        dc.b    $77, $00, $FD, $00
Tails_Animate_0x1D: ; loc_011F06:
        dc.b    $03, $01, $02, $03, $04, $05, $06, $07, $08, $FF
Tails_Animate_0x1E: ; loc_011F10:
        dc.b    $03, $01, $02, $03, $04, $05, $06, $07, $08, $FF
;=============================================================================== 
; End of Sub Tails_Animate
                
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub Load_Tails_Tail_Dynamic_PLC
                 
;===============================================================================    
Load_Tails_Tail_Dynamic_PLC: ; loc_011F1A:  ; Tails "Tail" subroutine
        moveq	#0,d0
        move.b  $001A(A0), D0
        cmp.b   ($FFFFF7DF).w, d0
        beq.s   loc_011F94
        move.b  d0, ($FFFFF7DF).w
        lea     (Tails_Dyn_Script), A2  ; loc_07056E
        add.w   d0, d0
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D5
        subq.w  #1,d5
        bmi.s   loc_011F94
        move.w  #$F600, D4
        bra.s   loc_011F68  
;=============================================================================== 
; End of Sub Load_Tails_Tail_Dynamic_PLC
                
;===============================================================================   
              
;=============================================================================== 
; Beginning of Sub Load_Tails_Dynamic_PLC
                 
;===============================================================================                        
Load_Tails_Dynamic_PLC: ; loc_011F42:
        moveq	#0,d0
        move.b  $001A(A0), D0
        cmp.b   ($FFFFF7DE).w, d0
        beq.s   loc_011F94
        move.b  d0, ($FFFFF7DE).w
        lea     (Tails_Dyn_Script), A2 ; loc_07056E
        add.w   d0, d0
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D5
        subq.w  #1,d5
        bmi.s   loc_011F94
        move.w  #$F400, D4
loc_011F68:        
        moveq   #0,d1
        move.w  (A2)+, d1
        move.w  d1, d3
        lsr.w   #8, d3
        andi.w  #$0F0, d3
        addi.w  #$010, d3
        andi.w  #$FFF, d1
        lsl.l   #5, d1
        addi.l  #Tails_Sprites, d1      ; loc_06254C
        move.w  d4, D2
        add.w   d3, D4
        add.w   d3, D4
        jsr     DMA_68KtoVRAM           ; loc_00156C
        dbra    d5, loc_011F68
loc_011F94:
        rts            
;=============================================================================== 
; Object 0x05 - Tails "Tail"

;===============================================================================             
Obj05_Tails_Tail: ; loc_011F96:               
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_011FA4(pc,d0), d1
        jmp     loc_011FA4(pc,d1)
loc_011FA4:
        dc.w    loc_011FA8-loc_011FA4
        dc.w    loc_011FD0-loc_011FA4
loc_011FA8:
        addq.b  #2,routine(a0)          
        move.l  #Tails_Mappings,mappings(a0) ; loc_06FB3C
        move.w  #$7B0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$2, $0018(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #4,render_flags(a0)
loc_011FD0:
        move.b  ($FFFFB066).w,angle(a0)
        move.b  ($FFFFB062).w, status(a0)
        move.w  ($FFFFB048).w, x_pos(a0)
        move.w  ($FFFFB04C).w, y_pos(a0)
        moveq	#0,d0
        move.b  ($FFFFB05C).w, d0
        cmp.b   Objoff_30(A0), D0
        beq.s   loc_011FFE
        move.b  d0, Objoff_30(a0)
        move.b  loc_012014(pc,d0), $001C(a0)
loc_011FFE:
        lea     (loc_012032), A1
        bsr     Tails_Animate2          ; loc_011BA8
        bsr     Load_Tails_Tail_Dynamic_PLC ; loc_011F1A
        jsr     DisplaySprite           ; loc_00D3C2
        rts
loc_012014:
        dc.b    $00, $00, $03, $03, $00, $01, $00, $02, $01, $07, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
                   
loc_012032:
        dc.w    loc_012042-loc_012032
        dc.w    loc_012045-loc_012032
        dc.w    loc_01204C-loc_012032
        dc.w    loc_012054-loc_012032
        dc.w    loc_01205A-loc_012032
        dc.w    loc_012060-loc_012032
        dc.w    loc_012066-loc_012032
        dc.w    loc_01206C-loc_012032
loc_012042:
        dc.b    $20, $00, $FF 
loc_012045:    
        dc.b    $07, $09, $0A, $0B, $0C, $0D, $FF
loc_01204C: 
        dc.b    $03, $09, $0A, $0B, $0C, $0D, $FD, $01 
loc_012054:
        dc.b    $FC, $49, $4A, $4B, $4C, $FF
loc_01205A:
        dc.b    $03, $4D, $4E, $4F, $50, $FF
loc_012060:
        dc.b    $03, $51, $52, $53, $54, $FF
loc_012066:
        dc.b    $03, $55, $56, $57, $58, $FF
loc_01206C: 
        dc.b    $02, $81, $82, $83, $84, $FF
;=============================================================================== 
; Object 0x05 - Tails "Tail"
; 
;===============================================================================            
        nop                     ; Filler 
KillTails: ; loc_012074:
        jmp     KillSonic               ; loc_021422
        dc.w    $0000           ; Filler  
;=============================================================================== 
; Object 0x0A - 

;===============================================================================                    
Obj0A_Bubbles_And_Numbers: ; loc_01207C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01208A(pc,d0), d1
        jmp     loc_01208A(pc,d1)
loc_01208A:
        dc.w    loc_01209C-loc_01208A
        dc.w    loc_0120F8-loc_01208A
        dc.w    loc_012104-loc_01208A
        dc.w    loc_01216E-loc_01208A
        dc.w    J_DeleteObject_01-loc_01208A ; loc_012182-...
        dc.w    loc_01230C-loc_01208A
        dc.w    loc_012188-loc_01208A
        dc.w    loc_01216E-loc_01208A
        dc.w    J_DeleteObject_01-loc_01208A ; loc_012182-...
loc_01209C:
        addq.b  #2,routine(a0)
        move.l  #Obj0A_Bubbles_Mappings,mappings(a0) ; loc_014374
        move.w  #$8500,art_tile(a0)
        move.b  #$84,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  subtype(A0), D0
        bpl.s   loc_0120E4
        addq.b  #8, $0024(a0)
        move.l  #Obj0A_Numbers_Mappings,mappings(a0) ; loc_0125C2
        move.w  #$440,art_tile(a0)
        andi.w  #$07F, d0
        move.b  d0, $0033(a0)
        bra     loc_01230C
loc_0120E4:
        move.b  d0, $001C(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  #$FF78, $0012(a0)
loc_0120F8:
        lea     (loc_012530), A1
        jsr     AnimateSprite           ; (loc_00D412)
loc_012104:
        move.w  (Water_Level_1).w, d0
        cmp.w   y_pos(a0), D0
        bcs.s   loc_01212A
        move.b  #6, $0024(a0)
        addq.b  #$7, $001C(a0)
        cmpi.b  #$D, $001C(a0)
        beq.s   loc_01216E
        bcs.s   loc_01216E
        move.b  #$D, $001C(a0)
        bra.s   loc_01216E
loc_01212A:
        tst.b   ($FFFFF7C7).w
        beq.s   loc_012134
        addq.w  #4, Objoff_30(a0)
loc_012134:
        move.b  angle(A0), D0
        addq.b  #1,angle(a0)
        andi.w  #$07F, d0
        lea     (loc_01220C), A1
        move.b  $00(A1, d0), D0
        ext.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        bsr.s   loc_0121C0
        jsr     SpeedToPos              ; (loc_00D27A)
        tst.b   render_flags(a0)
        bpl.s   J_DeleteObject_00       ; loc_012168
        jmp     DisplaySprite           ; (loc_00D3C2) 
J_DeleteObject_00: ; loc_012168:
        jmp     DeleteObject            ; (loc_00D3B4)    
loc_01216E:
        bsr.s   loc_0121C0
        lea     (loc_012530), A1
        jsr     AnimateSprite           ; (loc_00D412)
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_01: ; loc_012182:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_012188:
        cmpi.w  #$00C, ($FFFFFE14).w
        bhi.s   J_DeleteObject_02       ; loc_0121BA
        subq.w  #1, objoff_38(a0)
        bne.s   loc_0121A2
        move.b  #$E, $0024(a0)
        addq.b  #$7, $001C(a0)
        bra.s   loc_01216E
loc_0121A2:
        lea     (loc_012530), A1
        jsr     AnimateSprite           ; (loc_00D412)
        tst.b   render_flags(a0)
        bpl.s   J_DeleteObject_02       ; loc_0121BA
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_02: ; loc_0121BA:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_0121C0:
        tst.w   objoff_38(a0)
        beq.s   loc_01220A
        subq.w  #1, objoff_38(a0)
        bne.s   loc_01220A
        cmpi.b  #$7, $001C(a0)
        bcc.s   loc_01220A
        move.w  #$F, objoff_38(a0)
        clr.w   $0012(a0)
        move.b  #$80,render_flags(a0)
        move.w  x_pos(a0), D0
        sub.w   ($FFFFEE00).w, d0
        addi.w  #$080, d0
        move.w  d0, x_pos(a0)
        move.w  y_pos(a0), D0
        sub.w   ($FFFFEE04).w, d0
        addi.w  #$080, d0
        move.w  d0, $000A(a0)
        move.b  #$C, $0024(a0)
loc_01220A:
        rts

loc_01220C:
        dc.b    $00, $00, $00, $00, $00, $00, $01, $01, $01, $01, $01, $02, $02, $02, $02, $02
        dc.b    $02, $02, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03
        dc.b    $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $02
        dc.b    $02, $02, $02, $02, $02, $02, $01, $01, $01, $01, $01, $00, $00, $00, $00, $00
        dc.b    $00, $FF, $FF, $FF, $FF, $FF, $FE, $FE, $FE, $FE, $FE, $FD, $FD, $FD, $FD, $FD
        dc.b    $FD, $FD, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC
        dc.b    $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FD
        dc.b    $FD, $FD, $FD, $FD, $FD, $FD, $FE, $FE, $FE, $FE, $FE, $FF, $FF, $FF, $FF, $FF
        dc.b    $00, $00, $00, $00, $00, $00, $01, $01, $01, $01, $01, $02, $02, $02, $02, $02
        dc.b    $02, $02, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03
        dc.b    $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $02
        dc.b    $02, $02, $02, $02, $02, $02, $01, $01, $01, $01, $01, $00, $00, $00, $00, $00
        dc.b    $00, $FF, $FF, $FF, $FF, $FF, $FE, $FE, $FE, $FE, $FE, $FD, $FD, $FD, $FD, $FD
        dc.b    $FD, $FD, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC
        dc.b    $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FD
        dc.b    $FD, $FD, $FD, $FD, $FD, $FD, $FE, $FE, $FE, $FE, $FE, $FF, $FF, $FF, $FF, $FF
loc_01230C:
        tst.w   $002C(a0)
        bne     loc_0123F6
        cmpi.b  #6, ($FFFFB024).w
        bcc     loc_0124FC
        btst    #6, ($FFFFB022).w
        beq     loc_0124FC
        subq.w  #1, objoff_38(a0)
        bpl     loc_01241C
        move.w  #$03B, objoff_38(a0)
        move.w  #$001, objoff_36(a0)
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$001, d0
        move.b  d0, Objoff_34(a0)
        move.w  ($FFFFFE14).w, d0
        cmpi.w  #$019, d0
        beq.s   loc_012386
        cmpi.w  #$014, d0
        beq.s   loc_012386
        cmpi.w  #$F, d0
        beq.s   loc_012386
        cmpi.w  #$00C, d0
        bhi.s   loc_012390
        bne.s   loc_012372
        move.w  #$08A, d0
        jsr     (Play_Music)            ; loc_0014C0
loc_012372:
        subq.b  #1, $0032(a0)
        bpl.s   loc_012390
        move.b  $0033(A0), $0032(a0)
        bset    #$7, objoff_36(a0)
        bra.s   loc_012390
loc_012386:
        move.w  #$0C2, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_012390:
        subq.w  #1, ($FFFFFE14).w
        bcc     loc_01241A
        bsr     ResumeMusic             ; loc_0124FE
        move.b  #$81, ($FFFFB02A).w
        move.w  #$0B2, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        move.b  #$A, Objoff_34(a0)
        move.w  #$001, objoff_36(a0)
        move.w  #$078, $002C(a0)
        move.l  A0, -(A7)
        lea     (MainCharacter).w, A0
        bsr     Sonic_ResetOnFloor      ; loc_01090C
        move.b  #$17, $001C(a0)
        bset    #1, status(a0)
        bset    #$7,art_tile(a0)
        move.w  #0, $0012(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $14(a0)
        move.b  #1, ($FFFFEEDC).w
        move.l  (A7)+, A0
        rts
loc_0123F6:
        subq.w  #1, $002C(a0)
        bne.s   loc_012404
        move.b  #6, ($FFFFB024).w
        rts
loc_012404:
        move.l  A0, -(A7)
        lea     (MainCharacter).w, A0
        jsr     SpeedToPos              ; (loc_00D27A)
        addi.w  #$010, $0012(a0)
        move.l  (A7)+, A0
        bra.s   loc_01241C
loc_01241A:
        bra.s   loc_01242C
loc_01241C:
        tst.w   objoff_36(a0)
        beq     loc_0124FC
        subq.w  #1, objoff_3A(a0)
        bpl     loc_0124FC
loc_01242C:
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$F, d0
        move.w  d0, objoff_3A(a0)
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne     loc_0124FC
        move.b  #$A, 0(a1)
        move.w  (MainCharacter+x_pos).w, x_pos(a1)
        moveq   #6, d0
        btst    #0, ($FFFFB022).w
        beq.s   loc_012462
        neg.w   D0
        move.b  #$40, angle(a1)
loc_012462:
        add.w   d0, x_pos(a1)
        move.w  ($FFFFB00C).w, y_pos(a1)
        move.b  #6, subtype(a1)
        tst.w   $002C(a0)
        beq     loc_0124AE
        andi.w  #$007, objoff_3A(a0)
        addi.w  #0, objoff_3A(a0)
        move.w  ($FFFFB00C).w, d0
        subi.w  #$00C, d0
        move.w  d0, y_pos(a1)
        jsr     PseudoRandomNumber      ; loc_0031E4
        move.b  d0, angle(a1)
        move.w  ($FFFFFE04).w, d0
        andi.b  #3, d0
        bne.s   loc_0124F2
        move.b  #$E, subtype(a1)
        bra.s   loc_0124F2
loc_0124AE:
        btst    #$7, objoff_36(a0)
        beq.s   loc_0124F2
        move.w  ($FFFFFE14).w, D2
        lsr.w   #1, D2
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$003, d0
        bne.s   loc_0124DA
        bset    #6, objoff_36(a0)
        bne.s   loc_0124F2
        move.b  D2, subtype(a1)
        move.w  #$01C, objoff_38(a1)
loc_0124DA:
        tst.b   Objoff_34(a0)
        bne.s   loc_0124F2
        bset    #6, objoff_36(a0)
        bne.s   loc_0124F2
        move.b  D2, subtype(a1)
        move.w  #$01C, objoff_38(a1)
loc_0124F2:
        subq.b  #1, Objoff_34(a0)
        bpl.s   loc_0124FC
        clr.w   objoff_36(a0)
loc_0124FC:
        rts               
ResumeMusic: ; loc_0124FE:
        cmpi.w  #$00C, ($FFFFFE14).w
        bhi.s   loc_012524
        move.w  #$082, d0
        tst.b   ($FFFFFE2D).w
        beq.s   loc_012514
        move.w  #$087, d0
loc_012514:
        tst.b   ($FFFFF7AA).w
        beq.s   loc_01251E
        move.w  #$08C, d0
loc_01251E:
        jsr     (Play_Music)            ; loc_0014C0
loc_012524:
        move.w  #$01E, ($FFFFFE14).w
        clr.b   ($FFFFB372).w
        rts            
loc_012530:
        dc.w    loc_01254E-loc_012530
        dc.w    loc_012557-loc_012530
        dc.w    loc_012560-loc_012530
        dc.w    loc_012569-loc_012530
        dc.w    loc_012572-loc_012530
        dc.w    loc_01257B-loc_012530
        dc.w    loc_012584-loc_012530
        dc.w    loc_012589-loc_012530
        dc.w    loc_012591-loc_012530
        dc.w    loc_012599-loc_012530
        dc.w    loc_0125A1-loc_012530
        dc.w    loc_0125A9-loc_012530
        dc.w    loc_0125B1-loc_012530
        dc.w    loc_0125B9-loc_012530
        dc.w    loc_0125BB-loc_012530
loc_01254E:
        dc.b    $05, $00, $01, $02, $03, $04, $09, $0D, $FC
loc_012557:
        dc.b    $05, $00, $01, $02, $03, $04, $0C, $12, $FC
loc_012560:
        dc.b    $05, $00, $01, $02, $03, $04, $0C, $11, $FC
loc_012569:
        dc.b    $05, $00, $01, $02, $03, $04, $0B, $10, $FC
loc_012572:
        dc.b    $05, $00, $01, $02, $03, $04, $09, $0F, $FC
loc_01257B:
        dc.b    $05, $00, $01, $02, $03, $04, $0A, $0E, $FC
loc_012584:
        dc.b    $0E, $00, $01, $02, $FC
loc_012589:
        dc.b    $07, $16, $0D, $16, $0D, $16, $0D, $FC
loc_012591:
        dc.b    $07, $16, $12, $16, $12, $16, $12, $FC
loc_012599:
        dc.b    $07, $16, $11, $16, $11, $16, $11, $FC
loc_0125A1:
        dc.b    $07, $16, $10, $16, $10, $16, $10, $FC
loc_0125A9:
        dc.b    $07, $16, $0F, $16, $0F, $16, $0F, $FC
loc_0125B1:
        dc.b    $07, $16, $0E, $16, $0E, $16, $0E, $FC
loc_0125B9:
        dc.b    $0E, $FC
loc_0125BB:
        dc.b    $0E, $01, $02, $03, $04, $FC, $00 
Obj0A_Numbers_Mappings: ; loc_0125C2:
        dc.w    loc_0125C4-Obj0A_Numbers_Mappings
loc_0125C4:
        dc.w    $0001
        dc.l    $E80E0000, $0000FFF2        
;=============================================================================== 
; Object 0x0A - 
; 
;=============================================================================== 
;=============================================================================== 
; Object 0x38 - 

;===============================================================================  
Obj38_Shield: ; loc_0125CE:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0125DC(pc,d0), d1
        jmp     loc_0125DC(pc,d1)
loc_0125DC:         
        dc.w    loc_0125E0-loc_0125DC
        dc.w    loc_012616-loc_0125DC
loc_0125E0:
        addq.b  #2,routine(a0)
        move.l  #loc_012BB0,mappings(a0)
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #$18,width_pixels(a0)
        move.w  #$4BE,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        btst    #$7, ($FFFFB002).w
        beq.s   loc_012616
        bset    #$7,art_tile(a0)
loc_012616:
        tst.b   ($FFFFFE2D).w
        bne.s   loc_012646
        tst.b   ($FFFFFE2C).w
        beq.s   J_DeleteObject_03       ; loc_012648
        move.w  (MainCharacter+x_pos).w, x_pos(a0)
        move.w  ($FFFFB00C).w, y_pos(a0)
        move.b  ($FFFFB022).w, status(a0)
        lea     (loc_012BA2), A1
        jsr     AnimateSprite           ; (loc_00D412)
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_012646:
        rts    
J_DeleteObject_03: ; loc_012648:
        jmp     DeleteObject            ; (loc_00D3B4)
;=============================================================================== 
; Object 0x38 - 
; 
;===============================================================================  
;=============================================================================== 
; Object 0x35 - 

;===============================================================================           
Obj35_Invincibility: ; loc_01264E:
        moveq	#0,d0
        move.b  $000A(A0), D0
        move.w  loc_01265C(pc,d0), d1
        jmp     loc_01265C(pc,d1)
loc_01265C:
        dc.w    loc_012660-loc_01265C
        dc.w    loc_01268E-loc_01265C
loc_012660:
        addq.b  #$2, $000A(a0)
        move.l  #loc_012C88,mappings(a0)
        move.w  #$4DE,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        bset    #6,render_flags(a0)
        move.b  #$10, Objoff_E(a0)
        move.b  #8, Objoff_F(a0)
loc_01268E:
        tst.b   ($FFFFFE2D).w
        beq     DeleteObject            ; loc_00D3B4
        lea     (MainCharacter).w, A1
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        move.b  status(a1), D6
        lea     (loc_0127B0), A2
        move.b  angle(A1), d1
        btst    #1, D6
        beq.s   loc_0126C0
        move.b  $002B(A1), d1
        moveq   #0, D6
loc_0126C0:
        andi.b  #1, D6
        beq.s   loc_0126C8
        neg.w   d1
loc_0126C8:
        addi.b  #$10, d1
        lsr.b   #3, d1
        andi.w  #$01C, d1
        lea     $00(A2, d1), A2
        subq.w  #8, d1
        andi.w  #$010, d1
        bne.s   loc_0126E2
        eori.b  #1, D6
loc_0126E2:
        move.b  ($FFFFFE05).w, d0
        andi.b  #1,d0
        lea     (loc_0127D0), A3
        beq.s   loc_0126FA
        lea     (loc_012938), A3
        addq.w  #$2, a2
loc_0126FA:
        move.w  x_pos(A1), D4
        move.b  (A2)+, d1
        ext.w   d1
        andi.b  #1, D6
        beq.s   loc_01270A
        neg.w   d1
loc_01270A:
        add.w   d1, D4
        move.w  y_pos(A1), D5
        move.b  (A2)+, d1
        ext.w   d1
        add.w   d1,d5
        moveq	#0,d0
        move.b  $001A(A0), D0
        addq.b  #6, d0
        cmpi.b  #$78, d0
        bcs.s   loc_012726
        moveq	#0,d0
loc_012726:
        move.b  d0, $001A(a0)
        move.w  d0, d1
        add.w   d0, d0
        add.w   d1, d0
        lea     $00(A3, d0), A3
        lea    x_vel(A0), A2
        moveq	#0,d0
        moveq   #5, d1
loc_01273C:        
        move.b  (A3)+, D0
        move.b  (A3)+, D2
        ext.w   D2
        andi.b  #1, D6
        beq.s   loc_01274A
        neg.w   D2
loc_01274A:
        add.w   d4, D2
        move.b  (A3)+, D3
        ext.w   D3
        add.w   d5, d3
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        addq.w  #1, a2
        move.b  d0, (A2)+
        dbra    d1, loc_01273C
        move.w  x_pos(A1), D4
        move.w  y_pos(A1), D5
        moveq	#0,d0
        move.b  mappings(A0), D0
        addq.b  #6, d0
        cmpi.b  #$A2, d0
        bcs.s   loc_012776
        moveq	#0,d0
loc_012776:
        move.b  d0,mappings(a0)
        lea     (loc_012AA0), A3
        lea     $00(A3, d0), A3
        moveq   #1,d1
loc_012786:        
        move.b  (A3)+, D0
        move.b  (A3)+, D2
        ext.w   D2
        andi.b  #1, D6
        beq.s   loc_012794
        neg.w   D2
loc_012794:
        add.w   d4, D2
        move.b  (A3)+, D3
        ext.w   D3
        add.w   d5, d3
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        addq.w  #1, a2
        move.b  d0, (A2)+
        dbra    d1, loc_012786
        move.w  #$080, d0
        bra     DisplaySprite_Param     ; loc_00D3FE  
loc_0127B0:
        dc.w    $0000, $0000, $00F8, $00F0, $04F0, $04E0, $00F8, $00F0
        dc.w    $0000, $0000, $0008, $0010, $0410, $0420, $0008, $0010  
loc_0127D0:
        dc.b    $02, $F8, $F9, $05, $E5, $F9, $04, $E6, $08, $02, $E8, $FD, $00, $00, $00, $00
        dc.b    $00, $00, $03, $F7, $F9, $02, $F8, $07, $06, $E4, $F9, $05, $E5, $08, $03, $E7
        dc.b    $FD, $00, $00, $00, $04, $F6, $F9, $03, $F7, $07, $05, $E3, $FA, $06, $E4, $09
        dc.b    $04, $E6, $FC, $00, $00, $00, $05, $F5, $F9, $04, $F6, $08, $04, $E2, $FB, $05
        dc.b    $E3, $09, $05, $E5, $FC, $00, $00, $00, $06, $F4, $F9, $05, $F5, $08, $02, $F8
        dc.b    $FD, $03, $E1, $FC, $04, $E2, $0A, $06, $E4, $FB, $05, $F3, $FA, $06, $F4, $09
        dc.b    $03, $F7, $FD, $02, $E0, $FD, $03, $E1, $0A, $05, $E3, $FB, $04, $F2, $FB, $05
        dc.b    $F3, $09, $04, $F6, $FC, $01, $DF, $00, $02, $E0, $0B, $04, $E2, $FA, $03, $F1
        dc.b    $FC, $04, $F2, $0A, $05, $F5, $FC, $02, $F8, $02, $01, $DF, $0B, $03, $E1, $FA
        dc.b    $02, $F0, $FD, $03, $F1, $0A, $06, $F4, $FB, $03, $F7, $02, $02, $E0, $FA, $00
        dc.b    $00, $00, $01, $EF, $00, $02, $F0, $0B, $05, $F3, $FB, $04, $F6, $03, $01, $DF
        dc.b    $FA, $00, $00, $00, $01, $EE, $00, $01, $EF, $0B, $04, $F2, $FA, $05, $F5, $03
        dc.b    $02, $F8, $0E, $00, $00, $00, $01, $ED, $01, $01, $EE, $0C, $03, $F1, $FA, $06
        dc.b    $F4, $03, $03, $F7, $0E, $00, $00, $00, $01, $ED, $03, $01, $ED, $0D, $02, $F0
        dc.b    $FA, $05, $F3, $02, $04, $F6, $0D, $00, $00, $00, $01, $EC, $05, $01, $EC, $0D
        dc.b    $01, $EF, $FA, $04, $F2, $02, $05, $F5, $0D, $02, $F8, $F5, $01, $EB, $07, $01
        dc.b    $EB, $0D, $01, $EE, $F9, $03, $F1, $02, $06, $F4, $0C, $03, $F7, $F5, $01, $EA
        dc.b    $08, $01, $EA, $0D, $01, $ED, $F8, $02, $F0, $01, $05, $F3, $0C, $04, $F6, $F5
        dc.b    $01, $E9, $09, $01, $E9, $0D, $01, $EC, $F8, $01, $EF, $01, $04, $F2, $0B, $05
        dc.b    $F5, $F5, $01, $EB, $F7, $01, $EE, $00, $03, $F1, $0A, $05, $F4, $F6, $02, $E8
        dc.b    $F9, $00, $00, $00, $01, $EA, $F7, $01, $ED, $00, $02, $F0, $0A, $04, $F3, $F6
        dc.b    $03, $E7, $F9, $02, $E8, $07, $01, $E9, $F6, $01, $EC, $00, $01, $EF, $09, $03
        dc.b    $F2, $F6, $04, $E6, $F9, $03, $E7, $07    
loc_012938:
        dc.b    $01, $E6, $00, $01, $E7, $0B, $04, $EA, $FA, $05, $ED, $03, $02, $F0, $0E, $00
        dc.b    $00, $00, $01, $E5, $01, $01, $E6, $0C, $03, $E9, $FA, $06, $EC, $03, $03, $F1
        dc.b    $0E, $00, $00, $00, $01, $E5, $03, $01, $E5, $03, $02, $E8, $FA, $05, $EB, $02
        dc.b    $04, $EE, $0D, $00, $00, $00, $01, $E4, $05, $01, $E4, $0D, $01, $E7, $FA, $04
        dc.b    $EA, $02, $05, $ED, $0D, $02, $F0, $F5, $01, $E3, $07, $01, $E3, $0D, $01, $E6
        dc.b    $F9, $03, $E9, $02, $06, $EC, $0C, $03, $EF, $F5, $01, $E2, $08, $01, $E2, $0D
        dc.b    $01, $E5, $F8, $02, $E8, $01, $05, $EB, $0C, $04, $EE, $F5, $01, $E1, $09, $01
        dc.b    $E1, $0D, $01, $E4, $F8, $01, $E7, $01, $04, $EA, $0B, $05, $ED, $F5, $01, $E3
        dc.b    $F7, $01, $E6, $00, $03, $E9, $0A, $05, $EC, $F6, $02, $E8, $02, $00, $00, $00
        dc.b    $01, $E2, $F7, $01, $E5, $00, $02, $E8, $0A, $04, $EB, $F6, $03, $E7, $02, $02
        dc.b    $E8, $0E, $01, $E1, $F6, $01, $E4, $00, $01, $E7, $09, $03, $EA, $F6, $04, $E6
        dc.b    $03, $03, $E7, $0E, $02, $F0, $F9, $05, $E5, $03, $04, $E6, $0D, $02, $E8, $F5
        dc.b    $00, $00, $00, $00, $00, $00, $03, $EF, $F9, $02, $F0, $07, $06, $E4, $03, $05
        dc.b    $E5, $0D, $03, $E7, $F5, $00, $00, $00, $04, $EE, $F9, $03, $EF, $07, $05, $E3
        dc.b    $02, $06, $E4, $0C, $04, $E6, $F5, $00, $00, $00, $05, $ED, $F9, $04, $EE, $08
        dc.b    $04, $E2, $02, $05, $E3, $0C, $05, $E5, $F5, $00, $00, $00, $06, $EC, $F9, $05
        dc.b    $ED, $08, $02, $F0, $FD, $03, $E1, $02, $04, $E2, $0B, $06, $E4, $F6, $05, $EB
        dc.b    $FA, $06, $EC, $09, $03, $EF, $FD, $02, $E0, $01, $03, $E1, $0A, $05, $E3, $F6
        dc.b    $04, $EA, $FB, $05, $EB, $09, $04, $EE, $FD, $01, $DF, $01, $02, $E0, $0A, $04
        dc.b    $E2, $F6, $03, $E9, $FC, $04, $EA, $0A, $05, $ED, $FC, $02, $F0, $02, $01, $DF
        dc.b    $09, $03, $E1, $F7, $02, $E8, $FD, $03, $E9, $0A, $06, $EC, $FB, $03, $EF, $02
        dc.b    $02, $E0, $F7, $00, $00, $00, $01, $E7, $00, $02, $E8, $0B, $05, $EB, $FB, $04
        dc.b    $EE, $03, $01, $DF, $F8, $00, $00, $00      
loc_012AA0:
        dc.b    $04, $08, $09, $04, $FC, $01, $05, $08, $09, $05, $FC, $01, $06, $08, $09, $06
        dc.b    $FC, $01, $07, $08, $09, $07, $FC, $01, $08, $08, $09, $08, $FC, $01, $07, $08
        dc.b    $09, $07, $FC, $01, $06, $08, $09, $06, $FC, $01, $05, $08, $09, $05, $FC, $01
        dc.b    $04, $08, $09, $04, $FC, $01, $04, $F9, $F7, $04, $0B, $FC, $05, $F9, $F7, $05
        dc.b    $0B, $FC, $06, $F9, $F7, $06, $0B, $FC, $07, $F9, $F7, $07, $0B, $FC, $08, $F9
        dc.b    $F7, $08, $0B, $FC, $07, $F9, $F7, $07, $0B, $FC, $06, $F9, $F7, $06, $0B, $FC
        dc.b    $05, $F9, $F7, $05, $0B, $FC, $04, $F9, $F7, $04, $0B, $FC, $04, $03, $F1, $04
        dc.b    $F4, $09, $05, $03, $F1, $05, $F4, $09, $06, $03, $F1, $06, $F4, $09, $07, $03
        dc.b    $F1, $07, $F4, $09, $08, $03, $F1, $08, $F4, $09, $07, $03, $F1, $07, $F4, $09
        dc.b    $06, $03, $F1, $06, $F4, $09, $05, $03, $F1, $05, $F4, $09, $04, $03, $F1, $04
        dc.b    $F4, $09                                 
;=============================================================================== 
; Object 0x35 - 
; 
;===============================================================================       

;=============================================================================== 
; Object 0x08 - 

;===============================================================================       
Obj08_Water_Splash: ; loc_012B42:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_012B50(pc,d0), d1
        jmp     loc_012B50(pc,d1)
loc_012B50:
        dc.w    loc_012B56-loc_012B50
        dc.w    loc_012B84-loc_012B50
        dc.w    J_DeleteObject_04-loc_012B50 ; loc_012B9C-...
loc_012B56:
        addq.b  #2,routine(a0)
        move.l  #Obj08_Mappings,mappings(a0) ; loc_012CF4
        ori.b   #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.w  #$449C,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.w  (MainCharacter+x_pos).w, x_pos(a0)
loc_012B84:
        move.w  (Water_Level_1).w, y_pos(a0)
        lea     (loc_012CEC), A1
        jsr     AnimateSprite           ; (loc_00D412)
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_04: ; loc_012B9C:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_012BA2:
        dc.w    loc_012BA4-loc_012BA2
loc_012BA4:
        dc.b    $00, $05, $00, $05, $01, $05, $02, $05, $03, $05, $04, $FF
loc_012BB0:
        dc.w    loc_012BBC-loc_012BB0
        dc.w    loc_012BDE-loc_012BB0
        dc.w    loc_012C00-loc_012BB0
        dc.w    loc_012C22-loc_012BB0
        dc.w    loc_012C44-loc_012BB0
        dc.w    loc_012C66-loc_012BB0
loc_012BBC:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF0, $F0050800, $08000000
        dc.l    $00051000, $1000FFF0, $00051800, $18000000
loc_012BDE:
        dc.w    $0004
        dc.l    $F0050004, $0002FFF0, $F0050804, $08020000
        dc.l    $00051004, $1002FFF0, $00051804, $18020000
loc_012C00:
        dc.w    $0004
        dc.l    $F0050008, $0004FFF0, $F0050808, $08040000
        dc.l    $00051008, $1004FFF0, $00051808, $18040000
loc_012C22:
        dc.w    $0004
        dc.l    $F005000C, $0006FFF0, $F005080C, $08060000
        dc.l    $0005100C, $1006FFF0, $0005180C, $18060000
loc_012C44:
        dc.w    $0004
        dc.l    $F0050010, $0008FFF0, $F0050810, $08080000
        dc.l    $00051010, $1008FFF0, $00051810, $18080000
loc_012C66:
        dc.w    $0004
        dc.l    $E00B0014, $000AFFE8, $E00B0814, $080A0000
        dc.l    $000B1014, $100AFFE8, $000B1814, $180A0000
loc_012C88:
        dc.w    loc_012C9A-loc_012C88
        dc.w    loc_012C9C-loc_012C88
        dc.w    loc_012CA6-loc_012C88
        dc.w    loc_012CB0-loc_012C88
        dc.w    loc_012CBA-loc_012C88
        dc.w    loc_012CC4-loc_012C88
        dc.w    loc_012CCE-loc_012C88
        dc.w    loc_012CD8-loc_012C88
        dc.w    loc_012CE2-loc_012C88
loc_012C9A:
        dc.w    $0000
loc_012C9C:
        dc.w    $0001
        dc.l    $F8010000, $0000FFFC
loc_012CA6:
        dc.w    $0001
        dc.l    $F8010002, $0001FFFC
loc_012CB0:
        dc.w    $0001
        dc.l    $F8010004, $0002FFFC
loc_012CBA:
        dc.w    $0001
        dc.l    $F8010006, $0003FFFC
loc_012CC4:
        dc.w    $0001
        dc.l    $F8010008, $0004FFFC
loc_012CCE:
        dc.w    $0001
        dc.l    $F805000A, $0005FFF8
loc_012CD8:
        dc.w    $0001
        dc.l    $F805000E, $0007FFF8
loc_012CE2:
        dc.w    $0001
        dc.l    $F00F0012, $0009FFF0
loc_012CEC:        
        dc.w    loc_012CEE-loc_012CEC
loc_012CEE:
        dc.b    $04, $00, $01, $02, $FC, $00  
Obj08_Mappings:         
loc_012CF4:
        dc.w    loc_012CFA-loc_012CF4
        dc.w    loc_012D0C-loc_012CF4
        dc.w    loc_012D1E-loc_012CF4
loc_012CFA:
        dc.w    $0002
        dc.l    $F204006D, $0036FFF8, $FA0C006F, $0037FFF0
loc_012D0C:
        dc.w    $0002
        dc.l    $E2000073, $0039FFF8, $EA0E0074, $003AFFF0
loc_012D1E:
        dc.w    $0001
        dc.l    $E20F0080, $0040FFF0
;=============================================================================== 
; Object 0x08 - 
; 
;===============================================================================

;=============================================================================== 
; Beginning of Sub Sonic_AnglePos
                 
;===============================================================================        
Sonic_AnglePos: ; loc_012D28:
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_012D40
        move.l  #Primary_Collision, ($FFFFF796).w
loc_012D40:
        move.b  Objoff_3E(A0), D5
        btst    #3, status(a0)
        beq.s   loc_012D58
        moveq	#0,d0
        move.b  d0, ($FFFFF768).w
        move.b  d0, ($FFFFF76A).w
        rts
loc_012D58:
        moveq   #3, d0
        move.b  d0, ($FFFFF768).w
        move.b  d0, ($FFFFF76A).w
        move.b  angle(A0), D0
        addi.b  #$20, d0
        bpl.s   loc_012D7A
        move.b  angle(A0), D0
        bpl.s   loc_012D74
        subq.b  #1,d0
loc_012D74:
        addi.b  #$20, d0
        bra.s   loc_012D86
loc_012D7A:
        move.b  angle(A0), D0
        bpl.s   loc_012D82
        addq.b  #1,d0
loc_012D82:
        addi.b  #$1F, d0
loc_012D86:
        andi.b  #$C0, d0
        cmpi.b  #$40, d0
        beq     Sonic_WalkVertL         ; loc_012FDC
        cmpi.b  #$80, d0
        beq     Sonic_WalkCeiling       ; loc_012F2E
        cmpi.b  #$C0, d0
        beq     Sonic_WalkVertR         ; loc_012E86
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  $0017(A0), D0
        ext.w   D0
        neg.w   D0
        add.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  (A7)+, D0
        bsr     Sonic_Angle             ; loc_012E4A
        tst.w   d1
        beq.s   loc_012E10
        bpl.s   loc_012E12
        cmpi.w  #$FFF2, d1
        blt.s   loc_012E10
        add.w   d1, y_pos(a0)
loc_012E10:
        rts
loc_012E12:
        move.b x_vel(A0), D0
        bpl.s   loc_012E1A
        neg.b   D0
loc_012E1A:
        addq.b  #4, d0
        cmpi.b  #$E, d0
        bcs.s   loc_012E26
        move.b  #$E, d0
loc_012E26:
        cmp.b   d0, d1
        bgt.s   loc_012E30
loc_012E2A:
        add.w   d1, y_pos(a0)
        rts
loc_012E30:
        tst.b   objoff_38(a0)
        bne.s   loc_012E2A 
        bset    #1, status(a0)
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
        rts
        
;=============================================================================== 
; Beginning of Sub Sonic_Angle
                 
;===============================================================================           
Sonic_Angle: ; loc_012E4A:
        move.b  ($FFFFF76A).w, D2
        cmp.w   d0, d1
        ble.s   loc_012E58
        move.b  ($FFFFF768).w, D2
        move.w  d0, d1
loc_012E58:
        btst    #0, D2
        bne.s   loc_012E74
        move.b  d2, d0
        sub.b   angle(A0), D0
        bpl.s   loc_012E68
        neg.b   D0
loc_012E68:
        cmpi.b  #$20, d0
        bcc.s   loc_012E74
        move.b  D2,angle(a0)
        rts
loc_012E74:
        move.b  angle(A0), D2
        addi.b  #$20, D2
        andi.b  #$C0, D2
        move.b  D2,angle(a0)
        rts    
;===============================================================================        
Sonic_WalkVertR: ; loc_012E86:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        neg.w   D0
        add.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindWall        ; loc_01349E
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindWall        ; loc_01349E
        move.w  (A7)+, D0
        bsr     Sonic_Angle             ; loc_012E4A        
        tst.w   d1
        beq.s   loc_012EF4
        bpl.s   loc_012EF6
        cmpi.w  #$FFF2, d1
        blt.s   loc_012EF4         
        add.w   d1, x_pos(a0)
loc_012EF4:
        rts
loc_012EF6:
        move.b  $0012(A0), D0
        bpl.s   loc_012EFE
        neg.b   D0  
loc_012EFE:
        addq.b  #4, d0
        cmpi.b  #$E, d0
        bcs.s   loc_012F0A
        move.b  #$E, d0
loc_012F0A:        
        cmp.b   d0, d1
        bgt.s   loc_012F14
loc_012F0E:
        add.w   d1, x_pos(a0)
        rts
loc_012F14:
        tst.b   objoff_38(a0)
        bne.s   loc_012F0E
        bset    #1, status(a0)
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
        rts
;===============================================================================        
Sonic_WalkCeiling: ; loc_012F2E:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, D2
        eori.w  #$F, D2
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, D2
        eori.w  #$F, D2
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  (A7)+, D0
        bsr     Sonic_Angle             ; loc_012E4A
        tst.w   d1
        beq.s   loc_012FA2
        bpl.s   loc_012FA4
        cmpi.w  #$FFF2, d1
        blt.s   loc_012FA2
        sub.w   d1, y_pos(a0)
loc_012FA2:
        rts
loc_012FA4:
        move.b x_vel(A0), D0
        bpl.s   loc_012FAC
        neg.b   D0
loc_012FAC:
        addq.b  #4, d0
        cmpi.b  #$E, d0
        bcs.s   loc_012FB8
        move.b  #$E, d0
loc_012FB8:
        cmp.b   d0, d1
        bgt.s   loc_012FC2
loc_012FBC:
        sub.w   d1, y_pos(a0)
        rts
loc_012FC2:
        tst.b   objoff_38(a0)
        bne.s   loc_012FBC   
        bset    #1, status(a0)
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
        rts
;===============================================================================        
Sonic_WalkVertL: ; loc_012FDC:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, d3
        eori.w  #$F, d3
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$400, D6
        bsr     FindWall        ; loc_01349E
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, d3
        eori.w  #$F, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$FFF0, A3
        move.w  #$400, D6
        bsr     FindWall        ; loc_01349E
        move.w  (A7)+, D0
        bsr     Sonic_Angle             ; loc_012E4A
        tst.w   d1
        beq.s   loc_013050
        bpl.s   loc_013052
        cmpi.w  #$FFF2, d1
        blt.s   loc_013050
        sub.w   d1, x_pos(a0)
loc_013050:
        rts
loc_013052:
        move.b  $0012(A0), D0
        bpl.s   loc_01305A
        neg.b   D0
loc_01305A:
        addq.b  #4, d0
        cmpi.b  #$E, d0
        bcs.s   loc_013066
        move.b  #$E, d0
loc_013066:        
        cmp.b   d0, d1
        bgt.s   loc_013070
loc_01306A:
        sub.w   d1, x_pos(a0)
        
        rts
loc_013070:
        tst.b   objoff_38(a0)
        bne.s   loc_01306A
        bset    #1, status(a0)  
        bclr    #5, status(a0)
        move.b  #1, $001D(a0)
        rts
        
;=============================================================================== 
; Beginning of Sub Floor_ChkTile
                 
;===============================================================================          
Floor_ChkTile: ; loc_01308A:
        move.w  d2, d0
        add.w   d0, d0
        andi.w  #$F00, d0
        move.w  d3, d1
        lsr.w   #3, d1
        move.w  d1, D4
        lsr.w   #4, d1
        andi.w  #$07F, d1
        add.w   d1, d0
        moveq   #$FFFFFFFF, d1
        clr.w   d1
        lea     ($FFFF8000).w, A1
        move.b  $00(A1, d0), d1
        add.w   d1, d1
        move.w  loc_0130C4(pc,d1), d1
        move.w  d2, d0
        andi.w  #$070, d0
        add.w   d0, d1
        andi.w  #$00E, D4
        add.w   d4, d1
        move.l  d1, A1
        rts
loc_0130C4:
        dc.w    $0000, $0080, $0100, $0180, $0200, $0280, $0300, $0380
        dc.w    $0400, $0480, $0500, $0580, $0600, $0680, $0700, $0780
        dc.w    $0800, $0880, $0900, $0980, $0A00, $0A80, $0B00, $0B80
        dc.w    $0C00, $0C80, $0D00, $0D80, $0E00, $0E80, $0F00, $0F80
        dc.w    $1000, $1080, $1100, $1180, $1200, $1280, $1300, $1380
        dc.w    $1400, $1480, $1500, $1580, $1600, $1680, $1700, $1780
        dc.w    $1800, $1880, $1900, $1980, $1A00, $1A80, $1B00, $1B80
        dc.w    $1C00, $1C80, $1D00, $1D80, $1E00, $1E80, $1F00, $1F80
        dc.w    $2000, $2080, $2100, $2180, $2200, $2280, $2300, $2380
        dc.w    $2400, $2480, $2500, $2580, $2600, $2680, $2700, $2780
        dc.w    $2800, $2880, $2900, $2980, $2A00, $2A80, $2B00, $2B80
        dc.w    $2C00, $2C80, $2D00, $2D80, $2E00, $2E80, $2F00, $2F80
        dc.w    $3000, $3080, $3100, $3180, $3200, $3280, $3300, $3380
        dc.w    $3400, $3480, $3500, $3580, $3600, $3680, $3700, $3780
        dc.w    $3800, $3880, $3900, $3980, $3A00, $3A80, $3B00, $3B80
        dc.w    $3C00, $3C80, $3D00, $3D80, $3E00, $3E80, $3F00, $3F80
        dc.w    $4000, $4080, $4100, $4180, $4200, $4280, $4300, $4380
        dc.w    $4400, $4480, $4500, $4580, $4600, $4680, $4700, $4780
        dc.w    $4800, $4880, $4900, $4980, $4A00, $4A80, $4B00, $4B80
        dc.w    $4C00, $4C80, $4D00, $4D80, $4E00, $4E80, $4F00, $4F80
        dc.w    $5000, $5080, $5100, $5180, $5200, $5280, $5300, $5380
        dc.w    $5400, $5480, $5500, $5580, $5600, $5680, $5700, $5780
        dc.w    $5800, $5880, $5900, $5980, $5A00, $5A80, $5B00, $5B80
        dc.w    $5C00, $5C80, $5D00, $5D80, $5E00, $5E80, $5F00, $5F80
        dc.w    $6000, $6080, $6100, $6180, $6200, $6280, $6300, $6380
        dc.w    $6400, $6480, $6500, $6580, $6600, $6680, $6700, $6780
        dc.w    $6800, $6880, $6900, $6980, $6A00, $6A80, $6B00, $6B80
        dc.w    $6C00, $6C80, $6D00, $6D80, $6E00, $6E80, $6F00, $6F80
        dc.w    $7000, $7080, $7100, $7180, $7200, $7280, $7300, $7380
        dc.w    $7400, $7480, $7500, $7580, $7600, $7680, $7700, $7780
        dc.w    $7800, $7880, $7900, $7980, $7A00, $7A80, $7B00, $7B80
        dc.w    $7C00, $7C80, $7D00, $7D80, $7E00, $7E80, $7F00, $7F80
        
;=============================================================================== 
; Beginning of Sub FindFloor
                 
;===============================================================================          
FindFloor: ; loc_0132C4:        
        bsr     Floor_ChkTile           ; loc_01308A
        move.w  (A1), D0
        move.w  d0, D4
        andi.w  #$3FF, d0
        beq.s   loc_0132D6
        btst    d5, D4
        bne.s   loc_0132E4
loc_0132D6:
        add.w   A3, D2
        bsr     FindFloor2              ; loc_01336A
        sub.w   A3, D2
        addi.w  #$010, d1
        rts
loc_0132E4:
        move.l  ($FFFFF796).w, a2
        add.w   d0, d0
        move.w  $00(A2, d0), D0
        beq.s   loc_0132D6
        lea     (AngleMap), A2          ; loc_02D1EA
        move.b  $00(A2, d0), (a4)
        lsl.w   #4, d0
        move.w  d3, d1
        btst    #$A, D4
        beq.s   loc_013308
        not.w   d1
        neg.b   (a4)
loc_013308:
        btst    #$B, D4
        beq.s   loc_013318
        addi.b  #$40, (a4)
        neg.b   (a4)
        subi.b  #$40, (a4)        
loc_013318:
        andi.w  #$F, d1
        add.w   d0, d1
        lea     (Colision_Array_1), A2  ; loc_02D2EA
        move.b  $00(A2, d1), D0
        ext.w   D0
        eor.w   d6, D4
        btst    #$B, D4
        beq.s   loc_013334
        neg.w   D0
loc_013334:
        tst.w   D0
        beq.s   loc_0132D6
        bmi.s   loc_013350
        cmpi.b  #$10, d0
        beq.s   loc_01335C
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        move.w  #$F, d1
        sub.w   d0, d1
        rts
loc_013350:
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        bpl     loc_0132D6
loc_01335C:        
        sub.w   A3, D2
        bsr     FindFloor2              ; loc_01336A
        add.w   A3, D2
        subi.w  #$010, d1
        rts
;=============================================================================== 
; End of Sub FindFloor
                
;=============================================================================== 

;=============================================================================== 
; Beginning of Sub FindFloor2
                 
;===============================================================================         
FindFloor2: ; loc_01336A:
        bsr     Floor_ChkTile           ; loc_01308A
        move.w  (A1), D0
        move.w  d0, D4
        andi.w  #$3FF, d0
        beq.s   loc_01337C
        btst    d5, D4
        bne.s   loc_01338A
loc_01337C:
        move.w  #$F, d1
        move.w  d2, d0
        andi.w  #$F, d0
        sub.w   d0, d1
        rts
loc_01338A:
        move.l  ($FFFFF796).w, a2
        add.w   d0, d0
        move.w  $00(A2, d0), D0
        beq.s   loc_01337C
        lea     (AngleMap), A2          ; loc_02D1EA
        move.b  $00(A2, d0), (a4)
        lsl.w   #4, d0
        move.w  d3, d1
        btst    #$A, D4
        beq.s   loc_0133AE
        not.w   d1
        neg.b   (a4)
loc_0133AE:
        btst    #$B, D4
        beq.s   loc_0133BE
        addi.b  #$40, (a4)
        neg.b   (a4)
        subi.b  #$40, (a4)
loc_0133BE:
        andi.w  #$F, d1
        add.w   d0, d1
        lea     (Colision_Array_1), A2  ; loc_02D2EA
        move.b  $00(A2, d1), D0          
        ext.w   D0
        eor.w   d6, D4
        btst    #$B, D4
        beq.s   loc_0133DA
        neg.w   D0         
loc_0133DA:
        tst.w   D0
        beq.s   loc_01337C 
        bmi.s   loc_0133F0
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        move.w  #$F, d1
        sub.w   d0, d1
        rts
loc_0133F0:
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        bpl     loc_01337C
        not.w  d1
        rts
loc_013400:
        bsr     Floor_ChkTile           ; loc_01308A
        move.w  (A1), D0
        move.w  d0, D4
        andi.w  #$3FF, d0
        beq.s   loc_013412
        btst    d5, D4
        bne.s   loc_013418
loc_013412:
        move.w  #$010, d1
        rts
loc_013418:
        move.l  ($FFFFF796).w, a2
        add.w   d0, d0
        move.w  $00(A2, d0), D0
        beq.s   loc_013412
        lea     (AngleMap), A2          ; loc_02D1EA
        move.b  $00(A2, d0), (a4)
        lsl.w   #4, d0
        move.w  d3, d1
        btst    #$A, D4
        beq.s   loc_01343C
        not.w   d1
        neg.b   (a4)
loc_01343C:
        btst    #$B, D4
        beq.s   loc_01344C
        addi.b  #$40, (a4)
        neg.b   (a4)
        subi.b  #$40, (a4)
loc_01344C:
        andi.w  #$F, d1
        add.w   d0, d1
        lea     (Colision_Array_1), A2  ; loc_02D2EA
        move.b  $00(A2, d1), D0
        ext.w   D0
        eor.w   d6, D4
        btst    #$B, D4
        beq.s   loc_013468
        neg.w   D0
loc_013468:
        tst.w   D0
        beq.s   loc_013412
        bmi.s   loc_013484
        cmpi.b  #$10, d0
        beq.s   loc_013490
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        move.w  #$F, d1
        sub.w   d0, d1
        rts
loc_013484:
        move.w  D2, d1
        andi.w  #$F, d1
        add.w   d1, d0
        bpl     loc_013412
loc_013490:
        sub.w   A3, D2
        bsr     FindFloor2              ; loc_01336A
        add.w   A3, D2
        subi.w  #$010, d1
        rts
;=============================================================================== 
; End of Sub FindFloor2
                
;===============================================================================         
            
;=============================================================================== 
; Beginning of Sub FindWall
                 
;===============================================================================          
FindWall: ; loc_01349E:
        bsr     Floor_ChkTile           ; loc_01308A
        move.w  (A1), D0
        move.w  d0, D4
        andi.w  #$3FF, d0
        beq.s   loc_0134B0
        btst    d5, D4
        bne.s   loc_0134BE
loc_0134B0:
        add.w   A3, d3
        bsr     FindWall2               ; loc_013544
        sub.w   A3, d3
        addi.w  #$010, d1
        rts
loc_0134BE:
        move.l  ($FFFFF796).w, a2
        add.w   d0, d0
        move.w  $00(A2, d0), D0
        beq.s   loc_0134B0
        lea     (AngleMap), A2          ; loc_02D1EA
        move.b  $00(A2, d0), (a4)
        lsl.w   #4, d0
        move.w  D2, d1
        btst    #$B, D4
        beq.s   loc_0134EA
        not.w   d1
        addi.b  #$40, (a4)
        neg.b   (a4)
        subi.b  #$40, (a4)
loc_0134EA:
        btst    #$A, D4
        beq.s   loc_0134F2
        neg.b   (a4)
loc_0134F2:
        andi.w  #$F, d1
        add.w   d0, d1
        lea     (Colision_Array_2), A2  ; loc_02E2EA
        move.b  $00(A2, d1), D0
        ext.w   D0
        eor.w   d6, D4
        btst    #$A, D4
        beq.s   loc_01350E
        neg.w   D0
loc_01350E:
        tst.w   D0
        beq.s   loc_0134B0
        bmi.s   loc_01352A
        cmpi.b  #$10, d0
        beq.s   loc_013536
        move.w  d3, d1
        andi.w  #$F, d1
        add.w   d1, d0
        move.w  #$F, d1
        sub.w   d0, d1
        rts
loc_01352A:
        move.w  d3, d1
        andi.w  #$F, d1
        add.w   d1, d0
        bpl     loc_0134B0
loc_013536:
        sub.w   A3, d3
        bsr     FindWall2               ; loc_013544
        add.w   A3, d3
        subi.w  #$010, d1
        rts
;=============================================================================== 
; End of Sub FindWall
                
;===============================================================================    

;=============================================================================== 
; Beginning of Sub FindWall2
                 
;===============================================================================         
FindWall2: ; loc_013544:
        bsr     Floor_ChkTile           ; loc_01308A
        move.w  (A1), D0
        move.w  d0, D4
        andi.w  #$3FF, d0
        beq.s   loc_013556
        btst    d5, D4
        bne.s   loc_013564
loc_013556:
        move.w  #$F, d1
        move.w  d3, d0
        andi.w  #$F, d0
        sub.w   d0, d1
        rts
loc_013564:
        move.l  ($FFFFF796).w, a2
        add.w   d0, d0
        move.w  $00(A2, d0), D0
        beq.s   loc_013556
        lea     (AngleMap), A2          ; loc_02D1EA
        move.b  $00(A2, d0), (a4)
        lsl.w   #4, d0
        move.w  D2, d1
        btst    #$B, D4
        beq.s   loc_013590
        not.w   d1
        addi.b  #$40, (a4)
        neg.b   (a4)
        subi.b  #$40, (a4)
loc_013590:
        btst    #$A, D4
        beq.s   loc_013598
        neg.b   (a4)
loc_013598:
        andi.w  #$F, d1
        add.w   d0, d1
        lea     (Colision_Array_2), A2  ; loc_02E2EA
        move.b  $00(A2, d1), D0
        ext.w   D0
        eor.w   d6, D4
        btst    #$A, D4
        beq.s   loc_0135B4
        neg.w   D0
loc_0135B4:        
        tst.w   D0
        beq.s   loc_013556
        bmi.s   loc_0135CA
        move.w  d3, d1
        andi.w  #$F, d1
        add.w   d1, d0
        move.w  #$F, d1
        sub.w   d0, d1
        rts
loc_0135CA:
        move.w  d3, d1
        andi.w  #$F, d1
        add.w   d1, d0
        bpl     loc_013556
        not.w  d1
        rts
;=============================================================================== 
; End of Sub FindWall2
                
;===============================================================================  
        
loc_0135DA:
        rts 
;===============================================================================        
; loc_0135DC:
        lea     (Colision_Array_1), A1  ; loc_02D2EA
        lea     (Colision_Array_1), A2  ; loc_02D2EA
        move.w  #$0FF, d3
loc_0135EC:        
        moveq   #$10,d5
        move.w  #$F, D2
loc_0135F2:        
        moveq   #0, D4
        move.w  #$F, d1
loc_0135F8:        
        move.w  (A1)+, D0
        lsr.l   d5, d0
        addx.w  d4, D4
        dbra    d1, loc_0135F8
        move.w  d4, (A2)+
        suba.w  #$20, A1
        subq.w  #1,d5
        dbra    D2, loc_0135F2
        adda.w  #$20, A1
        dbra    d3, loc_0135EC
        lea     (Colision_Array_1), A1  ; loc_02D2EA
        lea     (Colision_Array_2), A2  ; loc_02E2EA
        bsr.s   loc_013630
        lea     (Colision_Array_1), A1  ; loc_02D2EA
        lea     (Colision_Array_1), A2  ; loc_02D2EA
loc_013630:                
        move.w  #$FFF, d3
loc_013634:        
        moveq   #0, D2
        move.w  #$F, d1
        move.w  (A1)+, D0
        beq.s   loc_013662
        bmi.s   loc_01364C
loc_013640:        
        lsr.w   #1,d0
        bcc.s   loc_013646
        addq.b  #1, D2
loc_013646:
        dbra    d1, loc_013640
        bra.s   loc_013664
loc_01364C:
        cmpi.w  #$FFFF, d0
        beq.s   loc_01365E
loc_013652:        
        lsl.w   #1,d0
        bcc.s   loc_013658
        subq.b  #1, D2
loc_013658:
        dbra    d1, loc_013652
        bra.s   loc_013664
loc_01365E:
        move.w  #$010, d0
loc_013662:
        move.w  d0, D2
loc_013664:
        move.b  D2, (A2)+
        dbra    d3, loc_013634
        rts
;=============================================================================== 
; Beginning of Sub Sonic_WalkSpeed
                 
;===============================================================================                  
Sonic_WalkSpeed: ; loc_01366C:
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_013684
        move.l  #Primary_Collision, ($FFFFF796).w
loc_013684:
        move.b  Objoff_3F(A0), D5
        move.l  x_pos(a0), D3
        move.l  y_pos(a0), D2
        move.w x_vel(A0), d1
        ext.l   d1
        asl.l   #8, d1
        add.l   d1, d3
        move.w  $0012(A0), d1
        ext.l   d1
        asl.l   #8, d1
        add.l   d1, D2
        swap.w  D2
        swap.w  D3
        move.b  d0, ($FFFFF768).w
        move.b  d0, ($FFFFF76A).w
        move.b  d0, d1
        addi.b  #$20, d0
        bpl.s   loc_0136C4
        move.b  d1, d0
        bpl.s   loc_0136BE
        subq.b  #1,d0
loc_0136BE:
        addi.b  #$20, d0
        bra.s   loc_0136CE
loc_0136C4:
        move.b  d1, d0
        bpl.s   loc_0136CA
        addq.b  #1,d0
loc_0136CA:
        addi.b  #$1F, d0
loc_0136CE:
        andi.b  #$C0, d0
        beq     loc_0137CE
        cmpi.b  #$80, d0
        beq     loc_013A3C
        andi.b  #$38, d1
        bne.s   loc_0136E6
        addq.w  #8, D2
loc_0136E6:
        cmpi.b  #$40, d0
        beq     loc_013B04
        bra     loc_013982            
loc_0136F2:
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_01370A
        move.l  #Primary_Collision, ($FFFFF796).w
loc_01370A:
        move.b  Objoff_3F(A0), D5
        move.b  d0, ($FFFFF768).w
        move.b  d0, ($FFFFF76A).w
        addi.b  #$20, d0
        andi.b  #$C0, d0
        cmpi.b  #$40, d0
        beq     loc_013A94
        cmpi.b  #$80, d0
        beq     Sonic_DontRunOnWalls    ; loc_0139CC
        cmpi.b  #$C0, d0
        beq     loc_01391A
loc_013736:        
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_01374E
        move.l  #Primary_Collision, ($FFFFF796).w
loc_01374E:
        move.b  Objoff_3E(A0), D5
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  (A7)+, D0
        move.b  #0, D2
loc_0137AE:        
        move.b  ($FFFFF76A).w, d3
        cmp.w   d0, d1
        ble.s   loc_0137BC
        move.b  ($FFFFF768).w, d3
        exg.l   d1, d0
loc_0137BC:
        btst    #0, d3
        beq.s   loc_0137C4
        move.b  D2, d3
loc_0137C4:
        rts
; loc_0137C6:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3        
loc_0137CE:
        addi.w  #$00A, D2
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindFloor               ; loc_0132C4
        move.b  #0, D2
loc_0137E6:        
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_0137F2
        move.b  D2, d3
loc_0137F2:
        rts   
        
;=============================================================================== 
; Beginning of Sub Sonic_HitFloor
                 
;===============================================================================                       
Sonic_HitFloor: ; loc_0137F4:
        move.w  x_pos(a0), D3
        move.w  y_pos(a0), D2
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a0)
        beq.s   loc_01381E
        move.l  #Primary_Collision, ($FFFFF796).w
loc_01381E:
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        move.b  Objoff_3E(A0), D5
        bsr     FindFloor               ; loc_0132C4
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_013844
        move.b  #0, d3
loc_013844:
        rts  
;=============================================================================== 
; End of Sub Sonic_HitFloor
                
;===============================================================================          

;=============================================================================== 
; Beginning of Sub Sonic_HitFloor2
                 
;===============================================================================         
Sonic_HitFloor2: ; loc_013846:
        move.w  x_pos(A1), D3
        move.w  y_pos(A1), D2
        moveq	#0,d0
        move.b  y_radius(A1), D0
        ext.w   D0
        add.w   d0, D2
        move.l  #Tails_Tails, ($FFFFF796).w
        cmpi.b  #$C, Objoff_3E(a1)
        beq.s   loc_013870
        move.l  #Primary_Collision, ($FFFFF796).w
loc_013870:
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        move.b  Objoff_3E(A1), D5
        bsr     FindFloor               ; loc_0132C4
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_013896
        move.b  #0, d3
loc_013896:
        rts
;=============================================================================== 
; End of Sub Sonic_HitFloor2
                
;===============================================================================   

;=============================================================================== 
; Beginning of Sub ObjHitFloor
                 
;===============================================================================           
ObjHitFloor: ; loc_013898:
        move.w  x_pos(a0), D3
ObjHitFloor2: ; loc_01389C:               
        move.w  y_pos(a0), D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        moveq   #$C,d5
        bsr     FindFloor               ; loc_0132C4
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_0138CC
        move.b  #0, d3
loc_0138CC:
        rts 
;=============================================================================== 
; End of Sub ObjHitFloor
                
;===============================================================================  
         
loc_0138CE:
        move.w  x_pos(A1), D3
        move.w  y_pos(A1), D2
        move.b  y_radius(A1), D0
        ext.w   D0
        add.w   d0, D2
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        moveq   #$C,d5
        bra     FindFloor               ; loc_0132C4
loc_0138F4:
        move.w  x_pos(a0), D3
        move.w  y_pos(a0), D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, D2
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        moveq   #$C,d5
        bra     loc_013400
;===============================================================================        
loc_01391A:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindWall        ; loc_01349E
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindWall        ; loc_01349E
        move.w  (A7)+, D0
        move.b  #$C0, D2
        bra     loc_0137AE 
;===============================================================================                       
loc_01397A:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3        
loc_013982:
        addi.w  #$00A, d3
        lea     ($FFFFF768).w, A4
        move.w  #$010, A3
        move.w  #0, D6
        bsr     FindWall        ; loc_01349E
        move.b  #$C0, D2
        bra     loc_0137E6 
          
;=============================================================================== 
; Beginning of Sub ObjHitWallRight
                 
;===============================================================================          
ObjHitWallRight: ; loc_01399E:
        add.w   x_pos(a0), D3
        move.w  y_pos(a0), D2
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$010, A3
        move.w  #0, D6
        moveq   #$D,d5
        bsr     FindWall        ; loc_01349E
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_0139CA
        move.b  #$C0, d3
loc_0139CA:
        rts
;=============================================================================== 
; End of Sub ObjHitWallRight
                
;===============================================================================          
        
;=============================================================================== 
; Beginning of Sub Sonic_DontRunOnWalls
                 
;===============================================================================          
Sonic_DontRunOnWalls: ; loc_0139CC:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, D2
        eori.w  #$F, D2
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, d3
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, D2
        eori.w  #$F, D2
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        bsr     FindFloor               ; loc_0132C4
        move.w  (A7)+, D0
        move.b  #$80, D2
        bra     loc_0137AE
;=============================================================================== 
; End of Sub Sonic_DontRunOnWalls
                
;===============================================================================               
              
;loc_013A34:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
loc_013A3C:
        subi.w  #$00A, D2
        eori.w  #$F, D2
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        bsr     FindFloor               ; loc_0132C4
        move.b  #$80, D2
        bra     loc_0137E6 
;===============================================================================        
; ObjHitCeiling ; loc_013A5C:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, D2
        eori.w  #$F, D2
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$800, D6
        moveq   #$D,d5
        bsr     FindFloor               ; loc_0132C4
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_013A92
        move.b  #$80, d3
loc_013A92:
        rts
;===============================================================================        
loc_013A94:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        sub.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, d3
        eori.w  #$F, d3
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$400, D6
        bsr     FindWall        ; loc_01349E
        move.w  d1, -(A7)
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        moveq	#0,d0
        move.b  $0017(A0), D0
        ext.w   D0
        add.w   d0, D2
        move.b  y_radius(A0), D0
        ext.w   D0
        sub.w   d0, d3
        eori.w  #$F, d3
        lea     ($FFFFF76A).w, A4
        move.w  #$FFF0, A3
        move.w  #$400, D6
        bsr     FindWall        ; loc_01349E
        move.w  (A7)+, D0
        move.b  #$40, D2
        bra     loc_0137AE   
        
;=============================================================================== 
; Beginning of Sub Sonic_HitWall
                 
;===============================================================================           
Sonic_HitWall: ; loc_013AFC:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3        
loc_013B04:
        subi.w  #$00A, d3
        eori.w  #$F, d3
        lea     ($FFFFF768).w, A4
        move.w  #$FFF0, A3
        move.w  #$400, D6
        bsr     FindWall        ; loc_01349E
        move.b  #$40, D2
        bra     loc_0137E6    
;===============================================================================                             
ObjHitWallLeft: ; loc_013B24:
        add.w   x_pos(a0), D3
        move.w  y_pos(a0), D2
        lea     ($FFFFF768).w, A4
        move.b  #0, (a4)
        move.w  #$FFF0, A3
        move.w  #$400, D6
        moveq   #$D,d5
        bsr     FindWall        ; loc_01349E
        move.b  ($FFFFF768).w, d3
        btst    #0, d3
        beq.s   loc_013B50
        move.b  #$40, d3
loc_013B50:
        rts
        nop                     ; Filler
;=============================================================================== 
; Object 0x79 - Lamp Post

;===============================================================================              
Obj79_Lamp_Post: ; loc_013B54:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_013B68(pc,d0), d1
        jsr     loc_013B68(pc,d1)
        jmp     MarkObjGone             ; (loc_00D2A0)
loc_013B68:
        dc.w    loc_013B6E-loc_013B68
        dc.w    loc_013BD0-loc_013B68
        dc.w    loc_013C58-loc_013B68
loc_013B6E:
        addq.b  #2,routine(a0)
        move.l  #Lamp_Post_Mappings,mappings(a0) ; loc_013D8E
        move.w  #$47C,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #8,width_pixels(a0)
        move.b  #5, $0018(a0)
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        bclr    #$7, $02(A2, d0)
        btst    #0, $02(A2, d0)
        bne.s   loc_013BC2
        move.b  (Last_star_pole_hit).w, d1
        andi.b  #$7F, d1
        move.b  subtype(A0), D2
        andi.b  #$7F, D2
        cmp.b   D2, d1
        bcs.s   loc_013BD0
loc_013BC2:
        bset    #0, $02(A2, d0)
        move.b  #4,routine(a0)
        rts
loc_013BD0:
        tst.w   (Debug_placement_mode).w
        bne     loc_013C56
        tst.b   ($FFFFB02A).w
        bmi     loc_013C56
        move.b  (Last_star_pole_hit).w, d1
        andi.b  #$7F, d1
        move.b  subtype(A0), D2
        andi.b  #$7F, D2
        cmp.b   D2, d1
        bcs.s   loc_013C0E
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        bset    #0, $02(A2, d0)
        move.b  #4,routine(a0)
        bra     loc_013C56
loc_013C0E:
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        addi.w  #8, d0
        cmpi.w  #$010, d0
        bcc     loc_013C56
        move.w  ($FFFFB00C).w, d0
        sub.w   y_pos(a0), D0
        addi.w  #$40, d0
        cmpi.w  #$068, d0
        bcc.s   loc_013C56
        move.w  #$0A1, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #2,routine(a0)
        bsr     Lamp_Post_Save_Info     ; loc_013C6A
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        bset    #0, $02(A2, d0)
loc_013C56:
        rts
loc_013C58:
        move.b  ($FFFFFE0F).w, d0
        andi.b  #$2, d0
        lsr.b   #1,d0
        addq.b  #1,d0
        move.b  d0, $001A(a0)
        rts
Lamp_Post_Save_Info: ; loc_013C6A:
        move.b  subtype(A0), (Last_star_pole_hit).w
        move.b  (Last_star_pole_hit).w, (Saved_Last_star_pole_hit).w
        move.w  x_pos(a0), (Saved_x_pos).w
        move.w  y_pos(a0), (Saved_y_pos).w
        move.w  (Ring_count).w, (Saved_Ring_count).w
        move.b  ($FFFFFE1B).w, ($FFFFFE54).w
        move.l  ($FFFFFE22).w, (Saved_Timer).w
        move.b  ($FFFFEEDF).w, ($FFFFFE3C).w
        move.w  ($FFFFEECE).w, ($FFFFFE3E).w
        move.w  ($FFFFEE00).w, ($FFFFFE40).w
        move.w  ($FFFFEE04).w, ($FFFFFE42).w
        move.w  ($FFFFEE08).w, ($FFFFFE44).w
        move.w  ($FFFFEE0C).w, ($FFFFFE46).w
        move.w  ($FFFFEE10).w, ($FFFFFE48).w
        move.w  ($FFFFEE14).w, ($FFFFFE4A).w
        move.w  ($FFFFEE18).w, ($FFFFFE4C).w
        move.w  ($FFFFEE1C).w, ($FFFFFE4E).w
        move.w  (Water_Level_2).w, ($FFFFFE50).w
        move.b  (Water_routine).w, ($FFFFFE52).w
        move.b  (Water_move).w, ($FFFFFE53).w
        rts
Lamp_Post_Load_Info: ; loc_013CE4:
        move.b  (Saved_Last_star_pole_hit).w, (Last_star_pole_hit).w
        move.w  (Saved_x_pos).w, (MainCharacter+x_pos).w
        move.w  (Saved_y_pos).w, ($FFFFB00C).w
        move.w  (Saved_Ring_count).w, (Ring_count).w
        move.b  ($FFFFFE54).w, ($FFFFFE1B).w
        clr.w   (Ring_count).w
        clr.b   ($FFFFFE1B).w
        move.l  (Saved_Timer).w, ($FFFFFE22).w
        move.b  #$3B, (Timer_centisecond).w
        subq.b  #1, (Timer_second).w
        move.b  ($FFFFFE3C).w, ($FFFFEEDF).w
        move.b  ($FFFFFE52).w, (Water_routine).w
        move.w  ($FFFFFE3E).w, ($FFFFEECE).w
        move.w  ($FFFFFE3E).w, ($FFFFEEC6).w
        move.w  ($FFFFFE40).w, ($FFFFEE00).w
        move.w  ($FFFFFE42).w, ($FFFFEE04).w
        move.w  ($FFFFFE44).w, ($FFFFEE08).w
        move.w  ($FFFFFE46).w, ($FFFFEE0C).w
        move.w  ($FFFFFE48).w, ($FFFFEE10).w
        move.w  ($FFFFFE4A).w, ($FFFFEE14).w
        move.w  ($FFFFFE4C).w, ($FFFFEE18).w
        move.w  ($FFFFFE4E).w, ($FFFFEE1C).w
        tst.b   ($FFFFF730).w
        beq.s   loc_013D7A
        move.w  ($FFFFFE50).w, (Water_Level_2).w
        move.b  ($FFFFFE52).w, (Water_routine).w
        move.b  ($FFFFFE53).w, (Water_move).w
loc_013D7A:
        tst.b   (Last_star_pole_hit).w
        bpl.s   loc_013D8C
        move.w  (Saved_x_pos).w, d0
        subi.w  #$0A0, d0
        move.w  d0, ($FFFFEEC8).w
loc_013D8C:
        rts
Lamp_Post_Mappings:
loc_013D8E:
        dc.w    loc_013D94-loc_013D8E
        dc.w    loc_013DB6-loc_013D8E
        dc.w    loc_013DD8-loc_013D8E
loc_013D94:
        dc.w    $0004
        dc.l    $E8012000, $2000FFF8, $E8012800, $28000000
        dc.l    $F8030006, $0003FFF8, $F8030806, $08030000
loc_013DB6:
        dc.w    $0004
        dc.l    $E8010002, $0001FFF8, $E8010802, $08010000
        dc.l    $F8030006, $0003FFF8, $F8030806, $08030000
loc_013DD8:
        dc.w    $0004
        dc.l    $E8012004, $2002FFF8, $E8012804, $28020000
        dc.l    $F8030006, $0003FFF8, $F8030806, $08030000   
;=============================================================================== 
; Object 0x79 - Lamp Post
; 
;===============================================================================            
        nop                     ; Filler             
;=============================================================================== 
; Object 0x7D - Hidden Bonus at end of levels - Sonic 1 Leftover

;===============================================================================            
Obj7D_Hidden_Bonus: ; loc_013DFC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_013E0A(pc,d0), d1
        jmp     loc_013E0A(pc,d1)
loc_013E0A:
        dc.w    loc_013E0E-loc_013E0A
        dc.w    loc_013EB2-loc_013E0A
loc_013E0E:
        moveq   #$10, D2
        move.w  D2, d3
        add.w   d3, d3
        lea     (MainCharacter).w, A1
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d2, d0
        cmp.w   d3, d0
        bcc.s   loc_013E90
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        add.w   D2, d1
        cmp.w   d3, d1
        bcc.s   loc_013E90
        tst.w   (Debug_placement_mode).w
        bne.s   loc_013E90
        tst.b   ($FFFFF7CD).w
        bne.s   loc_013E90
        addq.b  #2,routine(a0)
        move.l  #Hidden_Bonus_Mappings,mappings(a0) ; loc_013ED6
        move.w  #$84B6,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #0, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  subtype(A0), $001A(a0)
        move.w  #$077, Objoff_30(a0)
        move.w  #$0C9, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.w  loc_013EAA(pc,d0), D0
        jsr     AddPoints               ; (loc_022FD0)
loc_013E90:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_05       ; loc_013EA4
        rts
J_DeleteObject_05: ; loc_013EA4:
        jmp     DeleteObject            ; (loc_00D3B4)        
loc_013EAA:
        dc.w    $0000, $03E8, $0064, $0001  ; Bonus Points
loc_013EB2:
        subq.w  #1, Objoff_30(a0)
        bmi.s   J_DeleteObject_06       ; loc_013ED0
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_06       ; loc_013ED0
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_06: ; loc_013ED0:
        jmp     DeleteObject            ; (loc_00D3B4)
Hidden_Bonus_Mappings:        
loc_013ED6:
        dc.w    loc_013EDE-loc_013ED6
        dc.w    loc_013EE0-loc_013ED6
        dc.w    loc_013EEA-loc_013ED6
        dc.w    loc_013EF4-loc_013ED6
loc_013EDE:
        dc.w    $0000
loc_013EE0:
        dc.w    $0001
        dc.l    $F40E0000, $0000FFF0
loc_013EEA:
        dc.w    $0001
        dc.l    $F40E000C, $0006FFF0
loc_013EF4:
        dc.w    $0001
        dc.l    $F40E0018, $000CFFF0   
;=============================================================================== 
; Object 0x7D - Hidden Bonus at end of levels - Sonic 1 Leftover
; 
;===============================================================================      
        nop                     ; Filler  
;=============================================================================== 
; Object ??? - Unknow Object 0x013F00

;===============================================================================          
S1_Obj47: ; Unknow_Obj013F00: ; loc_013F00:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_013F0E(pc,d0), d1
        jmp     loc_013F0E(pc,d1)
loc_013F0E:
        dc.w    loc_013F12-loc_013F0E
        dc.w    loc_013F40-loc_013F0E
loc_013F12:
        addq.b  #2,routine(a0)
        move.l  #S1_Obj47_Mappings,mappings(a0) ; loc_01401E
        move.w  #$380,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  #$d7,collision_flags(a0)
loc_013F40:
        move.b  $0021(A0), D0
        beq     loc_014002
        lea     (MainCharacter).w, A1
        bclr    #0, $0021(a0)
        beq.s   loc_013F56
        bsr.s   loc_013F6C
loc_013F56:
        lea     (Sidekick).w, A1
        bclr    #1, $0021(a0)
        beq.s   loc_013F64
        bsr.s   loc_013F6C
loc_013F64:
        clr.b   $0021(a0)
        bra     loc_014002
loc_013F6C:
        move.w  x_pos(a0), d1
        move.w  y_pos(a0), D2
        sub.w   x_pos(A1), d1
        sub.w   y_pos(A1), D2
        jsr     CalcAngle               ; loc_0034A2
        jsr     CalcSine        ; loc_00320A
        muls.w  #$F900, d1
        asr.l   #8, d1
        move.w  d1,x_vel(a1)
        muls.w  #$F900, d0
        asr.l   #8,d0
        move.w  d0, $0012(a1)
        bset    #1, status(a1)
        bclr    #4, status(a1)
        bclr    #5, status(a1)
        clr.b   $003C(a1)
        move.b  #1, $001C(a0)
        move.w  #$0B4, d0
        jsr     Play_Sfx        ; (loc_0014C6)
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_013FDA
        cmpi.b  #$8A, $02(A2, d0)
        bcc.s   loc_014000
        addq.b  #1, $02(A2, d0)
loc_013FDA:
        moveq   #1,d0
        jsr     AddPoints               ; (loc_022FD0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_014000
        move.b  #$29, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  #4, $001A(a1)
loc_014000:
        rts
loc_014002:
        lea     (loc_014010), A1
        bsr     AnimateSprite           ; loc_00D412
        bra     MarkObjGone             ; loc_00D2A0              
loc_014010:
        dc.w    loc_014014-loc_014010
        dc.w    loc_014017-loc_014010
loc_014014:
        dc.b    $0F, $00, $FF
loc_014017:
        dc.b    $03, $01, $02, $01, $02, $FD, $00
S1_Obj47_Mappings: ; Unknow_Obj013F00_Mappings:   loc_01401E:
        dc.w    loc_014024-S1_Obj47_Mappings
        dc.w    loc_014036-S1_Obj47_Mappings
        dc.w    loc_014048-S1_Obj47_Mappings
loc_014024:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F0070800, $08000000
loc_014036:
        dc.w    $0002
        dc.l    $F4060008, $0004FFF4, $F4020808, $08040004
loc_014048:
        dc.w    $0002
        dc.l    $F007000E, $0007FFF0, $F007080E, $08070000                  
;=============================================================================== 
; Object ??? - Unknow Object 0x013F00

;===============================================================================          
        nop                     ; Filler
;=============================================================================== 
; Object ??? - Unknow Object 0x01405C

;===============================================================================          
S1_Obj64: ; Unknow_Obj01405C: ; loc_01405C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01406A(pc,d0), d1
        jmp     loc_01406A(pc,d1)
loc_01406A:
        dc.w    loc_014076-loc_01406A
        dc.w    loc_0140D8-loc_01406A
        dc.w    loc_0140F2-loc_01406A
        dc.w    loc_0141AC-loc_01406A
        dc.w    loc_0141CA-loc_01406A
        dc.w    loc_0141CE-loc_01406A
loc_014076:
        addq.b  #2,routine(a0)
        move.l  #Obj0A_Bubbles_Mappings,mappings(a0) ; loc_014374
        move.w  #$8500,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #$84,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  subtype(A0), D0
        bpl.s   loc_0140BE
        addq.b  #8, $0024(a0)
        andi.w  #$07F, d0
        move.b  d0, $0032(a0)
        move.b  d0, $0033(a0)
        move.b  #6, $001C(a0)
        bra     loc_0141CE
loc_0140BE:
        move.b  d0, $001C(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  #$FF78, $0012(a0)
        jsr     PseudoRandomNumber      ; loc_0031E4
        move.b  d0,angle(a0)
loc_0140D8:
        lea     (loc_014348), A1
        jsr     AnimateSprite           ; (loc_00D412)
        cmpi.b  #6, $001A(a0)
        bne.s   loc_0140F2
        move.b  #1, $002E(a0)
loc_0140F2:
        move.w  (Water_Level_1).w, d0
        cmp.w   y_pos(a0), D0
        bcs.s   loc_01410A
loc_0140FC        
        move.b  #6, $0024(a0)
        addq.b  #3, $001C(a0)
        bra     loc_0141AC
loc_01410A:
        move.b  angle(A0), D0
        addq.b  #1,angle(a0)
        andi.w  #$07F, d0
        lea     (loc_01220C), A1
        move.b  $00(A1, d0), D0
        ext.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        tst.b   $002E(a0)
        beq.s   loc_014196
        bsr     loc_01430A
        beq.s   loc_014196
        bsr     ResumeMusic             ; loc_0124FE
        move.w  #$0AD, d0
        jsr     Play_Sfx        ; (loc_0014C6)
        lea     (MainCharacter).w, A1
        clr.w  x_vel(a1)
        clr.w   $0012(a1)
        clr.w   $14(a1)
        move.b  #$15, $001C(a1)
        move.w  #$023, $002E(a1)
        move.b  #0, $003C(a1)
        bclr    #5, status(a1)
        bclr    #4, status(a1)
        btst    #$2, status(a1)
        beq     loc_0140FC
        bclr    #$2, status(a1)
        move.b  #$13, y_radius(a1)
        move.b  #$9, $0017(a1)
        subq.w  #5, y_pos(a1)
        bra     loc_0140FC
loc_014196:
        bsr     SpeedToPos              ; loc_00D27A
        tst.b   render_flags(a0)
        bpl.s   J_DeleteObject_07       ; loc_0141A6
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_07: ; loc_0141A6:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_0141AC:
        lea     (loc_014348), A1
        jsr     AnimateSprite           ; (loc_00D412)
        tst.b   render_flags(a0)
        bpl.s   J_DeleteObject_08       ; loc_0141C4
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_08: ; loc_0141C4:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_0141CA:
        bra     DeleteObject            ; loc_00D3B4
loc_0141CE:
        tst.w   objoff_36(a0)
        bne.s   loc_014230
        move.w  (Water_Level_1).w, d0
        cmp.w   y_pos(a0), D0
        bcc     loc_0142D6
        tst.b   render_flags(a0)
        bpl     loc_0142D6
        subq.w  #1, objoff_38(a0)
        bpl     loc_0142CA
        move.w  #$001, objoff_36(a0)
loc_0141F6:        
        jsr     PseudoRandomNumber      ; loc_0031E4
        move.w  d0, d1
        andi.w  #$007, d0
        cmpi.w  #$006, d0
        bcc.s   loc_0141F6
        move.b  d0, Objoff_34(a0)
        andi.w  #$00C, d1
        lea     (loc_0142F8), A1
        adda.w  d1, A1
        move.l  A1, Objoff_3C(a0)
        subq.b  #1, $0032(a0)
        bpl.s   loc_01422E
        move.b  $0033(A0), $0032(a0)
        bset    #$7, objoff_36(a0)
loc_01422E:
        bra.s   loc_014238
loc_014230:
        subq.w  #1, objoff_38(a0)
        bpl     loc_0142CA
loc_014238:
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$01F, d0
        move.w  d0, objoff_38(a0)
        bsr     SingleObjectLoad        ; loc_00E772
        bne.s   loc_0142AE
        move.w  x_pos(a0), x_pos(a1)
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$F, d0
        subq.w  #8,d0
        add.w   d0, x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        move.l  Objoff_3C(a0), A2
        move.b  $00(A2, d0), subtype(a1)
        btst    #$7, objoff_36(a0)
        beq.s   loc_0142AE
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$003, d0
        bne.s   loc_01429A
        bset    #6, objoff_36(a0)
        bne.s   loc_0142AE
        move.b  #$2, subtype(a1)
loc_01429A:
        tst.b   Objoff_34(a0)
        bne.s   loc_0142AE
        bset    #6, objoff_36(a0)
        bne.s   loc_0142AE
        move.b  #$2, subtype(a1)
loc_0142AE:
        subq.b  #1, Objoff_34(a0)
        bpl.s   loc_0142CA
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$07F, d0
        addi.w  #$080, d0
        add.w   d0, objoff_38(a0)
        clr.w   objoff_36(a0)
loc_0142CA:
        lea     (loc_014348), A1
        jsr     AnimateSprite           ; (loc_00D412)
loc_0142D6:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        move.w  (Water_Level_1).w, d0
        cmp.w   y_pos(a0), D0
        bcs     DisplaySprite           ; loc_00D3C2
        rts   
loc_0142F8:
        dc.w    $0001, $0000, $0000, $0100, $0000, $0001, $0001, $0000
        dc.w    $0100              
loc_01430A:
        tst.b   ($FFFFB02A).w
        bmi.s   loc_014344
        lea     (MainCharacter).w, A1
        move.w  x_pos(A1), D0
        move.w  x_pos(a0), d1
        subi.w  #$010, d1
        cmp.w   d0, d1
        bcc.s   loc_014344
        addi.w  #$20, d1
        cmp.w   d0, d1
        bcs.s   loc_014344
        move.w  y_pos(A1), D0
        move.w  y_pos(a0), d1
        cmp.w   d0, d1
        bcc.s   loc_014344
        addi.w  #$010, d1
        cmp.w   d0, d1
        bcs.s   loc_014344
        moveq   #1,d0
        rts
loc_014344:
        moveq	#0,d0
        rts        
loc_014348:
        dc.w    loc_014356-loc_014348
        dc.w    loc_01435B-loc_014348
        dc.w    loc_014361-loc_014348
        dc.w    loc_014368-loc_014348
        dc.w    loc_014368-loc_014348
        dc.w    loc_01436A-loc_014348
        dc.w    loc_01436F-loc_014348
loc_014356:
        dc.b    $0E, $00, $01, $02, $FC
loc_01435B:
        dc.b    $0E, $01, $02, $03, $04, $FC
loc_014361:
        dc.b    $0E, $02, $03, $04, $05, $06, $FC
loc_014368:
        dc.b    $04, $FC
loc_01436A:
        dc.b    $04, $06, $07, $08, $FC
loc_01436F:
        dc.b    $0F, $13, $14, $15, $FF
Obj0A_Bubbles_Mappings: ; loc_014374:
        dc.w    loc_0143A2-Obj0A_Bubbles_Mappings
        dc.w    loc_0143AC-Obj0A_Bubbles_Mappings
        dc.w    loc_0143B6-Obj0A_Bubbles_Mappings
        dc.w    loc_0143C0-Obj0A_Bubbles_Mappings
        dc.w    loc_0143CA-Obj0A_Bubbles_Mappings
        dc.w    loc_0143D4-Obj0A_Bubbles_Mappings
        dc.w    loc_0143DE-Obj0A_Bubbles_Mappings
        dc.w    loc_0143E8-Obj0A_Bubbles_Mappings
        dc.w    loc_01440A-Obj0A_Bubbles_Mappings
        dc.w    loc_01442C-Obj0A_Bubbles_Mappings
        dc.w    loc_014436-Obj0A_Bubbles_Mappings
        dc.w    loc_014440-Obj0A_Bubbles_Mappings
        dc.w    loc_01444A-Obj0A_Bubbles_Mappings
        dc.w    loc_014454-Obj0A_Bubbles_Mappings
        dc.w    loc_01445E-Obj0A_Bubbles_Mappings
        dc.w    loc_014468-Obj0A_Bubbles_Mappings
        dc.w    loc_014472-Obj0A_Bubbles_Mappings
        dc.w    loc_01447C-Obj0A_Bubbles_Mappings
        dc.w    loc_014486-Obj0A_Bubbles_Mappings
        dc.w    loc_014490-Obj0A_Bubbles_Mappings
        dc.w    loc_01449A-Obj0A_Bubbles_Mappings
        dc.w    loc_0144A4-Obj0A_Bubbles_Mappings
        dc.w    loc_0144AE-Obj0A_Bubbles_Mappings
loc_0143A2:
        dc.w    $0001
        dc.l    $FC000000, $0000FFFC
loc_0143AC:
        dc.w    $0001
        dc.l    $FC000001, $0000FFFC
loc_0143B6:
        dc.w    $0001
        dc.l    $FC000002, $0001FFFC
loc_0143C0:
        dc.w    $0001
        dc.l    $F8050003, $0001FFF8
loc_0143CA:
        dc.w    $0001
        dc.l    $F8050007, $0003FFF8
loc_0143D4:
        dc.w    $0001
        dc.l    $F40A000B, $0005FFF4
loc_0143DE:
        dc.w    $0001
        dc.l    $F00F0014, $000AFFF0
loc_0143E8:
        dc.w    $0004
        dc.l    $F0050024, $0012FFF0, $F0050824, $08120000
        dc.l    $00051024, $1012FFF0, $00051824, $18120000
loc_01440A:
        dc.w    $0004
        dc.l    $F0050028, $0014FFF0, $F0050828, $08140000
        dc.l    $00051028, $1014FFF0, $00051828, $18140000
loc_01442C:
        dc.w    $0001
        dc.l    $F406002C, $0016FFF8
loc_014436:
        dc.w    $0001
        dc.l    $F4060032, $0019FFF8
loc_014440:
        dc.w    $0001
        dc.l    $F4060038, $001CFFF8
loc_01444A:
        dc.w    $0001
        dc.l    $F406003E, $001FFFF8
loc_014454:
        dc.w    $0001
        dc.l    $F4062044, $2022FFF8
loc_01445E:
        dc.w    $0001
        dc.l    $F406204A, $2025FFF8
loc_014468:
        dc.w    $0001
        dc.l    $F4062050, $2028FFF8
loc_014472:
        dc.w    $0001
        dc.l    $F4062056, $202BFFF8
loc_01447C:
        dc.w    $0001
        dc.l    $F406205C, $202EFFF8
loc_014486:
        dc.w    $0001
        dc.l    $F4062062, $2031FFF8
loc_014490:
        dc.w    $0001
        dc.l    $F8050068, $0034FFF8
loc_01449A:
        dc.w    $0001
        dc.l    $F805006C, $0036FFF8
loc_0144A4:
        dc.w    $0001
        dc.l    $F8050070, $0038FFF8
loc_0144AE:
        dc.w    $0000        
;=============================================================================== 
; Object 0x03 - Layer Switch (Low / Hi Plane Switch)  

;===============================================================================         
Obj03_Layer_Switch: ; loc_0144B0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0144CC(pc,d0), d1
        jsr     loc_0144CC(pc,d1)
        tst.w   ($FFFFFFFA).w
        beq     loc_00D30C
        jmp     MarkObjGone             ; loc_00D2A0
loc_0144CC:
        dc.w    loc_0144D2-loc_0144CC
        dc.w    loc_014538-loc_0144CC
        dc.w    loc_01465C-loc_0144CC
loc_0144D2:        
        addq.b  #2,routine(a0)
        move.l  #Layer_Switch_Mappings,mappings(a0) ; loc_0147D0
        move.w  #$26BC,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #5, $0018(a0)
        move.b  subtype(A0), D0
        btst    #$2, d0
        beq.s   loc_014528         
        addq.b  #2,routine(a0)
        andi.w  #$007, d0
        move.b  d0, $001A(a0)
        andi.w  #$003, d0
        add.w   d0, d0
        move.w  loc_014520(pc,d0), $0032(a0)
        bra     loc_01465C
loc_014520:
        dc.w    $0020, $0040, $0080, $0100        
loc_014528:
        andi.w  #$003, d0
        move.b  d0, $001A(a0)
        add.w   d0, d0
        move.w  loc_014520(pc,d0), $0032(a0)
loc_014538:
        tst.w   (Debug_placement_mode).w
        bne     loc_01465A
        move.b  #0, Objoff_34(a0)
        move.w  Objoff_30(A0), D5
        move.w  x_pos(a0), D0
        move.w  d0, d1
        subq.w  #8,d0
        addq.w  #8, d1
        move.w  y_pos(a0), D2
        move.w  D2, d3
        move.w  $0032(A0), D4
        sub.w   d4, D2
        add.w   d4, d3
        lea     (loc_014780), A2
        moveq   #$7, D6
loc_01456A:
        move.l  (A2)+, D4
        beq     loc_01464A
        move.l  d4, A1
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_01459A
        cmp.w   d1, D4
        bcc     loc_01459A
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_01459A
        cmp.w   d3, D4
        bcc     loc_01459A
        ori.w   #$8000,d5
        bra     loc_01464A
loc_01459A:
        tst.w   D5
        bpl     loc_01464A
        swap.w  D0
        move.b  subtype(A0), D0
        bpl.s   loc_0145B2
        btst    #1, status(a1)
        bne     loc_014644
loc_0145B2:
        move.w  x_pos(A1), D4
        cmp.w   x_pos(a0), D4
        bcs.s   loc_0145F6
        btst    #0,render_flags(a0)
        bne.s   loc_0145E2
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
        btst    #3, d0
        beq.s   loc_0145E2
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_0145E2:
        bclr    #$7, art_tile(a1)
        btst    #5, d0
        beq.s   loc_01462E
        bset    #$7, art_tile(a1)
        bra.s   loc_01462E
loc_0145F6:
        btst    #0,render_flags(a0)
        bne.s   loc_01461C
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
        btst    #4, d0
        beq.s   loc_01461C
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_01461C:
        bclr    #$7, art_tile(a1)
        btst    #6, d0
        beq.s   loc_01462E
        bset    #$7, art_tile(a1)
loc_01462E:
        move.b  #1, Objoff_34(a0)
        tst.w   ($FFFFFFFA).w
        beq.s   loc_014644
        move.w  #$0A1, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_014644:
        swap.w  D0
        andi.w  #$7FFF,d5
loc_01464A:
        add.l   d5,d5
        dbra    d6, loc_01456A
        swap.w  D5
        move.b  d5, Objoff_30(a0)
        bsr     loc_0147A0
loc_01465A:        
        rts
loc_01465C:
        tst.w   (Debug_placement_mode).w
        bne     loc_01477E
        move.b  #0, Objoff_34(a0)
        move.w  Objoff_30(A0), D5
        move.w  x_pos(a0), D0
        move.w  d0, d1
        move.w  $0032(A0), D4
        sub.w   d4, d0
        add.w   d4, d1
        move.w  y_pos(a0), D2
        move.w  D2, d3
        subq.w  #8, D2
        addq.w  #8, d3
        lea     (loc_014780), A2
        moveq   #$7, D6
loc_01468E:
        move.l  (A2)+, D4
        beq     loc_01476E
        move.l  d4, A1
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_0146BE
        cmp.w   d1, D4
        bcc     loc_0146BE
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_0146BE
        cmp.w   d3, D4
        bcc     loc_0146BE
        ori.w   #$8000,d5
        bra     loc_01476E
loc_0146BE:
        tst.w   D5
        bpl     loc_01476E
        swap.w  D0
        move.b  subtype(A0), D0
        bpl.s   loc_0146D6
        btst    #1, status(a1)
        bne     loc_014768
loc_0146D6:
        move.w  y_pos(A1), D4
        cmp.w   y_pos(a0), D4
        bcs.s   loc_01471A
        btst    #0,render_flags(a0)
        bne.s   loc_014706
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
        btst    #3, d0
        beq.s   loc_014706
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_014706:
        bclr    #$7, art_tile(a1)
        btst    #5, d0
        beq.s   loc_014752
        bset    #$7, art_tile(a1)
        bra.s   loc_014752
loc_01471A:
        btst    #0,render_flags(a0)
        bne.s   loc_014740
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
        btst    #4, d0
        beq.s   loc_014740
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_014740:
        bclr    #$7, art_tile(a1)
        btst    #6, d0
        beq.s   loc_014752
        bset    #$7, art_tile(a1)
loc_014752:
        move.b  #1, Objoff_34(a0)
        tst.w   ($FFFFFFFA).w
        beq.s   loc_014768
        move.w  #$0A1, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_014768:
        swap.w  D0
        andi.w  #$7FFF,d5
loc_01476E:        
        add.l   d5,d5
        dbra    d6, loc_01468E
        swap.w  D5
        move.b  d5, Objoff_30(a0)
        bsr     loc_0147A0
loc_01477E:        
        rts  
loc_014780:    
        dc.l    MainCharacter, Sidekick, $00000000, $00000000
        dc.l    $00000000, $00000000, $00000000, $00000000  
loc_0147A0:
        tst.b   Objoff_34(a0)
        beq.s   loc_0147CE
        tst.w   ($FFFFB002).w
        bpl.s   loc_0147B4
        bset    #$7, ($FFFFB182).w
        bra.s   loc_0147BA
loc_0147B4:
        bclr    #$7, ($FFFFB182).w
loc_0147BA:
        tst.w   ($FFFFB042).w
        bpl.s   loc_0147C8
        bset    #$7, ($FFFFB1C2).w
        bra.s   loc_0147CE
loc_0147C8:
        bclr    #$7, ($FFFFB1C2).w
loc_0147CE:
        rts   
Layer_Switch_Mappings:
loc_0147D0:
        dc.w    loc_0147E0-loc_0147D0
        dc.w    loc_014802-loc_0147D0
        dc.w    loc_014824-loc_0147D0
        dc.w    loc_014824-loc_0147D0
        dc.w    loc_014846-loc_0147D0
        dc.w    loc_014868-loc_0147D0
        dc.w    loc_01488A-loc_0147D0
        dc.w    loc_01488A-loc_0147D0
loc_0147E0:
        dc.w    $0004
        dc.l    $E0050000, $0000FFF8, $F0050000, $0000FFF8
        dc.l    $00050000, $0000FFF8, $10050000, $0000FFF8
loc_014802:
        dc.w    $0004
        dc.l    $C0050000, $0000FFF8, $E0050000, $0000FFF8
        dc.l    $00050000, $0000FFF8, $30050000, $0000FFF8
loc_014824:
        dc.w    $0004
        dc.l    $80050000, $0000FFF8, $E0050000, $0000FFF8
        dc.l    $00050000, $0000FFF8, $70050000, $0000FFF8
loc_014846:
        dc.w    $0004
        dc.l    $F8050000, $0000FFE0, $F8050000, $0000FFF0
        dc.l    $F8050000, $00000000, $F8050000, $00000010
loc_014868:
        dc.w    $0004
        dc.l    $F8050000, $0000FFC0, $F8050000, $0000FFE0
        dc.l    $F8050000, $00000000, $F8050000, $00000030
loc_01488A:
        dc.w    $0004
        dc.l    $F8050000, $0000FF80, $F8050000, $0000FFE0
        dc.l    $F8050000, $00000000, $F8050000, $00000070                            
;=============================================================================== 
; Object 0x03 - Layer Switch (Low / Hi Plane Switch)  
; 
;===============================================================================  

;=============================================================================== 
; Object 0x0B - Chemical Plant - Open / Close Platforms
                 
;===============================================================================   
Obj0B_Open_Close_Platform: ; loc_0148AC:              
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0148BA(pc,d0), d1
        jmp     loc_0148BA(pc,d1)
loc_0148BA:
        dc.w    loc_0148C0-loc_0148BA
        dc.w    loc_014914-loc_0148BA
        dc.w    loc_014922-loc_0148BA
loc_0148C0:
        addq.b  #2,routine(a0)
        move.l  #Open_Close_Platform_Mappings,mappings(a0) ; loc_014996
        move.w  #$E3B0,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$0F0, d0
        addi.w  #$010, d0
        move.w  d0, d1
        subq.w  #1,d0
        move.w  d0, Objoff_30(a0)
        move.w  d0, $0032(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        addq.w  #1,d0
        lsl.w   #4, d0
        move.b  d0, objoff_36(a0)
loc_014914:
        move.b  ($FFFFFE0F).w, d0
        add.b   objoff_36(a0), D0
        bne.s   loc_01494C
        addq.b  #2,routine(a0)
loc_014922:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_014940
        move.w  #$07F, Objoff_30(a0)
        tst.b   $001C(a0)
        beq.s   loc_01493A
        move.w  $0032(A0), Objoff_30(a0)
loc_01493A:
        bchg    #0, $001C(a0)
loc_014940:
        lea     (loc_014982), A1
        jsr     AnimateSprite           ; (loc_00D412)
loc_01494C:
        tst.b   $001A(a0)
        bne.s   loc_014966
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #$11, d3
        move.w  x_pos(a0), D4
        bsr     loc_00F984
        bra     MarkObjGone             ; loc_00D2A0
loc_014966:
        btst    #3, status(a0)
        beq.s   loc_01497E
        lea     (MainCharacter).w, A1
        bclr    #3, status(a1)
        bclr    #3, status(a0)
loc_01497E:
        bra     MarkObjGone             ; loc_00D2A0
loc_014982:
        dc.w    loc_014986-loc_014982
        dc.w    loc_01498E-loc_014982
loc_014986:
        dc.b    $07
        dc.b    $00, $01, $02, $03, $04, $FE, $01
loc_01498E:
        dc.b    $07
        dc.b    $04, $03, $02, $01, $00, $FE, $01
Open_Close_Platform_Mappings:        
loc_014996:
        dc.w    loc_0149A0-loc_014996
        dc.w    loc_0149B2-loc_014996
        dc.w    loc_0149C4-loc_014996
        dc.w    loc_0149D6-loc_014996
        dc.w    loc_0149E8-loc_014996
loc_0149A0:
        dc.w    $0002
        dc.l    $F00C0000, $0000FFF0, $F80E0024, $0012FFF0
loc_0149B2:
        dc.w    $0002
        dc.l    $E80F0004, $0002FFF0, $F80E0024, $0012FFF0
loc_0149C4:
        dc.w    $0002
        dc.l    $F40F0014, $000AFFF0, $F80E0024, $0012FFF0
loc_0149D6:
        dc.w    $0002
        dc.l    $000F1004, $1002FFF0, $F80E0024, $0012FFF0
loc_0149E8:
        dc.w    $0002
        dc.l    $100C1000, $1000FFF0, $F80E0024, $0012FFF0
;=============================================================================== 
; Object 0x0B - Chemical Plant - Open / Close Platforms
                
;===============================================================================  
        nop                     ; Filler 
;=============================================================================== 
; Object 0x0C - 
                 
;===============================================================================  
Obj0C: ; loc_0149FC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_014A0A(pc,d0), d1
        jmp     loc_014A0A(pc,d1)
loc_014A0A:
        dc.w    loc_014A0E-loc_014A0A
        dc.w    loc_014A6E-loc_014A0A
loc_014A0E:
        addq.b  #2,routine(a0)
        move.l  #Obj0C_Mappings,mappings(a0) ; loc_014AE6
        move.w  #$E418,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.w  y_pos(a0), D0
        subi.w  #$010, d0
        move.w  d0, objoff_3A(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$0F0, d0
        addi.w  #$010, d0
        move.w  d0, d1
        subq.w  #1,d0
        move.w  d0, Objoff_30(a0)
        move.w  d0, $0032(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        move.b  d0, Objoff_3E(a0)
        move.b  d0, Objoff_3F(a0)
loc_014A6E:
        move.b  Objoff_3C(a0), D0
        beq.s   loc_014AAC
        cmpi.b  #$80, d0
        bne.s   loc_014ABC
        move.b  objoff_3D(A0), d1
        bne.s   loc_014A8E
        subq.b  #1, Objoff_3E(a0)
        bpl.s   loc_014A8E
        move.b  Objoff_3F(A0), Objoff_3E(a0)
        bra.s   loc_014ABC
loc_014A8E:
        addq.b  #1, objoff_3D(a0)
        move.b  d1, d0
        bsr     loc_014AF4
        addi.w  #8, d0
        asr.w   #6, d0
        subi.w  #$010, d0
        add.w   objoff_3A(A0), D0
        move.w  d0, y_pos(a0)
        bra.s   loc_014AD2
loc_014AAC:
        move.w  ($FFFFFE0E).w, d1
        andi.w  #$3FF, d1
        bne.s   loc_014AC0
        move.b  #1, objoff_3D(a0)
loc_014ABC:
        addq.b  #1, Objoff_3C(a0)
loc_014AC0:
        bsr     loc_014AF4
        addi.w  #8,d1
        asr.w   #4, d1
        add.w   objoff_3A(A0), d1
        move.w  d1, y_pos(a0)
loc_014AD2:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #$9, d3
        move.w  x_pos(a0), D4
        bsr     loc_00F984
        bra     MarkObjGone             ; loc_00D2A0
Obj0C_Mappings:        
loc_014AE6:
        dc.w    loc_014AE8-loc_014AE6
loc_014AE8:
        dc.w    $0001
        dc.l    $F80D0000, $0000FFF0
;=============================================================================== 
; Object 0x0C - 
                
;===============================================================================  
        nop                     ; Filler 
loc_014AF4:
        jmp     CalcSine        ; loc_00320A
        dc.w    $0000           ; Filler 
;=============================================================================== 
; Object 0x12 - Hidden Palace - Emerald 
                 
;===============================================================================          
Obj12_Emerald: ; loc_014AFC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_014B0A(pc,d0), d1
        jmp     loc_014B0A(pc,d1)
loc_014B0A:        
        dc.w    loc_014B0E-loc_014B0A
        dc.w    loc_014B36-loc_014B0A
loc_014B0E:
        addq.b  #2,routine(a0)
        move.l  #Emerald_Mappings,mappings(a0) ; loc_014B62
        move.w  #$6392,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #4, $0018(a0)
loc_014B36:
        move.w  #$20, d1
        move.w  #$010, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        bsr     SolidObject             ; loc_00F4A0
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2 
Emerald_Mappings: ; loc_014B62:
        dc.w    loc_014B64-Emerald_Mappings
loc_014B64:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFE0, $F00F0010, $00080000
;=============================================================================== 
; Object 0x12 - Hidden Palace - Emerald 
                
;===============================================================================  
        nop                     ; Filler
;=============================================================================== 
; Object 0x13 - Hidden Palace - Waterfalls 
                 
;===============================================================================          
Obj13_Hpz_Waterfalls: ; loc_014B78:     
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_014B86(pc,d0), d1
        jmp     loc_014B86(pc,d1)
loc_014B86:
        dc.w    loc_014B8C-loc_014B86
        dc.w    loc_014C52-loc_014B86
        dc.w    loc_014CDC-loc_014B86
loc_014B8C:
        addq.b  #2,routine(a0)
        move.l  #Hpz_Waterfalls_Mappings,mappings(a0) ; loc_014CF4
        move.w  #$E315,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  #$12, $001A(a0)
        bsr.s   loc_014BF4
        move.b  #$A0, y_radius(a1)
        bset    #4, render_flags(a1)
        move.l  A1, objoff_38(a0)
        move.w  y_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), objoff_36(a0)
        cmpi.b  #$10, subtype(a0)
        bcs.s   loc_014C38
        bsr.s   loc_014BF4
        move.l  A1, Objoff_3C(a0)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$098, y_pos(a1)
        bra.s   loc_014C38
loc_014BF4:
        jsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_014C36
        move.b  #$13, 0(a1)
        addq.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  #Hpz_Waterfalls_Mappings, mappings(a1) ; loc_014CF4
        move.w  #$E315, art_tile(a1)
        bsr     ModifyA1SpriteAttr_2P   ; loc_00DC4C
        move.b  #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #1, $0018(a1)
loc_014C36:        
        rts
loc_014C38:
        moveq   #0,d1
        move.b  subtype(A0), d1
        move.w  Objoff_34(A0), D0
        subi.w  #$078, d0
        lsl.w   #4, d1
        add.w   d1, d0
        move.w  d0, y_pos(a0)
        move.w  d0, Objoff_34(a0)
loc_014C52:
        move.l  objoff_38(A0), A1
        move.b  #$12, $001A(a0)
        move.w  Objoff_34(A0), D0 
        move.w  (Water_Level_1).w, d1
        cmp.w   d0, d1
        bcc.s   loc_014C6A
        move.w  d1, d0
loc_014C6A:
        move.w  d0, y_pos(a0)
        sub.w   objoff_36(a0), D0
        addi.w  #$080, d0
        bmi.s   loc_014CBC
        lsr.w   #4, d0
        move.w  d0, d1
        cmpi.w  #$F, d0
        bcs.s   loc_014C84
        moveq   #$F, d0
loc_014C84:
        move.b  d0, $001A(a1)
        cmpi.b  #$10, subtype(a0)
        bcs.s   loc_014CA4
        move.l  Objoff_3C(a0), A1
        subi.w  #$F, d1
        bcc.s   loc_014C9C
        moveq   #0,d1
loc_014C9C:
        addi.w  #$013, d1
        move.b  d1, $001A(a1) 
loc_014CA4:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2
loc_014CBC:        
        moveq   #$13, d0
        move.b  d0, $001A(a0)
        move.b  d0, $001A(a1)
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        rts
loc_014CDC:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     DeleteObject            ; loc_00D3B4
        bra     DisplaySprite           ; loc_00D3C2 
Hpz_Waterfalls_Mappings:          
loc_014CF4:
        dc.w    loc_014D2E-loc_014CF4
        dc.w    loc_014D38-loc_014CF4
        dc.w    loc_014D4A-loc_014CF4
        dc.w    loc_014D5C-loc_014CF4
        dc.w    loc_014D76-loc_014CF4
        dc.w    loc_014D90-loc_014CF4
        dc.w    loc_014DB2-loc_014CF4
        dc.w    loc_014DD4-loc_014CF4
        dc.w    loc_014DFE-loc_014CF4
        dc.w    loc_014E28-loc_014CF4
        dc.w    loc_014E5A-loc_014CF4
        dc.w    loc_014E8C-loc_014CF4
        dc.w    loc_014EC6-loc_014CF4
        dc.w    loc_014F00-loc_014CF4
        dc.w    loc_014F42-loc_014CF4
        dc.w    loc_014F84-loc_014CF4
        dc.w    loc_014FCE-loc_014CF4
        dc.w    loc_014FCE-loc_014CF4
        dc.w    loc_014FCE-loc_014CF4
        dc.w    loc_014D2C-loc_014CF4
        dc.w    loc_014FE0-loc_014CF4
        dc.w    loc_014FEA-loc_014CF4
        dc.w    loc_014FF4-loc_014CF4
        dc.w    loc_015006-loc_014CF4
        dc.w    loc_015018-loc_014CF4
        dc.w    loc_015032-loc_014CF4
        dc.w    loc_01504C-loc_014CF4
        dc.w    loc_01506E-loc_014CF4
loc_014D2C:
        dc.w    $0000        
loc_014D2E:
        dc.w    $0001
        dc.l    $800C0010, $0008FFF0
loc_014D38:
        dc.w    $0002
        dc.l    $800C0010, $0008FFF0, $880D002D, $0016FFF0
loc_014D4A:
        dc.w    $0002
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
loc_014D5C:
        dc.w    $0003
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80D002D, $0016FFF0
loc_014D76:
        dc.w    $0003
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0
loc_014D90:
        dc.w    $0004
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80D002D, $0016FFF0
loc_014DB2:
        dc.w    $0004
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
loc_014DD4:
        dc.w    $0005
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80D002D, $0016FFF0
loc_014DFE:
        dc.w    $0005
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0
loc_014E28:
        dc.w    $0006
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080D002D, $0016FFF0
loc_014E5A:
        dc.w    $0006
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
loc_014E8C:
        dc.w    $0007
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
        dc.l    $280D002D, $0016FFF0
loc_014EC6:
        dc.w    $0007
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
        dc.l    $280F0000, $0000FFF0
loc_014F00:
        dc.w    $0008
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
        dc.l    $280F0000, $0000FFF0, $480D002D, $0016FFF0
loc_014F42:
        dc.w    $0008
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
        dc.l    $280F0000, $0000FFF0, $480F0000, $0000FFF0
loc_014F84:
        dc.w    $0009
        dc.l    $800C0010, $0008FFF0, $880F0000, $0000FFF0
        dc.l    $A80F0000, $0000FFF0, $C80F0000, $0000FFF0
        dc.l    $E80F0000, $0000FFF0, $080F0000, $0000FFF0
        dc.l    $280F0000, $0000FFF0, $480F0000, $0000FFF0
        dc.l    $680D002D, $0016FFF0
loc_014FCE:
        dc.w    $0002
        dc.l    $F00A0018, $000CFFE8, $F00A0818, $080C0000
loc_014FE0:
        dc.w    $0001
        dc.l    $E00D002D, $0016FFF0
loc_014FEA:
        dc.w    $0001
        dc.l    $E00F0000, $0000FFF0
loc_014FF4:
        dc.w    $0002
        dc.l    $E00F0000, $0000FFF0, $000D002D, $0016FFF0
loc_015006:
        dc.w    $0002
        dc.l    $E00F0000, $0000FFF0, $000F0000, $0000FFF0
loc_015018:
        dc.w    $0003
        dc.l    $E00F0000, $0000FFF0, $000F0000, $0000FFF0
        dc.l    $200D002D, $0016FFF0
loc_015032:
        dc.w    $0003
        dc.l    $E00F0000, $0000FFF0, $000F0000, $0000FFF0
        dc.l    $200F0000, $0000FFF0
loc_01504C:
        dc.w    $0004
        dc.l    $E00F0000, $0000FFF0, $000F0000, $0000FFF0
        dc.l    $200F0000, $0000FFF0, $400D002D, $0016FFF0
loc_01506E:
        dc.w    $0004
        dc.l    $E00F0000, $0000FFF0, $000F0000, $0000FFF0
        dc.l    $200F0000, $0000FFF0, $400F0000, $0000FFF0          
                
;=============================================================================== 
; Object 0x13 - Hidden Palace - Waterfalls 
                
;===============================================================================  

;=============================================================================== 
; Object 0x04 - 
                 
;===============================================================================  
Obj04: ; loc_015090:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01509E(pc,d0), d1
        jmp     loc_01509E(pc,d1)
loc_01509E:
        dc.w    loc_0150A4-loc_01509E
        dc.w    loc_0150E4-loc_01509E
        dc.w    loc_015176-loc_01509E
loc_0150A4:
        addq.b  #2,routine(a0)
        move.l  #Obj04_Mappings,mappings(a0) ; loc_0151C2
        move.w  #$8400,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$80,width_pixels(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        cmpi.b  #$F, (Current_ZoneAndAct).w
        bne.s   loc_0150E4
        addq.b  #2,routine(a0)
        move.l  #Obj04_Mappings_1,mappings(a0) loc_0152B2
        bra     loc_015176
loc_0150E4:
        move.w  (Water_Level_1).w, d1
        move.w  d1, y_pos(a0)
        tst.b   $0032(a0)
        bne.s   loc_015106
        btst    #$7, (Ctrl_1_Press).w
        beq.s   loc_015116
        addq.b  #3, $001A(a0)
        move.b  #1, $0032(a0)
        bra.s   loc_015116
loc_015106:
        tst.w   (Game_paused).w
        bne.s   loc_015116
        move.b  #0, $0032(a0)
        subq.b  #3, $001A(a0)
loc_015116:
        lea     (loc_015136), A1
        moveq   #0,d1
        move.b  $001B(A0), d1
        move.b  $00(A1, d1), $001A(a0)
        addq.b  #1, $001B(a0)
        andi.b  #$3F, $001B(a0)
        bra     J_DisplaySprite_00      ; loc_015720
loc_015136:
        dc.b    $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01
        dc.b    $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02
        dc.b    $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01, $02, $01
        dc.b    $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00, $01, $00
loc_015176:
        move.w  (Water_Level_1).w, d1
        move.w  d1, y_pos(a0)
        tst.b   $0032(a0)
        bne.s   loc_015198
        btst    #$7, (Ctrl_1_Press).w
        beq.s   loc_0151A8
        addq.b  #$2, $001A(a0)
        move.b  #1, $0032(a0)
        bra.s   loc_0151BE
loc_015198:
        tst.w   (Game_paused).w
        bne.s   loc_0151BE
        move.b  #0, $0032(a0)
        subq.b  #$2, $001A(a0)
loc_0151A8:
        subq.b  #1, $001E(a0)
        bpl.s   loc_0151BE
        move.b  #5, $001E(a0)
        addq.b  #1, $001A(a0)
        andi.b  #1, $001A(a0)
loc_0151BE:
        bra     J_DisplaySprite_00      ; loc_015720
Obj04_Mappings:
loc_0151C2:
        dc.w    loc_0151CE-loc_0151C2
        dc.w    loc_0151E8-loc_0151C2
        dc.w    loc_015202-loc_0151C2
        dc.w    loc_01521C-loc_0151C2
        dc.w    loc_01524E-loc_0151C2
        dc.w    loc_015280-loc_0151C2           
loc_0151CE:
        dc.w    $0003
        dc.l    $F80D0000, $0000FFA0, $F80D0000, $0000FFE0
        dc.l    $F80D0000, $00000020
loc_0151E8:
        dc.w    $0003
        dc.l    $F80D0008, $0004FFA0, $F80D0008, $0004FFE0
        dc.l    $F80D0008, $00040020
loc_015202:
        dc.w    $0003
        dc.l    $F80D0010, $0008FFA0, $F80D0010, $0008FFE0
        dc.l    $F80D0010, $00080020
loc_01521C:
        dc.w    $0006
        dc.l    $F80D0000, $0000FFA0, $F80D0008, $0004FFC0
        dc.l    $F80D0000, $0000FFE0, $F80D0008, $00040000
        dc.l    $F80D0000, $00000020, $F80D0008, $00040040
loc_01524E:
        dc.w    $0006
        dc.l    $F80D0008, $0004FFA0, $F80D0010, $0008FFC0
        dc.l    $F80D0008, $0004FFE0, $F80D0010, $00080000
        dc.l    $F80D0008, $00040020, $F80D0010, $00080040
loc_015280:
        dc.w    $0006
        dc.l    $F80D0010, $0008FFA0, $F80D0008, $0004FFC0
        dc.l    $F80D0010, $0008FFE0, $F80D0008, $00040000
        dc.l    $F80D0010, $00080020, $F80D0008, $00040040
Obj04_Mappings_1:
loc_0152B2:
        dc.w    loc_0152BA-loc_0152B2
        dc.w    loc_0152D4-loc_0152B2
        dc.w    loc_0152EE-loc_0152B2
        dc.w    loc_015320-loc_0152B2
loc_0152BA:
        dc.w    $0003
        dc.l    $FC0D0000, $0000FFA0, $FC0D0000, $0000FFE0
        dc.l    $FC0D0000, $00000020
loc_0152D4:
        dc.w    $0003
        dc.l    $FC0D0008, $0004FFA0, $FC0D0008, $0004FFE0
        dc.l    $FC0D0008, $00040020
loc_0152EE:
        dc.w    $0006
        dc.l    $FC0D0000, $0000FFA0, $FC0D0000, $0000FFC0
        dc.l    $FC0D0000, $0000FFE0, $FC0D0000, $00000000
        dc.l    $FC0D0000, $00000020, $FC0D0000, $00000040
loc_015320:
        dc.w    $0006
        dc.l    $FC0D0008, $0004FFA0, $FC0D0008, $0004FFC0
        dc.l    $FC0D0008, $0004FFE0, $FC0D0008, $00040000
        dc.l    $FC0D0008, $00040020, $FC0D0008, $00040040        
;=============================================================================== 
; Object 0x04 - 
                
;===============================================================================  

;=============================================================================== 
; Object 0x49 - Green Hill - Waterfalls 
        
;===============================================================================  
Obj49_Waterfall: ; loc_015352:         
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_015360(pc,d0), d1
        jmp     loc_015360(pc,d1)
loc_015360:
        dc.w    loc_015364-loc_015360
        dc.w    loc_01539E-loc_015360
               
loc_015364:
        addq.b  #2,routine(a0)
        move.l  #Waterfall_Mappings,mappings(a0) ; loc_015404
        move.w  #$23AE,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        move.b  #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.b  #0, $0018(a0)
        move.b  #$80, y_radius(a0)
        bset    #4,render_flags(a0)
loc_01539E:
        tst.w   (Two_player_mode).w
        bne.s   loc_0153B8
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_09       ; loc_015726
loc_0153B8:
        move.w  x_pos(a0), d1
        move.w  d1, D2
        subi.w  #$40, d1
        addi.w  #$40, D2
        move.b  subtype(A0), D3
        move.b  #0, $001A(a0)
        move.w  (MainCharacter+x_pos).w, d0
        cmp.w   d1, d0
        bcs.s   loc_0153EA
        cmp.w   d2, d0
        bcc.s   loc_0153EA
        move.b  #1, $001A(a0)
        add.b   d3, $001A(a0)
        bra     J_DisplaySprite_00      ; loc_015720
loc_0153EA:
        move.w  ($FFFFB048).w, d0
        cmp.w   d1, d0
        bcs.s   loc_0153FC
        cmp.w   d2, d0
        bcc.s   loc_0153FC
        move.b  #1, $001A(a0)
loc_0153FC:
        add.b   d3, $001A(a0)
        bra     J_DisplaySprite_00      ; loc_015720
Waterfall_Mappings:        
loc_015404:
        dc.w    loc_015414-loc_015404
        dc.w    loc_015426-loc_015404
        dc.w    loc_0154B8-loc_015404
        dc.w    loc_0154BA-loc_015404
        dc.w    loc_0154B8-loc_015404
        dc.w    loc_0154DC-loc_015404
        dc.w    loc_015414-loc_015404
        dc.w    loc_01552E-loc_015404
loc_015414:
        dc.w    $0002
        dc.l    $800D0000, $0000FFE0, $800D0000, $00000000
loc_015426:
        dc.w    $0012
        dc.l    $800D0000, $0000FFE0, $800D0000, $00000000
        dc.l    $800F0008, $0004FFE0, $800F0008, $00040000
        dc.l    $A00F0008, $0004FFE0, $A00F0008, $00040000
        dc.l    $C00F0008, $0004FFE0, $C00F0008, $00040000
        dc.l    $E00F0008, $0004FFE0, $E00F0008, $00040000
        dc.l    $000F0008, $0004FFE0, $000F0008, $00040000
        dc.l    $200F0008, $0004FFE0, $200F0008, $00040000
        dc.l    $400F0008, $0004FFE0, $400F0008, $00040000
        dc.l    $600F0008, $0004FFE0, $600F0008, $00040000
loc_0154B8:
        dc.w    $0000
loc_0154BA:
        dc.w    $0004
        dc.l    $E00F0008, $0004FFE0, $E00F0008, $00040000
        dc.l    $000F0008, $0004FFE0, $000F0008, $00040000
loc_0154DC:
        dc.w    $000A
        dc.l    $C00F0008, $0004FFE0, $C00F0008, $00040000
        dc.l    $E00F0008, $0004FFE0, $E00F0008, $00040000
        dc.l    $000F0008, $0004FFE0, $000F0008, $00040000
        dc.l    $200F0008, $0004FFE0, $200F0008, $00040000
        dc.l    $400F0008, $0004FFE0, $400F0008, $00040000
loc_01552E:
        dc.w    $000E
        dc.l    $800D0000, $0000FFE0, $800D0000, $00000000
        dc.l    $800F0008, $0004FFE0, $800F0008, $00040000
        dc.l    $A00F0008, $0004FFE0, $A00F0008, $00040000
        dc.l    $C00F0008, $0004FFE0, $C00F0008, $00040000
        dc.l    $E00F0008, $0004FFE0, $E00F0008, $00040000
        dc.l    $000F0008, $0004FFE0, $000F0008, $00040000
        dc.l    $200F0008, $0004FFE0, $200F0008, $00040000
;=============================================================================== 
; Object 0x49 - Green Hill - Waterfalls 
                
;===============================================================================        

;=============================================================================== 
; Object 0x31 - Hill Top / Metropolis - Lava Attributes 
                 
;===============================================================================   
Obj31_Lava_Attributes: ; loc_0155A0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0155AE(pc,d0), d1
        jmp     loc_0155AE(pc,d1)
loc_0155AE:
        dc.w    loc_0155B6-loc_0155AE
        dc.w    loc_0155EC-loc_0155AE
loc_0155B2: 
        dc.w    $9694, $9500
        
loc_0155B6:
        addq.b  #2,routine(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.b  loc_0155B2(pc,d0),collision_flags(a0)
        move.l  #Lava_Attributes_Mappings,mappings(a0) ; loc_015612
        move.w  #$8680,art_tile(a0)
        move.b  #$84,render_flags(a0)
        move.b  #$80,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), $001A(a0)
loc_0155EC:        
        tst.w   (Two_player_mode).w
        bne.s   loc_015606
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_09       ; loc_015726
loc_015606:
        tst.w   (Debug_placement_mode).w
        beq.s   loc_015610
        bsr     J_DisplaySprite_00      ; loc_015720
loc_015610:        
        rts
Lava_Attributes_Mappings:        
loc_015612:
        dc.w    loc_015618-loc_015612
        dc.w    loc_015618-loc_015612
        dc.w    loc_015618-loc_015612
loc_015618:
        dc.w    $0000
;=============================================================================== 
; Object 0x31 - Hill Top / Metropolis - Lava Attributes 
                
;=============================================================================== 
;=============================================================================== 
; Object 0x74 - Hill Top / Metropolis / Dust Hill... - Invisible Block 
                 
;===============================================================================   
Obj74_Invisible_Block: ; loc_01561A:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_015628(pc,d0), d1
        jmp     loc_015628(pc,d1)
loc_015628:
        dc.w    loc_01562C-loc_015628
        dc.w    loc_015668-loc_015628
loc_01562C:
        addq.b  #2,routine(a0)
        move.l  #Invisible_Block_Mappings,mappings(a0) ; loc_0156B2
        move.w  #$8680,art_tile(a0)
        bsr     Adjust2PArtPointer     ; loc_00DC30
        ori.b   #4,render_flags(a0)
        move.b  subtype(A0), D0
        move.b  d0, d1
        andi.w  #$0F0, d0
        addi.w  #$010, d0
        lsr.w   #1,d0
        move.b  d0,width_pixels(a0)
        andi.w  #$F, d1
        addq.w  #1,d1
        lsl.w   #3, d1
        move.b  d1, y_radius(a0)
loc_015668:
        bsr     loc_00DDD8
        bne.s   loc_01568A
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     loc_00F4FA
loc_01568A:
        tst.w   (Two_player_mode).w
        bne.s   loc_0156A4
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_09       ; loc_015726
loc_0156A4:
        tst.w   (Debug_placement_mode).w
        beq.s   loc_0156B0
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_0156B0:
        rts
Invisible_Block_Mappings:
loc_0156B2:
        dc.w    loc_0156B8-loc_0156B2
        dc.w    loc_0156DA-loc_0156B2
        dc.w    loc_0156FC-loc_0156B2
loc_0156B8:
        dc.w    $0004
        dc.l    $F005001C, $000EFFF0, $F005001C, $000E0000
        dc.l    $0005001C, $000EFFF0, $0005001C, $000E0000
loc_0156DA:
        dc.w    $0004
        dc.l    $E005001C, $000EFFC0, $E005001C, $000E0030
        dc.l    $1005001C, $000EFFC0, $1005001C, $000E0030
loc_0156FC:
        dc.w    $0004
        dc.l    $E005001C, $000EFF80, $E005001C, $000E0070
        dc.l    $1005001C, $000EFF80, $1005001C, $000E0070        
;=============================================================================== 
; Object 0x74 - Hill Top / Metropolis / Dust Hill... - Invisible Block 
                
;===============================================================================   

        nop                     ; Filler 
J_DisplaySprite_00: ; loc_015720:
        jmp     DisplaySprite           ; loc_00D3C2
J_DeleteObject_09: ; loc_015726:
        jmp     DeleteObject            ; loc_00D3B4
;=============================================================================== 
; Object 0x06 - Green Hill / Metropolis - Spiral Loopings Attributes, ... 
                 
;===============================================================================           
Obj06_Spiral_Attributes: ; loc_01572C:   
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01575C(pc,d0), d1
        jsr     loc_01575C(pc,d1)
        tst.w   (Two_player_mode).w
        beq.s   loc_015742
        rts
loc_015742:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_0A       ; loc_015756
        rts
J_DeleteObject_0A: ; loc_015756:
        jmp     DeleteObject            ; loc_00D3B4
loc_01575C:
        dc.w    loc_015762-loc_01575C
        dc.w    loc_01577A-loc_01575C
        dc.w    loc_015A6A-loc_01575C
loc_015762:
        addq.b  #2,routine(a0)
        move.b  #$d0,width_pixels(a0)
        tst.b   subtype(a0)
        bpl.s   loc_01577A
        addq.b  #2,routine(a0)
        bra     loc_015A6A
loc_01577A:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        bsr.s   loc_015788
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_015788:
        btst    d6, status(a0)
        bne     loc_015822
        btst    #1, status(a1)
        bne     loc_015820
        btst    #3, status(a1)
        bne.s   loc_0157E2
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        tst.w  x_vel(a1)
        bmi.s   loc_0157BE
        cmpi.w  #$FF40, d0
        bgt.s   loc_015820
        cmpi.w  #$FF30, d0
        blt.s   loc_015820
        bra.s   loc_0157CA
loc_0157BE:
        cmpi.w  #$0C0, d0
        blt.s   loc_015820
        cmpi.w  #$0D0, d0
        bgt.s   loc_015820
loc_0157CA:
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        subi.w  #$010, d1
        cmpi.w  #$030, d1
        bcc.s   loc_015820
        bsr     loc_00FAF2
        rts
loc_0157E2:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        tst.w  x_vel(a1)
        bmi.s   loc_0157FE
        cmpi.w  #$FF50, d0
        bgt.s   loc_015820
        cmpi.w  #$FF40, d0
        blt.s   loc_015820
        bra.s   loc_01580A
loc_0157FE:
        cmpi.w  #$0B0, d0
        blt.s   loc_015820
        cmpi.w  #$0C0, d0
        bgt.s   loc_015820
loc_01580A:
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        subi.w  #$010, d1
        cmpi.w  #$030, d1
        bcc.s   loc_015820
        bsr     loc_00FAF2
loc_015820:
        rts
loc_015822:
        move.w  $14(A1), D0
        bpl.s   loc_01582A
        neg.w   D0
loc_01582A:
        cmpi.w  #$600, d0
        bcs.s   loc_01584C
        btst    #1, status(a1)
        bne.s   loc_01584C
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addi.w  #$0D0, d0
        bmi.s   loc_01584C
        cmpi.w  #$1A0, d0
        bcs.s   loc_015864
loc_01584C:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        rts
loc_015864:
        btst    #3, status(a1)
        beq.s   loc_015820
        move.b  loc_0158CA(pc,d0), d1
        ext.w   d1
        move.w  y_pos(a0), D2
        add.w   d1, D2
        moveq   #0,d1
        move.b  y_radius(A1), d1
        subi.w  #$013, d1
        sub.w   d1, D2
        move.w  D2, y_pos(a1)
        lsr.w   #3, d0
        andi.w  #$03F, d0
        move.b  loc_015896(pc,d0), $0027(a1)
        rts
loc_015896:
        dc.b    $00, $00, $01, $01, $16, $16, $16, $16, $2C, $2C, $2C, $2C, $42, $42, $42, $42
        dc.b    $58, $58, $58, $58, $6E, $6E, $6E, $6E, $84, $84, $84, $84, $9A, $9A, $9A, $9A
        dc.b    $B0, $B0, $B0, $B0, $C6, $C6, $C6, $C6, $DC, $DC, $DC, $DC, $F2, $F2, $F2, $F2
        dc.b    $01, $01, $00, $00
loc_0158CA:
        dc.b    $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
        dc.b    $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $1F, $1F
        dc.b    $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1E, $1E, $1E
        dc.b    $1E, $1E, $1E, $1E, $1E, $1E, $1D, $1D, $1D, $1D, $1D, $1C, $1C, $1C, $1C, $1B
        dc.b    $1B, $1B, $1B, $1A, $1A, $1A, $19, $19, $19, $18, $18, $18, $17, $17, $16, $16
        dc.b    $15, $15, $14, $14, $13, $12, $12, $11, $10, $10, $0F, $0E, $0E, $0D, $0C, $0C
        dc.b    $0B, $0A, $0A, $09, $08, $08, $07, $06, $06, $05, $04, $04, $03, $02, $02, $01
        dc.b    $00, $FF, $FE, $FE, $FD, $FC, $FC, $FB, $FA, $F9, $F9, $F8, $F7, $F7, $F6, $F6
        dc.b    $F5, $F5, $F4, $F4, $F3, $F2, $F2, $F1, $F1, $F0, $F0, $EF, $EF, $EE, $EE, $ED
        dc.b    $ED, $ED, $EC, $EB, $EB, $EA, $EA, $E9, $E9, $E8, $E8, $E7, $E7, $E6, $E6, $E5
        dc.b    $E5, $E4, $E4, $E4, $E3, $E3, $E2, $E2, $E2, $E1, $E1, $E1, $E0, $E0, $E0, $DF
        dc.b    $DF, $DF, $DF, $DE, $DE, $DE, $DD, $DD, $DD, $DD, $DD, $DD, $DD, $DD, $DC, $DC
        dc.b    $DC, $DC, $DC, $DC, $DC, $DC, $DC, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB
        dc.b    $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB, $DB
        dc.b    $DB, $DB, $DB, $DB, $DC, $DC, $DC, $DC, $DC, $DC, $DC, $DD, $DD, $DD, $DD, $DD
        dc.b    $DD, $DD, $DD, $DE, $DE, $DE, $DF, $DF, $DF, $DF, $E0, $E0, $E0, $E1, $E1, $E1
        dc.b    $E2, $E2, $E2, $E3, $E3, $E4, $E4, $E4, $E5, $E5, $E6, $E6, $E7, $E7, $E8, $E8
        dc.b    $E9, $E9, $EA, $EA, $EB, $EB, $EC, $ED, $ED, $EE, $EE, $EF, $F0, $F0, $F1, $F2
        dc.b    $F2, $F3, $F4, $F5, $F5, $F6, $F7, $F8, $F9, $F9, $FA, $FB, $FC, $FD, $FE, $FF
        dc.b    $00, $01, $02, $03, $04, $05, $06, $07, $08, $08, $09, $0A, $0A, $0B, $0C, $0D
        dc.b    $0D, $0E, $0E, $0F, $0F, $10, $10, $11, $11, $12, $12, $13, $13, $14, $14, $15
        dc.b    $15, $16, $16, $17, $17, $18, $18, $18, $19, $19, $19, $19, $1A, $1A, $1A, $1A
        dc.b    $1B, $1B, $1B, $1B, $1C, $1C, $1C, $1C, $1C, $1C, $1D, $1D, $1D, $1D, $1D, $1D
        dc.b    $1D, $1E, $1E, $1E, $1E, $1E, $1E, $1E, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F
        dc.b    $1F, $1F, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
        dc.b    $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20        
loc_015A6A:
        lea     (MainCharacter).w, A1
        lea     ($FFFFF7B2).w, a2
        moveq   #3, D6
        bsr.s   loc_015A80
        lea     (Sidekick).w, A1
        lea     ($FFFFF7B3).w, a2
        addq.b  #1, D6
loc_015A80:
        btst    d6, status(a0)
        bne     loc_015AEE
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        cmpi.w  #$FF40, d0
        blt.s   loc_015AEC
        cmpi.w  #$0C0, d0
        bge.s   loc_015AEC
        move.w  y_pos(a0), D0
        addi.w  #$03C, d0
        move.w  y_pos(A1), D2
        move.b  y_radius(A1), d1
        ext.w   d1
        add.w   D2, d1
        addq.w  #4, d1
        sub.w   d1, d0
        bhi.s   loc_015AEC
        cmpi.w  #$FFF0, d0
        bcs.s   loc_015AEC
        cmpi.b  #6, $0024(a1)
        bcc.s   loc_015AEC
        add.w   d0, D2
        addq.w  #3, D2
        move.w  D2, y_pos(a1)
        move.b  #1, $0029(a1)
        bsr     loc_00FAF2
        move.w  #$001, $001C(a1)
        move.b  #0, (a2)
        tst.w   $14(a1)
        bne.s   loc_015AEC
        move.w  #$001, $14(a1)
loc_015AEC:
        rts
loc_015AEE:
        btst    #1, status(a1)
        bne.s   loc_015B28
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addi.w  #$0C0, d0
        bmi.s   loc_015B0A
        cmpi.w  #$180, d0
        bcs.s   loc_015B42
loc_015B0A:
        bclr    #3, status(a1)
        bclr    d6, status(a0)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        bset    #1, status(a1)
        rts
loc_015B28:
        move.b  (A2), D0
        addi.b  #$20, d0
        cmpi.b  #$40, d0
        bcc.s   loc_015B3A
        asr.w   $0012(a1)
        bra.s   loc_015B0A
loc_015B3A:
        move.w  #0, $0012(a1)
        bra.s   loc_015B0A
loc_015B42:
        btst    #3, status(a1)
        beq.s   loc_015AEC
        move.b  (A2), D0
        bsr     loc_015B84
        muls.w  #$2800, d1
        swap.w  d1
        move.w  y_pos(a0), D2
        add.w   d1, D2
        moveq   #0,d1
        move.b  y_radius(A1), d1
        subi.w  #$013, d1
        sub.w   d1, D2
        move.w  D2, y_pos(a1)
        move.b  (A2), D0
        move.b  d0, $0027(a1)
        addq.b  #4, (a2)
        tst.w   $14(a1)
        bne.s   loc_015B80
        move.w  #$001, $14(a1)
loc_015B80:
        rts             
;=============================================================================== 
; Object 0x06 - Green Hill / Metropolis - Spiral Loopings Attributes, ... 
                
;=============================================================================== 
        nop                     ; Filler
loc_015B84:
        jmp     CalcSine        ; loc_00320A  
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x14 - Hill Top See-saw badnick 
                 
;===============================================================================    
Obj14_See_Saw: ; loc_015B8C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_015BA2(pc,d0), d1
        jsr     loc_015BA2(pc,d1)
        move.w  Objoff_30(A0), D0
        bra     loc_016004
loc_015BA2:
        dc.w    loc_015BAE-loc_015BA2
        dc.w    loc_015C1C-loc_015BA2
        dc.w    loc_015CD8-loc_015BA2
        dc.w    loc_015D06-loc_015BA2
        dc.w    loc_015D60-loc_015BA2
        dc.w    loc_015DF8-loc_015BA2
loc_015BAE:
        addq.b  #2,routine(a0)
        move.l  #See_Saw_Mappings,mappings(a0)  ; loc_015F54
        move.w  #$3C6,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_00 ; loc_015FF8
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$30,width_pixels(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        tst.b   subtype(a0)
        bne.s   loc_015C08
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_015C08
        move.b  #$14, 0(a1)
        addq.b  #6, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  status(a0), status(a1)
        move.l  A0, $003C(a1)
loc_015C08:
        btst    #0, status(a0)
        beq.s   loc_015C16
        move.b  #$2, $001A(a0)
loc_015C16:
        move.b  $001A(A0), objoff_3A(a0)
loc_015C1C:
        move.b  objoff_3A(A0), d1
        btst    #3, status(a0)
        beq.s   loc_015C76
        moveq   #$2, d1  
        lea     (MainCharacter).w, A1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_015C3C
        neg.w   D0
        moveq   #0,d1
loc_015C3C:
        cmpi.w  #8, d0
        bcc.s   loc_015C44
        moveq   #1,d1
loc_015C44:
        btst    #4, status(a0)
        beq.s   loc_015CAE
        moveq   #$2, D2
        lea     (Sidekick).w, A1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0 
        bcc.s   loc_015C60
        neg.w   D0
        moveq   #0, D2
loc_015C60:
        cmpi.w  #8, d0
        bcc.s   loc_015C68
        moveq   #1, D2
loc_015C68:
        add.w   D2, d1
        cmpi.w  #$003, d1   
        bne.s   loc_015C72
        addq.w  #1,d1
loc_015C72:
        lsr.w   #1,d1
        bra.s   loc_015CAE
loc_015C76:        
        btst    #4, status(a0)
        beq.s   loc_015C9C
        moveq   #$2, d1
        lea     (Sidekick).w, A1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_015C92
        neg.w   D0
        moveq   #0,d1
loc_015C92:
        cmpi.w  #8, d0
        bcc.s   loc_015CAE
        moveq   #1,d1
        bra.s   loc_015CAE
loc_015C9C:
        move.w  ($FFFFB012).w, d0
        move.w  ($FFFFB052).w, D2
        cmp.w   d0, D2
        blt.s   loc_015CAA
        move.w  d2, d0
loc_015CAA:
        move.w  d0, objoff_38(a0)
loc_015CAE:
        bsr     loc_015CDA
        lea     (loc_015EF2), A2
        btst    #0, $001A(a0)
        beq.s   loc_015CC6
        lea     (loc_015F23), A2
loc_015CC6:
        move.w  x_pos(a0), -(A7)
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #8, d3
        move.w  (A7)+, D4
        bra     loc_00F9D6
loc_015CD8:
        rts
loc_015CDA:
        move.b  $001A(A0), D0
        cmp.b   d1, d0
        beq.s   loc_015D04
        bcc.s   loc_015CE6
        addq.b  #$2, d0
loc_015CE6:
        subq.b  #1,d0
        move.b  d0, $001A(a0)
        move.b  d1, objoff_3A(a0)
        bclr    #0,render_flags(a0)
        btst    #1, $001A(a0)
        beq.s   loc_015D04
        bset    #0,render_flags(a0)
loc_015D04:
        rts
loc_015D06:
        addq.b  #2,routine(a0)
        move.l  #See_Saw_Badnick_Mappings,mappings(a0) ; loc_015FE0
        move.w  #$3DE,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_00 ; loc_015FF8
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$8B,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        addi.w  #$028, x_pos(a0)
        addi.w  #$010, y_pos(a0)
        move.w  y_pos(a0), Objoff_34(a0)
        btst    #0, status(a0)
        beq.s   loc_015D60
        subi.w  #$050, x_pos(a0)
        move.b  #$2, objoff_3A(a0)
loc_015D60:
        bsr     loc_015ECA
        move.l  Objoff_3C(a0), A1
        moveq	#0,d0
        move.b  objoff_3A(A0), D0
        sub.b   objoff_3A(A1), D0
        beq.s   loc_015DBA
        bcc.s   loc_015D78
        neg.b   D0
loc_015D78:
        move.w  #$F7E8, d1
        move.w  #$FEEC, D2
        cmpi.b  #1,d0
        beq.s   loc_015D9E
        move.w  #$F510, d1
        move.w  #$FF34, D2
        cmpi.w  #$A00, objoff_38(a1)
        blt.s   loc_015D9E
        move.w  #$F200, d1
        move.w  #$FF60, D2
loc_015D9E:
        move.w  d1, $0012(a0)
        move.w  D2,x_vel(a0)
        move.w  x_pos(a0), D0
        sub.w   Objoff_30(A0), D0
        bcc.s   loc_015DB4
        neg.w  x_vel(a0)
loc_015DB4:
        addq.b  #2,routine(a0)
        bra.s   loc_015DF8
loc_015DBA:
        lea     (loc_015EC0), A2
        moveq	#0,d0
        move.b  $001A(A1), D0
        move.w  #$028, D2
        move.w  x_pos(a0), d1
        sub.w   Objoff_30(A0), d1
        bcc.s   loc_015DD8
        neg.w   D2
        addq.w  #$2, d0
loc_015DD8:
        add.w   d0, d0
        move.w  Objoff_34(A0), d1
        add.w   $00(A2, d0), d1
        move.w  d1, y_pos(a0)
        add.w   Objoff_30(A0), D2
        move.w  D2, x_pos(a0)
        clr.w   Objoff_E(a0)
        clr.w   $000A(a0)
        rts
loc_015DF8:
        bsr     loc_015ECA
        tst.w   $0012(a0)
        bpl.s   loc_015E1A
        bsr     J_ObjectFall_00         ; loc_015FFE
        move.w  Objoff_34(A0), D0
        subi.w  #$02F, d0
        cmp.w   y_pos(a0), D0
        bgt.s   loc_015E18
        bsr     J_ObjectFall_00         ; loc_015FFE
loc_015E18:
        rts
loc_015E1A:
        bsr     J_ObjectFall_00         ; loc_015FFE
        move.l  Objoff_3C(a0), A1
        lea     (loc_015EC0), A2
        moveq	#0,d0
        move.b  $001A(A1), D0
        move.w  x_pos(a0), d1
        sub.w   Objoff_30(A0), d1
        bcc.s   loc_015E3A
        addq.w  #$2, d0
loc_015E3A:
        add.w   d0, d0
        move.w  Objoff_34(A0), d1
        add.w   $00(A2, d0), d1
        cmp.w   y_pos(a0), d1
        bgt.s   loc_015E8E
        move.l  Objoff_3C(a0), A1
        moveq   #$2, d1
        tst.w  x_vel(a0)
        bmi.s   loc_015E58
        moveq   #0,d1
loc_015E58:
        move.b  d1, objoff_3A(a1)
        move.b  d1, objoff_3A(a0)
        cmp.b   $001A(A1), d1
        beq.s   loc_015E82
        lea     (MainCharacter).w, a2
        bclr    #3, status(a1)
        beq.s   loc_015E74
        bsr.s   loc_015E90
loc_015E74:
        lea     (Sidekick).w, a2
        bclr    #4, status(a1)
        beq.s   loc_015E82
        bsr.s   loc_015E90
loc_015E82:
        clr.w  x_vel(a0)
        clr.w   $0012(a0)
        subq.b  #2,routine(a0)
loc_015E8E:        
        rts
loc_015E90:
        move.w  $0012(A0), $0012(a2)
        neg.w   $0012(a2)
        bset    #1, status(a2)
        bclr    #3, status(a2)
        clr.b   $003C(a2)
        move.b  #$10, $001C(a2)
        move.b  #$2, $0024(a2)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_015EC0:        
        dc.w    $FFF8, $FFE4, $FFD1, $FFE4, $FFF8
loc_015ECA:
        move.b  ($FFFFFE05).w, d0
        andi.b  #3, d0
        bne.s   loc_015EDA
        bchg    #5,art_tile(a0)
loc_015EDA:
        andi.b  #$FE,render_flags(a0)
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        bcs.s   loc_015EF0
        ori.b   #1,render_flags(a0)
loc_015EF0:
        rts        
loc_015EF2:        
        dc.b    $14, $14, $16, $18, $1A, $1C, $1A, $18, $16, $14, $13, $12, $11, $10, $0F, $0E
        dc.b    $0D, $0C, $0B, $0A, $09, $08, $07, $06, $05, $04, $03, $02, $01, $00, $FF, $FE
        dc.b    $FD, $FC, $FB, $FA, $F9, $F8, $F7, $F6, $F5, $F4, $F3, $F2, $F2, $F2, $F2, $F2
        dc.b    $F2
loc_015F23:
        dc.b    $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $00
See_Saw_Mappings:        
loc_015F54:
        dc.w    loc_015F5C-loc_015F54
        dc.w    loc_015F9E-loc_015F54
        dc.w    loc_015F5C-loc_015F54
        dc.w    loc_015F9E-loc_015F54
loc_015F5C:
        dc.w    $0008
        dc.l    $FC054014, $400AFFF8, $0C012012, $2009FFFC
        dc.l    $E4054006, $4003FFD0, $EC05400A, $4005FFE0
        dc.l    $F405400A, $4005FFF0, $FC05400A, $40050000
        dc.l    $0405400A, $40050010, $0C05400E, $40070020
loc_015F9E:
        dc.w    $0008
        dc.l    $FC054014, $400AFFF8, $0C012012, $2009FFFC
        dc.l    $F4054000, $4000FFD0, $F4054002, $4001FFE0
        dc.l    $F4054002, $4001FFF0, $F4054002, $40010000
        dc.l    $F4054002, $40010010, $F4054800, $48000020 
See_Saw_Badnick_Mappings:                       
loc_015FE0:
        dc.w    loc_015FE4-loc_015FE0
        dc.w    loc_015FEE-loc_015FE0
loc_015FE4:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_015FEE:
        dc.w    $0001
        dc.l    $F8052000, $2000FFF8  
;=============================================================================== 
; Object 0x14 - Hill Top See-saw badnick 
                
;===============================================================================           
J_ModifySpriteAttr_2P_00: ; loc_015FF8:
        jmp     Adjust2PArtPointer     ; loc_00DC30  
J_ObjectFall_00: ; ; loc_015FFE:
        jmp     ObjectFall              ; loc_00D24E   
loc_016004:
        jmp     loc_00D2D8                        
 
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x16 - Hill Top Teleferics
                 
;===============================================================================            
Obj16_Teleferics: ; loc_01600C:   
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01601A(pc,d0), d1
        jmp     loc_01601A(pc,d1)
loc_01601A:
        dc.w    loc_01601E-loc_01601A
        dc.w    loc_016064-loc_01601A
loc_01601E:
        addq.b  #2,routine(a0)
        move.l  #Teleferics_Mappings,mappings(a0)  ; loc_01611E
        move.w  #$43E6,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_01 ; loc_016210
        ori.b   #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #0, $001A(a0)
        move.b  #1, $0018(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), $0032(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsl.w   #3, d0
        move.w  d0, Objoff_34(a0)
loc_016064:
        move.w  x_pos(a0), -(A7)
        bsr     loc_016080
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  #$FFD8, d3
        move.w  (A7)+, D4
        bsr     loc_00F984
        bra     J_MarkObjGone_00        ; loc_01620A
loc_016080:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01608E(pc,d0), d1
        jmp     loc_01608E(pc,d1)
loc_01608E:
        dc.w    loc_016094-loc_01608E
        dc.w    loc_0160BC-loc_01608E
        dc.w    loc_016102-loc_01608E
loc_016094:               
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_0160BA
        addq.b  #$2, $0025(a0)
        move.w  #$200,x_vel(a0)
        btst    #0, status(a0)
        beq.s   loc_0160B4
        neg.w  x_vel(a0)
loc_0160B4:
        move.w  #$100, $0012(a0)
loc_0160BA:
        rts
loc_0160BC:
        bsr     J_SpeedToPos_00         ; loc_016216
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_016100
        addq.b  #$2, $0025(a0)
        move.b  #$2, $001A(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $0012(a0)
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_016100
        move.b  #$1C, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  #6, subtype(a1)
loc_016100:
        rts
loc_016102:
        bsr     J_SpeedToPos_00         ; loc_016216
        addi.w  #$038, $0012(a0)
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs     J_DeleteObject_0B       ; loc_016204
        rts   
Teleferics_Mappings:
loc_01611E:
        dc.w    loc_016128-loc_01611E
        dc.w    loc_01617A-loc_01611E
        dc.w    loc_0161BC-loc_01611E
        dc.w    loc_0161CE-loc_01611E
        dc.w    loc_0161E8-loc_01611E
loc_016128:
        dc.w    $000A
        dc.l    $C1050000, $0000FFE4, $D0030004, $0002FFE6
        dc.l    $F0030004, $0002FFE6, $10010008, $0004FFE7
        dc.l    $D505000A, $0005000C, $E003000E, $00070011
        dc.l    $10010012, $00090011, $0003000E, $00070011
        dc.l    $200D0014, $000AFFE0, $200D0814, $080A0000
loc_01617A:
        dc.w    $0008
        dc.l    $C1050000, $0000FFE4, $D0030004, $0002FFE6
        dc.l    $F0030004, $0002FFE6, $1001002C, $0016FFE6
        dc.l    $D505000A, $0005000C, $E003000E, $00070011
        dc.l    $1801002E, $00170011, $0003000E, $00070011
loc_0161BC:
        dc.w    $0002
        dc.l    $200D0014, $000AFFE0, $200D0814, $080A0000
loc_0161CE:
        dc.w    $0003
        dc.l    $D805001C, $000EFFF8, $E8070020, $0010FFF8
        dc.l    $08070020, $0010FFF8
loc_0161E8:
        dc.w    $0003
        dc.l    $D8050028, $0014FFF8, $E8070820, $0810FFF8
        dc.l    $08070820, $0810FFF8   
        nop                     Filler
J_DeleteObject_0B: ; loc_016204:
        jmp     DeleteObject            ; loc_00D3B4
J_MarkObjGone_00: ; loc_01620A:           
        jmp     MarkObjGone             ; loc_00D2A0
J_ModifySpriteAttr_2P_01: ; loc_016210:
        jmp     Adjust2PArtPointer     ; loc_00DC30
J_SpeedToPos_00: ; loc_016216:
        jmp     SpeedToPos              ; loc_00D27A               
;=============================================================================== 
; Object 0x16 - Hill Top Teleferics
                
;===============================================================================                     
;=============================================================================== 
; Object 0x19 - Oil Ocean - Elevators
                 
;===============================================================================  
Obj19_Elevator: ; loc_01621C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01622A(pc,d0), d1
        jmp     loc_01622A(pc,d1)
loc_01622A:
        dc.w    loc_016238-loc_01622A
        dc.w    loc_0162A0-loc_01622A
loc_01622E        
        dc.b    $20, $00, $18, $01, $20, $02, $40, $03, $30, $04
loc_016238:
        addq.b  #2,routine(a0)
        move.l  #Elevator_Mappings,mappings(a0) ; loc_016412
        move.w  #$63A0,art_tile(a0)
        cmpi.b  #$A, (Current_ZoneAndAct).w
        bne.s   loc_016258
        move.w  #$6300,art_tile(a0)
loc_016258:
        bsr     J_ModifySpriteAttr_2P_02 ; loc_01645C
        move.b  #4,render_flags(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$01E, d0
        lea     loc_01622E(pc,d0), A2
        move.b  (A2)+,width_pixels(a0)
        move.b  (A2)+, $001A(a0)
        move.b  #4, $0018(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), $0032(a0)
        andi.b  #$F, subtype(a0)
        cmpi.b  #$7, subtype(a0)
        bne.s   loc_0162A0
        subi.w  #$0C0, y_pos(a0)
loc_0162A0:
        move.w  x_pos(a0), -(A7)
        bsr     loc_0162D0
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  #$010, d3
        move.w  (A7)+, D4
        bsr     loc_00F984
        move.w  Objoff_30(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_0C       ; loc_016456
        bra     J_DisplaySprite_01      ; loc_016450
loc_0162D0:
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        add.w   d0, d0
        move.w  loc_0162E4(pc,d0), d1
        jmp     loc_0162E4(pc,d1)
loc_0162E4:
        dc.w    loc_016304-loc_0162E4
        dc.w    loc_01630E-loc_0162E4
        dc.w    loc_01632E-loc_0162E4
        dc.w    loc_01634E-loc_0162E4
        dc.w    loc_01635E-loc_0162E4
        dc.w    loc_01637E-loc_0162E4
        dc.w    loc_016380-loc_0162E4
        dc.w    loc_016380-loc_0162E4
        dc.w    loc_01639C-loc_0162E4
        dc.w    loc_01639C-loc_0162E4
        dc.w    loc_01639C-loc_0162E4
        dc.w    loc_01639C-loc_0162E4
        dc.w    loc_0163D6-loc_0162E4
        dc.w    loc_0163D6-loc_0162E4
        dc.w    loc_0163D6-loc_0162E4
        dc.w    loc_0163D6-loc_0162E4
loc_016304:
        move.b  ($FFFFFE68).w, d0
        move.w  #$40, d1
        bra.s   loc_016316
loc_01630E:
        move.b  ($FFFFFE6C).w, d0
        move.w  #$060, d1
loc_016316:
        btst    #0, status(a0)
        beq.s   loc_016322
        neg.w   D0
        add.w   d1, d0
loc_016322:
        move.w  Objoff_30(A0), d1
        sub.w   d0, d1
        move.w  d1, x_pos(a0)
        rts
loc_01632E:
        move.b  ($FFFFFE7C).w, d0
        move.w  #$080, d1
        btst    #0, status(a0)
        beq.s   loc_016342
        neg.w   D0
        add.w   d1, d0
loc_016342:
        move.w  $0032(A0), d1
        sub.w   d0, d1
        move.w  d1, y_pos(a0)
        rts
loc_01634E:
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_01635C
        addq.b  #1, subtype(a0)
loc_01635C:
        rts
loc_01635E:
        bsr     J_SpeedToPos_01         ; loc_016462
        moveq   #8, d1
        move.w  $0032(A0), D0
        subi.w  #$060, d0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_016374
        neg.w   d1
loc_016374:
        add.w   d1, $0012(a0)
        bne.s   loc_01637E
        addq.b  #1, subtype(a0)
loc_01637E:
        rts
loc_016380:
        bsr     J_SpeedToPos_01         ; loc_016462
        moveq   #8, d1
        move.w  $0032(A0), D0
        subi.w  #$060, d0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_016396
        neg.w   d1
loc_016396:
        add.w   d1, $0012(a0)
        rts
loc_01639C:
        move.b  ($FFFFFE98).w, d1
        subi.b  #$40, d1
        ext.w   d1
        move.b  ($FFFFFE9C).w, D2
        subi.b  #$40, D2
        ext.w   D2
        btst    #$2, d0
        beq.s   loc_0163BA
        neg.w   d1
        neg.w   D2
loc_0163BA:
        btst    #1,d0
        beq.s   loc_0163C4
        neg.w   d1
        exg.l   D2, d1
loc_0163C4:
        add.w   Objoff_30(A0), d1
        move.w  d1, x_pos(a0)
        add.w   $0032(A0), D2
        move.w  D2, y_pos(a0)
        rts
loc_0163D6:
        move.b  ($FFFFFE98).w, d1
        subi.b  #$40, d1
        ext.w   d1
        move.b  ($FFFFFE9C).w, D2
        subi.b  #$40, D2
        ext.w   D2
        btst    #$2, d0
        beq.s   loc_0163F4
        neg.w   d1
        neg.w   D2
loc_0163F4:
        btst    #1,d0
        beq.s   loc_0163FE
        neg.w   d1
        exg.l   D2, d1
loc_0163FE:
        neg.w   d1
        add.w   Objoff_30(A0), d1
        move.w  d1, x_pos(a0)
        add.w   $0032(A0), D2
        move.w  D2, y_pos(a0)
        rts
Elevator_Mappings:        
loc_016412:               
        dc.w    loc_016418-loc_016412
        dc.w    loc_01642A-loc_016412
        dc.w    loc_01643C-loc_016412
loc_016418:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFE0, $F00F0800, $08000000
loc_01642A:
        dc.w    $0002
        dc.l    $F00B0000, $0000FFE8, $F00B0800, $08000000
loc_01643C:
        dc.w    $0002
        dc.l    $F00E0000, $0000FFE0, $F00E0800, $08000000    
;=============================================================================== 
; Object 0x19 - Oil Ocean - Elevators
                
;===============================================================================  
        nop                     ; Filler
J_DisplaySprite_01: ; loc_016450:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_0C: ; loc_016456:
        jmp     DeleteObject            ; (loc_00D3B4)
J_ModifySpriteAttr_2P_02: ; loc_01645C:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SpeedToPos_01: ; loc_016462:
        jmp     SpeedToPos              ; (loc_00D27A)   
        
;=============================================================================== 
; Object 0x1B - Chemical Plant - Speed Booster
                 
;===============================================================================          
Obj1B_Speed_Booster: ; loc_016468:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_016476(pc,d0), d1
        jmp     loc_016476(pc,d1)
loc_016476:
        dc.w    loc_01647E-loc_016476
        dc.w    loc_0164B4-loc_016476         
loc_01647A:
        dc.w    $1000, $0A00
loc_01647E:
        addq.b  #2,routine(a0)
        move.l  #Speed_Booster_Mappings,mappings(a0) ; loc_01658A
        move.w  #$E39C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_03 ; loc_0165AA
        ori.b   #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  subtype(A0), D0
        andi.w  #$002, d0
        move.w  loc_01647A(pc,d0), Objoff_30(a0)
loc_0164B4:
        move.b  ($FFFFFE05).w, d0
        andi.b  #$2, d0
        move.b  d0, $001A(a0)
        move.w  x_pos(a0), D0
        move.w  d0, d1
        subi.w  #$010, d0
        addi.w  #$010, d1
        move.w  y_pos(a0), D2
        move.w  D2, d3
        subi.w  #$010, D2
        addi.w  #$010, d3
        lea     (MainCharacter).w, A1
        btst    #1, status(a1)
        bne.s   loc_016510
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_016510
        cmp.w   d1, D4
        bcc     loc_016510
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_016510
        cmp.w   d3, D4
        bcc     loc_016510
        move.w  d0, -(A7)
        bsr     loc_016544
        move.w  (A7)+, D0
loc_016510:
        lea     (Sidekick).w, A1
        btst    #1, status(a1)
        bne.s   loc_016540
        move.w  x_pos(A1), D4
        cmp.w   d0, D4
        bcs     loc_016540
        cmp.w   d1, D4
        bcc     loc_016540
        move.w  y_pos(A1), D4
        cmp.w   D2, D4
        bcs     loc_016540
        cmp.w   d3, D4
        bcc     loc_016540
        bsr     loc_016544
loc_016540:
        bra     J_MarkObjGone_01        ; loc_0165A4
loc_016544:
        move.w  Objoff_30(A0),x_vel(a1)
        bclr    #0, status(a1)
        btst    #0, status(a0)
        beq.s   loc_016562
        bset    #0, status(a1)
        neg.w  x_vel(a1)
loc_016562:
        move.w  #$F, $002E(a1)
        move.w x_vel(A1), $14(a1)
        bclr    #5, status(a0)
        bclr    #6, status(a0)
        bclr    #5, status(a1)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
Speed_Booster_Mappings:        
loc_01658A:
        dc.w    loc_016590-loc_01658A
        dc.w    loc_016590-loc_01658A
        dc.w    loc_0165A2-loc_01658A
loc_016590:
        dc.w    $0002
        dc.l    $F8050000, $0000FFE8, $F8050000, $00000008
loc_0165A2:
        dc.w    $0000
;=============================================================================== 
; Object 0x1B - Chemical Plant - Speed Booster
                
;===============================================================================  
J_MarkObjGone_01: ; loc_0165A4:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_03: ; loc_0165AA:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)   
;=============================================================================== 
; Object 0x1D - Chemical Plant - Worms
                 
;===============================================================================  
Obj1D_Worms: ; loc_0165B0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0165BE(pc,d0), d1
        jmp     loc_0165BE(pc,d1)
loc_0165BE:
        dc.w    loc_0165D0-loc_0165BE
        dc.w    loc_01667E-loc_0165BE
        dc.w    loc_01669C-loc_0165BE
        dc.w    loc_01667E-loc_0165BE
        dc.w    loc_0166D0-loc_0165BE         
;loc_0165C8:
        dc.w    $FB80, $FB00, $FA00, $F900          
loc_0165D0:
        addq.b  #2,routine(a0)
        move.w  #$FB80, $0012(a0)
        moveq   #0,d1
        move.b  subtype(A0), d1
        move.b  d1, d0
        andi.b  #$F, d1
        moveq   #$2,d5
        andi.b  #$F0, d0
        beq.s   loc_0165F0
        moveq   #6,d5
loc_0165F0:
        move.b  status(a0), D4
        moveq   #0, D2
        move.l  A0, A1
        bra.s   loc_016600
loc_0165FA:        
        bsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_016678
loc_016600:
        move.b  0(A0), 0(a1)
        move.b  d5, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  #Worms_Mappings, mappings(a1) ; loc_016702
        move.w  #$643C, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_00 ; loc_016716
        move.b  #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #$8B, $0020(a1)
        move.w  x_pos(A1), objoff_38(a1)
        move.w  y_pos(A1), Objoff_30(a1)
        move.w  $0012(A0), $0012(a1)
        move.w  $0012(A1), Objoff_34(a1)
        move.b  #8, $0019(a1)
        move.w  #$060, objoff_3A(a1)
        move.w  #$00B, $0036(a1)
        andi.b  #1, D4
        beq.s   loc_016672
        neg.w   $0036(a1)
        neg.w   objoff_3A(a1)
loc_016672:
        move.w  D2, $0032(a1)
        addq.w  #3, D2
loc_016678:
        dbra    d1, loc_0165FA
        rts
loc_01667E:
        subq.w  #1, $0032(a0)
        bpl.s   loc_016698
        addq.b  #2,routine(a0)
        move.w  #$03B, $0032(a0)
        move.w  #$0AE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_016698:
        bra     J_MarkObjGone_02        ; loc_016710
loc_01669C:
        bsr     J_SpeedToPos_02         ; loc_01671C
        move.w  objoff_36(a0), D0
        add.w   d0,x_vel(a0)
        addi.w  #$018, $0012(a0)
        bne.s   loc_0166B4
        neg.w   objoff_36(a0)
loc_0166B4:
        move.w  Objoff_30(A0), D0
        cmp.w   y_pos(a0), D0
        bhi.s   loc_0166CC
        move.w  Objoff_34(A0), $0012(a0)
        clr.w  x_vel(a0)
        subq.b  #2,routine(a0)
loc_0166CC:
        bra     J_MarkObjGone_02        ; loc_016710
loc_0166D0:
        bsr     J_SpeedToPos_02         ; loc_01671C
        addi.w  #$018, $0012(a0)
        bne.s   loc_0166E8
        move.w  objoff_3A(A0), D0
        add.w   objoff_38(A0), D0
        move.w  d0, x_pos(a0)
loc_0166E8:
        move.w  Objoff_30(A0), D0
        cmp.w   y_pos(a0), D0
        bhi.s   loc_0166FE
        move.w  Objoff_34(A0), $0012(a0)
        move.w  objoff_38(A0), x_pos(a0)
loc_0166FE:
        bra     J_MarkObjGone_02        ; loc_016710
Worms_Mappings:        
loc_016702:
        dc.w    loc_016704-loc_016702
loc_016704:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8  
;=============================================================================== 
; Object 0x1D - Chemical Plant - Worms
                
;===============================================================================               
        nop                     ; Filler
J_MarkObjGone_02: ; loc_016710:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifyA1SpriteAttr_2P_00: ; loc_016716:
        jmp     ModifyA1SpriteAttr_2P   ; (loc_00DC4C)
J_SpeedToPos_02: ; loc_01671C:
        jmp     SpeedToPos              ; (loc_00D27A)   
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x1E - Chemical Plant - Tube Attributes
                 
;===============================================================================          
Obj1E_Tube_Attributes: ; loc_016724:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_016740(pc,d0), d1
        jsr     loc_016740(pc,d1)
        move.b  $002C(A0), D0
        add.b   objoff_36(a0), D0
        beq     loc_01716C
        rts
loc_016740:
        dc.w    loc_01674A-loc_016740
        dc.w    loc_01675E-loc_016740
loc_016744:        
        dc.w    $00A0, $0100, $0120
loc_01674A:
        addq.b  #2,routine(a0)
        move.b  subtype(A0), D0
        add.w   d0, d0
        andi.w  #$006, d0
        move.w  loc_016744(pc,d0), $002A(a0)
loc_01675E:
        lea     (MainCharacter).w, A1
        lea     $002C(A0), A4
        bsr.s   loc_016770
        lea     (Sidekick).w, A1
        lea     objoff_36(a0), A4
loc_016770:
        moveq	#0,d0
        move.b  (A4), D0
        move.w  loc_01677C(pc,d0), D0
        jmp     loc_01677C(pc,d0)
loc_01677C:
        dc.w    loc_016784-loc_01677C
        dc.w    loc_016898-loc_01677C
        dc.w    loc_01697C-loc_01677C
        dc.w    loc_0169E8-loc_01677C
loc_016784:
        tst.w   (Debug_placement_mode).w
        bne     loc_016896
        move.w  $002A(A0), D2
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        cmp.w   d2, d0
        bcc     loc_016896
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        cmpi.w  #$080, d1
        bcc     loc_016896
        moveq   #0, d3
        cmpi.w  #$0A0, D2
        beq.s   loc_0167C6
        moveq   #8, d3
        cmpi.w  #$120, D2
        beq.s   loc_0167C6
        moveq   #4, d3
        neg.w   D0
        addi.w  #$100, d0
loc_0167C6:
        cmpi.w  #$080, d0
        bcs.s   loc_0167FC
        moveq   #0, D2
        move.b  subtype(A0), D0
        lsr.w   #$2, d0
        andi.w  #$F, d0
        move.b  loc_0167EC(pc,d0), D2
        cmpi.b  #$2, D2
loc_0167E0:
        bne.s   loc_016806
        move.b  ($FFFFFE04).w, D2
        andi.b  #1, D2
        bra.s   loc_016806
loc_0167EC:
        dc.b    $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $00, $02, $00, $01, $02, $01
loc_0167FC:
        moveq   #$2, D2
        cmpi.w  #$40, d1
        bcc.s   loc_016806
        moveq   #3, D2
loc_016806:
        move.b  D2, render_flags(a4)
        add.w   d3, D2
        add.w   D2, D2
        andi.w  #$01E, D2
        lea     loc_016AFE(PC), A2
        adda.w  $00(A2, D2), A2
        move.w  (A2)+, mappings(a4)
        subq.w  #4, mappings(a4)
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        move.w  d5, y_pos(a1)
        move.l  A2, $0006(a4)
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
loc_016840:
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        addq.b  #$2, (a4)
        move.b  #$81, $002A(a1)
        move.b  #$2, $001C(a1)
        move.w  #$800, $14(a1)
        move.w  #0,x_vel(a1)
loc_016860:
        move.w  #0, $0012(a1)
        bclr    #5, status(a0)
        bclr    #5, status(a1)
        bset    #1, status(a1)
        move.b  #0, $003C(a1)
        bclr    #$7, art_tile(a1)
        move.w  #$800, D2
        bsr     loc_016A80
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_016896:
        rts
loc_016898:
        subq.b  #1, art_tile(a4)
        bpl.s   loc_0168DC
        move.l  $0006(A4), A2
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        move.w  d5, y_pos(a1)
        tst.b   render_flags(a4)
        bpl.s   loc_0168BE
        subq.w  #8, a2
loc_0168BE:
        move.l  A2, $0006(a4)
        subq.w  #4, mappings(a4)
        beq.s   loc_016902
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        move.w  #$800, D2
        bra     loc_016A80
loc_0168DC:
        move.l  x_pos(A1), D2
        move.l  y_pos(A1), D3
        move.w x_vel(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a1)
        move.l  d3, y_pos(a1)
        rts
loc_016902:
        cmpi.b  #4, render_flags(a4)
        bcc.s   loc_016924
        move.b  subtype(A0), D0
        andi.w  #$0FC, d0
        add.b   render_flags(A4), D0
        move.b  #4, render_flags(a4)
        move.b  loc_01693C(pc,d0), D0
        bne     loc_016A10
loc_016924:
        andi.w  #$7FF, y_pos(a1)
        move.b  #6, (a4)
        clr.b   $002A(a1)
        move.w  #$0BC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_01693C:
        dc.b    $02, $01, $00, $00, $FF, $03, $00, $00, $04, $FE, $00, $00, $FD, $FC, $00, $00
        dc.b    $FB, $FB, $00, $00, $07, $06, $00, $00, $F9, $FA, $00, $00, $08, $09, $00, $00
        dc.b    $F8, $F7, $00, $00, $0B, $0A, $00, $00, $0C, $00, $00, $00, $F5, $F6, $00, $00
        dc.b    $F4, $00, $00, $00, $00, $0D, $00, $00, $F3, $0E, $00, $00, $00, $F2, $00, $00
loc_01697C:
        subq.b  #1, art_tile(a4)
        bpl.s   loc_0169B0
        move.l  $0006(A4), A2
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
        tst.b   render_flags(a4)
        bpl.s   loc_01699A
        subq.w  #8, a2
loc_01699A:
        move.l  A2, $0006(a4)
        subq.w  #4, mappings(a4)
        beq.s   loc_0169D6
        move.w  (A2)+, D4
        move.w  (A2)+, D5
        move.w  #$800, D2
        bra     loc_016A80
loc_0169B0:
        move.l  x_pos(A1), D2
        move.l  y_pos(A1), D3
        move.w x_vel(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a1)
        move.l  d3, y_pos(a1)
        rts
loc_0169D6:
        andi.w  #$7FF, y_pos(a1)
        clr.b   (a4)
        move.w  #$0BC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_0169E8:
        move.w  $002A(A0), D2
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        cmp.w   d2, d0
        bcc     loc_016A0C
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        cmpi.w  #$080, d1
        bcc     loc_016A0C
        rts
loc_016A0C:
        clr.b   (a4)
        rts
loc_016A10:
        bpl.s   loc_016A42
        neg.b   D0
        move.b  #$FC, render_flags(a4)
        add.w   d0, d0
        lea     (loc_017006), A2
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D0
        subq.w  #4, d0
        move.w  d0, mappings(a4)
        lea     $00(A2, d0), A2
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
        subq.w  #8, a2
        bra.s   loc_016A62
loc_016A42:
        add.w   d0, d0
        lea     (loc_017006), A2
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, mappings(a4)
        subq.w  #4, mappings(a4)
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
loc_016A62:
        move.l  A2, $0006(a4)
        move.w  (A2)+, D4
        move.w  (A2)+, D5
        move.w  #$800, D2
        bsr     loc_016A80
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #$2, (a4)
        rts
loc_016A80:
        moveq	#0,d0
        move.w  D2, d3
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        bge.s   loc_016A90
        neg.w   D0
        neg.w   D2
loc_016A90:
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        bge.s   loc_016A9E
        neg.w   d1
        neg.w   D3
loc_016A9E:
        cmp.w   d0, d1
        bcs.s   loc_016AD0
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        swap.w  d1
        divs.w  d3, d1
        moveq	#0,d0
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        beq.s   loc_016ABC
        swap.w  D0
        divs.w  d1, d0
loc_016ABC:
        move.w  d0,x_vel(a1)
        move.w  d3, $0012(a1)
        tst.w   d1
        bpl.s   loc_016ACA
        neg.w   d1
loc_016ACA:
        move.w  d1, art_tile(a4)
        rts
loc_016AD0:
        moveq	#0,d0
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        swap.w  D0
        divs.w  d2, d0
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        beq.s   loc_016AEA
        swap.w  d1
        divs.w  d0, d1
loc_016AEA:
        move.w  d1, $0012(a1)
        move.w  D2,x_vel(a1)
        tst.w   D0
        bpl.s   loc_016AF8
        neg.w   D0
loc_016AF8:
        move.w  d0, art_tile(a4)
        rts
loc_016AFE:              
        dc.w    loc_016B16-loc_016AFE
        dc.w    loc_016B8C-loc_016AFE
        dc.w    loc_016BEA-loc_016AFE
        dc.w    loc_016C60-loc_016AFE
        dc.w    loc_016CBE-loc_016AFE
        dc.w    loc_016D30-loc_016AFE
        dc.w    loc_016D8E-loc_016AFE
        dc.w    loc_016E00-loc_016AFE
        dc.w    loc_016E5E-loc_016AFE
        dc.w    loc_016ED4-loc_016AFE
        dc.w    loc_016F32-loc_016AFE
        dc.w    loc_016FA8-loc_016AFE
loc_016B16:
        dc.w    $0074
        dc.w    $0090, $0010, $0090, $0070, $0040, $0070, $0035, $006F
        dc.w    $0028, $006A, $001E, $0062, $0015, $0058, $0011, $004A
        dc.w    $0010, $0040, $0011, $0035, $0015, $0027, $001E, $001E
        dc.w    $0028, $0015, $0035, $0011, $0040, $0010, $0050, $0010
        dc.w    $005E, $0012, $0068, $0018, $006D, $0024, $0070, $0030
        dc.w    $006D, $003D, $0068, $0048, $005E, $004E, $0050, $0050
        dc.w    $0030, $0050, $0022, $0052, $0017, $005A, $0011, $0063
        dc.w    $0010, $0070 
loc_016B8C:
        dc.w    $005C
        dc.w    $0090, $0010, $0090, $0070, $0040, $0070, $002E, $006E
        dc.w    $001D, $0062, $0013, $0053, $0010, $0040, $0013, $002D
        dc.w    $001D, $001E, $002E, $0013, $0040, $0010, $0058, $0010
        dc.w    $0064, $14, $006C, $001A, $0070, $0028, $006C, $0036
        dc.w    $0064, $003C, $0058, $0040, $004B, $003D, $0040, $0038
        dc.w    $0036, $0032, $0028, $0030, $0010, $0030
loc_016BEA:
        dc.w    $0074
        dc.w    $0010, $0070, $0011, $0063, $0017, $005A, $0022, $0052
        dc.w    $0030, $0050, $0050, $0050, $005E, $004E, $0068, $0048
        dc.w    $006D, $003D, $0070, $0030, $006D, $0024, $0068, $0018
        dc.w    $005E, $0012, $0050, $0010, $0040, $0010, $0035, $0011
        dc.w    $0028, $0015, $001E, $001E, $0015, $0027, $0011, $0035
        dc.w    $0010, $0040, $0011, $004A, $0015, $0058, $001E, $0062
        dc.w    $0028, $006A, $0035, $006F, $0040, $0070, $0090, $0070
        dc.w    $0090, $0010
loc_016C60:
        dc.w    $005C
        dc.w    $0010, $0030, $0028, $0030, $0036, $0032, $0040, $0038
        dc.w    $004B, $003D, $0058, $0040, $0064, $003C, $006C, $0036
        dc.w    $0070, $0028, $006C, $001A, $0064, $14, $0058, $0010
        dc.w    $0040, $0010, $002E, $0013, $001D, $001E, $0013, $002D
        dc.w    $0010, $0040, $0013, $0053, $001D, $0062, $002E, $006E
        dc.w    $0040, $0070, $0090, $0070, $0090, $0010
loc_016CBE:
        dc.w    $0070
        dc.w    $0010, $0010, $0010, $0070, $00C0, $0070, $00CA, $006F
        dc.w    $00D4, $006C, $00DB, $0068, $00E3, $0062, $00E8, $005A
        dc.w    $00ED, $0052, $00EF, $0048, $00F0, $0040, $00EF, $0036
        dc.w    $00ED, $002E, $00E8, $0026, $00E3, $001E, $00DB, $0017
        dc.w    $00D4, $14, $00CA, $0012, $00C0, $0010, $00B7, $0011
        dc.w    $00AF, $0012, $00A6, $0017, $009E, $001E, $0097, $0026
        dc.w    $0093, $002E, $0091, $0036, $0090, $0040, $0090, $0070          
loc_016D30:
        dc.w    $005C
        dc.w    $0010, $0010, $0010, $0070, $00C0, $0070, $00D2, $006E
        dc.w    $00E3, $0062, $00ED, $0053, $00F0, $0040, $00ED, $002D
        dc.w    $00E3, $001E, $00D2, $0013, $00C0, $0010, $00A8, $0010
        dc.w    $009C, $14, $0094, $001A, $0090, $0028, $0094, $0036
        dc.w    $009C, $003C, $00A8, $0040, $00B5, $003D, $00C0, $0038
        dc.w    $00CA, $0032, $00D8, $0030, $00F0, $0030
loc_016D8E:
        dc.w    $0070
        dc.w    $0090, $0070, $0090, $0040, $0091, $0036, $0093, $002E
        dc.w    $0097, $0026, $009E, $001E, $00A6, $0017, $00AF, $0012
        dc.w    $00B7, $0011, $00C0, $0010, $00CA, $0012, $00D4, $14
        dc.w    $00DB, $0017, $00E3, $001E, $00E8, $0026, $00ED, $002E
        dc.w    $00EF, $0036, $00F0, $0040, $00EF, $0048, $00ED, $0052
        dc.w    $00E8, $005A, $00E3, $0062, $00DB, $0068, $00D4, $006C
        dc.w    $00CA, $006F, $00C0, $0070, $0010, $0070, $0010, $0010        
loc_016E00:
        dc.w    $005C
        dc.w    $00F0, $0030, $00D8, $0030, $00CA, $0032, $00C0, $0038
        dc.w    $00B5, $003D, $00A8, $0040, $009C, $003C, $0094, $0036
        dc.w    $0090, $0028, $0094, $001A, $009C, $14, $00A8, $0010
        dc.w    $00C0, $0010, $00D2, $0013, $00E3, $001E, $00ED, $002D
        dc.w    $00F0, $0040, $00ED, $0053, $00E3, $0062, $00D2, $006E
        dc.w    $00C0, $0070, $0010, $0070, $0010, $0010
loc_016E5E:
        dc.w    $0074
        dc.w    $0110, $0010, $0110, $0070, $0040, $0070, $0035, $006F
        dc.w    $0028, $006A, $001E, $0062, $0015, $0058, $0011, $004A
        dc.w    $0010, $0040, $0011, $0035, $0015, $0027, $001E, $001E
        dc.w    $0028, $0015, $0035, $0011, $0040, $0010, $0050, $0010
        dc.w    $005E, $0012, $0068, $0018, $006D, $0024, $0070, $0030
        dc.w    $006D, $003D, $0068, $0048, $005E, $004E, $0050, $0050
        dc.w    $0030, $0050, $0022, $0052, $0017, $005A, $0011, $0063
        dc.w    $0010, $0070
loc_016ED4:
        dc.w    $005C
        dc.w    $0110, $0010, $0110, $0070, $0040, $0070, $002E, $006E
        dc.w    $001D, $0062, $0013, $0053, $0010, $0040, $0013, $002D
        dc.w    $001D, $001E, $002E, $0013, $0040, $0010, $0058, $0010
        dc.w    $0064, $14, $006C, $001A, $0070, $0028, $006C, $0036
        dc.w    $0064, $003C, $0058, $0040, $004B, $003D, $0040, $0038
        dc.w    $0036, $0032, $0028, $0030, $0010, $0030
loc_016F32:
        dc.w    $0074
        dc.w    $0010, $0070, $0011, $0063, $0017, $005A, $0022, $0052
        dc.w    $0030, $0050, $0050, $0050, $005E, $004E, $0068, $0048
        dc.w    $006D, $003D, $0070, $0030, $006D, $0024, $0068, $0018
        dc.w    $005E, $0012, $0050, $0010, $0040, $0010, $0035, $0011
        dc.w    $0028, $0015, $001E, $001E, $0015, $0027, $0011, $0035
        dc.w    $0010, $0040, $0011, $004A, $0015, $0058, $001E, $0062
        dc.w    $0028, $006A, $0035, $006F, $0040, $0070, $0110, $0070
        dc.w    $0110, $0010
loc_016FA8:
        dc.w    $005C
        dc.w    $0010, $0030, $0028, $0030, $0036, $0032, $0040, $0038
        dc.w    $004B, $003D, $0058, $0040, $0064, $003C, $006C, $0036
        dc.w    $0070, $0028, $006C, $001A, $0064, $14, $0058, $0010
        dc.w    $0040, $0010, $002E, $0013, $001D, $001E, $0013, $002D
        dc.w    $0010, $0040, $0013, $0053, $001D, $0062, $002E, $006E
        dc.w    $0040, $0070, $0110, $0070, $0110, $0010
loc_017006:
        dc.w    loc_017024-loc_017006
        dc.w    loc_017024-loc_017006
        dc.w    loc_01703A-loc_017006
        dc.w    loc_017064-loc_017006
        dc.w    loc_01707A-loc_017006
        dc.w    loc_017090-loc_017006
        dc.w    loc_0170A6-loc_017006
        dc.w    loc_0170B8-loc_017006
        dc.w    loc_0170D2-loc_017006
        dc.w    loc_0170EC-loc_017006
        dc.w    loc_0170FE-loc_017006
        dc.w    loc_017110-loc_017006
        dc.w    loc_01712A-loc_017006
        dc.w    loc_017140-loc_017006
        dc.w    loc_01714E-loc_017006
loc_017024:
        dc.w    $14
        dc.w    $0790, $03B0, $0710, $03B0, $0710, $06B0, $0A90, $06B0
        dc.w    $0A90, $0670
loc_01703A:
        dc.w    $0028
        dc.w    $0790, $03F0, $0790, $04B0, $0A00, $04B0, $0C10, $04B0
        dc.w    $0C10, $0330, $0D90, $0330, $0D90, $01B0, $0F10, $01B0
        dc.w    $0F10, $02B0, $0F90, $02B0
loc_017064:
        dc.w    $14
        dc.w    $0AF0, $0630, $0E90, $0630, $0E90, $06B0, $0F90, $06B0
        dc.w    $0F90, $0670
loc_01707A:
        dc.w    $14
        dc.w    $0F90, $02F0, $0F90, $04B0, $0F10, $04B0, $0F10, $0630
        dc.w    $0F90, $0630
loc_017090:
        dc.w    $14
        dc.w    $1410, $0530, $1190, $0530, $1190, $06B0, $1410, $06B0
        dc.w    $1410, $0570
loc_0170A6:
        dc.w    $0010
        dc.w    $1AF0, $0530, $1B90, $0530, $1B90, $0330, $1E10, $0330
loc_0170B8:
        dc.w    $0018
        dc.w    $1A90, $0570, $1A90, $05B0, $1C10, $05B0, $1C10, $0430
        dc.w    $1E10, $0430, $1E10, $0370
loc_0170D2:
        dc.w    $0018
        dc.w    $2490, $0370, $2490, $03D0, $2390, $03D0, $2390, $05D0
        dc.w    $2510, $05D0, $2510, $0570
loc_0170EC:
        dc.w    $0010
        dc.w    $24F0, $0330, $2590, $0330, $2590, $0530, $2570, $0530
loc_0170FE:
        dc.w    $0010
        dc.w    $0310, $0330, $0290, $0330, $0290, $0230, $0490, $0230
loc_017110:
        dc.w    $0018
        dc.w    $0310, $0370, $0310, $03B0, $0410, $03B0, $0410, $02B0
        dc.w    $0490, $02B0, $0490, $0270
loc_01712A:
        dc.w    $14
        dc.w    $0490, $06F0, $0490, $0730, $0690, $0730, $0890, $0730
        dc.w    $0890, $06F0
loc_017140:
        dc.w    $000C
        dc.w    $0BF0, $0330, $0D90, $0330, $0D90, $02F0
loc_01714E:
        dc.w    $001C
        dc.w    $0D90, $02B0, $0C90, $02B0, $0C90, $00B0, $0E80, $00B0
        dc.w    $1110, $00B0, $1110, $0230, $10F0, $0230 
;=============================================================================== 
; Object 0x1E - Chemical Plant - Tube Attributes
                
;===============================================================================           
loc_01716C:
        jmp     (loc_00D30C) 
        dc.w    $0000           ; Filler  
        
;=============================================================================== 
; Object 0x20 - Fireball - Hill Top 
                 
;===============================================================================  
Obj20_Fireball: ; loc_017174:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_017182(pc,d0), d1
        jmp     loc_017182(pc,d1)
loc_017182:
        dc.w    loc_017190-loc_017182
        dc.w    loc_0171F2-loc_017182
        dc.w    loc_017200-loc_017182
        dc.w    loc_01729A-loc_017182
        dc.w    loc_0172C0-loc_017182
        dc.w    loc_01734E-loc_017182
        dc.w    loc_0173AE-loc_017182
loc_017190:
        addq.b  #2,routine(a0)
        move.b  #8, y_radius(a0)
        move.b  #8, $0017(a0)
        move.l  #Fireball_Mappings,mappings(a0) ; loc_0173D0
        move.w  #$8416,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_04 ; loc_017470
        ori.b   #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #8,width_pixels(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsl.w   #3, d0
        andi.w  #$780, d0
        neg.w   D0
        move.w  d0,x_vel(a0)
        move.w  d0, $0012(a0)
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        lsl.w   #4, d0
        move.w  d0, $0032(a0)
        move.w  d0, Objoff_34(a0)
loc_0171F2:
        lea     (loc_0173B2), A1
        bsr     J_AnimateSprite_00      ; loc_01746A
        bra     J_MarkObjGone_03        ; loc_01745E
loc_017200:
        cmpi.b  #5, $001E(a0)
        bne.s   loc_017230
        bsr     J_S1SingleObjectLoad_00 ; loc_017464
        bne.s   loc_017222
        bsr.s   loc_01723E
        bsr     J_S1SingleObjectLoad_00 ; loc_017464
        bne.s   loc_017222
        bsr.s   loc_01723E
        neg.w  x_vel(a1)
        bset    #0, render_flags(a1)
loc_017222:
        move.w  #$0AE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        addq.b  #2,routine(a0)
loc_017230:
        lea     (loc_0173B2), A1
        bsr     J_AnimateSprite_00      ; loc_01746A
        bra     J_MarkObjGone_03        ; loc_01745E
loc_01723E:
        move.b  #$20, 0(a1)
        move.b  #8, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w x_vel(A0),x_vel(a1)
        move.w  $0012(A0), $0012(a1)
        move.b  #8, y_radius(a1)
        move.b  #8, $0017(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #8, $0019(a1)
        move.b  #$8B, $0020(a1)
        move.w  y_pos(A1), Objoff_30(a1)
        rts
loc_01729A:
        subq.w  #1, $0032(a0)
        bpl.s   loc_0172B2
        move.w  Objoff_34(A0), $0032(a0)
        move.b  #2,routine(a0)
        move.w  #$001, $001C(a0)
loc_0172B2:
        lea     (loc_0173B2), A1
        bsr     J_AnimateSprite_00      ; loc_01746A
        bra     J_MarkObjGone_03        ; loc_01745E
loc_0172C0:
        subq.b  #1, $001E(a0)
        bpl.s   loc_0172D6
        move.b  #$7, $001E(a0)
        addq.b  #1, $001A(a0)
        andi.b  #1, $001A(a0)
loc_0172D6:
        bsr     J_SpeedToPos_03         ; loc_017476
        addi.w  #$018, $0012(a0)
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_0172F2
        bra     J_DeleteObject_0D       ; loc_017458
loc_0172F2:
        bclr    #1,render_flags(a0)
        tst.w   $0012(a0)
        bmi.s   loc_01734A
        bset    #1,render_flags(a0)
        bsr     ObjHitFloor             ; loc_013898
        tst.w   d1
        bpl.s   loc_01734A
        add.w   d1, y_pos(a0)
        addq.b  #2,routine(a0)
        move.b  #$2, $001C(a0)
        move.b  #4, $001A(a0)
        move.w  #0, $0012(a0)
        move.l  #$0017410,mappings(a0)
        move.w  #$839E,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_04 ; loc_017470
        move.b  #0, $001A(a0)
        move.w  #$009, $0032(a0)
        move.b  #3, objoff_36(a0)
loc_01734A:
        bra     J_MarkObjGone_03        ; loc_01745E
loc_01734E:
        subq.w  #1, $0032(a0)
        bpl.s   loc_0173A0
        move.w  #$07F, $0032(a0)
        subq.b  #1, objoff_36(a0)
        bmi.s   loc_0173A0
        bsr     J_S1SingleObjectLoad_00 ; loc_017464
        bne.s   loc_0173A0
        moveq	#0,d0
        move.w  #$F, d1
loc_01736C:        
        move.l  $00(A0, d0), $00(A1, d0)
        addq.w  #4, d0
        dbra    d1, loc_01736C
        move.w  #$009, $0032(a1)
        move.w  #$200, $001C(a1)
        move.w  #$00E, d0
        tst.w  x_vel(a1)
        bpl.s   loc_017390
        neg.w   D0
loc_017390:
        add.w   d0, x_pos(a1)
        move.l  A1, -(A7)
        bsr     loc_0138CE
        move.l  (A7)+, A1
        add.w   d1, y_pos(a1)
loc_0173A0:
        lea     (loc_0173B2), A1
        bsr     J_AnimateSprite_00      ; loc_01746A
        bra     J_MarkObjGone_03        ; loc_01745E
loc_0173AE:
        bra     J_DeleteObject_0D       ; loc_017458
loc_0173B2:
        dc.w    loc_0173B8-loc_0173B2
        dc.w    loc_0173BF-loc_0173B2
        dc.w    loc_0173C2-loc_0173B2
loc_0173B8:
        dc.b    $0B, $02, $03, $FC, $04, $FD, $01
loc_0173BF:
        dc.b    $7F, $05, $FF
loc_0173C2:
        dc.b    $05, $04, $05, $02, $03, $00, $01, $00, $01, $02, $03, $04, $05, $FC
Fireball_Mappings:        
loc_0173D0:
        dc.w    loc_0173DC-loc_0173D0
        dc.w    loc_0173E6-loc_0173D0
        dc.w    loc_0173F0-loc_0173D0
        dc.w    loc_0173FA-loc_0173D0
        dc.w    loc_017404-loc_0173D0
        dc.w    loc_01740E-loc_0173D0
loc_0173DC:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_0173E6:
        dc.w    $0001
        dc.l    $F8050004, $0002FFF8
loc_0173F0:
        dc.w    $0001
        dc.l    $F9050008, $0004FFF8
loc_0173FA:
        dc.w    $0001
        dc.l    $F6050008, $0004FFF8
loc_017404:
        dc.w    $0001
        dc.l    $F605000C, $0006FFF8
loc_01740E:
        dc.w    $0000
loc_017410_B:
        dc.w    loc_01741C-loc_017410_B
        dc.w    loc_017426-loc_017410_B
        dc.w    loc_017430-loc_017410_B
        dc.w    loc_01743A-loc_017410_B
        dc.w    loc_017444-loc_017410_B
        dc.w    loc_01744E-loc_017410_B
loc_01741C:
        dc.w    $0001
        dc.l    $F0070000, $0000FFF8
loc_017426:
        dc.w    $0001
        dc.l    $F0070800, $0800FFF8
loc_017430:
        dc.w    $0001
        dc.l    $F0070008, $0004FFF8
loc_01743A:
        dc.w    $0001
        dc.l    $F0070808, $0804FFF8
loc_017444:
        dc.w    $0001
        dc.l    $00050010, $0008FFF8
loc_01744E:
        dc.w    $0001
        dc.l    $00050810, $0808FFF8    
J_DeleteObject_0D: ; loc_017458:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_03: ; loc_01745E:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_00: ; loc_017464:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_AnimateSprite_00: ; loc_01746A:
        jmp     AnimateSprite           ; (loc_00D412)
J_ModifySpriteAttr_2P_04: ; loc_017470:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SpeedToPos_03: ; loc_017476:
        jmp     SpeedToPos              ; (loc_00D27A)        
;=============================================================================== 
; Object 0x20 - Fireball - Hill Top 
                
;=============================================================================== 
;=============================================================================== 
; Object 0x2F - Hill Top - Breakable Floor
                 
;=============================================================================== 
Obj2F_Breakable_Floor: ; loc_01747C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01748A(pc,d0), d1
        jmp     loc_01748A(pc,d1)
loc_01748A:
        dc.w    loc_01749A-loc_01748A
        dc.w    loc_0174D8-loc_01748A
        dc.w    loc_01764C-loc_01748A
loc_017490:
        dc.b    $24, $00, $20, $02, $18, $04, $10, $06, $08, $08
loc_01749A:
        addq.b  #2,routine(a0)
        move.l  #Breakable_Floor_Mappings,mappings(a0) ; loc_01786A
        move.w  #$C000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_05 ; loc_017A34
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$01E, d0
        lea     loc_017490(pc,d0), A2
        move.b  (A2)+, y_radius(a0)
        move.b  (A2)+, $001A(a0)
loc_0174D8:
        move.w  ($FFFFF7D0).w, objoff_38(a0)
        move.b  ($FFFFB01C).w, $0032(a0)
        move.b  ($FFFFB05C).w, $0033(a0)
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_00        ; loc_017A40
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_017514
loc_017510:        
        bra     J_MarkObjGone_04        ; loc_017A2E
loc_017514:
        cmpi.b  #$18, d0
        bne.s   loc_017578
        cmpi.b  #$2, $0032(a0)
        bne.s   loc_017530
        tst.b   subtype(a0)
        bmi.s   loc_017560
        cmpi.b  #$E, ($FFFFB03E).w
        beq.s   loc_017560
loc_017530:
        move.b  #$C, ($FFFFB03E).w
        move.b  #$D, ($FFFFB03F).w
        cmpi.b  #$2, $0033(a0)
        bne.s   loc_017552
        tst.b   subtype(a0)
        bmi.s   loc_017560
        cmpi.b  #$E, ($FFFFB07E).w
        beq.s   loc_017560
loc_017552:
        move.b  #$C, ($FFFFB07E).w
        move.b  #$D, ($FFFFB07F).w
        bra.s   loc_017510
loc_017560:
        lea     (MainCharacter).w, A1
        move.b  $0032(A0), D0
        bsr.s   loc_0175AE
        lea     (Sidekick).w, A1
        move.b  $0033(A0), D0
        bsr.s   loc_0175AE
        bra     loc_017614
loc_017578:
        move.b  d0, d1
        andi.b  #8, d1
        beq.s   loc_0175E0
        cmpi.b  #$2, $0032(a0)
        bne.s   loc_017596
        tst.b   subtype(a0)
        bmi.s   loc_0175A6
        cmpi.b  #$E, ($FFFFB03E).w
        beq.s   loc_0175A6
loc_017596:
        move.b  #$C, ($FFFFB03E).w
        move.b  #$D, ($FFFFB03F).w
        bra     loc_017510
loc_0175A6:
        lea     (MainCharacter).w, A1
        bsr.s   loc_0175B4
        bra.s   loc_017614
loc_0175AE:
        cmpi.b  #$2, d0
        bne.s   loc_0175CC
loc_0175B4:
        bset    #$2, status(a1)
        move.b  #$E, y_radius(a1)
        move.b  #$7, $0017(a1)
        move.b  #$2, $001C(a1)
loc_0175CC:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        rts
loc_0175E0:
        andi.b  #$10, d0
        beq     loc_017510
        cmpi.b  #$2, $0033(a0)
        bne.s   loc_0175FE
        tst.b   subtype(a0)
        bmi.s   loc_01760E
        cmpi.b  #$E, ($FFFFB07E).w
        beq.s   loc_01760E
loc_0175FE:
        move.b  #$C, ($FFFFB07E).w
        move.b  #$D, ($FFFFB07F).w
        bra     loc_017510
loc_01760E:
        lea     (Sidekick).w, A1
        bsr.s   loc_0175B4
loc_017614:
        move.w  objoff_38(A0), ($FFFFF7D0).w
        andi.b  #$E7, status(a0)
        lea     (loc_017662), A4
        moveq	#0,d0
        move.b  $001A(A0), D0
        addq.b  #1, $001A(a0)
        move.l  d0, d1
        add.w   d0, d0
        add.w   d0, d0
        lea     $00(A4, d0), A4
        neg.w   d1
        addi.w  #$009, d1
        move.w  #$018, D2
        bsr     loc_017A3A
        bsr     loc_017818
loc_01764C:
        bsr     J_SpeedToPos_04         ; loc_017A46
        addi.w  #$018, $0012(a0)
        tst.b   render_flags(a0)
        bpl     J_DeleteObject_0E       ; loc_017A22
        bra     J_DisplaySprite_02      ; loc_017A1C  
loc_017662:
        dc.w    $FF00, $F800, $0100, $F800, $FF20, $F900, $00E0, $F900
        dc.w    $FF40, $FA00, $00C0, $FA00, $FF60, $FB00, $00A0, $FB00
        dc.w    $FF80, $FC00, $0080, $FC00  
;=============================================================================== 
; Object 0x2F - Hill Top - Breakable Floor
                
;===============================================================================  
;=============================================================================== 
; Object 0x32 - Rock - Hill Top / Tunel Obstacule - Chemical Plant
                 
;=============================================================================== 
Obj32_Breakable_Obstacule: ; loc_01768A:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_017698(pc,d0), d1
        jmp     loc_017698(pc,d1)
loc_017698:
        dc.w    loc_01769E-loc_017698
        dc.w    loc_0176F2-loc_017698
        dc.w    loc_0177DA-loc_017698
loc_01769E:
        addq.b  #2,routine(a0)
        move.l  #Rock_Mappings,mappings(a0) ; loc_0179C2
        move.w  #$43B2,art_tile(a0)
        move.b  #$18,width_pixels(a0)
        move.l  #loc_0177F0, Objoff_3C(a0)
        cmpi.b  #$D, (Current_ZoneAndAct).w
        bne.s   loc_0176E2
        move.l  #Tunel_Obstacule_Mappings,mappings(a0) ; loc_0179F6
        move.w  #$6430,art_tile(a0)
        move.b  #$10,width_pixels(a0)
        move.l  #loc_017808, Objoff_3C(a0)
loc_0176E2:
        bsr     J_ModifySpriteAttr_2P_05 ; loc_017A34
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
loc_0176F2:
        move.w  ($FFFFF7D0).w, objoff_38(a0)
        move.b  ($FFFFB01C).w, $0032(a0)
        move.b  ($FFFFB05C).w, $0033(a0)
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_00        ; loc_017A40
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_01772C
loc_017728:        
        bra     J_MarkObjGone_04        ; loc_017A2E
loc_01772C:
        cmpi.b  #$18, d0
        bne.s   loc_01775A
        cmpi.b  #$2, $0032(a0)
        beq.s   loc_017742
        cmpi.b  #$2, $0033(a0)
        bne.s   loc_017728
loc_017742:
        lea     (MainCharacter).w, A1
        move.b  $0032(A0), D0
        bsr.s   loc_017772
        lea     (Sidekick).w, A1
        move.b  $0033(A0), D0
        bsr.s   loc_017772
        bra     loc_0177C2
loc_01775A:
        move.b  d0, d1
        andi.b  #8, d1
        beq.s   loc_0177AA
        cmpi.b  #$2, $0032(a0)
        bne.s   loc_017728
        lea     (MainCharacter).w, A1
        bsr.s   loc_017778
        bra.s   loc_0177C2
loc_017772:
        cmpi.b  #$2, d0
        bne.s   loc_017796
loc_017778:
        bset    #$2, status(a1)
        move.b  #$E, y_radius(a1)
        move.b  #$7, $0017(a1)
        move.b  #$2, $001C(a1)
        move.w  #$FD00, $0012(a1)
loc_017796:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        rts
loc_0177AA:
        andi.b  #$10, d0
        beq     loc_017728
        cmpi.b  #$2, $0033(a0)
        bne     loc_017728
        lea     (Sidekick).w, A1
        bsr.s   loc_017778
loc_0177C2:
        move.w  objoff_38(A0), ($FFFFF7D0).w
        andi.b  #$E7, status(a0)
        move.l  Objoff_3C(a0), A4
        bsr     loc_017A3A
        bsr     loc_017818
loc_0177DA:
        bsr     J_SpeedToPos_04         ; loc_017A46
        addi.w  #$018, $0012(a0)
        tst.b   render_flags(a0)
        bpl     J_DeleteObject_0E       ; loc_017A22
        bra     J_DisplaySprite_02      ; loc_017A1C
loc_0177F0:
        dc.w    $FE00, $FE00, $0000, $FD80, $0200, $FE00, $FE40, $FE40
        dc.w    $0000, $FE00, $01C0, $FE40
loc_017808:
        dc.w    $FF00, $FE00, $0100, $FE00, $FF40, $FE40, $00C0, $FE40        
;=============================================================================== 
; Object 0x32 - Rock - Hill Top / Tunel Obstacule - Chemical Plant
                
;===============================================================================              
loc_017818:
        bsr     J_SingleObjectLoad_00   ; loc_017A28
        bne.s   loc_017860
        move.b  #$29, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  ($FFFFF7D0).w, D2
        addq.w  #$2, ($FFFFF7D0).w
        cmpi.w  #$006, D2
        bcs.s   loc_017840
        moveq   #6, D2
loc_017840:
        moveq	#0,d0
        move.w  loc_017862(PC, D2), D0
        cmpi.w  #$20, ($FFFFF7D0).w
        bcs.s   loc_017854
        move.w  #$3E8, d0
        moveq   #$A, D2
loc_017854:
        jsr     AddPoints               ; (loc_022FD0)
        lsr.w   #1, D2
        move.b  D2, $001A(a1)
loc_017860:
        rts
loc_017862:
        dc.w    $000A, $14, $0032, $0064
Breakable_Floor_Mappings:        
loc_01786A:
        dc.w    loc_01787E-loc_01786A
        dc.w    loc_0178C8-loc_01786A
        dc.w    loc_01791A-loc_01786A
        dc.w    loc_01791A-loc_01786A
        dc.w    loc_01795C-loc_01786A
        dc.w    loc_01795C-loc_01786A
        dc.w    loc_01798E-loc_01786A
        dc.w    loc_01798E-loc_01786A
        dc.w    loc_0179B0-loc_01786A
        dc.w    loc_0179B0-loc_01786A
loc_01787E:
        dc.w    $0009
        dc.l    $D80D0012, $0009FFF0, $E805004A, $0025FFF0
        dc.l    $E805004A, $00250000, $F805004E, $0027FFF0
        dc.l    $F805004E, $00270000, $08050052, $0029FFF0
        dc.l    $08050052, $00290000, $18050052, $0029FFF0
        dc.l    $18050052, $00290000
loc_0178C8:
        dc.w    $000A
        dc.l    $D8050012, $0009FFF0, $D8050016, $000B0000
        dc.l    $E805004A, $0025FFF0, $E805004A, $00250000
        dc.l    $F805004E, $0027FFF0, $F805004E, $00270000
        dc.l    $08050052, $0029FFF0, $08050052, $00290000
        dc.l    $18050052, $0029FFF0, $18050052, $00290000
loc_01791A:
        dc.w    $0008
        dc.l    $E005004A, $0025FFF0, $E005004A, $00250000
        dc.l    $F005004E, $0027FFF0, $F005004E, $00270000
        dc.l    $00050052, $0029FFF0, $00050052, $00290000
        dc.l    $10050052, $0029FFF0, $10050052, $00290000
loc_01795C:
        dc.w    $0006
        dc.l    $E805004E, $0027FFF0, $E805004E, $00270000
        dc.l    $F8050052, $0029FFF0, $F8050052, $00290000
        dc.l    $08050052, $0029FFF0, $08050052, $00290000
loc_01798E:
        dc.w    $0004
        dc.l    $F0050052, $0029FFF0, $F0050052, $00290000
        dc.l    $00050052, $0029FFF0, $00050052, $00290000
loc_0179B0:
        dc.w    $0002
        dc.l    $F8050052, $0029FFF0, $F8050052, $00290000 
Rock_Mappings:                      
loc_0179C2:
        dc.w    loc_0179C4-loc_0179C2
loc_0179C4:
        dc.w    $0006
        dc.l    $F0050000, $0000FFE8, $F0050004, $0002FFF8
        dc.l    $F0050008, $00040008, $0005000C, $0006FFE8
        dc.l    $00050010, $0008FFF8, $00050010, $00080008
Tunel_Obstacule_Mappings:          
loc_0179F6:
        dc.w    loc_0179F8-loc_0179F6
loc_0179F8:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF0, $F0050800, $08000000
        dc.l    $00050000, $0000FFF0, $00050800, $08000000
        nop                     ; Filler               
J_DisplaySprite_02: ; loc_017A1C:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_0E: ; loc_017A22:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_00: ; loc_017A28:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_MarkObjGone_04: ; loc_017A2E:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_05: ; loc_017A34:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_017A3A:
        jmp     (loc_00CE50)
J_SolidObject_00: ; loc_017A40:
        jmp     SolidObject             ; (loc_00F4A0)
J_SpeedToPos_04: ; loc_017A46:
        jmp     SpeedToPos              ; (loc_00D27A) 
        
;=============================================================================== 
; Object 0x30 - 
                 
;===============================================================================          
Obj30: ; loc_017A4C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_017A5A(pc,d0), d1
        jmp     loc_017A5A(pc,d1)
loc_017A5A:
        dc.w    loc_017A68-loc_017A5A
        dc.w    loc_017AB4-loc_017A5A
loc_017A5E:
        dc.w    $C000, $C000, $C000, $E000, $FF00
loc_017A68:
        addq.b  #2,routine(a0)
        move.w  y_pos(a0), $0032(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.b  loc_017A5E(pc,d0),width_pixels(a0)
        cmpi.b  #6, d0
        bcs.s   loc_017AB4
        bne.s   loc_017A96
        cmpi.w  #$380, ($FFFFEE04).w
        bcc.s   loc_017AB4
        bra.s   loc_017A9E
loc_017A96:
        cmpi.w  #$380, ($FFFFEE04).w
        bcs.s   loc_017AB4
loc_017A9E:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_017AB0
        bclr    #$7, $02(A2, d0)
loc_017AB0:
        bra     J_DeleteObject_0F       ; loc_017C80
loc_017AB4:
        move.w  $0032(A0), D0
        add.w   ($FFFFEEE4).w, d0
        move.w  d0, y_pos(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.w  loc_017AD8(pc,d0), d1
        jsr     loc_017AD8(pc,d1)
        tst.b   ($FFFFEEBC).w
        beq     loc_017C8C
        rts
loc_017AD8:
        dc.w    loc_017AE2-loc_017AD8
        dc.w    loc_017AE2-loc_017AD8
        dc.w    loc_017AFA-loc_017AD8
        dc.w    loc_017B40-loc_017AD8
        dc.w    loc_017B5A-loc_017AD8
loc_017AE2:
        move.w  #$0CB, d1
        move.w  #$080, D2
        move.w  #$081, d3
        move.w  x_pos(a0), D4
        bsr     loc_017C92
        bra     loc_00FBF4
loc_017AFA:
        move.w  #$0CB, d1
        move.w  #$078, D2
        move.w  #$079, d3
        move.w  x_pos(a0), D4
        bsr     loc_017C92
        bsr     loc_00FBF4
loc_017B12:               
        btst    #3, status(a0)
        beq.s   loc_017B28
        move.l  A0, -(A7)
        move.l  A0, A1
        lea     (MainCharacter).w, A0
        bsr     loc_017C86
        move.l  (A7)+, A0
loc_017B28:
        btst    #4, status(a0)
        beq.s   loc_017B3E
        move.l  A0, -(A7)
        move.l  A0, A1
        lea     (Sidekick).w, A0
        bsr     loc_017C86
        move.l  (A7)+, A0
loc_017B3E:
        rts
loc_017B40:
        move.w  #$0EB, d1
        move.w  #$078, D2
        move.w  #$079, d3
        move.w  x_pos(a0), D4
        bsr     loc_017C92
        bsr     loc_00FBF4
        bra.s   loc_017B12
loc_017B5A:
        move.w  #$10A, d1
        move.w  #$03E, D2
        move.w  x_pos(a0), D4
        lea     (loc_017B74), A2
        bsr     loc_017C98
        bra     loc_00FBF4     
loc_017B74:
        dc.b    $40, $40, $40, $40, $40, $40, $40, $40, $3F, $3F, $3E, $3E, $3D, $3D, $3C, $3C
        dc.b    $3B, $3B, $3A, $3A, $39, $39, $38, $38, $37, $37, $36, $36, $35, $35, $34, $34
        dc.b    $33, $33, $32, $32, $31, $31, $30, $30, $2F, $2F, $2E, $2E, $2D, $2D, $2C, $2C
        dc.b    $2B, $2B, $2A, $2A, $29, $29, $28, $28, $27, $27, $26, $26, $25, $25, $24, $24
        dc.b    $23, $23, $22, $22, $21, $21, $20, $20, $1F, $1F, $1E, $1E, $1D, $1D, $1C, $1C
        dc.b    $1B, $1B, $1A, $1A, $19, $19, $18, $18, $17, $17, $16, $16, $15, $15, $14, $14
        dc.b    $13, $13, $12, $12, $11, $11, $10, $10, $0F, $0F, $0E, $0E, $0D, $0D, $0C, $0C
        dc.b    $0B, $0B, $0A, $0A, $09, $09, $08, $08, $07, $07, $06, $06, $05, $05, $04, $04
        dc.b    $03, $03, $02, $02, $01, $01, $00, $00, $FF, $FF, $FE, $FE, $FD, $FD, $FC, $FC
        dc.b    $FB, $FB, $FA, $FA, $F9, $F9, $F8, $F8, $F7, $F7, $F6, $F6, $F5, $F5, $F4, $F4
        dc.b    $F3, $F3, $F2, $F2, $F1, $F1, $F0, $F0, $EF, $EF, $EE, $EE, $ED, $ED, $EC, $EC
        dc.b    $EB, $EB, $EA, $EA, $E9, $E9, $E8, $E8, $E7, $E7, $E6, $E6, $E5, $E5, $E4, $E4
        dc.b    $E3, $E3, $E2, $E2, $E1, $E1, $E0, $E0, $DF, $DF, $DE, $DE, $DD, $DD, $DC, $DC
        dc.b    $DB, $DB, $DA, $DA, $D9, $D9, $d8, $d8, $d7, $d7, $d6, $d6, $d5, $d5, $d4, $D4
        dc.b    $d3, $d3, $D2, $D2, $d1, $d1, $d0, $d0, $CF, $CF, $CE, $CE, $CD, $CD, $CC, $CC
        dc.b    $CB, $CB, $CA, $CA, $C9, $C9, $C8, $C8, $C7, $C7, $C6, $C6, $C5, $C5, $C4, $C4
        dc.b    $C3, $C3, $C2, $C2, $C1, $C1, $C0, $C0, $C0, $C0, $C0, $C0                 
;=============================================================================== 
; Object 0x30 - 
                
;===============================================================================  
J_DeleteObject_0F: ; loc_017C80:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_017C86:
        jmp     (loc_021370)
loc_017C8C:
        jmp     (loc_00D30C)
loc_017C92:
        jmp     (loc_00F4FA)
loc_017C98:
        jmp     (loc_00F54C)
        dc.w    $0000           ; Filler          
;=============================================================================== 
; Object 0x33 - Oil Ocean - Touch to Boost Up
                 
;===============================================================================          
Obj33_Touch_Booster: ; loc_017CA0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_017CAE(pc,d0), d1
        jmp     loc_017CAE(pc,d1)
loc_017CAE:
        dc.w    loc_017CB2-loc_017CAE
        dc.w    loc_017CF6-loc_017CAE
loc_017CB2:
        addq.b  #2,routine(a0)
        move.l  #Touch_Booster_Mappings,mappings(a0) ; loc_017EE2
        move.w  #$632C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_06 ; loc_017EFE
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$18,width_pixels(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        addq.b  #$2, $0025(a0)
        move.w  #$078, objoff_36(a0)
        tst.b   subtype(a0)
        beq.s   loc_017CF6
        move.b  #4, $0025(a0)
loc_017CF6:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_017D22(pc,d0), d1
        jsr     loc_017D22(pc,d1)
        move.w  (A7)+, D4
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #8, D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_01        ; loc_017F04
        bra     J_MarkObjGone_05        ; loc_017EF8
loc_017D22:
        dc.w    loc_017D2C-loc_017D22
        dc.w    loc_017D46-loc_017D22
        dc.w    loc_017D82-loc_017D22
        dc.w    loc_017E68-loc_017D22
        dc.w    loc_017EE0-loc_017D22
loc_017D2C:
        subq.w  #1, objoff_36(a0)
        bpl.s   loc_017D44
        move.w  #$078, objoff_36(a0)
        move.l  #$FFF69800, $0032(a0)
        addq.b  #$2, $0025(a0)
loc_017D44:
        rts
loc_017D46:
        move.l  y_pos(a0), d1
        add.l   $0032(A0), d1
        move.l  d1, y_pos(a0)
        addi.l  #$0003800, $0032(a0)
        swap.w  d1
        cmp.w   Objoff_30(A0), d1
        bcs.s   loc_017D80
        move.l  $0032(A0), D0
        cmpi.l  #$0010000, d0
        bcc.s   loc_017D72
        subq.b  #$2, $0025(a0)
loc_017D72:
        lsr.l   #$2, d0
        neg.l   D0
        move.l  d0, $0032(a0)
        move.w  Objoff_30(A0), y_pos(a0)
loc_017D80:
        rts
loc_017D82:
        move.w  x_pos(a0), D2
        move.w  D2, d3
        subi.w  #$010, D2
        addi.w  #$010, d3
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_017DF0
        cmpi.b  #$18, d0
        beq.s   loc_017DF2
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        bsr.s   loc_017DAE
        lea     (Sidekick).w, A1
        addq.b  #1, D6
loc_017DAE:
        btst    d6, status(a0)
        beq.s   loc_017DF0
        move.w  x_pos(A1), D0
        cmp.w   d2, d0
        bcs.s   loc_017DF0
        cmp.w   d3, d0
        bcc.s   loc_017DF0
        move.b  #1, $002A(a1)
        move.w  #0, $14(a1)
        move.w  #0,x_vel(a1)
        move.w  #0, $0012(a1)
        bclr    #5, status(a1)
        bclr    #$7, art_tile(a1)
        move.l  #$FFF69800, $0032(a0)
        addq.b  #$2, $0025(a0)
loc_017DF0:
        rts
loc_017DF2:
        lea     (MainCharacter).w, A1
        move.w  x_pos(A1), D0
        cmp.w   d2, d0
        bcs.s   loc_017E66
        cmp.w   d3, d0
        bcc.s   loc_017E66
        lea     (Sidekick).w, a2
        move.w  x_pos(A2), D0
        cmp.w   d2, d0
        bcs.s   loc_017E66
        cmp.w   d3, d0
        bcc.s   loc_017E66
        move.b  #1, $002A(a1)
        move.w  #0, $14(a1)
        move.w  #0,x_vel(a1)
        move.w  #0, $0012(a1)
        bclr    #5, status(a1)
        bclr    #$7, art_tile(a1)
        move.b  #1, $002A(a2)
        move.w  #0, $14(a2)
        move.w  #0,x_vel(a2)
        move.w  #0, $0012(a2)
        bclr    #5, status(a2)
        bclr    #$7, art_tile(a2)
        move.l  #$FFF69800, $0032(a0)
        addq.b  #$2, $0025(a0)
loc_017E66:
        rts
loc_017E68:
        move.l  y_pos(a0), d1
        add.l   $0032(A0), d1
        move.l  d1, y_pos(a0)
        addi.l  #$0003800, $0032(a0)
        swap.w  d1
        move.w  Objoff_30(A0), D0
        subi.w  #$07D, d0
        cmp.w   d0, d1
        bne.s   loc_017EDE
        addq.b  #$2, $0025(a0)
        lea     (MainCharacter).w, A1
        move.b  status(a0), D0
        andi.b  #8,d0
        bsr.s   loc_017EA8
        lea     (Sidekick).w, A1
        move.b  status(a0), D0
        andi.b  #$10, d0
loc_017EA8:
        beq.s   loc_017EDE
        move.w  x_pos(a0), x_pos(a1)
        move.b  #$2, $001C(a1)
        move.w  #$800, $14(a1)
        bset    #1, status(a1)
        move.w  #$F000, $0012(a1)
        bclr    #3, status(a1)
        move.b  #0, $002A(a1)
        move.w  #$0CC, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_017EDE:
        rts
loc_017EE0:
        rts
Touch_Booster_Mappings:        
loc_017EE2:
        dc.w    loc_017EE4-loc_017EE2
loc_017EE4:
        dc.w    $0002
        dc.l    $F8090000, $0000FFE8, $F8090800, $08000000
;=============================================================================== 
; Object 0x33 - Oil Ocean - Touch to Boost Up 
                
;===============================================================================           
        nop                     ; Filler
J_MarkObjGone_05: ; loc_017EF8:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_06: ; loc_017EFE:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_01: ; loc_017F04:
        jmp     SolidObject             ; (loc_00F4A0)
        dc.w    $0000           ; Filler
        
;=============================================================================== 
; Object 0x43 - Oil Ocean - Giant Spikeball
                 
;===============================================================================         
Obj43_Giant_Spikeball: ; loc_017F0C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_017F1A(pc,d0), d1
        jmp     loc_017F1A(pc,d1)
loc_017F1A:
        dc.w    loc_017F32-loc_017F1A
        dc.w    loc_017FD6-loc_017F1A
        dc.w    loc_018028-loc_017F1A
loc_017F20:
        dc.b    $00, $68, $00, $00, $00, $00, $01, $E8, $FF, $E8, $00, $18, $01, $A8, $FF, $A8
        dc.b    $FF, $D8
loc_017F32:
        addq.b  #2,routine(a0)
        move.w  #$C30C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_07 ; loc_0180CA
        moveq   #0,d1
        move.b  subtype(A0), d1
        lea     loc_017F20(pc,d1), A2
        move.b  (A2)+, d1
        move.l  A0, A1
        bra.s   loc_017F74
loc_017F50:        
        bsr     J_S1SingleObjectLoad_01  ; loc_0180C4
        bne.s   loc_017FA0
        move.b  0(A0), 0(a1)
        move.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  #1, $0036(a1)
loc_017F74:
        move.l  #Giant_Spikeball_Mappings, mappings(a1) ; loc_01808E
        move.w  art_tile(A0), art_tile(a1)
        move.b  #4, render_flags(a1)
        move.b  #4, $0018(a1)
        move.b  #$18, $0019(a1)
        move.b  #$a5, $0020(a1)
        move.w  x_pos(A1), Objoff_30(a1)
loc_017FA0:
        dbra    d1, loc_017F50
        move.l  A0, $003C(a1)
        move.l  A1, Objoff_3C(a0)
        moveq   #0,d1
        move.b  (A2)+, d1
        move.w  Objoff_30(A0), D0
        sub.w   d1, d0
        move.w  d0, $0032(a0)
        move.w  d0, $0032(a1)
        add.w   d1, d0
        add.w   d1, d0
        move.w  d0, Objoff_34(a0)
        move.w  d0, Objoff_34(a1)
        move.w  (A2)+, D0
        add.w   d0, x_pos(a0)
        move.w  (A2)+, D0
        add.w   d0, x_pos(a1)
loc_017FD6:
        bsr.s   loc_018032
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bls.s   loc_017FFC
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_018002
loc_017FFC:
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_018002:
        move.l  Objoff_3C(a0), A1
        cmpa.l  A0, A1
        beq.s   loc_018010
        jsr     (DeleteObject2)
loc_018010:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_10       ; loc_018022
        bclr    #$7, $02(A2, d0)
J_DeleteObject_10: ; loc_018022:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_018028:
        bsr.s   loc_018032
        bsr.s   loc_018068
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_018032:
        tst.b   objoff_36(a0)
        bne.s   loc_018050
        move.w  x_pos(a0), D0
        subq.w  #1,d0
        cmp.w   $0032(A0), D0
        bne.s   loc_01804A
        move.b  #1, objoff_36(a0)
loc_01804A:
        move.w  d0, x_pos(a0)
        rts
loc_018050:
        move.w  x_pos(a0), D0
        addq.w  #1,d0
        cmp.w   Objoff_34(A0), D0
        bne.s   loc_018062
        move.b  #0, objoff_36(a0)
loc_018062:
        move.w  d0, x_pos(a0)
        rts
loc_018068:
        move.l  Objoff_3C(a0), A1
        move.w  x_pos(a0), D0
        subi.w  #$018, d0
        move.w  x_pos(A1), D2
        addi.w  #$018, D2
        cmp.w   d0, D2
        bne.s   loc_01808C
        eori.b  #1, objoff_36(a0)
        eori.b  #1, $0036(a1)
loc_01808C:
        rts
Giant_Spikeball_Mappings:
loc_01808E:
        dc.w    loc_018090-loc_01808E
loc_018090:
        dc.w    $0006
        dc.l    $E0050000, $0000FFE8, $D80F0004, $0002FFF8
        dc.l    $F8090014, $000AFFE8, $F809001A, $000D0000
        dc.l    $10051000, $1000FFE8, $080F1004, $1002FFF8        
;=============================================================================== 
; Object 0x43 - Oil Ocean - Big Spikeball
                
;===============================================================================        
        nop                     ; Filler
J_S1SingleObjectLoad_01: ; loc_0180C4:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_07: ; loc_0180CA:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
;=============================================================================== 
; Object 0x07 - 
                 
;===============================================================================  
Obj07: ; loc_0180D0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0180DE(pc,d0), d1
        jmp     loc_0180DE(pc,d1)
loc_0180DE:        
        dc.w    loc_0180E2-loc_0180DE
        dc.w    loc_018104-loc_0180DE   
loc_0180E2:
        addq.b  #2,routine(a0)
        move.w  #$758, y_pos(a0)
        move.b  #$20,width_pixels(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        move.b  #$30, objoff_38(a0)
        bset    #$7, status(a0)
loc_018104:
        lea     (MainCharacter).w, A1
        moveq   #8, d1
        move.b  status(a0), D0
        and.b   d1, d0
        bne.s   loc_018120
        cmpi.b  #$30, objoff_38(a0)
        beq.s   loc_01812A
        addq.b  #1, objoff_38(a0)
        bra.s   loc_01812A
loc_018120:
        tst.b   objoff_38(a0)
        beq.s   loc_01817E
        subq.b  #1, objoff_38(a0)
loc_01812A:
        moveq   #$20, d1
        moveq   #0, d3
        move.b  objoff_38(A0), D3
        moveq   #3, D6
        move.w  x_pos(A1), D4
        move.w  d4, x_pos(a0)
        bsr     loc_01819A
        lea     (Sidekick).w, A1
        moveq   #$10, d1
        move.b  status(a0), D0
        and.b   d1, d0
        bne.s   loc_01815C
        cmpi.b  #$30, objoff_3A(a0)
        beq.s   loc_018166
        addq.b  #1, objoff_3A(a0)
        bra.s   loc_018166
loc_01815C:
        tst.b   objoff_3A(a0)
        beq.s   loc_01817E
        subq.b  #1, objoff_3A(a0)
loc_018166:
        moveq   #$20, d1
        moveq   #0, d3
        move.b  objoff_3A(A0), D3
        moveq   #4, D6
        move.w  x_pos(A1), D4
        move.w  d4, x_pos(a0)
        bsr     loc_01819A
        rts
loc_01817E:
        not.b  d1
        and.b   d1, status(a0)
        move.l  A0, -(A7)
        move.l  A0, a2
        move.l  A1, A0
        bsr     J_KillSonic_01          ; loc_018194
        move.l  (A7)+, A0
        rts
;=============================================================================== 
; Object 0x07 - 
                
;===============================================================================          
        nop                     ; Filler            
J_KillSonic_01: ; loc_018194:
        jmp     KillSonic               ; (loc_021422)
loc_01819A:
        jmp     (loc_00F99A)

;=============================================================================== 
; Object 0x45 - Oil Ocean - Spring Push to Boost 
                 
;===============================================================================  
Obj45_Spring_Push_Boost: ; loc_0181A0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0181B2(pc,d0), d1
        jsr     loc_0181B2(pc,d1)
        bra     J_MarkObjGone_06        ; loc_018D78
loc_0181B2:
        dc.w    loc_0181B8-loc_0181B2
        dc.w    loc_01822E-loc_0181B2
        dc.w    loc_018322-loc_0181B2
loc_0181B8:
        addq.b  #2,routine(a0)
        move.l  #Spring_Push_Boost_Mappings,mappings(a0) ; loc_0185C2
        move.w  #$43C5,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$00E, d0
        move.w  loc_0181EE(pc,d0), D0
        jmp     loc_0181EE(pc,d0)
loc_0181EE:
        dc.w    loc_018216-loc_0181EE
        dc.w    loc_0181F2-loc_0181EE
loc_0181F2:
        move.b  #4,routine(a0)
        move.b  #1, $001C(a0)
        move.b  #$A, $001A(a0)
        move.w  #$43C5,art_tile(a0)
        move.b  #$14,width_pixels(a0)
        move.w  x_pos(a0), Objoff_34(a0)
loc_018216:
        move.b  subtype(A0), D0
        andi.w  #$002, d0
        move.w  loc_01822A(pc,d0), Objoff_30(a0)
        bsr     J_ModifySpriteAttr_2P_08 ; loc_018D7E
        rts
loc_01822A:
        dc.w    $F000, $F600
loc_01822E:
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_018244
        tst.b   $0032(a0)
        beq.s   loc_018250
        subq.b  #1, $0032(a0)
        bra.s   loc_018250
loc_018244:
        cmpi.b  #$9, $0032(a0)
        beq.s   loc_01826E
        addq.b  #1, $0032(a0)
loc_018250:
        moveq   #0, d3
        move.b  $0032(A0), D3
        move.b  d3, $001A(a0)
        add.w   d3, d3
        move.w  #$01B, d1
        move.w  #$014, D2
        move.w  x_pos(a0), D4
        bsr     loc_018D90
        rts
loc_01826E:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        bsr.s   loc_01827C
        lea     (Sidekick).w, A1
        moveq   #4, D6
loc_01827C:
        bclr    d6, status(a0)
        beq     loc_018320
        move.w  Objoff_30(A0), $0012(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        bpl.s   loc_0182AE
        move.w  #0,x_vel(a1)
loc_0182AE:
        btst    #0, d0
        beq.s   loc_0182EE
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        btst    #1,d0
        bne.s   loc_0182DE
        move.b  #1, $002C(a1)
loc_0182DE:
        btst    #0, status(a1)
        beq.s   loc_0182EE
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_0182EE:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_018304
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_018304:
        cmpi.b  #8,d0
        bne.s   loc_018316
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_018316:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_018320:
        rts
loc_018322:
        move.b  #0, objoff_36(a0)
        move.w  #$01F, d1
        move.w  #$00C, D2
        move.w  #$00D, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_018D8A
        cmpi.w  #$001, D4
        bne.s   loc_018368
        move.b  status(a0), d1
        move.w  x_pos(a0), D2
        sub.w   x_pos(A1), D2
        bcs.s   loc_01835E
        eori.b  #1,d1
loc_01835E:
        andi.b  #1,d1
        bne.s   loc_018368
        bsr     loc_0183E4
loc_018368:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_018D8A
        cmpi.w  #$001, D4
        bne.s   loc_018396
        move.b  status(a0), d1
        move.w  x_pos(a0), D2
        sub.w   x_pos(A1), D2
        bcs.s   loc_01838E
        eori.b  #1,d1
loc_01838E:
        andi.b  #1,d1
        bne.s   loc_018396
        bsr.s   loc_0183E4
loc_018396:
        tst.b   objoff_36(a0)
        bne.s   loc_0183E2
        move.w  Objoff_34(A0), D0
        cmp.w   x_pos(a0), D0
        beq.s   loc_0183E2
        bcc.s   loc_0183C4
        subq.b  #4, $001A(a0)
        subq.w  #4, x_pos(a0)
        cmp.w   x_pos(a0), D0
        bcs.s   loc_0183DE
        move.b  #$A, $001A(a0)
        move.w  Objoff_34(A0), x_pos(a0)
        bra.s   loc_0183DE
loc_0183C4:
        subq.b  #4, $001A(a0)
        addq.w  #4, x_pos(a0)
        cmp.w   x_pos(a0), D0
        bcc.s   loc_0183DE
        move.b  #$A, $001A(a0)
        move.w  Objoff_34(A0), x_pos(a0)
loc_0183DE:
        bsr     loc_018478
loc_0183E2:
        rts
loc_0183E4:
        btst    #0, status(a0)
        beq.s   loc_018420
        btst    #0, status(a1)
        bne     loc_018476
        tst.w   D0
        bne     loc_018406
        tst.w   $14(a1)
        beq.s   loc_018476
        bpl.s   loc_018470
        bra.s   loc_018476
loc_018406:
        move.w  Objoff_34(A0), D0
        addi.w  #$012, d0
        cmp.w   x_pos(a0), D0
        beq.s   loc_018470
        addq.w  #1, x_pos(a0)
        moveq   #1,d0
        move.w  #$40, d1
        bra.s   loc_01844E
loc_018420:
        btst    #0, status(a1)
        beq.s   loc_018476
        tst.w   D0
        bne     loc_018436
        tst.w   $14(a1)
        bmi.s   loc_018470
        bra.s   loc_018476
loc_018436:
        move.w  Objoff_34(A0), D0
        subi.w  #$012, d0
        cmp.w   x_pos(a0), D0
        beq.s   loc_018470
        subq.w  #1, x_pos(a0)
        moveq   #$FFFFFFFF, d0
        move.w  #$FFC0, d1
loc_01844E:
        add.w   d0, x_pos(a1)
        move.w  d1, $14(a1)
        move.w  #0,x_vel(a1)
        move.w  Objoff_34(A0), D0
        sub.w   x_pos(a0), D0
        bcc.s   loc_018468
        neg.w   D0
loc_018468:
        addi.w  #$00A, d0
        move.b  d0, $001A(a0)
loc_018470:
        move.b  #1, objoff_36(a0)
loc_018476:
        rts
loc_018478:
        move.b  status(a0), D0
        andi.b  #$60, d0
        beq     loc_018578
        lea     (MainCharacter).w, A1
        moveq   #5, D6
        bsr.s   loc_018492
        lea     (Sidekick).w, A1
        moveq   #6, D6
loc_018492:
        bclr    d6, status(a0)
        beq     loc_018578
        move.w  Objoff_34(A0), D0
        sub.w   x_pos(a0), D0
        bcc.s   loc_0184A6
        neg.w   D0
loc_0184A6:
        addi.w  #$00A, d0
        lsl.w   #$7, d0
        neg.w   D0
        move.w  d0,x_vel(a1)
        subq.w  #4, x_pos(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_0184D4
        bclr    #0, status(a1)
        addi.w  #8, x_pos(a1)
        neg.w  x_vel(a1)
loc_0184D4:
        move.w  #$F, $002E(a1)
        move.w x_vel(A1), $14(a1)
        btst    #$2, status(a1)
        bne.s   loc_0184EE
        move.b  #0, $001C(a1)
loc_0184EE:
        move.b  subtype(A0), D0
        bpl.s   loc_0184FA
        move.w  #0, $0012(a1)
loc_0184FA:
        btst    #0, d0
        beq.s   loc_01853A
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0
        bne.s   loc_01852A
        move.b  #3, $002C(a1)
loc_01852A:
        btst    #0, status(a1)
        beq.s   loc_01853A
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_01853A:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_018550
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_018550:
        cmpi.b  #8,d0
        bne.s   loc_018562
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_018562:
        bclr    #5, status(a1)
        move.b  #1, $001D(a1)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_018578:
        rts 
loc_01857A:   ; Unused Obj Conf
        dc.w    loc_01857E-loc_01857A
        dc.w    loc_0185A0-loc_01857A
loc_01857E:
        dc.b    $00, $00, $01, $02, $03, $04, $05, $06, $07, $08, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $08, $07, $06, $05, $04, $03, $02, $01, $00, $00, $00, $00, $00, $00
        dc.b    $00, $FF
loc_0185A0:
        dc.b    $00, $0A, $0B, $0C, $0D, $0E, $0F, $10, $11, $12, $13, $13, $13, $13, $13, $13
        dc.b    $13, $13, $12, $11, $10, $0F, $0E, $0D, $0C, $0B, $0A, $0A, $0A, $0A, $0A, $0A
        dc.b    $0A, $FF        
Spring_Push_Boost_Mappings: 
loc_0185C2:
        dc.w    loc_0185FC-loc_0185C2
        dc.w    loc_018626-loc_0185C2
        dc.w    loc_018650-loc_0185C2
        dc.w    loc_01867A-loc_0185C2
        dc.w    loc_0186A4-loc_0185C2
        dc.w    loc_0186CE-loc_0185C2
        dc.w    loc_0186F8-loc_0185C2
        dc.w    loc_018722-loc_0185C2
        dc.w    loc_01874C-loc_0185C2
        dc.w    loc_018776-loc_0185C2
        dc.w    loc_0187A0-loc_0185C2
        dc.w    loc_0187CA-loc_0185C2
        dc.w    loc_0187F4-loc_0185C2
        dc.w    loc_01881E-loc_0185C2
        dc.w    loc_018848-loc_0185C2
        dc.w    loc_018872-loc_0185C2
        dc.w    loc_01889C-loc_0185C2
        dc.w    loc_0188C6-loc_0185C2
        dc.w    loc_0188F0-loc_0185C2
        dc.w    loc_01891A-loc_0185C2
        dc.w    loc_018944-loc_0185C2
        dc.w    loc_01896E-loc_0185C2
        dc.w    loc_018998-loc_0185C2
        dc.w    loc_0189C2-loc_0185C2
        dc.w    loc_0189EC-loc_0185C2
        dc.w    loc_018A16-loc_0185C2
        dc.w    loc_018A40-loc_0185C2
        dc.w    loc_018A6A-loc_0185C2
        dc.w    loc_018A94-loc_0185C2               
loc_0185FC:
        dc.w    $0005
        dc.l    $EC0C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $04081007, $1003FFF4, $FC08300A, $3005FFF4
        dc.l    $F404100D, $1006FFF8
loc_018626:
        dc.w    $0005
        dc.l    $EE0C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $04081007, $1003FFF4, $FC08300A, $3005FFF4
        dc.l    $F604100D, $1006FFF8
loc_018650:
        dc.w    $0005
        dc.l    $F00C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $04081007, $1003FFF4, $FE08300A, $3005FFF4
        dc.l    $F804100D, $1006FFF8
loc_01867A:
        dc.w    $0005
        dc.l    $F20C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $06081007, $1003FFF4, $0008300A, $3005FFF4
        dc.l    $FA04100D, $1006FFF8
loc_0186A4:
        dc.w    $0005
        dc.l    $F40C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $06081007, $1003FFF4, $0008300A, $3005FFF4
        dc.l    $FC04100D, $1006FFF8
loc_0186CE:
        dc.w    $0005
        dc.l    $F60C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $06081007, $1003FFF4, $0208300A, $3005FFF4
        dc.l    $FE04100D, $1006FFF8
loc_0186F8:
        dc.w    $0005
        dc.l    $F80C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $08081007, $1003FFF4, $0408300A, $3005FFF4
        dc.l    $0004100D, $1006FFF8
loc_018722:
        dc.w    $0005
        dc.l    $FA0C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $08081007, $1003FFF4, $0408300A, $3005FFF4
        dc.l    $0204100D, $1006FFF8
loc_01874C:
        dc.w    $0005
        dc.l    $FC0C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $08081007, $1003FFF4, $0608300A, $3005FFF4
        dc.l    $0404100D, $1006FFF8
loc_018776:
        dc.w    $0005
        dc.l    $FE0C3000, $3000FFF0, $0C083004, $3002FFF4
        dc.l    $0A081007, $1003FFF4, $0808300A, $3005FFF4
        dc.l    $0604100D, $1006FFF8
loc_0187A0:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFEC
        dc.l    $F4020016, $000BFFF4, $F4022019, $200CFFFC
        dc.l    $F801001C, $000E0004
loc_0187CA:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFED
        dc.l    $F4020016, $000BFFF5, $F4022019, $200CFFFD
        dc.l    $F801001C, $000E0004
loc_0187F4:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFEE
        dc.l    $F4020016, $000BFFF6, $F4022019, $200CFFFE
        dc.l    $F801001C, $000E0004
loc_01881E:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFEF
        dc.l    $F4020016, $000BFFF7, $F4022019, $200CFFFF
        dc.l    $F801001C, $000E0004
loc_018848:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF0
        dc.l    $F4020016, $000BFFF8, $F4022019, $200CFFFE
        dc.l    $F801001C, $000E0004
loc_018872:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF1
        dc.l    $F4020016, $000BFFF9, $F4022019, $200CFFFF
        dc.l    $F801001C, $000E0004
loc_01889C:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF2
        dc.l    $F4020016, $000BFFF8, $F4022019, $200CFFFE
        dc.l    $F801001C, $000E0004
loc_0188C6:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF3
        dc.l    $F4020016, $000BFFF9, $F4022019, $200CFFFF
        dc.l    $F801001C, $000E0004
loc_0188F0:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF4
        dc.l    $F4020016, $000BFFFA, $F4022019, $200C0000
        dc.l    $F801001C, $000E0004
loc_01891A:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF5
        dc.l    $F4020016, $000BFFFB, $F4022019, $200C0001
        dc.l    $F801001C, $000E0004
loc_018944:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF6
        dc.l    $F4020016, $000BFFFC, $F4022019, $200C0000
        dc.l    $F801001C, $000E0004
loc_01896E:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF7
        dc.l    $F4020016, $000BFFFD, $F4022019, $200C0001
        dc.l    $F801001C, $000E0004
loc_018998:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF8
        dc.l    $F4020016, $000BFFFC, $F4022019, $200C0000
        dc.l    $F801001C, $000E0004
loc_0189C2:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFF9
        dc.l    $F4020016, $000BFFFD, $F4022019, $200C0001
        dc.l    $F801001C, $000E0004
loc_0189EC:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFFA
        dc.l    $F4020016, $000BFFFE, $F4022019, $200C0002
        dc.l    $F801001C, $000E0004
loc_018A16:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFFB
        dc.l    $F4020016, $000BFFFF, $F4022019, $200C0003
        dc.l    $F801001C, $000E0004
loc_018A40:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFFC
        dc.l    $F4020016, $000B0000, $F4022019, $200C0002
        dc.l    $F801001C, $000E0004
loc_018A6A:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFFD
        dc.l    $F4020016, $000B0001, $F4022019, $200C0003
        dc.l    $F801001C, $000E0004
loc_018A94:
        dc.w    $0005
        dc.l    $F003200F, $2007000C, $F4022013, $2009FFFE
        dc.l    $F4020016, $000B0000, $F4022019, $200C0002
        dc.l    $F801001C, $000E0004        
;=============================================================================== 
; Object 0x45 - Oil Ocean - Spring Push to Boost 
                
;===============================================================================  

;=============================================================================== 
; Object 0x46 - Oil Ocean - Spring With Ball - Sonic call stay on ball 
                 
;===============================================================================  
Obj46_Spring_Ball: ; loc_018ABE:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_018ACC(pc,d0), d1
        jmp     loc_018ACC(pc,d1)
loc_018ACC:
        dc.w    loc_018AD4-loc_018ACC
        dc.w    loc_018B92-loc_018ACC
        dc.w    loc_018BE0-loc_018ACC
        dc.w    loc_018C84-loc_018ACC
loc_018AD4:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_018AF0
        bclr    #$7, $02(A2, d0)
        bset    #0, $02(A2, d0)
        bne     J_DeleteObject_11       ; loc_018D6C
loc_018AF0:
        addq.b  #2,routine(a0)
        move.b  #$F, y_radius(a0)
        move.b  #$F, $0017(a0)
        move.l  #Spring_Ball_Mappings,mappings(a0) ; loc_018CFA
        move.w  #$6354,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_08 ; loc_018D7E
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), objoff_36(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #0, $001A(a0)
        move.w  #0, $14(a0)
        move.b  #1, $001F(a0)
        bsr     J_SingleObjectLoad_01   ; loc_018D72
        bne.s   loc_018B8E
        move.b  #$46, 0(a1)
        addq.b  #6, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$012, y_pos(a1)
        move.l  #Spring_Push_Boost_Mappings, mappings(a1) ; loc_0185C2
        move.w  #$43C5, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #4, $0018(a1)
        move.b  #$9, $001A(a1)
        move.l  A0, $003C(a1)
loc_018B8E:
        move.l  A1, Objoff_3C(a0)
loc_018B92:
        btst    #6, (Ctrl_2_Press).w
        bne.s   loc_018BAC
        lea     ($FFFFF7E0).w, a2
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #4, d0
        tst.b   $00(A2, d0)
        beq.s   loc_018BD8
loc_018BAC:
        addq.b  #2,routine(a0)
        bset    #1, status(a0)
        move.w  #$FD00, $0012(a0)
        move.w  #$100, $14(a0)
        move.l  Objoff_3C(a0), A1
        move.b  #1, Objoff_30(a1)
        btst    #0, status(a0)
        beq.s   loc_018BD8
        neg.w   $14(a0)
loc_018BD8:
        bsr     loc_018C98
        bra     J_MarkObjGone_06        ; loc_018D78
loc_018BE0:
        move.w  x_pos(a0), -(A7)
        bsr     J_SpeedToPos_05         ; loc_018D96
        btst    #1, status(a0)
        beq.s   loc_018C34
        addi.w  #$018, $0012(a0)
        bmi.s   loc_018C32
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcs.s   loc_018C6C
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl     loc_018C32
        add.w   d1, y_pos(a0)
        clr.w   $0012(a0)
        bclr    #1, status(a0)
        move.w  #$100,x_vel(a0)
        btst    #0, status(a0)
        beq.s   loc_018C32
        neg.w  x_vel(a0)
loc_018C32:
        bra.s   loc_018C4C
loc_018C34:
        jsr     ObjHitFloor             ; (loc_013898)
        cmpi.w  #8,d1
        blt.s   loc_018C48
        bset    #1, status(a0)
        bra.s   loc_018C4C
loc_018C48:
        add.w   d1, y_pos(a0)
loc_018C4C:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  (A7)+, D4
        bsr     J_SolidObject_02        ; loc_018D84
        bsr     loc_018C98
        bra     J_MarkObjGone_06        ; loc_018D78
loc_018C6C:
        move.w  (A7)+, D4
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_018C80
        bclr    #$7, $02(A2, d0)
loc_018C80:
        bra     J_DeleteObject_11       ; loc_018D6C
loc_018C84:
        tst.b   Objoff_30(a0)
        beq.s   loc_018C94
        subq.b  #1, $001A(a0)
        bne.s   loc_018C94
        clr.b   Objoff_30(a0)
loc_018C94:
        bra     J_MarkObjGone_06        ; loc_018D78
loc_018C98:
        tst.b   $001A(a0)
        beq.s   loc_018CA6
        move.b  #0, $001A(a0)
        rts
loc_018CA6:
        move.b  $14(A0), D0
        beq.s   loc_018CD2
        bmi.s   loc_018CDA
        subq.b  #1, $001E(a0)
        bpl.s   loc_018CD2
        neg.b   D0
        addq.b  #8,d0
        bcs.s   loc_018CBC
        moveq	#0,d0
loc_018CBC:
        move.b  d0, $001E(a0)
        move.b  $001F(A0), D0
        addq.b  #1,d0
        cmpi.b  #4, d0
        bne.s   loc_018CCE
        moveq   #1,d0
loc_018CCE:
        move.b  d0, $001F(a0)
loc_018CD2:
        move.b  $001F(A0), $001A(a0)
        rts
loc_018CDA:
        subq.b  #1, $001E(a0)
        bpl.s   loc_018CD2
        addq.b  #8,d0
        bcs.s   loc_018CE6
        moveq	#0,d0
loc_018CE6:
        move.b  d0, $001E(a0)
        move.b  $001F(A0), D0
        subq.b  #1,d0
        bne.s   loc_018CF4
        moveq   #3, d0
loc_018CF4:
        move.b  d0, $001F(a0)
        bra.s   loc_018CD2 
Spring_Ball_Mappings: ; loc_018CFA:
        dc.w    loc_018D02-Spring_Ball_Mappings
        dc.w    loc_018D24-Spring_Ball_Mappings
        dc.w    loc_018D46-Spring_Ball_Mappings
        dc.w    loc_018D58-Spring_Ball_Mappings
loc_018D02:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $00051804, $1802FFF0, $00051004, $10020000
loc_018D24:
        dc.w    $0004
        dc.l    $F0050008, $0004FFF0, $F0050808, $08040000
        dc.l    $00051008, $1004FFF0, $00051808, $18040000
loc_018D46:
        dc.w    $0002
        dc.l    $F00D000C, $0006FFF0, $000D180C, $1806FFF0
loc_018D58:
        dc.w    $0002
        dc.l    $F00D080C, $0806FFF0, $000D100C, $1006FFF0         
;=============================================================================== 
; Object 0x46 - Oil Ocean - Spring With Ball - Sonic call stay on ball 
                
;===============================================================================            
        nop                     ; Filler
J_DeleteObject_11: ; loc_018D6C:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_01: ; loc_018D72:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_MarkObjGone_06: ; loc_018D78:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_08: ; loc_018D7E:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_02: ; loc_018D84:
        jmp     SolidObject             ; (loc_00F4A0)
loc_018D8A:
        jmp     (loc_00F510)
loc_018D90:
        jmp     (loc_00F5F0)
J_SpeedToPos_05: ; loc_018D96:
        jmp     SpeedToPos              ; (loc_00D27A)
;=============================================================================== 
; Object 0x47 - Switch - Oil Ocean / Dust Hill
                 
;===============================================================================          
Obj47_Switch: ; loc_018D9C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_018DAA(pc,d0), d1
        jmp     loc_018DAA(pc,d1)  
loc_018DAA:          
        dc.w    loc_018DAE-loc_018DAA
        dc.w    loc_018DDA-loc_018DAA
loc_018DAE:
        addq.b  #2,routine(a0)
        move.l  #Switch_Mappings,mappings(a0) ; loc_018E3E
        move.w  #$424,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_09 ; loc_018E6A
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        addq.w  #4, y_pos(a0)
loc_018DDA:
        tst.b   render_flags(a0)
        bpl.s   loc_018E3A
        move.w  #$01B, d1
        move.w  #$004, D2
        move.w  #$005, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_03        ; loc_018E70
        move.b  #0, $001A(a0)
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        lea     ($FFFFF7E0).w, A3
        lea     $00(A3, d0), A3
        moveq   #0, d3
        btst    #6, subtype(a0)
        beq.s   loc_018E16
        moveq   #$7, d3
loc_018E16:
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_018E24
        bclr    d3, (a3)
        bra.s   loc_018E3A
loc_018E24:
        tst.b   (a3)
        bne.s   loc_018E32
        move.w  #$0CD, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_018E32:
        bset    d3, (a3)
        move.b  #1, $001A(a0)
loc_018E3A:
        bra     J_MarkObjGone_07        ; loc_018E64 
Switch_Mappings: ; loc_018E3E:
        dc.w    loc_018E44-Switch_Mappings
        dc.w    loc_018E4E-Switch_Mappings
        dc.w    loc_018E58-Switch_Mappings
loc_018E44:
        dc.w    $0001
        dc.l    $F40D0000, $0000FFF0
loc_018E4E:
        dc.w    $0001
        dc.l    $F40D0008, $0004FFF0
loc_018E58:
        dc.w    $0001
        dc.l    $F80D0000, $0000FFF0
;=============================================================================== 
; Object 0x47 - Switch - Oil Ocean / Dust Hill
                
;===============================================================================          
        nop                     ; Filler
J_MarkObjGone_07: ; loc_018E64:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_09 ; loc_018E6A:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_03: ; loc_018E70:
        jmp     SolidObject             ; (loc_00F4A0)
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x3D - Break to Boost - Oil Ocean
                 
;===============================================================================  
Obj3D_Break_Boost: ; loc_018E78:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_018E86(pc,d0), d1
        jmp     loc_018E86(pc,d1)
loc_018E86:
        dc.w    loc_018E8E-loc_018E86
        dc.w    loc_018EB6-loc_018E86
        dc.w    loc_018FCC-loc_018E86
        dc.w    loc_018FE2-loc_018E86
loc_018E8E:
        addq.b  #2,routine(a0)
        move.l  #Break_Boost_Mappings,mappings(a0) ; loc_01916E
        move.w  #$6332,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0A ; loc_019236
        move.b  #4,render_flags(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #4, $0018(a0)
loc_018EB6:
        move.b  ($FFFFB01C).w, $0032(a0)
        move.b  ($FFFFB05C).w, $0033(a0)
        move.w  ($FFFFB012).w, Objoff_34(a0)
        move.w  ($FFFFB052).w, objoff_36(a0)
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_04        ; loc_019242
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne.s   loc_018EF0
loc_018EEC:        
        bra     J_MarkObjGone_08        ; loc_019224
loc_018EF0:
        cmpi.b  #$18, d0
        bne.s   loc_018F26
        cmpi.b  #$2, $0032(a0)
        beq.s   loc_018F06
        cmpi.b  #$2, $0033(a0)
        bne.s   loc_018EEC
loc_018F06:
        lea     (MainCharacter).w, A1
        move.b  $0032(A0), D0
        move.w  Objoff_34(A0), d1
        bsr.s   loc_018F42
        lea     (Sidekick).w, A1
        move.b  $0033(A0), D0
        move.w  objoff_36(a0), d1
        bsr.s   loc_018F42
        bra     loc_018F94
loc_018F26:
        move.b  d0, d1
        andi.b  #8, d1
        beq.s   loc_018F78
        cmpi.b  #$2, $0032(a0)
        bne.s   loc_018EEC
        lea     (MainCharacter).w, A1
        move.w  Objoff_34(A0), d1
        bsr.s   loc_018F48
        bra.s   loc_018F94
loc_018F42:
        cmpi.b  #$2, d0
        bne.s   loc_018F64
loc_018F48:
        bset    #$2, status(a1)
        move.b  #$E, y_radius(a1)
        move.b  #$7, $0017(a1)
        move.b  #$2, $001C(a1)
        move.w  d1, $0012(a1)
loc_018F64:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
        rts
loc_018F78:
        andi.b  #$10, d0
        beq     loc_018EEC
        cmpi.b  #$2, $0033(a0)
        bne     loc_018EEC
        lea     (Sidekick).w, A1
        move.w  objoff_36(a0), d1
        bsr.s   loc_018F48
loc_018F94:
        andi.b  #$E7, status(a0)
        bsr     J_S1SingleObjectLoad_02  ; loc_01922A
        bne.s   loc_018FB8
        moveq	#0,d0
        move.w  #$009, d1
loc_018FA6:        
        move.l  $00(A0, d0), $00(A1, d0)
        addq.w  #4, d0
        dbra    d1, loc_018FA6
        move.b  #6, $0024(a1)
loc_018FB8:
        lea     (loc_01912E), A4
        addq.b  #1, $001A(a0)
        moveq   #$F, d1
        move.w  #$018, D2
        bsr     loc_01923C
loc_018FCC:
        bsr     J_SpeedToPos_06         ; loc_019248
        addi.w  #$018, $0012(a0)
        tst.b   render_flags(a0)
        bpl     J_DeleteObject_12       ; loc_01921E
        bra     J_DisplaySprite_03      ; loc_019218
loc_018FE2:
        lea     (MainCharacter).w, A1
        lea     $002C(A0), A4
        bsr.s   loc_019004
        lea     (Sidekick).w, A1
        lea     objoff_36(a0), A4
        bsr.s   loc_019004
        move.b  $002C(A0), D0
        add.b   objoff_36(a0), D0
        beq     loc_019230
        rts
loc_019004:
        moveq	#0,d0
        move.b  (A4), D0
        move.w  loc_019010(pc,d0), D0
        jmp     loc_019010(pc,d0)   
loc_019010:
        dc.w    loc_019014-loc_019010
        dc.w    loc_019092-loc_019010
loc_019014:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addi.w  #$010, d0
        cmpi.w  #$20, d0
        bcc     loc_019090
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        cmpi.w  #$010, d1
        bcc     loc_019090
        addq.b  #$2, (a4)
        move.w  y_pos(a0), y_pos(a1)
        move.b  #$81, $002A(a1)
        move.b  #$2, $001C(a1)
        move.w  #$800, $14(a1)
        move.w  #$800,x_vel(a1)
        move.w  #0, $0012(a1)
        bclr    #5, status(a0)
        bclr    #5, status(a1)
        bset    #1, status(a1)
        bset    #3, status(a1)
        move.w  A0, d0
        subi.w  #Object_RAM, d0
        lsr.w   #6, d0
        andi.w  #$07F, d0
        move.b  d0, objoff_3D(a1)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_019090:
        rts
loc_019092:
        bra.s   loc_0190D8
        subq.b  #1, art_tile(a4)
        bpl.s   loc_0190D8
        move.l  $0006(A4), A2
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        move.w  d5, y_pos(a1)
        tst.b   render_flags(a4)
        bpl.s   loc_0190BA
        subq.w  #8, a2
loc_0190BA:
        move.l  A2, $0006(a4)
        subq.w  #4, mappings(a4)
        beq.s   loc_0190FE
        move.w  (A2)+, D4
        add.w   x_pos(a0), D4
        move.w  (A2)+, D5
        add.w   y_pos(a0), D5
        move.w  #$800, D2
        bra     loc_016A80
loc_0190D8:
        move.l  x_pos(A1), D2
        move.l  y_pos(A1), D3
        move.w x_vel(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a1)
        move.l  d3, y_pos(a1)
        rts
loc_0190FE:
        cmpi.b  #4, render_flags(a4)
        bcc.s   loc_019116
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.b   render_flags(A4), D0
        move.b  #4, render_flags(a4)
loc_019116:
        andi.w  #$7FF, y_pos(a1)
        move.b  #6, (a4)
        clr.b   $002A(a1)
        move.w  #$0BC, d0
        jmp     (Play_Sfx)              ; loc_0014C6     
loc_01912E:
        dc.w    $FC00, $FC00, $FE00, $FC00, $0200, $FC00, $0400, $FC00
        dc.w    $FC40, $FE00, $FE40, $FE00, $01C0, $FE00, $03C0, $FE00
        dc.w    $FC80, $0200, $FE80, $0200, $0180, $0200, $0380, $0200
        dc.w    $FCC0, $0400, $FEC0, $0400, $0140, $0400, $0340, $0400 
Break_Boost_Mappings: ; loc_01916E:
        dc.w    loc_019172-Break_Boost_Mappings
        dc.w    loc_019194-Break_Boost_Mappings
loc_019172:
        dc.w    $0004
        dc.l    $F0030000, $0000FFF0, $F0030000, $0000FFF8
        dc.l    $F0030000, $00000000, $F0030000, $00000008
loc_019194:
        dc.w    $0010
        dc.l    $F0000000, $0000FFF0, $F0000000, $0000FFF8
        dc.l    $F0000000, $00000000, $F0000000, $00000008
        dc.l    $F8000000, $0000FFF0, $F8000000, $0000FFF8
        dc.l    $F8000000, $00000000, $F8000000, $00000008
        dc.l    $00000000, $0000FFF0, $00000000, $0000FFF8
        dc.l    $00000000, $00000000, $00000000, $00000008
        dc.l    $08000000, $0000FFF0, $08000000, $0000FFF8
        dc.l    $08000000, $00000000, $08000000, $00000008        
;=============================================================================== 
; Object 0x3D - Break to Boost - Oil Ocean 
                
;=============================================================================== 
        nop                     ; Filler
J_DisplaySprite_03: ; loc_019218:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_12: ; loc_01921E:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_08: ; loc_019224:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_02: ; loc_01922A:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
loc_019230:
        jmp     (loc_00D30C)
J_ModifySpriteAttr_2P_0A: ; loc_019236:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01923C:
        jmp     (loc_00CE50)
J_SolidObject_04: ; loc_019242:
        jmp     SolidObject             ; (loc_00F4A0)
J_SpeedToPos_06: ; loc_019248:
        jmp     SpeedToPos              ; (loc_00D27A)
        dc.w    $0000           ; Filler            
        
;=============================================================================== 
; Object 0x48 - Cannon - Oil Ocean 
                 
;===============================================================================          
Obj48_Cannon: ; loc_019250:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01926E(pc,d0), d1
        jsr     loc_01926E(pc,d1)
        move.b  $002C(A0), D0
        add.b   objoff_36(a0), D0
        beq     J_MarkObjGone_09        ; loc_019652
        bra     J_DisplaySprite_04      ; loc_01964C
loc_01926E:
        dc.w    loc_019282-loc_01926E
        dc.w    loc_0192D2-loc_01926E
loc_019272:
        dc.b    $04
loc_019273:
        dc.b    $00, $06, $07, $07, $00, $05, $07, $05, $00, $04, $07, $06, $00, $07, $07
loc_019282:
        addq.b  #2,routine(a0)
        move.l  #Cannon_Mappings,mappings(a0) ; loc_0194CA
        move.w  #$6368,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0B ; loc_019658
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        btst    #0, status(a0)
        beq.s   loc_0192AA
        addq.w  #4, d0
loc_0192AA:
        add.w   d0, d0
        move.b  loc_019272(pc,d0), render_flags(a0)
        move.b  loc_019273(pc,d0), Objoff_3F(a0)
        beq.s   loc_0192C0
        move.b  #1, Objoff_3E(a0)
loc_0192C0:
        move.b  Objoff_3F(A0), $001A(a0)
        move.b  #$28,width_pixels(a0)
        move.b  #1, $0018(a0)
loc_0192D2:
        lea     (MainCharacter).w, A1
        lea     $002C(A0), A4
        moveq   #$2C, D2
        bsr.s   loc_0192E8
        lea     (Sidekick).w, A1
        lea     objoff_36(a0), A4
        moveq   #$36, D2
loc_0192E8:
        moveq	#0,d0
        move.b  (A4), D0
        move.w  loc_0192F4(pc,d0), D0
        jmp     loc_0192F4(pc,d0)
loc_0192F4:
        dc.w    loc_0192FC-loc_0192F4
        dc.w    loc_0193B0-loc_0192F4
        dc.w    loc_01945E-loc_0192F4
        dc.w    loc_0194BE-loc_0192F4
loc_0192FC:
        tst.w   (Debug_placement_mode).w
        bne     loc_0193AE
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addi.w  #$010, d0
        cmpi.w  #$20, d0
        bcc     loc_0193AE
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        addi.w  #$010, d1
        cmpi.w  #$20, d1
        bcc     loc_0193AE
        btst    #3, status(a1)
        beq.s   loc_01934A
        moveq	#0,d0
        move.b  objoff_3D(A1), D0
        lsl.w   #6, d0
        addi.l  #MainCharacter, d0
        move.l  d0, A3
        move.b  #0, $00(A3, D2)
loc_01934A:
        move.w  A0, d0
        subi.w  #Object_RAM, d0
        lsr.w   #6, d0
        andi.w  #$07F, d0
        move.b  d0, objoff_3D(a1)
        addq.b  #$2, (a4)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  #$81, $002A(a1)
        move.b  #$2, $001C(a1)
        move.w  #$1000, $14(a1)
        move.w  #0,x_vel(a1)
        move.w  #0, $0012(a1)
        bclr    #5, status(a0)
        bclr    #5, status(a1)
        bset    #1, status(a1)
        bset    #3, status(a1)
        move.b  Objoff_3F(A0), $001A(a0)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_0193AE:
        rts
loc_0193B0:
        tst.b   Objoff_3E(a0)
        bne.s   loc_0193D8
        cmpi.b  #$7, $001A(a0)
        beq.s   loc_0193F2
        subq.w  #1, $001E(a0)
        bpl.s   loc_0193D6
        move.w  #$007, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #$7, $001A(a0)
        beq.s   loc_0193F2
loc_0193D6:
        rts
loc_0193D8:
        tst.b   $001A(a0)
        beq.s   loc_0193F2
        subq.w  #1, $001E(a0)
        bpl.s   loc_0193D6
        move.w  #$007, $001E(a0)
        subq.b  #1, $001A(a0)
        beq.s   loc_0193F2
        rts
loc_0193F2:
        addq.b  #$2, (a4)
        move.b  subtype(A0), D0
        addq.b  #1,d0
        btst    #0, status(a0)
        beq.s   loc_019404
        subq.b  #$2, d0
loc_019404:
        andi.w  #$003, d0
        add.w   d0, d0
        add.w   d0, d0
        move.w  loc_01944E(pc,d0),x_vel(a1)
        move.w  loc_019450(pc,d0), $0012(a1)
        move.w  #$003, $001E(a0)
        tst.b   subtype(a0)
        bpl.s   loc_01944C
        move.b  #0, $002A(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #0, $003C(a1)
        move.b  #$2, $0024(a1)
        move.b  #6, (a4)
        move.w  #$007, Objoff_3C(a0)
loc_01944C:
        rts     
loc_01944E:
        dc.w    $0000
loc_019450:
        dc.w    $F000, $1000, $0000, $0000, $1000, $F000, $0000
loc_01945E:
        cmpi.b  #$2, $002C(a0)
        beq.s   loc_019498
        cmpi.b  #$2, objoff_36(a0)
        beq.s   loc_019498
        subq.w  #1, $001E(a0)
        bpl.s   loc_019498
        move.w  #$001, $001E(a0)
        tst.b   Objoff_3E(a0)
        beq.s   loc_01948E
        cmpi.b  #$7, $001A(a0)
        beq.s   loc_019498
        addq.b  #1, $001A(a0)
        bra.s   loc_019498
loc_01948E:
        tst.b   $001A(a0)
        beq.s   loc_019498
        subq.b  #1, $001A(a0)
loc_019498:
        move.l  x_pos(A1), D2
        move.l  y_pos(A1), D3
        move.w x_vel(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a1)
        move.l  d3, y_pos(a1)
        rts
loc_0194BE:
        subq.w  #1, Objoff_3C(a0)
        bpl.s   loc_0194C8
        move.b  #0, (a4)
loc_0194C8:
        rts        
Cannon_Mappings:
loc_0194CA:
        dc.w    loc_0194DA-loc_0194CA
        dc.w    loc_01951C-loc_0194CA
        dc.w    loc_01954E-loc_0194CA
        dc.w    loc_019570-loc_0194CA
        dc.w    loc_019592-loc_0194CA
        dc.w    loc_0195B4-loc_0194CA
        dc.w    loc_0195D6-loc_0194CA
        dc.w    loc_019608-loc_0194CA
loc_0194DA:
        dc.w    $0008
        dc.l    $D8040000, $0000FFF0, $D8040800, $08000000
        dc.l    $E0040002, $0001FFF0, $E0040802, $08010000
        dc.l    $E80A0011, $0008FFE8, $E80A0811, $08080000
        dc.l    $000A1008, $1004FFE8, $000A1808, $18040000
loc_01951C:
        dc.w    $0006
        dc.l    $E0040000, $0000FFF0, $E0040800, $08000000
        dc.l    $E80A0011, $0008FFE8, $E80A0811, $08080000
        dc.l    $000A1008, $1004FFE8, $000A1808, $18040000
loc_01954E:
        dc.w    $0004
        dc.l    $E80A0011, $0008FFE8, $E80A0811, $08080000
        dc.l    $000A1008, $1004FFE8, $000A1808, $18040000
loc_019570:
        dc.w    $0004
        dc.l    $E80A001A, $000DFFE8, $E80A1823, $18110000
        dc.l    $000A0023, $0011FFE8, $000A181A, $180D0000
loc_019592:
        dc.w    $0004
        dc.l    $E80A1023, $1011FFE8, $E80A081A, $080D0000
        dc.l    $000A101A, $100DFFE8, $000A0823, $08110000
loc_0195B4:
        dc.w    $0004
        dc.l    $E80A0008, $0004FFE8, $E80A102C, $10160000
        dc.l    $000A1008, $1004FFE8, $000A002C, $00160000
loc_0195D6:
        dc.w    $0006
        dc.l    $E80A0008, $0004FFE8, $E80A102C, $10160000
        dc.l    $000A1008, $1004FFE8, $000A002C, $00160000
        dc.l    $F0010006, $00030018, $00011006, $10030018
loc_019608:
        dc.w    $0008
        dc.l    $E80A0008, $0004FFE8, $E80A102C, $10160000
        dc.l    $000A1008, $1004FFE8, $000A002C, $00160000
        dc.l    $F0010004, $00020018, $00011004, $10020018
        dc.l    $F0010006, $00030020, $00011006, $10030020        
;=============================================================================== 
; Object 0x48 - Cannon - Oil Ocean 
                
;===============================================================================   
        nop                     ; Filler
J_DisplaySprite_04: ; loc_01964C:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_MarkObjGone_09: ; loc_019652:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_0B: ; loc_019658:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x22 - Arrow Shooter - Neo Green Hill 
                 
;===============================================================================  
Obj22_Arrow_Shooter: ; loc_019660:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01966E(pc,d0), d1
        jmp     loc_01966E(pc,d1)
loc_01966E:
        dc.w    loc_019678-loc_01966E
        dc.w    loc_0196AC-loc_01966E
        dc.w    loc_0196F6-loc_01966E
        dc.w    loc_01973C-loc_01966E
        dc.w    loc_019780-loc_01966E
loc_019678:
        addq.b  #2,routine(a0)
        move.l  #Arrow_Shooter_Mappings,mappings(a0) ; loc_0197C6
        move.w  #$417,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0C ; loc_019844
        ori.b   #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $001A(a0)
        andi.b  #$F, subtype(a0)
loc_0196AC:
        cmpi.b  #$2, $001C(a0)
        beq.s   loc_0196D2
        moveq   #0, D2
        lea     (MainCharacter).w, A1
        bsr.s   loc_0196E0
        lea     (Sidekick).w, A1
        bsr.s   loc_0196E0
        tst.b   D2
        bne.s   loc_0196CE
        tst.b   $001C(a0)
        beq.s   loc_0196CE
        moveq   #$2, D2
loc_0196CE:
        move.b  D2, $001C(a0)
loc_0196D2:
        lea     (loc_0197B0), A1
        bsr     J_AnimateSprite_01      ; loc_01983E
        bra     J_MarkObjGone_0A        ; loc_019838
loc_0196E0:
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_0196EC
        neg.w   D0
loc_0196EC:
        cmpi.w  #$40, d0
        bcc.s   loc_0196F4
        moveq   #1, D2
loc_0196F4:
        rts
loc_0196F6:
        bsr     J_SingleObjectLoad_02   ; loc_019832
        bne.s   loc_01972A
        move.b  0(A0), 0(a1)
        addq.b  #6, $0024(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  status(a0), status(a1)
loc_01972A:
        subq.b  #2,routine(a0)
        lea     (loc_0197B0), A1
        bsr     J_AnimateSprite_01      ; loc_01983E
        bra     J_MarkObjGone_0A        ; loc_019838
loc_01973C:
        addq.b  #2,routine(a0)
        move.b  #8, y_radius(a0)
        move.b  #$10, $0017(a0)
        move.b  #4, $0018(a0)
        move.b  #$9B,collision_flags(a0)
        move.b  #8,width_pixels(a0)
        move.b  #0, $001A(a0)
        move.w  #$400,x_vel(a0)
        btst    #0, status(a0)
        beq.s   loc_019776
        neg.w  x_vel(a0)
loc_019776:
        move.w  #$0AE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_019780:
        bsr     J_SpeedToPos_07         ; loc_01984A
        btst    #0, status(a0)
        bne.s   loc_0197A0
        moveq   #Graphics_Flags, d3
        bsr     ObjHitWallLeft          ; loc_013B24
        tst.w   d1
        bmi     loc_01979C
        bra     J_MarkObjGone_0A        ; loc_019838
loc_01979C:
        bra     J_DeleteObject_13       ; loc_01982C
loc_0197A0:
        moveq   #8, d3
        bsr     ObjHitWallRight         ; loc_01399E
        tst.w   d1
        bmi     loc_01979C
        bra     J_MarkObjGone_0A        ; loc_019838
loc_0197B0:        
        dc.w    loc_0197B6-loc_0197B0
        dc.w    loc_0197B9-loc_0197B0
        dc.w    loc_0197BD-loc_0197B0
loc_0197B6:
        dc.b    $1F, $01, $FF
loc_0197B9:
        dc.b    $03, $01, $02, $FF
loc_0197BD:
        dc.b    $07, $03, $04, $FC, $04, $03, $01, $FD, $00
Arrow_Shooter_Mappings:        
loc_0197C6:
        dc.w    loc_0197D0-loc_0197C6
        dc.w    loc_0197DA-loc_0197C6
        dc.w    loc_0197EC-loc_0197C6
        dc.w    loc_019806-loc_0197C6
        dc.w    loc_019818-loc_0197C6
loc_0197D0:
        dc.w    $0001
        dc.l    $FC0C2000, $2000FFF0
loc_0197DA:
        dc.w    $0002
        dc.l    $F8092004, $2002FFF0, $F801200B, $20050008
loc_0197EC:
        dc.w    $0003
        dc.l    $FC00000A, $0005FFFC, $F8092004, $2002FFF0
        dc.l    $F801200B, $20050008
loc_019806:
        dc.w    $0002
        dc.l    $F8092004, $2002FFF0, $F801200D, $20060008
loc_019818:
        dc.w    $0002
        dc.l    $F8092004, $2002FFF0, $F801200F, $20070008
;=============================================================================== 
; Object 0x22 - Arrow Shooter - Neo Green Hill 
                
;===============================================================================          
        nop                     ; Filler
J_DeleteObject_13: ; loc_01982C:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_02: ; loc_019832:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_MarkObjGone_0A: ; loc_019838:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_01: ; loc_01983E:
        jmp     AnimateSprite           ; (loc_00D412)
J_ModifySpriteAttr_2P_0C: ; loc_019844:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SpeedToPos_07: ; loc_01984A:
        jmp     SpeedToPos              ; (loc_00D27A)                     
;=============================================================================== 
; Object 0x23 - Neo Green Hill - Pillar That Drops Lower Half 
                 
;=============================================================================== 
Obj23_Pillar: ; loc_019850:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01985E(pc,d0), d1
        jmp     loc_01985E(pc,d1)
loc_01985E:
        dc.w    loc_019862-loc_01985E
        dc.w    loc_0198E6-loc_01985E
loc_019862:
        addq.b  #2,routine(a0)
        move.l  #Pillar_Mappings,mappings(a0) ; loc_0199AA
        move.w  #$2000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0D ; loc_01A0B0
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$20, y_radius(a0)
        move.b  #4, $0018(a0)
        bsr     J_S1SingleObjectLoad_03  ; loc_01A0AA
        bne.s   loc_0198E6
        move.b  0(A0), 0(a1)
        addq.b  #$2, $0024(a1)
        addq.b  #$2, $0025(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  x_pos(a0), Objoff_30(a1)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$030, y_pos(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #$10, y_radius(a1)
        move.b  #4, $0018(a1)
        move.b  #1, $001A(a1)
loc_0198E6:
        move.w  x_pos(a0), -(A7)
        bsr     loc_01990C
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  (A7)+, D4
        bsr     J_SolidObject_05        ; loc_01A0B6
        bra     J_MarkObjGone_0B        ; loc_01A0A4
loc_01990C:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01991A(pc,d0), d1
        jmp     loc_01991A(pc,d1)         
loc_01991A:
        dc.w    loc_019950-loc_01991A
        dc.w    loc_019922-loc_01991A
        dc.w    loc_019952-loc_01991A
        dc.w    loc_01997C-loc_01991A
loc_019922:
        tst.w   (Debug_placement_mode).w
        bne.s   loc_019950
        lea     (MainCharacter).w, A1
        bsr.s   loc_019932
        lea     (Sidekick).w, A1
loc_019932:
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_01993E
        neg.w   D0
loc_01993E:
        cmpi.w  #$080, d0
        bcc.s   loc_019950
        move.b  #4, $0025(a0)
        move.w  #8, Objoff_34(a0)
loc_019950:
        rts
loc_019952:
        move.w  Objoff_34(A0), D0
        subq.w  #1,d0
        bcc.s   loc_019960
        addq.b  #$2, $0025(a0)
        rts
loc_019960:
        move.w  d0, Objoff_34(a0)
        move.b  loc_019974(pc,d0), D0
        ext.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        rts
loc_019974:
        dc.b    $00, $01, $FF, $01, $00, $FF, $00, $01
loc_01997C:
        bsr     J_SpeedToPos_08         ; loc_01A0BC
        addi.w  #$038, $0012(a0)
        bsr     ObjHitFloor             ; loc_013898
        tst.w   d1
        bpl     loc_0199A8
        add.w   d1, y_pos(a0)
        clr.w   $0012(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  #$2, $001A(a0)
        clr.b   $0025(a0)
loc_0199A8:
        rts
Pillar_Mappings:        
loc_0199AA:        
        dc.w    loc_0199B0-loc_0199AA
        dc.w    loc_0199E2-loc_0199AA
        dc.w    loc_0199FC-loc_0199AA
loc_0199B0:
        dc.w    $0006
        dc.l    $E005005D, $002EFFE0, $E005085D, $082E0010
        dc.l    $E00D0061, $0030FFF0, $F00D0069, $0034FFF0
        dc.l    $000D0069, $0034FFF0, $100D0071, $0038FFF0
loc_0199E2:
        dc.w    $0003
        dc.l    $F00D0069, $0034FFF0, $000D0079, $003CFFF0
        dc.l    $10040081, $0040FFF0
loc_0199FC:
        dc.w    $0004
        dc.l    $090D208B, $2045FFF0, $F00D0069, $0034FFF0
        dc.l    $000D0079, $003CFFF0, $10040081, $0040FFF0
;=============================================================================== 
; Object 0x23 - Neo Green Hill - Pillar That Drops Lower Half 
                
;===============================================================================         
;=============================================================================== 
; Object 0x2B - Neo Green Hill - Breakable Pillar
                 
;===============================================================================               
Obj2B_Breakable_Pillar: ; loc_019A1E:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_019A2C(pc,d0), d1
        jmp     loc_019A2C(pc,d1)
loc_019A2C:
        dc.w    loc_019A32-loc_019A2C
        dc.w    loc_019A60-loc_019A2C
        dc.w    loc_019B50-loc_019A2C
loc_019A32:
        addq.b  #2,routine(a0)
        move.l  #Breakable_Pillar_Mappings,mappings(a0) ; loc_019C30
        move.w  #$2000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0D ; loc_01A0B0
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$18, y_radius(a0)
        move.b  #4, $0018(a0)
loc_019A60:
        move.w  x_pos(a0), -(A7)
        bsr     loc_019AEA
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  (A7)+, D4
        bsr     J_SolidObject_05        ; loc_01A0B6
        move.b  status(a0), D0
        andi.b  #$18, d0
        bne     loc_019A92
        bra     J_MarkObjGone_0B        ; loc_01A0A4
loc_019A92:
        lea     (loc_019B80), A4
        lea     (loc_019B72), A2
        addq.b  #$7, $001A(a0)
        bsr     loc_019BB8
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        bsr.s   loc_019AB8
        lea     (Sidekick).w, A1
        addq.b  #1, D6
        bra     loc_019B50
loc_019AB8:
        bclr    d6, status(a0)
        beq.s   loc_019AE8
        bset    #$2, status(a1)
        move.b  #$E, y_radius(a1)
        move.b  #$7, $0017(a1)
        move.b  #$2, $001C(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$2, $0024(a1)
loc_019AE8:
        rts
loc_019AEA:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_019AF8(pc,d0), d1
        jmp     loc_019AF8(pc,d1)
loc_019AF8:
        dc.w    loc_019AFE-loc_019AF8
        dc.w    loc_019B28-loc_019AF8
        dc.w    loc_019B26-loc_019AF8
loc_019AFE:
        tst.w   (Debug_placement_mode).w
        bne.s   loc_019B26
        lea     (MainCharacter).w, A1
        bsr.s   loc_019B0E
        lea     (Sidekick).w, A1
loc_019B0E:
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_019B1A
        neg.w   D0
loc_019B1A:
        cmpi.w  #$40, d0
        bcc.s   loc_019B26
        move.b  #$2, $0025(a0)
loc_019B26:
        rts
loc_019B28:
        subq.w  #1, Objoff_34(a0)
        bcc.s   loc_019B4E
        move.w  #$003, Objoff_34(a0)
        subq.w  #4, y_pos(a0)
        addq.b  #4, y_radius(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #6, $001A(a0)
        bne.s   loc_019B4E
        move.b  #4, $0025(a0)
loc_019B4E:
        rts
loc_019B50:
        tst.b   Objoff_3F(a0)
        beq.s   loc_019B5C
        subq.b  #1, Objoff_3F(a0)
        bra.s   loc_019B66
loc_019B5C:
        bsr     J_SpeedToPos_08         ; loc_01A0BC
        addi.w  #$018, $0012(a0)
loc_019B66:
        tst.b   render_flags(a0)
        bpl     J_DeleteObject_14       ; loc_01A09E
        bra     J_DisplaySprite_05      ; loc_01A098
loc_019B72:
        dc.b    $00, $00, $00, $00, $04, $04, $08, $08, $0C, $0C, $10, $10, $14, $14        
loc_019B80:
        dc.w    $FE00, $FE00, $0200, $FE00, $FE40, $FE40, $01C0, $FE40
        dc.w    $FE80, $FE80, $0180, $FE80, $FEC0, $FEC0, $0140, $FEC0
        dc.w    $FF00, $FF00, $0100, $FF00, $FF40, $FF40, $00C0, $FF40
        dc.w    $FF80, $FF80, $0080, $FF80  
loc_019BB8:
        moveq	#0,d0
        move.b  $001A(A0), D0
        add.w   d0, d0
        move.l  mappings(A0), A3
        adda.w  $00(A3, d0), A3
        move.w  (A3)+, d1
        subq.w  #1,d1
        bset    #5,render_flags(a0)
        move.b  0(A0), D4
        move.b  render_flags(A0), D5
        move.l  A0, A1
        bra.s   loc_019BE6
loc_019BDE:        
        bsr     J_S1SingleObjectLoad_03  ; loc_01A0AA
        bne.s   loc_019C26
        addq.w  #8, A3
loc_019BE6:
        move.b  #4, $0024(a1)
        move.b  d4, 0(a1)
        move.l  A3, mappings(a1)
        move.b  d5, render_flags(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  $0018(A0), $0018(a1)
        move.b width_pixels(a0), $0019(a1)
        move.w  (A4)+,x_vel(a1)
        move.w  (A4)+, $0012(a1)
        move.b  (A2)+, Objoff_3F(a1)
        dbra    d1, loc_019BDE
loc_019C26:
        move.w  #$0CB, d0
        jmp     (Play_Sfx)              ; loc_0014C6  
Breakable_Pillar_Mappings:                             
loc_019C30:
        dc.w    loc_019C4C-loc_019C30
        dc.w    loc_019C7E-loc_019C30
        dc.w    loc_019CB8-loc_019C30
        dc.w    loc_019CF2-loc_019C30
        dc.w    loc_019D34-loc_019C30
        dc.w    loc_019D76-loc_019C30
        dc.w    loc_019DC0-loc_019C30
        dc.w    loc_019E0A-loc_019C30
        dc.w    loc_019E4C-loc_019C30
        dc.w    loc_019E9E-loc_019C30
        dc.w    loc_019EF0-loc_019C30
        dc.w    loc_019F52-loc_019C30
        dc.w    loc_019FB4-loc_019C30
        dc.w    loc_01A026-loc_019C30
loc_019C4C:
        dc.w    $0006
        dc.l    $100D208B, $2045FFF0, $E805005D, $002EFFE0
        dc.l    $E805085D, $082E0010, $E80D0061, $0030FFF0
        dc.l    $F80D0069, $0034FFF0, $080D0083, $0041FFF0
loc_019C7E:
        dc.w    $0007
        dc.l    $140D208B, $2045FFF0, $E405005D, $002EFFE0
        dc.l    $E405085D, $082E0010, $E40D0061, $0030FFF0
        dc.l    $F40D0069, $0034FFF0, $FC0D0069, $0034FFF0
        dc.l    $0C0D0083, $0041FFF0
loc_019CB8:
        dc.w    $0007
        dc.l    $180D208B, $2045FFF0, $E005005D, $002EFFE0
        dc.l    $E005085D, $082E0010, $E00D0061, $0030FFF0
        dc.l    $F00D0069, $0034FFF0, $000D0069, $0034FFF0
        dc.l    $100D0083, $0041FFF0
loc_019CF2:
        dc.w    $0008
        dc.l    $1C0D208B, $2045FFF0, $DC05005D, $002EFFE0
        dc.l    $DC05085D, $082E0010, $DC0D0061, $0030FFF0
        dc.l    $EC0D0069, $0034FFF0, $FC0D0069, $0034FFF0
        dc.l    $040D0069, $0034FFF0, $140D0083, $0041FFF0
loc_019D34:
        dc.w    $0008
        dc.l    $200D208B, $2045FFF0, $D805005D, $002EFFE0
        dc.l    $D805085D, $082E0010, $D80D0061, $0030FFF0
        dc.l    $E80D0069, $0034FFF0, $F80D0069, $0034FFF0
        dc.l    $080D0069, $0034FFF0, $180D0083, $0041FFF0
loc_019D76:
        dc.w    $0009
        dc.l    $240D208B, $2045FFF0, $D405005D, $002EFFE0
        dc.l    $D405085D, $082E0010, $D40D0061, $0030FFF0
        dc.l    $E40D0069, $0034FFF0, $F40D0069, $0034FFF0
        dc.l    $040D0069, $0034FFF0, $0C0D0069, $0034FFF0
        dc.l    $1C0D0083, $0041FFF0
loc_019DC0:
        dc.w    $0009
        dc.l    $280D208B, $2045FFF0, $D005005D, $002EFFE0
        dc.l    $D005085D, $082E0010, $D00D0061, $0030FFF0
        dc.l    $E00D0069, $0034FFF0, $F00D0069, $0034FFF0
        dc.l    $000D0069, $0034FFF0, $100D0069, $0034FFF0
        dc.l    $200D0083, $0041FFF0
loc_019E0A:
        dc.w    $0008
        dc.l    $E805005D, $002EFFE0, $E805085D, $082E0010
        dc.l    $E8050061, $0030FFF0, $E8050065, $00320000
        dc.l    $F8050069, $0034FFF0, $F805006D, $00360000
        dc.l    $08050083, $0041FFF0, $08050087, $00430000
loc_019E4C:
        dc.w    $000A
        dc.l    $E405005D, $002EFFE0, $E405085D, $082E0010
        dc.l    $E4050061, $0030FFF0, $E4050065, $00320000
        dc.l    $F4050069, $0034FFF0, $F405006D, $00360000
        dc.l    $FC050069, $0034FFF0, $FC05006D, $00360000
        dc.l    $0C050083, $0041FFF0, $0C050087, $00430000
loc_019E9E:
        dc.w    $000A
        dc.l    $E005005D, $002EFFE0, $E005085D, $082E0010
        dc.l    $E0050061, $0030FFF0, $E0050065, $00320000
        dc.l    $F0050069, $0034FFF0, $F005006D, $00360000
        dc.l    $00050069, $0034FFF0, $0005006D, $00360000
        dc.l    $10050083, $0041FFF0, $10050087, $00430000
loc_019EF0:
        dc.w    $000C
        dc.l    $DC05005D, $002EFFE0, $DC05085D, $082E0010
        dc.l    $DC050061, $0030FFF0, $DC050065, $00320000
        dc.l    $EC050069, $0034FFF0, $EC05006D, $00360000
        dc.l    $FC050069, $0034FFF0, $FC05006D, $00360000
        dc.l    $04050069, $0034FFF0, $0405006D, $00360000
        dc.l    $14050083, $0041FFF0, $14050087, $00430000
loc_019F52:
        dc.w    $000C
        dc.l    $D805005D, $002EFFE0, $D805085D, $082E0010
        dc.l    $D8050061, $0030FFF0, $D8050065, $00320000
        dc.l    $E8050069, $0034FFF0, $E805006D, $00360000
        dc.l    $F8050069, $0034FFF0, $F805006D, $00360000
        dc.l    $08050069, $0034FFF0, $0805006D, $00360000
        dc.l    $18050083, $0041FFF0, $18050087, $00430000
loc_019FB4:
        dc.w    $000E
        dc.l    $D405005D, $002EFFE0, $D405085D, $082E0010
        dc.l    $D4050061, $0030FFF0, $D4050065, $00320000
        dc.l    $E4050069, $0034FFF0, $E405006D, $00360000
        dc.l    $F4050069, $0034FFF0, $F405006D, $00360000
        dc.l    $04050069, $0034FFF0, $0405006D, $00360000
        dc.l    $0C050069, $0034FFF0, $0C05006D, $00360000
        dc.l    $1C050083, $0041FFF0, $1C050087, $00430000
loc_01A026:
        dc.w    $000E
        dc.l    $D005005D, $002EFFE0, $D005085D, $082E0010
        dc.l    $D0050061, $0030FFF0, $D0050065, $00320000
        dc.l    $E0050069, $0034FFF0, $E005006D, $00360000
        dc.l    $F0050069, $0034FFF0, $F005006D, $00360000
        dc.l    $00050069, $0034FFF0, $0005006D, $00360000
        dc.l    $10050069, $0034FFF0, $1005006D, $00360000
        dc.l    $20050083, $0041FFF0, $20050087, $00430000        
;=============================================================================== 
; Object 0x2B - Neo Green Hill - Breakable Pillar
                
;=============================================================================== 
J_DisplaySprite_05: ; loc_01A098:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_14: ; loc_01A09E:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_0B: ; loc_01A0A4:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_03: ; loc_01A0AA:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_0D: ; loc_01A0B0:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_05: ; loc_01A0B6:
        jmp     SolidObject             ; (loc_00F4A0)
J_SpeedToPos_08: ; loc_01A0BC:
        jmp     SpeedToPos              ; (loc_00D27A)
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x2C - Neo Green Hill - Leaves
                 
;===============================================================================          
Obj2C_Leaves: ; loc_01A0C4:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01A0D2(pc,d0), d1
        jmp     loc_01A0D2(pc,d1)
loc_01A0D2:
        dc.w    loc_01A0DC-loc_01A0D2
        dc.w    loc_01A112-loc_01A0D2
        dc.w    loc_01A234-loc_01A0D2
loc_01A0D8:
        dc.b    $d6, $d4, $d5, $00
loc_01A0DC:
        addq.b  #2,routine(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.b  loc_01A0D8(pc,d0),collision_flags(a0)
        move.l  #Lava_Attributes_Mappings,mappings(a0) ; loc_015612
        move.w  #$8680,art_tile(a0)
        move.b  #$84,render_flags(a0)
        move.b  #$80,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  subtype(A0), $001A(a0)
loc_01A112:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_15       ; loc_01A2F2
        tst.w   (Debug_placement_mode).w
        beq.s   loc_01A130
        bsr     J_DisplaySprite_06      ; loc_01A2EC
loc_01A130:
        move.b  $0021(A0), D0
        beq.s   loc_01A16C
        move.b  ($FFFFFE05).w, d0
        andi.w  #$F, d0
        bne.s   loc_01A150
        lea     (MainCharacter).w, a2
        bclr    #0, $0021(a0)
        beq.s   loc_01A168
        bsr.s   loc_01A16E
        bra.s   loc_01A168
loc_01A150:
        addi.w  #8, d0
        andi.w  #$F, d0
        bne.s   loc_01A168
        lea     (Sidekick).w, a2
        bclr    #1, $0021(a0)
        beq.s   loc_01A168
        bsr.s   loc_01A16E
loc_01A168:
        clr.b   $0021(a0)
loc_01A16C:
        rts
loc_01A16E:
        move.w x_vel(A2), D0
        bpl.s   loc_01A176
        neg.w   D0
loc_01A176:
        cmpi.w  #$200, d0
        bcc.s   loc_01A18A
        move.w  $0012(A2), D0
        bpl.s   loc_01A184
        neg.w   D0
loc_01A184:
        cmpi.w  #$200, d0
        bcs.s   loc_01A16C
loc_01A18A:
        lea     (loc_01A224), A3
        moveq   #3, D6
loc_01A192:        
        bsr     J_SingleObjectLoad_03   ; loc_01A2F8
        bne     loc_01A21E
        move.b  #$2C, 0(a1)
        move.b  #4, $0024(a1)
        move.w  x_pos(A2), x_pos(a1)
        move.w  y_pos(A2), y_pos(a1)
        bsr     loc_01A2FE
        andi.w  #$F, d0
        subq.w  #8,d0
        add.w   d0, x_pos(a1)
        swap.w  D0
        andi.w  #$F, d0
        subq.w  #8,d0
        add.w   d0, y_pos(a1)
        move.w  (A3)+,x_vel(a1)
        move.w  (A3)+, $0012(a1)
        btst    #0, status(a2)
        beq.s   loc_01A1E0
        neg.w  x_vel(a1)
loc_01A1E0:
        move.w  x_pos(A1), Objoff_30(a1)
        move.w  y_pos(A1), Objoff_34(a1)
        andi.b  #1,d0
        move.b  d0, $001A(a1)
        move.l  #Leaves_Mappings, mappings(a1) ; loc_01A2BC
        move.w  #$E410, art_tile(a1)
        move.b  #$84, render_flags(a1)
        move.b  #8, $0019(a1)
        move.b  #1, $0018(a1)
        move.b  #4, objoff_38(a1)
        move.b  d1,angle(a0)
loc_01A21E:
        dbra    d6, loc_01A192
        rts  
loc_01A224:
        dc.w    $FF80, $FF80, $00C0, $FFC0, $FF40, $0040, $0080, $0080
loc_01A234:
        move.b  objoff_38(A0), D0
        add.b   d0,angle(a0)
        add.b   ($FFFFFE0F).w, d0
        andi.w  #$01F, d0
        bne.s   loc_01A252
        add.b   d7, d0
        andi.b  #1,d0
        beq.s   loc_01A252
        neg.b   objoff_38(a0)
loc_01A252:
        move.l  Objoff_30(A0), D2
        move.l  Objoff_34(A0), D3
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, Objoff_30(a0)
        move.l  d3, Objoff_34(a0)
        swap.w  D2
        andi.w  #$003, d3
        addq.w  #4, d3
        add.w   d3, $0012(a0)
        move.b  angle(A0), D0
        bsr     loc_01A304
        asr.w   #6, d0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        asr.w   #6, d1
        add.w   Objoff_34(A0), d1
        move.w  d1, y_pos(a0)
        subq.b  #1, $001E(a0)
        bpl.s   loc_01A2B0
        move.b  #$B, $001E(a0)
        bchg    #1, $001A(a0)
loc_01A2B0:
        tst.b   render_flags(a0)
        bpl     J_DeleteObject_15       ; loc_01A2F2
        bra     J_DisplaySprite_06      ; loc_01A2EC
Leaves_Mappings:        
loc_01A2BC:
        dc.w    loc_01A2C4-loc_01A2BC
        dc.w    loc_01A2CE-loc_01A2BC
        dc.w    loc_01A2D8-loc_01A2BC
        dc.w    loc_01A2E2-loc_01A2BC
loc_01A2C4:
        dc.w    $0001
        dc.l    $FC000000, $0000FFFC
loc_01A2CE:
        dc.w    $0001
        dc.l    $FC040001, $0000FFF8
loc_01A2D8:
        dc.w    $0001
        dc.l    $FC040003, $0001FFF8
loc_01A2E2:
        dc.w    $0001
        dc.l    $FC040005, $0002FFF8                    
;=============================================================================== 
; Object 0x2C - Neo Green Hill - Leaves
                
;===============================================================================           
J_DisplaySprite_06: ; loc_01A2EC:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_15: ; loc_01A2F2:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_03: ; loc_01A2F8:
        jmp     SingleObjectLoad        ; (loc_00E772)
loc_01A2FE:
        jmp     PseudoRandomNumber      ; loc_0031E4
loc_01A304:
        jmp     CalcSine        ; loc_00320A  
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x40 - Chemical Plant / Neo Green Hill - Springs 
                 
;===============================================================================  
Obj40_Diagonal_Springs: ; loc_01A30C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01A31E(pc,d0), d1
        jsr     loc_01A31E(pc,d1)
        bra     J_MarkObjGone_0C        ; loc_01A5B4
loc_01A31E:
        dc.w    loc_01A328-loc_01A31E
        dc.w    loc_01A364-loc_01A31E
loc_01A322:
        dc.w    $FC00, $F600, $F800
loc_01A328:
        addq.b  #2,routine(a0)
        move.l  #Diagonal_Spring_Mappings,mappings(a0) ; loc_01A58A
        move.w  #$440,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_0E ; loc_01A5C0
        ori.b   #4,render_flags(a0)
        move.b  #$1C,width_pixels(a0)
        move.b  #4, $0018(a0)
        bset    #$7, status(a0)
        move.b  subtype(A0), D0
        andi.w  #$002, d0
        move.w  loc_01A322(pc,d0), Objoff_30(a0)
loc_01A364:
        lea     (loc_01A57E), A1
        bsr     J_AnimateSprite_02      ; loc_01A5BA
        move.w  #$027, d1
        move.w  #8, D2
        move.w  x_pos(a0), D4
        lea     loc_01A52E(PC), A2
        tst.b   $001A(a0)
        beq.s   loc_01A388
        lea     loc_01A556(PC), A2
loc_01A388:
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_01A5C6
        btst    #3, status(a0)
        beq.s   loc_01A3A0
        bsr.s   loc_01A3BA
loc_01A3A0:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_01A5C6
        btst    #4, status(a0)
        beq.s   loc_01A3B8
        bsr.s   loc_01A3BA
loc_01A3B8:
        rts
loc_01A3BA:
        btst    #0, status(a0)
        bne.s   loc_01A3D2
        move.w  x_pos(a0), D0
        subi.w  #$010, d0
        cmp.w   x_pos(A1), D0
        bcs.s   loc_01A3E2
        rts
loc_01A3D2:
        move.w  x_pos(a0), D0
        addi.w  #$010, d0
        cmp.w   x_pos(A1), D0
        bcc.s   loc_01A3E2
        rts
loc_01A3E2:
        cmpi.b  #1, $001C(a0)
        beq.s   loc_01A3F2
        move.w  #$100, $001C(a0)
        rts
loc_01A3F2:
        tst.b   $001A(a0)
        beq.s   loc_01A3FA
        rts
loc_01A3FA:
        move.w  x_pos(a0), D0
        subi.w  #$1C, d0
        sub.w   x_pos(A1), D0
        neg.w   D0
        btst    #0, status(a0)
        beq.s   loc_01A416
        not.w  D0
        addi.w  #$027, d0
loc_01A416:
        tst.w   D0
        bpl.s   loc_01A41C
        moveq	#0,d0
loc_01A41C:
        lea     (loc_01A4E6), A3
        move.b  $00(A3, d0), D0
        move.w  #$FC00, $0012(a1)
        sub.b   d0, $0012(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_01A446
        bclr    #0, status(a1)
        neg.b   D0
loc_01A446:
        move.w x_vel(A1), d1
        bpl.s   loc_01A44E
        neg.w   d1
loc_01A44E:
        cmpi.w  #$400, d1
        bcs.s   loc_01A458
        sub.b   d0,x_vel(a1)
loc_01A458:
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        btst    #0, d0
        beq.s   loc_01A4B4
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0
        bne.s   loc_01A4A4
        move.b  #3, $002C(a1)
loc_01A4A4:
        btst    #0, status(a1)
        beq.s   loc_01A4B4
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_01A4B4:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_01A4CA
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_01A4CA:
        cmpi.b  #8,d0
        bne.s   loc_01A4DC
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_01A4DC:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6   
loc_01A4E6:
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $01, $01, $01, $01, $01, $01, $01, $01
        dc.b    $01, $01, $01, $01, $01, $01, $01, $01, $02, $02, $02, $02, $02, $02, $02, $02
        dc.b    $03, $03, $03, $03, $03, $03, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00   
loc_01A52E:
        dc.b    $08, $08, $08, $08, $08, $08, $08, $09, $0A, $0B, $0C, $0D, $0E, $0F, $10, $10
        dc.b    $11, $12, $13, $14, $14, $15, $15, $16, $17, $18, $18, $18, $18, $18, $18, $18
        dc.b    $18, $18, $18, $18, $18, $18, $18, $18      
loc_01A556:
        dc.b    $08, $08, $08, $08, $08, $08, $08, $09, $0A, $0B, $0C, $0C, $0C, $0C, $0D, $0D
        dc.b    $0D, $0D, $0D, $0D, $0E, $0E, $0F, $0F, $10, $10, $10, $10, $0F, $0F, $0E, $0E
        dc.b    $0D, $0D, $0D, $0D, $0D, $0D, $0D, $0D        
loc_01A57E:
        dc.w    loc_01A582-loc_01A57E
        dc.w    loc_01A585-loc_01A57E
loc_01A582:
        dc.b    $0F, $00, $FF
loc_01A585:
        dc.b    $03, $01, $00, $FD, $00 
Diagonal_Spring_Mappings:                                 
loc_01A58A:
        dc.w    loc_01A58E-loc_01A58A
        dc.w    loc_01A5A0-loc_01A58A   
loc_01A58E:
        dc.w    $0002
        dc.l    $E8090000, $0000FFE4, $E80D0006, $0003FFFC
loc_01A5A0:
        dc.w    $0002
        dc.l    $E809000E, $0007FFE4, $E80D0014, $000AFFFC        
;=============================================================================== 
; Object 0x40 - Chemical Plant / Neo Green Hill - Springs 
                
;===============================================================================  
        nop
J_MarkObjGone_0C: ; loc_01A5B4:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_02: ; loc_01A5BA:
        jmp     AnimateSprite           ; (loc_00D412)
J_ModifySpriteAttr_2P_0E: ; loc_01A5C0:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01A5C6:
        jmp     (loc_00F562)
        
;=============================================================================== 
; Object 0x42 - Metropolis - Steam Vent 
                 
;===============================================================================          
Obj42_Steam_Vent: ; loc_01A5CC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01A5DA(pc,d0), d1
        jmp     loc_01A5DA(pc,d1)
loc_01A5DA:
        dc.w    loc_01A5E0-loc_01A5DA
        dc.w    loc_01A620-loc_01A5DA
        dc.w    loc_01A7CC-loc_01A5DA
loc_01A5E0:
        addq.b  #2,routine(a0)
        move.l  #Steam_Vent_Mappings,mappings(a0) ; loc_01A7FE
        move.w  #$6000,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        bsr     J_ModifySpriteAttr_2P_0F ; loc_01A8A8
        move.b  #$7, $001A(a0)
        move.w  y_pos(a0), Objoff_34(a0)
        move.w  #$010, objoff_36(a0)
        addi.w  #$010, y_pos(a0)
loc_01A620:
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_01A8AE
        btst    #3, status(a0)
        beq.s   loc_01A64A
        bsr     loc_01A726
loc_01A64A:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_01A8AE
        btst    #4, status(a0)
        beq.s   loc_01A664
        bsr     loc_01A726
loc_01A664:
        move.b  $0025(A0), D0
        bne.s   loc_01A67C
        subq.w  #1, $0032(a0)
        bpl.s   loc_01A6E0
        move.w  #$07F, $0032(a0)
        addq.b  #$2, $0025(a0)
        bra.s   loc_01A6E0
loc_01A67C:
        subq.b  #$2, d0
        bne.s   loc_01A6AE
        subq.w  #8, objoff_36(a0)
        bne.s   loc_01A6A0
        addq.b  #$2, $0025(a0)
        bsr.s   loc_01A6E4
        addi.w  #$028, x_pos(a1)
        bsr.s   loc_01A6E4
        subi.w  #$028, x_pos(a1)
        bset    #0, render_flags(a1)
loc_01A6A0:
        move.w  objoff_36(a0), D0
        add.w   Objoff_34(A0), D0
        move.w  d0, y_pos(a0)
        bra.s   loc_01A6E0
loc_01A6AE:
        subq.b  #$2, d0
        bne.s   loc_01A6C4
        subq.w  #1, $0032(a0)
        bpl.s   loc_01A6E0
        move.w  #$07F, $0032(a0)
        addq.b  #$2, $0025(a0)
        bra.s   loc_01A6E0
loc_01A6C4:
        addq.w  #8, objoff_36(a0)
        cmpi.w  #$010, objoff_36(a0)
        bne.s   loc_01A6D4
        clr.b   $0025(a0)
loc_01A6D4:
        move.w  objoff_36(a0), D0
        add.w   Objoff_34(A0), D0
        move.w  d0, y_pos(a0)
loc_01A6E0:
        bra     J_MarkObjGone_0D        ; loc_01A8A2
loc_01A6E4:
        bsr     J_SingleObjectLoad_04   ; loc_01A89C
        bne.s   loc_01A724
        move.b  0(A0), 0(a1)
        addq.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  Objoff_34(A0), y_pos(a1)
        move.b  #$7, $001E(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  #$2405, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #$18, $0019(a1)
        move.b  #4, $0018(a1)
loc_01A724:
        rts
loc_01A726:
        cmpi.b  #$2, $0025(a0)
        beq.s   loc_01A730
        rts
loc_01A730:
        move.w  #$FA00, $0012(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        bpl.s   loc_01A75A
        move.w  #0,x_vel(a1)
loc_01A75A:
        btst    #0, d0
        beq.s   loc_01A79A
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        btst    #1,d0
        bne.s   loc_01A78A
        move.b  #1, $002C(a1)
loc_01A78A:
        btst    #0, status(a1)
        beq.s   loc_01A79A
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_01A79A:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_01A7B0
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_01A7B0:
        cmpi.b  #8,d0
        bne.s   loc_01A7C2
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_01A7C2:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_01A7CC:
        subq.b  #1, $001E(a0)
        bpl.s   loc_01A7FA
        move.b  #$7, $001E(a0)
        move.b  #0,collision_flags(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #$2, $001A(a0)
        bne.s   loc_01A7F0
        move.b  #$8B,collision_flags(a0)
loc_01A7F0:
        cmpi.b  #$7, $001A(a0)
        beq     J_DeleteObject_16       ; loc_01A896
loc_01A7FA:
        bra     J_DisplaySprite_07      ; loc_01A890
Steam_Vent_Mappings:        
loc_01A7FE:
        dc.w    loc_01A80E-loc_01A7FE
        dc.w    loc_01A818-loc_01A7FE
        dc.w    loc_01A822-loc_01A7FE
        dc.w    loc_01A82C-loc_01A7FE
        dc.w    loc_01A83E-loc_01A7FE
        dc.w    loc_01A850-loc_01A7FE
        dc.w    loc_01A86A-loc_01A7FE
        dc.w    loc_01A87C-loc_01A7FE
loc_01A80E:
        dc.w    $0001
        dc.l    $FF000000, $0000FFE8
loc_01A818:
        dc.w    $0001
        dc.l    $FF040001, $0000FFE8
loc_01A822:
        dc.w    $0001
        dc.l    $FC050003, $0001FFEC
loc_01A82C:
        dc.w    $0002
        dc.l    $FC050007, $0003FFF8, $FC050003, $0001FFF0
loc_01A83E:
        dc.w    $0002
        dc.l    $FC051007, $10030000, $FC01100B, $1005FFF8
loc_01A850:
        dc.w    $0003
        dc.l    $FC01000D, $0006000C, $FC01000B, $00050004
        dc.l    $FC01180D, $1806FFFC
loc_01A86A:
        dc.w    $0002
        dc.l    $FC01000D, $00060010, $FC01180D, $18060008
loc_01A87C:
        dc.w    $0002
        dc.l    $F0070015, $000AFFF0, $F007001D, $000E0000            
;=============================================================================== 
; Object 0x42 - Metropolis - Steam Vent 
                
;===============================================================================          
        nop                     ; Filler
J_DisplaySprite_07: ; loc_01A890:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_16: ; loc_01A896:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_04: ; loc_01A89C:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_MarkObjGone_0D: ; loc_01A8A2:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_0F: ; loc_01A8A8:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01A8AE:
        jmp     (loc_00F510)   
;=============================================================================== 
; Object 0x64 - Metropolis - Pistons 
                 
;===============================================================================          
Obj64_Pistons: ; loc_01A8B4:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01A8C2(pc,d0), d1
        jmp     loc_01A8C2(pc,d1)
loc_01A8C2:
        dc.w    loc_01A8CE-loc_01A8C2
        dc.w    loc_01A936-loc_01A8C2
loc_01A8C6:
        dc.b    $40, $0C, $40, $01, $10, $20, $40, $01
loc_01A8CE:
        addq.b  #2,routine(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #$2, d0
        andi.w  #$1C, d0
        lea     loc_01A8C6(pc,d0), A3
        move.b  (A3)+,width_pixels(a0)
        move.b  (A3)+, $002E(a0)
        lsr.w   #$2, d0
        move.b  d0, $001A(a0)
        bne.s   loc_01A8FE
        move.b  #$6C, y_radius(a0)
        bset    #4,render_flags(a0)
loc_01A8FE:
        move.l  #Piston_Mappings,mappings(a0) ; loc_01A9F0
        move.w  #$2000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_10 ; loc_01AA68
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  (A3)+, D0
        move.w  d0, Objoff_3C(a0)
        andi.b  #$F, subtype(a0)
loc_01A936:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.w  loc_01A988(pc,d0), d1
        jsr     loc_01A988(pc,d1)
        move.w  (A7)+, D4
        tst.b   render_flags(a0)
        bpl.s   loc_01A96A
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  $002E(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_06        ; loc_01AA6E
loc_01A96A:
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_17       ; loc_01A982
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_17: ; loc_01A982:
        jmp     DeleteObject            ; (loc_00D3B4)   
loc_01A988:                      
        dc.w    loc_01A98C-loc_01A988
        dc.w    loc_01A98E-loc_01A988
loc_01A98C:
        rts
loc_01A98E:
        tst.b   objoff_38(a0)
        bne.s   loc_01A9B2
        tst.w   objoff_3A(a0)
        beq.s   loc_01A9A0
        subq.w  #8, objoff_3A(a0)
        bra.s   loc_01A9D2
loc_01A9A0:
        subq.w  #1, objoff_36(a0)
        bpl.s   loc_01A9D2
        move.w  #$03C, objoff_36(a0)
        move.b  #1, objoff_38(a0)
loc_01A9B2:
        move.w  objoff_3A(A0), D0
        cmp.w   Objoff_3C(a0), D0
        beq.s   loc_01A9C2
        addq.w  #8, objoff_3A(a0)
        bra.s   loc_01A9D2
loc_01A9C2:
        subq.w  #1, objoff_36(a0)
        bpl.s   loc_01A9D2
        move.w  #$03C, objoff_36(a0)
        clr.b   objoff_38(a0)
loc_01A9D2:
        move.w  objoff_3A(A0), D0
        btst    #0, status(a0)
        beq.s   loc_01A9E4
        neg.w   D0
        addi.w  #$40, d0
loc_01A9E4:
        move.w  Objoff_30(A0), d1
        add.w   d0, d1
        move.w  d1, y_pos(a0)
        rts           
Piston_Mappings:
loc_01A9F0:
        dc.w    loc_01A9F4-loc_01A9F0
        dc.w    loc_01AA46-loc_01A9F0
loc_01A9F4:
        dc.w    $000A
        dc.l    $F40E0001, $0000FFC0, $F40E0801, $0800FFE0
        dc.l    $F40E0001, $00000000, $F40E0801, $08000020
        dc.l    $0C07000D, $0006FFD8, $2C07000D, $0006FFD8
        dc.l    $4C07000D, $0006FFD8, $0C07000D, $00060018
        dc.l    $2C07000D, $00060018, $4C07000D, $00060018
loc_01AA46:
        dc.w    $0004
        dc.l    $E0070057, $002BFFF0, $E0070857, $082B0000
        dc.l    $00071057, $102BFFF0, $00071857, $182B0000  
;=============================================================================== 
; Object 0x64 - Metropolis - Pistons 
                
;===============================================================================          
J_ModifySpriteAttr_2P_10: ; loc_01AA68:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_06: ; loc_01AA6E:
        jmp     SolidObject             ; (loc_00F4A0)             
;=============================================================================== 
; Object 0x65 - Metropolis - Platform / Platform Over Gears
                 
;===============================================================================         
Obj65_Platform: ; loc_01AA74:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01AA82(pc,d0), d1
        jmp     loc_01AA82(pc,d1)
loc_01AA82:
        dc.w    loc_01AA9A-loc_01AA82
        dc.w    loc_01ABB0-loc_01AA82
        dc.w    loc_01AE08-loc_01AA82
        dc.w    loc_01AE26-loc_01AA82
loc_01AA8A:
        dc.b    $40, $0C, $80, $01, $20, $0C, $40, $03, $10, $10, $20, $00, $40, $0C, $80, $07
loc_01AA9A:
        addq.b  #2,routine(a0)
        move.l  #Mz_Platform_Mappings,mappings(a0) ; loc_01AE2C
        move.w  #$6000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_11 ; loc_01AEB0
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #$2, d0
        andi.w  #$1C, d0
        lea     loc_01AA8A(pc,d0), A3
        move.b  (A3)+,width_pixels(a0)
        move.b  (A3)+, y_radius(a0)
        lsr.w   #$2, d0
        move.b  d0, $001A(a0)
        cmpi.b  #1,d0
        bne.s   loc_01AAE6
        bset    #$7, status(a0)
loc_01AAE6:
        cmpi.b  #$2, d0
        bne.s   loc_01AB02
        addq.b  #4,routine(a0)
        move.l  #Obj65_Mappings_1,mappings(a0) ; loc_01AE68
        move.w  #$655F,art_tile(a0)
        bra     loc_01AE26
loc_01AB02:
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  (A3)+, D0
        move.w  d0, Objoff_3C(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        bpl     loc_01ABAA
        andi.b  #$F, d0
        move.b  d0, Objoff_3E(a0)
        move.b  (A3), subtype(a0)
        cmpi.b  #$7, (a3)
        bne.s   loc_01AB38
        move.w  Objoff_3C(a0), objoff_3A(a0)
loc_01AB38:
        bsr     J_S1SingleObjectLoad_04  ; loc_01AEAA
        bne.s   loc_01AB98
        move.b  0(A0), 0(a1)
        addq.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$FFB4, x_pos(a1)
        addi.w  #$014, y_pos(a1)
        btst    #0, status(a0)
        bne.s   loc_01AB74
        subi.w  #$FFE8, x_pos(a1)
        bset    #0, render_flags(a1)
loc_01AB74:
        move.l  #Obj65_Mappings_1, mappings(a1) ; loc_01AE68
        move.w  #$655F, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #4, $0018(a1)
        move.l  A0, $003C(a1)
loc_01AB98:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_01ABAA
        bclr    #$7, $02(A2, d0)
loc_01ABAA:
        andi.b  #$F, subtype(a0)
loc_01ABB0:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.w  loc_01AC0E(pc,d0), d1
        jsr     loc_01AC0E(pc,d1)
        move.w  (A7)+, D4
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_07        ; loc_01AEB6
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01ABF6
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01ABF6:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_18       ; loc_01AC08
        bclr    #$7, $02(A2, d0)
J_DeleteObject_18: ; loc_01AC08:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_01AC0E:
        dc.w    loc_01AC1E-loc_01AC0E
        dc.w    loc_01AC34-loc_01AC0E
        dc.w    loc_01ACC0-loc_01AC0E
        dc.w    loc_01AD1C-loc_01AC0E
        dc.w    loc_01ADC0-loc_01AC0E
        dc.w    loc_01ADCE-loc_01AC0E
        dc.w    loc_01AC20-loc_01AC0E
        dc.w    loc_01ACA0-loc_01AC0E
loc_01AC1E:
        rts
loc_01AC20:
        tst.b   objoff_38(a0)
        bne.s   loc_01AC32
        subq.w  #1, objoff_36(a0)
        bne.s   loc_01AC60
        move.b  #1, objoff_38(a0)
loc_01AC32:
        bra.s   loc_01AC52
loc_01AC34:
        tst.b   objoff_38(a0)
        bne.s   loc_01AC52
        lea     ($FFFFF7E0).w, a2
        moveq	#0,d0
        move.b  Objoff_3E(A0), D0
        btst    #0, $00(A2, d0)
        beq.s   loc_01AC60
        move.b  #1, objoff_38(a0)
loc_01AC52:
        move.w  Objoff_3C(a0), D0
        cmp.w   objoff_3A(A0), D0
        beq.s   loc_01AC7E
        addq.w  #$2, objoff_3A(a0)
loc_01AC60:
        move.w  objoff_3A(A0), D0
        btst    #0, status(a0)
        beq.s   loc_01AC72
        neg.w   D0
        addi.w  #$080, d0
loc_01AC72:
        move.w  Objoff_34(A0), d1
        sub.w   d0, d1
        move.w  d1, x_pos(a0)
        rts
loc_01AC7E:
        addq.b  #1, subtype(a0)
        move.w  #$0B4, objoff_36(a0)
        clr.b   objoff_38(a0)
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_01AC60
        bset    #0, $02(A2, d0)
        bra.s   loc_01AC60
loc_01ACA0:
        tst.b   objoff_38(a0)
        bne.s   loc_01ACBE
        lea     ($FFFFF7E0).w, a2
        moveq	#0,d0
        move.b  Objoff_3E(A0), D0
        btst    #0, $00(A2, d0)
        beq.s   loc_01ACDC
        move.b  #1, objoff_38(a0)
loc_01ACBE:
        bra.s   loc_01ACD2
loc_01ACC0:
        tst.b   objoff_38(a0)
        bne.s   loc_01ACD2
        subq.w  #1, objoff_36(a0)
        bne.s   loc_01ACDC
        move.b  #1, objoff_38(a0)
loc_01ACD2:
        tst.w   objoff_3A(a0)
        beq.s   loc_01ACFA
        subq.w  #$2, objoff_3A(a0)
loc_01ACDC:
        move.w  objoff_3A(A0), D0
        btst    #0, status(a0)
        beq.s   loc_01ACEE
        neg.w   D0
        addi.w  #$080, d0
loc_01ACEE:
        move.w  Objoff_34(A0), d1
        sub.w   d0, d1
        move.w  d1, x_pos(a0)
        rts
loc_01ACFA:
        subq.b  #1, subtype(a0)
        move.w  #$0B4, objoff_36(a0)
        clr.b   objoff_38(a0)
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_01ACDC
        bclr    #0, $02(A2, d0)
        bra.s   loc_01ACDC
loc_01AD1C:
        move.w  Objoff_34(A0), D4
        move.w  d4,d5
        btst    #0, status(a0)
        bne.s   loc_01AD34
        subi.w  #$20, D4
        addi.w  #$060,d5
        bra.s   loc_01AD3C
loc_01AD34:
        subi.w  #$0A0, D4
        subi.w  #$20,d5
loc_01AD3C:
        move.w  y_pos(a0), D2
        move.w  D2, d3
        subi.w  #$010, D2
        addi.w  #$40, d3
        moveq   #0,d1
        move.w  (MainCharacter+x_pos).w, d0
        cmp.w   d4, d0
        bcs.s   loc_01AD66
        cmp.w   d5, d0
        bcc.s   loc_01AD66
        move.w  ($FFFFB00C).w, d0
        cmp.w   d2, d0
        bcs.s   loc_01AD66
        cmp.w   d3, d0
        bcc.s   loc_01AD66
        moveq   #1,d1
loc_01AD66:
        move.w  ($FFFFB048).w, d0
        cmp.w   d4, d0
        bcs.s   loc_01AD80
        cmp.w   d5, d0
        bcc.s   loc_01AD80
        move.w  ($FFFFB04C).w, d0
        cmp.w   d2, d0
        bcs.s   loc_01AD80
        cmp.w   d3, d0
        bcc.s   loc_01AD80
        moveq   #1,d1
loc_01AD80:
        tst.b   d1
        beq.s   loc_01AD96
        move.w  Objoff_3C(a0), D0
        cmp.w   objoff_3A(A0), D0
        beq.s   loc_01ADBE
        addi.w  #$010, objoff_3A(a0)
        bra.s   loc_01ADA2
loc_01AD96:
        tst.w   objoff_3A(a0)
        beq.s   loc_01ADA2
        subi.w  #$010, objoff_3A(a0)
loc_01ADA2:
        move.w  objoff_3A(A0), D0
        btst    #0, status(a0)
        beq.s   loc_01ADB4
        neg.w   D0
        addi.w  #$40, d0
loc_01ADB4:
        move.w  Objoff_34(A0), d1
        sub.w   d0, d1
        move.w  d1, x_pos(a0)
loc_01ADBE:
        rts
loc_01ADC0:
        btst    #3, status(a0)
        beq.s   loc_01ADCC
        addq.b  #1, subtype(a0)
loc_01ADCC:
        rts
loc_01ADCE:
        tst.b   objoff_38(a0)
        bne.s   loc_01ADE8
        addq.w  #$2, x_pos(a0)
        cmpi.w  #$1B40, x_pos(a0)
        bne.s   loc_01ADFA
        move.b  #1, objoff_38(a0)
        bra.s   loc_01ADFA
loc_01ADE8:
        subq.w  #$2, x_pos(a0)
        cmpi.w  #$1800, x_pos(a0)
        bne.s   loc_01ADFA
        move.b  #0, objoff_38(a0)
loc_01ADFA:
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  x_pos(a0), ($FFFFF7B0).w
        rts
loc_01AE08:
        move.l  Objoff_3C(a0), A1
        move.w  objoff_3A(A1), D0
loc_01AE10:        
        andi.w  #$007, d0
        move.b  loc_01AE1E(pc,d0), $001A(a0)
        bra     J_MarkObjGone_0E        ; loc_01AEA4    
loc_01AE1E:
        dc.b    $00, $00, $02, $02, $02, $01, $01, $01
loc_01AE26:
        move.w  ($FFFFF7B0).w, d0
        bra.s   loc_01AE10  
Mz_Platform_Mappings:        
loc_01AE2C:
        dc.w    loc_01AE34-loc_01AE2C
        dc.w    loc_01AE56-loc_01AE2C
        dc.w    loc_01AE34-loc_01AE2C
        dc.w    loc_01AE34-loc_01AE2C
loc_01AE34:
        dc.w    $0004
        dc.l    $F40E004B, $0025FFC0, $F40E004B, $0025FFE0
        dc.l    $F40E004B, $00250000, $F40E004B, $00250020
loc_01AE56:
        dc.w    $0002
        dc.l    $F40E0039, $001CFFE0, $F40E0839, $081C0000  
Obj65_Mappings_1:        
loc_01AE68:
        dc.w    loc_01AE6E-loc_01AE68
        dc.w    loc_01AE80-loc_01AE68
        dc.w    loc_01AE92-loc_01AE68
loc_01AE6E:
        dc.w    $0002
        dc.l    $F4060000, $0000FFF0, $F4060800, $08000000
loc_01AE80:
        dc.w    $0002
        dc.l    $F4060006, $0003FFF0, $F4061806, $18030000
loc_01AE92:
        dc.w    $0002
        dc.l    $F4061006, $1003FFF0, $F4060806, $08030000                            
;=============================================================================== 
; Object 0x65 - Metropolis - Platform Over Gears
                
;===============================================================================          
J_MarkObjGone_0E: ; loc_01AEA4:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_04: ; loc_01AEAA:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_11: ; loc_01AEB0:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_07: ; loc_01AEB6:
        jmp     SolidObject             ; (loc_00F4A0)     
;=============================================================================== 
; Object 0x66 - Metropolis - Springs on Walls
                 
;===============================================================================           
Obj66_Spring_Wall: ; loc_01AEBC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01AECA(pc,d0), d1
        jmp     loc_01AECA(pc,d1)
loc_01AECA:
        dc.w    loc_01AECE-loc_01AECA
        dc.w    loc_01AF12-loc_01AECA
loc_01AECE:
        addq.b  #2,routine(a0)
        move.l  #Spring_Wall_Mappings,mappings(a0) ; loc_01B084
        move.w  #$8680,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_12 ; loc_01B0B8
        ori.b   #4,render_flags(a0)
        move.b  #8,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.b  #$40, y_radius(a0)
        move.b  subtype(A0), D0
        lsr.b   #4, d0
        andi.b  #$7, d0
        move.b  d0, $001A(a0)
        beq.s   loc_01AF12
        move.b  #$80, y_radius(a0)
loc_01AF12:
        move.w  #$013, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_01B0BE
        cmpi.b  #1, D4
        bne.s   loc_01AF5A
        btst    #1, status(a1)
        beq.s   loc_01AF5A
        move.b  status(a0), d1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcs.s   loc_01AF52
        eori.b  #1,d1
loc_01AF52:
        andi.b  #1,d1
        bne.s   loc_01AF5A
        bsr.s   loc_01AFB0
loc_01AF5A:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_01B0BE
        cmpi.b  #1, D4
        bne.s   loc_01AF90
        btst    #1, status(a1)
        beq.s   loc_01AF90
        move.b  status(a0), d1
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcs.s   loc_01AF88
        eori.b  #1,d1
loc_01AF88:
        andi.b  #1,d1
        bne.s   loc_01AF90
        bsr.s   loc_01AFB0
loc_01AF90:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_19       ; loc_01B0B2
        tst.w   (Debug_placement_mode).w
        beq.s   loc_01AFAE
        bsr     J_DisplaySprite_08      ; loc_01B0AC
loc_01AFAE:
        rts
loc_01AFB0:
        move.w  Objoff_30(A0),x_vel(a1)
        move.w  #$F800,x_vel(a1)
        move.w  #$F800, $0012(a1)
        bset    #0, status(a1)
        btst    #0, status(a0)
        bne.s   loc_01AFDA
        bclr    #0, status(a1)
        neg.w  x_vel(a1)
loc_01AFDA:
        move.w  #$F, $002E(a1)
        move.w x_vel(A1), $14(a1)
        btst    #$2, status(a1)
        bne.s   loc_01AFF4
        move.b  #0, $001C(a1)
loc_01AFF4:
        move.b  subtype(A0), D0
        bpl.s   loc_01B000
        move.w  #0, $0012(a1)
loc_01B000:
        btst    #0, d0
        beq.s   loc_01B040
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #1, $002C(a1)
        move.b  #8, $002D(a1)
        btst    #1,d0
        bne.s   loc_01B030
        move.b  #3, $002C(a1)
loc_01B030:
        btst    #0, status(a1)
        beq.s   loc_01B040
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_01B040:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_01B056
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_01B056:
        cmpi.b  #8,d0
        bne.s   loc_01B068
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_01B068:
        bclr    #5, status(a0)
        bclr    #6, status(a0)
        bclr    #5, status(a1)
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6
Spring_Wall_Mappings:           
loc_01B084:
        dc.w    loc_01B088-loc_01B084
        dc.w    loc_01B09A-loc_01B084        
loc_01B088:
        dc.w    $0002
        dc.l    $C0050034, $001AFFF8, $30050034, $001AFFF8
loc_01B09A:
        dc.w    $0002
        dc.l    $80050034, $001AFFF8, $70050034, $001AFFF8   
;=============================================================================== 
; Object 0x66 - Metropolis - Springs on Walls
                
;===============================================================================  
J_DisplaySprite_08: ; loc_01B0AC:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_19: ; loc_01B0B2:
        jmp     DeleteObject            ; (loc_00D3B4)
J_ModifySpriteAttr_2P_12: ; loc_01B0B8:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01B0BE:
        jmp     (loc_00F510)          
;=============================================================================== 
; Object 0x67 - Metropolis - Teleport Attributes
                 
;===============================================================================            
Obj67_Teleport_Attributes: ; loc_01B0C4:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01B0EC(pc,d0), d1
        jsr     loc_01B0EC(pc,d1)
        move.b  $002C(A0), D0
        add.b   objoff_36(a0), D0
        beq     loc_01B518
        lea     (loc_01B4BA), A1
        bsr     J_AnimateSprite_03      ; loc_01B512
        bra     J_DisplaySprite_09      ; loc_01B50C
loc_01B0EC:
        dc.w    loc_01B0F0-loc_01B0EC
        dc.w    loc_01B114-loc_01B0EC
loc_01B0F0:
        addq.b  #2,routine(a0)
        move.l  #Teleport_Attributes_Mappings,mappings(a0) ; loc_01B4D4
        move.w  #$633C,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #5, $0018(a0)
loc_01B114:
        lea     (MainCharacter).w, A1
        lea     $002C(A0), A4
        bsr.s   loc_01B126
        lea     (Sidekick).w, A1
        lea     objoff_36(a0), A4
loc_01B126:
        moveq	#0,d0
        move.b  (A4), D0
        move.w  loc_01B132(pc,d0), D0
        jmp     loc_01B132(pc,d0)
loc_01B132:
        dc.w    loc_01B138-loc_01B132
        dc.w    loc_01B1C8-loc_01B132
        dc.w    loc_01B1FC-loc_01B132
loc_01B138:
        tst.w   (Debug_placement_mode).w
        bne     loc_01B1C6
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addq.w  #3, d0
        btst    #0, status(a0)
        beq.s   loc_01B156
        addi.w  #$00A, d0
loc_01B156:
        cmpi.w  #$010, d0
        bcc.s   loc_01B1C6
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        addi.w  #$20, d1
        cmpi.w  #$40, d1
        bcc.s   loc_01B1C6
        tst.b   $002A(a1)
        bne.s   loc_01B1C6
        addq.b  #$2, (a4)
        move.b  #$81, $002A(a1)
        move.b  #$2, $001C(a1)
        move.w  #$800, $14(a1)
        move.w  #0,x_vel(a1)
        move.w  #0, $0012(a1)
        bclr    #5, status(a0)
        bclr    #5, status(a1)
        bset    #1, status(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        clr.b   render_flags(a4)
        move.w  #$0BE, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        move.w  #$100, $001C(a0)
loc_01B1C6:
        rts
loc_01B1C8:
        move.b  render_flags(A4), D0
        addq.b  #$2, render_flags(a4)
        jsr     CalcSine        ; loc_00320A
        asr.w   #5, d0
        move.w  y_pos(a0), D2
        sub.w   d0, D2
        move.w  D2, y_pos(a1)
        cmpi.b  #$80, render_flags(a4)
        bne.s   loc_01B1FA
        bsr     loc_01B278
        addq.b  #$2, (a4)
        move.w  #$0BC, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01B1FA:
        rts
loc_01B1FC:
        subq.b  #1, art_tile(a4)
        bpl.s   loc_01B230
        move.l  $0006(A4), A2
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
        tst.b   subtype(a0)
        bpl.s   loc_01B21A
        subq.w  #8, a2
loc_01B21A:
        move.l  A2, $0006(a4)
        subq.w  #4, mappings(a4)
        beq.s   loc_01B256
        move.w  (A2)+, D4
        move.w  (A2)+, D5
        move.w  #$1000, D2
        bra     loc_01B2DC
loc_01B230:
        move.l  x_pos(A1), D2
        move.l  y_pos(A1), D3
        move.w x_vel(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.w  $0012(A1), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  D2, x_pos(a1)
        move.l  d3, y_pos(a1)
        rts
loc_01B256:
        andi.w  #$7FF, y_pos(a1)
        clr.b   (a4)
        clr.b   $002A(a1)
        btst    #4, subtype(a0)
        bne.s   loc_01B276
        move.w  #0,x_vel(a1)
        move.w  #0, $0012(a1)
loc_01B276:
        rts
loc_01B278:
        move.b  subtype(A0), D0
        bpl.s   loc_01B2AC
        neg.b   D0
        andi.w  #$F, d0
        add.w   d0, d0
        lea     (loc_01B35A), A2
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D0
        subq.w  #4, d0
        move.w  d0, mappings(a4)
        lea     $00(A2, d0), A2
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
        subq.w  #8, a2
        bra.s   loc_01B2D0
loc_01B2AC:
        andi.w  #$F, d0
        add.w   d0, d0
        lea     (loc_01B35A), A2
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, mappings(a4)
        subq.w  #4, mappings(a4)
        move.w  (A2)+, D4
        move.w  d4, x_pos(a1)
        move.w  (A2)+, D5
        move.w  d5, y_pos(a1)
loc_01B2D0:
        move.l  A2, $0006(a4)
        move.w  (A2)+, D4
        move.w  (A2)+, D5
        move.w  #$1000, D2
loc_01B2DC:
        moveq	#0,d0
        move.w  D2, d3
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        bge.s   loc_01B2EC
        neg.w   D0
        neg.w   D2
loc_01B2EC:
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        bge.s   loc_01B2FA
        neg.w   d1
        neg.w   D3
loc_01B2FA:
        cmp.w   d0, d1
        bcs.s   loc_01B32C
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        swap.w  d1
        divs.w  d3, d1
        moveq	#0,d0
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        beq.s   loc_01B318
        swap.w  D0
        divs.w  d1, d0
loc_01B318:
        move.w  d0,x_vel(a1)
        move.w  d3, $0012(a1)
        tst.w   d1
        bpl.s   loc_01B326
        neg.w   d1
loc_01B326:
        move.w  d1, art_tile(a4)
        rts
loc_01B32C:
        moveq	#0,d0
        move.w  d4, d0
        sub.w   x_pos(A1), D0
        swap.w  D0
        divs.w  d2, d0
        moveq   #0,d1
        move.w  d5, d1
        sub.w   y_pos(A1), d1
        beq.s   loc_01B346
        swap.w  d1
        divs.w  d0, d1
loc_01B346:
        move.w  d1, $0012(a1)
        move.w  D2,x_vel(a1)
        tst.w   D0
        bpl.s   loc_01B354
        neg.w   D0
loc_01B354:
        move.w  d0, art_tile(a4)
        rts
loc_01B35A:
        dc.w    loc_01B37A-loc_01B35A
        dc.w    loc_01B394-loc_01B35A
        dc.w    loc_01B39E-loc_01B35A
        dc.w    loc_01B3A8-loc_01B35A
        dc.w    loc_01B3B2-loc_01B35A
        dc.w    loc_01B3BC-loc_01B35A
        dc.w    loc_01B3C6-loc_01B35A
        dc.w    loc_01B3D0-loc_01B35A
        dc.w    loc_01B3EA-loc_01B35A
        dc.w    loc_01B404-loc_01B35A
        dc.w    loc_01B41E-loc_01B35A
        dc.w    loc_01B438-loc_01B35A
        dc.w    loc_01B452-loc_01B35A
        dc.w    loc_01B46C-loc_01B35A
        dc.w    loc_01B486-loc_01B35A
        dc.w    loc_01B4A0-loc_01B35A
loc_01B37A:
        dc.w    $0018
        dc.b    $07, $28, $02, $70, $06, $d0, $02, $70, $06, $C0, $02, $88, $06, $C0, $03, $E0
        dc.b    $06, $d0, $03, $F0, $07, $28, $03, $F0
loc_01B394:
        dc.w    $0008
        dc.b    $0B, $d8, $05, $F0, $0E, $00, $05, $F0
loc_01B39E:
        dc.w    $0008
        dc.b    $0C, $58, $03, $70, $0E, $00, $03, $70
loc_01B3A8:
        dc.w    $0008
        dc.b    $13, $d8, $01, $F0, $15, $80, $01, $F0
loc_01B3B2:
        dc.w    $0008
        dc.b    $05, $d8, $03, $70, $07, $80, $03, $70
loc_01B3BC:
        dc.w    $0008
        dc.b    $05, $d8, $05, $F0, $07, $00, $05, $F0
loc_01B3C6:
        dc.w    $0008
        dc.b    $0B, $A8, $07, $70, $08, $80, $07, $70
loc_01B3D0:
        dc.w    $0018
        dc.b    $0B, $d8, $01, $F0, $0C, $30, $01, $F0, $0C, $40, $01, $E0, $0C, $40, $00, $C0
        dc.b    $0C, $50, $00, $B0, $0C, $A8, $00, $B0
loc_01B3EA:
        dc.w    $0018
        dc.b    $14, $d8, $04, $B0, $15, $30, $04, $B0, $15, $40, $04, $C0, $15, $40, $05, $A0
        dc.b    $15, $30, $05, $B0, $14, $d8, $05, $B0
loc_01B404:
        dc.w    $0018
        dc.b    $17, $28, $03, $30, $15, $d0, $03, $30, $15, $C0, $03, $20, $15, $C0, $02, $40
        dc.b    $15, $d0, $02, $30, $16, $28, $02, $30
loc_01B41E:
        dc.w    $0018
        dc.b    $0F, $d8, $03, $B0, $10, $30, $03, $B0, $10, $40, $03, $A0, $10, $40, $02, $C0
        dc.b    $10, $50, $02, $B0, $10, $A8, $02, $B0
loc_01B438:
        dc.w    $0018
        dc.b    $0F, $d8, $04, $B0, $10, $B0, $04, $B0, $10, $C0, $04, $A0, $10, $C0, $03, $C0
        dc.b    $10, $d0, $03, $B0, $11, $28, $03, $B0
loc_01B452:
        dc.w    $0018
        dc.b    $1E, $58, $01, $B0, $1F, $30, $01, $B0, $1F, $40, $01, $C0, $1F, $40, $02, $A0
        dc.b    $1F, $50, $02, $B0, $20, $A8, $02, $B0
loc_01B46C:
        dc.w    $0018
        dc.b    $20, $A8, $04, $70, $20, $50, $04, $70, $20, $40, $04, $80, $20, $40, $05, $A0
        dc.b    $20, $50, $05, $B0, $20, $A8, $05, $B0
loc_01B486:
        dc.w    $0018
        dc.b    $22, $58, $05, $B0, $23, $30, $05, $B0, $23, $40, $05, $A0, $23, $40, $04, $C0
        dc.b    $23, $50, $04, $B0, $23, $A8, $04, $B0
loc_01B4A0:
        dc.w    $0018
        dc.b    $22, $d8, $02, $B0, $23, $30, $02, $B0, $23, $40, $02, $C0, $23, $40, $04, $60
        dc.b    $23, $30, $04, $70, $22, $d8, $04, $70        
loc_01B4BA:         
        dc.w    loc_01B4BE-loc_01B4BA
        dc.w    loc_01B4C1-loc_01B4BA
loc_01B4BE:
        dc.b    $1F, $00, $FF
loc_01B4C1:
        dc.b    $01, $01, $00, $00, $00, $00, $00, $01, $00, $00, $00, $01, $00, $00, $01, $00
        dc.b    $FE, $02, $00   
Teleport_Attributes_Mappings:
loc_01B4D4:
        dc.w    loc_01B4D8-loc_01B4D4
        dc.w    loc_01B4DA-loc_01B4D4
loc_01B4D8:
        dc.w    $0000
loc_01B4DA:
        dc.w    $0006
        dc.l    $E0050000, $0000FFEC, $E0050000, $0000FFF8
        dc.l    $F0050000, $0000FFEC, $F0050000, $0000FFF8
        dc.l    $00050000, $0000FFEC, $00050000, $0000FFF8                     
;=============================================================================== 
; Object 0x67 - Metropolis - Teleport Attributes
                
;===============================================================================               
J_DisplaySprite_09: ; loc_01B50C:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_AnimateSprite_03: ; loc_01B512:
        jmp     AnimateSprite           ; (loc_00D412)
loc_01B518:
        jmp     (loc_00D30C)
        dc.w    $0000           ; Filler               
;=============================================================================== 
; Object 0x68 - Metropolis - Block with Arrow
                 
;===============================================================================            
Obj68_Block_Arrow: ; loc_01B520:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01B52E(pc,d0), d1
        jmp     loc_01B52E(pc,d1)
loc_01B52E:
        dc.w    loc_01B534-loc_01B52E
        dc.w    loc_01B5D6-loc_01B52E
        dc.w    loc_01B5EE-loc_01B52E
loc_01B534:
        addq.b  #2,routine(a0)
        move.l  #Block_Arrow_Mappings,mappings(a0) ; loc_01B6DC
        move.w  #$6414,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_13 ; loc_01B7FC
        move.b  #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        bsr     J_S1SingleObjectLoad_05  ; loc_01B7F6
        bne.s   loc_01B5D0
        move.b  0(A0), 0(a1)
        addq.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  x_pos(A1), Objoff_30(a1)
        move.w  y_pos(A1), $0032(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  #$241C, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #4, $0018(a1)
        move.w  ($FFFFFE04).w, d0
        lsr.w   #6, d0
        move.w  d0, d1
        andi.w  #$001, d0
        move.w  d0, $0036(a1)
        lsr.w   #1,d1
        add.b   subtype(A0), d1
        andi.w  #$003, d1
        move.b  d1, $0025(a1)
        move.b  d1, $001A(a1)
        lea     (loc_01B6D8), A2
        move.b  $00(A2, d1), $0020(a1)
loc_01B5D0:
        move.b  #4, $001A(a0)
loc_01B5D6:
        move.w  #$01B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_08        ; loc_01B802
        bra     J_MarkObjGone_0F        ; loc_01B7F0
loc_01B5EE:
        bsr     loc_01B656
        moveq	#0,d0
        move.b  $0025(A0), D0
        add.w   d0, d0
        move.w  loc_01B60A(pc,d0), d1
        jsr     loc_01B60A(pc,d1)
        move.w  Objoff_30(A0), D0
        bra     loc_01B808
loc_01B60A:
        dc.w    loc_01B612-loc_01B60A
        dc.w    loc_01B624-loc_01B60A
        dc.w    loc_01B634-loc_01B60A
        dc.w    loc_01B644-loc_01B60A
loc_01B612:
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        neg.w   D0
        add.w   $0032(A0), D0
        move.w  d0, y_pos(a0)
        rts
loc_01B624:
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        rts
loc_01B634:
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        add.w   $0032(A0), D0
        move.w  d0, y_pos(a0)
        rts
loc_01B644:
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        neg.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, x_pos(a0)
        rts
loc_01B656:
        tst.w   objoff_38(a0)
        beq.s   loc_01B67A
        move.b  ($FFFFFE05).w, d0
        andi.b  #$3F, d0
        bne.s   loc_01B6D6
        clr.w   objoff_38(a0)
        tst.b   render_flags(a0)
        bpl.s   loc_01B67A
        move.w  #$0B6, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01B67A:
        tst.w   objoff_36(a0)
        beq.s   loc_01B6B6
        subi.w  #$800, Objoff_34(a0)
        bcc.s   loc_01B6D6
        move.w  #0, Objoff_34(a0)
        move.w  #0, objoff_36(a0)
        move.w  #$001, objoff_38(a0)
        addq.b  #1, $0025(a0)
        andi.b  #3, $0025(a0)
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.b  d0, $001A(a0)
        move.b  loc_01B6D8(pc,d0),collision_flags(a0)
        rts
loc_01B6B6:
        addi.w  #$800, Objoff_34(a0)
        cmpi.w  #$2000, Objoff_34(a0)
        bcs.s   loc_01B6D6
        move.w  #$2000, Objoff_34(a0)
        move.w  #$001, objoff_36(a0)
        move.w  #$001, objoff_38(a0)
loc_01B6D6:
        rts
loc_01B6D8:
        dc.b    $84, $a6, $84, $a6  
Block_Arrow_Mappings:
loc_01B6DC:
        dc.w    loc_01B6E6-loc_01B6DC
        dc.w    loc_01B6F0-loc_01B6DC
        dc.w    loc_01B6FA-loc_01B6DC
        dc.w    loc_01B704-loc_01B6DC
        dc.w    loc_01B70E-loc_01B6DC
loc_01B6E6:
        dc.w    $0001
        dc.l    $F0031000, $1000FFFC
loc_01B6F0:
        dc.w    $0001
        dc.l    $FC0C0004, $0002FFF0
loc_01B6FA:
        dc.w    $0001
        dc.l    $F0030000, $0000FFFC
loc_01B704:
        dc.w    $0001
        dc.l    $FC0C0804, $0802FFF0
loc_01B70E:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F0070800, $08000000                      
;=============================================================================== 
; Object 0x68 - Metropolis - Block with Arrow
                
;===============================================================================  
;=============================================================================== 
; Object 0x6D - Metropolis - Floor Harpoon
                 
;===============================================================================  
Obj6D_Harpoon: ; loc_01B720:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01B72E(pc,d0), d1
        jmp     loc_01B72E(pc,d1)
loc_01B72E:
        dc.w    loc_01B732-loc_01B72E
        dc.w    loc_01B76C-loc_01B72E
loc_01B732:
        addq.b  #2,routine(a0)
        move.l  #Block_Arrow_Mappings,mappings(a0) ; loc_01B6DC
        move.w  #$241C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_13 ; loc_01B7FC
        ori.b   #4,render_flags(a0)
        move.b  #4,width_pixels(a0)
        move.b  #4, $0018(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  #$84,collision_flags(a0)
loc_01B76C:
        bsr     loc_01B788
        moveq	#0,d0
        move.b  Objoff_34(A0), D0
        neg.w   D0
        add.w   $0032(A0), D0
        move.w  d0, y_pos(a0)
        move.w  Objoff_30(A0), D0
        bra     loc_01B808
loc_01B788:
        tst.w   objoff_3A(a0)
        beq.s   loc_01B794
        subq.w  #1, objoff_3A(a0)
        rts
loc_01B794:
        tst.w   objoff_38(a0)
        beq.s   loc_01B7AC
        move.b  ($FFFFFE05).w, d0
        sub.b   subtype(A0), D0
        andi.b  #$7F, d0
        bne.s   loc_01B7EE
        clr.w   objoff_38(a0)
loc_01B7AC:
        tst.w   objoff_36(a0)
        beq.s   loc_01B7CE
        subi.w  #$400, Objoff_34(a0)
        bcc.s   loc_01B7EE
        move.w  #0, Objoff_34(a0)
        move.w  #0, objoff_36(a0)
        move.w  #$001, objoff_38(a0)
        rts
loc_01B7CE:
        addi.w  #$400, Objoff_34(a0)
        cmpi.w  #$2000, Objoff_34(a0)
        bcs.s   loc_01B7EE
        move.w  #$2000, Objoff_34(a0)
        move.w  #$001, objoff_36(a0)
        move.w  #$003, objoff_3A(a0)
loc_01B7EE:
        rts
;=============================================================================== 
; Object 0x6D - Metropolis - Floor Harpoon
                
;===============================================================================  

J_MarkObjGone_0F: ; loc_01B7F0:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_05: ; loc_01B7F6:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_13: ; loc_01B7FC:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_08: ; loc_01B802:
        jmp     SolidObject             ; (loc_00F4A0)
loc_01B808:
        jmp     (loc_00D2D8)       
        dc.w    $0000           ; Filler       
;=============================================================================== 
; Object 0x69 - Metropolis - Screew Nut
                 
;===============================================================================           
Obj69_Screw_Nut: ; loc_01B810:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01B81E(pc,d0), d1
        jmp     loc_01B81E(pc,d1)
loc_01B81E:
        dc.w    loc_01B826-loc_01B81E
        dc.w    loc_01B868-loc_01B81E
        dc.w    loc_01B982-loc_01B81E
        dc.w    loc_01B880-loc_01B81E
loc_01B826:
        addq.b  #2,routine(a0)
        move.l  #Screw_Nut_Mappings,mappings(a0) ; loc_01B9A6
        move.w  #$2500,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_14 ; loc_01BA16
        move.b  #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #$B, y_radius(a0)
        move.b  #4, $0018(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  subtype(A0), D0
        andi.w  #$07F, d0
        lsl.w   #3, d0
        move.w  d0, objoff_36(a0)
loc_01B868:
        lea     (MainCharacter).w, A1
        lea     objoff_38(A0), A4
        moveq   #3, D6
        bsr.s   loc_01B898
        lea     (Sidekick).w, A1
        lea     Objoff_3C(a0), A4
        moveq   #4, D6
        bsr.s   loc_01B898
loc_01B880:
        move.w  #$02B, d1
        move.w  #$00C, D2
        move.w  #$00D, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_09        ; loc_01BA1C
        bra     J_MarkObjGone_10        ; loc_01BA10
loc_01B898:
        btst    d6, status(a0)
        bne.s   loc_01B8A0
        clr.b   (a4)
loc_01B8A0:
        moveq	#0,d0
        move.b  (A4), D0
        move.w  loc_01B8AC(pc,d0), D0
        jmp     loc_01B8AC(pc,d0)
loc_01B8AC:
        dc.w    loc_01B8B2-loc_01B8AC
        dc.w    loc_01B8D2-loc_01B8AC
        dc.w    loc_01B8F4-loc_01B8AC
loc_01B8B2:
        btst    d6, status(a0)
        bne.s   loc_01B8BA
        rts
loc_01B8BA:
        addq.b  #$2, (a4)
        move.b  #0, render_flags(a4)
        move.w  x_pos(a0), D0
        sub.w   x_pos(A1), D0
        bcc.s   loc_01B8D2
        move.b  #1, render_flags(a4)
loc_01B8D2:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        tst.b   render_flags(a4)
        beq.s   loc_01B8E4
        addi.w  #$F, d0
loc_01B8E4:
        cmpi.w  #$010, d0
        bcc.s   loc_01B8F2
        move.w  x_pos(a0), x_pos(a1)
        addq.b  #$2, (a4)
loc_01B8F2:
        rts
loc_01B8F4:
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        bcc.s   loc_01B95A
        add.w   d0, Objoff_34(a0)
        move.w  x_pos(a0), x_pos(a1)
        move.w  Objoff_34(A0), D0
        asr.w   #3, d0
        move.w  d0, d1
        asr.w   #1,d0
        andi.w  #$003, d0
        move.b  d0, $001A(a0)
        neg.w   d1
        add.w   $0032(A0), d1
        move.w  d1, y_pos(a0)
        sub.w   $0032(A0), d1
        move.w  objoff_36(a0), D0
        cmp.w   d0, d1
        blt.s   loc_01B958
        move.w  d0, d1
        add.w   $0032(A0), d1
        move.w  d1, y_pos(a0)
        lsl.w   #3, d0
        neg.w   D0
        move.w  d0, Objoff_34(a0)
        move.b  #0, $001A(a0)
        tst.b   subtype(a0)
        bmi.s   loc_01B952
        clr.b   (a4)
        rts
loc_01B952:
        move.b  #4,routine(a0)
loc_01B958:
        rts
loc_01B95A:
        add.w   d0, Objoff_34(a0)
        move.w  x_pos(a0), x_pos(a1)
        move.w  Objoff_34(A0), D0
        asr.w   #3, d0
        move.w  d0, d1
        asr.w   #1,d0
        andi.w  #$003, d0
        move.b  d0, $001A(a0)
        neg.w   d1
        add.w   $0032(A0), d1
        move.w  d1, y_pos(a0)
        rts
loc_01B982:
        bsr     J_SpeedToPos_09         ; loc_01BA22
        addi.w  #$038, $0012(a0)
        bsr     J_ObjHitFloor_00        ; loc_01BA28
        tst.w   d1
        bpl     loc_01B9A2
        add.w   d1, y_pos(a0)
        clr.w   $0012(a0)
        addq.b  #2,routine(a0)
loc_01B9A2:
        bra     loc_01B880     
Screw_Nut_Mappings:
loc_01B9A6:
        dc.w    loc_01B9AE-loc_01B9A6
        dc.w    loc_01B9C0-loc_01B9A6
        dc.w    loc_01B9DA-loc_01B9A6
        dc.w    loc_01B9F4-loc_01B9A6
loc_01B9AE:
        dc.w    $0002
        dc.l    $F40E0000, $0000FFE0, $F40E000C, $00060000
loc_01B9C0:
        dc.w    $0003
        dc.l    $F40A0003, $0001FFE0, $F40E000C, $0006FFF8
        dc.l    $F4020809, $08040018
loc_01B9DA:
        dc.w    $0003
        dc.l    $F4060024, $0012FFE0, $F40E002A, $0015FFF0
        dc.l    $F4060018, $000C0010
loc_01B9F4:
        dc.w    $0003
        dc.l    $F4020027, $0013FFE0, $F40E0018, $000CFFE8
        dc.l    $F40A082D, $08160008                 
;=============================================================================== 
; Object 0x69 - Metropolis - Screew Nut
                
;===============================================================================  
        nop                     ; Filler
J_MarkObjGone_10: ; loc_01BA10:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_14: ; loc_01BA16:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_09: ; loc_01BA1C:
        jmp     SolidObject             ; (loc_00F4A0)
J_SpeedToPos_09: ; loc_01BA22:
        jmp     SpeedToPos              ; (loc_00D27A)
J_ObjHitFloor_00: ; loc_01BA28:
        jmp     ObjHitFloor             ; (loc_013898)
        dc.w    $0000           ; Filler             
;=============================================================================== 
; Object 0x6A - Dust Hill - Three Rotating Boxes
                 
;===============================================================================          
Obj6A_Rotating_Boxes: ; loc_01BA30:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01BA3E(pc,d0), d1
        jmp     loc_01BA3E(pc,d1)
loc_01BA3E:
        dc.w    loc_01BA44-loc_01BA3E
        dc.w    loc_01BB5E-loc_01BA3E
        dc.w    loc_01BBE6-loc_01BA3E
loc_01BA44:
        addq.b  #2,routine(a0)
        move.l  #Mz_Platform_Mappings,mappings(a0) ; loc_01AE2C
        move.w  #$6000,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #$C, y_radius(a0)
        move.l  #loc_01BC5C, $002C(a0)
        move.b  #1, $001A(a0)
        cmpi.b  #$B, (Current_ZoneAndAct).w
        bne     loc_01BB44
        addq.b  #2,routine(a0)
        move.l  #Rotating_Boxes_Mappings,mappings(a0) ; loc_01BCB0
        move.w  #$63D4,art_tile(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #$20, y_radius(a0)
        move.l  #loc_01BC74, $002C(a0)
        btst    #0, status(a0)
        beq.s   loc_01BABC
        move.l  #loc_01BC92, $002C(a0)
loc_01BABC:
        move.b  #0, $001A(a0)
        cmpi.b  #$18, subtype(a0)
        bne     loc_01BB50
        bsr     J_S1SingleObjectLoad_06  ; loc_01BCD4
        bne.s   loc_01BB1C
        bsr.s   loc_01BB1E
        addi.w  #$40, x_pos(a1)
        addi.w  #$40, y_pos(a1)
        move.b  #6, subtype(a1)
        btst    #0, status(a0)
        beq.s   loc_01BAF4
        move.b  #$C, subtype(a1)
loc_01BAF4:
        bsr     J_S1SingleObjectLoad_06  ; loc_01BCD4
        bne.s   loc_01BB1C
        bsr.s   loc_01BB1E
        subi.w  #$40, x_pos(a1)
        addi.w  #$40, y_pos(a1)
        move.b  #$C, subtype(a1)
        btst    #0, status(a0)
        beq.s   loc_01BB1C
        move.b  #6, subtype(a1)
loc_01BB1C:
        bra.s   loc_01BB44
loc_01BB1E:
        move.b  0(A0), 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  x_pos(a0), $0032(a1)
        move.w  y_pos(a0), Objoff_30(a1)
        move.b  status(a0), status(a1)
        rts
loc_01BB44:
        move.w  x_pos(a0), $0032(a0)
        move.w  y_pos(a0), Objoff_30(a0)
loc_01BB50:
        bsr     J_ModifySpriteAttr_2P_15 ; loc_01BCDA
        move.b  subtype(A0), objoff_38(a0)
        bra     loc_01BC22
loc_01BB5E:
        move.w  x_pos(a0), -(A7)
        tst.w   objoff_36(a0)
        bne.s   loc_01BBAE
        move.b  Objoff_3C(a0), d1
        move.b  status(a0), D0
        btst    #3, d0
        bne.s   loc_01BB8A
        btst    #3, d1
        beq.s   loc_01BB8E
        move.b  #1, objoff_36(a0)
        move.b  #0, Objoff_3C(a0)
        bra.s   loc_01BBBE
loc_01BB8A:
        move.b  d0, Objoff_3C(a0)
loc_01BB8E:
        btst    #4, d0
        bne.s   loc_01BBA8
        btst    #4, d1
        beq.s   loc_01BBBE
        move.b  #1, objoff_36(a0)
        move.b  #0, Objoff_3C(a0)
        bra.s   loc_01BBBE
loc_01BBA8:
        move.b  d0, Objoff_3C(a0)
        bra.s   loc_01BBBE
loc_01BBAE:
        jsr     SpeedToPos              ; (loc_00D27A)
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_01BBBE
        bsr     loc_01BC22
loc_01BBBE:
        move.w  (A7)+, D4
        tst.b   render_flags(a0)
        bpl.s   loc_01BBDE
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_0A        ; loc_01BCE0
loc_01BBDE:
        move.w  $0032(A0), D0
        bra     loc_01BCE6
loc_01BBE6:
        move.w  x_pos(a0), -(A7)
        jsr     SpeedToPos              ; (loc_00D27A)
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_01BBFA
        bsr     loc_01BC22
loc_01BBFA:
        move.w  (A7)+, D4
        tst.b   render_flags(a0)
        bpl.s   loc_01BC1A
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_0A        ; loc_01BCE0
loc_01BC1A:
        move.w  $0032(A0), D0
        bra     loc_01BCE6
loc_01BC22:
        moveq	#0,d0
        move.b  objoff_38(A0), D0
        move.l  $002C(A0), A1
        lea     $00(A1, d0), A1
        move.w  (A1)+,x_vel(a0)
        move.w  (A1)+, $0012(a0)
        move.w  (A1)+, Objoff_34(a0)
        move.w  #$007, objoff_3A(a0)
        move.b  #0, objoff_36(a0)
        addq.b  #6, objoff_38(a0)
        cmpi.b  #$18, objoff_38(a0)
        bcs.s   loc_01BC5A
        move.b  #0, objoff_38(a0)
loc_01BC5A:
        rts    
loc_01BC5C:
        dc.w    $0000, $0400, $0010, $0400, $FE00, $0020, $0000, $0400
        dc.w    $0010, $FC00, $FE00, $0020
loc_01BC74:
        dc.w    $0000, $0100, $0040, $FF00, $0000, $0080, $0000, $FF00
        dc.w    $0040, $0100, $0000, $0080, $0100, $0000, $0040
loc_01BC92:
        dc.w    $0000, $0100, $0040, $0100, $0000, $0080, $0000, $FF00
        dc.w    $0040, $FF00, $0000, $0080, $FF00, $0000, $0040
Rotating_Boxes_Mappings:           
loc_01BCB0:
        dc.w    loc_01BCB2-loc_01BCB0
loc_01BCB2:
        dc.w    $0004
        dc.l    $E00F0000, $0000FFE0, $E00F0010, $00080000
        dc.l    $000F1810, $1808FFE0, $000F1800, $18000000                                      
;=============================================================================== 
; Object 0x6A - Dust Hill - Three Rotating Boxes
                
;===============================================================================           
J_S1SingleObjectLoad_06: ; loc_01BCD4:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_15: ; loc_01BCDA:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_0A: ; loc_01BCE0:
        jmp     SolidObject             ; (loc_00F4A0)
loc_01BCE6:
        jmp     (loc_00D2D8)        
;=============================================================================== 
; Object 0x6B - Metropolis Platforms / Chemical Plant - Block
                 
;===============================================================================   
Obj6B_Mz_Platform: ; Obj6B_Block: ; loc_01BCEC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01BCFA(pc,d0), d1
        jmp     loc_01BCFA(pc,d1)
loc_01BCFA:
        dc.w    loc_01BD06-loc_01BCFA
        dc.w    loc_01BD88-loc_01BCFA
loc_01BCFE:
        dc.b    $20, $0C, $01, $00, $10, $10, $00, $00
loc_01BD06:
        addq.b  #2,routine(a0)
        move.l  #Mz_Platform_Mappings,mappings(a0) ; loc_01AE2C
        move.w  #$6000,art_tile(a0)
        cmpi.b  #$D, (Current_ZoneAndAct).w
        bne.s   loc_01BD2E
        move.l  #Block_Mappings,mappings(a0)       ; loc_01BF4A
        move.w  #$6418,art_tile(a0)
loc_01BD2E:
        bsr     J_ModifySpriteAttr_2P_16 ; loc_01BF58
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #$2, d0
        andi.w  #$1C, d0
        lea     loc_01BCFE(pc,d0), A2
        move.b  (A2)+,width_pixels(a0)
        move.b  (A2)+, y_radius(a0)
        move.b  (A2)+, $001A(a0)
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        subq.w  #8,d0
        bcs.s   loc_01BD88
        lsl.w   #$2, d0
        lea     ($FFFFFE8A).w, a2
        lea     $00(A2, d0), A2
        tst.w   (a2)
        bpl.s   loc_01BD88
        bchg    #0, status(a0)
loc_01BD88:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        add.w   d0, d0
        move.w  loc_01BDC8(pc,d0), d1
        jsr     loc_01BDC8(pc,d1)
        move.w  (A7)+, D4
        tst.b   render_flags(a0)
        bpl.s   loc_01BDC0
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_0B        ; loc_01BF5E
loc_01BDC0:
        move.w  Objoff_34(A0), D0
        bra     loc_01BF64
loc_01BDC8:
        dc.w    loc_01BDE0-loc_01BDC8
        dc.w    loc_01BDE2-loc_01BDC8
        dc.w    loc_01BDEE-loc_01BDC8
        dc.w    loc_01BE10-loc_01BDC8
        dc.w    loc_01BE1C-loc_01BDC8
        dc.w    loc_01BE3E-loc_01BDC8
        dc.w    loc_01BE5C-loc_01BDC8
        dc.w    loc_01BDE0-loc_01BDC8
        dc.w    loc_01BE8A-loc_01BDC8
        dc.w    loc_01BE9C-loc_01BDC8
        dc.w    loc_01BEAC-loc_01BDC8
        dc.w    loc_01BEBC-loc_01BDC8
loc_01BDE0:
        rts
loc_01BDE2:
        move.w  #$40, d1
        moveq	#0,d0
        move.b  ($FFFFFE68).w, d0
        bra.s   loc_01BDF8
loc_01BDEE:
        move.w  #$080, d1
        moveq	#0,d0
        move.b  ($FFFFFE7C).w, d0
loc_01BDF8:
        btst    #0, status(a0)
        beq.s   loc_01BE04
        neg.w   D0
        add.w   d1, d0
loc_01BE04:
        move.w  Objoff_34(A0), d1
        sub.w   d0, d1
        move.w  d1, x_pos(a0)
        rts
loc_01BE10:
        move.w  #$40, d1
        moveq	#0,d0
        move.b  ($FFFFFE68).w, d0
        bra.s   loc_01BE26
loc_01BE1C:
        move.w  #$080, d1
        moveq	#0,d0
        move.b  ($FFFFFE7C).w, d0
loc_01BE26:
        btst    #0, status(a0)
        beq.s   loc_01BE32
        neg.w   D0
        add.w   d1, d0
loc_01BE32:
        move.w  Objoff_30(A0), d1
        sub.w   d0, d1
        move.w  d1, y_pos(a0)
        rts
loc_01BE3E:
        move.b  ($FFFFFE60).w, d0
        lsr.w   #1,d0
        add.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
        move.b  status(a0), d1
        andi.b  #$18, d1
        beq.s   loc_01BE5A
        addq.b  #1, subtype(a0)
loc_01BE5A:
        rts
loc_01BE5C:
        move.l  y_pos(a0), D3
        move.w  $0012(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, d3
        move.l  d3, y_pos(a0)
        addi.w  #8, $0012(a0)
        move.w  ($FFFFEECE).w, d0
        addi.w  #$0E0, d0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_01BE88
        move.b  #0, subtype(a0)
loc_01BE88:
        rts
loc_01BE8A:
        move.w  #$010, d1
        moveq	#0,d0
        move.b  ($FFFFFE88).w, d0
        lsr.w   #1,d0
        move.w  ($FFFFFE8A).w, d3
        bra.s   loc_01BECA
loc_01BE9C:
        move.w  #$030, d1
        moveq	#0,d0
        move.b  ($FFFFFE8C).w, d0
        move.w  ($FFFFFE8E).w, d3
        bra.s   loc_01BECA
loc_01BEAC:
        move.w  #$050, d1
        moveq	#0,d0
        move.b  ($FFFFFE90).w, d0
        move.w  ($FFFFFE92).w, d3
        bra.s   loc_01BECA
loc_01BEBC:
        move.w  #$070, d1
        moveq	#0,d0
        move.b  ($FFFFFE94).w, d0
        move.w  ($FFFFFE96).w, d3
loc_01BECA:
        tst.w   D3
        bne.s   loc_01BED8
        addq.b  #1, status(a0)
        andi.b  #3, status(a0)
loc_01BED8:
        move.b  status(a0), D2
        andi.b  #3, D2
        bne.s   loc_01BEF8
        sub.w   d1, d0
        add.w   Objoff_34(A0), D0
        move.w  d0, x_pos(a0)
        neg.w   d1
        add.w   Objoff_30(A0), d1
        move.w  d1, y_pos(a0)
        rts
loc_01BEF8:
        subq.b  #1, D2
        bne.s   loc_01BF16
        subq.w  #1,d1
        sub.w   d1, d0
        neg.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
        addq.w  #1,d1
        add.w   Objoff_34(A0), d1
        move.w  d1, x_pos(a0)
        rts
loc_01BF16:
        subq.b  #1, D2
        bne.s   loc_01BF34
        subq.w  #1,d1
        sub.w   d1, d0
        neg.w   D0
        add.w   Objoff_34(A0), D0
        move.w  d0, x_pos(a0)
        addq.w  #1,d1
        add.w   Objoff_30(A0), d1
        move.w  d1, y_pos(a0)
        rts
loc_01BF34:
        sub.w   d1, d0
        add.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
        neg.w   d1
        add.w   Objoff_34(A0), d1
        move.w  d1, x_pos(a0)
        rts 
Block_Mappings:        
loc_01BF4A:
        dc.w    loc_01BF4C-loc_01BF4A
loc_01BF4C:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0                   
;=============================================================================== 
; Object 0x6B - Metropolis Platforms / Chemical Plant - Block
                
;===============================================================================  
        nop                     ; Filler
J_ModifySpriteAttr_2P_16: ; loc_01BF58:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_0B: ; loc_01BF5E:
        jmp     SolidObject             ; (loc_00F4A0)
loc_01BF64:
        jmp     (loc_00D2D8)    
        dc.w    $0000           ; Filler      
;=============================================================================== 
; Object 0x6C - Moving platforms - clockwise
                 
;===============================================================================          
Obj6C_Mz_Moving_Platforms: ; loc_01BF6C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01BF94(pc,d0), d1
        jsr     loc_01BF94(pc,d1)
        move.w  Objoff_30(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01BF90
        bra     J_DisplaySprite_0A      ; loc_01C2C0
loc_01BF90:
        bra     J_DeleteObject_1A       ; loc_01C2C6
loc_01BF94:
        dc.w    loc_01BF98-loc_01BF94
        dc.w    loc_01C0A0-loc_01BF94
loc_01BF98:
        move.b  subtype(A0), D0
        bmi     loc_01C04A
        addq.b  #2,routine(a0)
        move.l  #Obj6C_Mappings,mappings(a0) ; loc_01C2AA
        move.w  #$63F9,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #4, $0018(a0)
        bsr     J_ModifySpriteAttr_2P_17 ; loc_01C2D2
        move.b  #0, $001A(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.w  d0, d1
        lsr.w   #3, d0
        andi.w  #$01E, d0
        lea     loc_01C18A(PC), A2
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, objoff_38(a0)
        move.l  A2, Objoff_3C(a0)
        andi.w  #$F, d1
        lsl.w   #$2, d1
        move.b  d1, objoff_38(a0)
        move.b  #4, objoff_3A(a0)
        btst    #0, status(a0)
        beq.s   loc_01C02A
        neg.b   objoff_3A(a0)
        moveq   #0,d1
        move.b  objoff_38(A0), d1
        add.b   objoff_3A(A0), d1
        cmp.b   $0039(A0), d1
        bcs.s   loc_01C026
        move.b  d1, d0
        moveq   #0,d1
        tst.b   D0
        bpl.s   loc_01C026
        move.b  $0039(A0), d1
        subq.b  #4, d1
loc_01C026:
        move.b  d1, objoff_38(a0)
loc_01C02A:
        move.w  $00(A2, d1), D0
        add.w   Objoff_30(A0), D0
        move.w  d0, Objoff_34(a0)
        move.w  $02(A2, d1), D0
        add.w   $0032(A0), D0
        move.w  d0, objoff_36(a0)
        bsr     loc_01C112
        bra     loc_01C0A0
loc_01C04A:
        andi.w  #$07F, d0
        add.w   d0, d0
        lea     (loc_01C20E), A2    
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, d1
        move.l  A0, A1
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        bra.s   loc_01C06E
loc_01C068:        
        bsr     J_SingleObjectLoad_05   ; loc_01C2CC
        bne.s   loc_01C098
loc_01C06E:
        move.b  #$6C, 0(a1)
        move.w  (A2)+, D0
        add.w   d2, d0
        move.w  d0, x_pos(a1)
        move.w  (A2)+, D0
        add.w   d3, d0
        move.w  d0, y_pos(a1)
        move.w  D2, Objoff_30(a1)
        move.w  d3, $0032(a1)
        move.w  (A2)+, D0
        move.b  d0, subtype(a1)
        move.b  status(a0), status(a1)
loc_01C098:
        dbra    d1, loc_01C068
        addq.l  #4, A7
        rts
loc_01C0A0:
        move.w  x_pos(a0), -(A7)
        bsr     loc_01C0B6
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #8, d3
        move.w  (A7)+, D4
        bra     loc_01C2D8
loc_01C0B6:
        move.w  x_pos(a0), D0
        cmp.w   Objoff_34(A0), D0
        bne.s   loc_01C10C
        move.w  y_pos(a0), D0
        cmp.w   objoff_36(a0), D0
        bne.s   loc_01C10C
        moveq   #0,d1
        move.b  objoff_38(A0), d1
        add.b   objoff_3A(A0), d1
        cmp.b   $0039(A0), d1
        bcs.s   loc_01C0E8
        move.b  d1, d0
        moveq   #0,d1
        tst.b   D0
        bpl.s   loc_01C0E8
        move.b  $0039(A0), d1
        subq.b  #4, d1
loc_01C0E8:
        move.b  d1, objoff_38(a0)
        move.l  Objoff_3C(a0), A1
        move.w  $00(A1, d1), D0
        add.w   Objoff_30(A0), D0
        move.w  d0, Objoff_34(a0)
        move.w  $02(A1, d1), D0
        add.w   $0032(A0), D0
        move.w  d0, objoff_36(a0)
        bsr     loc_01C112
loc_01C10C:
        bsr     J_SpeedToPos_0A         ; loc_01C2DE
        rts
loc_01C112:
        moveq	#0,d0
        move.w  #$FF00, D2
        move.w  x_pos(a0), D0
        sub.w   Objoff_34(A0), D0
        bcc.s   loc_01C126
        neg.w   D0
        neg.w   D2
loc_01C126:
        moveq   #0,d1
        move.w  #$FF00, d3
        move.w  y_pos(a0), d1
        sub.w   objoff_36(a0), d1
        bcc.s   loc_01C13A
        neg.w   d1
        neg.w   D3
loc_01C13A:
        cmp.w   d0, d1
        bcs.s   loc_01C164
        move.w  x_pos(a0), D0
        sub.w   Objoff_34(A0), D0
        beq.s   loc_01C150
        ext.l   D0
        asl.l   #8,d0
        divs.w  d1, d0
        neg.w   D0
loc_01C150:
        move.w  d0,x_vel(a0)
        move.w  d3, $0012(a0)
        swap.w  D0
        move.w  d0, $000A(a0)
        clr.w   Objoff_E(a0)
        rts
loc_01C164:
        move.w  y_pos(a0), d1
        sub.w   objoff_36(a0), d1
        beq.s   loc_01C176
        ext.l   d1
        asl.l   #8, d1
        divs.w  d0, d1
        neg.w   d1
loc_01C176:
        move.w  d1, $0012(a0)
        move.w  D2,x_vel(a0)
        swap.w  d1
        move.w  d1, Objoff_E(a0)
        clr.w   $000A(a0)
        rts    
loc_01C18A:
        dc.w    loc_01C190-loc_01C18A
        dc.w    loc_01C1BA-loc_01C18A
        dc.w    loc_01C1E4-loc_01C18A
loc_01C190:
        dc.w    $0028
        dc.b    $00, $00, $00, $00, $FF, $EA, $00, $0A, $FF, $E0, $00, $20, $FF, $E0, $00, $E0
        dc.b    $FF, $EA, $00, $F6, $00, $00, $01, $00, $00, $16, $00, $F6, $00, $20, $00, $E0
        dc.b    $00, $20, $00, $20, $00, $16, $00, $0A
loc_01C1BA:
        dc.w    $0028
        dc.b    $00, $00, $00, $00, $FF, $EA, $00, $0A, $FF, $E0, $00, $20, $FF, $E0, $01, $60
        dc.b    $FF, $EA, $01, $76, $00, $00, $01, $80, $00, $16, $01, $76, $00, $20, $01, $60
        dc.b    $00, $20, $00, $20, $00, $16, $00, $0A
loc_01C1E4:
        dc.w    $0028
        dc.b    $00, $00, $00, $00, $FF, $EA, $00, $0A, $FF, $E0, $00, $20, $FF, $E0, $01, $E0
        dc.b    $FF, $EA, $01, $F6, $00, $00, $02, $00, $00, $16, $01, $F6, $00, $20, $01, $E0
        dc.b    $00, $20, $00, $20, $00, $16, $00, $0A        
loc_01C20E: 
        dc.w    loc_01C214-loc_01C20E
        dc.w    loc_01C246-loc_01C20E
        dc.w    loc_01C278-loc_01C20E
loc_01C214:
        dc.w    $0007
        dc.b    $00, $00, $00, $00, $00, $01, $FF, $E0, $00, $3A, $00, $03, $FF, $E0, $00, $80
        dc.b    $00, $03, $FF, $E0, $00, $C6, $00, $03, $00, $00, $01, $00, $00, $06, $00, $20
        dc.b    $00, $C6, $00, $08, $00, $20, $00, $80, $00, $08, $00, $20, $00, $3A, $00, $08  
loc_01C246:
        dc.w    $0007
        dc.b    $00, $00, $00, $00, $00, $11, $FF, $E0, $00, $5A, $00, $13, $FF, $E0, $00, $C0
        dc.b    $00, $13, $FF, $E0, $01, $26, $00, $13, $00, $00, $01, $80, $00, $16, $00, $20
        dc.b    $01, $26, $00, $18, $00, $20, $00, $C0, $00, $18, $00, $20, $00, $5A, $00, $18        
loc_01C278:
        dc.w    $0007
        dc.b    $00, $00, $00, $00, $00, $21, $FF, $E0, $00, $7A, $00, $23, $FF, $E0, $01, $00
        dc.b    $00, $23, $FF, $E0, $01, $86, $00, $23, $00, $00, $02, $00, $00, $26, $00, $20
        dc.b    $01, $86, $00, $28, $00, $20, $01, $00, $00, $28, $00, $20, $00, $7A, $00, $28
        
Obj6C_Mappings:        
loc_01C2AA:
        dc.w    loc_01C2AC-loc_01C2AA
loc_01C2AC:
        dc.w    $0002
        dc.l    $F8050000, $0000FFF0, $F8050800, $08000000                          
;=============================================================================== 
; Object 0x6C - Moving platforms - clockwise
                
;===============================================================================           
        nop                     ; Filler
J_DisplaySprite_0A: ; loc_01C2C0:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_1A: ; loc_01C2C6:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_05: ; loc_01C2CC:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_ModifySpriteAttr_2P_17: ; loc_01C2D2:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01C2D8:
        jmp     (loc_00F984)
J_SpeedToPos_0A: ; loc_01C2DE:
        jmp     SpeedToPos              ; (loc_00D27A)    
;=============================================================================== 
; Object 0x6E - Metropolis - Machine
                 
;===============================================================================           
Obj6E_Machine: ; loc_01C2E4:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01C2F2(pc,d0), d1
        jmp     loc_01C2F2(pc,d1)
loc_01C2F2:
        dc.w    loc_01C300-loc_01C2F2
        dc.w    loc_01C36A-loc_01C2F2
        dc.w    loc_01C3F4-loc_01C2F2
loc_01C2F8: 
        dc.b    $10, $0C, $28, $08, $60, $18, $0C, $0C
loc_01C300:
        addq.b  #2,routine(a0)
        move.l  #Machine_Mappings,mappings(a0) ; loc_01C464
        move.w  #$6000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_18 ; loc_01C4EC
loc_01C316:
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$00E, d0
        lea     loc_01C2F8(pc,d0), A3
        move.b  (A3)+,width_pixels(a0)
        move.b  (A3)+, y_radius(a0)
        lsr.w   #1,d0
        move.b  d0, $001A(a0)
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        cmpi.b  #3, d0
        bne.s   loc_01C36A
        addq.b  #2,routine(a0)
        move.w  #$63F0,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_18 ; loc_01C4EC
        move.b  #5, $0018(a0)
        bra     loc_01C3F4
loc_01C36A:
        move.w  x_pos(a0), -(A7)
        move.b  ($FFFFFE80).w, d1
        subi.b  #$38, d1
        ext.w   d1
        move.b  ($FFFFFE84).w, D2
        subi.b  #$38, D2
        ext.w   D2
        btst    #0, subtype(a0)
        beq.s   loc_01C38E
        neg.w   d1
        neg.w   D2
loc_01C38E:
        btst    #1, subtype(a0)
        beq.s   loc_01C39A
        neg.w   d1
        exg.l   D2, d1
loc_01C39A:
        add.w   Objoff_34(A0), d1
        move.w  d1, x_pos(a0)
        add.w   Objoff_30(A0), D2
        move.w  D2, y_pos(a0)
        move.w  (A7)+, D4
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_0C        ; loc_01C4F2
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01C3DC
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01C3DC:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_1B       ; loc_01C3EE
        bclr    #$7, $02(A2, d0)
J_DeleteObject_1B: ; loc_01C3EE:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_01C3F4:
        move.b  ($FFFFFE80).w, d1
        lsr.b   #1,d1
        subi.b  #$1C, d1
        ext.w   d1
        move.b  ($FFFFFE84).w, D2
        lsr.b   #1, D2
        subi.b  #$1C, D2
        ext.w   D2
        btst    #0, subtype(a0)
        beq.s   loc_01C418
        neg.w   d1
        neg.w   D2
loc_01C418:
        btst    #1, subtype(a0)
        beq.s   loc_01C424
        neg.w   d1
        exg.l   D2, d1
loc_01C424:
        add.w   Objoff_34(A0), d1
        move.w  d1, x_pos(a0)
        add.w   Objoff_30(A0), D2
        move.w  D2, y_pos(a0)
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01C44C
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01C44C:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_1C       ; loc_01C45E
        bclr    #$7, $02(A2, d0)
J_DeleteObject_1C: ; loc_01C45E:
        jmp     DeleteObject            ; (loc_00D3B4)   
Machine_Mappings:
loc_01C464:
        dc.w    loc_01C46C-loc_01C464
        dc.w    loc_01C476-loc_01C464
        dc.w    loc_01C490-loc_01C464
        dc.w    loc_01C4E2-loc_01C464
loc_01C46C:
        dc.w    $0001
        dc.l    $F40E0025, $0012FFF0
loc_01C476:
        dc.w    $0003
        dc.l    $F80D0031, $0018FFD8, $F80D0031, $0018FFF8
        dc.l    $F8050031, $00180018
loc_01C490:
        dc.w    $000A
        dc.l    $E80E0039, $001CFFA0, $E80E0839, $081CFFC0
        dc.l    $E80E0039, $001CFFE0, $E80E0839, $081C0000
        dc.l    $E80E0039, $001C0020, $E80E0839, $081C0040
        dc.l    $00060045, $0022FFA0, $00060845, $0822FFB0
        dc.l    $00060045, $00220040, $00060845, $08220050
loc_01C4E2:
        dc.w    $0001
        dc.l    $F40A0000, $0000FFF4                     
;=============================================================================== 
; Object 0x6E - Metropolis - Machine
                
;===============================================================================           
J_ModifySpriteAttr_2P_18: ; loc_01C4EC:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_0C: ; loc_01C4F2:
        jmp     SolidObject             ; (loc_00F4A0)   
;=============================================================================== 
; Object 0x6F - Metropolis - Parallelogram Elevators
                 
;===============================================================================            
Obj_Ox6F_Parallelogram_Elevator: ; loc_01C4F8:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01C506(pc,d0), d1
        jmp     loc_01C506(pc,d1)
loc_01C506:
        dc.w    loc_01C50A-loc_01C506
        dc.w    loc_01C570-loc_01C506
loc_01C50A:
        addq.b  #2,routine(a0)
        move.l  #Parallelogram_Elevator_Mappings,mappings(a0) ; loc_01C7BE
        move.w  #$653F,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_19 ; loc_01C844
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$80,width_pixels(a0)
        move.b  #$20, y_radius(a0)
        move.w  x_pos(a0), $0032(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        move.b  subtype(A0), D0
        lsr.w   #3, d0
        andi.w  #$00E, d0
        lea     (loc_01C632), A1
        move.w  $00(A1, d0), D0
        lea     $00(A1, d0), A1
        move.l  A1, Objoff_3C(a0)
        bsr     loc_01C604
        bset    #$7, status(a0)
        andi.b  #$F, subtype(a0)
loc_01C570:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  subtype(A0), D0
        add.w   d0, d0
        move.w  loc_01C5DA(pc,d0), d1
        jsr     loc_01C5DA(pc,d1)
        move.w  (A7)+, D4
        moveq   #0,d1
        move.b width_pixels(a0), d1
        lea     (loc_01C6BE), A2
        bsr     loc_01C84A
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01C5AE
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01C5AE:
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01C5C2
        rts
loc_01C5C2:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_1D       ; loc_01C5D4
        bclr    #$7, $02(A2, d0)
J_DeleteObject_1D: ; loc_01C5D4:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_01C5DA:
        dc.w    loc_01C5E0-loc_01C5DA
        dc.w    loc_01C5E2-loc_01C5DA
        dc.w    loc_01C5F2-loc_01C5DA
loc_01C5E0:
        rts
loc_01C5E2:
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_01C5F0
        addq.b  #1, subtype(a0)
loc_01C5F0:
        rts
loc_01C5F2:
        jsr     SpeedToPos              ; (loc_00D27A)
        subq.w  #1, Objoff_34(a0)
        bne.s   loc_01C602
        bsr     loc_01C604
loc_01C602:
        rts
loc_01C604:
        moveq	#0,d0
        move.b  objoff_38(A0), D0
        move.l  Objoff_3C(a0), A1
        move.w  (A1)+, d1
        lea     $00(A1, d0), A1
        move.w  (A1)+,x_vel(a0)
        move.w  (A1)+, $0012(a0)
        move.w  (A1)+, Objoff_34(a0)
        addq.b  #6, objoff_38(a0)
        cmp.b   objoff_38(A0), d1
        bhi.s   loc_01C630
        move.b  #0, objoff_38(a0)
loc_01C630:
        rts   
loc_01C632:
        dc.w    loc_01C63C-loc_01C632
        dc.w    loc_01C64A-loc_01C632
        dc.w    loc_01C658-loc_01C632
        dc.w    loc_01C672-loc_01C632
        dc.w    loc_01C6A4-loc_01C632
loc_01C63C:
        dc.w    $000C
        dc.b    $01, $00, $FF, $80, $01, $00, $FF, $00, $00, $80, $01, $00
loc_01C64A:
        dc.w    $000C
        dc.b    $01, $00, $FF, $80, $01, $80, $FF, $00, $00, $80, $01, $80
loc_01C658:
        dc.w    $0018
        dc.b    $FF, $00, $00, $80, $00, $80, $FF, $00, $00, $00, $01, $80, $01, $00, $FF, $80
        dc.b    $00, $80, $01, $00, $00, $00, $01, $80
loc_01C672:
        dc.w    $0030
        dc.b    $01, $00, $FF, $80, $02, $00, $01, $00, $00, $00, $01, $00, $FF, $00, $00, $80
        dc.b    $01, $00, $01, $00, $00, $00, $01, $80, $FF, $00, $00, $00, $01, $80, $01, $00
        dc.b    $FF, $80, $01, $00, $FF, $00, $00, $00, $01, $00, $FF, $00, $00, $80, $02, $00
loc_01C6A4:
        dc.w    $0018
        dc.b    $FF, $00, $00, $80, $01, $80, $01, $00, $00, $00, $02, $00, $FF, $00, $00, $00
        dc.b    $02, $00, $01, $00, $FF, $80, $01, $80  
loc_01C6BE:
        dc.w    $E101, $E202, $E303, $E404, $E505, $E606, $E707, $E808
        dc.w    $E909, $EA0A, $EB0B, $EC0C, $ED0D, $EE0E, $EF0F, $F010
        dc.w    $F111, $F212, $F313, $F414, $F515, $F616, $F717, $F818
        dc.w    $F919, $FA1A, $FB1B, $FC1C, $FD1D, $FE1E, $FF1F, $0020
        dc.w    $0121, $0222, $0323, $0424, $0525, $0626, $0727, $0828
        dc.w    $0929, $0A2A, $0B2B, $0C2C, $0D2D, $0E2E, $0F2F, $1030
        dc.w    $1131, $1232, $1333, $1434, $1535, $1636, $1737, $1838
        dc.w    $1939, $1A3A, $1B3B, $1C3C, $1D3D, $1E3E, $1F3F, $2040
        dc.w    $2040, $203F, $203E, $203D, $203C, $203B, $203A, $2039
        dc.w    $2038, $2037, $2036, $2035, $2034, $2033, $2032, $2031
        dc.w    $2030, $202F, $202E, $202D, $202C, $202B, $202A, $2029
        dc.w    $2028, $2027, $2026, $2025, $2024, $2023, $2022, $2021
        dc.w    $2020, $201F, $201E, $201D, $201C, $201B, $201A, $2019
        dc.w    $2018, $2017, $2016, $2015, $2014, $2013, $2012, $2011
        dc.w    $2010, $200F, $200E, $200D, $200C, $200B, $200A, $2009
        dc.w    $2008, $2007, $2006, $2005, $2004, $2003, $2002, $2001   
Parallelogram_Elevator_Mappings:
loc_01C7BE:
        dc.w    loc_01C7C0-loc_01C7BE
loc_01C7C0:
        dc.w    $0010
        dc.l    $100D0000, $0000FF80, $000D0000, $0000FFA0
        dc.l    $100D0008, $0004FFA0, $F00D0000, $0000FFC0
        dc.l    $000F0010, $0008FFC0, $E00D0000, $0000FFE0
        dc.l    $F00D0008, $0004FFE0, $000F0010, $0008FFE0
        dc.l    $E00F0010, $00080000, $000D0008, $00040000
        dc.l    $100D1800, $18000000, $E00F0010, $00080020
        dc.l    $000D1800, $18000020, $E00D0008, $00040040
        dc.l    $F00D1800, $18000040, $E00D1800, $18000060                            
;=============================================================================== 
; Object 0x6F - Metropolis - Parallelogram Elevators
                
;===============================================================================        
        nop                     ; Filler
J_ModifySpriteAttr_2P_19: ; loc_01C844:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01C84A:
        jmp     (loc_00F59E)   
        
;=============================================================================== 
; Object 0x70 - Metropolis - Rotating Gears
                 
;===============================================================================             
Obj70_Rotating_Gears: ; loc_01C850:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01C85E(pc,d0), d1
        jmp     loc_01C85E(pc,d1)
loc_01C85E:
        dc.w    loc_01C862-loc_01C85E
        dc.w    loc_01C8E2-loc_01C85E
loc_01C862:
        moveq   #$7, d1
        moveq   #0, D4
        lea     (loc_01C9B6), A2
        move.l  A0, A1
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        bset    #$7, status(a0)
        bra.s   loc_01C884
loc_01C87E:        
        bsr     J_S1SingleObjectLoad_07  ; loc_01CBB8
        bne.s   loc_01C8DE
loc_01C884:
        move.b  0(A0), 0(a1)
        addq.b  #$2, $0024(a1)
        move.l  #Rotating_Gears_Mappings, mappings(a1) ; loc_01CA16
        move.w  #$6378, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_01 ; loc_01CBBE
        move.b  #4, render_flags(a1)
        move.b  #4, $0018(a1)
        move.b  #$10, $0019(a1)
        move.w  D2, $0032(a1)
        move.w  d3, Objoff_30(a1)
        move.b  (A2)+, D0
        ext.w   D0
        add.w   d2, d0
        move.w  d0, x_pos(a1)
        move.b  (A2)+, D0
        ext.w   D0
        add.w   d3, d0
        move.w  d0, y_pos(a1)
        move.b  (A2)+, $001A(a1)
        move.w  d4, Objoff_34(a1)
        addq.w  #3, D4
        move.b  status(a0), status(a1)
loc_01C8DE:
        dbra    d1, loc_01C87E
loc_01C8E2:
        move.w  x_pos(a0), -(A7)
        move.b  ($FFFFFE05).w, d0
        move.b  d0, d1
        andi.w  #$F, d0
        bne.s   loc_01C95A
        move.w  objoff_36(a0), d1
        btst    #0, status(a0)
        beq.s   loc_01C914
        subi.w  #$018, d1
        bcc.s   loc_01C932
        moveq   #$48, d1
        subq.w  #3, Objoff_34(a0)
        bcc.s   loc_01C932
        move.w  #$015, Objoff_34(a0)
        bra.s   loc_01C932
loc_01C914:
        addi.w  #$018, d1
        cmpi.w  #$060, d1
        bcs.s   loc_01C932
        moveq   #0,d1
        addq.w  #3, Objoff_34(a0)
        cmpi.w  #$018, Objoff_34(a0)
        bcs.s   loc_01C932
        move.w  #0, Objoff_34(a0)
loc_01C932:
        move.w  d1, objoff_36(a0)
        add.w   Objoff_34(A0), d1
        lea     loc_01C9B6(pc,d1), A1
        move.b  (A1)+, D0
        ext.w   D0
        add.w   $0032(A0), D0
        move.w  d0, x_pos(a0)
        move.b  (A1)+, D0
        ext.w   D0
        add.w   Objoff_30(A0), D0
        move.w  d0, y_pos(a0)
        move.b  (A1)+, $001A(a0)
loc_01C95A:
        move.b  $001A(A0), D0
        add.w   d0, d0
        andi.w  #$01E, d0
        moveq   #0,d1
        moveq   #0, D2
        move.b  loc_01C996(pc,d0), d1
        move.b  loc_01C997(pc,d0), D2
        move.w  D2, d3
        move.w  (A7)+, D4
        bsr     J_SolidObject_0D        ; loc_01CBC4
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_1E       ; loc_01C990
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_1E: ; loc_01C990:
        jmp     DeleteObject            ; (loc_00D3B4)   

loc_01C996:          
        dc.b    $10
loc_01C997:
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $0C, $10
        dc.b    $08, $10, $0C, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10
loc_01C9B6:
        dc.b    $00, $B8, $00, $32, $CE, $04, $48, $00, $08, $32, $32, $0C, $00, $48, $10, $CE
        dc.b    $32, $14, $B8, $00, $18, $CE, $CE, $1C, $0D, $B8, $01, $3F, $DA, $05, $48, $0C
        dc.b    $09, $27, $3C, $0D, $F3, $48, $11, $C1, $26, $15, $B8, $F4, $19, $D9, $C4, $1D
        dc.b    $19, $BC, $02, $46, $E9, $06, $46, $17, $0A, $19, $44, $0E, $E7, $44, $12, $BA
        dc.b    $17, $16, $BA, $E9, $1A, $E7, $BC, $1E, $27, $C4, $03, $48, $F4, $07, $3F, $26
        dc.b    $0B, $0D, $48, $0F, $D9, $3C, $13, $B8, $0C, $17, $C1, $DA, $1B, $F3, $B8, $1F
Rotating_Gears_Mappings:
loc_01CA16:
        dc.w    loc_01CA56-loc_01CA16
        dc.w    loc_01CA68-loc_01CA16
        dc.w    loc_01CA72-loc_01CA16
        dc.w    loc_01CA7C-loc_01CA16
        dc.w    loc_01CA86-loc_01CA16
        dc.w    loc_01CA90-loc_01CA16
        dc.w    loc_01CA9A-loc_01CA16
        dc.w    loc_01CAA4-loc_01CA16
        dc.w    loc_01CAAE-loc_01CA16
        dc.w    loc_01CAC0-loc_01CA16
        dc.w    loc_01CACA-loc_01CA16
        dc.w    loc_01CAD4-loc_01CA16
        dc.w    loc_01CADE-loc_01CA16
        dc.w    loc_01CAE8-loc_01CA16
        dc.w    loc_01CAF2-loc_01CA16
        dc.w    loc_01CAFC-loc_01CA16
        dc.w    loc_01CB06-loc_01CA16
        dc.w    loc_01CB18-loc_01CA16
        dc.w    loc_01CB22-loc_01CA16
        dc.w    loc_01CB2C-loc_01CA16
        dc.w    loc_01CB36-loc_01CA16
        dc.w    loc_01CB40-loc_01CA16
        dc.w    loc_01CB4A-loc_01CA16
        dc.w    loc_01CB54-loc_01CA16
        dc.w    loc_01CB5E-loc_01CA16
        dc.w    loc_01CB70-loc_01CA16
        dc.w    loc_01CB7A-loc_01CA16
        dc.w    loc_01CB84-loc_01CA16
        dc.w    loc_01CB8E-loc_01CA16
        dc.w    loc_01CB98-loc_01CA16
        dc.w    loc_01CBA2-loc_01CA16
        dc.w    loc_01CBAC-loc_01CA16
loc_01CA56:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F0070800, $08000000
loc_01CA68:
        dc.w    $0001
        dc.l    $F00B0808, $0804FFF4
loc_01CA72:
        dc.w    $0001
        dc.l    $F00F0814, $080AFFF0
loc_01CA7C:
        dc.w    $0001
        dc.l    $F00F0824, $0812FFF0
loc_01CA86:
        dc.w    $0001
        dc.l    $F00F0834, $081AFFF0
loc_01CA90:
        dc.w    $0001
        dc.l    $F00F0844, $0822FFF0
loc_01CA9A:
        dc.w    $0001
        dc.l    $F00F0854, $082AFFF0
loc_01CAA4:
        dc.w    $0001
        dc.l    $F40E0864, $0832FFF0
loc_01CAAE:
        dc.w    $0002
        dc.l    $F00D0870, $0838FFF0, $000D1870, $1838FFF0
loc_01CAC0:
        dc.w    $0001
        dc.l    $F40E1864, $1832FFF0
loc_01CACA:
        dc.w    $0001
        dc.l    $F00F1854, $182AFFF0
loc_01CAD4:
        dc.w    $0001
        dc.l    $F00F1844, $1822FFF0
loc_01CADE:
        dc.w    $0001
        dc.l    $F00F1834, $181AFFF0
loc_01CAE8:
        dc.w    $0001
        dc.l    $F00F1824, $1812FFF0
loc_01CAF2:
        dc.w    $0001
        dc.l    $F00F1814, $180AFFF0
loc_01CAFC:
        dc.w    $0001
        dc.l    $F00B1808, $1804FFF4
loc_01CB06:
        dc.w    $0002
        dc.l    $F0071000, $1000FFF0, $F0071800, $18000000
loc_01CB18:
        dc.w    $0001
        dc.l    $F00B1008, $1004FFF4
loc_01CB22:
        dc.w    $0001
        dc.l    $F00F1014, $100AFFF0
loc_01CB2C:
        dc.w    $0001
        dc.l    $F00F1024, $1012FFF0
loc_01CB36:
        dc.w    $0001
        dc.l    $F00F1034, $101AFFF0
loc_01CB40:
        dc.w    $0001
        dc.l    $F00F1044, $1022FFF0
loc_01CB4A:
        dc.w    $0001
        dc.l    $F00F1054, $102AFFF0
loc_01CB54:
        dc.w    $0001
        dc.l    $F40E1064, $1032FFF0
loc_01CB5E:
        dc.w    $0002
        dc.l    $F00D0070, $0038FFF0, $000D1070, $1038FFF0
loc_01CB70:
        dc.w    $0001
        dc.l    $F40E0064, $0032FFF0
loc_01CB7A:
        dc.w    $0001
        dc.l    $F00F0054, $002AFFF0
loc_01CB84:
        dc.w    $0001
        dc.l    $F00F0044, $0022FFF0
loc_01CB8E:
        dc.w    $0001
        dc.l    $F00F0034, $001AFFF0
loc_01CB98:
        dc.w    $0001
        dc.l    $F00F0024, $0012FFF0
loc_01CBA2:
        dc.w    $0001
        dc.l    $F00F0014, $000AFFF0
loc_01CBAC:
        dc.w    $0001
        dc.l    $F00B0008, $0004FFF4                                
;=============================================================================== 
; Object 0x70 - Metropolis - Rotating Gears
                
;===============================================================================          
        nop                     ; Filler
J_S1SingleObjectLoad_07: ; loc_01CBB8:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifyA1SpriteAttr_2P_01: ; loc_01CBBE:
        jmp     ModifyA1SpriteAttr_2P   ; (loc_00DC4C)
J_SolidObject_0D: ; loc_01CBC4:
        jmp     SolidObject             ; (loc_00F4A0)  
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x72 - Metropolis - Conveyor Belt Attributes
                 
;===============================================================================           
Obj72_Conveyor_Belt_Attributes: ; loc_01CBCC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01CBDA(pc,d0), d1
        jmp     loc_01CBDA(pc,d1)
loc_01CBDA:
        dc.w    loc_01CBDE-loc_01CBDA
        dc.w    loc_01CBFE-loc_01CBDA
loc_01CBDE:
        addq.b  #2,routine(a0)
        move.b  subtype(A0), D0
        lsl.b   #4, d0
        move.b  d0, objoff_38(a0)
        move.w  #$002, objoff_36(a0)
        btst    #0, status(a0)
        beq.s   loc_01CBFE
        neg.w   objoff_36(a0)
loc_01CBFE:
        lea     (MainCharacter).w, A1
        bsr.s   loc_01CC0E
        lea     (Sidekick).w, A1
        bsr.s   loc_01CC0E
        bra     loc_01CC4C
loc_01CC0E:
        moveq   #0, D2
        move.b  objoff_38(A0), D2
        move.w  D2, d3
        add.w   d3, d3
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        add.w   d2, d0
        cmp.w   d3, d0
        bcc.s   loc_01CC48
        move.w  y_pos(A1), d1
        sub.w   y_pos(a0), d1
        addi.w  #$030, d1
        cmpi.w  #$030, d1
        bcc.s   loc_01CC48
        btst    #1, status(a1)
        bne.s   loc_01CC48
        move.w  objoff_36(a0), D0
        add.w   d0, x_pos(a1)
loc_01CC48:
        rts
        
;=============================================================================== 
; Object 0x72 - Metropolis - Conveyor Belt Attributes
                
;===============================================================================             
        nop                     ; Filler
loc_01CC4C:
        jmp     (loc_00D30C)     
        dc.w    $000            ; Filler
;=============================================================================== 
; Object 0x73 - Dust Hill - Rotating Rings - Sonic can walk Through
                 
;===============================================================================  
Obj73_Rotating_Rings: ; loc_01CC54:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01CC62(pc,d0), d1
        jmp     loc_01CC62(pc,d1)
loc_01CC62:
        dc.w    loc_01CC68-loc_01CC62
        dc.w    loc_01CD56-loc_01CC62
        dc.w    loc_01CDFE-loc_01CC62
loc_01CC68:
        addq.b  #2,routine(a0)
        move.l  #Rotating_Rings_Mappings,mappings(a0) ; loc_01CE1C
        move.w  #$26BC,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_1A ; loc_01CE3A
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #8,width_pixels(a0)
        move.w  x_pos(a0), objoff_3A(a0)
        move.w  y_pos(a0), objoff_38(a0)
        move.b  #0,collision_flags(a0)
        bset    #$7, status(a0)
        move.b  subtype(A0), d1
        andi.b  #$F0, d1
        ext.w   d1
        asl.w   #3, d1
        move.w  d1, Objoff_3E(a0)
        move.b  status(a0), D0
        ror.b   #$2, d0
        andi.b  #$C0, d0
        move.b  d0,angle(a0)
        lea     $0029(A0), A2
        move.b  subtype(A0), d1
        andi.w  #$007, d1
        move.b  #0, (A2)+
        move.w  d1, d3
        lsl.w   #4, d3
        move.b  d3, Objoff_3C(a0)
        subq.w  #1,d1
        bcs.s   loc_01CD48
        btst    #3, subtype(a0)
        beq.s   loc_01CCEE
        subq.w  #1,d1
        bcs.s   loc_01CD48
loc_01CCEE:
        bsr     J_SingleObjectLoad_06   ; loc_01CE2E
        bne.s   loc_01CD48
        addq.b  #1, $0029(a0)
        move.w  A1,d5
        subi.w  #Object_RAM,d5
        lsr.w   #6,d5
        andi.w  #$07F,d5
        move.b  d5, (A2)+
        move.b  #4, $0024(a1)
        move.b  0(A0), 0(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  $0018(A0), $0018(a1)
        move.b width_pixels(a0), $0019(a1)
        move.b collision_flags(a0), $0020(a1)
        move.b  status(a0), status(a1)
        subi.b  #$10, d3
        move.b  d3, $003C(a1)
        dbra    d1, loc_01CCEE
loc_01CD48:
        move.w  A0,d5
        subi.w  #Object_RAM,d5
        lsr.w   #6,d5
        andi.w  #$07F,d5
        move.b  d5, (A2)+
loc_01CD56:
        move.w  x_pos(a0), -(A7)
        bsr     loc_01CD74
        move.w  #8,d1
        move.w  #8, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  (A7)+, D4
        bsr     J_SolidObject_0E        ; loc_01CE40
        bra     loc_01CDC6
loc_01CD74:
        move.w  Objoff_3E(A0), D0
        add.w   d0,angle(a0)
        move.b  angle(A0), D0
        jsr     CalcSine        ; loc_00320A
        move.w  objoff_38(A0), D2
        move.w  objoff_3A(A0), D3
        lea     $0029(A0), A2
        moveq   #0, D6
        move.b  (A2)+, D6
loc_01CD96:        
        moveq   #0, D4
        move.b  (A2)+, D4
        lsl.w   #6, D4
        addi.l  #MainCharacter, D4
        move.l  d4, A1
        moveq   #0, D4
        move.b  $003C(A1), D4
        move.l  d4,d5
        muls.w  d0, D4
        asr.l   #8, D4
        muls.w  d1,d5
        asr.l   #8,d5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d4, y_pos(a1)
        move.w  d5, x_pos(a1)
        dbra    d6, loc_01CD96
        rts
loc_01CDC6:
        move.w  objoff_3A(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_01CDDE
        bra     J_DisplaySprite_0B      ; loc_01CE28
loc_01CDDE:
        moveq   #0, D2
        lea     $0029(A0), A2
        move.b  (A2)+, D2
loc_01CDE6:        
        moveq	#0,d0
        move.b  (A2)+, D0
        lsl.w   #6, d0
        addi.l  #MainCharacter, d0
        move.l  d0, A1
        bsr     loc_01CE34
        dbra    D2, loc_01CDE6
        rts
loc_01CDFE:
        move.w  #8,d1
        move.w  #8, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  objoff_36(a0), D4
        bsr     J_SolidObject_0E        ; loc_01CE40
        move.w  x_pos(a0), objoff_36(a0)
        bra     J_DisplaySprite_0B      ; loc_01CE28  
Rotating_Rings_Mappings:             
loc_01CE1C:
        dc.w    loc_01CE1E-loc_01CE1C
loc_01CE1E:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8               
;=============================================================================== 
; Object 0x73 - Dust Hill - Rotating Rings - Sonic can walk Through
                
;===============================================================================
J_DisplaySprite_0B: ; loc_01CE28:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_SingleObjectLoad_06: ; loc_01CE2E:
        jmp     SingleObjectLoad        ; (loc_00E772)
loc_01CE34:
        jmp     (DeleteObject2)
J_ModifySpriteAttr_2P_1A: ; loc_01CE3A:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_0E: ; loc_01CE40:
        jmp     SolidObject             ; (loc_00F4A0)      
        dc.w    $0000           ; Filler     
;=============================================================================== 
; Object 0x75 - Dust Hill - Spikeball with chain
                 
;===============================================================================        
Obj75_Spikeball_Chain: ; loc_01CE48:
        btst    #6,render_flags(a0)
        bne     loc_01CE60
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01CE68(pc,d0), d1
        jmp     loc_01CE68(pc,d1)
loc_01CE60:
        move.w  #$280, d0
        bra     J_DisplaySprite_Param_00  ; loc_01D040
loc_01CE68:
        dc.w    loc_01CE6E-loc_01CE68
        dc.w    loc_01CF4A-loc_01CE68
        dc.w    loc_01CFEC-loc_01CE68
loc_01CE6E:
        addq.b  #2,routine(a0)
        move.l  #Spikeball_Chain_Mappings,mappings(a0) ; loc_01D00A
        move.w  #$2000,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_1B ; loc_01D064
        move.b  #4,render_flags(a0)
        move.b  #5, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), $0032(a0)
        move.b  subtype(A0), d1
        move.b  d1, d0
        andi.w  #$F, d1
        andi.b  #$F0, d0
        ext.w   D0
        asl.w   #3, d0
        move.w  d0, Objoff_34(a0)
        move.b  status(a0), D0
        ror.b   #$2, d0
        andi.b  #$C0, d0
        move.b  d0,angle(a0)
        cmpi.b  #$F, d1
        bne.s   loc_01CEDE
        addq.b  #2,routine(a0)
        move.b  #4, $0018(a0)
        move.b  #$2, $001A(a0)
        rts
loc_01CEDE:
        move.b  #$9A,collision_flags(a0)
        bsr     J_S1SingleObjectLoad_08  ; loc_01D05E
        bne.s   loc_01CF4A
        move.b  0(A0), 0(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  #4, render_flags(a1)
        bset    #6, render_flags(a1)
        move.b  #$40, Objoff_E(a1)
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        move.b  d1, Objoff_F(a1)
        subq.w  #1,d1
        lea     $10(a1),a2
loc_01CF20:        
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        move.w  #$001, (A2)+
        dbra    d1, loc_01CF20
        move.w  D2, x_pos(a1)
        move.w  d3, y_pos(a1)
        move.b  #0, $000B(a1)
        move.l  A1, Objoff_3C(a0)
        move.b  #$40, $14(a1)
        bset    #4, render_flags(a1)
loc_01CF4A:
        move.w  Objoff_34(A0), D0
        add.w   d0,angle(a0)
        move.b  angle(A0), D0
        bsr     loc_01D06A
        move.w  $0032(A0), D2
        move.w  Objoff_30(A0), D3
        moveq   #0, D6
        move.l  Objoff_3C(a0), A1
        move.b  Objoff_F(A1), D6
        subq.w  #1, D6
        bcs.s   loc_01CFBE
        asl.w   #4, d0
        ext.l   D0
        asl.l   #8,d0
        asl.w   #4, d1
        ext.l   d1
        asl.l   #8, d1
        moveq   #0, D4
        moveq   #0,d5
        lea     $10(a1),a2
loc_01CF84:        
        movem.l D4/d5, -(A7)
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d5, (A2)+
        move.w  d4, (A2)+
        movem.l (A7)+, D4/D5
        add.l   d0, D4
        add.l   d1,d5
        addq.w  #$2, a2
        dbra    d6, loc_01CF84
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d5, x_pos(a0)
        move.w  d4, y_pos(a0)
        move.w  subtype(A1), x_pos(a1)
        move.w  $002A(A1), y_pos(a1)
loc_01CFBE:
        tst.w   (Two_player_mode).w
        beq.s   loc_01CFC8
        bra     J_DisplaySprite_0C      ; loc_01D046
loc_01CFC8:
        move.w  Objoff_30(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_01CFE0
        bra     J_DisplaySprite_0C      ; loc_01D046
loc_01CFE0:
        move.l  Objoff_3C(a0), A1
        bsr     loc_01D058
        bra     J_DeleteObject_1F       ; loc_01D04C
loc_01CFEC:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_0F        ; loc_01D070
        bra     J_MarkObjGone_11        ; loc_01D052   
Spikeball_Chain_Mappings:
loc_01D00A:
        dc.w    loc_01D010-loc_01D00A
        dc.w    loc_01D022-loc_01D00A
        dc.w    loc_01D02C-loc_01D00A
loc_01D010:
        dc.w    $0002
        dc.l    $F00D007A, $003DFFF0, $000D187A, $183DFFF0
loc_01D022:
        dc.w    $0001
        dc.l    $F8054066, $4033FFF8
loc_01D02C:
        dc.w    $0002
        dc.l    $F0074040, $4020FFF0, $F0074840, $48200000                     
;=============================================================================== 
; Object 0x75 - Dust Hill - Spikeball with chain
                
;===============================================================================  
        nop                     ; Filler
J_DisplaySprite_Param_00: ; loc_01D040:                       
        jmp     DisplaySprite_Param     ; (loc_00D3FE)
J_DisplaySprite_0C: ; loc_01D046:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_1F: ; loc_01D04C:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_11: ; loc_01D052:
        jmp     MarkObjGone             ; (loc_00D2A0)
loc_01D058:
        jmp     (DeleteObject2)
J_S1SingleObjectLoad_08: ; loc_01D05E:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_1B: ; loc_01D064:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01D06A:
        jmp     CalcSine        ; loc_00320A
J_SolidObject_0F: ; loc_01D070:
        jmp     SolidObject             ; (loc_00F4A0)     
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x76 - Dust Hill - Platform with spikes on sides 
                 
;===============================================================================            
Obj76_Platform_Spikes: ; loc_01D078:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D086(pc,d0), d1
        jmp     loc_01D086(pc,d1)
loc_01D086:
        dc.w    loc_01D08E-loc_01D086
        dc.w    loc_01D0DE-loc_01D086
loc_01D08A:
        dc.b    $40, $10, $00, $00
loc_01D08E:
        addq.b  #2,routine(a0)
        move.l  #Platform_Spikes_Mappings,mappings(a0) ; loc_01D1BA
        move.w  #0,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_1C ; loc_01D1F6
        ori.b   #4,render_flags(a0)
        move.b  #4, $0018(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsr.w   #$2, d0
        andi.w  #$1C, d0
        lea     loc_01D08A(pc,d0), A2
        move.b  (A2)+,width_pixels(a0)
        move.b  (A2)+, y_radius(a0)
        move.b  (A2)+, $001A(a0)
        move.w  x_pos(a0), Objoff_34(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        andi.w  #$F, subtype(a0)
loc_01D0DE:
        move.w  x_pos(a0), -(A7)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.w  loc_01D14A(pc,d0), d1
        jsr     loc_01D14A(pc,d1)
        move.w  (A7)+, D4
        tst.b   render_flags(a0)
        bpl.s   loc_01D142
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        moveq   #0, D2
        move.b  y_radius(A0), D2
        move.w  D2, d3
        addq.w  #1, d3
        bsr     J_SolidObject_10        ; loc_01D1FC
        swap.w  D6
        andi.w  #$003, D6
        beq.s   loc_01D142
        move.b  d6, d0
        andi.b  #1,d0
        beq.s   loc_01D12E
        lea     (MainCharacter).w, A1
        bsr     loc_01D1F0
        bclr    #5, status(a0)
loc_01D12E:
        andi.b  #$2, D6
        beq.s   loc_01D142
        lea     (Sidekick).w, A1
        bsr     loc_01D1F0
        bclr    #6, status(a0)
loc_01D142:
        move.w  Objoff_34(A0), D0
        bra     loc_01D202
loc_01D14A:          
        dc.w    loc_01D14E-loc_01D14A
        dc.w    loc_01D19E-loc_01D14A
loc_01D14E:
        lea     (MainCharacter).w, A1
        bsr.s   loc_01D158
        lea     (Sidekick).w, A1
loc_01D158:
        btst    #1, status(a1)
        bne.s   loc_01D19C
        move.w  x_pos(A1), D0
        sub.w   x_pos(a0), D0
        addi.w  #$0C0, d0
loc_01D16C:
        btst    #0, status(a0)
        beq.s   loc_01D178
        subi.w  #$100, d0
loc_01D178:
        cmpi.w  #$080, d0
        bcc.s   loc_01D19C
        move.w  y_pos(A1), D0
        sub.w   y_pos(a0), D0
        addi.w  #$010, d0
        cmpi.w  #$20, d0
        bcc.s   loc_01D19C
        move.b  #$2, subtype(a0)
        move.w  #$080, objoff_36(a0)
loc_01D19C:
        rts
loc_01D19E:
        tst.w   objoff_36(a0)
        beq.s   loc_01D1B8
        subq.w  #1, objoff_36(a0)
        moveq   #$FFFFFFFF, d0
        btst    #0, status(a0)
        beq.s   loc_01D1B4
        neg.w   D0
loc_01D1B4:
        add.w   d0, x_pos(a0)
loc_01D1B8:
        rts
Platform_Spikes_Mappings:
loc_01D1BA:
        dc.w    loc_01D1BC-loc_01D1BA
loc_01D1BC:
        dc.w    $0006
        dc.l    $F005242C, $2216FFC0, $0005242C, $2216FFC0
        dc.l    $F0076040, $6020FFD0, $F00F6048, $6024FFE0
        dc.l    $F00F6048, $60240000, $F00F6048, $60240020        
;=============================================================================== 
; Object 0x76 - Dust Hill - Platform with spikes on sides 
                
;===============================================================================           
        nop                     ; Filler
loc_01D1F0:
        jmp     Touch_Spikes            ; (loc_00CAD0)
J_ModifySpriteAttr_2P_1C: ; loc_01D1F6:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_10: ; loc_01D1FC:
        jmp     SolidObject             ; (loc_00F4A0)
loc_01D202:
        jmp     (loc_00D2D8)
;=============================================================================== 
; Object 0x77 - Dust Hill - Bridge 
                 
;===============================================================================            
Obj77_Bridge: ; loc_01D208:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D216(pc,d0), d1
        jmp     loc_01D216(pc,d1)
loc_01D216:
        dc.w    loc_01D21A-loc_01D216
        dc.w    loc_01D23C-loc_01D216
loc_01D21A:
        addq.b  #2,routine(a0)
        move.l  #Dhz_Bridge_Mappings,mappings(a0) ; loc_01D2E0
        move.w  #$643C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_1D ; loc_01D3B2
        ori.b   #4,render_flags(a0)
        move.b  #$80,width_pixels(a0)
loc_01D23C:
        tst.b   Objoff_34(a0)
        bne.s   loc_01D270
        lea     ($FFFFF7E0).w, a2
        moveq	#0,d0
        move.b  subtype(A0), D0
        btst    #0, $00(A2, d0)
        beq.s   loc_01D270
        move.b  #1, Objoff_34(a0)
        bchg    #0, $001C(a0)
        tst.b   render_flags(a0)
        bpl.s   loc_01D270
        move.w  #$0BB, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01D270:
        lea     (loc_01D2D0), A1
        jsr     AnimateSprite           ; (loc_00D412)
        tst.b   $001A(a0)
        bne.s   loc_01D29A
        move.w  #$04B, d1
        move.w  #8, D2
        move.w  D2, d3
        addq.w  #1, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_11        ; loc_01D3B8
        bra     J_MarkObjGone_12        ; loc_01D3AC
loc_01D29A:
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_01D2CC
        move.b  d0, d1
        andi.b  #8,d0
        beq.s   loc_01D2B6
        lea     (MainCharacter).w, A1
        bclr    #3, status(a1)
loc_01D2B6:
        andi.b  #$10, d1
        beq.s   loc_01D2C6
        lea     (Sidekick).w, A1
        bclr    #3, status(a1)
loc_01D2C6:
        andi.b  #$E7, status(a0)
loc_01D2CC:
        bra     J_MarkObjGone_12        ; loc_01D3AC  

loc_01D2D0:               
        dc.w    loc_01D2D4-loc_01D2D0
        dc.w    loc_01D2DA-loc_01D2D0
loc_01D2D4:
        dc.b    $03, $02, $01, $00, $FE, $01
loc_01D2DA:
        dc.b    $03, $00, $01, $02, $FE, $01
Dhz_Bridge_Mappings:        
loc_01D2E0:
        dc.w    loc_01D2E6-loc_01D2E0
        dc.w    loc_01D328-loc_01D2E0
        dc.w    loc_01D36A-loc_01D2E0        
loc_01D2E6:
        dc.w    $0008
        dc.l    $F8050000, $0000FFC0, $F8050000, $0000FFD0
        dc.l    $F8050000, $0000FFE0, $F8050000, $0000FFF0
        dc.l    $F8050000, $00000000, $F8050000, $00000010
        dc.l    $F8050000, $00000020, $F8050000, $00000030
loc_01D328:
        dc.w    $0008
        dc.l    $F8050000, $0000FFC0, $04050000, $0000FFCC
        dc.l    $10050000, $0000FFD8, $1C050000, $0000FFE4
        dc.l    $1C050000, $0000000C, $10050000, $00000018
        dc.l    $04050000, $00000024, $F8050000, $00000030
loc_01D36A:
        dc.w    $0008
        dc.l    $F8050000, $0000FFC0, $08050000, $0000FFC0
        dc.l    $18050000, $0000FFC0, $28050000, $0000FFC0
        dc.l    $F8050000, $00000030, $08050000, $00000030
        dc.l    $18050000, $00000030, $28050000, $00000030                    
;=============================================================================== 
; Object 0x77 - Dust Hill - Bridge 
                
;===============================================================================  
J_MarkObjGone_12: ; loc_01D3AC:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_ModifySpriteAttr_2P_1D: ; loc_01D3B2:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
J_SolidObject_11: ; loc_01D3B8:
        jmp     SolidObject             ; (loc_00F4A0)
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x78 - Chemical Plant - Rotanting Platforms / Down when Touch Platform 
                 
;===============================================================================          
Obj78_Rotating_Platforms: ; loc_01D3C0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D3D6(pc,d0), d1
        jsr     loc_01D3D6(pc,d1)
        move.w  Objoff_30(A0), D0
        bra     loc_01D58E
loc_01D3D6:
        dc.w    loc_01D3DC-loc_01D3D6
        dc.w    loc_01D460-loc_01D3D6
        dc.w    loc_01D474-loc_01D3D6
loc_01D3DC:
        addq.b  #2,routine(a0)
        moveq   #$34, d3
        moveq   #$2, D4
        btst    #0, status(a0)
        beq.s   loc_01D3F0
        moveq   #$3A, d3
        moveq   #$FFFFFFFE, D4
loc_01D3F0:
        move.w  x_pos(a0), D2
        move.l  A0, A1
        moveq   #3, d1
        bra.s   loc_01D408
loc_01D3FA:        
        bsr     J_S1SingleObjectLoad_09 ; loc_01D57C
        bne     loc_01D460
        move.b  #4, $0024(a1)
loc_01D408:
        move.b  0(A0), 0(a1)
        move.l  #Block_Mappings, mappings(a1) ; loc_01BF4A
        move.w  #$6418, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_02 ; loc_01D582
        move.b  #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #$10, $0019(a1)
        move.b  subtype(A0), subtype(a1)
        move.w  D2, x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  x_pos(a0), Objoff_30(a1)
        move.w  y_pos(A1), $0032(a1)
        addi.w  #$20, D2
        move.b  d3, $002F(a1)
        move.l  A0, $003C(a1)
        add.b   d4, d3
        dbra    d1, loc_01D3FA
loc_01D460:
        moveq	#0,d0
        move.b  subtype(A0), D0
        andi.w  #$007, d0
        add.w   d0, d0
        move.w  loc_01D4AC(pc,d0), d1
        jsr     loc_01D4AC(pc,d1)
loc_01D474:
        move.l  Objoff_3C(a0), A2
        moveq	#0,d0
        move.b  $002F(A0), D0
        move.w  $00(A2, d0), D0
        add.w   $0032(A0), D0
        move.w  d0, y_pos(a0)
        moveq   #0,d1
        move.b width_pixels(a0), d1
        addi.w  #$00B, d1
        move.w  #$010, D2
        move.w  #$011, d3
        move.w  x_pos(a0), D4
        bsr     J_SolidObject_12        ; loc_01D588
        swap.w  D6
        or.b    d6, $002E(a2)
        rts
loc_01D4AC:
        dc.w    loc_01D4BC-loc_01D4AC
        dc.w    loc_01D528-loc_01D4AC
        dc.w    loc_01D4E0-loc_01D4AC
        dc.w    loc_01D528-loc_01D4AC
        dc.w    loc_01D4BC-loc_01D4AC
        dc.w    loc_01D552-loc_01D4AC
        dc.w    loc_01D4E0-loc_01D4AC
        dc.w    loc_01D552-loc_01D4AC
loc_01D4BC:
        tst.w   $002C(a0)
        bne.s   loc_01D4D4
        move.b  $002E(A0), D0
        andi.b  #$30, d0
        beq.s   loc_01D4D2
        move.w  #$01E, $002C(a0)
loc_01D4D2:
        rts
loc_01D4D4:
        subq.w  #1, $002C(a0)
        bne.s   loc_01D4D2
        addq.b  #1, subtype(a0)
        rts
loc_01D4E0:
        tst.w   $002C(a0)
        bne.s   loc_01D4F8
        move.b  $002E(A0), D0
        andi.b  #$C, d0
        beq.s   loc_01D4F6
        move.w  #$03C, $002C(a0)
loc_01D4F6:
        rts
loc_01D4F8:
        subq.w  #1, $002C(a0)
        bne.s   loc_01D504
        addq.b  #1, subtype(a0)
        rts
loc_01D504:
        lea     Objoff_34(A0), A1
        move.w  $002C(A0), D0
        lsr.b   #$2, d0
        andi.b  #1,d0
        move.w  d0, (a1)+
        eori.b  #1,d0
        move.w  d0, (a1)+
        eori.b  #1,d0
        move.w  d0, (a1)+
        eori.b  #1,d0
        move.w  d0, (a1)+
        rts
loc_01D528:
        lea     Objoff_34(A0), A1
        cmpi.w  #$080, (a1)
        beq.s   loc_01D550
        addq.w  #1, (a1)
        moveq   #0,d1
        move.w  (A1)+, d1
        swap.w  d1
        lsr.l   #1,d1
        move.l  d1, D2
        lsr.l   #1,d1
        move.l  d1, d3
        add.l   D2, d3
        swap.w  d1
        swap.w  D2
        swap.w  D3
        move.w  d3, (A1)+
        move.w  D2, (A1)+
        move.w  d1, (A1)+
loc_01D550:
        rts
loc_01D552:
        lea     Objoff_34(A0), A1
        cmpi.w  #$FF80, (a1)
        beq.s   loc_01D57A
        subq.w  #1, (a1)
        moveq   #0,d1
        move.w  (A1)+, d1
        swap.w  d1
        asr.l   #1,d1
        move.l  d1, D2
        asr.l   #1,d1
        move.l  d1, d3
        add.l   D2, d3
        swap.w  d1
        swap.w  D2
        swap.w  D3
        move.w  d3, (A1)+
        move.w  D2, (A1)+
        move.w  d1, (A1)+
loc_01D57A:
        rts   
;=============================================================================== 
; Object 0x78 - Chemical Plant - Rotanting Platforms / Down when Touch Platform 
                
;===============================================================================           
J_S1SingleObjectLoad_09: ; loc_01D57C:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifyA1SpriteAttr_2P_02: ; loc_01D582:
        jmp     ModifyA1SpriteAttr_2P   ; (loc_00DC4C)
J_SolidObject_12: ; loc_01D588:
        jmp     SolidObject             ; (loc_00F4A0)
loc_01D58E:
        jmp     (loc_00D2D8)  
;=============================================================================== 
; Object 0x7A - Chemical Plant - Platforms - Move horizontally
                 
;===============================================================================             
Obj7A_Platform_Horizontal: ; loc_01D594:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D5A2(pc,d0), d1
        jmp     loc_01D5A2(pc,d1)
loc_01D5A2:
        dc.w    loc_01D5BA-loc_01D5A2
        dc.w    loc_01D660-loc_01D5A2
        dc.w    loc_01D6B2-loc_01D5A2
loc_01D5A8:        
        dc.b    $00, $70, $FF, $90, $00, $00, $01, $B0, $FF, $50, $00, $40, $01, $F0, $FF, $80
        dc.b    $00, $80
loc_01D5BA:
        addq.b  #2,routine(a0)
        move.w  #$E418,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_1E ; loc_01D73E
        moveq   #0,d1
        move.b  subtype(A0), d1
        lea     loc_01D5A8(pc,d1), A2
        move.b  (A2)+, d1
        move.l  A0, A1
        bra.s   loc_01D5F6
loc_01D5D8:        
        bsr     J_S1SingleObjectLoad_0A  ; loc_01D738
        bne.s   loc_01D61C
        move.b  0(A0), 0(a1)
        move.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
loc_01D5F6:
        move.l  #Platform_Horizontal_Mappings, mappings(a1) ; loc_01D72C
        move.w  art_tile(A0), art_tile(a1)
        move.b  #4, render_flags(a1)
        move.b  #4, $0018(a1)
        move.b  #$10, $0019(a1)
        move.w  x_pos(A1), Objoff_30(a1)
loc_01D61C:
        dbra    d1, loc_01D5D8
        move.l  A0, $003C(a1)
        move.l  A1, Objoff_3C(a0)
        cmpi.b  #$C, subtype(a0)
        bne.s   loc_01D636
        move.b  #1, objoff_36(a0)
loc_01D636:
        moveq   #0,d1
        move.b  (A2)+, d1
        move.w  Objoff_30(A0), D0
        sub.w   d1, d0
        move.w  d0, $0032(a0)
        move.w  d0, $0032(a1)
        add.w   d1, d0
        add.w   d1, d0
        move.w  d0, Objoff_34(a0)
        move.w  d0, Objoff_34(a1)
        move.w  (A2)+, D0
        add.w   d0, x_pos(a0)
        move.w  (A2)+, D0
        add.w   d0, x_pos(a1)
loc_01D660:
        bsr.s   loc_01D6BC
        move.w  $0032(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bls.s   loc_01D686
        move.w  Objoff_34(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   loc_01D68C
loc_01D686:
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01D68C:
        move.l  Objoff_3C(a0), A1
        cmpa.l  A0, A1
        beq.s   loc_01D69A
        jsr     (DeleteObject2)
loc_01D69A:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   J_DeleteObject_20       ; loc_01D6AC
        bclr    #$7, $02(A2, d0)
J_DeleteObject_20: ; loc_01D6AC:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_01D6B2:
        bsr.s   loc_01D6BC
        bsr.s   loc_01D706
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_01D6BC:
        move.w  x_pos(a0), -(A7)
        tst.b   objoff_36(a0)
        beq.s   loc_01D6DE
        move.w  x_pos(a0), D0
        subq.w  #1,d0
        cmp.w   $0032(A0), D0
        bne.s   loc_01D6D8
        move.b  #0, objoff_36(a0)
loc_01D6D8:
        move.w  d0, x_pos(a0)
        bra.s   loc_01D6F4
loc_01D6DE:
        move.w  x_pos(a0), D0
        addq.w  #1,d0
        cmp.w   Objoff_34(A0), D0
        bne.s   loc_01D6F0
        move.b  #1, objoff_36(a0)
loc_01D6F0:
        move.w  d0, x_pos(a0)
loc_01D6F4:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        move.w  #8, d3
        move.w  (A7)+, D4
        bsr     loc_01D744
        rts
loc_01D706:
        move.l  Objoff_3C(a0), A1
        move.w  x_pos(a0), D0
        subi.w  #$010, d0
        move.w  x_pos(A1), D2
        addi.w  #$010, D2
        cmp.w   d0, D2
        bne.s   loc_01D72A
        eori.b  #1, objoff_36(a0)
        eori.b  #1, $0036(a1)
loc_01D72A:
        rts
Platform_Horizontal_Mappings: ; loc_01D72C:
        dc.w    loc_01D72E-Platform_Horizontal_Mappings
loc_01D72E:
        dc.w    $0001
        dc.l    $F80D0010, $0008FFF0            
;=============================================================================== 
; Object 0x7A - Chemical Plant - Platforms - Move horizontally
                
;===============================================================================  
J_S1SingleObjectLoad_0A: ; loc_01D738:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_ModifySpriteAttr_2P_1E: ; loc_01D73E:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01D744:
        jmp     (loc_00F984)
        dc.w    $0000           ; Filler    
;=============================================================================== 
; Object 0x7B - Chemical Plant - Spring Over Tubes 
                 
;===============================================================================         
Obj7B_Spring_Tubes: ; loc_01D74C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D77C(pc,d0), d1
        jsr     loc_01D77C(pc,d1)
        tst.w   (Two_player_mode).w
        beq.s   loc_01D764
        bra     J_DisplaySprite_0D      ; loc_01D964
loc_01D764:
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     J_DeleteObject_21       ; loc_01D96A
        bra     J_DisplaySprite_0D      ; loc_01D964
loc_01D77C:
        dc.w    loc_01D784-loc_01D77C
        dc.w    loc_01D7BA-loc_01D77C
loc_01D780:
        dc.w    $F000, $F600
loc_01D784:
        addq.b  #2,routine(a0)
        move.l  #Spring_Tubes_Mappings,mappings(a0) ; loc_01D920
        move.w  #$3E0,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #1, $0018(a0)
        move.b  subtype(A0), D0
        andi.w  #$002, d0
        move.w  loc_01D780(pc,d0), Objoff_30(a0)
        bsr     J_ModifySpriteAttr_2P_1F ; loc_01D976
loc_01D7BA:
        cmpi.b  #1, $001A(a0)
        beq.s   loc_01D802
        move.w  #$01B, d1
        move.w  #8, D2
        move.w  #$010, d3
        move.w  x_pos(a0), D4
        lea     (MainCharacter).w, A1
        moveq   #3, D6
        movem.l d1-d4, -(A7)
        bsr     loc_01D97C
        btst    #3, status(a0)
        beq.s   loc_01D7EA
        bsr.s   loc_01D862
loc_01D7EA:
        movem.l (A7)+, d1-D4
        lea     (Sidekick).w, A1
        moveq   #4, D6
        bsr     loc_01D97C
        btst    #4, status(a0)
        beq.s   loc_01D802
        bsr.s   loc_01D862
loc_01D802:
        move.w  x_pos(a0), D4
        move.w  d4,d5
        subi.w  #$010, D4
        addi.w  #$010,d5
        move.w  y_pos(a0), D2
        move.w  D2, d3
        addi.w  #$030, d3
        move.w  (MainCharacter+x_pos).w, d0
        cmp.w   d4, d0
        bcs.s   loc_01D838
        cmp.w   d5, d0
        bcc.s   loc_01D838
        move.w  ($FFFFB00C).w, d0
        cmp.w   d2, d0
        bcs.s   loc_01D838
        cmp.w   d3, d0
        bcc.s   loc_01D838
        move.b  #$2, $001C(a0)
loc_01D838:
        move.w  ($FFFFB048).w, d0
        cmp.w   d4, d0
        bcs.s   loc_01D856
        cmp.w   d5, d0
        bcc.s   loc_01D856
        move.w  ($FFFFB04C).w, d0
        cmp.w   d2, d0
        bcs.s   loc_01D856
        cmp.w   d3, d0
        bcc.s   loc_01D856
        move.b  #3, $001C(a0)
loc_01D856:
        lea     (loc_01D908), A1
        bra     J_AnimateSprite_04      ; loc_01D970
        rts
loc_01D862:
        move.w  #$100, $001C(a0)
        addq.w  #4, y_pos(a1)
        move.w  Objoff_30(A0), $0012(a1)
        bset    #1, status(a1)
        bclr    #3, status(a1)
        move.b  #$10, $001C(a1)
        move.b  #$2, $0024(a1)
        move.b  subtype(A0), D0
        bpl.s   loc_01D896
        move.w  #0,x_vel(a1)
loc_01D896:
        btst    #0, d0
        beq.s   loc_01D8D6
        move.w  #$001, $14(a1)
        move.b  #1, $0027(a1)
        move.b  #0, $001C(a1)
        move.b  #0, $002C(a1)
        move.b  #4, $002D(a1)
        btst    #1,d0
        bne.s   loc_01D8C6
        move.b  #1, $002C(a1)
loc_01D8C6:
        btst    #0, status(a1)
        beq.s   loc_01D8D6
        neg.b   $0027(a1)
        neg.w   $14(a1)
loc_01D8D6:
        andi.b  #$C, d0
        cmpi.b  #4, d0
        bne.s   loc_01D8EC
        move.b  #$C, Objoff_3E(a1)
        move.b  #$D, Objoff_3F(a1)
loc_01D8EC:
        cmpi.b  #8,d0
        bne.s   loc_01D8FE
        move.b  #$E, Objoff_3E(a1)
        move.b  #$F, Objoff_3F(a1)
loc_01D8FE:
        move.w  #$0CC, d0
        jmp     (Play_Sfx)              ; loc_0014C6    
loc_01D908:
        dc.w    loc_01D910-loc_01D908
        dc.w    loc_01D913-loc_01D908
        dc.w    loc_01D917-loc_01D908
        dc.w    loc_01D917-loc_01D908
loc_01D910:
        dc.b    $0F, $00, $FF
loc_01D913:
        dc.b    $00, $03, $FD, $00
loc_01D917:
        dc.b    $05, $01, $02, $02, $02, $04, $FD, $00, $00  
Spring_Tubes_Mappings:
loc_01D920:
        dc.w    loc_01D92A-loc_01D920
        dc.w    loc_01D934-loc_01D920
        dc.w    loc_01D946-loc_01D920
        dc.w    loc_01D958-loc_01D920
        dc.w    loc_01D934-loc_01D920
loc_01D92A:
        dc.w    $0001
        dc.l    $F00D0000, $0000FFF0
loc_01D934:
        dc.w    $0002
        dc.l    $E0070008, $0004FFF0, $E0070808, $08040000
loc_01D946:
        dc.w    $0002
        dc.l    $E0070010, $0008FFF0, $E0070810, $08080000
loc_01D958:
        dc.w    $0001
        dc.l    $F00D0018, $000CFFF0                
;=============================================================================== 
; Object 0x7B - 
                
;===============================================================================  
        nop                     ; Filler 
J_DisplaySprite_0D: ; loc_01D964:                
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_21: ; loc_01D96A:
        jmp     DeleteObject            ; (loc_00D3B4)
J_AnimateSprite_04: ; loc_01D970:
        jmp     AnimateSprite           ; (loc_00D412)
J_ModifySpriteAttr_2P_1F: ; loc_01D976:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
loc_01D97C:
        jmp     (loc_00F510)
        dc.w    $0000           ; Filler            
;=============================================================================== 
; Object 0x4D - Hidden Palace - Rhinobot 
                 
;===============================================================================              
Obj4D_Rhinobot: ; loc_01D984:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01D992(pc,d0), d1
        jmp     loc_01D992(pc,d1)
loc_01D992:
        dc.w    loc_01D996-loc_01D992
        dc.w    loc_01D9E6-loc_01D992
loc_01D996:
        move.l  #Rhinobot_Mappings,mappings(a0) ; loc_01DAEE
        move.w  #$23C4,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$18,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #$18, $0017(a0)
        bsr     J_ObjectFall_01         ; loc_01DC4C
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_01D9E4
        add.w   d1, y_pos(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
loc_01D9E4:
        rts
loc_01D9E6:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01DA02(pc,d0), d1
        jsr     loc_01DA02(pc,d1)
        lea     (loc_01DAD2), A1
        bsr     J_AnimateSprite_05      ; loc_01DC46
        bra     J_MarkObjGone_13        ; loc_01DC40
loc_01DA02:
        dc.w    loc_01DA06-loc_01DA02
        dc.w    loc_01DA2A-loc_01DA02
loc_01DA06:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_01DA28
        addq.b  #$2, $0025(a0)
        move.w  #$FF80,x_vel(a0)
        move.b  #0, $001C(a0)
        bchg    #0, status(a0)
        bne.s   loc_01DA28
        neg.w  x_vel(a0)
loc_01DA28:
        rts
loc_01DA2A:
        bsr     loc_01DA74
        bsr     J_ObjectFall_01         ; loc_01DC4C
        jsr     ObjHitFloor             ; (loc_013898)
        cmpi.w  #$FFF8, d1
        blt.s   loc_01DA50
        cmpi.w  #$00C, d1
        bge.s   loc_01DA4E
        move.w  #0, $0012(a0)
        add.w   d1, y_pos(a0)
loc_01DA4E:
        rts
loc_01DA50:
        subq.b  #$2, $0025(a0)
        move.w  #$03B, Objoff_30(a0)
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        sub.l   d0, x_pos(a0)
        move.w  #0,x_vel(a0)
        move.b  #1, $001C(a0)
        rts
loc_01DA74:
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bmi.s   loc_01DAA8
        cmpi.w  #$060, d0
        bgt.s   loc_01DA98
        btst    #0, status(a0)
        bne.s   loc_01DA9A
        move.b  #$2, $001C(a0)
        move.w  #$FE00,x_vel(a0)
loc_01DA98:
        rts
loc_01DA9A:
        move.b  #0, $001C(a0)
        move.w  #$080,x_vel(a0)
        rts
loc_01DAA8:
        cmpi.w  #$FFA0, d0
        blt.s   loc_01DA98
        btst    #0, status(a0)
        beq.s   loc_01DAC4
        move.b  #$2, $001C(a0)
        move.w  #$200,x_vel(a0)
        rts
loc_01DAC4:
        move.b  #0, $001C(a0)
        move.w  #$FF80,x_vel(a0)
        rts
loc_01DAD2:
        dc.w    loc_01DAD8-loc_01DAD2
        dc.w    loc_01DAE6-loc_01DAD2
        dc.w    loc_01DAE9-loc_01DAD2
loc_01DAD8:
        dc.b    $02, $00, $00, $00, $03, $03, $04, $01, $01, $02, $05, $05, $05, $FF
loc_01DAE6:
        dc.b    $0F, $00, $FF
loc_01DAE9:
        dc.b    $02, $06, $07, $FF, $00
Rhinobot_Mappings:        
loc_01DAEE:
        dc.w    loc_01DAFE-loc_01DAEE
        dc.w    loc_01DB28-loc_01DAEE
        dc.w    loc_01DB52-loc_01DAEE
        dc.w    loc_01DB7C-loc_01DAEE
        dc.w    loc_01DBA6-loc_01DAEE
        dc.w    loc_01DBD0-loc_01DAEE
        dc.w    loc_01DBFA-loc_01DAEE
        dc.w    loc_01DC1C-loc_01DAEE
loc_01DAFE:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $0005000A, $0005FFF0
        dc.l    $00090022, $00110000
loc_01DB28:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $0005000E, $0007FFF0
        dc.l    $00090022, $00110000
loc_01DB52:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $00050012, $0009FFF0
        dc.l    $00090022, $00110000
loc_01DB7C:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $0005000A, $0005FFF0
        dc.l    $00090028, $00140000
loc_01DBA6:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $0005000E, $0007FFF0
        dc.l    $00090028, $00140000
loc_01DBD0:
        dc.w    $0005
        dc.l    $F0050000, $0000FFF0, $F0050004, $00020000
        dc.l    $F8010008, $0004FFE8, $00050012, $0009FFF0
        dc.l    $00090028, $00140000
loc_01DBFA:
        dc.w    $0004
        dc.l    $F00B0016, $000BFFE8, $F0050004, $00020000
        dc.l    $00090022, $00110000, $FB01002E, $0017001A
loc_01DC1C:
        dc.w    $0004
        dc.l    $F00B0016, $000BFFE8, $F0050004, $00020000
        dc.l    $00090028, $00140000, $FB010030, $0018001A        
;=============================================================================== 
; Object 0x4D - Hidden Palace - Rhinobot 
                
;===============================================================================  
        dc.w    $0000           ; Filler    
J_MarkObjGone_13: ; loc_01DC40:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_05: ; loc_01DC46:
        jmp     AnimateSprite           ; (loc_00D412)
J_ObjectFall_01: ; loc_01DC4C:
        jmp     ObjectFall              ; (loc_00D24E)  
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x52 - Piranha 
                 
;===============================================================================          
Obj52_Piranha: ; loc_01DC54:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01DC62(pc,d0), d1
        jmp     loc_01DC62(pc,d1)
loc_01DC62:
        dc.w    loc_01DC68-loc_01DC62
        dc.w    loc_01DCE0-loc_01DC62
        dc.w    loc_01DD50-loc_01DC62
loc_01DC68:
        addq.b  #2,routine(a0)
        move.l  #Piranha_Mappings,mappings(a0) ; loc_01DE66
        move.w  #$2530,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        move.b  d0, d1
        andi.w  #$0F0, d1
        add.w   d1, d1
        add.w   d1, d1
        move.w  d1, objoff_3A(a0)
        move.w  d1, Objoff_3C(a0)
        andi.w  #$F, d0
        lsl.w   #6, d0
        subq.w  #1,d0
        move.w  d0, Objoff_30(a0)
        move.w  d0, $0032(a0)
        move.w  #$FF80,x_vel(a0)
        move.l  #$FFFB8000, objoff_36(a0)
        move.w  y_pos(a0), Objoff_34(a0)
        bset    #6, status(a0)
        btst    #0, status(a0)
        beq.s   loc_01DCE0
        neg.w  x_vel(a0)
loc_01DCE0:
        cmpi.w  #$FFFF, objoff_3A(a0)
        beq.s   loc_01DCEC
        subq.w  #1, objoff_3A(a0)
loc_01DCEC:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_01DD0E
        move.w  $0032(A0), Objoff_30(a0)
        neg.w  x_vel(a0)
        bchg    #0, status(a0)
        move.b  #1, $001D(a0)
        move.w  Objoff_3C(a0), objoff_3A(a0)
loc_01DD0E:
        lea     (loc_01DE4E), A1
        bsr     J_AnimateSprite_06      ; loc_01DE9E
        bsr     J_SpeedToPos_0B         ; loc_01DEA4
        tst.w   objoff_3A(a0)
        bgt     J_MarkObjGone_14        ; loc_01DE98
        cmpi.w  #$FFFF, objoff_3A(a0)
        beq     J_MarkObjGone_14        ; loc_01DE98
        move.l  #$FFFB8000, objoff_36(a0)
        addq.b  #2,routine(a0)
        move.w  #$FFFF, objoff_3A(a0)
        move.b  #$2, $001C(a0)
        move.w  #$001, Objoff_3E(a0)
        bra     J_MarkObjGone_14        ; loc_01DE98
loc_01DD50:
        move.w  #$390, (Water_Level_1).w
        lea     (loc_01DE4E), A1
        bsr     J_AnimateSprite_06      ; loc_01DE9E
        move.w  Objoff_3E(A0), D0
        sub.w   d0, Objoff_30(a0)
        bsr     loc_01DE00
        tst.l   objoff_36(a0)
        bpl.s   loc_01DDA8
        move.w  y_pos(a0), D0
        cmp.w   (Water_Level_1).w, d0
        bgt     J_MarkObjGone_14        ; loc_01DE98
        move.b  #3, $001C(a0)
        bclr    #6, status(a0)
        tst.b   $002A(a0)
        bne     J_MarkObjGone_14        ; loc_01DE98
        move.w x_vel(A0), D0
        asl.w   #1,d0
        move.w  d0,x_vel(a0)
        addq.w  #1, Objoff_3E(a0)
        st      $002A(a0)
        bra     J_MarkObjGone_14        ; loc_01DE98
loc_01DDA8:
        move.w  y_pos(a0), D0
        cmp.w   (Water_Level_1).w, d0
        bgt.s   loc_01DDBC
        move.b  #1, $001C(a0)
        bra     J_MarkObjGone_14        ; loc_01DE98
loc_01DDBC:
        move.b  #0, $001C(a0)
        bset    #6, status(a0)
        bne.s   loc_01DDD6
        move.l  objoff_36(a0), D0
        asr.l   #1,d0
        move.l  d0, objoff_36(a0)
        nop
loc_01DDD6:
        move.w  Objoff_34(A0), D0
        cmp.w   y_pos(a0), D0
        bgt     J_MarkObjGone_14        ; loc_01DE98
        subq.b  #2,routine(a0)
        tst.b   $002A(a0)
        beq     J_MarkObjGone_14        ; loc_01DE98
        move.w x_vel(A0), D0
        asr.w   #1,d0
        move.w  d0,x_vel(a0)
        sf      $002A(a0)
        bra     J_MarkObjGone_14        ; loc_01DE98
loc_01DE00:
        move.l  x_pos(a0), D2
        move.l  y_pos(a0), D3
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        add.l   objoff_36(a0), D3
        btst    #6, status(a0)
        beq.s   loc_01DE3C
        tst.l   objoff_36(a0)
        bpl.s   loc_01DE34
        addi.l  #$0001000, objoff_36(a0)
        addi.l  #$0001000, objoff_36(a0)
loc_01DE34:
        subi.l  #$0001000, objoff_36(a0)
loc_01DE3C:
        addi.l  #$0001800, objoff_36(a0)
        move.l  D2, x_pos(a0)
        move.l  d3, y_pos(a0)
        rts      
loc_01DE4E:         
        dc.w    loc_01DE56-loc_01DE4E
        dc.w    loc_01DE5A-loc_01DE4E
        dc.w    loc_01DE5E-loc_01DE4E
        dc.w    loc_01DE62-loc_01DE4E
loc_01DE56:
        dc.b    $0E, $00, $01, $FF
loc_01DE5A:
        dc.b    $03, $00, $01, $FF
loc_01DE5E:
        dc.b    $0E, $02, $03, $FF
loc_01DE62:
        dc.b    $03, $02, $03, $FF  
Piranha_Mappings: ; loc_01DE66:
        dc.w    loc_01DE6E-Piranha_Mappings
        dc.w    loc_01DE78-Piranha_Mappings
        dc.w    loc_01DE82-Piranha_Mappings
        dc.w    loc_01DE8C-Piranha_Mappings               
loc_01DE6E:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_01DE78:
        dc.w    $0001
        dc.l    $F00F0010, $0008FFF0
loc_01DE82:
        dc.w    $0001
        dc.l    $F00F0020, $0010FFF0
loc_01DE8C:
        dc.w    $0001
        dc.l    $F00F0030, $0018FFF0                  
;=============================================================================== 
; Object 0x52 - Piranha 
                
;===============================================================================   
        dc.w    $0000           ; Filler   
J_MarkObjGone_14: ; loc_01DE98:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_06: ; loc_01DE9E:
        jmp     AnimateSprite           ; (loc_00D412)
J_SpeedToPos_0B: ; loc_01DEA4:
        jmp     SpeedToPos              ; (loc_00D27A)                            
        dc.w    $0000           ; Filler  
;=============================================================================== 
; Object 0x4F - Hidden Palace - Dinobot 
                 
;===============================================================================         
Obj4F_Dinobot: ; loc_01DEAC:               
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01DEBA(pc,d0), d1
        jmp     loc_01DEBA(pc,d1)
loc_01DEBA:        
        dc.w    loc_01DEC0-loc_01DEBA
        dc.w    loc_01DF16-loc_01DEBA
        dc.w    loc_01DFB8-loc_01DEBA
loc_01DEC0:
        move.l  #Dinobot_Mappings,mappings(a0) ; loc_01DFCA
        move.w  #$500,art_tile(a0)
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #6, $0017(a0)
        move.b  #$C,collision_flags(a0)
        bsr     J_ObjectFall_02         ; loc_01E002
        jsr     ObjHitFloor             ; loc_013898
        tst.w   d1
        bpl.s   loc_01DF14
        add.w   d1, y_pos(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
        bchg    #0, status(a0)
loc_01DF14:
        rts
loc_01DF16:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01DF5C(pc,d0), d1
        jsr     loc_01DF5C(pc,d1)
        lea     (loc_01DFBC), A1
        bsr     J_AnimateSprite_07      ; loc_01DFFC
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_01DF46
        bra     J_DisplaySprite_0E      ; loc_01DFF0
loc_01DF46:
        lea     (Object_Respawn_Table).w, a2
        moveq	#0,d0
        move.b  $0023(A0), D0
        beq.s   loc_01DF58
        bclr    #$7, $02(A2, d0)
loc_01DF58:
        bra     J_DeleteObject_22       ; loc_01DFF6
loc_01DF5C:               
        ori.b   #$28, D4
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_01DF82
        addq.b  #$2, $0025(a0)
        move.w  #$FF80,x_vel(a0)
        move.b  #1, $001C(a0)
        bchg    #0, status(a0)
        bne.s   loc_01DF82
        neg.w  x_vel(a0)
loc_01DF82:
        rts
        bsr     J_SpeedToPos_0C         ; loc_01E008
        jsr     ObjHitFloor             ; loc_013898
        cmpi.w  #$FFF8, d1
        blt.s   loc_01DFA0
        cmpi.w  #$00C, d1
        bge.s   loc_01DFA0
        add.w   d1, y_pos(a0)
        rts
loc_01DFA0:
        subq.b  #$2, $0025(a0)
        move.w  #$03B, Objoff_30(a0)
        move.w  #0,x_vel(a0)
        move.b  #0, $001C(a0)
        rts
loc_01DFB8:
        bra     J_DeleteObject_22       ; loc_01DFF6  
loc_01DFBC:
        dc.w    loc_01DFC0-loc_01DFBC
        dc.w    loc_01DFC3-loc_01DFBC
loc_01DFC0:                 
        dc.b    $09, $01, $FF 
loc_01DFC3:
        dc.b    $09, $00, $01, $02, $01, $FF, $00  
Dinobot_Mappings:        
loc_01DFCA:
        dc.w    loc_01DFD0-loc_01DFCA
        dc.w    loc_01DFDA-loc_01DFCA
        dc.w    loc_01DFE4-loc_01DFCA
loc_01DFD0:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_01DFDA:
        dc.w    $0001
        dc.l    $F00F0010, $0008FFF0
loc_01DFE4:
        dc.w    $0001
        dc.l    $F00F0020, $0010FFF0                       
;=============================================================================== 
; Object 0x4F - Hidden Palace - Dinobot 
                
;===============================================================================   
        dc.w    $0000           ; Filler        
J_DisplaySprite_0E: ; loc_01DFF0:
        jmp     DisplaySprite           ; loc_00D3C2
J_DeleteObject_22: ; loc_01DFF6:
        jmp     DeleteObject            ; loc_00D3B4
J_AnimateSprite_07: ; loc_01DFFC:
        jmp     AnimateSprite           ; loc_00D412
J_ObjectFall_02: ; loc_01E002:
        jmp     ObjectFall              ; loc_00D24E  
J_SpeedToPos_0C: ; loc_01E008:
        jmp     SpeedToPos              ; loc_00D27A  
        dc.w    $0000           ; Filler 
;=============================================================================== 
; Object 0x50 - Oil Ocean - Aquis (Seahorse)  
                 
;===============================================================================  
Obj50_Aquis: ; loc_01E010:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01E01E(pc,d0), d1
        jmp     loc_01E01E(pc,d1)
loc_01E01E:
        dc.w    loc_01E02A-loc_01E01E
        dc.w    loc_01E0E2-loc_01E01E
        dc.w    loc_01E10E-loc_01E01E
        dc.w    loc_01E138-loc_01E01E
        dc.w    loc_01E31A-loc_01E01E
        dc.w    loc_01E356-loc_01E01E
loc_01E02A:
        addq.b  #2,routine(a0)
        move.l  #Aquis_Mappings,mappings(a0) ; loc_01E4E0
        move.w  #$2570,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.w  #$FF00,x_vel(a0)
        move.b  subtype(A0), D0
        move.b  d0, d1
        andi.w  #$0F0, d1
        lsl.w   #4, d1
        move.w  d1, $002E(a0)
        move.w  d1, Objoff_30(a0)
        andi.w  #$F, d0
        lsl.w   #4, d0
        subq.w  #1,d0
        move.w  d0, $0032(a0)
        move.w  d0, Objoff_34(a0)
        move.w  y_pos(a0), $002A(a0)
        bsr     J_SingleObjectLoad_07   ; loc_01E87C
        bne.s   loc_01E0E2
        move.b  #$50, 0(a1)
        move.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$00A, x_pos(a1)
        addi.w  #$FFFFFFFA, y_pos(a1)
        move.l  #Aquis_Mappings, mappings(a1) ; loc_01E4E0
        move.w  #$24E0, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  status(a0), status(a1)
        move.b  #3, $001C(a1)
        move.l  A1, objoff_36(a0)
        move.l  A0, $0036(a1)
        bset    #6, status(a0)
loc_01E0E2:
        lea     (loc_01E4A8), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        move.w  #$39C, (Water_Level_1).w
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01E108(pc,d0), d1
        jsr     loc_01E108(pc,d1)
        bsr     loc_01E2E0
        bra     J_MarkObjGone_15        ; loc_01E882
loc_01E108:
        dc.w    loc_01E14E-loc_01E108
        dc.w    loc_01E160-loc_01E108
        dc.w    loc_01E16E-loc_01E108
loc_01E10E:
        move.l  objoff_36(a0), A1
        tst.b   (a1)
        beq     J_DeleteObject_23       ; loc_01E876
        cmpi.b  #$50, (a1)
        bne     J_DeleteObject_23       ; loc_01E876
        btst    #$7, status(a1)
        bne     J_DeleteObject_23       ; loc_01E876
        lea     (loc_01E4A8), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        bra     J_DisplaySprite_0F      ; loc_01E870
loc_01E138:
        bsr     loc_01E404
        bsr     J_SpeedToPos_0D         ; loc_01E894
        lea     (loc_01E4A8), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        bra     J_MarkObjGone_15        ; loc_01E882
loc_01E14E:
        bsr     J_SpeedToPos_0D         ; loc_01E894
        bsr     loc_01E3E6
        bsr     loc_01E28C
        bsr     loc_01E224
        rts
loc_01E160:
        bsr     J_SpeedToPos_0D         ; loc_01E894
        bsr     loc_01E3E6
        bsr     loc_01E2AE
        rts
loc_01E16E:
        bsr     J_ObjectFall_03         ; loc_01E88E
        bsr     loc_01E3E6
        bsr     loc_01E180
        bsr     loc_01E1FC
        rts
loc_01E180:
        tst.b   $002D(a0)
        bne.s   loc_01E18C
        tst.w   $0012(a0)
        bpl.s   loc_01E18E
loc_01E18C:
        rts
loc_01E18E:
        st      $002D(a0)
        bsr     J_SingleObjectLoad_07   ; loc_01E87C
        bne.s   loc_01E1FA
        move.b  #$50, 0(a1)
        move.b  #6, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  #Aquis_Mappings, mappings(a1) ; loc_01E4E0
        move.w  #$24E0, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #$E5, $0020(a1)
        move.b  #$2, $001C(a1)
        move.w  #$00C, d0
        move.w  #$010, d1
        move.w  #$FD00, D2
        btst    #0, status(a0)
        beq.s   loc_01E1EE
        neg.w   d1
        neg.w   D2
loc_01E1EE:
        sub.w   d0, y_pos(a1)
        sub.w   d1, x_pos(a1)
        move.w  D2,x_vel(a1)
loc_01E1FA:
        rts
loc_01E1FC:
        move.w  y_pos(a0), D0
        cmp.w   (Water_Level_1).w, d0
        blt.s   loc_01E222
        move.b  #$2, $0025(a0)
        move.b  #0, $001C(a0)
        move.w  Objoff_30(A0), $002E(a0)
        move.w  #$40, $0012(a0)
        sf      $002D(a0)
loc_01E222:
        rts
loc_01E224:
        tst.b   $002C(a0)
        beq.s   loc_01E28A
        move.w  (MainCharacter+x_pos).w, d0
        move.w  ($FFFFB00C).w, d1
        sub.w   y_pos(a0), d1
        bpl.s   loc_01E28A
        cmpi.w  #$FFD0, d1
        blt.s   loc_01E28A
        sub.w   x_pos(a0), D0
        cmpi.w  #$048, d0
        bgt.s   loc_01E28A
        cmpi.w  #$FFB8, d0
        blt.s   loc_01E28A
        tst.w   D0
        bpl.s   loc_01E262
        cmpi.w  #$FFD8, d0
        bgt.s   loc_01E28A
        btst    #0, status(a0)
        bne.s   loc_01E28A
        bra.s   loc_01E270
loc_01E262:
        cmpi.w  #$028, d0
        blt.s   loc_01E28A
        btst    #0, status(a0)
        beq.s   loc_01E28A
loc_01E270:
        moveq   #$20, d0
        cmp.w   $0032(A0), D0
        bgt.s   loc_01E28A
        move.b  #4, $0025(a0)
        move.b  #1, $001C(a0)
        move.w  #$FC00, $0012(a0)
loc_01E28A:
        rts
loc_01E28C:
        subq.w  #1, $002E(a0)
        bne.s   loc_01E2AC
        move.w  Objoff_30(A0), $002E(a0)
        addq.b  #$2, $0025(a0)
        move.w  #$FFC0, d0
        tst.b   $002C(a0)
        beq.s   loc_01E2A8
        neg.w   D0
loc_01E2A8:
        move.w  d0, $0012(a0)
loc_01E2AC:
        rts
loc_01E2AE:
        move.w  y_pos(a0), D0
        tst.b   $002C(a0)
        bne.s   loc_01E2CC
        cmp.w   (Water_Level_1).w, d0
        bgt.s   loc_01E2CA
        subq.b  #$2, $0025(a0)
        st      $002C(a0)
        clr.w   $0012(a0)
loc_01E2CA:
        rts
loc_01E2CC:
        cmp.w   $002A(A0), D0
        blt.s   loc_01E2CA
        subq.b  #$2, $0025(a0)
        sf      $002C(a0)
        clr.w   $0012(a0)
        rts
loc_01E2E0:
        moveq   #$A, d0
        moveq   #$FFFFFFFA, d1
        move.l  objoff_36(a0), A1
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  status(a0), status(a1)
        move.b  $0023(A0), $0023(a1)
        move.b  render_flags(A0), render_flags(a1)
        btst    #0, status(a1)
        beq.s   loc_01E310
        neg.w   D0
loc_01E310:
        add.w   d0, x_pos(a1)
        add.w   d1, y_pos(a1)
        rts
loc_01E31A:
        bsr     J_ObjectFall_03         ; loc_01E88E
        bsr     loc_01E330
        lea     (loc_01E4A8), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        bra     J_MarkObjGone_15        ; loc_01E882
loc_01E330:
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_01E34A
        add.w   d1, y_pos(a0)
        move.w  $0012(A0), D0
        asr.w   #1,d0
        neg.w   D0
        move.w  d0, $0012(a0)
loc_01E34A:
        subi.b  #1, $0021(a0)
        beq     J_DeleteObject_23       ; loc_01E876
        rts
loc_01E356:
        bsr     loc_01E3A6
        tst.b   $0025(a0)
        beq.s   loc_01E396
        subi.w  #$001, $002C(a0)
        beq     J_DeleteObject_23       ; loc_01E876
        move.w  (MainCharacter+x_pos).w, x_pos(a0)
        move.w  ($FFFFB00C).w, y_pos(a0)
        addi.w  #$00C, y_pos(a0)
        subi.b  #1, $002A(a0)
        bne.s   loc_01E398
        move.b  #3, $002A(a0)
        bchg    #0, status(a0)
        bchg    #0,render_flags(a0)
loc_01E396:
        rts
loc_01E398:
        lea     (loc_01E4A8), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        bra     J_DisplaySprite_0F      ; loc_01E870
loc_01E3A6:
        tst.b   $0025(a0)
        bne.s   loc_01E3E4
        move.b  ($FFFFB024).w, d0
        cmpi.b  #$2, d0
        bne.s   loc_01E3E4
        move.w  (MainCharacter+x_pos).w, x_pos(a0)
        move.w  ($FFFFB00C).w, y_pos(a0)
        ori.b   #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #5, $001C(a0)
        st      $0025(a0)
        move.w  #$12C, $002C(a0)
        move.b  #3, $002A(a0)
loc_01E3E4:
        rts
loc_01E3E6:
        subq.w  #1, $0032(a0)
        bpl.s   loc_01E402
        move.w  Objoff_34(A0), $0032(a0)
        neg.w  x_vel(a0)
        bchg    #0, status(a0)
        move.b  #1, $001D(a0)
loc_01E402:
        rts
loc_01E404:
        tst.b   $0021(a0)
        beq     loc_01E4A6
        moveq   #$2, d3
loc_01E40E:        
        bsr     J_SingleObjectLoad_07   ; loc_01E87C
        bne.s   loc_01E480
        move.b  0(A0), 0(a1)
        move.b  #8, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  #$24E0, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.w  #$FF00, $0012(a1)
        move.b  #4, $001C(a1)
        move.b  #$78, $0021(a1)
        cmpi.w  #$001, d3
        beq.s   loc_01E47A
        blt.s   loc_01E46C
        move.w  #$0C0,x_vel(a1)
        addi.w  #$FF40, $0012(a1)
        bra.s   loc_01E480
loc_01E46C:
        move.w  #$FF00,x_vel(a1)
        addi.w  #$FFC0, $0012(a1)
        bra.s   loc_01E480
loc_01E47A:
        move.w  #$40,x_vel(a1)
loc_01E480:
        dbra    d3, loc_01E40E
        bsr     J_SingleObjectLoad_07   ; loc_01E87C
        bne.s   loc_01E4A2
        move.b  0(A0), 0(a1)
        move.b  #$A, $0024(a1)
        move.l  mappings(A0), mappings(a1)
        move.w  #$24E0, art_tile(a1)
loc_01E4A2:
        bra     J_DeleteObject_23       ; loc_01E876
loc_01E4A6:
        rts    
loc_01E4A8:
        dc.w    loc_01E4B8-loc_01E4A8
        dc.w    loc_01E4BB-loc_01E4A8
        dc.w    loc_01E4C3-loc_01E4A8
        dc.w    loc_01E4C9-loc_01E4A8
        dc.w    loc_01E4CD-loc_01E4A8
        dc.w    loc_01E4D0-loc_01E4A8
        dc.w    loc_01E4D3-loc_01E4A8
        dc.w    loc_01E4D7-loc_01E4A8
loc_01E4B8:
        dc.b    $0E, $00, $FF
loc_01E4BB:
        dc.b    $05, $03, $04, $03, $04, $03, $04, $FF
loc_01E4C3:
        dc.b    $03, $05, $06, $07, $06, $FF
loc_01E4C9:
        dc.b    $03, $01, $02, $FF
loc_01E4CD:
        dc.b    $01, $05, $FF
loc_01E4D0:
        dc.b    $0E, $08, $FF
loc_01E4D3:
        dc.b    $01, $09, $0A, $FF
loc_01E4D7:
        dc.b    $05, $0B, $0C, $0B, $0C, $0B, $0C, $FF, $00
Aquis_Mappings:        
loc_01E4E0:
        dc.w    loc_01E4FA-loc_01E4E0
        dc.w    loc_01E514-loc_01E4E0
        dc.w    loc_01E51E-loc_01E4E0
        dc.w    loc_01E528-loc_01E4E0
        dc.w    loc_01E54A-loc_01E4E0
        dc.w    loc_01E56C-loc_01E4E0
        dc.w    loc_01E576-loc_01E4E0
        dc.w    loc_01E580-loc_01E4E0
        dc.w    loc_01E58A-loc_01E4E0
        dc.w    loc_01E594-loc_01E4E0
        dc.w    loc_01E5B6-loc_01E4E0
        dc.w    loc_01E5D8-loc_01E4E0
        dc.w    loc_01E602-loc_01E4E0
loc_01E4FA:
        dc.w    $0003
        dc.l    $E80D0000, $0000FFF0, $F8090016, $000BFFF8
        dc.l    $08050024, $0012FFF8
loc_01E514:
        dc.w    $0001
        dc.l    $F8050028, $0014FFF8
loc_01E51E:
        dc.w    $0001
        dc.l    $F805002C, $0016FFF8
loc_01E528:
        dc.w    $0004
        dc.l    $E8090008, $0004FFF0, $E801000E, $00070008
        dc.l    $F8090016, $000BFFF8, $08050024, $0012FFF8
loc_01E54A:
        dc.w    $0004
        dc.l    $E8090010, $0008FFF0, $E801000E, $00070008
        dc.l    $F8090016, $000BFFF8, $08050024, $0012FFF8
loc_01E56C:
        dc.w    $0001
        dc.l    $F8010030, $0018FFFC
loc_01E576:
        dc.w    $0001
        dc.l    $F8010032, $0019FFFC
loc_01E580:
        dc.w    $0001
        dc.l    $F8010034, $001AFFFC
loc_01E58A:
        dc.w    $0001
        dc.l    $F80D0036, $001BFFF0
loc_01E594:
        dc.w    $0004
        dc.l    $E80D0000, $0000FFF0, $F805001C, $000EFFF8
        dc.l    $F8010020, $00100008, $08050024, $0012FFF8
loc_01E5B6:
        dc.w    $0004
        dc.l    $E80D0000, $0000FFF0, $F805001C, $000EFFF8
        dc.l    $F8010022, $00110008, $08050024, $0012FFF8
loc_01E5D8:
        dc.w    $0005
        dc.l    $E8090008, $0004FFF0, $E801000E, $00070008
        dc.l    $F805001C, $000EFFF8, $F8010020, $00100008
        dc.l    $08050024, $0012FFF8
loc_01E602:
        dc.w    $0005
        dc.l    $E8090010, $0008FFF0, $E801000E, $00070008
        dc.l    $F805001C, $000EFFF8, $F8010022, $00110008
        dc.l    $08050024, $0012FFF8                   
;=============================================================================== 
; Object 0x50 - Oil Ocean - Aquis (Seahorse)  
                
;===============================================================================  
;=============================================================================== 
; Object 0x51 - Oil Ocean - Aquis (Seahorse)  
                 
;===============================================================================  
Obj51_Aquis: ; loc_01E62C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01E63A(pc,d0), d1
        jmp     loc_01E63A(pc,d1)
loc_01E63A:
        dc.w    loc_01E646-loc_01E63A
        dc.w    loc_01E6A4-loc_01E63A
        dc.w    loc_01E6C8-loc_01E63A
loc_01E640:
        dc.w    $0000, $FCE0, $FD1C
loc_01E646:
        addq.b  #2,routine(a0)
        move.l  #Aquis_Mappings,mappings(a0) ; loc_01E4E0
        move.w  #$2570,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #6, $001C(a0)
        move.b  subtype(A0), D0
        andi.w  #$F, d0
        move.w  d0, d1
        lsl.w   #5, d1
        subq.w  #1,d1
        move.w  d1, $0032(a0)
        move.w  d1, Objoff_34(a0)
        move.w  y_pos(a0), $002A(a0)
        move.w  y_pos(a0), $002E(a0)
        addi.w  #$060, $002E(a0)
        move.w  #$FF00,x_vel(a0)
loc_01E6A4:
        lea     loc_01E4A8(PC), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        move.w  #$39C, (Water_Level_1).w
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01E6C4(pc,d0), d1
        jsr     loc_01E6C4(pc,d1)
        bra     J_MarkObjGone_15        ; loc_01E882
loc_01E6C4:
        dc.w    loc_01E6DC-loc_01E6C4
        dc.w    loc_01E6F2-loc_01E6C4
loc_01E6C8:
        bsr     loc_01E404
        bsr     J_SpeedToPos_0D         ; loc_01E894
        lea     loc_01E4A8(PC), A1
        bsr     J_AnimateSprite_08      ; loc_01E888
        bra     J_MarkObjGone_15        ; loc_01E882
loc_01E6DC:
        bsr     J_SpeedToPos_0D         ; loc_01E894
        bsr     loc_01E3E6
        bsr     loc_01E72E
        bsr     loc_01E810
        bsr     loc_01E780
        rts
loc_01E6F2:
        bsr     J_SpeedToPos_0D         ; loc_01E894
        bsr     loc_01E3E6
        bsr     loc_01E72E
        bsr     loc_01E810
        bsr     loc_01E708
        rts
loc_01E708:
        subq.w  #1, Objoff_30(a0)
        beq.s   loc_01E71C
        move.w  Objoff_30(A0), D0
        cmpi.w  #$012, d0
        beq     loc_01E7A6
        rts
loc_01E71C:
        subq.b  #$2, $0025(a0)
        move.b  #6, $001C(a0)
        move.w  #$0B4, Objoff_30(a0)
        rts
loc_01E72E:
        sf      $002D(a0)
        sf      $002C(a0)
        sf      objoff_36(a0)
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        bpl.s   loc_01E74E
        btst    #0, status(a0)
        bne.s   loc_01E756
        bra.s   loc_01E75A
loc_01E74E:
        btst    #0, status(a0)
        bne.s   loc_01E75A
loc_01E756:
        st      $002C(a0)
loc_01E75A:
        move.w  ($FFFFB00C).w, d0
        sub.w   y_pos(a0), D0
        cmpi.w  #Checksum_fourcc, d0
        blt.s   loc_01E77E
        cmpi.w  #$004, d0
        bgt.s   loc_01E77A
        st      $002D(a0)
        move.w  #0, $0012(a0)
        rts
loc_01E77A:
        st      objoff_36(a0)
loc_01E77E:
        rts
loc_01E780:
        tst.b   $002C(a0)
        bne.s   loc_01E7A4
        subq.w  #1, Objoff_30(a0)
        bgt.s   loc_01E7A4
        tst.b   $002D(a0)
        beq.s   loc_01E7A4
        move.b  #$7, $001C(a0)
        move.w  #$024, Objoff_30(a0)
        addi.b  #$2, $0025(a0)
loc_01E7A4:
        rts
loc_01E7A6:
        bsr     J_SingleObjectLoad_07   ; loc_01E87C
        bne.s   loc_01E80E
        move.b  #$51, 0(a1)
        move.b  #4, $0024(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.l  #Aquis_Mappings, mappings(a1) ; loc_001E4E0
        move.w  #$24E0, art_tile(a1)
        ori.b   #4, render_flags(a1)
        move.b  #3, $0018(a1)
        move.b  #$2, $001C(a1)
        move.b  #$E5, $0020(a1)
        move.w  #$00C, d0
        move.w  #$010, d1
        move.w  #$FD00, D2
        btst    #0, status(a0)
        beq.s   loc_01E802
        neg.w   d1
        neg.w   D2
loc_01E802:
        sub.w   d0, y_pos(a1)
        sub.w   d1, x_pos(a1)
        move.w  D2,x_vel(a1)
loc_01E80E:
        rts
loc_01E810:
        tst.b   $002D(a0)
        bne.s   loc_01E86E
        tst.b   objoff_36(a0)
        beq.s   loc_01E840
        move.w  $002E(A0), D0
        cmp.w   y_pos(a0), D0
        ble.s   loc_01E864
        tst.b   $002C(a0)
        beq.s   loc_01E838
        move.w  $002A(A0), D0
        cmp.w   y_pos(a0), D0
        bge.s   loc_01E864
        rts
loc_01E838:
        move.w  #$180, $0012(a0)
        rts
loc_01E840:
        move.w  $002A(A0), D0
        cmp.w   y_pos(a0), D0
        bge.s   loc_01E864
        tst.b   $002C(a0)
        beq.s   loc_01E85C
        move.w  $002E(A0), D0
        cmp.w   y_pos(a0), D0
        ble.s   loc_01E864
        rts
loc_01E85C:
        move.w  #$FE80, $0012(a0)
        rts
loc_01E864:
        move.w  d0, y_pos(a0)
        move.w  #0, $0012(a0)
loc_01E86E:
        rts
;=============================================================================== 
; Object 0x51 - Oil Ocean - Aquis (Seahorse)  
                
;===============================================================================  
J_DisplaySprite_0F: ; loc_01E870:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_23: ; loc_01E876:
        jmp     DeleteObject            ; (loc_00D3B4)
J_SingleObjectLoad_07: ; loc_01E87C:
        jmp     SingleObjectLoad        ; (loc_00E772)
J_MarkObjGone_15: ; loc_01E882:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_08: ; loc_01E888:
        jmp     AnimateSprite           ; (loc_00D412)
J_ObjectFall_03: ; loc_01E88E:
        jmp     ObjectFall              ; (loc_00D24E)
J_SpeedToPos_0D: ; loc_01E894:
        jmp     SpeedToPos              ; (loc_00D27A)
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x4B - Green Hill - Buzz Bomber  
                 
;===============================================================================          
Obj4B_Buzz_Bomber: ; loc_01E89C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01E8AA(pc,d0), d1
        jmp     loc_01E8AA(pc,d1)
loc_01E8AA:
        dc.w    loc_01E8FC-loc_01E8AA
        dc.w    loc_01E9A8-loc_01E8AA
        dc.w    loc_01E8C4-loc_01E8AA
        dc.w    loc_01E8B2-loc_01E8AA
loc_01E8B2:
        bsr     J_SpeedToPos_0E         ; loc_01EBB0
        lea     (loc_01EAF2), A1
        bsr     J_AnimateSprite_09      ; loc_01EB98
        bra     loc_01EBA4
loc_01E8C4:
        move.l  $002A(A0), A1
        tst.b   (a1)
        beq     J_DeleteObject_24       ; loc_01EB8C
        tst.w   Objoff_30(a1)
        bmi.s   loc_01E8D6
        rts
loc_01E8D6:
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        lea     (loc_01EAF2), A1
        bsr     J_AnimateSprite_09      ; loc_01EB98
        bra     loc_01EBA4
loc_01E8FC:
        move.l  #Buzz_Bomber_Mappings,mappings(a0) ; loc_01EB0E
        move.w  #$3E6,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_20 ; loc_01EBAA
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #$18, $0017(a0)
        move.b  #3,priority(a0)
        addq.b  #2,routine(a0)
        bsr     J_S1SingleObjectLoad_0B  ; loc_01EB92
        bne.s   loc_01E9A6
        move.b  #$4B, 0(a1)
        move.b  #4, $0024(a1)
        move.l  #Buzz_Bomber_Mappings, mappings(a1) ; loc_01EB0E
        move.w  #$3E6, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_03 ; loc_01EB9E
        move.b  #4, $0018(a1)
        move.b  #$10, $0019(a1)
        move.b  status(a0), status(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  #1, $001C(a1)
        move.l  A0, $002A(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$100, $002E(a0)
        move.w  #$FF00,x_vel(a0)
        btst    #0,render_flags(a0)
        beq.s   loc_01E9A6
        neg.w  x_vel(a0)
loc_01E9A6:
        rts
loc_01E9A8:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01E9C4(pc,d0), d1
        jsr     loc_01E9C4(pc,d1)
        lea     (loc_01EAF2), A1
        bsr     J_AnimateSprite_09      ; loc_01EB98
        bra     loc_01EBA4
loc_01E9C4:
        dc.w    loc_01E9C8-loc_01E9C4
        dc.w    loc_01EA58-loc_01E9C4
loc_01E9C8:
        bsr     loc_01EA0A
        subq.w  #1, Objoff_30(a0)
        move.w  Objoff_30(A0), D0
        cmpi.w  #$F, d0
        beq.s   loc_01E9EE
        tst.w   D0
        bpl.s   loc_01E9EC
        subq.w  #1, $002E(a0)
        bgt     J_SpeedToPos_0E         ; loc_01EBB0
        move.w  #$01E, Objoff_30(a0)
loc_01E9EC:
        rts
loc_01E9EE:
        sf      $0032(a0)
        neg.w  x_vel(a0)
        bchg    #0,render_flags(a0)
        bchg    #0, status(a0)
        move.w  #$100, $002E(a0)
        rts
loc_01EA0A:
        tst.b   $0032(a0)
        bne     loc_01EA56
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        move.w  d0, d1
        bpl.s   loc_01EA20
        neg.w   D0
loc_01EA20:
        cmpi.w  #$028, d0
        blt.s   loc_01EA56
        cmpi.w  #$030, d0
        bgt.s   loc_01EA56
        tst.w   d1
        bpl.s   loc_01EA3A
        btst    #0,render_flags(a0)
        beq.s   loc_01EA56
        bra.s   loc_01EA42
loc_01EA3A:
        btst    #0,render_flags(a0)
        bne.s   loc_01EA56
loc_01EA42:
        st      $0032(a0)
        addq.b  #$2, $0025(a0)
        move.b  #3, $001C(a0)
        move.w  #$032, Objoff_34(a0)
loc_01EA56:
        rts
loc_01EA58:
        move.w  Objoff_34(A0), D0
        subq.w  #1,d0
        blt.s   loc_01EA6C
        move.w  d0, Objoff_34(a0)
        cmpi.w  #$014, d0
        beq.s   loc_01EA72
        rts
loc_01EA6C:
        subq.b  #$2, $0025(a0)
        rts
loc_01EA72:
        jsr     JmpTo_SingleObjLoad2      ; loc_00E788
        bne.s   loc_01EAEC
        move.b  #$4B, 0(a1)
        move.b  #6, $0024(a1)
        move.l  #Buzz_Bomber_Mappings, mappings(a1) ; loc_01EB0E
        move.w  #$3E6, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_03 ; loc_01EB9E
        move.b  #4, $0018(a1)
        move.b  #$98, $0020(a1)
        move.b  #$10, $0019(a1)
        move.b  status(a0), status(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  #$2, $001C(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        addi.w  #$018, y_pos(a1)
        move.w  #$00D, d0
        move.w  #$180, $0012(a1)
        move.w  #$FE80,x_vel(a1)
        btst    #0, render_flags(a1)
        beq.s   loc_01EAEC
        neg.w  x_vel(a1)
        neg.w   D0
loc_01EAEC:
        add.w   d0, x_pos(a1)
        rts        
loc_01EAF2:
        dc.w    loc_01EAFA-loc_01EAF2
        dc.w    loc_01EAFD-loc_01EAF2
        dc.w    loc_01EB01-loc_01EAF2
        dc.w    loc_01EB05-loc_01EAF2
loc_01EAFA:        
        dc.b    $0F, $00, $FF                 
loc_01EAFD:
        dc.b    $02, $03, $04, $FF
loc_01EB01:        
        dc.b    $03, $05, $06, $FF
loc_01EB05:        
        dc.b    $09, $01, $01, $01, $01, $01, $FD, $00, $00 
Buzz_Bomber_Mappings:            
loc_01EB0E:
        dc.w    loc_01EB1C-loc_01EB0E
        dc.w    loc_01EB2E-loc_01EB0E
        dc.w    loc_01EB48-loc_01EB0E
        dc.w    loc_01EB62-loc_01EB0E
        dc.w    loc_01EB6C-loc_01EB0E
        dc.w    loc_01EB76-loc_01EB0E
        dc.w    loc_01EB80-loc_01EB0E
loc_01EB1C:
        dc.w    $0002
        dc.l    $F8090000, $0000FFE8, $F8090006, $00030000
loc_01EB2E:
        dc.w    $0003
        dc.l    $F8090000, $0000FFE8, $F805000C, $00060000
        dc.l    $08050010, $00080002
loc_01EB48:
        dc.w    $0003
        dc.l    $F8090000, $0000FFE8, $F805000C, $00060000
        dc.l    $08050014, $000A0002
loc_01EB62:
        dc.w    $0001
        dc.l    $F0010014, $000A0004
loc_01EB6C:
        dc.w    $0001
        dc.l    $F0010016, $000B0004
loc_01EB76:
        dc.w    $0001
        dc.l    $F8010018, $000CFFF4
loc_01EB80:
        dc.w    $0001
        dc.l    $F801001A, $000DFFF4        
;=============================================================================== 
; Object 0x4B - Green Hill - Buzz Bomber  
                
;===============================================================================  
        dc.w    $0000           ; Filler
J_DeleteObject_24: ; loc_01EB8C:
        jmp     DeleteObject            ; (loc_00D3B4)
J_S1SingleObjectLoad_0B: ; loc_01EB92:
        jmp     JmpTo_SingleObjLoad2      ; loc_00E788
J_AnimateSprite_09: ; loc_01EB98:
        jmp     AnimateSprite           ; loc_00D412
J_ModifyA1SpriteAttr_2P_03: ; loc_01EB9E:
        jmp     ModifyA1SpriteAttr_2P   ; loc_00DC4C
loc_01EBA4:
        jmp     loc_00D340
J_ModifySpriteAttr_2P_20: ; loc_01EBAA:
        jmp     Adjust2PArtPointer     ; loc_00DC30
J_SpeedToPos_0E: ; loc_01EBB0:
        jmp     SpeedToPos              ; loc_00D27A
        dc.w    $0000           ; Filler        
;=============================================================================== 
; Object 0x4A - Oil Ocean - Octus
                 
;===============================================================================         
Obj4A_Octus: ; loc_01EBB8:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01EBC6(pc,d0), d1
        jmp     loc_01EBC6(pc,d1)
loc_01EBC6:          
        dc.w    loc_01EBF6-loc_01EBC6
        dc.w    loc_01EC5C-loc_01EBC6
        dc.w    loc_01EBEA-loc_01EBC6
        dc.w    loc_01EBCE-loc_01EBC6
loc_01EBCE:
        subi.w  #$001, $002C(a0)
        bmi.s   loc_01EBD8
        rts
loc_01EBD8:
        bsr     J_ObjectFall_04         ; loc_01EE60
loc_01EBDC:
        lea     (loc_01EDAA), A1
        bsr     J_AnimateSprite_0A      ; loc_01EE5A
        bra     J_MarkObjGone_16        ; loc_01EE54
loc_01EBEA:
        subq.w  #1, $002C(a0)
        beq     J_DeleteObject_25       ; loc_01EE4E
        bra     J_DisplaySprite_10      ; loc_01EE48
loc_01EBF6:
        move.l  #Octus_Mappings,mappings(a0) ; loc_01EDBC
        move.w  #$238A,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #8, $0017(a0)
        bsr     J_ObjectFall_04         ; loc_01EE60
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_01EC54
        add.w   d1, y_pos(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bpl.s   loc_01EC54
loc_01EC4E:
        bchg    #0, status(a0)
loc_01EC54:
        move.w  y_pos(a0), $002A(a0)
        rts
loc_01EC5C:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01EC78(pc,d0), d1
        jsr     loc_01EC78(pc,d1)
        lea     (loc_01EDAA), A1
        bsr     J_AnimateSprite_0A      ; loc_01EE5A
        bra     J_MarkObjGone_16        ; loc_01EE54
loc_01EC78:
        dc.w    loc_01EC80-loc_01EC78
        dc.w    loc_01ECA0-loc_01EC78
        dc.w    loc_01ECC2-loc_01EC78
        dc.w    loc_01ED94-loc_01EC78
loc_01EC80:
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        cmpi.w  #$080, d0
        bgt.s   loc_01EC9E
        cmpi.w  #$FF80, d0
        blt.s   loc_01EC9E
        addq.b  #$2, $0025(a0)
        move.b  #1, $001C(a0)
loc_01EC9E:
        rts
loc_01ECA0:
        subi.l  #$0018000, y_pos(a0)
        move.w  $002A(A0), D0
        sub.w   y_pos(a0), D0
        cmpi.w  #$20, d0
        ble.s   loc_01ECC0
        addq.b  #$2, $0025(a0)
        move.w  #0, $002C(a0)
loc_01ECC0:
        rts
loc_01ECC2:
        subi.w  #$001, $002C(a0)
        beq     loc_01ED8E
        bpl     loc_01ED8C
        move.w  #$01E, $002C(a0)
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_01ED28
        move.b  #$4A, 0(a1)
        move.b  #4, $0024(a1)
        move.l  #Octus_Mappings, mappings(a1) ; loc_01EDBC
        move.b  #4, $001A(a1)
        move.w  #$24C6, art_tile(a1)
        move.b  #3, $0018(a1)
        move.b  #$10, $0019(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$01E, $002C(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  status(a0), status(a1)
loc_01ED28:
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_01ED8C
        move.b  #$4A, 0(a1)
        move.b  #6, $0024(a1)
        move.l  #Octus_Mappings, mappings(a1) ; loc_01EDBC
        move.w  #$24C6, art_tile(a1)
        move.b  #4, $0018(a1)
        move.b  #$10, $0019(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.w  #$F, $002C(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  status(a0), status(a1)
        move.b  #$2, $001C(a1)
        move.w  #$FA80,x_vel(a1)
        btst    #0, render_flags(a1)
        beq.s   loc_01ED8C
        neg.w  x_vel(a1)
loc_01ED8C:
        rts
loc_01ED8E:
        addq.b  #$2, $0025(a0)
        rts
loc_01ED94:
        move.w  #$FFFFFFFA, d0
        btst    #0,render_flags(a0)
        beq.s   loc_01EDA2
        neg.w   D0
loc_01EDA2:
        add.w   d0, x_pos(a0)
        bra     J_MarkObjGone_16        ; loc_01EE54  
loc_01EDAA:
        dc.w    loc_01EDB0-loc_01EDAA
        dc.w    loc_01EDB3-loc_01EDAA
        dc.w    loc_01EDB8-loc_01EDAA
loc_01EDB0:
        dc.b    $0F, $00, $FF
loc_01EDB3:
        dc.b    $03, $01, $02, $03, $FF
loc_01EDB8:
        dc.b    $02, $05, $06, $FF
Octus_Mappings:        
loc_01EDBC:
        dc.w    loc_01EDCA-loc_01EDBC
        dc.w    loc_01EDDC-loc_01EDBC
        dc.w    loc_01EDF6-loc_01EDBC
        dc.w    loc_01EE10-loc_01EDBC
        dc.w    loc_01EE2A-loc_01EDBC
        dc.w    loc_01EE34-loc_01EDBC
        dc.w    loc_01EE3E-loc_01EDBC
loc_01EDCA:
        dc.w    $0002
        dc.l    $F00D0000, $0000FFF0, $000D0008, $0004FFF0
loc_01EDDC:
        dc.w    $0003
        dc.l    $F00D0000, $0000FFF0, $00090010, $0008FFE8
        dc.l    $00090016, $000B0000
loc_01EDF6:
        dc.w    $0003
        dc.l    $F00D0000, $0000FFF0, $0009001C, $000EFFE8
        dc.l    $00090022, $00110000
loc_01EE10:
        dc.w    $0003
        dc.l    $F00D0000, $0000FFF0, $00090028, $0014FFE8
        dc.l    $0009002E, $00170000
loc_01EE2A:
        dc.w    $0001
        dc.l    $F0010034, $001AFFF7
loc_01EE34:
        dc.w    $0001
        dc.l    $F2010036, $001BFFF0
loc_01EE3E:
        dc.w    $0001
        dc.l    $F2010038, $001CFFF0                         
;=============================================================================== 
; Object 0x4A - Oil Ocean - Octus
                
;===============================================================================    
J_DisplaySprite_10: ; loc_01EE48:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_25: ; loc_01EE4E:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_16: ; loc_01EE54:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_0A: ; loc_01EE5A:
        jmp     AnimateSprite           ; (loc_00D412)
J_ObjectFall_04: ; loc_01EE60:
        jmp     ObjectFall              ; (loc_00D24E)
        dc.w    $0000           ; Filler 
;=============================================================================== 
; Object 0x4C - Hidden Palace - Batbot
                 
;=============================================================================== 
Obj4C_Batbot: ; loc_01EE68:  
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01EE76(pc,d0), d1
        jmp     loc_01EE76(pc,d1)
loc_01EE76:
        dc.w    loc_01EE7C-loc_01EE76
        dc.w    loc_01EEBA-loc_01EE76
        dc.w    loc_01EF28-loc_01EE76
loc_01EE7C:        
        move.l  #Batbot_Mappings,mappings(a0)  ; loc_01F106
        move.w  #$2530,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #8, $0017(a0)
        addq.b  #2,routine(a0)
        move.w  y_pos(a0), $002E(a0)
        rts
loc_01EEBA:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01EEDA(pc,d0), d1
        jsr     loc_01EEDA(pc,d1)
        bsr     loc_01EEE0
        lea     (loc_01F0D2), A1
        bsr     J_AnimateSprite_0B      ; loc_01F2E2
        bra     J_MarkObjGone_17        ; loc_01F2DC
loc_01EEDA:
        dc.w    loc_01F046-loc_01EEDA
        dc.w    loc_01F07E-loc_01EEDA
        dc.w    loc_01F08A-loc_01EEDA        
loc_01EEE0:
        move.b  Objoff_3F(A0), D0
        jsr     CalcSine        ; loc_00320A
        asr.w   #6, d0
        add.w   $002E(A0), D0
        move.w  d0, y_pos(a0)
        addq.b  #4, Objoff_3F(a0)
        rts
loc_01EEFA:        
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        cmpi.w  #$080, d0
        bgt.s   loc_01EF26
        cmpi.w  #$FF80, d0
        blt.s   loc_01EF26
        move.b  #4, $0025(a0)
        move.b  #$2, $001C(a0)
        move.w  #8, $002A(a0)
        move.b  #0, Objoff_3E(a0)
loc_01EF26:
        rts
loc_01EF28:
        bsr     loc_01F026
        bsr     loc_01EFC8
        bsr     loc_01EF48
        bsr     J_SpeedToPos_0F         ; loc_01F2E8
        lea     (loc_01F0D2), A1
        bsr     J_AnimateSprite_0B      ; loc_01F2E2
        bra     J_MarkObjGone_17        ; loc_01F2DC
        rts
loc_01EF48:
        tst.b   objoff_3D(a0)
        beq.s   loc_01EF5A
        bset    #0,render_flags(a0)
        bset    #0, status(a0)
loc_01EF5A:
        rts
loc_01EF5C:        
        subi.w  #$001, $002C(a0)
        bpl.s   loc_01EFA6
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        cmpi.w  #$060, d0
        bgt.s   loc_01EFA8
        cmpi.w  #$FFA0, d0
        blt.s   loc_01EFA8
        tst.w   D0
        bpl.s   loc_01EF80
        st      objoff_3D(a0)
loc_01EF80:
        move.b  #$40, Objoff_3F(a0)
        move.w  #$400, $14(a0)
        move.b  #4,routine(a0)
        move.b  #3, $001C(a0)
        move.w  #$00C, $002A(a0)
        move.b  #1, Objoff_3E(a0)
        moveq	#0,d0
loc_01EFA6:
        rts
loc_01EFA8:
        cmpi.w  #$080, d0
        bgt.s   loc_01EFB4
        cmpi.w  #$FF80, d0
        bgt.s   loc_01EFA6
loc_01EFB4:
        move.b  #1, $001C(a0)
        move.b  #0, $0025(a0)
        move.w  #$018, $002A(a0)
        rts
loc_01EFC8:
        tst.b   objoff_3D(a0)
        bne.s   loc_01EFE2
        moveq	#0,d0
        move.b  Objoff_3F(A0), D0
        cmpi.w  #$0C0, d0
        bge.s   loc_01EFF6
        addq.b  #$2, d0
        move.b  d0, Objoff_3F(a0)
        rts
loc_01EFE2:
        moveq	#0,d0
        move.b  Objoff_3F(A0), D0
        cmpi.w  #$0C0, d0
        beq.s   loc_01EFF6
        subq.b  #$2, d0
        move.b  d0, Objoff_3F(a0)
        rts
loc_01EFF6:
        sf      objoff_3D(a0)
        move.b  #0, $001C(a0)
        move.b  #2,routine(a0)
        move.b  #0, $0025(a0)
        move.w  #$018, $002A(a0)
        move.b  #1, $001C(a0)
        bclr    #0,render_flags(a0)
        bclr    #0, status(a0)
        rts
loc_01F026:
        move.b  Objoff_3F(A0), D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), d1
        asr.l   #8, d1
        move.w  d1,x_vel(a0)
        muls.w  $14(A0), D0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
        rts
loc_01F046:
        subi.w  #$001, $002A(a0)
        bpl.s   loc_01F07C
        bsr     loc_01EEFA
        beq.s   loc_01F07C
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.b  #$FF, d0
        bne.s   loc_01F07C
        move.w  #$018, $002A(a0)
        move.w  #$01E, $002C(a0)
        addq.b  #$2, $0025(a0)
        move.b  #1, $001C(a0)
        move.b  #0, Objoff_3E(a0)
loc_01F07C:
        rts
loc_01F07E:
        subq.b  #1, $002A(a0)
        bpl.s   loc_01F088
        subq.b  #$2, $0025(a0)
loc_01F088:
        rts
loc_01F08A:
        bsr     loc_01EF5C
        beq.s   loc_01F0D0
        subi.w  #$001, $002A(a0)
        bne.s   loc_01F0D0
        move.b  Objoff_3E(A0), D0
        beq.s   loc_01F0B8
        move.b  #0, Objoff_3E(a0)
        move.w  #8, $002A(a0)
        bset    #0,render_flags(a0)
        bset    #0, status(a0)
        rts
loc_01F0B8:
        move.b  #1, Objoff_3E(a0)
        move.w  #$00C, $002A(a0)
        bclr    #0,render_flags(a0)
        bclr    #0, status(a0)
loc_01F0D0:
        rts
loc_01F0D2:
        dc.w    loc_01F0DA-loc_01F0D2
        dc.w    loc_01F0DE-loc_01F0D2
        dc.w    loc_01F0ED-loc_01F0D2
        dc.w    loc_01F0FE-loc_01F0D2
loc_01F0DA:  
        dc.b    $01, $00, $05, $FF
loc_01F0DE:
        dc.b    $01, $01, $06, $01, $06, $02, $07, $02, $07, $01, $06, $01, $06, $FD, $00
loc_01F0ED:
        dc.b    $01, $01, $06, $01, $06, $02, $07, $03, $08, $04, $09, $04, $09, $03, $08, $FE
        dc.b    $0A
loc_01F0FE:
        dc.b    $03, $0A, $0B, $0C, $0D, $0E, $FF, $00
Batbot_Mappings:        
loc_01F106:
        dc.w    loc_01F124-loc_01F106
        dc.w    loc_01F146-loc_01F106
        dc.w    loc_01F168-loc_01F106
        dc.w    loc_01F18A-loc_01F106
        dc.w    loc_01F1AC-loc_01F106
        dc.w    loc_01F1C6-loc_01F106
        dc.w    loc_01F1E8-loc_01F106
        dc.w    loc_01F20A-loc_01F106
        dc.w    loc_01F22C-loc_01F106
        dc.w    loc_01F24E-loc_01F106
        dc.w    loc_01F268-loc_01F106
        dc.w    loc_01F282-loc_01F106
        dc.w    loc_01F29C-loc_01F106
        dc.w    loc_01F2AE-loc_01F106
        dc.w    loc_01F2C0-loc_01F106
loc_01F124:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $00050004, $0002FFF8
        dc.l    $F00B0008, $00040005, $F00B0808, $0804FFE3
loc_01F146:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $00050004, $0002FFF8
        dc.l    $F60D0014, $000A0005, $F60D0814, $080AFFDB
loc_01F168:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $00050004, $0002FFF8
        dc.l    $F80D001C, $000E0004, $F80D081C, $080EFFDC
loc_01F18A:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $00050004, $0002FFF8
        dc.l    $F8050024, $0012FFEC, $F8050028, $00140004
loc_01F1AC:
        dc.w    $0003
        dc.l    $F801002C, $00160000, $F0050000, $0000FFF8
        dc.l    $00050004, $0002FFF8
loc_01F1C6:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $0005002E, $0017FFF8
        dc.l    $F00B0008, $00040005, $F00B0808, $0804FFE3
loc_01F1E8:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $0005002E, $0017FFF8
        dc.l    $F60D0014, $000A0005, $F60D0814, $080AFFDB
loc_01F20A:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $0005002E, $0017FFF8
        dc.l    $F80D001C, $000E0004, $F80D081C, $080EFFDC
loc_01F22C:
        dc.w    $0004
        dc.l    $F0050000, $0000FFF8, $0005002E, $0017FFF8
        dc.l    $F8050028, $00140004, $F8050024, $0012FFEC
loc_01F24E:
        dc.w    $0003
        dc.l    $F801002C, $00160000, $F0050000, $0000FFF8
        dc.l    $0005002E, $0017FFF8
loc_01F268:
        dc.w    $0003
        dc.l    $F0070032, $0019FFF8, $F80D001C, $000E0004
        dc.l    $F80D081C, $080EFFDC
loc_01F282:
        dc.w    $0003
        dc.l    $F0070032, $0019FFF8, $F8050028, $00140004
        dc.l    $F8050024, $0012FFEC
loc_01F29C:
        dc.w    $0002
        dc.l    $F801002C, $00160000, $F0070032, $0019FFF8
loc_01F2AE:
        dc.w    $0002
        dc.l    $F801082C, $0816FFF8, $F0070032, $0019FFF8
loc_01F2C0:
        dc.w    $0003
        dc.l    $F0070032, $0019FFF8, $F8050828, $0814FFEC
        dc.l    $F8050824, $08120004   
;=============================================================================== 
; Object 0x4C - Hidden Palace - Batbot
                
;===============================================================================        
        dc.w    $0000           ; Filler
J_MarkObjGone_17: ; loc_01F2DC:
        jmp     MarkObjGone             ; loc_00D2A0
J_AnimateSprite_0B: ; loc_01F2E2:
        jmp     AnimateSprite           ; loc_00D412
J_SpeedToPos_0F: ; loc_01F2E8:
        jmp     SpeedToPos              ; loc_00D27A
        dc.w    $0000           ; Filler
;=============================================================================== 
; Object 0x4E - (Desert Level) - Crocobot 
                 
;===============================================================================           
Obj4E_Crocobot: ; loc_01F2F0:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01F2FE(pc,d0), d1
        jmp     loc_01F2FE(pc,d1)
loc_01F2FE:
        dc.w    loc_01F302-loc_01F2FE
        dc.w    loc_01F352-loc_01F2FE
loc_01F302:
        move.l  #Crocobot_Mappings,mappings(a0) ; loc_01F420
        move.w  #$2300,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #8, $0017(a0)
        bsr     J_ObjectFall_05         ; loc_01F5DC
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_01F350
        add.w   d1, y_pos(a0)
        move.w  #0, $0012(a0)
        addq.b  #2,routine(a0)
loc_01F350:
        rts
loc_01F352:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01F36E(pc,d0), d1
        jsr     loc_01F36E(pc,d1)
        lea     (loc_01F406), A1
        bsr     J_AnimateSprite_0C      ; loc_01F5D6
        bra     J_MarkObjGone_18        ; loc_01F5D0
loc_01F36E:
        dc.w    loc_01F372-loc_01F36E
        dc.w    loc_01F396-loc_01F36E
loc_01F372:
        subq.w  #1, Objoff_30(a0)
        bpl.s   loc_01F394
        addq.b  #$2, $0025(a0)
        move.w  #$FF40,x_vel(a0)
        move.b  #0, $001C(a0)
        bchg    #0, status(a0)
        bne.s   loc_01F394
        neg.w  x_vel(a0)
loc_01F394:
        rts
loc_01F396:
        bsr     loc_01F3CE
        bsr     J_SpeedToPos_10         ; loc_01F5E2
        jsr     ObjHitFloor             ; (loc_013898)
        cmpi.w  #$FFF8, d1
        blt.s   loc_01F3B6
        cmpi.w  #$00C, d1
        bge.s   loc_01F3B6
        add.w   d1, y_pos(a0)
        rts
loc_01F3B6:
        subq.b  #$2, $0025(a0)
        move.w  #$03B, Objoff_30(a0)
        move.w  #0,x_vel(a0)
        move.b  #1, $001C(a0)
        rts
loc_01F3CE:
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bmi.s   loc_01F3E8
        cmpi.w  #$40, d0
        bgt.s   loc_01F3FE
        btst    #0, status(a0)
        beq.s   loc_01F3F6
        rts
loc_01F3E8:
        cmpi.w  #$FFC0, d0
        blt.s   loc_01F3FE
        btst    #0, status(a0)
        beq.s   loc_01F3FE
loc_01F3F6:
        move.b  #$2, $001C(a0)
        rts
loc_01F3FE:
        move.b  #0, $001C(a0)
        rts        

loc_01F406:
        dc.w    loc_01F40C-loc_01F406
        dc.w    loc_01F414-loc_01F406
        dc.w    loc_01F417-loc_01F406
loc_01F40C:
        dc.b    $03, $00, $04, $02, $03, $01, $05, $FF
loc_01F414:
        dc.b    $0F, $00, $FF
loc_01F417:
        dc.b    $03, $06, $0A, $08, $09, $07, $0B, $FF, $00
Crocobot_Mappings:        
loc_01F420:
        dc.w    loc_01F438-loc_01F420
        dc.w    loc_01F45A-loc_01F420
        dc.w    loc_01F47C-loc_01F420
        dc.w    loc_01F49E-loc_01F420
        dc.w    loc_01F4C0-loc_01F420
        dc.w    loc_01F4E2-loc_01F420
        dc.w    loc_01F504-loc_01F420
        dc.w    loc_01F526-loc_01F420
        dc.w    loc_01F548-loc_01F420
        dc.w    loc_01F56A-loc_01F420
        dc.w    loc_01F58C-loc_01F420
        dc.w    loc_01F5AE-loc_01F420
loc_01F438:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050020, $0010000C
loc_01F45A:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050024, $0012000C
loc_01F47C:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050028, $0014000C
loc_01F49E:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050020, $0010000C
loc_01F4C0:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050024, $0012000C
loc_01F4E2:
        dc.w    $0004
        dc.l    $F80E0000, $0000FFE4, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050028, $0014000C
loc_01F504:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050020, $0010000C
loc_01F526:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050024, $0012000C
loc_01F548:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001C, $000E0004, $00050028, $0014000C
loc_01F56A:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050020, $0010000C
loc_01F58C:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050024, $0012000C
loc_01F5AE:
        dc.w    $0004
        dc.l    $F00B000C, $0006FFEC, $F8050018, $000C0004
        dc.l    $0001001E, $000F0004, $00050028, $0014000C        
;=============================================================================== 
; Object 0x4E - (Desert Level) - Crocobot 
                
;===============================================================================         
J_MarkObjGone_18: ; loc_01F5D0:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_AnimateSprite_0C: ; loc_01F5D6:
        jmp     AnimateSprite           ; (loc_00D412)
J_ObjectFall_05: ; loc_01F5DC:
        jmp     ObjectFall              ; (loc_00D24E)
J_SpeedToPos_10: ; loc_01F5E2:
        jmp     SpeedToPos              ; (loc_00D27A)         
;=============================================================================== 
; Object 0x53 - Green Hill - Chopper
                 
;===============================================================================          
Obj53_Chopper: ; loc_01F5E8: 
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01F5FA(pc,d0), d1
        jsr     loc_01F5FA(pc,d1)
        bra     J_MarkObjGone_19        ; loc_01F6D0
loc_01F5FA:
        dc.w    loc_01F5FE-loc_01F5FA
        dc.w    loc_01F638-loc_01F5FA
loc_01F5FE:
        addq.b  #2,routine(a0)
        move.l  #Chopper_Mappings,mappings(a0) ; loc_01F696
        move.w  #$41C,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_21 ; loc_01F6DC
        move.b  #4,render_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$9,collision_flags(a0)
        move.b  #$10,width_pixels(a0)
        move.w  #$FC00, $0012(a0)
        move.w  y_pos(a0), Objoff_30(a0)
loc_01F638:
        lea     (loc_01F684), A1
        bsr     J_AnimateSprite_0D      ; loc_01F6D6
        bsr     J_SpeedToPos_11         ; loc_01F6E2
        addi.w  #$018, $0012(a0)
        move.w  Objoff_30(A0), D0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_01F660
        move.w  d0, y_pos(a0)
        move.w  #$FB00, $0012(a0)
loc_01F660:
        move.b  #1, $001C(a0)
        subi.w  #$0C0, d0
        cmp.w   y_pos(a0), D0
        bcc.s   loc_01F682
        move.b  #0, $001C(a0)
        tst.w   $0012(a0)
        bmi.s   loc_01F682
        move.b  #$2, $001C(a0)
loc_01F682:
        rts
loc_01F684:
        dc.w    loc_01F68A-loc_01F684
        dc.w    loc_01F68E-loc_01F684
        dc.w    loc_01F692-loc_01F684
loc_01F68A:
        dc.b    $07, $00, $01, $FF
loc_01F68E:
        dc.b    $03, $00, $01, $FF
loc_01F692:
        dc.b    $07, $00, $FF, $00
Chopper_Mappings:        
loc_01F696:
        dc.w    loc_01F69A-loc_01F696
        dc.w    loc_01F6B4-loc_01F696
loc_01F69A:
        dc.w    $0003
        dc.l    $F0050000, $0000FFF4, $F0010004, $00020004
        dc.l    $0009000A, $0005FFF4
loc_01F6B4:
        dc.w    $0003
        dc.l    $F0050000, $0000FFF4, $F0050006, $00030002
        dc.l    $00090010, $0008FFF4          
;=============================================================================== 
; Object 0x53 - Green Hill - Chopper
                
;=============================================================================== 
        dc.w    $0000           ; Filler  
J_MarkObjGone_19: ; loc_01F6D0:
        jmp     MarkObjGone             ; loc_00D2A0
J_AnimateSprite_0D: ; loc_01F6D6:
        jmp     AnimateSprite           ; loc_00D412
J_ModifySpriteAttr_2P_21: ; loc_01F6DC:
        jmp     Adjust2PArtPointer     ; loc_00DC30
J_SpeedToPos_11: ; loc_01F6E2:
        jmp     SpeedToPos              ; loc_00D27A  
;=============================================================================== 
; Object 0x54 - Green Hill - Motobug
                 
;===============================================================================  
Obj54_Motobug: ; loc_01F6E8:         
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01F6F6(pc,d0), d1
        jmp     loc_01F6F6(pc,d1)
loc_01F6F6:        
        dc.w    loc_01F700-loc_01F6F6
        dc.w    loc_01F7A0-loc_01F6F6
        dc.w    loc_01F8CC-loc_01F6F6
        dc.w    loc_01F904-loc_01F6F6
        dc.w    loc_01F88A-loc_01F6F6
loc_01F700:
        move.l  #Motobug_Mappings,mappings(a0) ; loc_01F938
        move.w  #$402,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_22 ; loc_01F98A
        ori.b   #4,render_flags(a0)
        move.b  #$A,collision_flags(a0)
        move.b  #4, $0018(a0)
        move.b  #$10,width_pixels(a0)
        move.b  #$10, y_radius(a0)
        move.b  #$E, $0017(a0)
        bsr     J_S1SingleObjectLoad_0C  ; loc_01F972
        bne.s   loc_01F788
        move.b  #$54, 0(a1)
        move.b  #6, $0024(a1)
        move.l  #Motobug_Mappings, mappings(a1) ; loc_01F938
        move.w  #$2402, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_04 ; loc_01F97E
        move.b  #3, $0018(a1)
        move.b  #$10, $0019(a1)
        move.b  status(a0), status(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.l  A0, $002A(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  #$2, $001A(a1)
loc_01F788:
        addq.b  #2,routine(a0)
        move.w  #$FF80, d0
        btst    #0, status(a0)
        beq.s   loc_01F79A
        neg.w   D0
loc_01F79A:
        move.w  d0,x_vel(a0)
        rts
loc_01F7A0:
        bsr     loc_01F7E8
        bsr     J_SpeedToPos_12         ; loc_01F996
        jsr     ObjHitFloor             ; loc_013898
        cmpi.w  #$FFF8, d1
        blt.s   loc_01F7CC
        cmpi.w  #$00C, d1
        bge.s   loc_01F7CC
        add.w   d1, y_pos(a0)
        lea     (loc_01F92C), A1
        bsr     J_AnimateSprite_0E      ; loc_01F978
        bra     loc_01F984
loc_01F7CC:
        addq.b  #2,routine(a0)
        move.w  #$014, Objoff_30(a0)
        st      Objoff_34(a0)
        lea     (loc_01F92C), A1
        bsr     J_AnimateSprite_0E      ; loc_01F978
        bra     loc_01F984
loc_01F7E8:
        tst.b   $0035(a0)
        bne.s   loc_01F82A
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   x_pos(a0), D0
        cmpi.w  #$064, d0
        bgt.s   loc_01F82A
        cmpi.w  #$FF9C, d0
        blt.s   loc_01F82A
        tst.w   D0
        bmi.s   loc_01F810
        btst    #0, status(a0)
        beq.s   loc_01F82A
        bra.s   loc_01F818
loc_01F810:
        btst    #0, status(a0)
        bne.s   loc_01F82A
loc_01F818:
        move.w x_vel(A0), D0
        asl.w   #$2, d0
        move.w  d0,x_vel(a0)
        st      $0035(a0)
        bsr     loc_01F82C
loc_01F82A:
        rts
loc_01F82C:
        bsr     J_S1SingleObjectLoad_0C  ; loc_01F972
        bne.s   loc_01F888
        move.b  #$54, 0(a1)
        move.b  #8, $0024(a1)
        move.l  #Buzz_Bomber_Mappings, mappings(a1) ; loc_01EB0E
        move.w  #$3E6, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_04 ; loc_01F97E
        move.b  #4, $0018(a1)
        move.b  #$10, $0019(a1)
        move.b  status(a0), status(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.l  A0, $002A(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        addq.w  #$7, y_pos(a1)
        addi.w  #$00D, x_pos(a1)
        move.b  #1, $001C(a1)
loc_01F888:
        rts
loc_01F88A:
        move.l  $002A(A0), A1
        cmpi.b  #$54, (a1)
        bne     J_DeleteObject_26       ; loc_01F96C
        tst.b   Objoff_34(a1)
        bne     J_DeleteObject_26       ; loc_01F96C
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        addq.w  #$7, y_pos(a0)
        moveq   #$D, d0
        btst    #0, status(a0)
        beq.s   loc_01F8BA
        neg.w   D0
loc_01F8BA:
        add.w   d0, x_pos(a0)
        lea     (loc_01EAF2), A1
        bsr     J_AnimateSprite_0E      ; loc_01F978
        bra     loc_01F984
loc_01F8CC:
        subi.w  #$001, Objoff_30(a0)
        bpl     loc_01F984
        neg.w  x_vel(a0)
        bsr     J_ObjectFall_06         ; loc_01F990
        move.w x_vel(A0), D0
        asr.w   #$2, d0
        move.w  d0,x_vel(a0)
        bchg    #0, status(a0)
        bchg    #0,render_flags(a0)
        subq.b  #2,routine(a0)
        sf      Objoff_34(a0)
        sf      $0035(a0)
        bra     loc_01F984
loc_01F904:
        move.l  $002A(A0), A1
        cmpi.b  #$54, (a1)
        bne     J_DeleteObject_26       ; loc_01F96C
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        bra     loc_01F984
loc_01F92C:
        dc.w    loc_01F930-loc_01F92C
        dc.w    loc_01F934-loc_01F92C
loc_01F930:
        dc.b    $05, $00, $01, $FF
loc_01F934:
        dc.b    $01, $00, $01, $FF
Motobug_Mappings:        
loc_01F938:
        dc.w    loc_01F93E-loc_01F938
        dc.w    loc_01F950-loc_01F938
        dc.w    loc_01F962-loc_01F938
loc_01F93E:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $01090014, $000AFFF4
loc_01F950:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $01091014, $100AFFF4
loc_01F962:
        dc.w    $0001
        dc.l    $FA050010, $0008FFE9             
;=============================================================================== 
; Object 0x54 - Green Hill - Motobug
                
;=============================================================================== 
J_DeleteObject_26: ; loc_01F96C:
        jmp     DeleteObject            ; loc_00D3B4
J_S1SingleObjectLoad_0C: ; loc_01F972:
        jmp     JmpTo_SingleObjLoad2      ; loc_00E788
J_AnimateSprite_0E: ; loc_01F978:
        jmp     AnimateSprite           ; loc_00D412
J_ModifyA1SpriteAttr_2P_04: ; loc_01F97E:
        jmp     ModifyA1SpriteAttr_2P   ; loc_00DC4C
loc_01F984:
        jmp     loc_00D340
J_ModifySpriteAttr_2P_22: ; loc_01F98A:
        jmp     Adjust2PArtPointer     ; loc_00DC30
J_ObjectFall_06: ; loc_01F990:
        jmp     ObjectFall              ; loc_00D24E
J_SpeedToPos_12: ; loc_01F996:
        jmp     SpeedToPos              ; loc_00D27A   
;=============================================================================== 
; Object 0x57 - 
                 
;===============================================================================            
Obj57: ; loc_01F99C:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01F9AA(pc,d0), d1
        jmp     loc_01F9AA(pc,d1)
loc_01F9AA:
        dc.w    loc_01F9B6-loc_01F9AA
        dc.w    loc_01F9DC-loc_01F9AA
        dc.w    loc_01FA38-loc_01F9AA
        dc.w    loc_01FA6A-loc_01F9AA
        dc.w    loc_01FA94-loc_01F9AA
        dc.w    loc_01FAAE-loc_01F9AA
loc_01F9B6:
        move.b  #0,collision_flags(a0)
        cmpi.w  #$29D0, x_pos(a0)
        ble.s   loc_01F9CE
        subi.w  #$001, x_pos(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01F9CE:
        move.w  #$29D0, x_pos(a0)
        addq.b  #$2, $0025(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01F9DC:
        moveq	#0,d0
        move.b  $002C(A0), D0
        move.w  loc_01F9EA(pc,d0), d1
        jmp     loc_01F9EA(pc,d1)
loc_01F9EA:
        dc.w    loc_01F9EE-loc_01F9EA
        dc.w    loc_01FA14-loc_01F9EA
loc_01F9EE:
        cmpi.w  #$41E, y_pos(a0)
        bge.s   loc_01FA00
        addi.w  #$001, y_pos(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FA00:
        addq.b  #$2, $002C(a0)
        bset    #0, $002D(a0)
        move.w  #$03C, $002A(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FA14:
        subi.w  #$001, $002A(a0)
        bpl     J_DisplaySprite_11      ; loc_0202DC
        move.w  #$FE00,x_vel(a0)
        addq.b  #$2, $0025(a0)
        move.b  #$F,collision_flags(a0)
        bset    #1, $002D(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FA38:
        bsr     loc_01FBA8
        bsr     loc_01FB86
        move.w  $002E(A0), D0
        lsr.w   #1,d0
        subi.w  #$014, d0
        move.w  d0, y_pos(a0)
        move.w  #0, $002E(a0)
        move.l  x_pos(a0), D2
        move.w x_vel(A0), D0
        ext.l   D0
        asl.l   #8,d0
        add.l   d0, D2
        move.l  D2, x_pos(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FA6A:
        subq.w  #1, Objoff_3C(a0)
        dc.w    $6A00, $0000
        bset    #0, status(a0)
        bclr    #$7, status(a0)
        clr.w  x_vel(a0)
        addq.b  #$2, $0025(a0)
        move.w  #$FFDA, Objoff_3C(a0)
        move.w  #$00C, $002A(a0)
        rts
loc_01FA94:
        addq.w  #1, y_pos(a0)
        subq.w  #1, $002A(a0)
        bpl     J_DisplaySprite_11      ; loc_0202DC
        addq.b  #$2, $0025(a0)
        move.b  #0, $002C(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FAAE:
        moveq	#0,d0
        move.b  $002C(A0), D0
        move.w  loc_01FAC0(pc,d0), d1
        jsr     loc_01FAC0(pc,d1)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FAC0:
        dc.w    loc_01FAC6-loc_01FAC0
        dc.w    loc_01FB3E-loc_01FAC0
        dc.w    loc_01FB58-loc_01FAC0
loc_01FAC6:
        bclr    #0, $002D(a0)
        bsr     J_S1SingleObjectLoad_0D ; loc_0202EE
        bne     J_DisplaySprite_11      ; loc_0202DC
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #Obj57_Mappings, mappings(a1) ; loc_020168
        move.w  #$2540, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$20, $0019(a1)
        move.b  #4, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addi.w  #$00C, y_pos(a1)
        move.b  status(a0), status(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  #8, $0024(a1)
        move.b  #$2, $001C(a1)
        move.w  #$010, $002A(a1)
        move.w  #$032, $002A(a0)
        addq.b  #$2, $002C(a0)
        rts
loc_01FB3E:
        subi.w  #$001, $002A(a0)
        bpl.s   loc_01FB56
        bset    #$2, $002D(a0)
        move.w  #$060, $002A(a0)
        addq.b  #$2, $002C(a0)
loc_01FB56:
        rts
loc_01FB58:
        subq.w  #1, y_pos(a0)
        subi.w  #$001, $002A(a0)
        bpl.s   loc_01FB84
        addq.w  #1, y_pos(a0)
        addq.w  #$2, x_pos(a0)
        cmpi.w  #$2B08, x_pos(a0)
        bcs.s   loc_01FB84
        tst.b   ($FFFFF7A7).w
        bne.s   loc_01FB84
        move.b  #1, ($FFFFF7A7).w
        bra     J_DeleteObject_27       ; loc_0202E2
loc_01FB84:
        rts
loc_01FB86:
        move.w  x_pos(a0), D0
        cmpi.w  #$2720, d0
        ble.s   loc_01FB96
        cmpi.w  #$2B08, d0
        blt.s   loc_01FBA6
loc_01FB96:
        bchg    #0, status(a0)
        bchg    #0,render_flags(a0)
        neg.w  x_vel(a0)
loc_01FBA6:
        rts
loc_01FBA8:
        cmpi.b  #6, $0025(a0)
        bcc.s   loc_01FBEE
        tst.b   status(a0)
        bmi.s   loc_01FBF0
        tst.b  collision_flags(a0)
        bne.s   loc_01FBEE
        tst.b   Objoff_3E(a0)
        bne.s   loc_01FBD2
        move.b  #$20, Objoff_3E(a0)
        move.w  #$0AC, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_01FBD2:
        lea     ($FFFFFB22).w, A1
        moveq	#0,d0
        tst.w   (a1)
        bne.s   loc_01FBE0
        move.w  #$EEE, d0
loc_01FBE0:
        move.w  d0, (a1)
        subq.b  #1, Objoff_3E(a0)
        bne.s   loc_01FBEE
        move.b  #$F,collision_flags(a0)
loc_01FBEE:
        rts
loc_01FBF0:
        moveq   #$64, d0
        bsr     AddPoints               ; loc_022FD0
        move.b  #6, $0025(a0)
        move.w  #$0B3, Objoff_3C(a0)
        bset    #3, $002D(a0)
        rts               
;=============================================================================== 
; Object 0x57 - 
                
;===============================================================================   

;=============================================================================== 
; Object 0x58 - 
                 
;===============================================================================  
Obj58: ; loc_01FC0A:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_01FC18(pc,d0), d1
        jmp     loc_01FC18(pc,d1)
loc_01FC18:
        dc.w    loc_01FC46-loc_01FC18
        dc.w    loc_01FCCC-loc_01FC18
        dc.w    loc_01FD1E-loc_01FC18
        dc.w    loc_01FE00-loc_01FC18
        dc.w    loc_01FC22-loc_01FC18
loc_01FC22:
        subi.w  #$001, y_pos(a0)
        subi.w  #$001, $002A(a0)
        bpl     J_DisplaySprite_11      ; loc_0202DC
        move.b  #0, $0024(a0)
        lea     (loc_02012E), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FC46:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01FC54(pc,d0), d1
        jmp     loc_01FC54(pc,d1)
loc_01FC54:
        dc.w    loc_01FC58-loc_01FC54
        dc.w    loc_01FCA2-loc_01FC54
loc_01FC58:
        move.l  Objoff_34(A0), A1
        cmpi.b  #$55, (a1)
        bne     J_DeleteObject_27       ; loc_0202E2
        btst    #0, $002D(a1)
        beq.s   loc_01FC7C
        move.b  #1, $001C(a0)
        move.w  #$018, $002A(a0)
        addq.b  #$2, $0025(a0)
loc_01FC7C:
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        lea     (loc_02012E), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FCA2:
        subi.w  #$001, $002A(a0)
        bpl.s   loc_01FCBE
        cmpi.w  #$FFF0, $002A(a0)
        ble     J_DeleteObject_27       ; loc_0202E2
        addi.w  #$001, y_pos(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FCBE:
        lea     (loc_02012E), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FCCC:
        move.l  Objoff_34(A0), A1
        cmpi.b  #$55, (a1)
        bne     J_DeleteObject_27       ; loc_0202E2
        btst    #1, $002D(a1)
        beq     J_DisplaySprite_11      ; loc_0202DC
        btst    #$2, $002D(a1)
        bne     loc_01FD0E
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        addi.w  #8, y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FD0E:
        move.b  #8, $001A(a0)
        move.b  #0, $0018(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FD1E:
        moveq	#0,d0
        move.b  $0025(A0), D0
        move.w  loc_01FD2C(pc,d0), d1
        jmp     loc_01FD2C(pc,d1)
loc_01FD2C:
        dc.w    loc_01FD34-loc_01FD2C
        dc.w    loc_01FD52-loc_01FD2C
        dc.w    loc_01FDB2-loc_01FD2C
        dc.w    loc_01FDDE-loc_01FD2C
loc_01FD34:
        move.l  Objoff_34(A0), A1
        cmpi.b  #$55, (a1)
        bne     J_DeleteObject_27       ; loc_0202E2
        btst    #1, $002D(a1)
        beq     J_DisplaySprite_11      ; loc_0202DC
        addq.b  #$2, $0025(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FD52:
        move.l  Objoff_34(A0), A1
        cmpi.b  #$55, (a1)
        bne     J_DeleteObject_27       ; loc_0202E2
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        tst.b   status(a0)
        bpl.s   loc_01FD74
        addq.b  #$2, $0025(a0)
loc_01FD74:
        bsr     loc_01FB86
        bsr     J_ObjectFall_07         ; loc_020306
        jsr     ObjHitFloor             ; (loc_013898)
        tst.w   d1
        bpl.s   loc_01FD8A
        add.w   d1, y_pos(a0)
loc_01FD8A:
        move.w  #$100, $0012(a0)
        cmpi.b  #1, $0018(a0)
        bne.s   loc_01FDA4
        move.w  y_pos(a0), D0
        move.l  Objoff_34(A0), A1
        add.w   d0, $002E(a1)
loc_01FDA4:
        lea     (loc_02023C), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FDB2:
        subi.w  #$001, $002A(a0)
        bpl     J_DisplaySprite_11      ; loc_0202DC
        addq.b  #$2, $0025(a0)
        move.w  #$00A, $002A(a0)
        move.w  #$FD00, $0012(a0)
        cmpi.b  #1, $0018(a0)
        beq     J_DisplaySprite_11      ; loc_0202DC
        neg.w  x_vel(a0)
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FDDE:
        subq.w  #1, $002A(a0)
        bpl     J_DisplaySprite_11      ; loc_0202DC
        bsr     J_ObjectFall_07         ; loc_020306
        bsr     J_ObjHitFloor_01        ; loc_020300
        tst.w   d1
        bpl.s   loc_01FDFC
        move.w  #$FE00, $0012(a0)
        add.w   d1, y_pos(a0)
loc_01FDFC:
        bra     J_MarkObjGone_1A        ; loc_0202E8
loc_01FE00:
        move.l  Objoff_34(A0), A1
        cmpi.b  #$55, (a1)
        bne     J_DeleteObject_27       ; loc_0202E2
        btst    #3, $002D(a1)
        bne.s   loc_01FE66
        bsr     loc_01FE86
        btst    #1, $002D(a1)
        beq     J_DisplaySprite_11      ; loc_0202DC
        move.b  #$8B,collision_flags(a0)
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        addi.w  #$010, y_pos(a0)
        move.w  #$FFCA, d0
        btst    #0, status(a0)
        beq.s   loc_01FE54
        neg.w   D0
loc_01FE54:
        add.w   d0, x_pos(a0)
        lea     (loc_02023C), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FE66:
        move.w  #$FFFD, d0
        btst    #0, status(a0)
        beq.s   loc_01FE74
        neg.w   D0
loc_01FE74:
        add.w   d0, x_pos(a0)
        lea     (loc_02023C), A1
        bsr     J_AnimateSprite_0F      ; loc_0202F4
        bra     J_DisplaySprite_11      ; loc_0202DC
loc_01FE86:
        cmpi.b  #1, $0021(a1)
        beq.s   loc_01FE90
        rts
loc_01FE90:
        move.w  x_pos(a0), D0
        sub.w   (MainCharacter+x_pos).w, d0
        bpl.s   loc_01FEA4
        btst    #0, status(a1)
        bne.s   loc_01FEAE
        rts
loc_01FEA4:
        btst    #0, status(a1)
        beq.s   loc_01FEAE
        rts
loc_01FEAE:
        bset    #3, $002D(a1)
        rts  
loc_01FEB6:
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_01FF2E
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020250, mappings(a1)
        move.w  #$24C0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #1, $0018(a1)
        move.b  #$10, y_radius(a1)
        move.b  #$10, $0017(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addi.w  #$01C, x_pos(a1)
        addi.w  #$00C, y_pos(a1)
        move.w  #$FE00,x_vel(a1)
        move.b  #4, $0024(a1)
        move.b  #4, $001A(a1)
        move.b  #1, $001C(a1)
        move.w  #$016, $002A(a1)
loc_01FF2E:
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_01FFA6
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020250, mappings(a1)
        move.w  #$24C0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #1, $0018(a1)
        move.b  #$10, y_radius(a1)
        move.b  #$10, $0017(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addi.w  #$FFF4, x_pos(a1)
        addi.w  #$00C, y_pos(a1)
        move.w  #$FE00,x_vel(a1)
        move.b  #4, $0024(a1)
        move.b  #4, $001A(a1)
        move.b  #1, $001C(a1)
        move.w  #$04B, $002A(a1)
loc_01FFA6:
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_02001E
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020250, mappings(a1)
        move.w  #$24C0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #$2, $0018(a1)
        move.b  #$10, y_radius(a1)
        move.b  #$10, $0017(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addi.w  #$FFD4, x_pos(a1)
        addi.w  #$00C, y_pos(a1)
        move.w  #$FE00,x_vel(a1)
        move.b  #4, $0024(a1)
        move.b  #6, $001A(a1)
        move.b  #$2, $001C(a1)
        move.w  #$030, $002A(a1)
loc_02001E:
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_02007E
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020250, mappings(a1)
        move.w  #$24C0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$10, $0019(a1)
        move.b  #1, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addi.w  #$FFCA, x_pos(a1)
        addi.w  #8, y_pos(a1)
        move.b  #6, $0024(a1)
        move.b  #1, $001A(a1)
        move.b  #0, $001C(a1)
loc_02007E:
        rts        
loc_020080:
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_0200C8
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020250, mappings(a1)
        move.w  #$4C0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$20, $0019(a1)
        move.b  #$2, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        move.b  #$2, $0024(a1)
loc_0200C8:
        bsr     loc_01FEB6
        subi.w  #8, objoff_38(a0)
        move.w  #$2A00, x_pos(a0)
        move.w  #$2C0, y_pos(a0)
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_02012C
        move.b  #$58, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #loc_020168, mappings(a1)
        move.w  #$2540, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_05 ; loc_0202FA
        move.b  #4, render_flags(a1)
        move.b  #$20, $0019(a1)
        move.b  #4, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        move.w  #$01E, $002A(a1)
        move.b  #0, $0024(a1)
loc_02012C:
        rts        
loc_02012E:
        dc.w    loc_020134-loc_02012E
        dc.w    loc_020138-loc_02012E
        dc.w    loc_02014E-loc_02012E
loc_020134:
        dc.b    $01, $05, $06, $FF
loc_020138:
        dc.b    $01, $01, $01, $01, $02, $02, $02, $03, $03, $03, $04, $04, $04, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $FF
loc_02014E:
        dc.b    $01, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $03, $03, $03, $02
        dc.b    $02, $02, $01, $01, $01, $05, $06, $FE, $02, $00               
Obj57_Mappings:
loc_020168:
        dc.w    loc_020176-loc_020168
        dc.w    loc_020180-loc_020168
        dc.w    loc_0201AA-loc_020168
        dc.w    loc_0201D4-loc_020168
        dc.w    loc_0201EE-loc_020168
        dc.w    loc_020208-loc_020168
        dc.w    loc_020222-loc_020168
loc_020176:
        dc.w    $0001
        dc.l    $D8050000, $00000002
loc_020180:
        dc.w    $0005
        dc.l    $D8050004, $00020002, $D80D000C, $00060012
        dc.l    $D80D000C, $00060032, $D80D000C, $0006FFE2
        dc.l    $D80D000C, $0006FFC2
loc_0201AA:
        dc.w    $0005
        dc.l    $D8050004, $00020002, $D80D000C, $00060012
        dc.l    $D8050008, $00040032, $D80D000C, $0006FFE2
        dc.l    $D8050008, $0004FFD2
loc_0201D4:
        dc.w    $0003
        dc.l    $D8050004, $00020002, $D80D000C, $00060012
        dc.l    $D80D000C, $0006FFE2
loc_0201EE:
        dc.w    $0003
        dc.l    $D8050004, $00020002, $D8050008, $00040012
        dc.l    $D8050008, $0004FFF2
loc_020208:
        dc.w    $0003
        dc.l    $D8050000, $00000002, $D80D000C, $00060012
        dc.l    $D80D000C, $00060032
loc_020222:
        dc.w    $0003
        dc.l    $D8050004, $00020002, $D80D000C, $0006FFE2
        dc.l    $D80D000C, $0006FFC2     
loc_02023C:
        dc.w    loc_020242-loc_02023C
        dc.w    loc_020247-loc_02023C
        dc.w    loc_02024B-loc_02023C
loc_020242:
        dc.b    $05, $01, $02, $03, $FF
loc_020247:
        dc.b    $01, $04, $05, $FF
loc_02024B:
        dc.b    $01, $06, $07, $FF, $00 

loc_020250:
        dc.w    loc_020262-loc_020250
        dc.w    loc_02027C-loc_020250
        dc.w    loc_020286-loc_020250
        dc.w    loc_020290-loc_020250
        dc.w    loc_02029A-loc_020250
        dc.w    loc_0202A4-loc_020250
        dc.w    loc_0202AE-loc_020250
        dc.w    loc_0202B8-loc_020250
        dc.w    loc_0202C2-loc_020250
loc_020262:
        dc.w    $0003
        dc.l    $F00F0000, $0000FFD0, $F00F0010, $0008FFF0
        dc.l    $F00F0020, $00100010
loc_02027C:
        dc.w    $0001
        dc.l    $F00F0030, $0018FFF0
loc_020286:
        dc.w    $0001
        dc.l    $F00F0040, $0020FFF0
loc_020290:
        dc.w    $0001
        dc.l    $F00F0050, $0028FFF0
loc_02029A:
        dc.w    $0001
        dc.l    $F00F0060, $0030FFF0
loc_0202A4:
        dc.w    $0001
        dc.l    $F00F1060, $1030FFF0
loc_0202AE:
        dc.w    $0001
        dc.l    $F00F0070, $0038FFF0
loc_0202B8:
        dc.w    $0001
        dc.l    $F00F1070, $1038FFF0
loc_0202C2:
        dc.w    $0003
        dc.l    $F00F8000, $8000FFD0, $F00F8010, $8008FFF0
        dc.l    $F00F8020, $80100010                       
;=============================================================================== 
; Object 0x58 - 
                
;===============================================================================    
J_DisplaySprite_11: ; loc_0202DC:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_27: ; loc_0202E2:
        jmp     DeleteObject            ; (loc_00D3B4)
J_MarkObjGone_1A: ; loc_0202E8:
        jmp     MarkObjGone             ; (loc_00D2A0)
J_S1SingleObjectLoad_0D: ; loc_0202EE:
        jmp     JmpTo_SingleObjLoad2      ; (loc_00E788)
J_AnimateSprite_0F: ; loc_0202F4:
        jmp     AnimateSprite           ; (loc_00D412)
J_ModifyA1SpriteAttr_2P_05: ; loc_0202FA:
        jmp     ModifyA1SpriteAttr_2P   ; (loc_00DC4C)
J_ObjHitFloor_01: ; loc_020300:
        jmp     ObjHitFloor             ; (loc_013898)
J_ObjectFall_07: ; loc_020306:
        jmp     ObjectFall              ; (loc_00D24E)
;=============================================================================== 
; Object 0x55 - Ghz Boss
                 
;===============================================================================         
Obj55_Ghz_Boss: ; loc_02030C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_02031A(pc,d0), d1
        jmp     loc_02031A(pc,d1)
loc_02031A:
        dc.w    loc_020324-loc_02031A
        dc.w    loc_02044E-loc_02031A
        dc.w    loc_02048C-loc_02031A
        dc.w    loc_0204BE-loc_02031A
        dc.w    loc_020560-loc_02031A
loc_020324:
        move.l  #Ghz_Boss_Mappings,mappings(a0) ; loc_0206BA
        move.w  #$2400,art_tile(a0)
        ori.b   #4,render_flags(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #3,priority(a0)
        move.b  #$F,collision_flags(a0)
        move.b  #8, $0021(a0)
        addq.b  #2,routine(a0)
        move.w  x_pos(a0), Objoff_30(a0)
        move.w  y_pos(a0), objoff_38(a0)
        move.b  subtype(A0), D0
        cmpi.b  #$81, d0
        bne.s   loc_020370
        addi.w  #$060,art_tile(a0)
loc_020370:
        bsr     J_ModifySpriteAttr_2P_23 ; loc_02073A
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne     loc_020434
        move.b  #$55, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  A1, Objoff_34(a0)
        move.l  #Ghz_Boss_Mappings, mappings(a1) ; loc_0206BA
        move.w  #$400, art_tile(a1)
        move.b  #4, render_flags(a1)
        move.b  #$20, $0019(a1)
        move.b  #3, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addq.b  #4, $0024(a1)
        move.b  #1, $001C(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  subtype(A0), D0
        cmpi.b  #$81, d0
        bne.s   loc_0203D8
        addi.w  #$060, art_tile(a1)
loc_0203D8:
        bsr     J_ModifyA1SpriteAttr_2P_06 ; loc_020734
        tst.b   subtype(a0)
        bmi.s   loc_020434
        jsr     JmpTo_SingleObjLoad2      ; (loc_00E788)
        bne.s   loc_020434
        move.b  #$55, 0(a1)
        move.l  A0, Objoff_34(a1)
        move.l  #Ghz_Boss_Mappings_1, mappings(a1) ; loc_020612
        move.w  #$4D0, art_tile(a1)
        bsr     J_ModifyA1SpriteAttr_2P_06 ; loc_020734
        move.b  #1, $001E(a0)
        move.b  #4, render_flags(a1)
        move.b  #$20, $0019(a1)
        move.b  #3, $0018(a1)
        move.l  x_pos(a0), x_pos(a1)
        move.l  y_pos(a0), y_pos(a1)
        addq.b  #6, $0024(a1)
        move.b  render_flags(A0), render_flags(a1)
loc_020434:
        move.b  subtype(A0), D0
        andi.w  #$07F, d0
        add.w   d0, d0
        add.w   d0, d0
        move.l  loc_020446(pc,d0), A1
        jmp     (a1)
loc_020446:
        dc.l    $00000000
        dc.l    loc_020080 
loc_02044E:
        move.b  subtype(A0), D0
        andi.w  #$07F, d0
        add.w   d0, d0
        add.w   d0, d0
        move.l  loc_020484(pc,d0), A1
        jsr     (a1)
        lea     (loc_0206AE), A1
        jsr     AnimateSprite           ; (loc_00D412)
        move.b  status(a0), D0
        andi.b  #3, d0
        andi.b  #$FC,render_flags(a0)
        or.b    d0,render_flags(a0)
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_020484:
        dc.l    $00000000
        dc.l    Obj57  ; loc_01F99C
loc_02048C:
        move.l  Objoff_34(A0), A1
        move.l  x_pos(A1), x_pos(a0)
        move.l  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        move.l  #loc_0206AE, A1
        jsr     AnimateSprite           ; (loc_00D412)
        jmp     DisplaySprite           ; (loc_00D3C2)           
loc_0204BA:
        dc.b    $00, $FF, $01, $00
loc_0204BE:
        btst    #$7, status(a0)
        bne.s   loc_020512
        move.l  Objoff_34(A0), A1
        move.l  x_pos(A1), x_pos(a0)
        move.l  y_pos(A1), y_pos(a0)
        move.b  status(a1), status(a0)
        move.b  render_flags(A1), render_flags(a0)
        subq.b  #1, $001E(a0)
        bpl.s   loc_020506
        move.b  #1, $001E(a0)
        move.b  $002A(A0), D0
        addq.b  #1,d0
        cmpi.b  #$2, d0
        ble.s   loc_0204FC
        moveq	#0,d0
loc_0204FC:
        move.b  loc_0204BA(pc,d0), $001A(a0)
        move.b  d0, $002A(a0)
loc_020506:
        cmpi.b  #$FF, $001A(a0)
        bne     J_DisplaySprite_12      ; loc_020728
        rts
loc_020512:
        move.l  Objoff_34(A0), A1
        btst    #6, $002E(a1)
        bne.s   loc_020520
        rts
loc_020520:
        addq.b  #2,routine(a0)
        move.l  #Ghz_Boss_Mappings_2,mappings(a0) ; loc_02062A
        move.w  #$4D8,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_23 ; loc_02073A
        move.b  #0, $001A(a0)
        move.b  #5, $001E(a0)
        move.l  Objoff_34(A0), A1
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        addi.w  #$004, y_pos(a0)
        subi.w  #$028, x_pos(a0)
        rts
loc_020560:
        subq.b  #1, $001E(a0)
        bpl.s   loc_0205A2
        move.b  #5, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #4, $001A(a0)
        bne     loc_0205A2
        move.b  #0, $001A(a0)
        move.l  Objoff_34(A0), A1
        move.b  (A1), D0
        beq     J_DeleteObject_28       ; loc_02072E
        move.w  x_pos(A1), x_pos(a0)
        move.w  y_pos(A1), y_pos(a0)
        addi.w  #$004, y_pos(a0)
        subi.w  #$028, x_pos(a0)
loc_0205A2:
        bra     J_DisplaySprite_12      ; loc_020728
;=============================================================================== 
; Object 0x55 - Ghz Boss
                
;===============================================================================                        
;=============================================================================== 
; Object 0x56 - Ghz Boss
                 
;===============================================================================  
Obj56: ; loc_0205A6:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_0205B4(pc,d0), d1
        jmp     loc_0205B4(pc,d1)
loc_0205B4:
        dc.w    loc_0205B8-loc_0205B4
        dc.w    loc_0205F4-loc_0205B4
loc_0205B8:
        addq.b  #2,routine(a0)
        move.l  #Obj56_Mappings,mappings(a0) ; loc_02065A
        move.w  #$5A0,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_23 ; loc_02073A
        move.b  #4,render_flags(a0)
        move.b  #1, $0018(a0)
        move.b  #0,collision_flags(a0)
        move.b  #$C,width_pixels(a0)
        move.b  #$7, $001E(a0)
        move.b  #0, $001A(a0)
        rts
loc_0205F4:
        subq.b  #1, $001E(a0)
        bpl.s   loc_02060E
        move.b  #$7, $001E(a0)
        addq.b  #1, $001A(a0)
        cmpi.b  #$7, $001A(a0)
        beq     J_DeleteObject_28       ; loc_02072E
loc_02060E:
        bra     J_DisplaySprite_12      ; loc_020728
Ghz_Boss_Mappings_1: 
loc_020612:
        dc.w    loc_020616-loc_020612
        dc.w    loc_020620-loc_020612
loc_020616:
        dc.w    $0001
        dc.l    $00050000, $0000001C
loc_020620:
        dc.w    $0001
        dc.l    $00050004, $0002001C
Ghz_Boss_Mappings_2: 
loc_02062A:
        dc.w    loc_020632-loc_02062A
        dc.w    loc_02063C-loc_02062A
        dc.w    loc_020646-loc_02062A
        dc.w    loc_020650-loc_02062A
loc_020632:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_02063C:
        dc.w    $0001
        dc.l    $F8050004, $0002FFF8
loc_020646:
        dc.w    $0001
        dc.l    $F8050008, $0004FFF8
loc_020650:
        dc.w    $0001
        dc.l    $F805000C, $0006FFF8    
Obj56_Mappings:
loc_02065A:
        dc.w    loc_020668-loc_02065A
        dc.w    loc_020672-loc_02065A
        dc.w    loc_02067C-loc_02065A
        dc.w    loc_020686-loc_02065A
        dc.w    loc_020690-loc_02065A
        dc.w    loc_02069A-loc_02065A
        dc.w    loc_0206A4-loc_02065A
loc_020668:
        dc.w    $0001
        dc.l    $F8050000, $0000FFF8
loc_020672:
        dc.w    $0001
        dc.l    $F00F0004, $0002FFF0
loc_02067C:
        dc.w    $0001
        dc.l    $F00F0014, $000AFFF0
loc_020686:
        dc.w    $0001
        dc.l    $F00F0024, $0012FFF0
loc_020690:
        dc.w    $0001
        dc.l    $F00F0034, $001AFFF0
loc_02069A:
        dc.w    $0001
        dc.l    $F00F0044, $0022FFF0
loc_0206A4:
        dc.w    $0001
        dc.l    $F00F0054, $002AFFF0                   
loc_0206AE:
        dc.w    loc_0206B2-loc_0206AE
        dc.w    loc_0206B5-loc_0206AE
loc_0206B2:
        dc.b    $0F, $00, $FF
loc_0206B5:
        dc.b    $07, $01, $02, $FF, $00 
Ghz_Boss_Mappings:         
loc_0206BA:
        dc.w    loc_0206C0-loc_0206BA
        dc.w    loc_0206E2-loc_0206BA
        dc.w    loc_020704-loc_0206BA
loc_0206C0:
        dc.w    $0004
        dc.l    $F8050000, $0000FFE0, $08050004, $0002FFE0
        dc.l    $F80F0008, $0004FFF0, $F8070018, $000C0010
loc_0206E2:
        dc.w    $0004
        dc.l    $E8050028, $0014FFE0, $E80D0030, $0018FFF0
        dc.l    $E8050024, $00120010, $D8050020, $00100002
loc_020704:
        dc.w    $0004
        dc.l    $E8050028, $0014FFE0, $E80D0038, $001CFFF0
        dc.l    $E8050024, $00120010, $D8050020, $00100002                      
;=============================================================================== 
; Object 0x56 - Ghz Boss
                
;===============================================================================          
        nop                     ; Filler
J_DisplaySprite_12: ; loc_020728:
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_28: ; loc_02072E:
        jmp     DeleteObject            ; (loc_00D3B4)
J_ModifyA1SpriteAttr_2P_06: ; loc_020734:
        jmp     ModifyA1SpriteAttr_2P   ; (loc_00DC4C)
J_ModifySpriteAttr_2P_23: ; loc_02073A:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
;=============================================================================== 
; Object 0x8A - Credits - Sonic 1 Leftover
                 
;=============================================================================== 
Obj8A_Credits: ; loc_020740:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_02074E(pc,d0), d1
        jmp     loc_02074E(pc,d1)
loc_02074E:
        dc.w    loc_020752-loc_02074E
        dc.w    loc_0207C0-loc_02074E
loc_020752:
        addq.b  #2,routine(a0)
        move.w  #$120, x_pos(a0)
        move.w  #$0F0, $000A(a0)
        move.l  #Credits_Mappings,mappings(a0) ; loc_0207C6
        move.w  #$5A0,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_24 ; loc_020E54
        move.w  ($FFFFFFF4).w, d0
        move.b  d0, $001A(a0)
        move.b  #0,render_flags(a0)
        move.b  #0, $0018(a0)
        cmpi.b  #4, (Game_Mode).w
        bne.s   loc_0207C0
        move.w  #$300,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_24 ; loc_020E54
        move.b  #$A, $001A(a0)
        tst.b   ($FFFFFFD3).w
        beq.s   loc_0207C0
        cmpi.b  #$72, ($FFFFF604).w
        bne.s   loc_0207C0
        move.w  #$EEE, ($FFFFFBC0).w
        move.w  #$880, ($FFFFFBC2).w
        jmp     DeleteObject            ; (loc_00D3B4)
loc_0207C0:
        jmp     DisplaySprite           ; (loc_00D3C2)
Credits_Mappings:        
loc_0207C6:              
        dc.w    loc_0207DC-loc_0207C6
        dc.w    loc_02084E-loc_0207C6
        dc.w    loc_0208D0-loc_0207C6
        dc.w    loc_020922-loc_0207C6
        dc.w    loc_0209E4-loc_0207C6
        dc.w    loc_020A86-loc_0207C6
        dc.w    loc_020B58-loc_0207C6
        dc.w    loc_020C12-loc_0207C6
        dc.w    loc_020D0C-loc_0207C6
        dc.w    loc_020D86-loc_0207C6
        dc.w    loc_020DC8-loc_0207C6
loc_0207DC:
        dc.w    $000E
        dc.l    $F805002E, $0017FF88, $F8050026, $0013FF98
        dc.l    $F805001A, $000DFFA8, $F8010046, $0023FFB8
        dc.l    $F805001E, $000FFFC0, $F805003E, $001FFFD8
        dc.l    $F805000E, $0007FFE8, $F8050004, $0002FFF8
        dc.l    $F8090008, $00040008, $F805002E, $00170028
        dc.l    $F805003E, $001F0038, $F8050004, $00020048
        dc.l    $F805005C, $002E0058, $F805005C, $002E0068
loc_02084E:
        dc.w    $0010
        dc.l    $D8050000, $0000FF80, $D8050004, $0002FF90
        dc.l    $D8090008, $0004FFA0, $D805000E, $0007FFB4
        dc.l    $D8050012, $0009FFD0, $D8050016, $000BFFE0
        dc.l    $D8050004, $0002FFF0, $D805001A, $000D0000
        dc.l    $0805001E, $000FFFC8, $08050004, $0002FFD8
        dc.l    $08050022, $0011FFE8, $08050026, $0013FFF8
        dc.l    $08050016, $000B0008, $0805002A, $00150020
        dc.l    $08050004, $00020030, $0805002E, $00170044
loc_0208D0:
        dc.w    $000A
        dc.l    $D8050012, $0009FF80, $D8050022, $0011FF90
        dc.l    $D8050026, $0013FFA0, $D8050000, $0000FFB0
        dc.l    $D8050022, $0011FFC0, $D8050004, $0002FFD0
        dc.l    $D8090008, $0004FFE0, $0805002A, $0015FFE8
        dc.l    $08050032, $0019FFF8, $08050036, $001B0008
loc_020922:
        dc.w    $0018
        dc.l    $D805001E, $000FFF88, $D805003A, $001DFF98
        dc.l    $D8050004, $0002FFA8, $D8050022, $0011FFB8
        dc.l    $D8050004, $0002FFC8, $D805001E, $000FFFD8
        dc.l    $D805003E, $001FFFE8, $D805000E, $0007FFF8
        dc.l    $D8050022, $00110008, $D8050042, $00210020
        dc.l    $D805000E, $00070030, $D805002E, $00170040
        dc.l    $D8010046, $00230050, $D8050000, $00000058
        dc.l    $D805001A, $000D0068, $08050048, $0024FFC0
        dc.l    $08010046, $0023FFD0, $08050000, $0000FFD8
        dc.l    $08010046, $0023FFE8, $0805002E, $0017FFF0
        dc.l    $08050016, $000B0000, $08050004, $00020010
        dc.l    $0805001A, $000D0020, $08050042, $00210030
loc_0209E4:
        dc.w    $14
        dc.l    $D0050042, $0021FFA0, $D005000E, $0007FFB0
        dc.l    $D005002E, $0017FFC0, $D0010046, $0023FFD0
        dc.l    $D0050000, $0000FFD8, $D005001A, $000DFFE8
        dc.l    $0005004C, $0026FFE8, $00010046, $0023FFF8
        dc.l    $0005001A, $000D0004, $0005002A, $00150014
        dc.l    $00050004, $00020024, $20050012, $0009FFD0
        dc.l    $2005003A, $001DFFE0, $2005000E, $0007FFF0
        dc.l    $2005001A, $000D0000, $20010046, $00230010
        dc.l    $20050050, $00280018, $20050022, $00110030
        dc.l    $20010046, $00230040, $2005000E, $00070048
loc_020A86:
        dc.w    $001A
        dc.l    $D805002E, $0017FF98, $D8050026, $0013FFA8
        dc.l    $D8050032, $0019FFB8, $D805001A, $000DFFC8
        dc.l    $D8050054, $002AFFD8, $D8050012, $0009FFF8
        dc.l    $D8050022, $00110008, $D8050026, $00130018
        dc.l    $D8050042, $00210028, $D8050032, $00190038
        dc.l    $D805001E, $000F0048, $D805000E, $00070058
        dc.l    $08090008, $0004FF88, $08050004, $0002FF9C
        dc.l    $0805002E, $0017FFAC, $08050004, $0002FFBC
        dc.l    $0805003E, $001FFFCC, $08050026, $0013FFDC
        dc.l    $0805001A, $000DFFF8, $08050004, $00020008
        dc.l    $08050058, $002C0018, $08050004, $00020028
        dc.l    $08090008, $00040038, $08050032, $0019004C
        dc.l    $08050022, $0011005C, $08050004, $0002006C
loc_020B58:
        dc.w    $0017
        dc.l    $D005002E, $0017FF98, $D0050026, $0013FFA8
        dc.l    $D0050032, $0019FFB8, $D005001A, $000DFFC8
        dc.l    $D0050054, $002AFFD8, $D0050012, $0009FFF8
        dc.l    $D0050022, $00110008, $D0050026, $00130018
        dc.l    $D0050000, $00000028, $D0050022, $00110038
        dc.l    $D0050004, $00020048, $D0090008, $00040058
        dc.l    $0005004C, $0026FFD0, $00010046, $0023FFE0
        dc.l    $00090008, $0004FFE8, $00010046, $0023FFFC
        dc.l    $0005003E, $001F0004, $00050004, $00020014
        dc.l    $20090008, $0004FFD0, $20050004, $0002FFE4
        dc.l    $2005001E, $000FFFF4, $20050058, $002C0004
        dc.l    $2005002A, $00150014
loc_020C12:
        dc.w    $001F
        dc.l    $D805002E, $0017FF80, $D8050012, $0009FF90
        dc.l    $D805000E, $0007FFA0, $D805001E, $000FFFB0
        dc.l    $D8010046, $0023FFC0, $D8050004, $0002FFC8
        dc.l    $D8050016, $000BFFD8, $D805003E, $001FFFF8
        dc.l    $D805003A, $001D0008, $D8050004, $00020018
        dc.l    $D805001A, $000D0028, $D8050058, $002C0038
        dc.l    $D805002E, $00170048, $0005005C, $002EFFB0
        dc.l    $00050032, $0019FFC0, $0005004C, $0026FFD0
        dc.l    $00010046, $0023FFE0, $00050026, $0013FFE8
        dc.l    $00090008, $00040000, $00010046, $00230014
        dc.l    $0005001A, $000D001C, $0005000E, $0007002C
        dc.l    $00050000, $0000003C, $00010046, $0023004C
        dc.l    $0005002E, $00170054, $0005003A, $001D0064
        dc.l    $00010046, $00230074, $20050012, $0009FFF8
        dc.l    $20050004, $00020008, $20050012, $00090018
        dc.l    $20050004, $00020028
loc_020D0C:
        dc.w    $000F
        dc.l    $F8050012, $0009FF80, $F8050022, $0011FF90
        dc.l    $F805000E, $0007FFA0, $F805002E, $0017FFB0
        dc.l    $F805000E, $0007FFC0, $F805001A, $000DFFD0
        dc.l    $F805003E, $001FFFE0, $F805000E, $0007FFF0
        dc.l    $F8050042, $00210000, $F8050048, $00240018
        dc.l    $F805002A, $00150028, $F805002E, $00170040
        dc.l    $F805000E, $00070050, $F8050000, $00000060
        dc.l    $F8050004, $00020070
loc_020D86:
        dc.w    $0008
        dc.l    $3005003E, $001FFFC0, $30050022, $0011FFD0
        dc.l    $3005002A, $0015FFE0, $30050004, $0002FFF8
        dc.l    $30050000, $00000008, $30050004, $00020018
        dc.l    $30010046, $00230028, $3005001A, $000D0030
loc_020DC8:
        dc.w    $0011
        dc.l    $E805002E, $0017FFB4, $E8050026, $0013FFC4
        dc.l    $E805001A, $000DFFD4, $E8010046, $0023FFE4
        dc.l    $E805001E, $000FFFEC, $E805003E, $001F0004
        dc.l    $E805000E, $00070014, $E8050004, $00020024
        dc.l    $E8090008, $00040034, $00050012, $0009FFC0
        dc.l    $00050022, $0011FFD0, $0005000E, $0007FFE0
        dc.l    $0005002E, $0017FFF0, $0005000E, $00070000
        dc.l    $0005001A, $000D0010, $0005003E, $001F0020
        dc.l    $0005002E, $00170030
;=============================================================================== 
; Object 0x8A - Credits - Sonic 1 Leftover
                
;=============================================================================== 
        nop                     ; Filler
J_ModifySpriteAttr_2P_24: ; loc_020E54:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
        dc.w     $0000          ; Filler
;=============================================================================== 
; Object 0x3E - Egg Prison / Animals Container
                 
;=============================================================================== 
Obj3E_Egg_Prison: ; loc_020E5C:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_020E88(pc,d0), d1
        jsr     loc_020E88(pc,d1)
        move.w  x_pos(a0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi.s   J_DeleteObject_29       ; loc_020E82
        jmp     DisplaySprite           ; (loc_00D3C2)
J_DeleteObject_29: ; loc_020E82:
        jmp     DeleteObject            ; (loc_00D3B4)
loc_020E88:
        dc.w    loc_020EA8-loc_020E88
        dc.w    loc_020EF6-loc_020E88
        dc.w    loc_020F32-loc_020E88
        dc.w    loc_020F9A-loc_020E88
        dc.w    loc_020F9A-loc_020E88
        dc.w    loc_020F9A-loc_020E88
        dc.w    loc_021032-loc_020E88
        dc.w    loc_021082-loc_020E88
loc_020E98:
        dc.w    $0220, $0400, $040C, $0501, $0610, $0403, $0810, $0305
loc_020EA8:
        move.l  #loc_0210AC,mappings(a0)
        move.w  #$49D,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_25 ; loc_021158
        move.b  #4,render_flags(a0)
        move.w  y_pos(a0), Objoff_30(a0)
        moveq	#0,d0
        move.b  subtype(A0), D0
        lsl.w   #$2, d0
        lea     loc_020E98(pc,d0), A1
        move.b  (A1)+, $0024(a0)
        move.b  (A1)+,width_pixels(a0)
        move.b  (A1)+, $0018(a0)
        move.b  (A1)+, $001A(a0)
        cmpi.w  #8, d0
        bne.s   loc_020EF4
        move.b  #6,collision_flags(a0)
        move.b  #8, $0021(a0)
loc_020EF4:
        rts
loc_020EF6:
        cmpi.b  #$2, ($FFFFF7A7).w
        beq.s   loc_020F14
        move.w  #$02B, d1
        move.w  #$018, D2
        move.w  #$018, d3
        move.w  x_pos(a0), D4
        jmp     SolidObject             ; (loc_00F4A0)
loc_020F14:
        tst.b   $0025(a0)
        beq.s   loc_020F2A
        clr.b   $0025(a0)
        bclr    #3, ($FFFFB022).w
        bset    #1, ($FFFFB022).w
loc_020F2A:
        move.b  #$2, $001A(a0)
        rts
loc_020F32:
        move.w  #$017, d1
        move.w  #8, D2
        move.w  #8, d3
        move.w  x_pos(a0), D4
        jsr     SolidObject             ; (loc_00F4A0)
        lea     (loc_0210A4), A1
        jsr     AnimateSprite           ; (loc_00D412)
        move.w  Objoff_30(A0), y_pos(a0)
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq.s   loc_020F98
        addq.w  #8, y_pos(a0)
        move.b  #$A, $0024(a0)
        move.w  #$03C, $001E(a0)
        clr.b   (Update_HUD_timer).w
        clr.b   ($FFFFF7AA).w
        move.b  #1, ($FFFFF7CC).w
        move.w  #$800, ($FFFFF602).w
        clr.b   $0025(a0)
        bclr    #3, ($FFFFB022).w
        bset    #1, ($FFFFB022).w
loc_020F98:
        rts
loc_020F9A:
        moveq   #$7, d0
        and.b   ($FFFFFE0F).w, d0
        bne.s   loc_020FD8
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_020FD8
        move.b  #$3F, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        jsr     PseudoRandomNumber      ; loc_0031E4
        moveq   #0,d1
        move.b  d0, d1
        lsr.b   #$2, d1
        subi.w  #$20, d1
        add.w   d1, x_pos(a1)
        lsr.w   #8,d0
        lsr.b   #3, d0
        add.w   d0, y_pos(a1)
loc_020FD8:
        subq.w  #1, $001E(a0)
        beq.s   loc_020FE0
        rts
loc_020FE0:
        move.b  #$2, ($FFFFF7A7).w
        move.b  #$C, $0024(a0)
        move.b  #6, $001A(a0)
        move.w  #$096, $001E(a0)
        addi.w  #$20, y_pos(a0)
        moveq   #$7, D6
        move.w  #$09A,d5
        moveq   #Music_to_play_2, D4    
loc_021006:                    
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_021030
        move.b  #$28, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        add.w   d4, x_pos(a1)
        addq.w  #$7, D4
        move.w  d5, $0036(a1)
        subq.w  #8,d5
        dbra    d6, loc_021006
loc_021030:
        rts
loc_021032:
        moveq   #$7, d0
        and.b   ($FFFFFE0F).w, d0
        bne.s   loc_021070
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_021070
        move.b  #$28, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        jsr     PseudoRandomNumber      ; loc_0031E4
        andi.w  #$01F, d0
        subq.w  #6, d0
        tst.w   d1
        bpl.s   loc_021066
        neg.w   D0
loc_021066:
        add.w   d0, x_pos(a1)
        move.w  #$00C, $0036(a1)
loc_021070:
        subq.w  #1, $001E(a0)
        bne.s   loc_021080
        addq.b  #2,routine(a0)
        move.w  #$0B4, $001E(a0)
loc_021080:
        rts
loc_021082:
        moveq   #$3E, d0
        moveq   #$28, d1
        moveq   #$40, D2
        lea     (Sidekick).w, A1
loc_02108C:        
        cmp.b   (A1), d1
        beq.s   loc_0210A2
        adda.w  D2, A1
        dbra    d0, loc_02108C
        jsr     (loc_00F352)
        jmp     DeleteObject            ; (loc_00D3B4)
loc_0210A2:
        rts                
loc_0210A4:        
        dc.w    loc_0210A8-loc_0210A4
        dc.w    loc_0210A8-loc_0210A4
loc_0210A8:
        dc.b    $02, $01, $03, $FF

loc_0210AC:
        dc.w    loc_0210BA-loc_0210AC
        dc.w    loc_0210F4-loc_0210AC
        dc.w    loc_0210FE-loc_0210AC
        dc.w    loc_021130-loc_0210AC
        dc.w    loc_02113A-loc_0210AC
        dc.w    loc_02114C-loc_0210AC
        dc.w    loc_021156-loc_0210AC
loc_0210BA:
        dc.w    $0007
        dc.l    $E00C2000, $2000FFF0, $E80D2004, $2002FFE0
        dc.l    $E80D200C, $20060000, $F80E2014, $200AFFE0
        dc.l    $F80E2020, $20100000, $100D202C, $2016FFE0
        dc.l    $100D2034, $201A0000
loc_0210F4:
        dc.w    $0001
        dc.l    $F809003C, $001EFFF4
loc_0210FE:
        dc.w    $0006
        dc.l    $00082042, $2021FFE0, $080C2045, $2022FFE0
        dc.l    $00042049, $20240010, $080C204B, $20250000
        dc.l    $100D202C, $2016FFE0, $100D2034, $201A0000
loc_021130:
        dc.w    $0001
        dc.l    $F809004F, $0027FFF4
loc_02113A:
        dc.w    $0002
        dc.l    $E80E2055, $202AFFF0, $000E2061, $2030FFF0
loc_02114C:
        dc.w    $0001
        dc.l    $F007206D, $2036FFF8
loc_021156:
        dc.w    $0000                
;=============================================================================== 
; Object 0x3E - Egg Prison / Animals Container
                
;=============================================================================== 
J_ModifySpriteAttr_2P_25: ; loc_021158:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
        dc.w    $0000           ; Filler
        
;=============================================================================== 
; End of Sub TouchResponse
                 
;===============================================================================  
TouchResponse: ; loc_021160:   
        nop
        bsr     loc_021502
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        subi.w  #8, D2
        moveq   #0,d5
        move.b  y_radius(A0), D5
        subq.b  #3,d5
        sub.w   d5, d3
        cmpi.b  #$39, $001A(a0)
        bne.s   loc_02118A
        addi.w  #$00C, d3
        moveq   #$A,d5
loc_02118A:
        move.w  #$010, D4
        add.w   d5,d5
        lea     ($FFFFB800).w, A1
        move.w  #$05F, D6
loc_021198:
        move.b  $0020(A1), D0
        bne.s   Touch_Height            ; loc_0211F8
loc_02119E:        
        lea     $0040(A1), A1
        dbra    d6, loc_021198  
        moveq	#0,d0
Touch_Sizes: ; loc_0211A8:        
        rts  
        dc.b    $14, $14, $0C, $14, $14, $0C, $04, $10, $0C, $12, $10, $10, $06, $06, $18, $0C
        dc.b    $0C, $10, $10, $0C, $08, $08, $14, $10, $14, $08, $0E, $0E, $18, $18, $28, $10
        dc.b    $10, $18, $08, $10, $20, $70, $40, $20, $80, $20, $20, $20, $08, $08, $04, $04
        dc.b    $20, $08, $0C, $0C, $08, $04, $18, $04, $28, $04, $04, $08, $04, $18, $04, $28
        dc.b    $04, $20, $18, $18, $0C, $18, $48, $08, $18, $28, $10, $04, $20, $02
;===============================================================================
Touch_Height: ; loc_0211F8:
        andi.w  #$03F, d0
        add.w   d0, d0
        lea     Touch_Sizes(pc,d0), A2 ; loc_0211A8
        moveq   #0,d1
        move.b  (A2)+, d1
        move.w  x_pos(A1), D0
        sub.w   d1, d0
        sub.w   d2, d0
        bcc.s   loc_02121A
        add.w   d1, d1
        add.w   d1, d0
        bcs.s   loc_021220
        bra     loc_02119E
loc_02121A:        
        cmp.w   d4, d0
        bhi     loc_02119E
loc_021220:        
        moveq   #0,d1
        move.b  (A2)+, d1
        move.w  y_pos(A1), D0
        sub.w   d1, d0
        sub.w   d3, d0
        bcc.s   loc_021238
        add.w   d1, d1
        add.w   d1, d0
        bcs.s   loc_02123E
        bra     loc_02119E        
loc_021238:
        cmp.w   d5, d0
        bhi     loc_02119E
loc_02123E:
        move.b  $0020(A1), d1
        andi.b  #$C0, d1
        beq     loc_0212B8
        cmpi.b  #$C0, d1
        beq     Touch_Special           ; loc_02147A
        tst.b   d1
        bmi     loc_021370
        move.b  $0020(A1), D0
        andi.b  #$3F, d0
        cmpi.b  #6, d0
        beq.s   loc_021278
        cmpi.w  #$05A, Objoff_30(a0)
        bcc     loc_021276
        move.b  #4, $0024(a1)
loc_021276:        
        rts
loc_021278:        
        tst.w   $0012(a0)
        bpl.s   loc_0212A4
        move.w  y_pos(a0), D0
        subi.w  #$010, d0
        cmp.w   y_pos(A1), D0  
        bcs.s   loc_0212B6
        neg.w   $0012(a0)
        move.w  #$FE80, $0012(a1)
        tst.b   $0025(a1)
        bne.s   loc_0212B6
        move.b  #4, $0025(a1)
        rts
loc_0212A4:
        cmpi.b  #$2, $001C(a0)
        bne.s   loc_0212B6
        neg.w   $0012(a0)
        move.b  #4, $0024(a1)
loc_0212B6:
        rts
loc_0212B8:
        tst.b   ($FFFFFE2D).w
        bne.s   loc_0212D0
        cmpi.b  #$9, $001C(a0)
        beq.s   loc_0212D0
        cmpi.b  #$2, $001C(a0)
        bne     loc_021370
loc_0212D0:
        tst.b   $0021(a1)
        beq.s   Touch_KillEnemy         ; loc_0212FA
        neg.w  x_vel(a0)
        neg.w   $0012(a0)
        asr.w  x_vel(a0)
        asr.w   $0012(a0)
        move.b  #0, $0020(a1)
        subq.b  #1, $0021(a1)
        bne.s   loc_0212F8
        bset    #$7, status(a1)
loc_0212F8:
        rts
;===============================================================================        
Touch_KillEnemy: ; loc_0212FA:
        bset    #$7, status(a1)
        moveq	#0,d0
        move.w  ($FFFFF7D0).w, d0
        addq.w  #$2, ($FFFFF7D0).w
        cmpi.w  #$006, d0
        bcs.s   loc_021312
        moveq   #6, d0
loc_021312:
        move.w  d0, Objoff_3E(a1)
        move.w  Enemy_Points(pc,d0), D0 ; loc_021362
        cmpi.w  #$20, ($FFFFF7D0).w
        bcs.s   loc_02132C
        move.w  #$3E8, d0
        move.w  #$00A, Objoff_3E(a1)
loc_02132C:
        bsr     AddPoints               ; loc_022FD0        
        move.b  #$27, 0(a1)
        move.b  #0, $0024(a1)
        tst.w   $0012(a0)
        bmi.s   loc_021352
        move.w  y_pos(a0), D0
        cmp.w   y_pos(A1), D0
        bcc.s   loc_02135A
        neg.w   $0012(a0)
        rts
loc_021352:
        addi.w  #$100, $0012(a0)
        rts
loc_02135A:
        subi.w  #$100, $0012(a0)
        rts                
Enemy_Points: ; loc_021362:
        dc.w    $000A, $14, $0032, $0064
loc_02136A:
        bset    #$7, status(a1)                
loc_021370:
        tst.b   ($FFFFFE2D).w
        beq.s   Touch_Hurt              ; loc_02137A
loc_021376:        
        moveq   #$FFFFFFFF, d0
        rts
;===============================================================================        
Touch_Hurt: ; loc_02137A:
        nop
        tst.w   Objoff_30(a0)
        bne.s   loc_021376
        move.l  A1, a2  

;=============================================================================== 
; Beginning of Sub HurtSonic
                 
;===============================================================================         
HurtSonic: ; loc_021384:
        tst.b   ($FFFFFE2C).w
        bne.s   HurtShield              ; loc_0213AC
        tst.w   (Ring_count).w
        beq     Hurt_NoRings            ; loc_02141A
        jsr     SingleObjectLoad        ; loc_00E772
        bne.s   HurtShield              ; loc_0213AC
        move.b  #$37, 0(a1)
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
HurtShield: ; loc_0213AC:
        move.b  #0, ($FFFFFE2C).w
        move.b  #4,routine(a0)
        bsr     J_Sonic_ResetOnFloor_00 ; loc_0214FC
        bset    #1, status(a0)
        move.w  #$FC00, $0012(a0)
        move.w  #$FE00,x_vel(a0)
        btst    #6, status(a0)
        beq.s   Hurt_Reverse            ; loc_0213E2
        move.w  #$FE00, $0012(a0)
        move.w  #$FF00,x_vel(a0)
Hurt_Reverse: ; loc_0213E2:
        move.w  x_pos(a0), D0
        cmp.w   x_pos(A2), D0
        bcs.s   Hurt_ChkSpikes          ; loc_0213F0 
        neg.w  x_vel(a0)
Hurt_ChkSpikes: ; loc_0213F0:
        move.w  #0, $14(a0)
        move.b  #$1A, $001C(a0)
        move.w  #$078, Objoff_30(a0)
        move.w  #$0A3, d0
        cmpi.b  #$36, (a2)
        bne.s   loc_021410
        move.w  #$0A6, d0
loc_021410:
        jsr     (Play_Sfx)              ; loc_0014C6
        moveq   #$FFFFFFFF, d0
        rts
Hurt_NoRings: ; loc_02141A:
        tst.w   ($FFFFFFFA).w
        bne     HurtShield              ; loc_0213AC 
;=============================================================================== 
; End of Sub HurtSonic
                
;===============================================================================  
               
;=============================================================================== 
; Beginning of Sub KillSonic
                 
;===============================================================================          
KillSonic: ; loc_021422:
        tst.w   (Debug_placement_mode).w
        bne.s   Kill_NoDeath            ; loc_021476
        move.b  #0, ($FFFFFE2D).w
        move.b  #6, $0024(a0)
        bsr     J_Sonic_ResetOnFloor_00 ; loc_0214FC
        bset    #1, status(a0)
        move.w  #$F900, $0012(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $14(a0)
        move.w  y_pos(a0), objoff_38(a0)
        move.b  #$18, $001C(a0)
        bset    #7,art_tile(a0)
        move.w  #$0A3, d0
        cmpi.b  #$36, (a2)
        bne.s   loc_021470
        move.w  #$0A6, d0   
loc_021470:
        jsr     (Play_Sfx)              ; loc_0014C6
Kill_NoDeath ; loc_021476:        
        moveq   #$FFFFFFFF, d0
        rts
;=============================================================================== 
; End of Sub KillSonic
                
;===============================================================================
           
Touch_Special: ; loc_02147A:
        move.b  $0020(A1), d1
        andi.b  #$3F, d1
        cmpi.b  #$B, d1
        beq.s   Touch_Caterkiller       ; loc_0214AE
        cmpi.b  #$C, d1
        beq.s   Touch_Yadrin            ; loc_0214B2
        cmpi.b  #$14, d1
        beq.s   Touch_D7        ; loc_0214E4
        cmpi.b  #$15, d1
        beq.s   Touch_D7        ; loc_0214E4
        cmpi.b  #$16, d1
        beq.s   Touch_D7        ; loc_0214E4
        cmpi.b  #$17, d1
        beq.s   Touch_D7        ; loc_0214E4
        cmpi.b  #$21, d1
        beq.s   Touch_E1        ; loc_0214F6
        rts
Touch_Caterkiller: ; loc_0214AE:
        bra     loc_02136A
Touch_Yadrin: ; loc_0214B2:
        sub.w   d0,d5
        cmpi.w  #8,d5
        bcc.s   loc_0214E0
        move.w  x_pos(A1), D0
        subq.w  #4, d0
        btst    #0, status(a1)
        beq.s   loc_0214CC
        subi.w  #$010, d0
loc_0214CC:
        sub.w   d2, d0
        bcc.s   loc_0214D8
        addi.w  #$018, d0
        bcs.s   loc_0214DC
        bra.s   loc_0214E0
loc_0214D8:
        cmp.w   d4, d0
        bhi.s   loc_0214E0
loc_0214DC:
        bra     loc_021370
loc_0214E0:
        bra     loc_0212B8
Touch_D7: ; loc_0214E4:
        move.w  A0, d1
        subi.w  #Object_RAM, d1
        beq.s   loc_0214F0
        addq.b  #1, $0021(a1)
loc_0214F0:
        addq.b  #1, $0021(a1)
        rts
Touch_E1: ; loc_0214F6:        
        addq.b  #1, $0021(a1)
        rts              
J_Sonic_ResetOnFloor_00: ; loc_0214FC:
        jmp     Sonic_ResetOnFloor      ; loc_01090C
loc_021502:
        jmp     TouchRings              ; loc_00DF6C 
;=============================================================================== 
; End of Sub TouchResponse
                
;=============================================================================== 
        
;===============================================================================
; Special Stage - Sub-routine
              
;===============================================================================
S1_SS_Show_Layout: ; loc_021508:
        bsr     loc_02164A
        bsr     loc_02188A
        move.w  d5, -(A7)
        lea     ($FFFF8000).w, A1
        move.b  ($FFFFF750).w, d0
        andi.b  #$FC, d0
        jsr     CalcSine        ; loc_00320A
        move.w  d0, D4
        move.w  d1,d5
        muls.w  #$018, D4
        muls.w  #$018,d5
        moveq   #0, D2
        move.w  ($FFFFEE00).w, D2
        divu.w  #$018, D2
        swap.w  D2
        neg.w   D2
        addi.w  #$FF4C, D2
        moveq   #0, d3
        move.w  ($FFFFEE04).w, d3
        divu.w  #$018, d3
        swap.w  D3
        neg.w   D3
        addi.w  #$FF4C, d3
        move.w  #$F, D7
loc_021558:        
        movem.w D0-D2, -(A7)
        movem.w D0/d1, -(A7)
        neg.w   D0
        muls.w  D2, d1
        muls.w  d3, d0
        move.l  d0, D6
        add.l   d1, D6
        movem.w (A7)+, D0/d1
        muls.w  d2, d0
        muls.w  d3, d1
        add.l   d0, d1
        move.l  d6, D2
        move.w  #$F, D6
loc_02157A:        
        move.l  d2, d0
        asr.l   #8,d0
        move.w  d0, (a1)+
        move.l  d1, d0
        asr.l   #8,d0
        move.w  d0, (a1)+
        add.l   d5, D2
        add.l   d4, d1
        dbra    d6, loc_02157A
        movem.w (A7)+, D0-D2
        addi.w  #$018, d3
        dbra    d7, loc_021558
        move.w  (A7)+, D5
        lea     ($FFFF0000), A0
        moveq	#0,d0
        move.w  ($FFFFEE04).w, d0
        divu.w  #$018, d0
        mulu.w  #$080, d0
        adda.l  d0, A0
        moveq	#0,d0
        move.w  ($FFFFEE00).w, d0
        divu.w  #$018, d0
        adda.w  d0, A0
        lea     ($FFFF8000).w, A4
        move.w  #$F, D7
loc_0215C6:        
        move.w  #$F, D6
loc_0215CA:        
        moveq	#0,d0
        move.b  (A0)+, D0
        beq.s   loc_021622
        cmpi.b  #$4E, d0
        bhi.s   loc_021622
        move.w  (A4), D3
        addi.w  #$120, d3
        cmpi.w  #$070, d3
        bcs.s   loc_021622
        cmpi.w  #$1D0, d3
        bcc.s   loc_021622
        move.w  art_tile(A4), D2
        addi.w  #$0F0, D2
        cmpi.w  #$070, D2
        bcs.s   loc_021622
        cmpi.w  #$170, D2
        bcc.s   loc_021622
        lea     ($FFFF4000), a5
        lsl.w   #3, d0
        lea     $00(a5, d0), a5
        move.l  (a5)+, A1
        move.w  (a5)+, d1
        add.w   d1, d1
        adda.w  $00(A1, d1), A1
        move.w  (a5)+, A3
        moveq   #0,d1
        move.b  (A1)+, d1
        subq.b  #1,d1
        bmi.s   loc_021622
        jsr     (loc_00D6F0)
loc_021622:
        addq.w  #4, A4
        dbra    d6, loc_0215CA
        lea     $0070(A0), A0
        dbra    d7, loc_0215C6
        move.b  d5, ($FFFFF62C).w
        cmpi.b  #$50,d5
        beq.s   loc_021642
        move.l  #$0000000, (a2)
        rts
loc_021642:
        move.b  #0, $FFFFFFFB(a2)
        rts  
loc_02164A:
        lea     ($FFFF400C), A1
        moveq	#0,d0
        move.b  ($FFFFF750).w, d0
        lsr.b   #$2, d0
        andi.w  #$F, d0
        moveq   #$23, d1
loc_02165E:        
        move.w  d0, (a1)
        addq.w  #8, A1
        dbra    d1, loc_02165E
        lea     ($FFFF4005), A1
        subq.b  #1, ($FFFFFEC2).w
        bpl.s   loc_021682
        move.b  #$7, ($FFFFFEC2).w
        addq.b  #1, ($FFFFFEC3).w
        andi.b  #3, ($FFFFFEC3).w
loc_021682:
        move.b  ($FFFFFEC3).w, $01D0(a1)
        subq.b  #1, ($FFFFFEC4).w
        bpl.s   loc_02169E
        move.b  #$7, ($FFFFFEC4).w
        addq.b  #1, ($FFFFFEC5).w
        andi.b  #1, ($FFFFFEC5).w
loc_02169E:
        move.b  ($FFFFFEC5).w, d0
        move.b  d0, $0138(a1)
        move.b  d0, $0160(a1)
        move.b  d0, $0148(a1)
        move.b  d0, $0150(a1)
        move.b  d0, $01D8(a1)
        move.b  d0, $01E0(a1)
        move.b  d0, $01E8(a1)
        move.b  d0, $01F0(a1)
        move.b  d0, $01F8(a1)
        move.b  d0, $0200(a1)
        subq.b  #1, ($FFFFFEC6).w
        bpl.s   loc_0216E0
        move.b  #4, ($FFFFFEC6).w
        addq.b  #1, ($FFFFFEC7).w
        andi.b  #3, ($FFFFFEC7).w
loc_0216E0:
        move.b  ($FFFFFEC7).w, d0
        move.b  d0, $0168(a1)
        move.b  d0, $0170(a1)
        move.b  d0, $0178(a1)
        move.b  d0, $0180(a1)
        subq.b  #1, ($FFFFFEC0).w
        bpl.s   loc_02170A
        move.b  #$7, ($FFFFFEC0).w
        subq.b  #1, ($FFFFFEC1).w
        andi.b  #$7, ($FFFFFEC1).w
loc_02170A:
        lea     ($FFFF4016), A1
        lea     (S1SS_WaRiVramSet), A0  ; loc_0217F4
        moveq	#0,d0
        move.b  ($FFFFFEC1).w, d0
        add.w   d0, d0
        lea     $00(A0, d0), A0
        move.w  (A0), (a1)
        move.w  art_tile(A0), x_pos(a1)
        move.w  mappings(A0),x_vel(a1)
        move.w  $0006(A0), $0018(a1)
        move.w  x_pos(a0), $0020(a1)
        move.w  $000A(A0), subtype(a1)
        move.w  y_pos(a0), Objoff_30(a1)
        move.w  Objoff_E(A0), objoff_38(a1)
        adda.w  #$20, A0
        adda.w  #$048, A1
        move.w  (A0), (a1)
        move.w  art_tile(A0), x_pos(a1)
        move.w  mappings(A0),x_vel(a1)
        move.w  $0006(A0), $0018(a1)
        move.w  x_pos(a0), $0020(a1)
        move.w  $000A(A0), subtype(a1)
        move.w  y_pos(a0), Objoff_30(a1)
        move.w  Objoff_E(A0), objoff_38(a1)
        adda.w  #$20, A0
        adda.w  #$048, A1
        move.w  (A0), (a1)
        move.w  art_tile(A0), x_pos(a1)
        move.w  mappings(A0),x_vel(a1)
        move.w  $0006(A0), $0018(a1)
        move.w  x_pos(a0), $0020(a1)
        move.w  $000A(A0), subtype(a1)
        move.w  y_pos(a0), Objoff_30(a1)
        move.w  Objoff_E(A0), objoff_38(a1)
        adda.w  #$20, A0
        adda.w  #$048, A1
        move.w  (A0), (a1)
        move.w  art_tile(A0), x_pos(a1)
        move.w  mappings(A0),x_vel(a1)
        move.w  $0006(A0), $0018(a1)
        move.w  x_pos(a0), $0020(a1)
        move.w  $000A(A0), subtype(a1)
        move.w  y_pos(a0), Objoff_30(a1)
        move.w  Objoff_E(A0), objoff_38(a1)
        adda.w  #$20, A0
        adda.w  #$048, A1
        rts   
S1SS_WaRiVramSet: ; loc_0217F4:
        dc.w    $0142, $6142, $0142, $0142, $0142, $0142, $0142, $6142
        dc.w    $0142, $6142, $0142, $0142, $0142, $0142, $0142, $6142
        dc.w    $2142, $0142, $2142, $2142, $2142, $2142, $2142, $0142
        dc.w    $2142, $0142, $2142, $2142, $2142, $2142, $2142, $0142
        dc.w    $4142, $2142, $4142, $4142, $4142, $4142, $4142, $2142
        dc.w    $4142, $2142, $4142, $4142, $4142, $4142, $4142, $2142
        dc.w    $6142, $4142, $6142, $6142, $6142, $6142, $6142, $4142
        dc.w    $6142, $4142, $6142, $6142, $6142, $6142, $6142, $4142        
loc_021874:
        lea     ($FFFF4400), A2
        move.w  #$01F, d0
loc_02187E:        
        tst.b   (a2)
        beq.s   loc_021888
        addq.w  #8, a2
        dbra    d0, loc_02187E
loc_021888:
        rts
loc_02188A:               
        lea     ($FFFF4400), A0
        move.w  #$01F, D7
loc_021894:        
        moveq	#0,d0
        move.b  (A0), D0
        beq.s   loc_0218A2
        lsl.w   #$2, d0
        move.l  S1SS_AniIndex-$04(pc,d0), A1 ; loc_0218AA
        jsr     (a1)
loc_0218A2:
        addq.w  #8, A0
        dbra    d7, loc_021894
        rts 
;===============================================================================        
S1SS_AniIndex: ; loc_0218AA: 
        dc.l    loc_0218C2
        dc.l    loc_0218F2
        dc.l    loc_021928
        dc.l    loc_021958
        dc.l    loc_02198E
        dc.l    loc_0219CE
loc_0218C2:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_0218EA
        move.b  #5,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_0218EC(pc,d0), D0
        move.b  d0, (a1)
        bne.s   loc_0218EA
        clr.l   (a0)
        clr.l   mappings(a0)        
loc_0218EA:
        rts
loc_0218EC:
        dc.b    $42, $43, $44, $45, $00, $00
loc_0218F2:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_021920
        move.b  #$7,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_021922(pc,d0), D0
        bne.s   loc_02191E
        clr.l   (a0)
        clr.l   mappings(a0)
        move.b  #$25, (a1)
        rts
loc_02191E:
        move.b  d0, (a1)
loc_021920:
        rts
loc_021922:
        dc.b    $32, $33, $32, $33, $00, $00
loc_021928:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_021950
        move.b  #5,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_021952(pc,d0), D0
        move.b  d0, (a1)
        bne.s   loc_021950
        clr.l   (a0)
        clr.l   mappings(a0)
loc_021950:
        rts
loc_021952:
        dc.b    $46, $47, $48, $49, $00, $00
loc_021958:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_021986
        move.b  #$7,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_021988(pc,d0), D0
        bne.s   loc_021984
        clr.l   (a0)
        clr.l   mappings(a0)
        move.b  #$2B, (a1)
        rts
loc_021984:
        move.b  d0, (a1)
loc_021986:
        rts
loc_021988:
        dc.b    $2B, $31, $2B, $31, $00, $00
loc_02198E:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_0219C6
        move.b  #5,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_0219C8(pc,d0), D0
        move.b  d0, (a1)
        bne.s   loc_0219C6
        clr.l   (a0)
        clr.l   mappings(a0)
        move.b  #4, ($FFFFB024).w
        move.w  #$0A8, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_0219C6:
        rts
loc_0219C8:
        dc.b    $46, $47, $48, $49, $00, $00
loc_0219CE:
        subq.b  #1,art_tile(a0)
        bpl.s   loc_0219FA
        move.b  #1,art_tile(a0)
        moveq	#0,d0
        move.b  $0003(A0), D0
        addq.b  #1, $0003(a0)
        move.l  mappings(A0), A1
        move.b  loc_0219FC(pc,d0), D0
        move.b  d0, (a1)
        bne.s   loc_0219FA
        move.b  mappings(A0), (a1)
        clr.l   (a0)
        clr.l   mappings(a0)
loc_0219FA:
        rts    
loc_0219FC:                   
        dc.b    $4B, $4C, $4D, $4E, $4B, $4C, $4D, $4E, $00, $00        
S1SS_LayoutIndex: ; loc_021A06:        
        dc.l    Special_Stage_1   ; loc_031CEA                     
        dc.l    Special_Stage_2   ; loc_031F64
        dc.l    Special_Stage_3   ; loc_032376        
        dc.l    Special_Stage_4   ; loc_0326D2
        dc.l    Special_Stage_5   ; loc_032BAC
        dc.l    Special_Stage_6   ; loc_03305C
S1SS_StartLoc: ; loc_021A1E:
        dc.l    $03D002E0   ; Sonic Start Position in Special Stage 1
        dc.l    $03280574   ; Sonic Start Position in Special Stage 2
        dc.l    $04E402E0   ; Sonic Start Position in Special Stage 3
        dc.l    $03AD02E0   ; Sonic Start Position in Special Stage 4
        dc.l    $034006B8   ; Sonic Start Position in Special Stage 5
        dc.l    $049B0358   ; Sonic Start Position in Special Stage 6
S1_Special_Stage_Load: ; loc_021A36:
        moveq	#0,d0
        move.b  ($FFFFFE16).w, d0
        addq.b  #1, ($FFFFFE16).w
        cmpi.b  #6, ($FFFFFE16).w
        bcs.s   loc_021A4E
        move.b  #0, ($FFFFFE16).w
loc_021A4E:
        cmpi.b  #6, ($FFFFFE57).w
        beq.s   loc_021A70
        moveq   #0,d1
        move.b  ($FFFFFE57).w, d1
        subq.b  #1,d1
        bcs.s   loc_021A70
        lea     ($FFFFFE58).w, A3
loc_021A64:        
        cmp.b   $00(A3, d1), D0
        bne.s   loc_021A6C
        bra.s   S1_Special_Stage_Load   ; loc_021A36
loc_021A6C:
        dbra    d1, loc_021A64
loc_021A70:
        lsl.w   #$2, d0
        lea     S1SS_StartLoc(pc,d0), A1 ; loc_021A1E
        move.w  (A1)+, (MainCharacter+x_pos).w
        move.w  (A1)+, ($FFFFB00C).w
        move.l  S1SS_LayoutIndex(pc,d0), A0 ; loc_021A06
        lea     ($FFFF4000), A1
        move.w  #0, d0
        jsr     EnigmaDec               ; loc_0018DA
        lea     ($FFFF0000), A1
        move.w  #$FFF, d0
loc_021A9C:        
        clr.l   (A1)+
        dbra    d0, loc_021A9C
        lea     ($FFFF1020), A1
        lea     ($FFFF4000), A0
        moveq   #$3F, d1
loc_021AB0:        
        moveq   #$3F, D2
loc_021AB2:        
        move.b  (A0)+, (A1)+
        dbra    D2, loc_021AB2
        lea     $0040(A1), A1
        dbra    d1, loc_021AB0
        lea     ($FFFF4008), A1
        lea     (loc_021AF2), A0
        moveq   #$4D, d1
loc_021ACE:        
        move.l  (A0)+, (A1)+
        move.w  #0, (A1)+
        move.b  Checksum_fourcc(A0), $FFFFFFFF(a1)
        move.w  (A0)+, (A1)+
        dbra    d1, loc_021ACE
        lea     ($FFFF4400), A1
        move.w  #$03F, d1
loc_021AEA:        
        clr.l   (A1)+
        dbra    d1, loc_021AEA
        rts
loc_021AF2:
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6         
        dc.w    $0142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $2142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142              
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $4142   
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142   
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142   
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142   
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142  
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $6142  
        dc.l    S1_Obj47_Mappings ; loc_01401E
        dc.w    $023B
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0570
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0251
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0370
        dc.l    SS_Up_Mappings          ; loc_021CFA
        dc.w    $0263
        dc.l    SS_Down_Mappings        ; loc_021D0A
        dc.w    $0263
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6        
        dc.w    $22F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $0470
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $05F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $65F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $25F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $45F0
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $02F0
        dc.l    (($01<<$18)|S1_Obj47_Mappings) ; loc_01401E
        dc.w    $023B
        dc.l    (($02<<$18)|S1_Obj47_Mappings) ; loc_01401E
        dc.w    $023B 
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0797
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $07A0
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $07A9
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $0797
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $07A0
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $07A9
        dc.l    Rings_Mappings          ; loc_00B036
        dc.w    $27B2
        dc.l    SS_Emerald_Mappings     ; loc_021D22
        dc.w    $0770
        dc.l    SS_Emerald_Mappings     ; loc_021D22
        dc.w    $2770
        dc.l    SS_Emerald_Mappings     ; loc_021D22
        dc.w    $4770
        dc.l    SS_Emerald_Mappings     ; loc_021D22           
        dc.w    $6770
        dc.l    SS_Red_Emerald_Mappings ; loc_021D1A
        dc.w    $0770
        dc.l    SS_Gray_Emerald_Mappings ; loc_021D1E
        dc.w    $0770
        dc.l    SS_Reverse_Goal_Mappings ; loc_021CC6
        dc.w    $04F0
        dc.l    (($04<<$18)|Rings_Mappings) ; loc_00B036
        dc.w    $27B2
        dc.l    (($05<<$18)|Rings_Mappings) ; loc_00B036           
        dc.w    $27B2
        dc.l    (($06<<$18)|Rings_Mappings) ; loc_00B036  
        dc.w    $27B2
        dc.l    (($07<<$18)|Rings_Mappings) ; loc_00B036 
        dc.w    $27B2
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA
        dc.w    $23F0
        dc.l    (($01<<$18)|SS_Red_White_Ball_Mappings) ; loc_021CDA
        dc.w    $23F0
        dc.l    (($02<<$18)|SS_Red_White_Ball_Mappings) ; loc_021CDA
        dc.w    $23F0
        dc.l    (($03<<$18)|SS_Red_White_Ball_Mappings) ; loc_021CDA
        dc.w    $23F0  
        dc.l    (($02<<$18)|SS_Reverse_Goal_Mappings) ; loc_021CC6
        dc.w    $04F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA          
        dc.w    $05F0           
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA 
        dc.w    $65F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA 
        dc.w    $25F0
        dc.l    SS_Red_White_Ball_Mappings ; loc_021CDA 
        dc.w    $45F0     
SS_Reverse_Goal_Mappings: ; loc_021CC6:   
        dc.w    loc_021CCC-SS_Reverse_Goal_Mappings
        dc.w    loc_021CD2-SS_Reverse_Goal_Mappings
        dc.w    loc_021CD8-SS_Reverse_Goal_Mappings
loc_021CCC:
        dc.b    $01
        dc.b    $F4, $0A, $00, $00, $F4        ; Sonic 1 Mappings Format
loc_021CD2:
        dc.b    $01
        dc.b    $F4, $0A, $00, $09, $F4        ; Sonic 1 Mappings Format
loc_021CD8:
        dc.b    $00
        dc.b    $00             ; Filler     
SS_Red_White_Ball_Mappings: ; loc_021CDA:
        dc.w    loc_021CE2-SS_Red_White_Ball_Mappings
        dc.w    loc_021CE8-SS_Red_White_Ball_Mappings
        dc.w    loc_021CEE-SS_Red_White_Ball_Mappings
        dc.w    loc_021CF4-SS_Red_White_Ball_Mappings
loc_021CE2:
        dc.b    $01
        dc.b    $F4, $0A, $00, $00, $F4        ; Sonic 1 Mappings Format
loc_021CE8:
        dc.b    $01
        dc.b    $F4, $0A, $08, $00, $F4        ; Sonic 1 Mappings Format
loc_021CEE:
        dc.b    $01
        dc.b    $F4, $0A, $18, $00, $F4        ; Sonic 1 Mappings Format
loc_021CF4:
        dc.b    $01
        dc.b    $F4, $0A, $10, $00, $F4        ; Sonic 1 Mappings Format   
SS_Up_Mappings: ; loc_021CFA:
        dc.w    loc_021CFE-SS_Up_Mappings
        dc.w    loc_021D04-SS_Up_Mappings
loc_021CFE:
        dc.b    $01
        dc.b    $F4, $0A, $00, $00, $F4        ; Sonic 1 Mappings Format
loc_021D04:
        dc.b    $01
        dc.b    $F4, $0A, $00, $12, $F4        ; Sonic 1 Mappings Format 
SS_Down_Mappings: ; loc_021D0A:
        dc.w    loc_021D0E-SS_Down_Mappings
        dc.w    loc_021D14-SS_Down_Mappings
loc_021D0E:
        dc.b    $01
        dc.b    $F4, $0A, $00, $09, $F4        ; Sonic 1 Mappings Format 
loc_021D14:
        dc.b    $01
        dc.b    $F4, $0A, $00, $12, $F4        ; Sonic 1 Mappings Format
SS_Red_Emerald_Mappings: ; loc_021D1A:
        dc.w    loc_021D26-SS_Red_Emerald_Mappings
        dc.w    loc_021D38-SS_Red_Emerald_Mappings
SS_Gray_Emerald_Mappings: ; loc_021D1E:
        dc.w    loc_021D2C-SS_Gray_Emerald_Mappings
        dc.w    loc_021D38-SS_Gray_Emerald_Mappings        
SS_Emerald_Mappings: ; loc_021D22:  {Blue / Yellow / Purple / Green}  
        dc.w    loc_021D32-SS_Emerald_Mappings
        dc.w    loc_021D38-SS_Emerald_Mappings
loc_021D26:
        dc.b    $01
        dc.b    $F8, $05, $00, $00, $F8        ; Sonic 1 Mappings Format   
loc_021D2C:
        dc.b    $01
        dc.b    $F8, $05, $00, $04, $F8        ; Sonic 1 Mappings Format        
loc_021D32:
        dc.b    $01
        dc.b    $F8, $05, $00, $08, $F8        ; Sonic 1 Mappings Format
loc_021D38:
        dc.b    $01
        dc.b    $F8, $05, $00, $0C, $F8        ; Sonic 1 Mappings Format                               
;===============================================================================
; Special Stage - Sub-routine
             
;===============================================================================  
        nop                     ; Filler                
;=============================================================================== 
; Object 0x09 - Sonic In Special Stage
                 
;===============================================================================         
Obj09_Sonic_In_Special_Stage: ; loc_021D40:
        tst.w   (Debug_placement_mode).w
        beq.s   Sonic_In_SS_Normal      ; loc_021D4E
        bsr     S1SS_FixCamera          ; loc_021F76
        bra     Debug_Mode              ; loc_023B70
Sonic_In_SS_Normal: ; loc_021D4E:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_021D5C(pc,d0), d1
        jmp     loc_021D5C(pc,d1)
loc_021D5C:        
        dc.w    loc_021D64-loc_021D5C
        dc.w    loc_021DA4-loc_021D5C
        dc.w    loc_021FA0-loc_021D5C
        dc.w    loc_021FF4-loc_021D5C
loc_021D64:
        addq.b  #2,routine(a0)    
        move.b  #$E, y_radius(a0)
        move.b  #$7, $0017(a0)
        move.l  #Sonic_Mappings,mappings(a0) ; loc_0614C0
        move.w  #$780,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_26 ; loc_0223E4
        move.b  #4,render_flags(a0)
        move.b  #0, $0018(a0)
        move.b  #$2, $001C(a0)
        bset    #$2, status(a0)
        bset    #1, status(a0)
loc_021DA4:
        tst.w   ($FFFFFFFA).w
        beq.s   loc_021DB8
        btst    #4, (Ctrl_1_Press).w
        beq.s   loc_021DB8
        move.w  #$001, (Debug_placement_mode).w
loc_021DB8:
        move.b  #0, Objoff_30(a0)
        moveq	#0,d0
        move.b  status(a0), D0
        andi.w  #$002, d0
        move.w  SonicInSS_Modes(pc,d0), d1 ; loc_021DDC
        jsr     SonicInSS_Modes(pc,d1)     ; loc_021DDC
        jsr     Load_Sonic_Dynamic_PLC  ; (loc_010DDC)
        jmp     DisplaySprite           ; (loc_00D3C2)
SonicInSS_Modes: ; loc_021DDC:
        dc.w    SonicInSS_OnWall-SonicInSS_Modes ; loc_021DE0
        dc.w    SonicInSS_InAir-SonicInSS_Modes  ; loc_021DEE
SonicInSS_OnWall: ; loc_021DE0:
        bsr     SonicInSS_Jump          ; loc_021F16
        bsr     SonicInSS_Move          ; loc_021E20
        bsr     SonicInSS_Fall          ; loc_022016
        bra.s   SonicInSS_Display       ; loc_021DFA
SonicInSS_InAir: ; loc_021DEE:
        bsr     SonicInSS_Null          ; loc_021F5A
        bsr     SonicInSS_Move          ; loc_021E20
        bsr     SonicInSS_Fall          ; loc_022016
SonicInSS_Display: ; loc_021DFA:
        bsr     SonicInSS_ChkItems      ; loc_022112
        bsr     SonicInSS_ChkItems2     ; loc_02224E
        jsr     SpeedToPos              ; (loc_00D27A)
        bsr     S1SS_FixCamera          ; loc_021F76
        move.w  ($FFFFF750).w, d0
        add.w   ($FFFFF752).w, d0
        move.w  d0, ($FFFFF750).w
        jsr     Sonic_Animate           ; (loc_010AB2)
        rts
SonicInSS_Move: ; loc_021E20:
        btst    #$2, ($FFFFF602).w
        beq.s   loc_021E2C
        bsr     SonicInSS_MoveLeft          ; loc_021EB8
loc_021E2C:
        btst    #3, ($FFFFF602).w
        beq.s   loc_021E38
        bsr     SonicInSS_MoveRight     ; loc_021EE8
loc_021E38:
        move.b  ($FFFFF602).w, d0
        andi.b  #$C, d0
        bne.s   loc_021E68
        move.w  $14(A0), D0
        beq.s   loc_021E68
        bmi.s   loc_021E5A
        subi.w  #$00C, d0
        bcc.s   loc_021E54
        move.w  #0, d0
loc_021E54:
        move.w  d0, $14(a0)
        bra.s   loc_021E68
loc_021E5A:
        addi.w  #$00C, d0
        bcc.s   loc_021E64
        move.w  #0, d0
loc_021E64:
        move.w  d0, $14(a0)
loc_021E68:
        move.b  ($FFFFF750).w, d0
        addi.b  #$20, d0
        andi.b  #$C0, d0
        neg.b   D0
        jsr     CalcSine        ; loc_00320A
        muls.w  $14(A0), d1
        add.l   d1, x_pos(a0)
        muls.w  $14(A0), D0
        add.l   d0, y_pos(a0)
        movem.l D0/d1, -(A7)
        move.l  y_pos(a0), D2
        move.l  x_pos(a0), D3
        bsr     loc_0220A8
        beq.s   loc_021EB2
        movem.l (A7)+, D0/d1
        sub.l   d1, x_pos(a0)
        sub.l   d0, y_pos(a0)
        move.w  #0, $14(a0)
        rts
loc_021EB2:
        movem.l (A7)+, D0/d1
        rts
        
;=============================================================================== 
; Beginning of Sub SonicInSS_MoveLeft
                 
;===============================================================================         
SonicInSS_MoveLeft: ; loc_021EB8:
        bset    #0, status(a0)
        move.w  $14(A0), D0
        beq.s   loc_021EC6
        bpl.s   loc_021EDA
loc_021EC6:
        subi.w  #$00C, d0
        cmpi.w  #$F800, d0
        bgt.s   loc_021ED4
        move.w  #$F800, d0
loc_021ED4:
        move.w  d0, $14(a0)
        rts
loc_021EDA:
        subi.w  #$40, d0
        bcc.s   loc_021EE2
        nop
loc_021EE2:
        move.w  d0, $14(a0)
        rts
;=============================================================================== 
; End of Sub SonicInSS_MoveLeft
                
;===============================================================================         

;=============================================================================== 
; Beginning of Sub SonicInSS_MoveRight
                 
;===============================================================================         
SonicInSS_MoveRight: ; loc_021EE8:
        bclr    #0, status(a0)
        move.w  $14(A0), D0
        bmi.s   loc_021F08
        addi.w  #$00C, d0
        cmpi.w  #$800, d0
        blt.s   loc_021F02
        move.w  #$800, d0
loc_021F02:
        move.w  d0, $14(a0)
        bra.s   loc_021F14
loc_021F08:
        addi.w  #$40, d0
        bcc.s   loc_021F10
        nop
loc_021F10:
        move.w  d0, $14(a0)
loc_021F14:
        rts
;=============================================================================== 
; End of Sub SonicInSS_MoveRight
                
;===============================================================================
         
;=============================================================================== 
; Beginning of Sub SonicInSS_Jump
                 
;===============================================================================         
SonicInSS_Jump: ; loc_021F16:
        move.b  (Ctrl_1_Press_Logical).w, d0
        andi.b  #$70, d0
        beq.s   loc_021F58
        move.b  ($FFFFF750).w, d0
        andi.b  #$FC, d0
        neg.b   D0
        subi.b  #$40, d0
        jsr     CalcSine        ; loc_00320A
        muls.w  #$680, d1
        asr.l   #8, d1
        move.w  d1,x_vel(a0)
        muls.w  #$680, d0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
        bset    #1, status(a0)
        move.w  #$0A0, d0
        jsr     (Play_Sfx)              ; loc_0014C6
loc_021F58:
        rts
;=============================================================================== 
; End of Sub SonicInSS_Jump
                
;===============================================================================         

;=============================================================================== 
; Beginning of Sub SonicInSS_Null
                 
;===============================================================================         
SonicInSS_Null: ; loc_021F5A:   
        rts
;=============================================================================== 
; End of Sub SonicInSS_Null
                
;===============================================================================         

        move.w  #$FC00, d1
        cmp.w   $0012(A0), d1
        ble.s   loc_021F74
        move.b  ($FFFFF602).w, d0
        andi.b  #$70, d0
        bne.s   loc_021F74
        move.w  d1, $0012(a0)
loc_021F74:
        rts
        
;=============================================================================== 
; Beginning of Sub S1SS_FixCamera
                 
;===============================================================================  
S1SS_FixCamera: ; loc_021F76:
        move.w  y_pos(a0), D2
        move.w  x_pos(a0), D3
        move.w  ($FFFFEE00).w, d0
        subi.w  #$0A0, d3
        bcs.s   loc_021F8E
        sub.w   d3, d0
        sub.w   d0, ($FFFFEE00).w
loc_021F8E:
        move.w  ($FFFFEE04).w, d0
        subi.w  #$070, D2
        bcs.s   loc_021F9E
        sub.w   d2, d0
        sub.w   d0, ($FFFFEE04).w
loc_021F9E:
        rts
;=============================================================================== 
; End of Sub S1SS_FixCamera
                
;===============================================================================          
loc_021FA0:
        addi.w  #$40, ($FFFFF752).w
        cmpi.w  #$1800, ($FFFFF752).w
        bne.s   loc_021FB4
        move.b  #$C, (Game_Mode).w
loc_021FB4:
        cmpi.w  #$3000, ($FFFFF752).w
        blt.s   loc_021FD2
        move.w  #0, ($FFFFF752).w
        move.w  #$4000, ($FFFFF750).w
        addq.b  #2,routine(a0)
        move.w  #$03C, objoff_38(a0)
loc_021FD2:
        move.w  ($FFFFF750).w, d0
        add.w   ($FFFFF752).w, d0
        move.w  d0, ($FFFFF750).w
        jsr     Sonic_Animate           ; (loc_010AB2)
        jsr     Load_Sonic_Dynamic_PLC  ; (loc_010DDC)
        bsr     S1SS_FixCamera          ; loc_021F76
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_021FF4:
        subq.w  #1, objoff_38(a0)
        bne.s   loc_022000
        move.b  #$C, (Game_Mode).w
loc_022000:
        jsr     Sonic_Animate           ; (loc_010AB2)
        jsr     Load_Sonic_Dynamic_PLC  ; (loc_010DDC)
        bsr     S1SS_FixCamera          ; loc_021F76
        jmp     DisplaySprite           ; (loc_00D3C2)
        
;=============================================================================== 
; Beginning of Sub SonicInSS_Fall
                 
;===============================================================================          
SonicInSS_Fall: ; loc_022016:
        move.l  y_pos(a0), D2
        move.l  x_pos(a0), D3
        move.b  ($FFFFF750).w, d0
        andi.b  #$FC, d0
        jsr     CalcSine        ; loc_00320A
        move.w x_vel(A0), D4
        ext.l   D4
        asl.l   #8, D4
        muls.w  #$02A, d0
        add.l   d4, d0
        move.w  $0012(A0), D4
        ext.l   D4
        asl.l   #8, D4
        muls.w  #$02A, d1
        add.l   d4, d1
        add.l   d0, d3
        bsr     loc_0220A8
        beq.s   loc_022070
        sub.l   d0, d3
        moveq	#0,d0
        move.w  d0,x_vel(a0)
        bclr    #1, status(a0)
        add.l   d1, D2
        bsr     loc_0220A8
        beq.s   loc_022086
        sub.l   d1, D2
        moveq   #0,d1
        move.w  d1, $0012(a0)
        rts
loc_022070:
        add.l   d1, D2
        bsr     loc_0220A8
        beq.s   loc_022094
        sub.l   d1, D2
        moveq   #0,d1
        move.w  d1, $0012(a0)
        bclr    #1, status(a0)
loc_022086:
        asr.l   #8,d0
        asr.l   #8, d1
        move.w  d0,x_vel(a0)
        move.w  d1, $0012(a0)
        rts
loc_022094:
        asr.l   #8,d0
        asr.l   #8, d1
        move.w  d0,x_vel(a0)
        move.w  d1, $0012(a0)
        bset    #1, status(a0)
        rts
;=============================================================================== 
; End of Sub SonicInSS_Fall
                
;===============================================================================  
        
loc_0220A8:
        lea     ($FFFF0000), A1
        moveq   #0, D4
        swap.w  D2
        move.w  D2, D4
        swap.w  D2
        addi.w  #$044, D4
        divu.w  #$018, D4
        mulu.w  #$080, D4
        adda.l  d4, A1
        moveq   #0, D4
        swap.w  D3
        move.w  d3, D4
        swap.w  D3
        addi.w  #$014, D4
        divu.w  #$018, D4
        adda.w  d4, A1
        moveq   #0,d5
        move.b  (A1)+, D4
        bsr.s   loc_0220F0
        move.b  (A1)+, D4
        bsr.s   loc_0220F0
        adda.w  #$07E, A1
        move.b  (A1)+, D4
        bsr.s   loc_0220F0
        move.b  (A1)+, D4
        bsr.s   loc_0220F0
        tst.b   D5
        rts
loc_0220F0:
        beq.s   loc_022104
        cmpi.b  #$28, D4
        beq.s   loc_022104
        cmpi.b  #$3A, D4
        bcs.s   loc_022106
        cmpi.b  #$4B, D4
        bcc.s   loc_022106
loc_022104:
        rts
loc_022106:
        move.b  d4, Objoff_30(a0)
        move.l  A1, $0032(a0)        
        moveq   #$FFFFFFFF,d5
        rts
        
;=============================================================================== 
; Beginning of Sub SonicInSS_ChkItems
                 
;===============================================================================          
SonicInSS_ChkItems: ; loc_022112:
        lea     ($FFFF0000), A1
        moveq   #0, D4
        move.w  y_pos(a0), D4
        addi.w  #$050, D4
        divu.w  #$018, D4
        mulu.w  #$080, D4
        adda.l  d4, A1
        moveq   #0, D4
        move.w  x_pos(a0), D4
        addi.w  #$20, D4
        divu.w  #$018, D4
        adda.w  d4, A1
        move.b  (A1), D4
        bne.s   loc_02214C
        tst.b   objoff_3A(a0)
        bne     loc_02221C
        moveq   #0, D4
        rts
loc_02214C:
        cmpi.b  #$3A, D4
        bne.s   loc_022188
        bsr     loc_021874
        bne.s   loc_022160
        move.b  #1, (a2)
        move.l  A1, mappings(a2)
loc_022160:
        jsr     (loc_00AD22)
        cmpi.w  #$032, (Ring_count).w
        bcs.s   loc_022184
        bset    #0, ($FFFFFE1B).w
        bne.s   loc_022184
        addq.b  #1, ($FFFFFE18).w
        move.w  #$0BF, d0
        jsr     (Play_Music)            ; loc_0014C0
loc_022184:
        moveq   #0, D4
        rts
loc_022188:
        cmpi.b  #$28, D4
        bne.s   loc_0221B2
        bsr     loc_021874
        bne.s   loc_02219C
        move.b  #3, (a2)
        move.l  A1, mappings(a2)
loc_02219C:
        addq.b  #1, ($FFFFFE12).w
        addq.b  #1, (Update_HUD_lives).w
        move.w  #$088, d0
        jsr     (Play_Music)            ; loc_0014C0
        moveq   #0, D4
        rts
loc_0221B2:
        cmpi.b  #$3B, D4
        bcs.s   loc_0221F8
        cmpi.b  #$40, D4
        bhi.s   loc_0221F8
        bsr     loc_021874
        bne.s   loc_0221CC
        move.b  #5, (a2)
        move.l  A1, mappings(a2)
loc_0221CC:
        cmpi.b  #6, ($FFFFFE57).w
        beq.s   loc_0221EA
        subi.b  #$3B, D4
        moveq	#0,d0
        move.b  ($FFFFFE57).w, d0
        lea     ($FFFFFE58).w, a2
        move.b  d4, $00(A2, d0)
        addq.b  #1, ($FFFFFE57).w
loc_0221EA:
        move.w  #$093, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        moveq   #0, D4
        rts
loc_0221F8:
        cmpi.b  #$41, D4
        bne.s   loc_022204
        move.b  #1, objoff_3A(a0)
loc_022204:
        cmpi.b  #$4A, D4
        bne.s   loc_022218
        cmpi.b  #1, objoff_3A(a0)
        bne.s   loc_022218
        move.b  #$2, objoff_3A(a0)
loc_022218:          
        moveq   #$FFFFFFFF, D4
        rts
loc_02221C:
        cmpi.b  #$2, objoff_3A(a0)
        bne.s   loc_022246
        lea     ($FFFF1020), A1
        moveq   #$3F, d1
loc_02222C:        
        moveq   #$3F, D2
loc_02222E:        
        cmpi.b  #$41, (a1)
        bne.s   loc_022238
        move.b  #$2C, (a1)
loc_022238:
        addq.w  #1, A1
        dbra    D2, loc_02222E
        lea     $0040(A1), A1
        dbra    d1, loc_02222C
loc_022246:
        clr.b   objoff_3A(a0)
        moveq   #0, D4
        rts
;=============================================================================== 
; End of Sub SonicInSS_ChkItems
                
;===============================================================================          

;=============================================================================== 
; Beginning of Sub SonicInSS_ChkItems2
                 
;===============================================================================          
SonicInSS_ChkItems2: ; loc_02224E:
        move.b  Objoff_30(A0), D0
        bne.s   loc_02226E
        subq.b  #1, objoff_36(a0)
        bpl.s   loc_022260
        move.b  #0, objoff_36(a0)
loc_022260:
        subq.b  #1, $0037(a0)
        bpl.s   loc_02226C
        move.b  #0, $0037(a0)
loc_02226C:
        rts
loc_02226E:
        cmpi.b  #$25, d0
        bne.s   loc_0222E6
        move.l  $0032(A0), d1
        subi.l  #$FFFF0001, d1
        move.w  d1, D2
        andi.w  #$07F, d1
        mulu.w  #$018, d1
        subi.w  #$014, d1
        lsr.w   #$7, D2
        andi.w  #$07F, D2
        mulu.w  #$018, D2
        subi.w  #$044, D2
        sub.w   x_pos(a0), d1
        sub.w   y_pos(a0), D2
        jsr     CalcAngle               ; loc_0034A2
        jsr     CalcSine        ; loc_00320A
        muls.w  #$F900, d1
        asr.l   #8, d1
        move.w  d1,x_vel(a0)
        muls.w  #$F900, d0
        asr.l   #8,d0
        move.w  d0, $0012(a0)
        bset    #1, status(a0)
        bsr     loc_021874
        bne.s   loc_0222DC
        move.b  #$2, (a2)
        move.l  $0032(A0), D0
        subq.l  #1,d0
        move.l  d0, mappings(a2)
loc_0222DC:
        move.w  #$0B4, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_0222E6:
        cmpi.b  #$27, d0
        bne.s   loc_0222FC
        addq.b  #2,routine(a0)
        move.w  #$0A8, d0
        jsr     (Play_Sfx)              ; loc_0014C6
        rts
loc_0222FC:
        cmpi.b  #$29, d0
        bne.s   loc_022330
        tst.b   objoff_36(a0)
        bne     loc_0223E0
        move.b  #$1E, objoff_36(a0)
        btst    #6, ($FFFFF753).w
        beq.s   loc_022326
        asl.w   ($FFFFF752).w
        move.l  $0032(A0), A1
        subq.l  #1, A1
        move.b  #$2A, (a1)
loc_022326:
        move.w  #$0A9, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_022330:
        cmpi.b  #$2A, d0
        bne.s   loc_022364
        tst.b   objoff_36(a0)
        bne     loc_0223E0
        move.b  #$1E, objoff_36(a0)
        btst    #6, ($FFFFF753).w
        bne.s   loc_02235A
        asr.w   ($FFFFF752).w
        move.l  $0032(A0), A1
        subq.l  #1, A1
        move.b  #$29, (a1)
loc_02235A:
        move.w  #$0A9, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_022364:
        cmpi.b  #$2B, d0
        bne.s   loc_02239A
        tst.b   $0037(a0)
        bne     loc_0223E0
        move.b  #$1E, $0037(a0)
        bsr     loc_021874
        bne.s   loc_02238C
        move.b  #4, (a2)
        move.l  $0032(A0), D0
        subq.l  #1,d0
        move.l  d0, mappings(a2)
loc_02238C:
        neg.w   ($FFFFF752).w
        move.w  #$0A9, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_02239A:
        cmpi.b  #$2D, d0
        beq.s   loc_0223B2
        cmpi.b  #$2E, d0
        beq.s   loc_0223B2
        cmpi.b  #$2F, d0
        beq.s   loc_0223B2
        cmpi.b  #$30, d0
        bne.s   loc_0223E0
loc_0223B2:
        bsr     loc_021874
        bne.s   loc_0223D6
        move.b  #6, (a2)
        move.l  $0032(A0), A1
        subq.l  #1, A1
        move.l  A1, mappings(a2)
        move.b  (A1), D0
        addq.b  #1,d0
        cmpi.b  #$30, d0
        bls.s   loc_0223D2
        clr.b   D0
loc_0223D2:
        move.b  d0, mappings(a2)
loc_0223D6:
        move.w  #$0BA, d0
        jmp     (Play_Sfx)              ; loc_0014C6
loc_0223E0:
        rts
;=============================================================================== 
; End of Sub SonicInSS_ChkItems2
                 
;===============================================================================          
        
;=============================================================================== 
; Object 0x09 - Sonic In Special Stage
                
;===============================================================================  
        
;=============================================================================== 
; Object 0x10
                 
;===============================================================================                 
Obj10: 
loc_0223E2:
        rts   
;=============================================================================== 
; Object 0x10
                
;===============================================================================         
J_ModifySpriteAttr_2P_26: ; loc_0223E4:                
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
        dc.w    $0000           ; Filler
        
        
Dynamic_Art_Cues: ; loc_0223EC: ; Dynamic reload sprites routine
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        add.w   d0, d0
        move.w  loc_02240A(pc,d0), d1
        lea     loc_022408(pc,d1), A2
        move.w  loc_022408(pc,d0), D0
        jmp     loc_022408(pc,d0)
        rts 
loc_022408:        ; Dynamic_Normal => loc_022630
        dc.w    Dynamic_Normal-loc_022408 ; Green Hill               
loc_02240A:
        dc.w    loc_022698-loc_022408 ; Green Hill        
        dc.w    loc_02244C-loc_022408 ; Null
        dc.w    loc_022866-loc_022408 ; Null
        dc.w    loc_02244C-loc_022408 ; Wood (Null)
        dc.w    loc_022866-loc_022408 ; Wood (Null)
        dc.w    loc_02244C-loc_022408 ; Null
        dc.w    loc_022866-loc_022408 ; Null
        dc.w    Dynamic_Normal-loc_022408 ; Metropolis
        dc.w    loc_0226FC-loc_022408 ; Metropolis
        dc.w    Dynamic_Normal-loc_022408 ; Metropolis
        dc.w    loc_0226FC-loc_022408 ; Metropolis
        dc.w    loc_02244C-loc_022408 ; Null
        dc.w    loc_022866-loc_022408 ; Null
        dc.w    loc_02244E-loc_022408 ; Hill Top 
        dc.w    loc_022754-loc_022408 ; Hill Top 
        dc.w    Dynamic_Normal-loc_022408 ; Hidden Palace
        dc.w    loc_0227B8-loc_022408 ; Hidden Palace
        dc.w    loc_02244C-loc_022408 ; Null
        dc.w    loc_022866-loc_022408 ; Null
        dc.w    Dynamic_Normal-loc_022408 ; Oil Ocean
        dc.w    loc_0227E4-loc_022408 ; Oil Ocean
        dc.w    loc_02244C-loc_022408 ; Dust Hill
        dc.w    loc_022866-loc_022408 ; Dust Hill
        dc.w    loc_02244C-loc_022408 ; Casino Night
        dc.w    loc_022866-loc_022408 ; Casino Night
        dc.w    Dynamic_Normal-loc_022408 ; Chemical Plant
        dc.w    CPz_Animate-loc_022408 ; Chemical Plant ; loc_02282A
        dc.w    loc_02244C-loc_022408 ; Genocide City (Null)
        dc.w    loc_022866-loc_022408 ; Genocide City (Null)
        dc.w    Dynamic_Normal-loc_022408 ; Neo Green Hill
        dc.w    loc_02283C-loc_022408 ; Neo Green Hill
        dc.w    loc_02244C-loc_022408 ; Death Egg (Null)
        dc.w    loc_022866-loc_022408 ; Death Egg (Null)
loc_02244C:
        rts       
loc_02244E:
        tst.w   (Two_player_mode).w
        bne     Dynamic_Normal          ; loc_022630
        lea     ($FFFFF7F0).w, A3
        moveq	#0,d0
        move.w  ($FFFFEE00).w, d1
        neg.w   d1
        asr.w   #3, d1
        move.w  ($FFFFEE00).w, d0
        lsr.w   #4, d0
        add.w   d1, d0
        subi.w  #$010, d0
        divu.w  #$030, d0
        swap.w  D0
        cmp.b   render_flags(A3), D0
        beq.s   loc_0224C0
        move.b  d0, render_flags(a3)
        move.w  d0, D2
        andi.w  #$007, d0
        add.w   d0, d0
        add.w   d0, d0
        add.w   d0, d0
        move.w  d0, d1
        add.w   d0, d0
        add.w   d1, d0
        andi.w  #$038, D2
        lsr.w   #$2, D2
        add.w   d2, d0
        lea     loc_0224C4(pc,d0), A4
        moveq   #5,d5
        move.w  #$A000, D4
loc_0224A4:
        moveq   #$FFFFFFFF, d1
        move.w  (A4)+, d1
        andi.l  #$0FFFFFF, d1
        move.w  d4, D2
        moveq   #$40, d3
        jsr     DMA_68KtoVRAM           ; loc_00156C
        addi.w  #$080, D4
        dbra    d5, loc_0224A4
loc_0224C0:
        bra     loc_022584         
loc_0224C4:
        dc.w    $0080, $0280, $0380, $0580, $0600, $0880, $0080, $0280
        dc.w    $0380, $0580, $0600, $0880, $0980, $0A80, $0B80, $0C80
        dc.w    $0E80, $0F00, $0980, $0A80, $0B80, $0C80, $0E80, $0F00
        dc.w    $1080, $1180, $1200, $1280, $1300, $1380, $1080, $1180
        dc.w    $1200, $1280, $1300, $1380, $1400, $1480, $1500, $1600
        dc.w    $1900, $1D00, $1400, $1480, $1500, $1600, $1900, $1D00
        dc.w    $1D80, $1E00, $2280, $2400, $2580, $2600, $1D80, $1E00
        dc.w    $2280, $2400, $2580, $2600, $2680, $2780, $2B00, $3280
        dc.w    $3600, $3680, $2680, $2780, $2B00, $3280, $3600, $3680
        dc.w    $3C80, $3D00, $3F00, $3F80, $4080, $4480, $3C80, $3D00
        dc.w    $3F00, $3F80, $4080, $4480, $4580, $4880, $4900, $4B80
        dc.w    $4C80, $4D80, $4580, $4880, $4900, $4B80, $4C80, $4D80         
loc_022584:
        lea     ($FFFFA800).w, A1
        move.w  ($FFFFEE00).w, D2
        neg.w   D2
        asr.w   #3, D2
        move.l  A2, -(A7)
        lea     (Hill_Top_Background_Unc), A0 ; loc_028C2A
        lea     ($FFFF7C00), A2
        moveq   #$F, d1
loc_0225A0:
        move.w  (A1)+, D0
        neg.w   D0
        add.w   d2, d0
        andi.w  #$01F, d0
        lsr.w   #1,d0
        bcc.s   loc_0225B2
        addi.w  #$200, d0
loc_0225B2:
        lea     $00(A0, d0), A4
        lsr.w   #1,d0
        bcs.s   loc_0225DC
        move.l  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.l  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.l  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.l  (A4)+, (A2)+
        suba.w  #$0C0, a2
        adda.w  #$20, A0
        dbra    d1, loc_0225A0  
        bra.s   loc_022614
loc_0225DC:
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        adda.w  #$03C, a2
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        move.b  (A4)+, (A2)+
        suba.w  #$0C0, a2
        adda.w  #$20, A0
        dbra    d1, loc_0225A0
loc_022614:
        move.l  #$0FF7C00, d1
        move.w  #$A300, D2
        move.w  #$080, d3
        jsr     DMA_68KtoVRAM           ; loc_00156C
        move.l  (A7)+, A2
        addq.w  #$2, A3
        bra     loc_022634                    
Dynamic_Normal: ; loc_022630:
        lea     ($FFFFF7F0).w, A3
loc_022634:        
        move.w  (A2)+, D6
loc_022636:
        subq.b  #1, (a3)
        bpl.s   loc_02267C
        moveq	#0,d0
        move.b  render_flags(A3), D0
        cmp.b   $0006(A2), D0
        bcs.s   loc_02264C
        moveq	#0,d0
        move.b  d0, render_flags(a3)
loc_02264C:
        addq.b  #1, render_flags(a3)
        move.b  (A2), (a3)
        bpl.s   loc_02265A
        add.w   d0, d0
        move.b  $09(A2, d0), (a3)
loc_02265A:
        move.b  $08(A2, d0), D0
        lsl.w   #5, d0
        move.w  mappings(A2), D2
        move.l  (a2),d1
        andi.l  #$0FFFFFF, d1
        add.l   d0, d1
        moveq   #0, d3
        move.b  $0007(A2), D3
        lsl.w   #4, d3
        jsr     DMA_68KtoVRAM           ; loc_00156C
loc_02267C:
        move.b  $0006(A2), D0
        tst.b   (a2)
        bpl.s   loc_022686
        add.b   d0, d0
loc_022686:        
        addq.b  #1,d0
        andi.w  #$0FE, d0
        lea     $08(A2, d0), A2
        addq.w  #$2, A3
        dbra    d6, loc_022636
        rts   
loc_022698: ; Green Hill Dynamic Reload Sprites          
        dc.w    $0004           ; Total of Animations
        dc.l    ($FF<<$18)|Ghz_Flower_1 ; loc_028000
        dc.w    $7280           ; VRam 
        dc.w    $0602           ; Frames/Tiles
        dc.w    $007F, $0213, $0007, $0207, $0007, $0207 ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Flower_2 ; loc_028080          
        dc.w    $72C0           ; VRam
        dc.w    $0802           ; Frames/Tiles
        dc.w    $027F, $000B, $020B, $000B, $0205, $0005, $0205, $0005 ; Frame Load/Frame Time
        dc.l    ($07<<$18)|Ghz_Flower_3 ; loc_028100  
        dc.w    $7300           ; VRam
        dc.w    $0202           ; Frames/Tiles
        dc.w    $0002           ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Flower_4 ; loc_028180    
        dc.w    $7340           ; VRam
        dc.w    $0802           ; Frames/Tiles
        dc.w    $007F, $0207, $0007, $0207, $0007, $020B, $000B, $020B ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Dyn_Wall ; loc_028200  
        dc.w    $7380           ; VRam
        dc.w    $0602           ; Frames/Tiles
        dc.w    $0017, $0209, $040B, $0617, $040B, $0209 ; Frame Load/Frame Time
loc_0226FC: ; Metropolis Dynamic Reload Sprites   
        dc.w    $0005           ; Total of Animations
        dc.l    Mz_Spinnig_Cylinder     ; loc_02902A  
        dc.w    $6980           ; VRam
        dc.w    $0810           ; Frames/Tiles
        dc.w    $0010, $2030, $4050, $6070 ; Frame Load/Frame Time
        dc.l    ($0D<<$18)|Mz_Lava      ; loc_02A02A:
        dc.w    $6800           ; VRam
        dc.w    $060C           ; Frames/Tiles
        dc.w    $000C, $1824, $180C     ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Mz_Pistons   ; loc_02A06A:
        dc.w    $6B80           ; VRam
        dc.w    $0406           ; Frames/Tiles
        dc.w    $0013, $0607, $0C13, $0607 ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Mz_Pistons   ; loc_02A06A:
        dc.w    $6C40           ; VRam
        dc.w    $0406           ; Frames/Tiles
        dc.w    $0C13, $0607, $0013, $0607 ; Frame Load/Frame Time
        dc.l    ($05<<$18)|Mz_Drills    ; loc_02A86A:
        dc.w    $6D00           ; VRam
        dc.w    $0408           ; Frames/Tiles
        dc.w    $0008, $1018            ; Frame Load/Frame Time
        dc.l    ($05<<$18)|Mz_Drills    ; loc_02A86A:
        dc.w    $6E00           ; VRam
        dc.w    $0408           ; Frames/Tiles
        dc.w    $0008, $1018            ; Frame Load/Frame Time
loc_022754: ; Hill Top Dynamic Reload Sprites  
        dc.w    $0004           ; Total of Animations
        dc.l    ($FF<<$18)|Ghz_Flower_1 ; loc_028000
        dc.w    $7280           ; VRam 
        dc.w    $0602           ; Frames/Tiles
        dc.w    $007F, $0213, $0007, $0207, $0007, $0207 ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Flower_2 ; loc_028080          
        dc.w    $72C0           ; VRam
        dc.w    $0802           ; Frames/Tiles
        dc.w    $027F, $000B, $020B, $000B, $0205, $0005, $0205, $0005 ; Frame Load/Frame Time
        dc.l    ($07<<$18)|Ghz_Flower_3 ; loc_028100  
        dc.w    $7300           ; VRam
        dc.w    $0202           ; Frames/Tiles
        dc.w    $0002           ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Flower_4 ; loc_028180    
        dc.w    $7340           ; VRam
        dc.w    $0802           ; Frames/Tiles
        dc.w    $007F, $0207, $0007, $0207, $0007, $020B, $000B, $020B ; Frame Load/Frame Time
        dc.l    ($FF<<$18)|Ghz_Dyn_Wall ; loc_028200  
        dc.w    $7380           ; VRam
        dc.w    $0602           ; Frames/Tiles
        dc.w    $0017, $0209, $040B, $0617, $040B, $0209 ; Frame Load/Frame Time
loc_0227B8: ; Hidden Palace Dynamic Reload Sprites  
        dc.w    $0002           ; Total of Animations
        dc.l    ($08<<$18)|HPz_Orbs     ; loc_02B46A
        dc.w    $5D00           ; VRam
        dc.w    $0608           ; Frames/Tiles
        dc.w    $0000, $0810, $1008     ; Frame Load/Frame Time         
        dc.l    ($08<<$18)|HPz_Orbs     ; loc_02B46A
        dc.w    $5E00           ; VRam
        dc.w    $0608           ; Frames/Tiles
        dc.w    $0810, $1008, $0000     ; Frame Load/Frame Time
        dc.l    ($08<<$18)|HPz_Orbs     ; loc_02B46A
        dc.w    $5F00           ; VRam
        dc.w    $0608           ; Frames/Tiles
        dc.w    $1008, $0000, $0810     ; Frame Load/Frame Time    
loc_0227E4: ; Oil Ocean Dynamic Reload Sprites              
        dc.w    $0004           ; Total of Animations
        dc.l    ($FF<<$18)|OOz_Red_Balls ; loc_02B76A
        dc.w    $5A00           ; VRam
        dc.w    $0404           ; Frames/Tiles
        dc.w    $000B, $0405, $0809, $0403 ; Frame Load/Frame Time 
        dc.l    ($06<<$18)|OOz_Rotating_Square_1 ; loc_02B8EA
        dc.w    $5A80           ; VRam
        dc.w    $0404           ; Frames/Tiles
        dc.w    $0004, $080C            ; Frame Load/Frame Time
        dc.l    ($06<<$18)|OOz_Rotating_Square_2 ; loc_02BAEA
        dc.w    $5B00           ; VRam
        dc.w    $0404           ; Frames/Tiles
        dc.w    $0004, $080C            ; Frame Load/Frame Time
        dc.l    ($11<<$18)|OOz_Oil_1    ; loc_02BCEA
        dc.w    $5B80           ; VRam
        dc.w    $0610           ; Frames/Tiles
        dc.w    $0010, $2030, $2010     ; Frame Load/Frame Time
        dc.l    ($11<<$18)|OOz_Oil_2 ; loc_02C4EA
        dc.w    $5D80           ; VRam
        dc.w    $0610           ; Frames/Tiles
        dc.w    $0010, $2030, $2010     ; Frame Load/Frame Time
CPz_Animate: ; loc_02282A: ; Chemical Plant Dynamic Reload Sprites              
        dc.w    $0000           ; Total of Animations
        dc.l    ($04<<$18)|CPz_Dyn_Background ; loc_02CCEA:
        dc.w    $6E00           ; VRam
        dc.w    $0802           ; Frames/Tiles
        dc.w    $0002, $0406, $080A, $0C0E ; Frame Load/Frame Time
loc_02283C: ; Neo Green Hill Dynamic Reload Sprites 
        dc.w    $0003           ; Total of Animations
        dc.l    ($05<<$18)|NGHz_Water_Falls_1 ; loc_02CEEA
        dc.w    $7F80           ; VRam
        dc.w    $0204           ; Frames/Tiles    
        dc.w    $0004           ; Frame Load/Frame Time
        dc.l    ($05<<$18)|NGHz_Water_Falls_1 ; loc_02CEEA
        dc.w    $7F00           ; VRam
        dc.w    $0204           ; Frames/Tiles    
        dc.w    $0400           ; Frame Load/Frame Time
        dc.l    ($05<<$18)|NGHz_Water_Falls_2 ; loc_02CFEA
        dc.w    $7E80           ; VRam
        dc.w    $0204           ; Frames/Tiles 
        dc.w    $0004           ; Frame Load/Frame Time
        dc.l    ($05<<$18)|NGHz_Water_Falls_3 ; loc_02D0EA
        dc.w    $7E00           ; VRam
        dc.w    $0204           ; Frames/Tiles 
        dc.w    $0004           ; Frame Load/Frame Time               
loc_022866:
        cmpi.b  #$D, (Current_ZoneAndAct).w
        beq.s   loc_022870
loc_02286E:
        rts
loc_022870:
        move.w  ($FFFFEE00).w, d0
        cmpi.w  #$1940, d0
        bcs.s   loc_02286E  
        cmpi.w  #$1F80, d0
        bcc.s   loc_02286E
        subq.b  #1, ($FFFFF721).w
        bpl.s   loc_02286E
        move.b  #$7, ($FFFFF721).w
        move.b  #1, ($FFFFF720).w
        lea     ($FFFF7500), A1
        bsr.s   loc_0228A0
        lea     ($FFFF7D00), A1
loc_0228A0:
        move.w  #$007, d1
loc_0228A4:
        move.w  (A1), D0
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  $0072(A1), (A1)+
        adda.w  #$070, A1
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  $0072(A1), (A1)+
        adda.w  #$070, A1
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  $0072(A1), (A1)+
        adda.w  #$070, A1
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  art_tile(A1), (A1)+
        move.w  d0, (a1)+
        suba.w  #$180, A1
        dbra    d1, loc_0228A4
        rts    
Load_16x16_Mappings_For_Dyn_Sprites: ; loc_02293A: ; Load 16x16 mappings used by dynamic reload sprites...
        cmpi.b  #$7, (Current_ZoneAndAct).w
        bne.s   loc_022952
        bsr     loc_022D62
        move.b  #$FF, ($FFFFF7F1).w
        move.w  #$FFFF, ($FFFFA820).w
loc_022952:
        cmpi.b  #$D, (Current_ZoneAndAct).w
        bne.s   loc_022960
        move.b  #$FF, ($FFFFF7F1).w
loc_022960:
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
        add.w   d0, d0
        move.w  Map16Delta_Index(pc,d0), D0 ; loc_0229A2
        lea     Map16Delta_Index(pc,d0), A0 ; loc_0229A2
        tst.w   (a0)
        beq.s   loc_022988
        lea     (Block_Table).w, A1
        adda.w  (A0)+, A1
        move.w  (A0)+, d1
        tst.w   (Two_player_mode).w
        bne.s   loc_02298A
loc_022982:
        move.w  (A0)+, (A1)+
        dbra    d1, loc_022982
loc_022988:
        rts
loc_02298A:
        move.w  (A0)+, D0
        move.w  d0, d1
        andi.w  #$F800, d0
        andi.w  #$7FF, d1
        lsr.w   #1,d1
        or.w    d1, d0
        move.w  d0, (a1)+
        dbra    d1, loc_02298A
        rts
Map16Delta_Index: ; loc_0229A2:            
        dc.w    Map16Delta_GHz-Map16Delta_Index  ; loc_0229C4 - Green Hill 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Null
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Wood (Null)
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Null
        dc.w    Map16Delta_Mz-Map16Delta_Index   ; loc_022A40 - Metropolis 16x16 mappings
        dc.w    Map16Delta_Mz-Map16Delta_Index   ; loc_022A40 - Metropolis 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Null
        dc.w    Map16Delta_GHz-Map16Delta_Index  ; loc_0229C4 - Hill Top 16x16 mappings
        dc.w    Map16Delta_HPz-Map16Delta_Index  ; loc_022B14 - Hidden Palace 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Null
        dc.w    Map16Delta_OOz-Map16Delta_Index  ; loc_022C08 - Oil Ocean 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Dust Hill (Null)
        dc.w    Map16Delta_CNz-Map16Delta_Index  ; loc_022C6C - Casino Night 16x16 mappings
        dc.w    Map16Delta_CPz-Map16Delta_Index  ; loc_022D10 - Chemical Plant 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Genocide City (Null)
        dc.w    Map16Delta_NGHz-Map16Delta_Index ; loc_022D1C - Neo Green Hill 16x16 mappings
        dc.w    Map16Delta_Null-Map16Delta_Index ; loc_022D60 - Death Egg (Null)          
;===============================================================================
; Green Hill Mappings 16x16 Delta  

;===============================================================================
Map16Delta_GHz: ; loc_0229C4: ; Green Hill / Hill Top 16x16 mappings used by dynamic reload sprites...        
        dc.w    $1788 ; Ram Address to start loading ($1788+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $003B ; Number of words to load in Ram Array ($0000..$003B) -> move.w  (A0)+, d1
        dc.w    $4500, $4504, $4501, $4505, $4508, $450C, $4509, $450D
        dc.w    $4510, $4514, $4511, $4515, $4502, $4506, $4503, $4507
        dc.w    $450A, $450E, $450B, $450F, $4512, $4516, $4513, $4517
        dc.w    $6518, $651A, $6519, $651B, $651C, $651E, $651D, $651F
        dc.w    $439C, $4B9C, $439D, $4B9D, $4158, $439C, $4159, $439D
        dc.w    $4B9C, $4958, $4B9D, $4959, $6394, $6B94, $6395, $6B95
        dc.w    $E396, $EB96, $E397, $EB97, $6398, $6B98, $6399, $6B99
        dc.w    $E39A, $EB9A, $E39B, $EB9B
;===============================================================================
; Green Hill Mappings 16x16 Delta  
; 
;===============================================================================  

;===============================================================================
; Metropolis Mappings 16x16 Delta  

;===============================================================================              
Map16Delta_Mz: ; loc_022A40: ; Metropolis 16x16 mappings used by dynamic reload sprites...  
        dc.w    $1730 ; Ram Address to start loading ($1730+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $0067 ; Number of words to load in Ram Array ($0000..$0067) -> move.w  (A0)+, d1
        dc.w    $235C, $2B5C, $235D, $2B5D, $235E, $2B5E, $235F, $2B5F
        dc.w    $635A, $635A, $635B, $635B, $6358, $6358, $6359, $6359
        dc.w    $6356, $6356, $6357, $6357, $6354, $6354, $6355, $6355
        dc.w    $6352, $6352, $6353, $6353, $6350, $6350, $6351, $6351
        dc.w    $634E, $634E, $634F, $634F, $634C, $634C, $634D, $634D
        dc.w    $2360, $2B60, $2361, $2B61, $2362, $2B62, $2363, $2B63
        dc.w    $2364, $2B64, $2365, $2B65, $2366, $2B66, $2367, $2B67
        dc.w    $0000, $0000, $4340, $4341, $0000, $0000, $4342, $4343
        dc.w    $4344, $4345, $4348, $4349, $4346, $4347, $434A, $434B
        dc.w    $E35A, $E35A, $E35B, $E35B, $E358, $E358, $E359, $E359
        dc.w    $E356, $E356, $E357, $E357, $E354, $E354, $E355, $E355
        dc.w    $E352, $E352, $E353, $E353, $E350, $E350, $E351, $E351
        dc.w    $E34E, $E34E, $E34F, $E34F, $E34C, $E34C, $E34D, $E34D
;===============================================================================
; Metropolis Mappings 16x16 Delta  
; 
;=============================================================================== 

;===============================================================================
; Hidden Palace Mappings 16x16 Delta  

;===============================================================================           
Map16Delta_HPz: ; loc_022B14: ; Hidden Palace 16x16 mappings used by dynamic reload sprites...  
        dc.w    $1710 ; Ram Address to start loading ($1710+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $0077 ; Number of words to load in Ram Array ($0000..$0077) -> move.w  (A0)+, d1
        dc.w    $62E8, $62E9, $62EA, $62EB, $62EC, $62ED, $62EE, $62EF
        dc.w    $62F0, $62F1, $62F2, $62F3, $62F4, $62F5, $62F6, $62F7
        dc.w    $62F8, $62F9, $62FA, $62FB, $62FC, $62FD, $62FE, $62FF
        dc.w    $42E8, $42E9, $42EA, $42EB, $42EC, $42ED, $42EE, $42EF
        dc.w    $42F0, $42F1, $42F2, $42F3, $42F4, $42F5, $42F6, $42F7
        dc.w    $42F8, $42F9, $42FA, $42FB, $42FC, $42FD, $42FE, $42FF
        dc.w    $0000, $62E8, $0000, $62EA, $62E9, $62EC, $62EB, $62EE
        dc.w    $62ED, $0000, $62EF, $0000, $0000, $62F0, $0000, $62F2
        dc.w    $62F1, $62F4, $62F3, $62F6, $62F5, $0000, $62F7, $0000
        dc.w    $0000, $62F8, $0000, $62FA, $62F9, $62FC, $62FB, $62FE
        dc.w    $62FD, $0000, $62FF, $0000, $0000, $42E8, $0000, $42EA
        dc.w    $42E9, $42EC, $42EB, $42EE, $42ED, $0000, $42EF, $0000
        dc.w    $0000, $42F0, $0000, $42F2, $42F1, $42F4, $42F3, $42F6
        dc.w    $42F5, $0000, $42F7, $0000, $0000, $42F8, $0000, $42FA
        dc.w    $42F9, $42FC, $42FB, $42FE, $42FD, $0000, $42FF, $0000
;===============================================================================
; Hidden Palace Mappings 16x16 Delta  
; 
;===============================================================================  

;===============================================================================
; Oil Ocean Mappings 16x16 Delta  

;===============================================================================          
Map16Delta_OOz: ; loc_022C08: ; Oil Ocean 16x16 mappings used by dynamic reload sprites...        
        dc.w    $17A0 ; Ram Address to start loading ($17A0+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $002F ; Number of words to load in Ram Array ($0000..$002F) -> move.w  (A0)+, d1
        dc.w    $82D0, $82D2, $82D1, $82D3, $E2D4, $E2D5, $E2D6, $E2D7
        dc.w    $0000, $62D8, $0000, $62DA, $62D9, $0000, $62DB, $0000
        dc.w    $C2DC, $C2DD, $C2E4, $C2E5, $C2DE, $C2DF, $C2E6, $C2E7
        dc.w    $C2E0, $C2E1, $C2E8, $C2E9, $C2E2, $C2E3, $C2EA, $C2EB
        dc.w    $C2EC, $C2ED, $C2F4, $C2F5, $C2EE, $C2EF, $C2F6, $C2F7
        dc.w    $C2F0, $C2F1, $C2F8, $C2F9, $C2F2, $C2F3, $C2FA, $C2FB
;===============================================================================
; Oil Ocean Mappings 16x16 Delta  
; 
;===============================================================================   

;===============================================================================
; Casino Night Mappings 16x16 Delta  

;===============================================================================           
Map16Delta_CNz: ; loc_022C6C: ; Casino Night 16x16 mappings used by dynamic reload sprites...  
        dc.w    $1760 ; Ram Address to start loading ($1760+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $004F ; Number of words to load in Ram Array ($0000..$004F) -> move.w  (A0)+, d1
        dc.w    $43D2, $43D4, $43D3, $43D5, $4BD4, $43D6, $4BD5, $43D7
        dc.w    $53D3, $53D5, $53D2, $53D4, $5BD5, $5BD3, $5BD4, $5BD2
        dc.w    $43D8, $43DA, $43D9, $43DB, $4BDA, $4BD8, $4BDB, $4BD9
        dc.w    $43DC, $43DE, $43DD, $43DF, $4BDE, $4BDC, $4BDF, $4BDD
        dc.w    $43E0, $43E2, $43E1, $43E3, $4BE2, $4BE0, $4BE3, $4BE1
        dc.w    $43E4, $43E6, $43E5, $43E7, $4BE6, $4BE4, $4BE7, $4BE5
        dc.w    $63E8, $63EA, $63E9, $63EB, $63EC, $63EE, $63ED, $63EF
        dc.w    $63F0, $63F2, $63F1, $63F3, $63F4, $63F6, $63F5, $63F7
        dc.w    $7BF7, $7BF5, $7BF6, $7BF4, $63F8, $63FA, $63F9, $63FB
        dc.w    $6BF6, $6BF4, $6BF7, $6BF5, $7BEB, $7BE9, $7BEA, $7BE8
;===============================================================================
; Casino Night Mappings 16x16 Delta  
; 
;===============================================================================   

;===============================================================================
; Chemical Plant Mappings 16x16 Delta  

;===============================================================================         
Map16Delta_CPz: ; loc_022D10: ; Chemical Plant 16x16 mappings used by dynamic reload sprites...
        dc.w    $17F8 ; Ram Address to start loading ($17F8+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $0003 ; Number of words to load in Ram Array ($0000..$0003) -> move.w  (A0)+, d1
        dc.w    $4370, $4371, $4370, $4371
;===============================================================================
; Chemical Plant Mappings 16x16 Delta  
; 
;===============================================================================  

;===============================================================================
; Neo Green Hill Mappings 16x16 Delta  

;===============================================================================  
Map16Delta_NGHz: ; loc_022D1C: ; Neo Green Hill 16x16 mappings used by dynamic reload sprites...               
        dc.w    $17C0 ; Ram Address to start loading ($17C0+Block_Table)      -> adda.w  (A0)+, A1
        dc.w    $001F ; Number of words to load in Ram Array ($0000..$001F) -> move.w  (A0)+, d1
        dc.w    $C3F0, $C3F1, $C3F2, $C3F3, $C3F4, $C3F5, $C3F6, $C3F7
        dc.w    $C3F8, $C3F9, $C3FA, $C3FB, $C3FC, $C3FD, $C3FE, $C3FF
        dc.w    $43F0, $43F1, $43F2, $43F3, $43F4, $43F5, $43F6, $43F7
        dc.w    $43F8, $43F9, $43FA, $43FB, $43FC, $43FD, $43FE, $43FF
;===============================================================================
; Neo Green Hill Mappings 16x16 Delta  
; 
;===============================================================================
          
;===============================================================================
; Null Mappings 16x16 Delta  

;=============================================================================== 
Map16Delta_Null: ; loc_022D60:
        dc.w    $0000 ; Null
;===============================================================================
; Null Mappings 16x16 Delta  
; 
;===============================================================================         
        
loc_022D62: ; Load Hill Top 8x8 Extra Background Tiles In To Ram               
        lea     (Hill_Top_Background), A0 ; loc_028300
        lea     ($FFFFB800).w, A4
        bsr     loc_022DF4
        lea     ($FFFFB800).w, A1
        lea     (loc_022D94), A4
        moveq   #0, D2
        moveq   #$2F, d3
loc_022D7E:
        moveq   #$FFFFFFFF, d0
        move.w  (A4)+, D0
        move.l  d0, a2
        moveq   #$1F, d1
loc_022D86:
        move.l  (A1), (A2)+
        move.l  D2, (A1)+
        dbra    d1, loc_022D86
        dbra    d3, loc_022D7E
        rts  
loc_022D94:
        dc.w    $0080, $0280, $0380, $0580, $0600, $0880, $0980, $0A80
        dc.w    $0B80, $0C80, $0E80, $0F00, $1080, $1180, $1200, $1280
        dc.w    $1300, $1380, $1400, $1480, $1500, $1600, $1900, $1D00
        dc.w    $1D80, $1E00, $2280, $2400, $2580, $2600, $2680, $2780
        dc.w    $2B00, $3280, $3600, $3680, $3C80, $3D00, $3F00, $3F80
        dc.w    $4080, $4480, $4580, $4880, $4900, $4B80, $4C80, $4D80
loc_022DF4:
        jmp     NemesisDec_ToRAM        ; loc_00160E 
        dc.w    $0000 ; Filler    
Obj21_Head_Up_Display: ; loc_022DFC:
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  loc_022E0A(pc,d0), d1
        jmp     loc_022E0A(pc,d1)
loc_022E0A:
        dc.w    loc_022E0E-loc_022E0A
        dc.w    loc_022E3C-loc_022E0A
loc_022E0E:
        addq.b  #2,routine(a0)
        move.w  #$090, x_pos(a0)
        move.w  #$108, $000A(a0)
        move.l  #Head_Up_Display_Mappings,mappings(a0) ; loc_022E80
        move.w  #$6CA,art_tile(a0)
        bsr     J_ModifySpriteAttr_2P_27 ; loc_023B68
        move.b  #0,render_flags(a0)
        move.b  #0, $0018(a0)
loc_022E3C:
        tst.w   (Ring_count).w
        beq.s   loc_022E60
        moveq	#0,d0
        btst    #3, ($FFFFFE05).w
        bne.s   loc_022E56
        cmpi.b  #$9, (Timer_minute).w
        bne.s   loc_022E56
        addq.w  #$2, d0
loc_022E56:
        move.b  d0, $001A(a0)
        jmp     DisplaySprite           ; loc_00D3C2
loc_022E60:
        moveq	#0,d0
        btst    #3, ($FFFFFE05).w
        bne.s   loc_022E76
        addq.w  #1,d0
        cmpi.b  #$9, (Timer_minute).w
        bne.s   loc_022E76
        addq.w  #$2, d0
loc_022E76:
        move.b  d0, $001A(a0)
        jmp     DisplaySprite           ; loc_00D3C2  
Head_Up_Display_Mappings: ; loc_022E80:
        dc.w    HUD_Map_01-Head_Up_Display_Mappings
        dc.w    HUD_Map_02-Head_Up_Display_Mappings
        dc.w    HUD_Map_03-Head_Up_Display_Mappings 
        dc.w    HUD_Map_04-Head_Up_Display_Mappings
HUD_Map_01: ; loc_022E88:
        dc.w    $000A
        dc.l    $800DA000, $A0000000, $800DA018, $A00C0020
        dc.l    $800DA020, $A0100040, $900DA010, $A0080000
        dc.l    $900DA028, $A0140028, $A00DA008, $A0040000
        dc.l    $A001A000, $A0000020, $A009A030, $A0180030
        dc.l    $4005810A, $80850000, $400DA10E, $A0870010
HUD_Map_02: ; loc_022EDA:        
        dc.w    $000A
        dc.l    $800DA000, $A0000000, $800DA018, $A00C0020
        dc.l    $800DA020, $A0100040, $900DA010, $A0080000
        dc.l    $900DA028, $A0140028, $A00D8008, $80040000
        dc.l    $A0018000, $80000020, $A009A030, $A0180030
        dc.l    $4005810A, $80850000, $400DA10E, $A0870010
HUD_Map_03: ; loc_022F2C:
        dc.w    $000A   
        dc.l    $800DA000, $A0000000, $800DA018, $A00C0020
        dc.l    $800DA020, $A0100040, $900D8010, $80080000
        dc.l    $900DA028, $A0140028, $A00DA008, $A0040000
        dc.l    $A001A000, $A0000020, $A009A030, $A0180030
        dc.l    $4005810A, $80850000, $400DA10E, $A0870010  
HUD_Map_04: ; loc_022F7E:               
        dc.w    $000A             
        dc.l    $800DA000, $A0000000, $800DA018, $A00C0020
        dc.l    $800DA020, $A0100040, $900D8010, $80080000
        dc.l    $900DA028, $A0140028, $A00D8008, $80040000
        dc.l    $A0018000, $80000020, $A009A030, $A0180030
        dc.l    $4005810A, $80850000, $400DA10E, $A0870010
;===============================================================================
; AddPoints - Sub-routine
              
;===============================================================================        
AddPoints: ; loc_022FD0:
        move.b  #1, (Update_HUD_Score).w
        lea     (Score).w, A3
        add.l   d0, (a3)
        move.l  #$00F423F, d1
        cmp.l   (A3), d1  
        bhi.s   loc_022FE8
        move.l  d1, (a3)
loc_022FE8:
        move.l  (A3), D0
        cmp.l   ($FFFFFFC0).w, d0
        bcs.s   loc_023010
        addi.l  #$0001388, ($FFFFFFC0).w
        tst.b   (Graphics_Flags).w
        bmi.s   loc_023010
        addq.b  #1, ($FFFFFE12).w
        addq.b  #1, (Update_HUD_lives).w
        move.w  #$088, d0           ; +1UP Sound - Sonic 1 LeftOver
        jmp     (Play_Music)            ; loc_0014C0
loc_023010:
        rts
HudUpdate: ; loc_023012:
        nop
        lea     ($00C00000), a6
        tst.w   ($FFFFFFFA).w
        bne     loc_023104
        tst.b   (Update_HUD_Score).w
        beq.s   loc_02303A
        clr.b   (Update_HUD_Score).w
        move.l  #$5C800003, d0
        move.l  (Score).w, d1
        bsr     loc_023250
loc_02303A:
        tst.b   (Update_HUD_rings).w
        beq.s   loc_02305A
        bpl.s   loc_023046
        bsr     loc_023170
loc_023046:
        clr.b   (Update_HUD_rings).w
        move.l  #$5F400003, d0
loc_023050:        
        moveq   #0,d1
        move.w  (Ring_count).w, d1
        bsr     loc_023246
loc_02305A:
        tst.b   (Update_HUD_timer).w
        beq.s   loc_0230B6 
        tst.w   (Game_paused).w
        bne.s   loc_0230B6
        lea     ($FFFFFE22).w, A1
        cmpi.l  #$0093B3B, (A1)+
        nop
        addq.b  #1, -(A1)
        cmpi.b  #$3C, (a1)
        bcs.s   loc_0230B6
        move.b  #0, (a1)
        addq.b  #1, -(A1)
        cmpi.b  #$3C, (a1)
        bcs.s   loc_023096
        move.b  #0, (a1)
        addq.b  #1, -(A1)
        cmpi.b  #$9, (a1)
        bcs.s   loc_023096
        move.b  #$9, (a1)
loc_023096:
        move.l  #$5E400003, d0
        moveq   #0,d1
        move.b  (Timer_minute).w, d1
        bsr     loc_02331E
        move.l  #$5EC00003, d0
        moveq   #0,d1
        move.b  (Timer_second).w, d1
        bsr     loc_023326
loc_0230B6:        
        tst.b   (Update_HUD_lives).w
        beq.s   loc_0230C4
        clr.b   (Update_HUD_lives).w
        bsr     loc_0233DE
loc_0230C4:
        tst.b   ($FFFFF7D6).w
        beq.s   loc_0230EC
        clr.b   ($FFFFF7D6).w
        move.l  #$6E000002, ($00C00004)
        moveq   #0,d1
        move.w  ($FFFFF7D2).w, d1
        bsr     loc_02337E
        moveq   #0,d1
        move.w  ($FFFFF7D4).w, d1
        bsr     loc_02337E
loc_0230EC:              
        rts  
Sub_Time_Over: ; loc_0230EE:
        clr.b   (Update_HUD_timer).w
        lea     (MainCharacter).w, A0
        move.l  A0, a2
        bsr     KillSonic               ; loc_021422
        move.b  #1, ($FFFFFE1A).w
        rts        
loc_023104:
        bsr     loc_0231DC
        tst.b   (Update_HUD_rings).w
        beq.s   loc_023128
        bpl.s   loc_023114
        bsr     loc_023170
loc_023114:
        clr.b   (Update_HUD_rings).w
        move.l  #$5F400003, d0
        moveq   #0,d1
        move.w  (Ring_count).w, d1
        bsr     loc_023246
loc_023128:
        move.l  #$5EC00003, d0
        moveq   #0,d1
        move.b  ($FFFFF62C).w, d1
        bsr     loc_023326
        tst.b   (Update_HUD_lives).w
        beq.s   loc_023146
        clr.b   (Update_HUD_lives).w
        bsr     loc_0233DE
loc_023146:
        tst.b   ($FFFFF7D6).w
        beq.s   loc_02316E
        clr.b   ($FFFFF7D6).w   
        move.l  #$6E000002, ($00C00004)
        moveq   #0,d1
        move.w  ($FFFFF7D2).w, d1
        bsr     loc_02337E
        moveq   #0,d1
        move.w  ($FFFFF7D4).w, d1
        bsr     loc_02337E
loc_02316E:        
        rts
loc_023170:
        move.l  #$5F400003, ($00C00004)
        lea     loc_0231D8(PC), A2
        move.w  #$002, D2
        bra.s   loc_0231A0
Head_Up_Display_Base: ; loc_023184: ; HUD routine               
        lea     ($00C00000), a6
        bsr     loc_0233DE
        move.l  #$5C400003, ($00C00004)
        lea     loc_0231CC(PC), A2
        move.w  #$00E, D2
loc_0231A0:
        lea     loc_023448(PC), A1
loc_0231A4:        
        move.w  #$F, d1
        move.b  (A2)+, D0
        bmi.s   loc_0231C0  
        ext.w   D0
        lsl.w   #5, d0
        lea     $00(A1, d0), A3           
loc_0231B4:
        move.l  (A3)+, (a6)
        dbra    d1, loc_0231B4
loc_0231BA:        
        dbra    D2, loc_0231A4
        rts 
loc_0231C0:
        move.l  #$0000000, (a6)
        dbra    d1, loc_0231C0
        bra.s   loc_0231BA            
loc_0231CC:
        dc.l    $16FFFFFF, $FFFFFF00, $00140000
loc_0231D8:
        dc.l    $FFFF0000
loc_0231DC:
        move.l  #$5C400003, ($00C00004)
        move.w  ($FFFFEE00).w, d1
        lsr.w   #7, d1
        move.w  ($FFFFFE04).w, d1
        lsr.w   #6, d1
        swap.w  d1
        move.w  (MainCharacter+x_pos).w, d1 
        bsr.s   loc_02320E
        move.w  ($FFFFEE04).w, d1
        move.w  ($FFFFEE08).w, d1
        lsr.w   #7, d1
        move.b  ($FFFFFE78).w, d1
        swap.w  d1
        move.w  ($FFFFB00C).w, d1
loc_02320E:
        moveq   #$7, D6
        lea     (loc_023888), A1
loc_023216:        
        rol.w   #4, d1
        move.w  d1, D2
        andi.w  #$F, D2
        cmpi.w  #$00A, D2
        bcs.s   loc_023228
        addi.w  #$007, D2
loc_023228:
        lsl.w   #5, D2
        lea     $00(A1, D2), A3
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        swap.w  d1
        dbra    d6, loc_023216
        rts
loc_023246:
        lea     (loc_023312), A2
        moveq   #$2, D6
        bra.s   loc_023258
loc_023250:
        lea     (loc_023306), A2
        moveq   #5, D6
loc_023258:
        moveq   #0, D4
        lea     loc_023448(PC), A1
loc_02325E:        
        moveq   #0, D2
        move.l  (A2)+, D3
loc_023262:        
        sub.l   d3, d1
        bcs.s   loc_02326A
        addq.w  #1, D2
        bra.s   loc_023262
loc_02326A:
        add.l   d3, d1
        tst.w   D2
        beq.s   loc_023274
        move.w  #$001, D4
loc_023274:
        tst.w   D4
        beq.s   loc_0232A2
        lsl.w   #6, D2
        move.l  d0, mappings(a6)
        lea     $00(A1, D2), A3
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
loc_0232A2:        
        addi.l  #$400000, d0
        dbra    d6, loc_02325E
        rts 
; loc_0232AE:
        move.l  #$5F800003, ($00C00004)
        lea     ($00C00000), a6
        lea     (loc_023316), A2
        moveq   #1, D6
        moveq   #0, D4
        lea     loc_023448(PC), A1
loc_0232CC:        
        moveq   #0, D2
        move.l  (A2)+, D3
loc_0232D0:        
        sub.l   d3, d1
        bcs.s   loc_0232D8
        addq.w  #1, D2
        bra.s   loc_0232D0
loc_0232D8:
        add.l   d3, d1
        lsl.w   #6, D2
        lea     $00(A1, D2), A3
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        dbra    d6, loc_0232CC
        rts           
loc_023306:
        dc.l    $000186A0
;loc_02330A:        
        dc.l    $00002710
loc_02330E:        
        dc.l    $000003E8
loc_023312:         
        dc.l    $00000064
loc_023316:
        dc.l    $0000000A 
loc_02331A:
        dc.l    $00000001                  
loc_02331E: 
        lea     loc_02331A(PC), A2 
        moveq   #0, D6
        bra.s   loc_02332C
loc_023326:        
        lea     loc_023316(PC), A2  
        moveq   #1, D6
loc_02332C:        
        moveq   #0, D4 
        lea     loc_023448(PC), A1
loc_023332:        
        moveq   #0, D2
        move.l  (A2)+, D3
loc_023336:        
        sub.l   d3, d1
        bcs.s   loc_02333E
        addq.w  #1, D2
        bra.s   loc_023336
loc_02333E:              
        add.l   d3, d1
        tst.w   D2
        beq.s   loc_023348
        move.w  #$001, D4
loc_023348:
        lsl.w   #6, D2
        move.l  d0, mappings(a6)
        lea     $00(A1, D2), A3
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        addi.l  #$400000, d0
        dbra    d6, loc_023332
        rts   
loc_02337E:           
        lea     loc_02330E(PC), A2 
        moveq   #3, D6
        moveq   #0, D4
        lea     loc_023448(PC), A1
loc_02338A:        
        moveq   #0, D2
        move.l  (A2)+, D3
loc_02338E:        
        sub.l   d3, d1
        bcs.s   loc_023396
        addq.w  #1, D2
        bra.s   loc_02338E 
loc_023396:
        add.l   d3, d1
        tst.w   D2
        beq.s   loc_0233A0
        move.w  #$001, D4          
loc_0233A0:
        tst.w   D4
        beq.s   loc_0233D0
        lsl.w   #6, D2
        lea     $00(A1, D2), A3        
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
loc_0233CA:        
        dbra    d6, loc_02338A
        rts   
loc_0233D0:
        moveq   #$F,d5
loc_0233D2:        
        move.l  #$0000000, (a6)
        dbra    d5, loc_0233D2
        bra.s   loc_0233CA              
loc_0233DE:
        move.l  #$7BA00003, d0
        moveq   #0,d1
        move.b  ($FFFFFE12).w, d1
        lea     loc_023316(PC), A2               
        moveq   #1, D6
        moveq   #0, D4
        lea     loc_023748(PC), A1
loc_0233F6:        
        move.l  d0, mappings(a6)
        moveq   #0, D2
        move.l  (A2)+, D3
loc_0233FE:        
        sub.l   d3, d1
        bcs.s   loc_023406
        addq.w  #1, D2
        bra.s   loc_0233FE
loc_023406:
        add.l   d3, d1
        tst.w   D2
        beq.s   loc_023410
        move.w  #$001, D4
loc_023410:
        tst.w   D4
        beq.s   loc_023436
loc_023414:        
        lsl.w   #5, D2
        lea     $00(A1, D2), A3
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
        move.l  (A3)+, (a6)
loc_02342A:
        addi.l  #$400000, d0
        dbra    d6, loc_0233F6
        rts
loc_023436:
        tst.w   D6
        beq.s   loc_023414
        moveq   #$7,d5
loc_02343C:        
        move.l  #$0000000, (a6)
        dbra    d5, loc_02343C
        bra.s   loc_02342A                     
loc_023448:  
        incbin  'data\sprites\bignumbr.dat' 
loc_023748:        
        incbin  'data\sprites\smallnum.dat'             
loc_023888:
        incbin  'data\sprites\debugnum.dat'
J_ModifySpriteAttr_2P_27: ; loc_023B68:
        jmp     Adjust2PArtPointer     ; loc_00DC30
        dc.w    $0000           ; Filler
Debug_Mode: ; loc_023B70: ; Debug Mode Routine         
        moveq	#0,d0
        move.b  (Debug_placement_mode).w, d0
        move.w  loc_023B7E(pc,d0), d1
        jmp     loc_023B7E(pc,d1)
loc_023B7E:
        dc.w    loc_023B82-loc_023B7E
        dc.w    loc_023BEC-loc_023B7E
loc_023B82:
        addq.b  #$2, (Debug_placement_mode).w
        move.w  ($FFFFEECC).w, ($FFFFFEF0).w
        move.w  ($FFFFEEC6).w, ($FFFFFEF2).w
        andi.w  #$7FF, ($FFFFB00C).w
        andi.w  #$7FF, ($FFFFEE04).w
        andi.w  #$7FF, ($FFFFEE0C).w
        move.b  #0, $001A(a0)
        move.b  #0, $001C(a0)
        cmpi.b  #$10, (Game_Mode).w
        bne.s   loc_023BBC
        moveq   #6, d0
        bra.s   loc_023BC2
loc_023BBC:
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
loc_023BC2:
        lea     (Debug_Index), A2   ;loc_023DBE 
        add.w   d0, d0
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D6
        cmp.b   ($FFFFFE06).w, D6
        bhi.s   loc_023BDC
        move.b  #0, ($FFFFFE06).w
loc_023BDC:
        bsr     loc_023D9E
        move.b  #$C, ($FFFFFE0A).w
        move.b  #1, ($FFFFFE0B).w
loc_023BEC:
        moveq   #6, d0
        cmpi.b  #$10, (Game_Mode).w
        beq.s   loc_023BFC
        moveq	#0,d0
        move.b  (Current_Zone).w, d0
loc_023BFC:
        lea     (Debug_Index), A2 ; loc_023DBE
        add.w   d0, d0
        adda.w  $00(A2, d0), A2
        move.w  (A2)+, D6
        bsr     loc_023C14
        jmp     DisplaySprite           ; (loc_00D3C2)
loc_023C14:
        moveq   #0, D4
        move.w  #$001, d1
        move.b  (Ctrl_1_Press).w, D4
        andi.w  #$F, D4
        bne.s   loc_023C56
        move.b  ($FFFFF604).w, d0
        andi.w  #$F, d0
        bne.s   loc_023C3E
        move.b  #$C, ($FFFFFE0A).w
        move.b  #$F, ($FFFFFE0B).w
        bra     loc_023CBA
loc_023C3E:
        subq.b  #1, ($FFFFFE0A).w
        bne.s   loc_023C5A
        move.b  #1, ($FFFFFE0A).w
        addq.b  #1, ($FFFFFE0B).w
        bne.s   loc_023C56
        move.b  #$FF, ($FFFFFE0B).w
loc_023C56:
        move.b  ($FFFFF604).w, D4
loc_023C5A:
        moveq   #0,d1
        move.b  ($FFFFFE0B).w, d1
        addq.w  #1,d1
        swap.w  d1
        asr.l   #4, d1
        move.l  y_pos(a0), D2
        move.l  x_pos(a0), D3
        btst    #0, D4
        beq.s   loc_023C84
        sub.l   d1, D2
        moveq	#0,d0
        move.w  ($FFFFEECC).w, d0
        swap.w  D0
        cmp.l   d0, D2
        bge.s   loc_023C84
        move.l  d0, D2
loc_023C84:
        btst    #1, D4
        beq.s   loc_023C9E
        add.l   d1, D2
        moveq	#0,d0
        move.w  ($FFFFEEC6).w, d0
        addi.w  #$0DF, d0
        swap.w  D0
        cmp.l   d0, D2
        blt.s   loc_023C9E
        move.l  d0, D2
loc_023C9E:
        btst    #$2, D4
        beq.s   loc_023CAA
        sub.l   d1, d3
        bcc.s   loc_023CAA
        moveq   #0, d3
loc_023CAA:
        btst    #3, D4
        beq.s   loc_023CB2
        add.l   d1, d3
loc_023CB2:
        move.l  D2, y_pos(a0)
        move.l  d3, x_pos(a0)
loc_023CBA:
        btst    #6, ($FFFFF604).w
        beq.s   loc_023CF2
        btst    #5, (Ctrl_1_Press).w
        beq.s   loc_023CD6
        subq.b  #1, ($FFFFFE06).w
        bcc.s   loc_023CEE
        add.b   d6, ($FFFFFE06).w
        bra.s   loc_023CEE
loc_023CD6:
        btst    #6, (Ctrl_1_Press).w
        beq.s   loc_023CF2
        addq.b  #1, ($FFFFFE06).w
        cmp.b   ($FFFFFE06).w, D6
        bhi.s   loc_023CEE
        move.b  #0, ($FFFFFE06).w
loc_023CEE:
        bra     loc_023D9E
loc_023CF2:
        btst    #5, (Ctrl_1_Press).w
        beq.s   loc_023D36
        jsr     SingleObjectLoad        ; (loc_00E772)
        bne.s   loc_023D36
        move.w  x_pos(a0), x_pos(a1)
        move.w  y_pos(a0), y_pos(a1)
        move.b  mappings(A0), 0(a1)
        move.b  render_flags(A0), render_flags(a1)
        move.b  render_flags(A0), status(a1)
        andi.b  #$7F, status(a1)
        moveq	#0,d0
        move.b  ($FFFFFE06).w, d0
        lsl.w   #3, d0
        move.b  $04(A2, d0), subtype(a1)
        rts
loc_023D36:
        btst    #4, (Ctrl_1_Press).w
        beq.s   loc_023D9C
        moveq	#0,d0
        move.w  d0, (Debug_placement_mode).w
        move.l  #Sonic_Mappings, ($FFFFB004).w ; loc_0614C0
        move.w  #$780, ($FFFFB002).w
        tst.w   (Two_player_mode).w
        beq.s   loc_023D5E
        move.w  #$3C0, ($FFFFB002).w
loc_023D5E:
        move.b  d0, ($FFFFB01C).w
        move.w  d0, $000A(a0)
        move.w  d0, Objoff_E(a0)
        move.w  x_pos(a0), ($FFFFB048).w
        move.w  y_pos(a0), ($FFFFB04C).w
        move.w  ($FFFFFEF0).w, ($FFFFEECC).w
        move.w  ($FFFFFEF2).w, ($FFFFEEC6).w
        cmpi.b  #$10, (Game_Mode).w
        bne.s   loc_023D9C
        move.b  #$2, ($FFFFB01C).w
        bset    #$2, ($FFFFB022).w
        bset    #1, ($FFFFB022).w
loc_023D9C:
        rts
loc_023D9E:
        moveq	#0,d0
        move.b  ($FFFFFE06).w, d0
        lsl.w   #3, d0
        move.l  $00(A2, d0), mappings(a0)
        move.w  $06(A2, d0),art_tile(a0)
        move.b  $05(A2, d0), $001A(a0)
        bsr     J_ModifySpriteAttr_2P_28 ; loc_02434C
        rts
Debug_Index: ; loc_023DBE:          
        dc.w    Debug_GHz-Debug_Index   ; Green Hill
        dc.w    Debug_Null-Debug_Index  ; Null
        dc.w    Debug_Null-Debug_Index  ; Wood
        dc.w    Debug_Null-Debug_Index  ; Null
        dc.w    Debug_Mz-Debug_Index    ; Metropolis
        dc.w    Debug_Mz-Debug_Index    ; Metropolis
        dc.w    Debug_Null-Debug_Index  ; Null
        dc.w    Debug_HTz-Debug_Index   ; Hill Top
        dc.w    Debug_HPz-Debug_Index   ; Hidden Palace
        dc.w    Debug_Null-Debug_Index  ; Null
        dc.w    Debug_OOz-Debug_Index   ; Oil Ocean
        dc.w    Debug_DHz-Debug_Index   ; Dust Hill
        dc.w    Debug_CNz-Debug_Index   ; Casino Night
        dc.w    Debug_CPz-Debug_Index   ; Chemical Plant
        dc.w    Debug_Null-Debug_Index  ; Genocide City
        dc.w    Debug_NGHz-Debug_Index  ; Neo Green Hill
        dc.w    Debug_Null-Debug_Index  ; Death Egg
Debug_Null: ; loc_023DE0:  ; Null
        dc.w    $0002
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $00, $00, $06, $80
Debug_GHz: ; loc_023DF2:  ; Green Hill
        dc.w    $0012                  
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($79<<$18)|Lamp_Post_Mappings          ; loc_013D8E
        dc.b    $01, $00, $04, $7C
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($49<<$18)|Waterfall_Mappings          ; loc_015404
        dc.b    $00, $00, $23, $AE
        dc.l    ($49<<$18)|Waterfall_Mappings          ; loc_015404        
        dc.b    $02, $03, $23, $AE
        dc.l    ($49<<$18)|Waterfall_Mappings          ; loc_015404 
        dc.b    $04, $05, $23, $AE
        dc.l    ($18<<$18)|Ghz_Platform_Mappings       ; loc_009078
        dc.b    $01, $00, $40, $00
        dc.l    ($18<<$18)|Ghz_Platform_Mappings       ; loc_009078
        dc.b    $9A, $01, $40, $00
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $00, $00, $24, $34
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $81, $00, $04, $5C
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $90, $03, $04, $70
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $A0, $06, $04, $5C
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $30, $07, $04, $3C
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $40, $0A, $04, $3C
        dc.l    ($4B<<$18)|Buzz_Bomber_Mappings        ; loc_01EB0E
        dc.b    $00, $00, $03, $E6
        dc.l    ($54<<$18)|Motobug_Mappings            ; loc_01F938
        dc.b    $00, $00, $04, $02
        dc.l    ($53<<$18)|Chopper_Mappings            ; loc_01F696        
        dc.b    $00, $00, $04, $1C
        dc.l    ($4F<<$18)|Dinobot_Mappings            ; loc_01DFCA  ; Out of Pointers
        dc.b    $00, $00, $05, $00
        dc.l    ($52<<$18)|Piranha_Mappings            ; loc_01DE66  ; Out of Pointers
        dc.b    $00, $00, $25, $30
        dc.l    ($50<<$18)|Aquis_Mappings              ; loc_01E4E0  ; Out of Pointers
        dc.b    $00, $00, $25, $70
        dc.l    ($51<<$18)|Aquis_Mappings              ; loc_01E4E0  ; Out of Pointers
        dc.b    $00, $00, $25, $70
        dc.l    ($4D<<$18)|Rhinobot_Mappings           ; loc_01DAEE  ; Out of Pointers
        dc.b    $00, $00, $23, $C4
        dc.l    ($4B<<$18)|Buzz_Bomber_Mappings        ; loc_01EB0E  ; Out of Pointers
        dc.b    $00, $00, $03, $2C
        dc.l    ($4E<<$18)|Crocobot_Mappings           ; loc_01F420  ; Out of Pointers
        dc.b    $00, $00, $23, $00
        dc.l    ($4C<<$18)|Batbot_Mappings             ; loc_01F106  ; Out of Pointers
        dc.b    $00, $00, $23, $50
        dc.l    ($4A<<$18)|Octus_Mappings              ; loc_01EDBC  ; Out of Pointers
        dc.b    $00, $00, $23, $8A
Debug_Mz: ; loc_023ECC:  ; Metropolis
        dc.w    $001C
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($79<<$18)|Lamp_Post_Mappings          ; loc_013D8E
        dc.b    $01, $00, $04, $7C
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($42<<$18)|Steam_Vent_Mappings         ; loc_01A7FE         
        dc.b    $01, $07, $60, $00
        dc.l    ($64<<$18)|Piston_Mappings             ; loc_01A9F0
        dc.b    $01, $00, $20, $00
        dc.l    ($64<<$18)|Piston_Mappings             ; loc_01A9F0
        dc.b    $11, $01, $20, $00
        dc.l    ($65<<$18)|Mz_Platform_Mappings        ; loc_01AE2C
        dc.b    $80, $00, $60, $00
        dc.l    ($65<<$18)|Mz_Platform_Mappings        ; loc_01AE2C
        dc.b    $13, $01, $60, $00
        dc.l    ($47<<$18)|Switch_Mappings             ; loc_018E3E
        dc.b    $00, $02, $04, $24
        dc.l    ($2D<<$18)|Automatic_Door_Mappings     ; loc_009E1E
        dc.b    $01, $01, $60, $00
        dc.l    ($66<<$18)|Spring_Wall_Mappings        ; loc_01B084
        dc.b    $01, $00, $86, $80
        dc.l    ($66<<$18)|Spring_Wall_Mappings        ; loc_01B084
        dc.b    $11, $01, $86, $80
        dc.l    ($68<<$18)|Block_Arrow_Mappings        ; loc_01B6DC
        dc.b    $00, $04, $64, $14
        dc.l    ($69<<$18)|Screw_Nut_Mappings          ; loc_01B9A6
        dc.b    $04, $00, $25, $00
        dc.l    ($6A<<$18)|Mz_Platform_Mappings        ; loc_01AE2C
        dc.b    $00, $01, $60, $00
        dc.l    ($6B<<$18)|Mz_Platform_Mappings        ; loc_01AE2C
        dc.b    $01, $01, $60, $00
        dc.l    ($6D<<$18)|Block_Arrow_Mappings        ; loc_01B6DC
        dc.b    $00, $00, $24, $1C
        dc.l    ($6E<<$18)|Machine_Mappings            ; loc_01C464
        dc.b    $00, $00, $60, $00
        dc.l    ($6E<<$18)|Machine_Mappings            ; loc_01C464
        dc.b    $10, $01, $60, $00
        dc.l    ($6E<<$18)|Machine_Mappings            ; loc_01C464
        dc.b    $20, $02, $60, $00
        dc.l    ($6F<<$18)|Parallelogram_Elevator_Mappings ; loc_01C7BE
        dc.b    $00, $00, $65, $3F
        dc.l    ($70<<$18)|Rotating_Gears_Mappings     ; loc_01CA16
        dc.b    $10, $00, $E3, $78
        dc.l    ($71<<$18)|Lava_Bubble_Mappings        ; loc_009BBE
        dc.b    $22, $05, $45, $36
        dc.l    ($1C<<$18)|loc_009B9A
        dc.b    $00, $00, $43, $FD
        dc.l    ($1C<<$18)|loc_009B9A
        dc.b    $01, $01, $43, $FD
        dc.l    ($1C<<$18)|loc_009B9A
        dc.b    $03, $02, $23, $FD
        dc.l    ($65<<$18)|Mz_Platform_Mappings        ; loc_01AE2C
        dc.b    $B0, $00, $60, $00
Debug_HTz: ; loc_023FAE:  ; Hill Top
        dc.w    $0019
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($79<<$18)|Lamp_Post_Mappings          ; loc_013D8E
        dc.b    $01, $00, $04, $7C
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($18<<$18)|Ghz_Platform_Mappings       ; loc_009078            
        dc.b    $01, $00, $40, $00
        dc.l    ($18<<$18)|Ghz_Platform_Mappings       ; loc_009078  
        dc.b    $9A, $01, $40, $00
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $00, $00, $24, $34
        dc.l    ($14<<$18)|See_Saw_Mappings            ; loc_015F54
        dc.b    $00, $00, $03, $C6
        dc.l    ($2D<<$18)|Automatic_Door_Mappings     ; loc_009E1E
        dc.b    $00, $00, $24, $26
        dc.l    ($2F<<$18)|Breakable_Floor_Mappings    ; loc_01786A
        dc.b    $00, $00, $C0, $00
        dc.l    ($20<<$18)|Fireball_Mappings           ; loc_0173D0
        dc.b    $44, $02, $84, $16           
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $81, $00, $04, $5C          
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $90, $03, $04, $70          
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $A0, $06, $04, $5C             
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $30, $07, $04, $3C            
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $40, $0A, $04, $3C
        dc.l    ($16<<$18)|Teleferics_Mappings         ; loc_01611E
        dc.b    $00, $00, $43, $E6
        dc.l    ($1C<<$18)|Teleferics_Mappings         ; loc_01611E
        dc.b    $04, $03, $43, $E6
        dc.l    ($1C<<$18)|Teleferics_Mappings         ; loc_01611E
        dc.b    $05, $04, $43, $E6
        dc.l    ($1C<<$18)|loc_009B3A
        dc.b    $07, $00, $40, $00
        dc.l    ($1C<<$18)|loc_009B3A
        dc.b    $08, $01, $40, $00
        dc.l    ($32<<$18)|Rock_Mappings               ; loc_0179C2
        dc.b    $00, $00, $43, $B2
        dc.l    ($31<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $00, $00, $86, $80
        dc.l    ($31<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $01, $01, $86, $80
        dc.l    ($31<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $02, $02, $86, $80
Debug_HPz: ; loc_024078:  ; Hidden Palace
        dc.w    $0008
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($71<<$18)|Hpz_Orbs_Mappings           ; loc_009AFA
        dc.b    $11, $03, $E3, $5A
        dc.l    ($13<<$18)|Hpz_Waterfalls_Mappings     ; loc_014CF4
        dc.b    $04, $04, $E3, $15
        dc.l    ($1A<<$18)|HPz_Collapsing_Platforms_Mappings ; loc_009858
        dc.b    $00, $00, $43, $4A
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($4F<<$18)|Dinobot_Mappings            ; loc_01DFCA  
        dc.b    $00, $00, $05, $00
        dc.l    ($4C<<$18)|Batbot_Mappings             ; loc_01F106  
        dc.b    $00, $00, $25, $30
        dc.l    ($52<<$18)|Piranha_Mappings            ; loc_01DE66  ; Out of Pointers
        dc.b    $00, $00, $25, $30
        dc.l    ($50<<$18)|Aquis_Mappings              ; loc_01E4E0  ; Out of Pointers
        dc.b    $00, $00, $25, $70
        dc.l    ($51<<$18)|Aquis_Mappings              ; loc_01E4E0  ; Out of Pointers
        dc.b    $00, $00, $25, $70         
        dc.l    ($4D<<$18)|Rhinobot_Mappings           ; loc_01DAEE  ; Out of Pointers
        dc.b    $00, $00, $23, $C4           
        dc.l    ($4B<<$18)|Buzz_Bomber_Mappings        ; loc_01EB0E  ; Out of Pointers
        dc.b    $00, $00, $03, $2C          
        dc.l    ($4E<<$18)|Crocobot_Mappings           ; loc_01F420  ; Out of Pointers
        dc.b    $00, $00, $23, $00          
        dc.l    ($4A<<$18)|Octus_Mappings              ; loc_01EDBC  ; Out of Pointers
        dc.b    $00, $00, $23, $8A
Debug_OOz: ; loc_0240F2:  ; Oil Ocean
        dc.w    $0010
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($33<<$18)|Touch_Booster_Mappings      ; loc_017EE2
        dc.b    $01, $00, $63, $2C
        dc.l    ($43<<$18)|Giant_Spikeball_Mappings    ; loc_01808E
        dc.b    $00, $00, $C3, $0C
        dc.l    ($19<<$18)|Elevator_Mappings           ; loc_016412
        dc.b    $23, $02, $63, $00
        dc.l    ($45<<$18)|Spring_Push_Boost_Mappings  ; loc_0185C2
        dc.b    $02, $00, $43, $C5
        dc.l    ($45<<$18)|Spring_Push_Boost_Mappings  ; loc_0185C2
        dc.b    $12, $0A, $43, $C5
        dc.l    ($46<<$18)|Spring_Ball_Mappings        ; loc_018CFA
        dc.b    $00, $01, $63, $54 
        dc.l    ($47<<$18)|Switch_Mappings             ; loc_018E3E
        dc.b    $00, $02, $04, $24
        dc.l    ($15<<$18)|Swing_Platforms_Mappings    ; loc_008AD8
        dc.b    $88, $01, $43, $E3
        dc.l    ($3D<<$18)|Break_Boost_Mappings        ; loc_01916E
        dc.b    $00, $00, $63, $32
        dc.l    ($48<<$18)|Cannon_Mappings             ; loc_0194CA
        dc.b    $80, $00, $63, $68
        dc.l    ($48<<$18)|Cannon_Mappings             ; loc_0194CA
        dc.b    $81, $01, $63, $68
        dc.l    ($48<<$18)|Cannon_Mappings             ; loc_0194CA
        dc.b    $82, $02, $63, $68
        dc.l    ($48<<$18)|Cannon_Mappings             ; loc_0194CA
        dc.b    $83, $03, $63, $68
        dc.l    ($1F<<$18)|OOz_Collapsing_Platforms_Mappings ; loc_009902
        dc.b    $00, $00, $63, $9D
        dc.l    ($1C<<$18)|loc_009B6A                      ; Out of Pointers
        dc.b    $0A, $00, $43, $46
        dc.l    ($1C<<$18)|loc_009B6A                      ; Out of Pointers
        dc.b    $0B, $01, $43, $46
        dc.l    ($1C<<$18)|loc_009B6A                      ; Out of Pointers
        dc.b    $0C, $02, $43, $46
        dc.l    ($1C<<$18)|loc_009B6A                      ; Out of Pointers
        dc.b    $0D, $03, $43, $46
Debug_DHz: ; loc_024194:  ; Dust Hill
        dc.w    $0010
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $00, $00, $06, $80
        dc.l    ($15<<$18)|DhzPlatformsMappings ; loc_008B46
        dc.b    $48, $02, $00, $00
        dc.l    ($1F<<$18)|Dhz_Collapsing_Platforms_Mappings ; loc_009942
        dc.b    $00, $00, $63, $F4
        dc.l    ($73<<$18)|Rotating_Rings_Mappings     ; loc_01CE1C
        dc.b    $F5, $00, $26, $BC
        dc.l    ($6A<<$18)|Rotating_Boxes_Mappings     ; loc_01BCB0
        dc.b    $18, $00, $63, $D4
        dc.l    ($2A<<$18)|Up_Down_Pillar_Mappings     ; loc_009CAE
        dc.b    $00, $00, $40, $00
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $00, $00, $24, $34
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $40, $04, $24, $34
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $81, $00, $04, $5C
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $90, $03, $04, $70
        dc.l    ($40<<$18)|Diagonal_Spring_Mappings    ; loc_01A58A
        dc.b    $01, $00, $04, $40
        dc.l    ($74<<$18)|Invisible_Block_Mappings    ; loc_0156B2
        dc.b    $11, $00, $86, $80
        dc.l    ($75<<$18)|Spikeball_Chain_Mappings    ; loc_01D00A
        dc.b    $18, $02, $20, $00
        dc.l    ($76<<$18)|Platform_Spikes_Mappings    ; loc_01D1BA
        dc.b    $00, $00, $00, $00
        dc.l    ($77<<$18)|Dhz_Bridge_Mappings         ; loc_01D2E0
        dc.b    $01, $00, $64, $3C
Debug_CNz: ; loc_024216:  ; Casino Night
        dc.w    $0002
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $00, $00, $06, $80
Debug_CPz: ; loc_024228:  ; Chemical Plant
        dc.w    $0013
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $07, $00, $06, $80
        dc.l    ($0B<<$18)|Open_Close_Platform_Mappings ; loc_014996
        dc.b    $70, $00, $E3, $B0
        dc.l    ($1B<<$18)|Speed_Booster_Mappings      ; loc_01658A
        dc.b    $00, $00, $E3, $9C
        dc.l    ($1D<<$18)|Worms_Mappings              ; loc_016702
        dc.b    $15, $00, $E4, $3C
        dc.l    ($19<<$18)|Elevator_Mappings           ; loc_016412
        dc.b    $06, $00, $63, $A0
        dc.l    ($2D<<$18)|Automatic_Door_Mappings     ; loc_009E1E
        dc.b    $02, $02, $23, $94
        dc.l    ($32<<$18)|Tunel_Obstacule_Mappings    ; loc_0179F6
        dc.b    $00, $00, $64, $30
        dc.l    ($6B<<$18)|Block_Mappings              ; loc_01BF4A
        dc.b    $10, $00, $64, $18
        dc.l    ($78<<$18)|Block_Mappings              ; loc_01BF4A
        dc.b    $00, $00, $64, $18        
        dc.l    ($7A<<$18)|Platform_Horizontal_Mappings ; loc_01D72C
        dc.b    $00, $00, $E4, $18
        dc.l    ($7B<<$18)|Spring_Tubes_Mappings       ; loc_01D920
        dc.b    $02, $00, $03, $E0
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $0D, $05, $26, $BC
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $00, $00, $24, $34
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $81, $00, $04, $5C  
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $90, $03, $04, $70                  
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $A0, $06, $04, $5C       
        dc.l    ($40<<$18)|Diagonal_Spring_Mappings    ; loc_01A58A
        dc.b    $01, $00, $04, $40
Debug_NGHz: ; loc_0242C2:  ; Neo Green Hill
        dc.w    $0011
        dc.l    ($25<<$18)|Rings_Mappings              ; loc_00B036
        dc.b    $00, $00, $26, $BC
        dc.l    ($26<<$18)|Monitors_Mappings           ; loc_00B6D2
        dc.b    $00, $00, $06, $80
        dc.l    ($15<<$18)|Nghz_Swing_Platforms_Mappings ; loc_008B0E
        dc.b    $88, $02, $00, $00
        dc.l    ($18<<$18)|Nghz_Platform_Mappings      ; loc_0090D0
        dc.b    $01, $00, $40, $00
        dc.l    ($18<<$18)|Nghz_Platform_Mappings      ; loc_0090D0
        dc.b    $9A, $01, $40, $00
        dc.l    ($22<<$18)|Arrow_Shooter_Mappings     ; loc_0197C6
        dc.b    $00, $01, $04, $17
        dc.l    ($23<<$18)|Pillar_Mappings             ; loc_0199AA
        dc.b    $00, $00, $20, $00
        dc.l    ($2B<<$18)|Breakable_Pillar_Mappings   ; loc_019C30
        dc.b    $00, $00, $20, $00
        dc.l    ($2C<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $00, $00, $86, $80
        dc.l    ($2C<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $01, $01, $86, $80
        dc.l    ($2C<<$18)|Lava_Attributes_Mappings    ; loc_015612
        dc.b    $02, $02, $86, $80
        dc.l    ($40<<$18)|Diagonal_Spring_Mappings    ; loc_01A58A
        dc.b    $01, $00, $04, $40          
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70          
        dc.b    $81, $00, $04, $5C          
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70          
        dc.b    $90, $03, $04, $70    
        dc.l    ($41<<$18)|Spring_Mappings             ; loc_00EF70
        dc.b    $A0, $06, $04, $5C    
        dc.l    ($03<<$18)|Layer_Switch_Mappings       ; loc_0147D0
        dc.b    $09, $01, $26, $BC
        dc.l    ($36<<$18)|Spike_Mappings              ; loc_00CBA0
        dc.b    $00, $00, $24, $34
J_ModifySpriteAttr_2P_28: ; loc_02434C:
        jmp     Adjust2PArtPointer     ; (loc_00DC30)
        dc.w    $0000           ; Filler
TilesMainTable: ; loc_024354:  
        dc.l    ($04<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $04 = Sprite Pointer in 0x024420 
        dc.l    ($05<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $05 = Sprite Pointer in 0x024420
        dc.l    ($04<<$18)|Green_Hill_128x128_Map ; loc_08692E $04 = Palette Pointer in 0x00294E
        dc.l    ($06<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $06 = Sprite Pointer in 0x024420 
        dc.l    ($07<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $07 = Sprite Pointer in 0x024420
        dc.l    ($05<<$18)|Green_Hill_128x128_Map ; loc_08692E $05 = Palette Pointer in 0x00294E
        dc.l    ($08<<$18)|Wood_8x8_Tiles         ; loc_08AB2E $08 = Sprite Pointer in 0x024420 
        dc.l    ($09<<$18)|Wood_16x16_Map         ; loc_089B8E $09 = Sprite Pointer in 0x024420
        dc.l    ($06<<$18)|Wood_128x128_Map       ; loc_08E826 $06 = Palette Pointer in 0x00294E
        dc.l    ($0A<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $0A = Sprite Pointer in 0x024420 
        dc.l    ($0B<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $0B = Sprite Pointer in 0x024420
        dc.l    ($07<<$18)|Green_Hill_128x128_Map ; loc_08692E $07 = Palette Pointer in 0x00294E
        dc.l    ($0C<<$18)|Metropolis_8x8_Tiles   ; loc_091716 $0C = Sprite Pointer in 0x024420 
        dc.l    ($0D<<$18)|Metropolis_16x16_Map   ; loc_090456 $0D = Sprite Pointer in 0x024420
        dc.l    ($08<<$18)|Metropolis_128x128_Map ; loc_094C56 $08 = Palette Pointer in 0x00294E
        dc.l    ($0C<<$18)|Metropolis_8x8_Tiles   ; loc_091716 $0C = Sprite Pointer in 0x024420 
        dc.l    ($0D<<$18)|Metropolis_16x16_Map   ; loc_090456 $0D = Sprite Pointer in 0x024420
        dc.l    ($08<<$18)|Metropolis_128x128_Map ; loc_094C56 $08 = Palette Pointer in 0x00294E
        dc.l    ($10<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $10 = Sprite Pointer in 0x024420 
        dc.l    ($11<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $11 = Sprite Pointer in 0x024420
        dc.l    ($0A<<$18)|Green_Hill_128x128_Map ; loc_08692E $0A = Palette Pointer in 0x00294E
        dc.l    ($12<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $12 = Sprite Pointer in 0x024420 
        dc.l    ($13<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $13 = Sprite Pointer in 0x024420
        dc.l    ($0B<<$18)|Green_Hill_128x128_Map ; loc_08692E $0B = Palette Pointer in 0x00294E
        dc.l    ($14<<$18)|Hidden_Palace_8x8_Tiles   ; loc_098B76 $14 = Sprite Pointer in 0x024420 
        dc.l    ($15<<$18)|Hidden_Palace_16x16_Map   ; loc_097596 $15 = Sprite Pointer in 0x024420
        dc.l    ($0C<<$18)|Hidden_Palace_128x128_Map ; loc_09B9F8 $0C = Palette Pointer in 0x00294E
        dc.l    ($16<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $16 = Sprite Pointer in 0x024420 
        dc.l    ($17<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $17 = Sprite Pointer in 0x024420
        dc.l    ($0D<<$18)|Green_Hill_128x128_Map ; loc_08692E $0D = Palette Pointer in 0x00294E
        dc.l    ($18<<$18)|Oil_Ocean_8x8_Tiles    ; loc_09ED58 $18 = Sprite Pointer in 0x024420 
        dc.l    ($19<<$18)|Oil_Ocean_16x16_Map    ; loc_09D778 $19 = Sprite Pointer in 0x024420
        dc.l    ($0E<<$18)|Oil_Ocean_128x128_Map  ; loc_0A1A58 $0E = Palette Pointer in 0x00294E
        dc.l    ($1A<<$18)|Dust_Hill_8x8_Tiles    ; loc_0A5248 $1A = Sprite Pointer in 0x024420 
        dc.l    ($1B<<$18)|Dust_Hill_16x16_Map    ; loc_0A3F88 $1B = Sprite Pointer in 0x024420
        dc.l    ($0F<<$18)|Dust_Hill_128x128_Map  ; loc_0A8B6A $0F = Palette Pointer in 0x00294E
        dc.l    ($1C<<$18)|Casino_Night_8x8_Tiles   ; loc_0ABF2A $1C = Sprite Pointer in 0x024420 
        dc.l    ($1D<<$18)|Casino_Night_16x16_Map   ; loc_0AB5CA $1D = Sprite Pointer in 0x024420
        dc.l    ($10<<$18)|Casino_Night_128x128_Map ; loc_0AF026 $10 = Palette Pointer in 0x00294E
        dc.l    ($1E<<$18)|Chemical_Plant_8x8_Tiles   ; loc_0B2506 $1E = Sprite Pointer in 0x024420 
        dc.l    ($1F<<$18)|Chemical_Plant_16x16_Map   ; loc_0B0F26 $1F = Sprite Pointer in 0x024420
        dc.l    ($11<<$18)|Chemical_Plant_128x128_Map ; loc_0B6058 $11 = Palette Pointer in 0x00294E
        dc.l    ($20<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $20 = Sprite Pointer in 0x024420 
        dc.l    ($21<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $21 = Sprite Pointer in 0x024420
        dc.l    ($12<<$18)|Green_Hill_128x128_Map ; loc_08692E $12 = Palette Pointer in 0x00294E
        dc.l    ($22<<$18)|Neo_Green_Hill_8x8_Tiles   ; loc_0B9E58 $22 = Sprite Pointer in 0x024420 
        dc.l    ($23<<$18)|Neo_Green_Hill_16x16_Map   ; loc_0B8558 $23 = Sprite Pointer in 0x024420
        dc.l    ($13<<$18)|Neo_Green_Hill_128x128_Map ; loc_0BF568 $13 = Palette Pointer in 0x00294E
        dc.l    ($24<<$18)|Green_Hill_8x8_Tiles   ; loc_081C00 $24 = Sprite Pointer in 0x024420 
        dc.l    ($25<<$18)|Green_Hill_16x16_Map   ; loc_080C60 $25 = Sprite Pointer in 0x024420
        dc.l    ($14<<$18)|Green_Hill_128x128_Map ; loc_08692E $14 = Palette Pointer in 0x00294E
ArtLoadCues: ; loc_024420:
        dc.w    Standard_Sprites_1-ArtLoadCues ; $00
        dc.w    Standard_Sprites_2-ArtLoadCues ; $01
        dc.w    Standard_Sprites_3-ArtLoadCues ; $02        
        dc.w    Standard_Sprites_4-ArtLoadCues ; $03
        dc.w    Green_Hill_Sprites_1-ArtLoadCues ; $04 - Green Hill
        dc.w    Green_Hill_Sprites_2-ArtLoadCues ; $05 - Green Hill        
        dc.w    Wood_Sprites_1-ArtLoadCues ; $06 
        dc.w    Wood_Sprites_1-ArtLoadCues ; $07 
        dc.w    Wood_Sprites_1-ArtLoadCues ; $08 
        dc.w    Wood_Sprites_2-ArtLoadCues ; $09  
        dc.w    Metropolis_Sprites_1-ArtLoadCues ; $0A  
        dc.w    Metropolis_Sprites_1-ArtLoadCues ; $0B
        dc.w    Metropolis_Sprites_1-ArtLoadCues ; $0C
        dc.w    Metropolis_Sprites_2-ArtLoadCues ; $0D        
        dc.w    Hill_Top_Sprites_1-ArtLoadCues ; $0E
        dc.w    Hill_Top_Sprites_1-ArtLoadCues ; $0F 
        dc.w    Hill_Top_Sprites_1-ArtLoadCues ; $10
        dc.w    Hill_Top_Sprites_1-ArtLoadCues ; $11
        dc.w    Hill_Top_Sprites_1-ArtLoadCues ; $12        
        dc.w    Hill_Top_Sprites_2-ArtLoadCues ; $13
        dc.w    Hidden_Palace_Sprites_1-ArtLoadCues ; $14 
        dc.w    Hidden_Palace_Sprites_2-ArtLoadCues ; $15        
        dc.w    Oil_Ocean_Sprites_1-ArtLoadCues ; $16 
        dc.w    Oil_Ocean_Sprites_1-ArtLoadCues ; $17 
        dc.w    Oil_Ocean_Sprites_1-ArtLoadCues ; $18 
        dc.w    Oil_Ocean_Sprites_2-ArtLoadCues ; $19  
        dc.w    Dust_Hill_Sprites_1-ArtLoadCues ; $1A  
        dc.w    Dust_Hill_Sprites_2-ArtLoadCues ; $1B
        dc.w    Casino_Night_Sprites_1-ArtLoadCues ; $1C
        dc.w    Casino_Night_Sprites_2-ArtLoadCues ; $1D        
        dc.w    Chemical_Plant_Sprites_1-ArtLoadCues ; $1E
        dc.w    Chemical_Plant_Sprites_2-ArtLoadCues ; $1F 
        dc.w    Neo_Green_Hill_Sprites_1-ArtLoadCues ; $20
        dc.w    Neo_Green_Hill_Sprites_1-ArtLoadCues ; $21
        dc.w    Neo_Green_Hill_Sprites_1-ArtLoadCues ; $22        
        dc.w    Neo_Green_Hill_Sprites_2-ArtLoadCues ; $23
        dc.w    End_Level_Results_Sprites-ArtLoadCues ; $24 
        dc.w    End_Level_Results_Sprites-ArtLoadCues ; $25        
        dc.w    End_Level_Results_Sprites-ArtLoadCues ; $26 
        dc.w    End_Level_Sprites-ArtLoadCues ; $27 
        dc.w    Green_Hill_Boss-ArtLoadCues ; $28 
        dc.w    Green_Hill_Boss-ArtLoadCues ; $29  
        dc.w    Green_Hill_Boss-ArtLoadCues ; $2A  
        dc.w    Green_Hill_Boss-ArtLoadCues ; $2B
        dc.w    Green_Hill_Boss-ArtLoadCues ; $2C          
Standard_Sprites_1:  
loc_02447A: 
        dc.w    (((loc_02449A-loc_02447A-$02)/$06)-$01)
        dc.l    Lamp_Post               ; loc_079278: 
        dc.w    $8F80 
        dc.l    Head_up_display_Sprites ; loc_078A12
        dc.w    $D940   
        dc.l    Head_up_display_Sonic   ; loc_078B1A 
        dc.w    $FA80  
        dc.l    Rings           ; loc_078C30: 
        dc.w    $D780  
        dc.l    Enemy_Points_Spr        ; loc_07919E:  
        dc.w    $9580        
loc_02449A:  
Standard_Sprites_2:           
        dc.w    (((loc_0244AE-loc_02449A-$02)/$06)-$01)
        dc.l    Monitors        ; loc_078D24
        dc.w    $D000
        dc.l    Shield          ; loc_06DF8E 
        dc.w    $97C0
        dc.l    Invencibility_Stars     ; loc_06E114
        dc.w    $9BC0
loc_0244AE:   
Standard_Sprites_3:           
        dc.w    (((loc_0244C2-loc_0244AE-$02)/$06)-$01)
        dc.l    Explosion               ; loc_07F012
        dc.w    $B400  
        dc.l    Rabbit          ; loc_080348
        dc.w    $B000 
        dc.l    White_Bird              ; loc_0804A0 
        dc.w    $B240
Standard_Sprites_4:  
loc_0244C2:
        dc.w    (((loc_0244CA-loc_0244C2-$02)/$06)-$01)
        dc.l    Game_Time_Over          ; loc_07F678
        dc.w    $ABC0
Green_Hill_Sprites_1:   
loc_0244CA:
        dc.w    (((loc_0244FC-loc_0244CA-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Green_Hill_8x8_Tiles    ; loc_081C00
        dc.w    $0000            
        dc.l    Ghz_Waterfall           ; loc_073B3C
        dc.w    $75C0 
        dc.l    Ghz_Bridge              ; loc_073D90  
        dc.w    $78C0    
        dc.l    FireBall        ; loc_0739C6  
        dc.w    $79C0 
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00
Green_Hill_Sprites_2:          
loc_0244FC: 
        dc.w    (((loc_024510-loc_0244FC-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Ghz_Buzzer_Bomber       ; loc_07A4BC
        dc.w    $7CC0 
        dc.l    Ghz_Motobug             ; loc_07C514
        dc.w    $8040   
        dc.l    Ghz_Chopper             ; loc_07CA92
        dc.w    $8380    
Wood_Sprites_1:   
loc_024510:
        dc.w    (((loc_024518-loc_024510-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Wood_8x8_Tiles          ; loc_08AB2E
        dc.w    $0000     
Wood_Sprites_2: 
loc_024518: 
        dc.w    (((loc_024532-loc_024518-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680 
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00           
Metropolis_Sprites_1:   
loc_024532:
        dc.w    (((loc_02456A-loc_024532-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Metropolis_8x8_Tiles    ; loc_091716
        dc.w    $0000 
        dc.l    Mz_Teleport             ; loc_075382
        dc.w    $6780   
        dc.l    Mz_Rotating_Gear        ; loc_07461C
        dc.w    $6F00 
        dc.l    Mz_Machine_Ball         ; loc_074A74
        dc.w    $7E00   
        dc.l    loc_074EE2
        dc.w    $7F20  
        dc.l    loc_0751FE
        dc.w    $7FA0
        dc.l    Mz_Steam        ; loc_074BEA  
        dc.w    $80A0
        dc.l    Mz_Block        ; loc_074B1C  
        dc.w    $8280
        dc.l    Mz_Harpoon              ; loc_074CF4
        dc.w    $8380
loc_02456A: 
Metropolis_Sprites_2: 
        dc.w    (((loc_0245A2-loc_02456A-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Switch          ; loc_078580
        dc.w    $8480     
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680 
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00   
        dc.l    Mz_Screw_Nut            ; loc_074DB6
        dc.w    $A000
        dc.l    Mz_Lava_Bubble          ; loc_074E2C
        dc.w    $A6C0 
        dc.l    Mz_Parallelogram_Elevator  ; loc_074F52    
        dc.w    $A7E0  
        dc.l    Mz_Mini_Gear            ; loc_0752A0
        dc.w    $ABE0       
Hill_Top_Sprites_1:   
loc_0245A2:
        dc.w    (((loc_0245E0-loc_0245A2-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Green_Hill_8x8_Tiles    ; loc_081C00
        dc.w    $0000 
        dc.l    Hill_Top_8x8_Tiles      ; loc_085200
        dc.w    $3F80
        dc.l    FireBall        ; loc_0739C6  
        dc.w    $73C0   
        dc.l    Htz_Rock        ; loc_07447A
        dc.w    $7640   
        dc.l    Htz_See_saw             ; loc_0741D4
        dc.w    $78C0 
        dc.l    Htz_See_saw_badnick     ; loc_0745B0 
        dc.w    $7BC0 
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680        
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00 
Hill_Top_Sprites_2:           
loc_0245E0: 
        dc.w    (((loc_0245F4-loc_0245E0-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Htz_Teleferic           ; loc_073E68 
        dc.w    $7CC0 
        dc.l    Htz_Lava_Bubble         ; loc_073C42
        dc.w    $82C0 
        dc.l    Htz_Automatic_Door      ; loc_07415C 
        dc.w    $84C0 
Hidden_Palace_Sprites_1:   
loc_0245F4:
        dc.w    (((loc_024626-loc_0245F4-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Hidden_Palace_8x8_Tiles ; loc_098B76
        dc.w    $0000 
        dc.l    Hpz_Bridge              ; loc_07538E 
        dc.w    $6000 
        dc.l    Hpz_Waterfall           ; loc_075506
        dc.w    $62A0 
        dc.l    Hpz_Platform            ; loc_075ADA
        dc.w    $6940     
        dc.l    Hpz_Orbs_Comp           ; loc_075B9A   
        dc.w    $6B40 
        dc.l    Hpz_Unknow_Platform     ; loc_075DD6   
        dc.w    $6F80 
        dc.l    Hpz_Emerald             ; loc_075868
        dc.w    $7240  
        dc.l    Water_Surface           ; loc_0777D2  
        dc.w    $8000  
Hidden_Palace_Sprites_2:                        
loc_024626: 
        dc.w   (((loc_02463A-loc_024626-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Hpz_Dinobot             ; loc_07B114 
        dc.w    $A000 
        dc.l    Hpz_Batbot              ; loc_07A6A2
        dc.w    $A600          
loc_02463A: ; Not all sprites are loaded in to VRam               
        dc.l    Hpz_Crocobot            ; loc_07A11A ; Left Over 
        dc.w    $6000 
        dc.l    Ghz_Buzzer_Bomber       ; loc_07A4BC
        dc.w    $6580  
        dc.l    Hpz_Batbot              ; loc_07A6A2
        dc.w    $6A00  
        dc.l    Hpz_Rhinobot            ; loc_07AD18 ; Left Over
        dc.w    $7880 
        dc.l    Hpz_Dinobot             ; loc_07B114 
        dc.w    $A000 
        dc.l    Hpz_Piranha             ; loc_07B4EA ; Left Over
        dc.w    $A600   
Oil_Ocean_Sprites_1:   
loc_024658:
        dc.w    (((loc_024684-loc_024658-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Oil_Ocean_8x8_Tiles     ; loc_09ED58
        dc.w    $0000
        dc.l    OOz_Elevator            ; loc_075F70
        dc.w    $6000   
        dc.l    OOz_Giant_Spikeball     ; loc_076060
        dc.w    $6180 
        dc.l    OOz_Touch_Boost_Up      ; loc_076258
        dc.w    $6580  
        dc.l    OOz_Break_Boost         ; loc_0762EE
        dc.w    $6640 
        dc.l    OOz_Oil         ; loc_07635A
        dc.w    $66C0    
        dc.l    OOz_Tube_Oil            ; loc_0764D6
        dc.w    $68C0          
Oil_Ocean_Sprites_2:    
loc_024684: 
        dc.w    (((loc_0246C2-loc_024684-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    OOz_Ball        ; loc_076602 
        dc.w    $6A80 
        dc.l    OOz_Cannon              ; loc_076722
        dc.w    $6D00 
        dc.l    OOz_Collapsing_Platform ; loc_076A12
        dc.w    $73A0  
        dc.l    OOz_Spring_Push_Boost   ; loc_076CA6
        dc.w    $78A0       
        dc.l    OOz_Swing_Platform      ; loc_076E68
        dc.w    $7C60 
        dc.l    Switch          ; loc_078580
        dc.w    $8480   
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00 
Dust_Hill_Sprites_1:   
loc_0246C2:
        dc.w    (((loc_0246E2-loc_0246C2-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Dust_Hill_8x8_Tiles     ; loc_0A5248
        dc.w    $0000 
        dc.l    Dhz_Box         ; loc_07708A
        dc.w    $7A80  
        dc.l    Dhz_Collapsing_Platform ; loc_0772C8
        dc.w    $7E80     
        dc.l    Dhz_Vines               ; loc_077472
        dc.w    $81C0   
        dc.l    Dhz_Vines_1             ; loc_07756A
        dc.w    $83C0 
Dust_Hill_Sprites_2:  
loc_0246E2:      
        dc.w    (((loc_024708-loc_0246E2-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Dhz_Horizontal_Spikes   ; loc_079A44        
        dc.w    $8580 
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Dhz_Bridge              ; loc_077614
        dc.w    $8780  
        dc.l    Diagonal_Spring_1       ; loc_0798F4
        dc.w    $8800  
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00   
Casino_Night_Sprites_1:   
loc_024708:
        dc.w    (((loc_024716-loc_024708-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Casino_Night_8x8_Tiles  ; loc_0ABF2A
        dc.w    $0000           
        dc.l    Cnz_Cards               ; loc_0AEF3C
        dc.w    $7A00   
Casino_Night_Sprites_2:  
loc_024716: 
        dc.w    (((loc_024730-loc_024716-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780        
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00         
Chemical_Plant_Sprites_1:   
loc_024730:
        dc.w    (((loc_02476E-loc_024730-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Chemical_Plant_8x8_Tiles ; loc_0B2506
        dc.w    $0000 
        dc.l    Cpz_Metal_Structure     ; loc_077A1C  
        dc.w    $6E60
        dc.l    Cpz_Automatic_Door      ; loc_077C66
        dc.w    $7280 
        dc.l    Cpz_Speed_Booster       ; loc_077942
        dc.w    $7380
        dc.l    Cpz_Elevator            ; loc_077684
        dc.w    $7400  
        dc.l    Cpz_Open_Close_Platform ; loc_077CD2 
        dc.w    $7600  
        dc.l    Cpz_Spring_Tubes        ; loc_078074
        dc.w    $7C00   
        dc.l    Water_Surface           ; loc_0777D2  
        dc.w    $8000
        dc.l    Cpz_Platforms           ; loc_077EB4
        dc.w    $8300 
        dc.l    loc_077C26
        dc.w    $8600 
Chemical_Plant_Sprites_2:      
loc_02476E:
        dc.w    (((loc_024794-loc_02476E-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Air_Bubbles_Numbers     ; loc_079AC0
        dc.w    $A000 
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680  
        dc.l    Cpz_Worms               ; loc_0779AA
        dc.w    $8780  
        dc.l    Diagonal_Spring_1       ; loc_0798F4
        dc.w    $8800  
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00      
Neo_Green_Hill_Sprites_1:   
loc_024794:
        dc.w    (((loc_0247B4-loc_024794-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Neo_Green_Hill_8x8_Tiles ; loc_0B9E58
        dc.w    $0000 
        dc.l    Nghz_Water_Surface      ; loc_078270
        dc.w    $8000   
        dc.l    Nghz_Leaves             ; loc_078356
        dc.w    $8200    
        dc.l    Nghz_Arrow_Shooter      ; loc_0783E2
        dc.w    $82E0  
        dc.l    Nghz_Water_Splash       ; loc_078540
        dc.w    $8500  
Neo_Green_Hill_Sprites_2:                       
loc_0247B4:
        dc.w    (((loc_0247D4-loc_0247B4-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Air_Bubbles_Numbers     ; loc_079AC0
        dc.w    $A000 
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Diagonal_Spring_1       ; loc_0798F4
        dc.w    $8800   
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00    
End_Level_Results_Sprites:         
loc_0247D4:  
        dc.w    (((loc_0247DC-loc_0247D4-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Title_Cards             ; loc_07EA04    
        dc.w    $B000   
End_Level_Sprites:                
loc_0247DC:
        dc.w    (((loc_0247E4-loc_0247DC-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto          
        dc.l    End_Panel               ; loc_07931E 
        dc.w    $8680
loc_0247E4: ; Not all sprites are loaded in to VRam           
        dc.l    Hidden_Points           ; loc_07FB5C
        dc.w    $96C0
        dc.l    Big_Ring_Flash          ; loc_07F9E8
        dc.w    $8C40
Green_Hill_Boss:
loc_0247F0:   
        dc.w    (((loc_024804-loc_0247F0-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Robotnik_Ship           ; loc_07CC9E 
        dc.w    $8C00
        dc.l    Ghz_Boss_Car            ; loc_07E124
        dc.w    $9800
        dc.l    Ghz_Boss_Blades         ; loc_07E910
        dc.w    $A800 
loc_024804: ; Not all sprites are loaded in to VRam  
        dc.l    Robotnik_Ship           ; loc_07CC9E 
        dc.w    $8000
        dc.l    Cpz_Boss        ; loc_07D3DA   
        dc.w    $8C00
        dc.l    Ship_Boost              ; loc_07DFC0 
        dc.w    $9A00 
        dc.l    Boss_Smoke              ; loc_07E03E 
        dc.w    $9B00 
        dc.l    Ghz_Boss_Car            ; loc_07E124
        dc.w    $9D00
        dc.l    Ghz_Boss_Blades         ; loc_07E910
        dc.w    $AD00         
        dc.w    (Diagonal_Spring_1&$FFFF) ; loc_0798F4 ; Left over from previous build
        dc.w    $8800           
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00  
loc_024838:        
        dc.w    (((loc_024840-loc_024838-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto 
        dc.l    Title_Cards             ; loc_07EA04    
        dc.w    $B000   
loc_024840:  
        dc.w    (((loc_024848-loc_024840-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    End_Panel               ; loc_07931E 
        dc.w    $8680
loc_024848:     
        dc.l    Hidden_Points           ; loc_07FB5C
        dc.w    $96C0
        dc.l    Big_Ring_Flash          ; loc_07F9E8
        dc.w    $8C40
loc_024854:           
        dc.w    (((loc_024868-loc_024854-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Robotnik_Ship           ; loc_07CC9E 
        dc.w    $8C00
        dc.l    Ghz_Boss_Car            ; loc_07E124
        dc.w    $9800
        dc.l    Ghz_Boss_Blades         ; loc_07E910
        dc.w    $A800 
loc_024868:          
        dc.l    Robotnik_Ship           ; loc_07CC9E 
        dc.w    $8000
        dc.l    Cpz_Boss        ; loc_07D3DA   
        dc.w    $8C00
        dc.l    Ship_Boost              ; loc_07DFC0 
        dc.w    $9A00 
        dc.l    Boss_Smoke              ; loc_07E03E 
        dc.w    $9B00 
        dc.l    Ghz_Boss_Car            ; loc_07E124
        dc.w    $9D00
        dc.l    Ghz_Boss_Blades         ; loc_07E910
        dc.w    $AD00
        dc.w    (Boss_Smoke&$FFFF)      ; loc_07E03E ; Left over from previous build
        dc.w    $9B00 
        dc.l    Ghz_Boss_Car            ; loc_07E124
        dc.w    $9D00
        dc.l    Ghz_Boss_Blades         ; loc_07E910
        dc.w    $AD00
        dc.l    Dhz_Bridge              ; loc_077614
        dc.w    $8780
        dc.l    (Diagonal_Spring_1-$0188) ; loc_07976C ; Left over from previous build
        dc.w    $8800  
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80 
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00 
Casino_Night_Sprites_Previous_Build_1:         
loc_0248B4:
        dc.w    (((loc_0248C2-loc_0248B4-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto 
        dc.l    Casino_Night_8x8_Tiles-$07E2 ; loc_0AB748 ; Left over from previous build
        dc.w    $0000
        dc.l    Cnz_Cards-$07E2              ; loc_0AE75A ; Left over from previous build
        dc.w    $7A00 
Casino_Night_Sprites_Previous_Build_2:           
loc_0248C2:     
        dc.w    (((loc_0248DC-loc_0248C2-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    Diagonal_Spring         ; loc_07883E
        dc.w    $8780   
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80 
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00 
Chemical_Plant_Sprites_Previous_Build_1:          
loc_0248DC:         
        dc.w    (((loc_02491A-loc_0248DC-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Chemical_Plant_8x8_Tiles-$07E2 ; loc_0B1D24
        dc.w    $0000 
        dc.l    Cpz_Metal_Structure     ; loc_077A1C  
        dc.w    $6E60
        dc.l    Cpz_Automatic_Door      ; loc_077C66
        dc.w    $7280 
        dc.l    Cpz_Speed_Booster       ; loc_077942
        dc.w    $7380
        dc.l    Cpz_Elevator            ; loc_077684
        dc.w    $7400  
        dc.l    Cpz_Open_Close_Platform ; loc_077CD2 
        dc.w    $7600  
        dc.l    Cpz_Spring_Tubes        ; loc_078074
        dc.w    $7C00   
        dc.l    Water_Surface           ; loc_0777D2  
        dc.w    $8000
        dc.l    Cpz_Platforms           ; loc_077EB4
        dc.w    $8300 
        dc.l    loc_077C26
        dc.w    $8600 
Chemical_Plant_Sprites_Previous_Build_2:                   
loc_02491A: 
        dc.w    (((loc_02493A-loc_02491A-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680  
        dc.l    Cpz_Worms               ; loc_0779AA
        dc.w    $8780                 
        dc.l    (Diagonal_Spring_1-$0188) ; loc_07976C 
        dc.w    $8800  
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00   
Neo_Green_Hill_Sprites_Previous_Build_1:            
loc_02493A:      
        dc.w    (((loc_02495A-loc_02493A-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Neo_Green_Hill_8x8_Tiles-$07D2 ; loc_0B9686
        dc.w    $0000
        dc.l    Nghz_Water_Surface      ; loc_078270
        dc.w    $8000   
        dc.l    Nghz_Leaves             ; loc_078356
        dc.w    $8200    
        dc.l    Nghz_Arrow_Shooter      ; loc_0783E2
        dc.w    $82E0  
        dc.l    Nghz_Water_Splash       ; loc_078540
        dc.w    $8500  
Neo_Green_Hill_Sprites_Previous_Build_2:          
loc_02495A:    
        dc.w    (((loc_024974-loc_02495A-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Spikes          ; loc_07914E
        dc.w    $8680   
        dc.l    (Diagonal_Spring_1-$0188) ; loc_07976C 
        dc.w    $8800   
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80   
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00   
End_Level_Results_Sprites_Previous_Build:            
loc_024974:  
        dc.w    (((loc_02497C-loc_024974-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Title_Cards-$07E2       ; loc_07E222    
        dc.w    $B000  
End_Level_Sprites_Previous_Build:                
loc_02497C: 
        dc.w    (((loc_024990-loc_02497C-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto          
        dc.l    End_Panel               ; loc_07931E 
        dc.w    $D000
        dc.l    Hidden_Points-$07E2     ; loc_07F37A
        dc.w    $96C0
        dc.l    Big_Ring_Flash-$07E2    ; loc_07F206
        dc.w    $8C40
Green_Hill_Boss_Previous_Build:
loc_024990: 
        dc.w    (((loc_0249A4-loc_024990-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Robotnik_Ship-$07E2     ; loc_07C4BC 
        dc.w    $8C00
        dc.l    Ghz_Boss_Car-$07E2      ; loc_07D942
        dc.w    $9800
        dc.l    Ghz_Boss_Blades-$07E2   ; loc_07E12E
        dc.w    $A800 
loc_0249A4:        
        dc.l    Robotnik_Ship-$07E2     ; loc_07C4BC 
        dc.w    $8000           
        dc.l    Cpz_Boss-$07E2          ; loc_07CBF8   
        dc.w    $8C00         
        dc.l    Ship_Boost-$07E2        ; loc_07D7DE 
        dc.w    $9A00           
        dc.l    Boss_Smoke-$07E2        ; loc_07D85C 
        dc.w    $9B00 
        dc.l    Ghz_Boss_Car-$07E2      ; loc_07D942
        dc.w    $9D00           
        dc.l    Ghz_Boss_Blades-$07E2   ; loc_07E12E
        dc.w    $AD00   
        dc.w    $8680               
        dc.l    (Diagonal_Spring_1-$0188) ; loc_07976C 
        dc.w    $8800  
        dc.l    Vertical_Spring         ; loc_078658
        dc.w    $8B80 
        dc.l    Horizontal_Spring       ; loc_078774
        dc.w    $8E00 
loc_0249DC:  
        dc.w    (((loc_0249E4-loc_0249DC-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Title_Cards-$07E2       ; loc_07E222    
        dc.w    $B000  
loc_0249E4: 
        dc.w    (((loc_0249F8-loc_0249E4-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto          
        dc.l    End_Panel               ; loc_07931E 
        dc.w    $D000
        dc.l    Hidden_Points-$07E2     ; loc_07F37A
        dc.w    $96C0
        dc.l    Big_Ring_Flash-$07E2    ; loc_07F206
        dc.w    $8C40 
loc_0249F8: 
        dc.w    (((loc_024A0C-loc_0249F8-$02)/$06)-$01) ; Auto Detect Number of Sprites Esrael L. G. Neto
        dc.l    Robotnik_Ship-$07E2     ; loc_07C4BC 
        dc.w    $8C00
        dc.l    Ghz_Boss_Car-$07E2      ; loc_07D942
        dc.w    $9800
        dc.l    Ghz_Boss_Blades-$07E2   ; loc_07E12E
        dc.w    $A800 
loc_024A0C: 
        dc.l    Robotnik_Ship-$07E2     ; loc_07C4BC 
        dc.w    $8000           
        dc.l    Cpz_Boss-$07E2          ; loc_07CBF8   
        dc.w    $8C00         
        dc.l    Ship_Boost-$07E2        ; loc_07D7DE 
        dc.w    $9A00           
        dc.l    Boss_Smoke-$07E2        ; loc_07D85C 
        dc.w    $9B00 
        dc.l    Ghz_Boss_Car-$07E2      ; loc_07D942
        dc.w    $9D00           
        dc.l    Ghz_Boss_Blades-$07E2   ; loc_07E12E
        dc.w    $AD00          
Unknow_Data_0x024A30:
loc_024A30:
        dc.b    $00, $78, $00, $06, $00, $07, $00, $06, $00, $10, $80, $06, $03, $0A, $06, $00
        dc.b    $07, $08, $60, $00, $06, $66, $88, $89, $07, $01, $10, $06, $0A, $01, $07, $00
        dc.b    $01, $10, $00, $11, $10, $00, $70, $02, $06, $77, $00, $11, $11, $66, $77, $03
        dc.b    $01, $07, $03, $01, $17, $03, $02, $9F, $10, $02, $02, $01, $10, $02, $01, $01
        dc.b    $02, $02, $09, $61, $02, $0A, $18, $66, $09, $EF, $87, $00, $97, $10, $6F, $76
        dc.b    $02, $0C, $10, $10, $77, $11, $06, $00, $17, $00, $10, $00, $01, $10, $02, $2D
        dc.b    $01, $01, $01, $61, $11, $06, $10, $77, $86, $17, $78, $88, $F7, $11, $0F, $07
        dc.b    $77, $00, $66, $FF, $17, $61, $01, $06, $07, $70, $67, $71, $16, $10, $76, $11
        dc.b    $10, $01, $10, $61, $06, $00, $61, $77, $E8, $9E, $9E, $E9, $77, $03, $0C, $F0
        dc.b    $07, $10, $00, $7F, $00, $01, $00, $17, $F0, $77, $61, $02, $0E, $77, $07, $67
        dc.b    $87, $11, $67, $F8, $11, $00, $01, $E9, $86, $66, $11, $02, $02, $07, $11, $05
        dc.b    $02, $E0, $71, $05, $01, $0E, $05, $0C, $71, $00, $E0, $77, $70, $00, $77, $77
        dc.b    $70, $16, $00, $70, $02, $01, $10, $02, $08, $07, $00, $07, $07, $00, $01, $00
        dc.b    $70, $04, $0E, $70, $00, $10, $00, $07, $00, $01, $07, $00, $10, $00, $11, $66
        dc.b    $71, $03, $02, $07, $11, $02, $01, $70, $04, $01, $01, $03, $01, $10, $02, $01
        dc.b    $70, $03, $01, $07, $03, $04, $61, $00, $01, $16, $0A, $02, $10, $70, $02, $01
        dc.b    $07, $02, $01, $01, $04, $01, $70, $05, $04, $60, $01, $76, $66, $10, $01, $70
        dc.b    $09, $06, $11, $00, $98, $88, $67, $10, $0B, $03, $01, $00, $0E, $05, $05, $70
        dc.b    $00, $E0, $07, $07, $04, $04, $88, $76, $61, $66, $05, $01, $10, $18, $04, $16
        dc.b    $66, $00, $01, $02, $05, $01, $10, $70, $00, $01, $04, $01, $07, $0B, $01, $07
        dc.b    $02, $08, $66, $00, $66, $76, $00, $70, $01, $10, $02, $01, $10, $02, $02, $07
        dc.b    $01, $07, $02, $71, $01, $03, $01, $11, $03, $04, $10, $66, $66, $61, $08, $01
        dc.b    $11, $03, $01, $10, $10, $05, $01, $66, $88, $89, $17, $03, $02, $77, $70, $02
        dc.b    $03, $70, $00, $E0, $05, $01, $70, $07, $02, $07, $70, $02, $06, $07, $76, $68
        dc.b    $88, $07, $01, $08, $01, $10, $02, $01, $70, $04, $01, $01, $02, $03, $07, $00
        dc.b    $10, $02, $06, $70, $01, $66, $66, $61, $11, $09, $05, $01, $10, $00, $10, $67
        dc.b    $02, $02, $06, $07, $02, $02, $70, $70, $02, $14, $07, $00, $10, $00, $FF, $8F
        dc.b    $FF, $EE, $87, $00, $10, $70, $18, $F7, $76, $F8, $01, $78, $FF, $07, $02, $08
        dc.b    $70, $70, $00, $10, $00, $01, $00, $01, $04, $10, $17, $10, $EE, $9E, $E8, $91
        dc.b    $77, $07, $88, $80, $88, $88, $61, $11, $01, $11, $02, $01, $10, $0F, $01, $10
        dc.b    $03, $01, $10, $1B, $03, $61, $10, $11, $02, $01, $10, $04, $08, $10, $00, $07
        dc.b    $10, $01, $01, $E0, $71, $03, $06, $07, $10, $00, $0E, $00, $71, $02, $07, $E0
        dc.b    $07, $01, $88, $86, $77, $16, $02, $03, $10, $00, $10, $03, $01, $01, $03, $01
        dc.b    $70, $08, $04, $10, $01, $07, $77, $03, $05, $76, $10, $00, $11, $70, $0A, $01
        dc.b    $01, $03, $02, $01, $01, $03, $01, $70, $03, $02, $07, $10, $02, $04, $66, $11
        dc.b    $66, $66, $05, $01, $17, $06, $01, $11, $03, $01, $10, $04, $01, $70, $06, $04
        dc.b    $11, $66, $66, $66, $10, $01, $71, $0B, $01, $61, $1A, $01, $01, $03, $05, $10
        dc.b    $22, $22, $22, $33, $1C, $0B, $23, $23, $44, $44, $10, $00, $70, $00, $11, $01
        dc.b    $07, $03, $02, $10, $70, $02, $02, $01, $07, $03, $01, $10, $07, $04, $01, $66
        dc.b    $66, $61, $03, $01, $71, $06, $01, $07, $02, $03, $07, $70, $71, $02, $03, $11
        dc.b    $77, $10, $04, $01, $01, $02, $05, $01, $60, $00, $16, $10, $1B, $05, $17, $66
        dc.b    $66, $68, $9E, $04, $0B, $07, $70, $0E, $00, $70, $17, $00, $EE, $01, $01, $70
        dc.b    $03, $06, $07, $77, $00, $01, $01, $10, $02, $06, $10, $01, $98, $89, $88, $88
        dc.b    $08, $01, $E0, $03, $02, $0E, $E0, $02, $02, $70, $0E, $02, $01, $07, $07, $08
        dc.b    $97, $00, $99, $EE, $00, $07, $01, $70, $07, $01, $17, $03, $01, $01, $05, $02
        dc.b    $07, $01, $05, $06, $E0, $77, $11, $00, $07, $01, $02, $01, $70, $08, $01, $10
        dc.b    $0E, $04, $99, $86, $61, $11, $11, $01, $0E, $0A, $06, $99, $98, $61, $11, $00
        dc.b    $10, $1A, $08, $99, $86, $66, $10, $00, $0E, $00, $71, $03, $01, $07, $02, $01
        dc.b    $E0, $04, $01, $07, $0A, $0D, $0E, $00, $9E, $E9, $89, $70, $17, $00, $10, $10
        dc.b    $10, $77, $71, $02, $01, $07, $02, $01, $01, $04, $04, $07, $01, $01, $11, $03
        dc.b    $17, $10, $70, $07, $00, $77, $77, $66, $10, $70, $70, $10, $01, $00, $07, $01
        dc.b    $10, $07, $00, $70, $10, $00, $07, $70, $02, $05, $70, $10, $07, $00, $01, $04
        dc.b    $07, $10, $70, $00, $76, $77, $00, $07, $03, $01, $70, $18, $03, $76, $66, $66
        dc.b    $07, $09, $01, $00, $01, $00, $17, $00, $70, $11, $78, $02, $05, $7F, $80, $00
        dc.b    $07, $80, $02, $09, $08, $01, $10, $66, $6E, $FE, $E8, $00, $16, $02, $3C, $11
        dc.b    $78, $FF, $F0, $FF, $00, $11, $18, $00, $80, $10, $01, $11, $00, $01, $10, $01
        dc.b    $00, $01, $11, $10, $01, $00, $01, $FF, $FE, $EF, $FF, $70, $00, $61, $00, $0F
        dc.b    $FF, $87, $11, $81, $11, $00, $FF, $10, $01, $08, $00, $01, $10, $00, $11, $11
        dc.b    $10, $00, $10, $10, $00, $10, $01, $FF, $FE, $FE, $EE, $02, $03, $01, $01, $10
        dc.b    $02, $1A, $10, $71, $00, $10, $77, $87, $11, $07, $07, $08, $F7, $00, $71, $00
        dc.b    $08, $70, $00, $01, $10, $80, $00, $FF, $FE, $87, $00, $10, $02, $01, $10, $02
        dc.b    $08, $01, $00, $10, $01, $70, $00, $71, $07, $02, $01, $77, $03, $02, $10, $17
        dc.b    $02, $01, $07, $03, $04, $01, $11, $10, $16, $02, $02, $11, $77, $02, $02, $10
        dc.b    $07, $02, $02, $01, $70, $07, $01, $17, $08, $06, $10, $01, $00, $01, $01, $01
        dc.b    $07, $01, $10, $02, $01, $70, $0C, $01, $10, $02, $05, $70, $66, $88, $88, $10
        dc.b    $13, $02, $10, $0E, $02, $01, $07, $03, $04, $9E, $0E, $99, $98, $03, $01, $01
        dc.b    $0E, $01, $70, $06, $01, $E0, $02, $04, $89, $86, $61, $11, $05, $01, $10, $02
        dc.b    $01, $10, $13, $04, $99, $98, $61, $11, $02, $01, $07, $19, $04, $99, $98, $66
        dc.b    $11, $1C, $04, $99, $98, $88, $61, $0F, $01, $E7, $0C, $06, $89, $EE, $EE, $96
        dc.b    $00, $70, $03, $04, $70, $00, $71, $07, $03, $06, $07, $70, $00, $07, $11, $07
        dc.b    $03, $01, $17, $02, $02, $71, $07, $02, $06, $70, $11, $67, $00, $10, $01, $03
        dc.b    $01, $70, $07, $01, $77, $02, $03, $10, $00, $10, $02, $05, $70, $10, $70, $00
        dc.b    $07, $02, $04, $77, $07, $67, $70, $1D, $0E, $08, $99, $98, $00, $08, $11, $10
        dc.b    $00, $08, $00, $01, $00, $80, $11, $03, $02, $01, $01, $02, $01, $10, $02, $01
        dc.b    $80, $02, $19, $77, $7F, $F8, $88, $FF, $FE, $E8, $89, $10, $10, $11, $01, $00
        dc.b    $11, $01, $10, $01, $10, $01, $11, $11, $10, $11, $10, $01, $02, $1E, $01, $01
        dc.b    $00, $10, $10, $00, $88, $88, $00, $10, $89, $98, $00, $10, $11, $01, $01, $01
        dc.b    $10, $11, $00, $11, $10, $01, $10, $01, $11, $01, $11, $10, $02, $14, $10, $01
        dc.b    $01, $00, $10, $00, $88, $88, $00, $01, $99, $80, $FE, $01, $11, $80, $00, $10
        dc.b    $00, $80, $02, $09, $11, $08, $00, $10, $10, $00, $01, $00, $01, $04, $0A, $08
        dc.b    $77, $88, $8F, $F7, $77, $66, $00, $01, $11, $06, $01, $10, $07, $02, $01, $11
        dc.b    $02, $04, $10, $11, $10, $07, $02, $08, $71, $00, $70, $11, $61, $66, $61, $10
        dc.b    $17, $01, $10, $02, $06, $01, $00, $61, $00, $01, $11, $07, $01, $01, $0B, $03
        dc.b    $10, $07, $10, $05, $05, $07, $70, $78, $88, $9E, $05, $01, $E0, $02, $01, $70
        dc.b    $07, $01, $0E, $0B, $01, $E0, $02, $01, $EE, $06, $01, $0E, $0F, $01, $E0, $05
        dc.b    $03, $9E, $E9, $77, $02, $07, $70, $10, $70, $00, $01, $01, $07, $08, $01, $07
        dc.b    $02, $02, $10, $70, $07, $05, $01, $10, $00, $01, $01, $07, $02, $07, $10, $06
        dc.b    $02, $70, $01, $07, $01, $70, $02, $04, $16, $61, $11, $61, $03, $01, $07, $02
        dc.b    $01, $10, $04, $01, $70, $06, $01, $01, $08, $01, $07, $03, $02, $11, $10, $0B
        dc.b    $01, $01, $03, $01, $70, $08, $01, $10, $04, $05, $06, $66, $07, $00, $07, $02
        dc.b    $05, $01, $01, $70, $00, $70, $09, $02, $07, $E0, $06, $07, $10, $97, $71, $00
        dc.b    $10, $00, $10, $04, $02, $01, $07, $03, $01, $77, $07, $01, $01, $02, $02, $17
        dc.b    $70, $04, $04, $77, $66, $70, $71, $03, $0B, $70, $77, $70, $77, $01, $00, $77
        dc.b    $11, $00, $10, $01, $02, $06, $17, $70, $00, $10, $00, $10, $06, $07, $06, $01
        dc.b    $16, $66, $10, $01, $07, $03, $01, $10, $04, $01, $07, $06, $01, $17, $04, $01
        dc.b    $71, $04, $05, $66, $11, $07, $06, $07, $02, $0C, $77, $70, $11, $10, $71, $01
        dc.b    $00, $10, $10, $10, $00, $01, $02, $02, $01, $10, $06, $01, $01, $02, $08, $10
        dc.b    $00, $11, $66, $10, $00, $10, $70, $02, $02, $01, $07, $03, $01, $10, $03, $01
        dc.b    $01, $0C, $08, $88, $88, $66, $66, $00, $0E, $00, $70, $05, $01, $E0, $06, $03
        dc.b    $0E, $00, $07, $09, $05, $E7, $77, $61, $17, $07, $06, $01, $10, $09, $01, $70
        dc.b    $04, $02, $01, $07, $04, $04, $70, $00, $11, $16, $08, $03, $70, $07, $01, $07
        dc.b    $02, $70, $10, $08, $04, $66, $66, $61, $11, $1C, $04, $66, $10, $00, $01, $0C
        dc.b    $01, $07, $0F, $00, $0E, $F6, $0A, $00, $10, $00, $5F, $00, $11, $00, $5F, $00
        dc.b    $01, $04, $80, $8C, $60, $C6, $60, $C7, $00, $10, $00, $10, $80, $d6, $80, $D7
        dc.b    $00, $14, $00, $15, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11
        dc.b    $00, $10, $00, $10, $00, $17, $00, $16, $00, $15, $00, $14, $80, $D2, $80, $D2
        dc.b    $00, $10, $00, $10, $08, $93, $00, $92, $00, $10, $00, $10, $00, $B2, $08, $B3
        dc.b    $00, $10, $00, $10, $80, $d4, $80, $d4, $00, $10, $00, $10, $00, $16, $00, $16
        dc.b    $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11
        dc.b    $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16
        dc.b    $00, $10, $00, $10, $80, $d4, $80, $d4, $00, $10, $00, $10, $88, $F7, $88, $B7
        dc.b    $00, $50, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $45, $00, $16
        dc.b    $03, $07, $10, $00, $51, $00, $42, $00, $10, $02, $04, $08, $41, $08, $51, $03
        dc.b    $07, $10, $00, $52, $00, $41, $00, $10, $03, $2D, $16, $00, $55, $00, $10, $00
        dc.b    $10, $00, $12, $E8, $52, $00, $10, $E8, $50, $08, $31, $08, $31, $00, $10, $00
        dc.b    $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $00
        dc.b    $10, $00, $63, $00, $62, $00, $61, $02, $03, $08, $61, $08, $04, $5D, $61, $00
        dc.b    $72, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $08, $F1, $08, $F1, $80, $10, $80, $10, $80
        dc.b    $12, $80, $12, $80, $13, $00, $10, $80, $15, $00, $16, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $88, $13, $00
        dc.b    $12, $88, $11, $88, $10, $80, $10, $00, $91, $08, $31, $03, $38, $A1, $00, $A2
        dc.b    $00, $91, $00, $A2, $00, $22, $00, $91, $00, $16, $00, $25, $00, $10, $00, $12
        dc.b    $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $00, $12
        dc.b    $08, $27, $00, $10, $08, $25, $08, $24, $00, $16, $08, $22, $08, $A2, $00, $12
        dc.b    $08, $00, $08, $A1, $08, $02, $80, $AB, $C6, $00, $C7, $00, $10, $00, $12, $00
        dc.b    $30, $00, $30, $00, $10, $00, $10, $00, $F6, $00, $14, $00, $F0, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $00, $16, $08, $11, $00, $10, $00, $10, $08
        dc.b    $15, $08, $F2, $00, $10, $08, $F0, $00, $14, $00, $16, $00, $10, $00, $10, $00
        dc.b    $32, $00, $30, $00, $12, $00, $10, $08, $DD, $08, $DF, $00, $10, $00, $10, $00
        dc.b    $12, $00, $10, $00, $10, $00, $10, $00, $10, $08, $11, $00, $10, $00, $10, $01
        dc.b    $19, $09, $1E, $00, $43, $00, $47, $00, $50, $00, $51, $00, $52, $00, $53, $09
        dc.b    $4D, $09, $42, $00, $10, $00, $1F, $08, $48, $00, $49, $00, $30, $00, $30, $00
        dc.b    $10, $00, $10, $00, $11, $00, $11, $00, $6E, $08, $6F, $00, $22, $00, $22, $00
        dc.b    $20, $00, $22, $00, $26, $00, $24, $00, $26, $08, $27, $00, $24, $08, $25, $08
        dc.b    $27, $08, $25, $00, $24, $00, $26, $00, $24, $00, $24, $00, $22, $00, $22, $08
        dc.b    $2B, $08, $46, $03, $3F, $6C, $00, $5D, $00, $5E, $00, $1A, $00, $16, $00, $18
        dc.b    $08, $15, $00, $16, $00, $1A, $00, $73, $08, $7C, $00, $70, $00, $70, $00, $76
        dc.b    $00, $76, $00, $70, $00, $70, $00, $72, $00, $72, $00, $70, $00, $70, $08, $73
        dc.b    $08, $73, $00, $70, $00, $70, $00, $76, $00, $76, $00, $70, $00, $70, $00, $0C
        dc.b    $00, $4A, $00, $47, $02, $14, $08, $09, $08, $0A, $00, $24, $00, $24, $08, $27
        dc.b    $08, $27, $08, $25, $00, $24, $00, $2F, $08, $76, $03, $1F, $5B, $00, $5C, $00
        dc.b    $5D, $00, $30, $00, $30, $00, $32, $00, $32, $00, $30, $00, $30, $08, $33, $08
        dc.b    $33, $00, $30, $00, $30, $00, $36, $08, $6C, $08, $5B, $03, $35, $1B, $00, $6A
        dc.b    $00, $1B, $00, $10, $00, $3D, $00, $44, $00, $70, $00, $70, $00, $72, $08, $73
        dc.b    $00, $70, $00, $70, $00, $46, $00, $44, $00, $24, $00, $24, $00, $2D, $08, $50
        dc.b    $08, $00, $08, $7D, $08, $7E, $08, $7F, $00, $26, $00, $26, $08, $25, $00, $59
        dc.b    $08, $7D, $03, $0B, $3D, $08, $3D, $00, $70, $00, $70, $00, $4D, $08, $15, $03
        dc.b    $07, $30, $00, $59, $00, $68, $00, $30, $03, $2B, $75, $00, $1D, $00, $67, $00
        dc.b    $61, $00, $73, $00, $75, $00, $03, $00, $53, $00, $01, $08, $50, $00, $06, $08
        dc.b    $07, $08, $05, $08, $05, $00, $53, $00, $03, $00, $30, $00, $10, $00, $10, $08
        dc.b    $1B, $08, $7A, $00, $0B, $03, $2F, $10, $00, $02, $00, $18, $00, $90, $00, $28
        dc.b    $00, $96, $00, $2E, $00, $28, $00, $28, $00, $8F, $00, $89, $00, $8D, $00, $8B
        dc.b    $08, $2B, $08, $2B, $00, $28, $00, $28, $00, $2E, $00, $2E, $00, $28, $00, $90
        dc.b    $00, $20, $08, $92, $00, $10, $02, $81, $0E, $08, $15, $00, $0F, $00, $10, $00
        dc.b    $10, $00, $66, $00, $66, $00, $F0, $00, $F0, $00, $F0, $00, $F0, $00, $F2, $00
        dc.b    $F2, $00, $10, $00, $10, $00, $43, $00, $41, $08, $42, $08, $40, $00, $41, $00
        dc.b    $43, $08, $F2, $08, $F0, $00, $10, $00, $E1, $00, $A0, $00, $51, $00, $51, $00
        dc.b    $53, $00, $53, $00, $51, $00, $51, $00, $43, $00, $D9, $00, $CB, $00, $03, $00
        dc.b    $0C, $00, $89, $00, $86, $00, $30, $00, $30, $00, $32, $00, $32, $00, $30, $00
        dc.b    $30, $00, $26, $00, $26, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
        dc.b    $10, $08, $E7, $08, $E7, $00, $F2, $00, $F2, $00, $F2, $00, $F2, $00, $F0, $00
        dc.b    $F0, $00, $86, $00, $86, $00, $10, $00, $10, $08, $3E, $08, $37, $00, $10, $00
        dc.b    $E1, $00, $89, $00, $71, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
        dc.b    $10, $00, $06, $00, $06, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
        dc.b    $10, $08, $25, $08, $25, $00, $30, $00, $30, $00, $32, $00, $32, $00, $30, $00
        dc.b    $30, $00, $80, $00, $80, $00, $10, $00, $10, $00, $82, $00, $82, $00, $10, $00
        dc.b    $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $BA, $00, $BA, $00, $0C, $00
        dc.b    $03, $08, $d3, $08, $DC, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
        dc.b    $10, $08, $45, $08, $45, $00, $43, $00, $51, $00, $41, $00, $53, $00, $53, $00
        dc.b    $51, $00, $E3, $00, $E8, $00, $E1, $00, $10, $08, $C8, $08, $D9, $00, $B0, $00
        dc.b    $59, $00, $59, $00, $B1, $00, $5B, $03, $23, $72, $00, $C1, $00, $10, $00, $10
        dc.b    $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $C4, $00, $3D
        dc.b    $00, $d4, $00, $A3, $00, $2D, $00, $5B, $00, $F9, $08, $d4, $03, $1D, $2D, $08
        dc.b    $C5, $00, $3D, $00, $3D, $08, $C4, $00, $3B, $08, $C2, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $08, $d1, $00, $39, $03, $2F, $5B, $08, $E8
        dc.b    $08, $B2, $00, $59, $08, $B0, $08, $DA, $08, $10, $00, $8B, $00, $7B, $00, $0A
        dc.b    $00, $30, $00, $10, $00, $10, $00, $16, $00, $16, $00, $EC, $00, $ED, $88, $79
        dc.b    $88, $78, $08, $87, $00, $F0, $80, $EE, $88, $88, $00, $30, $03, $01, $10, $03
        dc.b    $01, $70, $02, $80, $F4, $80, $AF, $80, $FC, $00, $10, $00, $01, $00, $11, $00
        dc.b    $01, $00, $11, $00, $01, $00, $F5, $00, $F4, $00, $10, $00, $10, $81, $1B, $81
        dc.b    $1B, $00, $10, $00, $10, $00, $12, $00, $10, $00, $10, $00, $16, $00, $10, $00
        dc.b    $16, $00, $07, $00, $07, $89, $7D, $89, $7D, $00, $F0, $00, $F0, $89, $8A, $89
        dc.b    $8A, $00, $16, $00, $14, $00, $16, $00, $14, $00, $0B, $00, $0B, $00, $0B, $00
        dc.b    $0B, $00, $09, $00, $09, $00, $09, $08, $0A, $08, $10, $00, $10, $08, $10, $08
        dc.b    $13, $00, $0B, $00, $1A, $01, $08, $00, $3B, $01, $1B, $00, $10, $00, $3F, $00
        dc.b    $16, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $13, $08
        dc.b    $13, $00, $10, $00, $10, $00, $16, $09, $34, $00, $10, $09, $1B, $08, $77, $08
        dc.b    $5E, $00, $0C, $00, $0C, $00, $0E, $00, $0E, $00, $0C, $00, $0C, $00, $0E, $00
        dc.b    $0E, $00, $08, $00, $08, $00, $0A, $00, $57, $00, $08, $00, $55, $89, $d5, $89
        dc.b    $d5, $00, $30, $00, $30, $00, $32, $00, $32, $00, $30, $00, $30, $00, $12, $00
        dc.b    $12, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $80, $00
        dc.b    $80, $00, $10, $00, $10, $88, $33, $08, $31, $00, $10, $00, $10, $08, $09, $88
        dc.b    $0B, $00, $0C, $00, $03, $08, $17, $08, $18, $00, $22, $00, $22, $08, $25, $08
        dc.b    $2A, $00, $10, $00, $1F, $08, $1E, $08, $1F, $04, $2C, $08, $78, $08, $79, $00
        dc.b    $F2, $00, $F2, $00, $F2, $00, $F2, $00, $F0, $00, $F0, $08, $80, $00, $81, $00
        dc.b    $24, $00, $24, $08, $24, $00, $25, $00, $22, $00, $22, $88, $21, $88, $23, $00
        dc.b    $10, $00, $10, $E0, $1A, $E0, $19, $04, $0C, $68, $29, $68, $21, $00, $E1, $00
        dc.b    $10, $68, $C8, $68, $31, $80, $A4, $5C, $E0, $00, $E0, $00, $E0, $00, $E0, $00
        dc.b    $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00
        dc.b    $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00
        dc.b    $E0, $00, $60, $00, $E0, $00, $60, $00, $E0, $00, $60, $00, $E0, $00, $60, $00
        dc.b    $E0, $00, $20, $00, $E0, $00, $20, $00, $60, $0A, $E0, $09, $00, $10, $00, $10
        dc.b    $00, $12, $80, $10, $00, $22, $00, $22, $08, $25, $08, $2A, $00, $10, $00, $1F
        dc.b    $68, $1F, $68, $1E, $04, $1F, $E0, $0A, $E0, $09, $00, $10, $00, $10, $60, $1A
        dc.b    $40, $19, $80, $00, $A0, $00, $40, $00, $40, $00, $40, $00, $40, $00, $A0, $00
        dc.b    $A0, $00, $A0, $00, $A0, $1B, $01, $E0, $03, $43, $E0, $00, $80, $00, $10, $03
        dc.b    $80, $00, $10, $03, $C0, $00, $E0, $00, $C0, $00, $E0, $00, $C0, $00, $E0, $00
        dc.b    $C0, $00, $E0, $00, $C0, $00, $E0, $00, $C0, $00, $E0, $00, $E0, $00, $E0, $00
        dc.b    $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $40, $00
        dc.b    $E0, $00, $E0, $00, $60, $00, $80, $00, $E0, $00, $C0, $00, $20, $03, $01, $60
        dc.b    $03, $07, $60, $00, $40, $00, $60, $00, $40, $03, $27, $C0, $00, $20, $00, $C0
        dc.b    $00, $60, $00, $80, $00, $60, $00, $80, $00, $E0, $00, $20, $00, $E0, $00, $E0
        dc.b    $00, $80, $00, $20, $00, $80, $00, $E0, $00, $C0, $00, $20, $00, $C0, $00, $20
        dc.b    $00, $40, $03, $01, $40, $03, $01, $C0, $03, $01, $C0, $03, $15, $60, $00, $80
        dc.b    $00, $60, $00, $80, $00, $C0, $00, $E0, $00, $C0, $00, $60, $00, $E0, $00, $60
        dc.b    $00, $E0, $03, $01, $E0, $37, $11, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $11
        dc.b    $11, $11, $11, $00, $11, $11, $11, $11, $05, $02, $11, $11, $02, $02, $11, $11
        dc.b    $04, $01, $11, $03, $01, $11, $03, $07, $11, $11, $11, $00, $11, $11, $11, $05
        dc.b    $02, $11, $11, $02, $02, $11, $11, $06, $02, $11, $11, $02, $02, $11, $11, $07
        dc.b    $01, $01, $03, $01, $01, $0E, $08, $11, $11, $11, $00, $11, $11, $11, $11, $07
        dc.b    $01, $11, $06, $19, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $00, $11, $0F, $11
        dc.b    $11, $BB, $F0, $EE, $22, $99, $00, $FF, $CC, $33, $FF, $00, $FF, $19, $03, $FF
        dc.b    $FF, $FF, $02, $04, $FF, $FF, $00, $FF, $80, $d5, $09, $A2, $A8, $A1, $A1, $05
        dc.b    $A8, $A1, $A1, $A7, $24, $0B, $64, $65, $66, $67, $0C, $0C, $0C, $67, $68, $69
        dc.b    $6A, $08, $11, $A0, $A1, $A1, $A1, $04, $03, $03, $03, $06, $07, $04, $07, $04
        dc.b    $07, $04, $07, $04, $02, $02, $07, $04, $02, $02, $07, $04, $02, $0A, $07, $99
        dc.b    $9E, $A2, $24, $B1, $3C, $00, $81, $8A, $25, $0C, $8B, $8C, $00, $48, $C2, $C6
        dc.b    $4B, $04, $49, $4A, $4B, $4C, $0D, $21, $7B, $74, $75, $80, $FA, $F6, $0B, $FF
        dc.b    $F1, $F6, $0B, $0A, $F0, $F4, $F4, $F7, $F0, $F4, $F4, $F7, $F0, $F4, $F4, $F7
        dc.b    $2E, $2F, $81, $06, $24, $AF, $00, $84, $8A, $08, $18, $02, $03, $04, $05, $02
        dc.b    $03, $04, $05, $02, $03, $04, $05, $02, $03, $04, $05, $02, $03, $04, $05, $02
        dc.b    $03, $04, $05, $05, $0C, $8D, $8E, $8F, $90, $DC, $DC, $DC, $C4, $51, $52, $53
        dc.b    $54, $05, $2A, $A9, $AA, $AB, $AC, $04, $AA, $AB, $AC, $d6, $7C, $7D, $83, $FF
        dc.b    $FE, $FB, $04, $F4, $FE, $FB, $FA, $F3, $FF, $F9, $FF, $F3, $FF, $F9, $FF, $F3
        dc.b    $FF, $F9, $FF, $2D, $2C, $84, $FB, $d6, $2A, $00, $79, $78, $85, $06, $1A, $09
        dc.b    $0A, $0B, $0C, $04, $04, $0B, $0C, $04, $04, $0B, $0C, $04, $04, $0B, $0C, $04
        dc.b    $04, $0B, $0C, $04, $04, $0B, $0C, $0D, $0E, $07, $09, $40, $41, $42, $43, $04
        dc.b    $41, $42, $43, $44, $0D, $22, $7B, $71, $72, $88, $F2, $F3, $F4, $0F, $F9, $F3
        dc.b    $F4, $F5, $F8, $F9, $FB, $F0, $F8, $F9, $FB, $F0, $F8, $F9, $FB, $F0, $26, $27
        dc.b    $89, $02, $2F, $25, $00, $80, $81, $8A, $05, $1C, $10, $11, $12, $13, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $14, $15, $16, $17, $06, $09, $48, $49, $4A, $4B, $04, $49, $4A, $4B
        dc.b    $4C, $02, $07, $60, $61, $62, $00, $60, $61, $62, $02, $24, $73, $6C, $79, $7A
        dc.b    $05, $1B, $12, $16, $1B, $0F, $12, $16, $1B, $0F, $12, $16, $1B, $0F, $12, $16
        dc.b    $1B, $0F, $12, $16, $0F, $CD, $C5, $C3, $79, $39, $2A, $25, $00, $83, $84, $8A
        dc.b    $05, $1F, $18, $19, $1A, $1B, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $1B, $1A, $19, $1F, $07, $07
        dc.b    $07, $03, $09, $50, $51, $52, $53, $04, $51, $52, $53, $54, $02, $07, $55, $5F
        dc.b    $63, $00, $55, $5F, $63, $02, $25, $7B, $74, $81, $82, $05, $0B, $F1, $F6, $0B
        dc.b    $FF, $F1, $F6, $0B, $FF, $F1, $F6, $0B, $FF, $F1, $F6, $0B, $FF, $F1, $F6, $FF
        dc.b    $FD, $DE, $DB, $81, $FB, $d7, $d7, $85, $79, $79, $78, $85, $04, $1F, $20, $21
        dc.b    $22, $23, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $44, $44, $44, $27, $60, $61, $62, $04, $0A, $59
        dc.b    $5A, $5B, $00, $CC, $CC, $5B, $00, $95, $96, $09, $25, $7B, $7C, $84, $82, $FD
        dc.b    $FB, $F4, $FE, $FB, $04, $F4, $FE, $FB, $04, $F4, $FE, $FB, $04, $F4, $FE, $FB
        dc.b    $04, $F4, $FE, $02, $05, $DE, $d3, $84, $02, $2E, $2E, $8A, $80, $80, $81, $8A
        dc.b    $04, $1F, $28, $29, $2A, $2B, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $79, $72, $4D, $2F, $55, $5F
        dc.b    $63, $05, $09, $3F, $91, $92, $93, $AB, $91, $92, $93, $94, $09, $25, $7B, $71
        dc.b    $89, $82, $FD, $F6, $F9, $F3, $F4, $0F, $F9, $F3, $F4, $0F, $F9, $F3, $F4, $0F
        dc.b    $F9, $F3, $F4, $0F, $F9, $F3, $0F, $05, $C0, $C0, $89, $01, $33, $35, $8A, $83
        dc.b    $83, $84, $8A, $07, $02, $01, $06, $02, $02, $01, $06, $02, $02, $30, $37, $02
        dc.b    $02, $30, $37, $02, $02, $01, $06, $02, $02, $01, $06, $0A, $3A, $B9, $58, $44
        dc.b    $00, $B9, $58, $44, $40, $4E, $4F, $44, $40, $4E, $4F, $44, $73, $6C, $6D, $78
        dc.b    $0A, $16, $06, $14, $14, $02, $12, $16, $1B, $0F, $12, $16, $1B, $0F, $12, $16
        dc.b    $1B, $0F, $12, $16, $1B, $1B, $F3, $F5, $F7, $CF, $3B, $A4, $9A, $1E, $1E, $80
        dc.b    $BD, $01, $05, $BD, $BD, $BC, $B8, $05, $02, $08, $0F, $02, $02, $08, $0F, $02
        dc.b    $02, $31, $36, $02, $02, $31, $36, $02, $02, $08, $0F, $02, $02, $08, $0F, $04
        dc.b    $40, $40, $58, $44, $40, $18, $1C, $0C, $1C, $14, $44, $48, $5C, $4C, $48, $56
        dc.b    $57, $4C, $48, $56, $57, $4C, $7B, $74, $75, $80, $FA, $F6, $05, $F4, $F4, $02
        dc.b    $F1, $F6, $0B, $FF, $F1, $F6, $0B, $FF, $F1, $F6, $0B, $FF, $F1, $F6, $0B, $0A
        dc.b    $EB, $74, $E8, $C7, $28, $B6, $9D, $C7, $C6, $36, $80, $F4, $FF, $80, $80, $81
        dc.b    $8A, $04, $18, $32, $33, $34, $35, $32, $33, $34, $35, $32, $33, $34, $35, $32
        dc.b    $33, $34, $35, $32, $33, $34, $35, $32, $33, $34, $35, $03, $44, $48, $5C, $4C
        dc.b    $48, $14, $10, $1C, $76, $08, $4C, $50, $3E, $54, $45, $46, $47, $4D, $45, $46
        dc.b    $47, $4D, $7B, $7C, $7D, $83, $FF, $FE, $0D, $FF, $F9, $01, $F4, $FE, $FB, $04
        dc.b    $F4, $FE, $FB, $04, $F4, $FE, $FB, $04, $F4, $FE, $FB, $10, $EC, $7C, $E3, $23
        dc.b    $29, $B6, $9E, $C9, $C8, $35, $83, $F9, $BF, $BB, $BA, $BD, $FB, $01, $00, $F9
        dc.b    $F9, $02, $05, $F9, $F9, $00, $F9, $F9, $02, $02, $F9, $F9, $09, $13, $F9, $F9
        dc.b    $00, $03, $C7, $C7, $3E, $6A, $39, $53, $57, $6E, $6A, $53, $6F, $39, $53, $00
        dc.b    $38, $02, $02, $5A, $59, $02, $06, $5A, $66, $3E, $3E, $3E, $01, $19, $09, $D9
        dc.b    $DD, $a6, $03, $E0, $DD, $a6, $03, $39, $1C, $04, $82, $82, $82, $82, $1C, $04
        dc.b    $BB, $BB, $BB, $BB, $7A, $00, $0C, $d6, $0A, $00, $10, $00, $3D, $00, $11, $00
        dc.b    $3D, $00, $01, $04, $64, $61, $0D, $61, $0E, $00, $10, $00, $10, $00, $12, $08
        dc.b    $13, $00, $10, $00, $10, $00, $12, $08, $10, $00, $11, $08, $11, $00, $11, $08
        dc.b    $35, $00, $35, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $08
        dc.b    $17, $00, $10, $00, $10, $00, $11, $08, $12, $00, $10, $00, $10, $08, $13, $08
        dc.b    $13, $00, $10, $00, $10, $00, $15, $00, $17, $00, $10, $00, $10, $00, $12, $00
        dc.b    $37, $00, $10, $00, $35, $08, $13, $08, $13, $00, $10, $08, $04, $08, $11, $00
        dc.b    $05, $08, $04, $00, $10, $00, $22, $08, $37, $04, $04, $08, $EA, $08, $EA, $04
        dc.b    $02, $08, $EA, $08, $02, $08, $EA, $09, $1F, $5B, $00, $5A, $00, $5B, $00, $5A
        dc.b    $00, $55, $00, $54, $00, $55, $00, $54, $00, $57, $00, $56, $00, $57, $00, $56
        dc.b    $00, $51, $00, $50, $08, $BB, $00, $50, $04, $04, $08, $EA, $00, $5D, $03, $25
        dc.b    $30, $00, $5C, $00, $32, $00, $30, $00, $45, $00, $05, $00, $72, $00, $10, $00
        dc.b    $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $1E, $00, $1E, $00, $10, $00
        dc.b    $10, $00, $6F, $00, $6E, $05, $0D, $7B, $00, $7A, $00, $10, $00, $10, $00, $71
        dc.b    $00, $70, $00, $73, $03, $0D, $2D, $00, $2D, $00, $30, $00, $10, $00, $42, $08
        dc.b    $3D, $00, $10, $03, $2D, $B5, $08, $88, $00, $89, $00, $10, $00, $8B, $00, $12
        dc.b    $00, $10, $00, $10, $00, $1E, $00, $1E, $00, $10, $00, $10, $00, $12, $00, $8E
        dc.b    $00, $10, $00, $8C, $00, $16, $00, $16, $00, $10, $00, $10, $00, $12, $00, $90
        dc.b    $00, $10, $03, $03, $93, $00, $7D, $03, $1F, $F0, $00, $7C, $00, $F2, $00, $F0
        dc.b    $00, $F0, $00, $25, $00, $27, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10
        dc.b    $00, $10, $00, $1E, $00, $A0, $00, $10, $03, $15, $12, $00, $BC, $00, $10, $00
        dc.b    $10, $00, $16, $00, $16, $00, $10, $00, $10, $00, $12, $00, $B0, $00, $10, $03
        dc.b    $0D, $CD, $00, $59, $00, $F0, $08, $43, $00, $d6, $00, $1A, $08, $67, $02, $7E
        dc.b    $08, $F6, $08, $C8, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10
        dc.b    $00, $1E, $00, $1E, $00, $10, $00, $10, $00, $CF, $00, $12, $00, $CD, $00, $10
        dc.b    $00, $16, $00, $16, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10
        dc.b    $00, $FC, $00, $4F, $00, $10, $00, $30, $00, $A3, $00, $B7, $00, $30, $00, $B5
        dc.b    $00, $45, $00, $47, $00, $E9, $00, $10, $00, $EB, $00, $12, $00, $10, $00, $10
        dc.b    $00, $1E, $00, $1E, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $08, $13
        dc.b    $00, $16, $08, $15, $08, $1B, $08, $1B, $08, $19, $08, $19, $08, $1B, $00, $E2
        dc.b    $08, $66, $08, $1A, $00, $30, $00, $d7, $08, $0A, $00, $CD, $00, $10, $02, $04
        dc.b    $08, $B4, $08, $67, $03, $0F, $10, $00, $66, $00, $24, $00, $10, $00, $30, $00
        dc.b    $24, $00, $79, $00, $30, $03, $03, $78, $08, $48, $03, $0F, $30, $08, $49, $00
        dc.b    $04, $00, $30, $00, $10, $00, $04, $08, $76, $00, $10, $02, $14, $08, $d3, $00
        dc.b    $BD, $00, $10, $00, $70, $00, $08, $00, $72, $00, $70, $00, $70, $00, $CC, $00
        dc.b    $32, $03, $27, $0B, $00, $FC, $00, $09, $00, $0D, $00, $0F, $00, $0F, $00, $09
        dc.b    $00, $0D, $00, $0B, $08, $0A, $08, $0C, $00, $0B, $00, $0D, $00, $0D, $00, $0F
        dc.b    $00, $0F, $00, $0D, $00, $0D, $08, $F1, $00, $0B, $02, $0E, $08, $48, $08, $DC
        dc.b    $00, $70, $00, $30, $08, $13, $00, $EC, $00, $30, $02, $04, $08, $ED, $08, $72
        dc.b    $03, $27, $98, $00, $82, $00, $78, $00, $68, $00, $78, $00, $48, $00, $58, $00
        dc.b    $48, $00, $58, $08, $58, $08, $48, $08, $58, $08, $48, $08, $78, $08, $68, $08
        dc.b    $78, $08, $68, $08, $98, $00, $EA, $08, $98, $03, $0B, $37, $00, $DC, $00, $30
        dc.b    $00, $30, $00, $F7, $00, $F6, $04, $04, $08, $00, $08, $C4, $03, $07, $30, $00
        dc.b    $C5, $00, $EE, $00, $30, $02, $04, $68, $E2, $68, $0D, $1C, $05, $01, $00, $01
        dc.b    $00, $01, $03, $01, $01, $07, $03, $09, $00, $09, $1D, $03, $60, $00, $08, $05
        dc.b    $03, $69, $00, $01, $15, $03, $09, $00, $09, $1D, $03, $60, $00, $60, $07, $01
        dc.b    $68, $03, $09, $01, $00, $68, $00, $01, $00, $01, $00, $01, $09, $03, $09, $00
        dc.b    $09, $1D, $03, $60, $00, $60, $07, $01, $68, $05, $03, $68, $00, $01, $05, $01
        dc.b    $01, $07, $03, $69, $00, $69, $2D, $03, $68, $00, $68, $0D, $03, $68, $00, $68
        dc.b    $2D, $03, $68, $00, $68, $0D, $03, $61, $00, $61, $0D, $05, $61, $00, $61, $00
        dc.b    $61, $03, $01, $61, $03, $23, $61, $00, $61, $00, $61, $00, $61, $00, $61, $00
        dc.b    $61, $00, $61, $00, $61, $00, $61, $00, $61, $00, $61, $00, $61, $00, $61, $00
        dc.b    $61, $00, $61, $00, $61, $00, $61, $00, $61, $51, $01, $80, $07, $01, $80, $0F
        dc.b    $03, $80, $00, $80, $15, $03, $80, $00, $80, $15, $03, $60, $00, $60, $05, $03
        dc.b    $60, $00, $60, $19, $01, $60, $03, $01, $60, $2D, $01, $60, $03, $01, $60, $1D
        dc.b    $03, $60, $00, $60, $81, $2D, $49, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0
        dc.b    $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0
        dc.b    $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0
        dc.b    $00, $60, $00, $E0, $00, $60, $00, $E0, $00, $60, $00, $E0, $00, $60, $00, $E0
        dc.b    $00, $20, $00, $E0, $00, $20, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0
        dc.b    $03, $01, $E0, $03, $01, $60, $03, $01, $60, $0D, $01, $40, $03, $19, $40, $00
        dc.b    $80, $00, $A0, $00, $80, $00, $A0, $00, $40, $00, $40, $00, $40, $00, $40, $00
        dc.b    $A0, $00, $A0, $00, $A0, $00, $A0, $1B, $01, $E0, $03, $43, $E0, $00, $80, $00
        dc.b    $E0, $00, $80, $00, $E0, $00, $C0, $00, $E0, $00, $C0, $00, $E0, $00, $C0, $00
        dc.b    $E0, $00, $C0, $00, $E0, $00, $C0, $00, $E0, $00, $C0, $00, $E0, $00, $E0, $00
        dc.b    $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00, $E0, $00
        dc.b    $40, $00, $E0, $00, $E0, $00, $60, $00, $80, $00, $E0, $00, $C0, $00, $20, $03
        dc.b    $01, $60, $03, $07, $60, $00, $40, $00, $60, $00, $40, $03, $27, $C0, $00, $20
        dc.b    $00, $C0, $00, $60, $00, $80, $00, $60, $00, $80, $00, $E0, $00, $20, $00, $E0
        dc.b    $00, $E0, $00, $80, $00, $20, $00, $80, $00, $E0, $00, $C0, $00, $20, $00, $C0
        dc.b    $00, $20, $00, $40, $03, $01, $40, $03, $01, $C0, $03, $01, $C0, $03, $15, $60
        dc.b    $00, $80, $00, $60, $00, $80, $00, $C0, $00, $E0, $00, $C0, $00, $60, $00, $E0
        dc.b    $00, $60, $00, $E0, $03, $01, $E0, $81, $3C, $04, $0D, $0D, $0D, $0D, $28, $04
        dc.b    $0D, $0D, $0D, $0D, $0D, $0A, $0D, $0D, $04, $0B, $01, $07, $09, $06, $01, $07
        dc.b    $02, $0E, $0E, $0C, $0F, $0E, $0E, $0C, $06, $08, $01, $07, $09, $06, $01, $07
        dc.b    $08, $08, $0E, $0C, $0F, $0E, $0E, $0C, $0F, $0E, $02, $04, $0D, $0D, $0D, $0D
        dc.b    $0D, $04, $0D, $0D, $0D, $0D, $06, $0C, $09, $08, $0B, $0A, $0C, $03, $0F, $0D
        dc.b    $05, $0B, $04, $07, $0A, $10, $09, $08, $0B, $0A, $0C, $03, $0F, $0D, $05, $0B
        dc.b    $04, $07, $0D, $0D, $0D, $0D, $0D, $10, $04, $0B, $0C, $0A, $09, $06, $01, $1A
        dc.b    $1C, $1F, $1E, $04, $1C, $1F, $1E, $19, $0A, $08, $09, $06, $01, $07, $09, $06
        dc.b    $01, $07, $04, $0A, $09, $06, $01, $07, $09, $06, $0C, $0A, $0D, $0D, $0D, $04
        dc.b    $0D, $0D, $0D, $0D, $03, $0A, $15, $14, $17, $16, $04, $04, $17, $16, $11, $10
        dc.b    $1B, $04, $0D, $0D, $0D, $0D, $0D, $04, $0D, $0D, $0D, $0D, $03, $0A, $2D, $2C
        dc.b    $2F, $2E, $04, $04, $2F, $2E, $29, $28, $05, $10, $0E, $0C, $0F, $0E, $0E, $0C
        dc.b    $0F, $0E, $09, $06, $01, $07, $09, $06, $01, $07, $06, $04, $0D, $0D, $0D, $0D
        dc.b    $0D, $04, $0D, $0D, $0D, $0D, $03, $0A, $25, $24, $27, $26, $04, $04, $27, $26
        dc.b    $21, $20, $03, $0C, $09, $08, $0B, $0A, $0C, $03, $0F, $0D, $05, $0B, $04, $07
        dc.b    $0C, $04, $0D, $0D, $0D, $0D, $0D, $1A, $03, $01, $02, $03, $0E, $0C, $0F, $33
        dc.b    $3C, $3F, $3E, $04, $04, $3F, $37, $3F, $39, $07, $12, $1C, $12, $15, $1B, $1A
        dc.b    $13, $12, $0C, $0A, $0E, $0C, $0F, $0E, $0E, $0C, $02, $03, $0D, $0D, $0D, $1A
        dc.b    $06, $07, $08, $06, $0F, $0D, $05, $3E, $30, $30, $36, $04, $04, $37, $36, $31
        dc.b    $30, $00, $2B, $2A, $23, $22, $2B, $2A, $23, $22, $0A, $0C, $09, $08, $0B, $0A
        dc.b    $0C, $03, $0F, $0D, $08, $06, $09, $0A, $0D, $04, $0D, $0D, $0D, $0D, $03, $19
        dc.b    $4D, $4C, $4F, $4E, $04, $04, $4F, $4E, $49, $48, $00, $3B, $3A, $33, $32, $3B
        dc.b    $3A, $3A, $34, $01, $07, $09, $06, $01, $07, $0C, $04, $0D, $0D, $0D, $0D, $0D
        dc.b    $04, $0D, $0D, $0D, $0D, $03, $13, $45, $44, $47, $46, $04, $04, $47, $46, $41
        dc.b    $40, $00, $4B, $4A, $43, $42, $4B, $4A, $43, $42, $12, $04, $0D, $0D, $0D, $0D
        dc.b    $0D, $04, $0D, $0D, $0D, $0D, $03, $13, $5D, $5C, $5F, $5E, $04, $04, $5F, $5E
        dc.b    $59, $58, $00, $5B, $5A, $55, $54, $5B, $5A, $55, $54, $12, $04, $0D, $0D, $0D
        dc.b    $0D, $80, $C4, $00, $00, $00, $0A, $20, $06, $66, $08, $88, $0C, $AA, $0E, $CC
        dc.b    $02, $46, $00, $08, $00, $0E, $04, $6A, $06, $8C, $08, $CE, $0E, $22, $0E, $62
        dc.b    $00, $00, $0E, $EE, $00, $00, $06, $22, $06, $44, $08, $66, $0A, $88, $0C, $CC
        dc.b    $02, $26, $04, $6E, $08, $AE, $00, $EE, $00, $0A, $02, $4C, $00, $6E, $00, $AE
        dc.b    $00, $00, $0E, $EE, $00, $00, $00, $26, $02, $48, $0A, $40, $0E, $60, $04, $44
        dc.b    $08, $66, $0A, $88, $00, $4E, $00, $CE, $00, $0A, $02, $82, $02, $C2, $04, $E2
        dc.b    $00, $00, $0E, $EE, $00, $00, $04, $EE, $04, $CE, $04, $8C, $02, $68, $00, $46
        dc.b    $02, $60, $0C, $88, $0C, $CA, $02, $28, $0E, $86, $02, $80, $00, $C0, $02, $E2
        dc.b    $00, $00, $0E, $EE, $20, $00, $00, $20, $05, $33, $33, $33, $33, $10, $02, $05
        dc.b    $01, $01, $07, $00, $10, $02, $01, $70, $05, $02, $01, $70, $02, $01, $10, $02
        dc.b    $0C, $10, $07, $00, $07, $01, $07, $77, $00, $77, $11, $00, $70, $02, $02, $10
        dc.b    $07, $02, $03, $01, $17, $77, $02, $01, $07, $03, $0E, $10, $11, $00, $11, $01
        dc.b    $00, $11, $00, $10, $33, $77, $77, $61, $22, $02, $0B, $70, $01, $00, $07, $01
        dc.b    $10, $00, $70, $10, $00, $70, $03, $08, $07, $01, $00, $03, $10, $00, $03, $30
        dc.b    $02, $09, $30, $00, $10, $01, $25, $55, $11, $10, $07, $02, $03, $01, $10, $70
        dc.b    $02, $01, $01, $05, $01, $33, $02, $03, $07, $00, $30, $04, $06, $01, $01, $55
        dc.b    $56, $67, $76, $0C, $01, $77, $02, $07, $07, $00, $70, $00, $70, $11, $17, $05
        dc.b    $05, $01, $66, $67, $00, $76, $05, $04, $77, $77, $70, $77, $02, $0A, $07, $00
        dc.b    $01, $11, $10, $01, $10, $00, $01, $10, $05, $06, $33, $30, $66, $66, $55, $56
        dc.b    $0C, $01, $77, $02, $07, $07, $00, $70, $00, $70, $11, $07, $03, $01, $10, $02
        dc.b    $03, $66, $67, $07, $02, $06, $07, $70, $11, $00, $70, $11, $02, $03, $01, $00
        dc.b    $03, $03, $03, $30, $70, $01, $07, $10, $70, $10, $30, $07, $70, $01, $12, $11
        dc.b    $11, $11, $11, $03, $33, $33, $33, $30, $13, $06, $22, $22, $22, $22, $11, $10
        dc.b    $02, $08, $30, $01, $11, $00, $03, $33, $30, $11, $02, $01, $03, $04, $01, $30
        dc.b    $08, $05, $25, $55, $55, $56, $07, $04, $03, $77, $00, $07, $02, $07, $70, $70
        dc.b    $10, $00, $07, $00, $01, $02, $01, $01, $08, $0B, $66, $70, $00, $01, $00, $07
        dc.b    $00, $11, $77, $70, $70, $02, $0F, $07, $00, $10, $11, $00, $77, $01, $00, $10
        dc.b    $07, $70, $33, $01, $00, $07, $04, $04, $33, $00, $11, $66, $09, $02, $03, $33
        dc.b    $02, $13, $30, $80, $33, $10, $00, $08, $80, $01, $30, $80, $08, $00, $03, $08
        dc.b    $00, $11, $00, $33, $BB, $04, $01, $03, $04, $01, $33, $02, $15, $03, $00, $33
        dc.b    $33, $30, $33, $00, $03, $03, $00, $33, $31, $80, $30, $00, $10, $A2, $21, $11
        dc.b    $00, $10, $02, $02, $07, $01, $02, $01, $07, $03, $17, $70, $01, $00, $77, $70
        dc.b    $10, $77, $77, $11, $07, $07, $01, $33, $74, $00, $13, $00, $40, $40, $00, $88
        dc.b    $00, $03, $04, $02, $10, $80, $02, $01, $03, $03, $01, $30, $03, $02, $01, $38
        dc.b    $02, $02, $03, $13, $03, $0F, $31, $44, $45, $54, $47, $01, $10, $00, $07, $15
        dc.b    $50, $10, $70, $50, $50, $04, $01, $07, $02, $03, $01, $00, $01, $02, $03, $70
        dc.b    $10, $05, $02, $0B, $03, $46, $66, $12, $30, $70, $10, $30, $00, $01, $03, $06
        dc.b    $02, $10, $30, $02, $01, $03, $03, $01, $30, $06, $07, $03, $33, $23, $00, $03
        dc.b    $30, $10, $06, $03, $03, $00, $30, $07, $03, $03, $00, $03, $02, $09, $33, $30
        dc.b    $00, $03, $33, $33, $30, $02, $33, $06, $01, $01, $02, $01, $30, $06, $01, $33
        dc.b    $06, $09, $01, $33, $00, $01, $10, $33, $00, $17, $01, $06, $01, $07, $02, $03
        dc.b    $01, $00, $01, $04, $05, $01, $01, $11, $00, $11, $02, $02, $11, $10, $04, $03
        dc.b    $03, $33, $33, $09, $01, $03, $02, $01, $10, $05, $0E, $30, $00, $01, $10, $03
        dc.b    $00, $10, $01, $10, $33, $01, $11, $06, $11, $06, $01, $07, $02, $01, $01, $06
        dc.b    $09, $01, $01, $10, $00, $11, $00, $01, $00, $10, $02, $08, $10, $11, $61, $10
        dc.b    $01, $00, $07, $01, $02, $0C, $70, $70, $10, $00, $07, $61, $11, $00, $11, $00
        dc.b    $01, $01, $02, $04, $33, $10, $00, $33, $02, $01, $03, $02, $02, $33, $30, $02
        dc.b    $01, $30, $03, $02, $03, $30, $03, $02, $03, $33, $02, $0A, $01, $00, $33, $33
        dc.b    $01, $11, $11, $00, $33, $11, $03, $02, $30, $10, $02, $02, $03, $01, $06, $01
        dc.b    $03, $02, $04, $33, $30, $00, $33, $02, $06, $11, $11, $11, $11, $00, $70, $03
        dc.b    $08, $77, $77, $77, $77, $16, $77, $77, $77, $04, $01, $01, $03, $01, $10, $02
        dc.b    $01, $70, $02, $0C, $07, $47, $00, $07, $74, $00, $07, $70, $40, $04, $74, $44
        dc.b    $02, $13, $62, $23, $34, $40, $11, $17, $70, $00, $11, $07, $00, $40, $30, $10
        dc.b    $70, $00, $33, $17, $70, $02, $04, $17, $04, $00, $13, $03, $03, $31, $17, $40
        dc.b    $02, $0E, $06, $21, $11, $03, $01, $03, $33, $00, $70, $11, $03, $00, $47, $70
        dc.b    $02, $03, $04, $43, $13, $03, $01, $31, $03, $01, $03, $04, $11, $12, $22, $22
        dc.b    $34, $03, $30, $01, $00, $88, $03, $00, $70, $00, $80, $00, $04, $80, $03, $18
        dc.b    $38, $80, $00, $40, $13, $03, $17, $00, $36, $21, $74, $00, $04, $70, $72, $11
        dc.b    $00, $47, $01, $33, $00, $04, $77, $10, $02, $02, $44, $71, $03, $01, $40, $03
        dc.b    $01, $07, $03, $01, $04, $05, $17, $05, $55, $44, $00, $50, $11, $77, $55, $11
        dc.b    $77, $11, $01, $77, $11, $03, $00, $01, $03, $30, $17, $10, $30, $88, $02, $01
        dc.b    $08, $02, $01, $03, $02, $08, $46, $65, $2B, $B8, $00, $07, $00, $03, $06, $01
        dc.b    $01, $08, $05, $10, $00, $07, $00, $01, $02, $06, $70, $00, $14, $55, $52, $11
        dc.b    $02, $01, $03, $04, $07, $01, $30, $00, $30, $11, $03, $33, $04, $01, $01, $02
        dc.b    $13, $01, $17, $00, $11, $10, $77, $01, $01, $12, $52, $22, $10, $30, $08, $00
        dc.b    $03, $08, $80, $80, $04, $04, $30, $80, $00, $80, $04, $01, $30, $02, $01, $80
        dc.b    $04, $04, $30, $88, $8B, $A2, $02, $02, $03, $10, $03, $01, $31, $07, $01, $03
        dc.b    $0C, $04, $33, $00, $03, $33, $02, $03, $03, $00, $10, $02, $06, $30, $10, $30
        dc.b    $00, $03, $01, $04, $01, $03, $03, $01, $10, $04, $0C, $30, $00, $01, $01, $12
        dc.b    $23, $00, $10, $00, $01, $00, $01, $05, $01, $01, $02, $03, $10, $00, $30, $07
        dc.b    $01, $03, $02, $05, $01, $33, $33, $31, $10, $02, $03, $03, $01, $10, $02, $06
        dc.b    $30, $10, $30, $00, $03, $01, $04, $01, $03, $03, $01, $10, $04, $05, $30, $00
        dc.b    $11, $13, $30, $05, $01, $11, $03, $01, $01, $03, $02, $30, $03, $02, $01, $03
        dc.b    $04, $02, $30, $30, $02, $02, $03, $03, $03, $02, $33, $03, $03, $01, $03, $17
        dc.b    $0B, $03, $22, $55, $54, $12, $10, $70, $01, $50, $01, $07, $02, $04, $30, $10
        dc.b    $00, $10, $02, $02, $70, $05, $04, $01, $30, $04, $12, $10, $70, $10, $66, $77
        dc.b    $11, $55, $77, $77, $11, $50, $11, $10, $70, $15, $33, $01, $07, $02, $03, $30
        dc.b    $10, $01, $03, $07, $70, $00, $30, $01, $00, $33, $33, $02, $18, $22, $14, $77
        dc.b    $70, $00, $50, $11, $77, $05, $11, $77, $11, $51, $77, $11, $03, $00, $01, $03
        dc.b    $30, $17, $10, $30, $88, $02, $01, $08, $02, $01, $03, $02, $14, $07, $65, $5D
        dc.b    $DD, $77, $77, $77, $77, $11, $11, $11, $11, $33, $33, $33, $30, $88, $88, $00
        dc.b    $03, $02, $01, $80, $07, $19, $80, $00, $DC, $C9, $14, $45, $71, $15, $50, $10
        dc.b    $07, $71, $01, $77, $11, $07, $17, $11, $00, $10, $00, $03, $30, $00, $71, $02
        dc.b    $04, $01, $00, $30, $03, $03, $13, $55, $66, $77, $41, $77, $77, $71, $15, $11
        dc.b    $10, $07, $01, $33, $01, $10, $77, $00, $30, $01, $06, $05, $33, $30, $10, $33
        dc.b    $30, $02, $04, $61, $30, $0B, $BA, $05, $01, $03, $04, $01, $08, $02, $01, $10
        dc.b    $02, $48, $17, $00, $30, $80, $00, $01, $03, $08, $00, $70, $10, $33, $54, $17
        dc.b    $76, $61, $00, $01, $00, $07, $00, $50, $10, $07, $00, $50, $17, $71, $05, $01
        dc.b    $70, $10, $00, $10, $01, $03, $50, $07, $10, $30, $01, $00, $03, $08, $67, $77
        dc.b    $65, $2A, $77, $70, $00, $70, $77, $77, $77, $77, $11, $00, $11, $07, $00, $11
        dc.b    $00, $11, $33, $33, $33, $00, $88, $88, $00, $33, $02, $07, $88, $00, $B8, $80
        dc.b    $00, $88, $03, $03, $02, $11, $38, $02, $19, $70, $03, $88, $00, $77, $10, $33
        dc.b    $88, $17, $71, $10, $33, $01, $70, $01, $10, $30, $10, $00, $10, $03, $32, $22
        dc.b    $30, $88, $02, $32, $31, $00, $80, $03, $01, $00, $80, $03, $33, $88, $00, $33
        dc.b    $30, $33, $33, $03, $30, $00, $33, $30, $08, $33, $00, $88, $80, $22, $22, $BB
        dc.b    $88, $11, $00, $10, $30, $00, $10, $01, $03, $30, $01, $00, $10, $03, $00, $07
        dc.b    $01, $00, $30, $17, $70, $88, $02, $01, $07, $04, $05, $88, $30, $10, $07, $03
        dc.b    $03, $15, $30, $01, $07, $07, $00, $10, $70, $00, $11, $07, $07, $77, $00, $07
        dc.b    $70, $11, $70, $11, $01, $03, $71, $02, $1A, $30, $01, $11, $10, $00, $11, $00
        dc.b    $10, $30, $00, $10, $01, $03, $33, $01, $00, $10, $00, $30, $07, $01, $00, $03
        dc.b    $17, $70, $88, $02, $01, $07, $04, $04, $88, $00, $31, $65, $02, $02, $03, $03
        dc.b    $04, $01, $33, $04, $07, $33, $33, $00, $11, $11, $10, $03, $02, $04, $10, $30
        dc.b    $00, $01, $02, $12, $22, $23, $33, $33, $30, $00, $33, $01, $03, $33, $00, $01
        dc.b    $00, $03, $33, $33, $33, $30, $03, $04, $88, $88, $00, $08, $03, $01, $80, $03
        dc.b    $0E, $BA, $AD, $DC, $44, $10, $07, $01, $00, $11, $00, $70, $10, $00, $10, $02
        dc.b    $01, $30, $0B, $01, $30, $03, $07, $03, $32, $26, $71, $30, $00, $30, $03, $01
        dc.b    $01, $02, $17, $03, $00, $70, $00, $30, $10, $01, $33, $01, $07, $00, $11, $10
        dc.b    $70, $15, $00, $77, $01, $00, $70, $65, $5C, $C9, $05, $01, $03, $04, $01, $08
        dc.b    $02, $01, $10, $02, $10, $17, $00, $30, $80, $00, $01, $03, $08, $00, $70, $10
        dc.b    $33, $CD, $D2, $23, $33, $05, $01, $08, $08, $01, $80, $03, $0E, $80, $03, $80
        dc.b    $08, $00, $33, $08, $80, $33, $30, $00, $33, $10, $33, $02, $08, $01, $10, $03
        dc.b    $01, $00, $13, $00, $10, $02, $0C, $30, $11, $10, $03, $03, $33, $01, $11, $30
        dc.b    $00, $30, $10, $02, $07, $03, $01, $30, $00, $33, $01, $30, $04, $01, $03, $03
        dc.b    $04, $30, $00, $10, $33, $02, $01, $07, $02, $2E, $11, $70, $11, $11, $07, $01
        dc.b    $00, $77, $70, $10, $36, $07, $77, $77, $00, $07, $00, $11, $05, $10, $70, $00
        dc.b    $05, $01, $07, $70, $50, $11, $77, $77, $01, $77, $00, $07, $17, $01, $11, $11
        dc.b    $00, $10, $33, $33, $17, $11, $30, $88, $0C, $0C, $01, $70, $13, $80, $50, $07
        dc.b    $01, $38, $05, $10, $70, $13, $02, $0E, $70, $10, $99, $45, $AA, $B3, $00, $80
        dc.b    $88, $88, $00, $08, $03, $38, $02, $02, $83, $03, $04, $06, $80, $00, $08, $30
        dc.b    $38, $80, $02, $03, $30, $08, $88, $02, $05, $32, $22, $33, $00, $01, $07, $0D
        dc.b    $01, $70, $03, $33, $17, $00, $10, $11, $00, $07, $01, $00, $70, $02, $09, $10
        dc.b    $70, $10, $70, $32, $AD, $CD, $DA, $08, $06, $24, $08, $08, $00, $08, $80, $30
        dc.b    $88, $83, $33, $03, $33, $31, $11, $11, $11, $10, $11, $07, $70, $11, $3B, $AD
        dc.b    $51, $01, $5D, $08, $30, $10, $00, $83, $01, $07, $00, $30, $10, $70, $02, $13
        dc.b    $11, $77, $70, $00, $33, $10, $07, $3B, $80, $01, $00, $88, $83, $01, $00, $A3
        dc.b    $30, $01, $22, $04, $01, $01, $02, $10, $30, $70, $10, $01, $13, $07, $01, $10
        dc.b    $01, $00, $77, $00, $11, $00, $07, $01, $03, $08, $10, $00, $DD, $52, $01, $66
        dc.b    $08, $03, $02, $24, $80, $30, $17, $00, $03, $11, $70, $00, $30, $11, $77, $70
        dc.b    $00, $33, $10, $07, $3B, $80, $01, $00, $88, $83, $01, $00, $A2, $20, $01, $22
        dc.b    $70, $01, $00, $30, $07, $00, $10, $03, $02, $06, $10, $00, $07, $01, $00, $03
        dc.b    $02, $05, $03, $30, $00, $10, $30, $02, $01, $03, $02, $18, $DA, $B8, $80, $03
        dc.b    $80, $00, $80, $30, $38, $88, $33, $00, $03, $33, $00, $11, $33, $00, $01, $07
        dc.b    $00, $33, $01, $17, $08, $05, $33, $22, $66, $66, $01, $02, $15, $10, $10, $07
        dc.b    $00, $05, $07, $70, $01, $50, $70, $01, $15, $00, $70, $01, $05, $00, $07, $00
        dc.b    $10, $50, $02, $04, $01, $00, $10, $70, $02, $04, $01, $07, $00, $05, $03, $01
        dc.b    $10, $02, $01, $70, $05, $01, $01, $05, $19, $70, $00, $10, $07, $00, $15, $66
        dc.b    $77, $77, $72, $00, $07, $00, $11, $01, $00, $70, $00, $10, $77, $77, $00, $07
        dc.b    $00, $07, $02, $04, $11, $11, $00, $71, $02, $05, $11, $10, $00, $33, $33, $04
        dc.b    $02, $11, $03, $02, $01, $01, $04, $01, $30, $06, $02, $01, $30, $02, $02, $10
        dc.b    $13, $02, $08, $31, $11, $33, $00, $03, $32, $33, $03, $0B, $01, $30, $06, $01
        dc.b    $03, $02, $0F, $03, $30, $00, $03, $30, $00, $01, $31, $11, $66, $66, $01, $00
        dc.b    $70, $01, $02, $01, $07, $09, $01, $01, $07, $0C, $10, $00, $07, $07, $70, $12
        dc.b    $25, $52, $00, $30, $08, $88, $05, $01, $30, $06, $03, $17, $13, $08, $03, $0A
        dc.b    $30, $80, $01, $71, $03, $08, $50, $00, $10, $30, $03, $01, $38, $04, $04, $05
        dc.b    $17, $00, $08, $02, $0A, $01, $30, $00, $51, $70, $13, $00, $05, $17, $01, $02
        dc.b    $08, $51, $67, $99, $91, $14, $46, $00, $08, $05, $03, $30, $00, $08, $02, $14
        dc.b    $88, $80, $03, $01, $30, $03, $30, $17, $03, $30, $11, $70, $11, $11, $77, $01
        dc.b    $10, $07, $11, $01, $02, $04, $05, $10, $10, $70, $03, $05, $01, $50, $51, $07
        dc.b    $05, $02, $06, $70, $10, $00, $05, $01, $50, $02, $01, $15, $03, $08, $14, $32
        dc.b    $21, $99, $07, $10, $38, $8B, $02, $08, $3B, $33, $00, $11, $03, $B8, $07, $70
        dc.b    $02, $1C, $10, $00, $13, $88, $51, $07, $01, $22, $05, $11, $77, $77, $12, $76
        dc.b    $77, $70, $31, $10, $07, $70, $31, $11, $07, $00, $03, $00, $10, $70, $02, $12
        dc.b    $10, $00, $03, $01, $00, $70, $21, $10, $77, $14, $77, $77, $11, $50, $00, $07
        dc.b    $77, $22, $04, $01, $01, $08, $1D, $17, $10, $01, $15, $00, $01, $10, $50, $51
        dc.b    $70, $07, $00, $05, $17, $70, $12, $22, $67, $00, $30, $11, $77, $00, $30, $10
        dc.b    $70, $00, $03, $01, $02, $24, $03, $01, $70, $07, $31, $17, $07, $71, $17, $70
        dc.b    $70, $13, $70, $07, $01, $30, $07, $61, $23, $00, $07, $10, $33, $33, $00, $01
        dc.b    $01, $11, $77, $11, $01, $10, $12, $33, $30, $01, $02, $03, $03, $30, $30, $02
        dc.b    $23, $03, $08, $88, $80, $00, $08, $BB, $B3, $22, $33, $01, $11, $07, $11, $10
        dc.b    $07, $77, $07, $77, $70, $70, $17, $00, $07, $01, $00, $70, $00, $10, $01, $07
        dc.b    $00, $03, $00, $10, $02, $0F, $16, $67, $07, $71, $77, $70, $00, $15, $70, $07
        dc.b    $70, $00, $11, $11, $07, $03, $03, $10, $00, $33, $05, $01, $10, $05, $0E, $25
        dc.b    $66, $66, $15, $07, $00, $10, $00, $10, $70, $01, $00, $01, $07, $02, $04, $30
        dc.b    $10, $70, $15, $04, $01, $30, $04, $07, $10, $00, $15, $00, $22, $25, $41, $02
        dc.b    $02, $08, $88, $02, $03, $80, $00, $10, $04, $04, $30, $80, $00, $01, $03, $1C
        dc.b    $70, $03, $08, $80, $00, $10, $30, $08, $52, $20, $12, $33, $00, $03, $10, $10
        dc.b    $80, $00, $31, $10, $08, $00, $03, $30, $00, $88, $00, $03, $06, $03, $88, $00
        dc.b    $80, $02, $05, $88, $3B, $BB, $AA, $AA, $02, $07, $11, $11, $00, $33, $33, $00
        dc.b    $03, $02, $17, $33, $00, $08, $88, $00, $33, $38, $80, $88, $03, $33, $38, $80
        dc.b    $80, $03, $03, $38, $A2, $22, $66, $13, $00, $77, $02, $02, $10, $70, $02, $0A
        dc.b    $01, $07, $00, $01, $30, $10, $70, $70, $03, $01, $02, $05, $80, $00, $07, $07
        dc.b    $80, $03, $1A, $44, $76, $00, $66, $00, $10, $77, $11, $01, $00, $77, $00, $10
        dc.b    $77, $11, $11, $07, $01, $00, $33, $00, $10, $33, $00, $70, $03, $02, $13, $01
        dc.b    $30, $00, $08, $32, $11, $11, $19, $00, $54, $44, $45, $05, $17, $77, $71, $51
        dc.b    $70, $11, $02, $05, $01, $30, $77, $00, $03, $08, $16, $30, $00, $01, $75, $66
        dc.b    $06, $11, $76, $66, $71, $76, $13, $33, $17, $10, $38, $80, $01, $03, $80, $08
        dc.b    $30, $0C, $10, $71, $9C, $CD, $56, $15, $41, $17, $77, $01, $00, $70, $11, $70
        dc.b    $07, $01, $33, $02, $02, $13, $08, $03, $02, $80, $07, $07, $15, $66, $07, $65
        dc.b    $DC, $11, $76, $66, $71, $76, $13, $33, $17, $10, $38, $80, $01, $33, $80, $08
        dc.b    $30, $80, $0B, $06, $83, $BA, $AA, $33, $00, $01, $02, $01, $03, $02, $01, $03
        dc.b    $06, $02, $07, $10, $03, $01, $01, $03, $02, $70, $03, $02, $07, $07, $03, $3B
        dc.b    $AD, $DD, $00, $80, $04, $07, $88, $80, $30, $88, $00, $08, $03, $04, $01, $30
        dc.b    $02, $01, $10, $03, $02, $01, $03, $02, $03, $67, $61, $33, $02, $05, $70, $03
        dc.b    $08, $00, $01, $05, $01, $80, $10, $04, $CD, $AB, $B8, $88, $03, $01, $80, $13
        dc.b    $01, $80, $04, $06, $8B, $BA, $AA, $30, $00, $01, $05, $01, $03, $06, $02, $07
        dc.b    $10, $03, $02, $01, $30, $02, $01, $70, $03, $05, $07, $30, $01, $00, $11, $06
        dc.b    $08, $70, $05, $30, $00, $01, $50, $00, $17, $02, $0F, $11, $70, $10, $00, $07
        dc.b    $00, $10, $00, $07, $70, $01, $50, $00, $07, $01, $02, $0E, $77, $01, $05, $00
        dc.b    $77, $77, $10, $11, $11, $00, $71, $33, $30, $10, $02, $02, $03, $01, $07, $19
        dc.b    $01, $00, $55, $22, $11, $15, $00, $70, $01, $03, $07, $70, $00, $11, $70, $01
        dc.b    $11, $11, $01, $10, $03, $33, $10, $03, $30, $02, $01, $30, $02, $01, $03, $02
        dc.b    $19, $08, $30, $08, $88, $80, $30, $08, $80, $00, $13, $33, $08, $88, $11, $11
        dc.b    $33, $00, $01, $11, $00, $33, $33, $33, $33, $33, $04, $02, $88, $80, $04, $06
        dc.b    $03, $23, $00, $08, $83, $11, $02, $06, $80, $00, $88, $88, $03, $11, $03, $01
        dc.b    $13, $02, $05, $30, $30, $00, $03, $33, $02, $01, $03, $02, $06, $33, $32, $22
        dc.b    $25, $11, $10, $02, $02, $11, $11, $02, $07, $03, $30, $10, $07, $30, $03, $01
        dc.b    $04, $01, $01, $06, $06, $01, $10, $23, $00, $32, $BB, $02, $01, $08, $0B, $12
        dc.b    $08, $00, $01, $30, $00, $80, $00, $03, $00, $08, $70, $11, $33, $00, $17, $01
        dc.b    $00, $52, $07, $01, $77, $02, $04, $01, $00, $51, $71, $04, $05, $10, $70, $05
        dc.b    $17, $77, $02, $0E, $51, $10, $01, $21, $9C, $C5, $67, $03, $80, $00, $01, $10
        dc.b    $00, $83, $02, $21, $08, $00, $10, $71, $30, $30, $00, $07, $13, $01, $07, $11
        dc.b    $71, $10, $71, $55, $17, $77, $15, $32, $60, $66, $49, $00, $10, $10, $00, $03
        dc.b    $07, $71, $38, $10, $31, $04, $32, $77, $12, $10, $31, $71, $77, $73, $17, $15
        dc.b    $11, $16, $71, $50, $55, $45, $DC, $91, $22, $03, $80, $00, $01, $30, $00, $83
        dc.b    $00, $10, $08, $00, $10, $71, $30, $30, $00, $07, $13, $01, $07, $11, $71, $10
        dc.b    $71, $55, $17, $77, $15, $12, $77, $00, $14, $03, $04, $77, $30, $00, $07, $02
        dc.b    $12, $10, $70, $11, $01, $00, $01, $00, $10, $00, $10, $03, $00, $01, $00, $30
        dc.b    $00, $10, $03, $03, $01, $30, $02, $02, $10, $30, $02, $12, $01, $03, $30, $11
        dc.b    $00, $10, $03, $00, $10, $01, $10, $33, $01, $00, $01, $00, $30, $10, $02, $07
        dc.b    $03, $01, $00, $45, $22, $03, $AA, $03, $01, $80, $05, $02, $70, $03, $05, $01
        dc.b    $51, $05, $01, $10, $02, $07, $07, $00, $08, $9C, $DD, $AB, $03, $02, $01, $08
        dc.b    $10, $01, $30, $02, $01, $80, $05, $04, $BB, $BA, $55, $61, $02, $02, $07, $70
        dc.b    $03, $05, $01, $00, $10, $70, $10, $02, $01, $01, $04, $05, $03, $01, $00, $10
        dc.b    $30, $04, $04, $10, $00, $66, $41, $02, $03, $70, $15, $11, $04, $03, $10, $07
        dc.b    $01, $04, $04, $30, $01, $00, $70, $04, $03, $03, $00, $10, $02, $03, $30, $00
        dc.b    $71, $02, $0F, $17, $10, $00, $31, $07, $11, $03, $01, $10, $70, $30, $33, $01
        dc.b    $00, $33, $04, $0B, $03, $01, $01, $00, $30, $10, $70, $30, $33, $22, $DC, $02
        dc.b    $01, $08, $05, $01, $03, $05, $12, $08, $00, $10, $30, $00, $80, $01, $03, $00
        dc.b    $08, $70, $10, $33, $00, $DA, $AB, $33, $03, $06, $02, $80, $03, $06, $01, $08
        dc.b    $04, $01, $80, $03, $02, $08, $88, $04, $04, $88, $88, $88, $30, $03, $01, $03
        dc.b    $04, $01, $30, $02, $02, $30, $03, $02, $0F, $03, $00, $33, $33, $00, $30, $00
        dc.b    $03, $80, $03, $00, $03, $80, $03, $01, $03, $01, $01, $02, $09, $30, $03, $00
        dc.b    $03, $00, $30, $01, $30, $33, $02, $03, $33, $00, $03, $07, $19, $30, $10, $11
        dc.b    $44, $76, $77, $05, $11, $17, $76, $51, $07, $61, $23, $00, $71, $33, $08, $17
        dc.b    $13, $08, $80, $01, $00, $80, $09, $10, $06, $65, $DD, $CC, $66, $67, $77, $11
        dc.b    $33, $32, $11, $77, $88, $00, $33, $10, $03, $02, $31, $08, $02, $02, $03, $80
        dc.b    $07, $17, $11, $14, $44, $55, $50, $51, $16, $77, $15, $17, $70, $11, $71, $70
        dc.b    $11, $BB, $00, $01, $3B, $00, $17, $00, $08, $07, $18, $30, $80, $67, $76, $74
        dc.b    $19, $77, $77, $11, $55, $11, $10, $77, $11, $33, $01, $10, $70, $80, $30, $01
        dc.b    $07, $00, $03, $02, $01, $08, $02, $01, $10, $04, $0A, $CC, $45, $11, $02, $10
        dc.b    $00, $70, $00, $01, $01, $02, $0E, $70, $10, $00, $03, $00, $01, $00, $10, $00
        dc.b    $70, $07, $01, $00, $07, $03, $08, $01, $70, $70, $15, $20, $25, $52, $30, $07
        dc.b    $17, $30, $03, $30, $00, $03, $00, $30, $03, $60, $30, $00, $31, $76, $13, $32
        dc.b    $01, $00, $71, $11, $03, $26, $60, $01, $03, $01, $70, $05, $0E, $30, $17, $00
        dc.b    $03, $01, $70, $00, $10, $10, $70, $07, $01, $11, $07, $02, $0C, $30, $10, $00
        dc.b    $70, $17, $67, $76, $62, $00, $07, $00, $03, $06, $01, $01, $08, $05, $10, $00
        dc.b    $07, $00, $01, $02, $06, $70, $00, $50, $11, $16, $77, $02, $12, $11, $77, $00
        dc.b    $11, $77, $11, $01, $77, $11, $03, $00, $01, $03, $30, $17, $10, $30, $88, $02
        dc.b    $01, $08, $02, $01, $03, $02, $17, $06, $74, $4C, $CD, $71, $10, $00, $10, $07
        dc.b    $71, $01, $77, $11, $07, $17, $11, $00, $10, $00, $03, $30, $00, $71, $02, $04
        dc.b    $01, $00, $30, $03, $03, $13, $55, $66, $77, $44, $77, $77, $71, $10, $11, $10
        dc.b    $07, $01, $33, $01, $10, $77, $00, $30, $01, $06, $05, $33, $30, $10, $33, $30
        dc.b    $02, $17, $22, $14, $47, $67, $50, $51, $16, $77, $15, $17, $70, $11, $71, $70
        dc.b    $11, $BB, $00, $01, $3B, $00, $17, $00, $08, $07, $18, $30, $80, $67, $76, $74
        dc.b    $19, $77, $77, $11, $55, $11, $10, $77, $11, $33, $01, $10, $70, $80, $30, $01
        dc.b    $07, $00, $03, $02, $01, $08, $02, $01, $10, $04, $14, $9C, $44, $66, $10, $51
        dc.b    $16, $77, $11, $17, $70, $11, $03, $70, $11, $03, $38, $01, $03, $38, $80, $02
        dc.b    $1A, $80, $00, $10, $30, $00, $08, $00, $08, $00, $80, $66, $5D, $DD, $44, $66
        dc.b    $67, $77, $11, $33, $32, $11, $77, $88, $00, $33, $10, $03, $02, $31, $08, $02
        dc.b    $02, $03, $80, $07, $10, $22, $55, $54, $11, $11, $67, $71, $50, $33, $32, $17
        dc.b    $15, $88, $00, $31, $70, $04, $01, $08, $03, $01, $80, $07, $07, $52, $30, $0B
        dc.b    $AC, $17, $03, $08, $02, $25, $10, $30, $88, $00, $71, $03, $30, $01, $07, $11
        dc.b    $03, $50, $10, $77, $61, $05, $01, $07, $71, $00, $01, $70, $10, $99, $45, $22
        dc.b    $30, $00, $80, $03, $31, $00, $08, $03, $32, $88, $88, $02, $29, $33, $33, $33
        dc.b    $00, $10, $00, $33, $00, $10, $33, $00, $08, $33, $00, $88, $80, $22, $23, $B8
        dc.b    $80, $11, $01, $03, $08, $00, $10, $10, $00, $33, $01, $01, $30, $00, $30, $10
        dc.b    $03, $00, $03, $00, $10, $88, $02, $01, $01, $06, $02, $31, $10, $08, $03, $88
        dc.b    $00, $30, $02, $13, $03, $00, $10, $33, $30, $01, $11, $10, $00, $01, $00, $10
        dc.b    $30, $03, $33, $16, $20, $15, $55, $02, $02, $10, $10, $04, $07, $70, $10, $10
        dc.b    $01, $07, $11, $70, $02, $0F, $77, $01, $55, $07, $01, $15, $00, $41, $15, $50
        dc.b    $00, $41, $14, $32, $19, $07, $11, $08, $00, $10, $71, $30, $01, $51, $07, $13
        dc.b    $15, $05, $10, $71, $50, $00, $51, $17, $02, $06, $05, $01, $11, $23, $34, $11
        dc.b    $03, $01, $10, $02, $08, $70, $00, $03, $10, $00, $01, $31, $07, $02, $14, $10
        dc.b    $70, $01, $05, $77, $01, $15, $50, $41, $15, $50, $00, $41, $62, $21, $99, $77
        dc.b    $10, $38, $8B, $02, $07, $3B, $33, $10, $11, $03, $B8, $01, $03, $10, $30, $10
        dc.b    $13, $88, $03, $01, $01, $22, $00, $30, $00, $77, $33, $30, $11, $66, $09, $02
        dc.b    $03, $33, $02, $13, $30, $80, $33, $10, $00, $08, $80, $01, $30, $80, $08, $00
        dc.b    $03, $08, $00, $11, $00, $33, $BB, $04, $01, $03, $04, $01, $33, $02, $15, $03
        dc.b    $00, $33, $33, $30, $33, $00, $03, $03, $00, $33, $31, $80, $30, $00, $10, $A2
        dc.b    $21, $11, $00, $10, $02, $02, $07, $01, $02, $01, $07, $03, $1C, $70, $01, $00
        dc.b    $77, $70, $10, $77, $77, $11, $07, $07, $01, $33, $71, $00, $13, $00, $01, $00
        dc.b    $12, $22, $00, $07, $00, $11, $77, $70, $70, $02, $0F, $07, $00, $10, $11, $00
        dc.b    $77, $01, $00, $10, $07, $70, $33, $01, $00, $07, $04, $04, $88, $33, $21, $67
        dc.b    $08, $03, $88, $00, $30, $02, $14, $03, $00, $10, $33, $30, $01, $11, $10, $00
        dc.b    $01, $00, $10, $00, $33, $33, $03, $3B, $88, $88, $03, $03, $02, $11, $38, $02
        dc.b    $19, $70, $03, $88, $00, $77, $10, $33, $88, $17, $71, $10, $33, $01, $70, $01
        dc.b    $10, $30, $10, $00, $10, $03, $32, $22, $30, $88, $02, $07, $31, $00, $80, $03
        dc.b    $01, $00, $80, $02, $10, $88, $00, $30, $00, $33, $33, $03, $33, $00, $33, $30
        dc.b    $00, $33, $00, $88, $88, $02, $05, $8B, $AC, $88, $00, $01, $02, $09, $80, $37
        dc.b    $65, $00, $80, $10, $00, $88, $03, $02, $12, $33, $30, $17, $15, $00, $33, $01
        dc.b    $00, $33, $08, $30, $00, $03, $3A, $21, $64, $00, $01, $05, $01, $03, $06, $02
        dc.b    $07, $10, $03, $02, $01, $30, $02, $01, $70, $03, $07, $07, $33, $3B, $AD, $DD
        dc.b    $00, $80, $04, $07, $88, $80, $30, $88, $00, $08, $03, $04, $01, $30, $02, $01
        dc.b    $10, $03, $02, $01, $03, $02, $04, $AA, $33, $32, $23, $02, $01, $01, $02, $02
        dc.b    $80, $30, $05, $05, $80, $08, $03, $11, $08, $04, $01, $80, $03, $01, $08, $02
        dc.b    $01, $30, $02, $02, $32, $30, $04, $01, $08, $02, $06, $30, $00, $80, $00, $03
        dc.b    $08, $03, $09, $30, $08, $00, $10, $00, $80, $88, $01, $03, $02, $06, $21, $01
        dc.b    $2A, $B8, $00, $01, $02, $01, $03, $02, $01, $03, $06, $02, $07, $10, $03, $01
        dc.b    $01, $03, $02, $70, $03, $02, $14, $07, $52, $77, $64, $44, $74, $61, $15, $00
        dc.b    $17, $77, $71, $50, $31, $71, $07, $15, $83, $06, $10, $0D, $09, $C5, $07, $02
        dc.b    $5C, $17, $01, $30, $80, $70, $0B, $01, $10, $05, $09, $30, $80, $00, $01, $03
        dc.b    $08, $BA, $AA, $33, $02, $05, $08, $00, $03, $00, $80, $02, $01, $08, $02, $01
        dc.b    $30, $03, $1C, $01, $80, $00, $03, $00, $80, $00, $30, $10, $80, $03, $01, $00
        dc.b    $42, $20, $02, $22, $06, $01, $03, $33, $00, $70, $11, $03, $50, $17, $70, $02
        dc.b    $03, $01, $16, $13, $03, $01, $61, $03, $01, $06, $02, $13, $11, $10, $17, $77
        dc.b    $66, $71, $03, $30, $01, $00, $88, $03, $00, $70, $00, $80, $00, $01, $80, $03
        dc.b    $2D, $38, $80, $00, $10, $13, $03, $17, $01, $66, $21, $71, $10, $01, $70, $77
        dc.b    $55, $00, $17, $01, $33, $01, $01, $77, $10, $00, $10, $11, $71, $10, $01, $10
        dc.b    $10, $07, $70, $01, $07, $00, $07, $00, $01, $70, $10, $70, $11, $11, $02, $10
        dc.b    $01, $11, $17, $70, $00, $11, $07, $00, $10, $30, $10, $70, $01, $33, $17, $70
        dc.b    $02, $04, $17, $01, $00, $13, $02, $09, $10, $61, $17, $11, $07, $71, $16, $76
        dc.b    $61, $04, $01, $03, $04, $01, $33, $02, $06, $03, $00, $33, $33, $30, $33, $02
        dc.b    $01, $03, $03, $08, $80, $00, $30, $00, $B3, $00, $03, $33, $10, $01, $33, $04
        dc.b    $01, $33, $04, $06, $33, $00, $33, $33, $33, $11, $03, $01, $11, $04, $01, $01
        dc.b    $03, $02, $01, $11, $03, $06, $10, $11, $11, $00, $01, $10, $03, $06, $01, $00
        dc.b    $33, $BB, $30, $06, $08, $02, $30, $88, $02, $01, $03, $04, $01, $30, $02, $01
        dc.b    $10, $03, $02, $01, $03, $02, $04, $11, $01, $56, $71, $03, $01, $77, $02, $01
        dc.b    $07, $02, $03, $10, $70, $11, $02, $01, $01, $03, $0D, $10, $03, $01, $01, $00
        dc.b    $30, $00, $10, $03, $00, $10, $00, $30, $02, $02, $10, $30, $02, $12, $01, $03
        dc.b    $30, $11, $00, $10, $03, $00, $10, $01, $10, $33, $01, $00, $01, $00, $30, $10
        dc.b    $02, $02, $03, $01, $03, $02, $30, $10, $02, $09, $30, $11, $00, $03, $01, $13
        dc.b    $33, $30, $10, $02, $01, $11, $02, $01, $11, $02, $1D, $13, $01, $11, $11, $01
        dc.b    $10, $33, $00, $11, $11, $33, $33, $BB, $11, $10, $30, $88, $30, $11, $03, $30
        dc.b    $03, $01, $10, $03, $00, $30, $01, $10, $02, $04, $10, $01, $30, $03, $02, $02
        dc.b    $13, $33, $02, $04, $20, $01, $67, $77, $03, $04, $77, $30, $00, $07, $02, $18
        dc.b    $10, $70, $11, $01, $00, $01, $00, $10, $00, $10, $03, $00, $01, $00, $30, $00
        dc.b    $10, $03, $00, $A2, $16, $02, $54, $83, $04, $01, $07, $02, $13, $31, $71, $07
        dc.b    $15, $17, $70, $10, $00, $70, $01, $71, $50, $41, $77, $15, $00, $05, $11, $50
        dc.b    $02, $0B, $50, $55, $54, $00, $05, $01, $10, $00, $05, $10, $11, $02, $05, $01
        dc.b    $BB, $00, $51, $1B, $02, $07, $10, $00, $0A, $05, $07, $1A, $A7, $02, $0E, $AA
        dc.b    $07, $41, $16, $EE, $44, $77, $11, $55, $00, $70, $77, $11, $50, $02, $0D, $70
        dc.b    $15, $00, $77, $77, $00, $77, $11, $17, $00, $71, $0B, $B0, $02, $01, $B0, $02
        dc.b    $1C, $16, $DC, $C5, $54, $06, $01, $03, $33, $10, $70, $11, $03, $00, $17, $70
        dc.b    $00, $01, $01, $16, $13, $70, $11, $10, $61, $07, $77, $01, $16, $02, $0E, $77
        dc.b    $01, $76, $66, $77, $77, $71, $11, $77, $01, $07, $77, $00, $10, $02, $0A, $11
        dc.b    $01, $00, $11, $00, $11, $01, $00, $01, $11, $02, $37, $11, $11, $00, $01, $11
        dc.b    $11, $00, $01, $10, $17, $10, $00, $11, $07, $10, $10, $10, $11, $11, $11, $11
        dc.b    $00, $11, $11, $11, $10, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11
        dc.b    $11, $66, $76, $67, $10, $71, $11, $07, $00, $07, $77, $70, $00, $11, $11, $11
        dc.b    $11, $10, $03, $37, $11, $01, $01, $01, $11, $11, $11, $11, $11, $11, $11, $11
        dc.b    $31, $01, $01, $32, $01, $10, $00, $33, $82, $76, $10, $00, $08, $57, $71, $00
        dc.b    $80, $82, $67, $10, $38, $80, $07, $01, $13, $03, $17, $30, $36, $21, $74, $03
        dc.b    $15, $22, $51, $12, $33, $33, $00, $03, $33, $00, $33, $02, $17, $33, $30, $33
        dc.b    $08, $88, $03, $00, $38, $80, $80, $30, $03, $08, $B3, $30, $10, $30, $33, $00
        dc.b    $10, $03, $33, $16, $04, $01, $30, $03, $01, $03, $03, $2A, $33, $00, $01, $00
        dc.b    $01, $00, $10, $74, $01, $11, $07, $00, $11, $07, $70, $40, $00, $16, $56, $35
        dc.b    $00, $10, $31, $70, $00, $01, $10, $00, $11, $00, $07, $15, $00, $10, $01, $50
        dc.b    $33, $01, $01, $50, $00, $30, $04, $0A, $17, $10, $11, $46, $60, $73, $05, $17
        dc.b    $71, $11, $02, $02, $2B, $33, $02, $0A, $38, $88, $05, $10, $13, $88, $00, $53
        dc.b    $71, $33, $02, $02, $43, $61, $03, $06, $43, $34, $44, $44, $44, $17, $02, $07
        dc.b    $07, $01, $70, $00, $70, $00, $07, $03, $02, $10, $70, $02, $1B, $01, $07, $70
        dc.b    $30, $00, $10, $70, $03, $00, $01, $10, $55, $66, $66, $67, $77, $77, $77, $77
        dc.b    $01, $11, $11, $00, $10, $33, $00, $11, $02, $01, $33, $04, $01, $33, $04, $02
        dc.b    $10, $30, $02, $04, $32, $21, $11, $11, $0D, $05, $53, $50, $00, $43, $16, $02
        dc.b    $02, $17, $71, $02, $03, $54, $67, $15, $02, $03, $07, $77, $22, $02, $01, $01
        dc.b    $02, $03, $51, $70, $10, $02, $01, $07, $02, $03, $05, $10, $71, $02, $02, $51
        dc.b    $07, $03, $01, $11, $04, $04, $19, $99, $14, $47, $02, $20, $80, $03, $38, $00
        dc.b    $08, $00, $03, $80, $00, $80, $00, $38, $00, $08, $11, $03, $88, $00, $77, $11
        dc.b    $33, $88, $11, $77, $11, $23, $50, $11, $77, $76, $00, $01, $05, $02, $07, $05
        dc.b    $06, $01, $70, $06, $01, $07, $05, $04, $32, $76, $60, $10, $02, $02, $01, $11
        dc.b    $02, $02, $01, $11, $02, $02, $11, $11, $02, $02, $11, $11, $02, $0E, $11, $11
        dc.b    $00, $01, $11, $11, $00, $01, $11, $11, $32, $22, $32, $66, $1C, $04, $43, $32
        dc.b    $22, $66, $02, $02, $01, $11, $02, $02, $01, $11, $03, $01, $11, $03, $01, $11
        dc.b    $03, $01, $11, $03, $01, $11, $03, $25, $11, $71, $00, $10, $11, $11, $11, $11
        dc.b    $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11
        dc.b    $11, $11, $11, $11, $11, $11, $11, $11, $11, $23, $26, $67, $10, $0D, $01, $50
        dc.b    $03, $01, $01, $04, $01, $07, $05, $2C, $22, $66, $71, $01, $00, $11, $11, $11
        dc.b    $00, $11, $11, $11, $00, $11, $11, $11, $00, $01, $11, $11, $00, $01, $11, $11
        dc.b    $00, $01, $11, $11, $00, $01, $11, $11, $21, $02, $BA, $32, $00, $03, $80, $88
        dc.b    $03, $10, $0B, $88, $02, $02, $03, $33, $03, $05, $30, $00, $30, $08, $03, $03
        dc.b    $0B, $80, $00, $01, $38, $08, $22, $30, $65, $99, $30, $10, $02, $05, $83, $00
        dc.b    $70, $00, $80, $03, $05, $23, $10, $04, $00, $11, $03, $01, $31, $03, $02, $83
        dc.b    $10, $02, $04, $80, $32, $13, $45, $03, $01, $70, $02, $01, $01, $03, $01, $30
        dc.b    $11, $04, $52, $23, $33, $24, $04, $01, $17, $03, $02, $50, $01, $05, $08, $08
        dc.b    $01, $00, $03, $00, $05, $70, $10, $04, $07, $38, $11, $61, $10, $03, $00, $30
        dc.b    $03, $01, $03, $02, $01, $88, $04, $02, $80, $30, $06, $02, $08, $03, $04, $15
        dc.b    $30, $AD, $BB, $00, $03, $17, $10, $33, $00, $01, $01, $10, $33, $00, $10, $01
        dc.b    $10, $00, $01, $00, $01, $02, $01, $11, $04, $01, $10, $03, $05, $01, $33, $30
        dc.b    $01, $16, $05, $05, $30, $10, $00, $33, $01, $02, $14, $11, $10, $00, $70, $70
        dc.b    $00, $07, $01, $77, $77, $70, $15, $07, $01, $01, $50, $33, $45, $40, $54, $03
        dc.b    $01, $17, $02, $01, $05, $04, $01, $10, $03, $01, $57, $03, $01, $04, $08, $20
        dc.b    $33, $44, $44, $33, $11, $67, $70, $77, $03, $31, $17, $70, $03, $8B, $31, $17
        dc.b    $10, $B8, $8B, $31, $71, $03, $B8, $83, $47, $61, $03, $B3, $04, $17, $11, $11
        dc.b    $02, $01, $70, $07, $01, $07, $02, $01, $01, $03, $01, $50, $0E, $24, $22, $27
        dc.b    $76, $01, $00, $01, $11, $11, $00, $01, $11, $11, $00, $01, $11, $11, $00, $11
        dc.b    $11, $11, $00, $11, $11, $11, $00, $11, $11, $11, $00, $11, $11, $11, $22, $23
        dc.b    $23, $26, $1C, $04, $44, $33, $22, $27, $03, $01, $01, $03, $01, $01, $03, $01
        dc.b    $01, $03, $01, $01, $03, $01, $01, $03, $01, $01, $04, $24, $66, $11, $10, $10
        dc.b    $00, $01, $11, $11, $00, $01, $11, $11, $00, $01, $11, $11, $00, $11, $11, $11
        dc.b    $00, $11, $11, $11, $00, $11, $11, $11, $00, $11, $11, $11, $22, $77, $60, $10
        dc.b    $06, $01, $07, $08, $02, $70, $05, $06, $03, $07, $00, $01, $02, $04, $37, $77
        dc.b    $76, $76, $02, $02, $11, $11, $02, $03, $01, $11, $01, $02, $05, $11, $00, $11
        dc.b    $00, $01, $02, $12, $11, $00, $07, $77, $00, $10, $71, $11, $77, $01, $DC, $CC
        dc.b    $DD, $AA, $33, $33, $33, $33, $08, $19, $03, $03, $03, $03, $33, $33, $33, $33
        dc.b    $33, $33, $33, $33, $33, $33, $33, $33, $03, $33, $03, $33, $00, $30, $00, $30
        dc.b    $30, $03, $03, $30, $00, $30, $03, $01, $30, $0D, $05, $88, $88, $8B, $AC, $88
        dc.b    $04, $01, $80, $03, $01, $80, $02, $06, $88, $00, $30, $00, $33, $33, $03, $01
        dc.b    $33, $02, $13, $33, $00, $30, $00, $11, $45, $21, $17, $00, $50, $00, $10, $00
        dc.b    $01, $70, $01, $00, $05, $17, $03, $02, $01, $77, $02, $2A, $01, $77, $00, $05
        dc.b    $17, $01, $00, $01, $70, $10, $19, $9D, $A2, $33, $08, $00, $08, $00, $30, $80
        dc.b    $00, $88, $13, $38, $80, $00, $01, $03, $38, $88, $77, $11, $13, $33, $66, $10
        dc.b    $01, $10, $00, $01, $11, $10, $04, $01, $33, $04, $01, $30, $02, $02, $80, $03
        dc.b    $02, $08, $80, $33, $00, $01, $33, $00, $01, $10, $02, $02, $01, $11, $04, $04
        dc.b    $01, $16, $72, $22, $02, $01, $15, $05, $01, $10, $04, $0E, $70, $15, $00, $77
        dc.b    $00, $50, $00, $77, $70, $40, $00, $11, $07, $04, $02, $03, $11, $67, $34, $02
        dc.b    $20, $01, $17, $30, $01, $00, $01, $03, $01, $11, $00, $80, $30, $10, $61, $08
        dc.b    $03, $31, $77, $00, $88, $00, $17, $88, $88, $00, $01, $55, $41, $12, $22, $70
        dc.b    $15, $02, $01, $07, $07, $02, $07, $15, $02, $01, $71, $03, $01, $01, $03, $01
        dc.b    $70, $03, $04, $34, $50, $54, $43, $1C, $0C, $32, $22, $66, $71, $00, $01, $11
        dc.b    $11, $00, $01, $11, $11, $02, $02, $11, $11, $02, $02, $11, $11, $02, $02, $11
        dc.b    $11, $02, $02, $01, $11, $02, $06, $01, $11, $32, $76, $60, $11, $1C, $04, $54
        dc.b    $17, $71, $10, $1C, $24, $66, $71, $00, $10, $11, $11, $11, $11, $01, $11, $11
        dc.b    $11, $01, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $01, $11, $11
        dc.b    $11, $01, $11, $11, $11, $23, $23, $23, $23, $1C, $04, $32, $22, $22, $32, $02
        dc.b    $02, $01, $11, $02, $02, $11, $11, $02, $02, $11, $11, $02, $21, $11, $11, $00
        dc.b    $01, $11, $11, $00, $01, $11, $11, $00, $01, $11, $11, $32, $26, $76, $67, $00
        dc.b    $51, $16, $77, $05, $17, $70, $11, $00, $70, $11, $BB, $51, $01, $3B, $03, $01
        dc.b    $08, $07, $18, $30, $80, $10, $76, $74, $19, $77, $77, $11, $55, $11, $10, $77
        dc.b    $11, $33, $01, $10, $70, $80, $30, $01, $07, $00, $03, $02, $01, $08, $02, $01
        dc.b    $10, $04, $05, $88, $88, $30, $16, $08, $02, $01, $70, $04, $0E, $08, $00, $01
        dc.b    $00, $30, $88, $30, $00, $03, $33, $17, $15, $11, $11, $02, $10, $07, $70, $17
        dc.b    $15, $34, $17, $10, $67, $00, $07, $01, $03, $00, $10, $00, $38, $0F, $01, $38
        dc.b    $04, $05, $11, $51, $10, $00, $88, $04, $03, $03, $00, $03, $03, $01, $10, $03
        dc.b    $05, $11, $00, $80, $30, $01, $06, $14, $03, $00, $88, $83, $33, $00, $88, $03
        dc.b    $33, $30, $80, $88, $80, $03, $38, $00, $08, $80, $13, $80, $02, $0C, $01, $3B
        dc.b    $88, $83, $10, $11, $33, $31, $01, $10, $11, $10, $02, $02, $07, $33, $09, $02
        dc.b    $10, $70, $03, $13, $01, $00, $01, $07, $05, $00, $10, $70, $10, $00, $77, $11
        dc.b    $50, $00, $66, $77, $22, $23, $11, $02, $11, $10, $77, $61, $11, $07, $70, $06
        dc.b    $67, $70, $17, $71, $01, $11, $01, $07, $10, $55, $02, $0B, $01, $00, $11, $07
        dc.b    $01, $00, $07, $64, $45, $00, $70, $03, $02, $01, $50, $02, $01, $15, $03, $01
        dc.b    $50, $11, $02, $05, $44, $1C, $04, $33, $22, $37, $76, $02, $02, $11, $11, $02
        dc.b    $02, $01, $11, $02, $02, $01, $11, $02, $02, $11, $11, $02, $02, $11, $11, $02
        dc.b    $02, $01, $11, $02, $06, $01, $11, $33, $27, $67, $10, $1C, $04, $05, $41, $77
        dc.b    $11, $1C, $24, $27, $76, $01, $10, $00, $11, $11, $11, $00, $11, $11, $11, $01
        dc.b    $11, $11, $11, $01, $11, $11, $11, $00, $11, $11, $11, $00, $11, $11, $11, $00
        dc.b    $11, $11, $11, $22, $23, $23, $23, $3C, $07, $54, $32, $21, $11, $00, $01, $03
        dc.b    $03, $01, $10, $02, $17, $70, $00, $30, $51, $00, $01, $03, $00, $07, $00, $10
        dc.b    $05, $10, $00, $13, $05, $17, $01, $30, $9C, $52, $20, $32, $08, $0C, $88, $00
        dc.b    $30, $10, $30, $00, $30, $11, $30, $00, $03, $30, $03, $0C, $03, $08, $88, $80
        dc.b    $00, $5D, $AB, $B0, $24, $07, $10, $38, $03, $01, $3B, $02, $05, $11, $03, $00
        dc.b    $07, $70, $02, $0C, $10, $00, $13, $00, $51, $07, $01, $65, $05, $11, $66, $50
        dc.b    $11, $06, $0A, $00, $10, $00, $80, $00, $11, $60, $80, $60, $01, $05, $81, $D3
        dc.b    $2C, $00, $2D, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $80
        dc.b    $33, $80, $93, $00, $10, $00, $10, $00, $B0, $00, $12, $00, $10, $00, $10, $00
        dc.b    $70, $00, $70, $00, $DD, $08, $DE, $80, $90, $88, $91, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $80, $9D, $80, $9F, $00, $10, $00, $10, $80
        dc.b    $53, $80, $51, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00
        dc.b    $1E, $00, $12, $00, $10, $00, $10, $00, $1E, $00, $16, $00, $10, $00, $10, $00
        dc.b    $3F, $00, $39, $00, $10, $00, $10, $00, $12, $00, $16, $00, $10, $00, $10, $00
        dc.b    $F7, $00, $30, $00, $10, $00, $10, $80, $99, $80, $5A, $00, $10, $00, $10, $80
        dc.b    $71, $80, $73, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00
        dc.b    $1E, $00, $12, $00, $10, $00, $10, $00, $1E, $00, $16, $00, $10, $00, $10, $00
        dc.b    $DA, $00, $d4, $00, $10, $00, $10, $00, $97, $00, $70, $00, $10, $00, $10, $00
        dc.b    $70, $00, $30, $00, $10, $00, $10, $80, $52, $80, $FD, $00, $10, $00, $10, $00
        dc.b    $12, $00, $16, $00, $10, $00, $10, $00, $16, $00, $12, $00, $10, $00, $10, $00
        dc.b    $12, $00, $1E, $00, $10, $00, $10, $00, $1E, $00, $12, $00, $10, $00, $10, $00
        dc.b    $12, $00, $16, $00, $10, $00, $10, $80, $7C, $80, $74, $00, $10, $00, $10, $00
        dc.b    $1E, $00, $12, $00, $10, $00, $10, $00, $58, $00, $58, $00, $10, $00, $10, $00
        dc.b    $12, $00, $16, $00, $10, $00, $10, $00, $16, $00, $12, $00, $10, $00, $10, $00
        dc.b    $12, $00, $1E, $00, $10, $00, $10, $00, $1E, $00, $12, $00, $10, $00, $10, $00
        dc.b    $B2, $00, $B6, $00, $BE, $00, $10, $00, $B8, $00, $12, $00, $10, $00, $10, $00
        dc.b    $10, $00, $11, $00, $10, $00, $10, $00, $DC, $00, $DD, $00, $10, $00, $10, $00
        dc.b    $12, $00, $16, $00, $10, $00, $10, $00, $16, $00, $12, $00, $10, $00, $10, $00
        dc.b    $16, $00, $12, $00, $10, $00, $10, $00, $14, $00, $1C, $00, $10, $00, $10, $00
        dc.b    $1E, $00, $12, $00, $10, $00, $10, $00, $3A, $00, $FF, $00, $10, $00, $10, $00
        dc.b    $9E, $00, $5B, $00, $10, $00, $10, $00, $5D, $00, $5F, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $00, $d7, $00, $d5, $00, $10, $00, $10, $00
        dc.b    $d1, $00, $32, $00, $10, $00, $d3, $00, $12, $00, $30, $00, $93, $00, $91, $00
        dc.b    $38, $00, $F7, $00, $DD, $00, $10, $00, $12, $00, $DD, $00, $10, $00, $DF, $00
        dc.b    $16, $00, $16, $00, $10, $00, $10, $00, $34, $00, $34, $00, $10, $00, $10, $00
        dc.b    $12, $00, $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $00, $10, $00
        dc.b    $F4, $00, $35, $03, $03, $C0, $08, $C0, $02, $02, $08, $C0, $03, $01, $C3, $03
        dc.b    $57, $75, $00, $B7, $20, $6B, $20, $6A, $00, $03, $00, $03, $20, $46, $20, $47
        dc.b    $00, $20, $00, $30, $80, $30, $80, $84, $00, $B4, $00, $10, $00, $B5, $00, $B7
        dc.b    $00, $B7, $00, $B5, $80, $a6, $80, $a6, $00, $30, $00, $30, $00, $32, $00, $32
        dc.b    $00, $30, $00, $30, $00, $6C, $00, $12, $00, $10, $00, $6E, $00, $6C, $00, $6C
        dc.b    $00, $70, $00, $71, $00, $2C, $00, $2D, $00, $10, $00, $10, $00, $3E, $00, $3E
        dc.b    $00, $10, $00, $10, $00, $d8, $00, $30, $03, $07, $10, $00, $EA, $00, $33, $00
        dc.b    $10, $03, $03, $FA, $00, $22, $03, $05, $10, $00, $DA, $00, $32, $05, $03, $DA
        dc.b    $00, $32, $03, $05, $10, $00, $DA, $00, $22, $04, $04, $61, $DA, $00, $33, $03
        dc.b    $07, $10, $61, $FA, $00, $23, $00, $10, $03, $1B, $32, $00, $13, $00, $10, $00
        dc.b    $10, $00, $3E, $00, $3E, $00, $10, $00, $1B, $00, $2D, $00, $20, $00, $10, $00
        dc.b    $10, $00, $11, $00, $16, $04, $04, $01, $9D, $01, $9D, $0B, $01, $0F, $03, $03
        dc.b    $0F, $08, $0F, $02, $02, $08, $F8, $03, $80, $A7, $10, $00, $C7, $00, $d3, $00
        dc.b    $F4, $00, $10, $00, $10, $00, $24, $00, $23, $00, $22, $00, $21, $00, $12, $00
        dc.b    $1E, $00, $10, $00, $10, $08, $1F, $08, $1F, $08, $11, $00, $10, $00, $2E, $08
        dc.b    $20, $08, $21, $08, $22, $00, $12, $00, $16, $00, $10, $00, $10, $08, $F7, $08
        dc.b    $F7, $00, $10, $00, $10, $00, $16, $00, $12, $00, $10, $00, $10, $00, $12, $00
Ghz_Flower_1:            ; loc_028000:
        incbin  'data\ghz\flower_1.dat'
Ghz_Flower_2:            ; loc_028080: 
        incbin  'data\ghz\flower_2.dat'
Ghz_Flower_3:            ; loc_028100:  
        incbin  'data\ghz\flower_3.dat'
Ghz_Flower_4:            ; loc_028180:         
        incbin  'data\ghz\flower_4.dat'         
Ghz_Dyn_Wall:            ; loc_028200:
        incbin  'data\ghz\dyn_wall.dat'        
Hill_Top_Background:     ; loc_028300:
        incbin  'data\htz\backgnd.nem'
Hill_Top_Background_Unc: ; loc_028C2A:        
        incbin  'data\htz\backgnd.dat'            
Mz_Spinnig_Cylinder:     ; loc_02902A:
        incbin  'data\mz\spin_cyl.dat'
Mz_Lava:         ; loc_02A02A:
        incbin  'data\mz\lava.dat'  
Mz_Pistons:              ; loc_02A06A:
        incbin  'data\mz\pistons.dat' 
Mz_Drills:               ; loc_02A86A:
        incbin  'data\mz\drills.dat'                               
HPz_Dyn_Background:      ; loc_02B06A: Unused - Left over from previous build
        incbin  'data\hpz\backgnd.dat' 
HPz_Orbs:        ; loc_02B46A:
        incbin  'data\hpz\orbs.dat' 
OOz_Red_Balls:           ; loc_02B76A:
        incbin  'data\ooz\red_ball.dat'  
OOz_Rotating_Square_1:   ; loc_02B8EA:
        incbin  'data\ooz\r_squar1.dat'                     
OOz_Rotating_Square_2:   ; loc_02BAEA:
        incbin  'data\ooz\r_squar2.dat'  
OOz_Oil_1:               ; loc_02BCEA:
        incbin  'data\ooz\oil_1.dat'   
OOz_Oil_2:               ; loc_02C4EA:
        incbin  'data\ooz\oil_2.dat'                 
CPz_Dyn_Background:      ; loc_02CCEA:
        incbin  'data\cpz\backgnd.dat'  
NGHz_Water_Falls_1:      ; loc_02CEEA:
        incbin  'data\nghz\water_f1.dat'        
NGHz_Water_Falls_2:      ; loc_02CFEA:
        incbin  'data\nghz\water_f2.dat'         
NGHz_Water_Falls_3:      ; loc_02D0EA:
        incbin  'data\nghz\water_f3.dat' 
;=============================================================================== 
; Colision Array

;===============================================================================         
AngleMap: ; loc_02D1EA:  
        incbin  'data\all\anglemap.dat' 
Colision_Array_1: ; loc_02D2EA: 
        incbin  'data\all\c_array1.dat' 
Colision_Array_2: ; loc_02E2EA: 
        incbin  'data\all\c_array2.dat' 
;=============================================================================== 
; Colision Array
; 
;===============================================================================          
;=============================================================================== 
; 16x16 Colision Index

;===============================================================================                          
Green_Hill_Colision_1:     ; loc_02F2EA:        
        incbin  'data\ghz\ghz_col1.dat'
Green_Hill_Colision_2:     ; loc_02F5EA:        
        incbin  'data\ghz\ghz_col2.dat'
Wood_Colision:             ; loc_02F8EA:
        incbin  'data\wz\wz_col.dat' 
Metropolis_Colision:       ; loc_02FBEA:
        incbin  'data\mz\mz_col.dat' 
Hidden_Palace_Colision_1:  ; loc_02FEEA:        
        incbin  'data\hpz\hpz_col1.dat'
Hidden_Palace_Colision_2:  ; loc_0301EA:        
        incbin  'data\hpz\hpz_col2.dat' 
Oil_Ocean_Colision:        ; loc_0304EA:        
        incbin  'data\ooz\ooz_col.dat' 
Dust_Hill_Colision:        ; loc_0307EA:        
        incbin  'data\dhz\dhz_col.dat'  
Casino_Night_Colision_1:   ; loc_030AEA:        
        incbin  'data\cnz\cnz_col1.dat'  
Casino_Night_Colision_2:   ; loc_030DEA:        
        incbin  'data\cnz\cnz_col2.dat'  
Chemical_Plant_Colision_1: ; loc_0310EA:        
        incbin  'data\cpz\cpz_col1.dat' 
Chemical_Plant_Colision_2: ; loc_0313EA:        
        incbin  'data\cpz\cpz_col2.dat' 
Neo_Green_Hill_Colision_1: ; loc_0316EA:        
        incbin  'data\nghz\nghzcol1.dat'
Neo_Green_Hill_Colision_2: ; loc_0319EA:        
        incbin  'data\nghz\nghzcol2.dat'                                                                                              
;=============================================================================== 
; 16x16 Colision Index
; 
;===============================================================================          
;=============================================================================== 
; Special Stage Layout

;===============================================================================        
Special_Stage_1: ; loc_031CEA:
        IncBin  ".\data\ss\stage_1.eni"  
Special_Stage_2: ; loc_031F64:
        IncBin  ".\data\ss\stage_2.eni"  
Special_Stage_3: ; loc_032376:        
        IncBin  ".\data\ss\stage_3.eni"  
Special_Stage_4: ; loc_0326D2:
        IncBin  ".\data\ss\stage_4.eni"  
Special_Stage_5: ; loc_032BAC:
        IncBin  ".\data\ss\stage_5.eni"  
Special_Stage_6: ; loc_03305C:
        IncBin  ".\data\ss\stage_6.eni"                                       
;=============================================================================== 
; Special Stage Layout
; 
;===============================================================================  
;=============================================================================== 
; Level Layout

;===============================================================================          
Level_Layout: ; loc_03334E:               
        dc.w    Ghz_1_Foreground-Level_Layout,Ghz_Background-Level_Layout ; $0000
        dc.w    Ghz_2_Foreground-Level_Layout,Ghz_Background-Level_Layout ; $0001        
        dc.w    Null_Layout_1-Level_Layout,Null_Layout_1-Level_Layout ; $0100
        dc.w    Null_Layout_1-Level_Layout,Null_Layout_1-Level_Layout ; $0101        
        dc.w    Wz_1_Foreground-Level_Layout,Wz_1_Background-Level_Layout ; $0200
        dc.w    Wz_2_Foreground-Level_Layout,Wz_2_Background-Level_Layout ; $0201
        dc.w    Null_Layout_2-Level_Layout,Null_Layout_2-Level_Layout ; $0300
        dc.w    Null_Layout_2-Level_Layout,Null_Layout_2-Level_Layout ; $0301
        dc.w    Mz_1_Foreground-Level_Layout,Mz_Background-Level_Layout ; $0400
        dc.w    Mz_2_Foreground-Level_Layout,Mz_Background-Level_Layout ; $0401
        dc.w    Mz_3_Foreground-Level_Layout,Mz_Background-Level_Layout ; $0500
        dc.w    Mz_3_Foreground-Level_Layout,Mz_Background-Level_Layout ; $0501          
        dc.w    Null_Layout_3-Level_Layout,Null_Layout_3-Level_Layout ; $0600
        dc.w    Null_Layout_3-Level_Layout,Null_Layout_3-Level_Layout ; $0601
        dc.w    Htz_1_Foreground-Level_Layout,Htz_1_Background-Level_Layout ; $0700
        dc.w    Htz_2_Foreground-Level_Layout,Htz_2_Background-Level_Layout ; $0701
        dc.w    Hpz_Foreground-Level_Layout,Hpz_Background-Level_Layout ; $0800
        dc.w    Hpz_Foreground-Level_Layout,Hpz_Background-Level_Layout ; $0801
        dc.w    Null_Layout_4-Level_Layout,Null_Layout_4-Level_Layout ; $0900
        dc.w    Null_Layout_4-Level_Layout,Null_Layout_4-Level_Layout ; $0901
        dc.w    OOz_1_Foreground-Level_Layout,OOz_Background-Level_Layout ; $0A00
        dc.w    OOz_2_Foreground-Level_Layout,OOz_Background-Level_Layout ; $0A01
        dc.w    Dhz_1_Foreground-Level_Layout,Dhz_Background-Level_Layout ; $0B00
        dc.w    Dhz_2_Foreground-Level_Layout,Dhz_Background-Level_Layout ; $0B01
        dc.w    Cnz_1_Foreground-Level_Layout,Cnz_1_Background-Level_Layout ; $0C00
        dc.w    Cnz_2_Foreground-Level_Layout,Cnz_2_Background-Level_Layout ; $0C01
        dc.w    Cpz_1_Foreground-Level_Layout,Cpz_Background-Level_Layout ; $0D00
        dc.w    Cpz_2_Foreground-Level_Layout,Cpz_Background-Level_Layout ; $0D01
        dc.w    Null_Layout_5-Level_Layout,Null_Layout_5-Level_Layout ; $0E00
        dc.w    Null_Layout_5-Level_Layout,Null_Layout_5-Level_Layout ; $0E01
        dc.w    Nghz_1_Foreground-Level_Layout,Nghz_1_Background-Level_Layout ; $0F00
        dc.w    Nghz_2_Foreground-Level_Layout,Nghz_2_Background-Level_Layout ; $0F01
        dc.w    Null_Layout_6-Level_Layout,Null_Layout_6-Level_Layout ; $1000
        dc.w    Null_Layout_6-Level_Layout,Null_Layout_6-Level_Layout ; $1001             
Ghz_1_Foreground:  ; loc_0333D6:               
        incbin  'data\ghz\foreact1.dat'
Ghz_2_Foreground:  ; loc_033BD8:        
        incbin  'data\ghz\foreact2.dat'

Ghz_Background:    ; loc_0343DA:            
        dc.b    $03, $01 ; x / y
        dc.b    $F8, $F9, $FA, $FB, $FC, $FD, $FE, $FF         
Null_Layout_1:     ; loc_0343E4:             
        dc.b    $00, $00, $00, $00          
Wz_1_Foreground:   ; loc_0343E8:           
        incbin  'data\wz\foreact1.dat'
Wz_2_Foreground:   ; loc_034BEA: 
        incbin  'data\wz\foreact2.dat'
Wz_1_Background:   ; loc_0353EC: 
        incbin  'data\wz\backact1.dat'   
Wz_2_Background:   ; loc_035BEE:  
        incbin  'data\wz\backact2.dat'
Null_Layout_2:     ; loc_0363F0:             
        dc.b    $00, $00, $00, $00          
Mz_1_Foreground:   ; loc_0363F4: 
        incbin  'data\mz\foreact1.dat'                    
Mz_2_Foreground:   ; loc_036BF6: 
        incbin  'data\mz\foreact2.dat'   
Mz_Background:     ; loc_0373F8:            
        dc.b    $05, $05 ; x / y
        dc.b    $60, $61, $62, $63, $64, $F2, $70, $71, $72, $73, $74, $60, $E0, $E1, $E2, $E3
        dc.b    $E4, $70, $F0, $F1, $F2, $F3, $F4, $E2, $62, $61, $60, $63, $64, $62, $72, $71
        dc.b    $70, $73, $74, $72        
Mz_3_Foreground:   ; loc_03741E:  
        incbin  'data\mz\foreact3.dat'               
Null_Layout_3:     ; loc_037C20:            
        dc.b    $00, $00, $00, $00                        
Htz_1_Foreground:  ; loc_037C24: 
        incbin  'data\htz\foreact1.dat'
Htz_2_Foreground:  ; loc_038426:  
        incbin  'data\htz\foreact2.dat'              
Htz_1_Background:  ; loc_038C28:              
        incbin  'data\htz\backact1.dat'                 
Htz_2_Background:  ; loc_03942A:               
        incbin  'data\htz\backact2.dat'                      
Hpz_Foreground:    ; loc_039C2C:  
        incbin  'data\hpz\foreact1.dat'           
Hpz_Background:    ; loc_03942E:                     
        dc.b    $07, $08 ; x / y
        dc.b    $A3, $A3, $A3, $A3, $A3, $A3, $A3, $A3, $A0, $A1, $A0, $A1, $A0, $A1, $A0, $A1
        dc.b    $C0, $C1, $C2, $C3, $C4, $C5, $C6, $C7, $d0, $d1, $D2, $d3, $d4, $d5, $d6, $D7
        dc.b    $E0, $E1, $E2, $E3, $E4, $E5, $E6, $E7, $B0, $B1, $B0, $B1, $B0, $B1, $B0, $B1
        dc.b    $A2, $A2, $A2, $A2, $A2, $A2, $A2, $A2, $B2, $B2, $B2, $B2, $B2, $B2, $B2, $B2
        dc.b    $B2, $B2, $B2, $B2, $B2, $B2, $B2, $B2          
Null_Layout_4:     ; loc_03A478:            
        dc.b    $00, $00, $00, $00                          
OOz_1_Foreground:  ; loc_03A47C:  
        incbin  'data\ooz\foreact1.dat'                
OOz_2_Foreground:  ; loc_03AC7E:   
        incbin  'data\ooz\foreact2.dat'                 
OOz_Background:    ; loc_03B480:             
        dc.b    $05, $03  ; x / y
        dc.b    $00, $00, $00, $00, $00, $00, $02, $4F, $02, $1F, $02, $1F, $49, $4A, $4B, $23
        dc.b    $54, $6C, $4C, $4D, $4E, $32, $5A, $74          
Dhz_1_Foreground:  ; loc_03B49A:  
        incbin  'data\dhz\foreact1.dat'        
Dhz_2_Foreground:  ; loc_03BC9C:               
        incbin  'data\dhz\foreact2.dat'        
Dhz_Background:    ; loc_03C49E:              
        dc.b    $03, $03 ; x / y
        dc.b    $58, $5C, $63, $64, $65, $66, $6E, $6F, $73, $80, $86, $A3, $B0, $E7, $E8, $E9   
Cnz_1_Foreground:  ; loc_03C4B0:  
        incbin  'data\cnz\foreact1.dat' 
Cnz_2_Foreground:  ; loc_03CCB2:          
        incbin  'data\cnz\foreact2.dat'
Cnz_1_Background:  ; loc_03D4B4:
        incbin  'data\cnz\backact1.dat' 
Cnz_2_Background:  ; loc_03DCB6: 
        incbin  'data\cnz\backact1.dat' 
Cpz_1_Foreground:  ; loc_03DCC0:  
        incbin  'data\cpz\foreact1.dat'        
Cpz_2_Foreground:  ; loc_03E4C2: 
        incbin  'data\cpz\foreact2.dat'        
Cpz_Background:    ; loc_03ECC4: 
        dc.b    $05, $06 ; x / y
        dc.b    $A0, $A1, $A2, $00, $A4, $a5, $B0, $B1, $B2, $B3, $B4, $B5, $C0, $C1, $C2, $C3
        dc.b    $C4, $C5, $d0, $d1, $D2, $d3, $d4, $d5, $E0, $E1, $E2, $E3, $E4, $E5, $E0, $E3
        dc.b    $E2, $E3, $E4, $E5, $E0, $E4, $E2, $E1, $E4, $E5
Null_Layout_5:     ; loc_03ECF0:            
        dc.b    $00, $00, $00, $00      
Nghz_1_Foreground: ; loc_03ECF4:    
        incbin  'data\nghz\foreact1.dat'        
Nghz_2_Foreground: ; loc_03F4F6: 
        incbin  'data\nghz\foreact2.dat'         
Nghz_1_Background: ; loc_03ECF8:  
        incbin  'data\nghz\backact1.dat'         
Nghz_2_Background: ; loc_0404FA:  
        incbin  'data\nghz\backact2.dat'                    
Null_Layout_6:     ; loc_040CFC:             
        dc.b    $00, $00, $00, $00    
;=============================================================================== 
; Level Object Layout
; 
;===============================================================================            
loc_040D00: ; Big Ring - Left Over from Sonic 1        
        incbin  'data\sprites\bigring.dat'
loc_041940: ; Neo Green Hill Foreground Act 2 overwrite by Big Ring- Left Over from previous build ???         
        incbin  'data\nghz\fgunused.dat'  
loc_041B72: ; Neo Green Hill Background Act 1 - Left Over from previous build ???         
        incbin  'data\nghz\backact1.dat'                
loc_042374: ; Neo Green Hill Background Act 2 - Left Over from previous build ???         
        incbin  'data\nghz\bgunused.dat'  
loc_042B76: ; Filler for Null Level Layout - Left Over from previous build ???                
        dc.b    $00, $00, $00, $00                    
loc_042B7A: ; Another Big Ring - Left Over from Sonic 1  
        incbin  'data\sprites\bigring.dat'       
Unknow_Pallete_0x0437BA: ; loc_0437BA:
        dc.w    $0000, $0262, $02A4, $04E8, $0000, $0EEE        
Unknow_Data_0x0437C6: ; loc_0437C6:
        dc.b    $20, $00, $00, $2D, $01, $20, $02, $02, $02, $12, $03, $02, $C6, $20, $02, $03
        dc.b    $0B, $72, $20, $02, $06, $AD, $62, $02, $FF, $DC, $61, $02, $02, $01, $66, $02
        dc.b    $06, $07, $B1, $00, $02, $6A, $A0, $02, $01, $10, $02, $01, $21, $06, $09, $20
        dc.b    $00, $1A, $00, $12, $66, $1A, $AB, $16, $03, $01, $10, $03, $02, $10, $01, $03
        dc.b    $01, $01, $02, $52, $07, $01, $6D, $DD, $10, $67, $77, $DD, $01, $66, $BA, $00
        dc.b    $76, $06, $CD, $DD, $BB, $BC, $CD, $DD, $DD, $CB, $BA, $AA, $66, $06, $67, $77
        dc.b    $BB, $66, $66, $61, $00, $A1, $00, $70, $00, $B1, $07, $07, $0A, $01, $16, $60
        dc.b    $C1, $B0, $67, $76, $CB, $B6, $11, $67, $BC, $61, $17, $BA, $61, $16, $71, $00
        dc.b    $11, $00, $67, $DD, $00, $06, $66, $d6, $70, $16, $1B, $0B, $01, $11, $A0, $00
        dc.b    $60, $35, $FF, $FF, $76, $32, $02, $03, $AB, $66, $20, $02, $09, $A1, $10, $00
        dc.b    $B0, $A0, $02, $00, $6D, $77, $02, $06, $06, $76, $11, $20, $66, $AB, $02, $04
        dc.b    $42, $FF, $23, $02, $02, $06, $22, $16, $00, $02, $16, $6B, $02, $05, $7B, $A0
        dc.b    $00, $21, $10, $02, $05, $07, $A0, $00, $02, $11, $06, $16, $20, $16, $A0, $BC
        dc.b    $66, $11, $6B, $BC, $BB, $76, $16, $CB, $00, $B0, $61, $16, $00, $01, $17, $11
        dc.b    $00, $0A, $05, $01, $70, $02, $26, $01, $00, $DD, $DC, $61, $07, $DD, $DC, $CB
        dc.b    $BB, $BA, $AB, $BC, $DD, $67, $76, $60, $66, $11, $66, $66, $BB, $70, $70, $1A
        dc.b    $00, $77, $07, $1B, $00, $70, $76, $10, $A0, $44, $45, $56, $7D, $02, $02, $02
        dc.b    $20, $03, $01, $02, $16, $0A, $22, $33, $00, $02, $16, $66, $00, $21, $70, $10
        dc.b    $03, $05, $10, $02, $17, $00, $10, $03, $05, $11, $21, $70, $00, $11, $03, $0B
        dc.b    $11, $67, $00, $11, $0B, $BB, $BB, $AA, $A0, $A0, $A0, $02, $02, $0A, $AA, $03
        dc.b    $01, $AA, $03, $01, $AA, $03, $01, $AA, $03, $01, $AA, $02, $05, $01, $A0, $A0
        dc.b    $00, $11, $03, $01, $11, $03, $01, $11, $03, $01, $11, $03, $01, $11, $03, $01
        dc.b    $11, $03, $01, $11, $03, $0E, $FE, $FC, $F5, $54, $11, $31, $30, $01, $03, $00
        dc.b    $03, $01, $00, $10, $06, $06, $01, $00, $10, $00, $10, $F0, $02, $14, $01, $00
        dc.b    $01, $00, $03, $FF, $F0, $20, $B1, $2E, $F0, $10, $0B, $A2, $33, $20, $00, $0B
        dc.b    $BB, $BB, $10, $04, $22, $22, $22, $22, $04, $01, $20, $03, $01, $02, $04, $01
        dc.b    $20, $05, $05, $01, $00, $02, $00, $11, $03, $05, $11, $02, $FF, $DD, $DC, $02
        dc.b    $01, $A0, $02, $3D, $A0, $AA, $A0, $00, $10, $00, $0A, $00, $70, $00, $11, $02
        dc.b    $0A, $00, $07, $00, $11, $00, $70, $00, $27, $0A, $01, $32, $20, $CB, $71, $C6
        dc.b    $01, $07, $71, $0B, $70, $10, $16, $A0, $A1, $01, $11, $1A, $07, $10, $60, $66
        dc.b    $B0, $01, $10, $01, $70, $71, $71, $01, $17, $00, $16, $17, $7C, $BD, $DD, $71
        dc.b    $A0, $02, $01, $1A, $03, $03, $A0, $0A, $AA, $02, $73, $0A, $07, $A0, $A0, $00
        dc.b    $a6, $70, $1B, $BA, $01, $0A, $66, $67, $C1, $06, $DD, $d0, $16, $76, $00, $d1
        dc.b    $DD, $71, $00, $0C, $00, $76, $00, $0A, $0B, $70, $00, $06, $a6, $d6, $00, $d1
        dc.b    $10, $AB, $00, $07, $61, $7B, $00, $0A, $61, $16, $CD, $B0, $B0, $C7, $11, $00
        dc.b    $A0, $B1, $00, $0A, $10, $07, $10, $01, $00, $61, $17, $70, $70, $d6, $11, $77
        dc.b    $00, $A7, $1A, $B7, $01, $11, $60, $01, $10, $61, $0D, $0A, $01, $03, $76, $0A
        dc.b    $01, $10, $1B, $A1, $07, $72, $0B, $17, $0B, $10, $06, $61, $70, $00, $0D, $60
        dc.b    $AA, $10, $0A, $70, $B1, $70, $01, $11, $67, $12, $26, $66, $DC, $DF, $05, $02
        dc.b    $01, $A0, $06, $02, $01, $0A, $02, $07, $10, $A0, $BA, $21, $0A, $0A, $11, $03
        dc.b    $08, $01, $DC, $A0, $AA, $16, $00, $0A, $01, $04, $01, $77, $02, $01, $10, $02
        dc.b    $15, $A1, $07, $00, $AB, $10, $61, $10, $10, $06, $67, $16, $00, $66, $BA, $10
        dc.b    $01, $71, $00, $DD, $00, $0A, $0E, $02, $07, $7D, $02, $06, $67, $61, $d0, $00
        dc.b    $7A, $B7, $02, $04, $5F, $F4, $2F, $FD, $03, $01, $21, $02, $1E, $02, $17, $02
        dc.b    $22, $30, $16, $20, $11, $16, $67, $06, $70, $60, $10, $06, $77, $06, $77, $00
        dc.b    $10, $61, $16, $16, $60, $66, $71, $70, $00, $01, $10, $02, $1A, $10, $10, $66
        dc.b    $00, $11, $77, $76, $77, $07, $06, $01, $11, $61, $6B, $71, $60, $06, $AB, $66
        dc.b    $10, $0A, $B6, $17, $0D, $d0, $BD, $02, $01, $A0, $02, $1B, $AA, $A0, $00, $77
        dc.b    $d7, $DC, $00, $DD, $DD, $77, $d0, $AA, $AA, $AB, $1D, $77, $77, $BA, $60, $7D
        dc.b    $77, $61, $A0, $0A, $00, $60, $B7, $02, $03, $11, $10, $10, $03, $0C, $10, $11
        dc.b    $11, $10, $01, $75, $57, $71, $17, $20, $02, $27, $04, $0C, $10, $20, $00, $20
        dc.b    $12, $05, $44, $67, $00, $01, $01, $67, $02, $06, $67, $02, $10, $01, $02, $20
        dc.b    $02, $04, $20, $00, $02, $20, $06, $0F, $17, $07, $52, $22, $00, $46, $13, $33
        dc.b    $70, $11, $15, $00, $25, $77, $71, $02, $03, $22, $07, $50, $02, $01, $22, $07
        dc.b    $01, $02, $02, $07, $02, $56, $50, $11, $13, $66, $33, $02, $01, $01, $03, $01
        dc.b    $01, $04, $01, $07, $03, $01, $07, $03, $01, $07, $07, $09, $70, $00, $02, $7C
        dc.b    $16, $00, $02, $7A, $a6, $02, $02, $27, $A1, $03, $01, $6A, $02, $02, $02, $1B
        dc.b    $03, $01, $26, $03, $01, $02, $04, $05, $33, $32, $32, $24, $17, $04, $3B, $70
        dc.b    $11, $06, $66, $00, $17, $66, $B6, $10, $71, $B1, $CB, $A1, $0A, $0A, $1D, $C7
        dc.b    $BA, $DC, $22, $1B, $A7, $17, $5F, $DB, $70, $06, $A0, $01, $10, $10, $B0, $01
        dc.b    $10, $17, $6D, $d6, $01, $7A, $66, $11, $17, $B0, $B1, $71, $01, $00, $C1, $11
        dc.b    $17, $BA, $66, $67, $61, $67, $AD, $CB, $11, $6D, $02, $02, $A0, $7A, $02, $02
        dc.b    $01, $11, $02, $02, $07, $07, $02, $02, $01, $11, $03, $01, $71, $02, $02, $A0
        dc.b    $07, $05, $03, $0A, $17, $07, $03, $07, $07, $00, $01, $70, $01, $AA, $A7, $02
        dc.b    $08, $66, $60, $11, $01, $11, $11, $10, $76, $02, $14, $11, $12, $10, $00, $22
        dc.b    $20, $10, $17, $42, $00, $10, $61, $62, $00, $70, $76, $20, $00, $01, $02, $02
        dc.b    $02, $71, $20, $02, $01, $12, $03, $01, $20, $07, $04, $24, $FF, $FF, $55, $02
        dc.b    $10, $0A, $16, $00, $0A, $B6, $77, $00, $B1, $06, $61, $07, $01, $BA, $AA, $00
        dc.b    $1A, $02, $01, $07, $04, $01, $A0, $02, $0E, $60, $DA, $0B, $DB, $76, $6A, $00
        dc.b    $61, $16, $10, $0B, $BA, $10, $A0, $02, $01, $70, $03, $1A, $10, $A0, $00, $AB
        dc.b    $00, $1A, $AA, $10, $00, $01, $11, $00, $0B, $B0, $66, $BB, $A0, $A0, $06, $D0
        dc.b    $00, $16, $d1, $00, $0B, $6D, $02, $14, $B0, $d0, $A1, $00, $0B, $00, $16, $7D
        dc.b    $0A, $00, $6D, $A0, $01, $AB, $d0, $A0, $67, $70, $DC, $16, $03, $01, $01, $03
        dc.b    $01, $01, $03, $01, $01, $03, $01, $01, $03, $01, $01, $03, $01, $01, $03, $06
        dc.b    $01, $71, $76, $0C, $60, $10, $03, $01, $10, $03, $01, $10, $03, $01, $10, $03
        dc.b    $01, $10, $03, $01, $10, $03, $01, $10, $03, $04, $1D, $0D, $DD, $d7, $1C, $0D
        dc.b    $0B, $6C, $C1, $C6, $01, $77, $77, $71, $10, $11, $11, $10, $51, $03, $18, $25
        dc.b    $10, $00, $01, $62, $51, $00, $17, $07, $47, $46, $12, $57, $66, $22, $62, $57
        dc.b    $24, $75, $77, $01, $20, $01, $10, $03, $01, $01, $04, $02, $10, $70, $02, $16
        dc.b    $70, $00, $11, $16, $20, $00, $05, $52, $20, $00, $02, $22, $06, $75, $03, $33
        dc.b    $77, $71, $50, $00, $11, $10, $04, $16, $50, $00, $01, $11, $15, $00, $67, $77
        dc.b    $71, $00, $22, $20, $71, $00, $22, $56, $15, $00, $33, $45, $73, $34, $03, $01
        dc.b    $70, $03, $01, $70, $03, $01, $70, $03, $01, $70, $03, $01, $70, $03, $01, $70
        dc.b    $03, $05, $70, $22, $22, $01, $66, $06, $0F, $01, $01, $00, $10, $11, $11, $11
        dc.b    $11, $11, $11, $10, $10, $10, $10, $10, $02, $11, $70, $00, $07, $07, $77, $33
        dc.b    $01, $06, $6B, $02, $60, $10, $A0, $00, $A1, $00, $A0, $03, $01, $10, $03, $1C
        dc.b    $7A, $00, $A1, $10, $11, $02, $6A, $70, $06, $00, $1A, $B1, $00, $42, $06, $C7
        dc.b    $66, $70, $07, $C6, $77, $10, $07, $00, $11, $00, $01, $A0, $03, $01, $10, $03
        dc.b    $01, $60, $02, $01, $07, $03, $01, $0A, $02, $10, $DD, $DA, $76, $61, $BB, $B1
        dc.b    $17, $70, $BB, $BB, $B6, $67, $B0, $BB, $06, $61, $03, $13, $01, $B0, $BB, $a6
        dc.b    $61, $BB, $BB, $16, $66, $BB, $11, $17, $77, $CC, $67, $54, $44, $11, $10, $02
        dc.b    $02, $76, $60, $02, $01, $67, $07, $01, $77, $03, $02, $66, $60, $02, $02, $66
        dc.b    $10, $02, $06, $77, $71, $44, $44, $70, $07, $02, $07, $77, $00, $01, $11, $70
        dc.b    $01, $10, $02, $01, $10, $02, $01, $01, $02, $06, $AA, $11, $00, $0A, $00, $11
        dc.b    $03, $17, $61, $AA, $A0, $0A, $07, $A0, $0A, $A0, $21, $1A, $A0, $11, $00, $71
        dc.b    $11, $00, $02, $17, $00, $77, $00, $21, $77, $02, $02, $02, $11, $03, $08, $22
        dc.b    $11, $44, $34, $44, $66, $00, $17, $02, $08, $07, $00, $77, $00, $70, $11, $10
        dc.b    $77, $02, $02, $01, $11, $04, $02, $01, $10, $02, $08, $12, $22, $01, $16, $64
        dc.b    $44, $76, $76, $02, $1E, $16, $76, $00, $07, $71, $1B, $77, $70, $10, $1B, $11
        dc.b    $11, $01, $60, $00, $01, $17, $AB, $11, $10, $07, $CB, $77, $76, $66, $CB, $67
        dc.b    $61, $76, $BB, $03, $01, $01, $03, $02, $01, $01, $02, $16, $70, $00, $10, $61
        dc.b    $16, $16, $77, $66, $67, $17, $71, $06, $01, $21, $10, $10, $66, $50, $70, $1D
        dc.b    $07, $10, $03, $01, $10, $02, $02, $01, $10, $02, $15, $66, $66, $10, $0A, $B6
        dc.b    $71, $70, $01, $AB, $16, $11, $16, $6B, $61, $01, $10, $16, $7D, $7D, $d0, $D0
        dc.b    $06, $01, $A0, $02, $0B, $0A, $76, $00, $7D, $77, $61, $A0, $DD, $DD, $BA, $60
        dc.b    $02, $16, $BC, $11, $DD, $DD, $61, $01, $27, $31, $71, $37, $00, $22, $16, $26
        dc.b    $05, $65, $71, $62, $00, $54, $61, $02, $02, $02, $55, $56, $03, $01, $05, $08
        dc.b    $04, $55, $31, $54, $33, $03, $0E, $66, $61, $20, $01, $05, $20, $00, $05, $50
        dc.b    $07, $02, $50, $00, $42, $04, $01, $50, $02, $02, $04, $07, $02, $02, $60, $14
        dc.b    $02, $02, $65, $50, $02, $01, $50, $17, $0A, $0B, $BA, $88, $89, $B1, $32, $FF
        dc.b    $01, $02, $0F, $02, $04, $10, $F0, $00, $F0, $04, $01, $3F, $07, $01, $10, $02
        dc.b    $0B, $0F, $2D, $DE, $F0, $00, $30, $31, $F0, $00, $10, $1F, $06, $02, $03, $0F
        dc.b    $03, $0E, $10, $FF, $FF, $01, $33, $00, $01, $00, $31, $21, $23, $FF, $ED, $30
        dc.b    $02, $06, $FE, $31, $DD, $0F, $00, $30, $03, $0F, $01, $F0, $F0, $11, $10, $1F
        dc.b    $00, $1F, $F1, $01, $1F, $F0, $0F, $E0, $E0, $02, $0D, $0E, $FF, $FE, $DD, $77
        dc.b    $FF, $01, $22, $9A, $00, $FF, $00, $13, $02, $02, $F0, $01, $04, $03, $F0, $00
        dc.b    $0F, $05, $01, $1F, $03, $07, $93, $DD, $EE, $22, $0B, $11, $23, $02, $03, $BB
        dc.b    $01, $11, $02, $02, $BB, $BB, $10, $04, $AA, $AA, $AA, $AA, $04, $0C, $11, $10
        dc.b    $01, $11, $00, $01, $11, $23, $BB, $B0, $13, $10, $02, $01, $31, $03, $01, $10
        dc.b    $05, $0A, $AA, $B0, $23, $33, $11, $01, $01, $10, $01, $23, $02, $07, $32, $00
        dc.b    $30, $01, $0F, $10, $03, $04, $02, $30, $F0, $07, $04, $CC, $32, $22, $21, $02
        dc.b    $08, $12, $22, $01, $23, $21, $10, $03, $10, $02, $01, $01, $06, $03, $01, $00
        dc.b    $0F, $02, $16, $01, $00, $F0, $00, $02, $3D, $E1, $12, $11, $01, $23, $30, $33
        dc.b    $11, $01, $11, $00, $30, $11, $11, $00, $03, $04, $01, $33, $04, $02, $33, $10
        dc.b    $03, $04, $23, $33, $33, $32, $03, $04, $10, $11, $11, $11, $04, $02, $01, $11
        dc.b    $02, $01, $10, $03, $04, $03, $30, $00, $01, $04, $0B, $30, $21, $00, $01, $22
        dc.b    $00, $01, $11, $11, $01, $10, $02, $09, $10, $33, $33, $33, $33, $11, $11, $11
        dc.b    $01, $02, $01, $01, $03, $08, $12, $01, $00, $01, $20, $22, $33, $32, $05, $01
        dc.b    $11, $04, $01, $10, $02, $15, $30, $10, $00, $11, $21, $00, $11, $03, $00, $11
        dc.b    $33, $30, $11, $33, $01, $10, $10, $11, $11, $10, $03, $03, $01, $11, $03, $05
        dc.b    $3F, $00, $01, $00, $10, $03, $01, $10, $02, $01, $10, $03, $01, $01, $04, $06
        dc.b    $EF, $11, $00, $01, $00, $11, $02, $01, $0F, $04       
;=============================================================================== 
; Level Object Layout

;===============================================================================                    
Objects_Layout: ; loc_044000:  
        dc.w    Ghz_1_Objects_Layout-Objects_Layout
        dc.w    Ghz_2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    WZ1_Objects_Layout-Objects_Layout
        dc.w    WZ2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Mz_1_Objects_Layout-Objects_Layout
        dc.w    Mz_2_Objects_Layout-Objects_Layout
        dc.w    Mz_3_Objects_Layout-Objects_Layout
        dc.w    Mz_3_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Htz_1_Objects_Layout-Objects_Layout
        dc.w    Htz_2_Objects_Layout-Objects_Layout
        dc.w    Hpz_1_Objects_Layout-Objects_Layout
        dc.w    Hpz_2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    OOz_1_Objects_Layout-Objects_Layout
        dc.w    OOz_2_Objects_Layout-Objects_Layout
        dc.w    Dhz_1_Objects_Layout-Objects_Layout
        dc.w    Dhz_2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Cpz_1_Objects_Layout-Objects_Layout
        dc.w    Cpz_2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Nghz_1_Objects_Layout-Objects_Layout
        dc.w    Nghz_2_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    Null_Objects_Layout-Objects_Layout
        dc.w    $FFFF, $0000, $0000 ; The Game will crash if these bytes are missing
Ghz_1_Objects_Layout:  ; loc_04404A:
        incbin  'data\ghz\Obj_act1.dat'
Ghz_2_Objects_Layout:  ; loc_0442C6:
        incbin  'data\ghz\Obj_act2.dat'
Wz1_Objects_Layout:  ; loc_04404A:
        incbin  'data\wz\Obj_act1.dat'
Wz2_Objects_Layout:  ; loc_0442C6:
        incbin  'data\wz\Obj_act2.dat'				
Mz_1_Objects_Layout:   ; loc_0445C0:
        incbin  'data\mz\Obj_act1.dat'
Mz_2_Objects_Layout:   ; loc_04488A:
        incbin  'data\mz\Obj_act2.dat'
Mz_3_Objects_Layout:   ; loc_044B30:
        incbin  'data\mz\Obj_act3.dat'
Htz_1_Objects_Layout:  ; loc_044EFC:
        incbin  'data\htz\Obj_act1.dat'
Htz_2_Objects_Layout:  ; loc_045130:
        incbin  'data\htz\Obj_act2.dat'
Hpz_1_Objects_Layout:  ; loc_04554A:
        incbin  'data\hpz\Obj_act1.dat'
Hpz_2_Objects_Layout:  ; loc_045652:
        dc.w    $FFFF, $0000, $0000 
        dc.w    $FFFF, $0000, $0000 
OOz_1_Objects_Layout:  ; loc_04565E: 
        incbin  'data\ooz\Obj_act1.dat'
OOz_2_Objects_Layout:  ; loc_0457C0:
        incbin  'data\ooz\Obj_act2.dat'
Dhz_1_Objects_Layout:  ; loc_0459AC:
        incbin  'data\dhz\Obj_act1.dat'
Dhz_2_Objects_Layout:  ; loc_045A24:
        dc.w    $FFFF, $0000, $0000 
Cpz_1_Objects_Layout:  ; loc_045A2A:
        incbin  'data\cpz\Obj_act1.dat'
Cpz_2_Objects_Layout:  ; loc_045CC4:
        incbin  'data\cpz\Obj_act2.dat'
Nghz_1_Objects_Layout: ; loc_04605A:
        incbin  'data\nghz\Obj_act1.dat'
Nghz_2_Objects_Layout: ; loc_046216:
        incbin  'data\nghz\Obj_act2.dat'
Null_Objects_Layout:   ; loc_046348:
        dc.w    $FFFF, $0000, $0000 
;=============================================================================== 
; Level Object Layout
; 
;===============================================================================                    
Unknow_Data_0x04634E: ; loc_04634E:
        dc.b    $00, $00, $77, $07, $70, $01, $11, $17, $07, $70, $70, $11, $00, $07, $07, $11
        dc.b    $11, $01, $11, $01, $01, $10, $11, $00, $01, $16, $77, $00, $16, $61, $11, $77
        dc.b    $61, $01, $16, $01, $11, $17, $70, $10, $77, $71, $11, $76, $11, $11, $11, $11
        dc.b    $11, $10, $00, $67, $70, $70, $02, $21, $07, $07, $00, $10, $00, $07, $00, $60
        dc.b    $07, $71, $07, $07, $70, $11, $71, $11, $11, $17, $00, $11, $10, $70, $10, $00
        dc.b    $11, $01, $0A, $01, $17, $10, $A0, $00, $70, $02, $07, $11, $00, $0A, $00, $7C
        dc.b    $BB, $A0, $05, $01, $A0, $13, $01, $0A, $03, $01, $0A, $02, $01, $AA, $12, $01
        dc.b    $0A, $08, $05, $01, $AB, $BB, $C6, $66, $08, $01, $10, $04, $03, $07, $00, $10
        dc.b    $0C, $24, $66, $70, $77, $76, $00, $07, $70, $11, $00, $17, $77, $10, $00, $11
        dc.b    $07, $01, $00, $01, $70, $11, $00, $10, $77, $01, $00, $10, $70, $77, $00, $11
        dc.b    $11, $11, $DD, $DD, $76, $11, $0A, $01, $01, $03, $02, $A0, $70, $04, $01, $A0
        dc.b    $03, $01, $A0, $03, $03, $DD, $CC, $C1, $02, $02, $10, $77, $02, $02, $10, $07
        dc.b    $03, $0A, $70, $01, $00, $01, $07, $00, $10, $11, $07, $70, $02, $35, $17, $10
        dc.b    $00, $01, $01, $00, $06, $76, $77, $7D, $01, $11, $00, $0A, $01, $10, $00, $1A
        dc.b    $01, $00, $A0, $BA, $01, $0A, $AA, $AA, $17, $1A, $0B, $0A, $00, $76, $67, $66
        dc.b    $01, $11, $11, $11, $DD, $DD, $71, $6D, $00, $0A, $00, $7A, $00, $0A, $07, $0A
        dc.b    $00, $0A, $01, $02, $01, $A0, $02, $08, $AA, $A0, $00, $70, $00, $A0, $01, $0A
        dc.b    $02, $06, $01, $00, $66, $66, $10, $BA, $02, $03, $70, $00, $70, $03, $01, $07
        dc.b    $04, $01, $70, $06, $02, $01, $07, $02, $01, $10, $03, $04, $AA, $BB, $77, $DD
        dc.b    $07, $02, $01, $0A, $02, $02, $01, $0A, $02, $04, $01, $00, $0A, $70, $04, $09
        dc.b    $01, $A0, $00, $10, $01, $5D, $C1, $77, $7C, $03, $01, $A0, $03, $01, $AA, $03
        dc.b    $02, $0A, $20, $02, $02, $0A, $01, $09, $06, $10, $00, $DC, $CB, $BA, $AA, $03
        dc.b    $01, $0A, $02, $01, $0A, $03, $01, $0A, $04, $09, $A1, $A0, $00, $0A, $17, $0A
        dc.b    $AA, $A1, $71, $02, $06, $17, $11, $01, $66, $61, $01, $03, $13, $16, $10, $01
        dc.b    $01, $71, $07, $10, $17, $1A, $71, $16, $6B, $AA, $11, $71, $A0, $0A, $17, $1A
        dc.b    $02, $02, $71, $AA, $02, $0D, $71, $A0, $00, $0A, $61, $AA, $A0, $0A, $AA, $00
        dc.b    $A0, $00, $A0, $03, $01, $A0, $0F, $06, $AA, $AB, $BB, $CD, $00, $01, $02, $04
        dc.b    $A0, $01, $07, $11, $04, $04, $0A, $01, $01, $17, $02, $01, $70, $02, $03, $01
        dc.b    $00, $70, $02, $06, $10, $00, $CB, $11, $7D, $BB, $04, $05, $70, $10, $A0, $00
        dc.b    $01, $11, $05, $A0, $00, $BA, $AA, $A0, $05, $01, $A0, $03, $01, $A0, $05, $01
        dc.b    $0A, $03, $01, $01, $03, $01, $0B, $07, $02, $AA, $AB, $05, $01, $AA, $03, $03
        dc.b    $A0, $00, $10, $04, $02, $A0, $A0, $02, $05, $A0, $00, $01, $00, $0A, $03, $06
        dc.b    $B1, $16, $67, $66, $00, $70, $0C, $03, $01, $00, $07, $0B, $07, $61, $10, $06
        dc.b    $67, $00, $10, $77, $02, $02, $10, $77, $02, $02, $10, $77, $02, $02, $01, $77
        dc.b    $02, $03, $11, $70, $11, $02, $0A, $70, $11, $00, $10, $77, $00, $DD, $CC, $B6
        dc.b    $06, $11, $01, $0A, $03, $01, $0A, $06, $04, $CD, $DC, $C1, $77, $02, $06, $17
        dc.b    $70, $00, $01, $10, $07, $02, $02, $10, $77, $02, $03, $10, $00, $01, $02, $01
        dc.b    $70, $02, $02, $10, $70, $02, $26, $10, $70, $76, $77, $66, $11, $11, $00, $A0
        dc.b    $00, $11, $0A, $AA, $00, $01, $0A, $AA, $00, $01, $00, $AA, $00, $01, $00, $AA
        dc.b    $A0, $00, $10, $AA, $A0, $00, $10, $0A, $00, $11, $00, $10, $11, $02, $0D, $11
        dc.b    $00, $11, $01, $11, $00, $01, $11, $11, $00, $01, $01, $10, $05, $01, $70, $02
        dc.b    $01, $07, $04, $04, $61, $10, $01, $BC, $09, $09, $10, $0A, $A0, $00, $10, $10
        dc.b    $A0, $10, $10, $02, $01, $10, $03, $01, $01, $02, $05, $0A, $AB, $B0, $7D, $D7
        dc.b    $05, $03, $07, $00, $01, $05, $03, $A1, $00, $01, $03, $1A, $01, $00, $10, $00
        dc.b    $11, $00, $70, $00, $12, $DC, $06, $76, $75, $00, $07, $10, $10, $00, $07, $00
        dc.b    $11, $00, $07, $00, $10, $01, $03, $04, $20, $00, $70, $07, $02, $1C, $07, $71
        dc.b    $00, $10, $00, $11, $57, $77, $01, $17, $00, $17, $11, $71, $01, $71, $17, $1A
        dc.b    $17, $11, $71, $00, $71, $17, $10, $A0, $11, $71, $02, $02, $17, $10, $02, $09
        dc.b    $71, $00, $10, $A0, $1A, $AA, $BA, $A0, $A0, $1F, $01, $A0, $03, $01, $A0, $16
        dc.b    $09, $0A, $00, $AB, $DC, $B1, $00, $07, $00, $70, $03, $02, $70, $0A, $02, $03
        dc.b    $70, $00, $10, $02, $01, $A0, $06, $01, $07, $04, $04, $10, $16, $7C, $CC, $02
        dc.b    $01, $0A, $04, $01, $AA, $04, $01, $01, $04, $01, $01, $03, $01, $11, $03, $07
        dc.b    $01, $10, $00, $BB, $BB, $BA, $AA, $03, $01, $0A, $02, $05, $0A, $A0, $AA, $AA
        dc.b    $A0, $0C, $08, $10, $00, $01, $01, $01, $00, $01, $10, $06, $01, $01, $05, $09
        dc.b    $77, $00, $10, $00, $70, $11, $00, $07, $70, $02, $01, $07, $03, $07, $77, $00
        dc.b    $07, $77, $01, $11, $70, $05, $01, $10, $0E, $01, $01, $06, $24, $11, $11, $16
        dc.b    $66, $00, $10, $07, $01, $00, $10, $07, $01, $00, $11, $77, $01, $00, $01, $77
        dc.b    $71, $00, $10, $07, $77, $00, $11, $00, $70, $00, $10, $11, $11, $DD, $DD, $D7
        dc.b    $61, $12, $01, $A0, $03, $01, $01, $04, $05, $70, $CC, $DD, $77, $07, $03, $01
        dc.b    $77, $03, $01, $77, $07, $01, $77, $03, $02, $77, $01, $02, $01, $07, $02, $09
        dc.b    $01, $11, $77, $67, $7D, $77, $01, $10, $AA, $02, $02, $10, $AA, $02, $17, $10
        dc.b    $0A, $00, $01, $10, $01, $01, $01, $01, $10, $10, $77, $77, $77, $77, $11, $11
        dc.b    $11, $11, $16, $66, $66, $61, $0C, $01, $10, $02, $01, $77, $04, $01, $07, $02
        dc.b    $01, $01, $02, $0A, $70, $00, $23, $66, $10, $6A, $00, $01, $06, $1A, $02, $06
        dc.b    $61, $66, $02, $17, $17, $11, $02, $06, $01, $71, $00, $01, $0A, $B7, $03, $07
        dc.b    $0B, $00, $70, $A0, $00, $FD, $BA, $06, $01, $A0, $03, $01, $6A, $03, $14, $16
        dc.b    $A0, $0A, $00, $11, $6A, $0A, $00, $71, $16, $A0, $0A, $B7, $11, $1A, $0A, $F4
        dc.b    $10, $67, $CB, $02, $06, $01, $70, $00, $20, $17, $06, $02, $1C, $70, $66, $00
        dc.b    $21, $06, $61, $02, $17, $66, $10, $00, $77, $11, $0A, $21, $01, $70, $0A, $67
        dc.b    $77, $BA, $A0, $70, $6A, $00, $0A, $71, $A0, $02, $01, $1A, $03, $01, $A0, $04
        dc.b    $01, $A0, $03, $01, $A0, $04, $01, $0A, $03, $01, $0A, $05, $01, $A0, $03, $01
        dc.b    $A0, $02, $01, $AA, $02, $01, $AA, $02, $14, $0A, $00, $11, $00, $A0, $11, $07
        dc.b    $0A, $01, $07, $71, $0A, $AB, $B6, $67, $00, $AA, $A0, $00, $AA, $02, $12, $10
        dc.b    $00, $10, $11, $01, $11, $01, $00, $07, $07, $77, $77, $61, $70, $11, $11, $00
        dc.b    $11, $03, $09, $77, $61, $01, $11, $01, $00, $01, $00, $10, $04, $01, $70, $02
        dc.b    $05, $77, $11, $00, $10, $11, $05, $01, $11, $02, $09, $16, $77, $01, $16, $70
        dc.b    $00, $66, $00, $70, $02, $02, $07, $70, $03, $01, $77, $03, $01, $07, $03, $03
        dc.b    $07, $70, $70, $02, $02, $07, $77, $03, $06, $70, $67, $77, $77, $77, $10, $0D
        dc.b    $0B, $70, $77, $77, $07, $77, $70, $70, $70, $70, $70, $70, $03, $01, $77, $04
        dc.b    $01, $70, $02, $02, $07, $70, $02, $01, $77, $03, $01, $07, $02, $01, $01, $03
        dc.b    $01, $01, $09, $05, $01, $11, $11, $00, $10, $0A, $01, $01, $07, $01, $10, $06
        dc.b    $1B, $01, $01, $01, $11, $60, $01, $11, $01, $70, $00, $11, $10, $11, $01, $01
        dc.b    $01, $67, $11, $01, $6C, $BA, $10, $66, $B0, $00, $16, $BA, $02, $01, $6B, $03
        dc.b    $06, $AA, $00, $AB, $CC, $0A, $0A, $04, $01, $10, $03, $01, $07, $0A, $01, $A0
        dc.b    $03, $07, $01, $00, $01, $CD, $76, $70, $01, $02, $02, $10, $70, $02, $02, $10
        dc.b    $70, $04, $04, $10, $00, $10, $70, $02, $06, $10, $70, $00, $01, $10, $70, $02
        dc.b    $0A, $10, $70, $16, $66, $6C, $6C, $00, $10, $0A, $AA, $02, $1C, $0A, $AA, $00
        dc.b    $10, $0A, $AA, $00, $10, $0A, $AA, $00, $10, $0A, $AA, $00, $10, $0A, $AA, $01
        dc.b    $10, $0A, $AA, $16, $71, $66, $BA, $00, $07, $05, $01, $10, $02, $02, $07, $A0
        dc.b    $02, $01, $01, $03, $01, $7A, $03, $01, $10, $02, $0A, $07, $A0, $0A, $00, $71
        dc.b    $0A, $0A, $00, $10, $0A, $06, $01, $0A, $05, $01, $A0, $03, $01, $A0, $03, $03
        dc.b    $0A, $00, $10, $02, $08, $d6, $0D, $CB, $0A, $00, $01, $17, $A0, $02, $03, $01
        dc.b    $10, $01, $02, $0A, $7B, $A0, $70, $02, $17, $00, $01, $20, $00, $07, $02, $0F
        dc.b    $21, $10, $12, $00, $02, $67, $13, $45, $5F, $10, $17, $00, $0A, $77, $10, $02
        dc.b    $02, $71, $70, $04, $03, $01, $00, $11, $02, $01, $11, $05, $01, $70, $02, $05
        dc.b    $DC, $CB, $BB, $B1, $A0, $02, $09, $A0, $AA, $00, $AA, $01, $A0, $AA, $00, $17
        dc.b    $02, $20, $11, $71, $10, $11, $07, $11, $01, $00, $71, $17, $00, $07, $11, $71
        dc.b    $11, $00, $01, $67, $16, $61, $01, $10, $71, $01, $10, $01, $11, $10, $77, $77
        dc.b    $10, $77, $02, $02, $76, $11, $02, $03, $10, $00, $11, $04, $06, $10, $77, $77
        dc.b    $77, $76, $10, $03, $10, $01, $01, $00, $01, $70, $11, $00, $17, $07, $01, $01
        dc.b    $71, $00, $01, $07, $10, $02, $02, $11, $0A, $02, $0F, $70, $00, $67, $76, $10
        dc.b    $1D, $17, $1B, $AA, $10, $61, $A0, $00, $a6, $0A, $02, $02, $01, $A0, $02, $01
        dc.b    $0A, $07, $01, $A0, $03, $06, $A0, $CC, $CC, $CC, $CC, $10, $03, $01, $01, $03
        dc.b    $02, $60, $10, $02, $13, $16, $01, $00, $10, $AB, $71, $11, $11, $00, $a6, $11
        dc.b    $10, $00, $0A, $C6, $11, $CC, $CC, $C6, $11, $09, $10, $10, $01, $00, $01, $01
        dc.b    $10, $11, $11, $04, $03, $11, $11, $10, $03, $0B, $10, $00, $01, $01, $00, $01
        dc.b    $01, $10, $00, $01, $11, $02, $01, $11, $0A, $01, $01, $03, $01, $66, $02, $02
        dc.b    $06, $1A, $02, $05, $61, $A0, $00, $06, $1A, $02, $13, $61, $A0, $00, $01, $1A
        dc.b    $00, $0B, $16, $AA, $0A, $B6, $7A, $0A, $A1, $60, $B0, $00, $AB, $DD, $05, $14
        dc.b    $0A, $AB, $BB, $0A, $B1, $67, $77, $A1, $77, $11, $11, $66, $11, $01, $11, $10
        dc.b    $11, $10, $00, $11, $03, $06, $C6, $67, $00, $01, $00, $10, $02, $05, $A0, $07
        dc.b    $00, $10, $01, $04, $04, $70, $01, $00, $10, $03, $03, $07, $00, $10, $05, $06
        dc.b    $61, $11, $11, $11, $00, $01, $03, $3D, $11, $00, $70, $00, $11, $07, $71, $00
        dc.b    $10, $07, $70, $01, $10, $70, $70, $01, $10, $70, $10, $00, $11, $11, $00, $16
        dc.b    $77, $7D, $7D, $01, $00, $AA, $AA, $01, $00, $AA, $BA, $01, $00, $AA, $BA, $01
        dc.b    $0A, $AA, $AA, $17, $1A, $0B, $0A, $00, $76, $67, $66, $01, $11, $11, $11, $01
        dc.b    $17, $DD, $DD, $10, $7A, $02, $02, $07, $10, $02, $02, $01, $A0, $02, $01, $7A
        dc.b    $03, $02, $10, $0A, $02, $02, $A0, $0A, $06, $08, $DC, $B0, $00, $0A, $21, $0A
        dc.b    $00, $A0, $03, $03, $01, $00, $70, $05, $01, $07, $02, $10, $A0, $10, $02, $11
        dc.b    $00, $01, $00, $07, $00, $70, $43, $03, $5F, $32, $71, $20, $06, $01, $12, $0B
        dc.b    $01, $20, $07, $0F, $23, $33, $34, $44, $01, $00, $07, $77, $00, $10, $00, $11
        dc.b    $00, $01, $11, $03, $02, $01, $16, $02, $02, $10, $70, $02, $17, $10, $70, $10
        dc.b    $00, $10, $70, $71, $10, $07, $11, $71, $11, $71, $AA, $10, $17, $1A, $00, $16
        dc.b    $61, $A0, $00, $71, $03, $02, $10, $0A, $02, $01, $10, $03, $02, $10, $0A, $02
        dc.b    $08, $AA, $00, $AA, $AB, $00, $AA, $00, $01, $02, $01, $A0, $07, $01, $0A, $06
        dc.b    $01, $A0, $03, $09, $A0, $0A, $01, $BB, $DC, $B0, $AB, $00, $07, $06, $0D, $17
        dc.b    $00, $0A, $00, $01, $10, $0A, $00, $10, $70, $1A, $00, $70, $03, $01, $11, $03
        dc.b    $03, $21, $71, $A0, $06, $06, $01, $A0, $00, $02, $17, $1A, $02, $07, $21, $66
        dc.b    $BA, $00, $02, $21, $66, $02, $02, $02, $21, $03, $05, $02, $FF, $FF, $FF, $FF
        dc.b    $04, $07, $A0, $00, $0A, $00, $A0, $00, $0A, $05, $01, $BA, $03, $02, $66, $BA
        dc.b    $02, $17, $21, $66, $BA, $00, $41, $10, $76, $DD, $B6, $77, $70, $11, $0A, $11
        dc.b    $07, $70, $00, $A0, $10, $07, $00, $0A, $01, $03, $02, $A0, $10, $02, $02, $0A
        dc.b    $01, $03, $06, $A0, $DD, $DD, $DD, $d1, $10, $02, $02, $11, $01, $02, $08, $6A
        dc.b    $00, $10, $01, $A0, $70, $00, $07, $03, $05, $11, $00, $07, $00, $7A, $03, $1B
        dc.b    $10, $0A, $BB, $C7, $6D, $d6, $00, $A1, $10, $10, $0A, $16, $01, $00, $01, $60
        dc.b    $10, $77, $A7, $00, $07, $00, $01, $01, $70, $01, $10, $02, $0E, $10, $70, $17
        dc.b    $10, $11, $01, $07, $67, $77, $00, $77, $77, $70, $77, $02, $01, $07, $04, $05
        dc.b    $01, $11, $11, $01, $11, $02, $02, $10, $01, $03, $01, $10, $03, $06, $76, $67
        dc.b    $77, $77, $00, $10, $02, $01, $01, $02, $02, $01, $10, $02, $01, $01, $02, $02
        dc.b    $01, $01, $02, $02, $01, $10, $02, $01, $01, $02, $0D, $01, $00, $07, $10, $10
        dc.b    $60, $70, $11, $70, $77, $01, $00, $77, $02, $16, $10, $77, $70, $10, $00, $77
        dc.b    $01, $00, $07, $00, $01, $00, $07, $70, $01, $00, $07, $01, $10, $00, $61, $10
        dc.b    $03, $02, $A0, $A0, $02, $25, $AA, $AA, $00, $0A, $0A, $AA, $00, $0A, $0A, $AA
        dc.b    $00, $0A, $AA, $AA, $A0, $AA, $AA, $AA, $A0, $A0, $AA, $AA, $00, $AA, $0A, $00
        dc.b    $AA, $0A, $00, $AA, $00, $0A, $0A, $A0, $00, $0A, $A0, $02, $02, $A0, $0A, $03
        dc.b    $01, $A0, $02, $01, $1A, $02, $02, $A0, $B0, $02, $08, $A0, $FF, $DC, $B0, $CD
        dc.b    $00, $21, $0A, $03, $01, $70, $02, $03, $02, $11, $12, $02, $01, $07, $03, $02
        dc.b    $21, $20, $02, $01, $02, $08, $01, $20, $02, $01, $02, $03, $01, $27, $02, $02
        dc.b    $02, $6A, $03, $01, $10, $02, $05, $26, $A0, $72, $00, $01, $02, $08, $02, $1A
        dc.b    $00, $A0, $02, $3F, $FF, $F2, $0F, $01, $02, $07, $01, $20, $03, $25, $01, $45
        dc.b    $5F, $5F, $DC, $10, $0A, $A0, $00, $10, $10, $AA, $00, $01, $10, $00, $AA, $70
        dc.b    $10, $10, $00, $16, $71, $01, $16, $60, $16, $66, $61, $17, $76, $66, $66, $AA
        dc.b    $AB, $B1, $07, $02, $1F, $A1, $71, $00, $0A, $17, $16, $AA, $A1, $71, $10, $01
        dc.b    $66, $11, $70, $76, $11, $17, $00, $11, $67, $70, $01, $77, $00, $11, $10, $60
        dc.b    $01, $0A, $AA, $60, $02, $05, $0A, $00, $10, $A0, $0A, $04, $02, $01, $0A, $02
        dc.b    $02, $10, $A0, $03, $01, $A0, $02, $02, $AA, $A0, $02, $1C, $0A, $DD, $DD, $DF
        dc.b    $01, $00, $01, $02, $07, $00, $01, $10, $A1, $00, $01, $00, $10, $00, $01, $00
        dc.b    $70, $00, $01, $00, $10, $00, $10, $10, $02, $05, $10, $10, $00, $01, $10, $02
        dc.b    $1F, $01, $00, $12, $00, $01, $01, $12, $00, $11, $01, $10, $00, $11, $10, $02
        dc.b    $00, $10, $01, $20, $01, $11, $02, $00, $01, $02, $20, $00, $22, $20, $00, $02
        dc.b    $13, $01, $02, $08, $0C, $44, $23, $5F, $F4, $10, $07, $A0, $A0, $00, $01, $A0
        dc.b    $17, $02, $04, $A0, $01, $01, $1A, $04, $0D, $0A, $70, $00, $70, $00, $10, $A0
        dc.b    $10, $01, $00, $d7, $1A, $C6, $02, $02, $77, $10, $02, $01, $10, $05, $01, $11
        dc.b    $02, $01, $11, $02, $01, $01, $03, $0D, $10, $00, $07, $01, $00, $07, $70, $00
        dc.b    $76, $61, $11, $01, $71, $03, $06, $16, $10, $00, $11, $10, $61, $02, $03, $01
        dc.b    $06, $10, $02, $08, $10, $70, $77, $00, $01, $01, $00, $77, $02, $10, $66, $66
        dc.b    $00, $07, $00, $10, $00, $70, $01, $11, $07, $77, $01, $10, $07, $70, $02, $06
        dc.b    $07, $70, $01, $00, $77, $77, $02, $35, $70, $70, $01, $11, $11, $11, $66, $76
        dc.b    $77, $77, $00, $11, $00, $0A, $00, $11, $00, $0A, $01, $11, $00, $0A, $01, $10
        dc.b    $00, $0A, $00, $11, $11, $11, $77, $77, $77, $77, $11, $11, $11, $11, $DD, $7D
        dc.b    $7D, $77, $A0, $AA, $AA, $00, $AA, $AA, $AA, $00, $A0, $AA, $0A, $02, $13, $A0
        dc.b    $01, $01, $11, $11, $10, $10, $77, $77, $77, $77, $11, $11, $11, $11, $DD, $DD
        dc.b    $DD, $DD, $0D, $07, $0A, $00, $0A, $00, $0A, $00, $A0, $02, $02, $0A, $01, $02
        dc.b    $01, $A0, $03, $02, $A0, $67, $02, $03, $0A, $70, $A0, $02, $02, $10, $A0, $02
        dc.b    $01, $A7, $02, $02, $0A, $01, $02, $02, $0A, $0A, $08, $02, $CD, $B0, $02, $02
        dc.b    $71, $7B, $02, $03, $77, $77, $A0, $02, $10, $07, $6A, $A0, $77, $00, $76, $1A
        dc.b    $10, $07, $07, $71, $00, $77, $00, $70, $a6, $03, $04, $0A, $CB, $BB, $BB, $10
        dc.b    $01, $AA, $03, $02, $61, $A0, $02, $02, $70, $0A, $02, $05, $46, $77, $DD, $DC
        dc.b    $02, $02, $03, $01, $00, $20, $03, $01, $02, $04, $01, $20, $03, $02, $02, $20
        dc.b    $03, $01, $02, $04, $05, $23, $33, $44, $45, $10, $02, $01, $01, $02, $07, $70
        dc.b    $00, $10, $00, $07, $00, $01, $02, $16, $70, $00, $11, $00, $07, $22, $00, $11
        dc.b    $10, $00, $22, $22, $01, $45, $55, $FF, $DD, $10, $00, $A0, $00, $10, $04, $05
        dc.b    $10, $0A, $00, $01, $01, $02, $16, $70, $00, $10, $A0, $07, $70, $01, $0A, $11
        dc.b    $16, $66, $66, $DD, $DD, $DD, $C6, $00, $0A, $00, $0A, $00, $0A, $0E, $01, $A0
        dc.b    $03, $08, $6C, $CB, $BB, $BB, $C6, $CB, $BB, $BB, $04, $01, $0A, $09, $01, $A0
        dc.b    $03, $01, $A0, $05, $08, $BB, $BB, $BB, $BB, $BB, $BB, $BB, $BB, $02, $01, $0A
        dc.b    $03, $01, $0A, $02, $01, $A0, $03, $03, $A0, $00, $0A, $02, $0E, $0A, $A0, $00
        dc.b    $AA, $A0, $11, $BC, $66, $77, $66, $43, $33, $22, $20, $0B, $01, $21, $06, $02
        dc.b    $02, $17, $03, $01, $01, $02, $11, $21, $6A, $23, $4F, $DC, $A0, $21, $70, $00
        dc.b    $A0, $00, $0B, $00, $A0, $02, $17, $A0, $02, $07, $01, $1A, $0A, $00, $20, $70
        dc.b    $AA, $02, $0A, $11, $0A, $00, $02, $07, $10, $FF, $FF, $DC, $BA, $04, $01, $A0
        dc.b    $02, $02, $A0, $A0, $02, $05, $10, $A0, $00, $0A, $0A, $0C, $14, $5D, $BA, $A0
        dc.b    $BA, $00, $71, $10, $AA, $02, $17, $71, $10, $00, $21, $17, $76, $00, $02, $21
        dc.b    $11, $02, $02, $02, $20, $03, $01, $02, $04, $04, $FF, $FF, $FF, $FF, $04, $02
        dc.b    $AA, $A0, $02, $0C, $11, $1B, $AA, $AA, $66, $77, $66, $66, $00, $11, $11, $11
        dc.b    $03, $02, $01, $20, $03, $04, $FD, $DD, $DD, $DC, $09, $01, $0A, $03, $01, $0A
        dc.b    $05, $01, $0A, $03, $01, $A0, $02, $06, $0A, $01, $00, $0A, $A0, $10, $02, $01
        dc.b    $01, $02, $1B, $A0, $10, $07, $0A, $01, $00, $70, $A0, $10, $07, $01, $01, $00
        dc.b    $70, $10, $10, $77, $01, $00, $07, $00, $10, $00, $BC, $CC, $DD, $DD, $04, $01
        dc.b    $0A, $03, $01, $0A, $03, $09, $A0, $00, $0A, $00, $10, $00, $0A, $00, $7B, $03
        dc.b    $01, $17, $03, $12, $d6, $CC, $BA, $BA, $00, $70, $01, $11, $0A, $10, $01, $11
        dc.b    $00, $07, $71, $10, $00, $A1, $04, $01, $07, $02, $02, $0A, $70, $04, $0D, $10
        dc.b    $AB, $BB, $06, $BA, $01, $01, $01, $BA, $00, $10, $11, $01, $03, $0F, $11, $00
        dc.b    $A0, $00, $0A, $0A, $AA, $0A, $AA, $0A, $AA, $A0, $0A, $A0, $AA, $02, $02, $0A
        dc.b    $A0, $06, $01, $AA, $03, $02, $11, $A0, $02, $03, $BB, $0B, $A0, $02, $02, $AB
        dc.b    $A0, $09, $06, $CC, $CD, $DD, $DD, $00, $01, $02, $02, $10, $01, $02, $02, $10
        dc.b    $11, $03, $02, $11, $10, $02, $05, $11, $10, $00, $11, $11, $03, $07, $10, $02
        dc.b    $02, $DD, $DD, $74, $DF, $02, $01, $01, $06, $02, $0A, $0A, $07, $01, $A0, $02
        dc.b    $01, $A0, $03, $01, $0A, $02, $04, $FF, $5F, $FF, $FF, $09, $0F, $02, $22, $20
        dc.b    $00, $21, $11, $12, $02, $17, $66, $61, $00, $71, $AA, $a6, $03, $05, $0A, $00
        dc.b    $0A, $00, $0B, $03, $01, $01, $03, $04, $A0, $00, $0A, $A0, $02, $13, $71, $0A
        dc.b    $01, $20, $17, $11, $17, $61, $01, $66, $61, $BC, $77, $77, $77, $DF, $55, $55
        dc.b    $55, $04, $01, $12, $03, $02, $71, $20, $03, $12, $12, $02, $22, $61, $10, $21
        dc.b    $66, $11, $17, $7C, $BB, $6C, $CA, $A0, $00, $5F, $FF, $DA, $02, $02, $02, $6A
        dc.b    $02, $09, $26, $10, $00, $22, $61, $A0, $00, $16, $BA, $02, $01, $6B, $02, $02
        dc.b    $0A, $A0, $02, $01, $A1, $02, $05, $AB, $11, $FF, $FF, $76, $04, $01, $71, $02
        dc.b    $01, $20, $04, $01, $17, $06, $01, $02, $04, $01, $01, $04, $04, $5F, $FF, $F5
        dc.b    $67, $07, $01, $0A, $02, $04, $01, $10, $00, $0A, $02, $02, $A0, $0A, $04, $02
        dc.b    $A0, $A0, $06, $01, $A1, $03, $13, $0A, $0A, $00, $0A, $AB, $B6, $AB, $B6, $66
        dc.b    $60, $67, $61, $11, $17, $11, $11, $67, $70, $11, $02, $1D, $01, $00, $07, $00
        dc.b    $01, $CC, $60, $70, $1B, $BC, $67, $71, $A0, $70, $07, $1A, $00, $07, $61, $00
        dc.b    $0A, $71, $00, $A0, $0A, $10, $00, $A0, $A0, $02, $02, $A0, $A0, $02, $1C, $A0
        dc.b    $00, $AA, $AA, $0A, $BB, $00, $0A, $01, $07, $00, $A0, $10, $70, $0A, $01, $07
        dc.b    $01, $A0, $17, $70, $10, $11, $70, $11, $00, $77, $01, $02, $02, $11, $10, $02
        dc.b    $02, $11, $10, $03, $01, $10, $02, $01, $11, $0D, $01, $01, $02, $0C, $01, $01
        dc.b    $10, $00, $01, $00, $10, $d0, $17, $DD, $DD, $A0, $03, $14, $10, $01, $A0, $00
        dc.b    $06, $17, $1A, $00, $77, $11, $66, $BA, $00, $01, $11, $66, $11, $11, $10, $01
        dc.b    $04, $04, $DD, $DD, $DD, $DD, $04, $07, $A0, $00, $0A, $00, $A0, $00, $0A, $05
        dc.b    $01, $BA, $03, $02, $66, $BA, $02, $03, $01, $66, $BA, $02, $03, $0A, $DF, $55
        dc.b    $02, $04, $03, $33, $11, $1B, $03, $12, $01, $AB, $BB, $77, $77, $10, $16, $00
        dc.b    $06, $16, $6B, $11, $61, $71, $A0, $AA, $07, $1A, $02, $0A, $DB, $A0, $00, $02
        dc.b    $22, $22, $20, $00, $11, $11, $02, $02, $0D, $d0, $06, $02, $0D, $d0, $02, $07
        dc.b    $11, $11, $00, $02, $22, $22, $20, $04, $07, $02, $22, $22, $20, $00, $11, $11
        dc.b    $02, $02, $0D, $d0, $06, $02, $0D, $d0, $02, $07, $11, $11, $00, $02, $22, $22
        dc.b    $20, $04, $07, $02, $22, $22, $20, $00, $11, $11, $02, $02, $0D, $d0, $06, $02
        dc.b    $0D, $d0, $02, $17, $11, $11, $00, $02, $22, $22, $20, $DD, $DD, $DD, $DD, $06
        dc.b    $11, $11, $11, $07, $C7, $77, $77, $00, $B1, $11, $11, $02, $02, $0A, $AA, $02
        dc.b    $02, $AA, $AA, $08, $38, $01, $67, $d7, $77, $11, $11, $11, $11, $77, $77, $77
        dc.b    $77, $11, $11, $11, $11, $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA, $04, $44, $40
        dc.b    $00, $40, $00, $04, $00, $33, $33, $33, $77, $11, $11, $11, $11, $77, $77, $77
        dc.b    $77, $11, $11, $11, $11, $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA, $03, $01, $44
        dc.b    $02, $0B, $04, $00, $77, $77, $73, $33, $01, $11, $11, $11, $10, $03, $05, $07
        dc.b    $77, $77, $77, $70, $03, $04, $01, $11, $11, $11, $04, $0C, $0A, $AA, $AA, $AA
        dc.b    $6D, $DD, $DD, $DD, $11, $11, $11, $11, $04, $04, $77, $77, $77, $77, $04, $04
        dc.b    $11, $11, $11, $11, $04, $04, $AA, $AA, $AA, $AA, $04, $07, $02, $22, $22, $20
        dc.b    $00, $11, $11, $02, $02, $0D, $d0, $06, $02, $0D, $d0, $02, $07, $11, $11, $00
        dc.b    $02, $22, $22, $20, $07, $01, $A0, $03, $01, $A0, $03, $01, $A0, $03, $01, $A0
        dc.b    $0E, $01, $A0, $03, $01, $A0, $13, $01, $A0, $03, $39, $A0, $00, $AB, $AB, $CD
        dc.b    $DF, $01, $10, $71, $12, $01, $10, $77, $10, $11, $10, $76, $10, $11, $10, $71
        dc.b    $10, $01, $10, $01, $00, $01, $07, $71, $02, $10, $00, $70, $02, $66, $61, $13
        dc.b    $22, $11, $10, $12, $00, $70, $71, $10, $20, $67, $77, $01, $00, $70, $77, $11
        dc.b    $00, $10, $00, $11, $02, $0B, $71, $11, $12, $07, $71, $11, $10, $43, $43, $23
        dc.b    $22, $07, $01, $02, $02, $02, $02, $2B, $02, $23, $2B, $B3, $00, $02, $B3, $35
        dc.b    $00, $0B, $30, $55, $00, $20, $00, $50, $00, $2B, $88, $89, $02, $2B, $BB, $00
        dc.b    $2B, $B3, $33, $B1, $B6, $65, $50, $3B, $60, $55, $50, $03, $05, $03, $24, $50
        dc.b    $00, $33, $30, $00, $03, $0B, $B3, $99, $8B, $A1, $1D, $07, $00, $10, $70, $07
        dc.b    $10, $00, $70, $10, $76, $01, $07, $B1, $70, $60, $11, $3B, $17, $06, $60, $03
        dc.b    $B1, $70, $17, $02, $06, $17, $11, $AA, $BB, $B9, $EE, $02, $04, $03, $33, $00
        dc.b    $2B, $03, $03, $02, $BB, $BB, $03, $13, $16, $00, $02, $16, $6B, $00, $21, $71
        dc.b    $A0, $00, $07, $1A, $00, $A9, $BD, $7D, $d6, $30, $0B, $02, $10, $0B, $B0, $00
        dc.b    $B0, $B1, $66, $11, $B0, $7C, $BB, $67, $1B, $A0, $00, $AB, $C7, $03, $01, $0A
        dc.b    $04, $05, $56, $6D, $DD, $CA, $30, $02, $15, $17, $00, $B0, $10, $11, $0B, $01
        dc.b    $71, $10, $B0, $17, $07, $11, $11, $71, $10, $71, $CC, $BA, $01, $07, $02, $06
        dc.b    $AA, $B1, $DC, $BA, $0A, $A0, $0A, $01, $A0, $06, $0F, $B1, $11, $11, $00, $C7
        dc.b    $77, $77, $01, $11, $11, $11, $33, $33, $33, $77, $04, $07, $40, $00, $04, $00
        dc.b    $04, $44, $40, $05, $10, $11, $11, $11, $11, $77, $77, $77, $77, $11, $11, $11
        dc.b    $11, $77, $77, $73, $33, $06, $01, $04, $04, $01, $44, $04, $14, $11, $11, $11
        dc.b    $11, $77, $77, $77, $77, $11, $11, $11, $11, $6D, $DD, $DD, $DD, $0A, $AA, $AA
        dc.b    $AA, $04, $05, $01, $11, $11, $11, $70, $03, $05, $07, $77, $77, $77, $10, $03
        dc.b    $0C, $01, $11, $11, $11, $DD, $DD, $DD, $DD, $AA, $AA, $AA, $AA, $04, $04, $11
        dc.b    $11, $11, $11, $04, $04, $77, $77, $77, $77, $04, $0F, $11, $11, $11, $11, $DD
        dc.b    $DD, $DD, $DD, $02, $22, $22, $20, $00, $11, $11, $02, $02, $0D, $d0, $06, $02
        dc.b    $0D, $d0, $02, $07, $11, $11, $00, $02, $22, $22, $20, $10, $01, $B0, $03, $01
        dc.b    $B0, $18, $01, $0A, $03, $01, $0A, $08, $01, $0A, $03, $41, $0A, $00, $AB, $BB
        dc.b    $CD, $CD, $01, $07, $71, $00, $01, $07, $70, $10, $01, $07, $70, $10, $01, $07
        dc.b    $71, $00, $10, $07, $00, $12, $77, $71, $10, $20, $11, $10, $00, $22, $66, $11
        dc.b    $10, $10, $00, $01, $01, $10, $07, $71, $01, $10, $07, $77, $01, $10, $70, $77
        dc.b    $10, $00, $77, $70, $11, $02, $70, $11, $12, $20, $11, $02, $20, $01
Unknow_Pallete_0x0474AC:
loc_0474AC:
        dc.w    $0000, $0A20, $0666, $0888, $0CAA, $0ECC, $0246, $0008
        dc.w    $000E, $046A, $068C, $08CE, $0E22, $0E62, $0000, $0EEE
        dc.w    $0000, $0A42, $0C64, $0E86, $048A, $08CE, $0046, $0068
        dc.w    $008A, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE
        dc.w    $0000, $044C, $066E, $0AAE, $048A, $08CE, $0E46, $0E68
        dc.w    $0E8A, $04CE, $0A24, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0E22, $0E42, $0E62, $0E82, $0C68, $0848, $0628
        dc.w    $0E88, $0E66, $0E44, $0C22, $0A02, $0602, $0000, $0EEE
        dc.w    $0664, $0444, $0666, $0888, $0444, $0666, $0888, $0444
        dc.w    $0888, $0666, $0222, $0262, $02A4, $04E8, $0000, $0EEE
        dc.w    $0664, $0EEE, $0EEE, $0EEE, $0EEE, $0EEE, $0EEE, $0EEE
        dc.w    $0EEE, $0EEE, $0EEE, $0262, $02A4, $04E8, $0000, $0EEE
        dc.w    $0664, $0C4C, $0C8C, $0CCC, $026A, $048C, $04CC, $0A84
        dc.w    $0EA6, $0AAA, $0222, $0262, $02A4, $04E8, $0000, $0EEE
        dc.w    $0664, $0A2C, $0E4E, $0EAE, $006C, $048C, $00CE, $0E62
        dc.w    $0E84, $0888, $0222, $0262, $02A4, $04E8, $0000, $0EEE
        dc.w    $0664, $080A, $0C4C, $0C8E, $004A, $046C, $00AE, $0C40
        dc.w    $0E84, $0666, $0000, $0262, $02A4, $04E8, $0000, $0EEE
        dc.w    $0622, $0262, $02A4, $04E8, $0400, $0620, $0840, $0A40
        dc.w    $0A40, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE
        dc.w    $0622, $0262, $02A4, $04E8, $0600, $0820, $0A60, $0C82
        dc.w    $0EA4, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE 
Unknow_Data_0x04760C:
loc_04760C:
        dc.b    $40, $00, $00, $2D, $01, $20, $02, $02, $02, $12, $03, $02, $C6, $20, $02, $03
        dc.b    $0B, $72, $20, $02, $06, $AD, $62, $02, $FF, $DC, $61, $02, $02, $01, $66, $02
        dc.b    $06, $07, $B1, $00, $02, $6A, $A0, $02, $01, $10, $02, $01, $21, $06, $09, $20
        dc.b    $00, $1A, $00, $12, $66, $1A, $AB, $16, $03, $01, $10, $03, $02, $10, $01, $03
        dc.b    $01, $01, $02, $52, $07, $01, $6D, $DD, $10, $67, $77, $DD, $01, $66, $BA, $00
        dc.b    $76, $06, $CD, $DD, $BB, $BC, $CD, $DD, $DD, $CB, $BA, $AA, $66, $06, $67, $77
        dc.b    $BB, $66, $66, $61, $00, $A1, $00, $70, $00, $B1, $07, $07, $0A, $01, $16, $60
        dc.b    $C1, $B0, $67, $76, $CB, $B6, $11, $67, $BC, $61, $17, $BA, $61, $16, $71, $00
        dc.b    $11, $00, $67, $DD, $00, $06, $66, $d6, $70, $16, $1B, $0B, $01, $11, $A0, $00
        dc.b    $60, $35, $FF, $FF, $76, $32, $02, $03, $AB, $66, $20, $02, $09, $A1, $10, $00
        dc.b    $B0, $A0, $02, $00, $6D, $77, $02, $06, $06, $76, $11, $20, $66, $AB, $02, $04
        dc.b    $42, $FF, $23, $02, $02, $06, $22, $16, $00, $02, $16, $6B, $02, $05, $7B, $A0
        dc.b    $00, $21, $10, $02, $05, $07, $A0, $00, $02, $11, $06, $16, $20, $16, $A0, $BC
        dc.b    $66, $11, $6B, $BC, $BB, $76, $16, $CB, $00, $B0, $61, $16, $00, $01, $17, $11
        dc.b    $00, $0A, $05, $01, $70, $02, $26, $01, $00, $DD, $DC, $61, $07, $DD, $DC, $CB
        dc.b    $BB, $BA, $AB, $BC, $DD, $67, $76, $60, $66, $11, $66, $66, $BB, $70, $70, $1A
        dc.b    $00, $77, $07, $1B, $00, $70, $76, $10, $A0, $44, $45, $56, $7D, $02, $02, $02
        dc.b    $20, $03, $01, $02, $16, $0A, $22, $33, $00, $02, $16, $66, $00, $21, $70, $10
        dc.b    $03, $05, $10, $02, $17, $00, $10, $03, $05, $11, $21, $70, $00, $11, $03, $0B
        dc.b    $11, $67, $00, $11, $0B, $BB, $BB, $AA, $A0, $A0, $A0, $02, $02, $0A, $AA, $03
        dc.b    $01, $AA, $03, $01, $AA, $03, $01, $AA, $03, $01, $AA, $02, $05, $01, $A0, $A0
        dc.b    $00, $11, $03, $01, $11, $03, $01, $11, $03, $01, $11, $03, $01, $11, $03, $01
        dc.b    $11, $03, $01, $11, $03, $0D, $76, $66, $6C, $CC, $0C, $66, $67, $77, $1B, $AA
        dc.b    $AB, $BB, $07, $0A, $01, $0A, $03, $01, $A0, $02, $13, $0A, $00, $10, $CC, $C6
        dc.b    $66, $77, $77, $77, $76, $BB, $BB, $B1, $16, $00, $AA, $A0, $10, $AA, $04, $05
        dc.b    $01, $10, $00, $01, $10, $02, $01, $10, $03, $04, $66, $66, $67, $61, $04, $01
        dc.b    $20, $03, $01, $02, $04, $01, $20, $05, $05, $01, $00, $02, $00, $11, $03, $05
        dc.b    $11, $02, $FF, $DD, $DC, $02, $01, $A0, $02, $3D, $A0, $AA, $A0, $00, $10, $00
        dc.b    $0A, $00, $70, $00, $11, $02, $0A, $00, $07, $00, $11, $00, $70, $00, $27, $0A
        dc.b    $01, $32, $20, $CB, $71, $C6, $01, $07, $71, $0B, $70, $10, $16, $A0, $A1, $01
        dc.b    $11, $1A, $07, $10, $60, $66, $B0, $01, $10, $01, $70, $71, $71, $01, $17, $00
        dc.b    $16, $17, $7C, $BD, $DD, $71, $A0, $02, $01, $1A, $03, $03, $A0, $0A, $AA, $02
        dc.b    $73, $0A, $07, $A0, $A0, $00, $a6, $70, $1B, $BA, $01, $0A, $66, $67, $C1, $06
        dc.b    $DD, $d0, $16, $76, $00, $d1, $DD, $71, $00, $0C, $00, $76, $00, $0A, $0B, $70
        dc.b    $00, $06, $a6, $d6, $00, $d1, $10, $AB, $00, $07, $61, $7B, $00, $0A, $61, $16
        dc.b    $CD, $B0, $B0, $C7, $11, $00, $A0, $B1, $00, $0A, $10, $07, $10, $01, $00, $61
        dc.b    $17, $70, $70, $d6, $11, $77, $00, $A7, $1A, $B7, $01, $11, $60, $01, $10, $61
        dc.b    $0D, $0A, $01, $03, $76, $0A, $01, $10, $1B, $A1, $07, $72, $0B, $17, $0B, $10
        dc.b    $06, $61, $70, $00, $0D, $60, $AA, $10, $0A, $70, $B1, $70, $01, $11, $67, $12
        dc.b    $26, $66, $DC, $DF, $05, $02, $01, $A0, $06, $02, $01, $0A, $02, $07, $10, $A0
        dc.b    $BA, $21, $0A, $0A, $11, $03, $08, $01, $DC, $A0, $AA, $16, $00, $0A, $01, $04
        dc.b    $01, $77, $02, $01, $10, $02, $15, $A1, $07, $00, $AB, $10, $61, $10, $10, $06
        dc.b    $67, $16, $00, $66, $BA, $10, $01, $71, $00, $DD, $00, $0A, $0E, $02, $07, $7D
        dc.b    $02, $06, $67, $61, $d0, $00, $7A, $B7, $02, $04, $5F, $F4, $2F, $FD, $03, $01
        dc.b    $21, $02, $1E, $02, $17, $02, $22, $30, $16, $20, $11, $16, $67, $06, $70, $60
        dc.b    $10, $06, $77, $06, $77, $00, $10, $61, $16, $16, $60, $66, $71, $70, $00, $01
        dc.b    $10, $02, $1A, $10, $10, $66, $00, $11, $77, $76, $77, $07, $06, $01, $11, $61
        dc.b    $6B, $71, $60, $06, $AB, $66, $10, $0A, $B6, $17, $0D, $d0, $BD, $02, $01, $A0
        dc.b    $02, $28, $AA, $A0, $00, $77, $d7, $DC, $00, $DD, $DD, $77, $d0, $AA, $AA, $AB
        dc.b    $1D, $77, $77, $BA, $60, $7D, $77, $61, $A0, $6C, $67, $06, $C1, $00, $76, $01
        dc.b    $77, $77, $11, $07, $10, $11, $A0, $01, $01, $AA, $02, $11, $AA, $00, $A1, $01
        dc.b    $A0, $AA, $16, $16, $6A, $77, $61, $01, $17, $01, $DC, $66, $76, $03, $05, $10
        dc.b    $00, $0A, $00, $07, $02, $02, $01, $07, $03, $0B, $07, $07, $B0, $10, $70, $01
        dc.b    $76, $66, $11, $16, $11, $02, $0A, $77, $61, $61, $61, $70, $77, $70, $00, $77
        dc.b    $07, $02, $01, $77, $03, $01, $07, $05, $06, $07, $00, $11, $11, $16, $77, $03
        dc.b    $05, $17, $22, $22, $01, $10, $02, $01, $01, $03, $01, $01, $04, $01, $07, $03
        dc.b    $01, $07, $03, $01, $07, $07, $09, $70, $00, $02, $7C, $16, $00, $02, $7A, $a6
        dc.b    $02, $02, $27, $A1, $03, $01, $6A, $02, $02, $02, $1B, $03, $01, $26, $03, $01
        dc.b    $02, $04, $05, $33, $32, $32, $24, $17, $04, $3B, $70, $11, $06, $66, $00, $17
        dc.b    $66, $B6, $10, $71, $B1, $CB, $A1, $0A, $0A, $1D, $C7, $BA, $DC, $22, $1B, $A7
        dc.b    $17, $5F, $DB, $70, $06, $A0, $01, $10, $10, $B0, $01, $10, $17, $6D, $d6, $01
        dc.b    $7A, $66, $11, $17, $B0, $B1, $71, $01, $00, $C1, $11, $17, $BA, $66, $67, $61
        dc.b    $67, $AD, $CB, $11, $6D, $02, $02, $A0, $7A, $02, $02, $01, $11, $02, $02, $07
        dc.b    $07, $02, $02, $01, $11, $03, $01, $71, $02, $02, $A0, $07, $05, $03, $0A, $17
        dc.b    $07, $03, $07, $07, $00, $01, $70, $01, $AA, $A7, $02, $08, $66, $60, $11, $01
        dc.b    $11, $11, $10, $76, $02, $14, $11, $12, $10, $00, $22, $20, $10, $17, $42, $00
        dc.b    $10, $61, $62, $00, $70, $76, $20, $00, $01, $02, $02, $02, $71, $20, $02, $01
        dc.b    $12, $03, $01, $20, $07, $04, $24, $FF, $FF, $55, $02, $10, $0A, $16, $00, $0A
        dc.b    $B6, $77, $00, $B1, $06, $61, $07, $01, $BA, $AA, $00, $1A, $02, $01, $07, $04
        dc.b    $01, $A0, $02, $0E, $60, $DA, $0B, $DB, $76, $6A, $00, $61, $16, $10, $0B, $BA
        dc.b    $10, $A0, $02, $01, $70, $03, $1A, $10, $A0, $00, $AB, $00, $1A, $AA, $10, $00
        dc.b    $01, $11, $00, $0B, $B0, $66, $BB, $A0, $A0, $06, $d0, $00, $16, $d1, $00, $0B
        dc.b    $6D, $02, $14, $B0, $d0, $A1, $00, $0B, $00, $16, $7D, $0A, $00, $6D, $A0, $01
        dc.b    $AB, $d0, $A0, $67, $70, $DC, $16, $03, $01, $01, $03, $01, $01, $03, $01, $01
        dc.b    $03, $01, $01, $03, $01, $01, $03, $01, $01, $03, $06, $01, $71, $76, $0C, $60
        dc.b    $10, $03, $01, $10, $03, $01, $10, $03, $01, $10, $03, $01, $10, $03, $01, $10
        dc.b    $03, $01, $10, $03, $04, $1D, $0D, $DD, $d7, $1C, $14, $7C, $1C, $C1, $C1, $07
        dc.b    $B7, $00, $76, $01, $00, $77, $1A, $0A, $01, $11, $00, $0A, $0A, $0A, $A0, $02
        dc.b    $30, $A0, $0A, $17, $A0, $00, $a6, $01, $7B, $BB, $71, $10, $67, $77, $11, $06
        dc.b    $07, $00, $76, $0A, $10, $77, $1A, $0A, $A1, $11, $A0, $01, $0A, $AA, $0A, $07
        dc.b    $AA, $00, $A1, $01, $66, $CC, $76, $01, $77, $66, $77, $07, $77, $61, $66, $01
        dc.b    $70, $02, $1C, $0A, $17, $70, $01, $00, $A1, $11, $00, $0A, $0A, $A0, $11, $01
        dc.b    $A0, $a6, $00, $06, $7C, $60, $00, $61, $01, $11, $10, $43, $22, $01, $07, $03
        dc.b    $01, $70, $03, $01, $70, $03, $01, $70, $03, $01, $70, $03, $01, $70, $03, $01
        dc.b    $70, $03, $05, $70, $22, $22, $01, $66, $06, $0F, $01, $01, $00, $10, $11, $11
        dc.b    $11, $11, $11, $11, $10, $10, $10, $10, $10, $02, $11, $70, $00, $07, $07, $77
        dc.b    $33, $01, $06, $6B, $02, $60, $10, $A0, $00, $A1, $00, $A0, $03, $01, $10, $03
        dc.b    $1C, $7A, $00, $A1, $10, $11, $02, $6A, $70, $06, $00, $1A, $B1, $00, $42, $06
        dc.b    $C7, $66, $70, $07, $C6, $77, $10, $07, $00, $11, $00, $01, $A0, $03, $01, $10
        dc.b    $03, $01, $60, $02, $01, $07, $03, $01, $0A, $02, $10, $DD, $DA, $76, $61, $BB
        dc.b    $B1, $17, $70, $BB, $BB, $B6, $67, $B0, $BB, $06, $61, $03, $13, $01, $B0, $BB
        dc.b    $a6, $61, $BB, $BB, $16, $66, $BB, $11, $17, $77, $CC, $67, $54, $44, $11, $10
        dc.b    $02, $02, $76, $60, $02, $01, $67, $07, $01, $77, $03, $02, $66, $60, $02, $02
        dc.b    $66, $10, $02, $06, $77, $71, $44, $44, $70, $07, $02, $07, $77, $00, $01, $11
        dc.b    $70, $01, $10, $02, $01, $10, $02, $01, $01, $02, $06, $AA, $11, $00, $0A, $00
        dc.b    $11, $03, $17, $61, $AA, $A0, $0A, $07, $A0, $0A, $A0, $21, $1A, $A0, $11, $00
        dc.b    $71, $11, $00, $02, $17, $00, $77, $00, $21, $77, $02, $02, $02, $11, $03, $08
        dc.b    $22, $11, $44, $34, $44, $66, $00, $17, $02, $08, $07, $00, $77, $00, $70, $11
        dc.b    $10, $77, $02, $02, $01, $11, $04, $02, $01, $10, $02, $08, $12, $22, $01, $16
        dc.b    $64, $44, $76, $76, $02, $1E, $16, $76, $00, $07, $71, $1B, $77, $70, $10, $1B
        dc.b    $11, $11, $01, $60, $00, $01, $17, $AB, $11, $10, $07, $CB, $77, $76, $66, $CB
        dc.b    $67, $61, $76, $BB, $03, $01, $01, $03, $02, $01, $01, $02, $16, $70, $00, $10
        dc.b    $61, $16, $16, $77, $66, $67, $17, $71, $06, $01, $21, $10, $10, $66, $50, $70
        dc.b    $1D, $07, $10, $03, $01, $10, $02, $02, $01, $10, $02, $15, $66, $66, $10, $0A
        dc.b    $B6, $71, $70, $01, $AB, $16, $11, $16, $6B, $61, $01, $10, $16, $7D, $7D, $D0
        dc.b    $d0, $06, $01, $A0, $02, $0B, $0A, $76, $00, $7D, $77, $61, $A0, $DD, $DD, $BA
        dc.b    $60, $02, $0E, $BC, $11, $DD, $DD, $61, $01, $61, $10, $10, $01, $07, $00, $10
        dc.b    $67, $02, $06, $06, $1B, $07, $10, $11, $A0, $02, $07, $7A, $00, $70, $01, $10
        dc.b    $00, $01, $02, $0A, $0A, $10, $07, $A0, $A0, $6D, $DB, $00, $AA, $B0, $09, $04
        dc.b    $AA, $AA, $0A, $AA, $02, $01, $A0, $0B, $08, $AA, $01, $67, $76, $00, $AB, $66
        dc.b    $01, $02, $0A, $A1, $60, $AA, $A0, $0A, $11, $00, $0A, $A0, $07, $02, $02, $0A
        dc.b    $A0, $03, $01, $A1, $04, $04, $77, $77, $77, $77, $0F, $01, $01, $03, $01, $10
        dc.b    $02, $01, $01, $03, $01, $10, $03, $02, $11, $11, $02, $08, $01, $11, $00, $01
        dc.b    $10, $00, $01, $10, $02, $01, $10, $05, $08, $07, $77, $00, $07, $70, $00, $07
        dc.b    $70, $02, $04, $16, $66, $66, $44, $02, $01, $01, $03, $02, $07, $20, $02, $01
        dc.b    $11, $03, $02, $7A, $10, $05, $1F, $60, $00, $72, $00, $10, $00, $01, $22, $52
        dc.b    $6D, $61, $00, $02, $11, $60, $00, $21, $76, $72, $02, $17, $B1, $10, $00, $71
        dc.b    $07, $20, $21, $1A, $01, $02, $02, $0A, $A0, $00, $07, $A0, $00, $21, $24, $FF
        dc.b    $52, $23, $02, $1E, $22, $22, $00, $22, $16, $60, $02, $11, $6B, $72, $21, $06
        dc.b    $AA, $10, $10, $6A, $a6, $20, $07, $00, $11, $00, $71, $AA, $02, $00, $45, $F5
        dc.b    $63, $44, $03, $01, $10, $02, $01, $07, $02, $03, $02, $10, $01, $06, $01, $07
        dc.b    $09, $04, $24, $5D, $CC, $AA, $04, $01, $07, $08, $01, $10, $05, $02, $0A, $11
        dc.b    $04, $01, $7A, $02, $04, $67, $61, $CD, $C6, $06, $01, $11, $02, $03, $07, $00
        dc.b    $07, $05, $01, $10, $03, $05, $01, $10, $70, $01, $70, $02, $05, $77, $6D, $CC
        dc.b    $B1, $11, $10, $04, $10, $00, $01, $70, $04, $07, $0A, $00, $A7, $00, $76, $CD
        dc.b    $73, $02, $01, $01, $02, $09, $07, $00, $02, $70, $00, $70, $10, $00, $01, $04
        dc.b    $07, $10, $00, $10, $70, $07, $00, $01, $03, $04, $23, $45, $76, $01, $06, $04
        dc.b    $01, $07, $00, $02, $04, $01, $10, $04, $01, $70, $02, $02, $17, $06, $02, $0B
        dc.b    $07, $60, $24, $46, $10, $16, $00, $B0, $77, $71, $01, $02, $09, $1A, $0A, $01
        dc.b    $11, $00, $0A, $0A, $0A, $A0, $02, $1F, $A0, $0A, $17, $A0, $00, $A7, $01, $7B
        dc.b    $BB, $71, $17, $67, $77, $17, $01, $07, $77, $71, $0A, $10, $00, $1A, $00, $A1
        dc.b    $11, $A0, $00, $0A, $AA, $00, $0A, $02, $15, $0A, $17, $A0, $00, $A7, $01, $7B
        dc.b    $BB, $71, $10, $60, $67, $11, $00, $01, $00, $76, $07, $10, $07, $1B, $03, $36
        dc.b    $1A, $01, $01, $07, $01, $01, $06, $00, $77, $06, $10, $01, $10, $11, $60, $16
        dc.b    $11, $11, $00, $17, $01, $61, $10, $01, $11, $BC, $C7, $77, $77, $A0, $0A, $AA
        dc.b    $AA, $1A, $AA, $00, $0A, $01, $11, $BA, $A0, $77, $77, $01, $11, $11, $00, $77
        dc.b    $77, $11, $11, $11, $13, $11, $02, $0C, $02, $66, $66, $61, $00, $BB, $11, $07
        dc.b    $10, $AA, $00, $07, $02, $13, $11, $70, $00, $11, $77, $00, $10, $77, $00, $11
        dc.b    $02, $11, $10, $11, $14, $00, $10, $07, $70, $02, $04, $70, $00, $01, $07, $05
        dc.b    $05, $01, $00, $70, $01, $10, $02, $04, $10, $00, $07, $01, $02, $04, $60, $01
        dc.b    $11, $11, $03, $01, $01, $02, $04, $11, $10, $01, $11, $02, $01, $10, $0F, $0E
        dc.b    $77, $A7, $6A, $a6, $06, $01, $0A, $00, $01, $00, $10, $01, $00, $06, $04, $06
        dc.b    $01, $A0, $00, $0A, $00, $10, $02, $01, $07, $03, $07, $61, $70, $01, $00, $10
        dc.b    $01, $01, $02, $02, $07, $10, $07, $03, $70, $00, $A0, $03, $05, $06, $17, $01
        dc.b    $A0, $01, $03, $06, $0A, $61, $01, $AA, $CF, $42, $04, $03, $10, $00, $02, $03
        dc.b    $01, $70, $02, $01, $0A, $02, $09, $10, $00, $16, $20, $00, $A0, $A1, $00, $71
        dc.b    $02, $05, $62, $34, $5D, $C6, $07, $06, $01, $10, $02, $03, $02, $00, $71, $02
        dc.b    $02, $01, $07, $06, $02, $20, $10, $03, $05, $01, $42, $35, $FD, $77, $02, $05
        dc.b    $A0, $00, $01, $11, $0A, $04, $1A, $01, $01, $07, $10, $10, $70, $00, $01, $00
        dc.b    $10, $11, $70, $07, $01, $71, $16, $61, $77, $71, $11, $66, $10, $11, $07, $00
        dc.b    $07, $07, $01, $71, $04, $15, $01, $07, $07, $10, $11, $10, $70, $01, $00, $11
        dc.b    $11, $61, $06, $CD, $71, $70, $00, $AA, $10, $00, $01, $03, $17, $10, $11, $00
        dc.b    $10, $07, $00, $71, $01, $00, $77, $00, $10, $11, $00, $10, $00, $01, $11, $01
        dc.b    $10, $76, $76, $11, $02, $01, $10, $03, $01, $07, $02, $07, $01, $70, $10, $01
        dc.b    $77, $00, $02, $02, $0E, $01, $00, $10, $00, $10, $20, $00, $11, $00, $20, $32
        dc.b    $00, $10, $03, $03, $01, $17, $03, $05, $70, $02, $01, $00, $01, $07, $3A, $71
        dc.b    $20, $11, $11, $17, $00, $01, $10, $11, $11, $01, $11, $01, $77, $01, $06, $77
        dc.b    $00, $60, $00, $10, $11, $A7, $01, $A1, $AA, $07, $01, $0A, $00, $B1, $00, $A0
        dc.b    $0B, $61, $16, $1A, $d6, $10, $01, $67, $11, $01, $11, $11, $00, $76, $01, $77
        dc.b    $77, $11, $07, $10                       
;=============================================================================== 
; Level Rings Layout

;===============================================================================                  
Rings_Layout: ; loc_048000:               
        dc.w    Ghz_1_Rings_Layout-Rings_Layout, Ghz_2_Rings_Layout-Rings_Layout 
        dc.w    Id_0100_Rings_Layout-Rings_Layout, Id_0101_Rings_Layout-Rings_Layout    
        dc.w    Wz_1_Rings_Layout-Rings_Layout, Wz_2_Rings_Layout-Rings_Layout 
        dc.w    Id_0300_Rings_Layout-Rings_Layout, Id_0301_Rings_Layout-Rings_Layout  
        dc.w    Mz_1_Rings_Layout-Rings_Layout, Mz_2_Rings_Layout-Rings_Layout    
        dc.w    Mz_3_Rings_Layout-Rings_Layout, Mz_4_Rings_Layout-Rings_Layout    
        dc.w    Id_0600_Rings_Layout-Rings_Layout, Id_0601_Rings_Layout-Rings_Layout 
        dc.w    Htz_1_Rings_Layout-Rings_Layout, Htz_2_Rings_Layout-Rings_Layout 
        dc.w    Hpz_1_Rings_Layout-Rings_Layout, Hpz_2_Rings_Layout-Rings_Layout 
        dc.w    Id_0900_Rings_Layout-Rings_Layout, Id_0901_Rings_Layout-Rings_Layout 
        dc.w    OOz_1_Rings_Layout-Rings_Layout, OOz_2_Rings_Layout-Rings_Layout 
        dc.w    DHz_1_Rings_Layout-Rings_Layout, DHz_2_Rings_Layout-Rings_Layout 
        dc.w    CNz_1_Rings_Layout-Rings_Layout, CNz_2_Rings_Layout-Rings_Layout
        dc.w    CPz_1_Rings_Layout-Rings_Layout, CPz_2_Rings_Layout-Rings_Layout 
        dc.w    GCz_1_Rings_Layout-Rings_Layout, GCz_2_Rings_Layout-Rings_Layout
        dc.w    NGHz_1_Rings_Layout-Rings_Layout, NGHz_2_Rings_Layout-Rings_Layout 
        dc.w    DEz_1_Rings_Layout-Rings_Layout, DEz_2_Rings_Layout-Rings_Layout
Ghz_1_Rings_Layout:   ; loc_048044:               
        incbin  'data\ghz\rng_act1.dat'              
Ghz_2_Rings_Layout:   ; loc_0481DE:               
        incbin  'data\ghz\rng_act2.dat'             
Id_0100_Rings_Layout: ; loc_0483DC:                   
        dc.w    $FFFF            
Id_0101_Rings_Layout: ; loc_0483DE:                   
        dc.w    $FFFF                 
Wz_1_Rings_Layout:    ; loc_0483E0:                      
                incbin  'data\wz\rng_act1.dat'               
Wz_2_Rings_Layout:    ; loc_0483E2:                       
        dc.w    $FFFF               
Id_0300_Rings_Layout: ; loc_0483E4:                   
        dc.w    $FFFF              
Id_0301_Rings_Layout: ; loc_0483E6:                 
        dc.w    $FFFF                       
Mz_1_Rings_Layout:    ; loc_0483E8:                       
        dc.w    $FFFF              
Mz_2_Rings_Layout:    ; loc_0483EA:                       
        dc.w    $FFFF                               
Mz_3_Rings_Layout:    ; loc_0483EC:                
        dc.w    $FFFF              
Mz_4_Rings_Layout:    ; loc_0483EE:                       
        dc.w    $FFFF              
Id_0600_Rings_Layout: ; loc_0483F0:                   
        dc.w    $FFFF               
Id_0601_Rings_Layout: ; loc_0483F2:                 
        dc.w    $FFFF        
Htz_1_Rings_Layout:   ; loc_0483F4:             
        incbin  'data\htz\rng_act1.dat'             
Htz_2_Rings_Layout:   ; loc_0484EA:        
        incbin  'data\htz\rng_act2.dat' 
Hpz_1_Rings_Layout:   ; loc_048654:             
        incbin  'data\hpz\rng_act1.dat'            
Hpz_2_Rings_Layout:   ; loc_0487C6:         
        dc.w    $FFFF                              
Id_0900_Rings_Layout: ; loc_0487C8:                   
        dc.w    $FFFF               
Id_0901_Rings_Layout: ; loc_0487CA:                 
        dc.w    $FFFF                            
OOz_1_Rings_Layout:   ; loc_0487CC:               
        incbin  'data\ooz\rng_act1.dat'      
OOz_2_Rings_Layout:   ; loc_04889E:             
        incbin  'data\ooz\rng_act2.dat'        
DHz_1_Rings_Layout:   ; loc_048968:               
        dc.w    $FFFF     
DHz_2_Rings_Layout:   ; loc_04896A:               
        dc.w    $FFFF 
CNz_1_Rings_Layout:   ; loc_04896C:        
        dc.w    $FFFF
CNz_2_Rings_Layout:   ; loc_04896E:        
        dc.w    $FFFF				
CPz_1_Rings_Layout:   ; loc_048970:               
        incbin  'data\cpz\rng_act1.dat'                               
CPz_2_Rings_Layout:   ; loc_048A3E:        
        incbin  'data\cpz\rng_act2.dat'             
GCz_1_Rings_Layout:   ; loc_048B94:        
        dc.w    $FFFF    
GCz_2_Rings_Layout:   ; loc_048B96:        
        dc.w    $FFFF               
NGHz_1_Rings_Layout:  ; loc_048B98:        
        incbin  'data\nghz\rng_act1.dat'                               
NGHz_2_Rings_Layout:  ; loc_048C76:        
        incbin  'data\nghz\rng_act2.dat'  
DEz_1_Rings_Layout:   ; loc_048DB0:              
                        dc.b    $71, $90, $76, $61, $89, $00, $AB, $AA, $33, $33, $00, $10, $02, $02, $20, $01
                dc.b    $04, $0C, $10, $00, $02, $00, $01, $10, $00, $20, $00, $01, $00, $02, $04, $06
                dc.b    $22, $00, $33, $33, $32, $17, $03, $01, $70, $0C, $01, $11, $02, $04, $70, $00
                dc.b    $11, $10, $04, $05, $01, $DD, $76, $11, $16, $06, $01, $01, $04, $08, $01, $00
                dc.b    $07, $00, $10, $0A, $10, $10, $02, $05, $70, $01, $00, $01, $01, $02, $04, $D0
                dc.b    $CD, $DC, $CC, $04, $01, $07, $07, $02, $11, $A0, $03, $01, $10, $02, $02, $01
                dc.b    $60, $03, $01, $0B, $02, $04, $CC, $70, $CC, $DD, $06, $01, $01, $02, $03, $07
                dc.b    $00, $01, $03, $04, $10, $0A, $10, $10, $02, $05, $70, $01, $00, $01, $01, $02
                dc.b    $06, $01, $71, $01, $33, $A1, $70, $02, $10, $67, $01, $02, $00, $11, $10, $02
                dc.b    $22, $00, $16, $61, $11, $11, $16, $77, $77, $02, $0A, $17, $77, $11, $11, $11
                dc.b    $10, $22, $33, $32, $23, $04, $03, $22, $22, $22, $02, $2A, $11, $11, $22, $00
                dc.b    $11, $00, $11, $66, $11, $11, $01, $07, $11, $11, $10, $71, $11, $77, $11, $BB
                dc.b    $99, $FB, $9B, $00, $01, $10, $00, $23, $11, $57, $01, $00, $25, $71, $02, $55
                dc.b    $67, $13, $11, $00, $07, $13, $02, $43, $63, $41, $11, $05, $50, $70, $30, $FA
                dc.b    $CC, $11, $03, $00, $A9, $26, $67, $0A, $26, $77, $77, $03, $70, $53, $33, $A1
                dc.b    $00, $22, $11, $37, $07, $71, $33, $10, $71, $77, $11, $00, $13, $10, $00, $07
                dc.b    $12, $17, $00, $77, $77, $77, $77, $77, $77, $77, $77, $33, $33, $33, $33, $11
                dc.b    $11, $11, $11, $22, $22, $22, $22, $77, $77, $77, $77, $04, $03, $75, $04, $57
                dc.b    $02, $3F, $01, $11, $70, $10, $75, $12, $25, $20, $17, $52, $00, $11, $31, $76
                dc.b    $55, $00, $31, $70, $00, $11, $14, $36, $00, $03, $07, $05, $50, $33, $70, $43
                dc.b    $50, $00, $01, $35, $70, $10, $75, $11, $25, $20, $17, $52, $00, $11, $31, $76
                dc.b    $55, $00, $31, $70, $00, $11, $14, $36, $00, $03, $07, $05, $50, $36, $00, $64
                dc.b    $50, $1A, $06, $01, $70, $06, $20, $11, $70, $02, $01, $02, $03, $12, $01, $57
                dc.b    $00, $01, $00, $13, $01, $30, $11, $11, $70, $12, $22, $22, $07, $77, $77, $77
                dc.b    $04, $1C, $77, $77, $77, $77, $77, $77, $77, $77, $77, $77, $77, $77, $33, $33
                dc.b    $33, $33, $11, $11, $11, $10, $22, $22, $22, $01, $77, $77, $70, $23, $02, $3D
                dc.b    $07, $01, $76, $66, $FF, $88, $76, $61, $89, $00, $70, $07, $71, $90, $26, $70
                dc.b    $07, $10, $12, $27, $00, $09, $10, $12, $70, $70, $01, $01, $10, $00, $30, $10
                dc.b    $30, $01, $15, $20, $06, $70, $10, $00, $03, $11, $00, $71, $10, $33, $30, $02
                dc.b    $11, $11, $A6, $07, $22, $11, $03, $60, $76, $55, $0A, $36, $70, $02, $09, $A9
                dc.b    $25, $55, $22, $22, $88, $89, $22, $20, $03, $03, $02, $20, $01, $03, $01, $01
                dc.b    $07, $01, $10, $03, $01, $07, $02, $18, $21, $70, $53, $32, $10, $00, $10, $11
                dc.b    $07, $00, $70, $00, $71, $11, $01, $17, $10, $00, $11, $71, $AA, $A0, $00, $10
                dc.b    $02, $01, $07, $02, $03, $0A, $00, $0A, $02, $02, $67, $6D, $02, $0D, $07, $01
                dc.b    $D0, $0A, $00, $70, $1D, $A0, $10, $07, $01, $77, $01, $06, $01, $01, $02, $04
                dc.b    $01, $10, $00, $10, $04, $06, $76, $01, $11, $10, $07, $11, $02, $04, $71, $10
                dc.b    $77, $77, $04, $01, $10, $04, $07, $10, $00, $01, $00, $01, $11, $10, $02, $08
                dc.b    $11, $66, $66, $10, $07, $01, $B1, $66, $02, $02, $0A, $A1, $02, $2B, $A0, $0A
                dc.b    $07, $01, $1A, $A0, $00, $77, $01, $1B, $10, $00, $77, $70, $01, $11, $11, $16
                dc.b    $01, $11, $67, $D6, $11, $00, $71, $AB, $01, $10, $07, $1A, $70, $01, $00, $71
                dc.b    $17, $10, $10, $07, $00, $01, $01, $00, $10, $02, $40, $10, $66, $11, $00, $01
                dc.b    $AB, $89, $9D, $DA, $13, $10, $10, $01, $31, $00, $20, $00, $10, $02, $70, $73
                dc.b    $12, $36, $00, $1A, $56, $70, $06, $30, $00, $07, $63, $A0, $55, $52, $9A, $00
                dc.b    $25, $30, $9F, $89, $10, $13, $10, $10, $00, $71, $77, $03, $37, $07, $71, $31
                dc.b    $A1, $00, $13, $10, $03, $70, $65, $44, $0A, $26, $70, $02, $13, $A9, $26, $67
                dc.b    $88, $88, $21, $10, $11, $11, $11, $11, $33, $33, $33, $33, $11, $11, $11, $11
                dc.b    $04, $04, $44, $44, $44, $44, $04, $33, $77, $77, $77, $77, $30, $07, $24, $47
                dc.b    $01, $00, $53, $30, $03, $05, $43, $33, $01, $12, $17, $00, $10, $21, $23, $33
                dc.b    $22, $12, $32, $66, $06, $30, $01, $22, $00, $10, $11, $11, $37, $04, $06, $65
                dc.b    $01, $00, $53, $30, $03, $05, $43, $33, $01, $12, $17, $02, $2A, $21, $23, $33
                dc.b    $42, $12, $32, $66, $06, $22, $11, $22, $77, $01, $23, $33, $07, $02, $31, $10
                dc.b    $10, $73, $03, $01, $00, $01, $11, $33, $07, $07, $21, $11, $90, $00, $72, $21
                dc.b    $01, $70, $07, $65, $09, $17, $70, $02, $13, $98, $16, $67, $88, $88, $11, $10
                dc.b    $11, $11, $11, $11, $33, $33, $33, $33, $11, $11, $11, $11, $04, $04, $44, $44
                dc.b    $44, $44, $04, $0A, $77, $77, $77, $77, $00, $77, $77, $70, $10, $77, $02, $06
                dc.b    $31, $10, $70, $07, $13, $31, $02, $0A, $01, $13, $07, $00, $41, $01, $20, $00
                dc.b    $05, $10, $03, $01, $20, $02, $05, $66, $20, $17, $07, $10, $1B, $04, $34, $77
                dc.b    $74, $43, $02, $02, $70, $07, $02, $02, $07, $70, $02, $02, $77, $70, $03, $01
                dc.b    $76, $02, $02, $77, $63, $02, $02, $76, $31, $02, $30, $63, $10, $06, $67, $12
                dc.b    $45, $77, $07, $70, $64, $07, $70, $62, $21, $71, $60, $31, $01, $22, $36, $50
                dc.b    $13, $10, $00, $01, $00, $01, $00, $65, $00, $10, $30, $07, $30, $33, $32, $23
                dc.b    $31, $22, $10, $01, $01, $01, $12, $23, $30, $23, $30, $0B, $15, $01, $67, $77
                dc.b    $17, $76, $10, $00, $05, $55, $54, $47, $70, $01, $10, $03, $00, $10, $33, $33
                dc.b    $00, $03, $02, $01, $01, $03, $02, $03, $30, $02, $03, $17, $77, $10, $03, $12
                dc.b    $67, $61, $76, $01, $16, $70, $32, $77, $77, $77, $33, $32, $17, $70, $00, $33
                dc.b    $01, $71, $02, $02, $06, $64, $02, $02, $65, $20, $02, $1C, $01, $10, $00, $06
                dc.b    $50, $03, $11, $17, $23, $56, $77, $07, $70, $00, $07, $70, $77, $00, $07, $00
                dc.b    $77, $00, $71, $77, $07, $00, $27, $67, $03, $01, $71, $02, $0B, $33, $07, $11
                dc.b    $11, $01, $22, $44, $76, $00, $12, $33, $19, $0C, $64, $56, $66, $67, $06, $44
                dc.b    $45, $56, $00, $01, $23, $30, $14, $36, $11, $32, $11, $66, $00, $77, $70, $70
                dc.b    $00, $70, $70, $70, $00, $77, $77, $07, $00, $07, $77, $77, $00, $07, $07, $70
                dc.b    $07, $07, $70, $00, $01, $11, $11, $11, $61, $11, $66, $61, $77, $70, $77, $70
                dc.b    $07, $77, $70, $70, $77, $07, $07, $70, $77, $00, $77, $00, $07, $77, $02, $02
                dc.b    $07, $77, $02, $0C, $11, $11, $11, $11, $FF, $EE, $EE, $EE, $01, $00, $77, $77
                dc.b    $02, $01, $70, $0A, $03, $01, $06, $06, $08, $0F, $DC, $CD, $CD, $BD, $06, $77
                dc.b    $77, $60, $01, $21, $12, $10, $00, $32, $53, $02, $02, $06, $20, $02, $1F, $34
                dc.b    $73, $00, $01, $21, $12, $10, $06, $77, $77, $60, $DD, $DD, $DD, $DD, $01, $66
                dc.b    $66, $66, $07, $07, $77, $77, $00, $70, $77, $77, $00, $07, $66, $66, $02, $02
                dc.b    $0B, $88, $02, $02, $03, $33, $02, $2E, $03, $00, $06, $16, $0B, $BB, $66, $66
                dc.b    $66, $66, $77, $77, $77, $77, $77, $77, $77, $70, $66, $66, $66, $67, $BB, $89
                dc.b    $99, $80, $00, $31, $00, $10, $00, $31, $00, $10, $BB, $89, $99, $86, $66, $66
                dc.b    $66, $66, $77, $77, $77, $77, $08, $04, $10, $01, $11, $11, $02, $02, $10, $10
                dc.b    $04, $0C, $01, $10, $10, $10, $66, $66, $66, $10, $77, $77, $70, $70, $02, $01
                dc.b    $07, $04, $03, $70, $11, $11, $02, $02, $10, $10, $06, $16, $8F, $E9, $AB, $BB
                dc.b    $00, $02, $10, $10, $00, $71, $01, $03, $06, $30, $10, $30, $17, $30, $03, $00
                dc.b    $05, $62, $02, $13, $31, $41, $50, $01, $00, $02, $76, $06, $02, $23, $17, $60
                dc.b    $30, $00, $66, $10, $00, $06, $10, $02, $0E, $71, $00, $11, $07, $00, $01, $00
                dc.b    $60, $00, $60, $00, $10, $00, $70, $03, $02, $11, $11, $02, $10, $01, $66, $00
                dc.b    $11, $10, $77, $11, $00, $77, $77, $77, $70, $77, $77, $77, $70, $04, $01, $77
                dc.b    $02, $0B, $76, $22, $44, $06, $22, $11, $11, $76, $43, $33, $25, $02, $03, $70
                dc.b    $77, $70, $02, $01, $70, $02, $02, $70, $77, $02, $02, $70, $77, $03, $10, $07
                dc.b    $55, $41, $77, $61, $33, $30, $16, $61, $16, $06, $23, $16, $77, $17, $20, $02
                dc.b    $1F, $07, $13, $00, $77, $07, $01, $00, $77, $07, $77, $60, $07, $70, $07, $76
                dc.b    $17, $70, $07, $70, $06, $61, $11, $11, $77, $47, $71, $06, $00, $30, $06, $17
                dc.b    $03, $01, $71, $03, $01, $10, $03, $01, $06, $03, $02, $01, $10, $02, $02, $06
                dc.b    $61, $02, $05, $65, $73, $30, $00, $62, $1C, $04, $62, $13, $00, $01, $1C, $16
                dc.b    $16, $32, $11, $11, $07, $77, $00, $07, $00, $77, $77, $70, $00, $77, $77, $70
                dc.b    $00, $77, $77, $70, $00, $77, $02, $01, $07, $03, $13, $01, $11, $11, $11, $66
                dc.b    $66, $66, $11, $77, $77, $77, $00, $77, $77, $70, $00, $77, $77, $70, $02, $08
                dc.b    $07, $77, $00, $77, $07, $77, $00, $77, $03, $08, $11, $11, $11, $11, $FE, $EF
                dc.b    $EF, $9F, $09, $03, $01, $06, $06, $04, $08, $01, $11, $16, $66, $01, $11, $66
                dc.b    $66, $02, $06, $70, $00, $54, $44, $43, $33, $02, $09, $01, $11, $00, $01, $13
                dc.b    $33, $00, $10, $30, $02, $03, $03, $00, $DD, $02, $01, $0D, $02, $0B, $13, $0D
                dc.b    $00, $11, $11, $23, $ED, $42, $53, $5F, $FC, $03, $01, $33, $02, $02, $03, $11
                dc.b    $02, $02, $01, $01, $03, $01, $13, $02, $02, $01, $30, $02, $01, $03, $05, $10
                dc.b    $8E, $8F, $93, $3D, $11, $01, $13, $30, $11, $13, $30, $00, $33, $30, $00, $30
                dc.b    $02, $01, $03, $02, $0F, $03, $31, $10, $03, $31, $10, $10, $30, $10, $01, $00
                dc.b    $89, $89, $F8, $E6, $16, $02, $70, $70, $02, $06, $10, $10, $61, $70, $11, $10
                dc.b    $14, $02, $70, $70, $02, $02, $10, $10, $02, $04, $AA, $B8, $99, $EF, $02, $05
                dc.b    $01, $00, $01, $00, $06, $02, $02, $30, $10, $03, $03, $60, $01, $10, $03, $3F
                dc.b    $03, $01, $00, $10, $00, $06, $00, $11, $46, $16, $66, $16, $17, $07, $77, $72
                dc.b    $70, $07, $07, $21, $77, $77, $01, $00, $77, $70, $73, $10, $77, $70, $10, $01
                dc.b    $00, $07, $31, $00, $11, $11, $00, $13, $45, $52, $02, $30, $10, $12, $30, $66
                dc.b    $01, $30, $66, $65, $13, $06, $65, $30, $00, $66, $30, $35, $36, $63, $53, $02
                dc.b    $0D, $33, $01, $06, $66, $06, $71, $00, $60, $36, $10, $00, $66, $61, $02, $13
                dc.b    $55, $51, $66, $00, $33, $30, $66, $60, $66, $60, $00, $66, $00, $70, $06, $06
                dc.b    $07, $10, $10, $03, $19, $17, $60, $77, $77, $10, $71, $17, $10, $60, $00, $01
                dc.b    $70, $06, $77, $00, $11, $00, $77, $00, $07, $00, $67, $60, $01, $10, $03, $18
                dc.b    $70, $01, $66, $00, $10, $00, $17, $00, $01, $45, $70, $16, $15, $11, $70, $06
                dc.b    $21, $23, $77, $76, $31, $00, $77, $77, $02, $03, $77, $77, $13, $03, $0A, $70
                dc.b    $00, $11, $11, $10, $00, $75, $47, $70, $01, $14, $02, $02, $30, $02, $08, $66
                dc.b    $66, $66, $67, $06, $45, $66, $66, $19, $01, $23, $02, $04, $F8, $99, $99, $EE
                dc.b    $0B, $01, $07, $03, $01, $70, $0B, $05, $70, $71, $00, $01, $70, $04, $01, $70
                dc.b    $04, $01, $01, $03, $02, $01, $10, $02, $02, $77, $10, $02, $0B, $70, $71, $10
                dc.b    $10, $07, $07, $11, $11, $00, $77, $76, $1B, $0C, $77, $54, $54, $45, $56, $11
                dc.b    $11, $23, $ED, $00, $13, $0D, $03, $01, $0D, $02, $06, $03, $00, $DD, $00, $10
                dc.b    $30, $02, $03, $01, $13, $33, $02, $0A, $01, $11, $53, $45, $33, $33, $00, $01
                dc.b    $76, $66, $02, $02, $01, $11, $14, $0C, $60, $77, $77, $77, $66, $66, $66, $66
                dc.b    $11, $11, $11, $11, $14, $01, $10, $03, $01, $10, $07, $18, $07, $01, $07, $07
                dc.b    $07, $88, $A7, $07, $01, $10, $01, $01, $01, $33, $01, $01, $07, $AB, $A7, $07
                dc.b    $07, $01, $07, $06, $08, $02, $01, $07, $02, $02, $88, $A7, $02, $02, $10, $01
                dc.b    $02, $02, $33, $01, $02, $02, $AB, $A7, $02, $0C, $A8, $99, $EE, $8E, $56, $10
                dc.b    $00, $70, $66, $60, $01, $70, $02, $09, $07, $70, $01, $00, $07, $00, $06, $00
                dc.b    $10, $07, $09, $11, $11, $76, $67, $55, $47, $00, $70, $01, $02, $06, $70, $00
                dc.b    $30, $00, $13, $10, $03, $01, $03, $02, $14, $03, $30, $00, $07, $66, $66, $66
                dc.b    $01, $11, $11, $11, $14, $71, $11, $17, $00, $06, $66, $60, $03, $03, $08, $06
                dc.b    $66, $66, $66, $66, $66, $66, $66, $04, $10, $66, $66, $66, $66, $11, $11, $11
                dc.b    $11, $16, $71, $11, $17, $61, $06, $66, $60, $04, $08, $66, $66, $66, $66, $66
                dc.b    $66, $66, $66, $04, $0B, $66, $66, $66, $66, $11, $11, $11, $11, $71, $77, $70
                dc.b    $03, $01, $01, $03, $07, $07, $00, $60, $00, $01, $00, $66, $07, $0F, $66, $66
                dc.b    $66, $10, $11, $11, $11, $10, $06, $66, $66, $77, $00, $77, $07, $02, $0A, $77
                dc.b    $70, $06, $00, $77, $77, $66, $00, $77, $77, $02, $01, $77, $06, $08, $06, $11
                dc.b    $11, $10, $60, $01, $16, $61, $02, $02, $70, $07, $02, $02, $07, $70, $02, $02
                dc.b    $77, $70, $03, $01, $77, $02, $02, $70, $77, $02, $01, $77, $02, $07, $01, $11
                dc.b    $61, $00, $01, $66, $61, $02, $02, $77, $70, $03, $01, $70, $02, $02, $77, $70
                dc.b    $02, $01, $77, $0A, $07, $01, $11, $11, $8F, $EE, $EE, $99, $1E, $0E, $07, $07
                dc.b    $01, $10, $07, $07, $70, $11, $00, $70, $00, $01, $10, $07, $02, $01, $11, $03
                dc.b    $02, $01, $11, $03, $01, $16, $03, $0D, $70, $61, $00, $77, $07, $10, $07, $00
                dc.b    $07, $01, $10, $00, $07, $03, $0B, $70, $01, $10, $07, $00, $11, $70, $70, $00
                dc.b    $67, $07, $03, $01, $70, $02, $03, $77, $00, $01, $07, $01, $10, $06, $01, $01
                dc.b    $03, $01, $10, $02, $02, $01, $01, $02, $07, $10, $10, $10, $00, $01, $70, $01
                dc.b    $02, $02, $77, $70, $02, $02, $07, $70, $08, $01, $77, $08, $01, $01, $03, $01
                dc.b    $11, $02, $01, $77, $0C, $01, $70, $0D, $06, $01, $11, $70, $00, $01, $11, $0F
                dc.b    $01, $77, $08, $01, $11, $03, $01, $11, $02, $01, $76, $0C, $01, $70, $0D, $0E
                dc.b    $01, $10, $CB, $BB, $BA, $AA, $03, $33, $33, $33, $00, $2B, $2B, $2B, $0F, $01
                dc.b    $0A, $03, $1B, $33, $03, $18, $18, $21, $33, $33, $32, $00, $2B, $21, $22, $33
                dc.b    $00, $33, $13, $2B, $0A, $31, $3B, $00, $33, $13, $20, $00, $31, $3B, $02, $02
                dc.b    $13, $20, $02, $0F, $03, $18, $18, $18, $00, $33, $33, $33, $33, $32, $1B, $2B
                dc.b    $2B, $31, $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $13
                dc.b    $02, $0E, $0B, $31, $18, $18, $18, $30, $33, $33, $33, $33, $2B, $2B, $2B, $2B
                dc.b    $0C, $01, $30, $03, $01, $3A, $03, $0C, $12, $18, $18, $18, $33, $33, $33, $33
                dc.b    $2B, $2B, $2B, $2B, $0F, $01, $0A, $03, $0C, $33, $18, $18, $18, $22, $33, $33
                dc.b    $33, $00, $2B, $2B, $2B, $0D, $01, $30, $03, $01, $3A, $03, $06, $12, $15, $F7
                dc.b    $FC, $00, $0D, $04, $01, $31, $06, $05, $0D, $00, $10, $00, $D0, $02, $01, $DD
                dc.b    $05, $06, $30, $10, $16, $66, $99, $88, $02, $02, $44, $44, $02, $02, $01, $11
                dc.b    $06, $02, $0C, $C0, $03, $01, $F1, $08, $04, $71, $00, $85, $DF, $03, $01, $07
                dc.b    $03, $01, $70, $0D, $0B, $01, $00, $07, $00, $01, $70, $07, $01, $00, $77, $77
                dc.b    $02, $01, $70, $02, $0E, $07, $00, $07, $00, $70, $00, $70, $07, $00, $07, $00
                dc.b    $70, $00, $70, $02, $01, $07, $03, $01, $70, $02, $01, $07, $02, $02, $01, $70
                dc.b    $02, $01, $10, $02, $02, $01, $01, $02, $0C, $10, $10, $00, $01, $01, $07, $00
                dc.b    $10, $10, $10, $01, $01, $02, $02, $10, $10, $02, $05, $01, $00, $01, $17, $10
                dc.b    $07, $01, $70, $07, $02, $60, $10, $0A, $04, $11, $10, $01, $77, $0A, $01, $11
                dc.b    $03, $01, $01, $03, $01, $10, $02, $0B, $11, $11, $66, $01, $11, $66, $66, $70
                dc.b    $00, $76, $77, $08, $01, $61, $03, $01, $01, $03, $01, $67, $03, $0C, $66, $11
                dc.b    $10, $00, $66, $61, $11, $00, $76, $70, $00, $77, $04, $0B, $14, $5A, $AA, $EE
                dc.b    $0F, $C3, $22, $11, $0F, $33, $11, $0D, $04, $65, $AA, $98, $88, $04, $0B, $EA
                dc.b    $AA, $54, $10, $12, $23, $CF, $00, $01, $13, $3F, $0D, $04, $31, $39, $0C, $BB
                dc.b    $02, $14, $33, $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $01, $31, $3B, $00
                dc.b    $03, $13, $20, $00, $01, $3B, $02, $02, $03, $20, $02, $01, $3B, $03, $01, $20
                dc.b    $1E, $01, $0B, $03, $01, $0B, $18, $1A, $18, $18, $18, $18, $33, $33, $32, $03
                dc.b    $2B, $21, $22, $3B, $00, $33, $13, $20, $0A, $31, $3B, $00, $33, $13, $20, $00
                dc.b    $31, $3B, $02, $02, $13, $20, $03, $01, $30, $02, $02, $33, $3A, $02, $07, $23
                dc.b    $13, $30, $00, $0B, $31, $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02
                dc.b    $02, $23, $13, $02, $08, $0B, $31, $19, $30, $00, $33, $31, $3A, $02, $07, $23
                dc.b    $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $13, $02, $02, $0B, $31, $03, $01
                dc.b    $23, $03, $06, $0B, $00, $B3, $A3, $A4, $CF, $1C, $04, $60, $00, $82, $DF, $0A
                dc.b    $02, $1D, $21, $02, $02, $01, $10, $02, $02, $83, $33, $02, $02, $0B, $FF, $02
                dc.b    $06, $10, $44, $71, $00, $06, $61, $02, $02, $07, $07, $18, $01, $01, $02, $02
                dc.b    $76, $77, $02, $05, $10, $07, $00, $01, $01, $03, $01, $10, $10, $05, $61, $00
                dc.b    $01, $17, $10, $0A, $01, $60, $05, $07, $11, $11, $66, $00, $11, $16, $66, $02
                dc.b    $06, $07, $00, $11, $10, $01, $77, $08, $02, $60, $10, $06, $09, $61, $11, $10
                dc.b    $00, $66, $11, $10, $00, $07, $03, $04, $71, $00, $01, $77, $1C, $04, $71, $00
                dc.b    $01, $76, $03, $01, $11, $02, $05, $11, $10, $00, $01, $10, $02, $07, $11, $00
                dc.b    $70, $71, $10, $07, $70, $02, $0B, $77, $01, $11, $00, $70, $11, $05, $AA, $99
                dc.b    $98, $15, $04, $01, $30, $02, $01, $77, $02, $03, $02, $77, $30, $02, $01, $15
                dc.b    $0B, $0E, $9C, $0F, $C3, $9A, $03, $2D, $CF, $00, $22, $02, $30, $00, $20, $10
                dc.b    $02, $02, $01, $3F, $03, $01, $F0, $03, $01, $DC, $03, $01, $13, $02, $06, $31
                dc.b    $09, $06, $B3, $03, $3A, $02, $03, $03, $13, $30, $02, $02, $31, $3A, $02, $07
                dc.b    $23, $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $13, $02, $03, $0B, $31, $1B
                dc.b    $02, $01, $28, $14, $01, $30, $03, $01, $3A, $03, $01, $0A, $1A, $01, $0A, $03
                dc.b    $01, $33, $02, $02, $0A, $21, $02, $14, $33, $13, $00, $0A, $31, $2B, $00, $33
                dc.b    $13, $20, $0A, $31, $3B, $00, $33, $13, $20, $00, $31, $3B, $02, $02, $13, $20
                dc.b    $02, $0F, $03, $18, $18, $18, $30, $13, $33, $33, $23, $12, $1B, $2B, $0B, $31
                dc.b    $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $13, $02, $02
                dc.b    $0B, $31, $02, $02, $0A, $33, $02, $01, $33, $02, $02, $0A, $31, $02, $0D, $33
                dc.b    $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $00, $31, $3B, $02, $02, $13, $20
                dc.b    $02, $04, $8B, $90, $90, $8C, $03, $01, $6E, $03, $01, $10, $02, $01, $06, $03
                dc.b    $02, $01, $F0, $06, $01, $60, $03, $17, $10, $10, $88, $77, $00, $FF, $11, $EF
                dc.b    $F0, $10, $00, $10, $F0, $16, $1E, $FE, $11, $60, $1F, $F1, $10, $00, $01, $05
                dc.b    $01, $16, $05, $0F, $AB, $A4, $53, $44, $14, $BA, $A9, $EE, $4F, $32, $21, $11
                dc.b    $00, $31, $10, $0E, $12, $0C, $C0, $00, $2A, $A5, $49, $88, $E9, $AA, $B4, $10
                dc.b    $11, $22, $2C, $40, $00, $11, $23, $11, $04, $89, $99, $AA, $27, $1C, $02, $89
                dc.b    $88, $03, $01, $11, $02, $02, $11, $03, $06, $01, $CC, $03, $03, $0F, $10, $77
                dc.b    $03, $01, $70, $05, $04, $2A, $8A, $06, $77, $10, $06, $07, $70, $01, $10, $00
                dc.b    $70, $04, $06, $01, $00, $67, $07, $00, $10, $16, $0A, $01, $10, $11, $07, $70
                dc.b    $11, $14, $AA, $E9, $8B, $09, $07, $F0, $33, $10, $14, $5A, $AA, $9A, $03, $01
                dc.b    $77, $04, $01, $10, $03, $04, $98, $9A, $A5, $67, $08, $09, $13, $30, $F0, $00
                dc.b    $9A, $AA, $54, $10, $70, $0B, $04, $C8, $A3, $A2, $A8, $03, $01, $0B, $18, $02
                dc.b    $02, $30, $02, $02, $31, $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02
                dc.b    $07, $23, $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $02, $02, $02, $01, $13
                dc.b    $03, $01, $13, $02, $14, $33, $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $0A
                dc.b    $31, $3B, $00, $33, $13, $20, $00, $20, $3B, $02, $01, $31, $03, $04, $33, $20
                dc.b    $00, $0B, $03, $01, $0B, $10, $0D, $03, $18, $18, $18, $33, $33, $33, $33, $0B
                dc.b    $2B, $2B, $30, $20, $13, $0D, $18, $18, $18, $00, $33, $33, $33, $30, $0B, $2B
                dc.b    $2B, $30, $20, $1B, $04, $90, $96, $E8, $12, $05, $01, $61, $05, $17, $10, $00
                dc.b    $01, $1F, $F1, $06, $11, $EF, $E1, $61, $0F, $01, $00, $01, $0F, $FE, $11, $FF
                dc.b    $00, $77, $88, $01, $01, $03, $01, $06, $06, $02, $0F, $10, $03, $01, $60, $02
                dc.b    $01, $01, $03, $01, $E6, $03, $07, $19, $96, $9B, $BB, $00, $0D, $20, $02, $02
                dc.b    $01, $10, $05, $0C, $4F, $03, $31, $10, $14, $BA, $A9, $9F, $00, $10, $00, $70
                dc.b    $04, $04, $89, $99, $AA, $27, $02, $02, $32, $D8, $02, $02, $32, $D0, $04, $0A
                dc.b    $11, $33, $0F, $40, $99, $AB, $B4, $10, $70, $01, $04, $06, $09, $81, $71, $00
                dc.b    $18, $FE, $18, $02, $99, $8A, $02, $04, $C2, $00, $11, $66, $02, $02, $11, $66
                dc.b    $04, $06, $D2, $10, $07, $00, $11, $30, $02, $02, $33, $0B, $02, $10, $FF, $B0
                dc.b    $16, $66, $44, $01, $11, $66, $00, $01, $11, $67, $61, $11, $10, $10, $04, $06
                dc.b    $07, $70, $01, $10, $00, $70, $04, $19, $01, $00, $66, $11, $10, $00, $61, $11
                dc.b    $10, $10, $01, $00, $06, $00, $01, $10, $07, $77, $00, $11, $00, $77, $00, $01
                dc.b    $11, $03, $02, $10, $11, $03, $01, $11, $08, $05, $71, $00, $01, $77, $01, $0B
                dc.b    $01, $11, $03, $01, $10, $0B, $04, $71, $00, $01, $77, $1C, $04, $C8, $A3, $A2
                dc.b    $A3, $17, $01, $0A, $03, $05, $33, $1B, $00, $0A, $22, $02, $14, $33, $13, $00
                dc.b    $0A, $31, $23, $00, $33, $13, $2B, $0A, $31, $3B, $00, $33, $13, $20, $00, $31
                dc.b    $3B, $02, $02, $13, $20, $02, $02, $33, $20, $02, $02, $31, $0A, $02, $07, $32
                dc.b    $13, $30, $00, $2B, $11, $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02
                dc.b    $02, $23, $13, $02, $11, $0B, $31, $18, $18, $18, $30, $00, $23, $33, $33, $03
                dc.b    $22, $1B, $2B, $00, $31, $3A, $02, $07, $23, $13, $30, $00, $0B, $31, $3A, $02
                dc.b    $02, $23, $13, $02, $0D, $0B, $31, $03, $18, $18, $33, $33, $33, $31, $00, $2B
                dc.b    $21, $21, $02, $0D, $33, $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $00, $31
                dc.b    $3B, $02, $02, $13, $20, $02, $01, $1B, $17, $01, $30, $03, $01, $3A, $03, $06
                dc.b    $ED, $E9, $09, $03, $00, $E0, $03, $10, $10, $11, $0F, $10, $FE, $FF, $F1, $1E
                dc.b    $FF, $01, $11, $F0, $10, $F1, $0F, $10, $02, $09, $10, $10, $10, $F0, $00, $EE
                dc.b    $11, $EE, $F0, $05, $0E, $E1, $11, $0F, $10, $F0, $00, $F1, $FE, $11, $10, $01
                dc.b    $10, $00, $10, $02, $01, $01, $02, $0A, $11, $10, $FF, $00, $EF, $F1, $EE, $FF
                dc.b    $00, $E0, $03, $10, $10, $11, $0F, $60, $FE, $FF, $F1, $7F, $FF, $01, $11, $F1
                dc.b    $10, $F1, $0F, $10, $02, $09, $10, $E0, $10, $F0, $00, $1E, $11, $EE, $F0, $02
                dc.b    $14, $01, $0F, $00, $E1, $10, $01, $10, $F0, $00, $F6, $FE, $11, $10, $06, $10
                dc.b    $00, $10, $01, $00, $01, $02, $09, $11, $10, $FF, $07, $07, $03, $DF, $8F, $70
                dc.b    $03, $01, $77, $03, $02, $33, $30, $02, $0B, $11, $11, $20, $00, $22, $22, $07
                dc.b    $07, $77, $77, $70, $05, $24, $75, $04, $47, $07, $00, $01, $02, $70, $00, $75
                dc.b    $11, $25, $10, $17, $52, $00, $01, $31, $76, $55, $30, $31, $70, $00, $11, $14
                dc.b    $36, $00, $03, $07, $05, $50, $30, $20, $73, $57, $03, $01, $07, $02, $12, $07
                dc.b    $77, $00, $01, $03, $33, $01, $30, $11, $11, $70, $12, $22, $22, $07, $77, $77
                dc.b    $77, $04, $06, $89, $9A, $AA, $AA, $00, $30, $05, $01, $DD, $02, $05, $0D, $00
                dc.b    $01, $00, $D0, $02, $01, $30, $03, $01, $13, $03, $06, $01, $D0, $00, $88, $88
                dc.b    $D0, $03, $01, $77, $04, $01, $70, $03, $01, $70, $02, $0C, $77, $DE, $77, $7A
                dc.b    $EE, $21, $FF, $F2, $11, $00, $11, $10, $02, $03, $EE, $32, $10, $03, $04, $10
                dc.b    $00, $0D, $02, $02, $02, $D3, $20, $02, $07, $21, $00, $01, $11, $00, $01, $10
                dc.b    $02, $0B, $10, $03, $33, $01, $03, $30, $00, $FD, $F5, $CF, $CD, $02, $1F, $33
                dc.b    $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $00, $31, $3B, $00, $02, $13, $20
                dc.b    $00, $01, $03, $18, $18, $33, $33, $33, $33, $0B, $2B, $2B, $2B, $20, $13, $0C
                dc.b    $18, $18, $18, $18, $33, $33, $33, $33, $2B, $2B, $2B, $20, $03, $01, $0B, $10
                dc.b    $0E, $18, $18, $18, $18, $33, $33, $33, $33, $32, $1B, $2B, $2B, $31, $3A, $02
                dc.b    $07, $23, $13, $30, $00, $0B, $31, $3A, $02, $13, $23, $13, $30, $00, $0B, $31
                dc.b    $3A, $18, $18, $30, $12, $33, $33, $33, $33, $2B, $2B, $21, $23, $02, $20, $33
                dc.b    $13, $00, $0A, $31, $3B, $00, $33, $13, $20, $0A, $31, $3B, $00, $33, $13, $20
                dc.b    $00, $21, $03, $18, $18, $33, $33, $33, $33, $32, $1B, $2B, $30, $31, $3A, $02
                dc.b    $07, $23, $13, $30, $00, $0B, $31, $3A, $02, $02, $23, $13, $02, $12, $0B, $31
                dc.b    $00, $18, $18, $30, $00, $33, $33, $33, $30, $C3, $CC, $CD, $CC, $0E, $10, $10
                dc.b    $02, $07, $1F, $FF, $F0, $01, $F1, $00, $0F, $04, $1A, $10, $00, $01, $0F, $01
                dc.b    $F1, $10, $F0, $00, $1F, $FF, $00, $EE, $E0, $00, $11, $FF, $F0, $10, $E1, $01
                dc.b    $10, $FE, $1F, $01, $0F, $03, $1F, $11, $00, $1F, $00, $1E, $11, $F0, $01, $01
                dc.b    $FF, $01, $10, $1E, $EE, $F1, $0E, $0F, $EF, $F0, $6E, $10, $10, $00, $60, $1F
                dc.b    $FF, $F0, $01, $F1, $00, $0F, $06, $42, $01, $0F, $01, $F1, $10, $F0, $60, $1F
                dc.b    $FF, $00, $8E, $E0, $00, $17, $FF, $F0, $10, $E6, $01, $10, $EE, $11, $01, $0F
                dc.b    $10, $0F, $00, $11, $00, $1F, $00, $1E, $11, $F1, $01, $01, $FF, $06, $10, $1E
                dc.b    $EE, $F7, $DE, $F7, $35, $48, $01, $00, $53, $30, $03, $05, $43, $33, $01, $12
                dc.b    $17, $00, $20, $21, $23, $33, $12, $12, $32, $66, $02, $02, $01, $22, $02, $06
                dc.b    $03, $33, $DC, $FE, $ED, $DD, $06, $05, $03, $33, $33, $33, $30, $04, $05, $11
                dc.b    $11, $11, $11, $01, $03, $01, $2E, $02, $02, $1F, $D0, $02, $0A, $1D, $00, $11
                dc.b    $10, $02, $D0, $33, $32, $11, $2D, $02, $09, $33, $12, $DD, $D0, $00, $32, $00
                dc.b    $0D, $DD, $04, $01, $DD, $04, $04, $77, $77, $77, $77, $04, $01, $70, $03, $02
                dc.b    $FA, $70, $02, $0A, $12, $F9, $A7, $77, $32, $11, $2F, $FF, $00, $31, $02, $06
                dc.b    $D0, $03, $10, $00, $E3, $33, $02, $03, $33, $30, $01, $02, $04, $03, $30, $00
                dc.b    $DD, $02, $04, $10, $00, $DD, $03, $03, $01, $D0, $07, $07, $D3, $10, $EE, $DD
                dc.b    $03, $22, $03, $02, $01, $DD, $02, $04, $DD, $00, $13, $0D, $06, $02, $01, $3D
                dc.b    $03, $02, $13, $D0, $02, $07, $01, $2E, $ED, $33, $33, $32, $24, $07, $01, $50
                dc.b    $06, $04, $55, $00, $55, $55, $06, $01, $30, $07, $05, $33, $33, $33, $33, $03
                dc.b    $05, $01, $11, $04, $01, $11, $02, $01, $10, $03, $01, $01, $05, $03, $33, $00
                dc.b    $01, $0F, $04, $10, $00, $11, $11, $0A, $01, $77, $02, $05, $07, $70, $77, $77
                dc.b    $70, $05, $01, $05, $03, $02, $05, $55, $04, $01, $55, $02, $03, $50, $33, $70
                dc.b    $02, $01, $30, $02, $02, $01, $12, $02, $02, $04, $41, $03, $01, $50, $06, $04
                dc.b    $55, $00, $55, $55, $06, $01, $30, $03, $0C, $21, $11, $21, $11, $12, $20, $30
                dc.b    $01, $03, $02, $22, $01, $02, $02, $11, $22, $03, $01, $11, $02, $01, $10, $03
                dc.b    $01, $01, $05, $04, $11, $22, $22, $33, $03, $07, $04, $00, $02, $00, $04, $22
                dc.b    $02, $03, $07, $22, $30, $00, $11, $11, $03, $33, $08, $04, $33, $33, $33, $33
                dc.b    $0C, $24, $01, $00, $20, $00, $31, $00, $20, $00, $04, $44, $00, $01, $70, $00
                dc.b    $41, $11, $64, $44, $41, $00, $02, $20, $00, $10, $30, $12, $20, $02, $03, $11
                dc.b    $02, $22, $00, $01, $11, $02, $03, $01, $11, $02, $03, $10, $70, $03, $02, $05
                dc.b    $77, $12, $22, $23, $34, $02, $01, $01, $03, $01, $01, $02, $01, $31, $02, $0C
                dc.b    $20, $31, $10, $00, $02, $20, $10, $10, $11, $13, $00, $10, $02, $0C, $33, $00
                dc.b    $33, $33, $23, $00, $40, $00, $10, $00, $04, $02, $03, $01, $42, $03, $07, $04
                dc.b    $00, $02, $55, $55, $11, $02, $03, $02, $10, $30, $02, $08, $01, $31, $11, $01
                dc.b    $11, $32, $00, $10, $02, $02, $20, $13, $03, $06, $13, $10, $00, $02, $00, $10
                dc.b    $02, $06, $20, $00, $11, $11, $13, $01, $03, $06, $31, $32, $33, $33, $30, $41
                dc.b    $03, $2C, $04, $04, $00, $01, $00, $04, $20, $01, $00, $40, $20, $00, $55, $50
                dc.b    $00, $10, $00, $01, $00, $10, $30, $00, $10, $10, $03, $30, $00, $10, $00, $03
                dc.b    $30, $00, $30, $10, $02, $00, $03, $11, $00, $03, $00, $01, $11, $23, $03, $01
                dc.b    $10, $02, $03, $10, $74, $03, $02, $07, $70, $52, $32, $23, $34, $74, $10, $04
                dc.b    $01, $01, $02, $02, $40, $01, $06, $01, $04, $06, $03, $70, $00, $03, $03, $01
                dc.b    $43, $07, $01, $51, $06, $04, $55, $00, $01, $55, $02, $01, $01, $03, $02, $10
                dc.b    $30, $02, $03, $01, $03, $30, $03, $05, $03, $33, $33, $30, $10, $02, $02, $03
                dc.b    $11, $03, $02, $01, $11, $04, $01, $11, $02, $03, $10, $70, $03, $02, $01, $77
                dc.b    $02, $03, $01, $17, $30, $12, $04, $10, $11, $11, $11, $05, $01, $77, $02, $05
                dc.b    $07, $70, $77, $77, $70, $04, $01, $07, $05, $01, $05, $03, $02, $05, $55, $04
                dc.b    $01, $07, $02, $05, $50, $70, $00, $05, $53, $03, $01, $03, $02, $01, $50, $06
                dc.b    $01, $55, $02, $01, $55, $07, $01, $30, $03, $0B, $21, $01, $11, $11, $00, $13
                dc.b    $20, $00, $20, $03, $32, $03, $09, $53, $02, $00, $10, $40, $02, $13, $10, $01
                dc.b    $04, $01, $01, $02, $08, $30, $01, $77, $30, $30, $00, $70, $70, $05, $05, $10
                dc.b    $07, $04, $00, $10, $06, $01, $01, $03, $03, $41, $00, $07, $02, $02, $03, $70
                dc.b    $02, $01, $03, $02, $01, $04, $0B, $06, $55, $03, $55, $55, $00, $13, $04, $01
                dc.b    $30, $03, $04, $21, $11, $11, $10, $02, $01, $01, $02, $02, $10, $01, $02, $06
                dc.b    $12, $30, $00, $20, $02, $20, $03, $03, $10, $20, $10, $02, $03, $20, $00, $10
                dc.b    $02, $02, $70, $10, $02, $01, $74, $04, $01, $02, $03, $01, $42, $0E, $03, $70
                dc.b    $00, $10, $02, $02, $04, $10, $0B, $01, $01, $02, $06, $55, $01, $00, $55, $00
                dc.b    $10, $05, $01, $30, $02, $05, $02, $65, $55, $51, $10, $03, $01, $03, $02, $01
                dc.b    $50, $06, $01, $55, $02, $16, $74, $11, $10, $00, $30, $01, $01, $11, $00, $01
                dc.b    $00, $20, $22, $21, $11, $31, $00, $03, $33, $33, $30, $10, $02, $02, $03, $11
                dc.b    $03, $02, $01, $11, $04, $13, $11, $11, $00, $10, $70, $00, $22, $23, $77, $04
                dc.b    $33, $33, $00, $04, $37, $77, $70, $00, $04, $03, $02, $40, $44, $02, $03, $44
                dc.b    $00, $40, $02, $0E, $20, $34, $00, $04, $20, $30, $00, $01, $00, $01, $44, $45
                dc.b    $44, $40, $07, $01, $50, $06, $04, $55, $00, $55, $55, $02, $01, $10, $03, $01
                dc.b    $01, $04, $01, $10, $02, $07, $10, $01, $33, $33, $10, $20, $20, $02, $02, $20
                dc.b    $02, $03, $0A, $40, $00, $04, $00, $42, $21, $04, $00, $02, $03, $02, $0B, $40
                dc.b    $00, $04, $33, $73, $34, $00, $77, $77, $70, $24, $03, $02, $20, $05, $03, $04
                dc.b    $45, $55, $00, $04, $02, $0C, $55, $04, $04, $50, $33, $00, $20, $00, $30, $00
                dc.b    $20, $40, $04, $04, $03, $00, $40, $01, $02, $01, $41, $03, $01, $01, $04, $02
                dc.b    $03, $10, $02, $01, $03, $03, $07, $04, $01, $22, $22, $27, $33, $20, $03, $01
                dc.b    $30, $03, $01, $32, $05, $04, $10, $00, $40, $11, $02, $02, $40, $30, $02, $01
                dc.b    $02, $03, $01, $02, $02, $07, $07, $00, $07, $77, $70, $00, $14, $03, $01, $10
                dc.b    $04, $09, $05, $00, $04, $00, $05, $55, $04, $04, $40, $02, $03, $04, $00, $50
                dc.b    $06, $01, $04, $02, $06, $04, $00, $50, $00, $04, $20, $03, $02, $20, $10, $0A
                dc.b    $07, $01, $00, $12, $22, $23, $22, $30, $03, $01, $20, $0B, $01, $40, $02, $04
                dc.b    $10, $41, $11, $11, $05, $01, $07, $02, $05, $07, $04, $77, $77, $70, $05, $01
                dc.b    $05, $02, $05, $03, $05, $55, $00, $03, $02, $01, $55, $02, $07, $50, $33, $40
                dc.b    $40, $00, $30, $40, $06, $01, $03, $02, $03, $50, $00, $04, $03, $02, $04, $05
                dc.b    $07, $01, $30, $02, $02, $20, $30, $02, $02, $20, $01, $03, $05, $01, $33, $33
                dc.b    $00, $01, $02, $05, $01, $00, $11, $00, $01, $02, $01, $11, $02, $01, $10, $03
                dc.b    $01, $01, $02, $0A, $01, $20, $00, $20, $01, $00, $10, $20, $00, $30, $03, $01
                dc.b    $30, $02, $01, $20, $02, $02, $04, $20, $02, $01, $04, $02, $07, $10, $00, $01
                dc.b    $01, $00, $10, $01, $02, $09, $31, $11, $13, $33, $33, $33, $32, $00, $03, $05
                dc.b    $01, $11, $04, $01, $01, $02, $02, $10, $31, $02, $01, $01, $05, $01, $03, $02
                dc.b    $02, $10, $30, $0A, $01, $03, $07, $04, $10, $11, $11, $11, $05, $0F, $BB, $B6
                dc.b    $54, $44, $0D, $E2, $11, $11, $F2, $11, $13, $33, $00, $10, $30, $02, $03, $03
                dc.b    $00, $DD, $02, $01, $0D, $02, $0B, $13, $0D, $00, $11, $11, $23, $ED, $11, $10
                dc.b    $01, $F3, $03, $01, $0F, $02, $01, $0E, $02, $0A, $0E, $E0, $FF, $EE, $E0, $FF
                dc.b    $11, $00, $0F, $11, $02, $01, $F1, $06, $02, $33, $C1, $02, $07, $CC, $CC, $10
                dc.b    $00, $11, $0C, $C1, $02, $03, $10, $0C, $D1, $02, $0C, $33, $3F, $00, $1F, $0F
                dc.b    $FF, $11, $FF, $E1, $11, $FF, $F1, $02, $04, $EE, $10, $01, $22, $02, $01, $13
                dc.b    $03, $0D, $03, $00, $21, $10, $11, $33, $DE, $32, $10, $11, $00, $D0, $31, $02
                dc.b    $0A, $D0, $30, $00, $DD, $03, $01, $00, $DD, $DE, $31, $03, $02, $D3, $10, $06
                dc.b    $01, $D0, $02, $04, $DD, $03, $00, $DD, $02, $0F, $10, $00, $03, $30, $00, $33
                dc.b    $30, $01, $00, $10, $03, $32, $22, $00, $30, $05, $01, $DD, $02, $05, $0D, $00
                dc.b    $01, $00, $D0, $02, $01, $30, $03, $01, $13, $04, $01, $D0, $02, $02, $01, $30
                dc.b    $03, $02, $1F, $D0, $03, $05, $2E, $11, $11, $11, $01, $03, $04, $11, $33, $33
                dc.b    $30, $03, $02, $03, $33, $04, $07, $22, $22, $0D, $DD, $00, $01, $D0, $02, $01
                dc.b    $13, $03, $01, $30, $02, $03, $01, $00, $D0, $03, $01, $0D, $04, $03, $DD, $00
                dc.b    $30, $02, $04, $01, $13, $0D, $DD, $02, $01, $D0, $02, $01, $13, $03, $01, $30
                dc.b    $02, $03, $01, $00, $D0, $03, $01, $0D, $04, $03, $DD, $00, $30, $02, $06, $10
                dc.b    $02, $22, $22, $11, $10, $02, $08, $FF, $F2, $11, $00, $77, $7A, $EE, $21, $02
                dc.b    $02, $77, $DE, $03, $01, $70, $03, $01, $70, $02, $09, $77, $00, $89, $9A, $DD
                dc.b    $DD, $01, $03, $30, $02, $0D, $10, $03, $33, $00, $01, $10, $00, $21, $00, $01
                dc.b    $11, $D3, $20, $02, $02, $0D, $02, $04, $0C, $10, $00, $FF, $33, $02, $22, $00
                dc.b    $10, $03, $33, $00, $01, $02, $08, $FF, $F2, $01, $10, $77, $7A, $9F, $21, $02
                dc.b    $02, $07, $AF, $03, $01, $07, $04, $04, $AA, $AA, $AA, $AA, $04, $02, $33, $30
                dc.b    $03, $04, $03, $33, $33, $11, $03, $05, $10, $11, $11, $11, $E2, $03, $02, $0D
                dc.b    $F1, $03, $03, $0E, $FF, $FF, $07, $09, $DD, $00, $0D, $DD, $00, $DD, $D0, $00
                dc.b    $32, $02, $11, $33, $12, $33, $32, $11, $2D, $11, $10, $02, $D0, $F2, $22, $12
                dc.b    $FF, $D0, $03, $10, $02, $01, $31, $02, $0A, $32, $11, $2F, $FF, $12, $F9, $A7
                dc.b    $77, $FA, $70, $02, $01, $70, $0E, $01, $07, $03, $01, $70, $02, $04, $77, $00
                dc.b    $77, $77, $09, $0C, $0D, $DD, $DD, $DD, $D0, $00, $03, $32, $22, $DD, $03, $01
                dc.b    $02, $02, $D0, $30, $02, $0B, $D0, $31, $00, $DE, $32, $10, $11, $21, $10, $11
                dc.b    $33, $02, $01, $03, $03, $08, $13, $00, $EE, $10, $01, $22, $FF, $F1, $02, $08
                dc.b    $11, $FF, $E1, $11, $00, $1F, $0F, $FF, $02, $10, $33, $3F, $00, $10, $0C, $D1
                dc.b    $11, $0C, $C1, $00, $CC, $CC, $10, $00, $33, $C1, $07, $01, $F1, $03, $0B, $0F
                dc.b    $11, $00, $EE, $E0, $FF, $11, $00, $0E, $E0, $FF, $02, $01, $0E, $04, $0C, $0F
                dc.b    $11, $10, $01, $F3, $11, $11, $23, $ED, $00, $13, $0D, $03, $01, $0D, $02, $1D
                dc.b    $03, $00, $DD, $00, $10, $30, $00, $F2, $11, $13, $33, $0D, $E2, $11, $11, $FF
                dc.b    $F2, $11, $12, $00, $01, $2E, $ED, $00, $13, $D0, $00, $01, $3D, $06, $02, $13
                dc.b    $0D, $04, $03, $DD, $00, $03, $02, $05, $DD, $66, $55, $55, $55, $80, $FC, $04
                dc.b    $FF, $FF, $FF, $FF, $07, $01, $07, $02, $0C, $07, $AF, $77, $7A, $9F, $21, $FF
                dc.b    $F2, $01, $10, $00, $01, $03, $09, $10, $03, $33, $FF, $E0, $12, $22, $0D, $F1
                dc.b    $02, $01, $E2, $03, $05, $10, $11, $11, $11, $11, $04, $05, $03, $33, $33, $33
                dc.b    $30, $06, $04, $11, $11, $16, $66, $02, $04, $07, $77, $05, $55, $02, $0A, $50
                dc.b    $00, $50, $00, $03, $30, $05, $55, $30, $03, $02, $10, $11, $00, $33, $33, $00
                dc.b    $11, $10, $01, $77, $70, $01, $17, $00, $07, $00, $70, $02, $0D, $77, $00, $55
                dc.b    $50, $00, $05, $00, $05, $00, $50, $33, $30, $55, $02, $0F, $03, $00, $03, $11
                dc.b    $00, $33, $31, $66, $77, $77, $76, $DD, $DD, $DD, $D0, $03, $01, $0D, $04, $02
                dc.b    $77, $77, $04, $01, $77, $04, $01, $70, $03, $05, $07, $AA, $AA, $99, $88, $02
                dc.b    $03, $30, $10, $DD, $04, $01, $D0, $03, $03, $0D, $00, $10, $06, $01, $31, $02
                dc.b    $01, $0D, $02, $0D, $99, $94, $76, $66, $00, $03, $30, $00, $30, $30, $03, $30
                dc.b    $03, $02, $09, $03, $10, $01, $11, $00, $01, $10, $00, $10, $03, $03, $01, $07
                dc.b    $77, $02, $06, $25, $55, $22, $22, $03, $30, $02, $04, $30, $03, $00, $03, $02
                dc.b    $0D, $33, $30, $00, $11, $00, $01, $01, $00, $10, $10, $10, $00, $01, $05, $04
                dc.b    $33, $33, $33, $33, $06, $02, $08, $80, $02, $02, $87, $78, $02, $02, $70, $07
                dc.b    $02, $01, $70, $03, $1B, $87, $00, $0F, $F0, $08, $00, $0F, $F0, $11, $EE, $00
                dc.b    $01, $33, $33, $01, $01, $0A, $A0, $01, $00, $A7, $7A, $80, $08, $70, $07, $78
                dc.b    $04, $01, $08, $02, $01, $07, $03, $04, $DD, $22, $DC, $CC, $0C, $1F, $A0, $00
                dc.b    $10, $00, $71, $11, $BC, $B0, $00, $0B, $70, $7B, $00, $07, $00, $07, $B7, $0C
                dc.b    $CC, $CB, $70, $BB, $77, $70, $0C, $77, $C0, $00, $07, $00, $70, $03, $01, $0C
                dc.b    $03, $02, $07, $55, $03, $02, $33, $B0, $02, $05, $3A, $CB, $BB, $BB, $59, $06
                dc.b    $02, $0B, $50, $02, $01, $0B, $02, $1A, $CC, $55, $09, $5C, $77, $90, $07, $97
                dc.b    $00, $70, $90, $70, $00, $09, $70, $DE, $77, $E9, $EE, $AE, $77, $93, $33, $70
                dc.b    $00, $70, $03, $02, $71, $0A, $02, $02, $B0, $A7, $02, $02, $1A, $70, $02, $01
                dc.b    $01, $03, $0D, $A7, $00, $DE, $77, $9F, $FF, $AE, $77, $92, $00, $70, $00, $70
                dc.b    $03, $02, $71, $08, $02, $02, $B0, $87, $02, $02, $1A, $70, $02, $01, $01, $03
                dc.b    $0A, $A7, $00, $FF, $70, $8F, $60, $00, $8F, $00, $97, $02, $02, $08, $88, $02
                dc.b    $02, $97, $78, $02, $02, $90, $07, $02, $01, $07, $03, $02, $08, $70, $03, $07
                dc.b    $87, $FF, $80, $FF, $F7, $00, $78, $03, $01, $07, $16, $02, $7B, $70, $02, $02
                dc.b    $B0, $70, $02, $01, $0C, $03, $01, $B7, $03, $01, $70, $12, $01, $E0, $07, $01
                dc.b    $80, $03, $01, $10, $03, $01, $70, $4C, $04, $FF, $FF, $FF, $FF, $1C, $04, $DD
                dc.b    $CC, $CB, $BB, $02, $02, $70, $07, $02, $02, $07, $70, $02, $02, $77, $70, $03
                dc.b    $01, $77, $02, $02, $70, $77, $02, $01, $77, $02, $07, $11, $11, $61, $00, $11
                dc.b    $66, $61, $02, $02, $77, $70, $03, $01, $70, $02, $02, $77, $70, $02, $01, $77
                dc.b    $0A, $03, $11, $11, $11, $00, $15, $69, $0A, $00, $15, $00, $97, $00, $14, $00
                dc.b    $97, $00, $01, $05, $3B, $0E, $00, $0F, $00, $10, $00, $10, $21, $78, $29, $79
                dc.b    $00, $10, $00, $10, $00, $F0, $08, $F1, $00, $10, $00, $10, $00, $1E, $00, $10
                dc.b    $00, $10, $00, $10, $00, $1E, $00, $1E, $00, $10, $00, $10, $21, $86, $21, $A8
                dc.b    $00, $30, $00, $07, $08, $11, $08, $26, $00, $07, $00, $30, $08, $36, $08, $21
                dc.b    $03, $17, $10, $00, $02, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00
                dc.b    $10, $00, $10, $00, $12, $08, $12, $00, $10, $02, $04, $08, $11, $00, $21, $03
                dc.b    $17, $21, $00, $22, $00, $23, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10
                dc.b    $00, $10, $00, $12, $08, $32, $08, $21, $05, $01, $07, $03, $17, $10, $00, $08
                dc.b    $00, $1E, $00, $10, $00, $10, $00, $1C, $00, $1C, $00, $10, $00, $10, $00, $12
                dc.b    $00, $15, $00, $10, $03, $03, $16, $00, $27, $03, $17, $10, $00, $28, $00, $1E
                dc.b    $00, $10, $00, $10, $00, $1C, $00, $1C, $00, $10, $00, $10, $00, $12, $00, $35
                dc.b    $00, $26, $09, $17, $1A, $00, $0B, $00, $16, $00, $10, $00, $10, $08, $17, $08
                dc.b    $17, $00, $10, $00, $10, $08, $1C, $08, $1B, $08, $1A, $02, $04, $08, $1A, $00
                dc.b    $2A, $05, $03, $2B, $00, $06, $04, $04, $08, $07, $08, $07, $05, $03, $06, $08
                dc.b    $2B, $04, $04, $08, $2A, $00, $3A, $03, $17, $30, $00, $3B, $00, $36, $00, $2B
                dc.b    $00, $0D, $08, $2C, $08, $0A, $00, $0D, $00, $2B, $00, $0B, $08, $10, $00, $30
                dc.b    $02, $14, $08, $2A, $00, $36, $00, $10, $00, $3B, $08, $06, $08, $2D, $00, $3B
                dc.b    $00, $10, $08, $3D, $08, $3D, $04, $04, $08, $3D, $08, $3D, $04, $24, $E8, $E5
                dc.b    $E8, $D9, $00, $10, $00, $10, $00, $11, $00, $10, $00, $10, $00, $10, $00, $10
                dc.b    $08, $11, $00, $10, $00, $10, $00, $12, $00, $13, $00, $10, $00, $10, $00, $21
                dc.b    $08, $20, $05, $2F, $30, $00, $3C, $00, $10, $08, $1D, $00, $36, $08, $37, $00
                dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $32, $00, $32, $00
                dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $34, $00, $34, $00
                dc.b    $10, $00, $10, $05, $80, $E7, $2A, $00, $2C, $01, $B0, $01, $B6, $00, $10, $00
                dc.b    $10, $00, $12, $00, $12, $00, $10, $00, $32, $00, $16, $00, $30, $00, $36, $00
                dc.b    $10, $00, $30, $00, $14, $00, $10, $00, $10, $00, $32, $00, $34, $00, $10, $00
                dc.b    $10, $00, $12, $00, $F0, $00, $10, $00, $D0, $00, $F0, $00, $30, $00, $D0, $00
                dc.b    $10, $00, $30, $00, $14, $00, $10, $00, $10, $00, $F2, $00, $F4, $00, $10, $00
                dc.b    $10, $00, $12, $00, $F0, $00, $10, $00, $F2, $00, $F0, $00, $12, $00, $F6, $00
                dc.b    $10, $00, $16, $00, $14, $00, $10, $00, $10, $00, $11, $00, $D6, $00, $F3, $00
                dc.b    $32, $00, $34, $00, $F5, $00, $36, $00, $F1, $00, $F2, $00, $F4, $00, $D0, $00
                dc.b    $D0, $00, $D2, $00, $D4, $00, $D0, $00, $D0, $00, $32, $00, $34, $00, $13, $00
                dc.b    $F2, $00, $11, $00, $F6, $00, $F6, $00, $11, $00, $D0, $00, $27, $00, $36, $00
                dc.b    $02, $00, $26, $00, $30, $00, $06, $00, $10, $00, $30, $00, $12, $00, $10, $00
                dc.b    $32, $00, $16, $00, $14, $00, $36, $00, $10, $00, $D8, $00, $DE, $01, $73, $01
                dc.b    $70, $09, $72, $01, $77, $01, $70, $01, $75, $08, $12, $00, $12, $00, $20, $01
                dc.b    $71, $00, $20, $01, $71, $00, $10, $00, $10, $08, $12, $00, $12, $00, $10, $00
                dc.b    $10, $C1, $9C, $C1, $9E, $00, $10, $00, $10, $29, $47, $21, $7A, $04, $04, $08
                dc.b    $3D, $08, $3D, $04, $1E, $E9, $E3, $E9, $DF, $00, $04, $00, $04, $61, $AA, $61
                dc.b    $AA, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $00
                dc.b    $53, $00, $10, $03, $33, $34, $00, $61, $00, $10, $00, $10, $00, $12, $00, $12
                dc.b    $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $08, $11, $00, $12, $08, $13
                dc.b    $08, $15, $00, $16, $08, $1B, $00, $18, $00, $19, $00, $10, $00, $1B, $00, $12
                dc.b    $00, $10, $00, $10, $00, $0A, $00, $0A, $05, $80, $93, $F2, $00, $F2, $00, $10
                dc.b    $00, $F2, $00, $16, $08, $F5, $00, $F5, $08, $11, $08, $F2, $00, $12, $08, $15
                dc.b    $00, $10, $00, $36, $00, $36, $00, $10, $00, $10, $00, $12, $00, $C0, $00, $10
                dc.b    $00, $C2, $00, $C3, $00, $16, $00, $C5, $00, $10, $00, $12, $00, $12, $00, $10
                dc.b    $00, $10, $00, $76, $00, $76, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10
                dc.b    $00, $10, $00, $16, $00, $16, $00, $10, $00, $16, $00, $12, $00, $14, $00, $10
                dc.b    $00, $10, $E1, $74, $E1, $74, $E1, $7A, $00, $19, $E1, $78, $00, $1B, $00, $1B
                dc.b    $00, $03, $E1, $5B, $E1, $43, $00, $E0, $00, $10, $00, $E2, $00, $12, $00, $10
                dc.b    $00, $10, $00, $84, $00, $79, $00, $F0, $00, $33, $00, $2E, $E1, $05, $00, $10
                dc.b    $01, $BC, $E1, $05, $01, $A1, $00, $03, $00, $10, $E1, $BE, $E1, $F4, $03, $15
                dc.b    $10, $00, $46, $00, $12, $00, $10, $00, $10, $00, $1E, $00, $1E, $00, $10, $00
                dc.b    $10, $E0, $58, $E1, $E6, $03, $05, $7F, $E0, $00, $E1, $8A, $03, $15, $10, $00
                dc.b    $4B, $00, $16, $00, $10, $00, $10, $00, $10, $00, $11, $00, $10, $00, $10, $00
                dc.b    $15, $00, $12, $04, $4E, $E1, $8F, $E1, $EC, $00, $03, $00, $10, $E1, $AE, $E1
                dc.b    $DE, $00, $10, $00, $10, $00, $37, $00, $31, $00, $10, $00, $51, $00, $76, $00
                dc.b    $33, $00, $10, $00, $10, $00, $12, $00, $A7, $00, $10, $00, $30, $00, $3F, $00
                dc.b    $F6, $00, $6E, $00, $30, $E1, $AD, $E1, $CE, $01, $C3, $00, $65, $E0, $8B, $E1
                dc.b    $88, $00, $11, $00, $D7, $00, $D1, $00, $D7, $00, $D7, $00, $D1, $00, $1C, $00
                dc.b    $2C, $00, $10, $03, $03, $21, $00, $30, $03, $15, $10, $00, $FF, $00, $DE, $00
                dc.b    $39, $00, $37, $00, $09, $00, $07, $00, $F0, $00, $F0, $E0, $8E, $E1, $4A, $03
                dc.b    $3D, $03, $E0, $9E, $E1, $59, $00, $30, $00, $30, $00, $04, $00, $04, $00, $10
                dc.b    $00, $10, $00, $16, $00, $16, $00, $10, $00, $10, $00, $2F, $00, $29, $00, $30
                dc.b    $00, $30, $00, $2F, $00, $29, $00, $32, $00, $32, $00, $6B, $00, $5A, $00, $21
                dc.b    $00, $10, $00, $12, $00, $80, $00, $10, $00, $F0, $E0, $F6, $E1, $42, $03, $3F
                dc.b    $0F, $01, $A4, $00, $6D, $00, $14, $00, $14, $00, $16, $00, $16, $00, $14, $00
                dc.b    $14, $01, $B2, $01, $B3, $01, $A8, $01, $A9, $00, $08, $00, $08, $00, $10, $00
                dc.b    $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $18, $01, $B3, $00, $1A, $01
                dc.b    $AB, $00, $1A, $01, $AB, $00, $1A, $01, $AB, $00, $1C, $01, $AB, $00, $01, $03
                dc.b    $0D, $0F, $01, $AE, $00, $10, $00, $01, $00, $06, $01, $AF, $00, $01, $03, $01
                dc.b    $03, $03, $41, $06, $01, $B7, $00, $12, $00, $0F, $00, $10, $00, $01, $00, $12
                dc.b    $00, $70, $00, $10, $00, $03, $00, $40, $00, $3B, $00, $07, $00, $09, $00, $05
                dc.b    $00, $0B, $00, $0B, $00, $09, $00, $0D, $00, $0F, $00, $0F, $00, $09, $00, $09
                dc.b    $00, $0F, $00, $0B, $00, $09, $00, $0D, $00, $0C, $00, $0F, $00, $0A, $08, $0B
                dc.b    $01, $FC, $00, $07, $02, $0A, $E9, $7F, $E0, $89, $00, $10, $00, $89, $00, $50
                dc.b    $03, $0F, $10, $00, $5E, $00, $D6, $00, $51, $00, $10, $00, $10, $80, $1E, $80
                dc.b    $1F, $26, $01, $80, $05, $01, $80, $37, $01, $80, $07, $01, $80, $67, $03, $80
                dc.b    $00, $80, $4D, $03, $80, $00, $80, $2D, $03, $80, $00, $80, $0D, $03, $80, $00
                dc.b    $80, $6D, $03, $80, $00, $80, $81, $0E, $04, $FF, $00, $FF, $FF, $02, $03, $FF
                dc.b    $FF, $FF, $1E, $04, $FF, $FF, $FF, $FF, $08, $04, $FF, $FF, $FF, $FF, $15, $02
                dc.b    $FF, $FF, $02, $09, $FF, $00, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $11, $02, $CC
                dc.b    $CC, $02, $03, $CC, $33, $FF, $04, $03, $FF, $00, $FF, $02, $14, $FF, $00, $FF
                dc.b    $FF, $00, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
                dc.b    $FF, $13, $01, $FF, $03, $01, $FF, $81, $AF, $05, $2E, $4D, $4E, $4D, $60, $04
                dc.b    $01, $01, $03, $01, $01, $09, $05, $7C, $4F, $4C, $4F, $30, $2A, $07, $52, $55
                dc.b    $54, $01, $53, $54, $55, $06, $0D, $1C, $1D, $1E, $1F, $1C, $01, $03, $01, $1F
                dc.b    $1C, $1D, $1E, $1F, $37, $06, $2D, $34, $35, $36, $18, $02, $02, $06, $02, $1A
                dc.b    $35, $36, $37, $2C, $09, $01, $2D, $03, $01, $2D, $2A, $0A, $56, $57, $58, $59
                dc.b    $0C, $0C, $58, $59, $5A, $5B, $03, $0D, $20, $21, $22, $23, $20, $01, $03, $01
                dc.b    $23, $20, $21, $22, $23, $37, $06, $2C, $38, $39, $3A, $15, $02, $02, $06, $02
                dc.b    $17, $39, $3A, $3B, $2D, $09, $01, $2C, $03, $01, $2C, $2A, $0C, $5C, $5D, $5E
                dc.b    $5F, $FC, $D0, $D0, $D0, $A0, $8D, $8E, $8F, $02, $02, $50, $51, $02, $03, $50
                dc.b    $01, $51, $02, $02, $50, $51, $22, $05, $2E, $4D, $4E, $4D, $60, $0C, $0B, $67
                dc.b    $4E, $4D, $4E, $2A, $2D, $3C, $3D, $3E, $10, $02, $02, $06, $02, $12, $3D, $3E
                dc.b    $3F, $2C, $09, $01, $2D, $03, $01, $2D, $2A, $10, $60, $61, $62, $63, $F0, $F0
                dc.b    $F2, $F2, $02, $91, $90, $91, $92, $00, $50, $51, $02, $03, $50, $01, $51, $02
                dc.b    $02, $50, $51, $22, $01, $2C, $03, $01, $2C, $11, $01, $2C, $03, $02, $2C, $32
                dc.b    $03, $09, $1F, $34, $35, $36, $1A, $06, $35, $36, $37, $04, $02, $32, $2C, $03
                dc.b    $01, $2C, $2A, $1A, $64, $65, $66, $67, $C5, $F5, $F7, $F7, $30, $03, $91, $90
                dc.b    $91, $9B, $09, $0A, $0B, $08, $01, $03, $01, $0B, $08, $09, $0A, $0B, $21, $01
                dc.b    $2D, $03, $01, $2D, $11, $01, $2D, $03, $02, $2D, $2D, $03, $09, $01, $38, $39
                dc.b    $3A, $17, $15, $39, $3A, $3B, $04, $02, $2D, $2D, $03, $01, $2D, $2A, $1A, $6A
                dc.b    $6B, $6B, $6B, $06, $06, $05, $FA, $FC, $FC, $FA, $91, $90, $9D, $99, $0E, $0F
                dc.b    $0C, $01, $03, $01, $0F, $0C, $0D, $0E, $0F, $21, $01, $2C, $03, $01, $2C, $11
                dc.b    $01, $2C, $03, $02, $2C, $2C, $03, $09, $01, $3C, $3D, $3E, $12, $10, $3D, $3E
                dc.b    $3F, $04, $02, $2C, $2C, $03, $01, $2C, $2A, $1A, $6F, $70, $70, $70, $1E, $A1
                dc.b    $02, $E0, $E0, $41, $E7, $90, $91, $80, $84, $12, $13, $10, $01, $03, $01, $13
                dc.b    $10, $11, $12, $13, $21, $01, $2D, $03, $07, $2D, $00, $28, $2B, $29, $2B, $01
                dc.b    $07, $05, $03, $2B, $29, $2B, $19, $03, $02, $33, $2D, $03, $0A, $1D, $4D, $4E
                dc.b    $4D, $7E, $62, $7A, $78, $0F, $02, $02, $07, $77, $1A, $07, $35, $36, $37, $33
                dc.b    $2A, $1A, $73, $74, $74, $75, $05, $74, $74, $02, $E6, $91, $90, $E1, $90, $85
                dc.b    $85, $80, $17, $14, $01, $03, $01, $17, $14, $15, $16, $17, $21, $01, $2C, $03
                dc.b    $01, $2C, $16, $01, $2C, $03, $01, $2C, $03, $0F, $40, $46, $47, $39, $03, $6A
                dc.b    $7F, $00, $79, $64, $71, $39, $3A, $48, $49, $29, $1B, $7C, $78, $79, $7A, $07
                dc.b    $0E, $79, $7A, $06, $E7, $90, $91, $EA, $91, $88, $88, $8D, $1B, $18, $01, $03
                dc.b    $01, $1B, $18, $19, $1A, $1B, $21, $01, $2D, $03, $01, $2D, $16, $01, $2D, $03
                dc.b    $01, $2D, $03, $0F, $42, $3A, $39, $3A, $79, $17, $7B, $00, $02, $17, $79, $3A
                dc.b    $39, $3A, $3B, $29, $1B, $83, $7E, $7F, $80, $02, $FC, $7F, $80, $05, $12, $91
                dc.b    $90, $1C, $90, $8D, $8D, $86, $1F, $1C, $01, $03, $01, $1F, $1C, $1D, $1E, $1F
                dc.b    $21, $01, $2C, $03, $01, $2C, $16, $01, $2C, $03, $01, $2C, $03, $0F, $44, $3E
                dc.b    $3D, $3E, $7B, $12, $79, $00, $02, $12, $7B, $3E, $3D, $3E, $3F, $29, $1B, $85
                dc.b    $86, $87, $88, $0C, $0C, $0C, $88, $13, $11, $17, $9D, $04, $04, $80, $80, $80
                dc.b    $80, $1C, $01, $03, $01, $1F, $1C, $1D, $1E, $1F, $11, $04, $01, $01, $01, $01
                dc.b    $0B, $06, $4C, $4A, $4C, $4F, $00, $05, $16, $01, $07, $03, $01, $07, $08, $01
                dc.b    $05, $03, $06, $05, $64, $4F, $4C, $4F, $28, $2B, $04, $53, $53, $53, $53, $11
                dc.b    $04, $F0, $F0, $F0, $F0, $08, $04, $A2, $A2, $A2, $A2, $84, $24, $00, $15, $69
                dc.b    $0A, $00, $15, $00, $97, $00, $14, $20, $97, $20, $01, $04, $38, $41, $00, $41
                dc.b    $01, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $16, $00
                dc.b    $16, $00, $10, $00, $10, $00, $34, $00, $34, $00, $10, $00, $10, $00, $12, $00
                dc.b    $12, $00, $10, $00, $10, $00, $16, $00, $16, $00, $10, $00, $10, $00, $32, $00
                dc.b    $22, $00, $10, $00, $30, $03, $29, $20, $00, $30, $00, $10, $00, $10, $00, $1E
                dc.b    $00, $01, $00, $11, $00, $2F, $00, $01, $00, $01, $00, $11, $00, $11, $00, $01
                dc.b    $00, $01, $00, $11, $00, $F7, $00, $11, $00, $01, $00, $11, $60, $A3, $60, $67
                dc.b    $05, $33, $50, $00, $72, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
                dc.b    $10, $00, $32, $00, $32, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
                dc.b    $10, $00, $72, $00, $72, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00
                dc.b    $10, $00, $02, $00, $32, $03, $37, $10, $00, $32, $00, $12, $00, $10, $00, $10
                dc.b    $00, $56, $00, $56, $00, $10, $00, $10, $00, $12, $00, $46, $00, $10, $00, $44
                dc.b    $00, $72, $00, $72, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10
                dc.b    $00, $32, $00, $32, $00, $10, $00, $10, $00, $12, $00, $06, $00, $10, $03, $03
                dc.b    $26, $00, $38, $03, $15, $10, $00, $37, $00, $3B, $00, $10, $00, $10, $00, $71
                dc.b    $08, $76, $00, $10, $00, $10, $00, $4C, $00, $4C, $04, $80, $B4, $60, $9D, $60
                dc.b    $4D, $00, $10, $00, $C0, $00, $17, $00, $17, $00, $10, $00, $10, $00, $11, $00
                dc.b    $11, $00, $10, $00, $10, $00, $13, $00, $13, $00, $10, $00, $E5, $08, $01, $00
                dc.b    $E4, $00, $0A, $00, $1B, $08, $1A, $08, $0B, $00, $1B, $00, $0A, $08, $0D, $08
                dc.b    $0D, $08, $03, $00, $0A, $00, $02, $08, $0B, $00, $0A, $08, $03, $08, $05, $00
                dc.b    $0C, $00, $91, $00, $0C, $08, $90, $08, $0D, $00, $0C, $00, $91, $00, $0C, $08
                dc.b    $DD, $00, $0C, $00, $48, $00, $41, $00, $05, $00, $48, $00, $0C, $00, $03, $00
                dc.b    $36, $00, $01, $00, $04, $00, $3D, $00, $38, $00, $04, $00, $01, $00, $04, $08
                dc.b    $3C, $00, $04, $00, $04, $08, $05, $08, $05, $00, $04, $00, $04, $08, $64, $00
                dc.b    $04, $00, $11, $08, $71, $00, $70, $08, $10, $08, $71, $00, $11, $08, $13, $08
                dc.b    $13, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $51, $00
                dc.b    $50, $00, $E5, $00, $10, $00, $30, $00, $15, $00, $C0, $00, $10, $61, $DB, $69
                dc.b    $DB, $0C, $06, $61, $EC, $01, $56, $00, $04, $02, $0E, $08, $05, $00, $5C, $00
                dc.b    $04, $00, $10, $08, $05, $00, $4C, $08, $71, $03, $0D, $12, $00, $5C, $00, $10
                dc.b    $00, $10, $08, $84, $00, $4C, $00, $C0, $03, $0D, $17, $00, $5C, $00, $10, $00
                dc.b    $10, $00, $11, $00, $4C, $00, $10, $03, $0D, $13, $00, $5C, $00, $10, $00, $10
                dc.b    $00, $11, $00, $4C, $00, $1B, $03, $0D, $0C, $00, $5C, $00, $0A, $00, $10, $00
                dc.b    $04, $00, $4C, $00, $0C, $03, $0B, $41, $00, $5C, $00, $48, $00, $10, $68, $85
                dc.b    $68, $F6, $03, $0D, $04, $00, $5C, $08, $05, $00, $10, $00, $04, $00, $4C, $08
                dc.b    $05, $02, $0E, $08, $71, $00, $5C, $00, $12, $00, $10, $00, $10, $00, $4C, $08
                dc.b    $84, $03, $0D, $C0, $00, $5C, $00, $17, $00, $10, $00, $10, $00, $4C, $00, $11
                dc.b    $03, $0D, $10, $00, $5C, $00, $13, $00, $10, $00, $10, $00, $4C, $00, $11, $03
                dc.b    $0D, $1B, $00, $5C, $00, $0C, $00, $10, $00, $0A, $00, $4C, $00, $04, $03, $0D
                dc.b    $0C, $00, $5C, $00, $41, $00, $10, $00, $48, $09, $1A, $69, $D3, $7C, $03, $20
                dc.b    $00, $20, $05, $03, $20, $00, $20, $80, $F5, $03, $20, $00, $20, $05, $03, $20
                dc.b    $00, $20, $80, $F5, $03, $20, $00, $20, $05, $03, $20, $00, $20, $80, $F5, $03
                dc.b    $20, $00, $20, $05, $03, $20, $00, $20, $80, $F5, $03, $20, $00, $20, $05, $03
                dc.b    $20, $00, $20, $82, $8D, $06, $0E, $0F, $12, $13, $18, $18, $02, $02, $18, $18
                dc.b    $02, $02, $18, $18, $02, $02, $18, $18, $02, $02, $18, $18, $02, $02, $18, $18
                dc.b    $02, $02, $18, $18, $02, $08, $18, $18, $2A, $57, $23, $23, $15, $68, $0E, $2F
                dc.b    $21, $2B, $26, $26, $07, $00, $02, $00, $0C, $0C, $03, $01, $00, $02, $00, $0C
                dc.b    $0C, $03, $01, $00, $02, $00, $0C, $0C, $03, $01, $00, $02, $00, $0C, $0C, $03
                dc.b    $01, $00, $02, $00, $0C, $0C, $03, $01, $00, $02, $00, $0B, $07, $09, $0A, $32
                dc.b    $06, $10, $11, $14, $15, $08, $08, $02, $02, $08, $08, $02, $02, $08, $08, $02
                dc.b    $02, $08, $08, $02, $02, $08, $08, $02, $02, $08, $08, $02, $02, $08, $08, $02
                dc.b    $08, $08, $08, $2D, $50, $3F, $3F, $16, $6B, $0E, $2F, $23, $26, $2E, $2C, $0F
                dc.b    $00, $08, $08, $0B, $09, $0B, $09, $00, $08, $08, $0B, $09, $0B, $09, $00, $08
                dc.b    $08, $0B, $09, $0B, $09, $00, $08, $08, $0B, $09, $0B, $09, $00, $08, $08, $0B
                dc.b    $09, $0B, $09, $00, $08, $08, $03, $08, $09, $0A, $32, $28, $12, $13, $0E, $0F
                dc.b    $08, $08, $18, $18, $08, $08, $18, $18, $08, $08, $18, $18, $08, $08, $18, $18
                dc.b    $08, $08, $18, $18, $08, $08, $18, $18, $08, $08, $18, $18, $08, $08, $2C, $51
                dc.b    $23, $23, $0B, $76, $0E, $2F, $3D, $37, $35, $35, $0A, $00, $0D, $0F, $01, $03
                dc.b    $0C, $0C, $00, $0D, $0F, $01, $03, $0C, $0C, $00, $0D, $0F, $01, $03, $0C, $0C
                dc.b    $00, $0D, $0F, $01, $03, $0C, $0C, $00, $0D, $0F, $01, $03, $0C, $0C, $00, $0D
                dc.b    $0F, $06, $07, $09, $0A, $32, $28, $14, $15, $10, $11, $08, $08, $08, $08, $08
                dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
                dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $23, $5E, $27, $27, $08, $75, $0E
                dc.b    $05, $3F, $3A, $3A, $38, $07, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01
                dc.b    $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04
                dc.b    $03, $01, $03, $01, $03, $04, $0B, $08, $09, $0A, $32, $28, $16, $17, $0D, $0D
                dc.b    $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A
                dc.b    $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $1B, $1A, $2A, $5F
                dc.b    $23, $37, $09, $68, $0E, $05, $39, $27, $3C, $2A, $07, $03, $04, $0C, $0E, $03
                dc.b    $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C
                dc.b    $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0B, $07, $09, $0A, $32
                dc.b    $28, $18, $19, $0E, $0F, $0E, $0E, $16, $16, $0E, $0E, $16, $16, $0E, $0E, $16
                dc.b    $16, $0E, $0E, $16, $16, $0E, $0E, $16, $16, $0E, $0E, $16, $16, $0E, $0E, $16
                dc.b    $16, $0E, $0E, $25, $50, $39, $38, $1C, $68, $0E, $05, $2D, $29, $28, $2B, $07
                dc.b    $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01
                dc.b    $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04
                dc.b    $0B, $08, $09, $0A, $32, $28, $1A, $1B, $10, $11, $02, $02, $1E, $1E, $02, $02
                dc.b    $1E, $1E, $02, $02, $1E, $1E, $02, $02, $1E, $1E, $02, $02, $1E, $1E, $02, $02
                dc.b    $1E, $1E, $02, $02, $1E, $1E, $02, $02, $30, $45, $38, $39, $1C, $68, $0E, $05
                dc.b    $2E, $25, $2B, $28, $07, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03
                dc.b    $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C
                dc.b    $0E, $03, $01, $03, $04, $0B, $07, $09, $0A, $32, $28, $1C, $1D, $12, $13, $0E
                dc.b    $0E, $02, $02, $0E, $0E, $02, $02, $0E, $0E, $02, $02, $0E, $0E, $02, $02, $0E
                dc.b    $0E, $02, $02, $0E, $0E, $02, $02, $0E, $0E, $02, $02, $0E, $0E, $2F, $5A, $3F
                dc.b    $29, $1C, $7F, $0E, $05, $2F, $3C, $2A, $3E, $07, $03, $04, $03, $01, $03, $01
                dc.b    $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01
                dc.b    $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $0B, $08, $09, $0A, $32, $28
                dc.b    $0D, $0D, $14, $15, $19, $18, $06, $06, $19, $18, $06, $06, $19, $18, $06, $06
                dc.b    $19, $18, $06, $06, $19, $18, $06, $06, $19, $18, $06, $06, $19, $18, $06, $06
                dc.b    $19, $18, $52, $5F, $28, $29, $65, $68, $0E, $05, $29, $23, $2C, $2E, $07, $03
                dc.b    $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03
                dc.b    $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0B
                dc.b    $07, $09, $0A, $32, $28, $0E, $0F, $0D, $0D, $14, $14, $19, $18, $14, $14, $19
                dc.b    $18, $14, $14, $19, $18, $14, $14, $19, $18, $14, $14, $19, $18, $14, $14, $19
                dc.b    $18, $14, $14, $19, $18, $14, $14, $55, $58, $29, $29, $66, $6B, $0E, $05, $2B
                dc.b    $2E, $2E, $2C, $07, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01
                dc.b    $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01
                dc.b    $03, $01, $03, $04, $0B, $08, $09, $0A, $32, $28, $10, $11, $1A, $1B, $0C, $0C
                dc.b    $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C
                dc.b    $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $0C, $54, $59, $39, $39
                dc.b    $6B, $66, $0E, $05, $25, $2F, $20, $22, $07, $03, $04, $0C, $0E, $03, $01, $03
                dc.b    $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0C, $0E, $03
                dc.b    $01, $03, $04, $0C, $0E, $03, $01, $03, $04, $0B, $07, $09, $0A, $32, $28, $12
                dc.b    $13, $1C, $1D, $1F, $1E, $04, $04, $1F, $1E, $04, $04, $1F, $1E, $04, $04, $1F
                dc.b    $1E, $04, $04, $1F, $1E, $04, $04, $1F, $1E, $04, $04, $1F, $1E, $04, $04, $1F
                dc.b    $1E, $5B, $56, $39, $39, $68, $65, $0E, $05, $27, $22, $22, $20, $07, $03, $04
                dc.b    $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01
                dc.b    $03, $04, $03, $01, $03, $01, $03, $04, $03, $01, $03, $01, $03, $04, $0B, $08
                dc.b    $09, $0A, $84, $E9, $00, $0D, $00, $00    
DEz_2_Rings_Layout:   ; loc_048DB2:               
        dc.w    $FFFF   
;=============================================================================== 
; Level Rings Layout
; 
;===============================================================================                                
Unknow_Data_0x048DB4: ; loc_048DB4:
   rts
Rock_Splashing: ; loc_04B76C: 
        incbin  'data\sprites\rockspsh.dat'                
Unknow_Palett_0x04BAAC: ; loc_04BAAC:
        dc.w    $0000, $0A20, $0666, $0888, $0CAA, $0ECC, $0246, $0008
        dc.w    $000E, $046A, $068C, $08CE, $0E22, $0E62, $0000, $0EEE
        dc.w    $0000, $0242, $0462, $0220, $0244, $0464, $0468, $068A
        dc.w    $08CC, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE
        dc.w    $0000, $0620, $0C20, $0E42, $0E66, $0A0E, $0A0E, $0A0E
        dc.w    $0A0E, $0006, $000E, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $06CE, $02AE, $026C, $0248, $0CCE, $006E, $004E
        dc.w    $088E, $066C, $044A, $0028, $0004, $0060, $0000, $0CEE
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0C00, $0000, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $0000, $0000, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0200, $0422, $0666, $0224, $0226, $0446, $0046
        dc.w    $0048, $0400, $0888, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0200, $0644, $0888, $0428, $0448, $064A, $006A
        dc.w    $008A, $0800, $0AAA, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0422, $0866, $0AAA, $042A, $064C, $0A6C, $006C
        dc.w    $00CC, $0A00, $0CCC, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0644, $0A88, $0CCC, $062C, $084E, $0C8E, $008E
        dc.w    $00EE, $0C00, $0EEE, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0848, $0C8C, $0EAE, $0A0E, $0C2E, $0C6E, $086E
        dc.w    $0A8E, $0404, $0ECE, $0282, $02C2, $04E2, $0000, $0EEE
        dc.w    $0000, $0020, $0242, $0020, $0222, $0242, $0244, $0266
        dc.w    $0488, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE
        dc.w    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        dc.w    $0000, $00EE, $000A, $024C, $006E, $00AE, $0000, $0EEE
Unknow_Data_0x04BC4C: ; loc_04BC4C:
        dc.b    $20, $00, $00, $20, $14, $CC, $BB, $BB, $BB, $77, $07, $12, $10, $11, $07, $63
        dc.b    $30, $30, $10, $76, $30, $03, $01, $00, $10, $02, $04, $07, $70, $00, $30, $03
        dc.b    $46, $30, $10, $07, $52, $11, $10, $77, $00, $21, $21, $22, $00, $02, $32, $11
        dc.b    $00, $11, $21, $02, $00, $10, $21, $12, $00, $33, $31, $01, $00, $11, $22, $22
        dc.b    $07, $77, $77, $77, $77, $77, $77, $77, $21, $22, $12, $10, $32, $00, $30, $30
        dc.b    $22, $10, $30, $00, $23, $21, $00, $30, $30, $31, $33, $00, $22, $22, $21, $10
        dc.b    $77, $77, $77, $77, $07, $77, $77, $02, $0B, $21, $70, $77, $00, $06, $70, $11
        dc.b    $00, $57, $01, $03, $02, $04, $10, $30, $07, $70, $04, $01, $03, $02, $09, $01
        dc.b    $03, $00, $76, $10, $33, $00, $10, $33, $02, $01, $33, $02, $01, $01, $03, $01
        dc.b    $11, $03, $01, $01, $02, $02, $01, $10, $02, $02, $01, $10, $02, $0A, $01, $10
        dc.b    $00, $11, $10, $10, $11, $00, $0D, $0D, $02, $02, $d0, $d0, $02, $09, $d0, $00
        dc.b    $10, $0D, $DD, $00, $10, $0D, $0D, $06, $02, $0D, $d0, $02, $07, $0D, $0D, $DD
        dc.b    $DD, $DD, $DD, $DD, $18, $13, $99, $96, $77, $77, $0F, $F1, $33, $33, $07, $10
        dc.b    $00, $44, $00, $03, $04, $00, $07, $00, $40, $07, $01, $04, $05, $08, $D2, $30
        dc.b    $40, $44, $44, $44, $40, $33, $02, $02, $04, $30, $02, $26, $04, $00, $04, $40
        dc.b    $03, $DE, $43, $30, $7E, $FE, $30, $74, $EF, $13, $03, $43, $00, $30, $ED, $D8
        dc.b    $69, $88, $06, $63, $22, $11, $03, $21, $0D, $d0, $01, $0D, $d0, $d0, $00, $D0
        dc.b    $0D, $10, $03, $01, $1D, $02, $02, $DD, $0D, $02, $20, $d0, $d0, $40, $DD, $DD
        dc.b    $d0, $0D, $DD, $d0, $01, $d0, $00, $0D, $01, $DD, $00, $0D, $01, $DD, $0D, $d1
        dc.b    $45, $00, $d0, $15, $49, $0D, $01, $54, $d0, $d0, $10, $02, $3E, $44, $53, $62
        dc.b    $CC, $06, $63, $22, $1C, $00, $31, $DD, $DD, $60, $1D, $00, $d0, $66, $20, $0D
        dc.b    $10, $DE, $6C, $00, $1D, $47, $E5, $DD, $0D, $40, $00, $d0, $d0, $9D, $A4, $DD
        dc.b    $d0, $0D, $DD, $d0, $01, $d0, $00, $0D, $01, $DD, $00, $0D, $01, $DD, $0D, $d1
        dc.b    $45, $00, $d0, $15, $49, $0D, $01, $54, $d0, $d0, $10, $02, $0B, $44, $5A, $EA
        dc.b    $77, $0F, $F1, $33, $77, $07, $13, $04, $02, $04, $13, $40, $00, $08, $03, $03
        dc.b    $DE, $F1, $70, $02, $01, $FF, $02, $0C, $30, $00, $04, $00, $33, $2D, $30, $44
        dc.b    $44, $44, $40, $33, $02, $02, $04, $30, $02, $18, $04, $00, $04, $40, $03, $DE
        dc.b    $43, $30, $7E, $FE, $30, $74, $EF, $13, $03, $43, $00, $30, $B9, $47, $96, $44
        dc.b    $00, $0D, $03, $1E, $DD, $d0, $00, $01, $1C, $1C, $CC, $33, $33, $33, $33, $03
        dc.b    $2F, $FF, $6F, $31, $DD, $09, $49, $00, $d4, $94, $d0, $01, $26, $63, $97, $00
        dc.b    $30, $10, $02, $02, $30, $10, $03, $56, $17, $70, $03, $01, $00, $10, $30, $10
        dc.b    $76, $00, $11, $07, $71, $10, $77, $70, $77, $77, $07, $77, $77, $77, $00, $21
        dc.b    $21, $12, $00, $31, $33, $13, $00, $11, $33, $13, $00, $20, $02, $33, $00, $33
        dc.b    $32, $33, $00, $12, $11, $12, $07, $77, $77, $77, $77, $77, $77, $77, $12, $12
        dc.b    $11, $20, $31, $33, $32, $30, $32, $13, $32, $30, $33, $21, $30, $30, $33, $33
        dc.b    $33, $00, $11, $20, $12, $10, $77, $77, $77, $77, $07, $76, $65, $55, $06, $01
        dc.b    $03, $02, $0E, $01, $10, $33, $07, $77, $01, $11, $06, $55, $33, $33, $01, $33
        dc.b    $11, $02, $01, $03, $02, $02, $52, $30, $05, $01, $10, $03, $2F, $11, $33, $33
        dc.b    $00, $10, $11, $11, $22, $23, $22, $02, $23, $32, $10, $00, $01, $00, $d1, $03
        dc.b    $00, $10, $d0, $32, $CC, $CD, $00, $0D, $d0, $d0, $00, $0D, $DD, $d0, $11, $11
        dc.b    $C1, $CC, $33, $33, $33, $33, $22, $FF, $FF, $F0, $00, $DD, $03, $01, $DD, $02
        dc.b    $01, $DD, $02, $01, $0F, $08, $18, $CC, $CC, $CC, $CC, $33, $33, $33, $33, $03
        dc.b    $2F, $FF, $6F, $31, $DD, $09, $49, $00, $C4, $E4, $d0, $5B, $BD, $E9, $49, $02
        dc.b    $02, $04, $40, $03, $01, $04, $02, $36, $40, $04, $00, $03, $04, $00, $07, $10
        dc.b    $00, $44, $08, $76, $53, $33, $00, $88, $8E, $EE, $99, $DD, $0F, $EE, $44, $40
        dc.b    $EF, $10, $33, $74, $7D, $FE, $30, $34, $04, $9E, $47, $40, $44, $07, $40, $04
        dc.b    $44, $04, $37, $77, $77, $73, $EE, $EE, $EE, $EE, $04, $99, $99, $44, $02, $01
        dc.b    $0D, $02, $03, $d0, $00, $12, $02, $80, $82, $0D, $13, $01, $0D, $00, $DC, $03
        dc.b    $10, $DD, $00, $06, $32, $11, $CC, $00, $66, $55, $55, $94, $45, $04, $94, $DD
        dc.b    $01, $54, $C1, $1D, $d0, $15, $55, $1D, $0D, $d1, $55, $d0, $00, $0D, $11, $00
        dc.b    $0D, $DD, $10, $CC, $C1, $11, $01, $55, $55, $55, $55, $EE, $F0, $99, $44, $11
        dc.b    $F5, $0D, $00, $FF, $6C, $00, $12, $66, $20, $0D, $13, $00, $0D, $00, $DC, $60
        dc.b    $10, $DD, $00, $06, $32, $11, $CC, $00, $66, $55, $55, $94, $45, $04, $94, $DD
        dc.b    $01, $54, $C1, $1D, $d0, $15, $55, $1D, $0D, $d1, $55, $d0, $00, $0D, $11, $00
        dc.b    $0D, $DD, $10, $CC, $C1, $11, $01, $55, $55, $55, $55, $EF, $F0, $ED, $99, $10
        dc.b    $FE, $34, $00, $FF, $E3, $40, $04, $0F, $03, $40, $04, $02, $32, $04, $00, $07
        dc.b    $10, $30, $44, $08, $71, $03, $33, $00, $8F, $EE, $EE, $99, $DD, $0F, $EE, $44
        dc.b    $40, $EF, $10, $33, $74, $7D, $FE, $30, $34, $04, $9E, $47, $40, $44, $07, $40
        dc.b    $04, $44, $04, $37, $77, $77, $73, $EE, $EE, $EE, $EE, $07, $76, $65, $55, $06
        dc.b    $01, $03, $02, $0D, $01, $10, $33, $07, $77, $01, $11, $06, $55, $22, $22, $01
        dc.b    $33, $03, $01, $03, $02, $04, $52, $30, $00, $11, $03, $01, $10, $03, $0D, $11
        dc.b    $33, $33, $00, $10, $11, $11, $22, $23, $22, $22, $22, $32, $02, $01, $01, $03
        dc.b    $1C, $10, $00, $11, $11, $DD, $DD, $00, $0D, $d0, $d0, $00, $0D, $DD, $d0, $11
        dc.b    $11, $C1, $CC, $33, $33, $33, $33, $12, $FF, $FF, $FF, $00, $DD, $03, $01, $DD
        dc.b    $02, $01, $ED, $0B, $0C, $CC, $CC, $CC, $CC, $33, $33, $33, $33, $FF, $FF, $FF
        dc.b    $FF, $08, $06, $9E, $FC, $CC, $CC, $00, $03, $07, $01, $03, $07, $01, $03, $07
        dc.b    $01, $03, $02, $07, $52, $31, $01, $11, $00, $01, $10, $03, $02, $11, $11, $02
        dc.b    $0A, $22, $22, $00, $02, $22, $3E, $01, $22, $01, $0D, $02, $2A, $01, $00, $10
        dc.b    $00, $01, $00, $31, $31, $CD, $DD, $00, $0D, $d0, $d0, $00, $1C, $1C, $0D, $02
        dc.b    $22, $33, $10, $3E, $EE, $F3, $31, $0D, $DD, $0C, $33, $00, $DD, $d0, $C0, $00
        dc.b    $0D, $d0, $00, $DD, $0D, $00, $0F, $04, $01, $0D, $03, $01, $DD, $03, $0B, $0D
        dc.b    $00, $d0, $00, $1D, $d0, $d0, $00, $0D, $DD, $0D, $02, $15, $DD, $DD, $00, $23
        dc.b    $3E, $3E, $EE, $21, $22, $12, $10, $32, $00, $30, $37, $22, $10, $30, $54, $23
        dc.b    $21, $02, $3F, $30, $31, $33, $04, $22, $22, $21, $05, $77, $77, $77, $00, $77
        dc.b    $77, $70, $63, $21, $22, $10, $06, $32, $00, $30, $66, $22, $10, $55, $46, $23
        dc.b    $21, $0C, $d5, $30, $31, $0C, $C5, $22, $22, $75, $55, $77, $77, $70, $5C, $00
        dc.b    $0F, $EE, $B7, $08, $F1, $03, $33, $00, $10, $30, $44, $00, $03, $04, $00, $07
        dc.b    $00, $40, $07, $01, $04, $05, $07, $D2, $30, $40, $44, $44, $44, $40, $02, $05
        dc.b    $04, $04, $44, $04, $04, $02, $24, $04, $40, $04, $40, $40, $40, $04, $40, $40
        dc.b    $04, $40, $44, $04, $44, $04, $04, $9D, $BF, $BB, $8C, $06, $03, $22, $11, $03
        dc.b    $21, $0D, $d0, $01, $0D, $d0, $d0, $00, $d0, $0D, $10, $03, $01, $1D, $02, $02
        dc.b    $DD, $0D, $02, $68, $d0, $d0, $40, $DD, $DD, $d0, $0D, $d0, $0D, $d1, $d0, $D0
        dc.b    $0D, $0C, $DD, $DD, $00, $DC, $DD, $0D, $0D, $DC, $00, $d1, $0D, $00, $0D, $11
        dc.b    $1D, $0D, $d0, $0D, $C0, $d1, $99, $84, $44, $98, $44, $00, $04, $44, $40, $44
        dc.b    $04, $44, $34, $40, $44, $00, $30, $44, $40, $40, $44, $00, $44, $04, $04, $40
        dc.b    $44, $40, $40, $40, $00, $40, $99, $D9, $9D, $DD, $DD, $d0, $0D, $DD, $DD, $0D
        dc.b    $DD, $d0, $0D, $00, $0D, $DD, $1D, $0D, $DC, $0D, $1D, $d0, $11, $d0, $DD, $01
        dc.b    $CD, $d0, $d0, $1C, $00, $DC, $44, $95, $55, $89, $77, $BC, $02, $0A, $11, $07
        dc.b    $C0, $00, $30, $10, $7C, $00, $03, $01, $04, $04, $07, $C0, $00, $30, $03, $09
        dc.b    $30, $10, $0C, $25, $10, $6B, $CC, $00, $10, $07, $01, $01, $03, $13, $10, $0C
        dc.b    $CC, $00, $77, $76, $66, $00, $76, $10, $00, $70, $76, $66, $66, $CC, $CC, $CC
        dc.b    $CC, $0C, $08, $CC, $CC, $CC, $CC, $66, $66, $66, $66, $04, $08, $66, $66, $66
        dc.b    $66, $CC, $CC, $CC, $CC, $0C, $08, $CC, $CC, $CC, $CC, $06, $66, $66, $66, $04
        dc.b    $08, $06, $66, $66, $66, $07, $66, $55, $55, $09, $0E, $11, $23, $33, $07, $77
        dc.b    $01, $11, $06, $55, $33, $33, $01, $33, $11, $02, $01, $03, $02, $02, $53, $10
        dc.b    $02, $22, $10, $00, $01, $00, $01, $00, $01, $00, $20, $00, $01, $00, $12, $00
        dc.b    $01, $00, $22, $00, $01, $00, $10, $00, $01, $00, $d1, $03, $00, $10, $d0, $3F
        dc.b    $CC, $C2, $00, $d0, $03, $01, $0D, $02, $02, $0D, $DD, $02, $02, $0D, $0D, $03
        dc.b    $01, $DD, $03, $01, $DD, $03, $01, $DD, $02, $01, $10, $02, $03, $0F, $00, $0D
        dc.b    $03, $11, $DD, $d0, $00, $01, $1C, $1C, $CC, $33, $33, $33, $33, $03, $2F, $FF
        dc.b    $FF, $31, $DD, $03, $47, $DD, $d0, $00, $53, $3E, $3E, $E9, $00, $21, $21, $25
        dc.b    $00, $02, $32, $11, $00, $11, $21, $02, $00, $10, $21, $12, $00, $33, $31, $04
        dc.b    $00, $11, $22, $56, $07, $77, $77, $03, $07, $77, $77, $0C, $00, $21, $21, $0F
        dc.b    $00, $02, $32, $46, $00, $11, $21, $06, $00, $10, $21, $12, $00, $33, $31, $01
        dc.b    $00, $11, $22, $22, $07, $77, $77, $77, $0F, $ED, $9D, $D9, $02, $02, $04, $40
        dc.b    $03, $01, $04, $02, $36, $40, $04, $00, $03, $04, $00, $07, $10, $00, $44, $08
        dc.b    $76, $53, $33, $00, $88, $8E, $EE, $99, $D9, $D9, $99, $40, $44, $30, $44, $04
        dc.b    $04, $74, $03, $00, $44, $04, $43, $44, $40, $44, $04, $40, $04, $44, $04, $37
        dc.b    $77, $77, $73, $EE, $EE, $EE, $EE, $04, $99, $49, $44, $02, $01, $DD, $02, $03
        dc.b    $d0, $00, $12, $02, $3E, $0D, $13, $01, $0D, $00, $DC, $03, $10, $DD, $00, $06
        dc.b    $32, $11, $CC, $00, $66, $55, $55, $94, $45, $99, $99, $DD, $01, $CD, $d0, $1D
        dc.b    $d0, $11, $d0, $1D, $0D, $DC, $0D, $0D, $00, $0D, $DD, $DD, $0D, $DD, $d0, $CC
        dc.b    $C1, $1C, $CC, $55, $55, $55, $55, $99, $99, $99, $9D, $04, $40, $04, $04, $04
        dc.b    $40, $04, $40, $02, $36, $40, $40, $44, $40, $40, $00, $04, $40, $44, $44, $37
        dc.b    $77, $33, $33, $EE, $EE, $EE, $EE, $94, $54, $59, $94, $0D, $11, $1D, $0D, $00
        dc.b    $d1, $0D, $00, $DD, $0D, $0D, $DC, $DD, $DD, $00, $DC, $d0, $d0, $0D, $0C, $1C
        dc.b    $C1, $1C, $C0, $55, $55, $55, $55, $07, $66, $55, $54, $04, $7E, $47, $10, $33
        dc.b    $01, $20, $76, $10, $32, $69, $46, $76, $67, $90, $d3, $06, $54, $d0, $C5, $52
        dc.b    $CD, $0C, $54, $CD, $00, $0C, $72, $CC, $DD, $00, $11, $55, $44, $1F, $67, $65
        dc.b    $99, $56, $65, $FC, $00, $76, $63, $CD, $DD, $33, $66, $31, $12, $DC, $26, $63
        dc.b    $30, $00, $D2, $60, $32, $d0, $DD, $FF, $12, $49, $4F, $DD, $10, $45, $66, $42
        dc.b    $36, $d1, $36, $66, $66, $C1, $30, $60, $06, $35, $62, $99, $94, $65, $9D, $00
        dc.b    $0D, $9C, $0D, $DD, $DD, $CF, $92, $0D, $d4, $36, $63, $d0, $d0, $66, $3C, $00
        dc.b    $10, $63, $10, $0D, $26, $03, $1D, $d1, $70, $66, $31, $13, $03, $94, $65, $36
        dc.b    $60, $0D, $46, $66, $31, $9E, $23, $53, $10, $00, $03, $02, $0C, $01, $33, $11
        dc.b    $00, $06, $55, $33, $33, $07, $76, $11, $11, $03, $01, $33, $02, $01, $03, $05
        dc.b    $18, $93, $00, $30, $01, $d1, $03, $00, $10, $10, $00, $01, $00, $22, $02, $23
        dc.b    $32, $11, $11, $22, $23, $33, $33, $00, $10, $03, $01, $11, $03, $07, $10, $11
        dc.b    $CC, $CC, $D2, $00, $DD, $03, $01, $DD, $02, $17, $22, $FF, $FF, $F0, $33, $33
        dc.b    $33, $33, $11, $11, $C1, $CC, $00, $0D, $DD, $d0, $00, $0D, $d0, $d0, $10, $0D
        dc.b    $d0, $02, $05, $DD, $d0, $00, $31, $DD, $02, $0C, $03, $2F, $FF, $FF, $33, $33
        dc.b    $33, $33, $CC, $CC, $CC, $CC, $08, $46, $9E, $EE, $EE, $EE, $00, $21, $21, $22
        dc.b    $00, $02, $32, $11, $47, $31, $21, $02, $00, $10, $21, $12, $40, $03, $31, $01
        dc.b    $50, $01, $22, $22, $00, $77, $77, $77, $36, $07, $77, $77, $60, $01, $21, $22
        dc.b    $66, $01, $32, $11, $64, $57, $21, $02, $5D, $C0, $21, $12, $5C, $C0, $31, $01
        dc.b    $55, $57, $22, $22, $C5, $00, $77, $77, $92, $77, $0C, $CC, $00, $06, $0F, $01
        dc.b    $01, $03, $01, $07, $02, $02, $07, $77, $02, $04, $CC, $CB, $0C, $BB, $02, $01
        dc.b    $06, $13, $01, $06, $03, $02, $07, $77, $02, $02, $CB, $CC, $18, $08, $66, $66
        dc.b    $66, $00, $66, $66, $AD, $BC, $02, $01, $01, $04, $01, $10, $04, $08, $CC, $CC
        dc.b    $01, $00, $66, $66, $77, $10, $02, $0A, $17, $70, $66, $66, $67, $00, $CC, $CC
        dc.b    $CC, $CC, $03, $01, $06, $03, $01, $69, $03, $01, $05, $03, $01, $03, $03, $01
        dc.b    $06, $02, $02, $06, $95, $02, $02, $6D, $53, $02, $03, $6B, $A9, $60, $03, $02
        dc.b    $D9, $66, $02, $06, $06, $9C, $60, $00, $04, $53, $02, $06, $02, $CF, $60, $00
        dc.b    $D9, $66, $02, $0F, $06, $66, $60, $00, $FA, $F3, $E8, $88, $50, $CC, $24, $44
        dc.b    $06, $C5, $60, $02, $01, $50, $02, $01, $06, $03, $02, $65, $50, $02, $07, $2C
        dc.b    $C5, $67, $00, $0D, $C3, $67, $02, $0F, $1F, $56, $59, $42, $1D, $10, $30, $06
        dc.b    $52, $10, $0C, $00, $06, $36, $63, $02, $02, $60, $06, $02, $13, $07, $66, $00
        dc.b    $07, $61, $01, $07, $61, $00, $07, $93, $30, $66, $66, $C1, $56, $00, $06, $05
        dc.b    $03, $01, $30, $03, $01, $60, $07, $01, $06, $03, $12, $52, $44, $66, $00, $0D
        dc.b    $d1, $60, $44, $5C, $DC, $56, $00, $05, $1D, $00, $10, $00, $52, $03, $1D, $06
        dc.b    $50, $30, $00, $06, $67, $60, $65, $92, $00, $01, $63, $F0, $31, $00, $06, $12
        dc.b    $30, $50, $70, $01, $03, $00, $10, $01, $03, $00, $27, $71, $02, $14, $21, $00
        dc.b    $10, $30, $33, $67, $01, $03, $22, $17, $70, $11, $77, $77, $07, $77, $55, $55
        dc.b    $54, $54, $02, $02, $01, $10, $02, $02, $01, $10, $02, $02, $01, $10, $03, $01
        dc.b    $01, $03, $02, $11, $33, $02, $03, $01, $10, $33, $02, $07, $32, $2F, $1C, $CC
        dc.b    $00, $0D, $d0, $05, $07, $10, $0D, $0D, $00, $10, $0D, $DD, $03, $01, $d0, $03
        dc.b    $0A, $d0, $d0, $11, $00, $0D, $0D, $CC, $DD, $DD, $DD, $18, $48, $DD, $DD, $DD
        dc.b    $DD, $43, $33, $33, $33, $71, $22, $12, $10, $12, $00, $30, $30, $22, $10, $30
        dc.b    $00, $23, $21, $00, $30, $63, $31, $33, $00, $66, $22, $21, $10, $30, $77, $77
        dc.b    $77, $C0, $77, $77, $77, $F0, $12, $12, $10, $67, $30, $30, $30, $61, $10, $30
        dc.b    $00, $03, $21, $00, $30, $30, $31, $33, $00, $22, $22, $21, $10, $77, $77, $77
        dc.b    $77, $CC, $CC, $CC, $CC, $04, $01, $60, $07, $01, $C6, $02, $11, $06, $10, $00
        dc.b    $06, $99, $10, $06, $99, $25, $30, $99, $36, $DC, $96, $9F, $A9, $0F, $02, $22
        dc.b    $06, $F2, $00, $06, $6F, $24, $06, $9F, $03, $40, $99, $3F, $F1, $00, $24, $C0
        dc.b    $30, $40, $DD, $60, $00, $04, $66, $00, $31, $01, $AB, $BD, $33, $DC, $54, $44
        dc.b    $52, $CF, $02, $02, $04, $13, $03, $01, $41, $04, $02, $44, $40, $02, $0D, $12
        dc.b    $14, $00, $40, $3F, $C2, $44, $00, $96, $69, $BB, $BB, $60, $03, $01, $F6, $03
        dc.b    $01, $30, $03, $05, $0F, $60, $00, $06, $13, $02, $01, $6D, $02, $24, $06, $d1
        dc.b    $13, $00, $6D, $1C, $A9, $66, $d1, $C0, $00, $6D, $1C, $FC, $06, $91, $CF, $25
        dc.b    $69, $4C, $F2, $40, $94, $DF, $24, $44, $4D, $03, $46, $DD, $d6, $01, $6F, $00
        dc.b    $60, $01, $02, $16, $9A, $C0, $00, $06, $25, $55, $2C, $F6, $40, $04, $01, $2F
        dc.b    $00, $42, $D2, $02, $00, $0F, $0F, $24, $40, $0F, $02, $34, $d0, $42, $FF, $20
        dc.b    $00, $04, $26, $45, $F3, $33, $27, $41, $55, $49, $CD, $37, $51, $DD, $C9, $40
        dc.b    $00, $C4, $55, $50, $52, $57, $01, $C0, $66, $00, $74, $00, $F4, $07, $07, $90
        dc.b    $0D, $46, $77, $77, $99, $41, $76, $17, $77, $77, $76, $66, $00, $07, $77, $06
        dc.b    $03, $01, $77, $10, $36, $33, $32, $11, $E3, $21, $23, $0F, $0D, $65, $66, $0F
        dc.b    $CD, $04, $50, $66, $52, $74, $10, $05, $56, $00, $d0, $0C, $10, $07, $97, $0D
        dc.b    $47, $00, $70, $04, $70, $27, $71, $66, $72, $C4, $56, $60, $00, $0D, $C4, $66
        dc.b    $00, $CD, $0D, $36, $00, $31, $00, $10, $00, $63, $d0, $03, $0D, $d0, $00, $01
        dc.b    $03, $d0, $16, $60, $02, $2F, $05, $30, $00, $03, $03, $03, $03, $00, $01, $05
        dc.b    $01, $03, $0E, $0B, $4E, $13, $00, $11, $00, $21, $00, $11, $0D, $C2, $23, $02
        dc.b    $27, $DC, $21, $22, $10, $0D, $CE, $EE, $01, $00, $DD, $d0, $01, $10, $10, $0D
        dc.b    $01, $11, $10, $00, $1C, $0C, $DD, $02, $0D, $0D, $0D, $10, $11, $11, $C1, $33
        dc.b    $23, $33, $33, $00, $EF, $FF, $F2, $03, $02, $08, $0D, $20, $d0, $d0, $00, $D0
        dc.b    $0D, $d0, $02, $01, $10, $02, $02, $0F, $1D, $03, $01, $0D, $03, $01, $0D, $03
        dc.b    $02, $10, $d0, $02, $02, $0D, $d0, $0A, $09, $5F, $27, $44, $AA, $03, $04, $30
        dc.b    $00, $08, $04, $01, $31, $02, $07, $07, $80, $40, $E0, $00, $03, $03, $02, $0F
        dc.b    $78, $10, $00, $07, $70, $34, $00, $33, $DD, $61, $63, $00, $03, $40, $3C, $03
        dc.b    $01, $8B, $02, $2B, $13, $00, $0E, $04, $08, $70, $00, $30, $30, $10, $00, $01
        dc.b    $87, $10, $00, $43, $07, $77, $98, $CD, $AA, $CC, $0F, $CF, $06, $00, $CF, $C9
        dc.b    $C6, $66, $33, $35, $59, $99, $FC, $FC, $95, $55, $9C, $F0, $0C, $31, $41, $02
        dc.b    $25, $01, $DD, $F0, $00, $FC, $66, $60, $FF, $CC, $06, $60, $F0, $33, $60, $00
        dc.b    $0F, $FF, $9D, $DD, $CC, $CF, $40, $04, $55, $56, $41, $D9, $99, $99, $40, $C0
        dc.b    $FC, $C0, $DC, $C0, $FC, $3F, $02, $02, $CD, $23, $02, $16, $31, $10, $00, $0F
        dc.b    $03, $33, $F0, $0F, $FF, $FF, $69, $99, $99, $99, $66, $65, $55, $54, $FF, $FC
        dc.b    $CC, $CD, $04, $23, $CF, $00, $DC, $00, $3F, $00, $2C, $DF, $F9, $C0, $FD, $1F
        dc.b    $94, $30, $C1, $30, $01, $F0, $30, $F0, $41, $CF, $F3, $0D, $D2, $3F, $F0, $02
        dc.b    $0F, $F0, $FF, $0F, $66, $0F, $DF, $02, $19, $60, $12, $D9, $00, $0F, $31, $40
        dc.b    $66, $60, $F3, $65, $00, $0D, $FF, $FC, $F0, $C1, $00, $0F, $F0, $C3, $F0, $0F
        dc.b    $00, $0F, $02, $1C, $CC, $D9, $FD, $CC, $53, $d4, $31, $0C, $42, $C1, $33, $CF
        dc.b    $01, $33, $F0, $9F, $13, $6F, $9F, $60, $50, $6F, $90, $09, $9F, $FF, $0F, $04
        dc.b    $02, $80, $88, $0F, $FD, $33, $3E, $CA, $AA, $d0, $00, $65, $56, $2C, $C2, $01
        dc.b    $C2, $62, $56, $5D, $0D, $07, $06, $0D, $00, $07, $06, $52, $CD, $00, $67, $76
        dc.b    $52, $00, $02, $17, $76, $70, $12, $10, $07, $77, $77, $00, $07, $06, $66, $77
        dc.b    $76, $46, $03, $45, $62, $d0, $03, $11, $24, $d4, $66, $34, $40, $21, $56, $05
        dc.b    $56, $65, $56, $65, $56, $77, $77, $77, $00, $77, $77, $77, $49, $65, $05, $50
        dc.b    $00, $25, $4C, $15, $4C, $44, $d0, $d1, $55, $4D, $0D, $d1, $30, $2F, $F2, $45
        dc.b    $67, $66, $66, $76, $61, $00, $55, $16, $32, $96, $53, $67, $00, $d3, $06, $01
        dc.b    $00, $13, $00, $73, $01, $56, $07, $13, $33, $07, $62, $22, $22, $61, $31, $DD
        dc.b    $DD, $33, $1D, $d0, $00, $52, $2C, $1C, $CC, $00, $03, $08, $0A, $30, $00, $07
        dc.b    $66, $12, $22, $06, $55, $32, $33, $02, $04, $10, $11, $01, $30, $02, $0A, $53
        dc.b    $31, $11, $1C, $01, $11, $00, $0D, $00, $11, $03, $18, $01, $11, $11, $22, $22
        dc.b    $22, $22, $33, $3E, $33, $22, $11, $0D, $0D, $10, $01, $10, $0D, $d1, $1D, $1D
        dc.b    $DD, $02, $0D, $02, $1F, $d0, $00, $DD, $0D, $10, $11, $C1, $C1, $33, $22, $33
        dc.b    $33, $31, $11, $33, $22, $1D, $03, $11, $d0, $d0, $00, $0D, $DD, $d0, $3C, $00
        dc.b    $d0, $d0, $0D, $d0, $06, $07, $1D, $d0, $d0, $00, $d0, $d0, $d0, $02, $01, $0D
        dc.b    $03, $01, $0D, $06, $06, $EE, $EE, $92, $7A, $21, $22, $02, $1C, $32, $00, $73
        dc.b    $4E, $22, $10, $18, $10, $23, $21, $06, $33, $30, $31, $30, $84, $22, $22, $21
        dc.b    $71, $77, $77, $77, $7B, $3E, $B0, $77, $77, $02, $28, $11, $22, $E4, $37, $02
        dc.b    $11, $01, $81, $21, $02, $33, $63, $21, $12, $48, $03, $31, $01, $17, $11, $22
        dc.b    $22, $B7, $77, $77, $77, $70, $07, $77, $77, $00, $77, $77, $77, $00, $17, $0C
        dc.b    $CC, $00, $01, $07, $01, $10, $03, $01, $01, $02, $02, $70, $70, $02, $0C, $77
        dc.b    $70, $7B, $BB, $77, $77, $77, $77, $CC, $CC, $CC, $CC, $14, $0C, $CB, $BB, $BB
        dc.b    $BB, $07, $77, $77, $77, $CC, $CC, $CC, $CC, $14, $0B, $BB, $BB, $BC, $CC, $77
        dc.b    $77, $70, $60, $CC, $CC, $06, $0C, $01, $10, $02, $01, $01, $04, $13, $70, $BB
        dc.b    $BB, $77, $CC, $21, $22, $15, $A0, $32, $00, $30, $00, $22, $10, $30, $0C, $23
        dc.b    $21, $02, $10, $30, $31, $33, $00, $22, $22, $21, $10, $77, $77, $77, $7C, $CC
        dc.b    $CC, $CC, $C0, $1C, $0E, $11, $11, $11, $11, $06, $66, $66, $66, $05, $67, $77
        dc.b    $77, $00, $31, $03, $02, $43, $10, $02, $02, $64, $31, $02, $03, $06, $43, $10
        dc.b    $02, $0E, $64, $31, $03, $11, $17, $30, $66, $66, $66, $66, $77, $77, $76, $50
        dc.b    $02, $10, $13, $57, $00, $01, $35, $70, $00, $13, $57, $00, $01, $35, $70, $00
        dc.b    $23, $57, $02, $0E, $33, $61, $11, $11, $66, $66, $66, $66, $15, $67, $77, $77
        dc.b    $64, $31, $02, $03, $06, $43, $10, $02, $02, $64, $31, $02, $03, $06, $43, $10
        dc.b    $02, $0D, $64, $31, $11, $11, $17, $33, $66, $66, $66, $00, $77, $77, $76, $03
        dc.b    $01, $13, $02, $02, $01, $35, $02, $09, $13, $57, $00, $01, $35, $70, $00, $23
        dc.b    $57, $02, $04, $30, $70, $00, $12, $05, $01, $10, $03, $01, $31, $03, $02, $43
        dc.b    $10, $02, $02, $64, $31, $02, $03, $06, $43, $10, $02, $06, $64, $31, $12, $00
        dc.b    $06, $40, $03, $01, $73, $02, $02, $01, $35, $02, $10, $13, $57, $00, $01, $35
        dc.b    $70, $00, $13, $57, $00, $01, $35, $70, $00, $23, $57, $02, $02, $05, $70, $02
        dc.b    $01, $55, $03, $02, $10, $10, $02, $02, $64, $31, $02, $03, $06, $43, $10, $02
        dc.b    $02, $64, $31, $02, $03, $06, $43, $10, $02, $02, $64, $31, $02, $02, $06, $33
        dc.b    $06, $01, $01, $03, $01, $13, $02, $02, $01, $35, $02, $09, $13, $57, $00, $01
        dc.b    $35, $70, $00, $23, $57, $02, $81, $04, $05, $DA, $AA, $B8, $55, $03, $32, $22
        dc.b    $10, $B1, $1D, $d0, $C4, $39, $d0, $d0, $0E, $43, $4D, $DD, $00, $34, $39, $0D
        dc.b    $00, $0E, $43, $4D, $00, $d0, $E4, $34, $02, $22, $2C, $40, $22, $23, $30, $73
        dc.b    $0D, $d1, $1B, $35, $DD, $0D, $93, $5D, $01, $d4, $35, $F0, $DC, $93, $52, $00
        dc.b    $04, $35, $F0, $00, $A3, $5F, $0D, $00, $05, $78, $84, $46, $55, $0C, $C7, $76
        dc.b    $10, $17, $71, $10, $64, $3A, $13, $30, $0A, $43, $B1, $10, $C7, $d4, $39, $23
        dc.b    $00, $1C, $43, $B0, $00, $03, $F4, $38, $00, $12, $2D, $40, $71, $11, $11, $73
        dc.b    $00, $03, $3B, $35, $00, $30, $83, $52, $11, $28, $35, $FD, $32, $A3, $5C, $33
        dc.b    $18, $35, $E1, $01, $A3, $52, $12, $11, $05, $CE, $33, $10, $55, $11, $11, $11
        dc.b    $10, $BF, $F2, $30, $34, $34, $0D, $C0, $DE, $43, $4D, $F0, $33, $d4, $39, $32
        dc.b    $01, $2E, $43, $8D, $13, $1D, $E4, $34, $12, $3E, $3D, $40, $11, $11, $11, $73
        dc.b    $03, $2F, $FB, $35, $0C, $d0, $43, $52, $0F, $d4, $35, $FD, $23, $93, $5C, $33
        dc.b    $d8, $35, $F2, $10, $73, $5F, $d1, $31, $05, $C3, $E3, $26, $55, $11, $11, $17
        dc.b    $10, $B3, $30, $00, $94, $38, $03, $00, $7E, $43, $82, $11, $33, $d4, $3A, $23
        dc.b    $10, $1F, $43, $81, $11, $21, $94, $39, $76, $48, $F6, $40, $67, $7C, $C0, $73
        dc.b    $01, $17, $71, $35, $03, $31, $A3, $57, $01, $1B, $35, $B0, $32, $93, $5C, $7C
        dc.b    $0B, $35, $d1, $00, $B3, $5E, $30, $00, $30, $79, $9A, $DE, $03, $01, $44, $02
        dc.b    $02, $01, $01, $02, $09, $13, $57, $00, $01, $35, $70, $00, $13, $57, $02, $02
        dc.b    $35, $70, $02, $01, $57, $02, $02, $05, $70, $02, $01, $36, $03, $02, $43, $10
        dc.b    $02, $02, $64, $31, $02, $03, $06, $43, $10, $02, $02, $64, $31, $02, $03, $06
        dc.b    $43, $10, $02, $02, $64, $32, $02, $02, $06, $40, $03, $01, $44, $02, $02, $01
        dc.b    $01, $02, $10, $13, $57, $00, $01, $35, $70, $00, $13, $57, $00, $01, $35, $70
        dc.b    $00, $13, $57, $02, $05, $05, $70, $00, $12, $36, $03, $02, $43, $10, $02, $02
        dc.b    $64, $31, $02, $03, $06, $43, $10, $02, $02, $64, $31, $02, $02, $06, $43, $03
        dc.b    $06, $64, $00, $12, $00, $06, $70, $03, $01, $44, $02, $02, $01, $01, $02, $17
        dc.b    $13, $57, $00, $01, $35, $70, $00, $13, $57, $00, $03, $03, $61, $11, $66, $66
        dc.b    $66, $66, $60, $77, $77, $77, $36, $03, $02, $43, $10, $02, $02, $64, $31, $02
        dc.b    $03, $06, $43, $10, $02, $0F, $64, $31, $00, $11, $17, $30, $11, $66, $66, $66
        dc.b    $66, $77, $77, $77, $15, $03, $01, $44, $02, $02, $01, $01, $02, $17, $13, $57
        dc.b    $00, $01, $35, $70, $00, $13, $57, $00, $11, $03, $61, $11, $66, $66, $66, $66
        dc.b    $60, $77, $77, $65, $36, $03, $02, $43, $10, $02, $02, $64, $31, $02, $03, $06
        dc.b    $43, $10, $02, $53, $64, $31, $00, $11, $17, $30, $00, $66, $66, $66, $65, $DF
        dc.b    $2F, $22, $15, $00, $d0, $d0, $44, $00, $0D, $d4, $01, $01, $0D, $43, $52, $00
        dc.b    $09, $35, $20, $63, $93, $5F, $0D, $0B, $35, $d1, $C1, $d3, $5B, $65, $55, $05
        dc.b    $F9, $45, $46, $36, $00, $0C, $00, $43, $9D, $DD, $00, $34, $39, $d0, $10, $D3
        dc.b    $43, $90, $00, $0D, $34, $39, $36, $11, $CC, $43, $B0, $55, $56, $A4, $3E, $07
        dc.b    $65, $5E, $40, $00, $03, $01, $44, $02, $06, $08, $01, $DA, $BB, $80, $36, $04
        dc.b    $1C, $33, $33, $33, $33, $44, $44, $44, $44, $11, $11, $11, $11, $60, $2F, $FE
        dc.b    $EC, $36, $d0, $11, $00, $43, $91, $01, $00, $73, $08, $88, $8A, $04, $1C, $33
        dc.b    $33, $33, $33, $44, $44, $44, $44, $11, $11, $11, $11, $DE, $FF, $22, $15, $00
        dc.b    $0D, $d0, $44, $00, $1C, $14, $01, $B8, $88, $80, $36, $04, $1C, $33, $33, $33
        dc.b    $33, $44, $44, $44, $44, $11, $11, $11, $11, $60, $22, $FF, $ED, $36, $0D, $D0
        dc.b    $00, $43, $41, $C1, $00, $73, $08, $88, $8B, $04, $1C, $33, $33, $33, $33, $44
        dc.b    $44, $44, $44, $11, $11, $11, $11, $CE, $EF, $F8, $15, $00, $11, $07, $44, $00
        dc.b    $10, $19, $01, $A8, $88, $80, $36, $04, $16, $33, $33, $33, $33, $44, $44, $44
        dc.b    $44, $11, $11, $11, $11, $60, $FE, $ED, $CB, $36, $10, $30, $00, $43, $80, $02
        dc.b    $04, $73, $08, $BB, $AD, $04, $10, $33, $33, $33, $33, $44, $44, $44, $44, $11
        dc.b    $11, $11, $11, $65, $77, $77, $15, $03, $01, $44, $02, $06, $01, $01, $03, $11
        dc.b    $10, $36, $04, $11, $33, $33, $33, $33, $44, $44, $44, $44, $11, $11, $11, $11
        dc.b    $60, $77, $77, $77, $36, $03, $02, $43, $10, $02, $04, $73, $01, $11, $11, $04
        dc.b    $10, $33, $33, $33, $33, $44, $44, $44, $44, $11, $11, $11, $11, $77, $77, $77
        dc.b    $15, $03, $01, $44, $02, $06, $01, $01, $11, $11, $10, $36, $04, $11, $33, $33
        dc.b    $33, $33, $44, $44, $44, $44, $11, $11, $11, $11, $60, $77, $77, $65, $36, $03
        dc.b    $02, $43, $10, $02, $03, $73, $01, $11, $05, $11, $33, $33, $33, $30, $44, $44
        dc.b    $44, $44, $11, $11, $11, $11, $60, $77, $77, $77, $36, $03, $02, $43, $10, $02
        dc.b    $02, $64, $31, $02, $03, $06, $43, $10, $02, $02, $64, $31, $02, $03, $06, $43
        dc.b    $11, $02, $02, $64, $33, $02, $02, $06, $40, $03, $01, $44, $02, $02, $01, $01
        dc.b    $02, $10, $13, $57, $00, $01, $35, $70, $00, $13, $57, $00, $11, $35, $70, $00
        dc.b    $03, $57, $02, $80, $84, $D9, $CC, $CB, $BA, $00, $16, $77, $71, $00, $33, $16
        dc.b    $77, $00, $10, $23, $16, $00, $10, $21, $33, $00, $33, $31, $01, $00, $11, $22
        dc.b    $23, $07, $77, $77, $77, $66, $65, $55, $55, $11, $13, $33, $00, $77, $71, $11
        dc.b    $33, $77, $77, $77, $66, $11, $16, $77, $77, $33, $30, $11, $10, $22, $21, $11
        dc.b    $10, $77, $77, $77, $77, $55, $55, $56, $66, $00, $33, $31, $11, $33, $11, $17
        dc.b    $77, $66, $77, $77, $77, $07, $77, $61, $11, $00, $11, $03, $33, $00, $11, $12
        dc.b    $22, $07, $77, $77, $77, $77, $70, $07, $77, $07, $77, $61, $10, $77, $61, $32
        dc.b    $00, $61, $33, $32, $30, $33, $31, $30, $30, $30, $33, $33, $00, $12, $20, $12
        dc.b    $10, $77, $77, $77, $77, $E9, $33, $33, $98, $0D, $01, $A0, $02, $02, $01, $A0
        dc.b    $03, $04, $A0, $00, $A0, $07, $02, $02, $01, $01, $04, $03, $1A, $00, $0A, $02
        dc.b    $01, $A0, $02, $06, $70, $A0, $A0, $01, $11, $A0, $02, $06, $07, $00, $A0, $01
        dc.b    $11, $10, $02, $06, $10, $7A, $00, $01, $16, $6A, $0C, $01, $A0, $03, $04, $A0
        dc.b    $00, $07, $1A, $02, $02, $07, $1A, $12, $01, $01, $03, $01, $01, $2C, $05, $0A
        dc.b    $00, $DC, $CB, $AA, $05, $01, $A0, $07, $03, $0A, $00, $A0, $03, $04, $A0, $00
        dc.b    $10, $A0, $03, $01, $0A, $02, $06, $76, $67, $DD, $DD, $70, $11, $03, $09, $11
        dc.b    $10, $00, $07, $11, $10, $00, $07, $11, $02, $02, $07, $01, $02, $0A, $06, $01
        dc.b    $10, $00, $76, $01, $10, $00, $77, $01, $02, $02, $07, $01, $02, $02, $07, $01
        dc.b    $02, $02, $77, $11, $02, $07, $77, $11, $10, $00, $70, $11, $10, $02, $01, $11
        dc.b    $02, $02, $11, $10, $02, $02, $01, $10, $02, $02, $07, $11, $02, $2B, $07, $11
        dc.b    $10, $00, $07, $01, $10, $00, $07, $71, $10, $00, $07, $71, $10, $00, $06, $71
        dc.b    $10, $00, $06, $71, $10, $00, $07, $71, $10, $00, $07, $71, $10, $00, $07, $71
        dc.b    $10, $00, $07, $61, $10, $00, $07, $11, $10, $02, $05, $01, $10, $00, $01, $01
        dc.b    $03, $01, $10, $02, $06, $11, $16, $11, $11, $00, $07, $02, $07, $07, $00, $70
        dc.b    $00, $07, $00, $70, $02, $02, $70, $70, $02, $11, $70, $77, $00, $70, $00, $77
        dc.b    $00, $70, $00, $70, $70, $70, $70, $00, $70, $70, $70, $03, $02, $70, $70, $02
        dc.b    $02, $70, $70, $03, $08, $70, $00, $70, $70, $70, $00, $70, $70, $02, $1A, $11
        dc.b    $11, $11, $11, $44, $66, $45, $AA, $22, $02, $1F, $00, $02, $01, $FF, $F0, $32
        dc.b    $2F, $F1, $3E, $00, $1F, $12, $02, $30, $0F, $02, $16, $20, $10, $E2, $02, $00
        dc.b    $2F, $01, $31, $EC, $C0, $FF, $F1, $00, $E3, $1F, $01, $00, $20, $21, $0F, $00
        dc.b    $20, $02, $20, $F0, $E3, $3E, $0F, $00, $0F, $F0, $00, $F0, $0F, $00, $F1, $FF
        dc.b    $01, $FF, $02, $30, $F1, $00, $02, $23, $00, $01, $10, $00, $31, $10, $02, $10
        dc.b    $02, $22, $22, $02, $16, $02, $31, $10, $02, $31, $01, $20, $31, $01, $32, $02
        dc.b    $01, $32, $22, $67, $45, $77, $57, $30, $00, $20, $02, $03, $0A, $22, $20, $22
        dc.b    $22, $20, $23, $33, $13, $02, $30, $02, $10, $22, $00, $33, $33, $33, $11, $20
        dc.b    $02, $11, $11, $22, $01, $11, $33, $00, $30, $03, $0A, $30, $33, $22, $20, $56
        dc.b    $50, $66, $66, $11, $05, $03, $07, $11, $00, $01, $11, $11, $11, $10, $02, $16
        dc.b    $55, $77, $56, $66, $02, $22, $30, $30, $02, $22, $33, $03, $20, $00, $20, $00
        dc.b    $23, $11, $20, $22, $33, $33, $02, $01, $30, $03, $28, $22, $20, $22, $00, $12
        dc.b    $22, $21, $11, $30, $00, $33, $03, $00, $20, $30, $30, $02, $00, $22, $22, $22
        dc.b    $22, $02, $00, $22, $22, $20, $20, $20, $22, $00, $20, $00, $22, $22, $00, $22
        dc.b    $00, $77, $76, $02, $14, $11, $00, $22, $00, $10, $01, $00, $07, $06, $77, $76
        dc.b    $61, $16, $77, $11, $01, $11, $77, $11, $10, $02, $1D, $76, $77, $70, $77, $67
        dc.b    $70, $26, $66, $10, $72, $03, $03, $00, $02, $00, $30, $77, $00, $20, $00, $21
        dc.b    $11, $13, $02, $33, $33, $33, $02, $30, $02, $09, $22, $00, $02, $22, $00, $DC
        dc.b    $8C, $AE, $F8, $08, $08, $66, $52, $41, $71, $66, $52, $41, $71, $08, $0C, $66
        dc.b    $52, $41, $71, $8A, $FE, $EF, $8B, $30, $00, $20, $02, $03, $0A, $22, $20, $22
        dc.b    $22, $20, $23, $33, $13, $02, $30, $02, $18, $22, $00, $33, $33, $33, $11, $20
        dc.b    $02, $11, $20, $02, $01, $11, $20, $00, $33, $33, $00, $02, $30, $00, $22, $22
        dc.b    $20, $02, $08, $32, $20, $22, $30, $30, $00, $22, $30, $02, $01, $22, $05, $18
        dc.b    $22, $03, $11, $02, $22, $30, $30, $02, $22, $33, $03, $20, $00, $20, $00, $23
        dc.b    $11, $20, $22, $33, $33, $00, $02, $30, $02, $1F, $02, $22, $20, $22, $00, $12
        dc.b    $22, $21, $11, $30, $00, $33, $03, $00, $20, $30, $30, $02, $00, $22, $22, $22
        dc.b    $22, $22, $00, $20, $00, $22, $00, $02, $22, $02, $01, $20, $03, $04, $22, $02
        dc.b    $21, $11, $02, $05, $33, $33, $00, $02, $30, $02, $0C, $20, $22, $22, $03, $31
        dc.b    $11, $00, $33, $33, $33, $02, $30, $03, $0C, $22, $22, $20, $20, $12, $00, $23
        dc.b    $33, $30, $00, $33, $33, $02, $01, $30, $02, $0C, $22, $02, $22, $03, $33, $31
        dc.b    $00, $33, $33, $33, $00, $30, $03, $1C, $02, $22, $22, $00, $75, $75, $44, $BB
        dc.b    $00, $22, $10, $FF, $22, $20, $23, $11, $33, $32, $00, $22, $10, $12, $00, $02
        dc.b    $23, $20, $00, $2E, $03, $19, $10, $32, $00, $02, $FF, $12, $33, $30, $C3, $13
        dc.b    $01, $12, $00, $13, $32, $20, $00, $22, $3C, $C3, $32, $CE, $F0, $0F, $F1, $03
        dc.b    $01, $0F, $03, $1D, $FF, $EE, $F0, $FF, $11, $22, $3C, $11, $00, $02, $20, $22
        dc.b    $22, $21, $13, $33, $32, $23, $31, $10, $01, $22, $02, $23, $33, $10, $20, $02
        dc.b    $22, $02, $11, $02, $22, $01, $02, $00, $23, $56, $55, $01, $33, $30, $00, $11
        dc.b    $10, $22, $00, $10, $03, $46, $70, $00, $21, $11, $26, $57, $30, $03, $30, $01
        dc.b    $30, $33, $33, $21, $21, $21, $22, $00, $67, $07, $76, $66, $10, $70, $10, $10
        dc.b    $00, $77, $11, $01, $77, $00, $77, $77, $76, $66, $66, $07, $10, $00, $01, $77
        dc.b    $10, $10, $10, $70, $76, $76, $77, $77, $76, $77, $21, $66, $11, $00, $30, $30
        dc.b    $10, $00, $33, $03, $00, $07, $22, $00, $11, $16, $67, $55, $02, $04, $10, $07
        dc.b    $01, $01, $02, $0B, $10, $10, $00, $70, $65, $57, $01, $66, $30, $00, $10, $02
        dc.b    $09, $20, $00, $11, $22, $07, $11, $00, $76, $60, $02, $04, $01, $10, $00, $70
        dc.b    $04, $0A, $77, $77, $77, $07, $67, $77, $66, $66, $10, $71, $03, $10, $01, $00
        dc.b    $11, $77, $00, $11, $00, $76, $61, $11, $00, $11, $11, $11, $00, $10, $02, $29
        dc.b    $77, $70, $07, $77, $00, $61, $70, $21, $11, $01, $00, $30, $30, $10, $00, $33
        dc.b    $03, $55, $00, $22, $22, $03, $11, $11, $00, $30, $03, $03, $00, $33, $00, $30
        dc.b    $00, $22, $12, $22, $00, $33, $33, $33, $33, $1C, $04, $11, $33, $11, $22, $02
        dc.b    $14, $33, $03, $22, $00, $30, $30, $00, $02, $01, $22, $21, $13, $31, $22, $33
        dc.b    $03, $33, $22, $33, $30, $02, $1D, $21, $22, $20, $22, $12, $20, $23, $33, $30
        dc.b    $22, $03, $03, $00, $02, $00, $30, $22, $00, $20, $00, $21, $11, $13, $02, $33
        dc.b    $33, $33, $02, $30, $02, $30, $22, $00, $02, $22, $00, $30, $22, $21, $11, $30
        dc.b    $20, $30, $30, $00, $22, $33, $03, $22, $00, $22, $22, $21, $11, $11, $00, $30
        dc.b    $00, $03, $00, $30, $30, $30, $00, $21, $21, $22, $00, $12, $00, $21, $12, $30
        dc.b    $00, $33, $30, $22, $00, $30, $05, $18, $21, $11, $03, $02, $30, $03, $30, $01
        dc.b    $30, $33, $33, $21, $21, $21, $22, $00, $12, $00, $21, $11, $30, $00, $30, $30
        dc.b    $02, $2F, $33, $03, $02, $00, $22, $22, $01, $11, $11, $00, $30, $03, $03, $00
        dc.b    $33, $00, $30, $00, $22, $12, $22, $00, $12, $20, $21, $11, $30, $00, $33, $33
        dc.b    $00, $20, $30, $00, $22, $02, $02, $22, $02, $20, $02, $00, $22, $22, $22, $00
        dc.b    $20, $07, $0D, $BB, $45, $75, $45, $00, $F1, $22, $02, $00, $F0, $00, $10, $0F
        dc.b    $02, $0E, $22, $F0, $01, $00, $02, $11, $10, $20, $23, $22, $22, $02, $1F, $C2
        dc.b    $03, $07, $C2, $23, $30, $3C, $00, $20, $02, $02, $02, $01, $10, $02, $0B, $02
        dc.b    $20, $00, $23, $CC, $32, $00, $EF, $00, $F1, $22, $02, $02, $0F, $10, $04, $08
        dc.b    $EF, $EE, $CE, $0E, $21, $00, $01, $F0, $04, $2A, $20, $02, $20, $F0, $20, $20
        dc.b    $00, $0F, $02, $00, $23, $33, $20, $02, $33, $32, $22, $31, $FF, $FE, $57, $44
        dc.b    $9A, $AA, $02, $22, $30, $30, $02, $22, $33, $03, $20, $00, $20, $00, $23, $11
        dc.b    $20, $22, $33, $33, $02, $01, $30, $03, $0D, $22, $20, $22, $00, $12, $05, $76
        dc.b    $66, $30, $00, $10, $00, $30, $02, $08, $11, $30, $67, $61, $00, $44, $06, $61
        dc.b    $03, $01, $01, $02, $36, $11, $10, $00, $11, $00, $77, $00, $10, $77, $76, $11
        dc.b    $10, $07, $11, $11, $10, $07, $10, $00, $10, $67, $77, $07, $01, $01, $66, $07
        dc.b    $10, $00, $10, $07, $10, $01, $01, $70, $76, $67, $77, $00, $77, $00, $76, $66
        dc.b    $07, $77, $10, $10, $07, $77, $11, $01, $70, $00, $77, $02, $0A, $77, $70, $77
        dc.b    $00, $77, $70, $20, $07, $00, $22, $02, $32, $07, $22, $20, $67, $77, $21, $11
        dc.b    $10, $02, $33, $33, $10, $02, $30, $00, $67, $70, $22, $02, $21, $11, $11, $02
        dc.b    $30, $00, $30, $02, $30, $03, $03, $20, $21, $12, $22, $00, $20, $00, $21, $11
        dc.b    $20, $00, $33, $33, $00, $02, $30, $00, $22, $22, $20, $02, $08, $32, $20, $22
        dc.b    $30, $30, $00, $22, $30, $02, $01, $22, $04, $04, $11, $11, $11, $33, $1C, $0F
        dc.b    $11, $33, $12, $22, $02, $22, $30, $30, $57, $55, $33, $03, $33, $32, $55, $02
        dc.b    $03, $01, $22, $52, $02, $02, $10, $27, $05, $27, $11, $01, $02, $56, $75, $65
        dc.b    $44, $30, $00, $33, $03, $00, $20, $30, $30, $02, $00, $22, $22, $22, $22, $22
        dc.b    $20, $20, $00, $02, $20, $22, $22, $20, $00, $77, $77, $00, $02, $55, $75, $21
        dc.b    $13, $02, $14, $33, $33, $00, $02, $35, $55, $00, $27, $52, $23, $03, $52, $21
        dc.b    $10, $36, $20, $10, $00, $30, $01, $02, $0D, $52, $00, $11, $10, $20, $23, $01
        dc.b    $01, $22, $00, $21, $00, $22, $02, $09, $02, $10, $20, $20, $00, $01, $02, $20
        dc.b    $20, $02, $01, $02, $04, $11, $02, $01, $02, $02, $31, $30, $02, $02, $56, $01
        dc.b    $11, $22, $60, $20, $00, $10, $25, $02, $23, $01, $20, $01, $00, $13, $02, $22
        dc.b    $33, $20, $00, $23, $33, $20, $00, $EF, $FF, $E3, $22, $CE, $EC, $C3, $20, $02
        dc.b    $22, $33, $32, $02, $3E, $FF, $01, $21, $F0, $00, $F0, $0F, $03, $01, $10, $02
        dc.b    $04, $F0, $0F, $00, $FF, $02, $01, $FF, $03, $09, $13, $11, $00, $10, $12, $20
        dc.b    $00, $21, $F1, $04, $28, $02, $00, $21, $F0, $00, $11, $EF, $01, $00, $02, $FF
        dc.b    $02, $00, $20, $00, $30, $00, $02, $FF, $33, $33, $22, $FE, $13, $31, $22, $00
        dc.b    $22, $22, $01, $12, $21, $00, $2F, $22, $10, $20, $1E, $01, $01, $02, $1C, $30
        dc.b    $12, $00, $0E, $01, $20, $00, $1F, $11, $CC, $CC, $10, $1F, $00, $0F, $13, $FF
        dc.b    $F0, $00, $20, $E3, $3F, $00, $20, $20, $03, $0F, $12, $03, $34, $FE, $20, $03
        dc.b    $00, $0E, $E3, $30, $FC, $01, $a6, $46, $66, $a5, $30, $20, $30, $30, $00, $22
        dc.b    $33, $03, $22, $00, $22, $22, $21, $11, $11, $00, $30, $00, $03, $00, $30, $30
        dc.b    $30, $00, $21, $21, $22, $00, $12, $00, $21, $12, $30, $00, $33, $30, $22, $00
        dc.b    $30, $05, $14, $21, $11, $03, $02, $30, $03, $30, $01, $30, $33, $33, $21, $21
        dc.b    $21, $22, $00, $22, $00, $77, $76, $02, $14, $11, $00, $22, $00, $10, $01, $00
        dc.b    $22, $56, $77, $21, $33, $31, $22, $33, $03, $33, $22, $33, $30, $02, $1D, $21
        dc.b    $22, $20, $22, $67, $00, $05, $54, $10, $00, $71, $10, $00, $07, $10, $11, $77
        dc.b    $00, $11, $00, $76, $61, $11, $00, $11, $11, $11, $00, $10, $02, $0B, $77, $00
        dc.b    $07, $77, $00, $11, $17, $66, $66, $01, $11, $02, $16, $10, $01, $00, $11, $77
        dc.b    $77, $61, $00, $76, $66, $61, $10, $10, $00, $01, $01, $00, $01, $10, $11, $11
        dc.b    $10, $02, $19, $10, $07, $56, $66, $10, $72, $03, $03, $00, $02, $00, $30, $77
        dc.b    $00, $20, $00, $21, $11, $13, $02, $33, $33, $33, $02, $30, $02, $09, $22, $00
        dc.b    $02, $22, $00, $11, $13, $33, $33, $1C, $77, $CB, $BB, $BB, $BB, $00, $21, $21
        dc.b    $12, $00, $31, $3B, $13, $00, $11, $B0, $13, $00, $20, $00, $33, $00, $33, $B0
        dc.b    $33, $00, $12, $10, $12, $07, $77, $7D, $A7, $77, $77, $77, $A7, $12, $12, $11
        dc.b    $20, $31, $33, $32, $3A, $32, $13, $32, $30, $33, $91, $30, $30, $33, $03, $33
        dc.b    $03, $1B, $00, $12, $B0, $A0, $0A, $7A, $30, $DA, $AA, $DA, $99, $00, $21, $8A
        dc.b    $22, $00, $02, $30, $81, $d0, $11, $B0, $02, $00, $10, $00, $82, $00, $38, $00
        dc.b    $01, $00, $10, $0A, $28, $77, $7D, $0A, $A0, $d7, $77, $AA, $AA, $21, $22, $12
        dc.b    $10, $3B, $00, $30, $30, $20, $10, $30, $00, $20, $91, $00, $30, $B0, $01, $33
        dc.b    $02, $1D, $02, $21, $10, $30, $d7, $A7, $77, $9A, $77, $A7, $d7, $21, $22, $12
        dc.b    $00, $32, $00, $38, $00, $22, $10, $30, $0A, $23, $21, $B0, $30, $30, $31, $02
        dc.b    $0B, $22, $22, $00, $03, $77, $77, $d0, $00, $DD, $ED, $70, $02, $06, $40, $20
        dc.b    $04, $d3, $03, $80, $02, $03, $44, $00, $01, $02, $08, $73, $00, $03, $00, $04
        dc.b    $00, $d0, $04, $04, $0C, $01, $40, $70, $99, $d6, $75, $00, $12, $A0, $30, $03
        dc.b    $B3, $03, $07, $03, $03, $00, $04, $3B, $30, $40, $04, $04, $10, $40, $00, $04
        dc.b    $04, $27, $67, $D9, $39, $DD, $0A, $2A, $81, $22, $00, $80, $32, $11, $00, $90
        dc.b    $21, $02, $00, $18, $21, $12, $3A, $33, $31, $01, $00, $11, $22, $22, $00, $A7
        dc.b    $77, $77, $EA, $A7, $7D, $DE, $00, $21, $2B, $02, $0A, $02, $32, $03, $00, $11
        dc.b    $21, $03, $00, $10, $28, $02, $09, $33, $30, $30, $00, $11, $80, $04, $07, $77
        dc.b    $02, $05, $ED, $DE, $76, $40, $03, $02, $06, $10, $40, $30, $01, $01, $04, $03
        dc.b    $03, $01, $44, $01, $03, $01, $10, $02, $01, $10, $03, $01, $01, $02, $0A, $11
        dc.b    $11, $51, $11, $00, $10, $40, $00, $01, $11, $04, $01, $10, $02, $01, $10, $04
        dc.b    $01, $01, $09, $08, $56, $66, $CC, $DD, $43, $00, $12, $10, $02, $05, $30, $30
        dc.b    $00, $08, $30, $02, $33, $01, $00, $30, $03, $01, $33, $00, $40, $A2, $21, $10
        dc.b    $00, $77, $77, $77, $9A, $77, $DD, $EE, $21, $22, $B0, $30, $32, $00, $38, $00
        dc.b    $22, $10, $30, $83, $26, $32, $13, $38, $00, $70, $01, $13, $17, $00, $01, $10
        dc.b    $77, $07, $01, $11, $AA, $BB, $CC, $CC, $04, $02, $40, $10, $02, $02, $04, $01
        dc.b    $02, $14, $BB, $EE, $FF, $FF, $33, $11, $11, $00, $33, $00, $11, $00, $23, $33
        dc.b    $11, $00, $CD, $DD, $EF, $EE, $03, $01, $04, $02, $36, $10, $40, $00, $01, $04
        dc.b    $03, $FF, $FE, $EA, $B8, $00, $11, $11, $33, $00, $11, $00, $33, $00, $11, $33
        dc.b    $32, $A9, $22, $11, $10, $00, $21, $21, $22, $3A, $02, $32, $11, $00, $11, $21
        dc.b    $02, $81, $22, $32, $40, $31, $10, $07, $00, $01, $10, $00, $71, $11, $10, $70
        dc.b    $77, $00, $15, $69, $0D, $00, $15, $00, $97, $00, $14, $00, $97, $00, $01, $60
        dc.b    $00, $60, $02, $35, $02, $00, $03, $00, $01, $00, $01, $00, $11, $00, $11, $00
        dc.b    $11, $00, $11, $00, $01, $00, $01, $00, $01, $00, $11, $00, $01, $00, $11, $00
        dc.b    $11, $00, $01, $00, $11, $00, $7C, $00, $7C, $00, $7E, $00, $7C, $00, $7E, $00
        dc.b    $01, $00, $7C, $00, $03, $00, $02, $00, $7E, $03, $81, $86, $76, $00, $09, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $13, $08, $13, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $17, $08, $17, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $13, $08, $13, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $35, $08, $35, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $17, $08, $17, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08, $13, $00, $12, $00
        dc.b    $10, $00, $10, $00, $11, $00, $11, $00, $10, $00, $10, $88, $18, $80, $19, $00
        dc.b    $37, $00, $10, $08, $36, $08, $11, $00, $10, $00, $37, $00, $32, $00, $15, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00
        dc.b    $10, $00, $10, $00, $12, $08, $17, $00, $10, $08, $15, $08, $71, $08, $71, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $88, $77, $88, $5C, $00
        dc.b    $01, $00, $10, $80, $43, $80, $79, $00, $10, $00, $10, $00, $12, $00, $12, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $00, $12, $00, $12, $00
        dc.b    $10, $00, $10, $88, $19, $88, $53, $00, $10, $00, $01, $80, $5C, $80, $07, $00
        dc.b    $24, $00, $24, $00, $26, $00, $26, $00, $24, $00, $24, $80, $20, $80, $0A, $00
        dc.b    $01, $00, $10, $80, $63, $80, $58, $00, $10, $00, $10, $00, $12, $00, $12, $00
        dc.b    $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $00, $12, $00, $12, $00
        dc.b    $10, $00, $10, $88, $38, $88, $73, $00, $10, $00, $01, $88, $5E, $88, $04, $00
        dc.b    $24, $00, $24, $00, $26, $08, $23, $00, $24, $08, $21, $08, $05, $08, $05, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $71, $08, $71, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00
        dc.b    $10, $00, $10, $00, $12, $00, $12, $00, $10, $08, $55, $68, $55, $60, $11, $00
        dc.b    $4C, $E0, $02, $02, $4C, $E0, $02, $57, $4E, $00, $4F, $00, $14, $00, $14, $00
        dc.b    $30, $00, $30, $00, $36, $00, $36, $00, $30, $00, $30, $00, $32, $00, $32, $00
        dc.b    $30, $00, $30, $68, $6B, $60, $5F, $00, $24, $08, $10, $80, $5F, $88, $23, $00
        dc.b    $7E, $08, $7D, $00, $7E, $08, $7D, $08, $7D, $00, $01, $00, $01, $00, $01, $00
        dc.b    $78, $00, $78, $00, $78, $00, $78, $00, $7E, $00, $7E, $00, $36, $00, $7D, $00
        dc.b    $7B, $00, $32, $00, $31, $00, $79, $00, $33, $00, $06, $00, $33, $00, $4D, $02
        dc.b    $81, $52, $08, $7E, $00, $68, $08, $17, $00, $10, $00, $10, $80, $FE, $80, $FC
        dc.b    $00, $14, $00, $14, $00, $1A, $00, $18, $00, $10, $00, $10, $00, $1C, $00, $1C
        dc.b    $00, $10, $00, $10, $00, $14, $00, $14, $00, $14, $00, $14, $00, $10, $00, $10
        dc.b    $00, $14, $00, $14, $00, $16, $00, $14, $00, $10, $00, $10, $00, $12, $00, $10
        dc.b    $00, $24, $00, $24, $00, $26, $00, $24, $00, $24, $00, $24, $00, $24, $00, $26
        dc.b    $00, $24, $00, $24, $00, $24, $00, $24, $00, $10, $00, $10, $00, $10, $00, $12
        dc.b    $00, $10, $00, $10, $00, $14, $00, $16, $00, $14, $00, $14, $00, $10, $00, $10
        dc.b    $00, $14, $00, $14, $00, $18, $00, $18, $00, $10, $00, $10, $00, $16, $00, $16
        dc.b    $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $00, $d8, $08, $D9
        dc.b    $00, $10, $00, $10, $80, $7A, $80, $7A, $00, $10, $00, $10, $80, $BA, $88, $B9
        dc.b    $80, $23, $00, $14, $80, $23, $00, $14, $00, $14, $80, $21, $80, $62, $00, $55
        dc.b    $00, $04, $00, $04, $00, $06, $00, $06, $00, $04, $00, $04, $00, $0E, $00, $0E
        dc.b    $00, $04, $00, $04, $00, $06, $00, $06, $00, $04, $00, $04, $00, $58, $00, $58
        dc.b    $00, $a5, $00, $a5, $00, $AB, $00, $AB, $00, $AB, $00, $AB, $E9, $0C, $E9, $0C
        dc.b    $00, $10, $00, $10, $00, $12, $00, $12, $00, $10, $00, $10, $08, $18, $09, $AC
        dc.b    $00, $10, $00, $01, $00, $10, $09, $BA, $00, $10, $00, $10, $81, $A1, $09, $A9
        dc.b    $00, $01, $00, $01, $80, $1F, $09, $B1, $00, $01, $00, $10, $09, $AA, $00, $12
        dc.b    $00, $10, $00, $10, $00, $FC, $00, $FC, $00, $10, $00, $10, $00, $DB, $00, $DE
        dc.b    $00, $CA, $00, $10, $00, $CD, $00, $12, $00, $10, $00, $10, $00, $C4, $00, $C4
        dc.b    $00, $19, $00, $15, $00, $0E, $A8, $0B, $00, $02, $00, $10, $E9, $E2, $A8, $D4
        dc.b    $00, $01, $E9, $2C, $E9, $2E, $E9, $2E, $E9, $2E, $00, $10, $E9, $EF, $00, $d1
        dc.b    $00, $10, $00, $10, $03, $67, $3F, $00, $2F, $00, $10, $00, $12, $00, $12, $00
        dc.b    $10, $00, $10, $00, $50, $00, $50, $00, $10, $00, $10, $E9, $93, $09, $3C, $00
        dc.b    $01, $00, $01, $E9, $EE, $09, $41, $00, $10, $00, $10, $00, $10, $00, $01, $00
        dc.b    $10, $00, $36, $00, $A2, $00, $01, $00, $30, $00, $10, $00, $CE, $00, $7A, $09
        dc.b    $A1, $00, $10, $E0, $02, $09, $1D, $00, $01, $00, $03, $E9, $EF, $09, $43, $00
        dc.b    $10, $00, $10, $00, $10, $00, $26, $00, $10, $00, $0E, $00, $83, $00, $6D, $00
        dc.b    $F0, $09, $B8, $00, $62, $09, $EC, $09, $42, $00, $11, $09, $42, $03, $19, $11
        dc.b    $00, $11, $00, $63, $00, $25, $00, $30, $00, $10, $09, $AF, $00, $68, $09, $D8
        dc.b    $00, $66, $01, $d8, $89, $d7, $01, $d6, $02, $36, $08, $d3, $81, $06, $00, $10
        dc.b    $00, $10, $08, $B8, $08, $BA, $00, $10, $00, $10, $00, $72, $00, $72, $00, $10
        dc.b    $00, $10, $00, $32, $00, $22, $00, $25, $00, $3B, $00, $24, $00, $1A, $00, $2A
        dc.b    $00, $18, $00, $1A, $00, $08, $00, $18, $00, $0E, $00, $08, $89, $C3, $01, $CC
        dc.b    $02, $03, $88, $00, $68, $05, $80, $9C, $21, $E6, $49, $E7, $00, $10, $00, $10
        dc.b    $00, $1E, $08, $1F, $00, $10, $00, $10, $08, $1F, $00, $1E, $00, $10, $00, $10
        dc.b    $08, $1E, $00, $1F, $00, $10, $00, $10, $00, $13, $08, $13, $00, $10, $00, $10
        dc.b    $00, $10, $08, $13, $00, $10, $00, $10, $C1, $d4, $C1, $d7, $00, $10, $00, $10
        dc.b    $00, $11, $00, $11, $00, $10, $00, $10, $00, $1B, $08, $1A, $00, $10, $00, $10
        dc.b    $00, $12, $00, $12, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10
        dc.b    $00, $12, $00, $12, $00, $10, $00, $10, $08, $1F, $08, $1F, $00, $10, $00, $10
        dc.b    $08, $11, $08, $11, $00, $10, $00, $10, $08, $17, $08, $17, $00, $10, $00, $10
        dc.b    $08, $11, $08, $11, $00, $10, $00, $10, $88, $79, $88, $79, $00, $10, $00, $10
        dc.b    $00, $12, $08, $13, $00, $10, $00, $10, $08, $13, $00, $12, $00, $10, $08, $55
        dc.b    $68, $55, $60, $11, $12, $01, $68, $03, $01, $68, $0B, $06, $68, $00, $20, $BF
        dc.b    $08, $03, $03, $01, $01, $02, $02, $40, $BD, $04, $02, $40, $BD, $03, $01, $01
        dc.b    $02, $04, $60, $03, $20, $BF, $5E, $01, $68, $07, $01, $68, $37, $01, $68, $07
        dc.b    $01, $68, $37, $01, $68, $07, $01, $68, $3D, $03, $80, $00, $80, $2D, $03, $80
        dc.b    $00, $80, $0D, $03, $80, $00, $80, $6D, $03, $80, $00, $80, $81, $15, $04, $FF
        dc.b    $FF, $FF, $FF, $14, $01, $FF, $03, $02, $FF, $FF, $02, $02, $FF, $FF, $02, $02
        dc.b    $FF, $FF, $03, $01, $FF, $06, $0A, $FF, $FF, $33, $33, $CC, $FF, $CC, $CC, $CC
        dc.b    $FF, $05, $01, $FF, $03, $01, $FF, $07, $09, $FF, $FF, $FF, $FF, $00, $FF, $FF
        dc.b    $FF, $FF, $04, $04, $FF, $FF, $FF, $FF, $08, $04, $FF, $FF, $FF, $FF, $10, $04
        dc.b    $FF, $FF, $FF, $FF, $02, $02, $FF, $FF, $02, $02, $FF, $FF, $0F, $0C, $FF, $FF
        dc.b    $FF, $FF, $00, $0F, $FF, $F0, $00, $0F, $FF, $F0, $81, $89, $62, $41, $04, $40
        dc.b    $41, $40, $44, $01, $40, $00, $41, $71, $16, $17, $32, $31, $15, $17, $32, $00
        dc.b    $42, $40, $05, $41, $01, $40, $44, $01, $40, $41, $01, $43, $41, $01, $40, $32
        dc.b    $57, $57, $32, $31, $57, $57, $37, $41, $01, $42, $44, $01, $40, $43, $01, $40
        dc.b    $41, $01, $40, $41, $01, $40, $00, $70, $56, $17, $32, $31, $16, $56, $72, $00
        dc.b    $41, $01, $40, $41, $01, $43, $11, $51, $51, $16, $01, $03, $03, $06, $04, $01
        dc.b    $03, $03, $07, $00, $02, $04, $01, $03, $03, $05, $02, $10, $11, $10, $11, $35
        dc.b    $4E, $43, $01, $42, $43, $42, $43, $01, $42, $00, $62, $62, $23, $22, $04, $04
        dc.b    $23, $22, $27, $21, $43, $42, $02, $46, $01, $42, $43, $01, $42, $43, $01, $40
        dc.b    $43, $01, $63, $22, $60, $60, $04, $04, $60, $60, $25, $67, $01, $42, $43, $01
        dc.b    $42, $43, $01, $42, $43, $01, $42, $43, $01, $42, $21, $63, $61, $22, $04, $04
        dc.b    $23, $61, $67, $24, $43, $01, $42, $43, $01, $42, $04, $42, $43, $01, $05, $0E
        dc.b    $02, $10, $14, $02, $02, $10, $14, $35, $04, $01, $01, $02, $01, $02, $11, $03
        dc.b    $02, $05, $29, $28, $29, $2F, $04, $04, $29, $2F, $2D, $2C, $02, $05, $00, $03
        dc.b    $03, $03, $03, $02, $05, $02, $0C, $02, $05, $29, $28, $2B, $2A, $04, $04, $2B
        dc.b    $2A, $2D, $2C, $03, $01, $03, $03, $03, $03, $02, $05, $02, $0E, $02, $05, $29
        dc.b    $28, $2B, $2A, $04, $04, $2B, $2A, $2D, $2C, $02, $05, $02, $07, $02, $05, $04
        dc.b    $01, $01, $01, $05, $0F, $01, $3E, $03, $01, $3E, $35, $17, $0C, $0D, $0C, $0D
        dc.b    $02, $04, $08, $0C, $0F, $08, $30, $34, $37, $36, $35, $34, $37, $36, $09, $0E
        dc.b    $0D, $0C, $06, $05, $13, $02, $04, $0C, $0E, $0D, $0D, $36, $34, $35, $33, $35
        dc.b    $34, $37, $36, $09, $0E, $0D, $0C, $06, $05, $1A, $02, $04, $0C, $0E, $0D, $0D
        dc.b    $36, $34, $35, $33, $35, $34, $37, $36, $03, $00, $02, $05, $03, $00, $05, $03
        dc.b    $01, $01, $06, $07, $0F, $01, $44, $03, $01, $44, $35, $0D, $01, $01, $01, $01
        dc.b    $5B, $5A, $00, $41, $1B, $5A, $00, $41, $40, $04, $08, $03, $5B, $5A, $00, $03
        dc.b    $5B, $5A, $03, $03, $15, $58, $5A, $00, $41, $1B, $5A, $00, $41, $40, $03, $00
        dc.b    $41, $40, $03, $5B, $1B, $40, $00, $5B, $5A, $03, $03, $02, $58, $5A, $02, $02
        dc.b    $5B, $5A, $03, $01, $03, $02, $0E, $41, $43, $00, $41, $01, $40, $27, $67, $6F
        dc.b    $3C, $26, $27, $2E, $3D, $0F, $01, $44, $03, $01, $44, $35, $0F, $02, $01, $01
        dc.b    $01, $5E, $5C, $00, $43, $1F, $5C, $03, $43, $42, $02, $06, $02, $08, $02, $58
        dc.b    $5C, $03, $00, $5D, $5C, $03, $03, $15, $5D, $5C, $03, $43, $1F, $5E, $06, $43
        dc.b    $42, $02, $05, $43, $42, $00, $5D, $1F, $41, $00, $5D, $5C, $03, $03, $07, $5D
        dc.b    $5C, $03, $00, $5D, $5E, $06, $02, $11, $02, $05, $00, $43, $42, $00, $43, $01
        dc.b    $42, $31, $73, $71, $32, $30, $31, $32, $33, $0F, $01, $44, $03, $01, $44, $35
        dc.b    $0C, $01, $03, $04, $01, $5F, $5C, $07, $05, $5F, $5E, $02, $05, $05, $03, $02
        dc.b    $5F, $5E, $02, $0C, $5A, $5E, $00, $02, $07, $05, $5F, $5E, $02, $05, $5F, $5E
        dc.b    $03, $02, $02, $05, $03, $02, $5A, $5E, $02, $0C, $5A, $5E, $00, $02, $07, $05
        dc.b    $5F, $5E, $02, $05, $5F, $5E, $03, $02, $02, $05, $03, $0C, $07, $05, $00, $02
        dc.b    $1F, $19, $1F, $1E, $1C, $1D, $1E, $1F, $0E, $02, $44, $02, $02, $02, $44, $02
        dc.b    $35, $04, $01, $01, $01, $01, $02, $05, $09, $0E, $0D, $0C, $06, $05, $13, $02
        dc.b    $04, $0F, $0E, $0F, $08, $19, $18, $1B, $1A, $19, $18, $1B, $1A, $09, $0E, $0D
        dc.b    $0C, $06, $05, $13, $02, $04, $0F, $0E, $0F, $08, $19, $18, $1B, $1A, $19, $18
        dc.b    $1B, $1A, $09, $0E, $0D, $0C, $06, $05, $0E, $02, $04, $0F, $0E, $0F, $08, $31
        dc.b    $16, $33, $32, $30, $17, $32, $33, $0E, $02, $10, $11, $02, $02, $10, $11, $35
        dc.b    $39, $41, $03, $40, $41, $40, $02, $41, $01, $40, $00, $41, $01, $40, $41, $01
        dc.b    $42, $41, $01, $40, $01, $41, $61, $20, $20, $22, $04, $04, $21, $27, $25, $24
        dc.b    $43, $45, $00, $41, $01, $45, $41, $01, $43, $44, $01, $40, $00, $41, $61, $20
        dc.b    $20, $22, $04, $04, $21, $27, $25, $24, $02, $05, $02, $02, $02, $05, $02, $0F
        dc.b    $01, $05, $02, $00, $03, $03, $23, $20, $23, $1C, $3F, $21, $22, $1E, $1F, $0E
        dc.b    $02, $12, $15, $02, $02, $12, $15, $35, $38, $43, $01, $42, $43, $41, $00, $43
        dc.b    $01, $41, $00, $43, $01, $42, $43, $01, $42, $43, $01, $42, $00, $43, $6B, $28
        dc.b    $2B, $2A, $04, $04, $2B, $2A, $2D, $2C, $43, $42, $00, $43, $01, $42, $43, $01
        dc.b    $42, $43, $01, $42, $00, $43, $6B, $28, $2B, $2A, $04, $04, $2B, $2A, $2D, $2C
        dc.b    $03, $03, $01, $03, $09, $1D, $29, $28, $2B, $33, $1B, $29, $12, $0B, $33, $38
        dc.b    $01, $39, $38, $01, $39, $38, $01, $39, $38, $01, $39, $38, $01, $29, $11, $38
        dc.b    $39, $10, $11, $35, $04, $01, $01, $01, $01, $02, $0C, $02, $05, $00, $02, $07
        dc.b    $05, $02, $07, $05, $00, $02, $05, $04, $10, $1D, $1C, $1F, $1E, $1F, $19, $1F
        dc.b    $1C, $07, $05, $02, $07, $05, $00, $02, $05, $08, $10, $1D, $1C, $1F, $1E, $1F
        dc.b    $19, $1F, $1C, $07, $05, $02, $07, $05, $00, $02, $05, $04, $20, $02, $05, $00
        dc.b    $02, $1F, $19, $1F, $1C, $26, $26, $22, $25, $01, $07, $06, $01, $07, $06, $01
        dc.b    $07, $06, $01, $07, $06, $01, $07, $2E, $2F, $3B, $3C, $12, $15, $35, $04, $10
        dc.b    $11, $10, $11, $04, $02, $02, $02, $02, $12, $02, $02, $02, $02, $02, $02, $02
        dc.b    $02, $02, $02, $80, $80, $82, $82, $80, $80, $80, $80, $04, $04, $02, $02, $02
        dc.b    $02, $04, $02, $02, $02, $02, $0C, $80, $80, $82, $82, $82, $82, $82, $82, $02
        dc.b    $02, $02, $02, $02, $04, $02, $02, $02, $02, $02, $02, $02, $02, $02, $1C, $80
        dc.b    $80, $82, $82, $04, $04, $04, $04, $00, $1B, $03, $03, $01, $1A, $00, $02, $1A
        dc.b    $03, $01, $03, $19, $00, $86, $86, $96, $97, $12, $13, $84, $54, $00, $15, $69
        dc.b    $0A, $00, $15, $00, $97, $00, $14, $20, $28, $20, $BE, $05, $33, $06, $00, $05
        dc.b    $00, $70, $00, $70, $00, $72, $00, $76, $00, $70, $00, $70, $00, $76, $00, $72
        dc.b    $00, $70, $00, $70, $00, $14, $00, $14, $00, $30, $00, $30, $00, $32, $00, $36
        dc.b    $00, $30, $00, $30, $00, $36, $00, $32, $00, $30, $00, $30, $20, $ED, $20, $EE
        dc.b    $04, $34, $20, $C0, $20, $C1, $00, $10, $00, $10, $00, $12, $00, $12, $00, $10
        dc.b    $00, $10, $00, $16, $00, $16, $00, $10, $00, $10, $00, $34, $00, $34, $00, $03
        dc.b    $00, $05, $00, $01, $00, $04, $00, $07, $00, $03, $00, $04, $00, $01, $00, $05
        dc.b    $00, $07, $20, $E4, $20, $E5, $0C, $34, $20, $B6, $20, $B7, $00, $70, $00, $70
        dc.b    $00, $7E, $00, $71, $00, $70, $00, $70, $00, $7F, $00, $7E, $00, $70, $00, $70
        dc.b    $00, $11, $00, $1F, $00, $30, $00, $30, $00, $3E, $00, $31, $00, $30, $00, $30
        dc.b    $00, $3F, $00, $3E, $00, $30, $00, $30, $20, $E7, $20, $E8, $4C, $80, $B4, $61
        dc.b    $CB, $69, $1B, $00, $10, $00, $C0, $00, $17, $00, $17, $00, $10, $00, $10, $00
        dc.b    $11, $00, $11, $00, $10, $00, $10, $00, $13, $00, $13, $00, $10, $00, $E5, $08
        dc.b    $01, $00, $E4, $00, $0A, $00, $1B, $08, $1A, $08, $0B, $00, $1B, $00, $0A, $08
        dc.b    $0D, $08, $0D, $08, $03, $00, $0A, $00, $02, $08, $0B, $00, $0A, $08, $03, $08
        dc.b    $05, $00, $0C, $00, $91, $00, $0C, $08, $90, $08, $0D, $00, $0C, $00, $91, $00
        dc.b    $0C, $08, $DD, $00, $0C, $00, $48, $00, $41, $00, $05, $00, $48, $00, $0C, $00
        dc.b    $03, $00, $36, $00, $01, $00, $04, $00, $3D, $00, $38, $00, $04, $00, $01, $00
        dc.b    $04, $08, $3C, $00, $04, $00, $04, $08, $05, $08, $05, $00, $04, $00, $04, $08
        dc.b    $64, $00, $04, $00, $11, $08, $71, $00, $70, $08, $10, $08, $71, $00, $11, $08
        dc.b    $13, $08, $13, $00, $10, $00, $10, $08, $11, $08, $11, $00, $10, $00, $10, $08
        dc.b    $51, $00, $50, $00, $E5, $00, $10, $00, $30, $00, $15, $00, $C0, $00, $10, $61
        dc.b    $DB, $69, $DB, $0C, $06, $61, $EC, $01, $56, $00, $04, $02, $0E, $08, $05, $00
        dc.b    $5C, $00, $04, $00, $10, $08, $05, $00, $4C, $08, $71, $03, $0D, $12, $00, $5C
        dc.b    $00, $10, $00, $10, $08, $84, $00, $4C, $00, $C0, $03, $0D, $17, $00, $5C, $00
        dc.b    $10, $00, $10, $00, $11, $00, $4C, $00, $10, $03, $0D, $13, $00, $5C, $00, $10
        dc.b    $00, $10, $00, $11, $00, $4C, $00, $1B, $03, $0D, $0C, $00, $5C, $00, $0A, $00
        dc.b    $10, $00, $04, $00, $4C, $00, $0C, $03, $0B, $41, $00, $5C, $00, $48, $00, $10
        dc.b    $68, $85, $68, $F6, $03, $0D, $04, $00, $5C, $08, $05, $00, $10, $00, $04, $00
        dc.b    $4C, $08, $05, $02, $0E, $08, $71, $00, $5C, $00, $12, $00, $10, $00, $10, $00
        dc.b    $4C, $08, $84, $03, $0D, $C0, $00, $5C, $00, $17, $00, $10, $00, $10, $00, $4C
        dc.b    $00, $11, $03, $0D, $10, $00, $5C, $00, $13, $00, $10, $00, $10, $00, $4C, $00
        dc.b    $11, $03, $0D, $1B, $00, $5C, $00, $0C, $00, $10, $00, $0A, $00, $4C, $00, $04
        dc.b    $03, $0D, $0C, $00, $5C, $00, $41, $00, $10, $00, $48, $09, $1A, $69, $d3, $7C
        dc.b    $03, $20, $00, $20, $05, $03, $20, $00, $20, $80, $F5, $03, $20, $00, $20, $05
        dc.b    $03, $20, $00, $20, $80, $F5, $03, $20, $00, $20, $05, $03, $20, $00, $20, $80
        dc.b    $F5, $03, $20, $00, $20, $05, $03, $20, $00, $20, $80, $F5, $03, $20, $00, $20
        dc.b    $05, $03, $20, $00, $20, $82, $8D, $47, $01, $02, $03, $01, $03, $01, $02, $03
        dc.b    $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01
        dc.b    $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02
        dc.b    $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03
        dc.b    $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $01, $02, $03, $01, $50
        dc.b    $47, $04, $05, $06, $04, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $04, $05, $06, $04, $50, $47, $02, $03, $01, $02, $01, $02
        dc.b    $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03
        dc.b    $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01
        dc.b    $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02
        dc.b    $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $02, $03, $01
        dc.b    $02, $50, $47, $05, $06, $04, $05, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $05, $06, $04, $05, $50, $47, $01, $02, $03, $01
        dc.b    $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03
        dc.b    $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01
        dc.b    $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02
        dc.b    $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $03, $01, $02, $01
        dc.b    $02, $03, $01, $50, $47, $04, $05, $06, $04, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $04, $05, $06, $04, $50, $47, $08, $09
        dc.b    $0A, $08, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $08, $09, $0A, $08, $50, $47, $08, $09, $0A, $08, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $08, $09, $0A, $08, $50, $47
        dc.b    $08, $09, $0A, $08, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $06, $05, $02, $06, $01, $06, $07, $01, $06, $07, $01, $06
        dc.b    $07, $01, $06, $07, $01, $06, $07, $01, $06, $07, $01, $06, $07, $01, $06, $07
        dc.b    $01, $06, $07, $0C, $0D, $0B, $0C, $50, $47, $08, $09, $0A, $08, $01, $03, $02
        dc.b    $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $1B, $1A, $19
        dc.b    $1B, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $11, $12, $10, $11
        dc.b    $50, $47, $08, $09, $0A, $08, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01
        dc.b    $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03, $02, $01, $03
        dc.b    $02, $01, $03, $02, $01, $03, $1E, $1D, $1A, $1E, $01, $06, $07, $01, $06, $07
        dc.b    $01, $06, $07, $01, $06, $07, $01, $06, $07, $01, $06, $07, $01, $06, $07, $01
        dc.b    $06, $07, $01, $06, $07, $14, $15, $13, $14, $85, $9E, $00, $00, $10, $CB, $BB        
Fire_In_Bowl: ; loc_04E86C:
        incbin  'data\sprites\firebowl.dat'  
Filler_1: ; loc_04EC6C: ; Filler
        dc.b   0,  0,  0,  0	;
Unknow_Data_0x04EE00: ; loc_04EE00:
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $18, $18, $18, $18, $18
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20
        dc.b    $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $00, $00, $00, $00, $00, $00, $00, $20, $20
        dc.b    $20, $20, $20, $25, $25, $25, $25, $25, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $05, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $20, $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $04, $04, $04, $04, $04, $00, $10, $10, $10, $10, $10, $10, $10, $10, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $08, $08, $29, $29, $29, $29, $29, $29, $29, $29, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $29, $29, $29, $29, $29, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $19, $19, $19, $19, $19, $19, $19, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $01, $01, $04, $04, $04, $04, $14, $14
        dc.b    $14, $14, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $05, $05, $05, $05
        dc.b    $05, $01, $01, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $01, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $10, $10, $10, $10, $10, $10, $10, $10, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $08, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $00, $00, $00, $10, $10
        dc.b    $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00
        dc.b    $00, $00, $00, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $28, $28, $28
        dc.b    $28, $28, $28, $28, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $18, $18, $18, $18, $18, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00
        dc.b    $00, $00, $00, $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20
        dc.b    $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $00
        dc.b    $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $25, $25, $25, $25, $25
        dc.b    $05, $05, $05, $05, $05, $05, $05, $05, $05, $04, $04, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $20
        dc.b    $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $10, $10, $10, $10
        dc.b    $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04, $04, $00, $10
        dc.b    $10, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $29, $29, $29
        dc.b    $29, $29, $29, $29, $29, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $29
        dc.b    $29, $29, $29, $29, $09, $09, $09, $09, $09, $09, $09, $09, $09, $19, $19, $19
        dc.b    $19, $19, $19, $19, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $01, $01, $04, $04, $04, $04, $14, $14, $14, $14, $10, $10, $10, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $05, $05, $05, $05, $05, $01, $01, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $01, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $20
        dc.b    $20, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $10
        dc.b    $10, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $00, $00, $00, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20
        dc.b    $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08, $08, $08, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $28, $28, $28, $28, $28, $28, $28, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $20, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $10, $10, $10, $10, $10, $10, $10, $10
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $18, $18, $18, $18, $18
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $20, $20, $20, $20, $20
        dc.b    $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $00, $00, $00, $00, $00, $00, $00, $20, $20
        dc.b    $20, $20, $20, $25, $25, $25, $25, $25, $05, $05, $05, $05, $05, $05, $05, $05
        dc.b    $05, $04, $04, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $20, $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $04, $04, $04, $04, $04, $00, $10, $10, $10, $10, $10, $10, $10, $10, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $08, $08, $29, $29, $29, $29, $29, $29, $29, $29, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $29, $29, $29, $29, $29, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $19, $19, $19, $19, $19, $19, $19, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $01, $01, $04, $04, $04, $04, $14, $14
        dc.b    $14, $14, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04
        dc.b    $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $04, $05, $05, $05, $05
        dc.b    $05, $01, $01, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $01, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $20, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $10, $10, $10, $10, $10, $10, $10, $10, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $08, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09
        dc.b    $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $09, $00, $00, $00, $10, $10
        dc.b    $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00
        dc.b    $00, $00, $00, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $28, $28, $28
        dc.b    $28, $28, $28, $28, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $20, $20, $20, $20, $20, $20, $00, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $10, $10, $10, $10, $10, $10, $10, $10, $00, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $08, $08, $08, $08
        dc.b    $08, $08, $08, $08, $08, $08, $08, $08, $08, $00, $00, $00, $00, $00, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $00, $00        
Filler_2: ; loc_04FB98:  ; Filler        
        dc.b   0,  0,  0,  0	;
Sonic_Sprites: ; loc_050000:
        incbin  'data\sprites\sonic2.dat'     
Sonic_Mappings: ; loc_0614C0: 
        dc.w    loc_06160E-Sonic_Mappings
        dc.w    loc_061610-Sonic_Mappings
        dc.w    loc_061632-Sonic_Mappings
        dc.w    loc_061644-Sonic_Mappings
        dc.w    loc_06166E-Sonic_Mappings
        dc.w    loc_061698-Sonic_Mappings
        dc.w    loc_0616C2-Sonic_Mappings
        dc.w    loc_0616E4-Sonic_Mappings
        dc.w    loc_061706-Sonic_Mappings
        dc.w    loc_061718-Sonic_Mappings
        dc.w    loc_06172A-Sonic_Mappings
        dc.w    loc_06173C-Sonic_Mappings
        dc.w    loc_06175E-Sonic_Mappings
        dc.w    loc_061780-Sonic_Mappings
        dc.w    loc_061792-Sonic_Mappings
        dc.w    loc_0617A4-Sonic_Mappings
        dc.w    loc_0617BE-Sonic_Mappings
        dc.w    loc_0617D8-Sonic_Mappings
        dc.w    loc_0617F2-Sonic_Mappings
        dc.w    loc_061814-Sonic_Mappings
        dc.w    loc_061836-Sonic_Mappings
        dc.w    loc_061850-Sonic_Mappings
        dc.w    loc_06186A-Sonic_Mappings
        dc.w    loc_061884-Sonic_Mappings
        dc.w    loc_06189E-Sonic_Mappings
        dc.w    loc_0618C0-Sonic_Mappings
        dc.w    loc_0618EA-Sonic_Mappings
        dc.w    loc_061914-Sonic_Mappings
        dc.w    loc_061936-Sonic_Mappings
        dc.w    loc_061958-Sonic_Mappings
        dc.w    loc_06197A-Sonic_Mappings
        dc.w    loc_06199C-Sonic_Mappings
        dc.w    loc_0619BE-Sonic_Mappings
        dc.w    loc_0619E8-Sonic_Mappings
        dc.w    loc_061A0A-Sonic_Mappings
        dc.w    loc_061A2C-Sonic_Mappings
        dc.w    loc_061A4E-Sonic_Mappings
        dc.w    loc_061A68-Sonic_Mappings
        dc.w    loc_061A7A-Sonic_Mappings
        dc.w    loc_061A8C-Sonic_Mappings
        dc.w    loc_061A9E-Sonic_Mappings
        dc.w    loc_061AB8-Sonic_Mappings
        dc.w    loc_061AD2-Sonic_Mappings
        dc.w    loc_061AEC-Sonic_Mappings
        dc.w    loc_061AFE-Sonic_Mappings
        dc.w    loc_061B10-Sonic_Mappings
        dc.w    loc_061B22-Sonic_Mappings
        dc.w    loc_061B34-Sonic_Mappings
        dc.w    loc_061B4E-Sonic_Mappings
        dc.w    loc_061B70-Sonic_Mappings
        dc.w    loc_061B92-Sonic_Mappings
        dc.w    loc_061BBC-Sonic_Mappings
        dc.w    loc_061BDE-Sonic_Mappings
        dc.w    loc_061C00-Sonic_Mappings
        dc.w    loc_061C22-Sonic_Mappings
        dc.w    loc_061C44-Sonic_Mappings
        dc.w    loc_061C66-Sonic_Mappings
        dc.w    loc_061C88-Sonic_Mappings
        dc.w    loc_061CAA-Sonic_Mappings
        dc.w    loc_061CCC-Sonic_Mappings
        dc.w    loc_061CEE-Sonic_Mappings
        dc.w    loc_061D00-Sonic_Mappings
        dc.w    loc_061D12-Sonic_Mappings
        dc.w    loc_061D24-Sonic_Mappings
        dc.w    loc_061D36-Sonic_Mappings
        dc.w    loc_061D48-Sonic_Mappings
        dc.w    loc_061D5A-Sonic_Mappings
        dc.w    loc_061D6C-Sonic_Mappings
        dc.w    loc_061D7E-Sonic_Mappings
        dc.w    loc_061D90-Sonic_Mappings
        dc.w    loc_061DA2-Sonic_Mappings
        dc.w    loc_061DB4-Sonic_Mappings
        dc.w    loc_061DC6-Sonic_Mappings
        dc.w    loc_061DD8-Sonic_Mappings
        dc.w    loc_061DEA-Sonic_Mappings
        dc.w    loc_061DFC-Sonic_Mappings
        dc.w    loc_061E0E-Sonic_Mappings
        dc.w    loc_061E20-Sonic_Mappings
        dc.w    loc_061E32-Sonic_Mappings
        dc.w    loc_061E44-Sonic_Mappings
        dc.w    loc_061E56-Sonic_Mappings
        dc.w    loc_061E68-Sonic_Mappings
        dc.w    loc_061E7A-Sonic_Mappings
        dc.w    loc_061E8C-Sonic_Mappings
        dc.w    loc_061E9E-Sonic_Mappings
        dc.w    loc_061EB0-Sonic_Mappings
        dc.w    loc_061EC2-Sonic_Mappings
        dc.w    loc_061ED4-Sonic_Mappings
        dc.w    loc_061EE6-Sonic_Mappings
        dc.w    loc_061EF8-Sonic_Mappings
        dc.w    loc_061F0A-Sonic_Mappings
        dc.w    loc_061F1C-Sonic_Mappings
        dc.w    loc_061F2E-Sonic_Mappings
        dc.w    loc_061F40-Sonic_Mappings
        dc.w    loc_061F52-Sonic_Mappings
        dc.w    loc_061F64-Sonic_Mappings
        dc.w    loc_061F76-Sonic_Mappings
        dc.w    loc_061F88-Sonic_Mappings
        dc.w    loc_061F9A-Sonic_Mappings
        dc.w    loc_061FAC-Sonic_Mappings
        dc.w    loc_061FBE-Sonic_Mappings
        dc.w    loc_061FD0-Sonic_Mappings
        dc.w    loc_061FE2-Sonic_Mappings
        dc.w    loc_061FF4-Sonic_Mappings
        dc.w    loc_062006-Sonic_Mappings
        dc.w    loc_062018-Sonic_Mappings
        dc.w    loc_06202A-Sonic_Mappings
        dc.w    loc_06203C-Sonic_Mappings
        dc.w    loc_06204E-Sonic_Mappings
        dc.w    loc_062058-Sonic_Mappings
        dc.w    loc_062062-Sonic_Mappings
        dc.w    loc_06206C-Sonic_Mappings
        dc.w    loc_062076-Sonic_Mappings
        dc.w    loc_062080-Sonic_Mappings
        dc.w    loc_06208A-Sonic_Mappings
        dc.w    loc_062094-Sonic_Mappings
        dc.w    loc_06209E-Sonic_Mappings
        dc.w    loc_0620A8-Sonic_Mappings
        dc.w    loc_0620B2-Sonic_Mappings
        dc.w    loc_0620BC-Sonic_Mappings
        dc.w    loc_0620D6-Sonic_Mappings
        dc.w    loc_0620F0-Sonic_Mappings
        dc.w    loc_06210A-Sonic_Mappings
        dc.w    loc_062124-Sonic_Mappings
        dc.w    loc_062146-Sonic_Mappings
        dc.w    loc_062168-Sonic_Mappings
        dc.w    loc_06218A-Sonic_Mappings
        dc.w    loc_0621A4-Sonic_Mappings
        dc.w    loc_0621AE-Sonic_Mappings
        dc.w    loc_0621B8-Sonic_Mappings
        dc.w    loc_0621D2-Sonic_Mappings
        dc.w    loc_0621EC-Sonic_Mappings
        dc.w    loc_062206-Sonic_Mappings
        dc.w    loc_062220-Sonic_Mappings
        dc.w    loc_062232-Sonic_Mappings
        dc.w    loc_062244-Sonic_Mappings
        dc.w    loc_062256-Sonic_Mappings
        dc.w    loc_062268-Sonic_Mappings
        dc.w    loc_06228A-Sonic_Mappings
        dc.w    loc_06229C-Sonic_Mappings
        dc.w    loc_0622B6-Sonic_Mappings
        dc.w    loc_0622D0-Sonic_Mappings
        dc.w    loc_0622E2-Sonic_Mappings
        dc.w    loc_0622F4-Sonic_Mappings
        dc.w    loc_062306-Sonic_Mappings
        dc.w    loc_062318-Sonic_Mappings
        dc.w    loc_06233A-Sonic_Mappings
        dc.w    loc_06235C-Sonic_Mappings
        dc.w    loc_06237E-Sonic_Mappings
        dc.w    loc_062398-Sonic_Mappings
        dc.w    loc_0623B2-Sonic_Mappings
        dc.w    loc_0623D4-Sonic_Mappings
        dc.w    loc_0623EE-Sonic_Mappings
        dc.w    loc_062410-Sonic_Mappings
        dc.w    loc_062432-Sonic_Mappings
        dc.w    loc_06244C-Sonic_Mappings
        dc.w    loc_062466-Sonic_Mappings
        dc.w    loc_062480-Sonic_Mappings
        dc.w    loc_062492-Sonic_Mappings
        dc.w    loc_06249C-Sonic_Mappings
        dc.w    loc_0624AE-Sonic_Mappings
        dc.w    loc_0624C8-Sonic_Mappings
        dc.w    loc_0624E2-Sonic_Mappings
        dc.w    loc_0624FC-Sonic_Mappings
        dc.w    loc_06250E-Sonic_Mappings
        dc.w    loc_062520-Sonic_Mappings
        dc.w    loc_06253A-Sonic_Mappings
loc_06160E:
        dc.w    $0000
loc_061610:
        dc.w    $0004
        dc.l    $E4050000, $0000FFF8, $EC030004, $0002FFF0
        dc.l    $F4090008, $0004FFF8, $0409000E, $0007FFF8
loc_061632:
        dc.w    $0002
        dc.l    $EC0B0000, $0000FFF0, $0C09000C, $0006FFF8
loc_061644:
        dc.w    $0005
        dc.l    $EC010000, $0000FFF0, $EC050002, $0001FFF8
        dc.l    $FC090006, $0003FFF0, $0C01000C, $0006FFF8
        dc.l    $0C05000E, $00070000
loc_06166E:
        dc.w    $0005
        dc.l    $EC010000, $0000FFF0, $EC050002, $0001FFF8
        dc.l    $FC090006, $0003FFF0, $0C01000C, $0006FFF8
        dc.l    $0C05000E, $00070000
loc_061698:
        dc.w    $0005
        dc.l    $EC010000, $0000FFF0, $EC050002, $0001FFF8
        dc.l    $FC090006, $0003FFF0, $0C01000C, $0006FFF8
        dc.l    $0C05000E, $00070000
loc_0616C2:
        dc.w    $0004
        dc.l    $E4050000, $0000FFF8, $EC030004, $0002FFF0
        dc.l    $F4090008, $0004FFF8, $0409000E, $0007FFF8
loc_0616E4:
        dc.w    $0004
        dc.l    $E4050000, $0000FFF8, $EC030004, $0002FFF0
        dc.l    $F4050008, $0004FFF8, $0409000C, $0006FFF8
loc_061706:
        dc.w    $0002
        dc.l    $F40B0000, $0000FFE1, $0405000C, $0006FFF9
loc_061718:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFEE, $040D000C, $0006FFEE
loc_06172A:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFF0, $0405000C, $0006FFF8
loc_06173C:
        dc.w    $0004
        dc.l    $E4070000, $0000FFF0, $04050008, $0004FFF0
        dc.l    $E4070800, $08000000, $04050808, $08040000
loc_06175E:
        dc.w    $0004
        dc.l    $EA0D0000, $0000FFEC, $FA090008, $0004FFEC
        dc.l    $FA07000E, $00070004, $0A050016, $000BFFEC
loc_061780:
        dc.w    $0002
        dc.l    $EB0D0000, $0000FFEC, $FB0F0008, $0004FFF2
loc_061792:
        dc.w    $0002
        dc.l    $EC0D0000, $0000FFEC, $FC0F0008, $0004FFF3
loc_0617A4:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFEC, $FC0D0008, $0004FFF3
        dc.l    $0C050010, $0008FFF8
loc_0617BE:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFEC, $FC0D0008, $0004FFF3
        dc.l    $0C050010, $0008FFF5
loc_0617D8:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFED, $FC0D0008, $0004FFED
        dc.l    $0C050010, $0008FFF5
loc_0617F2:
        dc.w    $0004
        dc.l    $EC090000, $0000FFF4, $FC0D0006, $0003FFEC
        dc.l    $FC01000E, $0007000C, $0C050010, $0008FFEC
loc_061814:
        dc.w    $0004
        dc.l    $EC090000, $0000FFF4, $FC0D0006, $0003FFF3
        dc.l    $0C01000E, $0007FFF3, $0C050010, $00080003
loc_061836:
        dc.w    $0003
        dc.l    $ED090000, $0000FFF4, $FD090006, $0003FFF4
        dc.l    $0D0D000C, $0006FFF4
loc_061850:
        dc.w    $0003
        dc.l    $ED0D0000, $0000FFED, $FD0D0008, $0004FFED
        dc.l    $0D050010, $0008FFFA
loc_06186A:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFEC, $FC0D0008, $0004FFF3
        dc.l    $0C050010, $0008FFFA
loc_061884:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFEC, $FC0D0008, $0004FFF3
        dc.l    $0C050010, $0008FFF3
loc_06189E:
        dc.w    $0004
        dc.l    $EB090000, $0000FFEB, $FB0D0006, $0003FFEB
        dc.l    $F305000E, $00070003, $0B010012, $0009FFFB
loc_0618C0:
        dc.w    $0005
        dc.l    $EC090000, $0000FFEC, $FC0D0006, $0003FFEC
        dc.l    $EC01000E, $00070004, $FC010010, $0008000C
        dc.l    $0C010012, $0009FFFF
loc_0618EA:
        dc.w    $0005
        dc.l    $ED090000, $0000FFED, $FD0D0006, $0003FFED
        dc.l    $ED01000E, $00070005, $FD010010, $0008000D
        dc.l    $0D010012, $00090000
loc_061914:
        dc.w    $0004
        dc.l    $EE090000, $0000FFED, $EE010006, $00030005
        dc.l    $FE0D0008, $0004FFED, $06090010, $0008FFFD
loc_061936:
        dc.w    $0004
        dc.l    $EE090000, $0000FFED, $EE010006, $00030005
        dc.l    $FE0D0008, $0004FFED, $06050010, $00080005
loc_061958:
        dc.w    $0004
        dc.l    $EE090000, $0000FFED, $FE090006, $0003FFED
        dc.l    $F603000C, $00060005, $0E010010, $0008FFFD
loc_06197A:
        dc.w    $0004
        dc.l    $EC090000, $0000FFED, $F4050006, $00030005
        dc.l    $FC09000A, $0005FFED, $0C010010, $0008FFFD
loc_06199C:
        dc.w    $0004
        dc.l    $EC090000, $0000FFED, $F7050006, $00030005
        dc.l    $FC09000A, $0005FFED, $0C010010, $0008FFFD
loc_0619BE:
        dc.w    $0005
        dc.l    $ED090000, $0000FFEE, $ED010006, $00030006
        dc.l    $FD090008, $0004FFEF, $FD05000E, $00070007
        dc.l    $0D010012, $0009FFFF
loc_0619E8:
        dc.w    $0004
        dc.l    $EE090000, $0000FFEE, $FE090006, $0003FFEE
        dc.l    $F601000C, $00060006, $0605000E, $00070006
loc_061A0A:
        dc.w    $0004
        dc.l    $EE090000, $0000FFED, $FE090006, $0003FFED
        dc.l    $F601000C, $00060005, $0605000E, $00070005
loc_061A2C:
        dc.w    $0004
        dc.l    $ED090000, $0000FFED, $FD090006, $0003FFED
        dc.l    $ED03000C, $00060005, $0D050010, $0008FFFF
loc_061A4E:
        dc.w    $0003
        dc.l    $F5070000, $0000FFEA, $ED0B0008, $0004FFFA
        dc.l    $0D050014, $000A0002
loc_061A68:
        dc.w    $0002
        dc.l    $F5070000, $0000FFEB, $EF0B0008, $0004FFFB
loc_061A7A:
        dc.w    $0002
        dc.l    $F5070000, $0000FFEC, $EE0B0008, $0004FFFC
loc_061A8C:
        dc.w    $0002
        dc.l    $F5070000, $0000FFEC, $EE0B0008, $0004FFFC
loc_061A9E:
        dc.w    $0003
        dc.l    $F5070000, $0000FFEC, $EF050008, $0004FFFC
        dc.l    $FF09000C, $0006FFFC
loc_061AB8:
        dc.w    $0003
        dc.l    $F4070000, $0000FFEC, $EC050008, $0004FFFC
        dc.l    $FC09000C, $0006FFFC
loc_061AD2:
        dc.w    $0003
        dc.l    $F5070000, $0000FFEC, $ED050008, $0004FFFC
        dc.l    $FD0B000C, $0006FFFC
loc_061AEC:
        dc.w    $0002
        dc.l    $F5070000, $0000FFEC, $ED0B0008, $0004FFFC
loc_061AFE:
        dc.w    $0002
        dc.l    $F5070000, $0000FFED, $ED0B0008, $0004FFFD
loc_061B10:
        dc.w    $0002
        dc.l    $F4070000, $0000FFED, $F40B0008, $0004FFFD
loc_061B22:
        dc.w    $0002
        dc.l    $F5070000, $0000FFEC, $EE0B0008, $0004FFFC
loc_061B34:
        dc.w    $0003
        dc.l    $F5070000, $0000FFEC, $EE050008, $0004FFFC
        dc.l    $FE09000C, $0006FFFC
loc_061B4E:
        dc.w    $0004
        dc.l    $EE090000, $0000FFF3, $FE070006, $0003FFEB
        dc.l    $FE0D000E, $0007FFFB, $0E010016, $000BFFFB
loc_061B70:
        dc.w    $0004
        dc.l    $ED0D0000, $0000FFF4, $FD070008, $0004FFEC
        dc.l    $FD0D0010, $0008FFFC, $0D010018, $000CFFFC
loc_061B92:
        dc.w    $0005
        dc.l    $EC0D0000, $0000FFF5, $EC010008, $00040015
        dc.l    $FC07000A, $0005FFED, $FC090012, $0009FFFD
        dc.l    $0C010018, $000CFFFD
loc_061BBC:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFF6, $FC070008, $0004FFEE
        dc.l    $FC090010, $0008FFFE, $0C010016, $000BFFFE
loc_061BDE:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFF6, $FC070008, $0004FFEE
        dc.l    $FC050010, $0008FFFE, $0C010014, $000AFFFE
loc_061C00:
        dc.w    $0004
        dc.l    $EC010000, $0000FFF6, $F4090002, $0001FFFE
        dc.l    $FC070008, $0004FFEE, $04050010, $0008FFFE
loc_061C22:
        dc.w    $0004
        dc.l    $EC050000, $0000FFF4, $FC070004, $0002FFEC
        dc.l    $FC0D000C, $0006FFFC, $0C050014, $000AFFFC
loc_061C44:
        dc.w    $0004
        dc.l    $EC050000, $0000FFF4, $FC070004, $0002FFEC
        dc.l    $FC09000C, $0006FFFC, $0C010012, $0009FFFC
loc_061C66:
        dc.w    $0004
        dc.l    $EB090000, $0000FFF5, $FB070006, $0003FFED
        dc.l    $FB09000E, $0007FFFD, $0B010014, $000AFFFD
loc_061C88:
        dc.w    $0004
        dc.l    $EB0D0000, $0000FFF6, $FB070008, $0004FFEE
        dc.l    $FB050010, $0008FFFE, $0B010014, $000AFFFE
loc_061CAA:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFF6, $FC070008, $0004FFEE
        dc.l    $FC050010, $0008FFFE, $0C010014, $000AFFFE
loc_061CCC:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFF5, $FC070008, $0004FFED
        dc.l    $FC090010, $0008FFFD, $0C010016, $000BFFFD
loc_061CEE:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFF0, $F00F0000, $0000FFF0
loc_061D00:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFF0, $F00F0000, $0000FFF0
loc_061D12:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFF0, $F00F0000, $0000FFF0
loc_061D24:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFF0, $F00F0000, $0000FFF0
loc_061D36:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFED, $F10F0000, $0000FFF1
loc_061D48:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFED, $F10F0000, $0000FFF1
loc_061D5A:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFED, $F10F0000, $0000FFF1
loc_061D6C:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFED, $F10F0000, $0000FFF1
loc_061D7E:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFEA, $F20F0000, $0000FFF2
loc_061D90:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFEA, $F20F0000, $0000FFF2
loc_061DA2:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFEA, $F20F0000, $0000FFF2
loc_061DB4:
        dc.w    $0002
        dc.l    $F40F0010, $0008FFEA, $F20F0000, $0000FFF2
loc_061DC6:
        dc.w    $0002
        dc.l    $F60F0010, $0008FFF9, $EA0F0000, $0000FFED
loc_061DD8:
        dc.w    $0002
        dc.l    $F60F0010, $0008FFF9, $EA0F0000, $0000FFED
loc_061DEA:
        dc.w    $0002
        dc.l    $F60F0010, $0008FFF9, $EA0F0000, $0000FFED
loc_061DFC:
        dc.w    $0002
        dc.l    $F60F0010, $0008FFF9, $EA0F0000, $0000FFED
loc_061E0E:
        dc.w    $0002
        dc.l    $F80F0010, $0008FFF7, $EA0F0000, $0000FFEE
loc_061E20:
        dc.w    $0002
        dc.l    $F80F0010, $0008FFF7, $EA0F0000, $0000FFEE
loc_061E32:
        dc.w    $0002
        dc.l    $F80F0010, $0008FFF7, $EA0F0000, $0000FFEE
loc_061E44:
        dc.w    $0002
        dc.l    $F80F0010, $0008FFF7, $EA0F0000, $0000FFEE
loc_061E56:
        dc.w    $0002
        dc.l    $FA0F0010, $0008FFF5, $EA0F0000, $0000FFEF
loc_061E68:
        dc.w    $0002
        dc.l    $FA0F0010, $0008FFF5, $EA0F0000, $0000FFEF
loc_061E7A:
        dc.w    $0002
        dc.l    $FA0F0010, $0008FFF5, $EA0F0000, $0000FFEF
loc_061E8C:
        dc.w    $0002
        dc.l    $FA0F0010, $0008FFF5, $EA0F0000, $0000FFEF
loc_061E9E:
        dc.w    $0002
        dc.l    $F00B000C, $0006FFFC, $F00B0000, $0000FFF0
loc_061EB0:
        dc.w    $0002
        dc.l    $F00B000C, $0006FFFC, $F00B0000, $0000FFF0
loc_061EC2:
        dc.w    $0002
        dc.l    $F00B000C, $0006FFFC, $F00B0000, $0000FFF0
loc_061ED4:
        dc.w    $0002
        dc.l    $F00B000C, $0006FFFC, $F00B0000, $0000FFF0
loc_061EE6:
        dc.w    $0002
        dc.l    $F30B000C, $0006FFFC, $EF0B0000, $0000FFF1
loc_061EF8:
        dc.w    $0002
        dc.l    $F30B000C, $0006FFFC, $EF0B0000, $0000FFF1
loc_061F0A:
        dc.w    $0002
        dc.l    $F30B000C, $0006FFFC, $EF0B0000, $0000FFF1
loc_061F1C:
        dc.w    $0002
        dc.l    $F30B000C, $0006FFFC, $EF0B0000, $0000FFF1
loc_061F2E:
        dc.w    $0002
        dc.l    $F60B000C, $0006FFFC, $EE0B0000, $0000FFF2
loc_061F40:
        dc.w    $0002
        dc.l    $F60B000C, $0006FFFC, $EE0B0000, $0000FFF2
loc_061F52:
        dc.w    $0002
        dc.l    $F60B000C, $0006FFFC, $EE0B0000, $0000FFF2
loc_061F64:
        dc.w    $0002
        dc.l    $F60B000C, $0006FFFC, $EE0B0000, $0000FFF2
loc_061F76:
        dc.w    $0002
        dc.l    $E70F0010, $0008FFF6, $F30F0000, $0000FFEA
loc_061F88:
        dc.w    $0002
        dc.l    $E70B0010, $0008FFFE, $F30F0000, $0000FFEA
loc_061F9A:
        dc.w    $0002
        dc.l    $E70F0010, $0008FFF6, $F30F0000, $0000FFEA
loc_061FAC:
        dc.w    $0002
        dc.l    $E70B0010, $0008FFFE, $F30F0000, $0000FFEA
loc_061FBE:
        dc.w    $0002
        dc.l    $E90F0010, $0008FFF8, $F20F0000, $0000FFEA
loc_061FD0:
        dc.w    $0002
        dc.l    $E90B0010, $00080000, $F20F0000, $0000FFEA
loc_061FE2:
        dc.w    $0002
        dc.l    $E90F0010, $0008FFF8, $F20F0000, $0000FFEA
loc_061FF4:
        dc.w    $0002
        dc.l    $E90B0010, $00080000, $F20F0000, $0000FFEA
loc_062006:
        dc.w    $0002
        dc.l    $EB0F0010, $0008FFFA, $F10F0000, $0000FFEA
loc_062018:
        dc.w    $0002
        dc.l    $EB0B0010, $00080002, $F10F0000, $0000FFEA
loc_06202A:
        dc.w    $0002
        dc.l    $EB0F0010, $0008FFFA, $F10F0000, $0000FFEA
loc_06203C:
        dc.w    $0002
        dc.l    $EB0B0010, $00080002, $F10F0000, $0000FFEA
loc_06204E:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_062058:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_062062:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_06206C:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_062076:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_062080:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_06208A:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_062094:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_06209E:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_0620A8:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_0620B2:
        dc.w    $0001
        dc.l    $F80F0000, $0000FFF4
loc_0620BC:
        dc.w    $0003
        dc.l    $E5090000, $0000FFF8, $F5090006, $0003FFF8
        dc.l    $050D000C, $0006FFF0
loc_0620D6:
        dc.w    $0003
        dc.l    $E5090000, $0000FFF8, $F5090006, $0003FFF8
        dc.l    $0509000C, $0006FFF8
loc_0620F0:
        dc.w    $0003
        dc.l    $E5090000, $0000FFF8, $F5090006, $0003FFF8
        dc.l    $050D000C, $0006FFF0
loc_06210A:
        dc.w    $0003
        dc.l    $E5090000, $0000FFF8, $F5090006, $0003FFF8
        dc.l    $0509000C, $0006FFF8
loc_062124:
        dc.w    $0004
        dc.l    $E40B0000, $0000FFE8, $F405000C, $00060000
        dc.l    $04011010, $1008FFE8, $040D0012, $0009FFF0
loc_062146:
        dc.w    $0004
        dc.l    $E40B0000, $0000FFE8, $F405000C, $00060000
        dc.l    $04011010, $1008FFE8, $040D0012, $0009FFF0
loc_062168:
        dc.w    $0004
        dc.l    $E40B0000, $0000FFE8, $F405000C, $00060000
        dc.l    $04011010, $1008FFE8, $040D0012, $0009FFF0
loc_06218A:
        dc.w    $0003
        dc.l    $E5030000, $0000FFF0, $E5070004, $0002FFF8
        dc.l    $0505000C, $0006FFF8
loc_0621A4:
        dc.w    $0001
        dc.l    $F40B0000, $0000FFF6
loc_0621AE:
        dc.w    $0001
        dc.l    $F40F0000, $0000FFF2
loc_0621B8:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $E8030008, $00040000
        dc.l    $0805000C, $00060000
loc_0621D2:
        dc.w    $0003
        dc.l    $ED070000, $0000FFF0, $E5030008, $00040000
        dc.l    $0505000C, $00060000
loc_0621EC:
        dc.w    $0003
        dc.l    $EE0B0000, $0000FFF0, $FE01000C, $00060008
        dc.l    $0E05000E, $00070000
loc_062206:
        dc.w    $0003
        dc.l    $ED0B0000, $0000FFF0, $FD01000C, $00060008
        dc.l    $0D05000E, $00070000
loc_062220:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFF4, $040D000C, $0006FFF4
loc_062232:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFF8, $0409000C, $0006FFF8
loc_062244:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFF0, $040D000C, $0006FFF0
loc_062256:
        dc.w    $0002
        dc.l    $F40F0000, $0000FFE8, $04010010, $00080008
loc_062268:
        dc.w    $0004
        dc.l    $E4090000, $0000FFF6, $F40D0006, $0003FFF2
        dc.l    $040D000E, $0007FFEE, $04010016, $000B000E
loc_06228A:
        dc.w    $0002
        dc.l    $E40B0000, $0000FFF9, $040D000C, $0006FFEF
loc_06229C:
        dc.w    $0003
        dc.l    $E4090000, $0000FFFD, $F40D0006, $0003FFFB
        dc.l    $0405000E, $00070002
loc_0622B6:
        dc.w    $0003
        dc.l    $E4090000, $0000FFFC, $F40D0006, $0003FFFA
        dc.l    $0405000E, $00070002
loc_0622D0:
        dc.w    $0002
        dc.l    $F8010000, $0000FFEC, $F00F0002, $0001FFF4
loc_0622E2:
        dc.w    $0002
        dc.l    $F0030000, $0000FFEC, $F00F0004, $0002FFF4
loc_0622F4:
        dc.w    $0002
        dc.l    $EC0F0000, $0000FFE8, $EC070010, $00080008
loc_062306:
        dc.w    $0002
        dc.l    $EC0F0000, $0000FFE8, $EC070010, $00080008
loc_062318:
        dc.w    $0004
        dc.l    $FC050000, $0000FFEC, $F40D0004, $0002FFFC
        dc.l    $0401000C, $0006FFFC, $0405000E, $00070004
loc_06233A:
        dc.w    $0004
        dc.l    $F4090000, $0000FFE8, $04050006, $0003FFF0
        dc.l    $F4090800, $08000000, $04050806, $08030000
loc_06235C:
        dc.w    $0004
        dc.l    $FC050800, $08000004, $F40D0804, $0802FFE4
        dc.l    $0401080C, $0806FFFC, $0405080E, $0807FFEC
loc_06237E:
        dc.w    $0003
        dc.l    $F40D0000, $0000FFE4, $04090008, $0004FFEC
        dc.l    $FC01000E, $00070004
loc_062398:
        dc.w    $0003
        dc.l    $F40D0800, $0800FFFC, $04090808, $0804FFFC
        dc.l    $FC01080E, $0807FFF4
loc_0623B2:
        dc.w    $0004
        dc.l    $F40D0000, $0000FFFC, $FC050008, $0004FFEC
        dc.l    $0401000C, $0006FFFC, $0405000E, $00070004
loc_0623D4:
        dc.w    $0003
        dc.l    $E4090000, $0000FFF4, $F40F0006, $0003FFEC
        dc.l    $04010016, $000B000C
loc_0623EE:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFEA, $EC010008, $0004000A
        dc.l    $FC09000A, $0005FFF2, $0C0D0010, $0008FFF2
loc_062410:
        dc.w    $0004
        dc.l    $EC0D0000, $0000FFEA, $EC010008, $0004000A
        dc.l    $FC09000A, $0005FFF2, $0C0D0010, $0008FFF2
loc_062432:
        dc.w    $0003
        dc.l    $EC0D0000, $0000FFEA, $EC010008, $0004000A
        dc.l    $FC0B000A, $0005FFF2
loc_06244C:
        dc.w    $0003
        dc.l    $E4090000, $0000FFF0, $F40B0006, $0003FFF0
        dc.l    $F4010012, $00090008
loc_062466:
        dc.w    $0003
        dc.l    $E50B0000, $0000FFF0, $F401000C, $00060008
        dc.l    $0505000E, $0007FFF8
loc_062480:
        dc.w    $0002
        dc.l    $EC0B0000, $0000FFF1, $FC01000C, $00060009
loc_062492:
        dc.w    $0001
        dc.l    $EE0F0000, $0000FFF0
loc_06249C:
        dc.w    $0002
        dc.l    $F20B0000, $0000FFF0, $FA01000C, $00060008
loc_0624AE:
        dc.w    $0003
        dc.l    $E4010000, $00000000, $F40B0002, $0001FFF0
        dc.l    $F401000E, $00070008
loc_0624C8:
        dc.w    $0003
        dc.l    $E5090000, $0000FFF0, $F50B0006, $0003FFF0
        dc.l    $ED030012, $00090008
loc_0624E2:
        dc.w    $0003
        dc.l    $E4050000, $0000FFF8, $F40B0004, $0002FFF0
        dc.l    $F4010010, $00080008
loc_0624FC:
        dc.w    $0002
        dc.l    $ED0B0000, $0000FFF0, $F501000C, $00060008
loc_06250E:
        dc.w    $0002
        dc.l    $F4010000, $0000FFF0, $F10B0002, $0001FFF8
loc_062520:
        dc.w    $0003
        dc.l    $E4050000, $0000FFF1, $F40B0004, $0002FFF0
        dc.l    $F4010010, $00080008
loc_06253A:
        dc.w    $0002
        dc.l    $E1050000, $0000FFF0, $F10F0004, $0002FFF0               
Tails_Sprites: ; loc_06254C:
        incbin  'data\sprites\tails.dat'              
Sonic_Dyn_Script: ; loc_06DA4C:           
        dc.w    loc_06DB9A-Sonic_Dyn_Script
        dc.w    loc_06DB9C-Sonic_Dyn_Script 
        dc.w    loc_06DBA6-Sonic_Dyn_Script 
        dc.w    loc_06DBAC-Sonic_Dyn_Script 
        dc.w    loc_06DBB8-Sonic_Dyn_Script
        dc.w    loc_06DBC4-Sonic_Dyn_Script
        dc.w    loc_06DBD0-Sonic_Dyn_Script
        dc.w    loc_06DBDA-Sonic_Dyn_Script
        dc.w    loc_06DBE4-Sonic_Dyn_Script
        dc.w    loc_06DBEA-Sonic_Dyn_Script
        dc.w    loc_06DBF0-Sonic_Dyn_Script
        dc.w    loc_06DBF6-Sonic_Dyn_Script
        dc.w    loc_06DC00-Sonic_Dyn_Script
        dc.w    loc_06DC0A-Sonic_Dyn_Script
        dc.w    loc_06DC10-Sonic_Dyn_Script  
        dc.w    loc_06DC16-Sonic_Dyn_Script 
        dc.w    loc_06DC1E-Sonic_Dyn_Script
        dc.w    loc_06DC26-Sonic_Dyn_Script
        dc.w    loc_06DC2E-Sonic_Dyn_Script
        dc.w    loc_06DC38-Sonic_Dyn_Script
        dc.w    loc_06DC42-Sonic_Dyn_Script
        dc.w    loc_06DC4A-Sonic_Dyn_Script
        dc.w    loc_06DC52-Sonic_Dyn_Script
        dc.w    loc_06DC5A-Sonic_Dyn_Script
        dc.w    loc_06DC62-Sonic_Dyn_Script
        dc.w    loc_06DC6C-Sonic_Dyn_Script
        dc.w    loc_06DC78-Sonic_Dyn_Script
        dc.w    loc_06DC84-Sonic_Dyn_Script
        dc.w    loc_06DC8E-Sonic_Dyn_Script
        dc.w    loc_06DC98-Sonic_Dyn_Script  
        dc.w    loc_06DCA2-Sonic_Dyn_Script
        dc.w    loc_06DCAC-Sonic_Dyn_Script
        dc.w    loc_06DCB6-Sonic_Dyn_Script
        dc.w    loc_06DCC2-Sonic_Dyn_Script
        dc.w    loc_06DCCC-Sonic_Dyn_Script
        dc.w    loc_06DCD6-Sonic_Dyn_Script
        dc.w    loc_06DCE0-Sonic_Dyn_Script
        dc.w    loc_06DCE8-Sonic_Dyn_Script
        dc.w    loc_06DCEE-Sonic_Dyn_Script
        dc.w    loc_06DCF4-Sonic_Dyn_Script
        dc.w    loc_06DCFA-Sonic_Dyn_Script
        dc.w    loc_06DD02-Sonic_Dyn_Script
        dc.w    loc_06DD0A-Sonic_Dyn_Script
        dc.w    loc_06DD12-Sonic_Dyn_Script
        dc.w    loc_06DD18-Sonic_Dyn_Script
        dc.w    loc_06DD1E-Sonic_Dyn_Script
        dc.w    loc_06DD24-Sonic_Dyn_Script
        dc.w    loc_06DD2A-Sonic_Dyn_Script
        dc.w    loc_06DD32-Sonic_Dyn_Script
        dc.w    loc_06DD3C-Sonic_Dyn_Script
        dc.w    loc_06DD46-Sonic_Dyn_Script
        dc.w    loc_06DD52-Sonic_Dyn_Script
        dc.w    loc_06DD5C-Sonic_Dyn_Script
        dc.w    loc_06DD66-Sonic_Dyn_Script
        dc.w    loc_06DD70-Sonic_Dyn_Script
        dc.w    loc_06DD7A-Sonic_Dyn_Script
        dc.w    loc_06DD84-Sonic_Dyn_Script
        dc.w    loc_06DD8E-Sonic_Dyn_Script
        dc.w    loc_06DD98-Sonic_Dyn_Script        
        dc.w    loc_06DDA2-Sonic_Dyn_Script 
        dc.w    loc_06DDAC-Sonic_Dyn_Script 
        dc.w    loc_06DDB2-Sonic_Dyn_Script 
        dc.w    loc_06DDB8-Sonic_Dyn_Script 
        dc.w    loc_06DDBE-Sonic_Dyn_Script          
        dc.w    loc_06DDAC-Sonic_Dyn_Script 
        dc.w    loc_06DDB2-Sonic_Dyn_Script 
        dc.w    loc_06DDB8-Sonic_Dyn_Script 
        dc.w    loc_06DDBE-Sonic_Dyn_Script          
        dc.w    loc_06DDAC-Sonic_Dyn_Script 
        dc.w    loc_06DDB2-Sonic_Dyn_Script 
        dc.w    loc_06DDB8-Sonic_Dyn_Script 
        dc.w    loc_06DDBE-Sonic_Dyn_Script         
        dc.w    loc_06DDC4-Sonic_Dyn_Script 
        dc.w    loc_06DDCA-Sonic_Dyn_Script 
        dc.w    loc_06DDD0-Sonic_Dyn_Script
        dc.w    loc_06DDD6-Sonic_Dyn_Script          
        dc.w    loc_06DDC4-Sonic_Dyn_Script 
        dc.w    loc_06DDCA-Sonic_Dyn_Script 
        dc.w    loc_06DDD0-Sonic_Dyn_Script
        dc.w    loc_06DDD6-Sonic_Dyn_Script         
        dc.w    loc_06DDC4-Sonic_Dyn_Script 
        dc.w    loc_06DDCA-Sonic_Dyn_Script 
        dc.w    loc_06DDD0-Sonic_Dyn_Script
        dc.w    loc_06DDD6-Sonic_Dyn_Script         
        dc.w    loc_06DDDC-Sonic_Dyn_Script
        dc.w    loc_06DDE2-Sonic_Dyn_Script
        dc.w    loc_06DDE8-Sonic_Dyn_Script
        dc.w    loc_06DDEE-Sonic_Dyn_Script         
        dc.w    loc_06DDDC-Sonic_Dyn_Script
        dc.w    loc_06DDE2-Sonic_Dyn_Script
        dc.w    loc_06DDE8-Sonic_Dyn_Script
        dc.w    loc_06DDEE-Sonic_Dyn_Script         
        dc.w    loc_06DDDC-Sonic_Dyn_Script
        dc.w    loc_06DDE2-Sonic_Dyn_Script
        dc.w    loc_06DDE8-Sonic_Dyn_Script
        dc.w    loc_06DDEE-Sonic_Dyn_Script         
        dc.w    loc_06DDF4-Sonic_Dyn_Script
        dc.w    loc_06DDFA-Sonic_Dyn_Script
        dc.w    loc_06DE00-Sonic_Dyn_Script
        dc.w    loc_06DE06-Sonic_Dyn_Script         
        dc.w    loc_06DDF4-Sonic_Dyn_Script
        dc.w    loc_06DDFA-Sonic_Dyn_Script
        dc.w    loc_06DE00-Sonic_Dyn_Script
        dc.w    loc_06DE06-Sonic_Dyn_Script         
        dc.w    loc_06DDF4-Sonic_Dyn_Script
        dc.w    loc_06DDFA-Sonic_Dyn_Script
        dc.w    loc_06DE00-Sonic_Dyn_Script
        dc.w    loc_06DE06-Sonic_Dyn_Script         
        dc.w    loc_06DE0C-Sonic_Dyn_Script
        dc.w    loc_06DE10-Sonic_Dyn_Script
        dc.w    loc_06DE14-Sonic_Dyn_Script
        dc.w    loc_06DE18-Sonic_Dyn_Script
        dc.w    loc_06DE1C-Sonic_Dyn_Script
        dc.w    loc_06DE20-Sonic_Dyn_Script
        dc.w    loc_06DE24-Sonic_Dyn_Script
        dc.w    loc_06DE28-Sonic_Dyn_Script
        dc.w    loc_06DE2C-Sonic_Dyn_Script
        dc.w    loc_06DE30-Sonic_Dyn_Script
        dc.w    loc_06DE34-Sonic_Dyn_Script
        dc.w    loc_06DE38-Sonic_Dyn_Script
        dc.w    loc_06DE40-Sonic_Dyn_Script
        dc.w    loc_06DE48-Sonic_Dyn_Script
        dc.w    loc_06DE50-Sonic_Dyn_Script
        dc.w    loc_06DE58-Sonic_Dyn_Script
        dc.w    loc_06DE62-Sonic_Dyn_Script
        dc.w    loc_06DE6C-Sonic_Dyn_Script
        dc.w    loc_06DE76-Sonic_Dyn_Script
        dc.w    loc_06DE7E-Sonic_Dyn_Script
        dc.w    loc_06DE82-Sonic_Dyn_Script
        dc.w    loc_06DE86-Sonic_Dyn_Script
        dc.w    loc_06DE8E-Sonic_Dyn_Script
        dc.w    loc_06DE96-Sonic_Dyn_Script
        dc.w    loc_06DE9E-Sonic_Dyn_Script                   
        dc.w    loc_06DEA6-Sonic_Dyn_Script
        dc.w    loc_06DEAC-Sonic_Dyn_Script
        dc.w    loc_06DEB2-Sonic_Dyn_Script
        dc.w    loc_06DEB8-Sonic_Dyn_Script
        dc.w    loc_06DEBE-Sonic_Dyn_Script
        dc.w    loc_06DEC8-Sonic_Dyn_Script
        dc.w    loc_06DECE-Sonic_Dyn_Script
        dc.w    loc_06DED6-Sonic_Dyn_Script
        dc.w    loc_06DEDE-Sonic_Dyn_Script
        dc.w    loc_06DEE4-Sonic_Dyn_Script
        dc.w    loc_06DEEA-Sonic_Dyn_Script
        dc.w    loc_06DEF0-Sonic_Dyn_Script
        dc.w    loc_06DEF6-Sonic_Dyn_Script         
        dc.w    loc_06DF00-Sonic_Dyn_Script         
        dc.w    loc_06DEF6-Sonic_Dyn_Script         
        dc.w    loc_06DF06-Sonic_Dyn_Script         
        dc.w    loc_06DF06-Sonic_Dyn_Script         
        dc.w    loc_06DF0E-Sonic_Dyn_Script
        dc.w    loc_06DF18-Sonic_Dyn_Script
        dc.w    loc_06DF20-Sonic_Dyn_Script
        dc.w    loc_06DF2A-Sonic_Dyn_Script
        dc.w    loc_06DF34-Sonic_Dyn_Script
        dc.w    loc_06DF3C-Sonic_Dyn_Script
        dc.w    loc_06DF44-Sonic_Dyn_Script
        dc.w    loc_06DF4C-Sonic_Dyn_Script
        dc.w    loc_06DF52-Sonic_Dyn_Script
        dc.w    loc_06DF56-Sonic_Dyn_Script
        dc.w    loc_06DF5C-Sonic_Dyn_Script
        dc.w    loc_06DF64-Sonic_Dyn_Script
        dc.w    loc_06DF6C-Sonic_Dyn_Script
        dc.w    loc_06DF74-Sonic_Dyn_Script
        dc.w    loc_06DF7A-Sonic_Dyn_Script
        dc.w    loc_06DF80-Sonic_Dyn_Script
        dc.w    loc_06DF88-Sonic_Dyn_Script 
loc_06DB9A:                       
        dc.w    $0000  
loc_06DB9C:    
        dc.w    $0004              ; Total of Animations
        dc.w    $3000, $3004, $5008, $500E ; Frames/Tiles
loc_06DBA6:               
        dc.w    $0002              ; Total of Animations
        dc.w    $B014, $5020               ; Frames/Tiles
loc_06DBAC:        
        dc.w    $0005
        dc.w    $1026, $3028, $502C, $1032, $3034 
loc_06DBB8:        
        dc.w    $0005
        dc.w    $1026, $3038, $502C, $1032, $3034
loc_06DBC4:  
        dc.w    $0005
        dc.w    $1026, $3038, $502C, $1032, $303C
loc_06DBD0:             
        dc.w    $0004
        dc.w    $3040, $3044, $5048, $500E
loc_06DBDA:             
        dc.w    $0004
        dc.w    $304E, $3052, $3056, $500E
loc_06DBE4:        
        dc.w    $0002
        dc.w    $B05A, $3066
loc_06DBEA:
        dc.w    $0002
        dc.w    $B06A, $7076
loc_06DBF0:    
        dc.w    $0002
        dc.w    $B07E, $308A
loc_06DBF6:
        dc.w    $0004
        dc.w    $708E, $3096, $708E, $3096
loc_06DC00:    
        dc.w    $0004
        dc.w    $709A, $50A2, $70A8, $30B0
loc_06DC0A:
        dc.w    $0002
        dc.w    $709A, $F0B4
loc_06DC10:
        dc.w    $0002
        dc.w    $709A, $F0C4
loc_06DC16:
        dc.w    $0003
        dc.w    $70D4, $70DC, $30E4
loc_06DC1E:
        dc.w    $0003
        dc.w    $70D4, $70E8, $30F0
loc_06DC26:
        dc.w    $0003
        dc.w    $70F4, $70FC, $3104
loc_06DC2E:
        dc.w    $0004
        dc.w    $5108, $710E, $1116, $3118
loc_06DC38:
        dc.w    $0004
        dc.w    $5108, $711C, $1124, $3126
loc_06DC42:
        dc.w    $0003
        dc.w    $5108, $512A, $7130 
loc_06DC4A:
        dc.w    $0003
        dc.w    $70F4, $7138, $3140
loc_06DC52:
        dc.w    $0003
        dc.w    $70D4, $7144, $314C
loc_06DC5A:
        dc.w    $0003
        dc.w    $709A, $7150, $3158
loc_06DC62:
        dc.w    $0004
        dc.w    $515C, $7162, $316A, $116E
loc_06DC6C:
        dc.w    $0005
        dc.w    $515C, $7170, $1178, $117A, $117C
loc_06DC78:
        dc.w    $0005
        dc.w    $515C, $717E, $1186, $1188, $118A
loc_06DC84:
        dc.w    $0004
        dc.w    $518C, $1192, $7194, $519C
loc_06DC8E:
        dc.w    $0004
        dc.w    $518C, $1192, $71A2, $31AA
loc_06DC98:            
        dc.w    $0004
        dc.w    $51AE, $51B4, $31BA, $11BE
loc_06DCA2:
        dc.w    $0004
        dc.w    $51C0, $31C6, $51CA, $11D0
loc_06DCAC:
        dc.w    $0004
        dc.w    $51C0, $31D2, $51D6, $11DC
loc_06DCB6:
        dc.w    $0005
        dc.w    $51C0, $11DE, $51E0, $31E6, $11EA
loc_06DCC2:
        dc.w    $0004
        dc.w    $51AE, $51EC, $11F2, $31F4
loc_06DCCC:
        dc.w    $0004
        dc.w    $518C, $51F8, $11FE, $3200
loc_06DCD6:
        dc.w    $0004
        dc.w    $515C, $5204, $320A, $320E
loc_06DCE0:
        dc.w    $0003
        dc.w    $7212, $B21A, $3226
loc_06DCE8:
        dc.w    $0002
        dc.w    $7212, $B22A
loc_06DCEE:
        dc.w    $0002
        dc.w    $7212, $B236
loc_06DCF4:
        dc.w    $0002
        dc.w    $7242, $B24A
loc_06DCFA:
        dc.w    $0003
        dc.w    $7242, $3256, $525A
loc_06DD02:
        dc.w    $0003
        dc.w    $7260, $3268, $526C
loc_06DD0A:
        dc.w    $0003
        dc.w    $7272, $327A, $B27E
loc_06DD12:
        dc.w    $0002
        dc.w    $7272, $B28A
loc_06DD18:
        dc.w    $0002
        dc.w    $7272, $B296
loc_06DD1E:
        dc.w    $0002
        dc.w    $7260, $B2A2
loc_06DD24:
        dc.w    $0002
        dc.w    $7242, $B2AE
loc_06DD2A:
        dc.w    $0003
        dc.w    $7212, $32BA, $52BE
loc_06DD32:
        dc.w    $0004
        dc.w    $52C4, $72CA, $72D2, $12DA
loc_06DD3C:
        dc.w    $0004
        dc.w    $72DC, $72CA, $72E4, $12DA
loc_06DD46:
        dc.w    $0005
        dc.w    $72EC, $12F4, $72CA, $52F6, $12DA
loc_06DD52:
        dc.w    $0004
        dc.w    $72FC, $7304, $530C, $1312
loc_06DD5C:
        dc.w    $0004
        dc.w    $7314, $7304, $331C, $1312
loc_06DD66:
        dc.w    $0004
        dc.w    $1320, $5322, $7328, $3330
loc_06DD70:
        dc.w    $0004
        dc.w    $3334, $7338, $7340, $3348
loc_06DD7A:
        dc.w    $0004
        dc.w    $334C, $7338, $5350, $1348
loc_06DD84:
        dc.w    $0004
        dc.w    $5356, $7338, $535C, $1348
loc_06DD8E:
        dc.w    $0004
        dc.w    $7362, $7328, $336A, $136E
loc_06DD98:  
        dc.w    $0004
        dc.w    $7370, $7304, $3378, $1312          
loc_06DDA2:
        dc.w    $0004
        dc.w    $737C, $72CA, $5384, $12DA
loc_06DDAC:
        dc.w    $0002
        dc.w    $F38A, $F3AA
loc_06DDB2:
        dc.w    $0002
        dc.w    $F39A, $F3BA
loc_06DDB8:
        dc.w    $0002
        dc.w    $F38A, $F3CA
loc_06DDBE:
        dc.w    $0002
        dc.w    $F39A, $F3DA 
loc_06DDC4:
        dc.w    $0002
        dc.w    $F3EA, $F40A
loc_06DDCA:
        dc.w    $0002
        dc.w    $F3EA, $F41A
loc_06DDD0:
        dc.w    $0002
        dc.w    $F3EA, $F42A
loc_06DDD6:
        dc.w    $0002
        dc.w    $F3EA, $F43A
loc_06DDDC:
        dc.w    $0002
        dc.w    $B44A, $B462
loc_06DDE2:
        dc.w    $0002
        dc.w    $B456, $B46E
loc_06DDE8:
        dc.w    $0002
        dc.w    $B44A, $B47A
loc_06DDEE:
        dc.w    $0002
        dc.w    $B456, $B486
loc_06DDF4:
        dc.w    $0002
        dc.w    $F492, $F4B2
loc_06DDFA:
        dc.w    $0002
        dc.w    $F4A2, $B4C2
loc_06DE00:
        dc.w    $0002
        dc.w    $F492, $F4CE
loc_06DE06:
        dc.w    $0002
        dc.w    $F4A2, $B4DE  
loc_06DE0C:
        dc.w    $0001
        dc.w    $F4EA
loc_06DE10:
        dc.w    $0001
        dc.w    $F4FA
loc_06DE14:
        dc.w    $0001
        dc.w    $F50A
loc_06DE18:
        dc.w    $0001
        dc.w    $F51A
loc_06DE1C:
        dc.w    $0001
        dc.w    $F52A
loc_06DE20:
        dc.w    $0001
        dc.w    $F53A
loc_06DE24:
        dc.w    $0001
        dc.w    $F54A
loc_06DE28:
        dc.w    $0001
        dc.w    $F55A
loc_06DE2C:
        dc.w    $0001
        dc.w    $F56A
loc_06DE30:
        dc.w    $0001
        dc.w    $F57A
loc_06DE34:
        dc.w    $0001
        dc.w    $F58A
loc_06DE38:
        dc.w    $0003
        dc.w    $559A, $55A0, $75A6
loc_06DE40:
        dc.w    $0003
        dc.w    $559A, $55AE, $55B4
loc_06DE48:
        dc.w    $0003
        dc.w    $559A, $55A0, $75BA
loc_06DE50:
        dc.w    $0003
        dc.w    $559A, $55AE, $55C2
loc_06DE58:
        dc.w    $0004
        dc.w    $B5C8, $35D4, $108E, $75D8
loc_06DE62:
        dc.w    $0004
        dc.w    $B5C8, $35D4, $108E, $75E0
loc_06DE6C:
        dc.w    $0004
        dc.w    $B5C8, $35D4, $108E, $75E8
loc_06DE76:
        dc.w    $0003
        dc.w    $3052, $75F0, $35F8
loc_06DE7E:
        dc.w    $0001
        dc.w    $B5FC
loc_06DE82:
        dc.w    $0001
        dc.w    $F608
loc_06DE86:
        dc.w    $0003
        dc.w    $7618, $3620, $3624
loc_06DE8E:
        dc.w    $0003
        dc.w    $7628, $3630, $3634
loc_06DE96:
        dc.w    $0003
        dc.w    $B638, $1644, $3646
loc_06DE9E:  
        dc.w    $0003
        dc.w    $B64A, $1656, $3658
loc_06DEA6:   
        dc.w    $0002
        dc.w    $B65C, $7668
loc_06DEAC:
        dc.w    $0002
        dc.w    $B670, $567C
loc_06DEB2:
        dc.w    $0002
        dc.w    $B682, $768E
loc_06DEB8:
        dc.w    $0002
        dc.w    $F696, $16A6
loc_06DEBE:
        dc.w    $0004
        dc.w    $56A8, $76AE, $76B6, $16BE
loc_06DEC8:
        dc.w    $0002
        dc.w    $B6C0, $76CC
loc_06DECE:
        dc.w    $0003
        dc.w    $56D4, $76DA, $36E2
loc_06DED6:
        dc.w    $0003
        dc.w    $56D4, $76E6, $36E2
loc_06DEDE:
        dc.w    $0002
        dc.w    $16EE, $F6F0
loc_06DEE4:
        dc.w    $0002
        dc.w    $3700, $F704
loc_06DEEA:
        dc.w    $0002
        dc.w    $F714, $7724
loc_06DEF0:
        dc.w    $0002
        dc.w    $F72C, $773C
loc_06DEF6:
        dc.w    $0004
        dc.w    $3744, $7748, $1750, $3752
loc_06DF00:
        dc.w    $0002
        dc.w    $5756, $375C
loc_06DF06:
        dc.w    $0003
        dc.w    $7760, $5768, $176E
loc_06DF0E:
        dc.w    $0004
        dc.w    $7770, $3778, $177C, $3752
loc_06DF18:
        dc.w    $0003
        dc.w    $577E, $F784, $1794
loc_06DF20:
        dc.w    $0004
        dc.w    $7796, $179E, $57A0, $77A6
loc_06DF2A:
        dc.w    $0004
        dc.w    $77AE, $179E, $57B6, $77A6
loc_06DF34:
        dc.w    $0003
        dc.w    $77BC, $17C4, $B7C6
loc_06DF3C:
        dc.w    $0003
        dc.w    $57D2, $B7D8, $17E4
loc_06DF44:
        dc.w    $0003
        dc.w    $B7E6, $17F2, $37F4
loc_06DF4C:
        dc.w    $0002
        dc.w    $B800, $180C
loc_06DF52:
        dc.w    $0001
        dc.w    $F80E
loc_06DF56:
        dc.w    $0002
        dc.w    $B81E, $182A
loc_06DF5C:
        dc.w    $0003
        dc.w    $182C, $B82E, $183A
loc_06DF64:
        dc.w    $0003
        dc.w    $583C, $B842, $384E
loc_06DF6C:
        dc.w    $0003
        dc.w    $3852, $B856, $1862
loc_06DF74:
        dc.w    $0002
        dc.w    $B864, $1870
loc_06DF7A:
        dc.w    $0002
        dc.w    $1872, $B874
loc_06DF80:
        dc.w    $0003
        dc.w    $3880, $B884, $1890
loc_06DF88:        
        dc.w    $0002
        dc.w    $3892, $F896
Shield: ; loc_06DF8E:
        incbin  'data\sprites\shield.nem'  
Invencibility_Stars: ; loc_06E114:                      
        incbin  'data\sprites\invstars.nem'  
Unused_Dust: ; loc_06E1FC:   
        incbin  'data\sprites\dust.dat'         
Tails_Mappings: ; loc_06FB3C: 
        dc.w    loc_06FC46-Tails_Mappings
        dc.w    loc_06FC48-Tails_Mappings
        dc.w    loc_06FC5A-Tails_Mappings
        dc.w    loc_06FC6C-Tails_Mappings
        dc.w    loc_06FC7E-Tails_Mappings
        dc.w    loc_06FC90-Tails_Mappings
        dc.w    loc_06FC9A-Tails_Mappings
        dc.w    loc_06FCA4-Tails_Mappings
        dc.w    loc_06FCB6-Tails_Mappings
        dc.w    loc_06FCC8-Tails_Mappings
        dc.w    loc_06FCD2-Tails_Mappings
        dc.w    loc_06FCDC-Tails_Mappings
        dc.w    loc_06FCE6-Tails_Mappings
        dc.w    loc_06FCF0-Tails_Mappings
        dc.w    loc_06FCFA-Tails_Mappings
        dc.w    loc_06FD14-Tails_Mappings
        dc.w    loc_06FD2E-Tails_Mappings
        dc.w    loc_06FD48-Tails_Mappings
        dc.w    loc_06FD62-Tails_Mappings
        dc.w    loc_06FD7C-Tails_Mappings
        dc.w    loc_06FD96-Tails_Mappings
        dc.w    loc_06FDB0-Tails_Mappings
        dc.w    loc_06FDCA-Tails_Mappings
        dc.w    loc_06FDE4-Tails_Mappings
        dc.w    loc_06FDFE-Tails_Mappings
        dc.w    loc_06FE18-Tails_Mappings
        dc.w    loc_06FE32-Tails_Mappings
        dc.w    loc_06FE4C-Tails_Mappings
        dc.w    loc_06FE66-Tails_Mappings
        dc.w    loc_06FE80-Tails_Mappings
        dc.w    loc_06FE9A-Tails_Mappings
        dc.w    loc_06FEB4-Tails_Mappings
        dc.w    loc_06FECE-Tails_Mappings
        dc.w    loc_06FEE8-Tails_Mappings
        dc.w    loc_06FF02-Tails_Mappings
        dc.w    loc_06FF1C-Tails_Mappings
        dc.w    loc_06FF36-Tails_Mappings
        dc.w    loc_06FF50-Tails_Mappings
        dc.w    loc_06FF6A-Tails_Mappings
        dc.w    loc_06FF7C-Tails_Mappings
        dc.w    loc_06FF96-Tails_Mappings
        dc.w    loc_06FFA8-Tails_Mappings
        dc.w    loc_06FFC2-Tails_Mappings
        dc.w    loc_06FFD4-Tails_Mappings
        dc.w    loc_06FFEE-Tails_Mappings
        dc.w    loc_070000-Tails_Mappings
        dc.w    loc_07001A-Tails_Mappings
        dc.w    loc_07002C-Tails_Mappings
        dc.w    loc_07003E-Tails_Mappings
        dc.w    loc_070050-Tails_Mappings
        dc.w    loc_070062-Tails_Mappings
        dc.w    loc_070074-Tails_Mappings
        dc.w    loc_070086-Tails_Mappings
        dc.w    loc_0700A0-Tails_Mappings
        dc.w    loc_0700BA-Tails_Mappings
        dc.w    loc_0700D4-Tails_Mappings
        dc.w    loc_0700EE-Tails_Mappings
        dc.w    loc_070108-Tails_Mappings
        dc.w    loc_070122-Tails_Mappings
        dc.w    loc_07013C-Tails_Mappings
        dc.w    loc_070156-Tails_Mappings
        dc.w    loc_07013C-Tails_Mappings
        dc.w    loc_070170-Tails_Mappings
        dc.w    loc_07018A-Tails_Mappings
        dc.w    loc_0701A4-Tails_Mappings
        dc.w    loc_0701BE-Tails_Mappings
        dc.w    loc_0701D8-Tails_Mappings
        dc.w    loc_0701F2-Tails_Mappings
        dc.w    loc_07020C-Tails_Mappings
        dc.w    loc_070226-Tails_Mappings
        dc.w    loc_070240-Tails_Mappings
        dc.w    loc_07024A-Tails_Mappings
        dc.w    loc_070254-Tails_Mappings
        dc.w    loc_07025E-Tails_Mappings
        dc.w    loc_070268-Tails_Mappings
        dc.w    loc_070272-Tails_Mappings
        dc.w    loc_07027C-Tails_Mappings
        dc.w    loc_070286-Tails_Mappings
        dc.w    loc_070290-Tails_Mappings
        dc.w    loc_07029A-Tails_Mappings
        dc.w    loc_0702A4-Tails_Mappings
        dc.w    loc_0702AE-Tails_Mappings
        dc.w    loc_0702B8-Tails_Mappings
        dc.w    loc_0702C2-Tails_Mappings
        dc.w    loc_0702CC-Tails_Mappings
        dc.w    loc_0702D6-Tails_Mappings
        dc.w    loc_0702E0-Tails_Mappings
        dc.w    loc_0702EA-Tails_Mappings
        dc.w    loc_0702F4-Tails_Mappings
        dc.w    loc_0702FE-Tails_Mappings
        dc.w    loc_070310-Tails_Mappings
        dc.w    loc_070322-Tails_Mappings
        dc.w    loc_07032C-Tails_Mappings
        dc.w    loc_070336-Tails_Mappings
        dc.w    loc_070340-Tails_Mappings
        dc.w    loc_070352-Tails_Mappings
        dc.w    loc_070364-Tails_Mappings
        dc.w    loc_07036E-Tails_Mappings
        dc.w    loc_070378-Tails_Mappings
        dc.w    loc_070382-Tails_Mappings
        dc.w    loc_070394-Tails_Mappings
        dc.w    loc_0703A6-Tails_Mappings
        dc.w    loc_0703B8-Tails_Mappings
        dc.w    loc_0703CA-Tails_Mappings
        dc.w    loc_0703DC-Tails_Mappings
        dc.w    loc_0703EE-Tails_Mappings
        dc.w    loc_070400-Tails_Mappings
        dc.w    loc_070412-Tails_Mappings
        dc.w    loc_07041C-Tails_Mappings
        dc.w    loc_07042E-Tails_Mappings
        dc.w    loc_070440-Tails_Mappings
        dc.w    loc_070452-Tails_Mappings
        dc.w    loc_070464-Tails_Mappings
        dc.w    loc_070476-Tails_Mappings
        dc.w    loc_070488-Tails_Mappings
        dc.w    loc_07049A-Tails_Mappings
        dc.w    loc_0704AC-Tails_Mappings
        dc.w    loc_0704B6-Tails_Mappings
        dc.w    loc_0704C0-Tails_Mappings
        dc.w    loc_0704D2-Tails_Mappings
        dc.w    loc_0704DC-Tails_Mappings
        dc.w    loc_0704E6-Tails_Mappings
        dc.w    loc_0704F0-Tails_Mappings
        dc.w    loc_0704FA-Tails_Mappings
        dc.w    loc_070504-Tails_Mappings
        dc.w    loc_07050E-Tails_Mappings
        dc.w    loc_070518-Tails_Mappings
        dc.w    loc_070522-Tails_Mappings
        dc.w    loc_070534-Tails_Mappings
        dc.w    loc_070546-Tails_Mappings
        dc.w    loc_070550-Tails_Mappings
        dc.w    loc_07055A-Tails_Mappings
        dc.w    loc_070564-Tails_Mappings
loc_06FC46:
        dc.w    $0000
loc_06FC48:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FC5A:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FC6C:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FC7E:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FC90:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFF4
loc_06FC9A:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFF4
loc_06FCA4:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FCB6:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF4, $00090006, $0003FFF4
loc_06FCC8:
        dc.w    $0001
        dc.l    $F0070000, $0000FFEC
loc_06FCD2:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFE4
loc_06FCDC:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFE4
loc_06FCE6:
        dc.w    $0001
        dc.l    $00090000, $0000FFE4
loc_06FCF0:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFE4
loc_06FCFA:
        dc.w    $0003
        dc.l    $EC090000, $0000FFF0, $FC0D0006, $0003FFF0
        dc.l    $FC09000E, $0007FFE2
loc_06FD14:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF3, $000D0006, $0003FFF0
        dc.l    $0009000E, $0007FFE4
loc_06FD2E:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF8, $00090006, $0003FFF3
        dc.l    $FD09000C, $0006FFE4
loc_06FD48:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF2, $00090006, $0003FFF2
        dc.l    $FD09000C, $0006FFE6
loc_06FD62:
        dc.w    $0003
        dc.l    $EC090000, $0000FFF0, $FC0D0006, $0003FFF0
        dc.l    $FC09000E, $0007FFE2
loc_06FD7C:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF3, $000D0006, $0003FFF0
        dc.l    $0009000E, $0007FFE4
loc_06FD96:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF8, $00090006, $0003FFF1
        dc.l    $FD09000C, $0006FFE4
loc_06FDB0:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF2, $00090006, $0003FFF2
        dc.l    $FD09000C, $0006FFE6
loc_06FDCA:
        dc.w    $0003
        dc.l    $E3010000, $0000FFF3, $F3030002, $0001FFEC
        dc.l    $F30B0006, $0003FFF4
loc_06FDE4:
        dc.w    $0003
        dc.l    $E7050000, $0000FFF6, $F70B0004, $0002FFEE
        dc.l    $FE050010, $00080006
loc_06FDFE:
        dc.w    $0003
        dc.l    $E6050000, $0000FFF8, $F6030004, $0002FFEF
        dc.l    $F60B0008, $0004FFF7
loc_06FE18:
        dc.w    $0003
        dc.l    $E3010000, $0000FFF7, $F30F0002, $0001FFEC
        dc.l    $FB010012, $0009000C
loc_06FE32:
        dc.w    $0003
        dc.l    $E3010000, $0000FFF3, $F3030002, $0001FFEC
        dc.l    $F30B0006, $0003FFF4
loc_06FE4C:
        dc.w    $0003
        dc.l    $E7050000, $0000FFF6, $F70B0004, $0002FFEE
        dc.l    $FF050010, $00080006
loc_06FE66:
        dc.w    $0003
        dc.l    $E6050000, $0000FFF8, $F6030004, $0002FFEF
        dc.l    $F60B0008, $0004FFF7
loc_06FE80:
        dc.w    $0003
        dc.l    $E3010000, $0000FFF7, $F30F0002, $0001FFEC
        dc.l    $03010012, $0009000C
loc_06FE9A:
        dc.w    $0003
        dc.l    $F0070000, $0000FFEC, $F0070008, $0004FFFC
        dc.l    $06070010, $0008FFFC
loc_06FEB4:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $00080000
loc_06FECE:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $0008FFFD
loc_06FEE8:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $0008FFFD
loc_06FF02:
        dc.w    $0003
        dc.l    $F0070000, $0000FFEC, $F0070008, $0004FFFC
        dc.l    $06070010, $0008FFFC
loc_06FF1C:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $00080000
loc_06FF36:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $0008FFFD
loc_06FF50:
        dc.w    $0003
        dc.l    $F0070000, $0000FFF0, $F0070008, $00040000
        dc.l    $04070010, $0008FFFD
loc_06FF6A:
        dc.w    $0002
        dc.l    $04010000, $0000FFEB, $F40F0002, $0001FFF3
loc_06FF7C:
        dc.w    $0003
        dc.l    $E2050000, $0000FFF8, $FA010004, $0002FFF0
        dc.l    $F20F0006, $0003FFF8
loc_06FF96:
        dc.w    $0002
        dc.l    $F9010000, $0000FFEC, $F10F0002, $0001FFF4
loc_06FFA8:
        dc.w    $0003
        dc.l    $FC010000, $0000FFEF, $E5010002, $0001FFFF
        dc.l    $F50F0004, $0002FFF7
loc_06FFC2:
        dc.w    $0002
        dc.l    $04010000, $0000FFEB, $F40F0002, $0001FFF3
loc_06FFD4:
        dc.w    $0003
        dc.l    $E2010000, $00000000, $FA010002, $0001FFF0
        dc.l    $F20F0004, $0002FFF8
loc_06FFEE:
        dc.w    $0002
        dc.l    $F9010000, $0000FFEC, $F10F0002, $0001FFF4
loc_070000:
        dc.w    $0003
        dc.l    $E4010000, $0000FFFF, $FC010002, $0001FFEF
        dc.l    $F40F0004, $0002FFF7
loc_07001A:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F0070010, $0008FFEA
loc_07002C:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F8050010, $0008FFEA
loc_07003E:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F8050010, $0008FFEA
loc_070050:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F8051010, $1008FFEA
loc_070062:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F0070010, $0008FFEA
loc_070074:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $F0071810, $1808FFEA
loc_070086:
        dc.w    $0003
        dc.l    $E4010000, $0000FFFA, $F40B0002, $0001FFF0
        dc.l    $FE0B000E, $0007FFE8
loc_0700A0:
        dc.w    $0003
        dc.l    $E4050000, $0000FFF8, $F40B0004, $0002FFF0
        dc.l    $04050010, $0008FFEF
loc_0700BA:
        dc.w    $0003
        dc.l    $E4010000, $0000FFFA, $F40B0002, $0001FFF0
        dc.l    $0405000E, $0007FFEF
loc_0700D4:
        dc.w    $0003
        dc.l    $E4050000, $0000FFF8, $F40B0004, $0002FFF0
        dc.l    $04050010, $0008FFEF
loc_0700EE:
        dc.w    $0003
        dc.l    $E4010000, $0000FFFA, $F40B0002, $0001FFF0
        dc.l    $FC0B000E, $0007FFEA
loc_070108:
        dc.w    $0003
        dc.l    $E4050000, $0000FFF8, $F40B0004, $0002FFF0
        dc.l    $E90B1810, $1808FFF2
loc_070122:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
        dc.l    $060D000E, $0007FFF0
loc_07013C:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
        dc.l    $0605000E, $0007FFF8
loc_070156:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
        dc.l    $0605000E, $0007FFF8
loc_070170:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
        dc.l    $060D000E, $0007FFF0
loc_07018A:
        dc.w    $0003
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
        dc.l    $060D000E, $0007FFF0
loc_0701A4:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $FE0B0810, $08080000
loc_0701BE:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $01050810, $08080004
loc_0701D8:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $01050810, $08080004
loc_0701F2:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $01050810, $08080004
loc_07020C:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $FC0B0810, $0808FFFE
loc_070226:
        dc.w    $0003
        dc.l    $F80B0000, $0000FFEC, $F805000C, $00060004
        dc.l    $FC0B1010, $10080006
loc_070240:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_07024A:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_070254:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_07025E:
        dc.w    $0001
        dc.l    $F8090000, $0000FFDC
loc_070268:
        dc.w    $0001
        dc.l    $F8090000, $0000FFDC
loc_070272:
        dc.w    $0001
        dc.l    $F8090000, $0000FFDC
loc_07027C:
        dc.w    $0001
        dc.l    $F8090000, $0000FFDC
loc_070286:
        dc.w    $0001
        dc.l    $07090000, $0000FFE1
loc_070290:
        dc.w    $0001
        dc.l    $07090000, $0000FFE1
loc_07029A:
        dc.w    $0001
        dc.l    $07090000, $0000FFE1
loc_0702A4:
        dc.w    $0001
        dc.l    $07090000, $0000FFE1
loc_0702AE:
        dc.w    $0001
        dc.l    $0C070000, $0000FFF8
loc_0702B8:
        dc.w    $0001
        dc.l    $0C070000, $0000FFF8
loc_0702C2:
        dc.w    $0001
        dc.l    $0C070000, $0000FFF8
loc_0702CC:
        dc.w    $0001
        dc.l    $0C070000, $0000FFF8
loc_0702D6:
        dc.w    $0001
        dc.l    $07070000, $00000007
loc_0702E0:
        dc.w    $0001
        dc.l    $07070000, $00000007
loc_0702EA:
        dc.w    $0001
        dc.l    $07070000, $00000007
loc_0702F4:
        dc.w    $0001
        dc.l    $07070000, $00000007
loc_0702FE:
        dc.w    $0002
        dc.l    $E8050000, $0000FFF8, $F80B0004, $0002FFF0
loc_070310:
        dc.w    $0002
        dc.l    $E8050000, $0000FFF8, $F80B0004, $0002FFF0
loc_070322:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFF9
loc_07032C:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_070336:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_070340:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $E40D0010, $0008FFEA
loc_070352:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFF0, $E40D0810, $0808FFEA
loc_070364:
        dc.w    $0001
        dc.l    $F40F0000, $0000FFF0
loc_07036E:
        dc.w    $0001
        dc.l    $F40F0000, $0000FFF0
loc_070378:
        dc.w    $0001
        dc.l    $F40F0000, $0000FFF0
loc_070382:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF8, $000D0006, $0003FFF0
loc_070394:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF8, $00090006, $0003FFF8
loc_0703A6:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF8, $00090006, $0003FFF8
loc_0703B8:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF8, $00090006, $0003FFF8
loc_0703CA:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
loc_0703DC:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF0, $000D0006, $0003FFF0
loc_0703EE:
        dc.w    $0002
        dc.l    $F8010000, $0000FFF0, $F00B0002, $0001FFF8
loc_070400:
        dc.w    $0002
        dc.l    $F0090000, $0000FFF8, $000D0006, $0003FFF0
loc_070412:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_07041C:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFEC, $F0030010, $0008000C
loc_07042E:
        dc.w    $0002
        dc.l    $F00F0000, $0000FFEC, $F0030010, $0008000C
loc_070440:
        dc.w    $0002
        dc.l    $F8050000, $0000FFEC, $F00B0004, $0002FFFC
loc_070452:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F0070800, $08000000
loc_070464:
        dc.w    $0002
        dc.l    $F8050800, $08000004, $F00B0804, $0802FFEC
loc_070476:
        dc.w    $0002
        dc.l    $F0070000, $0000FFF0, $F8050008, $00040000
loc_070488:
        dc.w    $0002
        dc.l    $F0070800, $08000000, $F8050808, $0804FFF0
loc_07049A:
        dc.w    $0002
        dc.l    $F8050000, $0000FFEC, $F00B0004, $0002FFFC
loc_0704AC:
        dc.w    $0001
        dc.l    $F00F0000, $0000FFF0
loc_0704B6:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFF1
loc_0704C0:
        dc.w    $0002
        dc.l    $E4050000, $0000FFF8, $F40B0004, $0002FFF1
loc_0704D2:
        dc.w    $0001
        dc.l    $F20B0000, $0000FFF2
loc_0704DC:
        dc.w    $0001
        dc.l    $F40B0000, $0000FFF0
loc_0704E6:
        dc.w    $0001
        dc.l    $F30B0000, $0000FFF2
loc_0704F0:
        dc.w    $0001
        dc.l    $F20B0000, $0000FFF2
loc_0704FA:
        dc.w    $0001
        dc.l    $F20B0000, $0000FFF2
loc_070504:
        dc.w    $0001
        dc.l    $F00B0000, $0000FFF1
loc_07050E:
        dc.w    $0001
        dc.l    $ED0B0000, $0000FFF0
loc_070518:
        dc.w    $0001
        dc.l    $EC0B0000, $0000FFF1
loc_070522:
        dc.w    $0002
        dc.l    $F4090000, $0000FFF3, $04050006, $0003FFF3
loc_070534:
        dc.w    $0002
        dc.l    $F2070000, $0000FFF0, $EC030008, $00040000
loc_070546:
        dc.w    $0001
        dc.l    $F8090000, $0000FFE0
loc_070550:
        dc.w    $0001
        dc.l    $F8090000, $0000FFE0
loc_07055A:
        dc.w    $0001
        dc.l    $F8090000, $0000FFE0
loc_070564:
        dc.w    $0001
        dc.l    $F8090000, $0000FFE0
Tails_Dyn_Script: ; loc_07056E:   
        dc.w    loc_070678-Tails_Dyn_Script
        dc.w    loc_07067A-Tails_Dyn_Script
        dc.w    loc_070680-Tails_Dyn_Script
        dc.w    loc_070686-Tails_Dyn_Script
        dc.w    loc_07068C-Tails_Dyn_Script
        dc.w    loc_070692-Tails_Dyn_Script
        dc.w    loc_070696-Tails_Dyn_Script
        dc.w    loc_07069A-Tails_Dyn_Script
        dc.w    loc_0706A0-Tails_Dyn_Script
        dc.w    loc_0706A6-Tails_Dyn_Script
        dc.w    loc_0706AA-Tails_Dyn_Script
        dc.w    loc_0706AE-Tails_Dyn_Script
        dc.w    loc_0706B2-Tails_Dyn_Script
        dc.w    loc_0706B6-Tails_Dyn_Script
        dc.w    loc_0706BA-Tails_Dyn_Script
        dc.w    loc_0706C2-Tails_Dyn_Script
        dc.w    loc_0706CA-Tails_Dyn_Script
        dc.w    loc_0706D2-Tails_Dyn_Script
        dc.w    loc_0706DA-Tails_Dyn_Script
        dc.w    loc_0706E2-Tails_Dyn_Script
        dc.w    loc_0706EA-Tails_Dyn_Script
        dc.w    loc_0706F2-Tails_Dyn_Script
        dc.w    loc_0706FA-Tails_Dyn_Script
        dc.w    loc_070702-Tails_Dyn_Script
        dc.w    loc_07070A-Tails_Dyn_Script
        dc.w    loc_070712-Tails_Dyn_Script
        dc.w    loc_07071A-Tails_Dyn_Script
        dc.w    loc_070722-Tails_Dyn_Script
        dc.w    loc_07072A-Tails_Dyn_Script
        dc.w    loc_070732-Tails_Dyn_Script
        dc.w    loc_07073A-Tails_Dyn_Script
        dc.w    loc_070742-Tails_Dyn_Script
        dc.w    loc_07074A-Tails_Dyn_Script
        dc.w    loc_070752-Tails_Dyn_Script
        dc.w    loc_07075A-Tails_Dyn_Script
        dc.w    loc_070762-Tails_Dyn_Script
        dc.w    loc_07076A-Tails_Dyn_Script
        dc.w    loc_070772-Tails_Dyn_Script
        dc.w    loc_07077A-Tails_Dyn_Script
        dc.w    loc_070780-Tails_Dyn_Script
        dc.w    loc_070788-Tails_Dyn_Script
        dc.w    loc_07078E-Tails_Dyn_Script
        dc.w    loc_070796-Tails_Dyn_Script
        dc.w    loc_07079C-Tails_Dyn_Script
        dc.w    loc_0707A4-Tails_Dyn_Script
        dc.w    loc_0707AA-Tails_Dyn_Script
        dc.w    loc_0707B2-Tails_Dyn_Script
        dc.w    loc_0707B8-Tails_Dyn_Script
        dc.w    loc_0707BE-Tails_Dyn_Script
        dc.w    loc_0707B8-Tails_Dyn_Script
        dc.w    loc_0707C4-Tails_Dyn_Script
        dc.w    loc_0707CA-Tails_Dyn_Script
        dc.w    loc_0707D0-Tails_Dyn_Script
        dc.w    loc_0707D8-Tails_Dyn_Script
        dc.w    loc_0707E0-Tails_Dyn_Script
        dc.w    loc_0707E8-Tails_Dyn_Script
        dc.w    loc_0707F0-Tails_Dyn_Script
        dc.w    loc_0707F8-Tails_Dyn_Script
        dc.w    loc_070800-Tails_Dyn_Script
        dc.w    loc_070808-Tails_Dyn_Script
        dc.w    loc_070810-Tails_Dyn_Script
        dc.w    loc_070808-Tails_Dyn_Script
        dc.w    loc_070818-Tails_Dyn_Script
        dc.w    loc_070820-Tails_Dyn_Script
        dc.w    loc_070828-Tails_Dyn_Script
        dc.w    loc_070830-Tails_Dyn_Script
        dc.w    loc_070838-Tails_Dyn_Script
        dc.w    loc_070840-Tails_Dyn_Script
        dc.w    loc_070848-Tails_Dyn_Script
        dc.w    loc_070850-Tails_Dyn_Script
        dc.w    loc_070858-Tails_Dyn_Script
        dc.w    loc_07085C-Tails_Dyn_Script
        dc.w    loc_070860-Tails_Dyn_Script
        dc.w    loc_070864-Tails_Dyn_Script
        dc.w    loc_070868-Tails_Dyn_Script
        dc.w    loc_07086C-Tails_Dyn_Script
        dc.w    loc_070870-Tails_Dyn_Script
        dc.w    loc_070874-Tails_Dyn_Script
        dc.w    loc_070878-Tails_Dyn_Script
        dc.w    loc_07087C-Tails_Dyn_Script
        dc.w    loc_070880-Tails_Dyn_Script
        dc.w    loc_070884-Tails_Dyn_Script
        dc.w    loc_070888-Tails_Dyn_Script
        dc.w    loc_07088C-Tails_Dyn_Script
        dc.w    loc_070890-Tails_Dyn_Script
        dc.w    loc_070894-Tails_Dyn_Script
        dc.w    loc_070898-Tails_Dyn_Script
        dc.w    loc_07089C-Tails_Dyn_Script
        dc.w    loc_0708A0-Tails_Dyn_Script
        dc.w    loc_0708A4-Tails_Dyn_Script
        dc.w    loc_0708AA-Tails_Dyn_Script
        dc.w    loc_0708B0-Tails_Dyn_Script
        dc.w    loc_0708B4-Tails_Dyn_Script
        dc.w    loc_0708B8-Tails_Dyn_Script
        dc.w    loc_0708BC-Tails_Dyn_Script
        dc.w    loc_0708BC-Tails_Dyn_Script
        dc.w    loc_0708C2-Tails_Dyn_Script
        dc.w    loc_0708C6-Tails_Dyn_Script
        dc.w    loc_0708CA-Tails_Dyn_Script
        dc.w    loc_0708CE-Tails_Dyn_Script
        dc.w    loc_0708D4-Tails_Dyn_Script
        dc.w    loc_0708DA-Tails_Dyn_Script
        dc.w    loc_0708E0-Tails_Dyn_Script
        dc.w    loc_0708E6-Tails_Dyn_Script
        dc.w    loc_0708EC-Tails_Dyn_Script
        dc.w    loc_0708F2-Tails_Dyn_Script
        dc.w    loc_0708F8-Tails_Dyn_Script
        dc.w    loc_0708FE-Tails_Dyn_Script
        dc.w    loc_070902-Tails_Dyn_Script
        dc.w    loc_070908-Tails_Dyn_Script
        dc.w    loc_07090E-Tails_Dyn_Script
        dc.w    loc_070914-Tails_Dyn_Script
        dc.w    loc_07090E-Tails_Dyn_Script
        dc.w    loc_07091A-Tails_Dyn_Script
        dc.w    loc_07091A-Tails_Dyn_Script
        dc.w    loc_070920-Tails_Dyn_Script
        dc.w    loc_070926-Tails_Dyn_Script
        dc.w    loc_07092A-Tails_Dyn_Script
        dc.w    loc_07092E-Tails_Dyn_Script
        dc.w    loc_070934-Tails_Dyn_Script
        dc.w    loc_070938-Tails_Dyn_Script
        dc.w    loc_07093C-Tails_Dyn_Script
        dc.w    loc_070940-Tails_Dyn_Script
        dc.w    loc_070944-Tails_Dyn_Script
        dc.w    loc_070948-Tails_Dyn_Script
        dc.w    loc_07094C-Tails_Dyn_Script
        dc.w    loc_070950-Tails_Dyn_Script
        dc.w    loc_070954-Tails_Dyn_Script
        dc.w    loc_07095A-Tails_Dyn_Script
        dc.w    loc_070864-Tails_Dyn_Script
        dc.w    loc_070868-Tails_Dyn_Script
        dc.w    loc_07086C-Tails_Dyn_Script
        dc.w    loc_070870-Tails_Dyn_Script
loc_070678:
        dc.w    $0000
loc_07067A:
        dc.w    $0002
        dc.w    $5000, $5006
loc_070680:
        dc.w    $0002
        dc.w    $500C, $5006
loc_070686:
        dc.w    $0002
        dc.w    $5012, $5006
loc_07068C:
        dc.w    $0002
        dc.w    $5018, $5006
loc_070692:
        dc.w    $0001
        dc.w    $B01E
loc_070696:
        dc.w    $0001
        dc.w    $B02A
loc_07069A:
        dc.w    $0002
        dc.w    $5036, $503C
loc_0706A0:
        dc.w    $0002
        dc.w    $5036, $5042
loc_0706A6:
        dc.w    $0001
        dc.w    $7048
loc_0706AA:
        dc.w    $0001
        dc.w    $B050
loc_0706AE:
        dc.w    $0001
        dc.w    $B05C
loc_0706B2:
        dc.w    $0001
        dc.w    $5068
loc_0706B6:
        dc.w    $0001
        dc.w    $B06E
loc_0706BA:
        dc.w    $0003
        dc.w    $507A, $7080, $50CA
loc_0706C2:
        dc.w    $0003
        dc.w    $5088, $708E, $50D0
loc_0706CA:
        dc.w    $0003
        dc.w    $5096, $509C, $50D6
loc_0706D2:
        dc.w    $0003
        dc.w    $50A2, $50A8, $50DC
loc_0706DA:
        dc.w    $0003
        dc.w    $507A, $70AE, $50CA
loc_0706E2:
        dc.w    $0003
        dc.w    $5088, $70B6, $50D0
loc_0706EA:
        dc.w    $0003
        dc.w    $5096, $50BE, $50D6
loc_0706F2:
        dc.w    $0003
        dc.w    $50A2, $50C4, $50DC
loc_0706FA:
        dc.w    $0003
        dc.w    $10E2, $30E4, $B0E8
loc_070702:
        dc.w    $0003
        dc.w    $30F4, $B0F8, $3104
loc_07070A:
        dc.w    $0003
        dc.w    $3108, $310C, $B110
loc_070712:
        dc.w    $0003
        dc.w    $111C, $F11E, $112E
loc_07071A:
        dc.w    $0003
        dc.w    $10E2, $30E4, $B130
loc_070722:
        dc.w    $0003
        dc.w    $30F4, $B13C, $3148
loc_07072A:
        dc.w    $0003
        dc.w    $3108, $310C, $B14C
loc_070732:
        dc.w    $0003
        dc.w    $111C, $F158, $1168
loc_07073A:
        dc.w    $0003
        dc.w    $716A, $7172, $71CA
loc_070742:
        dc.w    $0003
        dc.w    $717A, $7182, $71D2
loc_07074A:
        dc.w    $0003
        dc.w    $718A, $7192, $71DA
loc_070752:
        dc.w    $0003
        dc.w    $719A, $71A2, $71E2
loc_07075A:
        dc.w    $0003
        dc.w    $716A, $71AA, $71CA
loc_070762:
        dc.w    $0003
        dc.w    $717A, $71B2, $71D2
loc_07076A:
        dc.w    $0003
        dc.w    $718A, $71BA, $71DA
loc_070772:
        dc.w    $0003
        dc.w    $719A, $71C2, $71E2
loc_07077A:
        dc.w    $0002
        dc.w    $11EA, $F1EC
loc_070780:
        dc.w    $0003
        dc.w    $31FC, $1200, $F202
loc_070788:
        dc.w    $0002
        dc.w    $1212, $F214
loc_07078E:
        dc.w    $0003
        dc.w    $1224, $1226, $F228
loc_070796:
        dc.w    $0002
        dc.w    $11EA, $F238
loc_07079C:
        dc.w    $0003
        dc.w    $1248, $1200, $F24A
loc_0707A4:
        dc.w    $0002
        dc.w    $1212, $F25A
loc_0707AA:
        dc.w    $0003
        dc.w    $126A, $1224, $F26C
loc_0707B2:
        dc.w    $0002
        dc.w    $F27C, $729C
loc_0707B8:
        dc.w    $0002
        dc.w    $F28C, $32A4
loc_0707BE:
        dc.w    $0002
        dc.w    $F27C, $32A8
loc_0707C4:
        dc.w    $0002
        dc.w    $F27C, $72AC
loc_0707CA:
        dc.w    $0002
        dc.w    $F28C, $72AC
loc_0707D0:
        dc.w    $0003
        dc.w    $12B4, $B2B6, $B2D2
loc_0707D8:
        dc.w    $0003
        dc.w    $32C2, $B2C6, $32DE
loc_0707E0:
        dc.w    $0003
        dc.w    $12B4, $B2B6, $32E2
loc_0707E8:
        dc.w    $0003
        dc.w    $32C2, $B2C6, $32E6
loc_0707F0:
        dc.w    $0003
        dc.w    $12B4, $B2B6, $B2EA
loc_0707F8:
        dc.w    $0003
        dc.w    $32C2, $B2C6, $B2EA
loc_070800:
        dc.w    $0003
        dc.w    $52F6, $72FC, $7312
loc_070808:
        dc.w    $0003
        dc.w    $5304, $730A, $331E
loc_070810:
        dc.w    $0003
        dc.w    $52F6, $72FC, $331A
loc_070818:
        dc.w    $0003
        dc.w    $52F6, $72FC, $7322
loc_070820:
        dc.w    $0003
        dc.w    $5304, $730A, $7322
loc_070828:
        dc.w    $0003
        dc.w    $B32A, $3336, $B2D2
loc_070830:
        dc.w    $0003
        dc.w    $B33A, $3346, $32DE
loc_070838:
        dc.w    $0003
        dc.w    $B32A, $3336, $32E2
loc_070840:
        dc.w    $0003
        dc.w    $B33A, $3346, $32E6
loc_070848:
        dc.w    $0003
        dc.w    $B32A, $3336, $B2EA
loc_070850:
        dc.w    $0003
        dc.w    $B33A, $3346, $B2EA
loc_070858:
        dc.w    $0001
        dc.w    $F34A
loc_07085C:
        dc.w    $0001
        dc.w    $F35A
loc_070860:
        dc.w    $0001
        dc.w    $F36A
loc_070864:
        dc.w    $0001
        dc.w    $50CA
loc_070868:
        dc.w    $0001
        dc.w    $50D0
loc_07086C:
        dc.w    $0001
        dc.w    $50D6
loc_070870:
        dc.w    $0001
        dc.w    $50DC
loc_070874:
        dc.w    $0001
        dc.w    $537A
loc_070878:
        dc.w    $0001
        dc.w    $5380
loc_07087C:
        dc.w    $0001
        dc.w    $5386
loc_070880:
        dc.w    $0001
        dc.w    $538C
loc_070884:
        dc.w    $0001
        dc.w    $71CA
loc_070888:
        dc.w    $0001
        dc.w    $71D2
loc_07088C:
        dc.w    $0001
        dc.w    $71DA
loc_070890:
        dc.w    $0001
        dc.w    $71E2
loc_070894:
        dc.w    $0001
        dc.w    $7392
loc_070898:
        dc.w    $0001
        dc.w    $739A
loc_07089C:
        dc.w    $0001
        dc.w    $73A2
loc_0708A0:
        dc.w    $0001
        dc.w    $73AA
loc_0708A4:
        dc.w    $0002
        dc.w    $33B2, $B3B6
loc_0708AA:
        dc.w    $0002
        dc.w    $33B2, $B3C2
loc_0708B0:
        dc.w    $0001
        dc.w    $B3CE
loc_0708B4:
        dc.w    $0001
        dc.w    $F3DA
loc_0708B8:
        dc.w    $0001
        dc.w    $F3EA
loc_0708BC:
        dc.w    $0002
        dc.w    $F3FA, $740A
loc_0708C2:
        dc.w    $0001
        dc.w    $F412
loc_0708C6:
        dc.w    $0001
        dc.w    $F422
loc_0708CA:
        dc.w    $0001
        dc.w    $F432
loc_0708CE:
        dc.w    $0002
        dc.w    $5442, $7448
loc_0708D4:
        dc.w    $0002
        dc.w    $5442, $5450
loc_0708DA:
        dc.w    $0002
        dc.w    $5442, $5456
loc_0708E0:
        dc.w    $0002
        dc.w    $5442, $545C
loc_0708E6:
        dc.w    $0002
        dc.w    $5462, $7468
loc_0708EC:
        dc.w    $0002
        dc.w    $5470, $7476
loc_0708F2:
        dc.w    $0002
        dc.w    $147E, $B480
loc_0708F8:
        dc.w    $0002
        dc.w    $548C, $7492
loc_0708FE:
        dc.w    $0001
        dc.w    $F49A
loc_070902:
        dc.w    $0002
        dc.w    $F4AA, $34BA
loc_070908:
        dc.w    $0002
        dc.w    $F4BE, $34CE
loc_07090E:
        dc.w    $0002
        dc.w    $34D2, $B4D6
loc_070914:
        dc.w    $0002
        dc.w    $74E2, $74E2
loc_07091A:
        dc.w    $0002
        dc.w    $74EA, $34F2
loc_070920:
        dc.w    $0002
        dc.w    $34F6, $B4FA
loc_070926:
        dc.w    $0001
        dc.w    $F506
loc_07092A:
        dc.w    $0001
        dc.w    $B516
loc_07092E:
        dc.w    $0002
        dc.w    $3522, $B526
loc_070934:
        dc.w    $0001
        dc.w    $B532
loc_070938:
        dc.w    $0001
        dc.w    $B53E
loc_07093C:
        dc.w    $0001
        dc.w    $B54A
loc_070940:
        dc.w    $0001
        dc.w    $B556
loc_070944:
        dc.w    $0001
        dc.w    $B562
loc_070948:
        dc.w    $0001
        dc.w    $B56E
loc_07094C:
        dc.w    $0001
        dc.w    $B57A
loc_070950:
        dc.w    $0001
        dc.w    $B586
loc_070954:
        dc.w    $0002
        dc.w    $5592, $3598
loc_07095A:
        dc.w    $0002
        dc.w    $759C, $35A4                     
SegaLogo: ; loc_070960:        
        incbin  'data\sprites\sega.nem'
SegaLogo_Mappings: ; loc_070DD0:
        incbin  'data\all\sega.eni'
TS_Wings_Sonic_Mappings: ; loc_070ECC: 
        incbin  'data\all\titlescr.eni'
Title_Screen_Bg_Mappings: ; loc_071024:
        incbin  'data\all\titscrbg.eni'
Title_Screen_R_Bg_Mappings: ; loc_0712D8:        
        incbin  'data\all\titscrb2.eni'
Title_Screen_Bg_Wings: ; loc_071520: 
        incbin  'data\sprites\titlescr.nem' ; Title Screen Wings and background
Title_Screen_Sonic_Tails: ; loc_072E82: 
        incbin  'data\sprites\sontascr.nem' ; Sonic And Tails in Title Screen  
FireBall: ; loc_0739C6:         
        incbin  'data\sprites\fireball.nem'
Ghz_Waterfall: ; loc_073B3C:  
        incbin  'data\ghz\watrfall.nem'  
Htz_Lava_Bubble: ; loc_073C42:   
        incbin  'data\htz\lvbubble.nem'              
Ghz_Bridge: ; loc_073D90: 
        incbin  'data\ghz\bridge.nem'          
Htz_Teleferic:  ; loc_073E68: 
        incbin  'data\htz\telefrcs.nem' 
Htz_Automatic_Door: ; loc_07415C: 
        incbin  'data\htz\autodoor.nem' 
Htz_See_saw: ; loc_0741D4: 
        incbin  'data\htz\see-saw.nem'
Fireball_1: ; loc_07436C: 
        incbin  'data\sprites\firebal1.nem'        
Htz_Rock:; loc_07447A: 
        incbin  'data\htz\rock.nem'             
Htz_See_saw_badnick: ; loc_0745B0: 
        incbin  'data\htz\see-sawb.nem' 
Mz_Rotating_Gear: ; loc_07461C:      
        incbin  'data\mz\gear.nem'   
Mz_Machine_Ball: ; loc_074A74: 
        incbin  'data\mz\m_ball.nem'  
Mz_Block: ; loc_074B1C:     
        incbin  'data\mz\block.nem'  
Mz_Steam: ; loc_074BEA:  
        incbin  'data\mz\steam.nem'         
Mz_Harpoon: ; loc_074CF4:     
        incbin  'data\mz\harpoon.nem'  
Mz_Screw_Nut: ; loc_074DB6:  
        incbin  'data\mz\screwnut.nem'                                    
Mz_Lava_Bubble: ; loc_074E2C:   
        incbin  'data\mz\lvbubble.nem' 
loc_074EE2:  
        incbin  'data\mz\0x074EE2.nem'          
Mz_Parallelogram_Elevator: ; loc_074F52:  
        incbin  'data\mz\parallel.nem' 
loc_0751FE:  
        incbin  'data\mz\0x0751FE.nem'  
Mz_Mini_Gear: ; loc_0752A0:  
        incbin  'data\mz\minigear.nem'                 
Mz_Teleport: ; Mz_Four_Block: ; loc_075382:         
        dc.b    $00, $04, $86, $71, $00, $FF, $00, $00, $00, $00, $00, $00                 
Hpz_Bridge: ; loc_07538E: 
        incbin  'data\hpz\bridge.nem'
Hpz_Waterfall: ; loc_075506: 
        incbin  'data\hpz\watrfall.nem'               
Hpz_Emerald: ; loc_075868: 
        incbin  'data\hpz\emerald.nem'                 
Hpz_Platform: ; loc_075ADA: 
        incbin  'data\hpz\platform.nem'               
Hpz_Orbs_Comp: ; loc_075B9A: ; Compressed 
        incbin  'data\hpz\orbs.nem'        
Hpz_Unknow_Platform: ; loc_075DD6: 
        incbin  'data\hpz\unkptfm.nem'  
OOz_Elevator: ; loc_075F70:  
        incbin  'data\ooz\elevator.nem' 
OOz_Giant_Spikeball: ; loc_076060:  
        incbin  'data\ooz\gspkball.nem'   
OOz_Touch_Boost_Up: ; loc_076258:  
        incbin  'data\ooz\boost_up.nem'   
OOz_Break_Boost: ; loc_0762EE:  
        incbin  'data\ooz\brkboost.nem'            
OOz_Oil: ; loc_07635A:  
        incbin  'data\ooz\oil.nem' 
OOz_Tube_Oil: ; loc_0764D6:  
        incbin  'data\ooz\tube_oil.nem'   
OOz_Ball: ; loc_076602:  
        incbin  'data\ooz\ball.nem'     
OOz_Cannon: ; loc_076722:  
        incbin  'data\ooz\cannon.nem'  
OOz_Collapsing_Platform: ; loc_076A12:  
        incbin  'data\ooz\platform.nem'  
OOz_Spring_Push_Boost: ; loc_076CA6:   
        incbin  'data\ooz\spngpush.nem'  
OOz_Swing_Platform: ; loc_076E68:   
        incbin  'data\ooz\swngptfm.nem' 
Dhz_Box: ; loc_07708A:   
        incbin  'data\dhz\box.nem' 
Dhz_Collapsing_Platform: ; loc_0772C8:   
        incbin  'data\dhz\clp_ptfm.nem' 
Dhz_Vines: ; loc_077472:   
        incbin  'data\dhz\vines.nem' 
Dhz_Vines_1: ; loc_07756A:   
        incbin  'data\dhz\vines_1.nem'  
Dhz_Bridge: ; loc_077614:   
        incbin  'data\dhz\bridge.nem' 
Cpz_Elevator: ; loc_077684:      
        incbin  'data\cpz\elevator.nem'                                                                                                                      
Water_Surface: ; loc_0777D2: 
        incbin  'data\sprites\watrsurf.nem'  
Cpz_Speed_Booster: ; loc_077942:      
        incbin  'data\cpz\speedbst.nem' 
Cpz_Worms: ; loc_0779AA:      
        incbin  'data\cpz\worms.nem'                 
Cpz_Metal_Structure: ; loc_077A1C:      
        incbin  'data\cpz\metal_st.nem' 
loc_077C26:      
        incbin  'data\cpz\0x077C26.nem'        
Cpz_Automatic_Door: ; loc_077C66:      
        incbin  'data\cpz\autodoor.nem' 
Cpz_Open_Close_Platform: ; loc_077CD2:      
        incbin  'data\cpz\oc_ptfrm.nem'   
Cpz_Platforms: ; loc_077EB4:      
        incbin  'data\cpz\platform.nem'           
Cpz_Spring_Tubes: ; loc_078074:      
        incbin  'data\cpz\spgtubes.nem' 
Nghz_Water_Surface: ; loc_078270:      
        incbin  'data\nghz\watrsurf.nem'   
Nghz_Leaves: ; loc_078356:     
        incbin  'data\nghz\leaves.nem'                         
Nghz_Arrow_Shooter: ; loc_0783E2:                  
        incbin  'data\nghz\arrow_s.nem' 
Nghz_Water_Splash: ; loc_078540:                  
        incbin  'data\nghz\w_splash.nem'                                     
Switch: ; loc_078580:      
        incbin  'data\sprites\switch.nem'   
Vertical_Spring: ; loc_078658: 
        incbin  'data\sprites\v_spring.nem' 
Horizontal_Spring: ; loc_078774: 
        incbin  'data\sprites\h_spring.nem'               
Diagonal_Spring: ; loc_07883E: 
        incbin  'data\sprites\d_spring.nem'           
Head_up_display_Sprites: ; loc_078A12: 
        incbin  'data\sprites\hud.nem' ; Head-up display  
Head_up_display_Sonic: ; loc_078B1A:
        incbin  'data\sprites\hudsonic.nem'   
Rings: ; loc_078C30: 
        incbin  'data\sprites\rings.nem' 
Monitors: ; loc_078D24:
        incbin  'data\sprites\monitors.nem' ; Monitors    
Spikes: ; loc_07914E:        
        incbin  'data\sprites\spikes.nem' 
Enemy_Points_Spr: ; loc_07919E:
        incbin  'data\sprites\points.nem'                               
Lamp_Post: ; loc_079278:        
        incbin  'data\sprites\lamppost.nem' 
End_Panel: ; loc_07931E:  
        incbin  'data\sprites\endpanel.nem' 
Diagonal_Spring_1: ; loc_0798F4:        
        incbin  'data\sprites\dspring1.nem'         
Dhz_Horizontal_Spikes: ; loc_079A44:        
        incbin  'data\dhz\h_spikes.nem' 
Air_Bubbles_Numbers: ; loc_079AC0: 
        incbin  'data\sprites\airbubls.nem'             
Hpz_Crocobot: ; loc_07A11A: 
        incbin  'data\hpz\Crocobot.nem' 
Ghz_Buzzer_Bomber: ; loc_07A4BC: 
        incbin  'data\ghz\buzzbomb.nem'          
Hpz_Batbot: ; loc_07A6A2: 
        incbin  'data\hpz\batbot.nem' 
OOz_Octus: ; loc_07A9F8: 
        incbin  'data\ooz\octus.nem'         
Hpz_Rhinobot: ; loc_07AD18: 
        incbin  'data\hpz\rhinobot.nem'                 
Hpz_Dinobot: ; loc_07B114: 
        incbin  'data\hpz\dinobot.nem'          
Hpz_Piranha: ; loc_07B4EA: 
        incbin  'data\hpz\piranha.nem'  
OOz_Aquis: ; loc_07B9E2: 
        incbin  'data\ooz\aquis.nem' 
Spinning_Ball: ; loc_07BE30: 
        incbin  'data\sprites\spinball.nem'   
Blink: ; loc_07C0C6: 
        incbin  'data\sprites\blink.nem'    
Bubble_Monster: ; loc_07C2F2: 
        incbin  'data\sprites\bmonster.nem'                                 
Ghz_Motobug: ; loc_07C514: 
        incbin  'data\ghz\motobug.nem'           
Crawl: ; loc_07C710: 
        incbin  'data\cnz\crawl.nem'        
Ghz_Chopper: ; loc_07CA92: 
        incbin  'data\ghz\chopper.nem'
Robotnik_Ship: ; loc_07CC9E: 
        incbin  'data\sprites\robotnik.nem'  
Cpz_Boss: ; loc_07D3DA: 
        incbin  'data\cpz\boss.nem' 
Boss_Explosions: ; loc_07D938: 
        incbin  'data\sprites\bossexpl.nem'         
Ship_Boost: ; loc_07DFC0: 
        incbin  'data\sprites\shpboost.nem'    
Boss_Smoke: ; loc_07E03E: 
        incbin  'data\sprites\b_smoke.nem'                                                   
Ghz_Boss_Car: ; loc_07E124: 
        incbin  'data\ghz\boss_car.nem'                                        
Ghz_Boss_Blades: ; loc_07E910: 
        incbin  'data\ghz\b_blades.nem'         
Title_Cards: ; loc_07EA04:         
        incbin  'data\sprites\titlcard.nem' ; Title Cards
Explosion: ; loc_07F012:  
        incbin  'data\sprites\explosn.nem'
Game_Time_Over: ; loc_07F678:
        incbin  'data\sprites\gt_over.nem'
Vertical_Springs_Sonic_1: ; loc_07F80A:        
        incbin  'data\sprites\vspng_s1.nem'  
Horizontal_Springs_Sonic_1: ; loc_07F90C:        
        incbin  'data\sprites\hspng_s1.nem'         
Big_Ring_Flash: ; loc_07F9E8:
        incbin  'data\sprites\rngflash.nem'          
Hidden_Points: ; loc_07FB5C:
        incbin  'data\sprites\h_points.nem' 
Sonic_Continue_Screen: ; loc_07FE5E:
        incbin  'data\sprites\sonicctn.nem'   
Continue_Special_Stage_Results_Screen: ; loc_08010E:
        incbin  'data\sprites\cont_ss.nem'                                               
Rabbit: ; loc_080348:
        incbin  'data\sprites\rabbit.nem'
White_Bird: ; loc_0804A0:  
        incbin  'data\sprites\wthebird.nem'
Black_Bird: ; loc_0805FC:  
        incbin  'data\sprites\blckbird.nem'     
Seal: ; loc_080778:  
        incbin  'data\sprites\seal.nem' 
Pig: ; loc_080894:  
        incbin  'data\sprites\pig.nem' 
Blue_Bird: ; loc_0809CA:  
        incbin  'data\sprites\bluebird.nem'                             
Bear: ; loc_080B04:  
        incbin  'data\sprites\bear.nem'                                    
;--------------------------------------------------------
; Emerald(Green) Hill Zone Art
;--------------------------------------------------------					
Green_Hill_16x16_Map: ; loc_080C60: 
        incbin  'lvl_maps\blocks\ghz16.bin'           
Green_Hill_8x8_Tiles: ; loc_081C00: 
        incbin  'art\8x8tiles\ghz.bin'
Green_Hill_128x128_Map: ; loc_08692E:  
        incbin  'lvl_maps\chunks\ghz128.bin'
        even  				
;--------------------------------------------------------
; Hill Top Zone Art
;--------------------------------------------------------				
Hill_Top_16x16_Map: ; loc_084a50:    
        incbin  'lvl_maps\blocks\htz16.bin'          
Hill_Top_8x8_Tiles: ; loc_085200:  
        incbin  'art\8x8tiles\htz.bin'        
Htz_Init_Sprites_Dyn_Reload: ; loc_086626:    
        incbin  'data\htz\init_spr.nem'           
;--------------------------------------------------------
; Wood Zone Art
;--------------------------------------------------------			
Wood_16x16_Map: ; loc_089B8E:  
        incbin  'lvl_maps\blocks\wz16.bin'         
Wood_8x8_Tiles: ; loc_08AB2E: 
        incbin  'art\8x8tiles\wz.bin'         
Wood_128x128_Map: ; loc_08E826:        
        incbin  'lvl_maps\chunks\wz128.bin'
        even
;--------------------------------------------------------
; Metropolis Zone Art
;--------------------------------------------------------				
Metropolis_16x16_Map: ; loc_090456:
       incbin  'lvl_maps\blocks\mz16.bin' 
Metropolis_8x8_Tiles: ; loc_091716:
        incbin  'art\8x8tiles\mz.bin'         
Mz_Init_Sprites_Dyn_Reload: ; loc_094994:  
        incbin  'data\mz\init_spr.nem'          
Metropolis_128x128_Map: ; loc_094C56:         
        incbin  'lvl_maps\chunks\mz128.bin'    
        even  
;--------------------------------------------------------
; Hidden Palace Zone Art
;--------------------------------------------------------				
Hidden_Palace_16x16_Map: ; loc_097596:
       incbin  'lvl_maps\blocks\hpz16.bin' 
Hidden_Palace_8x8_Tiles: ; loc_098B76:
        incbin  'art\8x8tiles\hpz.bin'        
Hpz_Init_Sprites_Dyn_Reload: ; loc_09B884: Orbs
        incbin  'data\hpz\init_spr.nem'  
Hidden_Palace_128x128_Map: ; loc_09B9F8:         
        incbin  'lvl_maps\chunks\hpz128.bin'         
        even
Waterfall: ; loc_08E6C6:  
        incbin  'data\sprites\watrfall.nem'   				
;--------------------------------------------------------
; Oil Ocean Zone Art
;--------------------------------------------------------					
Oil_Ocean_16x16_Map: ; loc_09D778:
        incbin  'lvl_maps\blocks\ooz16.bin'
Oil_Ocean_8x8_Tiles: ; loc_09ED58:  
        incbin  'art\8x8tiles\ooz.bin'         
OOz_Init_Sprites_Dyn_Reload: ; loc_0a186A: red ball, oil ...
        incbin  'data\ooz\init_spr.nem' 
Oil_Ocean_128x128_Map: ; loc_0a1a58:         
        incbin  'lvl_maps\chunks\ooz128.bin'        
        dc.w    $0000, $0000, $0000, $0000, $0000 ; Filler         
;--------------------------------------------------------
; Dust Hill Zone Art
;--------------------------------------------------------					
Dust_Hill_16x16_Map: ; loc_0A3F88:
        incbin  'lvl_maps\blocks\dhz16.bin' 
Dust_Hill_8x8_Tiles: ; loc_0a5248:  
        incbin  'art\8x8tiles\dhz.bin'
				even
Dust_Hill_128x128_Map: ; loc_0A8B6A:           
        incbin  'lvl_maps\chunks\dhz128.bin'      
        even
;--------------------------------------------------------
; Casino Nigh Zone Art
;--------------------------------------------------------					
Casino_Night_16x16_Map: ; loc_0AB5CA:
        incbin  'lvl_maps\blocks\cnz16.bin'
Casino_Night_8x8_Tiles: ; loc_0ABF2A: 
        incbin  'art\8x8tiles\cnz.bin'    
				even
Cnz_Cards: ; loc_0AEF3C:           
        incbin  'data\cnz\cards.nem'
Casino_Night_128x128_Map: ; loc_0AF026:        
        incbin  'lvl_maps\chunks\cnz128.bin'      
        even 
;--------------------------------------------------------
; Chemical Plant Zone Art
;--------------------------------------------------------								
Chemical_Plant_16x16_Map: ; loc_0B0F26:  
        incbin  'lvl_maps\blocks\cpz16.bin'
Chemical_Plant_8x8_Tiles: ; loc_0B2506: 
        incbin  'art\8x8tiles\cpz.bin'
				even
Cpz_Init_Sprites_Dyn_Reload: ; loc_0B602E:  
        incbin  'data\cpz\init_spr.nem' 
Chemical_Plant_128x128_Map: ; loc_0B6058:         
        incbin  'lvl_maps\chunks\cpz128.bin'       
        dc.w    $0000, $0000, $0000 ; Filler  
Chemical_Plant_16x16_Map_Previous_Builder: ; loc_0C943C:                
        incbin  'data\all\cpz_16.dat'         
Chemical_Plant_8x8_Tiles_Previous_Builder: ; loc_0CAa1C:                
        incbin  'data\sprites\cpz_8.nem'  
Cpz_Building: ; loc_0CDFC6: Left over                    
        incbin  'data\sprites\building.nem'   
Chemical_Plant_128x128_Map_Previous_Builder:  ; loc_0CE03A:                  
        incbin  'data\all\cpz_128.dat'        				
;--------------------------------------------------------
; Neo Green Hill Zone Art
;--------------------------------------------------------						
Neo_Green_Hill_16x16_Map: ; loc_0B8558:
        incbin  'lvl_maps\blocks\nghz16.bin' 
Neo_Green_Hill_8x8_Tiles: ; loc_0B9E58:
        incbin  'art\8x8tiles\nghz.bin'     
        even				
Nghz_Init_Sprites_Dyn_Reload: ; loc_0BF408:  Waterfalls
        incbin  'data\nghz\init_spr.nem'  
Neo_Green_Hill_128x128_Map: ; loc_0BF568:          
        incbin  'lvl_maps\chunks\nghz128.bin'         
loc_0C2138: ; Leftover end of compressed Nghz 128x128 mappings...
        dc.w    $C00B, $F8C4, $C00B, $5200, $F8C0, $F80E, $00F0, $0000  
Unknow_Uncompressed_12x128_Map: ; loc_0C2148:                
        incbin  'data\all\unk_128.dat'       
Neo_Green_Hill_16x16_Map_Previous_Builder: ; loc_0D603A:                
        incbin  'data\all\nghz_16.dat'          
Neo_Green_Hill_8x8_Tiles_Previous_Builder: ; loc_0D793A:                
        incbin  'data\nghz\nghz_8.nem'                 
Nghz_Init_Sprites_Dyn_Reload_2: ; loc_0DCEEA: ; Waterfalls  ; Left over
        incbin  'data\nghz\init_spr.nem'          
Neo_Green_Hill_128x128_Map_Previous_Builder: ; loc_0DD04A:           
        incbin  'data\all\nghz_128.dat'          
Neo_Green_Hill_8x8_Incomplete_Tiles_Previous_Builder: ; loc_0E504A:           
        incbin  'data\sprites\nghz_8.nem'        
Nghz_Init_Sprites_Dyn_Reload_3: ; loc_0E57E6: ; Waterfalls  ; Left over
        incbin  'data\nghz\init_spr.nem'
       
Uncompiled_Asm: ; loc_0E5946:         
Cr              equ     $0D
Lf              equ     $0A
Tab             equ     $09    
        dc.b    $3B, $20, $88, $B3, $8F, $6B, $91, $4F
        dc.b    ' $8000  ', $88, $B3, $8F, $6B, $8C, $E3
        dc.b    ' $2c00  ', $88, $B3, $8F, $6B, $97, $a6
        dc.b    ' 34.4%  ', $83, $5A, $83, $8B, $90, $94
        dc.b    ' 1024', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$1d,$7f,$00,$ff,$f8,$7e,$04,$01,$fb,$02,$00,$03,$04,$05,$04,$80', Cr, Lf 
        dc.b    Tab, 'dc.b', Tab,'$ff,$fa,$ff,$07,$54,$0b,$54,$0a,$50,$0c,$50,$ff,$8f,$0d,$54,$0f', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$0e,$50,$10,$50,$11,$52,$19,$52,$18,$ff,$ff,$fc,$1a,$52,$1b', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$51,$8a,$51,$8b,$52,$1c,$02,$1e,$02,$1f,$02,$2a,$9f,$ff,$02,$2b', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$01,$8c,$01,$8d,$f4,$1d,$02,$2c,$02,$2d,$01,$ff,$f4,$88,$01,$89', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$01,$8e,$01,$8f,$02,$1a,$e4,$02,$2e,$02,$46,$c0,$2f,$e0,$ff,$1b', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ec,$fc,$dc,$00,$70,$02,$c4,$d4,$ee,$18,$02,$19,$01,$3f,$f6,$fd', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e4,$e6,$04,$2e,$04,$2d,$04,$9d,$fe,$77,$bd,$00,$be,$f9,$50,$31', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$30,$54,$2f,$7f,$f8,$56,$03,$56,$02,$56,$01,$05,$ff,$f0,$52', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$1d,$52,$1e,$e1,$9f,$52,$1f,$fc,$50,$3e,$54,$3c,$56,$04,$54,$36', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$09,$e0,$c4,$9c,$f8,$ea,$1a,$50,$48,$24,$41,$ba,$a4,$b2,$fc,$fc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$21,$9a,$f2,$80,$f6,$9c,$fc,$1d,$5e,$92,$68,$01,$8a,$01,$8b,$ee', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$fc,$68,$f2,$fd,$d5,$fd,$ce,$f7,$f7,$80,$fd,$f0,$f8,$0f,$04,$35', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$f8,$0d,$54,$3f,$54,$39,$7f,$fe,$54,$38,$01,$ff,$02,$00,$06', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$00,$60,$1a,$54,$43,$54,$ff,$f3,$42,$55,$fe,$55,$fd,$55,$fc,$55', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$fb,$54,$46,$a4,$1c,$ff,$11,$50,$49,$54,$44,$54,$52,$50,$51,$54', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$80,$b2,$12,$8e,$8f,$4e,$06,$fc,$f2,$f2,$3c,$90,$fa,$58,$5c', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$80,$f8,$20,$60,$f8,$20,$40,$f3,$02,$0a,$02,$2c,$3c,$0b,$70,$40', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f6,$86,$2a,$54,$29,$52,$f4,$62,$f8,$11,$c0,$f1,$2a,$52,$2b,$bc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f4,$fc,$1a,$62,$f1,$72,$6e,$f2,$f2,$78,$00,$16,$bd,$fe,$00,$17', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$fc,$f8,$0c,$18,$00,$19,$fc,$f8,$0c,$e0,$f8,$2e,$54,$06,$54,$04', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$fb,$be,$08,$50,$09,$f8,$fe,$50,$12,$50,$13,$fc,$f8,$0b,$00', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$14,$00,$15,$f7,$fc,$fc,$f8,$0c,$1e,$00,$1f,$fc,$f8,$0c,$20,$00', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$21,$fc,$f4,$50,$f5,$f7,$07,$50,$f6,$50,$f7,$e8,$fe,$50,$f8,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$87,$52,$1b,$3c,$1f,$fd,$e0,$fc,$50,$f9,$50,$85,$40,$ae,$f1,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$fa,$50,$fb,$07,$e1,$50,$fc,$50,$8b,$f6,$86,$f1,$2a,$1c,$50,$2f', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$b2,$8c,$50,$8d,$50,$8e,$24,$f1,$24,$ee,$0a,$24,$9a,$eb,$92,$f3', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$7c,$f2,$0a,$f2,$e0,$ec,$af,$9f,$dc,$05,$6d,$ae,$ef,$60,$f2,$1a', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$06,$25,$01,$89,$45,$94,$e4,$4e,$ed,$e0,$e8,$2a,$f3,$11,$ae,$e0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$c0,$28,$02,$29,$38,$f6,$00,$8c,$c0,$fd,$ce,$e4,$a0,$59,$44', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$c0,$8d,$ce,$00,$ea,$bc,$e0,$0b,$a8,$d6,$fc,$1b,$dc,$e2,$f8,$f0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$68,$ec,$ea,$bd,$f8,$e5,$20,$f0,$15,$a0,$e8,$09,$20,$f0,$16,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$0d,$20,$f5,$1b,$52,$1c,$92,$a0,$dc,$e4,$60,$e5,$a8,$6e,$e2', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$80,$6e,$e4,$82,$28,$12,$fc,$4e,$e2,$80,$6e,$e2,$44,$ee,$e7,$fa', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$00,$66,$8e,$fe,$56,$25,$51,$8c,$c0,$c2,$e4,$bc,$f0,$fe,$38,$02', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$15,$d8,$80,$fc,$06,$f8,$9d,$59,$f0,$12,$02,$11,$02,$10,$80,$fc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f6,$5a,$30,$fe,$e0,$ee,$13,$80,$2e,$52,$2f,$f9,$6d,$7f,$f5,$05', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f9,$02,$16,$00,$23,$00,$24,$e4,$f3,$f2,$f1,$80,$ea,$50,$2b,$20', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$8c,$50,$76,$5a,$f3,$84,$51,$89,$40,$a0,$5c,$58,$60,$6e,$00,$f9', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$11,$95,$ae,$f5,$1b,$5a,$f6,$6a,$e3,$6a,$fc,$02,$82,$e8,$10,$96', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ee,$ea,$47,$0f,$ce,$f2,$13,$02,$14,$76,$b2,$f2,$16,$02,$17,$44', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$8c,$ee,$e4,$88,$ea,$33,$fa,$d4,$04,$23,$f2,$e4,$e6,$fc,$54,$27', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$4f,$e4,$94,$54,$93,$04,$92,$e0,$ea,$e4,$f2,$54,$af,$af,$85', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$97,$04,$98,$c6,$fd,$52,$f3,$54,$87,$54,$99,$bc,$fc,$ff,$ff', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$00,$e8,$39,$50,$6b,$50,$6c,$50,$6d,$50,$73,$50,$74,$50,$75,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$76,$50,$ff,$8f,$77,$50,$78,$50,$79,$50,$15,$50,$7a,$50,$7b,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$7c,$5e,$51,$f8,$20,$ee,$12,$00,$13,$fc,$f8,$0c,$00,$e8,$0e,$08', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$6e,$e2,$4d,$d2,$fc,$f2,$bc,$d2,$8a,$32,$ee,$f6,$60,$04,$f0,$fa', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$22,$fa,$00,$23,$06,$5c,$32,$fc,$80,$f1,$26,$54,$25,$67,$c1,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$27,$f6,$58,$20,$80,$f2,$20,$60,$d1,$51,$55,$f1,$6d,$d8,$80,$f3', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$cc,$f3,$28,$f1,$80,$f0,$09,$12,$dc,$2d,$a3,$04,$e1,$d8,$ea,$18', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$84,$d6,$a0,$d8,$4f,$41,$80,$f4,$02,$25,$01,$24,$ae,$05,$c0,$80', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f4,$88,$23,$f0,$25,$92,$12,$05,$fa,$ab,$02,$d6,$e0,$ff,$92,$f3', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e0,$fc,$8a,$f1,$e0,$86,$a7,$88,$10,$88,$01,$f9,$01,$fa,$80,$5d', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$21,$05,$fa,$60,$fc,$50,$28,$80,$fe,$e0,$e9,$fc,$2d,$1b,$94,$84', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$bc,$c9,$52,$86,$c0,$ce,$64,$ea,$2a,$7c,$74,$19,$fa,$e9,$76,$d2', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$58,$55,$05,$48,$01,$5d,$f9,$5e,$f2,$fc,$f4,$57,$05,$52,$85,$e9', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$1b,$05,$49,$f4,$fe,$02,$d5,$ff,$f2,$f4,$f8,$09,$ff,$f8,$32,$32', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d6,$96,$ca,$ff,$d8,$38,$50,$39,$50,$3f,$a2,$49,$a2,$4a,$fc,$54', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ea,$fe,$7f,$af,$02,$0d,$02,$0e,$02,$0f,$06,$0d,$cc,$f8,$0a,$c1', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$00,$c2,$bc,$f8,$0c,$d2,$f9,$f0,$f8,$2c,$c0,$e1,$f0,$07,$04,$05', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f1,$07,$51,$bf,$aa,$75,$50,$c1,$50,$c2,$54,$31,$a0,$c6,$ac,$da', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ee,$f5,$46,$f2,$aa,$20,$60,$f3,$e4,$f3,$dc,$de,$d2,$cc,$6e,$de', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d4,$52,$d8,$0c,$b2,$ac,$e2,$e8,$5c,$f3,$d8,$c8,$e2,$82,$b2,$20', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$de,$34,$f3,$ec,$1a,$f2,$84,$db,$b8,$84,$6a,$e8,$fe,$c4,$b8,$c0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$b8,$49,$20,$fc,$c0,$b8,$10,$1b,$2d,$e8,$08,$f3,$00,$f1,$51,$fc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$da,$8a,$f2,$bd,$ae,$d7,$97,$01,$73,$06,$99,$fc,$fe,$98,$f6,$e4', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$04,$0a,$fc,$f6,$f4,$9b,$7f,$46,$f6,$06,$9f,$02,$e2,$0a,$98,$0a', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f4,$e6,$38,$e9,$fe,$e3,$04,$00,$fa,$f4,$fc,$50,$f5,$93,$43,$e2', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$06,$91,$02,$fe,$92,$f8,$f0,$07,$84,$98,$06,$96,$02,$fe,$b0,$f8', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$91,$20,$06,$95,$f0,$c4,$fe,$9a,$8d,$87,$f8,$06,$9c,$f0,$e4,$02', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e5,$aa,$08,$fe,$02,$bc,$f8,$fa,$eb,$32,$50,$33,$50,$34,$9f,$ff', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$b4,$50,$b5,$50,$b6,$fc,$b7,$50,$b8,$50,$b9,$54,$e1,$fb,$b9', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$fe,$ba,$f0,$bb,$f0,$bc,$68,$d2,$06,$19,$fc,$ff,$f4,$ae,$fc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ad,$fc,$ac,$fc,$ab,$fc,$aa,$f0,$fc,$a6,$fc,$fb,$8b,$a5,$fc,$a4', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$48,$d6,$30,$be,$3c,$a3,$3c,$a2,$38,$d0,$09,$c5,$56,$f0,$a1,$58', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$c0,$0b,$f0,$a0,$f0,$f8,$0e,$9f,$40,$b0,$52,$58,$d5,$b5,$6e,$80', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f7,$58,$d5,$80,$f0,$0d,$f1,$72,$cc,$80,$f7,$01,$6d,$c0,$f8,$1e', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$58,$45,$fd,$48,$f6,$bc,$fc,$c0,$c0,$ee,$9c,$ea,$18,$a1,$6d,$01', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$4b,$f8,$48,$05,$55,$8e,$cc,$a6,$f0,$52,$05,$57,$d1,$a0,$05,$56', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ec,$38,$ea,$88,$a0,$32,$cb,$c0,$fe,$ec,$fe,$c6,$f0,$ec,$fe,$01', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$1f,$02,$5d,$01,$ff,$bf,$0f,$01,$10,$02,$45,$02,$30,$02,$31,$c1', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$da,$c2,$33,$c2,$32,$ff,$cf,$d2,$e2,$02,$34,$02,$35,$02,$32,$c1', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$db,$c2,$3c,$02,$3d,$7f,$00,$f0,$47,$02,$36,$02,$37,$c1,$dc,$e0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ea,$0e,$ff,$f0,$44,$ce,$c5,$d8,$c1,$d9,$02,$40,$02,$f0,$ff,$41', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$c1,$d4,$c1,$d5,$c1,$d6,$c1,$d7,$02,$3e,$02,$ff,$3f,$3f,$02', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$46,$c0,$c1,$c0,$c2,$c2,$3a,$c2,$3b,$02,$38,$02,$39,$01,$02,$d8', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$d0,$c8,$02,$7e,$c0,$c4,$f8,$30,$01,$29,$01,$2a,$02,$44,$92', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d6,$aa,$c0,$a3,$aa,$80,$d3,$8b,$2e,$ca,$d3,$a0,$c9,$9a,$d2,$a4', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$cd,$aa,$eb,$80,$cf,$a4,$cd,$66,$d2,$a8,$ce,$80,$d6,$04,$5e,$72', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ce,$60,$d5,$5d,$97,$f6,$54,$61,$54,$60,$e4,$fc,$ea,$52,$1c,$e0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$a9,$63,$54,$ff,$da,$62,$54,$67,$54,$66,$54,$65,$54,$64,$f2,$bc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e0,$ac,$54,$e0,$a9,$7f,$e1,$51,$fb,$51,$fc,$51,$fd,$51,$fe,$80', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e8,$0f,$fc,$50,$ba,$5b,$50,$50,$bb,$50,$80,$e8,$14,$0c,$80,$e8', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$0c,$f0,$80,$e8,$7b,$e0,$d8,$3f,$fd,$ef,$ec,$e9,$9a,$f2,$1e,$54', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$9d,$54,$9c,$54,$90,$54,$8f,$92,$b7,$1c,$1f,$d5,$54,$8e,$54,$8d', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$50,$e0,$e8,$ba,$b2,$9e,$80,$9a,$aa,$aa,$1d,$9c,$bb,$c4,$da', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$7c,$ea,$ba,$b2,$36,$db,$f8,$9d,$00,$be,$aa,$f4,$a0,$c8,$09,$8e', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$a6,$0e,$a3,$92,$c6,$c0,$9a,$d4,$04,$24,$00,$c2,$ff,$5a,$32,$f0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$09,$e6,$54,$4f,$54,$4e,$54,$4d,$54,$4c,$54,$d5,$7e,$59,$54,$9c', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$c3,$a8,$b1,$00,$ea,$1c,$80,$99,$57,$54,$56,$54,$5f,$11,$55,$60', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ff,$aa,$ea,$80,$9a,$a0,$fe,$06,$bc,$95,$54,$68,$d6,$5c,$d6,$12', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$9c,$56,$dc,$e4,$9a,$ea,$84,$c4,$8f,$3f,$5c,$ac,$51,$09,$83,$f2', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$62,$02,$63,$01,$88,$05,$7c,$a2,$f6,$51,$00,$91,$09,$24,$f2,$fc', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$10,$25,$05,$64,$91,$f0,$96,$b2,$ee,$61,$1d,$92,$c1,$f2,$50,$91', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$a8,$c2,$fc,$fe,$f0,$96,$ac,$b0,$f0,$48,$b1,$8d,$64,$e1,$20,$c3', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f0,$00,$9e,$8c,$aa,$92,$95,$78,$f2,$60,$f8,$09,$8e,$93,$92,$f3', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d1,$f5,$72,$90,$09,$1f,$36,$44,$ef,$00,$53,$40,$b1,$fa,$f1,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$4a,$ff,$ff,$50,$4b,$50,$4c,$50,$4d,$50,$4e,$50,$4f,$50,$55,$50', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$56,$50,$57,$3d,$48,$50,$3d,$f8,$f5,$18,$50,$40,$f6,$fc,$f7,$2a', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$a9,$2a,$20,$9a,$b6,$bb,$20,$90,$0a,$e8,$ee,$fe,$e8,$a4,$a4,$ff', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$e4,$f4,$c6,$80,$de,$0e,$b5,$50,$46,$50,$47,$50,$48,$50,$3f,$c2', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$3a,$50,$3b,$50,$42,$50,$43,$a0,$ff,$51,$5f,$55,$50,$52,$50,$44', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$45,$d8,$f1,$3c,$f2,$e4,$c3,$2e,$f8,$09,$a0,$8e,$95,$05,$a0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$fd,$80,$88,$0a,$e0,$ef,$0e,$b2,$c5,$ce,$55,$62,$00,$bb,$5c,$f8', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$0a,$60,$f6,$5c,$8a,$3c,$5a,$2b,$2a,$d2,$fe,$01,$12,$a0,$09,$52', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f3,$f0,$5a,$f3,$8e,$fe,$30,$91,$f0,$b6,$f2,$ea,$8a,$32,$c0,$d1', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$96,$fd,$2e,$bd,$f0,$b2,$fe,$12,$cb,$2c,$c0,$40,$fd,$0e,$a0,$5c', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$8f,$be,$56,$a0,$a6,$4e,$a2,$51,$82,$b8,$09,$88,$a1,$53,$22,$b8', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$2d,$c0,$82,$f5,$27,$f0,$f8,$0b,$a6,$b9,$c0,$81,$54,$34,$54,$33', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$32,$f0,$ed,$92,$40,$d1,$e0,$ea,$1a,$c0,$82,$54,$37,$c0,$81', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$68,$68,$55,$72,$f2,$58,$aa,$81,$41,$00,$e0,$60,$8e,$b0,$0a,$c0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$80,$09,$7a,$b0,$0a,$bf,$28,$80,$c0,$40,$c0,$be,$cc,$a3,$cc,$00', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d8,$0a,$f0,$00,$d8,$0c,$8a,$ba,$f0,$00,$d8,$0c,$f0,$00,$d8,$0a', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$88,$fe,$54,$b4,$7f,$fd,$cc,$f4,$f4,$bc,$f4,$bb,$f4,$ba,$f4,$80', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d1,$7c,$d1,$bf,$50,$c0,$f8,$ff,$fa,$aa,$f8,$ab,$f8,$ac,$f8,$ad', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f8,$ae,$d4,$91,$26,$b7,$f8,$b1,$f8,$fb,$dd,$b2,$f8,$b3,$16,$b0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$0b,$38,$af,$38,$b0,$30,$06,$b0,$0c,$38,$a9,$f0,$f8,$0e,$d6,$ed', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$a8,$f0,$f8,$0e,$a7,$f0,$f8,$0d,$ff,$f8,$13,$f0,$d5,$f0,$f8,$0e', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d6,$f0,$f8,$0e,$d7,$fd,$ff,$05,$6e,$f2,$f8,$09,$f4,$d8,$f0,$d9', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$55,$71,$55,$70,$55,$6f,$50,$dd,$7f,$7f,$f0,$de,$f0,$df,$f0,$e0', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f2,$18,$00,$f1,$72,$51,$73,$50,$ef,$f0,$d8,$f0,$ff,$f1,$f2,$00', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$d9,$a2,$fe,$1f,$a1,$88,$7f,$70,$a1,$89,$a2,$2c,$a2,$2d,$a2,$1a', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$f4,$f8,$c8,$67,$02,$59,$5d,$ef,$a0,$6c,$f0,$fe,$f2,$5a,$00,$d4', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$9b,$f8,$4c,$2d,$00,$2e,$ac,$e8,$0a,$2f,$ff,$6d,$50,$30,$50,$31', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$50,$36,$50,$37,$50,$3c,$40,$df,$1e,$40,$d9,$1b,$ad,$6a,$7c,$e7', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$54,$e2,$8d,$88,$94,$f8,$d4,$a0,$8c,$92,$8e,$ee,$cb,$8f,$05,$19', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$ee,$bf,$2a,$e2,$f4,$80,$88,$0a,$e6,$04,$14,$f2,$e0,$ba,$f6,$ee', Cr, Lf
        dc.b    Tab, 'dc.b', Tab,'$c0,$d3,$94,$f5,$e0,$c0,$d0,$15,$58,$85,$80,$84,$da,$'
Incomplete_Sega_Snd: ; Left Over ; loc_0E8000:  
 ;       incbin  'data\all\sega.snd'  
; $F0000 => Sounds $98 to $9F
; $F8000 => Sounds $81 to $97 
;================================ Sound Driver ================================         
Sound_Driver: ; loc_0EC000: S2B_0x0EC000:         

        move	SR, -(A7)
        movem.l D0-a6, -(SP)
        move    #$2700, SR
        lea     ($00A11100), A3
		lea     ($00A11200), A2
		moveq   #0, D2
		move.w  #$100, d1 
	        move.w  d1, (a3)	
        move.w  d1, (a2)
Sound_Driver_001:        
        btst    D2, (a3)
        bne.s   Sound_Driver_001 
        jsr     Sound_Driver_002(PC)
        move.w  D2, (a2)
        move.w  D2, (a3)
        moveq   #$17, d0
Sound_Driver_Loop_01:
        dbra    d0, Sound_Driver_Loop_01
        move.w  d1, (a2)
        movem.l (SP)+,D0-a6
        move    (SP)+, SR
        rts
Sound_Driver_002:
        lea     Sound_Driver_009(PC), a6 
        move.w  #$DF3, D7
        moveq   #0, D6
        lea     ($00A00000), a5
        moveq   #0,d5
        lea     ($00A00000), A4
Sound_Driver_003:        
        lsr.w   #1, D6
        btst    #8, D6
        bne.s   Sound_Driver_004
        jsr     Sound_Driver_007(PC)
        move.b  d0, D6
        ori.w   #$FF00, D6
Sound_Driver_004:  
        btst    #0, D6
        beq.s   Sound_Driver_005
        jsr     Sound_Driver_007(PC)
        move.b  d0, (a5)+
        addq.w  #1,d5
        bra.w   Sound_Driver_003 
Sound_Driver_005:          
        jsr     Sound_Driver_007(PC)
        moveq   #0, D4
        move.b  d0, D4 
        jsr     Sound_Driver_007(PC)
        move.b  d0, d3 
        andi.w  #$F, d3
        addq.w  #$2, d3
        andi.w  #$0F0, d0
        lsl.w   #4, d0
        add.w   d0, D4
        addi.w  #$012, D4
        andi.w  #$FFF, D4
        move.w  d5, d0
        andi.w  #$F000, d0
        add.w   d0, D4
        cmp.w   d4,d5  
        bcc.s   Sound_Driver_006
        subi.w  #$1000, D4
        bcc.s   Sound_Driver_006
        add.w   d3,d5
        addq.w  #1,d5
Sound_Driver_Loop_02:        
        move.b  #0, (a5)+
        addq.w  #1, D4
        dbra    d3, Sound_Driver_Loop_02
        bra.w   Sound_Driver_003
Sound_Driver_006:        
        add.w   d3,d5
        addq.w  #1,d5
Sound_Driver_Loop_03:         
        move.b  $00(A4, D4), (a5)+
        addq.w  #1, D4
        dbra    d3, Sound_Driver_Loop_03 
        bra.w   Sound_Driver_003 
Sound_Driver_007:        
        move.b  (a6)+, D0   
        subq.w  #1, D7  
        bne.s   Sound_Driver_008
        addq.w  #4, A7
Sound_Driver_008:      
        rts           
Sound_Driver_009:  
        dc.w    $FFF3,$3180,$1BC3,$2D01,$00FF,$3A00,$4087,$38FA
        dc.w    $C900,$FFDD,$CB01,$5628,$0218,$10FF,$F5CF,$F132
        dc.w    $0040,$F5CF,$FF79,$3201,$40F1,$C900,$00EA,$0601
        dc.w    $020B,$0203,$1103,$D9CD,$B9FF,$0BAF,$32AA,$11DD
        dc.w    $2180,$FF1B,$3A83,$1BB7,$2806,$CDFF,$BD05,$C3E9
        dc.w    $00DD,$3501,$FFCC,$F40A,$3A84,$1BB7,$C4EF,$0B0A
        dc.w    $3A8E,$4700,$370B,$3AFF,$891B,$DDB6,$0ADD,$B60B
        dc.w    $FFC4,$2106,$3A88,$1BFE,$80FF,$C45E,$063E,$FF32
        dc.w    $871B,$FFDD,$2197,$1BDD,$CB00,$7EEF,$C4A9,$01AF
        dc.w    $6900,$0606,$C5DF,$112A,$00DD,$1970,$02FE,$01DF
        dc.w    $C110,$F006,$037D,$0896,$04FE,$8A00,$AF1E,$0121
        dc.w    $0060,$731A,$A501,$77AA,$003E,$802C,$008D,$0A88
        dc.w    $0FFA,$9A09,$77A7,$043A,$A811,$B7FA,$FF05,$01D9
        dc.w    $0601,$F1FB,$C9F7,$3E80,$08E6,$00D6,$8132,$A8FF
        dc.w    $1187,$87C6,$7532,$2201,$FFC6,$0232,$2601,$F121
        dc.w    $3CFF,$01E3,$2A75,$0FED,$5B77,$FF0F,$0100,$01FB
        dc.w    $C9CD,$88FF,$0AFB,$FD21,$7901,$1100,$FF00,$7AB3
        dc.w    $28FC,$10FE,$F3DB,$3E2A,$0900,$7E07,$3310,$E60F
        dc.w    $7F32,$5101,$08FD,$8600,$0F00,$6F08,$41FB,$002A
        dc.w    $10F5,$F12D,$12AF,$417E,$231B,$3710,$6F3B,$16FB
        dc.w    $F700,$C338,$1610,$0204,$0810,$FF20,$4080,$FFFE
        dc.w    $FCF8,$F0FF,$E0C0,$151C,$0000,$3F1C,$FF69,$1CBD
        dc.w    $1CE7,$1C11,$1DFF,$111D,$3B1D,$0000,$651D,$FF8F
        dc.w    $1DB9,$1DE3,$1D0D,$1EFF,$0D1E,$DD35,$0BC0,$DD6E
        dc.w    $FF03,$DD66,$047E,$23FE,$E0FF,$3806,$CDDF,$0BC3
        dc.w    $B301,$FFB7,$F2D5,$01DD,$770D,$7EFF,$B7F2,$D401
        dc.w    $DD7E,$0CDD,$FF77,$0BC3,$D801,$23CD,$6B7F,$02DD
        dc.w    $7503,$DD74,$0470,$00FF,$56C0,$DD7E,$0DFE,$80C8
        dc.w    $FFD6,$8187,$C68D,$32F3,$01DF,$ED4B,$8D0F,$79FB
        dc.w    $0078,$32B7,$2901,$C997,$1020,$0D70,$00A6,$FFCD
        dc.w    $1902,$CDDB,$03C3,$9CFF,$0BCD,$A502,$CDBD,$02C3
        dc.w    $D3EB,$039B,$1370,$008E,$A117,$2302,$FFF5,$CDAC
        dc.w    $0BF1,$B7F2,$41FF,$02CD,$4702,$7EB7,$FA7C,$FD02
        dc.w    $C211,$C37C,$02D6,$8028,$FF14,$DD86,$0587,$C61B
        dc.w    $32FF,$5602,$ED5B,$1B03,$DD73,$DF0D,$DD72,$0EC9
        dc.w    $7000,$CEAF,$FEB1,$10DD,$770E,$C94F,$DD46,$DF02
        dc.w    $1007,$DD77,$BB11,$C981,$A3C3,$6FC5,$15BA,$1270
        dc.w    $0066,$D010,$10BF,$DD77,$0FDD,$3609,$FDF0,$00FF
        dc.w    $5EC8,$DD6E,$11DD,$6612,$FFC3,$180E,$DD7E,$0FB7
        dc.w    $C8AF,$DD35,$0FC0,$4D21,$D1FE,$F07E,$BFC2,$A305
        dc.w    $C3AC,$0BA0,$2000,$F94E,$9B21,$8820,$7E13,$B728
        dc.w    $0497,$DD35,$13EB,$1014,$9A10,$8C21,$23FF,$7EDD
        dc.w    $7714,$DD7E,$16B7,$F720,$0F23,$CA21,$16DD,$7E15
        dc.w    $DFED,$44DD,$7715,$EB10,$16DD,$FF6E,$17DD,$6618
        dc.w    $0600,$DDFF,$4E15,$CB79,$CA0B,$0306,$FFFF,$09DD
        dc.w    $7517,$DD74,$18FF,$DD4E,$0DDD,$460E,$09EB,$FFE9
        dc.w    $5E02,$8402,$AB02,$D3FF,$02FE,$022D,$035C,$038F
        dc.w    $FF03,$C503,$FF03,$3C04,$7CFF,$045E,$0A84,$0AAB
        dc.w    $0AD3,$FF0A,$FE0A,$2D0B,$5C0B,$8FFF,$0BC5,$0BFF
        dc.w    $0B3C,$0C7C,$FF0C,$5E12,$8412,$AB12,$D3FF,$12FE
        dc.w    $122D,$135C,$138F,$FF13,$C513,$FF13,$3C14,$7CFF
        dc.w    $145E,$1A84,$1AAB,$1AD3,$FF1A,$FE1A,$2D1B,$5C1B
        dc.w    $8FFF,$1BC5,$1BFF,$1B3C,$1C7C,$FF1C,$5E22,$8422
        dc.w    $AB22,$D3FF,$22FE,$222D,$235C,$238F,$FF23,$C523
        dc.w    $FF23,$3C24,$7CFF,$245E,$2A84,$2AAB,$2AD3,$FF2A
        dc.w    $FE2A,$2D2B,$5C2B,$8FFF,$2BC5,$2BFF,$2B3C,$2C7C
        dc.w    $FF2C,$5E32,$8432,$AB32,$D3FF,$32FE,$322D,$335C
        dc.w    $338F,$FF33,$C533,$FF33,$3C34,$7CFF,$345E,$3A84
        dc.w    $3AAB,$3AD3,$FF3A,$FE3A,$2D3B,$5C3B,$8FFF,$3BC5
        dc.w    $3BFF,$3B3C,$3C7C,$FD3C,$AC23,$5E0D,$DD56,$0E7A
        dc.w    $EFB3,$CA42,$05CC,$1226,$00DD,$FF6E,$19CB,$7D28
        dc.w    $0226,$FFFF,$194C,$DD7E,$01E6,$03C6,$FFA4,$D74D
        dc.w    $D604,$D7C9,$56FF,$0326,$03F9,$02CE,$02A5,$FF02
        dc.w    $8002,$5C02,$3A02,$1AFF,$02FB,$01DF,$01C4,$01AB
        dc.w    $FF01,$9301,$7D01,$6701,$53FF,$0140,$012E,$011D
        dc.w    $010D,$FF01,$FE00,$EF00,$E200,$D6FF,$00C9,$00BE
        dc.w    $00B4,$00A9,$FF00,$A000,$9700,$8F00,$87FF,$007F
        dc.w    $0078,$0071,$006B,$FF00,$6500,$5F00,$5A00,$55FF
        dc.w    $0050,$004B,$0047,$0043,$FF00,$4000,$3C00,$3900
        dc.w    $36FF,$0033,$0030,$002D,$002B,$FF00,$2800,$2600
        dc.w    $2400,$22FF,$0020,$001F,$001D,$001B,$FF00,$1A00
        dc.w    $1800,$1700,$167F,$0015,$0013,$0012,$0023,$10FC
        dc.w    $3E00,$EE15,$B404,$CD04,$05C3,$DB4C,$05FE,$1147
        dc.w    $0501,$2110,$05FE,$072F,$0BC3,$BE04,$B7F2,$D76F
        dc.w    $04CD,$DD04,$292A,$8138,$3823,$FF0A,$32EC,$04ED
        dc.w    $5B0A,$04B6,$4628,$3EFF,$5223,$C3A3,$D830,$0EF7
        dc.w    $7E20,$38CE,$33DD,$7E00,$E6F9,$06DD,$3AEB,$30FE
        dc.w    $E020,$023E,$FFC0,$477D,$E60F,$B032,$11DF,$7F7D
        dc.w    $CB3C,$1F22,$501F,$1FF3,$E63F,$1E50,$4C22,$C9DD
        dc.w    $7E08,$F696,$2046,$0635,$5128,$2721,$A9FF,$0F3D
        dc.w    $875F,$1600,$197E,$FF23,$66DD,$8609,$6F8C,$95FF
        dc.w    $677E,$DD34,$09B7,$F274,$FF05,$FE80,$282B,$80FE
        dc.w    $109F,$3802,$3E0F,$47FE,$4376,$2120,$DD0A,$EB30
        dc.w    $B0C6,$102C,$527E,$10B7,$B728,$F093,$2120,$EAEB
        dc.w    $1009,$DC4C,$21CF,$1101,$F61F,$2C51,$2111,$FF7F
        dc.w    $369F,$36BF,$36DF,$36FF,$FFC9,$FACD,$05FE,$02C8
        dc.w    $FFDD,$3603,$02CD,$700A,$C3AF,$B105,$DDE5,$B150
        dc.w    $006C,$0106,$EF07,$CDFA,$059F,$0CDD,$213B,$671D
        dc.w    $0603,$C750,$2800,$DDE1,$4C21,$FB7E,$28BA,$0156
        dc.w    $2013,$DD4E,$DD07,$EB33,$B4D7,$C535,$50CD,$76BB
        dc.w    $0DC1,$B602,$10DA,$C95F,$02C0,$FF21,$891B,$3A80
        dc.w    $1B4F,$06FF,$037E,$5F36,$0023,$FE81,$FF38,$22D6
        dc.w    $A030,$057B,$32FF,$881B,$C9E5,$C630,$6FCE,$BD0F
        dc.w    $5450,$B938,$054F,$2B61,$E1FF,$79B7,$F832,$801B
        dc.w    $C910,$FFD3,$C9B7,$CA88,$0AF0,$DDFF,$3608,$80FE
        dc.w    $A0DA,$E306,$FFFE,$A0D8,$FEE1,$DA95,$08FF,$FEF9
        dc.w    $D8FE,$FED0,$D6F9,$FF87,$8732,$8206,$18FE,$C3FF
        dc.w    $F609,$00C3,$9706,$00C3,$DF07,$0B00,$C314,$7B60
        dc.w    $880A,$3F00,$3E2B,$0E80,$DF9F,$03DE,$017E,$A902
        dc.b    $21
;0x000EC70D Sega_Pointer 8C9E
Sega_Snd_Ptr    equ     (Sega_Snd&$FFFF)|$8000                       
        dc.w    ((Sega_Snd_Ptr>>$08)|(Sega_Snd_Ptr<<$08))&$FFFF 
        dc.b    $11
        dc.w    $BA30,$2D12,$F70E,$807E,$0F00,$2300
        dc.w    $060C,$BB10,$FE5F,$00B9,$2010,$A667,$1BDF,$7AB3
        dc.w    $C2B8,$0628,$003A,$95FF,$1B4F,$3E2B,$DFC9,$32A9
        dc.w    $FF11,$FE98,$203B,$3A91,$1B67,$B720,$3C6C,$01B6
        dc.w    $0006,$0A70,$0055,$960A,$60F8,$D952,$0670,$00BE
        dc.w    $EB61,$F711,$371E,$3000,$01BB,$01ED,$DDB0,$AE00
        dc.w    $911B,$AF45,$6018,$07FD,$AF0A,$7032,$901B,$CDAE
        dc.w    $0AF3,$3AA9,$F800,$4850,$2188,$1119,$BF7E,$3293
        dc.w    $1B21,$6927,$7047,$BFE6,$8032,$961B,$7847,$5121
        dc.b    $EF
;0x000EC79D Music_Pointers 0080        
Snd_81To97_Ptr  equ     (Music_81_To_97&$FFFF)|$8000                       
        dc.w    ((Snd_81To97_Ptr>>$08)|(Snd_81To97_Ptr<<$08))&$FFFF         
        dc.b    $19
        dc.w    $E528,$00E1,$5E23,$FF56,$D5DD,$E1DD
        dc.w    $5E00,$DDFF,$5601,$ED53,$8C1B,$DD7E,$FF05,$3292
        dc.w    $1B47,$3A94,$1BFF,$B778,$2803,$3A93,$1B32,$FF82
        dc.w    $1B32,$811B,$DDE5,$E1F7,$1106,$000F,$5002,$B7CA
        dc.w    $F9DF,$0747,$FDE5,$FD6D,$014E,$04FF,$118B,$08FD
        dc.w    $CB00,$FE1A,$FF13,$FD77,$01FD,$7102,$FDFF,$360A
        dc.w    $2AFD,$3607,$C0FD,$FF36,$0B01,$D5C5,$FD7D,$C6FF
        dc.w    $035F,$FD8C,$9357,$EDA0,$FCAB,$73B6,$00FD,$19C1
        dc.w    $D110,$CCFB,$FDE1,$7470,$FE07,$2004,$AFFF,$4F18
        dc.w    $183E,$280E,$06DF,$FF3E,$420E,$FF06,$04EF,$C6FF
        dc.w    $0410,$FB3E,$B60E,$C0EF,$BF3E,$804F,$3295,$1BCD
        dc.w    $60DD,$BF7E,$03B7,$CA45,$087B,$72BD,$C51C,$8271
        dc.w    $9287,$7F9D,$7FAB,$7123,$7E2F,$23FD,$7708,$B375
        dc.w    $CABC,$70F0,$62F4,$B601,$E951,$1CEB,$30B7,$FA60
        dc.w    $08DF,$D602,$8718,$0627,$501F,$E6FF,$0FC6,$8932
        dc.w    $6C08,$2A89,$7B01,$CBEA,$61DA,$DD21,$C17A,$00C4
        dc.w    $1E20,$0A60,$F9DD,$50F0,$406C,$80C9,$06FE,$6711
        dc.w    $0506,$80A0,$C04F,$DDFF,$7E11,$DDB6,$04DD,$B60E
        dc.w    $FFC2,$7809,$79FE,$B520,$0FFF,$3AAB,$11B7,$2002
        dc.w    $0ECE,$FF2F,$32AB,$11C3,$C508,$79FF,$FEA7,$200A
        dc.w    $3AAC,$11B7,$EDC0,$AE00,$AC11,$9F0C
        dc.b    $21
;0x000EC8E9 Sfx_Pointers 00F0
Sfx_Pointers    equ     (Sfx_A0_To_F9&$FFFF)|$8000                       
        dc.w    ((Sfx_Pointers>>$08)|(Sfx_Pointers<<$08))&$FFFF 
        dc.b    $D7
        dc.w    $79D6,$A047,$556F,$4670,$23ED,$FF53,$6809,$4E23
        dc.w    $4623,$C5BF,$AF32,$5F09,$E523,$2920,$01DD,$0949
        dc.w    $80C3,$1A09,$DF80,$FEC0,$B720,$0CF5,$9952,$EE20
        dc.w    $1E50,$F1D6,$4E86,$2009,$5981,$D67A,$502B,$09FF
        dc.w    $DD2A,$9901,$DD5D,$DD54,$FFD5,$6B62,$3600,$1301
        dc.w    $29DF,$00ED,$B0D1,$E1AB,$71C1,$C5AF,$DD71,$02DD
        dc.w    $0C80,$DD95,$707B,$EFC6,$015F,$8AA9,$773E,$00B7
        dc.w    $F8EF,$1099,$7023,$10DD,$731C,$DD72,$7F1D,$C105
        dc.w    $C2EF,$08C3,$2901,$AE46,$60CD,$7809,$EF63,$C570
        dc.w    $01CA,$B3EC,$09F5,$6243,$81BF,$091D,$22DD,$69E5
        dc.w    $4980,$5480,$AA16,$9089,$01E7,$62BC,$4E20,$0063
        dc.w    $DDE1,$C3EC,$8690,$A389,$058B,$904E,$86D3,$959C
        dc.w    $1251,$3C50,$1BF6,$1E50,$DDE1,$B602,$C105,$1091
        dc.w    $FFC9,$CD7D,$093E,$0332,$85DF,$1B3E,$2832,$840C
        dc.w    $7097,$1B3F,$3294,$1BC9,$3A85,$3500,$BB20,$F505
        dc.w    $EB10,$044D,$60DD,$3605,$03F8,$BB50,$6382,$E852
        dc.w    $11DD,$3406,$F2FD,$39E6,$61BE,$1805,$C5CD,$E7EE
        dc.w    $0565,$E206,$03E8,$5434,$063E,$BF10,$DDBE,$06D2
        dc.w    $5E20,$A308,$9DC5,$3A50,$CD7C,$0506,$65E5,$503E
        dc.w    $FF28,$0603,$480D,$DFCB,$D1DF,$DF10,$F83E,$30D0
        dc.w    $7060,$DFA7,$EF3C,$10F1,$0086,$6179,$E171,$27F7
        dc.w    $0E00,$DF30,$0011,$811B,$366F,$0001,$B602,$0672
        dc.w    $881B,$B554,$D630,$00DD,$46EE,$2011,$4CA0,$14DD
        dc.w    $FB4E,$104C,$A009,$DD4E,$0AC5,$FA84,$A6BA,$0570
        dc.w    $C1DD,$7009,$DD7B,$710A,$C2A0,$14DD,$7110,$C2A0
        dc.w    $AF00,$DD71,$1191,$A83A,$6872,$21FD,$A2E1,$6334
        dc.w    $1910,$FCC9,$0639,$80D8,$6164,$7028,$0F18,$EC20
        dc.w    $F7A2,$AB92,$1B02,$000B,$6773,$78F5,$9132,$FF39
        dc.w    $1E32,$381E,$7832,$4BEF,$1EC9,$3A8F,$FB93,$0FC9
        dc.w    $3AFD,$90DA,$600D,$3A97,$1BE6,$FBDE,$F290,$AF32
        dc.w    $8E1B,$EB10,$10DD,$F736,$0F02,$0DAA,$08DD,$3506
        dc.w    $EA27,$A8EB,$33A4,$1257,$B0DD,$7E06,$1663,$53C5
        dc.w    $4750,$A7E1,$E551,$6B53,$9750,$DFF0,$4F3E,$28DF
        dc.w    $89B2,$14C0,$FF3E,$28DD,$4E01,$DFC9,$3AD5,$96DA
        dc.w    $6010,$8A6C,$C99F,$0CC9,$D6BD,$E06A,$60E9,$0B7E
        dc.w    $236F,$6052,$AF0C,$00C3,$70DA,$B074,$DAB0,$78FA
        dc.w    $DAB0,$8BDA,$B00C,$0D00,$C310,$AAEE,$B019,$EEB0
        dc.w    $1FEE,$B026,$EEB0,$2DAA,$EEB0,$34EE,$B049,$EEB0
        dc.w    $50EE,$B056,$FAEE,$B058,$EEB0,$0D0E,$00C3,$36AA
        dc.w    $1AC0,$3C1A,$C0D0,$1AC0,$E01A,$C0E6,$EA1A,$C0EA
        dc.w    $1AC0,$ED1A,$C00B,$0F00,$37C3,$240F,$FDF1,$7EF8
        dc.w    $CC12,$8380,$7F07,$E637,$B1DD,$7707,$8380,$FEF9
        dc.w    $53C9,$DD77,$19C9,$3286,$7640,$B04E,$0AED,$20E5
        dc.w    $E109,$CD81,$FB0C,$0CC6,$A0C9,$2137,$1E11,$3C01
        dc.w    $74C6,$6197,$1BF6,$04F2,$902F,$B086,$95B0,$914F
        dc.w    $F360,$6380,$E856,$A190,$0637,$81DD,$77F4,$6156
        dc.w    $204B,$A001,$6A42,$33A4,$0E4D,$2171,$81A8,$C307
        dc.w    $63E5,$AE00,$B58E,$EB91,$900C,$7091,$1BC9,$64C1
        dc.w    $FDC1,$3C01,$7702,$C9DD,$8606,$B6AB,$C0C3,$E7F0
        dc.w    $11E6,$2B5D,$C00F,$F7DD,$7710,$FDC0,$05DD,$7705
        dc.w    $65C9,$6773,$C90D,$A1E0,$6577,$026B,$816C,$E551
        dc.w    $FFC2,$C9AF,$B080,$2BC9,$0BD1,$FB08,$4FCC,$12E5
        dc.w    $CD67,$0DE1,$BFC9,$3AAA,$11B7,$7955,$B06E,$FF1C
        dc.w    $DD66,$1D18,$032A,$8CFF,$1BE5,$4F06,$0087,$6F60
        dc.w    $FF29,$295D,$5429,$1909,$D1EE,$4B50,$32BB,$0D54
        dc.w    $C4B0,$D7D6,$BF80,$0604,$4E23,$D7D5,$70F9,$DFF5
        dc.w    $C610,$0610,$89D4,$C624,$FEF4,$50D7,$DD75,$1EDD
        dc.w    $741F,$FF3E,$00E6,$07C6,$DF5F,$16FF,$0D1A,$DD77
        dc.w    $1A5F,$DD56,$FB06,$F187,$D1CB,$1B30,$05F5,$EF7A
        dc.w    $814F,$F18B,$D1F0,$C908,$1ECD,$D00C,$0E0E,$0FA1
        dc.w    $219B,$21CF,$10EB,$5E1A,$EB33,$40B6,$D0CB,$7AC0
        dc.w    $FFE5,$DD6E,$1EDD,$661F,$CDF9,$CC52,$D070,$00DE
        dc.w    $2BDD,$7511,$FFDD,$7412,$DD7D,$C613,$5F3D,$DDA8
        dc.w    $767E,$23CB,$3FD8,$2051,$203F,$17DD,$7718,$C92B
        dc.w    $FBD1,$4C21,$F9BE,$F111,$A121,$200C,$3A87,$1B2F
        dc.w    $B7FA,$CE0E,$1E20,$1870,$8155,$D167,$F2CD,$0E0D
        dc.w    $7142,$82A5,$0E8C,$957B,$770E,$9694,$56CA,$A00E
        dc.w    $E251,$9C9B,$9ACA,$5DE1,$C1C1,$21D0,$4E86,$B4F8
        dc.w    $62E5,$C69F,$8EE3,$3601,$E0DD,$77A6,$6F01,$56C0
        dc.w    $2C51,$24E1,$9E45,$D1C9,$FF66,$6FC9,$4E23,$E5C6
        dc.w    $20F9,$6FDE,$301C,$9019,$7EB7,$2001,$DF71,$35E1
        dc.w    $2805,$CD81,$C923,$FD23,$5820,$7E0A,$D602,$DD77
        dc.w    $FF0A,$4623,$EBDD,$856F,$DDFE,$5350,$7323,$7260
        dc.w    $69C9,$3EBF,$880E,$0FDF,$3E8C,$14F0,$2B57,$C980
        dc.w    $701F,$F568,$1FF0,$602A,$F1A4,$2CF0,$1FF6,$7F31
        dc.w    $F91F,$F180,$4EFC,$90FE,$5EF1
               ;dc.w    $00D0,$9402,$94D2,$23FF,$076B,$EA68,$02D3,$EC50
               ;dc.w    $FF0A,$B7D9,$B50B,$6CE5,$FFFF,$04
DAC01_Offset    equ     (DAC_Sample01&$FFFF)|$8000          
DAC01_Size      equ     DAC_Sample01_End-DAC_Sample01 
DAC02_Offset    equ     (DAC_Sample02&$FFFF)|$8000          
DAC02_Size      equ     DAC_Sample02_End-DAC_Sample02   
DAC03_Offset    equ     (DAC_Sample03&$FFFF)|$8000          
DAC03_Size      equ     DAC_Sample03_End-DAC_Sample03  
DAC04_Offset    equ     (DAC_Sample04&$FFFF)|$8000          
DAC04_Size      equ     DAC_Sample04_End-DAC_Sample04   
DAC05_Offset    equ     (DAC_Sample05&$FFFF)|$8000          
DAC05_Size      equ     DAC_Sample05_End-DAC_Sample05  
DAC06_Offset    equ     (DAC_Sample06&$FFFF)|$8000          
DAC06_Size      equ     DAC_Sample06_End-DAC_Sample06        
        dc.w    ((DAC01_Offset>>$08)|(DAC01_Offset<<$08))&$FFFF               
        dc.w    ((DAC01_Size>>$08)|(DAC01_Size<<$08))&$FFFF         
        dc.w    ((DAC02_Offset>>$08)|(DAC02_Offset<<$08))&$FFFF 
        dc.b    DAC02_Size&$FF,$FF,(DAC02_Size>>$08)&$FF
        dc.w    ((DAC03_Offset>>$08)|(DAC03_Offset<<$08))&$FFFF 
        dc.w    ((DAC03_Size>>$08)|(DAC03_Size<<$08))&$FFFF 
        dc.w    ((DAC04_Offset>>$08)|(DAC04_Offset<<$08))&$FFFF 
        dc.b    DAC04_Size&$FF,$FF,(DAC04_Size>>$08)&$FF
        dc.w    ((DAC05_Offset>>$08)|(DAC05_Offset<<$08))&$FFFF               
        dc.w    ((DAC05_Size>>$08)|(DAC05_Size<<$08))&$FFFF 
        dc.w    ((DAC06_Offset>>$08)|(DAC06_Offset<<$08))&$FFFF 
        dc.b    DAC06_Size&$FF,$FF,(DAC06_Size>>$08)&$FF          
        dc.b    $81
        dc.w    $1782,$0183,$1784,$FF04,$851B
        dc.w    $860A,$0000,$85FF,$1285,$1585,$1C85,$1D86,$FF0A
        dc.w    $860E,$8613,$C30F,$DAFF,$0FE1,$0FF2,$0F0C,$10FD
        dc.w    $FF0F,$3610,$5210,$7A10,$8BBF,$10C9,$10E5,$1065
        dc.w    $8041,$01FF,$0101,$0202,$0203,$0303,$FF04,$0404
        dc.w    $0505,$0506,$06FF,$0607,$8000,$0204,$0608,$8310
        dc.w    $80B2,$F1B8,$F1BE,$F1C4,$F0C6,$F000,$2102,$D6F2
        dc.w    $7E80,$BAF0,$B7F0,$02B4,$F081,$4001,$00CE,$F0FA
        dc.w    $F5B4,$F004,$08EE,$F1EE,$F1BA,$F002,$1A02,$04F9
        dc.w    $F40D,$07BA,$F7DE,$F127,$0A19,$0320,$BDF0,$BEF2
        dc.w    $C1F2,$DBF1,$C6F0,$01E2,$F03C,$00FF,$0809,$0A0B
        dc.w    $0C0D,$0E0F,$00F9,$FF89,$0F0D,$0A18,$0720,$01BD
        dc.w    $F0EB,$F30B,$0900,$B006,$ECF1,$8F0F,$9F09,$A10F
        dc.w    $0319,$5502,$171C,$E05A,$022B,$1C5F,$023F,$1C66
        dc.w    $0103,$8080,$FF81,$8283,$8485,$8687,$88FF,$898A
        dc.w    $8B8C,$8D8E,$8F8F,$BF90,$9192,$9394,$9468,$0305
        dc.w    $FF05,$0772,$7326,$1508,$FF03,$0520,$7E1F,$8412
        dc.w    $7902 
        
        cnop    $0000,$1000         
DAC_Sample01:
        dc.w    $03BC,$7FD5,$2DD5,$3BF7,$D0F7,$6ED7,$EFE8,$D64E
        dc.w    $E77E,$96E6,$53D5,$41D5,$0000,$0000,$D4A1,$EEDC
        dc.w    $4FD5,$DDDE,$CCB9,$0000,$04AB,$259B,$34C3,$244B
        dc.w    $A434,$4495,$1443,$4534,$2444,$3444,$2432,$4342
        dc.w    $B431,$93B3,$A4C0,$3BB2,$C1BB,$BABB,$BCBA,$BCBB
        dc.w    $CCBB,$CBCB,$CBBB,$CCAC,$ABBB,$CB9A,$BBB0,$AB90
        dc.w    $A190,$A320,$0330,$2322,$3333,$3133,$3333,$3333
        dc.w    $3233,$2343,$B242,$3222,$1321,$1122,$1110,$9039
        dc.w    $AA22,$A9A1,$00AA,$009A,$9AB0,$90BA,$A9B2,$ABA1
        dc.w    $0BA0,$1CA3,$A09A,$A02A,$900A,$2A02,$0A02,$A20A
        dc.w    $2B22,$2AA2,$002B,$993A,$A009,$A00B,$2AA2,$9B1A
        dc.w    $B01A,$9AB3,$1BC2,$2092,$0BA4,$2B12,$1102,$3B04
        dc.w    $3AB3,$24A2,$B433,$C342,$A409,$04A2,$203A,$211A
        dc.w    $3A0A,$32BC,$3100,$0AB2,$1B92,$0AA2,$AB39,$BB23
        dc.w    $BB09,$B902,$BC94,$BB91,$A901,$AA03,$9B20,$0B22
        dc.w    $2CA4,$9B9B,$029A,$A22A,$9121,$2210,$B4A2,$2A03
        dc.w    $1010,$9221,$39A0,$3299,$23BA,$23AA,$2A91,$0919
        dc.w    $A30A,$921B,$13AA,$A301,$A903,$9193,$A922,$0210
        dc.w    $001A,$23B0,$A209,$19A9,$91B0,$2A99,$001A,$A12A
        dc.w    $9992,$B21A,$B12A,$BA20,$B12A,$AA30,$A2A0,$291A
        dc.w    $12AA,$20A2,$2A92,$2A30,$0002,$2990,$0292,$B13B
        dc.w    $1A3B,$22A2,$21A1,$3A12,$011A,$1929,$093A,$B24B
        dc.w    $AA30,$A31A,$11A2,$A92A,$0099,$AA4B,$BB32,$3B2A
        dc.w    $219B,$23AA,$10AA,$03BA,$A190,$AB20,$AA90,$4CB3
        dc.w    $3BA0,$0939,$AA22,$9920,$A30A,$933C,$339A,$32B0
        dc.w    $2110,$0920,$A21A,$922A,$A3B2,$0A19,$13AC,$24CA
        dc.w    $31AA,$310B,$2292,$29A9,$24BB,$0320,$20A3,$3999
        dc.w    $331B,$0021,$3B00,$0A99,$00B0,$9091,$CA32,$AAA9
        dc.w    $2A02,$A901,$2AB1,$2AB2,$1AA2,$B101,$A991,$90A1
        dc.w    $991A,$21A9,$A201,$1A0A,$23B1,$20A2,$2A11,$1A22
        dc.w    $9102,$2A13,$0001,$1A13,$92A3,$31B3,$30A3,$292A
        dc.w    $109A,$2999,$0BA0,$39BA,$2A23,$B923,$BA33,$BA29
        dc.w    $B02A,$B10B,$0090,$190A,$220C,$3300,$0B99,$12AB
        dc.w    $11AB,$229A,$3AA3,$1A00,$0019,$2A91,$3AA0,$2091
        dc.w    $1AA2,$2991,$9012,$0A11,$2A09,$912A,$A121,$AA30
        dc.w    $0200,$2122,$9931,$2010,$1022,$A011,$19A1,$A202
        dc.w    $A900,$9009,$0A19,$A91A,$2A9A,$019A,$10A9,$1990
        dc.w    $019A,$A1A9,$90A0,$2A09,$1090,$1909,$2091,$9001
        dc.w    $9011,$0A10,$0020,$A100,$0190,$1091,$021A,$1212
        dc.w    $0001,$1200,$1020,$0119,$1191,$1001,$0010,$0001
        dc.w    $0900,$0919,$1900,$0009,$9100,$9990,$0991,$A900
        dc.w    $9900,$9009
DAC_Sample01_End: 
DAC_Sample02:   
        dc.w    $3567,$F472,$F2E7,$D2DD,$DEDC,$DDAD,$55FD,$7F27
        dc.w    $7FD8,$4FF6,$66ED,$7FF5,$66DD,$6F56,$6E54,$69E6
        dc.w    $CD6F,$65E6,$4E34,$7581,$57DC,$6343,$DEF7,$20CD
        dc.w    $C0D4,$DBCB,$0AA0,$2901,$0ACE,$EC35,$5545,$5555
        dc.w    $2433,$4045,$654E,$DDED,$DEE4,$7ED7,$2E56,$CE66
        dc.w    $E492,$E75A,$DDE1,$DCCB,$CCCE,$45DD,$E675,$ECBE
        dc.w    $564C,$453E,$B66E,$A47D,$F56D,$E415,$3456,$5E36
        dc.w    $6CDE,$4DDD,$DDE4,$CD54,$DE5D,$ED46,$7536,$C6C6
        dc.w    $9FC4,$ED44,$EDB7,$2E46,$D464,$5034,$E3D4,$914B
        dc.w    $5E5B,$DDEB,$E465,$2655,$BEC6,$CDD5,$CED6,$CDE6
        dc.w    $63DE,$D4DC,$5554,$3ED5,$D66C,$D315,$4444,$5C55
        dc.w    $44E1,$6EDD,$55EE,$D6DE,$C605,$56A4,$AAED,$454E
        dc.w    $C2BB,$DC6D,$DDBE,$34C5,$2565,$D555,$73ED,$41CC
        dc.w    $ECDD,$B51D,$DBB2,$57DD,$C5C5,$5D66,$EC52,$6DED
        dc.w    $5D1E,$55EC,$4E4B,$C756,$DE26,$EBAE,$404B,$4DCE
        dc.w    $45DC,$63D5,$6601,$46BD,$E64E,$CCED,$DF75,$4CE7
        dc.w    $CE7C,$BCEB,$5A7D,$D66E,$DC6E,$EDD2,$4ACD,$D56E
        dc.w    $A6C5,$5C55,$E64D,$DCD4,$65D5,$55CE,$D36E,$44EB
        dc.w    $D51B,$D4CC,$37EE,$A436,$D2D4,$6DD6,$5AB4,$AD4A
        dc.w    $EBD3,$AED4,$C356,$BC66,$E5CC,$E53B,$D462,$4C04
        dc.w    $DD5C,$54E4,$413E,$56AD,$E4D4,$6CC4,$EC42,$5355
        dc.w    $B52A,$40E3,$BE05,$55CD,$AD5D,$DB5C,$5EB5,$D6D6
        dc.w    $2DC5,$65ED,$444C,$CCA6,$A0DD,$64E4,$D5C4,$D156
        dc.w    $ADC2,$E3CC,$A4CE,$EA56,$65BC,$2636,$C5ED,$66ED
        dc.w    $C5EE,$64AD,$DCAF,$666E,$E55D,$565C,$3646,$EDCC
        dc.w    $D53A,$D4DD,$55D4,$CEC5,$DE6C,$53A4,$C36C,$5D3A
        dc.w    $C644,$4AE5,$CD21,$BB4E,$5BD5,$0DC3,$6CD5,$55DD
        dc.w    $C4DE,$35C4,$5001,$665C,$EC54,$3D4D,$34CE,$B2A4
        dc.w    $D3DC,$CEA5,$65C4,$44B6,$623C,$DE25,$5EED,$94A2
        dc.w    $EB4C,$41D6,$1305,$653D,$5345,$5DCC,$24D4,$DECD
        dc.w    $DCCC,$E56A,$1356,$D956,$CC6D,$4429,$CBCC,$DCDA
        dc.w    $4DD1,$456E,$9515,$4AD4,$4AC2,$4CDA,$D4AD,$4A65
        dc.w    $DC5D,$3D44,$4444,$ABD2,$5E4E,$6DBD,$D55D,$DAD6
        dc.w    $6CC5,$6E24,$2454,$A14D,$0C25,$B3DC,$D4EC,$C1B9
        dc.w    $0DB5,$644D,$3553,$325B,$CC34,$DDE6,$5DDC,$9CB2
        dc.w    $46CD,$EB7A,$22C4,$DC55,$CED1,$C29D,$45C3,$535B
        dc.w    $5B65,$4CDC,$AE6B,$DCDE,$54D2,$332C,$945D,$4454
        dc.w    $04B3,$425D,$DCCC,$C5DE,$B64A,$D4CB,$454A,$CCC4
        dc.w    $5CD3,$64B3,$DD94,$C354,$E904,$BDE2,$6644,$D393
        dc.w    $B53A,$A42C,$DBD2,$C49C,$D5C4,$04B9,$4454,$DCCD
        dc.w    $D5DD,$4556,$DCB5,$2A50,$B3C5,$3CBC,$C044,$DDE5
        dc.w    $6BEB,$ACD5,$2A45,$5D94,$61DA,$3554,$5BDC,$A325
        dc.w    $CDEC,$0D4B,$1CC5,$1C34,$3435,$5CDC,$D5BA,$4CDC
        dc.w    $443B,$46D9,$5DB5,$9CCB,$0BCC,$5A24,$AB2B,$654E
        dc.w    $C4DC,$C56D,$C44A,$BDD5,$0DCA,$4BB2,$44CC,$4CD6
        dc.w    $9CD2,$4CC4,$694C,$3A5B,$1D4C,$334B,$BCAC,$44DA
        dc.w    $CB42,$A2A4,$BD55,$9C5A,$2C45,$5DD4,$D3CC,$C54D
        dc.w    $D5AC,$2A13,$4CD4,$9CAD,$53B6,$3C4C,$B42A,$BA4C
        dc.w    $DCDA,$64B0,$B034,$523C,$A62D,$DC33,$DC4D,$C53D
        dc.w    $C454,$10A5,$BCC5,$594C,$DC4C,$DDA2,$49A3,$B50B
        dc.w    $244C,$E955,$DC44,$5234,$DB5A,$D2C5,$AD49,$354C
        dc.w    $31C4,$2D45,$DC9D,$C92C,$BCA4,$5B10,$413C,$05C4
        dc.w    $55DE,$4539,$BA4A,$C0CB,$42CA,$A2A4,$39BB,$3544
        dc.w    $BBE2,$C254,$9BC4,$1D44,$CB92,$D431,$2AC1,$0345
        dc.w    $4DD4,$4ACB,$DAB1,$3C45,$43C3,$25CD,$55DD,$4035
        dc.w    $9C4C,$432D,$D4D5,$430A,$DB12,$D043,$3AAC,$DB40
        dc.w    $3123,$C45A,$A423,$235C,$AB4D,$BBBB,$44BD,$3D34
        dc.w    $0D34,$44C5,$222C,$B04C,$C49B,$C04A,$3233,$CA24
        dc.w    $ACB3,$4ABD,$CC1C,$ACC4,$4C56,$42C3,$4CAC,$55BD
        dc.w    $4CC4,$2922,$A2DD,$1531,$43AC,$2C34,$52CC,$C09A
        dc.w    $DC5C,$BBD0,$5254,$4DA5,$CDC1,$4C0C,$B455,$43AD
        dc.w    $B5BC,$2ACB,$4A15,$4CC0,$40C2,$2249,$CBA2,$55CC
        dc.w    $4BC9,$CCB2,$BDD2,$2C43,$4AC4,$5534,$1CD3,$4C4B
        dc.w    $C24C,$BCBB,$4A43,$C332,$3442,$AA24,$ADBB,$CDC2
        dc.w    $4453,$A4C2,$32B2,$BBB3,$35CC,$914C,$C3CB,$53CC
        dc.w    $CA2A,$CB2A,$C52C,$243C,$CA55,$3DD1,$554C,$043B
        dc.w    $20CB,$D244,$2394,$9DD4,$9CCC,$BB45,$354A,$BAA1
        dc.w    $B1BC,$13C1,$CC50,$43C4,$4CA2,$0CD4,$B45B,$CDB4
        dc.w    $5CB4,$4102,$33C0,$B344,$B292,$BCCD,$192C,$A341
        dc.w    $B332,$52AB,$CB90,$C45A,$BCC5,$29BC,$CABC,$4345
        dc.w    $C44C,$A45C,$4B41,$ACCB,$BDCC,$B2A1,$4442,$C342
        dc.w    $AC55,$ADC4,$4239,$CCCA,$C24C,$AB1B,$539B,$94CB
        dc.w    $BA24,$415C,$D9B2,$54AB,$D203,$BD45,$AA4B,$429C
        dc.w    $3944,$CCA2,$BBCA,$C230,$4A34,$93CB,$B4BC,$AB42
        dc.w    $43C3,$0BD2,$4430,$BC04,$4309,$CDA4,$4090,$B300
        dc.w    $22A0,$0CB0,$2BC4,$543C,$C1C5,$3CC9,$3BCA,$243C
        dc.w    $BAA4,$9B42,$AAC4,$2B14,$32A3,$BCB4,$A2BA,$10B0
        dc.w    $C93A,$2233,$3513,$C2AA,$41BB,$BCCD,$54AC,$245A
        dc.w    $32DC,$AB13,$0022,$290B,$99BB,$4BBB,$B432,$3CC3
        dc.w    $A34A,$41C0,$C153,$0B3B,$33A3,$19B4,$43BC,$BBB3
        dc.w    $2BB3,$34BC,$A20C,$C942,$B133,$ACC3,$449B,$CB42
        dc.w    $233B,$C323,$BCBB,$A223,$AB4B,$443B,$2AAC,$24C1
        dc.w    $B30A,$3BAB,$053A,$B23A,$BC41,$C293,$4BB9,$92A1
        dc.w    $A04B,$12BB,$49BA,$B3C2,$AB2A,$90C1,$4343,$ABB0
        dc.w    $32BC,$323B,$4233,$ABCA,$21AA,$CB0A,$241C,$1330
        dc.w    $B220,$4034,$2A1C,$B3C2,$49CB,$1BB9,$0932,$0990
        dc.w    $3CA3,$AA4C,$A4A2,$441B,$41A4,$ACAA,$B3BC,$A433
        dc.w    $BC94,$910C,$CC11,$A944,$4392,$1BCB,$50CA,$BB19
        dc.w    $0234,$3130,$BCC4,$13CC,$0332,$1233,$232A,$ABC2
        dc.w    $9CBA,$229A,$4BBA,$B430,$BB33,$4212,$4139,$AB0A
        dc.w    $02BC,$A00C,$BA22,$B94B,$B935,$32CC,$B221,$31BA
        dc.w    $3224,$413C,$B932,$BC01,$21CC,$AAB9,$220B,$22A2
        dc.w    $3A14,$32AA,$03B0,$0132,$A1AB,$940A,$B332,$A22B
        dc.w    $AC00,$BA03,$ABB2,$BB33,$43CB,$3235,$2BB3,$B09B
        dc.w    $CCBA,$9C24,$4CB1,$1233,$43AB,$413C,$A2A0,$9B19
        dc.w    $12AA,$33CA,$2993,$421B,$32A1,$AB23,$AB0A,$C9B9
        dc.w    $24CC,$B34A,$9192,$3A45,$0CB3,$3BC3,$29A9,$0B40
        dc.w    $BCAB,$BB44,$9C24,$2342,$902A,$C941,$CB23,$2ACB
        dc.w    $143A,$91AC,$9432,$19A9,$23A0,$90AC,$A109,$B101
        dc.w    $B13C,$3459,$B043,$0AB0,$221B,$CBA9,$BB03,$3BB3
        dc.w    $9B24,$331A,$30BB,$39BA,$BBA2,$2312,$1A90,$BB34
        dc.w    $0A0A,$042A,$9120,$CAC9,$3202,$1B03,$40A2,$AAA2
        dc.w    $43BB,$00A3,$9A30,$CA2A,$C402,$2ACB,$AA31,$9232
        dc.w    $1B91,$9A2A,$1A33,$BB22,$0B19,$AB09,$A222,$1B33
        dc.w    $AA19,$3A90,$0A13,$2A1A,$B022,$21C9,$3333,$A133
        dc.w    $A01B,$CA0B,$B2AB,$9B90,$3424,$1AA0,$BB43,$0B93
        dc.w    $3221,$B34A,$BCB9,$22B0,$24BA,$22AA,$201B,$BA12
        dc.w    $AA23,$120A,$A200,$00BA,$0020,$1234,$2A13,$BA13
        dc.w    $ACB9,$3AB2,$20BA,$3220,$1CA9,$2032,$9032,$9AA2
        dc.w    $1AA2,$2B9B,$12A0,$2AA9,$A9AB,$3232,$B13B,$A3AB
        dc.w    $332B,$030B,$032A,$BB93,$3290,$220C,$932B,$2209
        dc.w    $B319,$2231,$B391,$CB33,$12A0,$1ABB,$A31A,$A9BA
        dc.w    $0011,$1299,$1232,$09B3,$AB23,$0B3A,$BA09,$10A3
        dc.w    $AA33,$2CB2,$42BA,$A9BB,$1221,$1B02,$9312,$2A23
        dc.w    $0BA1
        dc.b    $13
DAC_Sample02_End: 
DAC_Sample05:
        dc.w    $4655,$6303,$32DE,$FE57,$DEDE,$DC05,$3DEB,$B576
        dc.w    $6643,$5EFB,$BDCC,$EB34,$AB73,$C03D,$DC93,$21BC
        dc.w    $CCA3,$6425,$6566,$5009,$DDCC,$253D,$DDC6,$AEFE
        dc.w    $DD41,$3063,$DD56,$CEB5,$DC45,$4554,$3454,$AB42
        dc.w    $39BC,$CCCC,$DC2A,$DCDC,$5550,$5665,$4559,$2CEA
        dc.w    $339B,$3DD0,$3CDB,$9BEE,$DA9C,$EC43,$4445,$5CD9
        dc.w    $64DC,$1C44,$6646,$6CD4,$53DE,$EEBB,$D355,$5533
        dc.w    $23CC,$9559,$243D,$CABB,$BECC,$A54B,$444D,$DACC
        dc.w    $DCDD,$CE46,$5BBA,$4444,$4313,$6555,$3ABA,$351B
        dc.w    $B342,$BCDB,$3CDE,$DC46,$545B,$ED40,$DCDA,$2C44
        dc.w    $3352,$DA55,$CDDD,$B149,$EDA5,$6C25,$DC66,$453D
        dc.w    $2434,$5225,$4ABA,$DB4A,$D23C,$42BB,$CCEE,$143C
        dc.w    $BC34,$934A,$CDDC,$2C45,$49C4,$5544,$5CDC,$BB03
        dc.w    $BDA5,$5A45,$352A,$CB65,$CA1B,$9CDD,$54C3,$52DC
        dc.w    $D450,$DDCC,$DC1C,$CDBB,$B454,$ADA5,$BC55,$B443
        dc.w    $49C4,$4454,$D963,$C4DD,$C9AB,$455C,$B45C,$DC54
        dc.w    $EDCC,$C2AA,$54A2,$AB64,$CDDD,$E3A0,$BA30,$3A4A
        dc.w    $24CA,$5543,$2B2A,$9C44,$0549,$43B4,$495C,$E45D
        dc.w    $04DC,$0BD5,$0E45,$3BCB,$33DC,$DC54,$CC25,$9D56
        dc.w    $3ECA,$DACA,$4403,$5315,$42A2,$324A,$14CD,$244C
        dc.w    $A103,$5045,$CDD9,$CD24,$1DD1,$3D45,$3CC3,$B2B1
        dc.w    $BBB3,$444C,$D933,$53D3,$5CA4,$4132,$BC9B,$3225
        dc.w    $5CC9,$155D,$CBDC,$40C5,$4D95,$BCA3,$33CC,$CD42
        dc.w    $EC53,$D245,$33CC,$143C,$9AB3,$40B5,$4A25,$422A
        dc.w    $D0A1,$53C9,$9CC3,$3B33,$CB3C,$A5CC,$2BC2,$33AB
        dc.w    $C1B2,$4349,$CCD1,$54CC,$3BDB,$5432,$1443,$CCC5
        dc.w    $4CC3,$BB45,$4ACC,$A450,$AAB4,$3DC0,$3CCB,$44BA
        dc.w    $A14B,$CBAB,$BB41,$DA43,$C350,$B9C3,$1C34,$3320
        dc.w    $3CB4,$4294,$BC24,$441D,$CABC,$45B9,$CC44,$32CB
        dc.w    $4BB0,$BCAB,$AADB,$4345,$9CB9,$2C44,$2CAB,$B144
        dc.w    $C042,$AC25,$4BC3,$3CC3,$3332,$04AC,$3A29,$CB34
        dc.w    $B2AC,$A33A,$C2BC,$A449,$CB1C,$C232,$AC02,$2423
        dc.w    $BC45,$A92B,$B013,$39A4,$3BC3,$454B,$A4CD,$A322
        dc.w    $BCDA,$20B4,$54DD,$B143,$9BBB,$BA04,$2C34,$3929
        dc.w    $C04B,$C439,$BB45,$CD34,$124C,$C243,$23A0,$3ACA
        dc.w    $5ACA,$4332,$ABBC,$2BCA,$42CD,$143B,$CA04,$2B14
        dc.w    $4CDB,$A019,$A231,$2444,$313C,$B339,$33BB,$3430
        dc.w    $DC55,$CDC4,$4CB4,$BDC4,$53BB,$CC23,$902A,$CB33
        dc.w    $B11C,$1342,$C13A,$9031,$242A,$CCA1,$3334,$3CA4
        dc.w    $421A,$C930,$333C,$DCA3,$3333,$A144,$BACD,$DB44
        dc.w    $1AB3,$ACC4,$49AB,$B1A0,$4343,$BDC3,$5420,$1390
        dc.w    $2201,$232A,$A121,$B932,$BC93,$BA1B,$CA43,$AC0B
        dc.w    $B24B,$BA20,$A32B,$CAA3,$3921,$133B,$3429,$BB34
        dc.w    $21BC,$11BB,$43A2,$340C,$B92A,$3390,$31AB,$B03A
        dc.w    $CC44,$2CA9,$BB93,$ACCB,$1442,$00CC,$2222,$99B4
        dc.w    $5913,$BB33,$A321,$2032,$4ACA,$10A4,$0CB9,$A22A
        dc.w    $B2BA,$2ACC,$0332,$BB9A,$9923,$3AC3,$40CB,$3224
        dc.w    $2014,$2CAB,$00A2,$49BB,$3349,$B912,$3932,$BBA1
        dc.w    $A99A,$2310,$1BA3,$10BC,$BABA,$A33A,$2BBA,$9ABA
        dc.w    $4491,$1220,$A029,$0003,$2343,$0B0B,$243C,$A343
        dc.w    $ACA9,$A0AB,$12BC,$2AA2,$ACB2,$A233,$A11B,$B222
        dc.w    $3ABA,$BC34,$3230,$229A,$339A,$339B,$BA33,$0A1C
        dc.w    $1441,$CC13,$3923,$ABAA,$B34B,$CC93,$439B,$ABBB
        dc.w    $11CB,$933B,$141C,$B933,$AB04,$539B,$A991,$3309
        dc.w    $3430,$AA9B,$B122,$1AC0,$32BC,$922A,$CB24,$BCB1
        dc.w    $A220,$0A11,$0092,$222B,$A311,$2000,$3221,$32AB
        dc.w    $A933,$00AB,$B243,$ABCB,$3419,$22BC,$A431,$1ABA
        dc.w    $09A9,$BBB9,$331B,$A0AA,$ABBB,$9443,$3B23,$0BC2
        dc.w    $4439,$1212,$39A0,$2AB9,$3323,$2BBB,$A0AA,$B930
        dc.w    $BC02,$103B,$CCA2,$2221,$9000,$1329,$9B14,$3190
        dc.w    $1000,$221B,$B934,$2902,$BB93,$9921,$2AB0,$2109
        dc.w    $0001,$1A12,$BB9A,$222A,$CBAB,$931A,$A232,$AAA0
        dc.w    $AB03,$3202,$3322,$2100,$BA24,$3012,$2B91,$A030
        dc.w    $AB92,$AA2A,$BB9B,$BAB2,$30BB,$9332,$BB99,$2192
        dc.w    $2229,$A332,$19B1,$3232,$9909,$0AB3,$3910,$A099
        dc.w    $43BB,$21CA,$9102,$2909,$120A,$21BA,$CA02,$9232
        dc.w    $BCAA,$10A9,$2192,$1122,$0921,$A934,$2333,$1A9A
        dc.w    $13AA,$A033,$0BAA,$BA1A,$AABA,$3102,$9BBC,$A010
        dc.w    $0010,$9022,$339B,$91A1,$3331,$0A91,$3191,$2AA0
        dc.w    $3201,$2ABA,$A901,$2221,$BB91,$32BB,$1219,$1290
        dc.w    $9A99,$AABB,$1299,$AB02,$211A,$BA02,$2333,$320A
        dc.w    $2319,$0091,$333A,$A923,$9AAA,$A9AA,$32AB,$BBAA
        dc.w    $AA11,$090A,$A010,$A01A,$A012,$3199,$1233,$2229
        dc.w    $A992,$3319,$AAB9,$2299,$1112,$0009,$BAA2,$2190
        dc.w    $9913,$190A,$BBA1,$0B92,$2A00,$AB91,$1010,$AB12
        dc.w    $321A,$9091,$3232,$3322,$0190,$21AB,$A233,$19BB
        dc.w    $AB00,$A10A,$A00B,$AAA0,$AB99,$A933,$219A,$0221
        dc.w    $22A0,$0913,$4091,$9A22,$90A9,$2222,$AA00,$A010
        dc.w    $0009,$9220,$ABBA,$0123,$1AA1,$229A,$BAAA,$B000
        dc.w    $9012,$29AB,$A122,$2220,$0122,$2122,$19A0,$4332
        dc.w    $0A9A,$A920,$AB90,$A9AA,$99AB,$BA93,$102A,$B99A
        dc.w    $1222,$ABB3,$3322,$0AA1,$2321,$1901,$2211,$0AA0
        dc.w    $2999,$229A,$A220,$9AB9,$0022,$0119,$90AA,$AA03
        dc.w    $0B90,$0112,$ABBB,$A220,$9912,$0122,$10A0,$3302
        dc.w    $2223,$29A9,$1222,$009A,$0119,$AABA,$B9AA,$9990
        dc.w    $9100,$9AB0,$1992,$20AA,$1202,$3190,$9133,$2111
        dc.w    $AA12,$399A,$9010,$0121,$99AB,$9122,$0AAA,$2209
        dc.w    $9909,$1091,$22AA,$C0AA,$0221,$AAA9,$220B,$A911
        dc.w    $2222,$2311,$9022,$2101,$1221,$0109,$AA01,$11A0
        dc.w    $29BB,$AA9B,$BAAA,$A023,$009A,$9012,$100A,$0321
        dc.w    $0000,$0232,$221A,$9120,$0009,$AAA0,$331A,$AA02
        dc.w    $109A,$BA92,$320A,$9910,$99AA,$9911,$3AAA,$09AB
        dc.w    $0000,$1112,$09A0,$2201,$1222,$2222,$1110,$0122
        dc.w    $0909,$A019,$9AAB,$9991,$1A9B,$BAB9,$9012,$9901
        dc.w    $1222,$0090,$9232,$100A,$9022,$2200,$1122,$19AA
        dc.w    $BA23,$19AA,$9012,$29AA,$0010,$9A00,$0001,$9000
        dc.w    $AAA0,$9900,$1109,$A909,$AA02,$2091,$2333,$1991
        dc.w    $1222,$2112,$19A9,$009A,$0109,$99AA,$AA0A,$AAA9
        dc.w    $AA12,$00AA,$A002,$221A,$0222,$2220,$90A2,$2229
        dc.w    $9110,$0190,$0190,$1110,$9AAA,$010A,$9000,$0021
        dc.w    $299A,$0900,$0000,$AAA0,$9A99,$9991,$1212,$1000
        dc.w    $9A00,$1223,$2222,$2019,$0021,$1111,$0A9A,$AAAA
        dc.w    $9999,$0000,$AAAB,$AA01,$0900,$1212,$09A0,$1222
        dc.w    $3011,$0111,$1109,$9011,$1009,$AA91,$1099,$0022
        dc.w    $199A,$9110,$9A9A,$9210,$0001,$9A90,$99AA,$0019
        dc.w    $0000,$9990,$2101,$2231,$0009,$1232,$9012,$2219
        dc.w    $0999,$9000,$A9AA,$AAAA,$99A9,$9190,$010A,$AA09
        dc.w    $1211,$2222,$2101,$1001,$0001,$2009,$0000,$0010
        dc.w    $0090,$10AA,$0109,$9091,$1110,$09A9,$0AA0,$1009
        dc.w    $9011,$0099,$AAA0,$1199,$0121,$0900,$2212,$2222
        dc.w    $2110,$AA92,$2201,$1000,$09AA,$ABA9,$AA99,$999A
        dc.w    $9910,$0100,$1120,$9A90,$2220,$0112,$2222,$1990
        dc.w    $0900,$1000,$9009,$0010,$9A00,$0901,$9009,$0A21
        dc.w    $2009,$9900,$00B9,$9009,$9011,$0900,$0090,$A901
        dc.w    $0122,$2211,$1212,$2112,$110A,$9A99,$9001,$0000
        dc.w    $99AA,$BAAA,$A900,$0001,$9A91,$1201,$1012,$2210
        dc.w    $0000,$0222,$2109,$0090,$9099,$A901,$2000,$9990
        dc.w    $0001,$0990,$0100,$0900,$0000,$00A9,$9999,$0099
        dc.w    $9000,$1111,$1901,$0110,$0211,$2221,$1100,$2190
        dc.w    $0109,$999A,$AA99,$9000,$0BA9,$99A9,$0909,$9122
        dc.w    $2101,$0100,$0132,$2109,$0010,$1900,$0100,$000A
        dc.w    $9A00,$1009,$0010,$0109,$A000,$0100,$9010,$090A
        dc.w    $A910,$0900,$0909,$0009,$9901,$1122,$2100,$0111
        dc.w    $1121,$0111,$1000,$0A99,$0209,$AAAA,$9BA9,$A990
        dc.w    $0110,$0009,$9001,$1121,$1012,$1110,$1901,$1112
        dc.w    $0009,$A900,$0009,$9000,$0099,$0001,$1009,$9001
        dc.w    $090A,$9021,$0000,$0000,$AAA0,$9901,$0009,$0910
        dc.w    $1111,$0121,$2212,$1100,$1009,$0011,$9999,$0099
        dc.w    $AA90,$0AA9,$A99A,$9901,$0012,$1011,$1010,$0003
        dc.w    $0201,$0101,$1000,$0900,$1000,$9999,$9900,$0000
        dc.w    $0100,$0090,$0100,$0900,$0001,$900A,$A090,$1009
        dc.w    $9990,$0901,$2100,$1010,$2111,$1011,$1211,$0000
        dc.w    $9009,$0090,$0999,$AA0B,$9999,$0090,$9090,$0000
        dc.w    $0121,$2221,$0110,$0000,$1111,$0900,$0010,$0999
        dc.w    $0009,$0990,$AA00,$3010,$0011,$190A,$90AA,$0121
        dc.w    $0000,$0A99,$0090,$9900,$1000,$0090,$1113,$0111
        dc.w    $1111,$1010,$9011,$0099,$9009,$99A9,$90AA,$9999
        dc.w    $9090,$0000,$0010,$1111,$0112,$2120,$0101,$0009
        dc.w    $9909,$0001,$1000,$9000,$0099,$900A,$9000,$0022
        dc.w    $0010,$0000,$990A,$9091,$0009,$0990,$0009,$0101
        dc.w    $0011,$0002,$1011,$2211,$1090,$0100,$9090,$1099
        dc.w    $AAAA,$A099,$9990,$0100,$0909,$0111,$2110,$0002
        dc.w    $1100,$1211,$0100,$0099,$9990,$9009,$0100,$1090
        dc.w    $9000,$0000,$0000,$0001,$0900,$1000,$9000,$AA99
        dc.w    $0000,$0000,$0001,$0011,$2101,$1111,$1000,$0011
        dc.w    $1009,$9009,$0999,$9990,$0AAA,$9999,$0001,$0100
        dc.w    $0110,$1010,$3011,$0100,$1000,$0101,$0009,$9099
        dc.w    $0990,$0000,$0000,$0001,$0090,$0000,$1000,$9000
        dc.w    $0000,$0000,$0A90,$9990,$0000,$0001,$1121,$0010
        dc.w    $1111,$1000,$0010,$0000,$0000,$099A,$9A0B,$9909
        dc.w    $0090,$9900,$0011,$1111,$1211,$0001,$0010,$0100
        dc.w    $1019,$0909,$0090,$0909,$0000,$0000,$0000,$0010
        dc.w    $0000,$0900,$0001,$900A,$9000,$0009,$0000,$0090
        dc.w    $9900,$1113,$0111,$1110,$0001,$0000,$0090,$0990
        dc.w    $9009,$990A,$A999,$9909,$0101,$0100,$1011,$0301
        dc.w    $1101,$0009,$0000,$1001,$0900,$9099,$9000,$0000
        dc.w    $00A9,$2100,$0000,$1000,$0090,$1009,$0000,$0A99
        dc.w    $0900,$0000,$0100,$0000,$0010,$2112,$1110,$1010
        dc.w    $0900,$0909,$0090,$99A0,$AA00,$0090,$9990,$9009
        dc.w    $1011,$1113,$0010,$1010,$1100,$0000,$9990,$0000
        dc.w    $0009,$0900,$0000,$A902,$1010,$0000,$0000,$0000
        dc.w    $0009,$0000,$A999,$0000,$0000,$0001,$0010,$2101
        dc.w    $0100,$1011,$1010,$0010,$0909,$9099,$9990,$A999
        dc.w    $A990,$0011,$1000,$0000,$0101,$1211,$2101,$0000
        dc.w    $0000,$9009,$0999,$0000,$0000,$0000,$0000,$0001
        dc.w    $0100,$0909,$0000,$0000,$0000,$0A99,$0990,$0001
        dc.w    $0000,$0101,$0211,$1101,$1100,$1900,$0000,$0090
        dc.w    $0099,$9990,$AA99,$9909,$0001,$0010,$1111,$2100
        dc.w    $0001,$0011,$0110,$0000,$9090,$9900,$9000,$000A
        dc.w    $9000,$2101,$0001,$0000,$9000,$0009,$0000,$00A9
        dc.w    $0009,$0909,$0000,$0001,$0112,$1101,$0110,$1100
        dc.w    $0010,$0009,$9909,$0009,$9090,$AA99,$9090,$9010
        dc.w    $1011,$0010,$1210,$1110,$0000,$0000,$0100,$0090
        dc.w    $9090,$900A,$9021,$0000,$0000,$0110,$1000,$0009
        dc.w    $9090,$0000,$A900,$9009,$0000,$0000,$0000,$0112
        dc.w    $1011,$1111,$0000,$0010,$9009,$0909,$0909,$900A
        dc.w    $A099,$0909,$0090,$1011,$1112,$1011,$0010,$0100
        dc.w    $0000,$0900,$9900,$0000,$9000,$0000,$0A20,$0001
        dc.w    $0000,$0101,$0000,$0909,$090A,$A090,$0000,$0000
        dc.w    $0000,$1001,$0021,$0101,$0111,$0110,$0190,$0900
        dc.w    $9909,$9990,$A990,$9090,$9000,$0000,$0100,$1110
        dc.w    $2111,$0100,$1000,$0000,$0090,$9090,$900A,$9021
        dc.w    $0000,$0000,$0010,$0000,$0100,$0000,$0000,$0909
        dc.w    $0AA9,$9090,$0010,$0100,$1001,$0211,$0111,$0010
        dc.w    $0000,$0100,$0190,$9909,$9990,$AA09,$0909,$0000
        dc.w    $0010,$0101,$1021,$0010,$0110,$0100,$0000,$9009
        dc.w    $0900,$0900,$0A90,$0002,$1001,$0100,$0000,$0900
        dc.w    $0100,$0090
        dc.b    $90 
DAC_Sample05_End:
DAC_Sample06: 
        dc.w    $0123,$5456,$E4F5,$E5CF,$D56C,$D76D,$BC46,$CAF7
        dc.w    $6F74,$C525,$6DDE,$2DCE,$5FD5,$5EC6,$9EED,$C6B4
        dc.w    $5CC2,$6366,$4445,$4C55,$64AD,$DD0D,$EC2D,$DE14
        dc.w    $CCDD,$C223,$C444,$556B,$E355,$B6A4,$5542,$C15C
        dc.w    $3DBA,$BCDD,$9BDD,$99DD,$D4BB,$3935,$9CB5,$25A5
        dc.w    $5355,$CC96,$553B,$B4BD,$14EE,$B4DD,$BDD4,$DDD1
        dc.w    $5A5D,$4553,$4A4D,$5455,$3023,$53BB,$63BE,$14CE
        dc.w    $55EE,$1DC0,$3C34,$4BD3,$C50B,$1A1D,$3445,$A5B5
        dc.w    $5553,$524A,$D1D9,$DCCC,$D1CC,$AC3C,$2CD3,$4C54
        dc.w    $12C3,$4C3A,$4B25,$4434,$441C,$CB4C,$2C94,$B343
        dc.w    $4CDB,$BC0B,$CCCD,$C044,$D4A5,$3B43,$4B53,$39CA
        dc.w    $0313,$B4B3,$935D,$4900,$B213,$BBCB,$CC24,$D9AC
        dc.w    $B449,$CDA2,$3494,$A3C5,$C45A,$B023,$359C,$412C
        dc.w    $42AA,$CB3B,$CA4B,$9BAB,$CAC2,$ACA2,$2104,$939B
        dc.w    $A044,$9242,$12B4,$3BC4,$03CC,$5B1A,$2A2B,$2133
        dc.w    $ACCD,$22A2,$9B14,$B03A,$B3B3,$C9BB,$43A2,$3439
        dc.w    $BB94,$B439,$B942,$3A34,$31CB,$C1AC,$C3AC,$9A49
        dc.w    $02AC,$B229,$29BB,$B329,$A410,$3334,$44A2,$29B9
        dc.w    $3C0A,$A13A,$92B0,$BB4B,$2BAB,$A2CA,$A3CA,$CA93
        dc.w    $B042,$2411,$3342,$A110,$1292,$A223,$A143,$B9AC
        dc.w    $B39B,$CB39,$C0BB,$2BBA,$C320,$A340,$1313,$2300
        dc.w    $1313,$A1A4,$B341,$291A,$ABCB,$9AA0,$1BAA,$B9AA
        dc.w    $BBB9,$0242,$2A33,$3429,$AACA,$B492,$3213,$3393
        dc.w    $B21B,$33AA,$BBB9,$9A9C,$1A9A,$22A2,$202B,$12AB
        dc.w    $0B12,$0A09,$3924,$AB09,$4312,$1323,$3A12,$BB0B
        dc.w    $120C,$2AAA,$9BAA,$AA02,$022B,$AA0B,$B9B1,$1333
        dc.w    $3220,$3393,$2312,$3402,$209B,$9ACB,$9CC0,$1BBB
        dc.w    $19C4,$B002,$0A02,$A3A9,$3132,$3404,$3121,$030A
        dc.w    $1B29,$BAB0,$BB9A,$BAA9,$0000,$30B2,$B09A,$A123
        dc.w    $2A22,$2323,$2392,$9911,$999B,$B911,$2AAA,$99B3
        dc.w    $12C0,$1911,$3912,$114B,$01AA,$11BA,$2AAA,$A223
        dc.w    $0B1A,$2A22,$1A92,$B9B1,$013A,$9303,$321A,$0201
        dc.w    $AA91,$B090,$B332,$A0A1,$A09B,$3BBB,$1A92,$292B
        dc.w    $3122,$3AA0,$3112,$321A,$B9A0,$2A00,$9211,$21A9
        dc.w    $A92A,$20BA,$AA11,$3BB0,$1A1A,$21AA,$0913,$0021
        dc.w    $121B,$0300,$0220,$2222,$2122,$AAB9,$0ABA,$BAA1
        dc.w    $AA21,$A110,$0BBA,$1BA3,$1A22,$313A,$3302,$2331
        dc.w    $2930,$A399,$B0BA,$AAAA,$90B1,$A2A0,$ABA9,$B29A
        dc.w    $A22A,$2A22,$2222,$3232,$2323,$A010,$2009,$0AB9
        dc.w    $9BA9,$A0AA,$0919,$A99A,$A990,$0B00,$1222,$2032
        dc.w    $3002,$2221,$110A,$92A0,$0091,$2A90,$1AA0,$A990
        dc.w    $0A99,$0BA0,$A091,$9911,$2001,$010A,$2121,$1222
        dc.w    $2231,$20A0,$000A,$9A2A,$A919,$2AA1,$ABA9,$9AB1
        dc.w    $A091,$1093,$0092,$1102,$2211,$3012,$0092,$2900
        dc.w    $9A01,$0AA1,$99A9,$AB09,$AA2A,$9002,$2122,$2112
        dc.w    $1999,$1910,$0909,$A92A,$992A,$1A01,$A121,$9313
        dc.w    $9100,$9001,$0A02,$0099,$2010,$A9A0,$9ABA,$09AB
        dc.w    $0900,$2910,$2312,$2222,$2921,$1199,$9229,$1100
        dc.w    $0A10,$BA0A,$0A0B,$BA00,$AA02,$0919,$1022,$29A0
        dc.w    $2102,$3121,$2029,$1109,$92A0,$920A,$0990,$09A0
        dc.w    $9A9A,$A990,$A019,$0110,$0110,$1100,$1193,$0000
        dc.w    $1902,$2022,$11A2,$A092,$90AA,$090A,$90B0,$9991
        dc.w    $9990,$90A9,$A212,$1200,$1230,$0309,$0110,$0100
        dc.w    $2920,$1A90,$900A,$0AA0,$AAA0,$90AA,$A001,$1210
        dc.w    $1211,$9001,$0022,$1000,$2029,$1299,$119A,$99A9
        dc.w    $0A9A,$0901,$1A00,$0111,$0090,$0000,$1210,$00A2
        dc.w    $1010,$0119,$000A,$9AA0,$1900,$0910,$0913,$0000
        dc.w    $2110,$9009,$0001,$90A0,$0000,$00A9,$A20A,$0000
        dc.w    $1900,$1019,$1910,$2100,$1210,$0000,$0999,$1990
        dc.w    $000A,$2000,$0000,$0A99,$0009,$1091,$1090,$0121
        dc.w    $00A2,$0000,$0000,$0000,$0190,$0109,$1901,$1020
        dc.w    $9001,$AA00,$0000,$A900,$9099,$9901,$0900,$1110
        dc.w    $2221,$0101,$1090,$1000,$1909,$0099,$0099,$190A
        dc.w    $2B9A,$9900,$0090,$1111,$0110,$3101,$1100,$0191
        dc.w    $1900,$9190,$9099,$0900,$0A99,$9090,$0910,$0109
        dc.w    $1191,$1021,$0000,$1910,$9000,$0101,$0010,$9000
        dc.w    $9190,$9109,$00A2,$0000,$0000,$00A9,$00A0,$0101
        dc.w    $9001,$0000,$0910,$0221,$1009,$1000,$9919,$1920
        dc.w    $9009,$0900,$0AA0,$0091,$0990,$0001,$1001,$2101
        dc.w    $1000,$0000,$0990,$0000,$0000,$0000,$1090,$0000
        dc.w    $0000,$000A,$2000,$0000,$0A90,$9100,$2100,$00A2
        dc.w    $0A99,$0012,$A210,$0010,$1000,$0010,$9000,$0009
        dc.w    $0900,$0000,$A999,$9000,$0000,$1101,$0210,$0019
        dc.w    $1000,$1910,$0000,$0091,$0190,$0090,$090A,$9900
        dc.w    $0000,$0090,$0000,$0010,$1021,$0019,$1000,$9100
        dc.w    $0091,$0001,$9100,$0010,$9199,$9000,$AA90,$9010
        dc.w    $0010,$102A,$210A,$9000,$0002,$1001,$0100,$1000
        dc.w    $0009,$0919,$0090,$0000,$00A9,$0090,$9010,$0091
        dc.w    $0000,$0091,$0102,$1010,$1010,$0019,$0090,$9009
        dc.w    $0000,$0000,$A909,$0000,$0010,$0000,$9100
        dc.b    $00
DAC_Sample06_End:
DAC_Sample03:  
        dc.w    $5E35,$E67F,$F47D,$E5C5,$5053,$EE6B,$61EC,$4135
        dc.w    $DC54,$E53D,$62DC,$A34A,$20B3,$0A3B,$AA30,$B3AA
        dc.w    $32A6,$8A88,$7778,$D7FF,$776C,$1FB4,$6E55,$EE67
        dc.w    $BF3C,$6D2C,$553D,$1CB5,$33CC,$92D5,$5D29,$C4AA
        dc.w    $3AC2,$44BA,$AC23,$3AB0,$321C,$B33F,$77DF,$E67E
        dc.w    $F666,$7FDE,$E57F,$5D7D,$EE55,$64EE,$416D,$D5B9
        dc.w    $25DB,$4BC0,$054B,$AC2C,$414C,$0C78,$77E6,$FF77
        dc.w    $FEC5,$653D,$E452,$06E5,$6E9E,$5DD6,$62E6,$D06F
        dc.w    $65E2,$D4A5,$D3A6,$EB5C,$5E7E,$E5E3,$6136,$F6BD
        dc.w    $51EC,$56CA,$1E5C,$6CE6,$6DF5,$C564,$5E3C,$DBC6
        dc.w    $4E6E,$7F45,$C5E5,$DC66,$EDC4,$66F0,$D606,$25ED
        dc.w    $ED65,$4AE6,$D5E2,$646F,$EC64,$651E,$ED46,$7FC4
        dc.w    $C6E1,$C162,$F66C,$2E5D,$6E6D,$A5DB,$25B5,$DDB4
        dc.w    $4B4C,$AC46,$E5DB,$6DAD,$D555,$ADBD,$5C55,$EC5D
        dc.w    $410C,$64EC,$D562,$CDD4,$963C,$EA53,$59E2,$5D45
        dc.w    $D45E,$D62D,$3432,$C41D,$435D,$9CB5,$4DBB,$53B3
        dc.w    $BD54,$BAD5,$CC5D,$53CC,$235D,$BAA4,$44CD,$33C3
        dc.w    $5D3B,$30BC,$244A,$AAAC,$243C,$3AD5,$243D,$C53C
        dc.w    $0000,$3B01,$BB41,$33D4,$0B9C,$52CB,$310D,$53B1
        dc.w    $C24C,$3B4A,$92C1,$0A40,$4C3A,$C033,$ABB3,$22B0
        dc.w    $23AB,$33A9,$CB44,$BC39,$4C2A,$2B2A,$A339,$B132
        dc.w    $AB94,$1BC2,$339A,$2991,$B2A3,$3AAB,$23A0,$9B12
        dc.w    $3A0C,$413B,$CA33,$3BAA,$331A,$C131,$B93A,$221A
        dc.w    $002A,$B2A3,$29BB,$2923,$1AAA,$3021,$AB02,$1109
        dc.w    $19A2,$19AA,$302A,$A22A,$1BA3,$1002,$A0A9,$211B
        dc.w    $2290,$B312,$AB22,$2A01,$AB92,$23AB,$3009,$A3AA
        dc.w    $A32A,$2BA3,$1029,$A0AA,$3A22,$2BAA,$B332,$2BB1
        dc.w    $2A02,$21BA,$0329,$9AA1,$2101,$0900,$11A1,$B931
        dc.w    $9109,$B032,$2B0B,$1210,$A22A,$A201,$20A9,$0B3B
        dc.w    $3019,$0019,$0191,$BA23,$29AA,$AA42,$AB21,$90A2
        dc.w    $0012,$A9AA,$0301,$09B1,$39A2,$0A22,$B200,$029B
        dc.w    $0002,$1000,$0A21,$199B,$3001,$900A,$2019,$0010
        dc.w    $BA31,$000A,$2A20,$2A00,$19B9,$231A,$0001,$90B9
        dc.w    $2309,$029B,$2111,$BA30,$0190,$B130,$09AA,$0300
        dc.w    $129B,$2A2A,$2019,$A2A2,$1090,$2AA2,$A211,$A0AA
        dc.w    $1211,$09A2,$0A20,$0119,$9A92,$AA32,$2ABA,$1320
        dc.w    $9B00,$0221,$AB10,$212A,$A2A9,$2100,$A200,$0000
        dc.w    $0AA3,$1900,$0000,$0000,$0190,$0000,$0001,$09A2
        dc.w    $0001,$9019,$AA31,$900A
DAC_Sample03_End:      
DAC_Sample04: 
        dc.w    $AABC,$DC94,$9C40,$BA10,$3124,$2B30,$0222,$9023
        dc.w    $23A9,$0214,$1213,$033A,$A922,$4002,$0214,$B21A
        dc.w    $2200,$0210,$B9CA,$CDED,$677C,$DCCC,$CBBA,$ACA0
        dc.w    $A9BA,$A9A2,$C1AA,$90AB,$2B1A,$9AA2,$00BA,$9A92
        dc.w    $A0A0,$B93B,$0A00,$A9AB,$30B9,$A00A,$9ABA,$BCDE
        dc.w    $D466,$51BA,$1003,$9242,$02A2,$0310,$0000,$0000
        dc.w    $0BA9,$2A0B,$90B3,$BA90,$2AB9,$B9A4,$9BAB,$2123
        dc.w    $B003,$BBC0,$31BA,$1312,$A022,$A224,$A020,$0392
        dc.w    $312A,$2221,$0333,$0A02,$A3A2,$2233,$0212,$A022
        dc.w    $3300,$22A0,$23AB,$056C,$D0CC,$BB44,$3BDD,$567D
        dc.w    $EB43,$DBA2,$AA92,$1A92,$A0B3,$0BA2,$A90B,$9B30
        dc.w    $BA2B,$10A0,$0A90,$B00A,$9A2A,$00AB,$9A9B,$BDD3
        dc.w    $5523,$4CB0,$2AA2,$2A0A,$9021,$A9B0,$3C3A,$2B1A
        dc.w    $A020,$BA1A,$433B,$BBBA,$ABBA,$ABB0,$AABB,$BCCD
        dc.w    $DBA4,$652A,$ACAC,$3555,$BDAC,$BB2B,$000A,$203B
        dc.w    $A020,$A203,$1B93,$BBCD,$9455,$5445,$4CBC,$BA02
        dc.w    $0A20,$2A21,$0A92,$BBDD,$C556,$553C,$CBCA,$A002
        dc.w    $AA2A,$BBAC,$DD45,$6544,$3CCC,$1A9A,$0ABC,$CDE0
        dc.w    $5564,$2444,$CCCB,$CAAC,$BCDD,$D556,$5343,$DCBC
        dc.w    $AB20,$0BAB,$CBDE,$C565,$633C,$CCA0,$BAB0,$CBCD
        dc.w    $DD35,$6662,$DD1C,$DA3B,$31BA,$BABB,$DDD3,$6673
        dc.w    $CECD,$2B21,$2000,$0A2B,$200A,$ACDD,$C946,$763D
        dc.w    $DDDB,$0CB2,$0A2B,$ACCC,$BB55,$675B,$EDED,$B31B
        dc.w    $B943,$3AAC,$BA2B,$DE47,$75CD,$ECCD,$CCC3,$400C
        dc.w    $AADD,$A765,$5DDD,$CCB0,$2CBD,$B30B,$CCDD,$9774
        dc.w    $5DDE,$DE1C,$CC0C,$CD67,$73CE,$DECC,$DCBB,$CCC4
        dc.w    $775B,$DECD,$CBCD,$CCBC,$DA67,$71CD,$EDCB,$CCDC
        dc.w    $DDC9,$7764,$DDED,$CBCD,$CED9,$6776,$DEDE,$ACCC
        dc.w    $DECC,$4674,$BBBA,$B212,$2A02,$1030,$0039,$02BB
        dc.w    $DA46,$54BD,$CCBA,$CAAC,$ACBB,$A9AA,$BA0B,$2B9B
        dc.w    $9AA2,$ACCD,$E966,$54CB,$A02A,$CD36,$76DE,$DD23
        dc.w    $20CB,$0202,$10A9,$2A0A,$CCEE,$C666,$77EE,$EED4
        dc.w    $321A,$0ADD,$ED27,$774D,$EFDA,$49CD,$DDD3,$7765
        dc.w    $DDEE,$CB02,$1BBD,$CDDD,$578D,$EEFC,$A9A2,$22BC
        dc.w    $BDDC,$578C,$EFFC,$BDB4,$0DB6,$775D,$EEED,$BABB
        dc.w    $BBCD,$A677,$5EEE,$DDBC,$1B90,$ABD2,$6765,$DDED
        dc.w    $DBAB,$BCA9,$2BC5,$772D,$DEDD,$D0BB,$39CC,$B277
        dc.w    $4DDD,$DDCC,$CA22,$21A0,$00CB,$5766,$BEEF,$4BC1
        dc.w    $4430,$2BDC,$C676,$90ED,$EDCB,$334B,$BCCB,$6763
        dc.w    $CEED,$DBAA,$90AB,$BCA6,$76CD,$DDBA,$CDDD,$CC0B
        dc.w    $B677,$CDEE,$EDAA,$20CB,$AD57,$7DC9,$D9CD,$DD9B
        dc.w    $DCBB,$ACC6,$77BD,$CEDD,$DCAB,$CBCC,$D067,$7ADE
        dc.w    $EDDC,$A0A9,$CBCC,$5774,$CEDE,$CDCB,$C433,$AACD
        dc.w    $C477,$5BEE,$EDCC,$DCBC,$3776,$0DEE,$EDBC,$42A2
        dc.w    $1D96,$77DD,$EEED,$100A,$CCBC,$5771,$BCED,$ED00
        dc.w    $B93B,$BABB,$D676,$5DCE,$EDA9,$A0BA,$BCBC,$1676
        dc.w    $5CEE,$DDBC,$CABB,$ACA6,$77AD,$EEEC,$AA9A,$CA0C
        dc.w    $D677,$6FEE,$EA45,$3BCC,$B20D,$2776,$DEDE,$DD9A
        dc.w    $2BDD,$DC68,$5BDC,$EDDC,$C2AD,$DDD2,$686C,$EDEE
        dc.w    $DA31,$CCDD,$D677,$6EEE,$ECCC,$CCAC,$4752,$AAC3
        dc.w    $121A,$2A32,$3AB0,$2332,$CC22,$213C,$9020,$0A0A
        dc.w    $92AB,$AACA,$9DD1,$764D,$EBDC,$BBCC,$BB2A,$ABAA
        dc.w    $2B2B,$1A2C,$1A0C,$DDB6,$632B,$931A,$4CDC,$677D
        dc.w    $EEDC,$BAA4,$A122,$3A9A,$20A9,$CBEE,$D675,$769E
        dc.w    $DEDC,$1231,$000B,$BDEE,$D677,$61DE,$DEBB,$332B
        dc.w    $ACCD,$DED7,$77DE,$EEB3,$10AC,$CCCD,$DC77,$6AED
        dc.w    $EBDC,$3BBD,$CDDA,$6765,$5DDE,$CDBB,$CBDA,$DEC4
        dc.w    $776D,$DCE3,$BBDC,$CBCD,$CCB5,$774E,$DDC4,$4ADD
        dc.w    $CCAC,$CDB3,$5766,$2DDE,$B9CC,$D1CD,$DB45,$766D
        dc.w    $DBDC,$CCCB,$BCDD,$CA57,$665E,$CDDB,$BABB,$A9AC
        dc.w    $CDCD,$4776,$CEDD,$DCAB,$B92B,$CCBD,$C577,$54DE
        dc.w    $ED3D,$C934,$32AD,$EEB6,$77EF,$60E3,$62C4,$3555
        dc.w    $DEEE,$4750,$CEE6,$5544,$CDDD,$ACEC,$A565,$333C
        dc.w    $C5AC,$054E,$EC00,$02AA,$20AB,$A9B1,$C1AB,$DED5
        dc.w    $87EF,$EDB2,$334A,$1A02,$21AA,$CDDD,$3776,$5EEE
        dc.w    $CB04,$12A3,$902B,$ACCC,$CDB6,$766D,$DDDC,$CACB
        dc.w    $902B,$BBDB,$BDC6,$7554,$DCCD,$ACDC,$B10A,$BCCD
        dc.w    $BDD6,$765C,$CCEB,$BCCC,$9CA2,$BBCC,$1BDC,$5766
        dc.w    $CECD,$CCBC,$CCB3,$30AC,$CBCB,$C476,$6DE2,$D3AC
        dc.w    $BADC,$1333,$2B0C,$DBBB,$2675,$4CDC,$D0AC,$BCCB
        dc.w    $1492,$A0BB,$CABC,$1765,$ACCC,$CCA9,$2CAB,$CB42
        dc.w    $000B,$ACCD,$DB67,$7DCD,$DCC2,$1BCC,$D123,$1302
        dc.w    $AC1C,$BCDE,$677D,$CCC3,$B2AB,$CCCC,$DAA2,$4302
        dc.w    $AA9B,$0ACD,$ED68,$5BDD,$EECC,$D244,$4433,$0BBB
        dc.w    $A2AA,$CCDD,$D576,$54CD,$CD10,$CBCB,$CB02,$A212
        dc.w    $000A,$BBBA,$ACBD,$DC77,$053D,$EEDC,$0455,$5BCB
        dc.w    $DCC9,$0BBC,$ABCB,$CDD6,$7639,$DDBC,$3B12,$3A32
        dc.w    $2A2A,$0BAD,$A200,$CBCB,$0A0B,$BCCD,$B577,$BADD
        dc.w    $CBC9,$0AAC,$CCC2,$3122,$1200,$A492,$ABAB,$ABA9
        dc.w    $CD47,$655C,$EC0B,$3000,$BA9A,$2BBC,$C0A2,$0002
        dc.w    $AABB,$CA3D,$DC56,$64B9,$AA12,$33A2,$A222,$10A2
        dc.w    $49C3,$BA21,$0A9A,$2AAB,$3200,$0CA2,$3BCC,$B22A
        dc.w    $2BA1,$B2BC,$0AAB,$B41C,$B002,$1A2A,$ACCA,$C565
        dc.w    $DEA5,$5CCB,$93BB,$9CDC,$5776,$EEEC,$BA41,$A20A
        dc.w    $22A0,$A202,$1030,$0039,$0202,$A4B2,$303A,$231B
        dc.w    $3021,$22A4,$B2A3,$921A,$9B49,$A9B0,$030B,$0A20
        dc.w    $A9A0,$0A9C,$1A20,$AA9B,$3B0A,$AB0B,$AAC2,$AA22
        dc.w    $B90C,$BCDC,$5644,$BBA0,$A20A,$0200,$A20C,$4AAA
        dc.w    $92A0,$412A,$0BAC,$BBB0,$B9BA,$CACA,$0233,$3A0C
        dc.w    $C9CC,$C2B3,$02A2,$21A2,$214B,$0223,$3022,$131B
        dc.w    $3321,$AAC0,$5542,$1223,$0203,$4249,$210A,$9B04
        dc.w    $90AB,$2302,$233A,$9CB2,$A223,$B1AA,$B9A9,$4B94
        dc.w    $3AA1,$2B2B,$BCCA,$0A22,$210A,$900A,$00A2,$C149
        dc.w    $BADC,$1652,$B032,$39A2,$0000,$A0A2,$A92A,$00BA
        dc.w    $BB2B,$A9A0,$0BB1,$0A9A,$BA10,$AA2A,$A92A,$000B
        dc.w    $9AA9,$02BC,$D056,$2A2A,$2229,$04BC,$9B32,$214B
        dc.w    $BAAC,$2444,$49DE,$E544,$553C,$DCB2,$2BC9,$02AA
        dc.w    $9022,$900A,$3032,$10A0,$B3B3,$BCC1,$5641,$44BB
        dc.w    $B2BB,$24B9,$49C1,$43AC,$2229,$C33A,$CA3A,$AA34
        dc.w    $9CBB,$A921,$0221,$02B3,$BAB0,$ACAA,$CCC3,$6654
        dc.w    $3CD0,$410C,$CC45,$530C,$CDCC,$BC00,$4443,$CBBA
        dc.w    $AAB2,$21A2,$C2BD,$DD35,$6649,$0445,$CC9C,$1A9A
        dc.w    $CC13,$42AB,$BBBA,$2BBC,$4C12,$1B9C,$DDEE,$5666
        dc.w    $5A34,$54D9,$D124,$0CCC,$A90C,$A240,$BA2A,$A1A0
        dc.w    $C1BC,$EE34,$4566,$644C,$DCC4,$00CB,$BA92,$1B9A
        dc.w    $BB0A,$000C,$1ACC,$CEED,$5677,$30EE,$CA55,$4CCC
        dc.w    $DA44,$3BB2,$A2BD,$DBCE,$E556,$6665,$DE0D,$300C
        dc.w    $3BAB,$A00C,$CCEE,$B146,$774C,$EECC,$A0B9,$31BA
        dc.w    $BA0C,$DDEC,$4567,$7CEE,$CCAC,$1BCB,$CDDD,$B565
        dc.w    $4574,$CEE0,$B923,$9CBD,$DDD9,$5659,$C567,$BDEE
        dc.w    $90CC,$EDDA,$566D,$D576,$DCDE,$D332,$2ADC,$CDDD
        dc.w    $B256,$773E,$FCBA,$BACD,$DD35,$6006,$74DD,$EDA2
        dc.w    $0BAB,$CDDC,$B664,$CD66,$64DE,$ECBB,$ABDE,$C565
        dc.w    $666A,$DDEC,$CABB,$ADEE,$4665,$76BE,$EDDD,$EED5
        dc.w    $777E,$EC4C,$EC5C,$CCAB,$DEC5,$5367,$6CFD,$CCBC
        dc.w    $DEC5,$64B6,$75DF,$CCDD,$DDB4,$6779,$EF3C,$BDDD
        dc.w    $DA57,$751E,$EDCC,$BDCE,$3546,$666B,$EFA9,$BBCE
        dc.w    $D567,$7CEF,$CDDD,$4644,$6652,$EFDE,$2655,$4563
        dc.w    $4CEE,$EDC5,$6514,$5524,$0EEE,$CC56,$6CC5,$5134
        dc.w    $DFEC,$3666,$5B12,$DFEB,$674C,$DBC4,$0C40,$C131
        dc.w    $2A0A,$A94A,$9200,$A200,$CB44,$10A3,$54EF,$A666
        dc.w    $CDD9,$2232,$20C4,$00C1,$0322,$1CE4,$6552,$AEFC
        dc.w    $67AC,$DDD6,$5530,$EFD6,$64B5,$5340,$FF26,$7B04
        dc.w    $4350,$EFE5,$74B5,$545C,$FEED,$6664,$654C,$EFCE
        dc.w    $D367,$751F,$FED3,$6655,$655D,$FEDE,$2556,$765E
        dc.w    $FEDE,$0577,$6DFE,$DEC3,$5656,$70EF,$DDEC,$5776
        dc.w    $EFCD,$ED36,$676D,$FDDE,$D167,$7CEE,$EDDD,$4676
        dc.w    $4EFB,$EC35,$6666,$EFDE,$C465,$665B,$FDDE,$B576
        dc.w    $61EF,$ADE4,$6666,$5EF1,$DDDA,$677E,$EEDD,$EC66
        dc.w    $76EF,$DEC3,$676C,$FCED,$A567,$6CEF,$BDD9,$6666
        dc.w    $9EEE,$CDC5,$676C,$FDDD,$DC67,$6CF0,$DEC1,$6674
        dc.w    $DFDE,$B456,$75DF,$CDDD,$A576,$6FED,$EC26,$764E
        dc.w    $EEDE,$4667,$5EEE,$DDD3,$6763,$EEDD,$CEC5,$773E
        dc.w    $EEEE,$5775,$FEEE,$4665,$39CA,$0A20,$2310,$B0AA
        dc.w    $1002,$1AAA,$9AAD,$C673,$EF4C,$CDDB,$6659,$CDC3
        dc.w    $67EF,$BDDD,$C677,$CFEC,$DDD4,$6765,$EFDE,$C366
        dc.w    $76EF,$DDEB,$677E,$FDEC,$4676,$4EEE,$EC46,$76CF
        dc.w    $DED3,$6760,$EEEE,$C677,$EFDD,$E567,$6DFD,$ED67
        dc.w    $64EE,$EE36,$76EE,$EDD5,$764E,$FCD4,$676E,$EEED
        dc.w    $676C,$FDEC,$676C,$FDEC,$577D,$FDDE,$3676,$EEEE
        dc.w    $1676,$EFCD,$A676,$EFDD,$3675,$EEED,$B676,$EFCE
        dc.w    $3667,$DFDE,$1676,$EFDD,$5666,$CEEE,$C576,$0FDE
        dc.w    $2766,$FDEC,$9576,$BFDE,$A567,$4EEE,$E576,$5FDD
        dc.w    $E676,$EFD5,$75EF,$4553,$43AC,$A22A,$0A22,$13C3
        dc.w    $0A20,$A200,$3BBD,$A662,$EEDC,$A555,$2BA9,$65EE
        dc.w    $DD35,$5565,$EFBD,$576C,$FDD1,$763F,$EC46,$75EF
        dc.w    $DC47,$63FD,$E367,$6EFD,$D576,$EFB2,$567D,$FEB3
        dc.w    $674F,$ED46,$74EF,$C267,$3EFC,$2576,$DFEC,$2666
        dc.w    $CF15,$65BE,$D0CC,$D475,$EF45,$665E,$F2D4,$675E
        dc.w    $FDB5,$67DF,$EB56,$7BFE,$C366,$6DFC,$D466,$6EFB
        dc.w    $5665,$EF14,$5662,$EEE5,$566B,$FD95,$664E,$F256
        dc.w    $64EF,$4566,$5EF1,$5656,$CFE5,$5662,$EF46,$556C
        dc.w    $FE56,$456C,$FE56,$555E,$ED65,$0AAB,$2BBC,$4554
        dc.w    $CEEC,$655A,$D2B3,$BA31,$2B2B,$3B45,$9EE6,$51C9
        dc.w    $55DE,$D554,$60EE,$0555,$5CEE,$5545,$5BEE,$9635
        dc.w    $5AEE,$3552,$54CE,$D355,$6CEE,$2555,$5DED,$5555
        dc.w    $DED5,$555D,$ED55,$444C,$ED55,$54AE,$D055,$A342
        dc.w    $DE35,$5B44,$3EE3,$5555,$1EE1,$5445,$49EE,$5554
        dc.w    $5CEE,$4565,$0EEC,$6345,$4CEE,$5555,$5DFC,$56A5
        dc.w    $51EE,$A556,$5DFD,$5645,$5DFC,$6505,$54EF,$1656
        dc.w    $6DFE,$5656,$5DFE,$5645,$69EF,$C656,$55EF,$D660
        dc.w    $569E,$FD66,$456C,$FED6,$666E,$FE56,$75EF,$E665
        dc.w    $3CCC,$0004,$A10C,$141A,$0BA1,$2292,$C420,$BB33
        dc.w    $ACD5,$66DF,$ED57,$5CCD,$C366,$3FEE,$3665,$0265
        dc.w    $EF45,$2322,$0000,$0000,$0000,$0000,$0000,$0A0B
DAC_Sample04_End:     

        cnop    $0000,$F0000 
Music_98_Offset equ     (Music_98&$FFFF)|$8000
Music_99_Offset equ     (Music_99&$FFFF)|$8000
Music_9A_Offset equ     (Music_9A&$FFFF)|$8000
Music_9B_Offset equ     (Music_9B&$FFFF)|$8000   
Music_9C_Offset equ     (Music_9C&$FFFF)|$8000
Music_9D_Offset equ     (Music_9D&$FFFF)|$8000
; Music_9E_Offset equ     (Music_9E&$FFFF)|$8000
; Music_9F_Offset equ     (Music_9F&$FFFF)|$8000  
                     
        dc.w    ((Music_98_Offset>>$08)|(Music_98_Offset<<$08))&$FFFF 
        dc.w    ((Music_99_Offset>>$08)|(Music_99_Offset<<$08))&$FFFF 
        dc.w    ((Music_9A_Offset>>$08)|(Music_9A_Offset<<$08))&$FFFF
        dc.w    ((Music_9B_Offset>>$08)|(Music_9B_Offset<<$08))&$FFFF 
        dc.w    ((Music_9C_Offset>>$08)|(Music_9C_Offset<<$08))&$FFFF 
        dc.w    ((Music_9D_Offset>>$08)|(Music_9D_Offset<<$08))&$FFFF
Music_98: ; loc_0F000C:             
        incbin  'data\sounds\1up_98.snd'        
Music_99: ; loc_0F00F9:        
        incbin  'data\sounds\tscrn_99.snd'
Music_9A: ; loc_0F02A5:              
        incbin  'data\sounds\rscrn_9A.snd'
Music_9B: ; loc_0F03FA:                   
        incbin  'data\sounds\tgovr_9B.snd'
Music_9C: ; loc_0F0549:
        incbin  'data\sounds\cont_9C.snd'
Music_9D: ; loc_0F06A6:
        incbin  'data\sounds\emrld_9D.snd'

        cnop    $000000, $0F1E8C
Sega_Snd: ; loc_0F1E8C:        
        incbin  'data\sounds\sega.snd'         
        
        cnop    $000000, $0F8000    
Music_81_Offset equ     (Music_81&$FFFF)|$8000  
Music_82_Offset equ     (Music_82&$FFFF)|$8000  
Music_83_Offset equ     (Music_83&$FFFF)|$8000  
Music_84_Offset equ     (Music_84&$FFFF)|$8000  
Music_85_Offset equ     (Music_85&$FFFF)|$8000  
Music_86_Offset equ     (Music_86&$FFFF)|$8000  
Music_87_Offset equ     (Music_87&$FFFF)|$8000  
Music_88_Offset equ     (Music_88&$FFFF)|$8000  
Music_89_Offset equ     (Music_89&$FFFF)|$8000  
Music_8A_Offset equ     (Music_8A&$FFFF)|$8000  
Music_8B_Offset equ     (Music_8B&$FFFF)|$8000  
Music_8C_Offset equ     (Music_8C&$FFFF)|$8000  
Music_8D_Offset equ     (Music_8D&$FFFF)|$8000  
Music_8E_Offset equ     (Music_8E&$FFFF)|$8000  
Music_8F_Offset equ     (Music_8F&$FFFF)|$8000  
Music_90_Offset equ     (Music_90&$FFFF)|$8000  
Music_91_Offset equ     (Music_91&$FFFF)|$8000  
Music_92_Offset equ     (Music_92&$FFFF)|$8000  
Music_93_Offset equ     (Music_93&$FFFF)|$8000  
Music_94_Offset equ     (Music_94&$FFFF)|$8000  
Music_95_Offset equ     (Music_95&$FFFF)|$8000  
Music_96_Offset equ     (Music_96&$FFFF)|$8000  
Music_97_Offset equ     (Music_97&$FFFF)|$8000  

Music_81_To_97: ; loc_0F8000:        
        dc.w    (((Music_81_Offset>>$08)|(Music_81_Offset<<$08))&$FFFF)
        dc.w    (((Music_82_Offset>>$08)|(Music_82_Offset<<$08))&$FFFF)
        dc.w    (((Music_83_Offset>>$08)|(Music_83_Offset<<$08))&$FFFF)
        dc.w    (((Music_84_Offset>>$08)|(Music_84_Offset<<$08))&$FFFF)
        dc.w    (((Music_85_Offset>>$08)|(Music_85_Offset<<$08))&$FFFF)
        dc.w    (((Music_86_Offset>>$08)|(Music_86_Offset<<$08))&$FFFF)
        dc.w    (((Music_87_Offset>>$08)|(Music_87_Offset<<$08))&$FFFF)
        dc.w    (((Music_88_Offset>>$08)|(Music_88_Offset<<$08))&$FFFF)
        dc.w    (((Music_89_Offset>>$08)|(Music_89_Offset<<$08))&$FFFF)
        dc.w    (((Music_8A_Offset>>$08)|(Music_8A_Offset<<$08))&$FFFF)
        dc.w    (((Music_8B_Offset>>$08)|(Music_8B_Offset<<$08))&$FFFF)
        dc.w    (((Music_8C_Offset>>$08)|(Music_8C_Offset<<$08))&$FFFF)
        dc.w    (((Music_8D_Offset>>$08)|(Music_8D_Offset<<$08))&$FFFF)
        dc.w    (((Music_8E_Offset>>$08)|(Music_8E_Offset<<$08))&$FFFF)
        dc.w    (((Music_8F_Offset>>$08)|(Music_8F_Offset<<$08))&$FFFF)
        dc.w    (((Music_90_Offset>>$08)|(Music_90_Offset<<$08))&$FFFF)
        dc.w    (((Music_92_Offset>>$08)|(Music_92_Offset<<$08))&$FFFF)
        dc.w    (((Music_93_Offset>>$08)|(Music_93_Offset<<$08))&$FFFF)
        dc.w    (((Music_94_Offset>>$08)|(Music_94_Offset<<$08))&$FFFF)
        dc.w    (((Music_95_Offset>>$08)|(Music_95_Offset<<$08))&$FFFF)
        dc.w    (((Music_96_Offset>>$08)|(Music_96_Offset<<$08))&$FFFF)               
        
Music_81: ; loc_0F802A:
        incbin  'data\sounds\ooz_81.snd'
Music_82: ; loc_0F85AC: 
        incbin  'data\sounds\music_82.bin'
Music_83: ; loc_0F8D1D:
        incbin  'data\sounds\mz_wz_83.snd'
Music_84: ; loc_0F927A: 
        incbin  'data\sounds\cnz_84.snd'               
Music_85: ; loc_0F9DEE: 
        incbin  'data\sounds\dhz_85.snd' 
Music_86: ; loc_0FA49E: 
        incbin  'data\sounds\hpz_86.snd' 
Music_87: ; loc_0FA8E7: 
        incbin  'data\sounds\nghz_87.snd' 
Music_88: ; loc_0FB10A: 
        incbin  'data\sounds\music_88.snd' 
Music_89: ; loc_0FB778:  
        incbin  'data\sounds\ss_89.snd' 
Music_8A:         
Music_8B: ; loc_0FBD7F:   
        incbin  'data\sounds\menu_8A.snd' 
Music_8C: ; loc_0FBED8:  
        incbin  'data\sounds\music_8C.snd'
Music_8D: ; loc_0FC249:    
        incbin  'data\sounds\cpz_8D.snd' 
Music_8E: ; loc_0FC8AE:   
        incbin  'data\sounds\boss_8E.snd'
Music_8F: ; loc_0FCB08:  
        incbin  'data\sounds\music_8F.snd'
Music_90:
Music_91: ; loc_0FCF0B:         
        incbin  'data\sounds\music_90.snd'
Music_92: ; loc_0FD322:  
        incbin  'data\sounds\music_92.snd'
Music_93: ; loc_0FD73B:  
        incbin  'data\sounds\music_93.snd'
Music_94: ; loc_0FDC54:   
        incbin  'data\sounds\music_94.snd'
Music_95: ; loc_0FE0B7:  
        incbin  'data\sounds\invcb_95.snd'
Music_96:
Music_97: ; loc_0FE3BE:              
        incbin  'data\sounds\htz_96.snd'              
                
        cnop    $000000, $0FF000 
Sfx_A0_Offset   equ     (Sfx_A0&$FFFF)|$8000   
Sfx_A1_Offset   equ     (Sfx_A1&$FFFF)|$8000    
Sfx_A2_Offset   equ     (Sfx_A2&$FFFF)|$8000    
Sfx_A3_Offset   equ     (Sfx_A3&$FFFF)|$8000  
Sfx_A4_Offset   equ     (Sfx_A4&$FFFF)|$8000 
Sfx_A5_Offset   equ     (Sfx_A5&$FFFF)|$8000  
Sfx_A6_Offset   equ     (Sfx_A6&$FFFF)|$8000   
Sfx_A7_Offset   equ     (Sfx_A7&$FFFF)|$8000    
Sfx_A8_Offset   equ     (Sfx_A8&$FFFF)|$8000    
Sfx_A9_Offset   equ     (Sfx_A9&$FFFF)|$8000  
Sfx_AA_Offset   equ     (Sfx_AA&$FFFF)|$8000 
Sfx_AB_Offset   equ     (Sfx_AB&$FFFF)|$8000  
Sfx_AC_Offset   equ     (Sfx_AC&$FFFF)|$8000   
Sfx_AD_Offset   equ     (Sfx_AD&$FFFF)|$8000    
Sfx_AE_Offset   equ     (Sfx_AE&$FFFF)|$8000    
Sfx_AF_Offset   equ     (Sfx_AF&$FFFF)|$8000  
Sfx_B0_Offset   equ     (Sfx_B0&$FFFF)|$8000 
Sfx_B1_Offset   equ     (Sfx_B1&$FFFF)|$8000  
Sfx_B2_Offset   equ     (Sfx_B2&$FFFF)|$8000   
Sfx_B3_Offset   equ     (Sfx_B3&$FFFF)|$8000    
Sfx_B4_Offset   equ     (Sfx_B4&$FFFF)|$8000    
Sfx_B5_Offset   equ     (Sfx_B5&$FFFF)|$8000  
Sfx_B6_Offset   equ     (Sfx_B6&$FFFF)|$8000 
Sfx_B7_Offset   equ     (Sfx_B7&$FFFF)|$8000  
Sfx_B8_Offset   equ     (Sfx_B8&$FFFF)|$8000    
Sfx_B9_Offset   equ     (Sfx_B9&$FFFF)|$8000  
Sfx_BA_Offset   equ     (Sfx_BA&$FFFF)|$8000 
Sfx_BB_Offset   equ     (Sfx_BB&$FFFF)|$8000  
Sfx_BC_Offset   equ     (Sfx_BC&$FFFF)|$8000   
Sfx_BD_Offset   equ     (Sfx_BD&$FFFF)|$8000    
Sfx_BE_Offset   equ     (Sfx_BE&$FFFF)|$8000    
Sfx_BF_Offset   equ     (Sfx_BF&$FFFF)|$8000 
Sfx_C0_Offset   equ     (Sfx_C0&$FFFF)|$8000 
Sfx_C1_Offset   equ     (Sfx_C1&$FFFF)|$8000  
Sfx_C2_Offset   equ     (Sfx_C2&$FFFF)|$8000   
Sfx_C3_Offset   equ     (Sfx_C3&$FFFF)|$8000    
Sfx_C4_Offset   equ     (Sfx_C4&$FFFF)|$8000    
Sfx_C5_Offset   equ     (Sfx_C5&$FFFF)|$8000  
Sfx_C6_Offset   equ     (Sfx_C6&$FFFF)|$8000 
Sfx_C7_Offset   equ     (Sfx_C7&$FFFF)|$8000  
Sfx_C8_Offset   equ     (Sfx_C8&$FFFF)|$8000    
Sfx_C9_Offset   equ     (Sfx_C9&$FFFF)|$8000  
Sfx_CA_Offset   equ     (Sfx_CA&$FFFF)|$8000 
Sfx_CB_Offset   equ     (Sfx_CB&$FFFF)|$8000  
Sfx_CC_Offset   equ     (Sfx_CC&$FFFF)|$8000   
Sfx_CD_Offset   equ     (Sfx_CD&$FFFF)|$8000    
Sfx_CE_Offset   equ     (Sfx_CE&$FFFF)|$8000    
Sfx_CF_Offset   equ     (Sfx_CF&$FFFF)|$8000 
Sfx_D0_Offset   equ     (Sfx_D0&$FFFF)|$8000 
Sfx_D1_Offset   equ     (Sfx_D1&$FFFF)|$8000  
Sfx_D2_Offset   equ     (Sfx_D2&$FFFF)|$8000   
Sfx_D3_Offset   equ     (Sfx_D3&$FFFF)|$8000    
Sfx_D4_Offset   equ     (Sfx_D4&$FFFF)|$8000    
Sfx_D5_Offset   equ     (Sfx_D5&$FFFF)|$8000  
Sfx_D6_Offset   equ     (Sfx_D6&$FFFF)|$8000 
Sfx_D7_Offset   equ     (Sfx_D7&$FFFF)|$8000  
Sfx_D8_Offset   equ     (Sfx_D8&$FFFF)|$8000    
Sfx_D9_Offset   equ     (Sfx_D9&$FFFF)|$8000  
Sfx_DA_Offset   equ     (Sfx_DA&$FFFF)|$8000 
Sfx_DB_Offset   equ     (Sfx_DB&$FFFF)|$8000  
Sfx_DC_Offset   equ     (Sfx_DC&$FFFF)|$8000   
Sfx_DD_Offset   equ     (Sfx_DD&$FFFF)|$8000    
Sfx_DE_Offset   equ     (Sfx_DE&$FFFF)|$8000    
Sfx_DF_Offset   equ     (Sfx_DF&$FFFF)|$8000 
Sfx_E0_Offset   equ     (Sfx_E0&$FFFF)|$8000 
        
Sfx_A0_To_F9: ; loc_0FF000:      
        dc.w    (((Sfx_A0_Offset>>$08)|(Sfx_A0_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_A1_Offset>>$08)|(Sfx_A1_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_A2_Offset>>$08)|(Sfx_A2_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_A3_Offset>>$08)|(Sfx_A3_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_A4_Offset>>$08)|(Sfx_A4_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_A5_Offset>>$08)|(Sfx_A5_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_A6_Offset>>$08)|(Sfx_A6_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_A7_Offset>>$08)|(Sfx_A7_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_A8_Offset>>$08)|(Sfx_A8_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_A9_Offset>>$08)|(Sfx_A9_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_AA_Offset>>$08)|(Sfx_AA_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_AB_Offset>>$08)|(Sfx_AB_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_AC_Offset>>$08)|(Sfx_AC_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_AD_Offset>>$08)|(Sfx_AD_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_AE_Offset>>$08)|(Sfx_AE_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_AF_Offset>>$08)|(Sfx_AF_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_B0_Offset>>$08)|(Sfx_B0_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_B1_Offset>>$08)|(Sfx_B1_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_B2_Offset>>$08)|(Sfx_B2_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_B3_Offset>>$08)|(Sfx_B3_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_B4_Offset>>$08)|(Sfx_B4_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_B5_Offset>>$08)|(Sfx_B5_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_B6_Offset>>$08)|(Sfx_B6_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_B7_Offset>>$08)|(Sfx_B7_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_B8_Offset>>$08)|(Sfx_B8_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_B9_Offset>>$08)|(Sfx_B9_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_BA_Offset>>$08)|(Sfx_BA_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_BB_Offset>>$08)|(Sfx_BB_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_BC_Offset>>$08)|(Sfx_BC_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_BD_Offset>>$08)|(Sfx_BD_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_BE_Offset>>$08)|(Sfx_BE_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_BF_Offset>>$08)|(Sfx_BF_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_C0_Offset>>$08)|(Sfx_C0_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_C1_Offset>>$08)|(Sfx_C1_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_C2_Offset>>$08)|(Sfx_C2_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_C3_Offset>>$08)|(Sfx_C3_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_C4_Offset>>$08)|(Sfx_C4_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_C5_Offset>>$08)|(Sfx_C5_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_C6_Offset>>$08)|(Sfx_C6_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_C7_Offset>>$08)|(Sfx_C7_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_C8_Offset>>$08)|(Sfx_C8_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_C9_Offset>>$08)|(Sfx_C9_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_CA_Offset>>$08)|(Sfx_CA_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_CB_Offset>>$08)|(Sfx_CB_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_CC_Offset>>$08)|(Sfx_CC_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_CD_Offset>>$08)|(Sfx_CD_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_CE_Offset>>$08)|(Sfx_CE_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_CF_Offset>>$08)|(Sfx_CF_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_D0_Offset>>$08)|(Sfx_D0_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_D1_Offset>>$08)|(Sfx_D1_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_D2_Offset>>$08)|(Sfx_D2_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_D3_Offset>>$08)|(Sfx_D3_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_D4_Offset>>$08)|(Sfx_D4_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_D5_Offset>>$08)|(Sfx_D5_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_D6_Offset>>$08)|(Sfx_D6_Offset<<$08))&$FFFF)      
        dc.w    (((Sfx_D7_Offset>>$08)|(Sfx_D7_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_D8_Offset>>$08)|(Sfx_D8_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_D9_Offset>>$08)|(Sfx_D9_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_DA_Offset>>$08)|(Sfx_DA_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_DB_Offset>>$08)|(Sfx_DB_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_DC_Offset>>$08)|(Sfx_DC_Offset<<$08))&$FFFF)   
        dc.w    (((Sfx_DD_Offset>>$08)|(Sfx_DD_Offset<<$08))&$FFFF)
        dc.w    (((Sfx_DE_Offset>>$08)|(Sfx_DE_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_DF_Offset>>$08)|(Sfx_DF_Offset<<$08))&$FFFF) 
        dc.w    (((Sfx_E0_Offset>>$08)|(Sfx_E0_Offset<<$08))&$FFFF) 
Sfx_A0: ; loc_0FF082:          
        dc.b    $00, $00, $01, $01, $80, $80, $8C, $F0, $F4, $00, $F5, $00, $9E, $05, $F0, $02
        dc.b    $01, $F8, $65, $A3, $15, $F2  
Sfx_A1: ; loc_0FF098:        
        dc.b    $A2, $F0, $01, $01, $80, $05, $BB, $F0, $00, $01, $3C, $05, $0A, $01, $01, $56
        dc.b    $5C, $5C, $5C, $0E, $11, $11, $11, $09, $06, $0A, $0A, $4F, $3F, $3F, $3F, $17
        dc.b    $20, $80, $80, $EF, $00, $BD, $06, $BA, $16, $F2
Sfx_A2: ; loc_0FF0C2: 
        dc.b    $00, $00, $01, $01, $80, $C0, $CC, $F0, $00, $00, $F0, $01, $01, $F0, $08, $F3
        dc.b    $E7, $C0, $04, $CA, $04, $C0, $01, $EC, $01, $F7, $00, $06, $d7, $F0, $F2
Sfx_A3: ; loc_0FF0E1:               
        dc.b    $FA, $F0, $01, $01, $80, $05, $EB, $F0, $F4, $00, $EF, $00, $B0, $07, $E7, $AD
        dc.b    $01, $E6, $01, $F7, $00, $2F, $F1, $F0, $F2, $30, $30, $30, $30, $30, $9E, $DC
        dc.b    $d8, $DC, $0E, $04, $0A, $05, $08, $08, $08, $08, $BF, $BF, $BF, $BF, $14, $14
        dc.b    $3C, $80
Sfx_A4: ; loc_0FF113:         
        dc.b    $00, $00, $01, $02, $80, $A0, $23, $F1, $F4, $00, $80, $C0, $35, $F1, $F4, $00
        dc.b    $F5, $00, $AF, $01, $80, $AF, $80, $03, $AF, $01, $80, $01, $F7, $00, $0B, $2B
        dc.b    $F1, $F2, $F5, $00, $80, $01, $AD, $80, $AD, $80, $03, $AD, $01, $80, $01, $F7
        dc.b    $00, $0B, $3E, $F1, $F2         
Sfx_A5: ; loc_0FF148:            
        dc.b    $5B, $F1, $01, $01, $80, $05, $52, $F1, $00, $00, $EF, $00, $80, $01, $8B, $0A
        dc.b    $80, $02, $F2, $FA, $21, $10, $30, $32, $2F, $2F, $1F, $2F, $05, $09, $08, $02
        dc.b    $06, $06, $0F, $02, $1F, $4F, $2F, $2F, $0F, $0E, $1A, $80 
Sfx_A6: ; loc_0FF174:  
        dc.b    $8A, $F1, $01, $01, $80, $05, $7E, $F1, $F2, $00, $EF, $00, $F0, $01, $01, $10
        dc.b    $FF, $CF, $05, $d7, $25, $F2, $3B, $3C, $30, $39, $31, $DF, $1F, $1F, $DF, $04
        dc.b    $04, $05, $01, $04, $04, $04, $02, $FF, $1F, $0F, $AF, $29, $0F, $20, $80
Sfx_A7: ; loc_0FF1A3:    
        dc.b    $B9, $F1, $01, $01, $80, $04, $AD, $F1, $00, $06, $EF, $00, $8F, $07, $80, $02
        dc.b    $8F, $06, $80, $10, $ED, $F2, $FA, $21, $10, $30, $32, $1F, $1F, $1F, $1F, $05
        dc.b    $09, $18, $02, $06, $06, $0F, $02, $1F, $4F, $2F, $2F, $0F, $0E, $0E, $80
Sfx_A8: ; loc_0FF1D2:    
        dc.b    $8A, $F1, $01, $01, $80, $05, $DC, $F1, $F2, $04, $EF, $00, $a6, $02, $E7, $A4
        dc.b    $01, $E7, $E9, $02, $F7, $00, $26, $DF, $F1, $F2
Sfx_A9: ; loc_0FF1EC:  
        dc.b    $00, $00, $01, $01, $80, $A0, $F6, $F1, $00, $00, $F0, $01, $01, $E6, $35, $8E
        dc.b    $06, $F2
Sfx_AA: ; loc_0FF1FE:   
        dc.b    $26, $F2, $01, $02, $80, $C0, $0E, $F2, $00, $00, $80, $05, $21, $F2, $00, $03
        dc.b    $F5, $00, $F3, $E7, $C2, $05, $C6, $05, $E7, $07, $EC, $01, $E7, $F7, $00, $0F
        dc.b    $17, $F2, $F2, $EF, $00, $a6, $14, $F2, $00, $00, $02, $03, $00, $D9, $1F, $DF
        dc.b    $1F, $12, $14, $11, $0F, $0A, $0A, $00, $0D, $FF, $FF, $FF, $FF, $22, $27, $07
        dc.b    $80               
Sfx_AB: ; loc_0FF23F:   
        dc.b    $00, $00, $01, $01, $80, $C0, $49, $F2, $00, $00, $F5, $00, $F3, $E7, $C6, $03
        dc.b    $80, $03, $C6, $01, $E7, $01, $EC, $01, $E7, $F7, $00, $15, $54, $F2, $F2
Sfx_AC: ; loc_0FF25E:    
        dc.b    $79, $F2, $01, $01, $80, $05, $68, $F2, $00, $00, $EF, $00, $F0, $01, $01, $0C
        dc.b    $01, $81, $0A, $E6, $10, $F7, $00, $04, $6F, $F2, $F2, $F9, $21, $10, $30, $32
        dc.b    $1F, $1F, $1F, $1F, $05, $09, $18, $02, $0B, $10, $1F, $05, $1F, $4F, $2F, $2F
        dc.b    $0E, $04, $07, $80
Sfx_AD: ; loc_0FF292:  
        dc.b    $AF, $F2, $01, $01, $80, $05, $9C, $F2, $0E, $00, $EF, $00, $F0, $01, $01, $21
        dc.b    $6E, $a6, $07, $80, $06, $F0, $01, $01, $44, $1E, $AD, $08, $F2, $35, $05, $08
        dc.b    $09, $07, $1E, $0D, $0D, $0E, $0C, $03, $15, $06, $16, $09, $0E, $10, $2F, $1F
        dc.b    $2F, $1F, $15, $12, $12, $80
Sfx_AE: ; loc_0FF2C8:
        dc.b    $F9, $F2, $01, $02, $80, $05, $d8, $F2, $00, $00, $80, $C0, $E6, $F2, $00, $00
        dc.b    $EF, $00, $80, $01, $F0, $01, $01, $40, $48, $83, $06, $85, $02, $F2, $F5, $00
        dc.b    $80, $0B, $F3, $E7, $C6, $01, $E7, $02, $EC, $01, $E7, $F7, $00, $10, $EF, $F2
        dc.b    $F2, $FA, $02, $00, $03, $05, $12, $0F, $11, $13, $05, $09, $18, $02, $06, $06
        dc.b    $0F, $02, $1F, $4F, $2F, $2F, $2F, $0E, $1A, $80          
Sfx_AF: ; loc_0FF312:   
        dc.b    $26, $F3, $01, $01, $80, $05, $1C, $F3, $0C, $00, $EF, $00, $80, $01, $A3, $05
        dc.b    $E7, $A4, $26, $F2, $30, $30, $30, $30, $30, $9E, $AC, $A8, $DC, $0E, $04, $0A
        dc.b    $05, $08, $08, $08, $08, $BF, $BF, $BF, $BF, $04, $14, $2C, $80             
Sfx_B0: ; loc_0FF33F:     
        dc.b    $57, $F3, $01, $01, $80, $05, $49, $F3, $FB, $05, $EF, $00, $DF, $7F, $DF, $02
        dc.b    $E6, $01, $F7, $00, $1B, $4D, $F3, $F2, $83, $1F, $1F, $15, $1F, $1F, $1F, $1F
        dc.b    $1F, $00, $00, $00, $00, $02, $02, $02, $02, $2F, $FF, $2F, $3F, $0B, $01, $16
        dc.b    $82     
Sfx_B1: ; loc_0FF370:          
        dc.b    $83, $F3, $01, $01, $80, $05, $7A, $F3, $FB, $02, $EF, $00, $B3, $05, $80, $01
        dc.b    $B3, $09, $F2, $83, $12, $13, $10, $1E, $1F, $1F, $1F, $1F, $00, $00, $00, $00
        dc.b    $02, $02, $02, $02, $2F, $FF, $2F, $3F, $05, $34, $10, $87
Sfx_B2: ; loc_0FF39C:    
        dc.b    $D2, $F3, $01, $02, $80, $04, $BE, $F3, $0C, $04, $80, $05, $AC, $F3, $0E, $02
        dc.b    $EF, $00, $F0, $01, $01, $83, $0C, $8A, $05, $05, $E6, $03, $F7, $00, $0A, $B3
        dc.b    $F3, $F2, $80, $06, $EF, $00, $F0, $01, $01, $6F, $0E, $8D, $04, $05, $E6, $03
        dc.b    $F7, $00, $0A, $C7, $F3, $F2, $35, $14, $04, $1A, $09, $0E, $11, $10, $0E, $0C
        dc.b    $03, $15, $06, $16, $09, $0E, $10, $2F, $4F, $2F, $4F, $2F, $12, $12, $80
Sfx_B3: ; loc_0FF3EB:
        dc.b    $F9, $F2, $01, $02, $80, $05, $FB, $F3, $00, $00, $80, $C0, $09, $F4, $00, $00
        dc.b    $EF, $00, $80, $01, $F0, $01, $01, $40, $48, $83, $06, $85, $02, $F2, $F5, $00
        dc.b    $80, $0B, $F3, $E7, $A7, $25, $E7, $02, $EC, $01, $E7, $F7, $00, $10, $12, $F4
        dc.b    $F2  
Sfx_B4: ; loc_0FF41C:
        dc.b    $45, $F4, $01, $03, $80, $05, $32, $F4, $00, $00, $80, $04, $37, $F4, $00, $00
        dc.b    $80, $02, $40, $F4, $00, $02, $EF, $00, $F6, $3D, $F4, $EF, $00, $E1, $07, $80
        dc.b    $01, $BA, $20, $F2, $EF, $01, $9A, $03, $F2, $3C, $05, $0A, $01, $01, $56, $5C
        dc.b    $5C, $5C, $0E, $11, $11, $11, $09, $06, $0A, $0A, $4F, $3F, $3F, $3F, $1F, $2B
        dc.b    $80, $80, $05, $00, $00, $00, $00, $1F, $1F, $1F, $1F, $12, $0C, $0C, $0C, $12
        dc.b    $08, $08, $08, $1F, $5F, $5F, $5F, $07, $80, $80, $80 

Sfx_B5: ; loc_0FF477:
        dc.b    $47, $F8, $01, $01, $80, $05, $81, $F4, $00, $05, $EF, $00, $E0, $40, $C1, $05
        dc.b    $C4, $05, $C9, $1B, $F2 
Sfx_B6: ; loc_0FF48C:  
        dc.b    $00, $00, $01, $01, $80, $C0, $96, $F4, $00, $00, $F0, $01, $01, $F0, $08, $F3
        dc.b    $E7, $C1, $07, $d0, $01, $EC, $01, $F7, $00, $0C, $9F, $F4, $F2
Sfx_B7: ; loc_0FF4A9:
        dc.b    $CB, $F4, $01, $01, $80, $05, $B3, $F4, $00, $00, $EF, $00, $F0, $01, $01, $20
        dc.b    $08, $8B, $0A, $F7, $00, $08, $BA, $F4, $8B, $10, $E6, $03, $F7, $00, $09, $C1
        dc.b    $F4, $F2, $FA, $21, $10, $30, $32, $1F, $1F, $1F, $1F, $05, $09, $18, $02, $06
        dc.b    $06, $0F, $02, $1F, $4F, $2F, $2F, $0F, $0E, $1A, $80
Sfx_B8: ; loc_0FF4E4:
        dc.b    $00, $00, $01, $01, $80, $C0, $EE, $F4, $00, $00, $F0, $01, $01, $F0, $08, $F3
        dc.b    $E7, $B4, $08, $B0, $02, $EC, $01, $F7, $00, $03, $F7, $F4, $F2    
Sfx_B9: ; loc_0FF501:   
        dc.b    $79, $F2, $01, $04, $80, $02, $1D, $F5, $10, $00, $80, $04, $28, $F5, $00, $00
        dc.b    $80, $05, $24, $F5, $10, $00, $80, $C0, $39, $F5, $00, $00, $E0, $40, $80, $02
        dc.b    $F6, $28, $F5, $E0, $80, $80, $01, $EF, $00, $F0, $03, $01, $20, $04, $81, $18
        dc.b    $E6, $0A, $F7, $00, $06, $2F, $F5, $F2, $F0, $01, $01, $0F, $05, $F3, $E7, $B0
        dc.b    $18, $E7, $EC, $03, $F7, $00, $05, $40, $F5, $F2
Sfx_BA: ; loc_0FF54B:
        dc.b    $5A, $F5, $01, $01, $80, $05, $55, $F5, $00, $07, $EF, $00, $AE, $08, $F2, $1C
        dc.b    $2E, $0F, $02, $02, $1F, $1F, $1F, $1F, $18, $14, $0F, $0E, $00, $00, $00, $00
        dc.b    $FF, $FF, $FF, $FF, $20, $1B, $80, $80 
Sfx_BB: ; loc_0FF573:
        dc.b    $85, $F5, $01, $01, $80, $05, $7D, $F5, $F4, $00, $EF, $00, $9B, $04, $80, $A0
        dc.b    $06, $F2, $3C, $00, $00, $00, $00, $1F, $1F, $1F, $1F, $00, $0F, $16, $0F, $00
        dc.b    $00, $00, $00, $0F, $FF, $AF, $FF, $00, $0A, $80, $80
Sfx_BC: ; loc_0FF59E:
        dc.b    $C6, $F5, $01, $02, $80, $05, $AE, $F5, $90, $00, $80, $C0, $B8, $F5, $00, $00
        dc.b    $EF, $00, $F0, $01, $01, $C5, $1A, $CD, $07, $F2, $F5, $07, $80, $07, $F0, $01
        dc.b    $02, $05, $FF, $F3, $E7, $BB, $4F, $F2, $FD, $09, $00, $03, $00, $1F, $1F, $1F
        dc.b    $1F, $10, $0C, $0C, $0C, $0B, $10, $1F, $05, $1F, $4F, $2F, $2F, $09, $92, $84
        dc.b    $8E           
Sfx_BD: ; loc_0FF5DF:
        dc.b    $00, $F6, $01, $02, $80, $05, $EF, $F5, $10, $0A, $80, $04, $F9, $F5, $00, $00
        dc.b    $EF, $00, $F0, $01, $01, $60, $01, $A7, $08, $F2, $80, $08, $EF, $01, $84, $22
        dc.b    $F2, $FA, $21, $19, $3A, $30, $1F, $1F, $1F, $1F, $05, $09, $18, $02, $0B, $10
        dc.b    $1F, $05, $1F, $4F, $2F, $2F, $0E, $04, $07, $80, $FA, $31, $10, $30, $32, $1F
        dc.b    $1F, $1F, $1F, $05, $05, $18, $10, $0B, $10, $1F, $10, $1F, $1F, $2F, $2F, $0D
        dc.b    $01, $00, $80               
Sfx_BE: ; loc_0FF632:
        dc.b    $53, $F6, $01, $01, $80, $04, $3C, $F6, $0C, $05, $EF, $00, $80, $01, $F0, $03
        dc.b    $01, $09, $FF, $CA, $25, $F4, $E7, $E6, $01, $d0, $02, $F7, $00, $2A, $48, $F6
        dc.b    $F2, $3C, $00, $02, $44, $02, $1F, $1F, $1F, $15, $00, $00, $1F, $00, $00, $00
        dc.b    $00, $00, $0F, $0F, $0F, $0F, $0D, $28, $00, $00
Sfx_BF: ; loc_0FF66C:
        dc.b    $C5, $F6, $01, $03, $80, $02, $82, $F6, $F4, $06, $80, $04, $9D, $F6, $F4, $06
        dc.b    $80, $05, $B2, $F6, $F4, $06, $EF, $00, $C9, $07, $CD, $d0, $CB, $CE, $D2, $CD
        dc.b    $d0, $d4, $CE, $D2, $d5, $d0, $07, $d4, $d7, $E6, $05, $F7, $00, $08, $91, $F6
        dc.b    $F2, $EF, $00, $E1, $01, $80, $07, $CD, $15, $CE, $d0, $D2, $d4, $15, $E6, $05
        dc.b    $F7, $00, $08, $A8, $F6, $F2, $EF, $00, $E1, $01, $C9, $15, $CB, $CD, $CE, $D0
        dc.b    $15, $E6, $05, $F7, $00, $08, $BB, $F6, $F2, $14, $25, $36, $33, $11, $1F, $1F
        dc.b    $1F, $1F, $15, $1C, $18, $13, $0B, $0D, $08, $09, $0F, $8F, $9F, $0F, $24, $0A
        dc.b    $05, $80               
Sfx_C0: ; loc_0FF6DE:
        dc.b    $F3, $F6, $01, $01, $80, $05, $E8, $F6, $00, $03, $EF, $00, $94, $05, $80, $05
        dc.b    $94, $04, $80, $04, $F2, $38, $08, $08, $08, $08, $1F, $1F, $1F, $0E, $00, $00
        dc.b    $00, $00, $00, $00, $00, $00, $0F, $0F, $0F, $1F, $00, $00, $00, $80
Sfx_C1: ; loc_0FF70C:
        dc.b    $2D, $F7, $01, $02, $80, $05, $1C, $F7, $00, $00, $80, $C0, $26, $F7, $00, $02
        dc.b    $F0, $03, $01, $72, $0B, $EF, $00, $BA, $16, $F2, $F5, $01, $F3, $E7, $B0, $1B
        dc.b    $F2, $3C, $0F, $03, $01, $01, $1F, $1F, $1F, $1F, $19, $19, $12, $0E, $05, $00
        dc.b    $12, $0F, $0F, $FF, $7F, $FF, $00, $00, $80, $80               
Sfx_C2: ; loc_0FF746:
        dc.b    $C5, $F6, $01, $01, $80, $05, $50, $F7, $0C, $08, $EF, $00, $BA, $08, $BA, $25
        dc.b    $F2
Sfx_C3: ; loc_0FF757:
        dc.b    $86, $F7, $01, $02, $80, $04, $67, $F7, $0C, $00, $80, $05, $73, $F7, $00, $13
        dc.b    $EF, $01, $80, $01, $A2, $08, $EF, $00, $E7, $AD, $26, $F2, $EF, $02, $F0, $06
        dc.b    $01, $03, $FF, $80, $0A, $C3, $06, $F7, $00, $05, $7C, $F7, $C3, $17, $F2, $30
        dc.b    $30, $34, $5C, $30, $9E, $AC, $A8, $DC, $0E, $04, $0A, $05, $08, $08, $08, $08
        dc.b    $BF, $BF, $BF, $BF, $24, $04, $1C, $80, $30, $30, $34, $5C, $30, $9E, $AC, $A8
        dc.b    $DC, $0E, $04, $0A, $05, $08, $08, $08, $08, $BF, $BF, $BF, $BF, $24, $04, $2C
        dc.b    $80, $04, $37, $77, $72, $49, $1F, $1F, $1F, $1F, $07, $07, $0A, $0D, $00, $00
        dc.b    $0B, $0B, $1F, $1F, $0F, $0F, $13, $13, $81, $88
Sfx_C4: ; loc_0FF7D1:
        dc.b    $E0, $F7, $01, $01, $80, $05, $DB, $F7, $00, $00, $EF, $00, $8A, $22, $F2, $FA
        dc.b    $21, $10, $30, $32, $1F, $1F, $1F, $1F, $05, $05, $18, $10, $0B, $10, $1F, $10
        dc.b    $1F, $4F, $2F, $2F, $0D, $04, $07, $80
Sfx_C5: ; loc_0FF7F9:
        dc.b    $2E, $F8, $01, $03, $80, $05, $0F, $F8, $00, $00, $80, $04, $18, $F8, $00, $00
        dc.b    $80, $C0, $1F, $F8, $00, $00, $EF, $00, $8A, $08, $80, $02, $8A, $08, $F2, $EF
        dc.b    $01, $80, $12, $C6, $55, $F2, $F5, $02, $F3, $E7, $80, $02, $C2, $05, $C4, $04
        dc.b    $C2, $05, $C4, $04, $F2, $3B, $03, $02, $02, $06, $18, $1A, $1A, $96, $17, $0A
        dc.b    $0E, $10, $00, $00, $00, $00, $FF, $FF, $FF, $FF, $00, $39, $28, $80, $04, $37
        dc.b    $77, $72, $49, $1F, $1F, $1F, $1F, $07, $07, $0A, $0D, $00, $00, $0B, $0B, $1F
        dc.b    $1F, $0F, $0F, $23, $23, $80, $80
Sfx_C6: ; loc_0FF860:
        dc.b    $47, $F8, $01, $02, $80, $04, $70, $F8, $00, $05, $80, $05, $7C, $F8, $00, $08
        dc.b    $EF, $00, $C6, $02, $05, $05, $05, $05, $05, $05, $3A, $F2, $EF, $00, $80, $02
        dc.b    $C4, $02, $05, $15, $02, $05, $32, $F2               
Sfx_C7: ; loc_0FF888:
        dc.b    $9D, $F8, $01, $01, $80, $05, $92, $F8, $00, $00, $EF, $00, $BE, $05, $80, $04
        dc.b    $BE, $04, $80, $04, $F2, $28, $2F, $37, $5F, $2B, $1F, $1F, $1F, $1F, $15, $15
        dc.b    $15, $13, $13, $0D, $0C, $10, $2F, $3F, $2F, $2F, $00, $1F, $10, $80
Sfx_C8: ; loc_0FF8B6:
        dc.b    $00, $00, $01, $01, $80, $C0, $C0, $F8, $00, $00, $F5, $00, $F3, $E7, $A7, $25
        dc.b    $F2
Sfx_C9: ; loc_0FF8C7:
        dc.b    $DB, $F8, $01, $01, $80, $05, $d1, $F8, $0E, $00, $EF, $00, $F0, $01, $01, $33
        dc.b    $18, $B9, $1A, $F2, $3B, $0A, $05, $31, $02, $5F, $5F, $5F, $5F, $04, $16, $14
        dc.b    $0C, $00, $00, $04, $00, $1F, $d8, $6F, $FF, $03, $00, $25, $80
Sfx_CA: ; loc_0FF8F4:
        dc.b    $08, $F9, $01, $01, $80, $05, $FE, $F8, $00, $02, $EF, $00, $F0, $01, $01, $5B
        dc.b    $02, $CC, $65, $F2, $20, $36, $30, $35, $31, $41, $3B, $49, $4B, $09, $09, $06
        dc.b    $08, $01, $02, $03, $A9, $0F, $0F, $0F, $0F, $29, $23, $27, $80               
Sfx_CB: ; loc_0FF921:
        dc.b    $79, $F2, $01, $02, $80, $05, $31, $F9, $00, $00, $80, $C0, $42, $F9, $00, $00
        dc.b    $EF, $00, $F0, $03, $01, $20, $04, $81, $18, $E6, $0A, $F7, $00, $06, $38, $F9
        dc.b    $F2, $F0, $01, $01, $0F, $05, $F3, $E7, $B0, $18, $E7, $EC, $03, $F7, $00, $05
        dc.b    $49, $F9, $F2
Sfx_CC: ; loc_0FF954:
        dc.b    $75, $F9, $01, $01, $80, $04, $5E, $F9, $00, $02, $EF, $00, $80, $01, $F0, $03
        dc.b    $01, $5D, $0F, $B0, $0C, $F4, $E7, $E6, $02, $BD, $02, $F7, $00, $19, $6A, $F9
        dc.b    $F2, $20, $36, $30, $35, $31, $DF, $9F, $DF, $9F, $07, $09, $06, $06, $07, $06
        dc.b    $06, $08, $2F, $1F, $1F, $FF, $16, $13, $30, $80           
Sfx_CD: ; loc_0FF98E:
        dc.b    $00, $00, $01, $01, $80, $C0, $98, $F9, $00, $00, $BB, $02, $F2               
Sfx_CE: ; loc_0FF99B:
        dc.b    $47, $F8, $01, $01, $80, $04, $a5, $F9, $00, $05, $EF, $00, $E0, $80, $C1, $04
        dc.b    $C4, $05, $C9, $1B, $F2
Sfx_CF: ; loc_0FF9B0:
        dc.b    $CE, $F9, $01, $02, $80, $04, $C0, $F9, $27, $03, $80, $05, $C2, $F9, $27, $00
        dc.b    $80, $04, $EF, $00, $B4, $05, $E6, $02, $F7, $00, $15, $C4, $F9, $F2, $F4, $06
        dc.b    $0F, $04, $0E, $1F, $1F, $1F, $1F, $00, $0B, $00, $0B, $00, $05, $00, $08, $0F
        dc.b    $FF, $0F, $FF, $0C, $03, $8B, $80
Sfx_D0: ; loc_0FF9E7:
        dc.b    $02, $FA, $01, $01, $80, $05, $F1, $F9, $00, $00, $EF, $00, $9D, $05, $9D, $02
        dc.b    $AD, $05, $9D, $02, $AD, $05, $9D, $02, $AD, $05, $F2, $3B, $70, $53, $70, $51
        dc.b    $0F, $0F, $0F, $0F, $0F, $0F, $00, $0F, $00, $00, $00, $00, $0F, $0F, $0F, $0F
        dc.b    $0E, $2F, $0C, $80
Sfx_D1: ; loc_0FFA1B:
        dc.b    $2A, $FA, $01, $01, $80, $05, $25, $FA, $00, $01, $EF, $00, $81, $05, $F2, $35
        dc.b    $02, $01, $00, $04, $1F, $1F, $1F, $1F, $00, $19, $12, $14, $00, $00, $0C, $0F
        dc.b    $0F, $FF, $EF, $FF, $00, $00, $00, $80               
Sfx_D2: ; loc_0FFA43:
        dc.b    $5B, $FA, $01, $01, $80, $05, $4D, $FA, $00, $00, $EF, $00, $F0, $01, $01, $2D
        dc.b    $21, $81, $26, $81, $26, $81, $26, $F2, $0E, $05, $06, $04, $0F, $1F, $1F, $1F
        dc.b    $1F, $1F, $1F, $1F, $1F, $05, $08, $05, $05, $0F, $0F, $0F, $0F, $51, $82, $44
        dc.b    $97    
Sfx_D3: ; loc_0FFA74:
        dc.b    $88, $FA, $01, $01, $80, $05, $7E, $FA, $00, $00, $EF, $00, $F0, $01, $02, $3F
        dc.b    $04, $96, $3A, $F2, $05, $07, $30, $0F, $0A, $30, $1F, $1F, $1F, $03, $03, $03
        dc.b    $03, $1F, $0F, $0F, $0F, $AF, $AF, $AF, $AF, $4D, $80, $80, $80
Sfx_D4: ; loc_0FFAA1:
        dc.b    $C7, $FA, $01, $02, $80, $04, $B1, $FA, $00, $00, $80, $05, $BB, $FA, $00, $00
        dc.b    $EF, $00, $F0, $01, $01, $E7, $01, $93, $17, $F2, $EF, $00, $E1, $02, $F0, $01
        dc.b    $01, $E7, $01, $93, $17, $F2, $3E, $20, $0E, $0F, $0F, $1F, $1F, $1F, $1F, $1F
        dc.b    $1F, $1F, $1F, $0F, $0E, $0F, $0E, $0F, $0F, $0F, $0F, $8E, $80, $80, $80
Sfx_D5: ; loc_0FFAE0:
        dc.b    $F4, $FA, $01, $01, $80, $05, $EA, $FA, $00, $00, $EF, $00, $F0, $01, $01, $02
        dc.b    $02, $B1, $15, $F2, $35, $29, $09, $08, $0F, $1A, $1F, $10, $1F, $0F, $1F, $1F
        dc.b    $1F, $0C, $0D, $0E, $0E, $0F, $0F, $0F, $0F, $80, $80, $80, $80
Sfx_D6: ; loc_0FFB0D:
        dc.b    $3A, $FB, $01, $02, $80, $04, $1D, $FB, $00, $08, $80, $05, $1D, $FB, $0C, $08
        dc.b    $EF, $00, $F0, $01, $01, $12, $FF, $8F, $45, $F0, $00, $00, $00, $00, $E7, $E6
        dc.b    $03, $A0, $01, $E6, $02, $E7, $0A, $F7, $00, $07, $30, $FB, $F2, $34, $01, $0B
        dc.b    $0E, $09, $9F, $AF, $AF, $CF, $02, $00, $02, $00, $07, $0A, $04, $05, $BF, $BF
        dc.b    $BF, $BF, $50, $1C, $00, $80               
Sfx_D7: ; loc_0FFB53:
        dc.b    $67, $FB, $01, $01, $80, $05, $5D, $FB, $00, $06, $EF, $00, $F0, $01, $01, $07
        dc.b    $01, $99, $1B, $F2, $3E, $20, $0F, $1F, $0F, $1F, $1F, $1F, $1F, $1F, $1F, $1F
        dc.b    $1F, $0F, $0E, $0F, $0E, $0F, $0F, $0F, $0F, $8C, $80, $80, $80
Sfx_D8: ; loc_0FFB80:
        dc.b    $9E, $FB, $01, $01, $80, $05, $8A, $FB, $00, $00, $EF, $00, $B7, $03, $BB, $03
        dc.b    $C7, $0A, $E6, $08, $C7, $05, $80, $05, $F7, $00, $03, $92, $FB, $F2, $3C, $05
        dc.b    $0A, $01, $01, $56, $5C, $5C, $5C, $0E, $11, $11, $11, $09, $06, $0A, $0A, $4F
        dc.b    $3F, $3F, $3F, $17, $20, $80, $80
Sfx_D9: ; loc_0FFBB7:
        dc.b    $ED, $FB, $01, $03, $80, $80, $CD, $FB, $EC, $00, $80, $A0, $CD, $FB, $EA, $00
        dc.b    $80, $05, $DC, $FB, $00, $00, $F0, $01, $01, $81, $45, $9C, $05, $EC, $02, $F7
        dc.b    $00, $02, $D2, $FB, $F2, $EF, $00, $F0, $01, $01, $0C, $01, $92, $07, $E6, $0A
        dc.b    $F7, $00, $03, $E3, $FB, $F2, $43, $01, $01, $01, $01, $5F, $5F, $5F, $5F, $0E
        dc.b    $11, $11, $11, $09, $06, $0A, $0A, $4F, $3F, $3F, $3F, $17, $20, $80, $80
Sfx_DA: ; loc_0FFC06:
        dc.b    $2E, $FC, $01, $02, $80, $C0, $16, $FC, $00, $02, $80, $05, $1D, $FC, $00, $00
        dc.b    $F3, $E7, $F5, $01, $CC, $29, $F2, $EF, $00, $F0, $01, $01, $7F, $F1, $AA, $0A
        dc.b    $E6, $0C, $F7, $00, $03, $24, $FC, $F2, $47, $03, $02, $02, $04, $5F, $5F, $5F
        dc.b    $5F, $0E, $1A, $11, $0A, $09, $0A, $0A, $0A, $4F, $3F, $3F, $3F, $7F, $80, $80
        dc.b    $A3               
Sfx_DB: ; loc_0FFC47:
        dc.b    $64, $FC, $01, $01, $80, $C0, $51, $FC, $00, $00, $F5, $00, $F3, $E7, $C5, $01
        dc.b    $CE, $02, $E7, $02, $EC, $01, $E7, $F7, $00, $14, $5A, $FC, $F2
Sfx_DC: ; loc_0FFC64:
        dc.b    $A8, $FC, $01, $03, $80, $04, $7A, $FC, $00, $00, $80, $05, $81, $FC, $00, $00
        dc.b    $80, $C0, $8A, $FC, $00, $00, $EF, $00, $8D, $06, $8D, $30, $F2, $80, $0C, $EF
        dc.b    $00, $8D, $06, $8D, $30, $F2, $F5, $00, $F3, $E7, $F0, $01, $01, $01, $01, $99
        dc.b    $0F, $F0, $01, $01, $05, $05, $95, $1F, $E7, $12, $EC, $01, $E7, $0F, $F7, $00
        dc.b    $1F, $9E, $FC, $F2, $38, $71, $00, $00, $60, $0A, $0A, $0F, $0F, $00, $00, $00
        dc.b    $12, $00, $09, $07, $0B, $0F, $0F, $0F, $0F, $11, $04, $0E, $80           
Sfx_DD: ; loc_0FFCC1:
        dc.b    $D2, $FC, $01, $01, $80, $05, $CB, $FC, $00, $00, $EF, $00, $BB, $05, $BB, $05
        dc.b    $F2, $3E, $20, $3F, $1F, $BF, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $0F, $0F
        dc.b    $0F, $0F, $0F, $0F, $0F, $0F, $8C, $80, $80, $80               
Sfx_DE: ; loc_0FFCEB:
        dc.b    $0F, $FD, $01, $01, $80, $05, $F5, $FC, $00, $00, $EF, $00, $F0, $01, $01, $0F
        dc.b    $FE, $93, $43, $F0, $01, $01, $03, $03, $9F, $0F, $E7, $03, $E6, $01, $F7, $00
        dc.b    $23, $05, $FD, $F2, $3C, $00, $02, $40, $02, $1F, $1F, $1F, $15, $00, $00, $1F
        dc.b    $00, $00, $00, $00, $00, $0F, $0F, $0F, $0F, $0D, $28, $00, $00
Sfx_DF: ; loc_0FFD28:
        dc.b    $5A, $FD, $01, $02, $80, $05, $38, $FD, $15, $00, $80, $02, $49, $FD, $F4, $05
        dc.b    $EF, $00, $F0, $01, $01, $19, $31, $9D, $3A, $E6, $05, $F7, $00, $02, $3F, $FD
        dc.b    $F2, $EF, $00, $F0, $01, $01, $19, $31, $9D, $3A, $E6, $05, $F7, $00, $02, $50
        dc.b    $FD, $F2, $30, $30, $30, $30, $3C, $9E, $AC, $A8, $DF, $0E, $04, $0A, $00, $08
        dc.b    $08, $08, $08, $BF, $BF, $BF, $BF, $04, $14, $2C, $80
Sfx_E0: ; loc_0FFD73:
        dc.b    $CF, $FD, $01, $03, $80, $05, $89, $FD, $00, $00, $80, $02, $a6, $FD, $F7, $00
        dc.b    $80, $C0, $C3, $FD, $00, $00, $EF, $00, $F0, $01, $01, $19, $F6, $C4, $25, $F0
        dc.b    $01, $01, $00, $00, $E7, $E6, $0F, $d0, $0F, $E7, $03, $E6, $02, $F7, $00, $13
        dc.b    $9C, $FD, $F2, $EF, $00, $F0, $01, $01, $19, $F6, $d5, $25, $F0, $01, $01, $00
        dc.b    $00, $E7, $E6, $0F, $DB, $0F, $E7, $03, $E6, $02, $F7, $00, $13, $B9, $FD, $F2
        dc.b    $F5, $01, $F3, $E7, $F0, $01, $01, $01, $01, $AC, $24, $F2, $34, $00, $03, $0C
        dc.b    $09, $9F, $AC, $AF, $d5, $06, $00, $02, $00, $02, $0A, $04, $08, $BF, $BF, $BF
        dc.b    $BF, $00, $1C, $00, $80
           
        cnop    $000000, $0FFFFE
        dc.w    $0000
               